/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 152;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(1),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 63,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 151,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 137,
  Feature_HasMMXBit = 109,
  Feature_HasSSE1Bit = 49,
  Feature_UseSSE1Bit = 56,
  Feature_HasSSE2Bit = 48,
  Feature_UseSSE2Bit = 57,
  Feature_HasSSE3Bit = 40,
  Feature_UseSSE3Bit = 66,
  Feature_HasSSSE3Bit = 110,
  Feature_UseSSSE3Bit = 67,
  Feature_UseSSE41Bit = 64,
  Feature_UseSSE42Bit = 71,
  Feature_HasSSE4ABit = 81,
  Feature_NoAVXBit = 77,
  Feature_HasAVXBit = 58,
  Feature_HasAVX2Bit = 52,
  Feature_HasAVX1OnlyBit = 50,
  Feature_HasEVEX512Bit = 144,
  Feature_HasAVX10_2Bit = 108,
  Feature_HasAVX10_2_512Bit = 107,
  Feature_NoAVX10_2Bit = 70,
  Feature_HasAVX512Bit = 94,
  Feature_UseAVXBit = 54,
  Feature_NoAVX512Bit = 45,
  Feature_HasCDIBit = 98,
  Feature_HasVPOPCNTDQBit = 102,
  Feature_HasDQIBit = 96,
  Feature_NoDQIBit = 68,
  Feature_HasBWIBit = 97,
  Feature_NoBWIBit = 65,
  Feature_HasVLXBit = 95,
  Feature_NoVLXBit = 44,
  Feature_NoVLX_Or_NoBWIBit = 62,
  Feature_HasVNNIBit = 104,
  Feature_HasVP2INTERSECTBit = 106,
  Feature_HasFP16Bit = 100,
  Feature_HasAVXVNNIINT16Bit = 93,
  Feature_HasAVXVNNIINT8Bit = 88,
  Feature_HasAVXVNNIBit = 82,
  Feature_NoVLX_Or_NoVNNIBit = 83,
  Feature_HasBITALGBit = 105,
  Feature_HasPOPCNTBit = 69,
  Feature_HasAESBit = 74,
  Feature_HasVAESBit = 76,
  Feature_NoVLX_Or_NoVAESBit = 75,
  Feature_HasFXSRBit = 41,
  Feature_HasX87Bit = 39,
  Feature_HasXSAVEBit = 126,
  Feature_HasXSAVEOPTBit = 127,
  Feature_HasXSAVECBit = 128,
  Feature_HasXSAVESBit = 129,
  Feature_HasPCLMULBit = 78,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 79,
  Feature_HasVPCLMULQDQBit = 80,
  Feature_HasGFNIBit = 85,
  Feature_HasFMABit = 42,
  Feature_HasFMA4Bit = 46,
  Feature_NoFMA4Bit = 43,
  Feature_HasXOPBit = 47,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 142,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 84,
  Feature_HasFSGSBaseBit = 130,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 141,
  Feature_HasVBMIBit = 99,
  Feature_HasVBMI2Bit = 103,
  Feature_HasIFMABit = 101,
  Feature_HasAVXIFMABit = 86,
  Feature_NoVLX_Or_NoIFMABit = 87,
  Feature_HasRTMBit = 112,
  Feature_HasSHABit = 73,
  Feature_HasSHA512Bit = 90,
  Feature_HasSM3Bit = 91,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 59,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 111,
  Feature_HasMWAITXBit = 140,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 133,
  Feature_FPStackf32Bit = 37,
  Feature_FPStackf64Bit = 38,
  Feature_HasSM4Bit = 92,
  Feature_HasCLFLUSHBit = 60,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 125,
  Feature_HasRDPIDBit = 132,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 131,
  Feature_HasCX8Bit = 138,
  Feature_HasCX16Bit = 139,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 117,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 89,
  Feature_HasKLBit = 113,
  Feature_HasRAOINTBit = 123,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 114,
  Feature_HasAMXBF16Bit = 116,
  Feature_HasAMXINT8Bit = 115,
  Feature_HasAMXCOMPLEXBit = 118,
  Feature_HasAMXFP8Bit = 119,
  Feature_HasAMXTRANSPOSEBit = 120,
  Feature_HasAMXAVX512Bit = 121,
  Feature_HasAMXTF32Bit = 122,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 124,
  Feature_HasCRC32Bit = 72,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 135,
  Feature_NotLP64Bit = 134,
  Feature_NotWin64WithoutFPBit = 136,
  Feature_IsPSBit = 146,
  Feature_NotPSBit = 145,
  Feature_KernelCodeBit = 147,
  Feature_NearDataBit = 149,
  Feature_IsNotPICBit = 148,
  Feature_OptForSizeBit = 53,
  Feature_OptForMinSizeBit = 51,
  Feature_OptForSpeedBit = 143,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 55,
  Feature_ImportCallOptimizationEnabledBit = 35,
  Feature_ImportCallOptimizationDisabledBit = 33,
  Feature_CallImmAddrBit = 150,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 36,
  Feature_HasMFenceBit = 61,
  Feature_UseIndirectThunkCallsBit = 34,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  if (MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationEnabledBit);
  if (!MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationDisabledBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasAVXNECONVERT,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasCLDEMOTE,
  GIFBS_HasCLFLUSH,
  GIFBS_HasCLFLUSHOPT,
  GIFBS_HasCLWB,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFXSR,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMOVRS,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasPrefetchW,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasSSEPrefetch,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasXSAVE,
  GIFBS_HasXSAVEC,
  GIFBS_HasXSAVEOPT,
  GIFBS_HasXSAVES,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoAVX,
  GIFBS_NoDQI,
  GIFBS_NoEGPR,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseIncDec,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE3,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasAVX512_NoEGPR,
  GIFBS_HasAVX512_OptForSize,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasBWI_NoEGPR,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasDQI_NoEGPR,
  GIFBS_HasEGPR_HasINVPCID,
  GIFBS_HasEGPR_In64BitMode,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFP16_OptForSize,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasFXSR_In64BitMode,
  GIFBS_HasINVPCID_NoEGPR,
  GIFBS_HasINVPCID_Not64BitMode,
  GIFBS_HasMOVBE_NoEGPR,
  GIFBS_HasMOVDIR64B_NoEGPR,
  GIFBS_HasMOVDIRI_NoEGPR,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPREFETCHI_In64BitMode,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_HasXSAVE_In64BitMode,
  GIFBS_HasXSAVEC_In64BitMode,
  GIFBS_HasXSAVEOPT_In64BitMode,
  GIFBS_HasXSAVES_In64BitMode,
  GIFBS_In64BitMode_UseIncDec,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_OptForSize_UseAVX,
  GIFBS_OptForSize_UseSSE1,
  GIFBS_OptForSize_UseSSE2,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTILE_HasEGPR_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode_NoEGPR,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX10_2_HasMOVRS_In64BitMode,
  GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode,
  GIFBS_HasAVX512_HasEGPR_In64BitMode,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEGPR_In64BitMode,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasMOVBE_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIRI_In64BitMode,
  GIFBS_HasEGPR_HasMOVRS_In64BitMode,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
  GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR,
  GIFBS_HasMOVDIRI_In64BitMode_NoEGPR,
  GIFBS_HasMOVRS_In64BitMode_NoEGPR,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasAVXNECONVERTBit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasCLDEMOTEBit, },
  {Feature_HasCLFLUSHBit, },
  {Feature_HasCLFLUSHOPTBit, },
  {Feature_HasCLWBBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFXSRBit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMOVRSBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasPrefetchWBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasSSEPrefetchBit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasXSAVEBit, },
  {Feature_HasXSAVECBit, },
  {Feature_HasXSAVEOPTBit, },
  {Feature_HasXSAVESBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoAVXBit, },
  {Feature_NoDQIBit, },
  {Feature_NoEGPRBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseIncDecBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE3Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasAVX512Bit, Feature_NoEGPRBit, },
  {Feature_HasAVX512Bit, Feature_OptForSizeBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasBWIBit, Feature_NoEGPRBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasDQIBit, Feature_NoEGPRBit, },
  {Feature_HasEGPRBit, Feature_HasINVPCIDBit, },
  {Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFP16Bit, Feature_OptForSizeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasFXSRBit, Feature_In64BitModeBit, },
  {Feature_HasINVPCIDBit, Feature_NoEGPRBit, },
  {Feature_HasINVPCIDBit, Feature_Not64BitModeBit, },
  {Feature_HasMOVBEBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIR64BBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_NoEGPRBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPREFETCHIBit, Feature_In64BitModeBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_HasXSAVEBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVECBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVEOPTBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVESBit, Feature_In64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseIncDecBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_OptForSizeBit, Feature_UseAVXBit, },
  {Feature_OptForSizeBit, Feature_UseSSE1Bit, },
  {Feature_OptForSizeBit, Feature_UseSSE2Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX10_2Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasMOVBEBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIRIBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVRSBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addr,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &X86InstructionSelector::selectAddr, // gi_addr
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_alignedload = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_alignedstore,
  GICXXPred_MI_Predicate_imm_su,
  GICXXPred_MI_Predicate_loadi8,
  GICXXPred_MI_Predicate_loadi16,
  GICXXPred_MI_Predicate_loadi32,
};
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_alignedload: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedload should have returned");
  }
  case GICXXPred_MI_Predicate_alignedstore: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedstore should have returned");
  }
  case GICXXPred_MI_Predicate_imm_su: {
     return true; 
  }
  case GICXXPred_MI_Predicate_loadi8: {
     return isa<GLoad>(MI); 
  }
  case GICXXPred_MI_Predicate_loadi16: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 2 && Load.isSimple();
      
    llvm_unreachable("loadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_loadi32: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 4 && Load.isSimple();
      
    llvm_unreachable("loadi32 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(341), /*)*//*default:*//*Label 79*/ GIMT_Encode4(236799),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1162),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(7395),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(10931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(14714),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(25306),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(33710), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(46411), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(46578), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(48868),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(52046), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 10*/ GIMT_Encode4(53266),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 11*/ GIMT_Encode4(59491),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 12*/ GIMT_Encode4(59824), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 13*/ GIMT_Encode4(60479), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 14*/ GIMT_Encode4(85942),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 15*/ GIMT_Encode4(86178), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    298 */ /*TargetOpcode::G_PREFETCH*//*Label 16*/ GIMT_Encode4(86426), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 17*/ GIMT_Encode4(86745),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 18*/ GIMT_Encode4(100571), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 19*/ GIMT_Encode4(109646),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 20*/ GIMT_Encode4(110081),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 21*/ GIMT_Encode4(111170),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 22*/ GIMT_Encode4(111776), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 23*/ GIMT_Encode4(112229),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ GIMT_Encode4(113901),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 25*/ GIMT_Encode4(114143),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 26*/ GIMT_Encode4(116127),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 27*/ GIMT_Encode4(118411),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 28*/ GIMT_Encode4(120455),
     /*    378 */ /*TargetOpcode::G_FSHL*//*Label 29*/ GIMT_Encode4(122499),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 30*/ GIMT_Encode4(123227),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 31*/ GIMT_Encode4(123915),
     /*    390 */ /*TargetOpcode::G_ROTL*//*Label 32*/ GIMT_Encode4(127413),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 33*/ GIMT_Encode4(131133), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 34*/ GIMT_Encode4(132790), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 35*/ GIMT_Encode4(140456),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 36*/ GIMT_Encode4(141321),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 37*/ GIMT_Encode4(142186),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 38*/ GIMT_Encode4(143872),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 39*/ GIMT_Encode4(145558),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 40*/ GIMT_Encode4(146624), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 41*/ GIMT_Encode4(147690),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 42*/ GIMT_Encode4(153604),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 43*/ GIMT_Encode4(157786),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 44*/ GIMT_Encode4(163700), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 45*/ GIMT_Encode4(169688), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 46*/ GIMT_Encode4(173870),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 47*/ GIMT_Encode4(173993),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 48*/ GIMT_Encode4(174925),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 49*/ GIMT_Encode4(175311),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 50*/ GIMT_Encode4(176692),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 51*/ GIMT_Encode4(177248),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 52*/ GIMT_Encode4(180624), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 53*/ GIMT_Encode4(182871), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(182994),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(186315),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(189636),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(192957),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(196278), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(198159), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 60*/ GIMT_Encode4(198175), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    770 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 61*/ GIMT_Encode4(201104),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 62*/ GIMT_Encode4(203086),
     /*    778 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 63*/ GIMT_Encode4(203392),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 64*/ GIMT_Encode4(203779), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 65*/ GIMT_Encode4(205083),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 66*/ GIMT_Encode4(207345), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(207845), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 68*/ GIMT_Encode4(210014),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 69*/ GIMT_Encode4(214944),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 70*/ GIMT_Encode4(218634),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 71*/ GIMT_Encode4(223564), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 72*/ GIMT_Encode4(227254),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 73*/ GIMT_Encode4(233242), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 74*/ GIMT_Encode4(235411),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 75*/ GIMT_Encode4(235424),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 76*/ GIMT_Encode4(235460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1154 */ /*X86::G_FILD*//*Label 77*/ GIMT_Encode4(235476),
     /*   1158 */ /*X86::G_FIST*//*Label 78*/ GIMT_Encode4(235935),
     /*   1162 */ // Label 0: @1162
     /*   1162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 96*/ GIMT_Encode4(7394),
     /*   1173 */ /*GILLT_s8*//*Label 80*/ GIMT_Encode4(1269),
     /*   1177 */ /*GILLT_s16*//*Label 81*/ GIMT_Encode4(1774),
     /*   1181 */ /*GILLT_s32*//*Label 82*/ GIMT_Encode4(2424),
     /*   1185 */ /*GILLT_s64*//*Label 83*/ GIMT_Encode4(3074), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1201 */ /*GILLT_v2s64*//*Label 84*/ GIMT_Encode4(3898), GIMT_Encode4(0),
     /*   1209 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(4240),
     /*   1213 */ /*GILLT_v4s64*//*Label 86*/ GIMT_Encode4(4704), GIMT_Encode4(0),
     /*   1221 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(5019),
     /*   1225 */ /*GILLT_v8s32*//*Label 88*/ GIMT_Encode4(5483),
     /*   1229 */ /*GILLT_v8s64*//*Label 89*/ GIMT_Encode4(5798), GIMT_Encode4(0),
     /*   1237 */ /*GILLT_v16s8*//*Label 90*/ GIMT_Encode4(5954),
     /*   1241 */ /*GILLT_v16s16*//*Label 91*/ GIMT_Encode4(6296),
     /*   1245 */ /*GILLT_v16s32*//*Label 92*/ GIMT_Encode4(6611), GIMT_Encode4(0),
     /*   1253 */ /*GILLT_v32s8*//*Label 93*/ GIMT_Encode4(6767),
     /*   1257 */ /*GILLT_v32s16*//*Label 94*/ GIMT_Encode4(7082), GIMT_Encode4(0),
     /*   1265 */ /*GILLT_v64s8*//*Label 95*/ GIMT_Encode4(7238),
     /*   1269 */ // Label 80: @1269
     /*   1269 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1773),
     /*   1274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   1277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   1280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1284 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1345), // Rule ID 26054 //
     /*   1289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1307 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1324 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1343 */     GIR_RootConstrainSelectedInstOperands,
     /*   1344 */     // GIR_Coverage, 26054,
     /*   1344 */     GIR_EraseRootFromParent_Done,
     /*   1345 */   // Label 98: @1345
     /*   1345 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1406), // Rule ID 26073 //
     /*   1350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1368 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1385 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1404 */     GIR_RootConstrainSelectedInstOperands,
     /*   1405 */     // GIR_Coverage, 26073,
     /*   1405 */     GIR_EraseRootFromParent_Done,
     /*   1406 */   // Label 99: @1406
     /*   1406 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1467), // Rule ID 22796 //
     /*   1411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1433 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1446 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1465 */     GIR_RootConstrainSelectedInstOperands,
     /*   1466 */     // GIR_Coverage, 22796,
     /*   1466 */     GIR_EraseRootFromParent_Done,
     /*   1467 */   // Label 100: @1467
     /*   1467 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1528), // Rule ID 22886 //
     /*   1472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1507 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1526 */     GIR_RootConstrainSelectedInstOperands,
     /*   1527 */     // GIR_Coverage, 22886,
     /*   1527 */     GIR_EraseRootFromParent_Done,
     /*   1528 */   // Label 101: @1528
     /*   1528 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1556), // Rule ID 22862 //
     /*   1533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1544 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*   1547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1554 */     GIR_RootConstrainSelectedInstOperands,
     /*   1555 */     // GIR_Coverage, 22862,
     /*   1555 */     GIR_EraseRootFromParent_Done,
     /*   1556 */   // Label 102: @1556
     /*   1556 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1584), // Rule ID 22866 //
     /*   1561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1572 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*   1575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1577 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1582 */     GIR_RootConstrainSelectedInstOperands,
     /*   1583 */     // GIR_Coverage, 22866,
     /*   1583 */     GIR_EraseRootFromParent_Done,
     /*   1584 */   // Label 103: @1584
     /*   1584 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1612), // Rule ID 22952 //
     /*   1589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1600 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*   1603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1610 */     GIR_RootConstrainSelectedInstOperands,
     /*   1611 */     // GIR_Coverage, 22952,
     /*   1611 */     GIR_EraseRootFromParent_Done,
     /*   1612 */   // Label 104: @1612
     /*   1612 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1640), // Rule ID 22956 //
     /*   1617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1628 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*   1631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1638 */     GIR_RootConstrainSelectedInstOperands,
     /*   1639 */     // GIR_Coverage, 22956,
     /*   1639 */     GIR_EraseRootFromParent_Done,
     /*   1640 */   // Label 105: @1640
     /*   1640 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1677), // Rule ID 22800 //
     /*   1645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1660 */     // MIs[1] Operand 1
     /*   1660 */     // No operand predicates
     /*   1660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1662 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*   1665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1675 */     GIR_RootConstrainSelectedInstOperands,
     /*   1676 */     // GIR_Coverage, 22800,
     /*   1676 */     GIR_EraseRootFromParent_Done,
     /*   1677 */   // Label 106: @1677
     /*   1677 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1714), // Rule ID 22890 //
     /*   1682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1697 */     // MIs[1] Operand 1
     /*   1697 */     // No operand predicates
     /*   1697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1699 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*   1702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1712 */     GIR_RootConstrainSelectedInstOperands,
     /*   1713 */     // GIR_Coverage, 22890,
     /*   1713 */     GIR_EraseRootFromParent_Done,
     /*   1714 */   // Label 107: @1714
     /*   1714 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1743), // Rule ID 22792 //
     /*   1719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1730 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*   1735 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1741 */     GIR_RootConstrainSelectedInstOperands,
     /*   1742 */     // GIR_Coverage, 22792,
     /*   1742 */     GIR_Done,
     /*   1743 */   // Label 108: @1743
     /*   1743 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1772), // Rule ID 22882 //
     /*   1748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1759 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*   1764 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1770 */     GIR_RootConstrainSelectedInstOperands,
     /*   1771 */     // GIR_Coverage, 22882,
     /*   1771 */     GIR_Done,
     /*   1772 */   // Label 109: @1772
     /*   1772 */   GIM_Reject,
     /*   1773 */ // Label 97: @1773
     /*   1773 */ GIM_Reject,
     /*   1774 */ // Label 81: @1774
     /*   1774 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2423),
     /*   1779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   1782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   1785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1789 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1858), // Rule ID 22617 //
     /*   1794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1805 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1808 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1812 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1816 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1836 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] })  =>  (SUB16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i16] })
     /*   1836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi_ND),
     /*   1839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1841 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   1845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1856 */     GIR_RootConstrainSelectedInstOperands,
     /*   1857 */     // GIR_Coverage, 22617,
     /*   1857 */     GIR_EraseRootFromParent_Done,
     /*   1858 */   // Label 111: @1858
     /*   1858 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1919), // Rule ID 26055 //
     /*   1863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1874 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1881 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1898 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1917 */     GIR_RootConstrainSelectedInstOperands,
     /*   1918 */     // GIR_Coverage, 26055,
     /*   1918 */     GIR_EraseRootFromParent_Done,
     /*   1919 */   // Label 112: @1919
     /*   1919 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1980), // Rule ID 26074 //
     /*   1924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1942 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1959 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1978 */     GIR_RootConstrainSelectedInstOperands,
     /*   1979 */     // GIR_Coverage, 26074,
     /*   1979 */     GIR_EraseRootFromParent_Done,
     /*   1980 */   // Label 113: @1980
     /*   1980 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2041), // Rule ID 22797 //
     /*   1985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2000 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2007 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   2011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2020 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   2023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2039 */     GIR_RootConstrainSelectedInstOperands,
     /*   2040 */     // GIR_Coverage, 22797,
     /*   2040 */     GIR_EraseRootFromParent_Done,
     /*   2041 */   // Label 114: @2041
     /*   2041 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2102), // Rule ID 22887 //
     /*   2046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2068 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   2072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2081 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   2084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2086 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2100 */     GIR_RootConstrainSelectedInstOperands,
     /*   2101 */     // GIR_Coverage, 22887,
     /*   2101 */     GIR_EraseRootFromParent_Done,
     /*   2102 */   // Label 115: @2102
     /*   2102 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2140), // Rule ID 22602 //
     /*   2107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2114 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2125 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   2125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   2128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2138 */     GIR_RootConstrainSelectedInstOperands,
     /*   2139 */     // GIR_Coverage, 22602,
     /*   2139 */     GIR_EraseRootFromParent_Done,
     /*   2140 */   // Label 116: @2140
     /*   2140 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2178), // Rule ID 22608 //
     /*   2145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2152 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2163 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   2163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   2166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2176 */     GIR_RootConstrainSelectedInstOperands,
     /*   2177 */     // GIR_Coverage, 22608,
     /*   2177 */     GIR_EraseRootFromParent_Done,
     /*   2178 */   // Label 117: @2178
     /*   2178 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2206), // Rule ID 22863 //
     /*   2183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2194 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*   2197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2204 */     GIR_RootConstrainSelectedInstOperands,
     /*   2205 */     // GIR_Coverage, 22863,
     /*   2205 */     GIR_EraseRootFromParent_Done,
     /*   2206 */   // Label 118: @2206
     /*   2206 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2234), // Rule ID 22867 //
     /*   2211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2222 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*   2225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2232 */     GIR_RootConstrainSelectedInstOperands,
     /*   2233 */     // GIR_Coverage, 22867,
     /*   2233 */     GIR_EraseRootFromParent_Done,
     /*   2234 */   // Label 119: @2234
     /*   2234 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2262), // Rule ID 22953 //
     /*   2239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2250 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*   2253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2260 */     GIR_RootConstrainSelectedInstOperands,
     /*   2261 */     // GIR_Coverage, 22953,
     /*   2261 */     GIR_EraseRootFromParent_Done,
     /*   2262 */   // Label 120: @2262
     /*   2262 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2290), // Rule ID 22957 //
     /*   2267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2278 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*   2281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2288 */     GIR_RootConstrainSelectedInstOperands,
     /*   2289 */     // GIR_Coverage, 22957,
     /*   2289 */     GIR_EraseRootFromParent_Done,
     /*   2290 */   // Label 121: @2290
     /*   2290 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2327), // Rule ID 22801 //
     /*   2295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2310 */     // MIs[1] Operand 1
     /*   2310 */     // No operand predicates
     /*   2310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2312 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*   2315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2325 */     GIR_RootConstrainSelectedInstOperands,
     /*   2326 */     // GIR_Coverage, 22801,
     /*   2326 */     GIR_EraseRootFromParent_Done,
     /*   2327 */   // Label 122: @2327
     /*   2327 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2364), // Rule ID 22891 //
     /*   2332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2347 */     // MIs[1] Operand 1
     /*   2347 */     // No operand predicates
     /*   2347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2349 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*   2352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2354 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2362 */     GIR_RootConstrainSelectedInstOperands,
     /*   2363 */     // GIR_Coverage, 22891,
     /*   2363 */     GIR_EraseRootFromParent_Done,
     /*   2364 */   // Label 123: @2364
     /*   2364 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2393), // Rule ID 22793 //
     /*   2369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2380 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*   2385 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2391 */     GIR_RootConstrainSelectedInstOperands,
     /*   2392 */     // GIR_Coverage, 22793,
     /*   2392 */     GIR_Done,
     /*   2393 */   // Label 124: @2393
     /*   2393 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2422), // Rule ID 22883 //
     /*   2398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2409 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*   2414 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2420 */     GIR_RootConstrainSelectedInstOperands,
     /*   2421 */     // GIR_Coverage, 22883,
     /*   2421 */     GIR_Done,
     /*   2422 */   // Label 125: @2422
     /*   2422 */   GIM_Reject,
     /*   2423 */ // Label 110: @2423
     /*   2423 */ GIM_Reject,
     /*   2424 */ // Label 82: @2424
     /*   2424 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(3073),
     /*   2429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2439 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2508), // Rule ID 22618 //
     /*   2444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2462 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2466 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2486 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] })  =>  (SUB32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i32] })
     /*   2486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi_ND),
     /*   2489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2506 */     GIR_RootConstrainSelectedInstOperands,
     /*   2507 */     // GIR_Coverage, 22618,
     /*   2507 */     GIR_EraseRootFromParent_Done,
     /*   2508 */   // Label 127: @2508
     /*   2508 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2569), // Rule ID 26056 //
     /*   2513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2527 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2531 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2548 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2567 */     GIR_RootConstrainSelectedInstOperands,
     /*   2568 */     // GIR_Coverage, 26056,
     /*   2568 */     GIR_EraseRootFromParent_Done,
     /*   2569 */   // Label 128: @2569
     /*   2569 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2630), // Rule ID 26075 //
     /*   2574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2585 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2592 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2609 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2614 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2628 */     GIR_RootConstrainSelectedInstOperands,
     /*   2629 */     // GIR_Coverage, 26075,
     /*   2629 */     GIR_EraseRootFromParent_Done,
     /*   2630 */   // Label 129: @2630
     /*   2630 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2691), // Rule ID 22798 //
     /*   2635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2657 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2670 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2689 */     GIR_RootConstrainSelectedInstOperands,
     /*   2690 */     // GIR_Coverage, 22798,
     /*   2690 */     GIR_EraseRootFromParent_Done,
     /*   2691 */   // Label 130: @2691
     /*   2691 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2752), // Rule ID 22888 //
     /*   2696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2714 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2718 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2731 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2750 */     GIR_RootConstrainSelectedInstOperands,
     /*   2751 */     // GIR_Coverage, 22888,
     /*   2751 */     GIR_EraseRootFromParent_Done,
     /*   2752 */   // Label 131: @2752
     /*   2752 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2790), // Rule ID 22603 //
     /*   2757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2764 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2775 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   2778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2780 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2788 */     GIR_RootConstrainSelectedInstOperands,
     /*   2789 */     // GIR_Coverage, 22603,
     /*   2789 */     GIR_EraseRootFromParent_Done,
     /*   2790 */   // Label 132: @2790
     /*   2790 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2828), // Rule ID 22609 //
     /*   2795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2802 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2813 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   2816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2818 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2826 */     GIR_RootConstrainSelectedInstOperands,
     /*   2827 */     // GIR_Coverage, 22609,
     /*   2827 */     GIR_EraseRootFromParent_Done,
     /*   2828 */   // Label 133: @2828
     /*   2828 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2856), // Rule ID 22864 //
     /*   2833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2844 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*   2847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2854 */     GIR_RootConstrainSelectedInstOperands,
     /*   2855 */     // GIR_Coverage, 22864,
     /*   2855 */     GIR_EraseRootFromParent_Done,
     /*   2856 */   // Label 134: @2856
     /*   2856 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2884), // Rule ID 22868 //
     /*   2861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2872 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*   2875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2882 */     GIR_RootConstrainSelectedInstOperands,
     /*   2883 */     // GIR_Coverage, 22868,
     /*   2883 */     GIR_EraseRootFromParent_Done,
     /*   2884 */   // Label 135: @2884
     /*   2884 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2912), // Rule ID 22954 //
     /*   2889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2900 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*   2903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2910 */     GIR_RootConstrainSelectedInstOperands,
     /*   2911 */     // GIR_Coverage, 22954,
     /*   2911 */     GIR_EraseRootFromParent_Done,
     /*   2912 */   // Label 136: @2912
     /*   2912 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2940), // Rule ID 22958 //
     /*   2917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2928 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*   2931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2938 */     GIR_RootConstrainSelectedInstOperands,
     /*   2939 */     // GIR_Coverage, 22958,
     /*   2939 */     GIR_EraseRootFromParent_Done,
     /*   2940 */   // Label 137: @2940
     /*   2940 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2977), // Rule ID 22802 //
     /*   2945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2960 */     // MIs[1] Operand 1
     /*   2960 */     // No operand predicates
     /*   2960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2962 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*   2965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2975 */     GIR_RootConstrainSelectedInstOperands,
     /*   2976 */     // GIR_Coverage, 22802,
     /*   2976 */     GIR_EraseRootFromParent_Done,
     /*   2977 */   // Label 138: @2977
     /*   2977 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(3014), // Rule ID 22892 //
     /*   2982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2997 */     // MIs[1] Operand 1
     /*   2997 */     // No operand predicates
     /*   2997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2999 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*   3002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3012 */     GIR_RootConstrainSelectedInstOperands,
     /*   3013 */     // GIR_Coverage, 22892,
     /*   3013 */     GIR_EraseRootFromParent_Done,
     /*   3014 */   // Label 139: @3014
     /*   3014 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3043), // Rule ID 22794 //
     /*   3019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3030 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   3030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*   3035 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3041 */     GIR_RootConstrainSelectedInstOperands,
     /*   3042 */     // GIR_Coverage, 22794,
     /*   3042 */     GIR_Done,
     /*   3043 */   // Label 140: @3043
     /*   3043 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(3072), // Rule ID 22884 //
     /*   3048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3059 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   3059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*   3064 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3070 */     GIR_RootConstrainSelectedInstOperands,
     /*   3071 */     // GIR_Coverage, 22884,
     /*   3071 */     GIR_Done,
     /*   3072 */   // Label 141: @3072
     /*   3072 */   GIM_Reject,
     /*   3073 */ // Label 126: @3073
     /*   3073 */ GIM_Reject,
     /*   3074 */ // Label 83: @3074
     /*   3074 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3897),
     /*   3079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   3082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   3085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3089 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3158), // Rule ID 22619 //
     /*   3094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3105 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3112 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3136 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i64] })
     /*   3136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3156 */     GIR_RootConstrainSelectedInstOperands,
     /*   3157 */     // GIR_Coverage, 22619,
     /*   3157 */     GIR_EraseRootFromParent_Done,
     /*   3158 */   // Label 143: @3158
     /*   3158 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(3234), // Rule ID 22625 //
     /*   3163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3185 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3205 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -2147483648:{ *:[i64] })
     /*   3205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3214 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3232 */     GIR_RootConstrainSelectedInstOperands,
     /*   3233 */     // GIR_Coverage, 22625,
     /*   3233 */     GIR_EraseRootFromParent_Done,
     /*   3234 */   // Label 144: @3234
     /*   3234 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(3295), // Rule ID 26057 //
     /*   3239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3257 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3274 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3293 */     GIR_RootConstrainSelectedInstOperands,
     /*   3294 */     // GIR_Coverage, 26057,
     /*   3294 */     GIR_EraseRootFromParent_Done,
     /*   3295 */   // Label 145: @3295
     /*   3295 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3356), // Rule ID 26076 //
     /*   3300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3318 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3335 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3354 */     GIR_RootConstrainSelectedInstOperands,
     /*   3355 */     // GIR_Coverage, 26076,
     /*   3355 */     GIR_EraseRootFromParent_Done,
     /*   3356 */   // Label 146: @3356
     /*   3356 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3417), // Rule ID 22799 //
     /*   3361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3396 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3415 */     GIR_RootConstrainSelectedInstOperands,
     /*   3416 */     // GIR_Coverage, 22799,
     /*   3416 */     GIR_EraseRootFromParent_Done,
     /*   3417 */   // Label 147: @3417
     /*   3417 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3478), // Rule ID 22889 //
     /*   3422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3457 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3476 */     GIR_RootConstrainSelectedInstOperands,
     /*   3477 */     // GIR_Coverage, 22889,
     /*   3477 */     GIR_EraseRootFromParent_Done,
     /*   3478 */   // Label 148: @3478
     /*   3478 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3516), // Rule ID 22604 //
     /*   3483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3490 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3501 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3514 */     GIR_RootConstrainSelectedInstOperands,
     /*   3515 */     // GIR_Coverage, 22604,
     /*   3515 */     GIR_EraseRootFromParent_Done,
     /*   3516 */   // Label 149: @3516
     /*   3516 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(3554), // Rule ID 22610 //
     /*   3521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3528 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3539 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3552 */     GIR_RootConstrainSelectedInstOperands,
     /*   3553 */     // GIR_Coverage, 22610,
     /*   3553 */     GIR_EraseRootFromParent_Done,
     /*   3554 */   // Label 150: @3554
     /*   3554 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3599), // Rule ID 22620 //
     /*   3559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3566 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3577 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3584 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3597 */     GIR_RootConstrainSelectedInstOperands,
     /*   3598 */     // GIR_Coverage, 22620,
     /*   3598 */     GIR_EraseRootFromParent_Done,
     /*   3599 */   // Label 151: @3599
     /*   3599 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3644), // Rule ID 22622 //
     /*   3604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3611 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3622 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3629 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3642 */     GIR_RootConstrainSelectedInstOperands,
     /*   3643 */     // GIR_Coverage, 22622,
     /*   3643 */     GIR_EraseRootFromParent_Done,
     /*   3644 */   // Label 152: @3644
     /*   3644 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3672), // Rule ID 22865 //
     /*   3649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3660 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*   3663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3670 */     GIR_RootConstrainSelectedInstOperands,
     /*   3671 */     // GIR_Coverage, 22865,
     /*   3671 */     GIR_EraseRootFromParent_Done,
     /*   3672 */   // Label 153: @3672
     /*   3672 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3700), // Rule ID 22869 //
     /*   3677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3688 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*   3691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3698 */     GIR_RootConstrainSelectedInstOperands,
     /*   3699 */     // GIR_Coverage, 22869,
     /*   3699 */     GIR_EraseRootFromParent_Done,
     /*   3700 */   // Label 154: @3700
     /*   3700 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3728), // Rule ID 22955 //
     /*   3705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3716 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*   3719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3726 */     GIR_RootConstrainSelectedInstOperands,
     /*   3727 */     // GIR_Coverage, 22955,
     /*   3727 */     GIR_EraseRootFromParent_Done,
     /*   3728 */   // Label 155: @3728
     /*   3728 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3756), // Rule ID 22959 //
     /*   3733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3744 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*   3747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3754 */     GIR_RootConstrainSelectedInstOperands,
     /*   3755 */     // GIR_Coverage, 22959,
     /*   3755 */     GIR_EraseRootFromParent_Done,
     /*   3756 */   // Label 156: @3756
     /*   3756 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3797), // Rule ID 22803 //
     /*   3761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3780 */     // MIs[1] Operand 1
     /*   3780 */     // No operand predicates
     /*   3780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3782 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*   3785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3795 */     GIR_RootConstrainSelectedInstOperands,
     /*   3796 */     // GIR_Coverage, 22803,
     /*   3796 */     GIR_EraseRootFromParent_Done,
     /*   3797 */   // Label 157: @3797
     /*   3797 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3838), // Rule ID 22893 //
     /*   3802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3821 */     // MIs[1] Operand 1
     /*   3821 */     // No operand predicates
     /*   3821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3823 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*   3826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3836 */     GIR_RootConstrainSelectedInstOperands,
     /*   3837 */     // GIR_Coverage, 22893,
     /*   3837 */     GIR_EraseRootFromParent_Done,
     /*   3838 */   // Label 158: @3838
     /*   3838 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3867), // Rule ID 22795 //
     /*   3843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3854 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*   3859 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3865 */     GIR_RootConstrainSelectedInstOperands,
     /*   3866 */     // GIR_Coverage, 22795,
     /*   3866 */     GIR_Done,
     /*   3867 */   // Label 159: @3867
     /*   3867 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3896), // Rule ID 22885 //
     /*   3872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3883 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*   3888 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3894 */     GIR_RootConstrainSelectedInstOperands,
     /*   3895 */     // GIR_Coverage, 22885,
     /*   3895 */     GIR_Done,
     /*   3896 */   // Label 160: @3896
     /*   3896 */   GIM_Reject,
     /*   3897 */ // Label 142: @3897
     /*   3897 */ GIM_Reject,
     /*   3898 */ // Label 84: @3898
     /*   3898 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(4239),
     /*   3903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   3906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   3909 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3971), // Rule ID 23438 //
     /*   3914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3953 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3969 */     GIR_RootConstrainSelectedInstOperands,
     /*   3970 */     // GIR_Coverage, 23438,
     /*   3970 */     GIR_EraseRootFromParent_Done,
     /*   3971 */   // Label 162: @3971
     /*   3971 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(4033), // Rule ID 23708 //
     /*   3976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4015 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   4018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4020 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4031 */     GIR_RootConstrainSelectedInstOperands,
     /*   4032 */     // GIR_Coverage, 23708,
     /*   4032 */     GIR_EraseRootFromParent_Done,
     /*   4033 */   // Label 163: @4033
     /*   4033 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(4095), // Rule ID 2541 //
     /*   4038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4077 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   4080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4093 */     GIR_RootConstrainSelectedInstOperands,
     /*   4094 */     // GIR_Coverage, 2541,
     /*   4094 */     GIR_EraseRootFromParent_Done,
     /*   4095 */   // Label 164: @4095
     /*   4095 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4157), // Rule ID 4654 //
     /*   4100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4139 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   4142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4155 */     GIR_RootConstrainSelectedInstOperands,
     /*   4156 */     // GIR_Coverage, 4654,
     /*   4156 */     GIR_EraseRootFromParent_Done,
     /*   4157 */   // Label 165: @4157
     /*   4157 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4184), // Rule ID 2540 //
     /*   4162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4177 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*   4182 */     GIR_RootConstrainSelectedInstOperands,
     /*   4183 */     // GIR_Coverage, 2540,
     /*   4183 */     GIR_Done,
     /*   4184 */   // Label 166: @4184
     /*   4184 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4211), // Rule ID 2542 //
     /*   4189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4204 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*   4209 */     GIR_RootConstrainSelectedInstOperands,
     /*   4210 */     // GIR_Coverage, 2542,
     /*   4210 */     GIR_Done,
     /*   4211 */   // Label 167: @4211
     /*   4211 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(4238), // Rule ID 4651 //
     /*   4216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4231 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   4231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*   4236 */     GIR_RootConstrainSelectedInstOperands,
     /*   4237 */     // GIR_Coverage, 4651,
     /*   4237 */     GIR_Done,
     /*   4238 */   // Label 168: @4238
     /*   4238 */   GIM_Reject,
     /*   4239 */ // Label 161: @4239
     /*   4239 */ GIM_Reject,
     /*   4240 */ // Label 85: @4240
     /*   4240 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4703),
     /*   4245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4251 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(4313), // Rule ID 23435 //
     /*   4256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4271 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4295 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4311 */     GIR_RootConstrainSelectedInstOperands,
     /*   4312 */     // GIR_Coverage, 23435,
     /*   4312 */     GIR_EraseRootFromParent_Done,
     /*   4313 */   // Label 170: @4313
     /*   4313 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4375), // Rule ID 23726 //
     /*   4318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4333 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4357 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4373 */     GIR_RootConstrainSelectedInstOperands,
     /*   4374 */     // GIR_Coverage, 23726,
     /*   4374 */     GIR_EraseRootFromParent_Done,
     /*   4375 */   // Label 171: @4375
     /*   4375 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4437), // Rule ID 2535 //
     /*   4380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4399 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4402 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4406 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4419 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4435 */     GIR_RootConstrainSelectedInstOperands,
     /*   4436 */     // GIR_Coverage, 2535,
     /*   4436 */     GIR_EraseRootFromParent_Done,
     /*   4437 */   // Label 172: @4437
     /*   4437 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4499), // Rule ID 4681 //
     /*   4442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4461 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4468 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4481 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4486 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4497 */     GIR_RootConstrainSelectedInstOperands,
     /*   4498 */     // GIR_Coverage, 4681,
     /*   4498 */     GIR_EraseRootFromParent_Done,
     /*   4499 */   // Label 173: @4499
     /*   4499 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4560), // Rule ID 17867 //
     /*   4504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4543 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4558 */     GIR_RootConstrainSelectedInstOperands,
     /*   4559 */     // GIR_Coverage, 17867,
     /*   4559 */     GIR_EraseRootFromParent_Done,
     /*   4560 */   // Label 174: @4560
     /*   4560 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4621), // Rule ID 25190 //
     /*   4565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4604 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4619 */     GIR_RootConstrainSelectedInstOperands,
     /*   4620 */     // GIR_Coverage, 25190,
     /*   4620 */     GIR_EraseRootFromParent_Done,
     /*   4621 */   // Label 175: @4621
     /*   4621 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4648), // Rule ID 2534 //
     /*   4626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4641 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*   4646 */     GIR_RootConstrainSelectedInstOperands,
     /*   4647 */     // GIR_Coverage, 2534,
     /*   4647 */     GIR_Done,
     /*   4648 */   // Label 176: @4648
     /*   4648 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4675), // Rule ID 2536 //
     /*   4653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4668 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*   4673 */     GIR_RootConstrainSelectedInstOperands,
     /*   4674 */     // GIR_Coverage, 2536,
     /*   4674 */     GIR_Done,
     /*   4675 */   // Label 177: @4675
     /*   4675 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4702), // Rule ID 4678 //
     /*   4680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4695 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   4695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*   4700 */     GIR_RootConstrainSelectedInstOperands,
     /*   4701 */     // GIR_Coverage, 4678,
     /*   4701 */     GIR_Done,
     /*   4702 */   // Label 178: @4702
     /*   4702 */   GIM_Reject,
     /*   4703 */ // Label 169: @4703
     /*   4703 */ GIM_Reject,
     /*   4704 */ // Label 86: @4704
     /*   4704 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(5018),
     /*   4709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   4712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   4715 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4777), // Rule ID 23440 //
     /*   4720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4759 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4775 */     GIR_RootConstrainSelectedInstOperands,
     /*   4776 */     // GIR_Coverage, 23440,
     /*   4776 */     GIR_EraseRootFromParent_Done,
     /*   4777 */   // Label 180: @4777
     /*   4777 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4839), // Rule ID 23702 //
     /*   4782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4797 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4800 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4804 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4821 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4837 */     GIR_RootConstrainSelectedInstOperands,
     /*   4838 */     // GIR_Coverage, 23702,
     /*   4838 */     GIR_EraseRootFromParent_Done,
     /*   4839 */   // Label 181: @4839
     /*   4839 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4901), // Rule ID 2545 //
     /*   4844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4883 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4899 */     GIR_RootConstrainSelectedInstOperands,
     /*   4900 */     // GIR_Coverage, 2545,
     /*   4900 */     GIR_EraseRootFromParent_Done,
     /*   4901 */   // Label 182: @4901
     /*   4901 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4963), // Rule ID 4645 //
     /*   4906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4945 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4961 */     GIR_RootConstrainSelectedInstOperands,
     /*   4962 */     // GIR_Coverage, 4645,
     /*   4962 */     GIR_EraseRootFromParent_Done,
     /*   4963 */   // Label 183: @4963
     /*   4963 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4990), // Rule ID 2544 //
     /*   4968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4983 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   4983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*   4988 */     GIR_RootConstrainSelectedInstOperands,
     /*   4989 */     // GIR_Coverage, 2544,
     /*   4989 */     GIR_Done,
     /*   4990 */   // Label 184: @4990
     /*   4990 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5017), // Rule ID 4642 //
     /*   4995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5010 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   5010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*   5015 */     GIR_RootConstrainSelectedInstOperands,
     /*   5016 */     // GIR_Coverage, 4642,
     /*   5016 */     GIR_Done,
     /*   5017 */   // Label 185: @5017
     /*   5017 */   GIM_Reject,
     /*   5018 */ // Label 179: @5018
     /*   5018 */ GIM_Reject,
     /*   5019 */ // Label 87: @5019
     /*   5019 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5482),
     /*   5024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5030 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5092), // Rule ID 23432 //
     /*   5035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5050 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5074 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5090 */     GIR_RootConstrainSelectedInstOperands,
     /*   5091 */     // GIR_Coverage, 23432,
     /*   5091 */     GIR_EraseRootFromParent_Done,
     /*   5092 */   // Label 187: @5092
     /*   5092 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5154), // Rule ID 23738 //
     /*   5097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5136 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5152 */     GIR_RootConstrainSelectedInstOperands,
     /*   5153 */     // GIR_Coverage, 23738,
     /*   5153 */     GIR_EraseRootFromParent_Done,
     /*   5154 */   // Label 188: @5154
     /*   5154 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5216), // Rule ID 2529 //
     /*   5159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5198 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5214 */     GIR_RootConstrainSelectedInstOperands,
     /*   5215 */     // GIR_Coverage, 2529,
     /*   5215 */     GIR_EraseRootFromParent_Done,
     /*   5216 */   // Label 189: @5216
     /*   5216 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5278), // Rule ID 4702 //
     /*   5221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5260 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5276 */     GIR_RootConstrainSelectedInstOperands,
     /*   5277 */     // GIR_Coverage, 4702,
     /*   5277 */     GIR_EraseRootFromParent_Done,
     /*   5278 */   // Label 190: @5278
     /*   5278 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5339), // Rule ID 17866 //
     /*   5283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5322 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   5337 */     GIR_RootConstrainSelectedInstOperands,
     /*   5338 */     // GIR_Coverage, 17866,
     /*   5338 */     GIR_EraseRootFromParent_Done,
     /*   5339 */   // Label 191: @5339
     /*   5339 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5400), // Rule ID 25189 //
     /*   5344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5383 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   5398 */     GIR_RootConstrainSelectedInstOperands,
     /*   5399 */     // GIR_Coverage, 25189,
     /*   5399 */     GIR_EraseRootFromParent_Done,
     /*   5400 */   // Label 192: @5400
     /*   5400 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5427), // Rule ID 2528 //
     /*   5405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5420 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*   5425 */     GIR_RootConstrainSelectedInstOperands,
     /*   5426 */     // GIR_Coverage, 2528,
     /*   5426 */     GIR_Done,
     /*   5427 */   // Label 193: @5427
     /*   5427 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5454), // Rule ID 2530 //
     /*   5432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   5435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5447 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*   5452 */     GIR_RootConstrainSelectedInstOperands,
     /*   5453 */     // GIR_Coverage, 2530,
     /*   5453 */     GIR_Done,
     /*   5454 */   // Label 194: @5454
     /*   5454 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5481), // Rule ID 4699 //
     /*   5459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5474 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   5474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*   5479 */     GIR_RootConstrainSelectedInstOperands,
     /*   5480 */     // GIR_Coverage, 4699,
     /*   5480 */     GIR_Done,
     /*   5481 */   // Label 195: @5481
     /*   5481 */   GIM_Reject,
     /*   5482 */ // Label 186: @5482
     /*   5482 */ GIM_Reject,
     /*   5483 */ // Label 88: @5483
     /*   5483 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5797),
     /*   5488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   5491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   5494 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5556), // Rule ID 23437 //
     /*   5499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5538 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5554 */     GIR_RootConstrainSelectedInstOperands,
     /*   5555 */     // GIR_Coverage, 23437,
     /*   5555 */     GIR_EraseRootFromParent_Done,
     /*   5556 */   // Label 197: @5556
     /*   5556 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5618), // Rule ID 23720 //
     /*   5561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5600 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5616 */     GIR_RootConstrainSelectedInstOperands,
     /*   5617 */     // GIR_Coverage, 23720,
     /*   5617 */     GIR_EraseRootFromParent_Done,
     /*   5618 */   // Label 198: @5618
     /*   5618 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5680), // Rule ID 2539 //
     /*   5623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5662 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5678 */     GIR_RootConstrainSelectedInstOperands,
     /*   5679 */     // GIR_Coverage, 2539,
     /*   5679 */     GIR_EraseRootFromParent_Done,
     /*   5680 */   // Label 199: @5680
     /*   5680 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5742), // Rule ID 4672 //
     /*   5685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5724 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5740 */     GIR_RootConstrainSelectedInstOperands,
     /*   5741 */     // GIR_Coverage, 4672,
     /*   5741 */     GIR_EraseRootFromParent_Done,
     /*   5742 */   // Label 200: @5742
     /*   5742 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5769), // Rule ID 2538 //
     /*   5747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5762 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   5762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*   5767 */     GIR_RootConstrainSelectedInstOperands,
     /*   5768 */     // GIR_Coverage, 2538,
     /*   5768 */     GIR_Done,
     /*   5769 */   // Label 201: @5769
     /*   5769 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(5796), // Rule ID 4669 //
     /*   5774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5789 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   5789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*   5794 */     GIR_RootConstrainSelectedInstOperands,
     /*   5795 */     // GIR_Coverage, 4669,
     /*   5795 */     GIR_Done,
     /*   5796 */   // Label 202: @5796
     /*   5796 */   GIM_Reject,
     /*   5797 */ // Label 196: @5797
     /*   5797 */ GIM_Reject,
     /*   5798 */ // Label 89: @5798
     /*   5798 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(5953),
     /*   5803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   5806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   5809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5813 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(5871), // Rule ID 23696 //
     /*   5818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5853 */     // (add:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5869 */     GIR_RootConstrainSelectedInstOperands,
     /*   5870 */     // GIR_Coverage, 23696,
     /*   5870 */     GIR_EraseRootFromParent_Done,
     /*   5871 */   // Label 204: @5871
     /*   5871 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(5929), // Rule ID 4636 //
     /*   5876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5911 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5927 */     GIR_RootConstrainSelectedInstOperands,
     /*   5928 */     // GIR_Coverage, 4636,
     /*   5928 */     GIR_EraseRootFromParent_Done,
     /*   5929 */   // Label 205: @5929
     /*   5929 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(5952), // Rule ID 4633 //
     /*   5934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5945 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   5945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*   5950 */     GIR_RootConstrainSelectedInstOperands,
     /*   5951 */     // GIR_Coverage, 4633,
     /*   5951 */     GIR_Done,
     /*   5952 */   // Label 206: @5952
     /*   5952 */   GIM_Reject,
     /*   5953 */ // Label 203: @5953
     /*   5953 */ GIM_Reject,
     /*   5954 */ // Label 90: @5954
     /*   5954 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6295),
     /*   5959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   5965 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6027), // Rule ID 23429 //
     /*   5970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6009 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   6012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6025 */     GIR_RootConstrainSelectedInstOperands,
     /*   6026 */     // GIR_Coverage, 23429,
     /*   6026 */     GIR_EraseRootFromParent_Done,
     /*   6027 */   // Label 208: @6027
     /*   6027 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6089), // Rule ID 23747 //
     /*   6032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6047 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6071 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   6074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6087 */     GIR_RootConstrainSelectedInstOperands,
     /*   6088 */     // GIR_Coverage, 23747,
     /*   6088 */     GIR_EraseRootFromParent_Done,
     /*   6089 */   // Label 209: @6089
     /*   6089 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6151), // Rule ID 2523 //
     /*   6094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6133 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   6136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6149 */     GIR_RootConstrainSelectedInstOperands,
     /*   6150 */     // GIR_Coverage, 2523,
     /*   6150 */     GIR_EraseRootFromParent_Done,
     /*   6151 */   // Label 210: @6151
     /*   6151 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6213), // Rule ID 4720 //
     /*   6156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6195 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6211 */     GIR_RootConstrainSelectedInstOperands,
     /*   6212 */     // GIR_Coverage, 4720,
     /*   6212 */     GIR_EraseRootFromParent_Done,
     /*   6213 */   // Label 211: @6213
     /*   6213 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6240), // Rule ID 2522 //
     /*   6218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6233 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*   6238 */     GIR_RootConstrainSelectedInstOperands,
     /*   6239 */     // GIR_Coverage, 2522,
     /*   6239 */     GIR_Done,
     /*   6240 */   // Label 212: @6240
     /*   6240 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6267), // Rule ID 2524 //
     /*   6245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   6248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6260 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*   6265 */     GIR_RootConstrainSelectedInstOperands,
     /*   6266 */     // GIR_Coverage, 2524,
     /*   6266 */     GIR_Done,
     /*   6267 */   // Label 213: @6267
     /*   6267 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6294), // Rule ID 4717 //
     /*   6272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6287 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*   6287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*   6292 */     GIR_RootConstrainSelectedInstOperands,
     /*   6293 */     // GIR_Coverage, 4717,
     /*   6293 */     GIR_Done,
     /*   6294 */   // Label 214: @6294
     /*   6294 */   GIM_Reject,
     /*   6295 */ // Label 207: @6295
     /*   6295 */ GIM_Reject,
     /*   6296 */ // Label 91: @6296
     /*   6296 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6610),
     /*   6301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*   6304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*   6307 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(6369), // Rule ID 23434 //
     /*   6312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6351 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6367 */     GIR_RootConstrainSelectedInstOperands,
     /*   6368 */     // GIR_Coverage, 23434,
     /*   6368 */     GIR_EraseRootFromParent_Done,
     /*   6369 */   // Label 216: @6369
     /*   6369 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(6431), // Rule ID 23735 //
     /*   6374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6413 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6429 */     GIR_RootConstrainSelectedInstOperands,
     /*   6430 */     // GIR_Coverage, 23735,
     /*   6430 */     GIR_EraseRootFromParent_Done,
     /*   6431 */   // Label 217: @6431
     /*   6431 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(6493), // Rule ID 2533 //
     /*   6436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6475 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6491 */     GIR_RootConstrainSelectedInstOperands,
     /*   6492 */     // GIR_Coverage, 2533,
     /*   6492 */     GIR_EraseRootFromParent_Done,
     /*   6493 */   // Label 218: @6493
     /*   6493 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6555), // Rule ID 4696 //
     /*   6498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6524 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6537 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6553 */     GIR_RootConstrainSelectedInstOperands,
     /*   6554 */     // GIR_Coverage, 4696,
     /*   6554 */     GIR_EraseRootFromParent_Done,
     /*   6555 */   // Label 219: @6555
     /*   6555 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6582), // Rule ID 2532 //
     /*   6560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6575 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*   6575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*   6580 */     GIR_RootConstrainSelectedInstOperands,
     /*   6581 */     // GIR_Coverage, 2532,
     /*   6581 */     GIR_Done,
     /*   6582 */   // Label 220: @6582
     /*   6582 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6609), // Rule ID 4693 //
     /*   6587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6602 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*   6602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*   6607 */     GIR_RootConstrainSelectedInstOperands,
     /*   6608 */     // GIR_Coverage, 4693,
     /*   6608 */     GIR_Done,
     /*   6609 */   // Label 221: @6609
     /*   6609 */   GIM_Reject,
     /*   6610 */ // Label 215: @6610
     /*   6610 */ GIM_Reject,
     /*   6611 */ // Label 92: @6611
     /*   6611 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6766),
     /*   6616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*   6619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*   6622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6626 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6684), // Rule ID 23714 //
     /*   6631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6666 */     // (add:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6671 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6682 */     GIR_RootConstrainSelectedInstOperands,
     /*   6683 */     // GIR_Coverage, 23714,
     /*   6683 */     GIR_EraseRootFromParent_Done,
     /*   6684 */   // Label 223: @6684
     /*   6684 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6742), // Rule ID 4663 //
     /*   6689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6724 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6740 */     GIR_RootConstrainSelectedInstOperands,
     /*   6741 */     // GIR_Coverage, 4663,
     /*   6741 */     GIR_EraseRootFromParent_Done,
     /*   6742 */   // Label 224: @6742
     /*   6742 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6765), // Rule ID 4660 //
     /*   6747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6758 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*   6758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*   6763 */     GIR_RootConstrainSelectedInstOperands,
     /*   6764 */     // GIR_Coverage, 4660,
     /*   6764 */     GIR_Done,
     /*   6765 */   // Label 225: @6765
     /*   6765 */   GIM_Reject,
     /*   6766 */ // Label 222: @6766
     /*   6766 */ GIM_Reject,
     /*   6767 */ // Label 93: @6767
     /*   6767 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(7081),
     /*   6772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*   6775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*   6778 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6840), // Rule ID 23431 //
     /*   6783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6822 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6827 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6838 */     GIR_RootConstrainSelectedInstOperands,
     /*   6839 */     // GIR_Coverage, 23431,
     /*   6839 */     GIR_EraseRootFromParent_Done,
     /*   6840 */   // Label 227: @6840
     /*   6840 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6902), // Rule ID 23744 //
     /*   6845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6884 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6900 */     GIR_RootConstrainSelectedInstOperands,
     /*   6901 */     // GIR_Coverage, 23744,
     /*   6901 */     GIR_EraseRootFromParent_Done,
     /*   6902 */   // Label 228: @6902
     /*   6902 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6964), // Rule ID 2527 //
     /*   6907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6946 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6962 */     GIR_RootConstrainSelectedInstOperands,
     /*   6963 */     // GIR_Coverage, 2527,
     /*   6963 */     GIR_EraseRootFromParent_Done,
     /*   6964 */   // Label 229: @6964
     /*   6964 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(7026), // Rule ID 4714 //
     /*   6969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7008 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   7011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7015 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7024 */     GIR_RootConstrainSelectedInstOperands,
     /*   7025 */     // GIR_Coverage, 4714,
     /*   7025 */     GIR_EraseRootFromParent_Done,
     /*   7026 */   // Label 230: @7026
     /*   7026 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(7053), // Rule ID 2526 //
     /*   7031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   7034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7046 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*   7046 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*   7051 */     GIR_RootConstrainSelectedInstOperands,
     /*   7052 */     // GIR_Coverage, 2526,
     /*   7052 */     GIR_Done,
     /*   7053 */   // Label 231: @7053
     /*   7053 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(7080), // Rule ID 4711 //
     /*   7058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   7061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7073 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*   7073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*   7078 */     GIR_RootConstrainSelectedInstOperands,
     /*   7079 */     // GIR_Coverage, 4711,
     /*   7079 */     GIR_Done,
     /*   7080 */   // Label 232: @7080
     /*   7080 */   GIM_Reject,
     /*   7081 */ // Label 226: @7081
     /*   7081 */ GIM_Reject,
     /*   7082 */ // Label 94: @7082
     /*   7082 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7237),
     /*   7087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*   7090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*   7093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7097 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7155), // Rule ID 23732 //
     /*   7102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7137 */     // (add:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7142 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7153 */     GIR_RootConstrainSelectedInstOperands,
     /*   7154 */     // GIR_Coverage, 23732,
     /*   7154 */     GIR_EraseRootFromParent_Done,
     /*   7155 */   // Label 234: @7155
     /*   7155 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7213), // Rule ID 4690 //
     /*   7160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7195 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   7198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7211 */     GIR_RootConstrainSelectedInstOperands,
     /*   7212 */     // GIR_Coverage, 4690,
     /*   7212 */     GIR_EraseRootFromParent_Done,
     /*   7213 */   // Label 235: @7213
     /*   7213 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7236), // Rule ID 4687 //
     /*   7218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7229 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*   7229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*   7234 */     GIR_RootConstrainSelectedInstOperands,
     /*   7235 */     // GIR_Coverage, 4687,
     /*   7235 */     GIR_Done,
     /*   7236 */   // Label 236: @7236
     /*   7236 */   GIM_Reject,
     /*   7237 */ // Label 233: @7237
     /*   7237 */ GIM_Reject,
     /*   7238 */ // Label 95: @7238
     /*   7238 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7393),
     /*   7243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*   7246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*   7249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7253 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7311), // Rule ID 23741 //
     /*   7258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7293 */     // (add:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7309 */     GIR_RootConstrainSelectedInstOperands,
     /*   7310 */     // GIR_Coverage, 23741,
     /*   7310 */     GIR_EraseRootFromParent_Done,
     /*   7311 */   // Label 238: @7311
     /*   7311 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(7369), // Rule ID 4708 //
     /*   7316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7351 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7367 */     GIR_RootConstrainSelectedInstOperands,
     /*   7368 */     // GIR_Coverage, 4708,
     /*   7368 */     GIR_EraseRootFromParent_Done,
     /*   7369 */   // Label 239: @7369
     /*   7369 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(7392), // Rule ID 4705 //
     /*   7374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7385 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*   7385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*   7390 */     GIR_RootConstrainSelectedInstOperands,
     /*   7391 */     // GIR_Coverage, 4705,
     /*   7391 */     GIR_Done,
     /*   7392 */   // Label 240: @7392
     /*   7392 */   GIM_Reject,
     /*   7393 */ // Label 237: @7393
     /*   7393 */ GIM_Reject,
     /*   7394 */ // Label 96: @7394
     /*   7394 */ GIM_Reject,
     /*   7395 */ // Label 1: @7395
     /*   7395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 257*/ GIMT_Encode4(10930),
     /*   7406 */ /*GILLT_s8*//*Label 241*/ GIMT_Encode4(7502),
     /*   7410 */ /*GILLT_s16*//*Label 242*/ GIMT_Encode4(7854),
     /*   7414 */ /*GILLT_s32*//*Label 243*/ GIMT_Encode4(8206),
     /*   7418 */ /*GILLT_s64*//*Label 244*/ GIMT_Encode4(8558), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   7434 */ /*GILLT_v2s64*//*Label 245*/ GIMT_Encode4(8918), GIMT_Encode4(0),
     /*   7442 */ /*GILLT_v4s32*//*Label 246*/ GIMT_Encode4(9136),
     /*   7446 */ /*GILLT_v4s64*//*Label 247*/ GIMT_Encode4(9354), GIMT_Encode4(0),
     /*   7454 */ /*GILLT_v8s16*//*Label 248*/ GIMT_Encode4(9545),
     /*   7458 */ /*GILLT_v8s32*//*Label 249*/ GIMT_Encode4(9763),
     /*   7462 */ /*GILLT_v8s64*//*Label 250*/ GIMT_Encode4(9954), GIMT_Encode4(0),
     /*   7470 */ /*GILLT_v16s8*//*Label 251*/ GIMT_Encode4(10048),
     /*   7474 */ /*GILLT_v16s16*//*Label 252*/ GIMT_Encode4(10266),
     /*   7478 */ /*GILLT_v16s32*//*Label 253*/ GIMT_Encode4(10457), GIMT_Encode4(0),
     /*   7486 */ /*GILLT_v32s8*//*Label 254*/ GIMT_Encode4(10551),
     /*   7490 */ /*GILLT_v32s16*//*Label 255*/ GIMT_Encode4(10742), GIMT_Encode4(0),
     /*   7498 */ /*GILLT_v64s8*//*Label 256*/ GIMT_Encode4(10836),
     /*   7502 */ // Label 241: @7502
     /*   7502 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(7853),
     /*   7507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   7510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   7513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7578), // Rule ID 22808 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7544 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7557 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm),
     /*   7560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7562 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7576 */     GIR_RootConstrainSelectedInstOperands,
     /*   7577 */     // GIR_Coverage, 22808,
     /*   7577 */     GIR_EraseRootFromParent_Done,
     /*   7578 */   // Label 259: @7578
     /*   7578 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(7639), // Rule ID 22898 //
     /*   7583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7605 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7618 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm_ND),
     /*   7621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7637 */     GIR_RootConstrainSelectedInstOperands,
     /*   7638 */     // GIR_Coverage, 22898,
     /*   7638 */     GIR_EraseRootFromParent_Done,
     /*   7639 */   // Label 260: @7639
     /*   7639 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(7667), // Rule ID 241 //
     /*   7644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7655 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*   7658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7665 */     GIR_RootConstrainSelectedInstOperands,
     /*   7666 */     // GIR_Coverage, 241,
     /*   7666 */     GIR_EraseRootFromParent_Done,
     /*   7667 */   // Label 261: @7667
     /*   7667 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(7695), // Rule ID 249 //
     /*   7672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7683 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*   7686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7693 */     GIR_RootConstrainSelectedInstOperands,
     /*   7694 */     // GIR_Coverage, 249,
     /*   7694 */     GIR_EraseRootFromParent_Done,
     /*   7695 */   // Label 262: @7695
     /*   7695 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(7720), // Rule ID 257 //
     /*   7700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7711 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*   7711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*   7714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7718 */     GIR_RootConstrainSelectedInstOperands,
     /*   7719 */     // GIR_Coverage, 257,
     /*   7719 */     GIR_EraseRootFromParent_Done,
     /*   7720 */   // Label 263: @7720
     /*   7720 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(7757), // Rule ID 22812 //
     /*   7725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7740 */     // MIs[1] Operand 1
     /*   7740 */     // No operand predicates
     /*   7740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7742 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*   7745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7755 */     GIR_RootConstrainSelectedInstOperands,
     /*   7756 */     // GIR_Coverage, 22812,
     /*   7756 */     GIR_EraseRootFromParent_Done,
     /*   7757 */   // Label 264: @7757
     /*   7757 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(7794), // Rule ID 22902 //
     /*   7762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7777 */     // MIs[1] Operand 1
     /*   7777 */     // No operand predicates
     /*   7777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7779 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*   7782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7784 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7792 */     GIR_RootConstrainSelectedInstOperands,
     /*   7793 */     // GIR_Coverage, 22902,
     /*   7793 */     GIR_EraseRootFromParent_Done,
     /*   7794 */   // Label 265: @7794
     /*   7794 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(7823), // Rule ID 22804 //
     /*   7799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7810 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*   7815 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7821 */     GIR_RootConstrainSelectedInstOperands,
     /*   7822 */     // GIR_Coverage, 22804,
     /*   7822 */     GIR_Done,
     /*   7823 */   // Label 266: @7823
     /*   7823 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(7852), // Rule ID 22894 //
     /*   7828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7839 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*   7844 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7850 */     GIR_RootConstrainSelectedInstOperands,
     /*   7851 */     // GIR_Coverage, 22894,
     /*   7851 */     GIR_Done,
     /*   7852 */   // Label 267: @7852
     /*   7852 */   GIM_Reject,
     /*   7853 */ // Label 258: @7853
     /*   7853 */ GIM_Reject,
     /*   7854 */ // Label 242: @7854
     /*   7854 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(8205),
     /*   7859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   7862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   7865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7869 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(7930), // Rule ID 22809 //
     /*   7874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7896 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7909 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm),
     /*   7912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7928 */     GIR_RootConstrainSelectedInstOperands,
     /*   7929 */     // GIR_Coverage, 22809,
     /*   7929 */     GIR_EraseRootFromParent_Done,
     /*   7930 */   // Label 269: @7930
     /*   7930 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(7991), // Rule ID 22899 //
     /*   7935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7957 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7970 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm_ND),
     /*   7973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7975 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 22899,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 270: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(8019), // Rule ID 242 //
     /*   7996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8007 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   8007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*   8010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8017 */     GIR_RootConstrainSelectedInstOperands,
     /*   8018 */     // GIR_Coverage, 242,
     /*   8018 */     GIR_EraseRootFromParent_Done,
     /*   8019 */   // Label 271: @8019
     /*   8019 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(8047), // Rule ID 250 //
     /*   8024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8035 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   8035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*   8038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8045 */     GIR_RootConstrainSelectedInstOperands,
     /*   8046 */     // GIR_Coverage, 250,
     /*   8046 */     GIR_EraseRootFromParent_Done,
     /*   8047 */   // Label 272: @8047
     /*   8047 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(8072), // Rule ID 258 //
     /*   8052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8063 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*   8063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*   8066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8070 */     GIR_RootConstrainSelectedInstOperands,
     /*   8071 */     // GIR_Coverage, 258,
     /*   8071 */     GIR_EraseRootFromParent_Done,
     /*   8072 */   // Label 273: @8072
     /*   8072 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(8109), // Rule ID 22813 //
     /*   8077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8092 */     // MIs[1] Operand 1
     /*   8092 */     // No operand predicates
     /*   8092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8094 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   8094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   8097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8107 */     GIR_RootConstrainSelectedInstOperands,
     /*   8108 */     // GIR_Coverage, 22813,
     /*   8108 */     GIR_EraseRootFromParent_Done,
     /*   8109 */   // Label 274: @8109
     /*   8109 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(8146), // Rule ID 22903 //
     /*   8114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8129 */     // MIs[1] Operand 1
     /*   8129 */     // No operand predicates
     /*   8129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8131 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   8131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   8134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8144 */     GIR_RootConstrainSelectedInstOperands,
     /*   8145 */     // GIR_Coverage, 22903,
     /*   8145 */     GIR_EraseRootFromParent_Done,
     /*   8146 */   // Label 275: @8146
     /*   8146 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8175), // Rule ID 22805 //
     /*   8151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8162 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   8162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*   8167 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8173 */     GIR_RootConstrainSelectedInstOperands,
     /*   8174 */     // GIR_Coverage, 22805,
     /*   8174 */     GIR_Done,
     /*   8175 */   // Label 276: @8175
     /*   8175 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8204), // Rule ID 22895 //
     /*   8180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8191 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   8191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*   8196 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8202 */     GIR_RootConstrainSelectedInstOperands,
     /*   8203 */     // GIR_Coverage, 22895,
     /*   8203 */     GIR_Done,
     /*   8204 */   // Label 277: @8204
     /*   8204 */   GIM_Reject,
     /*   8205 */ // Label 268: @8205
     /*   8205 */ GIM_Reject,
     /*   8206 */ // Label 243: @8206
     /*   8206 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8557),
     /*   8211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   8214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   8217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8221 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8282), // Rule ID 22810 //
     /*   8226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8241 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8248 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8261 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm),
     /*   8264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8280 */     GIR_RootConstrainSelectedInstOperands,
     /*   8281 */     // GIR_Coverage, 22810,
     /*   8281 */     GIR_EraseRootFromParent_Done,
     /*   8282 */   // Label 279: @8282
     /*   8282 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8343), // Rule ID 22900 //
     /*   8287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8309 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8322 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm_ND),
     /*   8325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8341 */     GIR_RootConstrainSelectedInstOperands,
     /*   8342 */     // GIR_Coverage, 22900,
     /*   8342 */     GIR_EraseRootFromParent_Done,
     /*   8343 */   // Label 280: @8343
     /*   8343 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8371), // Rule ID 243 //
     /*   8348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8359 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*   8362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8369 */     GIR_RootConstrainSelectedInstOperands,
     /*   8370 */     // GIR_Coverage, 243,
     /*   8370 */     GIR_EraseRootFromParent_Done,
     /*   8371 */   // Label 281: @8371
     /*   8371 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8399), // Rule ID 251 //
     /*   8376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8387 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*   8390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8397 */     GIR_RootConstrainSelectedInstOperands,
     /*   8398 */     // GIR_Coverage, 251,
     /*   8398 */     GIR_EraseRootFromParent_Done,
     /*   8399 */   // Label 282: @8399
     /*   8399 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8424), // Rule ID 259 //
     /*   8404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8415 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*   8418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8422 */     GIR_RootConstrainSelectedInstOperands,
     /*   8423 */     // GIR_Coverage, 259,
     /*   8423 */     GIR_EraseRootFromParent_Done,
     /*   8424 */   // Label 283: @8424
     /*   8424 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8461), // Rule ID 22814 //
     /*   8429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8444 */     // MIs[1] Operand 1
     /*   8444 */     // No operand predicates
     /*   8444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8446 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   8449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8459 */     GIR_RootConstrainSelectedInstOperands,
     /*   8460 */     // GIR_Coverage, 22814,
     /*   8460 */     GIR_EraseRootFromParent_Done,
     /*   8461 */   // Label 284: @8461
     /*   8461 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8498), // Rule ID 22904 //
     /*   8466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8481 */     // MIs[1] Operand 1
     /*   8481 */     // No operand predicates
     /*   8481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8483 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8496 */     GIR_RootConstrainSelectedInstOperands,
     /*   8497 */     // GIR_Coverage, 22904,
     /*   8497 */     GIR_EraseRootFromParent_Done,
     /*   8498 */   // Label 285: @8498
     /*   8498 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8527), // Rule ID 22806 //
     /*   8503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8514 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*   8519 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8525 */     GIR_RootConstrainSelectedInstOperands,
     /*   8526 */     // GIR_Coverage, 22806,
     /*   8526 */     GIR_Done,
     /*   8527 */   // Label 286: @8527
     /*   8527 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8556), // Rule ID 22896 //
     /*   8532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8543 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*   8548 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8554 */     GIR_RootConstrainSelectedInstOperands,
     /*   8555 */     // GIR_Coverage, 22896,
     /*   8555 */     GIR_Done,
     /*   8556 */   // Label 287: @8556
     /*   8556 */   GIM_Reject,
     /*   8557 */ // Label 278: @8557
     /*   8557 */ GIM_Reject,
     /*   8558 */ // Label 244: @8558
     /*   8558 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8917),
     /*   8563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   8566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   8569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8573 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(8634), // Rule ID 22811 //
     /*   8578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8613 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm),
     /*   8616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8632 */     GIR_RootConstrainSelectedInstOperands,
     /*   8633 */     // GIR_Coverage, 22811,
     /*   8633 */     GIR_EraseRootFromParent_Done,
     /*   8634 */   // Label 289: @8634
     /*   8634 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(8695), // Rule ID 22901 //
     /*   8639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8674 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm_ND),
     /*   8677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8693 */     GIR_RootConstrainSelectedInstOperands,
     /*   8694 */     // GIR_Coverage, 22901,
     /*   8694 */     GIR_EraseRootFromParent_Done,
     /*   8695 */   // Label 290: @8695
     /*   8695 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(8723), // Rule ID 244 //
     /*   8700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8711 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*   8714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8721 */     GIR_RootConstrainSelectedInstOperands,
     /*   8722 */     // GIR_Coverage, 244,
     /*   8722 */     GIR_EraseRootFromParent_Done,
     /*   8723 */   // Label 291: @8723
     /*   8723 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(8751), // Rule ID 252 //
     /*   8728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8739 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*   8742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8749 */     GIR_RootConstrainSelectedInstOperands,
     /*   8750 */     // GIR_Coverage, 252,
     /*   8750 */     GIR_EraseRootFromParent_Done,
     /*   8751 */   // Label 292: @8751
     /*   8751 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(8776), // Rule ID 260 //
     /*   8756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8767 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*   8767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*   8770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8774 */     GIR_RootConstrainSelectedInstOperands,
     /*   8775 */     // GIR_Coverage, 260,
     /*   8775 */     GIR_EraseRootFromParent_Done,
     /*   8776 */   // Label 293: @8776
     /*   8776 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(8817), // Rule ID 22815 //
     /*   8781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8800 */     // MIs[1] Operand 1
     /*   8800 */     // No operand predicates
     /*   8800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8802 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   8805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8815 */     GIR_RootConstrainSelectedInstOperands,
     /*   8816 */     // GIR_Coverage, 22815,
     /*   8816 */     GIR_EraseRootFromParent_Done,
     /*   8817 */   // Label 294: @8817
     /*   8817 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(8858), // Rule ID 22905 //
     /*   8822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8841 */     // MIs[1] Operand 1
     /*   8841 */     // No operand predicates
     /*   8841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8843 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   8846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 22905,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 295: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(8887), // Rule ID 22807 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8874 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*   8879 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8885 */     GIR_RootConstrainSelectedInstOperands,
     /*   8886 */     // GIR_Coverage, 22807,
     /*   8886 */     GIR_Done,
     /*   8887 */   // Label 296: @8887
     /*   8887 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(8916), // Rule ID 22897 //
     /*   8892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8903 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*   8908 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8914 */     GIR_RootConstrainSelectedInstOperands,
     /*   8915 */     // GIR_Coverage, 22897,
     /*   8915 */     GIR_Done,
     /*   8916 */   // Label 297: @8916
     /*   8916 */   GIM_Reject,
     /*   8917 */ // Label 288: @8917
     /*   8917 */ GIM_Reject,
     /*   8918 */ // Label 245: @8918
     /*   8918 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(9135),
     /*   8923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   8929 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(8991), // Rule ID 2607 //
     /*   8934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8953 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8956 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8973 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQrm),
     /*   8976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8978 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8989 */     GIR_RootConstrainSelectedInstOperands,
     /*   8990 */     // GIR_Coverage, 2607,
     /*   8990 */     GIR_EraseRootFromParent_Done,
     /*   8991 */   // Label 299: @8991
     /*   8991 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(9053), // Rule ID 4744 //
     /*   8996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9035 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rm),
     /*   9038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9051 */     GIR_RootConstrainSelectedInstOperands,
     /*   9052 */     // GIR_Coverage, 4744,
     /*   9052 */     GIR_EraseRootFromParent_Done,
     /*   9053 */   // Label 300: @9053
     /*   9053 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(9080), // Rule ID 2606 //
     /*   9058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9073 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   9073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*   9078 */     GIR_RootConstrainSelectedInstOperands,
     /*   9079 */     // GIR_Coverage, 2606,
     /*   9079 */     GIR_Done,
     /*   9080 */   // Label 301: @9080
     /*   9080 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9107), // Rule ID 2608 //
     /*   9085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9100 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   9100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*   9105 */     GIR_RootConstrainSelectedInstOperands,
     /*   9106 */     // GIR_Coverage, 2608,
     /*   9106 */     GIR_Done,
     /*   9107 */   // Label 302: @9107
     /*   9107 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(9134), // Rule ID 4741 //
     /*   9112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9127 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   9127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*   9132 */     GIR_RootConstrainSelectedInstOperands,
     /*   9133 */     // GIR_Coverage, 4741,
     /*   9133 */     GIR_Done,
     /*   9134 */   // Label 303: @9134
     /*   9134 */   GIM_Reject,
     /*   9135 */ // Label 298: @9135
     /*   9135 */ GIM_Reject,
     /*   9136 */ // Label 246: @9136
     /*   9136 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(9353),
     /*   9141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9147 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(9209), // Rule ID 2601 //
     /*   9152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9191 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDrm),
     /*   9194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9207 */     GIR_RootConstrainSelectedInstOperands,
     /*   9208 */     // GIR_Coverage, 2601,
     /*   9208 */     GIR_EraseRootFromParent_Done,
     /*   9209 */   // Label 305: @9209
     /*   9209 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(9271), // Rule ID 4771 //
     /*   9214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9253 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rm),
     /*   9256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9269 */     GIR_RootConstrainSelectedInstOperands,
     /*   9270 */     // GIR_Coverage, 4771,
     /*   9270 */     GIR_EraseRootFromParent_Done,
     /*   9271 */   // Label 306: @9271
     /*   9271 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(9298), // Rule ID 2600 //
     /*   9276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9291 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*   9296 */     GIR_RootConstrainSelectedInstOperands,
     /*   9297 */     // GIR_Coverage, 2600,
     /*   9297 */     GIR_Done,
     /*   9298 */   // Label 307: @9298
     /*   9298 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(9325), // Rule ID 2602 //
     /*   9303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9318 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*   9323 */     GIR_RootConstrainSelectedInstOperands,
     /*   9324 */     // GIR_Coverage, 2602,
     /*   9324 */     GIR_Done,
     /*   9325 */   // Label 308: @9325
     /*   9325 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(9352), // Rule ID 4768 //
     /*   9330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9345 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   9345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*   9350 */     GIR_RootConstrainSelectedInstOperands,
     /*   9351 */     // GIR_Coverage, 4768,
     /*   9351 */     GIR_Done,
     /*   9352 */   // Label 309: @9352
     /*   9352 */   GIM_Reject,
     /*   9353 */ // Label 304: @9353
     /*   9353 */ GIM_Reject,
     /*   9354 */ // Label 247: @9354
     /*   9354 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(9544),
     /*   9359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   9362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   9365 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(9427), // Rule ID 2611 //
     /*   9370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9409 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrm),
     /*   9412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9425 */     GIR_RootConstrainSelectedInstOperands,
     /*   9426 */     // GIR_Coverage, 2611,
     /*   9426 */     GIR_EraseRootFromParent_Done,
     /*   9427 */   // Label 311: @9427
     /*   9427 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(9489), // Rule ID 4735 //
     /*   9432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9451 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9471 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rm),
     /*   9474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9487 */     GIR_RootConstrainSelectedInstOperands,
     /*   9488 */     // GIR_Coverage, 4735,
     /*   9488 */     GIR_EraseRootFromParent_Done,
     /*   9489 */   // Label 312: @9489
     /*   9489 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(9516), // Rule ID 2610 //
     /*   9494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9509 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   9509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*   9514 */     GIR_RootConstrainSelectedInstOperands,
     /*   9515 */     // GIR_Coverage, 2610,
     /*   9515 */     GIR_Done,
     /*   9516 */   // Label 313: @9516
     /*   9516 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(9543), // Rule ID 4732 //
     /*   9521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9536 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   9536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*   9541 */     GIR_RootConstrainSelectedInstOperands,
     /*   9542 */     // GIR_Coverage, 4732,
     /*   9542 */     GIR_Done,
     /*   9543 */   // Label 314: @9543
     /*   9543 */   GIM_Reject,
     /*   9544 */ // Label 310: @9544
     /*   9544 */ GIM_Reject,
     /*   9545 */ // Label 248: @9545
     /*   9545 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(9762),
     /*   9550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9556 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(9618), // Rule ID 2595 //
     /*   9561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9600 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWrm),
     /*   9603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9616 */     GIR_RootConstrainSelectedInstOperands,
     /*   9617 */     // GIR_Coverage, 2595,
     /*   9617 */     GIR_EraseRootFromParent_Done,
     /*   9618 */   // Label 316: @9618
     /*   9618 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(9680), // Rule ID 4792 //
     /*   9623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9662 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rm),
     /*   9665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9678 */     GIR_RootConstrainSelectedInstOperands,
     /*   9679 */     // GIR_Coverage, 4792,
     /*   9679 */     GIR_EraseRootFromParent_Done,
     /*   9680 */   // Label 317: @9680
     /*   9680 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(9707), // Rule ID 2594 //
     /*   9685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9700 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*   9705 */     GIR_RootConstrainSelectedInstOperands,
     /*   9706 */     // GIR_Coverage, 2594,
     /*   9706 */     GIR_Done,
     /*   9707 */   // Label 318: @9707
     /*   9707 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(9734), // Rule ID 2596 //
     /*   9712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9727 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*   9732 */     GIR_RootConstrainSelectedInstOperands,
     /*   9733 */     // GIR_Coverage, 2596,
     /*   9733 */     GIR_Done,
     /*   9734 */   // Label 319: @9734
     /*   9734 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(9761), // Rule ID 4789 //
     /*   9739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9754 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   9754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*   9759 */     GIR_RootConstrainSelectedInstOperands,
     /*   9760 */     // GIR_Coverage, 4789,
     /*   9760 */     GIR_Done,
     /*   9761 */   // Label 320: @9761
     /*   9761 */   GIM_Reject,
     /*   9762 */ // Label 315: @9762
     /*   9762 */ GIM_Reject,
     /*   9763 */ // Label 249: @9763
     /*   9763 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(9953),
     /*   9768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   9771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   9774 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(9836), // Rule ID 2605 //
     /*   9779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9818 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrm),
     /*   9821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9834 */     GIR_RootConstrainSelectedInstOperands,
     /*   9835 */     // GIR_Coverage, 2605,
     /*   9835 */     GIR_EraseRootFromParent_Done,
     /*   9836 */   // Label 322: @9836
     /*   9836 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(9898), // Rule ID 4762 //
     /*   9841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9880 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rm),
     /*   9883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9885 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9896 */     GIR_RootConstrainSelectedInstOperands,
     /*   9897 */     // GIR_Coverage, 4762,
     /*   9897 */     GIR_EraseRootFromParent_Done,
     /*   9898 */   // Label 323: @9898
     /*   9898 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9925), // Rule ID 2604 //
     /*   9903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9918 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   9918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*   9923 */     GIR_RootConstrainSelectedInstOperands,
     /*   9924 */     // GIR_Coverage, 2604,
     /*   9924 */     GIR_Done,
     /*   9925 */   // Label 324: @9925
     /*   9925 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9952), // Rule ID 4759 //
     /*   9930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9945 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   9945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*   9950 */     GIR_RootConstrainSelectedInstOperands,
     /*   9951 */     // GIR_Coverage, 4759,
     /*   9951 */     GIR_Done,
     /*   9952 */   // Label 325: @9952
     /*   9952 */   GIM_Reject,
     /*   9953 */ // Label 321: @9953
     /*   9953 */ GIM_Reject,
     /*   9954 */ // Label 250: @9954
     /*   9954 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(10047),
     /*   9959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   9962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   9965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9973 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(10027), // Rule ID 4726 //
     /*   9978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9989 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9996 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10009 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrm),
     /*  10012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10014 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10025 */     GIR_RootConstrainSelectedInstOperands,
     /*  10026 */     // GIR_Coverage, 4726,
     /*  10026 */     GIR_EraseRootFromParent_Done,
     /*  10027 */   // Label 327: @10027
     /*  10027 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(10046), // Rule ID 4723 //
     /*  10032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10039 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  10039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*  10044 */     GIR_RootConstrainSelectedInstOperands,
     /*  10045 */     // GIR_Coverage, 4723,
     /*  10045 */     GIR_Done,
     /*  10046 */   // Label 328: @10046
     /*  10046 */   GIM_Reject,
     /*  10047 */ // Label 326: @10047
     /*  10047 */ GIM_Reject,
     /*  10048 */ // Label 251: @10048
     /*  10048 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(10265),
     /*  10053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10059 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(10121), // Rule ID 2589 //
     /*  10064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  10067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10083 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10103 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBrm),
     /*  10106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10108 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10119 */     GIR_RootConstrainSelectedInstOperands,
     /*  10120 */     // GIR_Coverage, 2589,
     /*  10120 */     GIR_EraseRootFromParent_Done,
     /*  10121 */   // Label 330: @10121
     /*  10121 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(10183), // Rule ID 4810 //
     /*  10126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10165 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rm),
     /*  10168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 4810,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 331: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10210), // Rule ID 2588 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10203 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  10208 */     GIR_RootConstrainSelectedInstOperands,
     /*  10209 */     // GIR_Coverage, 2588,
     /*  10209 */     GIR_Done,
     /*  10210 */   // Label 332: @10210
     /*  10210 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10237), // Rule ID 2590 //
     /*  10215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  10218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10230 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  10235 */     GIR_RootConstrainSelectedInstOperands,
     /*  10236 */     // GIR_Coverage, 2590,
     /*  10236 */     GIR_Done,
     /*  10237 */   // Label 333: @10237
     /*  10237 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10264), // Rule ID 4807 //
     /*  10242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10257 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  10257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  10262 */     GIR_RootConstrainSelectedInstOperands,
     /*  10263 */     // GIR_Coverage, 4807,
     /*  10263 */     GIR_Done,
     /*  10264 */   // Label 334: @10264
     /*  10264 */   GIM_Reject,
     /*  10265 */ // Label 329: @10265
     /*  10265 */ GIM_Reject,
     /*  10266 */ // Label 252: @10266
     /*  10266 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10456),
     /*  10271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  10274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  10277 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10339), // Rule ID 2599 //
     /*  10282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10321 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrm),
     /*  10324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10337 */     GIR_RootConstrainSelectedInstOperands,
     /*  10338 */     // GIR_Coverage, 2599,
     /*  10338 */     GIR_EraseRootFromParent_Done,
     /*  10339 */   // Label 336: @10339
     /*  10339 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10401), // Rule ID 4786 //
     /*  10344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10383 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rm),
     /*  10386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10388 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10399 */     GIR_RootConstrainSelectedInstOperands,
     /*  10400 */     // GIR_Coverage, 4786,
     /*  10400 */     GIR_EraseRootFromParent_Done,
     /*  10401 */   // Label 337: @10401
     /*  10401 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10428), // Rule ID 2598 //
     /*  10406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10421 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  10421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  10426 */     GIR_RootConstrainSelectedInstOperands,
     /*  10427 */     // GIR_Coverage, 2598,
     /*  10427 */     GIR_Done,
     /*  10428 */   // Label 338: @10428
     /*  10428 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10455), // Rule ID 4783 //
     /*  10433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10448 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  10448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  10453 */     GIR_RootConstrainSelectedInstOperands,
     /*  10454 */     // GIR_Coverage, 4783,
     /*  10454 */     GIR_Done,
     /*  10455 */   // Label 339: @10455
     /*  10455 */   GIM_Reject,
     /*  10456 */ // Label 335: @10456
     /*  10456 */ GIM_Reject,
     /*  10457 */ // Label 253: @10457
     /*  10457 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10550),
     /*  10462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  10465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  10468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10476 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10530), // Rule ID 4753 //
     /*  10481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10512 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrm),
     /*  10515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10528 */     GIR_RootConstrainSelectedInstOperands,
     /*  10529 */     // GIR_Coverage, 4753,
     /*  10529 */     GIR_EraseRootFromParent_Done,
     /*  10530 */   // Label 341: @10530
     /*  10530 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10549), // Rule ID 4750 //
     /*  10535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10542 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  10542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  10547 */     GIR_RootConstrainSelectedInstOperands,
     /*  10548 */     // GIR_Coverage, 4750,
     /*  10548 */     GIR_Done,
     /*  10549 */   // Label 342: @10549
     /*  10549 */   GIM_Reject,
     /*  10550 */ // Label 340: @10550
     /*  10550 */ GIM_Reject,
     /*  10551 */ // Label 254: @10551
     /*  10551 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10741),
     /*  10556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  10559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  10562 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10624), // Rule ID 2593 //
     /*  10567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10606 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrm),
     /*  10609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10622 */     GIR_RootConstrainSelectedInstOperands,
     /*  10623 */     // GIR_Coverage, 2593,
     /*  10623 */     GIR_EraseRootFromParent_Done,
     /*  10624 */   // Label 344: @10624
     /*  10624 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10686), // Rule ID 4804 //
     /*  10629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10668 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rm),
     /*  10671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10684 */     GIR_RootConstrainSelectedInstOperands,
     /*  10685 */     // GIR_Coverage, 4804,
     /*  10685 */     GIR_EraseRootFromParent_Done,
     /*  10686 */   // Label 345: @10686
     /*  10686 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10713), // Rule ID 2592 //
     /*  10691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10706 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  10706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  10711 */     GIR_RootConstrainSelectedInstOperands,
     /*  10712 */     // GIR_Coverage, 2592,
     /*  10712 */     GIR_Done,
     /*  10713 */   // Label 346: @10713
     /*  10713 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10740), // Rule ID 4801 //
     /*  10718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10733 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  10733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  10738 */     GIR_RootConstrainSelectedInstOperands,
     /*  10739 */     // GIR_Coverage, 4801,
     /*  10739 */     GIR_Done,
     /*  10740 */   // Label 347: @10740
     /*  10740 */   GIM_Reject,
     /*  10741 */ // Label 343: @10741
     /*  10741 */ GIM_Reject,
     /*  10742 */ // Label 255: @10742
     /*  10742 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10835),
     /*  10747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  10750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  10753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10761 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10815), // Rule ID 4780 //
     /*  10766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10797 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrm),
     /*  10800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10813 */     GIR_RootConstrainSelectedInstOperands,
     /*  10814 */     // GIR_Coverage, 4780,
     /*  10814 */     GIR_EraseRootFromParent_Done,
     /*  10815 */   // Label 349: @10815
     /*  10815 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10834), // Rule ID 4777 //
     /*  10820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10827 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  10827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  10832 */     GIR_RootConstrainSelectedInstOperands,
     /*  10833 */     // GIR_Coverage, 4777,
     /*  10833 */     GIR_Done,
     /*  10834 */   // Label 350: @10834
     /*  10834 */   GIM_Reject,
     /*  10835 */ // Label 348: @10835
     /*  10835 */ GIM_Reject,
     /*  10836 */ // Label 256: @10836
     /*  10836 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10929),
     /*  10841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  10844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  10847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10855 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(10909), // Rule ID 4798 //
     /*  10860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10891 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrm),
     /*  10894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10896 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10907 */     GIR_RootConstrainSelectedInstOperands,
     /*  10908 */     // GIR_Coverage, 4798,
     /*  10908 */     GIR_EraseRootFromParent_Done,
     /*  10909 */   // Label 352: @10909
     /*  10909 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(10928), // Rule ID 4795 //
     /*  10914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10921 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  10921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  10926 */     GIR_RootConstrainSelectedInstOperands,
     /*  10927 */     // GIR_Coverage, 4795,
     /*  10927 */     GIR_Done,
     /*  10928 */   // Label 353: @10928
     /*  10928 */   GIM_Reject,
     /*  10929 */ // Label 351: @10929
     /*  10929 */ GIM_Reject,
     /*  10930 */ // Label 257: @10930
     /*  10930 */ GIM_Reject,
     /*  10931 */ // Label 2: @10931
     /*  10931 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 366*/ GIMT_Encode4(14713),
     /*  10942 */ /*GILLT_s16*//*Label 354*/ GIMT_Encode4(11026),
     /*  10946 */ /*GILLT_s32*//*Label 355*/ GIMT_Encode4(11443),
     /*  10950 */ /*GILLT_s64*//*Label 356*/ GIMT_Encode4(11860), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10966 */ /*GILLT_v2s64*//*Label 357*/ GIMT_Encode4(12285), GIMT_Encode4(0),
     /*  10974 */ /*GILLT_v4s32*//*Label 358*/ GIMT_Encode4(12614),
     /*  10978 */ /*GILLT_v4s64*//*Label 359*/ GIMT_Encode4(12956), GIMT_Encode4(0),
     /*  10986 */ /*GILLT_v8s16*//*Label 360*/ GIMT_Encode4(13273),
     /*  10990 */ /*GILLT_v8s32*//*Label 361*/ GIMT_Encode4(13615),
     /*  10994 */ /*GILLT_v8s64*//*Label 362*/ GIMT_Encode4(13930), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  11006 */ /*GILLT_v16s16*//*Label 363*/ GIMT_Encode4(14086),
     /*  11010 */ /*GILLT_v16s32*//*Label 364*/ GIMT_Encode4(14401), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  11022 */ /*GILLT_v32s16*//*Label 365*/ GIMT_Encode4(14557),
     /*  11026 */ // Label 354: @11026
     /*  11026 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(11442),
     /*  11031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  11034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  11037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11041 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11105), // Rule ID 22979 //
     /*  11046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11061 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11073 */     // MIs[2] Operand 1
     /*  11073 */     // No operand predicates
     /*  11073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11082 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rmi),
     /*  11085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11103 */     GIR_RootConstrainSelectedInstOperands,
     /*  11104 */     // GIR_Coverage, 22979,
     /*  11104 */     GIR_EraseRootFromParent_Done,
     /*  11105 */   // Label 368: @11105
     /*  11105 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11166), // Rule ID 26058 //
     /*  11110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11121 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11128 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11145 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11164 */     GIR_RootConstrainSelectedInstOperands,
     /*  11165 */     // GIR_Coverage, 26058,
     /*  11165 */     GIR_EraseRootFromParent_Done,
     /*  11166 */   // Label 369: @11166
     /*  11166 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11227), // Rule ID 26077 //
     /*  11171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11189 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11206 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11225 */     GIR_RootConstrainSelectedInstOperands,
     /*  11226 */     // GIR_Coverage, 26077,
     /*  11226 */     GIR_EraseRootFromParent_Done,
     /*  11227 */   // Label 370: @11227
     /*  11227 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11288), // Rule ID 22823 //
     /*  11232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11254 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11267 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11286 */     GIR_RootConstrainSelectedInstOperands,
     /*  11287 */     // GIR_Coverage, 22823,
     /*  11287 */     GIR_EraseRootFromParent_Done,
     /*  11288 */   // Label 371: @11288
     /*  11288 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11349), // Rule ID 22913 //
     /*  11293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11315 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11328 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11347 */     GIR_RootConstrainSelectedInstOperands,
     /*  11348 */     // GIR_Coverage, 22913,
     /*  11348 */     GIR_EraseRootFromParent_Done,
     /*  11349 */   // Label 372: @11349
     /*  11349 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11383), // Rule ID 22976 //
     /*  11354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11366 */     // MIs[1] Operand 1
     /*  11366 */     // No operand predicates
     /*  11366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11368 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  11371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11381 */     GIR_RootConstrainSelectedInstOperands,
     /*  11382 */     // GIR_Coverage, 22976,
     /*  11382 */     GIR_EraseRootFromParent_Done,
     /*  11383 */   // Label 373: @11383
     /*  11383 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11412), // Rule ID 22820 //
     /*  11388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11399 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  11404 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11410 */     GIR_RootConstrainSelectedInstOperands,
     /*  11411 */     // GIR_Coverage, 22820,
     /*  11411 */     GIR_Done,
     /*  11412 */   // Label 374: @11412
     /*  11412 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11441), // Rule ID 22910 //
     /*  11417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11428 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  11433 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11439 */     GIR_RootConstrainSelectedInstOperands,
     /*  11440 */     // GIR_Coverage, 22910,
     /*  11440 */     GIR_Done,
     /*  11441 */   // Label 375: @11441
     /*  11441 */   GIM_Reject,
     /*  11442 */ // Label 367: @11442
     /*  11442 */ GIM_Reject,
     /*  11443 */ // Label 355: @11443
     /*  11443 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11859),
     /*  11448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  11451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  11454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11458 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11522), // Rule ID 22980 //
     /*  11463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11474 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11478 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11490 */     // MIs[2] Operand 1
     /*  11490 */     // No operand predicates
     /*  11490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11499 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rmi:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rmi),
     /*  11502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11520 */     GIR_RootConstrainSelectedInstOperands,
     /*  11521 */     // GIR_Coverage, 22980,
     /*  11521 */     GIR_EraseRootFromParent_Done,
     /*  11522 */   // Label 377: @11522
     /*  11522 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11583), // Rule ID 26059 //
     /*  11527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11545 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11562 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11581 */     GIR_RootConstrainSelectedInstOperands,
     /*  11582 */     // GIR_Coverage, 26059,
     /*  11582 */     GIR_EraseRootFromParent_Done,
     /*  11583 */   // Label 378: @11583
     /*  11583 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11644), // Rule ID 26078 //
     /*  11588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11602 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11606 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11623 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11628 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11642 */     GIR_RootConstrainSelectedInstOperands,
     /*  11643 */     // GIR_Coverage, 26078,
     /*  11643 */     GIR_EraseRootFromParent_Done,
     /*  11644 */   // Label 379: @11644
     /*  11644 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11705), // Rule ID 22824 //
     /*  11649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11671 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11684 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11689 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11703 */     GIR_RootConstrainSelectedInstOperands,
     /*  11704 */     // GIR_Coverage, 22824,
     /*  11704 */     GIR_EraseRootFromParent_Done,
     /*  11705 */   // Label 380: @11705
     /*  11705 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11766), // Rule ID 22914 //
     /*  11710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11725 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11732 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11745 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11764 */     GIR_RootConstrainSelectedInstOperands,
     /*  11765 */     // GIR_Coverage, 22914,
     /*  11765 */     GIR_EraseRootFromParent_Done,
     /*  11766 */   // Label 381: @11766
     /*  11766 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11800), // Rule ID 22977 //
     /*  11771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11783 */     // MIs[1] Operand 1
     /*  11783 */     // No operand predicates
     /*  11783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11785 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  11788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11790 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11798 */     GIR_RootConstrainSelectedInstOperands,
     /*  11799 */     // GIR_Coverage, 22977,
     /*  11799 */     GIR_EraseRootFromParent_Done,
     /*  11800 */   // Label 382: @11800
     /*  11800 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(11829), // Rule ID 22821 //
     /*  11805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11816 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  11821 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11827 */     GIR_RootConstrainSelectedInstOperands,
     /*  11828 */     // GIR_Coverage, 22821,
     /*  11828 */     GIR_Done,
     /*  11829 */   // Label 383: @11829
     /*  11829 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11858), // Rule ID 22911 //
     /*  11834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11845 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  11850 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11856 */     GIR_RootConstrainSelectedInstOperands,
     /*  11857 */     // GIR_Coverage, 22911,
     /*  11857 */     GIR_Done,
     /*  11858 */   // Label 384: @11858
     /*  11858 */   GIM_Reject,
     /*  11859 */ // Label 376: @11859
     /*  11859 */ GIM_Reject,
     /*  11860 */ // Label 356: @11860
     /*  11860 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(12284),
     /*  11865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11875 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(11943), // Rule ID 22981 //
     /*  11880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11911 */     // MIs[2] Operand 1
     /*  11911 */     // No operand predicates
     /*  11911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11920 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rmi32:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rmi32),
     /*  11923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11941 */     GIR_RootConstrainSelectedInstOperands,
     /*  11942 */     // GIR_Coverage, 22981,
     /*  11942 */     GIR_EraseRootFromParent_Done,
     /*  11943 */   // Label 386: @11943
     /*  11943 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(12004), // Rule ID 26060 //
     /*  11948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11983 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12002 */     GIR_RootConstrainSelectedInstOperands,
     /*  12003 */     // GIR_Coverage, 26060,
     /*  12003 */     GIR_EraseRootFromParent_Done,
     /*  12004 */   // Label 387: @12004
     /*  12004 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(12065), // Rule ID 26079 //
     /*  12009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12044 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  12047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12063 */     GIR_RootConstrainSelectedInstOperands,
     /*  12064 */     // GIR_Coverage, 26079,
     /*  12064 */     GIR_EraseRootFromParent_Done,
     /*  12065 */   // Label 388: @12065
     /*  12065 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12126), // Rule ID 22825 //
     /*  12070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12105 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  12108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12112 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12124 */     GIR_RootConstrainSelectedInstOperands,
     /*  12125 */     // GIR_Coverage, 22825,
     /*  12125 */     GIR_EraseRootFromParent_Done,
     /*  12126 */   // Label 389: @12126
     /*  12126 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12187), // Rule ID 22915 //
     /*  12131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12166 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  12169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12171 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12185 */     GIR_RootConstrainSelectedInstOperands,
     /*  12186 */     // GIR_Coverage, 22915,
     /*  12186 */     GIR_EraseRootFromParent_Done,
     /*  12187 */   // Label 390: @12187
     /*  12187 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12225), // Rule ID 22978 //
     /*  12192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  12208 */     // MIs[1] Operand 1
     /*  12208 */     // No operand predicates
     /*  12208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12210 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  12210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  12213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  12220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12223 */     GIR_RootConstrainSelectedInstOperands,
     /*  12224 */     // GIR_Coverage, 22978,
     /*  12224 */     GIR_EraseRootFromParent_Done,
     /*  12225 */   // Label 391: @12225
     /*  12225 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12254), // Rule ID 22822 //
     /*  12230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12241 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  12246 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12252 */     GIR_RootConstrainSelectedInstOperands,
     /*  12253 */     // GIR_Coverage, 22822,
     /*  12253 */     GIR_Done,
     /*  12254 */   // Label 392: @12254
     /*  12254 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12283), // Rule ID 22912 //
     /*  12259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12270 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  12275 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12281 */     GIR_RootConstrainSelectedInstOperands,
     /*  12282 */     // GIR_Coverage, 22912,
     /*  12282 */     GIR_Done,
     /*  12283 */   // Label 393: @12283
     /*  12283 */   GIM_Reject,
     /*  12284 */ // Label 385: @12284
     /*  12284 */ GIM_Reject,
     /*  12285 */ // Label 357: @12285
     /*  12285 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12613),
     /*  12290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  12293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  12296 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12358), // Rule ID 23825 //
     /*  12301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12340 */     // (mul:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12356 */     GIR_RootConstrainSelectedInstOperands,
     /*  12357 */     // GIR_Coverage, 23825,
     /*  12357 */     GIR_EraseRootFromParent_Done,
     /*  12358 */   // Label 395: @12358
     /*  12358 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12420), // Rule ID 5023 //
     /*  12363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12402 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12418 */     GIR_RootConstrainSelectedInstOperands,
     /*  12419 */     // GIR_Coverage, 5023,
     /*  12419 */     GIR_EraseRootFromParent_Done,
     /*  12420 */   // Label 396: @12420
     /*  12420 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12447), // Rule ID 5020 //
     /*  12425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12440 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  12440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  12445 */     GIR_RootConstrainSelectedInstOperands,
     /*  12446 */     // GIR_Coverage, 5020,
     /*  12446 */     GIR_Done,
     /*  12447 */   // Label 397: @12447
     /*  12447 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12612), // Rule ID 19998 //
     /*  12452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  12459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12467 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  12467 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12470 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12474 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12481 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12484 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12488 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12493 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12496 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12500 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  12503 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12508 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12513 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12544 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12551 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  12554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  12572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  12576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  12587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12594 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  12601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  12606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12611 */     // GIR_Coverage, 19998,
     /*  12611 */     GIR_EraseRootFromParent_Done,
     /*  12612 */   // Label 398: @12612
     /*  12612 */   GIM_Reject,
     /*  12613 */ // Label 394: @12613
     /*  12613 */ GIM_Reject,
     /*  12614 */ // Label 358: @12614
     /*  12614 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12955),
     /*  12619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12625 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12687), // Rule ID 23528 //
     /*  12630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12645 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12652 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12669 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12685 */     GIR_RootConstrainSelectedInstOperands,
     /*  12686 */     // GIR_Coverage, 23528,
     /*  12686 */     GIR_EraseRootFromParent_Done,
     /*  12687 */   // Label 400: @12687
     /*  12687 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12749), // Rule ID 23798 //
     /*  12692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12707 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12714 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12731 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12747 */     GIR_RootConstrainSelectedInstOperands,
     /*  12748 */     // GIR_Coverage, 23798,
     /*  12748 */     GIR_EraseRootFromParent_Done,
     /*  12749 */   // Label 401: @12749
     /*  12749 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12811), // Rule ID 3240 //
     /*  12754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12793 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12809 */     GIR_RootConstrainSelectedInstOperands,
     /*  12810 */     // GIR_Coverage, 3240,
     /*  12810 */     GIR_EraseRootFromParent_Done,
     /*  12811 */   // Label 402: @12811
     /*  12811 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(12873), // Rule ID 4978 //
     /*  12816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12855 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12871 */     GIR_RootConstrainSelectedInstOperands,
     /*  12872 */     // GIR_Coverage, 4978,
     /*  12872 */     GIR_EraseRootFromParent_Done,
     /*  12873 */   // Label 403: @12873
     /*  12873 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(12900), // Rule ID 3239 //
     /*  12878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12893 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  12898 */     GIR_RootConstrainSelectedInstOperands,
     /*  12899 */     // GIR_Coverage, 3239,
     /*  12899 */     GIR_Done,
     /*  12900 */   // Label 404: @12900
     /*  12900 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(12927), // Rule ID 3247 //
     /*  12905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  12908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12920 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  12925 */     GIR_RootConstrainSelectedInstOperands,
     /*  12926 */     // GIR_Coverage, 3247,
     /*  12926 */     GIR_Done,
     /*  12927 */   // Label 405: @12927
     /*  12927 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(12954), // Rule ID 4975 //
     /*  12932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12947 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  12947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  12952 */     GIR_RootConstrainSelectedInstOperands,
     /*  12953 */     // GIR_Coverage, 4975,
     /*  12953 */     GIR_Done,
     /*  12954 */   // Label 406: @12954
     /*  12954 */   GIM_Reject,
     /*  12955 */ // Label 399: @12955
     /*  12955 */ GIM_Reject,
     /*  12956 */ // Label 359: @12956
     /*  12956 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(13272),
     /*  12961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  12964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  12967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12971 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(13029), // Rule ID 23819 //
     /*  12976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13011 */     // (mul:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  13014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13027 */     GIR_RootConstrainSelectedInstOperands,
     /*  13028 */     // GIR_Coverage, 23819,
     /*  13028 */     GIR_EraseRootFromParent_Done,
     /*  13029 */   // Label 408: @13029
     /*  13029 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(13087), // Rule ID 5014 //
     /*  13034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  13037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13049 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13052 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13056 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13069 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  13072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13085 */     GIR_RootConstrainSelectedInstOperands,
     /*  13086 */     // GIR_Coverage, 5014,
     /*  13086 */     GIR_EraseRootFromParent_Done,
     /*  13087 */   // Label 409: @13087
     /*  13087 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(13110), // Rule ID 5011 //
     /*  13092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  13095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13103 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  13103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  13108 */     GIR_RootConstrainSelectedInstOperands,
     /*  13109 */     // GIR_Coverage, 5011,
     /*  13109 */     GIR_Done,
     /*  13110 */   // Label 410: @13110
     /*  13110 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(13271), // Rule ID 19996 //
     /*  13115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  13118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13126 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  13126 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  13129 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13133 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  13140 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  13143 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13147 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13152 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  13155 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  13159 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  13162 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13167 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13172 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13177 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  13180 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13184 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  13194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13203 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  13210 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  13213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13218 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  13231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13240 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  13246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13253 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  13260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13270 */     // GIR_Coverage, 19996,
     /*  13270 */     GIR_EraseRootFromParent_Done,
     /*  13271 */   // Label 411: @13271
     /*  13271 */   GIM_Reject,
     /*  13272 */ // Label 407: @13272
     /*  13272 */ GIM_Reject,
     /*  13273 */ // Label 360: @13273
     /*  13273 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(13614),
     /*  13278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13284 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(13346), // Rule ID 23453 //
     /*  13289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13328 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13344 */     GIR_RootConstrainSelectedInstOperands,
     /*  13345 */     // GIR_Coverage, 23453,
     /*  13345 */     GIR_EraseRootFromParent_Done,
     /*  13346 */   // Label 413: @13346
     /*  13346 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(13408), // Rule ID 23810 //
     /*  13351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13390 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13406 */     GIR_RootConstrainSelectedInstOperands,
     /*  13407 */     // GIR_Coverage, 23810,
     /*  13407 */     GIR_EraseRootFromParent_Done,
     /*  13408 */   // Label 414: @13408
     /*  13408 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(13470), // Rule ID 2571 //
     /*  13413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13452 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13468 */     GIR_RootConstrainSelectedInstOperands,
     /*  13469 */     // GIR_Coverage, 2571,
     /*  13469 */     GIR_EraseRootFromParent_Done,
     /*  13470 */   // Label 415: @13470
     /*  13470 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(13532), // Rule ID 4999 //
     /*  13475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13514 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13530 */     GIR_RootConstrainSelectedInstOperands,
     /*  13531 */     // GIR_Coverage, 4999,
     /*  13531 */     GIR_EraseRootFromParent_Done,
     /*  13532 */   // Label 416: @13532
     /*  13532 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(13559), // Rule ID 2570 //
     /*  13537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13552 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  13557 */     GIR_RootConstrainSelectedInstOperands,
     /*  13558 */     // GIR_Coverage, 2570,
     /*  13558 */     GIR_Done,
     /*  13559 */   // Label 417: @13559
     /*  13559 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(13586), // Rule ID 2572 //
     /*  13564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  13567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13579 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  13584 */     GIR_RootConstrainSelectedInstOperands,
     /*  13585 */     // GIR_Coverage, 2572,
     /*  13585 */     GIR_Done,
     /*  13586 */   // Label 418: @13586
     /*  13586 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(13613), // Rule ID 4996 //
     /*  13591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13606 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  13606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  13611 */     GIR_RootConstrainSelectedInstOperands,
     /*  13612 */     // GIR_Coverage, 4996,
     /*  13612 */     GIR_Done,
     /*  13613 */   // Label 419: @13613
     /*  13613 */   GIM_Reject,
     /*  13614 */ // Label 412: @13614
     /*  13614 */ GIM_Reject,
     /*  13615 */ // Label 361: @13615
     /*  13615 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(13929),
     /*  13620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  13623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  13626 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(13688), // Rule ID 23530 //
     /*  13631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13670 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13686 */     GIR_RootConstrainSelectedInstOperands,
     /*  13687 */     // GIR_Coverage, 23530,
     /*  13687 */     GIR_EraseRootFromParent_Done,
     /*  13688 */   // Label 421: @13688
     /*  13688 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(13750), // Rule ID 23792 //
     /*  13693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13732 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13748 */     GIR_RootConstrainSelectedInstOperands,
     /*  13749 */     // GIR_Coverage, 23792,
     /*  13749 */     GIR_EraseRootFromParent_Done,
     /*  13750 */   // Label 422: @13750
     /*  13750 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(13812), // Rule ID 3244 //
     /*  13755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13794 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13810 */     GIR_RootConstrainSelectedInstOperands,
     /*  13811 */     // GIR_Coverage, 3244,
     /*  13811 */     GIR_EraseRootFromParent_Done,
     /*  13812 */   // Label 423: @13812
     /*  13812 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(13874), // Rule ID 4969 //
     /*  13817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13856 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13872 */     GIR_RootConstrainSelectedInstOperands,
     /*  13873 */     // GIR_Coverage, 4969,
     /*  13873 */     GIR_EraseRootFromParent_Done,
     /*  13874 */   // Label 424: @13874
     /*  13874 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(13901), // Rule ID 3243 //
     /*  13879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13894 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  13894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  13899 */     GIR_RootConstrainSelectedInstOperands,
     /*  13900 */     // GIR_Coverage, 3243,
     /*  13900 */     GIR_Done,
     /*  13901 */   // Label 425: @13901
     /*  13901 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(13928), // Rule ID 4966 //
     /*  13906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13921 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  13921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  13926 */     GIR_RootConstrainSelectedInstOperands,
     /*  13927 */     // GIR_Coverage, 4966,
     /*  13927 */     GIR_Done,
     /*  13928 */   // Label 426: @13928
     /*  13928 */   GIM_Reject,
     /*  13929 */ // Label 420: @13929
     /*  13929 */ GIM_Reject,
     /*  13930 */ // Label 362: @13930
     /*  13930 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(14085),
     /*  13935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  13938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  13941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13945 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(14003), // Rule ID 23813 //
     /*  13950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13961 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13964 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13968 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13985 */     // (mul:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14001 */     GIR_RootConstrainSelectedInstOperands,
     /*  14002 */     // GIR_Coverage, 23813,
     /*  14002 */     GIR_EraseRootFromParent_Done,
     /*  14003 */   // Label 428: @14003
     /*  14003 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(14061), // Rule ID 5005 //
     /*  14008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  14011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14043 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  14046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14048 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14059 */     GIR_RootConstrainSelectedInstOperands,
     /*  14060 */     // GIR_Coverage, 5005,
     /*  14060 */     GIR_EraseRootFromParent_Done,
     /*  14061 */   // Label 429: @14061
     /*  14061 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(14084), // Rule ID 5002 //
     /*  14066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  14069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14077 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  14077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  14082 */     GIR_RootConstrainSelectedInstOperands,
     /*  14083 */     // GIR_Coverage, 5002,
     /*  14083 */     GIR_Done,
     /*  14084 */   // Label 430: @14084
     /*  14084 */   GIM_Reject,
     /*  14085 */ // Label 427: @14085
     /*  14085 */ GIM_Reject,
     /*  14086 */ // Label 363: @14086
     /*  14086 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(14400),
     /*  14091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  14094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  14097 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(14159), // Rule ID 23455 //
     /*  14102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14141 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14157 */     GIR_RootConstrainSelectedInstOperands,
     /*  14158 */     // GIR_Coverage, 23455,
     /*  14158 */     GIR_EraseRootFromParent_Done,
     /*  14159 */   // Label 432: @14159
     /*  14159 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(14221), // Rule ID 23807 //
     /*  14164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14203 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14219 */     GIR_RootConstrainSelectedInstOperands,
     /*  14220 */     // GIR_Coverage, 23807,
     /*  14220 */     GIR_EraseRootFromParent_Done,
     /*  14221 */   // Label 433: @14221
     /*  14221 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(14283), // Rule ID 2575 //
     /*  14226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14265 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14281 */     GIR_RootConstrainSelectedInstOperands,
     /*  14282 */     // GIR_Coverage, 2575,
     /*  14282 */     GIR_EraseRootFromParent_Done,
     /*  14283 */   // Label 434: @14283
     /*  14283 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(14345), // Rule ID 4993 //
     /*  14288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14327 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14343 */     GIR_RootConstrainSelectedInstOperands,
     /*  14344 */     // GIR_Coverage, 4993,
     /*  14344 */     GIR_EraseRootFromParent_Done,
     /*  14345 */   // Label 435: @14345
     /*  14345 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(14372), // Rule ID 2574 //
     /*  14350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14365 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  14365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  14370 */     GIR_RootConstrainSelectedInstOperands,
     /*  14371 */     // GIR_Coverage, 2574,
     /*  14371 */     GIR_Done,
     /*  14372 */   // Label 436: @14372
     /*  14372 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(14399), // Rule ID 4990 //
     /*  14377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14392 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  14392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  14397 */     GIR_RootConstrainSelectedInstOperands,
     /*  14398 */     // GIR_Coverage, 4990,
     /*  14398 */     GIR_Done,
     /*  14399 */   // Label 437: @14399
     /*  14399 */   GIM_Reject,
     /*  14400 */ // Label 431: @14400
     /*  14400 */ GIM_Reject,
     /*  14401 */ // Label 364: @14401
     /*  14401 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(14556),
     /*  14406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  14409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  14412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14416 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(14474), // Rule ID 23786 //
     /*  14421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14456 */     // (mul:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14472 */     GIR_RootConstrainSelectedInstOperands,
     /*  14473 */     // GIR_Coverage, 23786,
     /*  14473 */     GIR_EraseRootFromParent_Done,
     /*  14474 */   // Label 439: @14474
     /*  14474 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(14532), // Rule ID 4960 //
     /*  14479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14514 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14530 */     GIR_RootConstrainSelectedInstOperands,
     /*  14531 */     // GIR_Coverage, 4960,
     /*  14531 */     GIR_EraseRootFromParent_Done,
     /*  14532 */   // Label 440: @14532
     /*  14532 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(14555), // Rule ID 4957 //
     /*  14537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14548 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  14548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  14553 */     GIR_RootConstrainSelectedInstOperands,
     /*  14554 */     // GIR_Coverage, 4957,
     /*  14554 */     GIR_Done,
     /*  14555 */   // Label 441: @14555
     /*  14555 */   GIM_Reject,
     /*  14556 */ // Label 438: @14556
     /*  14556 */ GIM_Reject,
     /*  14557 */ // Label 365: @14557
     /*  14557 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(14712),
     /*  14562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  14565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  14568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14572 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(14630), // Rule ID 23804 //
     /*  14577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14612 */     // (mul:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14628 */     GIR_RootConstrainSelectedInstOperands,
     /*  14629 */     // GIR_Coverage, 23804,
     /*  14629 */     GIR_EraseRootFromParent_Done,
     /*  14630 */   // Label 443: @14630
     /*  14630 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(14688), // Rule ID 4987 //
     /*  14635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14670 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14686 */     GIR_RootConstrainSelectedInstOperands,
     /*  14687 */     // GIR_Coverage, 4987,
     /*  14687 */     GIR_EraseRootFromParent_Done,
     /*  14688 */   // Label 444: @14688
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(14711), // Rule ID 4984 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14704 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  14704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  14709 */     GIR_RootConstrainSelectedInstOperands,
     /*  14710 */     // GIR_Coverage, 4984,
     /*  14710 */     GIR_Done,
     /*  14711 */   // Label 445: @14711
     /*  14711 */   GIM_Reject,
     /*  14712 */ // Label 442: @14712
     /*  14712 */ GIM_Reject,
     /*  14713 */ // Label 366: @14713
     /*  14713 */ GIM_Reject,
     /*  14714 */ // Label 3: @14714
     /*  14714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 469*/ GIMT_Encode4(25305),
     /*  14725 */ /*GILLT_s1*//*Label 446*/ GIMT_Encode4(14825),
     /*  14729 */ /*GILLT_s8*//*Label 447*/ GIMT_Encode4(15171),
     /*  14733 */ /*GILLT_s16*//*Label 448*/ GIMT_Encode4(15564),
     /*  14737 */ /*GILLT_s32*//*Label 449*/ GIMT_Encode4(16249),
     /*  14741 */ /*GILLT_s64*//*Label 450*/ GIMT_Encode4(18075), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14753 */ /*GILLT_v2s1*//*Label 451*/ GIMT_Encode4(19779),
     /*  14757 */ /*GILLT_v2s64*//*Label 452*/ GIMT_Encode4(20125),
     /*  14761 */ /*GILLT_v4s1*//*Label 453*/ GIMT_Encode4(20467),
     /*  14765 */ /*GILLT_v4s32*//*Label 454*/ GIMT_Encode4(20813),
     /*  14769 */ /*GILLT_v4s64*//*Label 455*/ GIMT_Encode4(21155),
     /*  14773 */ /*GILLT_v8s1*//*Label 456*/ GIMT_Encode4(21621),
     /*  14777 */ /*GILLT_v8s16*//*Label 457*/ GIMT_Encode4(22119),
     /*  14781 */ /*GILLT_v8s32*//*Label 458*/ GIMT_Encode4(22461),
     /*  14785 */ /*GILLT_v8s64*//*Label 459*/ GIMT_Encode4(22927),
     /*  14789 */ /*GILLT_v16s1*//*Label 460*/ GIMT_Encode4(23083),
     /*  14793 */ /*GILLT_v16s8*//*Label 461*/ GIMT_Encode4(23243),
     /*  14797 */ /*GILLT_v16s16*//*Label 462*/ GIMT_Encode4(23585),
     /*  14801 */ /*GILLT_v16s32*//*Label 463*/ GIMT_Encode4(24051),
     /*  14805 */ /*GILLT_v32s1*//*Label 464*/ GIMT_Encode4(24207),
     /*  14809 */ /*GILLT_v32s8*//*Label 465*/ GIMT_Encode4(24367),
     /*  14813 */ /*GILLT_v32s16*//*Label 466*/ GIMT_Encode4(24833),
     /*  14817 */ /*GILLT_v64s1*//*Label 467*/ GIMT_Encode4(24989),
     /*  14821 */ /*GILLT_v64s8*//*Label 468*/ GIMT_Encode4(25149),
     /*  14825 */ // Label 446: @14825
     /*  14825 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(15170),
     /*  14830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14840 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14960), // Rule ID 19488 //
     /*  14845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14870 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14884 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14884 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14887 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14891 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14896 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14900 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14917 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14938 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14941 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14959 */     // GIR_Coverage, 19488,
     /*  14959 */     GIR_EraseRootFromParent_Done,
     /*  14960 */   // Label 471: @14960
     /*  14960 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(15080), // Rule ID 25367 //
     /*  14965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14994 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15000 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  15002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15004 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  15004 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  15007 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15011 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15016 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  15020 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15025 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  15028 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15032 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  15049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  15053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15058 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  15064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  15079 */     // GIR_Coverage, 25367,
     /*  15079 */     GIR_EraseRootFromParent_Done,
     /*  15080 */   // Label 472: @15080
     /*  15080 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(15169), // Rule ID 19484 //
     /*  15085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15093 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  15093 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  15096 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15100 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15105 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  15109 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  15117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  15130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  15138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  15142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  15153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  15168 */     // GIR_Coverage, 19484,
     /*  15168 */     GIR_EraseRootFromParent_Done,
     /*  15169 */   // Label 473: @15169
     /*  15169 */   GIM_Reject,
     /*  15170 */ // Label 470: @15170
     /*  15170 */ GIM_Reject,
     /*  15171 */ // Label 447: @15171
     /*  15171 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(15563),
     /*  15176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  15179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  15182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15186 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(15247), // Rule ID 26069 //
     /*  15191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15209 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15226 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15245 */     GIR_RootConstrainSelectedInstOperands,
     /*  15246 */     // GIR_Coverage, 26069,
     /*  15246 */     GIR_EraseRootFromParent_Done,
     /*  15247 */   // Label 475: @15247
     /*  15247 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(15308), // Rule ID 26088 //
     /*  15252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15270 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15287 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15306 */     GIR_RootConstrainSelectedInstOperands,
     /*  15307 */     // GIR_Coverage, 26088,
     /*  15307 */     GIR_EraseRootFromParent_Done,
     /*  15308 */   // Label 476: @15308
     /*  15308 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(15369), // Rule ID 22854 //
     /*  15313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15335 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15348 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15367 */     GIR_RootConstrainSelectedInstOperands,
     /*  15368 */     // GIR_Coverage, 22854,
     /*  15368 */     GIR_EraseRootFromParent_Done,
     /*  15369 */   // Label 477: @15369
     /*  15369 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(15430), // Rule ID 22944 //
     /*  15374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15396 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15409 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15428 */     GIR_RootConstrainSelectedInstOperands,
     /*  15429 */     // GIR_Coverage, 22944,
     /*  15429 */     GIR_EraseRootFromParent_Done,
     /*  15430 */   // Label 478: @15430
     /*  15430 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(15467), // Rule ID 22858 //
     /*  15435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15450 */     // MIs[1] Operand 1
     /*  15450 */     // No operand predicates
     /*  15450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15452 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  15455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15465 */     GIR_RootConstrainSelectedInstOperands,
     /*  15466 */     // GIR_Coverage, 22858,
     /*  15466 */     GIR_EraseRootFromParent_Done,
     /*  15467 */   // Label 479: @15467
     /*  15467 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(15504), // Rule ID 22948 //
     /*  15472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15487 */     // MIs[1] Operand 1
     /*  15487 */     // No operand predicates
     /*  15487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15489 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  15492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15502 */     GIR_RootConstrainSelectedInstOperands,
     /*  15503 */     // GIR_Coverage, 22948,
     /*  15503 */     GIR_EraseRootFromParent_Done,
     /*  15504 */   // Label 480: @15504
     /*  15504 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(15533), // Rule ID 22850 //
     /*  15509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15520 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  15525 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15531 */     GIR_RootConstrainSelectedInstOperands,
     /*  15532 */     // GIR_Coverage, 22850,
     /*  15532 */     GIR_Done,
     /*  15533 */   // Label 481: @15533
     /*  15533 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(15562), // Rule ID 22940 //
     /*  15538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15549 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  15554 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15560 */     GIR_RootConstrainSelectedInstOperands,
     /*  15561 */     // GIR_Coverage, 22940,
     /*  15561 */     GIR_Done,
     /*  15562 */   // Label 482: @15562
     /*  15562 */   GIM_Reject,
     /*  15563 */ // Label 474: @15563
     /*  15563 */ GIM_Reject,
     /*  15564 */ // Label 448: @15564
     /*  15564 */ GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(16248),
     /*  15569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  15572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  15575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(15640), // Rule ID 26070 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15595 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15598 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15602 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15619 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15624 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15638 */     GIR_RootConstrainSelectedInstOperands,
     /*  15639 */     // GIR_Coverage, 26070,
     /*  15639 */     GIR_EraseRootFromParent_Done,
     /*  15640 */   // Label 484: @15640
     /*  15640 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15701), // Rule ID 26089 //
     /*  15645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15663 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15680 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15699 */     GIR_RootConstrainSelectedInstOperands,
     /*  15700 */     // GIR_Coverage, 26089,
     /*  15700 */     GIR_EraseRootFromParent_Done,
     /*  15701 */   // Label 485: @15701
     /*  15701 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15762), // Rule ID 22855 //
     /*  15706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15728 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15741 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15760 */     GIR_RootConstrainSelectedInstOperands,
     /*  15761 */     // GIR_Coverage, 22855,
     /*  15761 */     GIR_EraseRootFromParent_Done,
     /*  15762 */   // Label 486: @15762
     /*  15762 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15823), // Rule ID 22945 //
     /*  15767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15782 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15789 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15802 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15821 */     GIR_RootConstrainSelectedInstOperands,
     /*  15822 */     // GIR_Coverage, 22945,
     /*  15822 */     GIR_EraseRootFromParent_Done,
     /*  15823 */   // Label 487: @15823
     /*  15823 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15925), // Rule ID 26036 //
     /*  15828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15844 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15859 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15923 */     GIR_RootConstrainSelectedInstOperands,
     /*  15924 */     // GIR_Coverage, 26036,
     /*  15924 */     GIR_EraseRootFromParent_Done,
     /*  15925 */   // Label 488: @15925
     /*  15925 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(16027), // Rule ID 22774 //
     /*  15930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15961 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15987 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  16002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  16007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  16012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  16015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  16022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16025 */     GIR_RootConstrainSelectedInstOperands,
     /*  16026 */     // GIR_Coverage, 22774,
     /*  16026 */     GIR_EraseRootFromParent_Done,
     /*  16027 */   // Label 489: @16027
     /*  16027 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(16115), // Rule ID 22634 //
     /*  16032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16036 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  16047 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  16047 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  16050 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  16054 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16059 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  16065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  16070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  16075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  16078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  16082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  16090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  16092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  16095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16097 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  16104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  16109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  16114 */     // GIR_Coverage, 22634,
     /*  16114 */     GIR_EraseRootFromParent_Done,
     /*  16115 */   // Label 490: @16115
     /*  16115 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(16152), // Rule ID 22859 //
     /*  16120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16135 */     // MIs[1] Operand 1
     /*  16135 */     // No operand predicates
     /*  16135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16137 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  16137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  16140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  16147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16150 */     GIR_RootConstrainSelectedInstOperands,
     /*  16151 */     // GIR_Coverage, 22859,
     /*  16151 */     GIR_EraseRootFromParent_Done,
     /*  16152 */   // Label 491: @16152
     /*  16152 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(16189), // Rule ID 22949 //
     /*  16157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16172 */     // MIs[1] Operand 1
     /*  16172 */     // No operand predicates
     /*  16172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16174 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  16174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  16177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  16184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16187 */     GIR_RootConstrainSelectedInstOperands,
     /*  16188 */     // GIR_Coverage, 22949,
     /*  16188 */     GIR_EraseRootFromParent_Done,
     /*  16189 */   // Label 492: @16189
     /*  16189 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(16218), // Rule ID 22851 //
     /*  16194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16205 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  16210 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16216 */     GIR_RootConstrainSelectedInstOperands,
     /*  16217 */     // GIR_Coverage, 22851,
     /*  16217 */     GIR_Done,
     /*  16218 */   // Label 493: @16218
     /*  16218 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(16247), // Rule ID 22941 //
     /*  16223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16234 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  16239 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16245 */     GIR_RootConstrainSelectedInstOperands,
     /*  16246 */     // GIR_Coverage, 22941,
     /*  16246 */     GIR_Done,
     /*  16247 */   // Label 494: @16247
     /*  16247 */   GIM_Reject,
     /*  16248 */ // Label 483: @16248
     /*  16248 */ GIM_Reject,
     /*  16249 */ // Label 449: @16249
     /*  16249 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(18074),
     /*  16254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  16257 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(16349), // Rule ID 17546 //
     /*  16262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16305 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16308 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16312 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16325 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16347 */     GIR_RootConstrainSelectedInstOperands,
     /*  16348 */     // GIR_Coverage, 17546,
     /*  16348 */     GIR_EraseRootFromParent_Done,
     /*  16349 */   // Label 496: @16349
     /*  16349 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(16441), // Rule ID 17550 //
     /*  16354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16400 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16404 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16417 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16439 */     GIR_RootConstrainSelectedInstOperands,
     /*  16440 */     // GIR_Coverage, 17550,
     /*  16440 */     GIR_EraseRootFromParent_Done,
     /*  16441 */   // Label 497: @16441
     /*  16441 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(16533), // Rule ID 25103 //
     /*  16446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16471 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16496 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16509 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16531 */     GIR_RootConstrainSelectedInstOperands,
     /*  16532 */     // GIR_Coverage, 25103,
     /*  16532 */     GIR_EraseRootFromParent_Done,
     /*  16533 */   // Label 498: @16533
     /*  16533 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(16625), // Rule ID 25107 //
     /*  16538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16563 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16588 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16601 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16623 */     GIR_RootConstrainSelectedInstOperands,
     /*  16624 */     // GIR_Coverage, 25107,
     /*  16624 */     GIR_EraseRootFromParent_Done,
     /*  16625 */   // Label 499: @16625
     /*  16625 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(16693), // Rule ID 26071 //
     /*  16630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16655 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16672 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16691 */     GIR_RootConstrainSelectedInstOperands,
     /*  16692 */     // GIR_Coverage, 26071,
     /*  16692 */     GIR_EraseRootFromParent_Done,
     /*  16693 */   // Label 500: @16693
     /*  16693 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(16761), // Rule ID 26090 //
     /*  16698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16723 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16740 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16759 */     GIR_RootConstrainSelectedInstOperands,
     /*  16760 */     // GIR_Coverage, 26090,
     /*  16760 */     GIR_EraseRootFromParent_Done,
     /*  16761 */   // Label 501: @16761
     /*  16761 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(16829), // Rule ID 22856 //
     /*  16766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16795 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16808 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16827 */     GIR_RootConstrainSelectedInstOperands,
     /*  16828 */     // GIR_Coverage, 22856,
     /*  16828 */     GIR_EraseRootFromParent_Done,
     /*  16829 */   // Label 502: @16829
     /*  16829 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(16897), // Rule ID 22946 //
     /*  16834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16863 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16876 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16895 */     GIR_RootConstrainSelectedInstOperands,
     /*  16896 */     // GIR_Coverage, 22946,
     /*  16896 */     GIR_EraseRootFromParent_Done,
     /*  16897 */   // Label 503: @16897
     /*  16897 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(16974), // Rule ID 24995 //
     /*  16902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  16937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16949 */     // MIs[2] src
     /*  16949 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16960 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16972 */     GIR_RootConstrainSelectedInstOperands,
     /*  16973 */     // GIR_Coverage, 24995,
     /*  16973 */     GIR_EraseRootFromParent_Done,
     /*  16974 */   // Label 504: @16974
     /*  16974 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(17051), // Rule ID 25007 //
     /*  16979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17026 */     // MIs[2] src
     /*  17026 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17031 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  17035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17037 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  17040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17049 */     GIR_RootConstrainSelectedInstOperands,
     /*  17050 */     // GIR_Coverage, 25007,
     /*  17050 */     GIR_EraseRootFromParent_Done,
     /*  17051 */   // Label 505: @17051
     /*  17051 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(17128), // Rule ID 17356 //
     /*  17056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17087 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17103 */     // MIs[2] src
     /*  17103 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17108 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  17112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17114 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  17117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17126 */     GIR_RootConstrainSelectedInstOperands,
     /*  17127 */     // GIR_Coverage, 17356,
     /*  17127 */     GIR_EraseRootFromParent_Done,
     /*  17128 */   // Label 506: @17128
     /*  17128 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(17205), // Rule ID 17368 //
     /*  17133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17164 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17180 */     // MIs[2] src
     /*  17180 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17185 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  17189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17191 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  17194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17203 */     GIR_RootConstrainSelectedInstOperands,
     /*  17204 */     // GIR_Coverage, 17368,
     /*  17204 */     GIR_EraseRootFromParent_Done,
     /*  17205 */   // Label 507: @17205
     /*  17205 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(17263), // Rule ID 24989 //
     /*  17210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17238 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17242 */     // MIs[0] src
     /*  17242 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17249 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17261 */     GIR_RootConstrainSelectedInstOperands,
     /*  17262 */     // GIR_Coverage, 24989,
     /*  17262 */     GIR_EraseRootFromParent_Done,
     /*  17263 */   // Label 508: @17263
     /*  17263 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(17372), // Rule ID 26042 //
     /*  17268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17291 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17306 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  17364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17370 */     GIR_RootConstrainSelectedInstOperands,
     /*  17371 */     // GIR_Coverage, 26042,
     /*  17371 */     GIR_EraseRootFromParent_Done,
     /*  17372 */   // Label 509: @17372
     /*  17372 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(17426), // Rule ID 17350 //
     /*  17377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17403 */     // MIs[1] src
     /*  17403 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  17408 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17414 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17424 */     GIR_RootConstrainSelectedInstOperands,
     /*  17425 */     // GIR_Coverage, 17350,
     /*  17425 */     GIR_EraseRootFromParent_Done,
     /*  17426 */   // Label 510: @17426
     /*  17426 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(17535), // Rule ID 22780 //
     /*  17431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17458 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17469 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17495 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17502 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17533 */     GIR_RootConstrainSelectedInstOperands,
     /*  17534 */     // GIR_Coverage, 22780,
     /*  17534 */     GIR_EraseRootFromParent_Done,
     /*  17535 */   // Label 511: @17535
     /*  17535 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(17600), // Rule ID 22632 //
     /*  17540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17551 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17562 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  17562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  17565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17574 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  17580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  17585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  17593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17598 */     GIR_RootConstrainSelectedInstOperands,
     /*  17599 */     // GIR_Coverage, 22632,
     /*  17599 */     GIR_EraseRootFromParent_Done,
     /*  17600 */   // Label 512: @17600
     /*  17600 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(17665), // Rule ID 22633 //
     /*  17605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17627 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  17627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  17630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  17645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  17650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  17658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17663 */     GIR_RootConstrainSelectedInstOperands,
     /*  17664 */     // GIR_Coverage, 22633,
     /*  17664 */     GIR_EraseRootFromParent_Done,
     /*  17665 */   // Label 513: @17665
     /*  17665 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(17709), // Rule ID 22860 //
     /*  17670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17692 */     // MIs[1] Operand 1
     /*  17692 */     // No operand predicates
     /*  17692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17694 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  17697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17707 */     GIR_RootConstrainSelectedInstOperands,
     /*  17708 */     // GIR_Coverage, 22860,
     /*  17708 */     GIR_EraseRootFromParent_Done,
     /*  17709 */   // Label 514: @17709
     /*  17709 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(17753), // Rule ID 22950 //
     /*  17714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17736 */     // MIs[1] Operand 1
     /*  17736 */     // No operand predicates
     /*  17736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17738 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  17741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17751 */     GIR_RootConstrainSelectedInstOperands,
     /*  17752 */     // GIR_Coverage, 22950,
     /*  17752 */     GIR_EraseRootFromParent_Done,
     /*  17753 */   // Label 515: @17753
     /*  17753 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(17815), // Rule ID 17544 //
     /*  17758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17789 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17799 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17813 */     GIR_RootConstrainSelectedInstOperands,
     /*  17814 */     // GIR_Coverage, 17544,
     /*  17814 */     GIR_EraseRootFromParent_Done,
     /*  17815 */   // Label 516: @17815
     /*  17815 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(17877), // Rule ID 17548 //
     /*  17820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17851 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17861 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17875 */     GIR_RootConstrainSelectedInstOperands,
     /*  17876 */     // GIR_Coverage, 17548,
     /*  17876 */     GIR_EraseRootFromParent_Done,
     /*  17877 */   // Label 517: @17877
     /*  17877 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(17939), // Rule ID 25101 //
     /*  17882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17917 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17923 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17937 */     GIR_RootConstrainSelectedInstOperands,
     /*  17938 */     // GIR_Coverage, 25101,
     /*  17938 */     GIR_EraseRootFromParent_Done,
     /*  17939 */   // Label 518: @17939
     /*  17939 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(18001), // Rule ID 25105 //
     /*  17944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17979 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17985 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17999 */     GIR_RootConstrainSelectedInstOperands,
     /*  18000 */     // GIR_Coverage, 25105,
     /*  18000 */     GIR_EraseRootFromParent_Done,
     /*  18001 */   // Label 519: @18001
     /*  18001 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(18037), // Rule ID 22852 //
     /*  18006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18024 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  18029 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  18035 */     GIR_RootConstrainSelectedInstOperands,
     /*  18036 */     // GIR_Coverage, 22852,
     /*  18036 */     GIR_Done,
     /*  18037 */   // Label 520: @18037
     /*  18037 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(18073), // Rule ID 22942 //
     /*  18042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18060 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  18065 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  18071 */     GIR_RootConstrainSelectedInstOperands,
     /*  18072 */     // GIR_Coverage, 22942,
     /*  18072 */     GIR_Done,
     /*  18073 */   // Label 521: @18073
     /*  18073 */   GIM_Reject,
     /*  18074 */ // Label 495: @18074
     /*  18074 */ GIM_Reject,
     /*  18075 */ // Label 450: @18075
     /*  18075 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(19778),
     /*  18080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  18083 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(18175), // Rule ID 17547 //
     /*  18088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18131 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18138 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18151 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18173 */     GIR_RootConstrainSelectedInstOperands,
     /*  18174 */     // GIR_Coverage, 17547,
     /*  18174 */     GIR_EraseRootFromParent_Done,
     /*  18175 */   // Label 523: @18175
     /*  18175 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(18267), // Rule ID 17551 //
     /*  18180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18223 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18243 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18265 */     GIR_RootConstrainSelectedInstOperands,
     /*  18266 */     // GIR_Coverage, 17551,
     /*  18266 */     GIR_EraseRootFromParent_Done,
     /*  18267 */   // Label 524: @18267
     /*  18267 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(18359), // Rule ID 25104 //
     /*  18272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18290 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18322 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18335 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18357 */     GIR_RootConstrainSelectedInstOperands,
     /*  18358 */     // GIR_Coverage, 25104,
     /*  18358 */     GIR_EraseRootFromParent_Done,
     /*  18359 */   // Label 525: @18359
     /*  18359 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(18451), // Rule ID 25108 //
     /*  18364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18427 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18449 */     GIR_RootConstrainSelectedInstOperands,
     /*  18450 */     // GIR_Coverage, 25108,
     /*  18450 */     GIR_EraseRootFromParent_Done,
     /*  18451 */   // Label 526: @18451
     /*  18451 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(18519), // Rule ID 26072 //
     /*  18456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18498 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18517 */     GIR_RootConstrainSelectedInstOperands,
     /*  18518 */     // GIR_Coverage, 26072,
     /*  18518 */     GIR_EraseRootFromParent_Done,
     /*  18519 */   // Label 527: @18519
     /*  18519 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(18587), // Rule ID 26091 //
     /*  18524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18566 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18585 */     GIR_RootConstrainSelectedInstOperands,
     /*  18586 */     // GIR_Coverage, 26091,
     /*  18586 */     GIR_EraseRootFromParent_Done,
     /*  18587 */   // Label 528: @18587
     /*  18587 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(18655), // Rule ID 22857 //
     /*  18592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18614 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18621 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18634 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18653 */     GIR_RootConstrainSelectedInstOperands,
     /*  18654 */     // GIR_Coverage, 22857,
     /*  18654 */     GIR_EraseRootFromParent_Done,
     /*  18655 */   // Label 529: @18655
     /*  18655 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(18723), // Rule ID 22947 //
     /*  18660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18702 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18721 */     GIR_RootConstrainSelectedInstOperands,
     /*  18722 */     // GIR_Coverage, 22947,
     /*  18722 */     GIR_EraseRootFromParent_Done,
     /*  18723 */   // Label 530: @18723
     /*  18723 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(18800), // Rule ID 24996 //
     /*  18728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18775 */     // MIs[2] src
     /*  18775 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18780 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18786 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18798 */     GIR_RootConstrainSelectedInstOperands,
     /*  18799 */     // GIR_Coverage, 24996,
     /*  18799 */     GIR_EraseRootFromParent_Done,
     /*  18800 */   // Label 531: @18800
     /*  18800 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(18877), // Rule ID 25008 //
     /*  18805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18836 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18852 */     // MIs[2] src
     /*  18852 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18857 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18863 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18875 */     GIR_RootConstrainSelectedInstOperands,
     /*  18876 */     // GIR_Coverage, 25008,
     /*  18876 */     GIR_EraseRootFromParent_Done,
     /*  18877 */   // Label 532: @18877
     /*  18877 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(18954), // Rule ID 17357 //
     /*  18882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18929 */     // MIs[2] src
     /*  18929 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  18938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18940 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18952 */     GIR_RootConstrainSelectedInstOperands,
     /*  18953 */     // GIR_Coverage, 17357,
     /*  18953 */     GIR_EraseRootFromParent_Done,
     /*  18954 */   // Label 533: @18954
     /*  18954 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(19031), // Rule ID 17369 //
     /*  18959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18990 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19006 */     // MIs[2] src
     /*  19006 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19011 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  19015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19017 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  19020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  19026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19029 */     GIR_RootConstrainSelectedInstOperands,
     /*  19030 */     // GIR_Coverage, 17369,
     /*  19030 */     GIR_EraseRootFromParent_Done,
     /*  19031 */   // Label 534: @19031
     /*  19031 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(19089), // Rule ID 24990 //
     /*  19036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19068 */     // MIs[0] src
     /*  19068 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19075 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  19084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19087 */     GIR_RootConstrainSelectedInstOperands,
     /*  19088 */     // GIR_Coverage, 24990,
     /*  19088 */     GIR_EraseRootFromParent_Done,
     /*  19089 */   // Label 535: @19089
     /*  19089 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(19198), // Rule ID 26048 //
     /*  19094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19117 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19132 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  19190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19196 */     GIR_RootConstrainSelectedInstOperands,
     /*  19197 */     // GIR_Coverage, 26048,
     /*  19197 */     GIR_EraseRootFromParent_Done,
     /*  19198 */   // Label 536: @19198
     /*  19198 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(19252), // Rule ID 17351 //
     /*  19203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19229 */     // MIs[1] src
     /*  19229 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  19234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19240 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  19247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19250 */     GIR_RootConstrainSelectedInstOperands,
     /*  19251 */     // GIR_Coverage, 17351,
     /*  19251 */     GIR_EraseRootFromParent_Done,
     /*  19252 */   // Label 537: @19252
     /*  19252 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(19361), // Rule ID 22786 //
     /*  19257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19295 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19359 */     GIR_RootConstrainSelectedInstOperands,
     /*  19360 */     // GIR_Coverage, 22786,
     /*  19360 */     GIR_EraseRootFromParent_Done,
     /*  19361 */   // Label 538: @19361
     /*  19361 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(19409), // Rule ID 22861 //
     /*  19366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19392 */     // MIs[1] Operand 1
     /*  19392 */     // No operand predicates
     /*  19392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19394 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  19397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19407 */     GIR_RootConstrainSelectedInstOperands,
     /*  19408 */     // GIR_Coverage, 22861,
     /*  19408 */     GIR_EraseRootFromParent_Done,
     /*  19409 */   // Label 539: @19409
     /*  19409 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(19457), // Rule ID 22951 //
     /*  19414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19440 */     // MIs[1] Operand 1
     /*  19440 */     // No operand predicates
     /*  19440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19442 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  19445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19455 */     GIR_RootConstrainSelectedInstOperands,
     /*  19456 */     // GIR_Coverage, 22951,
     /*  19456 */     GIR_EraseRootFromParent_Done,
     /*  19457 */   // Label 540: @19457
     /*  19457 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(19519), // Rule ID 17545 //
     /*  19462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19493 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19503 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19517 */     GIR_RootConstrainSelectedInstOperands,
     /*  19518 */     // GIR_Coverage, 17545,
     /*  19518 */     GIR_EraseRootFromParent_Done,
     /*  19519 */   // Label 541: @19519
     /*  19519 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(19581), // Rule ID 17549 //
     /*  19524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19555 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19565 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19579 */     GIR_RootConstrainSelectedInstOperands,
     /*  19580 */     // GIR_Coverage, 17549,
     /*  19580 */     GIR_EraseRootFromParent_Done,
     /*  19581 */   // Label 542: @19581
     /*  19581 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(19643), // Rule ID 25102 //
     /*  19586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19621 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19627 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19641 */     GIR_RootConstrainSelectedInstOperands,
     /*  19642 */     // GIR_Coverage, 25102,
     /*  19642 */     GIR_EraseRootFromParent_Done,
     /*  19643 */   // Label 543: @19643
     /*  19643 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(19705), // Rule ID 25106 //
     /*  19648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19683 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19689 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19703 */     GIR_RootConstrainSelectedInstOperands,
     /*  19704 */     // GIR_Coverage, 25106,
     /*  19704 */     GIR_EraseRootFromParent_Done,
     /*  19705 */   // Label 544: @19705
     /*  19705 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(19741), // Rule ID 22853 //
     /*  19710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19728 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  19733 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19739 */     GIR_RootConstrainSelectedInstOperands,
     /*  19740 */     // GIR_Coverage, 22853,
     /*  19740 */     GIR_Done,
     /*  19741 */   // Label 545: @19741
     /*  19741 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(19777), // Rule ID 22943 //
     /*  19746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19764 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  19769 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19775 */     GIR_RootConstrainSelectedInstOperands,
     /*  19776 */     // GIR_Coverage, 22943,
     /*  19776 */     GIR_Done,
     /*  19777 */   // Label 546: @19777
     /*  19777 */   GIM_Reject,
     /*  19778 */ // Label 522: @19778
     /*  19778 */ GIM_Reject,
     /*  19779 */ // Label 451: @19779
     /*  19779 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(20124),
     /*  19784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19794 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(19914), // Rule ID 19489 //
     /*  19799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19824 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19830 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19838 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19850 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19854 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19913 */     // GIR_Coverage, 19489,
     /*  19913 */     GIR_EraseRootFromParent_Done,
     /*  19914 */   // Label 548: @19914
     /*  19914 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(20034), // Rule ID 25368 //
     /*  19919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19948 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19954 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19958 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19958 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19961 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19965 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19970 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  19974 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  20033 */     // GIR_Coverage, 25368,
     /*  20033 */     GIR_EraseRootFromParent_Done,
     /*  20034 */   // Label 549: @20034
     /*  20034 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(20123), // Rule ID 19485 //
     /*  20039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  20043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  20047 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  20047 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20050 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20054 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20059 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20063 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20080 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20101 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  20122 */     // GIR_Coverage, 19485,
     /*  20122 */     GIR_EraseRootFromParent_Done,
     /*  20123 */   // Label 550: @20123
     /*  20123 */   GIM_Reject,
     /*  20124 */ // Label 547: @20124
     /*  20124 */ GIM_Reject,
     /*  20125 */ // Label 452: @20125
     /*  20125 */ GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(20466),
     /*  20130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20136 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(20198), // Rule ID 23360 //
     /*  20141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20180 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20185 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 23360,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 552: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(20260), // Rule ID 24149 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20242 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20247 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20258 */     GIR_RootConstrainSelectedInstOperands,
     /*  20259 */     // GIR_Coverage, 24149,
     /*  20259 */     GIR_EraseRootFromParent_Done,
     /*  20260 */   // Label 553: @20260
     /*  20260 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(20322), // Rule ID 2111 //
     /*  20265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20304 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20320 */     GIR_RootConstrainSelectedInstOperands,
     /*  20321 */     // GIR_Coverage, 2111,
     /*  20321 */     GIR_EraseRootFromParent_Done,
     /*  20322 */   // Label 554: @20322
     /*  20322 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(20384), // Rule ID 5707 //
     /*  20327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20366 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20382 */     GIR_RootConstrainSelectedInstOperands,
     /*  20383 */     // GIR_Coverage, 5707,
     /*  20383 */     GIR_EraseRootFromParent_Done,
     /*  20384 */   // Label 555: @20384
     /*  20384 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(20411), // Rule ID 2110 //
     /*  20389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20404 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20409 */     GIR_RootConstrainSelectedInstOperands,
     /*  20410 */     // GIR_Coverage, 2110,
     /*  20410 */     GIR_Done,
     /*  20411 */   // Label 556: @20411
     /*  20411 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(20438), // Rule ID 2112 //
     /*  20416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20431 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20436 */     GIR_RootConstrainSelectedInstOperands,
     /*  20437 */     // GIR_Coverage, 2112,
     /*  20437 */     GIR_Done,
     /*  20438 */   // Label 557: @20438
     /*  20438 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(20465), // Rule ID 5704 //
     /*  20443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20458 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  20458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  20463 */     GIR_RootConstrainSelectedInstOperands,
     /*  20464 */     // GIR_Coverage, 5704,
     /*  20464 */     GIR_Done,
     /*  20465 */   // Label 558: @20465
     /*  20465 */   GIM_Reject,
     /*  20466 */ // Label 551: @20466
     /*  20466 */ GIM_Reject,
     /*  20467 */ // Label 453: @20467
     /*  20467 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(20812),
     /*  20472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20482 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(20602), // Rule ID 19490 //
     /*  20487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20518 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20526 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20526 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20529 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20533 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20538 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20542 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20547 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20550 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20554 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20559 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20580 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20601 */     // GIR_Coverage, 19490,
     /*  20601 */     GIR_EraseRootFromParent_Done,
     /*  20602 */   // Label 560: @20602
     /*  20602 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(20722), // Rule ID 25369 //
     /*  20607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20636 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20642 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20646 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20658 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  20662 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20703 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20721 */     // GIR_Coverage, 25369,
     /*  20721 */     GIR_EraseRootFromParent_Done,
     /*  20722 */   // Label 561: @20722
     /*  20722 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(20811), // Rule ID 19486 //
     /*  20727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20735 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20735 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20738 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20742 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20747 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20751 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20768 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20789 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20810 */     // GIR_Coverage, 19486,
     /*  20810 */     GIR_EraseRootFromParent_Done,
     /*  20811 */   // Label 562: @20811
     /*  20811 */   GIM_Reject,
     /*  20812 */ // Label 559: @20812
     /*  20812 */ GIM_Reject,
     /*  20813 */ // Label 454: @20813
     /*  20813 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(21154),
     /*  20818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20824 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(20886), // Rule ID 24167 //
     /*  20829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20868 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20873 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20884 */     GIR_RootConstrainSelectedInstOperands,
     /*  20885 */     // GIR_Coverage, 24167,
     /*  20885 */     GIR_EraseRootFromParent_Done,
     /*  20886 */   // Label 564: @20886
     /*  20886 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(20948), // Rule ID 25253 //
     /*  20891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20930 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20946 */     GIR_RootConstrainSelectedInstOperands,
     /*  20947 */     // GIR_Coverage, 25253,
     /*  20947 */     GIR_EraseRootFromParent_Done,
     /*  20948 */   // Label 565: @20948
     /*  20948 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(21010), // Rule ID 5734 //
     /*  20953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20992 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21008 */     GIR_RootConstrainSelectedInstOperands,
     /*  21009 */     // GIR_Coverage, 5734,
     /*  21009 */     GIR_EraseRootFromParent_Done,
     /*  21010 */   // Label 566: @21010
     /*  21010 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(21072), // Rule ID 18160 //
     /*  21015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21054 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  21057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21070 */     GIR_RootConstrainSelectedInstOperands,
     /*  21071 */     // GIR_Coverage, 18160,
     /*  21071 */     GIR_EraseRootFromParent_Done,
     /*  21072 */   // Label 567: @21072
     /*  21072 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(21099), // Rule ID 5731 //
     /*  21077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21092 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  21092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /*  21097 */     GIR_RootConstrainSelectedInstOperands,
     /*  21098 */     // GIR_Coverage, 5731,
     /*  21098 */     GIR_Done,
     /*  21099 */   // Label 568: @21099
     /*  21099 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(21126), // Rule ID 18148 //
     /*  21104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21119 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  21119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  21124 */     GIR_RootConstrainSelectedInstOperands,
     /*  21125 */     // GIR_Coverage, 18148,
     /*  21125 */     GIR_Done,
     /*  21126 */   // Label 569: @21126
     /*  21126 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(21153), // Rule ID 18172 //
     /*  21131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  21134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21146 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  21146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  21151 */     GIR_RootConstrainSelectedInstOperands,
     /*  21152 */     // GIR_Coverage, 18172,
     /*  21152 */     GIR_Done,
     /*  21153 */   // Label 570: @21153
     /*  21153 */   GIM_Reject,
     /*  21154 */ // Label 563: @21154
     /*  21154 */ GIM_Reject,
     /*  21155 */ // Label 455: @21155
     /*  21155 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(21620),
     /*  21160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  21163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  21166 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(21228), // Rule ID 23362 //
     /*  21171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21210 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21226 */     GIR_RootConstrainSelectedInstOperands,
     /*  21227 */     // GIR_Coverage, 23362,
     /*  21227 */     GIR_EraseRootFromParent_Done,
     /*  21228 */   // Label 572: @21228
     /*  21228 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(21290), // Rule ID 24143 //
     /*  21233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21272 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21288 */     GIR_RootConstrainSelectedInstOperands,
     /*  21289 */     // GIR_Coverage, 24143,
     /*  21289 */     GIR_EraseRootFromParent_Done,
     /*  21290 */   // Label 573: @21290
     /*  21290 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(21352), // Rule ID 25242 //
     /*  21295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21334 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21350 */     GIR_RootConstrainSelectedInstOperands,
     /*  21351 */     // GIR_Coverage, 25242,
     /*  21351 */     GIR_EraseRootFromParent_Done,
     /*  21352 */   // Label 574: @21352
     /*  21352 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(21414), // Rule ID 2115 //
     /*  21357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21396 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21412 */     GIR_RootConstrainSelectedInstOperands,
     /*  21413 */     // GIR_Coverage, 2115,
     /*  21413 */     GIR_EraseRootFromParent_Done,
     /*  21414 */   // Label 575: @21414
     /*  21414 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(21476), // Rule ID 5698 //
     /*  21419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21458 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21474 */     GIR_RootConstrainSelectedInstOperands,
     /*  21475 */     // GIR_Coverage, 5698,
     /*  21475 */     GIR_EraseRootFromParent_Done,
     /*  21476 */   // Label 576: @21476
     /*  21476 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(21538), // Rule ID 18133 //
     /*  21481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21520 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21527 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21536 */     GIR_RootConstrainSelectedInstOperands,
     /*  21537 */     // GIR_Coverage, 18133,
     /*  21537 */     GIR_EraseRootFromParent_Done,
     /*  21538 */   // Label 577: @21538
     /*  21538 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(21565), // Rule ID 2114 //
     /*  21543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21558 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  21563 */     GIR_RootConstrainSelectedInstOperands,
     /*  21564 */     // GIR_Coverage, 2114,
     /*  21564 */     GIR_Done,
     /*  21565 */   // Label 578: @21565
     /*  21565 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(21592), // Rule ID 5695 //
     /*  21570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21585 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  21585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  21590 */     GIR_RootConstrainSelectedInstOperands,
     /*  21591 */     // GIR_Coverage, 5695,
     /*  21591 */     GIR_Done,
     /*  21592 */   // Label 579: @21592
     /*  21592 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(21619), // Rule ID 18117 //
     /*  21597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21612 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  21617 */     GIR_RootConstrainSelectedInstOperands,
     /*  21618 */     // GIR_Coverage, 18117,
     /*  21618 */     GIR_Done,
     /*  21619 */   // Label 580: @21619
     /*  21619 */   GIM_Reject,
     /*  21620 */ // Label 571: @21620
     /*  21620 */ GIM_Reject,
     /*  21621 */ // Label 456: @21621
     /*  21621 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(22118),
     /*  21626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21636 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(21696), // Rule ID 4431 //
     /*  21641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21669 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21683 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21692 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  21694 */     GIR_RootConstrainSelectedInstOperands,
     /*  21695 */     // GIR_Coverage, 4431,
     /*  21695 */     GIR_EraseRootFromParent_Done,
     /*  21696 */   // Label 582: @21696
     /*  21696 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(21819), // Rule ID 19487 //
     /*  21701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21729 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21743 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21743 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21746 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21750 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21755 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21759 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21764 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21767 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21771 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21797 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21800 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21818 */     // GIR_Coverage, 19487,
     /*  21818 */     GIR_EraseRootFromParent_Done,
     /*  21819 */   // Label 583: @21819
     /*  21819 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(21879), // Rule ID 23692 //
     /*  21824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21856 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21866 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  21877 */     GIR_RootConstrainSelectedInstOperands,
     /*  21878 */     // GIR_Coverage, 23692,
     /*  21878 */     GIR_EraseRootFromParent_Done,
     /*  21879 */   // Label 584: @21879
     /*  21879 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(22002), // Rule ID 25366 //
     /*  21884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21916 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21926 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21938 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  21942 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21980 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  22001 */     // GIR_Coverage, 25366,
     /*  22001 */     GIR_EraseRootFromParent_Done,
     /*  22002 */   // Label 585: @22002
     /*  22002 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(22025), // Rule ID 4415 //
     /*  22007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  22010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22018 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  22018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 4415,
     /*  22024 */     GIR_Done,
     /*  22025 */   // Label 586: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(22117), // Rule ID 19483 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22041 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  22041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  22044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22053 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  22057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  22062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  22065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  22078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  22083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  22086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  22090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22098 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  22101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  22111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  22116 */     // GIR_Coverage, 19483,
     /*  22116 */     GIR_EraseRootFromParent_Done,
     /*  22117 */   // Label 587: @22117
     /*  22117 */   GIM_Reject,
     /*  22118 */ // Label 581: @22118
     /*  22118 */ GIM_Reject,
     /*  22119 */ // Label 457: @22119
     /*  22119 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(22460),
     /*  22124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22130 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(22192), // Rule ID 25252 //
     /*  22135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22174 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22190 */     GIR_RootConstrainSelectedInstOperands,
     /*  22191 */     // GIR_Coverage, 25252,
     /*  22191 */     GIR_EraseRootFromParent_Done,
     /*  22192 */   // Label 589: @22192
     /*  22192 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(22254), // Rule ID 25433 //
     /*  22197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22236 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22252 */     GIR_RootConstrainSelectedInstOperands,
     /*  22253 */     // GIR_Coverage, 25433,
     /*  22253 */     GIR_EraseRootFromParent_Done,
     /*  22254 */   // Label 590: @22254
     /*  22254 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(22316), // Rule ID 18159 //
     /*  22259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22298 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22314 */     GIR_RootConstrainSelectedInstOperands,
     /*  22315 */     // GIR_Coverage, 18159,
     /*  22315 */     GIR_EraseRootFromParent_Done,
     /*  22316 */   // Label 591: @22316
     /*  22316 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(22378), // Rule ID 20025 //
     /*  22321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22360 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22376 */     GIR_RootConstrainSelectedInstOperands,
     /*  22377 */     // GIR_Coverage, 20025,
     /*  22377 */     GIR_EraseRootFromParent_Done,
     /*  22378 */   // Label 592: @22378
     /*  22378 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(22405), // Rule ID 18147 //
     /*  22383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22398 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  22403 */     GIR_RootConstrainSelectedInstOperands,
     /*  22404 */     // GIR_Coverage, 18147,
     /*  22404 */     GIR_Done,
     /*  22405 */   // Label 593: @22405
     /*  22405 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(22432), // Rule ID 18171 //
     /*  22410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  22413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22425 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  22430 */     GIR_RootConstrainSelectedInstOperands,
     /*  22431 */     // GIR_Coverage, 18171,
     /*  22431 */     GIR_Done,
     /*  22432 */   // Label 594: @22432
     /*  22432 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(22459), // Rule ID 20017 //
     /*  22437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22452 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  22452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  22457 */     GIR_RootConstrainSelectedInstOperands,
     /*  22458 */     // GIR_Coverage, 20017,
     /*  22458 */     GIR_Done,
     /*  22459 */   // Label 595: @22459
     /*  22459 */   GIM_Reject,
     /*  22460 */ // Label 588: @22460
     /*  22460 */ GIM_Reject,
     /*  22461 */ // Label 458: @22461
     /*  22461 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(22926),
     /*  22466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  22469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  22472 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(22534), // Rule ID 24161 //
     /*  22477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22516 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22532 */     GIR_RootConstrainSelectedInstOperands,
     /*  22533 */     // GIR_Coverage, 24161,
     /*  22533 */     GIR_EraseRootFromParent_Done,
     /*  22534 */   // Label 597: @22534
     /*  22534 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(22596), // Rule ID 25232 //
     /*  22539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22578 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22594 */     GIR_RootConstrainSelectedInstOperands,
     /*  22595 */     // GIR_Coverage, 25232,
     /*  22595 */     GIR_EraseRootFromParent_Done,
     /*  22596 */   // Label 598: @22596
     /*  22596 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(22658), // Rule ID 25241 //
     /*  22601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22640 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22656 */     GIR_RootConstrainSelectedInstOperands,
     /*  22657 */     // GIR_Coverage, 25241,
     /*  22657 */     GIR_EraseRootFromParent_Done,
     /*  22658 */   // Label 599: @22658
     /*  22658 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(22720), // Rule ID 5725 //
     /*  22663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22702 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22718 */     GIR_RootConstrainSelectedInstOperands,
     /*  22719 */     // GIR_Coverage, 5725,
     /*  22719 */     GIR_EraseRootFromParent_Done,
     /*  22720 */   // Label 600: @22720
     /*  22720 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(22782), // Rule ID 18104 //
     /*  22725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22764 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22780 */     GIR_RootConstrainSelectedInstOperands,
     /*  22781 */     // GIR_Coverage, 18104,
     /*  22781 */     GIR_EraseRootFromParent_Done,
     /*  22782 */   // Label 601: @22782
     /*  22782 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(22844), // Rule ID 18132 //
     /*  22787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22826 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22842 */     GIR_RootConstrainSelectedInstOperands,
     /*  22843 */     // GIR_Coverage, 18132,
     /*  22843 */     GIR_EraseRootFromParent_Done,
     /*  22844 */   // Label 602: @22844
     /*  22844 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(22871), // Rule ID 5722 //
     /*  22849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22864 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  22864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /*  22869 */     GIR_RootConstrainSelectedInstOperands,
     /*  22870 */     // GIR_Coverage, 5722,
     /*  22870 */     GIR_Done,
     /*  22871 */   // Label 603: @22871
     /*  22871 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(22898), // Rule ID 18092 //
     /*  22876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22891 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  22896 */     GIR_RootConstrainSelectedInstOperands,
     /*  22897 */     // GIR_Coverage, 18092,
     /*  22897 */     GIR_Done,
     /*  22898 */   // Label 604: @22898
     /*  22898 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(22925), // Rule ID 18116 //
     /*  22903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22918 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  22923 */     GIR_RootConstrainSelectedInstOperands,
     /*  22924 */     // GIR_Coverage, 18116,
     /*  22924 */     GIR_Done,
     /*  22925 */   // Label 605: @22925
     /*  22925 */   GIM_Reject,
     /*  22926 */ // Label 596: @22926
     /*  22926 */ GIM_Reject,
     /*  22927 */ // Label 459: @22927
     /*  22927 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(23082),
     /*  22932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  22935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  22938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22942 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(23000), // Rule ID 24137 //
     /*  22947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22982 */     // (and:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22987 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22998 */     GIR_RootConstrainSelectedInstOperands,
     /*  22999 */     // GIR_Coverage, 24137,
     /*  22999 */     GIR_EraseRootFromParent_Done,
     /*  23000 */   // Label 607: @23000
     /*  23000 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(23058), // Rule ID 5689 //
     /*  23005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23040 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  23043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23056 */     GIR_RootConstrainSelectedInstOperands,
     /*  23057 */     // GIR_Coverage, 5689,
     /*  23057 */     GIR_EraseRootFromParent_Done,
     /*  23058 */   // Label 608: @23058
     /*  23058 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(23081), // Rule ID 5686 //
     /*  23063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23074 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  23074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  23079 */     GIR_RootConstrainSelectedInstOperands,
     /*  23080 */     // GIR_Coverage, 5686,
     /*  23080 */     GIR_Done,
     /*  23081 */   // Label 609: @23081
     /*  23081 */   GIM_Reject,
     /*  23082 */ // Label 606: @23082
     /*  23082 */ GIM_Reject,
     /*  23083 */ // Label 460: @23083
     /*  23083 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(23242),
     /*  23088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23098 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(23158), // Rule ID 4432 //
     /*  23103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23131 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23137 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23145 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  23156 */     GIR_RootConstrainSelectedInstOperands,
     /*  23157 */     // GIR_Coverage, 4432,
     /*  23157 */     GIR_EraseRootFromParent_Done,
     /*  23158 */   // Label 611: @23158
     /*  23158 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(23218), // Rule ID 23693 //
     /*  23163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23195 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23205 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  23216 */     GIR_RootConstrainSelectedInstOperands,
     /*  23217 */     // GIR_Coverage, 23693,
     /*  23217 */     GIR_EraseRootFromParent_Done,
     /*  23218 */   // Label 612: @23218
     /*  23218 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(23241), // Rule ID 4416 //
     /*  23223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23234 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  23239 */     GIR_RootConstrainSelectedInstOperands,
     /*  23240 */     // GIR_Coverage, 4416,
     /*  23240 */     GIR_Done,
     /*  23241 */   // Label 613: @23241
     /*  23241 */   GIM_Reject,
     /*  23242 */ // Label 610: @23242
     /*  23242 */ GIM_Reject,
     /*  23243 */ // Label 461: @23243
     /*  23243 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(23584),
     /*  23248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  23251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  23254 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(23316), // Rule ID 25251 //
     /*  23259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23298 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23314 */     GIR_RootConstrainSelectedInstOperands,
     /*  23315 */     // GIR_Coverage, 25251,
     /*  23315 */     GIR_EraseRootFromParent_Done,
     /*  23316 */   // Label 615: @23316
     /*  23316 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(23378), // Rule ID 25432 //
     /*  23321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23360 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23376 */     GIR_RootConstrainSelectedInstOperands,
     /*  23377 */     // GIR_Coverage, 25432,
     /*  23377 */     GIR_EraseRootFromParent_Done,
     /*  23378 */   // Label 616: @23378
     /*  23378 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(23440), // Rule ID 18158 //
     /*  23383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23422 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23438 */     GIR_RootConstrainSelectedInstOperands,
     /*  23439 */     // GIR_Coverage, 18158,
     /*  23439 */     GIR_EraseRootFromParent_Done,
     /*  23440 */   // Label 617: @23440
     /*  23440 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(23502), // Rule ID 20024 //
     /*  23445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23484 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23500 */     GIR_RootConstrainSelectedInstOperands,
     /*  23501 */     // GIR_Coverage, 20024,
     /*  23501 */     GIR_EraseRootFromParent_Done,
     /*  23502 */   // Label 618: @23502
     /*  23502 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(23529), // Rule ID 18146 //
     /*  23507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23522 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  23527 */     GIR_RootConstrainSelectedInstOperands,
     /*  23528 */     // GIR_Coverage, 18146,
     /*  23528 */     GIR_Done,
     /*  23529 */   // Label 619: @23529
     /*  23529 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(23556), // Rule ID 18170 //
     /*  23534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  23537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23549 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  23554 */     GIR_RootConstrainSelectedInstOperands,
     /*  23555 */     // GIR_Coverage, 18170,
     /*  23555 */     GIR_Done,
     /*  23556 */   // Label 620: @23556
     /*  23556 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(23583), // Rule ID 20016 //
     /*  23561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23576 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  23576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  23581 */     GIR_RootConstrainSelectedInstOperands,
     /*  23582 */     // GIR_Coverage, 20016,
     /*  23582 */     GIR_Done,
     /*  23583 */   // Label 621: @23583
     /*  23583 */   GIM_Reject,
     /*  23584 */ // Label 614: @23584
     /*  23584 */ GIM_Reject,
     /*  23585 */ // Label 462: @23585
     /*  23585 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(24050),
     /*  23590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  23593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  23596 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(23658), // Rule ID 25231 //
     /*  23601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23640 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23656 */     GIR_RootConstrainSelectedInstOperands,
     /*  23657 */     // GIR_Coverage, 25231,
     /*  23657 */     GIR_EraseRootFromParent_Done,
     /*  23658 */   // Label 623: @23658
     /*  23658 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(23720), // Rule ID 25240 //
     /*  23663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23702 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23707 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23718 */     GIR_RootConstrainSelectedInstOperands,
     /*  23719 */     // GIR_Coverage, 25240,
     /*  23719 */     GIR_EraseRootFromParent_Done,
     /*  23720 */   // Label 624: @23720
     /*  23720 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(23782), // Rule ID 25439 //
     /*  23725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23764 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23780 */     GIR_RootConstrainSelectedInstOperands,
     /*  23781 */     // GIR_Coverage, 25439,
     /*  23781 */     GIR_EraseRootFromParent_Done,
     /*  23782 */   // Label 625: @23782
     /*  23782 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(23844), // Rule ID 18103 //
     /*  23787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23826 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23842 */     GIR_RootConstrainSelectedInstOperands,
     /*  23843 */     // GIR_Coverage, 18103,
     /*  23843 */     GIR_EraseRootFromParent_Done,
     /*  23844 */   // Label 626: @23844
     /*  23844 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(23906), // Rule ID 18131 //
     /*  23849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23888 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23904 */     GIR_RootConstrainSelectedInstOperands,
     /*  23905 */     // GIR_Coverage, 18131,
     /*  23905 */     GIR_EraseRootFromParent_Done,
     /*  23906 */   // Label 627: @23906
     /*  23906 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(23968), // Rule ID 20041 //
     /*  23911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23950 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23966 */     GIR_RootConstrainSelectedInstOperands,
     /*  23967 */     // GIR_Coverage, 20041,
     /*  23967 */     GIR_EraseRootFromParent_Done,
     /*  23968 */   // Label 628: @23968
     /*  23968 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(23995), // Rule ID 18091 //
     /*  23973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23988 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  23993 */     GIR_RootConstrainSelectedInstOperands,
     /*  23994 */     // GIR_Coverage, 18091,
     /*  23994 */     GIR_Done,
     /*  23995 */   // Label 629: @23995
     /*  23995 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(24022), // Rule ID 18115 //
     /*  24000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24015 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  24015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24020 */     GIR_RootConstrainSelectedInstOperands,
     /*  24021 */     // GIR_Coverage, 18115,
     /*  24021 */     GIR_Done,
     /*  24022 */   // Label 630: @24022
     /*  24022 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(24049), // Rule ID 20033 //
     /*  24027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24042 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  24042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24047 */     GIR_RootConstrainSelectedInstOperands,
     /*  24048 */     // GIR_Coverage, 20033,
     /*  24048 */     GIR_Done,
     /*  24049 */   // Label 631: @24049
     /*  24049 */   GIM_Reject,
     /*  24050 */ // Label 622: @24050
     /*  24050 */ GIM_Reject,
     /*  24051 */ // Label 463: @24051
     /*  24051 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(24206),
     /*  24056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  24059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  24062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24066 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(24124), // Rule ID 24155 //
     /*  24071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24106 */     // (and:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  24109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24122 */     GIR_RootConstrainSelectedInstOperands,
     /*  24123 */     // GIR_Coverage, 24155,
     /*  24123 */     GIR_EraseRootFromParent_Done,
     /*  24124 */   // Label 633: @24124
     /*  24124 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(24182), // Rule ID 5716 //
     /*  24129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24164 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  24167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24180 */     GIR_RootConstrainSelectedInstOperands,
     /*  24181 */     // GIR_Coverage, 5716,
     /*  24181 */     GIR_EraseRootFromParent_Done,
     /*  24182 */   // Label 634: @24182
     /*  24182 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(24205), // Rule ID 5713 //
     /*  24187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24198 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  24198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /*  24203 */     GIR_RootConstrainSelectedInstOperands,
     /*  24204 */     // GIR_Coverage, 5713,
     /*  24204 */     GIR_Done,
     /*  24205 */   // Label 635: @24205
     /*  24205 */   GIM_Reject,
     /*  24206 */ // Label 632: @24206
     /*  24206 */ GIM_Reject,
     /*  24207 */ // Label 464: @24207
     /*  24207 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(24366),
     /*  24212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24222 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(24282), // Rule ID 4433 //
     /*  24227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24255 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24261 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24269 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24280 */     GIR_RootConstrainSelectedInstOperands,
     /*  24281 */     // GIR_Coverage, 4433,
     /*  24281 */     GIR_EraseRootFromParent_Done,
     /*  24282 */   // Label 637: @24282
     /*  24282 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(24342), // Rule ID 23694 //
     /*  24287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24319 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24325 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24329 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24340 */     GIR_RootConstrainSelectedInstOperands,
     /*  24341 */     // GIR_Coverage, 23694,
     /*  24341 */     GIR_EraseRootFromParent_Done,
     /*  24342 */   // Label 638: @24342
     /*  24342 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(24365), // Rule ID 4417 //
     /*  24347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24358 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /*  24363 */     GIR_RootConstrainSelectedInstOperands,
     /*  24364 */     // GIR_Coverage, 4417,
     /*  24364 */     GIR_Done,
     /*  24365 */   // Label 639: @24365
     /*  24365 */   GIM_Reject,
     /*  24366 */ // Label 636: @24366
     /*  24366 */ GIM_Reject,
     /*  24367 */ // Label 465: @24367
     /*  24367 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(24832),
     /*  24372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  24375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  24378 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(24440), // Rule ID 25230 //
     /*  24383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24422 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24438 */     GIR_RootConstrainSelectedInstOperands,
     /*  24439 */     // GIR_Coverage, 25230,
     /*  24439 */     GIR_EraseRootFromParent_Done,
     /*  24440 */   // Label 641: @24440
     /*  24440 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(24502), // Rule ID 25239 //
     /*  24445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24484 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24500 */     GIR_RootConstrainSelectedInstOperands,
     /*  24501 */     // GIR_Coverage, 25239,
     /*  24501 */     GIR_EraseRootFromParent_Done,
     /*  24502 */   // Label 642: @24502
     /*  24502 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(24564), // Rule ID 25438 //
     /*  24507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24546 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24562 */     GIR_RootConstrainSelectedInstOperands,
     /*  24563 */     // GIR_Coverage, 25438,
     /*  24563 */     GIR_EraseRootFromParent_Done,
     /*  24564 */   // Label 643: @24564
     /*  24564 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(24626), // Rule ID 18102 //
     /*  24569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24608 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24624 */     GIR_RootConstrainSelectedInstOperands,
     /*  24625 */     // GIR_Coverage, 18102,
     /*  24625 */     GIR_EraseRootFromParent_Done,
     /*  24626 */   // Label 644: @24626
     /*  24626 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(24688), // Rule ID 18130 //
     /*  24631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24670 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24686 */     GIR_RootConstrainSelectedInstOperands,
     /*  24687 */     // GIR_Coverage, 18130,
     /*  24687 */     GIR_EraseRootFromParent_Done,
     /*  24688 */   // Label 645: @24688
     /*  24688 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(24750), // Rule ID 20040 //
     /*  24693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24732 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24748 */     GIR_RootConstrainSelectedInstOperands,
     /*  24749 */     // GIR_Coverage, 20040,
     /*  24749 */     GIR_EraseRootFromParent_Done,
     /*  24750 */   // Label 646: @24750
     /*  24750 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(24777), // Rule ID 18090 //
     /*  24755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24770 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24775 */     GIR_RootConstrainSelectedInstOperands,
     /*  24776 */     // GIR_Coverage, 18090,
     /*  24776 */     GIR_Done,
     /*  24777 */   // Label 647: @24777
     /*  24777 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(24804), // Rule ID 18114 //
     /*  24782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24797 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24802 */     GIR_RootConstrainSelectedInstOperands,
     /*  24803 */     // GIR_Coverage, 18114,
     /*  24803 */     GIR_Done,
     /*  24804 */   // Label 648: @24804
     /*  24804 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(24831), // Rule ID 20032 //
     /*  24809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24824 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  24824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24829 */     GIR_RootConstrainSelectedInstOperands,
     /*  24830 */     // GIR_Coverage, 20032,
     /*  24830 */     GIR_Done,
     /*  24831 */   // Label 649: @24831
     /*  24831 */   GIM_Reject,
     /*  24832 */ // Label 640: @24832
     /*  24832 */ GIM_Reject,
     /*  24833 */ // Label 466: @24833
     /*  24833 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(24988),
     /*  24838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  24841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  24844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24848 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(24906), // Rule ID 25445 //
     /*  24853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24888 */     // (and:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24904 */     GIR_RootConstrainSelectedInstOperands,
     /*  24905 */     // GIR_Coverage, 25445,
     /*  24905 */     GIR_EraseRootFromParent_Done,
     /*  24906 */   // Label 651: @24906
     /*  24906 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(24964), // Rule ID 20057 //
     /*  24911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24946 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24962 */     GIR_RootConstrainSelectedInstOperands,
     /*  24963 */     // GIR_Coverage, 20057,
     /*  24963 */     GIR_EraseRootFromParent_Done,
     /*  24964 */   // Label 652: @24964
     /*  24964 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(24987), // Rule ID 20049 //
     /*  24969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24980 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  24980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  24985 */     GIR_RootConstrainSelectedInstOperands,
     /*  24986 */     // GIR_Coverage, 20049,
     /*  24986 */     GIR_Done,
     /*  24987 */   // Label 653: @24987
     /*  24987 */   GIM_Reject,
     /*  24988 */ // Label 650: @24988
     /*  24988 */ GIM_Reject,
     /*  24989 */ // Label 467: @24989
     /*  24989 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(25148),
     /*  24994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25004 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(25064), // Rule ID 4434 //
     /*  25009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25037 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  25045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25051 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  25054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  25060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  25062 */     GIR_RootConstrainSelectedInstOperands,
     /*  25063 */     // GIR_Coverage, 4434,
     /*  25063 */     GIR_EraseRootFromParent_Done,
     /*  25064 */   // Label 655: @25064
     /*  25064 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(25124), // Rule ID 23695 //
     /*  25069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25101 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  25109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25111 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  25114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  25120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  25122 */     GIR_RootConstrainSelectedInstOperands,
     /*  25123 */     // GIR_Coverage, 23695,
     /*  25123 */     GIR_EraseRootFromParent_Done,
     /*  25124 */   // Label 656: @25124
     /*  25124 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(25147), // Rule ID 4418 //
     /*  25129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25140 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /*  25145 */     GIR_RootConstrainSelectedInstOperands,
     /*  25146 */     // GIR_Coverage, 4418,
     /*  25146 */     GIR_Done,
     /*  25147 */   // Label 657: @25147
     /*  25147 */   GIM_Reject,
     /*  25148 */ // Label 654: @25148
     /*  25148 */ GIM_Reject,
     /*  25149 */ // Label 468: @25149
     /*  25149 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(25304),
     /*  25154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  25157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  25160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25164 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(25222), // Rule ID 25444 //
     /*  25169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25204 */     // (and:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25220 */     GIR_RootConstrainSelectedInstOperands,
     /*  25221 */     // GIR_Coverage, 25444,
     /*  25221 */     GIR_EraseRootFromParent_Done,
     /*  25222 */   // Label 659: @25222
     /*  25222 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(25280), // Rule ID 20056 //
     /*  25227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25249 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25262 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25267 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25278 */     GIR_RootConstrainSelectedInstOperands,
     /*  25279 */     // GIR_Coverage, 20056,
     /*  25279 */     GIR_EraseRootFromParent_Done,
     /*  25280 */   // Label 660: @25280
     /*  25280 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(25303), // Rule ID 20048 //
     /*  25285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25296 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  25296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25301 */     GIR_RootConstrainSelectedInstOperands,
     /*  25302 */     // GIR_Coverage, 20048,
     /*  25302 */     GIR_Done,
     /*  25303 */   // Label 661: @25303
     /*  25303 */   GIM_Reject,
     /*  25304 */ // Label 658: @25304
     /*  25304 */ GIM_Reject,
     /*  25305 */ // Label 469: @25305
     /*  25305 */ GIM_Reject,
     /*  25306 */ // Label 4: @25306
     /*  25306 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 685*/ GIMT_Encode4(33709),
     /*  25317 */ /*GILLT_s1*//*Label 662*/ GIMT_Encode4(25417),
     /*  25321 */ /*GILLT_s8*//*Label 663*/ GIMT_Encode4(25517),
     /*  25325 */ /*GILLT_s16*//*Label 664*/ GIMT_Encode4(25910),
     /*  25329 */ /*GILLT_s32*//*Label 665*/ GIMT_Encode4(26507),
     /*  25333 */ /*GILLT_s64*//*Label 666*/ GIMT_Encode4(27963), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  25345 */ /*GILLT_v2s1*//*Label 667*/ GIMT_Encode4(29427),
     /*  25349 */ /*GILLT_v2s64*//*Label 668*/ GIMT_Encode4(29527),
     /*  25353 */ /*GILLT_v4s1*//*Label 669*/ GIMT_Encode4(29869),
     /*  25357 */ /*GILLT_v4s32*//*Label 670*/ GIMT_Encode4(29969),
     /*  25361 */ /*GILLT_v4s64*//*Label 671*/ GIMT_Encode4(30311),
     /*  25365 */ /*GILLT_v8s1*//*Label 672*/ GIMT_Encode4(30777),
     /*  25369 */ /*GILLT_v8s16*//*Label 673*/ GIMT_Encode4(30901),
     /*  25373 */ /*GILLT_v8s32*//*Label 674*/ GIMT_Encode4(31243),
     /*  25377 */ /*GILLT_v8s64*//*Label 675*/ GIMT_Encode4(31709),
     /*  25381 */ /*GILLT_v16s1*//*Label 676*/ GIMT_Encode4(31865),
     /*  25385 */ /*GILLT_v16s8*//*Label 677*/ GIMT_Encode4(31899),
     /*  25389 */ /*GILLT_v16s16*//*Label 678*/ GIMT_Encode4(32241),
     /*  25393 */ /*GILLT_v16s32*//*Label 679*/ GIMT_Encode4(32707),
     /*  25397 */ /*GILLT_v32s1*//*Label 680*/ GIMT_Encode4(32863),
     /*  25401 */ /*GILLT_v32s8*//*Label 681*/ GIMT_Encode4(32897),
     /*  25405 */ /*GILLT_v32s16*//*Label 682*/ GIMT_Encode4(33363),
     /*  25409 */ /*GILLT_v64s1*//*Label 683*/ GIMT_Encode4(33519),
     /*  25413 */ /*GILLT_v64s8*//*Label 684*/ GIMT_Encode4(33553),
     /*  25417 */ // Label 662: @25417
     /*  25417 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(25516), // Rule ID 19492 //
     /*  25422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  25425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  25428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25440 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  25440 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  25443 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25447 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25452 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  25456 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25461 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  25464 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25468 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25473 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  25477 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  25485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  25489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25497 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  25515 */   // GIR_Coverage, 19492,
     /*  25515 */   GIR_EraseRootFromParent_Done,
     /*  25516 */ // Label 686: @25516
     /*  25516 */ GIM_Reject,
     /*  25517 */ // Label 663: @25517
     /*  25517 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(25909),
     /*  25522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  25525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  25528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25532 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(25593), // Rule ID 26061 //
     /*  25537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25555 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25572 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25591 */     GIR_RootConstrainSelectedInstOperands,
     /*  25592 */     // GIR_Coverage, 26061,
     /*  25592 */     GIR_EraseRootFromParent_Done,
     /*  25593 */   // Label 688: @25593
     /*  25593 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(25654), // Rule ID 26080 //
     /*  25598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25616 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25633 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25638 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25652 */     GIR_RootConstrainSelectedInstOperands,
     /*  25653 */     // GIR_Coverage, 26080,
     /*  25653 */     GIR_EraseRootFromParent_Done,
     /*  25654 */   // Label 689: @25654
     /*  25654 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(25715), // Rule ID 22830 //
     /*  25659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25681 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25694 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25713 */     GIR_RootConstrainSelectedInstOperands,
     /*  25714 */     // GIR_Coverage, 22830,
     /*  25714 */     GIR_EraseRootFromParent_Done,
     /*  25715 */   // Label 690: @25715
     /*  25715 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(25776), // Rule ID 22920 //
     /*  25720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25742 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25755 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25762 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25774 */     GIR_RootConstrainSelectedInstOperands,
     /*  25775 */     // GIR_Coverage, 22920,
     /*  25775 */     GIR_EraseRootFromParent_Done,
     /*  25776 */   // Label 691: @25776
     /*  25776 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(25813), // Rule ID 22834 //
     /*  25781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25796 */     // MIs[1] Operand 1
     /*  25796 */     // No operand predicates
     /*  25796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25798 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /*  25801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25811 */     GIR_RootConstrainSelectedInstOperands,
     /*  25812 */     // GIR_Coverage, 22834,
     /*  25812 */     GIR_EraseRootFromParent_Done,
     /*  25813 */   // Label 692: @25813
     /*  25813 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(25850), // Rule ID 22924 //
     /*  25818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25833 */     // MIs[1] Operand 1
     /*  25833 */     // No operand predicates
     /*  25833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25835 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /*  25838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25848 */     GIR_RootConstrainSelectedInstOperands,
     /*  25849 */     // GIR_Coverage, 22924,
     /*  25849 */     GIR_EraseRootFromParent_Done,
     /*  25850 */   // Label 693: @25850
     /*  25850 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(25879), // Rule ID 22826 //
     /*  25855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25866 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /*  25871 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25877 */     GIR_RootConstrainSelectedInstOperands,
     /*  25878 */     // GIR_Coverage, 22826,
     /*  25878 */     GIR_Done,
     /*  25879 */   // Label 694: @25879
     /*  25879 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(25908), // Rule ID 22916 //
     /*  25884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25895 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /*  25900 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25906 */     GIR_RootConstrainSelectedInstOperands,
     /*  25907 */     // GIR_Coverage, 22916,
     /*  25907 */     GIR_Done,
     /*  25908 */   // Label 695: @25908
     /*  25908 */   GIM_Reject,
     /*  25909 */ // Label 687: @25909
     /*  25909 */ GIM_Reject,
     /*  25910 */ // Label 664: @25910
     /*  25910 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(26506),
     /*  25915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  25918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  25921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25925 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(25986), // Rule ID 26062 //
     /*  25930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25948 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25965 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25970 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25984 */     GIR_RootConstrainSelectedInstOperands,
     /*  25985 */     // GIR_Coverage, 26062,
     /*  25985 */     GIR_EraseRootFromParent_Done,
     /*  25986 */   // Label 697: @25986
     /*  25986 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(26047), // Rule ID 26081 //
     /*  25991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26009 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26026 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  26029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26045 */     GIR_RootConstrainSelectedInstOperands,
     /*  26046 */     // GIR_Coverage, 26081,
     /*  26046 */     GIR_EraseRootFromParent_Done,
     /*  26047 */   // Label 698: @26047
     /*  26047 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(26108), // Rule ID 22831 //
     /*  26052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26074 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26087 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  26090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26106 */     GIR_RootConstrainSelectedInstOperands,
     /*  26107 */     // GIR_Coverage, 22831,
     /*  26107 */     GIR_EraseRootFromParent_Done,
     /*  26108 */   // Label 699: @26108
     /*  26108 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(26169), // Rule ID 22921 //
     /*  26113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26135 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26148 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  26151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26167 */     GIR_RootConstrainSelectedInstOperands,
     /*  26168 */     // GIR_Coverage, 22921,
     /*  26168 */     GIR_EraseRootFromParent_Done,
     /*  26169 */   // Label 700: @26169
     /*  26169 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(26271), // Rule ID 26037 //
     /*  26174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26190 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26205 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26269 */     GIR_RootConstrainSelectedInstOperands,
     /*  26270 */     // GIR_Coverage, 26037,
     /*  26270 */     GIR_EraseRootFromParent_Done,
     /*  26271 */   // Label 701: @26271
     /*  26271 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(26373), // Rule ID 22775 //
     /*  26276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26307 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26371 */     GIR_RootConstrainSelectedInstOperands,
     /*  26372 */     // GIR_Coverage, 22775,
     /*  26372 */     GIR_EraseRootFromParent_Done,
     /*  26373 */   // Label 702: @26373
     /*  26373 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(26410), // Rule ID 22835 //
     /*  26378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26393 */     // MIs[1] Operand 1
     /*  26393 */     // No operand predicates
     /*  26393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26395 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /*  26398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26408 */     GIR_RootConstrainSelectedInstOperands,
     /*  26409 */     // GIR_Coverage, 22835,
     /*  26409 */     GIR_EraseRootFromParent_Done,
     /*  26410 */   // Label 703: @26410
     /*  26410 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(26447), // Rule ID 22925 //
     /*  26415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26430 */     // MIs[1] Operand 1
     /*  26430 */     // No operand predicates
     /*  26430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26432 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /*  26435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26445 */     GIR_RootConstrainSelectedInstOperands,
     /*  26446 */     // GIR_Coverage, 22925,
     /*  26446 */     GIR_EraseRootFromParent_Done,
     /*  26447 */   // Label 704: @26447
     /*  26447 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(26476), // Rule ID 22827 //
     /*  26452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26463 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /*  26468 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26474 */     GIR_RootConstrainSelectedInstOperands,
     /*  26475 */     // GIR_Coverage, 22827,
     /*  26475 */     GIR_Done,
     /*  26476 */   // Label 705: @26476
     /*  26476 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(26505), // Rule ID 22917 //
     /*  26481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26492 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /*  26497 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26503 */     GIR_RootConstrainSelectedInstOperands,
     /*  26504 */     // GIR_Coverage, 22917,
     /*  26504 */     GIR_Done,
     /*  26505 */   // Label 706: @26505
     /*  26505 */   GIM_Reject,
     /*  26506 */ // Label 696: @26506
     /*  26506 */ GIM_Reject,
     /*  26507 */ // Label 665: @26507
     /*  26507 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(27962),
     /*  26512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26515 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(26583), // Rule ID 26063 //
     /*  26520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26545 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26562 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26581 */     GIR_RootConstrainSelectedInstOperands,
     /*  26582 */     // GIR_Coverage, 26063,
     /*  26582 */     GIR_EraseRootFromParent_Done,
     /*  26583 */   // Label 708: @26583
     /*  26583 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(26651), // Rule ID 26082 //
     /*  26588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26609 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26613 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26630 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26649 */     GIR_RootConstrainSelectedInstOperands,
     /*  26650 */     // GIR_Coverage, 26082,
     /*  26650 */     GIR_EraseRootFromParent_Done,
     /*  26651 */   // Label 709: @26651
     /*  26651 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(26719), // Rule ID 22832 //
     /*  26656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26685 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26698 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26717 */     GIR_RootConstrainSelectedInstOperands,
     /*  26718 */     // GIR_Coverage, 22832,
     /*  26718 */     GIR_EraseRootFromParent_Done,
     /*  26719 */   // Label 710: @26719
     /*  26719 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(26787), // Rule ID 22922 //
     /*  26724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26753 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26766 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26771 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26785 */     GIR_RootConstrainSelectedInstOperands,
     /*  26786 */     // GIR_Coverage, 22922,
     /*  26786 */     GIR_EraseRootFromParent_Done,
     /*  26787 */   // Label 711: @26787
     /*  26787 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(26864), // Rule ID 25003 //
     /*  26792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26823 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26839 */     // MIs[2] src
     /*  26839 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26844 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26850 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26862 */     GIR_RootConstrainSelectedInstOperands,
     /*  26863 */     // GIR_Coverage, 25003,
     /*  26863 */     GIR_EraseRootFromParent_Done,
     /*  26864 */   // Label 712: @26864
     /*  26864 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(26941), // Rule ID 25005 //
     /*  26869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26900 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  26904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26916 */     // MIs[2] src
     /*  26916 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26927 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26939 */     GIR_RootConstrainSelectedInstOperands,
     /*  26940 */     // GIR_Coverage, 25005,
     /*  26940 */     GIR_EraseRootFromParent_Done,
     /*  26941 */   // Label 713: @26941
     /*  26941 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(27019), // Rule ID 24991 //
     /*  26946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26990 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26998 */     // MIs[0] src
     /*  26998 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27005 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  27014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27017 */     GIR_RootConstrainSelectedInstOperands,
     /*  27018 */     // GIR_Coverage, 24991,
     /*  27018 */     GIR_EraseRootFromParent_Done,
     /*  27019 */   // Label 714: @27019
     /*  27019 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(27096), // Rule ID 17364 //
     /*  27024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27055 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27071 */     // MIs[2] src
     /*  27071 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27076 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  27080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27082 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  27085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27094 */     GIR_RootConstrainSelectedInstOperands,
     /*  27095 */     // GIR_Coverage, 17364,
     /*  27095 */     GIR_EraseRootFromParent_Done,
     /*  27096 */   // Label 715: @27096
     /*  27096 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(27173), // Rule ID 17366 //
     /*  27101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27132 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27148 */     // MIs[2] src
     /*  27148 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27153 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27159 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  27162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27171 */     GIR_RootConstrainSelectedInstOperands,
     /*  27172 */     // GIR_Coverage, 17366,
     /*  27172 */     GIR_EraseRootFromParent_Done,
     /*  27173 */   // Label 716: @27173
     /*  27173 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(27247), // Rule ID 17352 //
     /*  27178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27220 */     // MIs[2] src
     /*  27220 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27225 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27235 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27245 */     GIR_RootConstrainSelectedInstOperands,
     /*  27246 */     // GIR_Coverage, 17352,
     /*  27246 */     GIR_EraseRootFromParent_Done,
     /*  27247 */   // Label 717: @27247
     /*  27247 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(27305), // Rule ID 24999 //
     /*  27252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27280 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27284 */     // MIs[0] src
     /*  27284 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27291 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27303 */     GIR_RootConstrainSelectedInstOperands,
     /*  27304 */     // GIR_Coverage, 24999,
     /*  27304 */     GIR_EraseRootFromParent_Done,
     /*  27305 */   // Label 718: @27305
     /*  27305 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(27363), // Rule ID 25001 //
     /*  27310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27338 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27342 */     // MIs[0] src
     /*  27342 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27349 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27361 */     GIR_RootConstrainSelectedInstOperands,
     /*  27362 */     // GIR_Coverage, 25001,
     /*  27362 */     GIR_EraseRootFromParent_Done,
     /*  27363 */   // Label 719: @27363
     /*  27363 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(27472), // Rule ID 26043 //
     /*  27368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27391 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27406 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27432 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27435 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27439 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27470 */     GIR_RootConstrainSelectedInstOperands,
     /*  27471 */     // GIR_Coverage, 26043,
     /*  27471 */     GIR_EraseRootFromParent_Done,
     /*  27472 */   // Label 720: @27472
     /*  27472 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(27530), // Rule ID 24993 //
     /*  27477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27500 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27509 */     // MIs[0] src
     /*  27509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27516 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  27525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27528 */     GIR_RootConstrainSelectedInstOperands,
     /*  27529 */     // GIR_Coverage, 24993,
     /*  27529 */     GIR_EraseRootFromParent_Done,
     /*  27530 */   // Label 721: @27530
     /*  27530 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(27584), // Rule ID 17360 //
     /*  27535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27561 */     // MIs[1] src
     /*  27561 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27566 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27572 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27577 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27582 */     GIR_RootConstrainSelectedInstOperands,
     /*  27583 */     // GIR_Coverage, 17360,
     /*  27583 */     GIR_EraseRootFromParent_Done,
     /*  27584 */   // Label 722: @27584
     /*  27584 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(27638), // Rule ID 17362 //
     /*  27589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27615 */     // MIs[1] src
     /*  27615 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27626 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27636 */     GIR_RootConstrainSelectedInstOperands,
     /*  27637 */     // GIR_Coverage, 17362,
     /*  27637 */     GIR_EraseRootFromParent_Done,
     /*  27638 */   // Label 723: @27638
     /*  27638 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(27747), // Rule ID 22781 //
     /*  27643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27670 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27681 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27707 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27745 */     GIR_RootConstrainSelectedInstOperands,
     /*  27746 */     // GIR_Coverage, 22781,
     /*  27746 */     GIR_EraseRootFromParent_Done,
     /*  27747 */   // Label 724: @27747
     /*  27747 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(27801), // Rule ID 17354 //
     /*  27752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27778 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27782 */     // MIs[1] src
     /*  27782 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27789 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27799 */     GIR_RootConstrainSelectedInstOperands,
     /*  27800 */     // GIR_Coverage, 17354,
     /*  27800 */     GIR_EraseRootFromParent_Done,
     /*  27801 */   // Label 725: @27801
     /*  27801 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(27845), // Rule ID 22836 //
     /*  27806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27828 */     // MIs[1] Operand 1
     /*  27828 */     // No operand predicates
     /*  27828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27830 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /*  27833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27835 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27843 */     GIR_RootConstrainSelectedInstOperands,
     /*  27844 */     // GIR_Coverage, 22836,
     /*  27844 */     GIR_EraseRootFromParent_Done,
     /*  27845 */   // Label 726: @27845
     /*  27845 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(27889), // Rule ID 22926 //
     /*  27850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27872 */     // MIs[1] Operand 1
     /*  27872 */     // No operand predicates
     /*  27872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27874 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /*  27877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27887 */     GIR_RootConstrainSelectedInstOperands,
     /*  27888 */     // GIR_Coverage, 22926,
     /*  27888 */     GIR_EraseRootFromParent_Done,
     /*  27889 */   // Label 727: @27889
     /*  27889 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(27925), // Rule ID 22828 //
     /*  27894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27912 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /*  27917 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27923 */     GIR_RootConstrainSelectedInstOperands,
     /*  27924 */     // GIR_Coverage, 22828,
     /*  27924 */     GIR_Done,
     /*  27925 */   // Label 728: @27925
     /*  27925 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(27961), // Rule ID 22918 //
     /*  27930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27948 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /*  27953 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27959 */     GIR_RootConstrainSelectedInstOperands,
     /*  27960 */     // GIR_Coverage, 22918,
     /*  27960 */     GIR_Done,
     /*  27961 */   // Label 729: @27961
     /*  27961 */   GIM_Reject,
     /*  27962 */ // Label 707: @27962
     /*  27962 */ GIM_Reject,
     /*  27963 */ // Label 666: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(29426),
     /*  27968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27971 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(28039), // Rule ID 26064 //
     /*  27976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28018 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  28021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28037 */     GIR_RootConstrainSelectedInstOperands,
     /*  28038 */     // GIR_Coverage, 26064,
     /*  28038 */     GIR_EraseRootFromParent_Done,
     /*  28039 */   // Label 731: @28039
     /*  28039 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(28107), // Rule ID 26083 //
     /*  28044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  28047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28086 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28105 */     GIR_RootConstrainSelectedInstOperands,
     /*  28106 */     // GIR_Coverage, 26083,
     /*  28106 */     GIR_EraseRootFromParent_Done,
     /*  28107 */   // Label 732: @28107
     /*  28107 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(28175), // Rule ID 22833 //
     /*  28112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  28115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28154 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  28157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28159 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28173 */     GIR_RootConstrainSelectedInstOperands,
     /*  28174 */     // GIR_Coverage, 22833,
     /*  28174 */     GIR_EraseRootFromParent_Done,
     /*  28175 */   // Label 733: @28175
     /*  28175 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(28243), // Rule ID 22923 //
     /*  28180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  28183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28222 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28241 */     GIR_RootConstrainSelectedInstOperands,
     /*  28242 */     // GIR_Coverage, 22923,
     /*  28242 */     GIR_EraseRootFromParent_Done,
     /*  28243 */   // Label 734: @28243
     /*  28243 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(28320), // Rule ID 25004 //
     /*  28248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28279 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28295 */     // MIs[2] src
     /*  28295 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28300 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28306 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28318 */     GIR_RootConstrainSelectedInstOperands,
     /*  28319 */     // GIR_Coverage, 25004,
     /*  28319 */     GIR_EraseRootFromParent_Done,
     /*  28320 */   // Label 735: @28320
     /*  28320 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(28397), // Rule ID 25006 //
     /*  28325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28356 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28372 */     // MIs[2] src
     /*  28372 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28377 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28383 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28395 */     GIR_RootConstrainSelectedInstOperands,
     /*  28396 */     // GIR_Coverage, 25006,
     /*  28396 */     GIR_EraseRootFromParent_Done,
     /*  28397 */   // Label 736: @28397
     /*  28397 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(28475), // Rule ID 24992 //
     /*  28402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  28437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28446 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28450 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28454 */     // MIs[0] src
     /*  28454 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  28459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28461 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  28470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28473 */     GIR_RootConstrainSelectedInstOperands,
     /*  28474 */     // GIR_Coverage, 24992,
     /*  28474 */     GIR_EraseRootFromParent_Done,
     /*  28475 */   // Label 737: @28475
     /*  28475 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(28552), // Rule ID 17365 //
     /*  28480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28527 */     // MIs[2] src
     /*  28527 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28532 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28538 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28550 */     GIR_RootConstrainSelectedInstOperands,
     /*  28551 */     // GIR_Coverage, 17365,
     /*  28551 */     GIR_EraseRootFromParent_Done,
     /*  28552 */   // Label 738: @28552
     /*  28552 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(28629), // Rule ID 17367 //
     /*  28557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28588 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28604 */     // MIs[2] src
     /*  28604 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28609 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28615 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28627 */     GIR_RootConstrainSelectedInstOperands,
     /*  28628 */     // GIR_Coverage, 17367,
     /*  28628 */     GIR_EraseRootFromParent_Done,
     /*  28629 */   // Label 739: @28629
     /*  28629 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(28703), // Rule ID 17353 //
     /*  28634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28676 */     // MIs[2] src
     /*  28676 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28681 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28691 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28701 */     GIR_RootConstrainSelectedInstOperands,
     /*  28702 */     // GIR_Coverage, 17353,
     /*  28702 */     GIR_EraseRootFromParent_Done,
     /*  28703 */   // Label 740: @28703
     /*  28703 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(28761), // Rule ID 25000 //
     /*  28708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28740 */     // MIs[0] src
     /*  28740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28747 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28759 */     GIR_RootConstrainSelectedInstOperands,
     /*  28760 */     // GIR_Coverage, 25000,
     /*  28760 */     GIR_EraseRootFromParent_Done,
     /*  28761 */   // Label 741: @28761
     /*  28761 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(28819), // Rule ID 25002 //
     /*  28766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28798 */     // MIs[0] src
     /*  28798 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28805 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28817 */     GIR_RootConstrainSelectedInstOperands,
     /*  28818 */     // GIR_Coverage, 25002,
     /*  28818 */     GIR_EraseRootFromParent_Done,
     /*  28819 */   // Label 742: @28819
     /*  28819 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(28928), // Rule ID 26049 //
     /*  28824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28847 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28862 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28888 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28891 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28926 */     GIR_RootConstrainSelectedInstOperands,
     /*  28927 */     // GIR_Coverage, 26049,
     /*  28927 */     GIR_EraseRootFromParent_Done,
     /*  28928 */   // Label 743: @28928
     /*  28928 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(28986), // Rule ID 24994 //
     /*  28933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  28948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  28960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28965 */     // MIs[0] src
     /*  28965 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  28970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28972 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  28981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28984 */     GIR_RootConstrainSelectedInstOperands,
     /*  28985 */     // GIR_Coverage, 24994,
     /*  28985 */     GIR_EraseRootFromParent_Done,
     /*  28986 */   // Label 744: @28986
     /*  28986 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(29040), // Rule ID 17361 //
     /*  28991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  29017 */     // MIs[1] src
     /*  29017 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29022 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  29026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29028 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  29031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29038 */     GIR_RootConstrainSelectedInstOperands,
     /*  29039 */     // GIR_Coverage, 17361,
     /*  29039 */     GIR_EraseRootFromParent_Done,
     /*  29040 */   // Label 745: @29040
     /*  29040 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(29094), // Rule ID 17363 //
     /*  29045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  29071 */     // MIs[1] src
     /*  29071 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29082 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29092 */     GIR_RootConstrainSelectedInstOperands,
     /*  29093 */     // GIR_Coverage, 17363,
     /*  29093 */     GIR_EraseRootFromParent_Done,
     /*  29094 */   // Label 746: @29094
     /*  29094 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(29203), // Rule ID 22787 //
     /*  29099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  29118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  29126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  29130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  29135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29137 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  29137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  29140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  29151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  29154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  29158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  29170 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  29173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  29178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  29183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  29188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  29191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29201 */     GIR_RootConstrainSelectedInstOperands,
     /*  29202 */     // GIR_Coverage, 22787,
     /*  29202 */     GIR_EraseRootFromParent_Done,
     /*  29203 */   // Label 747: @29203
     /*  29203 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(29257), // Rule ID 17355 //
     /*  29208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  29230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  29238 */     // MIs[1] src
     /*  29238 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29245 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  29248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29255 */     GIR_RootConstrainSelectedInstOperands,
     /*  29256 */     // GIR_Coverage, 17355,
     /*  29256 */     GIR_EraseRootFromParent_Done,
     /*  29257 */   // Label 748: @29257
     /*  29257 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(29305), // Rule ID 22837 //
     /*  29262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29288 */     // MIs[1] Operand 1
     /*  29288 */     // No operand predicates
     /*  29288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29290 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /*  29293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29303 */     GIR_RootConstrainSelectedInstOperands,
     /*  29304 */     // GIR_Coverage, 22837,
     /*  29304 */     GIR_EraseRootFromParent_Done,
     /*  29305 */   // Label 749: @29305
     /*  29305 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(29353), // Rule ID 22927 //
     /*  29310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29336 */     // MIs[1] Operand 1
     /*  29336 */     // No operand predicates
     /*  29336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29338 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /*  29341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29351 */     GIR_RootConstrainSelectedInstOperands,
     /*  29352 */     // GIR_Coverage, 22927,
     /*  29352 */     GIR_EraseRootFromParent_Done,
     /*  29353 */   // Label 750: @29353
     /*  29353 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(29389), // Rule ID 22829 //
     /*  29358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29376 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /*  29381 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29387 */     GIR_RootConstrainSelectedInstOperands,
     /*  29388 */     // GIR_Coverage, 22829,
     /*  29388 */     GIR_Done,
     /*  29389 */   // Label 751: @29389
     /*  29389 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(29425), // Rule ID 22919 //
     /*  29394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29412 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /*  29417 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29423 */     GIR_RootConstrainSelectedInstOperands,
     /*  29424 */     // GIR_Coverage, 22919,
     /*  29424 */     GIR_Done,
     /*  29425 */   // Label 752: @29425
     /*  29425 */   GIM_Reject,
     /*  29426 */ // Label 730: @29426
     /*  29426 */ GIM_Reject,
     /*  29427 */ // Label 667: @29427
     /*  29427 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(29526), // Rule ID 19493 //
     /*  29432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  29435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  29438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29450 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  29450 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29453 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29457 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29462 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29466 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29471 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29474 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29478 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29483 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29487 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29507 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  29525 */   // GIR_Coverage, 19493,
     /*  29525 */   GIR_EraseRootFromParent_Done,
     /*  29526 */ // Label 753: @29526
     /*  29526 */ GIM_Reject,
     /*  29527 */ // Label 668: @29527
     /*  29527 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(29868),
     /*  29532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  29538 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(29600), // Rule ID 23363 //
     /*  29543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29582 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29587 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29598 */     GIR_RootConstrainSelectedInstOperands,
     /*  29599 */     // GIR_Coverage, 23363,
     /*  29599 */     GIR_EraseRootFromParent_Done,
     /*  29600 */   // Label 755: @29600
     /*  29600 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(29662), // Rule ID 24185 //
     /*  29605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29644 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29660 */     GIR_RootConstrainSelectedInstOperands,
     /*  29661 */     // GIR_Coverage, 24185,
     /*  29661 */     GIR_EraseRootFromParent_Done,
     /*  29662 */   // Label 756: @29662
     /*  29662 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(29724), // Rule ID 2117 //
     /*  29667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29689 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29693 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29706 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29711 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29722 */     GIR_RootConstrainSelectedInstOperands,
     /*  29723 */     // GIR_Coverage, 2117,
     /*  29723 */     GIR_EraseRootFromParent_Done,
     /*  29724 */   // Label 757: @29724
     /*  29724 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(29786), // Rule ID 5761 //
     /*  29729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29748 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29755 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29768 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29784 */     GIR_RootConstrainSelectedInstOperands,
     /*  29785 */     // GIR_Coverage, 5761,
     /*  29785 */     GIR_EraseRootFromParent_Done,
     /*  29786 */   // Label 758: @29786
     /*  29786 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(29813), // Rule ID 2116 //
     /*  29791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29806 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  29811 */     GIR_RootConstrainSelectedInstOperands,
     /*  29812 */     // GIR_Coverage, 2116,
     /*  29812 */     GIR_Done,
     /*  29813 */   // Label 759: @29813
     /*  29813 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(29840), // Rule ID 2118 //
     /*  29818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  29821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29833 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  29838 */     GIR_RootConstrainSelectedInstOperands,
     /*  29839 */     // GIR_Coverage, 2118,
     /*  29839 */     GIR_Done,
     /*  29840 */   // Label 760: @29840
     /*  29840 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(29867), // Rule ID 5758 //
     /*  29845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29860 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  29860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  29865 */     GIR_RootConstrainSelectedInstOperands,
     /*  29866 */     // GIR_Coverage, 5758,
     /*  29866 */     GIR_Done,
     /*  29867 */   // Label 761: @29867
     /*  29867 */   GIM_Reject,
     /*  29868 */ // Label 754: @29868
     /*  29868 */ GIM_Reject,
     /*  29869 */ // Label 669: @29869
     /*  29869 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(29968), // Rule ID 19494 //
     /*  29874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  29877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  29880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29892 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  29892 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29895 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29899 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29904 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29908 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29925 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29929 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29946 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29949 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  29967 */   // GIR_Coverage, 19494,
     /*  29967 */   GIR_EraseRootFromParent_Done,
     /*  29968 */ // Label 762: @29968
     /*  29968 */ GIM_Reject,
     /*  29969 */ // Label 670: @29969
     /*  29969 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(30310),
     /*  29974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29980 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(30042), // Rule ID 24203 //
     /*  29985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30000 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30007 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30024 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  30027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30029 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30031 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30040 */     GIR_RootConstrainSelectedInstOperands,
     /*  30041 */     // GIR_Coverage, 24203,
     /*  30041 */     GIR_EraseRootFromParent_Done,
     /*  30042 */   // Label 764: @30042
     /*  30042 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(30104), // Rule ID 25256 //
     /*  30047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30086 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30102 */     GIR_RootConstrainSelectedInstOperands,
     /*  30103 */     // GIR_Coverage, 25256,
     /*  30103 */     GIR_EraseRootFromParent_Done,
     /*  30104 */   // Label 765: @30104
     /*  30104 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(30166), // Rule ID 5788 //
     /*  30109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30148 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  30151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30164 */     GIR_RootConstrainSelectedInstOperands,
     /*  30165 */     // GIR_Coverage, 5788,
     /*  30165 */     GIR_EraseRootFromParent_Done,
     /*  30166 */   // Label 766: @30166
     /*  30166 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(30228), // Rule ID 18163 //
     /*  30171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30210 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30226 */     GIR_RootConstrainSelectedInstOperands,
     /*  30227 */     // GIR_Coverage, 18163,
     /*  30227 */     GIR_EraseRootFromParent_Done,
     /*  30228 */   // Label 767: @30228
     /*  30228 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(30255), // Rule ID 5785 //
     /*  30233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30248 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  30248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /*  30253 */     GIR_RootConstrainSelectedInstOperands,
     /*  30254 */     // GIR_Coverage, 5785,
     /*  30254 */     GIR_Done,
     /*  30255 */   // Label 768: @30255
     /*  30255 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(30282), // Rule ID 18151 //
     /*  30260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30275 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30280 */     GIR_RootConstrainSelectedInstOperands,
     /*  30281 */     // GIR_Coverage, 18151,
     /*  30281 */     GIR_Done,
     /*  30282 */   // Label 769: @30282
     /*  30282 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(30309), // Rule ID 18175 //
     /*  30287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30302 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30307 */     GIR_RootConstrainSelectedInstOperands,
     /*  30308 */     // GIR_Coverage, 18175,
     /*  30308 */     GIR_Done,
     /*  30309 */   // Label 770: @30309
     /*  30309 */   GIM_Reject,
     /*  30310 */ // Label 763: @30310
     /*  30310 */ GIM_Reject,
     /*  30311 */ // Label 671: @30311
     /*  30311 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(30776),
     /*  30316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  30319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  30322 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(30384), // Rule ID 23365 //
     /*  30327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30366 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30382 */     GIR_RootConstrainSelectedInstOperands,
     /*  30383 */     // GIR_Coverage, 23365,
     /*  30383 */     GIR_EraseRootFromParent_Done,
     /*  30384 */   // Label 772: @30384
     /*  30384 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(30446), // Rule ID 24179 //
     /*  30389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30428 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30444 */     GIR_RootConstrainSelectedInstOperands,
     /*  30445 */     // GIR_Coverage, 24179,
     /*  30445 */     GIR_EraseRootFromParent_Done,
     /*  30446 */   // Label 773: @30446
     /*  30446 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(30508), // Rule ID 25246 //
     /*  30451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30490 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30506 */     GIR_RootConstrainSelectedInstOperands,
     /*  30507 */     // GIR_Coverage, 25246,
     /*  30507 */     GIR_EraseRootFromParent_Done,
     /*  30508 */   // Label 774: @30508
     /*  30508 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(30570), // Rule ID 2121 //
     /*  30513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30552 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30568 */     GIR_RootConstrainSelectedInstOperands,
     /*  30569 */     // GIR_Coverage, 2121,
     /*  30569 */     GIR_EraseRootFromParent_Done,
     /*  30570 */   // Label 775: @30570
     /*  30570 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(30632), // Rule ID 5752 //
     /*  30575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30594 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30614 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30630 */     GIR_RootConstrainSelectedInstOperands,
     /*  30631 */     // GIR_Coverage, 5752,
     /*  30631 */     GIR_EraseRootFromParent_Done,
     /*  30632 */   // Label 776: @30632
     /*  30632 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(30694), // Rule ID 18137 //
     /*  30637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30676 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30692 */     GIR_RootConstrainSelectedInstOperands,
     /*  30693 */     // GIR_Coverage, 18137,
     /*  30693 */     GIR_EraseRootFromParent_Done,
     /*  30694 */   // Label 777: @30694
     /*  30694 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(30721), // Rule ID 2120 //
     /*  30699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30714 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  30719 */     GIR_RootConstrainSelectedInstOperands,
     /*  30720 */     // GIR_Coverage, 2120,
     /*  30720 */     GIR_Done,
     /*  30721 */   // Label 778: @30721
     /*  30721 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(30748), // Rule ID 5749 //
     /*  30726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30741 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  30741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  30746 */     GIR_RootConstrainSelectedInstOperands,
     /*  30747 */     // GIR_Coverage, 5749,
     /*  30747 */     GIR_Done,
     /*  30748 */   // Label 779: @30748
     /*  30748 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(30775), // Rule ID 18121 //
     /*  30753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30768 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  30773 */     GIR_RootConstrainSelectedInstOperands,
     /*  30774 */     // GIR_Coverage, 18121,
     /*  30774 */     GIR_Done,
     /*  30775 */   // Label 780: @30775
     /*  30775 */   GIM_Reject,
     /*  30776 */ // Label 771: @30776
     /*  30776 */ GIM_Reject,
     /*  30777 */ // Label 672: @30777
     /*  30777 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(30900),
     /*  30782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  30785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  30788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30800 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(30815), // Rule ID 4419 //
     /*  30805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  30808 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  30808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /*  30813 */     GIR_RootConstrainSelectedInstOperands,
     /*  30814 */     // GIR_Coverage, 4419,
     /*  30814 */     GIR_Done,
     /*  30815 */   // Label 782: @30815
     /*  30815 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(30899), // Rule ID 19491 //
     /*  30820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  30823 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  30823 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  30826 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30830 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30835 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  30839 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  30847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30856 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  30860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  30868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  30872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30877 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  30880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  30883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  30898 */     // GIR_Coverage, 19491,
     /*  30898 */     GIR_EraseRootFromParent_Done,
     /*  30899 */   // Label 783: @30899
     /*  30899 */   GIM_Reject,
     /*  30900 */ // Label 781: @30900
     /*  30900 */ GIM_Reject,
     /*  30901 */ // Label 673: @30901
     /*  30901 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(31242),
     /*  30906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30912 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(30974), // Rule ID 25255 //
     /*  30917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30956 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30972 */     GIR_RootConstrainSelectedInstOperands,
     /*  30973 */     // GIR_Coverage, 25255,
     /*  30973 */     GIR_EraseRootFromParent_Done,
     /*  30974 */   // Label 785: @30974
     /*  30974 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(31036), // Rule ID 25435 //
     /*  30979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31018 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31034 */     GIR_RootConstrainSelectedInstOperands,
     /*  31035 */     // GIR_Coverage, 25435,
     /*  31035 */     GIR_EraseRootFromParent_Done,
     /*  31036 */   // Label 786: @31036
     /*  31036 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(31098), // Rule ID 18162 //
     /*  31041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31080 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31096 */     GIR_RootConstrainSelectedInstOperands,
     /*  31097 */     // GIR_Coverage, 18162,
     /*  31097 */     GIR_EraseRootFromParent_Done,
     /*  31098 */   // Label 787: @31098
     /*  31098 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(31160), // Rule ID 20027 //
     /*  31103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31142 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31158 */     GIR_RootConstrainSelectedInstOperands,
     /*  31159 */     // GIR_Coverage, 20027,
     /*  31159 */     GIR_EraseRootFromParent_Done,
     /*  31160 */   // Label 788: @31160
     /*  31160 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(31187), // Rule ID 18150 //
     /*  31165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31180 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  31185 */     GIR_RootConstrainSelectedInstOperands,
     /*  31186 */     // GIR_Coverage, 18150,
     /*  31186 */     GIR_Done,
     /*  31187 */   // Label 789: @31187
     /*  31187 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(31214), // Rule ID 18174 //
     /*  31192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  31195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31207 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  31212 */     GIR_RootConstrainSelectedInstOperands,
     /*  31213 */     // GIR_Coverage, 18174,
     /*  31213 */     GIR_Done,
     /*  31214 */   // Label 790: @31214
     /*  31214 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(31241), // Rule ID 20019 //
     /*  31219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31234 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  31234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  31239 */     GIR_RootConstrainSelectedInstOperands,
     /*  31240 */     // GIR_Coverage, 20019,
     /*  31240 */     GIR_Done,
     /*  31241 */   // Label 791: @31241
     /*  31241 */   GIM_Reject,
     /*  31242 */ // Label 784: @31242
     /*  31242 */ GIM_Reject,
     /*  31243 */ // Label 674: @31243
     /*  31243 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(31708),
     /*  31248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  31251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  31254 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(31316), // Rule ID 24197 //
     /*  31259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31298 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31314 */     GIR_RootConstrainSelectedInstOperands,
     /*  31315 */     // GIR_Coverage, 24197,
     /*  31315 */     GIR_EraseRootFromParent_Done,
     /*  31316 */   // Label 793: @31316
     /*  31316 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(31378), // Rule ID 25235 //
     /*  31321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31360 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31376 */     GIR_RootConstrainSelectedInstOperands,
     /*  31377 */     // GIR_Coverage, 25235,
     /*  31377 */     GIR_EraseRootFromParent_Done,
     /*  31378 */   // Label 794: @31378
     /*  31378 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(31440), // Rule ID 25245 //
     /*  31383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31422 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31438 */     GIR_RootConstrainSelectedInstOperands,
     /*  31439 */     // GIR_Coverage, 25245,
     /*  31439 */     GIR_EraseRootFromParent_Done,
     /*  31440 */   // Label 795: @31440
     /*  31440 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(31502), // Rule ID 5779 //
     /*  31445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31484 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31500 */     GIR_RootConstrainSelectedInstOperands,
     /*  31501 */     // GIR_Coverage, 5779,
     /*  31501 */     GIR_EraseRootFromParent_Done,
     /*  31502 */   // Label 796: @31502
     /*  31502 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(31564), // Rule ID 18107 //
     /*  31507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31526 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31546 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31562 */     GIR_RootConstrainSelectedInstOperands,
     /*  31563 */     // GIR_Coverage, 18107,
     /*  31563 */     GIR_EraseRootFromParent_Done,
     /*  31564 */   // Label 797: @31564
     /*  31564 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(31626), // Rule ID 18136 //
     /*  31569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31608 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31624 */     GIR_RootConstrainSelectedInstOperands,
     /*  31625 */     // GIR_Coverage, 18136,
     /*  31625 */     GIR_EraseRootFromParent_Done,
     /*  31626 */   // Label 798: @31626
     /*  31626 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(31653), // Rule ID 5776 //
     /*  31631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31646 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  31646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /*  31651 */     GIR_RootConstrainSelectedInstOperands,
     /*  31652 */     // GIR_Coverage, 5776,
     /*  31652 */     GIR_Done,
     /*  31653 */   // Label 799: @31653
     /*  31653 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(31680), // Rule ID 18095 //
     /*  31658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31673 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  31678 */     GIR_RootConstrainSelectedInstOperands,
     /*  31679 */     // GIR_Coverage, 18095,
     /*  31679 */     GIR_Done,
     /*  31680 */   // Label 800: @31680
     /*  31680 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(31707), // Rule ID 18120 //
     /*  31685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31700 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  31705 */     GIR_RootConstrainSelectedInstOperands,
     /*  31706 */     // GIR_Coverage, 18120,
     /*  31706 */     GIR_Done,
     /*  31707 */   // Label 801: @31707
     /*  31707 */   GIM_Reject,
     /*  31708 */ // Label 792: @31708
     /*  31708 */ GIM_Reject,
     /*  31709 */ // Label 675: @31709
     /*  31709 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(31864),
     /*  31714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  31717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  31720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31724 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(31782), // Rule ID 24173 //
     /*  31729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31764 */     // (or:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31780 */     GIR_RootConstrainSelectedInstOperands,
     /*  31781 */     // GIR_Coverage, 24173,
     /*  31781 */     GIR_EraseRootFromParent_Done,
     /*  31782 */   // Label 803: @31782
     /*  31782 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(31840), // Rule ID 5743 //
     /*  31787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31802 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31805 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31809 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31822 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31838 */     GIR_RootConstrainSelectedInstOperands,
     /*  31839 */     // GIR_Coverage, 5743,
     /*  31839 */     GIR_EraseRootFromParent_Done,
     /*  31840 */   // Label 804: @31840
     /*  31840 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(31863), // Rule ID 5740 //
     /*  31845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31856 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  31856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  31861 */     GIR_RootConstrainSelectedInstOperands,
     /*  31862 */     // GIR_Coverage, 5740,
     /*  31862 */     GIR_Done,
     /*  31863 */   // Label 805: @31863
     /*  31863 */   GIM_Reject,
     /*  31864 */ // Label 802: @31864
     /*  31864 */ GIM_Reject,
     /*  31865 */ // Label 676: @31865
     /*  31865 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(31898), // Rule ID 4420 //
     /*  31870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  31876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  31879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31891 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  31891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  31896 */   GIR_RootConstrainSelectedInstOperands,
     /*  31897 */   // GIR_Coverage, 4420,
     /*  31897 */   GIR_Done,
     /*  31898 */ // Label 806: @31898
     /*  31898 */ GIM_Reject,
     /*  31899 */ // Label 677: @31899
     /*  31899 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(32240),
     /*  31904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31910 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(31972), // Rule ID 25254 //
     /*  31915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31954 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31970 */     GIR_RootConstrainSelectedInstOperands,
     /*  31971 */     // GIR_Coverage, 25254,
     /*  31971 */     GIR_EraseRootFromParent_Done,
     /*  31972 */   // Label 808: @31972
     /*  31972 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(32034), // Rule ID 25434 //
     /*  31977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32016 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  32019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32032 */     GIR_RootConstrainSelectedInstOperands,
     /*  32033 */     // GIR_Coverage, 25434,
     /*  32033 */     GIR_EraseRootFromParent_Done,
     /*  32034 */   // Label 809: @32034
     /*  32034 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(32096), // Rule ID 18161 //
     /*  32039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  32042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32078 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  32081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32094 */     GIR_RootConstrainSelectedInstOperands,
     /*  32095 */     // GIR_Coverage, 18161,
     /*  32095 */     GIR_EraseRootFromParent_Done,
     /*  32096 */   // Label 810: @32096
     /*  32096 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(32158), // Rule ID 20026 //
     /*  32101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32140 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  32143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32156 */     GIR_RootConstrainSelectedInstOperands,
     /*  32157 */     // GIR_Coverage, 20026,
     /*  32157 */     GIR_EraseRootFromParent_Done,
     /*  32158 */   // Label 811: @32158
     /*  32158 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(32185), // Rule ID 18149 //
     /*  32163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  32166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32178 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  32183 */     GIR_RootConstrainSelectedInstOperands,
     /*  32184 */     // GIR_Coverage, 18149,
     /*  32184 */     GIR_Done,
     /*  32185 */   // Label 812: @32185
     /*  32185 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(32212), // Rule ID 18173 //
     /*  32190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  32193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32205 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  32210 */     GIR_RootConstrainSelectedInstOperands,
     /*  32211 */     // GIR_Coverage, 18173,
     /*  32211 */     GIR_Done,
     /*  32212 */   // Label 813: @32212
     /*  32212 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(32239), // Rule ID 20018 //
     /*  32217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32232 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  32232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  32237 */     GIR_RootConstrainSelectedInstOperands,
     /*  32238 */     // GIR_Coverage, 20018,
     /*  32238 */     GIR_Done,
     /*  32239 */   // Label 814: @32239
     /*  32239 */   GIM_Reject,
     /*  32240 */ // Label 807: @32240
     /*  32240 */ GIM_Reject,
     /*  32241 */ // Label 678: @32241
     /*  32241 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(32706),
     /*  32246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  32249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  32252 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(32314), // Rule ID 25234 //
     /*  32257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32296 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32301 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32312 */     GIR_RootConstrainSelectedInstOperands,
     /*  32313 */     // GIR_Coverage, 25234,
     /*  32313 */     GIR_EraseRootFromParent_Done,
     /*  32314 */   // Label 816: @32314
     /*  32314 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(32376), // Rule ID 25244 //
     /*  32319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32358 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32374 */     GIR_RootConstrainSelectedInstOperands,
     /*  32375 */     // GIR_Coverage, 25244,
     /*  32375 */     GIR_EraseRootFromParent_Done,
     /*  32376 */   // Label 817: @32376
     /*  32376 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(32438), // Rule ID 25441 //
     /*  32381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32420 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32436 */     GIR_RootConstrainSelectedInstOperands,
     /*  32437 */     // GIR_Coverage, 25441,
     /*  32437 */     GIR_EraseRootFromParent_Done,
     /*  32438 */   // Label 818: @32438
     /*  32438 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(32500), // Rule ID 18106 //
     /*  32443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32482 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32498 */     GIR_RootConstrainSelectedInstOperands,
     /*  32499 */     // GIR_Coverage, 18106,
     /*  32499 */     GIR_EraseRootFromParent_Done,
     /*  32500 */   // Label 819: @32500
     /*  32500 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(32562), // Rule ID 18135 //
     /*  32505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32544 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32560 */     GIR_RootConstrainSelectedInstOperands,
     /*  32561 */     // GIR_Coverage, 18135,
     /*  32561 */     GIR_EraseRootFromParent_Done,
     /*  32562 */   // Label 820: @32562
     /*  32562 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(32624), // Rule ID 20043 //
     /*  32567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32606 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32622 */     GIR_RootConstrainSelectedInstOperands,
     /*  32623 */     // GIR_Coverage, 20043,
     /*  32623 */     GIR_EraseRootFromParent_Done,
     /*  32624 */   // Label 821: @32624
     /*  32624 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(32651), // Rule ID 18094 //
     /*  32629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32644 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  32649 */     GIR_RootConstrainSelectedInstOperands,
     /*  32650 */     // GIR_Coverage, 18094,
     /*  32650 */     GIR_Done,
     /*  32651 */   // Label 822: @32651
     /*  32651 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(32678), // Rule ID 18119 //
     /*  32656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32671 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  32676 */     GIR_RootConstrainSelectedInstOperands,
     /*  32677 */     // GIR_Coverage, 18119,
     /*  32677 */     GIR_Done,
     /*  32678 */   // Label 823: @32678
     /*  32678 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(32705), // Rule ID 20035 //
     /*  32683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32698 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  32698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  32703 */     GIR_RootConstrainSelectedInstOperands,
     /*  32704 */     // GIR_Coverage, 20035,
     /*  32704 */     GIR_Done,
     /*  32705 */   // Label 824: @32705
     /*  32705 */   GIM_Reject,
     /*  32706 */ // Label 815: @32706
     /*  32706 */ GIM_Reject,
     /*  32707 */ // Label 679: @32707
     /*  32707 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(32862),
     /*  32712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  32715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  32718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32722 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(32780), // Rule ID 24191 //
     /*  32727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32762 */     // (or:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32778 */     GIR_RootConstrainSelectedInstOperands,
     /*  32779 */     // GIR_Coverage, 24191,
     /*  32779 */     GIR_EraseRootFromParent_Done,
     /*  32780 */   // Label 826: @32780
     /*  32780 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(32838), // Rule ID 5770 //
     /*  32785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32820 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32836 */     GIR_RootConstrainSelectedInstOperands,
     /*  32837 */     // GIR_Coverage, 5770,
     /*  32837 */     GIR_EraseRootFromParent_Done,
     /*  32838 */   // Label 827: @32838
     /*  32838 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(32861), // Rule ID 5767 //
     /*  32843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32854 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  32854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /*  32859 */     GIR_RootConstrainSelectedInstOperands,
     /*  32860 */     // GIR_Coverage, 5767,
     /*  32860 */     GIR_Done,
     /*  32861 */   // Label 828: @32861
     /*  32861 */   GIM_Reject,
     /*  32862 */ // Label 825: @32862
     /*  32862 */ GIM_Reject,
     /*  32863 */ // Label 680: @32863
     /*  32863 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(32896), // Rule ID 4421 //
     /*  32868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  32871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  32874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  32877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32889 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  32889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /*  32894 */   GIR_RootConstrainSelectedInstOperands,
     /*  32895 */   // GIR_Coverage, 4421,
     /*  32895 */   GIR_Done,
     /*  32896 */ // Label 829: @32896
     /*  32896 */ GIM_Reject,
     /*  32897 */ // Label 681: @32897
     /*  32897 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(33362),
     /*  32902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  32905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  32908 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(32970), // Rule ID 25233 //
     /*  32913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32952 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32968 */     GIR_RootConstrainSelectedInstOperands,
     /*  32969 */     // GIR_Coverage, 25233,
     /*  32969 */     GIR_EraseRootFromParent_Done,
     /*  32970 */   // Label 831: @32970
     /*  32970 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(33032), // Rule ID 25243 //
     /*  32975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33014 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33030 */     GIR_RootConstrainSelectedInstOperands,
     /*  33031 */     // GIR_Coverage, 25243,
     /*  33031 */     GIR_EraseRootFromParent_Done,
     /*  33032 */   // Label 832: @33032
     /*  33032 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(33094), // Rule ID 25440 //
     /*  33037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33076 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33092 */     GIR_RootConstrainSelectedInstOperands,
     /*  33093 */     // GIR_Coverage, 25440,
     /*  33093 */     GIR_EraseRootFromParent_Done,
     /*  33094 */   // Label 833: @33094
     /*  33094 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(33156), // Rule ID 18105 //
     /*  33099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33118 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33125 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33138 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  33141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33145 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33154 */     GIR_RootConstrainSelectedInstOperands,
     /*  33155 */     // GIR_Coverage, 18105,
     /*  33155 */     GIR_EraseRootFromParent_Done,
     /*  33156 */   // Label 834: @33156
     /*  33156 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(33218), // Rule ID 18134 //
     /*  33161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33200 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33216 */     GIR_RootConstrainSelectedInstOperands,
     /*  33217 */     // GIR_Coverage, 18134,
     /*  33217 */     GIR_EraseRootFromParent_Done,
     /*  33218 */   // Label 835: @33218
     /*  33218 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(33280), // Rule ID 20042 //
     /*  33223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33249 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33262 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33267 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33278 */     GIR_RootConstrainSelectedInstOperands,
     /*  33279 */     // GIR_Coverage, 20042,
     /*  33279 */     GIR_EraseRootFromParent_Done,
     /*  33280 */   // Label 836: @33280
     /*  33280 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(33307), // Rule ID 18093 //
     /*  33285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33300 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  33305 */     GIR_RootConstrainSelectedInstOperands,
     /*  33306 */     // GIR_Coverage, 18093,
     /*  33306 */     GIR_Done,
     /*  33307 */   // Label 837: @33307
     /*  33307 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(33334), // Rule ID 18118 //
     /*  33312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33327 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  33332 */     GIR_RootConstrainSelectedInstOperands,
     /*  33333 */     // GIR_Coverage, 18118,
     /*  33333 */     GIR_Done,
     /*  33334 */   // Label 838: @33334
     /*  33334 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(33361), // Rule ID 20034 //
     /*  33339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33354 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  33354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  33359 */     GIR_RootConstrainSelectedInstOperands,
     /*  33360 */     // GIR_Coverage, 20034,
     /*  33360 */     GIR_Done,
     /*  33361 */   // Label 839: @33361
     /*  33361 */   GIM_Reject,
     /*  33362 */ // Label 830: @33362
     /*  33362 */ GIM_Reject,
     /*  33363 */ // Label 682: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(33518),
     /*  33368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  33371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33378 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(33436), // Rule ID 25447 //
     /*  33383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33418 */     // (or:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33434 */     GIR_RootConstrainSelectedInstOperands,
     /*  33435 */     // GIR_Coverage, 25447,
     /*  33435 */     GIR_EraseRootFromParent_Done,
     /*  33436 */   // Label 841: @33436
     /*  33436 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(33494), // Rule ID 20059 //
     /*  33441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33476 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33492 */     GIR_RootConstrainSelectedInstOperands,
     /*  33493 */     // GIR_Coverage, 20059,
     /*  33493 */     GIR_EraseRootFromParent_Done,
     /*  33494 */   // Label 842: @33494
     /*  33494 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(33517), // Rule ID 20051 //
     /*  33499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33510 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  33510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33515 */     GIR_RootConstrainSelectedInstOperands,
     /*  33516 */     // GIR_Coverage, 20051,
     /*  33516 */     GIR_Done,
     /*  33517 */   // Label 843: @33517
     /*  33517 */   GIM_Reject,
     /*  33518 */ // Label 840: @33518
     /*  33518 */ GIM_Reject,
     /*  33519 */ // Label 683: @33519
     /*  33519 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(33552), // Rule ID 4422 //
     /*  33524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  33527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  33530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  33533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33545 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  33545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /*  33550 */   GIR_RootConstrainSelectedInstOperands,
     /*  33551 */   // GIR_Coverage, 4422,
     /*  33551 */   GIR_Done,
     /*  33552 */ // Label 844: @33552
     /*  33552 */ GIM_Reject,
     /*  33553 */ // Label 684: @33553
     /*  33553 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(33708),
     /*  33558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  33561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  33564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33568 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(33626), // Rule ID 25446 //
     /*  33573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33608 */     // (or:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33624 */     GIR_RootConstrainSelectedInstOperands,
     /*  33625 */     // GIR_Coverage, 25446,
     /*  33625 */     GIR_EraseRootFromParent_Done,
     /*  33626 */   // Label 846: @33626
     /*  33626 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(33684), // Rule ID 20058 //
     /*  33631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33666 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33682 */     GIR_RootConstrainSelectedInstOperands,
     /*  33683 */     // GIR_Coverage, 20058,
     /*  33683 */     GIR_EraseRootFromParent_Done,
     /*  33684 */   // Label 847: @33684
     /*  33684 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(33707), // Rule ID 20050 //
     /*  33689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33700 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  33700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33705 */     GIR_RootConstrainSelectedInstOperands,
     /*  33706 */     // GIR_Coverage, 20050,
     /*  33706 */     GIR_Done,
     /*  33707 */   // Label 848: @33707
     /*  33707 */   GIM_Reject,
     /*  33708 */ // Label 845: @33708
     /*  33708 */ GIM_Reject,
     /*  33709 */ // Label 685: @33709
     /*  33709 */ GIM_Reject,
     /*  33710 */ // Label 5: @33710
     /*  33710 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 872*/ GIMT_Encode4(46410),
     /*  33721 */ /*GILLT_s1*//*Label 849*/ GIMT_Encode4(33821),
     /*  33725 */ /*GILLT_s8*//*Label 850*/ GIMT_Encode4(34379),
     /*  33729 */ /*GILLT_s16*//*Label 851*/ GIMT_Encode4(34906),
     /*  33733 */ /*GILLT_s32*//*Label 852*/ GIMT_Encode4(35651),
     /*  33737 */ /*GILLT_s64*//*Label 853*/ GIMT_Encode4(36599), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  33749 */ /*GILLT_v2s1*//*Label 854*/ GIMT_Encode4(37506),
     /*  33753 */ /*GILLT_v2s64*//*Label 855*/ GIMT_Encode4(38048),
     /*  33757 */ /*GILLT_v4s1*//*Label 856*/ GIMT_Encode4(38668),
     /*  33761 */ /*GILLT_v4s32*//*Label 857*/ GIMT_Encode4(39210),
     /*  33765 */ /*GILLT_v4s64*//*Label 858*/ GIMT_Encode4(39830),
     /*  33769 */ /*GILLT_v8s1*//*Label 859*/ GIMT_Encode4(40574),
     /*  33773 */ /*GILLT_v8s16*//*Label 860*/ GIMT_Encode4(41372),
     /*  33777 */ /*GILLT_v8s32*//*Label 861*/ GIMT_Encode4(41992),
     /*  33781 */ /*GILLT_v8s64*//*Label 862*/ GIMT_Encode4(42736),
     /*  33785 */ /*GILLT_v16s1*//*Label 863*/ GIMT_Encode4(42934),
     /*  33789 */ /*GILLT_v16s8*//*Label 864*/ GIMT_Encode4(43192),
     /*  33793 */ /*GILLT_v16s16*//*Label 865*/ GIMT_Encode4(43812),
     /*  33797 */ /*GILLT_v16s32*//*Label 866*/ GIMT_Encode4(44556),
     /*  33801 */ /*GILLT_v32s1*//*Label 867*/ GIMT_Encode4(44754),
     /*  33805 */ /*GILLT_v32s8*//*Label 868*/ GIMT_Encode4(45012),
     /*  33809 */ /*GILLT_v32s16*//*Label 869*/ GIMT_Encode4(45756),
     /*  33813 */ /*GILLT_v64s1*//*Label 870*/ GIMT_Encode4(45954),
     /*  33817 */ /*GILLT_v64s8*//*Label 871*/ GIMT_Encode4(46212),
     /*  33821 */ // Label 849: @33821
     /*  33821 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(34378),
     /*  33826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  33829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(33956), // Rule ID 25372 //
     /*  33837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33880 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33892 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  33896 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33913 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33917 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33934 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33937 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33955 */     // GIR_Coverage, 25372,
     /*  33955 */     GIR_EraseRootFromParent_Done,
     /*  33956 */   // Label 874: @33956
     /*  33956 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(34081), // Rule ID 19496 //
     /*  33961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  33995 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  34003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34005 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34005 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34012 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34017 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  34021 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34038 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  34042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  34054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34062 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34080 */     // GIR_Coverage, 19496,
     /*  34080 */     GIR_EraseRootFromParent_Done,
     /*  34081 */   // Label 875: @34081
     /*  34081 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(34205), // Rule ID 25373 //
     /*  34086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  34106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  34110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34119 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  34127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34129 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34141 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  34145 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  34166 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  34178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34204 */     // GIR_Coverage, 25373,
     /*  34204 */     GIR_EraseRootFromParent_Done,
     /*  34205 */   // Label 876: @34205
     /*  34205 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(34284), // Rule ID 19482 //
     /*  34210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  34214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34222 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  34230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34232 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  34232 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34235 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34239 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34244 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  34248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  34260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  34283 */     // GIR_Coverage, 19482,
     /*  34283 */     GIR_EraseRootFromParent_Done,
     /*  34284 */   // Label 877: @34284
     /*  34284 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(34377), // Rule ID 19500 //
     /*  34289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34301 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34301 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34304 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34308 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34313 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  34317 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  34338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  34350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34358 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34376 */     // GIR_Coverage, 19500,
     /*  34376 */     GIR_EraseRootFromParent_Done,
     /*  34377 */   // Label 878: @34377
     /*  34377 */   GIM_Reject,
     /*  34378 */ // Label 873: @34378
     /*  34378 */ GIM_Reject,
     /*  34379 */ // Label 850: @34379
     /*  34379 */ GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(34905),
     /*  34384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  34387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  34390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34394 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(34450), // Rule ID 273 //
     /*  34399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34417 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34434 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] })  =>  (NOT8m_ND:{ *:[i8] } addr:{ *:[iPTR] }:$src1)
     /*  34434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m_ND),
     /*  34437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34448 */     GIR_RootConstrainSelectedInstOperands,
     /*  34449 */     // GIR_Coverage, 273,
     /*  34449 */     GIR_EraseRootFromParent_Done,
     /*  34450 */   // Label 880: @34450
     /*  34450 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(34511), // Rule ID 26065 //
     /*  34455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34473 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34490 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34509 */     GIR_RootConstrainSelectedInstOperands,
     /*  34510 */     // GIR_Coverage, 26065,
     /*  34510 */     GIR_EraseRootFromParent_Done,
     /*  34511 */   // Label 881: @34511
     /*  34511 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(34572), // Rule ID 26084 //
     /*  34516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34527 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34530 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34534 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34551 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34570 */     GIR_RootConstrainSelectedInstOperands,
     /*  34571 */     // GIR_Coverage, 26084,
     /*  34571 */     GIR_EraseRootFromParent_Done,
     /*  34572 */   // Label 882: @34572
     /*  34572 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(34633), // Rule ID 22842 //
     /*  34577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34599 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34612 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34631 */     GIR_RootConstrainSelectedInstOperands,
     /*  34632 */     // GIR_Coverage, 22842,
     /*  34632 */     GIR_EraseRootFromParent_Done,
     /*  34633 */   // Label 883: @34633
     /*  34633 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(34694), // Rule ID 22932 //
     /*  34638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34660 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34673 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34692 */     GIR_RootConstrainSelectedInstOperands,
     /*  34693 */     // GIR_Coverage, 22932,
     /*  34693 */     GIR_EraseRootFromParent_Done,
     /*  34694 */   // Label 884: @34694
     /*  34694 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(34722), // Rule ID 22599 //
     /*  34699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /*  34707 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /*  34707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  34710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  34717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34720 */     GIR_RootConstrainSelectedInstOperands,
     /*  34721 */     // GIR_Coverage, 22599,
     /*  34721 */     GIR_EraseRootFromParent_Done,
     /*  34722 */   // Label 885: @34722
     /*  34722 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(34747), // Rule ID 245 //
     /*  34727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34738 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /*  34741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34745 */     GIR_RootConstrainSelectedInstOperands,
     /*  34746 */     // GIR_Coverage, 245,
     /*  34746 */     GIR_EraseRootFromParent_Done,
     /*  34747 */   // Label 886: @34747
     /*  34747 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(34772), // Rule ID 253 //
     /*  34752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34763 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /*  34766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34768 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34770 */     GIR_RootConstrainSelectedInstOperands,
     /*  34771 */     // GIR_Coverage, 253,
     /*  34771 */     GIR_EraseRootFromParent_Done,
     /*  34772 */   // Label 887: @34772
     /*  34772 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(34809), // Rule ID 22846 //
     /*  34777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34792 */     // MIs[1] Operand 1
     /*  34792 */     // No operand predicates
     /*  34792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34794 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /*  34797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34807 */     GIR_RootConstrainSelectedInstOperands,
     /*  34808 */     // GIR_Coverage, 22846,
     /*  34808 */     GIR_EraseRootFromParent_Done,
     /*  34809 */   // Label 888: @34809
     /*  34809 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(34846), // Rule ID 22936 //
     /*  34814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34829 */     // MIs[1] Operand 1
     /*  34829 */     // No operand predicates
     /*  34829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34831 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /*  34834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34844 */     GIR_RootConstrainSelectedInstOperands,
     /*  34845 */     // GIR_Coverage, 22936,
     /*  34845 */     GIR_EraseRootFromParent_Done,
     /*  34846 */   // Label 889: @34846
     /*  34846 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(34875), // Rule ID 22838 //
     /*  34851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34862 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /*  34867 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34873 */     GIR_RootConstrainSelectedInstOperands,
     /*  34874 */     // GIR_Coverage, 22838,
     /*  34874 */     GIR_Done,
     /*  34875 */   // Label 890: @34875
     /*  34875 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(34904), // Rule ID 22928 //
     /*  34880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34891 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /*  34896 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34902 */     GIR_RootConstrainSelectedInstOperands,
     /*  34903 */     // GIR_Coverage, 22928,
     /*  34903 */     GIR_Done,
     /*  34904 */   // Label 891: @34904
     /*  34904 */   GIM_Reject,
     /*  34905 */ // Label 879: @34905
     /*  34905 */ GIM_Reject,
     /*  34906 */ // Label 851: @34906
     /*  34906 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(35650),
     /*  34911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  34914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  34917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34921 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(34977), // Rule ID 274 //
     /*  34926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34944 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34961 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] })  =>  (NOT16m_ND:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /*  34961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m_ND),
     /*  34964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34975 */     GIR_RootConstrainSelectedInstOperands,
     /*  34976 */     // GIR_Coverage, 274,
     /*  34976 */     GIR_EraseRootFromParent_Done,
     /*  34977 */   // Label 893: @34977
     /*  34977 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(35038), // Rule ID 26066 //
     /*  34982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34993 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34996 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35000 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35017 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  35020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35022 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35036 */     GIR_RootConstrainSelectedInstOperands,
     /*  35037 */     // GIR_Coverage, 26066,
     /*  35037 */     GIR_EraseRootFromParent_Done,
     /*  35038 */   // Label 894: @35038
     /*  35038 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(35099), // Rule ID 26085 //
     /*  35043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35061 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35078 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35083 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35097 */     GIR_RootConstrainSelectedInstOperands,
     /*  35098 */     // GIR_Coverage, 26085,
     /*  35098 */     GIR_EraseRootFromParent_Done,
     /*  35099 */   // Label 895: @35099
     /*  35099 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(35160), // Rule ID 22843 //
     /*  35104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35126 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35139 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  35142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35158 */     GIR_RootConstrainSelectedInstOperands,
     /*  35159 */     // GIR_Coverage, 22843,
     /*  35159 */     GIR_EraseRootFromParent_Done,
     /*  35160 */   // Label 896: @35160
     /*  35160 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(35221), // Rule ID 22933 //
     /*  35165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35187 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35200 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35205 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35219 */     GIR_RootConstrainSelectedInstOperands,
     /*  35220 */     // GIR_Coverage, 22933,
     /*  35220 */     GIR_EraseRootFromParent_Done,
     /*  35221 */   // Label 897: @35221
     /*  35221 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(35263), // Rule ID 22600 //
     /*  35226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35230 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /*  35241 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /*  35241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  35244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35248 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /*  35258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35261 */     GIR_RootConstrainSelectedInstOperands,
     /*  35262 */     // GIR_Coverage, 22600,
     /*  35262 */     GIR_EraseRootFromParent_Done,
     /*  35263 */   // Label 898: @35263
     /*  35263 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(35365), // Rule ID 26038 //
     /*  35268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35299 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35325 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35363 */     GIR_RootConstrainSelectedInstOperands,
     /*  35364 */     // GIR_Coverage, 26038,
     /*  35364 */     GIR_EraseRootFromParent_Done,
     /*  35365 */   // Label 899: @35365
     /*  35365 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(35467), // Rule ID 22776 //
     /*  35370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35390 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35401 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35465 */     GIR_RootConstrainSelectedInstOperands,
     /*  35466 */     // GIR_Coverage, 22776,
     /*  35466 */     GIR_EraseRootFromParent_Done,
     /*  35467 */   // Label 900: @35467
     /*  35467 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(35492), // Rule ID 246 //
     /*  35472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35483 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /*  35486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35490 */     GIR_RootConstrainSelectedInstOperands,
     /*  35491 */     // GIR_Coverage, 246,
     /*  35491 */     GIR_EraseRootFromParent_Done,
     /*  35492 */   // Label 901: @35492
     /*  35492 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(35517), // Rule ID 254 //
     /*  35497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35508 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /*  35511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35515 */     GIR_RootConstrainSelectedInstOperands,
     /*  35516 */     // GIR_Coverage, 254,
     /*  35516 */     GIR_EraseRootFromParent_Done,
     /*  35517 */   // Label 902: @35517
     /*  35517 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(35554), // Rule ID 22847 //
     /*  35522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35537 */     // MIs[1] Operand 1
     /*  35537 */     // No operand predicates
     /*  35537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35539 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /*  35542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35552 */     GIR_RootConstrainSelectedInstOperands,
     /*  35553 */     // GIR_Coverage, 22847,
     /*  35553 */     GIR_EraseRootFromParent_Done,
     /*  35554 */   // Label 903: @35554
     /*  35554 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(35591), // Rule ID 22937 //
     /*  35559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35574 */     // MIs[1] Operand 1
     /*  35574 */     // No operand predicates
     /*  35574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35576 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /*  35579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35589 */     GIR_RootConstrainSelectedInstOperands,
     /*  35590 */     // GIR_Coverage, 22937,
     /*  35590 */     GIR_EraseRootFromParent_Done,
     /*  35591 */   // Label 904: @35591
     /*  35591 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(35620), // Rule ID 22839 //
     /*  35596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35607 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /*  35612 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35618 */     GIR_RootConstrainSelectedInstOperands,
     /*  35619 */     // GIR_Coverage, 22839,
     /*  35619 */     GIR_Done,
     /*  35620 */   // Label 905: @35620
     /*  35620 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(35649), // Rule ID 22929 //
     /*  35625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35636 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /*  35641 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35647 */     GIR_RootConstrainSelectedInstOperands,
     /*  35648 */     // GIR_Coverage, 22929,
     /*  35648 */     GIR_Done,
     /*  35649 */   // Label 906: @35649
     /*  35649 */   GIM_Reject,
     /*  35650 */ // Label 892: @35650
     /*  35650 */ GIM_Reject,
     /*  35651 */ // Label 852: @35651
     /*  35651 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(36598),
     /*  35656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35659 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(35722), // Rule ID 275 //
     /*  35664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35689 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35706 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] })  =>  (NOT32m_ND:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  35706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m_ND),
     /*  35709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  35715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35720 */     GIR_RootConstrainSelectedInstOperands,
     /*  35721 */     // GIR_Coverage, 275,
     /*  35721 */     GIR_EraseRootFromParent_Done,
     /*  35722 */   // Label 908: @35722
     /*  35722 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(35790), // Rule ID 26067 //
     /*  35727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35748 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35752 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35769 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35788 */     GIR_RootConstrainSelectedInstOperands,
     /*  35789 */     // GIR_Coverage, 26067,
     /*  35789 */     GIR_EraseRootFromParent_Done,
     /*  35790 */   // Label 909: @35790
     /*  35790 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(35858), // Rule ID 26086 //
     /*  35795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35813 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35820 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35837 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35842 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35844 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35856 */     GIR_RootConstrainSelectedInstOperands,
     /*  35857 */     // GIR_Coverage, 26086,
     /*  35857 */     GIR_EraseRootFromParent_Done,
     /*  35858 */   // Label 910: @35858
     /*  35858 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(35926), // Rule ID 22844 //
     /*  35863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35885 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35892 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35905 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35924 */     GIR_RootConstrainSelectedInstOperands,
     /*  35925 */     // GIR_Coverage, 22844,
     /*  35925 */     GIR_EraseRootFromParent_Done,
     /*  35926 */   // Label 911: @35926
     /*  35926 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(35994), // Rule ID 22934 //
     /*  35931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35953 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35960 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35973 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35978 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35992 */     GIR_RootConstrainSelectedInstOperands,
     /*  35993 */     // GIR_Coverage, 22934,
     /*  35993 */     GIR_EraseRootFromParent_Done,
     /*  35994 */   // Label 912: @35994
     /*  35994 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(36043), // Rule ID 22601 //
     /*  35999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36010 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /*  36021 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /*  36021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  36024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36028 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  36038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36041 */     GIR_RootConstrainSelectedInstOperands,
     /*  36042 */     // GIR_Coverage, 22601,
     /*  36042 */     GIR_EraseRootFromParent_Done,
     /*  36043 */   // Label 913: @36043
     /*  36043 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(36101), // Rule ID 24997 //
     /*  36048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36076 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36080 */     // MIs[0] src
     /*  36080 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36087 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36099 */     GIR_RootConstrainSelectedInstOperands,
     /*  36100 */     // GIR_Coverage, 24997,
     /*  36100 */     GIR_EraseRootFromParent_Done,
     /*  36101 */   // Label 914: @36101
     /*  36101 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(36210), // Rule ID 26044 //
     /*  36106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36129 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36144 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36144 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36147 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36151 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36208 */     GIR_RootConstrainSelectedInstOperands,
     /*  36209 */     // GIR_Coverage, 26044,
     /*  36209 */     GIR_EraseRootFromParent_Done,
     /*  36210 */   // Label 915: @36210
     /*  36210 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(36264), // Rule ID 17358 //
     /*  36215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36241 */     // MIs[1] src
     /*  36241 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36246 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36252 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36262 */     GIR_RootConstrainSelectedInstOperands,
     /*  36263 */     // GIR_Coverage, 17358,
     /*  36263 */     GIR_EraseRootFromParent_Done,
     /*  36264 */   // Label 916: @36264
     /*  36264 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(36373), // Rule ID 22782 //
     /*  36269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36307 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36371 */     GIR_RootConstrainSelectedInstOperands,
     /*  36372 */     // GIR_Coverage, 22782,
     /*  36372 */     GIR_EraseRootFromParent_Done,
     /*  36373 */   // Label 917: @36373
     /*  36373 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(36405), // Rule ID 247 //
     /*  36378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36396 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /*  36399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36403 */     GIR_RootConstrainSelectedInstOperands,
     /*  36404 */     // GIR_Coverage, 247,
     /*  36404 */     GIR_EraseRootFromParent_Done,
     /*  36405 */   // Label 918: @36405
     /*  36405 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(36437), // Rule ID 255 //
     /*  36410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36428 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /*  36431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36433 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36435 */     GIR_RootConstrainSelectedInstOperands,
     /*  36436 */     // GIR_Coverage, 255,
     /*  36436 */     GIR_EraseRootFromParent_Done,
     /*  36437 */   // Label 919: @36437
     /*  36437 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(36481), // Rule ID 22848 //
     /*  36442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36464 */     // MIs[1] Operand 1
     /*  36464 */     // No operand predicates
     /*  36464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36466 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /*  36469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36479 */     GIR_RootConstrainSelectedInstOperands,
     /*  36480 */     // GIR_Coverage, 22848,
     /*  36480 */     GIR_EraseRootFromParent_Done,
     /*  36481 */   // Label 920: @36481
     /*  36481 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(36525), // Rule ID 22938 //
     /*  36486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36508 */     // MIs[1] Operand 1
     /*  36508 */     // No operand predicates
     /*  36508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36510 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /*  36513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36515 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36523 */     GIR_RootConstrainSelectedInstOperands,
     /*  36524 */     // GIR_Coverage, 22938,
     /*  36524 */     GIR_EraseRootFromParent_Done,
     /*  36525 */   // Label 921: @36525
     /*  36525 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(36561), // Rule ID 22840 //
     /*  36530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36548 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /*  36553 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36559 */     GIR_RootConstrainSelectedInstOperands,
     /*  36560 */     // GIR_Coverage, 22840,
     /*  36560 */     GIR_Done,
     /*  36561 */   // Label 922: @36561
     /*  36561 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(36597), // Rule ID 22930 //
     /*  36566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36584 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /*  36589 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36595 */     GIR_RootConstrainSelectedInstOperands,
     /*  36596 */     // GIR_Coverage, 22930,
     /*  36596 */     GIR_Done,
     /*  36597 */   // Label 923: @36597
     /*  36597 */   GIM_Reject,
     /*  36598 */ // Label 907: @36598
     /*  36598 */ GIM_Reject,
     /*  36599 */ // Label 853: @36599
     /*  36599 */ GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(37505),
     /*  36604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36607 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(36670), // Rule ID 276 //
     /*  36612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36654 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] })  =>  (NOT64m_ND:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /*  36654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m_ND),
     /*  36657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  36663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36668 */     GIR_RootConstrainSelectedInstOperands,
     /*  36669 */     // GIR_Coverage, 276,
     /*  36669 */     GIR_EraseRootFromParent_Done,
     /*  36670 */   // Label 925: @36670
     /*  36670 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(36738), // Rule ID 26068 //
     /*  36675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36717 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36736 */     GIR_RootConstrainSelectedInstOperands,
     /*  36737 */     // GIR_Coverage, 26068,
     /*  36737 */     GIR_EraseRootFromParent_Done,
     /*  36738 */   // Label 926: @36738
     /*  36738 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(36806), // Rule ID 26087 //
     /*  36743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36785 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36804 */     GIR_RootConstrainSelectedInstOperands,
     /*  36805 */     // GIR_Coverage, 26087,
     /*  36805 */     GIR_EraseRootFromParent_Done,
     /*  36806 */   // Label 927: @36806
     /*  36806 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(36874), // Rule ID 22845 //
     /*  36811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36853 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36872 */     GIR_RootConstrainSelectedInstOperands,
     /*  36873 */     // GIR_Coverage, 22845,
     /*  36873 */     GIR_EraseRootFromParent_Done,
     /*  36874 */   // Label 928: @36874
     /*  36874 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(36942), // Rule ID 22935 //
     /*  36879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36901 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36921 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36940 */     GIR_RootConstrainSelectedInstOperands,
     /*  36941 */     // GIR_Coverage, 22935,
     /*  36941 */     GIR_EraseRootFromParent_Done,
     /*  36942 */   // Label 929: @36942
     /*  36942 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(37000), // Rule ID 24998 //
     /*  36947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36979 */     // MIs[0] src
     /*  36979 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36986 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36998 */     GIR_RootConstrainSelectedInstOperands,
     /*  36999 */     // GIR_Coverage, 24998,
     /*  36999 */     GIR_EraseRootFromParent_Done,
     /*  37000 */   // Label 930: @37000
     /*  37000 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37109), // Rule ID 26050 //
     /*  37005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  37028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  37032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37043 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37107 */     GIR_RootConstrainSelectedInstOperands,
     /*  37108 */     // GIR_Coverage, 26050,
     /*  37108 */     GIR_EraseRootFromParent_Done,
     /*  37109 */   // Label 931: @37109
     /*  37109 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(37163), // Rule ID 17359 //
     /*  37114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  37117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  37136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37140 */     // MIs[1] src
     /*  37140 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  37145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  37149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37151 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  37151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  37154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  37158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37161 */     GIR_RootConstrainSelectedInstOperands,
     /*  37162 */     // GIR_Coverage, 17359,
     /*  37162 */     GIR_EraseRootFromParent_Done,
     /*  37163 */   // Label 932: @37163
     /*  37163 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37272), // Rule ID 22788 //
     /*  37168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  37195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  37199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37206 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37270 */     GIR_RootConstrainSelectedInstOperands,
     /*  37271 */     // GIR_Coverage, 22788,
     /*  37271 */     GIR_EraseRootFromParent_Done,
     /*  37272 */   // Label 933: @37272
     /*  37272 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(37304), // Rule ID 248 //
     /*  37277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37295 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /*  37298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37302 */     GIR_RootConstrainSelectedInstOperands,
     /*  37303 */     // GIR_Coverage, 248,
     /*  37303 */     GIR_EraseRootFromParent_Done,
     /*  37304 */   // Label 934: @37304
     /*  37304 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(37336), // Rule ID 256 //
     /*  37309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  37312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37327 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /*  37330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37334 */     GIR_RootConstrainSelectedInstOperands,
     /*  37335 */     // GIR_Coverage, 256,
     /*  37335 */     GIR_EraseRootFromParent_Done,
     /*  37336 */   // Label 935: @37336
     /*  37336 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(37384), // Rule ID 22849 //
     /*  37341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37367 */     // MIs[1] Operand 1
     /*  37367 */     // No operand predicates
     /*  37367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37369 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /*  37372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37382 */     GIR_RootConstrainSelectedInstOperands,
     /*  37383 */     // GIR_Coverage, 22849,
     /*  37383 */     GIR_EraseRootFromParent_Done,
     /*  37384 */   // Label 936: @37384
     /*  37384 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(37432), // Rule ID 22939 //
     /*  37389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37415 */     // MIs[1] Operand 1
     /*  37415 */     // No operand predicates
     /*  37415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37417 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /*  37420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37430 */     GIR_RootConstrainSelectedInstOperands,
     /*  37431 */     // GIR_Coverage, 22939,
     /*  37431 */     GIR_EraseRootFromParent_Done,
     /*  37432 */   // Label 937: @37432
     /*  37432 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(37468), // Rule ID 22841 //
     /*  37437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37455 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /*  37460 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37466 */     GIR_RootConstrainSelectedInstOperands,
     /*  37467 */     // GIR_Coverage, 22841,
     /*  37467 */     GIR_Done,
     /*  37468 */   // Label 938: @37468
     /*  37468 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(37504), // Rule ID 22931 //
     /*  37473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37491 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /*  37496 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37502 */     GIR_RootConstrainSelectedInstOperands,
     /*  37503 */     // GIR_Coverage, 22931,
     /*  37503 */     GIR_Done,
     /*  37504 */   // Label 939: @37504
     /*  37504 */   GIM_Reject,
     /*  37505 */ // Label 924: @37505
     /*  37505 */ GIM_Reject,
     /*  37506 */ // Label 854: @37506
     /*  37506 */ GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(38047),
     /*  37511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37521 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(37641), // Rule ID 25374 //
     /*  37526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37551 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37565 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37565 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37568 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37572 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37577 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37581 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37640 */     // GIR_Coverage, 25374,
     /*  37640 */     GIR_EraseRootFromParent_Done,
     /*  37641 */   // Label 941: @37641
     /*  37641 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(37762), // Rule ID 19497 //
     /*  37646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  37676 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37682 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37686 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37698 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37702 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37761 */     // GIR_Coverage, 19497,
     /*  37761 */     GIR_EraseRootFromParent_Done,
     /*  37762 */   // Label 942: @37762
     /*  37762 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(37882), // Rule ID 25375 //
     /*  37767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37796 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37802 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37806 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37818 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  37822 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37881 */     // GIR_Coverage, 25375,
     /*  37881 */     GIR_EraseRootFromParent_Done,
     /*  37882 */   // Label 943: @37882
     /*  37882 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(37957), // Rule ID 19481 //
     /*  37887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  37903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37905 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37917 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  37921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  37933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37938 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37956 */     // GIR_Coverage, 19481,
     /*  37956 */     GIR_EraseRootFromParent_Done,
     /*  37957 */   // Label 944: @37957
     /*  37957 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(38046), // Rule ID 19501 //
     /*  37962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37970 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37982 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  38007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  38019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  38045 */     // GIR_Coverage, 19501,
     /*  38045 */     GIR_EraseRootFromParent_Done,
     /*  38046 */   // Label 945: @38046
     /*  38046 */   GIM_Reject,
     /*  38047 */ // Label 940: @38047
     /*  38047 */ GIM_Reject,
     /*  38048 */ // Label 855: @38048
     /*  38048 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(38667),
     /*  38053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38059 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(38121), // Rule ID 23366 //
     /*  38064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38103 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38119 */     GIR_RootConstrainSelectedInstOperands,
     /*  38120 */     // GIR_Coverage, 23366,
     /*  38120 */     GIR_EraseRootFromParent_Done,
     /*  38121 */   // Label 947: @38121
     /*  38121 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(38183), // Rule ID 24221 //
     /*  38126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38165 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38181 */     GIR_RootConstrainSelectedInstOperands,
     /*  38182 */     // GIR_Coverage, 24221,
     /*  38182 */     GIR_EraseRootFromParent_Done,
     /*  38183 */   // Label 948: @38183
     /*  38183 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(38245), // Rule ID 2123 //
     /*  38188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38227 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38243 */     GIR_RootConstrainSelectedInstOperands,
     /*  38244 */     // GIR_Coverage, 2123,
     /*  38244 */     GIR_EraseRootFromParent_Done,
     /*  38245 */   // Label 949: @38245
     /*  38245 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(38307), // Rule ID 5815 //
     /*  38250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38289 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38305 */     GIR_RootConstrainSelectedInstOperands,
     /*  38306 */     // GIR_Coverage, 5815,
     /*  38306 */     GIR_EraseRootFromParent_Done,
     /*  38307 */   // Label 950: @38307
     /*  38307 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(38539), // Rule ID 21946 //
     /*  38312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  38315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  38319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38327 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38333 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38337 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  38337 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  38340 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38344 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  38351 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  38354 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38358 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38363 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  38366 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38370 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  38373 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38378 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38383 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38388 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  38391 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38395 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  38402 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  38405 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38409 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38414 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  38417 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38421 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  38424 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38429 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38434 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38439 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  38442 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38446 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38453 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  38456 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38460 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38465 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38468 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38472 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  38475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38480 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38485 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  38493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  38497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38502 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  38508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  38511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  38514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  38528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  38533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38538 */     // GIR_Coverage, 21946,
     /*  38538 */     GIR_EraseRootFromParent_Done,
     /*  38539 */   // Label 951: @38539
     /*  38539 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(38585), // Rule ID 21954 //
     /*  38544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  38547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38569 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /*  38569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  38572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  38583 */     GIR_RootConstrainSelectedInstOperands,
     /*  38584 */     // GIR_Coverage, 21954,
     /*  38584 */     GIR_EraseRootFromParent_Done,
     /*  38585 */   // Label 952: @38585
     /*  38585 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(38612), // Rule ID 2122 //
     /*  38590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38605 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  38610 */     GIR_RootConstrainSelectedInstOperands,
     /*  38611 */     // GIR_Coverage, 2122,
     /*  38611 */     GIR_Done,
     /*  38612 */   // Label 953: @38612
     /*  38612 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(38639), // Rule ID 2124 //
     /*  38617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  38620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38632 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  38637 */     GIR_RootConstrainSelectedInstOperands,
     /*  38638 */     // GIR_Coverage, 2124,
     /*  38638 */     GIR_Done,
     /*  38639 */   // Label 954: @38639
     /*  38639 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(38666), // Rule ID 5812 //
     /*  38644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38659 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  38659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  38664 */     GIR_RootConstrainSelectedInstOperands,
     /*  38665 */     // GIR_Coverage, 5812,
     /*  38665 */     GIR_Done,
     /*  38666 */   // Label 955: @38666
     /*  38666 */   GIM_Reject,
     /*  38667 */ // Label 946: @38667
     /*  38667 */ GIM_Reject,
     /*  38668 */ // Label 856: @38668
     /*  38668 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(39209),
     /*  38673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38683 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(38803), // Rule ID 25376 //
     /*  38688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38713 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38719 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38727 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38727 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38730 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38734 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38739 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38743 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38760 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38802 */     // GIR_Coverage, 25376,
     /*  38802 */     GIR_EraseRootFromParent_Done,
     /*  38803 */   // Label 957: @38803
     /*  38803 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(38924), // Rule ID 19498 //
     /*  38808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  38838 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38848 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38848 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38851 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38855 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38860 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  38864 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38869 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38876 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38885 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38923 */     // GIR_Coverage, 19498,
     /*  38923 */     GIR_EraseRootFromParent_Done,
     /*  38924 */   // Label 958: @38924
     /*  38924 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(39044), // Rule ID 25377 //
     /*  38929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38958 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38968 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38968 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38971 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38975 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38980 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  38984 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39001 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  39017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  39028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39043 */     // GIR_Coverage, 25377,
     /*  39043 */     GIR_EraseRootFromParent_Done,
     /*  39044 */   // Label 959: @39044
     /*  39044 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(39119), // Rule ID 19480 //
     /*  39049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39057 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39067 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  39067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39079 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  39095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39118 */     // GIR_Coverage, 19480,
     /*  39118 */     GIR_EraseRootFromParent_Done,
     /*  39119 */   // Label 960: @39119
     /*  39119 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(39208), // Rule ID 19502 //
     /*  39124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39132 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  39132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  39135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39144 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  39148 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39165 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  39169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  39181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39189 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  39192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39207 */     // GIR_Coverage, 19502,
     /*  39207 */     GIR_EraseRootFromParent_Done,
     /*  39208 */   // Label 961: @39208
     /*  39208 */   GIM_Reject,
     /*  39209 */ // Label 956: @39209
     /*  39209 */ GIM_Reject,
     /*  39210 */ // Label 857: @39210
     /*  39210 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(39829),
     /*  39215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39221 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(39283), // Rule ID 24239 //
     /*  39226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39241 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39248 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39265 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39281 */     GIR_RootConstrainSelectedInstOperands,
     /*  39282 */     // GIR_Coverage, 24239,
     /*  39282 */     GIR_EraseRootFromParent_Done,
     /*  39283 */   // Label 963: @39283
     /*  39283 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(39345), // Rule ID 25259 //
     /*  39288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39303 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39310 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39327 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39332 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39343 */     GIR_RootConstrainSelectedInstOperands,
     /*  39344 */     // GIR_Coverage, 25259,
     /*  39344 */     GIR_EraseRootFromParent_Done,
     /*  39345 */   // Label 964: @39345
     /*  39345 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(39407), // Rule ID 5842 //
     /*  39350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39389 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39405 */     GIR_RootConstrainSelectedInstOperands,
     /*  39406 */     // GIR_Coverage, 5842,
     /*  39406 */     GIR_EraseRootFromParent_Done,
     /*  39407 */   // Label 965: @39407
     /*  39407 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(39469), // Rule ID 18166 //
     /*  39412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39431 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39434 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39438 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39451 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39467 */     GIR_RootConstrainSelectedInstOperands,
     /*  39468 */     // GIR_Coverage, 18166,
     /*  39468 */     GIR_EraseRootFromParent_Done,
     /*  39469 */   // Label 966: @39469
     /*  39469 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(39701), // Rule ID 21945 //
     /*  39474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  39477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  39481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39499 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  39499 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  39502 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39506 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  39513 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  39516 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39520 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39525 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  39528 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39532 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  39535 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39540 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39545 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39550 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  39553 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39557 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  39564 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  39567 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39571 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39576 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  39579 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39583 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  39586 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39591 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39596 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  39604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  39618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39627 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39634 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  39637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  39655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  39659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  39670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  39673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  39676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39683 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  39690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  39695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39700 */     // GIR_Coverage, 21945,
     /*  39700 */     GIR_EraseRootFromParent_Done,
     /*  39701 */   // Label 967: @39701
     /*  39701 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(39747), // Rule ID 21953 //
     /*  39706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  39709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39731 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /*  39731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  39734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  39745 */     GIR_RootConstrainSelectedInstOperands,
     /*  39746 */     // GIR_Coverage, 21953,
     /*  39746 */     GIR_EraseRootFromParent_Done,
     /*  39747 */   // Label 968: @39747
     /*  39747 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(39774), // Rule ID 5839 //
     /*  39752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39767 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  39767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /*  39772 */     GIR_RootConstrainSelectedInstOperands,
     /*  39773 */     // GIR_Coverage, 5839,
     /*  39773 */     GIR_Done,
     /*  39774 */   // Label 969: @39774
     /*  39774 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(39801), // Rule ID 18154 //
     /*  39779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39794 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  39799 */     GIR_RootConstrainSelectedInstOperands,
     /*  39800 */     // GIR_Coverage, 18154,
     /*  39800 */     GIR_Done,
     /*  39801 */   // Label 970: @39801
     /*  39801 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(39828), // Rule ID 18178 //
     /*  39806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  39809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39821 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  39826 */     GIR_RootConstrainSelectedInstOperands,
     /*  39827 */     // GIR_Coverage, 18178,
     /*  39827 */     GIR_Done,
     /*  39828 */   // Label 971: @39828
     /*  39828 */   GIM_Reject,
     /*  39829 */ // Label 962: @39829
     /*  39829 */ GIM_Reject,
     /*  39830 */ // Label 858: @39830
     /*  39830 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(40573),
     /*  39835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  39838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  39841 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(39903), // Rule ID 23368 //
     /*  39846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39885 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39901 */     GIR_RootConstrainSelectedInstOperands,
     /*  39902 */     // GIR_Coverage, 23368,
     /*  39902 */     GIR_EraseRootFromParent_Done,
     /*  39903 */   // Label 973: @39903
     /*  39903 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(39965), // Rule ID 24215 //
     /*  39908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39947 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 24215,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 974: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(40027), // Rule ID 25250 //
     /*  39970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40009 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  40012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  40016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40025 */     GIR_RootConstrainSelectedInstOperands,
     /*  40026 */     // GIR_Coverage, 25250,
     /*  40026 */     GIR_EraseRootFromParent_Done,
     /*  40027 */   // Label 975: @40027
     /*  40027 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(40089), // Rule ID 2127 //
     /*  40032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40051 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40071 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  40074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40087 */     GIR_RootConstrainSelectedInstOperands,
     /*  40088 */     // GIR_Coverage, 2127,
     /*  40088 */     GIR_EraseRootFromParent_Done,
     /*  40089 */   // Label 976: @40089
     /*  40089 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(40151), // Rule ID 5806 //
     /*  40094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40133 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  40136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40149 */     GIR_RootConstrainSelectedInstOperands,
     /*  40150 */     // GIR_Coverage, 5806,
     /*  40150 */     GIR_EraseRootFromParent_Done,
     /*  40151 */   // Label 977: @40151
     /*  40151 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(40213), // Rule ID 18141 //
     /*  40156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40195 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  40198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40211 */     GIR_RootConstrainSelectedInstOperands,
     /*  40212 */     // GIR_Coverage, 18141,
     /*  40212 */     GIR_EraseRootFromParent_Done,
     /*  40213 */   // Label 978: @40213
     /*  40213 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(40445), // Rule ID 21950 //
     /*  40218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  40221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40243 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  40243 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  40246 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40250 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  40257 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  40260 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40264 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40269 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  40272 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40276 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  40279 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40284 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40289 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40294 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  40297 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40301 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  40308 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  40311 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40315 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40320 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  40323 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40327 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  40330 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40335 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40340 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40345 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  40348 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40352 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  40362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40371 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  40381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  40399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  40403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40408 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  40414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  40417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  40420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  40434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40444 */     // GIR_Coverage, 21950,
     /*  40444 */     GIR_EraseRootFromParent_Done,
     /*  40445 */   // Label 979: @40445
     /*  40445 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(40491), // Rule ID 21958 //
     /*  40450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  40453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40465 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40471 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40475 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /*  40475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  40478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  40489 */     GIR_RootConstrainSelectedInstOperands,
     /*  40490 */     // GIR_Coverage, 21958,
     /*  40490 */     GIR_EraseRootFromParent_Done,
     /*  40491 */   // Label 980: @40491
     /*  40491 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(40518), // Rule ID 2126 //
     /*  40496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40511 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  40516 */     GIR_RootConstrainSelectedInstOperands,
     /*  40517 */     // GIR_Coverage, 2126,
     /*  40517 */     GIR_Done,
     /*  40518 */   // Label 981: @40518
     /*  40518 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(40545), // Rule ID 5803 //
     /*  40523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40538 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  40538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  40543 */     GIR_RootConstrainSelectedInstOperands,
     /*  40544 */     // GIR_Coverage, 5803,
     /*  40544 */     GIR_Done,
     /*  40545 */   // Label 982: @40545
     /*  40545 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(40572), // Rule ID 18125 //
     /*  40550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40565 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  40570 */     GIR_RootConstrainSelectedInstOperands,
     /*  40571 */     // GIR_Coverage, 18125,
     /*  40571 */     GIR_Done,
     /*  40572 */   // Label 983: @40572
     /*  40572 */   GIM_Reject,
     /*  40573 */ // Label 972: @40573
     /*  40573 */ GIM_Reject,
     /*  40574 */ // Label 859: @40574
     /*  40574 */ GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(41371),
     /*  40579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40589 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(40649), // Rule ID 23684 //
     /*  40594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40636 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  40647 */     GIR_RootConstrainSelectedInstOperands,
     /*  40648 */     // GIR_Coverage, 23684,
     /*  40648 */     GIR_EraseRootFromParent_Done,
     /*  40649 */   // Label 985: @40649
     /*  40649 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(40772), // Rule ID 25370 //
     /*  40654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40682 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40696 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40696 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40699 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40703 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40708 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  40712 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40729 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40750 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40771 */     // GIR_Coverage, 25370,
     /*  40771 */     GIR_EraseRootFromParent_Done,
     /*  40772 */   // Label 986: @40772
     /*  40772 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(40835), // Rule ID 4423 //
     /*  40777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40810 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40816 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40820 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40833 */     GIR_RootConstrainSelectedInstOperands,
     /*  40834 */     // GIR_Coverage, 4423,
     /*  40834 */     GIR_EraseRootFromParent_Done,
     /*  40835 */   // Label 987: @40835
     /*  40835 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(40959), // Rule ID 19495 //
     /*  40840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40873 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40879 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40883 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40883 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40886 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40890 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40895 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40899 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40904 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40907 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40911 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40920 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40937 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40940 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40958 */     // GIR_Coverage, 19495,
     /*  40958 */     GIR_EraseRootFromParent_Done,
     /*  40959 */   // Label 988: @40959
     /*  40959 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(41019), // Rule ID 23685 //
     /*  40964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40996 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41002 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  41004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41006 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  41009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  41015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  41017 */     GIR_RootConstrainSelectedInstOperands,
     /*  41018 */     // GIR_Coverage, 23685,
     /*  41018 */     GIR_EraseRootFromParent_Done,
     /*  41019 */   // Label 989: @41019
     /*  41019 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(41142), // Rule ID 25371 //
     /*  41024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  41043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  41047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41056 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  41064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41066 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41066 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41069 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41073 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41078 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  41082 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  41103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  41115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41141 */     // GIR_Coverage, 25371,
     /*  41141 */     GIR_EraseRootFromParent_Done,
     /*  41142 */   // Label 990: @41142
     /*  41142 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(41177), // Rule ID 4411 //
     /*  41147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41158 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41168 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /*  41168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /*  41171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41175 */     GIR_RootConstrainSelectedInstOperands,
     /*  41176 */     // GIR_Coverage, 4411,
     /*  41176 */     GIR_EraseRootFromParent_Done,
     /*  41177 */   // Label 991: @41177
     /*  41177 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(41255), // Rule ID 19479 //
     /*  41182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /*  41185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41203 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  41231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41254 */     // GIR_Coverage, 19479,
     /*  41254 */     GIR_EraseRootFromParent_Done,
     /*  41255 */   // Label 992: @41255
     /*  41255 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(41278), // Rule ID 4427 //
     /*  41260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41271 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /*  41276 */     GIR_RootConstrainSelectedInstOperands,
     /*  41277 */     // GIR_Coverage, 4427,
     /*  41277 */     GIR_Done,
     /*  41278 */   // Label 993: @41278
     /*  41278 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(41370), // Rule ID 19499 //
     /*  41283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41294 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41306 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  41310 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  41331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  41343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41369 */     // GIR_Coverage, 19499,
     /*  41369 */     GIR_EraseRootFromParent_Done,
     /*  41370 */   // Label 994: @41370
     /*  41370 */   GIM_Reject,
     /*  41371 */ // Label 984: @41371
     /*  41371 */ GIM_Reject,
     /*  41372 */ // Label 860: @41372
     /*  41372 */ GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(41991),
     /*  41377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  41380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41383 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(41445), // Rule ID 25258 //
     /*  41388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41427 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41443 */     GIR_RootConstrainSelectedInstOperands,
     /*  41444 */     // GIR_Coverage, 25258,
     /*  41444 */     GIR_EraseRootFromParent_Done,
     /*  41445 */   // Label 996: @41445
     /*  41445 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(41507), // Rule ID 25437 //
     /*  41450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41489 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41505 */     GIR_RootConstrainSelectedInstOperands,
     /*  41506 */     // GIR_Coverage, 25437,
     /*  41506 */     GIR_EraseRootFromParent_Done,
     /*  41507 */   // Label 997: @41507
     /*  41507 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(41569), // Rule ID 18165 //
     /*  41512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41538 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41551 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41567 */     GIR_RootConstrainSelectedInstOperands,
     /*  41568 */     // GIR_Coverage, 18165,
     /*  41568 */     GIR_EraseRootFromParent_Done,
     /*  41569 */   // Label 998: @41569
     /*  41569 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(41631), // Rule ID 20029 //
     /*  41574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41613 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41629 */     GIR_RootConstrainSelectedInstOperands,
     /*  41630 */     // GIR_Coverage, 20029,
     /*  41630 */     GIR_EraseRootFromParent_Done,
     /*  41631 */   // Label 999: @41631
     /*  41631 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(41863), // Rule ID 21944 //
     /*  41636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  41639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  41643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41661 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  41661 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  41664 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41668 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  41675 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  41678 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41682 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41687 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  41690 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41694 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  41697 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41702 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41707 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41712 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  41715 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41719 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  41726 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  41729 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41733 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41738 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  41741 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41745 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  41748 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41753 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41758 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41763 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  41766 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41770 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  41780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41789 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41792 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41796 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  41799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  41817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  41821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41826 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  41832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  41835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  41838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  41852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  41857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41862 */     // GIR_Coverage, 21944,
     /*  41862 */     GIR_EraseRootFromParent_Done,
     /*  41863 */   // Label 1000: @41863
     /*  41863 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(41909), // Rule ID 21952 //
     /*  41868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41889 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41893 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /*  41893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  41896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  41907 */     GIR_RootConstrainSelectedInstOperands,
     /*  41908 */     // GIR_Coverage, 21952,
     /*  41908 */     GIR_EraseRootFromParent_Done,
     /*  41909 */   // Label 1001: @41909
     /*  41909 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(41936), // Rule ID 18153 //
     /*  41914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41929 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  41934 */     GIR_RootConstrainSelectedInstOperands,
     /*  41935 */     // GIR_Coverage, 18153,
     /*  41935 */     GIR_Done,
     /*  41936 */   // Label 1002: @41936
     /*  41936 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(41963), // Rule ID 18177 //
     /*  41941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  41944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41956 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  41961 */     GIR_RootConstrainSelectedInstOperands,
     /*  41962 */     // GIR_Coverage, 18177,
     /*  41962 */     GIR_Done,
     /*  41963 */   // Label 1003: @41963
     /*  41963 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(41990), // Rule ID 20021 //
     /*  41968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41983 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  41983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  41988 */     GIR_RootConstrainSelectedInstOperands,
     /*  41989 */     // GIR_Coverage, 20021,
     /*  41989 */     GIR_Done,
     /*  41990 */   // Label 1004: @41990
     /*  41990 */   GIM_Reject,
     /*  41991 */ // Label 995: @41991
     /*  41991 */ GIM_Reject,
     /*  41992 */ // Label 861: @41992
     /*  41992 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(42735),
     /*  41997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  42000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  42003 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(42065), // Rule ID 24233 //
     /*  42008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42047 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42063 */     GIR_RootConstrainSelectedInstOperands,
     /*  42064 */     // GIR_Coverage, 24233,
     /*  42064 */     GIR_EraseRootFromParent_Done,
     /*  42065 */   // Label 1006: @42065
     /*  42065 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(42127), // Rule ID 25238 //
     /*  42070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42109 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42125 */     GIR_RootConstrainSelectedInstOperands,
     /*  42126 */     // GIR_Coverage, 25238,
     /*  42126 */     GIR_EraseRootFromParent_Done,
     /*  42127 */   // Label 1007: @42127
     /*  42127 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(42189), // Rule ID 25249 //
     /*  42132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42171 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42187 */     GIR_RootConstrainSelectedInstOperands,
     /*  42188 */     // GIR_Coverage, 25249,
     /*  42188 */     GIR_EraseRootFromParent_Done,
     /*  42189 */   // Label 1008: @42189
     /*  42189 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(42251), // Rule ID 5833 //
     /*  42194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42213 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42220 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42233 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42249 */     GIR_RootConstrainSelectedInstOperands,
     /*  42250 */     // GIR_Coverage, 5833,
     /*  42250 */     GIR_EraseRootFromParent_Done,
     /*  42251 */   // Label 1009: @42251
     /*  42251 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(42313), // Rule ID 18110 //
     /*  42256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42295 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42311 */     GIR_RootConstrainSelectedInstOperands,
     /*  42312 */     // GIR_Coverage, 18110,
     /*  42312 */     GIR_EraseRootFromParent_Done,
     /*  42313 */   // Label 1010: @42313
     /*  42313 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(42375), // Rule ID 18140 //
     /*  42318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42357 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42373 */     GIR_RootConstrainSelectedInstOperands,
     /*  42374 */     // GIR_Coverage, 18140,
     /*  42374 */     GIR_EraseRootFromParent_Done,
     /*  42375 */   // Label 1011: @42375
     /*  42375 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(42607), // Rule ID 21949 //
     /*  42380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  42383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42401 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42405 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  42405 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  42408 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42412 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  42419 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  42422 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42426 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42431 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  42434 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42438 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  42441 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42446 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42451 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42456 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  42459 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42463 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  42470 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  42473 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42477 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42482 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  42485 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42489 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  42492 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42497 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42502 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  42510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  42524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42533 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42536 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42540 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  42543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  42561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  42576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  42579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  42582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  42596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42606 */     // GIR_Coverage, 21949,
     /*  42606 */     GIR_EraseRootFromParent_Done,
     /*  42607 */   // Label 1012: @42607
     /*  42607 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(42653), // Rule ID 21957 //
     /*  42612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  42615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42633 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42637 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /*  42637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  42640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42651 */     GIR_RootConstrainSelectedInstOperands,
     /*  42652 */     // GIR_Coverage, 21957,
     /*  42652 */     GIR_EraseRootFromParent_Done,
     /*  42653 */   // Label 1013: @42653
     /*  42653 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(42680), // Rule ID 5830 //
     /*  42658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42673 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  42673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /*  42678 */     GIR_RootConstrainSelectedInstOperands,
     /*  42679 */     // GIR_Coverage, 5830,
     /*  42679 */     GIR_Done,
     /*  42680 */   // Label 1014: @42680
     /*  42680 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(42707), // Rule ID 18098 //
     /*  42685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42700 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  42705 */     GIR_RootConstrainSelectedInstOperands,
     /*  42706 */     // GIR_Coverage, 18098,
     /*  42706 */     GIR_Done,
     /*  42707 */   // Label 1015: @42707
     /*  42707 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(42734), // Rule ID 18124 //
     /*  42712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42727 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  42732 */     GIR_RootConstrainSelectedInstOperands,
     /*  42733 */     // GIR_Coverage, 18124,
     /*  42733 */     GIR_Done,
     /*  42734 */   // Label 1016: @42734
     /*  42734 */   GIM_Reject,
     /*  42735 */ // Label 1005: @42735
     /*  42735 */ GIM_Reject,
     /*  42736 */ // Label 862: @42736
     /*  42736 */ GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(42933),
     /*  42741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  42744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  42747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42751 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(42809), // Rule ID 24209 //
     /*  42756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42791 */     // (xor:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42807 */     GIR_RootConstrainSelectedInstOperands,
     /*  42808 */     // GIR_Coverage, 24209,
     /*  42808 */     GIR_EraseRootFromParent_Done,
     /*  42809 */   // Label 1018: @42809
     /*  42809 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(42867), // Rule ID 5797 //
     /*  42814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42849 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42865 */     GIR_RootConstrainSelectedInstOperands,
     /*  42866 */     // GIR_Coverage, 5797,
     /*  42866 */     GIR_EraseRootFromParent_Done,
     /*  42867 */   // Label 1019: @42867
     /*  42867 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(42909), // Rule ID 21942 //
     /*  42872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42889 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42893 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /*  42893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42907 */     GIR_RootConstrainSelectedInstOperands,
     /*  42908 */     // GIR_Coverage, 21942,
     /*  42908 */     GIR_EraseRootFromParent_Done,
     /*  42909 */   // Label 1020: @42909
     /*  42909 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(42932), // Rule ID 5794 //
     /*  42914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42925 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  42925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  42930 */     GIR_RootConstrainSelectedInstOperands,
     /*  42931 */     // GIR_Coverage, 5794,
     /*  42931 */     GIR_Done,
     /*  42932 */   // Label 1021: @42932
     /*  42932 */   GIM_Reject,
     /*  42933 */ // Label 1017: @42933
     /*  42933 */ GIM_Reject,
     /*  42934 */ // Label 863: @42934
     /*  42934 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(43191),
     /*  42939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42949 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(43009), // Rule ID 23686 //
     /*  42954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42982 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42996 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  43007 */     GIR_RootConstrainSelectedInstOperands,
     /*  43008 */     // GIR_Coverage, 23686,
     /*  43008 */     GIR_EraseRootFromParent_Done,
     /*  43009 */   // Label 1023: @43009
     /*  43009 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(43072), // Rule ID 4424 //
     /*  43014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  43029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  43033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43047 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43057 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  43070 */     GIR_RootConstrainSelectedInstOperands,
     /*  43071 */     // GIR_Coverage, 4424,
     /*  43071 */     GIR_EraseRootFromParent_Done,
     /*  43072 */   // Label 1024: @43072
     /*  43072 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(43132), // Rule ID 23687 //
     /*  43077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  43096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  43100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43109 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43115 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43119 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  43130 */     GIR_RootConstrainSelectedInstOperands,
     /*  43131 */     // GIR_Coverage, 23687,
     /*  43131 */     GIR_EraseRootFromParent_Done,
     /*  43132 */   // Label 1025: @43132
     /*  43132 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(43167), // Rule ID 4412 //
     /*  43137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43148 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43154 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43158 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /*  43158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  43161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43165 */     GIR_RootConstrainSelectedInstOperands,
     /*  43166 */     // GIR_Coverage, 4412,
     /*  43166 */     GIR_EraseRootFromParent_Done,
     /*  43167 */   // Label 1026: @43167
     /*  43167 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(43190), // Rule ID 4428 //
     /*  43172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43183 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  43188 */     GIR_RootConstrainSelectedInstOperands,
     /*  43189 */     // GIR_Coverage, 4428,
     /*  43189 */     GIR_Done,
     /*  43190 */   // Label 1027: @43190
     /*  43190 */   GIM_Reject,
     /*  43191 */ // Label 1022: @43191
     /*  43191 */ GIM_Reject,
     /*  43192 */ // Label 864: @43192
     /*  43192 */ GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(43811),
     /*  43197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  43200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  43203 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(43265), // Rule ID 25257 //
     /*  43208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43247 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43252 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43263 */     GIR_RootConstrainSelectedInstOperands,
     /*  43264 */     // GIR_Coverage, 25257,
     /*  43264 */     GIR_EraseRootFromParent_Done,
     /*  43265 */   // Label 1029: @43265
     /*  43265 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(43327), // Rule ID 25436 //
     /*  43270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43285 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43309 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43325 */     GIR_RootConstrainSelectedInstOperands,
     /*  43326 */     // GIR_Coverage, 25436,
     /*  43326 */     GIR_EraseRootFromParent_Done,
     /*  43327 */   // Label 1030: @43327
     /*  43327 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(43389), // Rule ID 18164 //
     /*  43332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43351 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43358 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43371 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43387 */     GIR_RootConstrainSelectedInstOperands,
     /*  43388 */     // GIR_Coverage, 18164,
     /*  43388 */     GIR_EraseRootFromParent_Done,
     /*  43389 */   // Label 1031: @43389
     /*  43389 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(43451), // Rule ID 20028 //
     /*  43394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43433 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43449 */     GIR_RootConstrainSelectedInstOperands,
     /*  43450 */     // GIR_Coverage, 20028,
     /*  43450 */     GIR_EraseRootFromParent_Done,
     /*  43451 */   // Label 1032: @43451
     /*  43451 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(43683), // Rule ID 21943 //
     /*  43456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  43463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43471 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43477 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43481 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  43481 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  43484 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43488 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  43495 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  43498 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43502 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43507 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  43510 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43514 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  43517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43522 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43527 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43532 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  43535 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43539 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  43546 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  43549 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43553 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43558 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  43561 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43565 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  43568 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43573 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43578 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43583 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  43586 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43590 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  43600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43609 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43612 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43616 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  43619 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43624 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  43637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  43641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  43652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  43655 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  43658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  43672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  43677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43682 */     // GIR_Coverage, 21943,
     /*  43682 */     GIR_EraseRootFromParent_Done,
     /*  43683 */   // Label 1033: @43683
     /*  43683 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(43729), // Rule ID 21951 //
     /*  43688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43713 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /*  43713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  43716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  43727 */     GIR_RootConstrainSelectedInstOperands,
     /*  43728 */     // GIR_Coverage, 21951,
     /*  43728 */     GIR_EraseRootFromParent_Done,
     /*  43729 */   // Label 1034: @43729
     /*  43729 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(43756), // Rule ID 18152 //
     /*  43734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43749 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  43754 */     GIR_RootConstrainSelectedInstOperands,
     /*  43755 */     // GIR_Coverage, 18152,
     /*  43755 */     GIR_Done,
     /*  43756 */   // Label 1035: @43756
     /*  43756 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(43783), // Rule ID 18176 //
     /*  43761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  43764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43776 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  43781 */     GIR_RootConstrainSelectedInstOperands,
     /*  43782 */     // GIR_Coverage, 18176,
     /*  43782 */     GIR_Done,
     /*  43783 */   // Label 1036: @43783
     /*  43783 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(43810), // Rule ID 20020 //
     /*  43788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43803 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  43803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  43808 */     GIR_RootConstrainSelectedInstOperands,
     /*  43809 */     // GIR_Coverage, 20020,
     /*  43809 */     GIR_Done,
     /*  43810 */   // Label 1037: @43810
     /*  43810 */   GIM_Reject,
     /*  43811 */ // Label 1028: @43811
     /*  43811 */ GIM_Reject,
     /*  43812 */ // Label 865: @43812
     /*  43812 */ GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(44555),
     /*  43817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  43820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  43823 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(43885), // Rule ID 25237 //
     /*  43828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43867 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43883 */     GIR_RootConstrainSelectedInstOperands,
     /*  43884 */     // GIR_Coverage, 25237,
     /*  43884 */     GIR_EraseRootFromParent_Done,
     /*  43885 */   // Label 1039: @43885
     /*  43885 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(43947), // Rule ID 25248 //
     /*  43890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43929 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43945 */     GIR_RootConstrainSelectedInstOperands,
     /*  43946 */     // GIR_Coverage, 25248,
     /*  43946 */     GIR_EraseRootFromParent_Done,
     /*  43947 */   // Label 1040: @43947
     /*  43947 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(44009), // Rule ID 25443 //
     /*  43952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43991 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43998 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44007 */     GIR_RootConstrainSelectedInstOperands,
     /*  44008 */     // GIR_Coverage, 25443,
     /*  44008 */     GIR_EraseRootFromParent_Done,
     /*  44009 */   // Label 1041: @44009
     /*  44009 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(44071), // Rule ID 18109 //
     /*  44014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44040 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44053 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  44056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44069 */     GIR_RootConstrainSelectedInstOperands,
     /*  44070 */     // GIR_Coverage, 18109,
     /*  44070 */     GIR_EraseRootFromParent_Done,
     /*  44071 */   // Label 1042: @44071
     /*  44071 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(44133), // Rule ID 18139 //
     /*  44076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44115 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  44118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44131 */     GIR_RootConstrainSelectedInstOperands,
     /*  44132 */     // GIR_Coverage, 18139,
     /*  44132 */     GIR_EraseRootFromParent_Done,
     /*  44133 */   // Label 1043: @44133
     /*  44133 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(44195), // Rule ID 20045 //
     /*  44138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44177 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44182 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44193 */     GIR_RootConstrainSelectedInstOperands,
     /*  44194 */     // GIR_Coverage, 20045,
     /*  44194 */     GIR_EraseRootFromParent_Done,
     /*  44195 */   // Label 1044: @44195
     /*  44195 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(44427), // Rule ID 21948 //
     /*  44200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  44203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44225 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  44225 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  44228 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44232 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  44239 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  44242 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44246 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44251 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  44254 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44258 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  44261 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44266 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44271 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44276 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  44279 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44283 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  44290 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  44293 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44297 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44302 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  44305 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44309 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  44312 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44317 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44322 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44327 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  44330 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44334 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  44341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  44344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44353 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  44356 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44360 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  44363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  44381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  44396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  44399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  44402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  44416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44426 */     // GIR_Coverage, 21948,
     /*  44426 */     GIR_EraseRootFromParent_Done,
     /*  44427 */   // Label 1045: @44427
     /*  44427 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(44473), // Rule ID 21956 //
     /*  44432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44457 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /*  44457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  44460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44464 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44471 */     GIR_RootConstrainSelectedInstOperands,
     /*  44472 */     // GIR_Coverage, 21956,
     /*  44472 */     GIR_EraseRootFromParent_Done,
     /*  44473 */   // Label 1046: @44473
     /*  44473 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(44500), // Rule ID 18097 //
     /*  44478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44493 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  44498 */     GIR_RootConstrainSelectedInstOperands,
     /*  44499 */     // GIR_Coverage, 18097,
     /*  44499 */     GIR_Done,
     /*  44500 */   // Label 1047: @44500
     /*  44500 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(44527), // Rule ID 18123 //
     /*  44505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44520 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  44525 */     GIR_RootConstrainSelectedInstOperands,
     /*  44526 */     // GIR_Coverage, 18123,
     /*  44526 */     GIR_Done,
     /*  44527 */   // Label 1048: @44527
     /*  44527 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(44554), // Rule ID 20037 //
     /*  44532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44547 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  44547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  44552 */     GIR_RootConstrainSelectedInstOperands,
     /*  44553 */     // GIR_Coverage, 20037,
     /*  44553 */     GIR_Done,
     /*  44554 */   // Label 1049: @44554
     /*  44554 */   GIM_Reject,
     /*  44555 */ // Label 1038: @44555
     /*  44555 */ GIM_Reject,
     /*  44556 */ // Label 866: @44556
     /*  44556 */ GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(44753),
     /*  44561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  44564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  44567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44571 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(44629), // Rule ID 24227 //
     /*  44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44611 */     // (xor:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44627 */     GIR_RootConstrainSelectedInstOperands,
     /*  44628 */     // GIR_Coverage, 24227,
     /*  44628 */     GIR_EraseRootFromParent_Done,
     /*  44629 */   // Label 1051: @44629
     /*  44629 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(44687), // Rule ID 5824 //
     /*  44634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44669 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44685 */     GIR_RootConstrainSelectedInstOperands,
     /*  44686 */     // GIR_Coverage, 5824,
     /*  44686 */     GIR_EraseRootFromParent_Done,
     /*  44687 */   // Label 1052: @44687
     /*  44687 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(44729), // Rule ID 21941 //
     /*  44692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44713 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /*  44713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44727 */     GIR_RootConstrainSelectedInstOperands,
     /*  44728 */     // GIR_Coverage, 21941,
     /*  44728 */     GIR_EraseRootFromParent_Done,
     /*  44729 */   // Label 1053: @44729
     /*  44729 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(44752), // Rule ID 5821 //
     /*  44734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44745 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  44745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /*  44750 */     GIR_RootConstrainSelectedInstOperands,
     /*  44751 */     // GIR_Coverage, 5821,
     /*  44751 */     GIR_Done,
     /*  44752 */   // Label 1054: @44752
     /*  44752 */   GIM_Reject,
     /*  44753 */ // Label 1050: @44753
     /*  44753 */ GIM_Reject,
     /*  44754 */ // Label 867: @44754
     /*  44754 */ GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(45011),
     /*  44759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44769 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(44829), // Rule ID 23688 //
     /*  44774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44802 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44816 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  44827 */     GIR_RootConstrainSelectedInstOperands,
     /*  44828 */     // GIR_Coverage, 23688,
     /*  44828 */     GIR_EraseRootFromParent_Done,
     /*  44829 */   // Label 1056: @44829
     /*  44829 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(44892), // Rule ID 4425 //
     /*  44834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44867 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44877 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  44890 */     GIR_RootConstrainSelectedInstOperands,
     /*  44891 */     // GIR_Coverage, 4425,
     /*  44891 */     GIR_EraseRootFromParent_Done,
     /*  44892 */   // Label 1057: @44892
     /*  44892 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(44952), // Rule ID 23689 //
     /*  44897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44929 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44939 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  44950 */     GIR_RootConstrainSelectedInstOperands,
     /*  44951 */     // GIR_Coverage, 23689,
     /*  44951 */     GIR_EraseRootFromParent_Done,
     /*  44952 */   // Label 1058: @44952
     /*  44952 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(44987), // Rule ID 4413 //
     /*  44957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44974 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44978 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /*  44978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /*  44981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44983 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44985 */     GIR_RootConstrainSelectedInstOperands,
     /*  44986 */     // GIR_Coverage, 4413,
     /*  44986 */     GIR_EraseRootFromParent_Done,
     /*  44987 */   // Label 1059: @44987
     /*  44987 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(45010), // Rule ID 4429 //
     /*  44992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  45003 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  45003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /*  45008 */     GIR_RootConstrainSelectedInstOperands,
     /*  45009 */     // GIR_Coverage, 4429,
     /*  45009 */     GIR_Done,
     /*  45010 */   // Label 1060: @45010
     /*  45010 */   GIM_Reject,
     /*  45011 */ // Label 1055: @45011
     /*  45011 */ GIM_Reject,
     /*  45012 */ // Label 868: @45012
     /*  45012 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(45755),
     /*  45017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  45020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  45023 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(45085), // Rule ID 25236 //
     /*  45028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45067 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45083 */     GIR_RootConstrainSelectedInstOperands,
     /*  45084 */     // GIR_Coverage, 25236,
     /*  45084 */     GIR_EraseRootFromParent_Done,
     /*  45085 */   // Label 1062: @45085
     /*  45085 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(45147), // Rule ID 25247 //
     /*  45090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45105 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45112 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45129 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45145 */     GIR_RootConstrainSelectedInstOperands,
     /*  45146 */     // GIR_Coverage, 25247,
     /*  45146 */     GIR_EraseRootFromParent_Done,
     /*  45147 */   // Label 1063: @45147
     /*  45147 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(45209), // Rule ID 25442 //
     /*  45152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45191 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45207 */     GIR_RootConstrainSelectedInstOperands,
     /*  45208 */     // GIR_Coverage, 25442,
     /*  45208 */     GIR_EraseRootFromParent_Done,
     /*  45209 */   // Label 1064: @45209
     /*  45209 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(45271), // Rule ID 18108 //
     /*  45214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45253 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45269 */     GIR_RootConstrainSelectedInstOperands,
     /*  45270 */     // GIR_Coverage, 18108,
     /*  45270 */     GIR_EraseRootFromParent_Done,
     /*  45271 */   // Label 1065: @45271
     /*  45271 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(45333), // Rule ID 18138 //
     /*  45276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45315 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45331 */     GIR_RootConstrainSelectedInstOperands,
     /*  45332 */     // GIR_Coverage, 18138,
     /*  45332 */     GIR_EraseRootFromParent_Done,
     /*  45333 */   // Label 1066: @45333
     /*  45333 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(45395), // Rule ID 20044 //
     /*  45338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45377 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45393 */     GIR_RootConstrainSelectedInstOperands,
     /*  45394 */     // GIR_Coverage, 20044,
     /*  45394 */     GIR_EraseRootFromParent_Done,
     /*  45395 */   // Label 1067: @45395
     /*  45395 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(45627), // Rule ID 21947 //
     /*  45400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  45403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45425 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  45425 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  45428 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45432 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  45439 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  45442 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45446 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45451 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  45454 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45458 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  45461 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45466 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45471 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45476 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  45479 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45483 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  45490 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  45493 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45497 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45502 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  45505 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45509 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  45512 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45517 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45522 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  45530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45541 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  45544 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45548 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45553 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45560 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  45563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  45581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45593 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  45596 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  45599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  45602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  45616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45626 */     // GIR_Coverage, 21947,
     /*  45626 */     GIR_EraseRootFromParent_Done,
     /*  45627 */   // Label 1068: @45627
     /*  45627 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(45673), // Rule ID 21955 //
     /*  45632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45657 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /*  45657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  45660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45662 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45671 */     GIR_RootConstrainSelectedInstOperands,
     /*  45672 */     // GIR_Coverage, 21955,
     /*  45672 */     GIR_EraseRootFromParent_Done,
     /*  45673 */   // Label 1069: @45673
     /*  45673 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(45700), // Rule ID 18096 //
     /*  45678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45693 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  45698 */     GIR_RootConstrainSelectedInstOperands,
     /*  45699 */     // GIR_Coverage, 18096,
     /*  45699 */     GIR_Done,
     /*  45700 */   // Label 1070: @45700
     /*  45700 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(45727), // Rule ID 18122 //
     /*  45705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45720 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  45725 */     GIR_RootConstrainSelectedInstOperands,
     /*  45726 */     // GIR_Coverage, 18122,
     /*  45726 */     GIR_Done,
     /*  45727 */   // Label 1071: @45727
     /*  45727 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(45754), // Rule ID 20036 //
     /*  45732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45747 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  45747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  45752 */     GIR_RootConstrainSelectedInstOperands,
     /*  45753 */     // GIR_Coverage, 20036,
     /*  45753 */     GIR_Done,
     /*  45754 */   // Label 1072: @45754
     /*  45754 */   GIM_Reject,
     /*  45755 */ // Label 1061: @45755
     /*  45755 */ GIM_Reject,
     /*  45756 */ // Label 869: @45756
     /*  45756 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(45953),
     /*  45761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  45764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  45767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45771 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(45829), // Rule ID 25449 //
     /*  45776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45811 */     // (xor:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45827 */     GIR_RootConstrainSelectedInstOperands,
     /*  45828 */     // GIR_Coverage, 25449,
     /*  45828 */     GIR_EraseRootFromParent_Done,
     /*  45829 */   // Label 1074: @45829
     /*  45829 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(45887), // Rule ID 20061 //
     /*  45834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45869 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45885 */     GIR_RootConstrainSelectedInstOperands,
     /*  45886 */     // GIR_Coverage, 20061,
     /*  45886 */     GIR_EraseRootFromParent_Done,
     /*  45887 */   // Label 1075: @45887
     /*  45887 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(45929), // Rule ID 21940 //
     /*  45892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45913 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /*  45913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45927 */     GIR_RootConstrainSelectedInstOperands,
     /*  45928 */     // GIR_Coverage, 21940,
     /*  45928 */     GIR_EraseRootFromParent_Done,
     /*  45929 */   // Label 1076: @45929
     /*  45929 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(45952), // Rule ID 20053 //
     /*  45934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45945 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  45945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  45950 */     GIR_RootConstrainSelectedInstOperands,
     /*  45951 */     // GIR_Coverage, 20053,
     /*  45951 */     GIR_Done,
     /*  45952 */   // Label 1077: @45952
     /*  45952 */   GIM_Reject,
     /*  45953 */ // Label 1073: @45953
     /*  45953 */ GIM_Reject,
     /*  45954 */ // Label 870: @45954
     /*  45954 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(46211),
     /*  45959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45969 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(46029), // Rule ID 23690 //
     /*  45974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46002 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46016 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46027 */     GIR_RootConstrainSelectedInstOperands,
     /*  46028 */     // GIR_Coverage, 23690,
     /*  46028 */     GIR_EraseRootFromParent_Done,
     /*  46029 */   // Label 1079: @46029
     /*  46029 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(46092), // Rule ID 4426 //
     /*  46034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46067 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46077 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  46090 */     GIR_RootConstrainSelectedInstOperands,
     /*  46091 */     // GIR_Coverage, 4426,
     /*  46091 */     GIR_EraseRootFromParent_Done,
     /*  46092 */   // Label 1080: @46092
     /*  46092 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(46152), // Rule ID 23691 //
     /*  46097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46129 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46135 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46139 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46150 */     GIR_RootConstrainSelectedInstOperands,
     /*  46151 */     // GIR_Coverage, 23691,
     /*  46151 */     GIR_EraseRootFromParent_Done,
     /*  46152 */   // Label 1081: @46152
     /*  46152 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(46187), // Rule ID 4414 //
     /*  46157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46168 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46178 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /*  46178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /*  46181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46185 */     GIR_RootConstrainSelectedInstOperands,
     /*  46186 */     // GIR_Coverage, 4414,
     /*  46186 */     GIR_EraseRootFromParent_Done,
     /*  46187 */   // Label 1082: @46187
     /*  46187 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(46210), // Rule ID 4430 //
     /*  46192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46203 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /*  46208 */     GIR_RootConstrainSelectedInstOperands,
     /*  46209 */     // GIR_Coverage, 4430,
     /*  46209 */     GIR_Done,
     /*  46210 */   // Label 1083: @46210
     /*  46210 */   GIM_Reject,
     /*  46211 */ // Label 1078: @46211
     /*  46211 */ GIM_Reject,
     /*  46212 */ // Label 871: @46212
     /*  46212 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(46409),
     /*  46217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  46220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  46223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46227 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(46285), // Rule ID 25448 //
     /*  46232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46267 */     // (xor:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  46274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46283 */     GIR_RootConstrainSelectedInstOperands,
     /*  46284 */     // GIR_Coverage, 25448,
     /*  46284 */     GIR_EraseRootFromParent_Done,
     /*  46285 */   // Label 1085: @46285
     /*  46285 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(46343), // Rule ID 20060 //
     /*  46290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46325 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46341 */     GIR_RootConstrainSelectedInstOperands,
     /*  46342 */     // GIR_Coverage, 20060,
     /*  46342 */     GIR_EraseRootFromParent_Done,
     /*  46343 */   // Label 1086: @46343
     /*  46343 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(46385), // Rule ID 21939 //
     /*  46348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46359 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46365 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46369 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /*  46369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  46372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  46383 */     GIR_RootConstrainSelectedInstOperands,
     /*  46384 */     // GIR_Coverage, 21939,
     /*  46384 */     GIR_EraseRootFromParent_Done,
     /*  46385 */   // Label 1087: @46385
     /*  46385 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(46408), // Rule ID 20052 //
     /*  46390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46401 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  46401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  46406 */     GIR_RootConstrainSelectedInstOperands,
     /*  46407 */     // GIR_Coverage, 20052,
     /*  46407 */     GIR_Done,
     /*  46408 */   // Label 1088: @46408
     /*  46408 */   GIM_Reject,
     /*  46409 */ // Label 1084: @46409
     /*  46409 */ GIM_Reject,
     /*  46410 */ // Label 872: @46410
     /*  46410 */ GIM_Reject,
     /*  46411 */ // Label 6: @46411
     /*  46411 */ GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(46577),
     /*  46416 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  46419 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 1093*/ GIMT_Encode4(46576),
     /*  46430 */   /*GILLT_v16s1*//*Label 1090*/ GIMT_Encode4(46462), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46446 */   /*GILLT_v32s1*//*Label 1091*/ GIMT_Encode4(46500), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46458 */   /*GILLT_v64s1*//*Label 1092*/ GIMT_Encode4(46538),
     /*  46462 */   // Label 1090: @46462
     /*  46462 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(46499), // Rule ID 19503 //
     /*  46467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46470 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  46476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46488 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /*  46488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /*  46491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46493 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46497 */     GIR_RootConstrainSelectedInstOperands,
     /*  46498 */     // GIR_Coverage, 19503,
     /*  46498 */     GIR_EraseRootFromParent_Done,
     /*  46499 */   // Label 1094: @46499
     /*  46499 */   GIM_Reject,
     /*  46500 */   // Label 1091: @46500
     /*  46500 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(46537), // Rule ID 19504 //
     /*  46505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46508 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  46514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46526 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /*  46526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /*  46529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46535 */     GIR_RootConstrainSelectedInstOperands,
     /*  46536 */     // GIR_Coverage, 19504,
     /*  46536 */     GIR_EraseRootFromParent_Done,
     /*  46537 */   // Label 1095: @46537
     /*  46537 */   GIM_Reject,
     /*  46538 */   // Label 1092: @46538
     /*  46538 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(46575), // Rule ID 19505 //
     /*  46543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46546 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  46549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  46552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46564 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /*  46564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /*  46567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46573 */     GIR_RootConstrainSelectedInstOperands,
     /*  46574 */     // GIR_Coverage, 19505,
     /*  46574 */     GIR_EraseRootFromParent_Done,
     /*  46575 */   // Label 1096: @46575
     /*  46575 */   GIM_Reject,
     /*  46576 */   // Label 1093: @46576
     /*  46576 */   GIM_Reject,
     /*  46577 */ // Label 1089: @46577
     /*  46577 */ GIM_Reject,
     /*  46578 */ // Label 7: @46578
     /*  46578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1105*/ GIMT_Encode4(48867),
     /*  46589 */ /*GILLT_s8*//*Label 1097*/ GIMT_Encode4(46681),
     /*  46593 */ /*GILLT_s16*//*Label 1098*/ GIMT_Encode4(46742),
     /*  46597 */ /*GILLT_s32*//*Label 1099*/ GIMT_Encode4(47572),
     /*  46601 */ /*GILLT_s64*//*Label 1100*/ GIMT_Encode4(47998), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46633 */ /*GILLT_v8s1*//*Label 1101*/ GIMT_Encode4(48424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46649 */ /*GILLT_v16s1*//*Label 1102*/ GIMT_Encode4(48585), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46665 */ /*GILLT_v32s1*//*Label 1103*/ GIMT_Encode4(48725), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46677 */ /*GILLT_v64s1*//*Label 1104*/ GIMT_Encode4(48796),
     /*  46681 */ // Label 1097: @46681
     /*  46681 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(46741), // Rule ID 19434 //
     /*  46686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  46693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46697 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /*  46697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46723 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /*  46730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  46735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46740 */   // GIR_Coverage, 19434,
     /*  46740 */   GIR_EraseRootFromParent_Done,
     /*  46741 */ // Label 1106: @46741
     /*  46741 */ GIM_Reject,
     /*  46742 */ // Label 1098: @46742
     /*  46742 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(46802), // Rule ID 19431 //
     /*  46747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46758 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /*  46758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46770 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46784 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46801 */   // GIR_Coverage, 19431,
     /*  46801 */   GIR_EraseRootFromParent_Done,
     /*  46802 */ // Label 1107: @46802
     /*  46802 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(46903), // Rule ID 22140 //
     /*  46807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46821 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /*  46821 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46824 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46828 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46835 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46838 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46842 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46847 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46850 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46854 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /*  46857 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46862 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46867 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /*  46879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46884 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  46902 */   // GIR_Coverage, 22140,
     /*  46902 */   GIR_EraseRootFromParent_Done,
     /*  46903 */ // Label 1108: @46903
     /*  46903 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(46983), // Rule ID 22153 //
     /*  46908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46922 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  46922 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  46925 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46929 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46934 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46938 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  46943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /*  46950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46955 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46965 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46982 */   // GIR_Coverage, 22153,
     /*  46982 */   GIR_EraseRootFromParent_Done,
     /*  46983 */ // Label 1109: @46983
     /*  46983 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(47062), // Rule ID 18340 //
     /*  46988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46998 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46998 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47001 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47005 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47010 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47014 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /*  47026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47044 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47061 */   // GIR_Coverage, 18340,
     /*  47061 */   GIR_EraseRootFromParent_Done,
     /*  47062 */ // Label 1110: @47062
     /*  47062 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(47179), // Rule ID 18341 //
     /*  47067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  47070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47077 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47077 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47080 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47084 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47091 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47094 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47098 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47103 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47106 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47110 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47113 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47118 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47123 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47128 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47131 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47135 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /*  47149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47154 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47157 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47160 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47178 */   // GIR_Coverage, 18341,
     /*  47178 */   GIR_EraseRootFromParent_Done,
     /*  47179 */ // Label 1111: @47179
     /*  47179 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(47258), // Rule ID 18337 //
     /*  47184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47194 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47194 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47197 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47201 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47206 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47210 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  47222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47227 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47230 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47240 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47247 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47257 */   // GIR_Coverage, 18337,
     /*  47257 */   GIR_EraseRootFromParent_Done,
     /*  47258 */ // Label 1112: @47258
     /*  47258 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(47375), // Rule ID 18338 //
     /*  47263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47273 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47273 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47276 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47280 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47287 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47290 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47294 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47299 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47302 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47306 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47309 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47314 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47319 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47324 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47327 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47331 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /*  47345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47350 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47353 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47356 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47374 */   // GIR_Coverage, 18338,
     /*  47374 */   GIR_EraseRootFromParent_Done,
     /*  47375 */ // Label 1113: @47375
     /*  47375 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(47454), // Rule ID 21841 //
     /*  47380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47390 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47390 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47393 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47397 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47402 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47406 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  47411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /*  47418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47423 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47426 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47436 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47453 */   // GIR_Coverage, 21841,
     /*  47453 */   GIR_EraseRootFromParent_Done,
     /*  47454 */ // Label 1114: @47454
     /*  47454 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(47571), // Rule ID 21842 //
     /*  47459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  47469 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  47469 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47472 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47476 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47483 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47486 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47490 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47495 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47498 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47502 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47505 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47510 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47515 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47520 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47523 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47527 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /*  47541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47546 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47549 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47552 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  47570 */   // GIR_Coverage, 21842,
     /*  47570 */   GIR_EraseRootFromParent_Done,
     /*  47571 */ // Label 1115: @47571
     /*  47571 */ GIM_Reject,
     /*  47572 */ // Label 1099: @47572
     /*  47572 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(47638), // Rule ID 22525 //
     /*  47577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  47580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47595 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47602 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47609 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47615 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47622 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  47625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47627 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47636 */   GIR_RootConstrainSelectedInstOperands,
     /*  47637 */   // GIR_Coverage, 22525,
     /*  47637 */   GIR_EraseRootFromParent_Done,
     /*  47638 */ // Label 1116: @47638
     /*  47638 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(47704), // Rule ID 22526 //
     /*  47643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47661 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47664 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47668 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47675 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47681 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47688 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  47691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47693 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47697 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47702 */   GIR_RootConstrainSelectedInstOperands,
     /*  47703 */   // GIR_Coverage, 22526,
     /*  47703 */   GIR_EraseRootFromParent_Done,
     /*  47704 */ // Label 1117: @47704
     /*  47704 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(47770), // Rule ID 22527 //
     /*  47709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47734 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47741 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47747 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47754 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  47757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47759 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47763 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47768 */   GIR_RootConstrainSelectedInstOperands,
     /*  47769 */   // GIR_Coverage, 22527,
     /*  47769 */   GIR_EraseRootFromParent_Done,
     /*  47770 */ // Label 1118: @47770
     /*  47770 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(47796), // Rule ID 2915 //
     /*  47775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47789 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /*  47794 */   GIR_RootConstrainSelectedInstOperands,
     /*  47795 */   // GIR_Coverage, 2915,
     /*  47795 */   GIR_Done,
     /*  47796 */ // Label 1119: @47796
     /*  47796 */ GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(47822), // Rule ID 2916 //
     /*  47801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47815 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /*  47820 */   GIR_RootConstrainSelectedInstOperands,
     /*  47821 */   // GIR_Coverage, 2916,
     /*  47821 */   GIR_Done,
     /*  47822 */ // Label 1120: @47822
     /*  47822 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(47848), // Rule ID 2925 //
     /*  47827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47841 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /*  47846 */   GIR_RootConstrainSelectedInstOperands,
     /*  47847 */   // GIR_Coverage, 2925,
     /*  47847 */   GIR_Done,
     /*  47848 */ // Label 1121: @47848
     /*  47848 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(47874), // Rule ID 2926 //
     /*  47853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47867 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /*  47872 */   GIR_RootConstrainSelectedInstOperands,
     /*  47873 */   // GIR_Coverage, 2926,
     /*  47873 */   GIR_Done,
     /*  47874 */ // Label 1122: @47874
     /*  47874 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(47900), // Rule ID 4598 //
     /*  47879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47893 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47898 */   GIR_RootConstrainSelectedInstOperands,
     /*  47899 */   // GIR_Coverage, 4598,
     /*  47899 */   GIR_Done,
     /*  47900 */ // Label 1123: @47900
     /*  47900 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(47926), // Rule ID 4603 //
     /*  47905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47919 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  47919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  47924 */   GIR_RootConstrainSelectedInstOperands,
     /*  47925 */   // GIR_Coverage, 4603,
     /*  47925 */   GIR_Done,
     /*  47926 */ // Label 1124: @47926
     /*  47926 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(47953), // Rule ID 19442 //
     /*  47931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47942 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /*  47942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  47952 */   // GIR_Coverage, 19442,
     /*  47952 */   GIR_Done,
     /*  47953 */ // Label 1125: @47953
     /*  47953 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(47997), // Rule ID 19876 //
     /*  47958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47969 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /*  47969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /*  47976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47995 */   GIR_RootConstrainSelectedInstOperands,
     /*  47996 */   // GIR_Coverage, 19876,
     /*  47996 */   GIR_EraseRootFromParent_Done,
     /*  47997 */ // Label 1126: @47997
     /*  47997 */ GIM_Reject,
     /*  47998 */ // Label 1100: @47998
     /*  47998 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(48064), // Rule ID 22528 //
     /*  48003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48028 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48035 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48041 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48048 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  48051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48053 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48062 */   GIR_RootConstrainSelectedInstOperands,
     /*  48063 */   // GIR_Coverage, 22528,
     /*  48063 */   GIR_EraseRootFromParent_Done,
     /*  48064 */ // Label 1127: @48064
     /*  48064 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(48130), // Rule ID 22529 //
     /*  48069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48087 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48094 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48101 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48107 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48114 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  48117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48119 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48123 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48128 */   GIR_RootConstrainSelectedInstOperands,
     /*  48129 */   // GIR_Coverage, 22529,
     /*  48129 */   GIR_EraseRootFromParent_Done,
     /*  48130 */ // Label 1128: @48130
     /*  48130 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(48196), // Rule ID 22530 //
     /*  48135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48160 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48167 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48173 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48180 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  48183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48185 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48194 */   GIR_RootConstrainSelectedInstOperands,
     /*  48195 */   // GIR_Coverage, 22530,
     /*  48195 */   GIR_EraseRootFromParent_Done,
     /*  48196 */ // Label 1129: @48196
     /*  48196 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(48222), // Rule ID 2910 //
     /*  48201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48215 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /*  48220 */   GIR_RootConstrainSelectedInstOperands,
     /*  48221 */   // GIR_Coverage, 2910,
     /*  48221 */   GIR_Done,
     /*  48222 */ // Label 1130: @48222
     /*  48222 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(48248), // Rule ID 2914 //
     /*  48227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48241 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /*  48246 */   GIR_RootConstrainSelectedInstOperands,
     /*  48247 */   // GIR_Coverage, 2914,
     /*  48247 */   GIR_Done,
     /*  48248 */ // Label 1131: @48248
     /*  48248 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(48274), // Rule ID 2923 //
     /*  48253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48267 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /*  48272 */   GIR_RootConstrainSelectedInstOperands,
     /*  48273 */   // GIR_Coverage, 2923,
     /*  48273 */   GIR_Done,
     /*  48274 */ // Label 1132: @48274
     /*  48274 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(48300), // Rule ID 2924 //
     /*  48279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48293 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /*  48298 */   GIR_RootConstrainSelectedInstOperands,
     /*  48299 */   // GIR_Coverage, 2924,
     /*  48299 */   GIR_Done,
     /*  48300 */ // Label 1133: @48300
     /*  48300 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(48326), // Rule ID 4596 //
     /*  48305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48319 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48324 */   GIR_RootConstrainSelectedInstOperands,
     /*  48325 */   // GIR_Coverage, 4596,
     /*  48325 */   GIR_Done,
     /*  48326 */ // Label 1134: @48326
     /*  48326 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(48352), // Rule ID 4597 //
     /*  48331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48345 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  48345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48350 */   GIR_RootConstrainSelectedInstOperands,
     /*  48351 */   // GIR_Coverage, 4597,
     /*  48351 */   GIR_Done,
     /*  48352 */ // Label 1135: @48352
     /*  48352 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(48379), // Rule ID 19444 //
     /*  48357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48368 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /*  48368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  48378 */   // GIR_Coverage, 19444,
     /*  48378 */   GIR_Done,
     /*  48379 */ // Label 1136: @48379
     /*  48379 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(48423), // Rule ID 19878 //
     /*  48384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48395 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /*  48395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /*  48402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48407 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48421 */   GIR_RootConstrainSelectedInstOperands,
     /*  48422 */   // GIR_Coverage, 19878,
     /*  48422 */   GIR_EraseRootFromParent_Done,
     /*  48423 */ // Label 1137: @48423
     /*  48423 */ GIM_Reject,
     /*  48424 */ // Label 1101: @48424
     /*  48424 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(48584),
     /*  48429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  48432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  48436 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(48509), // Rule ID 19448 //
     /*  48441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48472 */     // (bitconvert:{ *:[v8i1] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), VK8:{ *:[i32] })
     /*  48472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  48479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48484 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  48488 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48508 */     // GIR_Coverage, 19448,
     /*  48508 */     GIR_EraseRootFromParent_Done,
     /*  48509 */   // Label 1139: @48509
     /*  48509 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(48583), // Rule ID 19433 //
     /*  48514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  48518 */     // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /*  48518 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48521 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48525 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  48554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  48569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48582 */     // GIR_Coverage, 19433,
     /*  48582 */     GIR_EraseRootFromParent_Done,
     /*  48583 */   // Label 1140: @48583
     /*  48583 */   GIM_Reject,
     /*  48584 */ // Label 1138: @48584
     /*  48584 */ GIM_Reject,
     /*  48585 */ // Label 1102: @48585
     /*  48585 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(48724),
     /*  48590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  48597 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(48649), // Rule ID 19449 //
     /*  48602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48620 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  48624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48633 */     // (bitconvert:{ *:[v16i1] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  48633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  48636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48647 */     GIR_RootConstrainSelectedInstOperands,
     /*  48648 */     // GIR_Coverage, 19449,
     /*  48648 */     GIR_EraseRootFromParent_Done,
     /*  48649 */   // Label 1142: @48649
     /*  48649 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(48723), // Rule ID 19430 //
     /*  48654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48658 */     // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /*  48658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /*  48694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  48709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  48722 */     // GIR_Coverage, 19430,
     /*  48722 */     GIR_EraseRootFromParent_Done,
     /*  48723 */   // Label 1143: @48723
     /*  48723 */   GIM_Reject,
     /*  48724 */ // Label 1141: @48724
     /*  48724 */ GIM_Reject,
     /*  48725 */ // Label 1103: @48725
     /*  48725 */ GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(48795),
     /*  48730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  48737 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(48757), // Rule ID 19441 //
     /*  48742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48746 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /*  48746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /*  48756 */     // GIR_Coverage, 19441,
     /*  48756 */     GIR_Done,
     /*  48757 */   // Label 1145: @48757
     /*  48757 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(48794), // Rule ID 19875 //
     /*  48762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  48766 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /*  48766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  48773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /*  48787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48792 */     GIR_RootConstrainSelectedInstOperands,
     /*  48793 */     // GIR_Coverage, 19875,
     /*  48793 */     GIR_EraseRootFromParent_Done,
     /*  48794 */   // Label 1146: @48794
     /*  48794 */   GIM_Reject,
     /*  48795 */ // Label 1144: @48795
     /*  48795 */ GIM_Reject,
     /*  48796 */ // Label 1104: @48796
     /*  48796 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(48866),
     /*  48801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48808 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(48828), // Rule ID 19443 //
     /*  48813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48817 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /*  48817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /*  48827 */     // GIR_Coverage, 19443,
     /*  48827 */     GIR_Done,
     /*  48828 */   // Label 1148: @48828
     /*  48828 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(48865), // Rule ID 19877 //
     /*  48833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48837 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /*  48837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /*  48858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48863 */     GIR_RootConstrainSelectedInstOperands,
     /*  48864 */     // GIR_Coverage, 19877,
     /*  48864 */     GIR_EraseRootFromParent_Done,
     /*  48865 */   // Label 1149: @48865
     /*  48865 */   GIM_Reject,
     /*  48866 */ // Label 1147: @48866
     /*  48866 */ GIM_Reject,
     /*  48867 */ // Label 1105: @48867
     /*  48867 */ GIM_Reject,
     /*  48868 */ // Label 8: @48868
     /*  48868 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1162*/ GIMT_Encode4(52045),
     /*  48879 */ /*GILLT_s16*//*Label 1150*/ GIMT_Encode4(48963),
     /*  48883 */ /*GILLT_s32*//*Label 1151*/ GIMT_Encode4(49024),
     /*  48887 */ /*GILLT_s64*//*Label 1152*/ GIMT_Encode4(49648), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48903 */ /*GILLT_v2s64*//*Label 1153*/ GIMT_Encode4(50272), GIMT_Encode4(0),
     /*  48911 */ /*GILLT_v4s32*//*Label 1154*/ GIMT_Encode4(50361),
     /*  48915 */ /*GILLT_v4s64*//*Label 1155*/ GIMT_Encode4(50807), GIMT_Encode4(0),
     /*  48923 */ /*GILLT_v8s16*//*Label 1156*/ GIMT_Encode4(50986),
     /*  48927 */ /*GILLT_v8s32*//*Label 1157*/ GIMT_Encode4(51075),
     /*  48931 */ /*GILLT_v8s64*//*Label 1158*/ GIMT_Encode4(51426), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48943 */ /*GILLT_v16s16*//*Label 1159*/ GIMT_Encode4(51694),
     /*  48947 */ /*GILLT_v16s32*//*Label 1160*/ GIMT_Encode4(51783), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48959 */ /*GILLT_v32s16*//*Label 1161*/ GIMT_Encode4(51956),
     /*  48963 */ // Label 1150: @48963
     /*  48963 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(49023), // Rule ID 22169 //
     /*  48968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  48971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  48982 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /*  48982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  48989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48994 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49005 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  49012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  49017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  49022 */   // GIR_Coverage, 22169,
     /*  49022 */   GIR_EraseRootFromParent_Done,
     /*  49023 */ // Label 1163: @49023
     /*  49023 */ GIM_Reject,
     /*  49024 */ // Label 1151: @49024
     /*  49024 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(49083), // Rule ID 1756 //
     /*  49029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49047 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49050 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49054 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49058 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49060 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49067 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrm),
     /*  49070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49072 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49081 */   GIR_RootConstrainSelectedInstOperands,
     /*  49082 */   // GIR_Coverage, 1756,
     /*  49082 */   GIR_EraseRootFromParent_Done,
     /*  49083 */ // Label 1164: @49083
     /*  49083 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(49142), // Rule ID 1760 //
     /*  49088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49106 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49109 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49113 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49119 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49126 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrm),
     /*  49129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49131 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49140 */   GIR_RootConstrainSelectedInstOperands,
     /*  49141 */   // GIR_Coverage, 1760,
     /*  49141 */   GIR_EraseRootFromParent_Done,
     /*  49142 */ // Label 1165: @49142
     /*  49142 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(49201), // Rule ID 1780 //
     /*  49147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49165 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49172 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49178 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49185 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrm),
     /*  49188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49190 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49199 */   GIR_RootConstrainSelectedInstOperands,
     /*  49200 */   // GIR_Coverage, 1780,
     /*  49200 */   GIR_EraseRootFromParent_Done,
     /*  49201 */ // Label 1166: @49201
     /*  49201 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(49260), // Rule ID 1784 //
     /*  49206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49216 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49224 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49227 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49231 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49237 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49244 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrm),
     /*  49247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49249 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49258 */   GIR_RootConstrainSelectedInstOperands,
     /*  49259 */   // GIR_Coverage, 1784,
     /*  49259 */   GIR_EraseRootFromParent_Done,
     /*  49260 */ // Label 1167: @49260
     /*  49260 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(49319), // Rule ID 10353 //
     /*  49265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49283 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49290 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49296 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49303 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrm),
     /*  49306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49308 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49317 */   GIR_RootConstrainSelectedInstOperands,
     /*  49318 */   // GIR_Coverage, 10353,
     /*  49318 */   GIR_EraseRootFromParent_Done,
     /*  49319 */ // Label 1168: @49319
     /*  49319 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(49378), // Rule ID 10357 //
     /*  49324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49342 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49345 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49349 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49355 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49362 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrm),
     /*  49365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49367 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49376 */   GIR_RootConstrainSelectedInstOperands,
     /*  49377 */   // GIR_Coverage, 10357,
     /*  49377 */   GIR_EraseRootFromParent_Done,
     /*  49378 */ // Label 1169: @49378
     /*  49378 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(49437), // Rule ID 22171 //
     /*  49383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49401 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49404 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49408 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49412 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49414 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49421 */   // (lrint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /*  49424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49426 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49435 */   GIR_RootConstrainSelectedInstOperands,
     /*  49436 */   // GIR_Coverage, 22171,
     /*  49436 */   GIR_EraseRootFromParent_Done,
     /*  49437 */ // Label 1170: @49437
     /*  49437 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(49467), // Rule ID 1755 //
     /*  49442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49456 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /*  49461 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49465 */   GIR_RootConstrainSelectedInstOperands,
     /*  49466 */   // GIR_Coverage, 1755,
     /*  49466 */   GIR_Done,
     /*  49467 */ // Label 1171: @49467
     /*  49467 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(49497), // Rule ID 1759 //
     /*  49472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49486 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /*  49491 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49495 */   GIR_RootConstrainSelectedInstOperands,
     /*  49496 */   // GIR_Coverage, 1759,
     /*  49496 */   GIR_Done,
     /*  49497 */ // Label 1172: @49497
     /*  49497 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(49527), // Rule ID 1779 //
     /*  49502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49516 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /*  49521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49525 */   GIR_RootConstrainSelectedInstOperands,
     /*  49526 */   // GIR_Coverage, 1779,
     /*  49526 */   GIR_Done,
     /*  49527 */ // Label 1173: @49527
     /*  49527 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(49557), // Rule ID 1783 //
     /*  49532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49546 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /*  49551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49555 */   GIR_RootConstrainSelectedInstOperands,
     /*  49556 */   // GIR_Coverage, 1783,
     /*  49556 */   GIR_Done,
     /*  49557 */ // Label 1174: @49557
     /*  49557 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(49587), // Rule ID 10352 //
     /*  49562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  49576 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  49576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /*  49581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49585 */   GIR_RootConstrainSelectedInstOperands,
     /*  49586 */   // GIR_Coverage, 10352,
     /*  49586 */   GIR_Done,
     /*  49587 */ // Label 1175: @49587
     /*  49587 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(49617), // Rule ID 10356 //
     /*  49592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  49606 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /*  49606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /*  49611 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49615 */   GIR_RootConstrainSelectedInstOperands,
     /*  49616 */   // GIR_Coverage, 10356,
     /*  49616 */   GIR_Done,
     /*  49617 */ // Label 1176: @49617
     /*  49617 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(49647), // Rule ID 22170 //
     /*  49622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49636 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /*  49636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49641 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49645 */   GIR_RootConstrainSelectedInstOperands,
     /*  49646 */   // GIR_Coverage, 22170,
     /*  49646 */   GIR_Done,
     /*  49647 */ // Label 1177: @49647
     /*  49647 */ GIM_Reject,
     /*  49648 */ // Label 1152: @49648
     /*  49648 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(49707), // Rule ID 17990 //
     /*  49653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49671 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49678 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49684 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49691 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  49694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49696 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49705 */   GIR_RootConstrainSelectedInstOperands,
     /*  49706 */   // GIR_Coverage, 17990,
     /*  49706 */   GIR_EraseRootFromParent_Done,
     /*  49707 */ // Label 1178: @49707
     /*  49707 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(49766), // Rule ID 17992 //
     /*  49712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49730 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49733 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49737 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49741 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49743 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49750 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  49753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49764 */   GIR_RootConstrainSelectedInstOperands,
     /*  49765 */   // GIR_Coverage, 17992,
     /*  49765 */   GIR_EraseRootFromParent_Done,
     /*  49766 */ // Label 1179: @49766
     /*  49766 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(49825), // Rule ID 17994 //
     /*  49771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49789 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49796 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49802 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49809 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  49812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49814 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49823 */   GIR_RootConstrainSelectedInstOperands,
     /*  49824 */   // GIR_Coverage, 17994,
     /*  49824 */   GIR_EraseRootFromParent_Done,
     /*  49825 */ // Label 1180: @49825
     /*  49825 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(49884), // Rule ID 17996 //
     /*  49830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49848 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49851 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49855 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49861 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49868 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  49871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49873 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49882 */   GIR_RootConstrainSelectedInstOperands,
     /*  49883 */   // GIR_Coverage, 17996,
     /*  49883 */   GIR_EraseRootFromParent_Done,
     /*  49884 */ // Label 1181: @49884
     /*  49884 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(49943), // Rule ID 21160 //
     /*  49889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49907 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49914 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49920 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49927 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  49930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49932 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49936 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49941 */   GIR_RootConstrainSelectedInstOperands,
     /*  49942 */   // GIR_Coverage, 21160,
     /*  49942 */   GIR_EraseRootFromParent_Done,
     /*  49943 */ // Label 1182: @49943
     /*  49943 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(50002), // Rule ID 21162 //
     /*  49948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49966 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49969 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49973 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49979 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49986 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  49989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49991 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49995 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50000 */   GIR_RootConstrainSelectedInstOperands,
     /*  50001 */   // GIR_Coverage, 21162,
     /*  50001 */   GIR_EraseRootFromParent_Done,
     /*  50002 */ // Label 1183: @50002
     /*  50002 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(50061), // Rule ID 22173 //
     /*  50007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50025 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50028 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50032 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50038 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50045 */   // (lrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  50045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  50048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50050 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50059 */   GIR_RootConstrainSelectedInstOperands,
     /*  50060 */   // GIR_Coverage, 22173,
     /*  50060 */   GIR_EraseRootFromParent_Done,
     /*  50061 */ // Label 1184: @50061
     /*  50061 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(50091), // Rule ID 17989 //
     /*  50066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  50069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50080 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  50085 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50089 */   GIR_RootConstrainSelectedInstOperands,
     /*  50090 */   // GIR_Coverage, 17989,
     /*  50090 */   GIR_Done,
     /*  50091 */ // Label 1185: @50091
     /*  50091 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(50121), // Rule ID 17991 //
     /*  50096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  50099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50110 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  50115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50119 */   GIR_RootConstrainSelectedInstOperands,
     /*  50120 */   // GIR_Coverage, 17991,
     /*  50120 */   GIR_Done,
     /*  50121 */ // Label 1186: @50121
     /*  50121 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(50151), // Rule ID 17993 //
     /*  50126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  50129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50140 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  50145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50149 */   GIR_RootConstrainSelectedInstOperands,
     /*  50150 */   // GIR_Coverage, 17993,
     /*  50150 */   GIR_Done,
     /*  50151 */ // Label 1187: @50151
     /*  50151 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(50181), // Rule ID 17995 //
     /*  50156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50170 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  50175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50179 */   GIR_RootConstrainSelectedInstOperands,
     /*  50180 */   // GIR_Coverage, 17995,
     /*  50180 */   GIR_Done,
     /*  50181 */ // Label 1188: @50181
     /*  50181 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(50211), // Rule ID 21159 //
     /*  50186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50200 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  50205 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50209 */   GIR_RootConstrainSelectedInstOperands,
     /*  50210 */   // GIR_Coverage, 21159,
     /*  50210 */   GIR_Done,
     /*  50211 */ // Label 1189: @50211
     /*  50211 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(50241), // Rule ID 21161 //
     /*  50216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50230 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  50235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50239 */   GIR_RootConstrainSelectedInstOperands,
     /*  50240 */   // GIR_Coverage, 21161,
     /*  50240 */   GIR_Done,
     /*  50241 */ // Label 1190: @50241
     /*  50241 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(50271), // Rule ID 22172 //
     /*  50246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  50260 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  50260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  50265 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50269 */   GIR_RootConstrainSelectedInstOperands,
     /*  50270 */   // GIR_Coverage, 22172,
     /*  50270 */   GIR_Done,
     /*  50271 */ // Label 1191: @50271
     /*  50271 */ GIM_Reject,
     /*  50272 */ // Label 1153: @50272
     /*  50272 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(50360),
     /*  50277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  50280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50284 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(50336), // Rule ID 21385 //
     /*  50289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50320 */     // (lrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  50320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  50323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50334 */     GIR_RootConstrainSelectedInstOperands,
     /*  50335 */     // GIR_Coverage, 21385,
     /*  50335 */     GIR_EraseRootFromParent_Done,
     /*  50336 */   // Label 1193: @50336
     /*  50336 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(50359), // Rule ID 21384 //
     /*  50341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50348 */     // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  50348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  50353 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50357 */     GIR_RootConstrainSelectedInstOperands,
     /*  50358 */     // GIR_Coverage, 21384,
     /*  50358 */     GIR_Done,
     /*  50359 */   // Label 1194: @50359
     /*  50359 */   GIM_Reject,
     /*  50360 */ // Label 1192: @50360
     /*  50360 */ GIM_Reject,
     /*  50361 */ // Label 1154: @50361
     /*  50361 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(50420), // Rule ID 18044 //
     /*  50366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50384 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50387 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50391 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50395 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50397 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50404 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrm),
     /*  50407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50409 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50418 */   GIR_RootConstrainSelectedInstOperands,
     /*  50419 */   // GIR_Coverage, 18044,
     /*  50419 */   GIR_EraseRootFromParent_Done,
     /*  50420 */ // Label 1195: @50420
     /*  50420 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(50479), // Rule ID 18048 //
     /*  50425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50443 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50446 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50450 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50456 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50463 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrm),
     /*  50466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50468 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50477 */   GIR_RootConstrainSelectedInstOperands,
     /*  50478 */   // GIR_Coverage, 18048,
     /*  50478 */   GIR_EraseRootFromParent_Done,
     /*  50479 */ // Label 1196: @50479
     /*  50479 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(50538), // Rule ID 18050 //
     /*  50484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50502 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50509 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50513 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50515 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50522 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrm),
     /*  50525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50527 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50536 */   GIR_RootConstrainSelectedInstOperands,
     /*  50537 */   // GIR_Coverage, 18050,
     /*  50537 */   GIR_EraseRootFromParent_Done,
     /*  50538 */ // Label 1197: @50538
     /*  50538 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(50597), // Rule ID 21357 //
     /*  50543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50561 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50568 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50574 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50581 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rm),
     /*  50584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50586 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50595 */   GIR_RootConstrainSelectedInstOperands,
     /*  50596 */   // GIR_Coverage, 21357,
     /*  50596 */   GIR_EraseRootFromParent_Done,
     /*  50597 */ // Label 1198: @50597
     /*  50597 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(50656), // Rule ID 21361 //
     /*  50602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50620 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50623 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50627 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50633 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50640 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZ256rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rm),
     /*  50643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50645 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50654 */   GIR_RootConstrainSelectedInstOperands,
     /*  50655 */   // GIR_Coverage, 21361,
     /*  50655 */   GIR_EraseRootFromParent_Done,
     /*  50656 */ // Label 1199: @50656
     /*  50656 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(50686), // Rule ID 18043 //
     /*  50661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50675 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /*  50680 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50684 */   GIR_RootConstrainSelectedInstOperands,
     /*  50685 */   // GIR_Coverage, 18043,
     /*  50685 */   GIR_Done,
     /*  50686 */ // Label 1200: @50686
     /*  50686 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(50716), // Rule ID 18047 //
     /*  50691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50705 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /*  50705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /*  50710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50714 */   GIR_RootConstrainSelectedInstOperands,
     /*  50715 */   // GIR_Coverage, 18047,
     /*  50715 */   GIR_Done,
     /*  50716 */ // Label 1201: @50716
     /*  50716 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(50746), // Rule ID 18049 //
     /*  50721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50735 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /*  50740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50744 */   GIR_RootConstrainSelectedInstOperands,
     /*  50745 */   // GIR_Coverage, 18049,
     /*  50745 */   GIR_Done,
     /*  50746 */ // Label 1202: @50746
     /*  50746 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(50776), // Rule ID 21356 //
     /*  50751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50765 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /*  50765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /*  50770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50774 */   GIR_RootConstrainSelectedInstOperands,
     /*  50775 */   // GIR_Coverage, 21356,
     /*  50775 */   GIR_Done,
     /*  50776 */ // Label 1203: @50776
     /*  50776 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(50806), // Rule ID 21360 //
     /*  50781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50795 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /*  50795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /*  50800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50804 */   GIR_RootConstrainSelectedInstOperands,
     /*  50805 */   // GIR_Coverage, 21360,
     /*  50805 */   GIR_Done,
     /*  50806 */ // Label 1204: @50806
     /*  50806 */ GIM_Reject,
     /*  50807 */ // Label 1155: @50807
     /*  50807 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(50866), // Rule ID 21381 //
     /*  50812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50830 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50837 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50841 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50843 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50850 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  50853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50855 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50864 */   GIR_RootConstrainSelectedInstOperands,
     /*  50865 */   // GIR_Coverage, 21381,
     /*  50865 */   GIR_EraseRootFromParent_Done,
     /*  50866 */ // Label 1205: @50866
     /*  50866 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(50925), // Rule ID 21387 //
     /*  50871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50889 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50896 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50902 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50909 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  50912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50914 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50923 */   GIR_RootConstrainSelectedInstOperands,
     /*  50924 */   // GIR_Coverage, 21387,
     /*  50924 */   GIR_EraseRootFromParent_Done,
     /*  50925 */ // Label 1206: @50925
     /*  50925 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(50955), // Rule ID 21380 //
     /*  50930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50944 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  50944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  50949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50953 */   GIR_RootConstrainSelectedInstOperands,
     /*  50954 */   // GIR_Coverage, 21380,
     /*  50954 */   GIR_Done,
     /*  50955 */ // Label 1207: @50955
     /*  50955 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(50985), // Rule ID 21386 //
     /*  50960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50974 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  50974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  50979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50983 */   GIR_RootConstrainSelectedInstOperands,
     /*  50984 */   // GIR_Coverage, 21386,
     /*  50984 */   GIR_Done,
     /*  50985 */ // Label 1208: @50985
     /*  50985 */ GIM_Reject,
     /*  50986 */ // Label 1156: @50986
     /*  50986 */ GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(51074),
     /*  50991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50998 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(51050), // Rule ID 22156 //
     /*  51003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51034 */     // (lrint:{ *:[v8i16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  51034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rm),
     /*  51037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51048 */     GIR_RootConstrainSelectedInstOperands,
     /*  51049 */     // GIR_Coverage, 22156,
     /*  51049 */     GIR_EraseRootFromParent_Done,
     /*  51050 */   // Label 1210: @51050
     /*  51050 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(51073), // Rule ID 22155 //
     /*  51055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51062 */     // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /*  51062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /*  51067 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51071 */     GIR_RootConstrainSelectedInstOperands,
     /*  51072 */     // GIR_Coverage, 22155,
     /*  51072 */     GIR_Done,
     /*  51073 */   // Label 1211: @51073
     /*  51073 */   GIM_Reject,
     /*  51074 */ // Label 1209: @51074
     /*  51074 */ GIM_Reject,
     /*  51075 */ // Label 1157: @51075
     /*  51075 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(51134), // Rule ID 18046 //
     /*  51080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51098 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51101 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51105 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51111 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51118 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrm),
     /*  51121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51123 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51132 */   GIR_RootConstrainSelectedInstOperands,
     /*  51133 */   // GIR_Coverage, 18046,
     /*  51133 */   GIR_EraseRootFromParent_Done,
     /*  51134 */ // Label 1212: @51134
     /*  51134 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(51193), // Rule ID 21359 //
     /*  51139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51157 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51160 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51164 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51170 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51177 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rm),
     /*  51180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51182 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51191 */   GIR_RootConstrainSelectedInstOperands,
     /*  51192 */   // GIR_Coverage, 21359,
     /*  51192 */   GIR_EraseRootFromParent_Done,
     /*  51193 */ // Label 1213: @51193
     /*  51193 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(51249), // Rule ID 21365 //
     /*  51198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51213 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51216 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51220 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51224 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51226 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51233 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrm),
     /*  51236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51238 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51247 */   GIR_RootConstrainSelectedInstOperands,
     /*  51248 */   // GIR_Coverage, 21365,
     /*  51248 */   GIR_EraseRootFromParent_Done,
     /*  51249 */ // Label 1214: @51249
     /*  51249 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(51308), // Rule ID 22160 //
     /*  51254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51272 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51279 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51285 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51292 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rm),
     /*  51295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51306 */   GIR_RootConstrainSelectedInstOperands,
     /*  51307 */   // GIR_Coverage, 22160,
     /*  51307 */   GIR_EraseRootFromParent_Done,
     /*  51308 */ // Label 1215: @51308
     /*  51308 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(51338), // Rule ID 18045 //
     /*  51313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51327 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /*  51327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /*  51332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51336 */   GIR_RootConstrainSelectedInstOperands,
     /*  51337 */   // GIR_Coverage, 18045,
     /*  51337 */   GIR_Done,
     /*  51338 */ // Label 1216: @51338
     /*  51338 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(51368), // Rule ID 21358 //
     /*  51343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51357 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /*  51357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /*  51362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51366 */   GIR_RootConstrainSelectedInstOperands,
     /*  51367 */   // GIR_Coverage, 21358,
     /*  51367 */   GIR_Done,
     /*  51368 */ // Label 1217: @51368
     /*  51368 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(51395), // Rule ID 21364 //
     /*  51373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51384 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /*  51384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /*  51389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51393 */   GIR_RootConstrainSelectedInstOperands,
     /*  51394 */   // GIR_Coverage, 21364,
     /*  51394 */   GIR_Done,
     /*  51395 */ // Label 1218: @51395
     /*  51395 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(51425), // Rule ID 22159 //
     /*  51400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51414 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /*  51414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /*  51419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51423 */   GIR_RootConstrainSelectedInstOperands,
     /*  51424 */   // GIR_Coverage, 22159,
     /*  51424 */   GIR_Done,
     /*  51425 */ // Label 1219: @51425
     /*  51425 */ GIM_Reject,
     /*  51426 */ // Label 1158: @51426
     /*  51426 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(51485), // Rule ID 21393 //
     /*  51431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51449 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51456 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51462 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51469 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  51472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51474 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51483 */   GIR_RootConstrainSelectedInstOperands,
     /*  51484 */   // GIR_Coverage, 21393,
     /*  51484 */   GIR_EraseRootFromParent_Done,
     /*  51485 */ // Label 1220: @51485
     /*  51485 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(51544), // Rule ID 21397 //
     /*  51490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51508 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51515 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51521 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51528 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  51531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51533 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51542 */   GIR_RootConstrainSelectedInstOperands,
     /*  51543 */   // GIR_Coverage, 21397,
     /*  51543 */   GIR_EraseRootFromParent_Done,
     /*  51544 */ // Label 1221: @51544
     /*  51544 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(51603), // Rule ID 22166 //
     /*  51549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51567 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51570 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51574 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51580 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51587 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  51590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51592 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51601 */   GIR_RootConstrainSelectedInstOperands,
     /*  51602 */   // GIR_Coverage, 22166,
     /*  51602 */   GIR_EraseRootFromParent_Done,
     /*  51603 */ // Label 1222: @51603
     /*  51603 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(51633), // Rule ID 21392 //
     /*  51608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51622 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  51622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  51627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51631 */   GIR_RootConstrainSelectedInstOperands,
     /*  51632 */   // GIR_Coverage, 21392,
     /*  51632 */   GIR_Done,
     /*  51633 */ // Label 1223: @51633
     /*  51633 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(51663), // Rule ID 21396 //
     /*  51638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51652 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  51652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  51657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51661 */   GIR_RootConstrainSelectedInstOperands,
     /*  51662 */   // GIR_Coverage, 21396,
     /*  51662 */   GIR_Done,
     /*  51663 */ // Label 1224: @51663
     /*  51663 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(51693), // Rule ID 22165 //
     /*  51668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51682 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  51682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  51687 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51691 */   GIR_RootConstrainSelectedInstOperands,
     /*  51692 */   // GIR_Coverage, 22165,
     /*  51692 */   GIR_Done,
     /*  51693 */ // Label 1225: @51693
     /*  51693 */ GIM_Reject,
     /*  51694 */ // Label 1159: @51694
     /*  51694 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(51782),
     /*  51699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51706 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(51758), // Rule ID 22158 //
     /*  51711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51742 */     // (lrint:{ *:[v16i16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  51742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rm),
     /*  51745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51756 */     GIR_RootConstrainSelectedInstOperands,
     /*  51757 */     // GIR_Coverage, 22158,
     /*  51757 */     GIR_EraseRootFromParent_Done,
     /*  51758 */   // Label 1227: @51758
     /*  51758 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(51781), // Rule ID 22157 //
     /*  51763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51770 */     // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /*  51770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /*  51775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51779 */     GIR_RootConstrainSelectedInstOperands,
     /*  51780 */     // GIR_Coverage, 22157,
     /*  51780 */     GIR_Done,
     /*  51781 */   // Label 1228: @51781
     /*  51781 */   GIM_Reject,
     /*  51782 */ // Label 1226: @51782
     /*  51782 */ GIM_Reject,
     /*  51783 */ // Label 1160: @51783
     /*  51783 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(51839), // Rule ID 21363 //
     /*  51788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51803 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51810 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51816 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51823 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrm),
     /*  51826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51828 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51837 */   GIR_RootConstrainSelectedInstOperands,
     /*  51838 */   // GIR_Coverage, 21363,
     /*  51838 */   GIR_EraseRootFromParent_Done,
     /*  51839 */ // Label 1229: @51839
     /*  51839 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(51898), // Rule ID 22164 //
     /*  51844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51862 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51865 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51869 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51875 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51882 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrm),
     /*  51885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51887 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51896 */   GIR_RootConstrainSelectedInstOperands,
     /*  51897 */   // GIR_Coverage, 22164,
     /*  51897 */   GIR_EraseRootFromParent_Done,
     /*  51898 */ // Label 1230: @51898
     /*  51898 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(51925), // Rule ID 21362 //
     /*  51903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51914 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /*  51914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /*  51919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51923 */   GIR_RootConstrainSelectedInstOperands,
     /*  51924 */   // GIR_Coverage, 21362,
     /*  51924 */   GIR_Done,
     /*  51925 */ // Label 1231: @51925
     /*  51925 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(51955), // Rule ID 22163 //
     /*  51930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51944 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /*  51944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /*  51949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51953 */   GIR_RootConstrainSelectedInstOperands,
     /*  51954 */   // GIR_Coverage, 22163,
     /*  51954 */   GIR_Done,
     /*  51955 */ // Label 1232: @51955
     /*  51955 */ GIM_Reject,
     /*  51956 */ // Label 1161: @51956
     /*  51956 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(52044),
     /*  51961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  51964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51968 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(52020), // Rule ID 22162 //
     /*  51973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52004 */     // (lrint:{ *:[v32i16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  52004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrm),
     /*  52007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52018 */     GIR_RootConstrainSelectedInstOperands,
     /*  52019 */     // GIR_Coverage, 22162,
     /*  52019 */     GIR_EraseRootFromParent_Done,
     /*  52020 */   // Label 1234: @52020
     /*  52020 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(52043), // Rule ID 22161 //
     /*  52025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  52028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52032 */     // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /*  52032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /*  52037 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52041 */     GIR_RootConstrainSelectedInstOperands,
     /*  52042 */     // GIR_Coverage, 22161,
     /*  52042 */     GIR_Done,
     /*  52043 */   // Label 1235: @52043
     /*  52043 */   GIM_Reject,
     /*  52044 */ // Label 1233: @52044
     /*  52044 */ GIM_Reject,
     /*  52045 */ // Label 1162: @52045
     /*  52045 */ GIM_Reject,
     /*  52046 */ // Label 9: @52046
     /*  52046 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 1240*/ GIMT_Encode4(53265),
     /*  52057 */ /*GILLT_s64*//*Label 1236*/ GIMT_Encode4(52105), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52073 */ /*GILLT_v2s64*//*Label 1237*/ GIMT_Encode4(52729), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52085 */ /*GILLT_v4s64*//*Label 1238*/ GIMT_Encode4(52818), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52101 */ /*GILLT_v8s64*//*Label 1239*/ GIMT_Encode4(52997),
     /*  52105 */ // Label 1236: @52105
     /*  52105 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(52164), // Rule ID 1758 //
     /*  52110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52128 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52131 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52135 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52141 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52148 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  52151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52153 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52162 */   GIR_RootConstrainSelectedInstOperands,
     /*  52163 */   // GIR_Coverage, 1758,
     /*  52163 */   GIR_EraseRootFromParent_Done,
     /*  52164 */ // Label 1241: @52164
     /*  52164 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(52223), // Rule ID 1762 //
     /*  52169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52187 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52194 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52198 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52200 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52207 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  52210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52212 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52221 */   GIR_RootConstrainSelectedInstOperands,
     /*  52222 */   // GIR_Coverage, 1762,
     /*  52222 */   GIR_EraseRootFromParent_Done,
     /*  52223 */ // Label 1242: @52223
     /*  52223 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(52282), // Rule ID 1782 //
     /*  52228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52246 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52253 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52259 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52266 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  52269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52271 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52280 */   GIR_RootConstrainSelectedInstOperands,
     /*  52281 */   // GIR_Coverage, 1782,
     /*  52281 */   GIR_EraseRootFromParent_Done,
     /*  52282 */ // Label 1243: @52282
     /*  52282 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(52341), // Rule ID 1786 //
     /*  52287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52305 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52312 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52316 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52318 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52325 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  52328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52330 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52339 */   GIR_RootConstrainSelectedInstOperands,
     /*  52340 */   // GIR_Coverage, 1786,
     /*  52340 */   GIR_EraseRootFromParent_Done,
     /*  52341 */ // Label 1244: @52341
     /*  52341 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(52400), // Rule ID 10355 //
     /*  52346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52364 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52367 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52371 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52377 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52384 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  52387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52389 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52398 */   GIR_RootConstrainSelectedInstOperands,
     /*  52399 */   // GIR_Coverage, 10355,
     /*  52399 */   GIR_EraseRootFromParent_Done,
     /*  52400 */ // Label 1245: @52400
     /*  52400 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(52459), // Rule ID 10359 //
     /*  52405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52423 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52426 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52430 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52436 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52443 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  52446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52448 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52457 */   GIR_RootConstrainSelectedInstOperands,
     /*  52458 */   // GIR_Coverage, 10359,
     /*  52458 */   GIR_EraseRootFromParent_Done,
     /*  52459 */ // Label 1246: @52459
     /*  52459 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(52518), // Rule ID 22175 //
     /*  52464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52482 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52485 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52489 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52493 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52495 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52502 */   // (llrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  52505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52507 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52511 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52516 */   GIR_RootConstrainSelectedInstOperands,
     /*  52517 */   // GIR_Coverage, 22175,
     /*  52517 */   GIR_EraseRootFromParent_Done,
     /*  52518 */ // Label 1247: @52518
     /*  52518 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(52548), // Rule ID 1757 //
     /*  52523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52537 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  52542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52546 */   GIR_RootConstrainSelectedInstOperands,
     /*  52547 */   // GIR_Coverage, 1757,
     /*  52547 */   GIR_Done,
     /*  52548 */ // Label 1248: @52548
     /*  52548 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(52578), // Rule ID 1761 //
     /*  52553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52567 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  52572 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52576 */   GIR_RootConstrainSelectedInstOperands,
     /*  52577 */   // GIR_Coverage, 1761,
     /*  52577 */   GIR_Done,
     /*  52578 */ // Label 1249: @52578
     /*  52578 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(52608), // Rule ID 1781 //
     /*  52583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52597 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  52602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52606 */   GIR_RootConstrainSelectedInstOperands,
     /*  52607 */   // GIR_Coverage, 1781,
     /*  52607 */   GIR_Done,
     /*  52608 */ // Label 1250: @52608
     /*  52608 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(52638), // Rule ID 1785 //
     /*  52613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52627 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  52632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52636 */   GIR_RootConstrainSelectedInstOperands,
     /*  52637 */   // GIR_Coverage, 1785,
     /*  52637 */   GIR_Done,
     /*  52638 */ // Label 1251: @52638
     /*  52638 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(52668), // Rule ID 10354 //
     /*  52643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  52657 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /*  52657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  52662 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52666 */   GIR_RootConstrainSelectedInstOperands,
     /*  52667 */   // GIR_Coverage, 10354,
     /*  52667 */   GIR_Done,
     /*  52668 */ // Label 1252: @52668
     /*  52668 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(52698), // Rule ID 10358 //
     /*  52673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  52687 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  52687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  52692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52696 */   GIR_RootConstrainSelectedInstOperands,
     /*  52697 */   // GIR_Coverage, 10358,
     /*  52697 */   GIR_Done,
     /*  52698 */ // Label 1253: @52698
     /*  52698 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(52728), // Rule ID 22174 //
     /*  52703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  52717 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  52717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  52722 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52726 */   GIR_RootConstrainSelectedInstOperands,
     /*  52727 */   // GIR_Coverage, 22174,
     /*  52727 */   GIR_Done,
     /*  52728 */ // Label 1254: @52728
     /*  52728 */ GIM_Reject,
     /*  52729 */ // Label 1237: @52729
     /*  52729 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(52817),
     /*  52734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52741 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(52793), // Rule ID 21389 //
     /*  52746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52777 */     // (llrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  52777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  52780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52791 */     GIR_RootConstrainSelectedInstOperands,
     /*  52792 */     // GIR_Coverage, 21389,
     /*  52792 */     GIR_EraseRootFromParent_Done,
     /*  52793 */   // Label 1256: @52793
     /*  52793 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(52816), // Rule ID 21388 //
     /*  52798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52805 */     // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  52805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  52810 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52814 */     GIR_RootConstrainSelectedInstOperands,
     /*  52815 */     // GIR_Coverage, 21388,
     /*  52815 */     GIR_Done,
     /*  52816 */   // Label 1257: @52816
     /*  52816 */   GIM_Reject,
     /*  52817 */ // Label 1255: @52817
     /*  52817 */ GIM_Reject,
     /*  52818 */ // Label 1238: @52818
     /*  52818 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(52877), // Rule ID 21383 //
     /*  52823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52841 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52848 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52854 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52861 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  52864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52866 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52875 */   GIR_RootConstrainSelectedInstOperands,
     /*  52876 */   // GIR_Coverage, 21383,
     /*  52876 */   GIR_EraseRootFromParent_Done,
     /*  52877 */ // Label 1258: @52877
     /*  52877 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(52936), // Rule ID 21391 //
     /*  52882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52892 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52896 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52900 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52903 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52907 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52913 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52920 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  52923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52925 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52934 */   GIR_RootConstrainSelectedInstOperands,
     /*  52935 */   // GIR_Coverage, 21391,
     /*  52935 */   GIR_EraseRootFromParent_Done,
     /*  52936 */ // Label 1259: @52936
     /*  52936 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(52966), // Rule ID 21382 //
     /*  52941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52955 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  52955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  52960 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52964 */   GIR_RootConstrainSelectedInstOperands,
     /*  52965 */   // GIR_Coverage, 21382,
     /*  52965 */   GIR_Done,
     /*  52966 */ // Label 1260: @52966
     /*  52966 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(52996), // Rule ID 21390 //
     /*  52971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52985 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  52985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  52990 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52994 */   GIR_RootConstrainSelectedInstOperands,
     /*  52995 */   // GIR_Coverage, 21390,
     /*  52995 */   GIR_Done,
     /*  52996 */ // Label 1261: @52996
     /*  52996 */ GIM_Reject,
     /*  52997 */ // Label 1239: @52997
     /*  52997 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(53056), // Rule ID 21395 //
     /*  53002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  53008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53012 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53016 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53020 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53027 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53033 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53040 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  53043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53045 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53054 */   GIR_RootConstrainSelectedInstOperands,
     /*  53055 */   // GIR_Coverage, 21395,
     /*  53055 */   GIR_EraseRootFromParent_Done,
     /*  53056 */ // Label 1262: @53056
     /*  53056 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(53115), // Rule ID 21399 //
     /*  53061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53079 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53086 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53090 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53092 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53099 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  53102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53104 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53113 */   GIR_RootConstrainSelectedInstOperands,
     /*  53114 */   // GIR_Coverage, 21399,
     /*  53114 */   GIR_EraseRootFromParent_Done,
     /*  53115 */ // Label 1263: @53115
     /*  53115 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(53174), // Rule ID 22168 //
     /*  53120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53138 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53141 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53145 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53151 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53158 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  53161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53163 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53172 */   GIR_RootConstrainSelectedInstOperands,
     /*  53173 */   // GIR_Coverage, 22168,
     /*  53173 */   GIR_EraseRootFromParent_Done,
     /*  53174 */ // Label 1264: @53174
     /*  53174 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(53204), // Rule ID 21394 //
     /*  53179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  53185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  53193 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  53193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  53198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53202 */   GIR_RootConstrainSelectedInstOperands,
     /*  53203 */   // GIR_Coverage, 21394,
     /*  53203 */   GIR_Done,
     /*  53204 */ // Label 1265: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(53234), // Rule ID 21398 //
     /*  53209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53223 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  53223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  53228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53232 */   GIR_RootConstrainSelectedInstOperands,
     /*  53233 */   // GIR_Coverage, 21398,
     /*  53233 */   GIR_Done,
     /*  53234 */ // Label 1266: @53234
     /*  53234 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(53264), // Rule ID 22167 //
     /*  53239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  53253 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  53253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  53258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53262 */   GIR_RootConstrainSelectedInstOperands,
     /*  53263 */   // GIR_Coverage, 22167,
     /*  53263 */   GIR_Done,
     /*  53264 */ // Label 1267: @53264
     /*  53264 */ GIM_Reject,
     /*  53265 */ // Label 1240: @53265
     /*  53265 */ GIM_Reject,
     /*  53266 */ // Label 10: @53266
     /*  53266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 1293*/ GIMT_Encode4(59490),
     /*  53277 */ /*GILLT_s1*//*Label 1268*/ GIMT_Encode4(53377),
     /*  53281 */ /*GILLT_s8*//*Label 1269*/ GIMT_Encode4(53444),
     /*  53285 */ /*GILLT_s16*//*Label 1270*/ GIMT_Encode4(53585),
     /*  53289 */ /*GILLT_s32*//*Label 1271*/ GIMT_Encode4(54138),
     /*  53293 */ /*GILLT_s64*//*Label 1272*/ GIMT_Encode4(54560),
     /*  53297 */ /*GILLT_s80*//*Label 1273*/ GIMT_Encode4(55133),
     /*  53301 */ /*GILLT_s128*//*Label 1274*/ GIMT_Encode4(55292),
     /*  53305 */ /*GILLT_v2s1*//*Label 1275*/ GIMT_Encode4(55420),
     /*  53309 */ /*GILLT_v2s64*//*Label 1276*/ GIMT_Encode4(55487),
     /*  53313 */ /*GILLT_v4s1*//*Label 1277*/ GIMT_Encode4(55981),
     /*  53317 */ /*GILLT_v4s32*//*Label 1278*/ GIMT_Encode4(56048),
     /*  53321 */ /*GILLT_v4s64*//*Label 1279*/ GIMT_Encode4(56542),
     /*  53325 */ /*GILLT_v8s1*//*Label 1280*/ GIMT_Encode4(56876),
     /*  53329 */ /*GILLT_v8s16*//*Label 1281*/ GIMT_Encode4(56958),
     /*  53333 */ /*GILLT_v8s32*//*Label 1282*/ GIMT_Encode4(57532),
     /*  53337 */ /*GILLT_v8s64*//*Label 1283*/ GIMT_Encode4(57866),
     /*  53341 */ /*GILLT_v16s1*//*Label 1284*/ GIMT_Encode4(58040),
     /*  53345 */ /*GILLT_v16s8*//*Label 1285*/ GIMT_Encode4(58122),
     /*  53349 */ /*GILLT_v16s16*//*Label 1286*/ GIMT_Encode4(58376),
     /*  53353 */ /*GILLT_v16s32*//*Label 1287*/ GIMT_Encode4(58710),
     /*  53357 */ /*GILLT_v32s1*//*Label 1288*/ GIMT_Encode4(58884),
     /*  53361 */ /*GILLT_v32s8*//*Label 1289*/ GIMT_Encode4(58966),
     /*  53365 */ /*GILLT_v32s16*//*Label 1290*/ GIMT_Encode4(59140),
     /*  53369 */ /*GILLT_v64s1*//*Label 1291*/ GIMT_Encode4(59314),
     /*  53373 */ /*GILLT_v64s8*//*Label 1292*/ GIMT_Encode4(59396),
     /*  53377 */ // Label 1268: @53377
     /*  53377 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(53443), // Rule ID 19445 //
     /*  53382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  53396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53407 */   // (ld:{ *:[v1i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK1:{ *:[i32] })
     /*  53407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  53410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  53414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53419 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53423 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  53442 */   // GIR_Coverage, 19445,
     /*  53442 */   GIR_EraseRootFromParent_Done,
     /*  53443 */ // Label 1294: @53443
     /*  53443 */ GIM_Reject,
     /*  53444 */ // Label 1269: @53444
     /*  53444 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(53493), // Rule ID 22515 //
     /*  53449 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53456 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53467 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53478 */   // (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53483 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53491 */   GIR_RootConstrainSelectedInstOperands,
     /*  53492 */   // GIR_Coverage, 22515,
     /*  53492 */   GIR_EraseRootFromParent_Done,
     /*  53493 */ // Label 1295: @53493
     /*  53493 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(53542), // Rule ID 22580 //
     /*  53498 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53501 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53505 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53527 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53532 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53540 */   GIR_RootConstrainSelectedInstOperands,
     /*  53541 */   // GIR_Coverage, 22580,
     /*  53541 */   GIR_EraseRootFromParent_Done,
     /*  53542 */ // Label 1296: @53542
     /*  53542 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(53584), // Rule ID 28 //
     /*  53547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53558 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  53562 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53569 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53574 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53578 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53582 */   GIR_RootConstrainSelectedInstOperands,
     /*  53583 */   // GIR_Coverage, 28,
     /*  53583 */   GIR_EraseRootFromParent_Done,
     /*  53584 */ // Label 1297: @53584
     /*  53584 */ GIM_Reject,
     /*  53585 */ // Label 1270: @53585
     /*  53585 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(53634), // Rule ID 22516 //
     /*  53590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53597 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  53604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53619 */   // (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53624 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53632 */   GIR_RootConstrainSelectedInstOperands,
     /*  53633 */   // GIR_Coverage, 22516,
     /*  53633 */   GIR_EraseRootFromParent_Done,
     /*  53634 */ // Label 1298: @53634
     /*  53634 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(53713), // Rule ID 22581 //
     /*  53639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53642 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53668 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53680 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53684 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53695 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53702 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53712 */   // GIR_Coverage, 22581,
     /*  53712 */   GIR_EraseRootFromParent_Done,
     /*  53713 */ // Label 1299: @53713
     /*  53713 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(53792), // Rule ID 22583 //
     /*  53718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53721 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53725 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53747 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53759 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53763 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53774 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53791 */   // GIR_Coverage, 22583,
     /*  53791 */   GIR_EraseRootFromParent_Done,
     /*  53792 */ // Label 1300: @53792
     /*  53792 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(53837), // Rule ID 4621 //
     /*  53797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53815 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53822 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSHZrm_alt:{ *:[f16] } addr:{ *:[iPTR] }:$src)
     /*  53822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZrm_alt),
     /*  53825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53827 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53835 */   GIR_RootConstrainSelectedInstOperands,
     /*  53836 */   // GIR_Coverage, 4621,
     /*  53836 */   GIR_EraseRootFromParent_Done,
     /*  53837 */ // Label 1301: @53837
     /*  53837 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(53923), // Rule ID 18339 //
     /*  53842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  53845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53867 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53867 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53870 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53874 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrmi),
     /*  53888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53893 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53896 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53900 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53903 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53922 */   // GIR_Coverage, 18339,
     /*  53922 */   GIR_EraseRootFromParent_Done,
     /*  53923 */ // Label 1302: @53923
     /*  53923 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(53965), // Rule ID 29 //
     /*  53928 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53939 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  53943 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53950 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53955 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53963 */   GIR_RootConstrainSelectedInstOperands,
     /*  53964 */   // GIR_Coverage, 29,
     /*  53964 */   GIR_EraseRootFromParent_Done,
     /*  53965 */ // Label 1303: @53965
     /*  53965 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(54051), // Rule ID 18335 //
     /*  53970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  53973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53995 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  54002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  54012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrmi),
     /*  54016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54021 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54024 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54028 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  54031 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54045 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  54050 */   // GIR_Coverage, 18335,
     /*  54050 */   GIR_EraseRootFromParent_Done,
     /*  54051 */ // Label 1304: @54051
     /*  54051 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(54137), // Rule ID 21839 //
     /*  54056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  54059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  54070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54081 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  54081 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  54084 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  54088 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  54098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrmi),
     /*  54102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54107 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54110 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54114 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  54117 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  54136 */   // GIR_Coverage, 21839,
     /*  54136 */   GIR_EraseRootFromParent_Done,
     /*  54137 */ // Label 1305: @54137
     /*  54137 */ GIM_Reject,
     /*  54138 */ // Label 1271: @54138
     /*  54138 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(54186), // Rule ID 1080 //
     /*  54143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  54146 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54149 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  54157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54168 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp32m:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m),
     /*  54171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54173 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54177 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54184 */   GIR_RootConstrainSelectedInstOperands,
     /*  54185 */   // GIR_Coverage, 1080,
     /*  54185 */   GIR_EraseRootFromParent_Done,
     /*  54186 */ // Label 1306: @54186
     /*  54186 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(54231), // Rule ID 1697 //
     /*  54191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54216 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  54219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54221 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54229 */   GIR_RootConstrainSelectedInstOperands,
     /*  54230 */   // GIR_Coverage, 1697,
     /*  54230 */   GIR_EraseRootFromParent_Done,
     /*  54231 */ // Label 1307: @54231
     /*  54231 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(54276), // Rule ID 1698 //
     /*  54236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  54239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54250 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54254 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54261 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  54264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54266 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54274 */   GIR_RootConstrainSelectedInstOperands,
     /*  54275 */   // GIR_Coverage, 1698,
     /*  54275 */   GIR_EraseRootFromParent_Done,
     /*  54276 */ // Label 1308: @54276
     /*  54276 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(54325), // Rule ID 22517 //
     /*  54281 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54310 */   // (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54315 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54323 */   GIR_RootConstrainSelectedInstOperands,
     /*  54324 */   // GIR_Coverage, 22517,
     /*  54324 */   GIR_EraseRootFromParent_Done,
     /*  54325 */ // Label 1309: @54325
     /*  54325 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(54374), // Rule ID 22582 //
     /*  54330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54333 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54359 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54364 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54372 */   GIR_RootConstrainSelectedInstOperands,
     /*  54373 */   // GIR_Coverage, 22582,
     /*  54373 */   GIR_EraseRootFromParent_Done,
     /*  54374 */ // Label 1310: @54374
     /*  54374 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(54423), // Rule ID 22584 //
     /*  54379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54382 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54386 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54397 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54401 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54408 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54413 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54421 */   GIR_RootConstrainSelectedInstOperands,
     /*  54422 */   // GIR_Coverage, 22584,
     /*  54422 */   GIR_EraseRootFromParent_Done,
     /*  54423 */ // Label 1311: @54423
     /*  54423 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(54472), // Rule ID 22585 //
     /*  54428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54431 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54435 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54457 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54462 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54470 */   GIR_RootConstrainSelectedInstOperands,
     /*  54471 */   // GIR_Coverage, 22585,
     /*  54471 */   GIR_EraseRootFromParent_Done,
     /*  54472 */ // Label 1312: @54472
     /*  54472 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(54517), // Rule ID 4609 //
     /*  54477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  54491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54502 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  54505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54507 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54511 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54515 */   GIR_RootConstrainSelectedInstOperands,
     /*  54516 */   // GIR_Coverage, 4609,
     /*  54516 */   GIR_EraseRootFromParent_Done,
     /*  54517 */ // Label 1313: @54517
     /*  54517 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(54559), // Rule ID 30 //
     /*  54522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54529 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54533 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  54537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54544 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54549 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54557 */   GIR_RootConstrainSelectedInstOperands,
     /*  54558 */   // GIR_Coverage, 30,
     /*  54558 */   GIR_EraseRootFromParent_Done,
     /*  54559 */ // Label 1314: @54559
     /*  54559 */ GIM_Reject,
     /*  54560 */ // Label 1272: @54560
     /*  54560 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(54602), // Rule ID 31 //
     /*  54565 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54568 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54587 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54592 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54600 */   GIR_RootConstrainSelectedInstOperands,
     /*  54601 */   // GIR_Coverage, 31,
     /*  54601 */   GIR_EraseRootFromParent_Done,
     /*  54602 */ // Label 1315: @54602
     /*  54602 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(54650), // Rule ID 1081 //
     /*  54607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54613 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54632 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp64m:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m),
     /*  54635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54637 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54641 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54648 */   GIR_RootConstrainSelectedInstOperands,
     /*  54649 */   // GIR_Coverage, 1081,
     /*  54649 */   GIR_EraseRootFromParent_Done,
     /*  54650 */ // Label 1316: @54650
     /*  54650 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(54705), // Rule ID 1083 //
     /*  54655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54658 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54661 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54687 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m64),
     /*  54690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54692 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54696 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54703 */   GIR_RootConstrainSelectedInstOperands,
     /*  54704 */   // GIR_Coverage, 1083,
     /*  54704 */   GIR_EraseRootFromParent_Done,
     /*  54705 */ // Label 1317: @54705
     /*  54705 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(54750), // Rule ID 1701 //
     /*  54710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54724 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54728 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54735 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  54738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54740 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54748 */   GIR_RootConstrainSelectedInstOperands,
     /*  54749 */   // GIR_Coverage, 1701,
     /*  54749 */   GIR_EraseRootFromParent_Done,
     /*  54750 */ // Label 1318: @54750
     /*  54750 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(54795), // Rule ID 1702 //
     /*  54755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  54758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54780 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  54783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54785 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54793 */   GIR_RootConstrainSelectedInstOperands,
     /*  54794 */   // GIR_Coverage, 1702,
     /*  54794 */   GIR_EraseRootFromParent_Done,
     /*  54795 */ // Label 1319: @54795
     /*  54795 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(54844), // Rule ID 22518 //
     /*  54800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54822 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54829 */   // (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54834 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54842 */   GIR_RootConstrainSelectedInstOperands,
     /*  54843 */   // GIR_Coverage, 22518,
     /*  54843 */   GIR_EraseRootFromParent_Done,
     /*  54844 */ // Label 1320: @54844
     /*  54844 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(54925), // Rule ID 22587 //
     /*  54849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54852 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54856 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54867 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54871 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54878 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54890 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54894 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54919 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54924 */   // GIR_Coverage, 22587,
     /*  54924 */   GIR_EraseRootFromParent_Done,
     /*  54925 */ // Label 1321: @54925
     /*  54925 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(55006), // Rule ID 22588 //
     /*  54930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54933 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54959 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54971 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54975 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  55000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  55005 */   // GIR_Coverage, 22588,
     /*  55005 */   GIR_EraseRootFromParent_Done,
     /*  55006 */ // Label 1322: @55006
     /*  55006 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(55087), // Rule ID 22589 //
     /*  55011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55014 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55018 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  55025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  55029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55040 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  55040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  55047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55052 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55056 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  55076 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  55081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  55086 */   // GIR_Coverage, 22589,
     /*  55086 */   GIR_EraseRootFromParent_Done,
     /*  55087 */ // Label 1323: @55087
     /*  55087 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(55132), // Rule ID 4615 //
     /*  55092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  55095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  55106 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55110 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55117 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  55117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  55120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55122 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55130 */   GIR_RootConstrainSelectedInstOperands,
     /*  55131 */   // GIR_Coverage, 4615,
     /*  55131 */   GIR_EraseRootFromParent_Done,
     /*  55132 */ // Label 1324: @55132
     /*  55132 */ GIM_Reject,
     /*  55133 */ // Label 1273: @55133
     /*  55133 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(55291),
     /*  55138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55141 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(55186), // Rule ID 1082 //
     /*  55146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55168 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp80m:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp80m),
     /*  55171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55184 */     GIR_RootConstrainSelectedInstOperands,
     /*  55185 */     // GIR_Coverage, 1082,
     /*  55185 */     GIR_EraseRootFromParent_Done,
     /*  55186 */   // Label 1326: @55186
     /*  55186 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(55238), // Rule ID 1084 //
     /*  55191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55194 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  55205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55220 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>  =>  (LD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m80),
     /*  55223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55236 */     GIR_RootConstrainSelectedInstOperands,
     /*  55237 */     // GIR_Coverage, 1084,
     /*  55237 */     GIR_EraseRootFromParent_Done,
     /*  55238 */   // Label 1327: @55238
     /*  55238 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(55290), // Rule ID 1085 //
     /*  55243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55246 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  55257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55272 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m80),
     /*  55275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55288 */     GIR_RootConstrainSelectedInstOperands,
     /*  55289 */     // GIR_Coverage, 1085,
     /*  55289 */     GIR_EraseRootFromParent_Done,
     /*  55290 */   // Label 1328: @55290
     /*  55290 */   GIM_Reject,
     /*  55291 */ // Label 1325: @55291
     /*  55291 */ GIM_Reject,
     /*  55292 */ // Label 1274: @55292
     /*  55292 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(55419),
     /*  55297 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55300 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55304 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(55342), // Rule ID 23145 //
     /*  55309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  55312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55327 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55340 */     GIR_RootConstrainSelectedInstOperands,
     /*  55341 */     // GIR_Coverage, 23145,
     /*  55341 */     GIR_EraseRootFromParent_Done,
     /*  55342 */   // Label 1330: @55342
     /*  55342 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(55380), // Rule ID 23149 //
     /*  55347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55365 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55378 */     GIR_RootConstrainSelectedInstOperands,
     /*  55379 */     // GIR_Coverage, 23149,
     /*  55379 */     GIR_EraseRootFromParent_Done,
     /*  55380 */   // Label 1331: @55380
     /*  55380 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(55418), // Rule ID 23153 //
     /*  55385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  55388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55403 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  55406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55416 */     GIR_RootConstrainSelectedInstOperands,
     /*  55417 */     // GIR_Coverage, 23153,
     /*  55417 */     GIR_EraseRootFromParent_Done,
     /*  55418 */   // Label 1332: @55418
     /*  55418 */   GIM_Reject,
     /*  55419 */ // Label 1329: @55419
     /*  55419 */ GIM_Reject,
     /*  55420 */ // Label 1275: @55420
     /*  55420 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(55486), // Rule ID 19446 //
     /*  55425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  55439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55443 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55450 */   // (ld:{ *:[v2i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK2:{ *:[i32] })
     /*  55450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55462 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55466 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  55485 */   // GIR_Coverage, 19446,
     /*  55485 */   GIR_EraseRootFromParent_Done,
     /*  55486 */ // Label 1333: @55486
     /*  55486 */ GIM_Reject,
     /*  55487 */ // Label 1276: @55487
     /*  55487 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(55980),
     /*  55492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55495 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55499 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(55541), // Rule ID 1704 //
     /*  55504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55526 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDrm),
     /*  55529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55539 */     GIR_RootConstrainSelectedInstOperands,
     /*  55540 */     // GIR_Coverage, 1704,
     /*  55540 */     GIR_EraseRootFromParent_Done,
     /*  55541 */   // Label 1335: @55541
     /*  55541 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(55579), // Rule ID 1706 //
     /*  55546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55564 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDrm),
     /*  55567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55577 */     GIR_RootConstrainSelectedInstOperands,
     /*  55578 */     // GIR_Coverage, 1706,
     /*  55578 */     GIR_EraseRootFromParent_Done,
     /*  55579 */   // Label 1336: @55579
     /*  55579 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(55621), // Rule ID 1713 //
     /*  55584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55606 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDrm),
     /*  55609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55619 */     GIR_RootConstrainSelectedInstOperands,
     /*  55620 */     // GIR_Coverage, 1713,
     /*  55620 */     GIR_EraseRootFromParent_Done,
     /*  55621 */   // Label 1337: @55621
     /*  55621 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(55659), // Rule ID 1714 //
     /*  55626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55644 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDrm),
     /*  55647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55657 */     GIR_RootConstrainSelectedInstOperands,
     /*  55658 */     // GIR_Coverage, 1714,
     /*  55658 */     GIR_EraseRootFromParent_Done,
     /*  55659 */   // Label 1338: @55659
     /*  55659 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(55701), // Rule ID 2518 //
     /*  55664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55686 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  55689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55699 */     GIR_RootConstrainSelectedInstOperands,
     /*  55700 */     // GIR_Coverage, 2518,
     /*  55700 */     GIR_EraseRootFromParent_Done,
     /*  55701 */   // Label 1339: @55701
     /*  55701 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(55739), // Rule ID 2519 //
     /*  55706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55724 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  55727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55737 */     GIR_RootConstrainSelectedInstOperands,
     /*  55738 */     // GIR_Coverage, 2519,
     /*  55738 */     GIR_EraseRootFromParent_Done,
     /*  55739 */   // Label 1340: @55739
     /*  55739 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(55781), // Rule ID 4490 //
     /*  55744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55766 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rm),
     /*  55769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55779 */     GIR_RootConstrainSelectedInstOperands,
     /*  55780 */     // GIR_Coverage, 4490,
     /*  55780 */     GIR_EraseRootFromParent_Done,
     /*  55781 */   // Label 1341: @55781
     /*  55781 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(55819), // Rule ID 4515 //
     /*  55786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55804 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128rm),
     /*  55807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55817 */     GIR_RootConstrainSelectedInstOperands,
     /*  55818 */     // GIR_Coverage, 4515,
     /*  55818 */     GIR_EraseRootFromParent_Done,
     /*  55819 */   // Label 1342: @55819
     /*  55819 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(55861), // Rule ID 4544 //
     /*  55824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55846 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  55849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55859 */     GIR_RootConstrainSelectedInstOperands,
     /*  55860 */     // GIR_Coverage, 4544,
     /*  55860 */     GIR_EraseRootFromParent_Done,
     /*  55861 */   // Label 1343: @55861
     /*  55861 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(55899), // Rule ID 4587 //
     /*  55866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55884 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  55887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55897 */     GIR_RootConstrainSelectedInstOperands,
     /*  55898 */     // GIR_Coverage, 4587,
     /*  55898 */     GIR_EraseRootFromParent_Done,
     /*  55899 */   // Label 1344: @55899
     /*  55899 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(55941), // Rule ID 17939 //
     /*  55904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55926 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55939 */     GIR_RootConstrainSelectedInstOperands,
     /*  55940 */     // GIR_Coverage, 17939,
     /*  55940 */     GIR_EraseRootFromParent_Done,
     /*  55941 */   // Label 1345: @55941
     /*  55941 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(55979), // Rule ID 17943 //
     /*  55946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55964 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55977 */     GIR_RootConstrainSelectedInstOperands,
     /*  55978 */     // GIR_Coverage, 17943,
     /*  55978 */     GIR_EraseRootFromParent_Done,
     /*  55979 */   // Label 1346: @55979
     /*  55979 */   GIM_Reject,
     /*  55980 */ // Label 1334: @55980
     /*  55980 */ GIM_Reject,
     /*  55981 */ // Label 1277: @55981
     /*  55981 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(56047), // Rule ID 19447 //
     /*  55986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  56000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56011 */   // (ld:{ *:[v4i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK4:{ *:[i32] })
     /*  56011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  56014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56023 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  56027 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  56046 */   // GIR_Coverage, 19447,
     /*  56046 */   GIR_EraseRootFromParent_Done,
     /*  56047 */ // Label 1347: @56047
     /*  56047 */ GIM_Reject,
     /*  56048 */ // Label 1278: @56048
     /*  56048 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(56541),
     /*  56053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56056 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56060 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(56102), // Rule ID 1703 //
     /*  56065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56087 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  56090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56100 */     GIR_RootConstrainSelectedInstOperands,
     /*  56101 */     // GIR_Coverage, 1703,
     /*  56101 */     GIR_EraseRootFromParent_Done,
     /*  56102 */   // Label 1349: @56102
     /*  56102 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(56140), // Rule ID 1705 //
     /*  56107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56125 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  56128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56138 */     GIR_RootConstrainSelectedInstOperands,
     /*  56139 */     // GIR_Coverage, 1705,
     /*  56139 */     GIR_EraseRootFromParent_Done,
     /*  56140 */   // Label 1350: @56140
     /*  56140 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(56182), // Rule ID 1711 //
     /*  56145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56167 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56180 */     GIR_RootConstrainSelectedInstOperands,
     /*  56181 */     // GIR_Coverage, 1711,
     /*  56181 */     GIR_EraseRootFromParent_Done,
     /*  56182 */   // Label 1351: @56182
     /*  56182 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(56220), // Rule ID 1712 //
     /*  56187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56205 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56218 */     GIR_RootConstrainSelectedInstOperands,
     /*  56219 */     // GIR_Coverage, 1712,
     /*  56219 */     GIR_EraseRootFromParent_Done,
     /*  56220 */   // Label 1352: @56220
     /*  56220 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(56262), // Rule ID 4472 //
     /*  56225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56247 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  56250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56260 */     GIR_RootConstrainSelectedInstOperands,
     /*  56261 */     // GIR_Coverage, 4472,
     /*  56261 */     GIR_EraseRootFromParent_Done,
     /*  56262 */   // Label 1353: @56262
     /*  56262 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(56300), // Rule ID 4503 //
     /*  56267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56285 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  56288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56290 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56298 */     GIR_RootConstrainSelectedInstOperands,
     /*  56299 */     // GIR_Coverage, 4503,
     /*  56299 */     GIR_EraseRootFromParent_Done,
     /*  56300 */   // Label 1354: @56300
     /*  56300 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(56342), // Rule ID 17940 //
     /*  56305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56327 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56340 */     GIR_RootConstrainSelectedInstOperands,
     /*  56341 */     // GIR_Coverage, 17940,
     /*  56341 */     GIR_EraseRootFromParent_Done,
     /*  56342 */   // Label 1355: @56342
     /*  56342 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(56380), // Rule ID 17944 //
     /*  56347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56365 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56378 */     GIR_RootConstrainSelectedInstOperands,
     /*  56379 */     // GIR_Coverage, 17944,
     /*  56379 */     GIR_EraseRootFromParent_Done,
     /*  56380 */   // Label 1356: @56380
     /*  56380 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(56422), // Rule ID 18319 //
     /*  56385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56407 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56420 */     GIR_RootConstrainSelectedInstOperands,
     /*  56421 */     // GIR_Coverage, 18319,
     /*  56421 */     GIR_EraseRootFromParent_Done,
     /*  56422 */   // Label 1357: @56422
     /*  56422 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(56460), // Rule ID 18323 //
     /*  56427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56445 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  56448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56458 */     GIR_RootConstrainSelectedInstOperands,
     /*  56459 */     // GIR_Coverage, 18323,
     /*  56459 */     GIR_EraseRootFromParent_Done,
     /*  56460 */   // Label 1358: @56460
     /*  56460 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(56502), // Rule ID 19812 //
     /*  56465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56487 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  56490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56500 */     GIR_RootConstrainSelectedInstOperands,
     /*  56501 */     // GIR_Coverage, 19812,
     /*  56501 */     GIR_EraseRootFromParent_Done,
     /*  56502 */   // Label 1359: @56502
     /*  56502 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(56540), // Rule ID 19816 //
     /*  56507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56525 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  56528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56538 */     GIR_RootConstrainSelectedInstOperands,
     /*  56539 */     // GIR_Coverage, 19816,
     /*  56539 */     GIR_EraseRootFromParent_Done,
     /*  56540 */   // Label 1360: @56540
     /*  56540 */   GIM_Reject,
     /*  56541 */ // Label 1348: @56541
     /*  56541 */ GIM_Reject,
     /*  56542 */ // Label 1279: @56542
     /*  56542 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(56875),
     /*  56547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56550 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56554 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(56596), // Rule ID 1708 //
     /*  56559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56581 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYrm),
     /*  56584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56594 */     GIR_RootConstrainSelectedInstOperands,
     /*  56595 */     // GIR_Coverage, 1708,
     /*  56595 */     GIR_EraseRootFromParent_Done,
     /*  56596 */   // Label 1362: @56596
     /*  56596 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(56634), // Rule ID 1710 //
     /*  56601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56619 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYrm),
     /*  56622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56632 */     GIR_RootConstrainSelectedInstOperands,
     /*  56633 */     // GIR_Coverage, 1710,
     /*  56633 */     GIR_EraseRootFromParent_Done,
     /*  56634 */   // Label 1363: @56634
     /*  56634 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(56676), // Rule ID 4485 //
     /*  56639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56661 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rm),
     /*  56664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56666 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56674 */     GIR_RootConstrainSelectedInstOperands,
     /*  56675 */     // GIR_Coverage, 4485,
     /*  56675 */     GIR_EraseRootFromParent_Done,
     /*  56676 */   // Label 1364: @56676
     /*  56676 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(56714), // Rule ID 4512 //
     /*  56681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56699 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256rm),
     /*  56702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56704 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56712 */     GIR_RootConstrainSelectedInstOperands,
     /*  56713 */     // GIR_Coverage, 4512,
     /*  56713 */     GIR_EraseRootFromParent_Done,
     /*  56714 */   // Label 1365: @56714
     /*  56714 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(56756), // Rule ID 4539 //
     /*  56719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56741 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  56744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56754 */     GIR_RootConstrainSelectedInstOperands,
     /*  56755 */     // GIR_Coverage, 4539,
     /*  56755 */     GIR_EraseRootFromParent_Done,
     /*  56756 */   // Label 1366: @56756
     /*  56756 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(56794), // Rule ID 4584 //
     /*  56761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56779 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  56782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56792 */     GIR_RootConstrainSelectedInstOperands,
     /*  56793 */     // GIR_Coverage, 4584,
     /*  56793 */     GIR_EraseRootFromParent_Done,
     /*  56794 */   // Label 1367: @56794
     /*  56794 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(56836), // Rule ID 17915 //
     /*  56799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56821 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  56824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56834 */     GIR_RootConstrainSelectedInstOperands,
     /*  56835 */     // GIR_Coverage, 17915,
     /*  56835 */     GIR_EraseRootFromParent_Done,
     /*  56836 */   // Label 1368: @56836
     /*  56836 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(56874), // Rule ID 17919 //
     /*  56841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56859 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  56862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56872 */     GIR_RootConstrainSelectedInstOperands,
     /*  56873 */     // GIR_Coverage, 17919,
     /*  56873 */     GIR_EraseRootFromParent_Done,
     /*  56874 */   // Label 1369: @56874
     /*  56874 */   GIM_Reject,
     /*  56875 */ // Label 1361: @56875
     /*  56875 */ GIM_Reject,
     /*  56876 */ // Label 1280: @56876
     /*  56876 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56957),
     /*  56881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56884 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  56892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56896 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(56926), // Rule ID 4395 //
     /*  56901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  56904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56911 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56924 */     GIR_RootConstrainSelectedInstOperands,
     /*  56925 */     // GIR_Coverage, 4395,
     /*  56925 */     GIR_EraseRootFromParent_Done,
     /*  56926 */   // Label 1371: @56926
     /*  56926 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56956), // Rule ID 4397 //
     /*  56931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  56934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56941 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm_EVEX:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm_EVEX),
     /*  56944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56954 */     GIR_RootConstrainSelectedInstOperands,
     /*  56955 */     // GIR_Coverage, 4397,
     /*  56955 */     GIR_EraseRootFromParent_Done,
     /*  56956 */   // Label 1372: @56956
     /*  56956 */   GIM_Reject,
     /*  56957 */ // Label 1370: @56957
     /*  56957 */ GIM_Reject,
     /*  56958 */ // Label 1281: @56958
     /*  56958 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(57531),
     /*  56963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56970 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(57012), // Rule ID 17931 //
     /*  56975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56997 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  57000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57010 */     GIR_RootConstrainSelectedInstOperands,
     /*  57011 */     // GIR_Coverage, 17931,
     /*  57011 */     GIR_EraseRootFromParent_Done,
     /*  57012 */   // Label 1374: @57012
     /*  57012 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(57050), // Rule ID 17932 //
     /*  57017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57035 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  57038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57048 */     GIR_RootConstrainSelectedInstOperands,
     /*  57049 */     // GIR_Coverage, 17932,
     /*  57049 */     GIR_EraseRootFromParent_Done,
     /*  57050 */   // Label 1375: @57050
     /*  57050 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(57092), // Rule ID 17941 //
     /*  57055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57077 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57090 */     GIR_RootConstrainSelectedInstOperands,
     /*  57091 */     // GIR_Coverage, 17941,
     /*  57091 */     GIR_EraseRootFromParent_Done,
     /*  57092 */   // Label 1376: @57092
     /*  57092 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(57130), // Rule ID 17945 //
     /*  57097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57115 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57128 */     GIR_RootConstrainSelectedInstOperands,
     /*  57129 */     // GIR_Coverage, 17945,
     /*  57129 */     GIR_EraseRootFromParent_Done,
     /*  57130 */   // Label 1377: @57130
     /*  57130 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(57172), // Rule ID 17955 //
     /*  57135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  57138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57157 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57170 */     GIR_RootConstrainSelectedInstOperands,
     /*  57171 */     // GIR_Coverage, 17955,
     /*  57171 */     GIR_EraseRootFromParent_Done,
     /*  57172 */   // Label 1378: @57172
     /*  57172 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(57210), // Rule ID 17956 //
     /*  57177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  57180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57195 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57208 */     GIR_RootConstrainSelectedInstOperands,
     /*  57209 */     // GIR_Coverage, 17956,
     /*  57209 */     GIR_EraseRootFromParent_Done,
     /*  57210 */   // Label 1379: @57210
     /*  57210 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(57252), // Rule ID 18320 //
     /*  57215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57237 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57250 */     GIR_RootConstrainSelectedInstOperands,
     /*  57251 */     // GIR_Coverage, 18320,
     /*  57251 */     GIR_EraseRootFromParent_Done,
     /*  57252 */   // Label 1380: @57252
     /*  57252 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(57294), // Rule ID 18321 //
     /*  57257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57279 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57292 */     GIR_RootConstrainSelectedInstOperands,
     /*  57293 */     // GIR_Coverage, 18321,
     /*  57293 */     GIR_EraseRootFromParent_Done,
     /*  57294 */   // Label 1381: @57294
     /*  57294 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(57332), // Rule ID 18324 //
     /*  57299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57317 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57330 */     GIR_RootConstrainSelectedInstOperands,
     /*  57331 */     // GIR_Coverage, 18324,
     /*  57331 */     GIR_EraseRootFromParent_Done,
     /*  57332 */   // Label 1382: @57332
     /*  57332 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(57370), // Rule ID 18325 //
     /*  57337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57355 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57368 */     GIR_RootConstrainSelectedInstOperands,
     /*  57369 */     // GIR_Coverage, 18325,
     /*  57369 */     GIR_EraseRootFromParent_Done,
     /*  57370 */   // Label 1383: @57370
     /*  57370 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57412), // Rule ID 19813 //
     /*  57375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57397 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  57400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57410 */     GIR_RootConstrainSelectedInstOperands,
     /*  57411 */     // GIR_Coverage, 19813,
     /*  57411 */     GIR_EraseRootFromParent_Done,
     /*  57412 */   // Label 1384: @57412
     /*  57412 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57454), // Rule ID 19814 //
     /*  57417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57439 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  57442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57444 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57452 */     GIR_RootConstrainSelectedInstOperands,
     /*  57453 */     // GIR_Coverage, 19814,
     /*  57453 */     GIR_EraseRootFromParent_Done,
     /*  57454 */   // Label 1385: @57454
     /*  57454 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57492), // Rule ID 19817 //
     /*  57459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57477 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  57480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57490 */     GIR_RootConstrainSelectedInstOperands,
     /*  57491 */     // GIR_Coverage, 19817,
     /*  57491 */     GIR_EraseRootFromParent_Done,
     /*  57492 */   // Label 1386: @57492
     /*  57492 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57530), // Rule ID 19818 //
     /*  57497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57515 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57528 */     GIR_RootConstrainSelectedInstOperands,
     /*  57529 */     // GIR_Coverage, 19818,
     /*  57529 */     GIR_EraseRootFromParent_Done,
     /*  57530 */   // Label 1387: @57530
     /*  57530 */   GIM_Reject,
     /*  57531 */ // Label 1373: @57531
     /*  57531 */ GIM_Reject,
     /*  57532 */ // Label 1282: @57532
     /*  57532 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57865),
     /*  57537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57544 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57586), // Rule ID 1707 //
     /*  57549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57571 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57584 */     GIR_RootConstrainSelectedInstOperands,
     /*  57585 */     // GIR_Coverage, 1707,
     /*  57585 */     GIR_EraseRootFromParent_Done,
     /*  57586 */   // Label 1389: @57586
     /*  57586 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57624), // Rule ID 1709 //
     /*  57591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57609 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57622 */     GIR_RootConstrainSelectedInstOperands,
     /*  57623 */     // GIR_Coverage, 1709,
     /*  57623 */     GIR_EraseRootFromParent_Done,
     /*  57624 */   // Label 1390: @57624
     /*  57624 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57666), // Rule ID 4467 //
     /*  57629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57651 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  57654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57664 */     GIR_RootConstrainSelectedInstOperands,
     /*  57665 */     // GIR_Coverage, 4467,
     /*  57665 */     GIR_EraseRootFromParent_Done,
     /*  57666 */   // Label 1391: @57666
     /*  57666 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57704), // Rule ID 4500 //
     /*  57671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57689 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  57692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57702 */     GIR_RootConstrainSelectedInstOperands,
     /*  57703 */     // GIR_Coverage, 4500,
     /*  57703 */     GIR_EraseRootFromParent_Done,
     /*  57704 */   // Label 1392: @57704
     /*  57704 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57746), // Rule ID 17916 //
     /*  57709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57731 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57744 */     GIR_RootConstrainSelectedInstOperands,
     /*  57745 */     // GIR_Coverage, 17916,
     /*  57745 */     GIR_EraseRootFromParent_Done,
     /*  57746 */   // Label 1393: @57746
     /*  57746 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57784), // Rule ID 17920 //
     /*  57751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57769 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57782 */     GIR_RootConstrainSelectedInstOperands,
     /*  57783 */     // GIR_Coverage, 17920,
     /*  57783 */     GIR_EraseRootFromParent_Done,
     /*  57784 */   // Label 1394: @57784
     /*  57784 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57826), // Rule ID 19828 //
     /*  57789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57811 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  57814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57824 */     GIR_RootConstrainSelectedInstOperands,
     /*  57825 */     // GIR_Coverage, 19828,
     /*  57825 */     GIR_EraseRootFromParent_Done,
     /*  57826 */   // Label 1395: @57826
     /*  57826 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(57864), // Rule ID 19832 //
     /*  57831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57849 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  57852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57862 */     GIR_RootConstrainSelectedInstOperands,
     /*  57863 */     // GIR_Coverage, 19832,
     /*  57863 */     GIR_EraseRootFromParent_Done,
     /*  57864 */   // Label 1396: @57864
     /*  57864 */   GIM_Reject,
     /*  57865 */ // Label 1388: @57865
     /*  57865 */ GIM_Reject,
     /*  57866 */ // Label 1283: @57866
     /*  57866 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(58039),
     /*  57871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57874 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57878 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(57920), // Rule ID 4480 //
     /*  57883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57905 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrm),
     /*  57908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57918 */     GIR_RootConstrainSelectedInstOperands,
     /*  57919 */     // GIR_Coverage, 4480,
     /*  57919 */     GIR_EraseRootFromParent_Done,
     /*  57920 */   // Label 1398: @57920
     /*  57920 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(57958), // Rule ID 4509 //
     /*  57925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57943 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZrm),
     /*  57946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57956 */     GIR_RootConstrainSelectedInstOperands,
     /*  57957 */     // GIR_Coverage, 4509,
     /*  57957 */     GIR_EraseRootFromParent_Done,
     /*  57958 */   // Label 1399: @57958
     /*  57958 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(58000), // Rule ID 4534 //
     /*  57963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57985 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  57988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57998 */     GIR_RootConstrainSelectedInstOperands,
     /*  57999 */     // GIR_Coverage, 4534,
     /*  57999 */     GIR_EraseRootFromParent_Done,
     /*  58000 */   // Label 1400: @58000
     /*  58000 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58038), // Rule ID 4581 //
     /*  58005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58023 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  58023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58036 */     GIR_RootConstrainSelectedInstOperands,
     /*  58037 */     // GIR_Coverage, 4581,
     /*  58037 */     GIR_EraseRootFromParent_Done,
     /*  58038 */   // Label 1401: @58038
     /*  58038 */   GIM_Reject,
     /*  58039 */ // Label 1397: @58039
     /*  58039 */ GIM_Reject,
     /*  58040 */ // Label 1284: @58040
     /*  58040 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58121),
     /*  58045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58048 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  58056 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58060 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58090), // Rule ID 4399 //
     /*  58065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  58068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58075 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  58075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  58078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58088 */     GIR_RootConstrainSelectedInstOperands,
     /*  58089 */     // GIR_Coverage, 4399,
     /*  58089 */     GIR_EraseRootFromParent_Done,
     /*  58090 */   // Label 1403: @58090
     /*  58090 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58120), // Rule ID 4401 //
     /*  58095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  58098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58105 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm_EVEX:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  58105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm_EVEX),
     /*  58108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58118 */     GIR_RootConstrainSelectedInstOperands,
     /*  58119 */     // GIR_Coverage, 4401,
     /*  58119 */     GIR_EraseRootFromParent_Done,
     /*  58120 */   // Label 1404: @58120
     /*  58120 */   GIM_Reject,
     /*  58121 */ // Label 1402: @58121
     /*  58121 */ GIM_Reject,
     /*  58122 */ // Label 1285: @58122
     /*  58122 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58375),
     /*  58127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58134 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58176), // Rule ID 17942 //
     /*  58139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  58142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58161 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  58164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58174 */     GIR_RootConstrainSelectedInstOperands,
     /*  58175 */     // GIR_Coverage, 17942,
     /*  58175 */     GIR_EraseRootFromParent_Done,
     /*  58176 */   // Label 1406: @58176
     /*  58176 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(58214), // Rule ID 17946 //
     /*  58181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  58184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58199 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58212 */     GIR_RootConstrainSelectedInstOperands,
     /*  58213 */     // GIR_Coverage, 17946,
     /*  58213 */     GIR_EraseRootFromParent_Done,
     /*  58214 */   // Label 1407: @58214
     /*  58214 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(58256), // Rule ID 18322 //
     /*  58219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58241 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  58244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58246 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58254 */     GIR_RootConstrainSelectedInstOperands,
     /*  58255 */     // GIR_Coverage, 18322,
     /*  58255 */     GIR_EraseRootFromParent_Done,
     /*  58256 */   // Label 1408: @58256
     /*  58256 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(58294), // Rule ID 18326 //
     /*  58261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58279 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  58282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58292 */     GIR_RootConstrainSelectedInstOperands,
     /*  58293 */     // GIR_Coverage, 18326,
     /*  58293 */     GIR_EraseRootFromParent_Done,
     /*  58294 */   // Label 1409: @58294
     /*  58294 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(58336), // Rule ID 19815 //
     /*  58299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58321 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  58324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58334 */     GIR_RootConstrainSelectedInstOperands,
     /*  58335 */     // GIR_Coverage, 19815,
     /*  58335 */     GIR_EraseRootFromParent_Done,
     /*  58336 */   // Label 1410: @58336
     /*  58336 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(58374), // Rule ID 19819 //
     /*  58341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58359 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  58362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58372 */     GIR_RootConstrainSelectedInstOperands,
     /*  58373 */     // GIR_Coverage, 19819,
     /*  58373 */     GIR_EraseRootFromParent_Done,
     /*  58374 */   // Label 1411: @58374
     /*  58374 */   GIM_Reject,
     /*  58375 */ // Label 1405: @58375
     /*  58375 */ GIM_Reject,
     /*  58376 */ // Label 1286: @58376
     /*  58376 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(58709),
     /*  58381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58388 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(58430), // Rule ID 17917 //
     /*  58393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58415 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58428 */     GIR_RootConstrainSelectedInstOperands,
     /*  58429 */     // GIR_Coverage, 17917,
     /*  58429 */     GIR_EraseRootFromParent_Done,
     /*  58430 */   // Label 1413: @58430
     /*  58430 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(58468), // Rule ID 17921 //
     /*  58435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58453 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58466 */     GIR_RootConstrainSelectedInstOperands,
     /*  58467 */     // GIR_Coverage, 17921,
     /*  58467 */     GIR_EraseRootFromParent_Done,
     /*  58468 */   // Label 1414: @58468
     /*  58468 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(58510), // Rule ID 17935 //
     /*  58473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58495 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58508 */     GIR_RootConstrainSelectedInstOperands,
     /*  58509 */     // GIR_Coverage, 17935,
     /*  58509 */     GIR_EraseRootFromParent_Done,
     /*  58510 */   // Label 1415: @58510
     /*  58510 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(58548), // Rule ID 17936 //
     /*  58515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58533 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58546 */     GIR_RootConstrainSelectedInstOperands,
     /*  58547 */     // GIR_Coverage, 17936,
     /*  58547 */     GIR_EraseRootFromParent_Done,
     /*  58548 */   // Label 1416: @58548
     /*  58548 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(58590), // Rule ID 19829 //
     /*  58553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58575 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58588 */     GIR_RootConstrainSelectedInstOperands,
     /*  58589 */     // GIR_Coverage, 19829,
     /*  58589 */     GIR_EraseRootFromParent_Done,
     /*  58590 */   // Label 1417: @58590
     /*  58590 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(58632), // Rule ID 19830 //
     /*  58595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58617 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  58620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58622 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58630 */     GIR_RootConstrainSelectedInstOperands,
     /*  58631 */     // GIR_Coverage, 19830,
     /*  58631 */     GIR_EraseRootFromParent_Done,
     /*  58632 */   // Label 1418: @58632
     /*  58632 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(58670), // Rule ID 19833 //
     /*  58637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58655 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58668 */     GIR_RootConstrainSelectedInstOperands,
     /*  58669 */     // GIR_Coverage, 19833,
     /*  58669 */     GIR_EraseRootFromParent_Done,
     /*  58670 */   // Label 1419: @58670
     /*  58670 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(58708), // Rule ID 19834 //
     /*  58675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58693 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  58696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58706 */     GIR_RootConstrainSelectedInstOperands,
     /*  58707 */     // GIR_Coverage, 19834,
     /*  58707 */     GIR_EraseRootFromParent_Done,
     /*  58708 */   // Label 1420: @58708
     /*  58708 */   GIM_Reject,
     /*  58709 */ // Label 1412: @58709
     /*  58709 */ GIM_Reject,
     /*  58710 */ // Label 1287: @58710
     /*  58710 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(58883),
     /*  58715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58718 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58722 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(58764), // Rule ID 4462 //
     /*  58727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58749 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58762 */     GIR_RootConstrainSelectedInstOperands,
     /*  58763 */     // GIR_Coverage, 4462,
     /*  58763 */     GIR_EraseRootFromParent_Done,
     /*  58764 */   // Label 1422: @58764
     /*  58764 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(58802), // Rule ID 4497 //
     /*  58769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58787 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58800 */     GIR_RootConstrainSelectedInstOperands,
     /*  58801 */     // GIR_Coverage, 4497,
     /*  58801 */     GIR_EraseRootFromParent_Done,
     /*  58802 */   // Label 1423: @58802
     /*  58802 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(58844), // Rule ID 19796 //
     /*  58807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58829 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58842 */     GIR_RootConstrainSelectedInstOperands,
     /*  58843 */     // GIR_Coverage, 19796,
     /*  58843 */     GIR_EraseRootFromParent_Done,
     /*  58844 */   // Label 1424: @58844
     /*  58844 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(58882), // Rule ID 19800 //
     /*  58849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58867 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58880 */     GIR_RootConstrainSelectedInstOperands,
     /*  58881 */     // GIR_Coverage, 19800,
     /*  58881 */     GIR_EraseRootFromParent_Done,
     /*  58882 */   // Label 1425: @58882
     /*  58882 */   GIM_Reject,
     /*  58883 */ // Label 1421: @58883
     /*  58883 */ GIM_Reject,
     /*  58884 */ // Label 1288: @58884
     /*  58884 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(58965),
     /*  58889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  58900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58904 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(58934), // Rule ID 4403 //
     /*  58909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  58912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58919 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm),
     /*  58922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58932 */     GIR_RootConstrainSelectedInstOperands,
     /*  58933 */     // GIR_Coverage, 4403,
     /*  58933 */     GIR_EraseRootFromParent_Done,
     /*  58934 */   // Label 1427: @58934
     /*  58934 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(58964), // Rule ID 4407 //
     /*  58939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  58942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58949 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm_EVEX:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm_EVEX),
     /*  58952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58962 */     GIR_RootConstrainSelectedInstOperands,
     /*  58963 */     // GIR_Coverage, 4407,
     /*  58963 */     GIR_EraseRootFromParent_Done,
     /*  58964 */   // Label 1428: @58964
     /*  58964 */   GIM_Reject,
     /*  58965 */ // Label 1426: @58965
     /*  58965 */ GIM_Reject,
     /*  58966 */ // Label 1289: @58966
     /*  58966 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(59139),
     /*  58971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58974 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58978 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(59020), // Rule ID 17918 //
     /*  58983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59005 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  59008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59018 */     GIR_RootConstrainSelectedInstOperands,
     /*  59019 */     // GIR_Coverage, 17918,
     /*  59019 */     GIR_EraseRootFromParent_Done,
     /*  59020 */   // Label 1430: @59020
     /*  59020 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(59058), // Rule ID 17922 //
     /*  59025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  59028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  59032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59043 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  59046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59056 */     GIR_RootConstrainSelectedInstOperands,
     /*  59057 */     // GIR_Coverage, 17922,
     /*  59057 */     GIR_EraseRootFromParent_Done,
     /*  59058 */   // Label 1431: @59058
     /*  59058 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(59100), // Rule ID 19831 //
     /*  59063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  59066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  59070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59085 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  59088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59098 */     GIR_RootConstrainSelectedInstOperands,
     /*  59099 */     // GIR_Coverage, 19831,
     /*  59099 */     GIR_EraseRootFromParent_Done,
     /*  59100 */   // Label 1432: @59100
     /*  59100 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(59138), // Rule ID 19835 //
     /*  59105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  59108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  59112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59123 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  59126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59136 */     GIR_RootConstrainSelectedInstOperands,
     /*  59137 */     // GIR_Coverage, 19835,
     /*  59137 */     GIR_EraseRootFromParent_Done,
     /*  59138 */   // Label 1433: @59138
     /*  59138 */   GIM_Reject,
     /*  59139 */ // Label 1429: @59139
     /*  59139 */ GIM_Reject,
     /*  59140 */ // Label 1290: @59140
     /*  59140 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(59313),
     /*  59145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59152 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(59194), // Rule ID 19797 //
     /*  59157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59179 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59192 */     GIR_RootConstrainSelectedInstOperands,
     /*  59193 */     // GIR_Coverage, 19797,
     /*  59193 */     GIR_EraseRootFromParent_Done,
     /*  59194 */   // Label 1435: @59194
     /*  59194 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(59236), // Rule ID 19798 //
     /*  59199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59210 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59221 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  59224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59234 */     GIR_RootConstrainSelectedInstOperands,
     /*  59235 */     // GIR_Coverage, 19798,
     /*  59235 */     GIR_EraseRootFromParent_Done,
     /*  59236 */   // Label 1436: @59236
     /*  59236 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(59274), // Rule ID 19801 //
     /*  59241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59259 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59272 */     GIR_RootConstrainSelectedInstOperands,
     /*  59273 */     // GIR_Coverage, 19801,
     /*  59273 */     GIR_EraseRootFromParent_Done,
     /*  59274 */   // Label 1437: @59274
     /*  59274 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(59312), // Rule ID 19802 //
     /*  59279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59297 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  59300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59310 */     GIR_RootConstrainSelectedInstOperands,
     /*  59311 */     // GIR_Coverage, 19802,
     /*  59311 */     GIR_EraseRootFromParent_Done,
     /*  59312 */   // Label 1438: @59312
     /*  59312 */   GIM_Reject,
     /*  59313 */ // Label 1434: @59313
     /*  59313 */ GIM_Reject,
     /*  59314 */ // Label 1291: @59314
     /*  59314 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(59395),
     /*  59319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59322 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  59330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59334 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(59364), // Rule ID 4405 //
     /*  59339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  59342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59349 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm),
     /*  59352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59362 */     GIR_RootConstrainSelectedInstOperands,
     /*  59363 */     // GIR_Coverage, 4405,
     /*  59363 */     GIR_EraseRootFromParent_Done,
     /*  59364 */   // Label 1440: @59364
     /*  59364 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(59394), // Rule ID 4409 //
     /*  59369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  59372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59379 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm_EVEX:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm_EVEX),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59392 */     GIR_RootConstrainSelectedInstOperands,
     /*  59393 */     // GIR_Coverage, 4409,
     /*  59393 */     GIR_EraseRootFromParent_Done,
     /*  59394 */   // Label 1441: @59394
     /*  59394 */   GIM_Reject,
     /*  59395 */ // Label 1439: @59395
     /*  59395 */ GIM_Reject,
     /*  59396 */ // Label 1292: @59396
     /*  59396 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(59489),
     /*  59401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59404 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59408 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(59450), // Rule ID 19799 //
     /*  59413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59435 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59448 */     GIR_RootConstrainSelectedInstOperands,
     /*  59449 */     // GIR_Coverage, 19799,
     /*  59449 */     GIR_EraseRootFromParent_Done,
     /*  59450 */   // Label 1443: @59450
     /*  59450 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(59488), // Rule ID 19803 //
     /*  59455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59473 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59486 */     GIR_RootConstrainSelectedInstOperands,
     /*  59487 */     // GIR_Coverage, 19803,
     /*  59487 */     GIR_EraseRootFromParent_Done,
     /*  59488 */   // Label 1444: @59488
     /*  59488 */   GIM_Reject,
     /*  59489 */ // Label 1442: @59489
     /*  59489 */ GIM_Reject,
     /*  59490 */ // Label 1293: @59490
     /*  59490 */ GIM_Reject,
     /*  59491 */ // Label 11: @59491
     /*  59491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1448*/ GIMT_Encode4(59823),
     /*  59502 */ /*GILLT_s16*//*Label 1445*/ GIMT_Encode4(59514),
     /*  59506 */ /*GILLT_s32*//*Label 1446*/ GIMT_Encode4(59590),
     /*  59510 */ /*GILLT_s64*//*Label 1447*/ GIMT_Encode4(59684),
     /*  59514 */ // Label 1445: @59514
     /*  59514 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(59589), // Rule ID 22648 //
     /*  59519 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59544 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59556 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59560 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59571 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59588 */   // GIR_Coverage, 22648,
     /*  59588 */   GIR_EraseRootFromParent_Done,
     /*  59589 */ // Label 1449: @59589
     /*  59589 */ GIM_Reject,
     /*  59590 */ // Label 1446: @59590
     /*  59590 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(59683),
     /*  59595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59598 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(59640), // Rule ID 615 //
     /*  59603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59625 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59638 */     GIR_RootConstrainSelectedInstOperands,
     /*  59639 */     // GIR_Coverage, 615,
     /*  59639 */     GIR_EraseRootFromParent_Done,
     /*  59640 */   // Label 1451: @59640
     /*  59640 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(59682), // Rule ID 617 //
     /*  59645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59667 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm16),
     /*  59670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59680 */     GIR_RootConstrainSelectedInstOperands,
     /*  59681 */     // GIR_Coverage, 617,
     /*  59681 */     GIR_EraseRootFromParent_Done,
     /*  59682 */   // Label 1452: @59682
     /*  59682 */   GIM_Reject,
     /*  59683 */ // Label 1450: @59683
     /*  59683 */ GIM_Reject,
     /*  59684 */ // Label 1447: @59684
     /*  59684 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(59822),
     /*  59689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59692 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(59734), // Rule ID 623 //
     /*  59697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59719 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX64rm8:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm8),
     /*  59722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59732 */     GIR_RootConstrainSelectedInstOperands,
     /*  59733 */     // GIR_Coverage, 623,
     /*  59733 */     GIR_EraseRootFromParent_Done,
     /*  59734 */   // Label 1454: @59734
     /*  59734 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(59776), // Rule ID 625 //
     /*  59739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59761 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX64rm16:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm16),
     /*  59764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59774 */     GIR_RootConstrainSelectedInstOperands,
     /*  59775 */     // GIR_Coverage, 625,
     /*  59775 */     GIR_EraseRootFromParent_Done,
     /*  59776 */   // Label 1455: @59776
     /*  59776 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(59821), // Rule ID 627 //
     /*  59781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  59784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  59791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59806 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (MOVSX64rm32:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm32),
     /*  59809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59819 */     GIR_RootConstrainSelectedInstOperands,
     /*  59820 */     // GIR_Coverage, 627,
     /*  59820 */     GIR_EraseRootFromParent_Done,
     /*  59821 */   // Label 1456: @59821
     /*  59821 */   GIM_Reject,
     /*  59822 */ // Label 1453: @59822
     /*  59822 */ GIM_Reject,
     /*  59823 */ // Label 1448: @59823
     /*  59823 */ GIM_Reject,
     /*  59824 */ // Label 12: @59824
     /*  59824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1461*/ GIMT_Encode4(60478),
     /*  59835 */ /*GILLT_s8*//*Label 1457*/ GIMT_Encode4(59851),
     /*  59839 */ /*GILLT_s16*//*Label 1458*/ GIMT_Encode4(59897),
     /*  59843 */ /*GILLT_s32*//*Label 1459*/ GIMT_Encode4(60036),
     /*  59847 */ /*GILLT_s64*//*Label 1460*/ GIMT_Encode4(60172),
     /*  59851 */ // Label 1457: @59851
     /*  59851 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(59896), // Rule ID 22576 //
     /*  59856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59859 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  59870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59881 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  59881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  59884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59886 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59894 */   GIR_RootConstrainSelectedInstOperands,
     /*  59895 */   // GIR_Coverage, 22576,
     /*  59895 */   GIR_EraseRootFromParent_Done,
     /*  59896 */ // Label 1462: @59896
     /*  59896 */ GIM_Reject,
     /*  59897 */ // Label 1458: @59897
     /*  59897 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(60035),
     /*  59902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59920 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(59977), // Rule ID 22577 //
     /*  59925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59932 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59944 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59959 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59976 */     // GIR_Coverage, 22577,
     /*  59976 */     GIR_EraseRootFromParent_Done,
     /*  59977 */   // Label 1464: @59977
     /*  59977 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(60034), // Rule ID 22650 //
     /*  59982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59989 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60001 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60005 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60016 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  60023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  60028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  60033 */     // GIR_Coverage, 22650,
     /*  60033 */     GIR_EraseRootFromParent_Done,
     /*  60034 */   // Label 1465: @60034
     /*  60034 */   GIM_Reject,
     /*  60035 */ // Label 1463: @60035
     /*  60035 */ GIM_Reject,
     /*  60036 */ // Label 1459: @60036
     /*  60036 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(60171),
     /*  60041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60044 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(60086), // Rule ID 619 //
     /*  60049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60071 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60084 */     GIR_RootConstrainSelectedInstOperands,
     /*  60085 */     // GIR_Coverage, 619,
     /*  60085 */     GIR_EraseRootFromParent_Done,
     /*  60086 */   // Label 1467: @60086
     /*  60086 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(60128), // Rule ID 621 //
     /*  60091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60113 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60126 */     GIR_RootConstrainSelectedInstOperands,
     /*  60127 */     // GIR_Coverage, 621,
     /*  60127 */     GIR_EraseRootFromParent_Done,
     /*  60128 */   // Label 1468: @60128
     /*  60128 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(60170), // Rule ID 22578 //
     /*  60133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60155 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60168 */     GIR_RootConstrainSelectedInstOperands,
     /*  60169 */     // GIR_Coverage, 22578,
     /*  60169 */     GIR_EraseRootFromParent_Done,
     /*  60170 */   // Label 1469: @60170
     /*  60170 */   GIM_Reject,
     /*  60171 */ // Label 1466: @60171
     /*  60171 */ GIM_Reject,
     /*  60172 */ // Label 1460: @60172
     /*  60172 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(60477),
     /*  60177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60180 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(60254), // Rule ID 17591 //
     /*  60185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60207 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60219 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60223 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60253 */     // GIR_Coverage, 17591,
     /*  60253 */     GIR_EraseRootFromParent_Done,
     /*  60254 */   // Label 1471: @60254
     /*  60254 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(60328), // Rule ID 17593 //
     /*  60259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60281 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60293 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60297 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60327 */     // GIR_Coverage, 17593,
     /*  60327 */     GIR_EraseRootFromParent_Done,
     /*  60328 */   // Label 1472: @60328
     /*  60328 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(60402), // Rule ID 17595 //
     /*  60333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  60340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60355 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  60362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60367 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60371 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60401 */     // GIR_Coverage, 17595,
     /*  60401 */     GIR_EraseRootFromParent_Done,
     /*  60402 */   // Label 1473: @60402
     /*  60402 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(60476), // Rule ID 22579 //
     /*  60407 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60429 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60441 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60475 */     // GIR_Coverage, 22579,
     /*  60475 */     GIR_EraseRootFromParent_Done,
     /*  60476 */   // Label 1474: @60476
     /*  60476 */   GIM_Reject,
     /*  60477 */ // Label 1470: @60477
     /*  60477 */ GIM_Reject,
     /*  60478 */ // Label 1461: @60478
     /*  60478 */ GIM_Reject,
     /*  60479 */ // Label 13: @60479
     /*  60479 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 1497*/ GIMT_Encode4(85941),
     /*  60490 */ /*GILLT_s8*//*Label 1475*/ GIMT_Encode4(60586),
     /*  60494 */ /*GILLT_s16*//*Label 1476*/ GIMT_Encode4(65256),
     /*  60498 */ /*GILLT_s32*//*Label 1477*/ GIMT_Encode4(70500),
     /*  60502 */ /*GILLT_s64*//*Label 1478*/ GIMT_Encode4(76200),
     /*  60506 */ /*GILLT_s80*//*Label 1479*/ GIMT_Encode4(81592),
     /*  60510 */ /*GILLT_s128*//*Label 1480*/ GIMT_Encode4(81751), GIMT_Encode4(0),
     /*  60518 */ /*GILLT_v2s64*//*Label 1481*/ GIMT_Encode4(82005), GIMT_Encode4(0),
     /*  60526 */ /*GILLT_v4s32*//*Label 1482*/ GIMT_Encode4(82499),
     /*  60530 */ /*GILLT_v4s64*//*Label 1483*/ GIMT_Encode4(82993),
     /*  60534 */ /*GILLT_v8s1*//*Label 1484*/ GIMT_Encode4(83327),
     /*  60538 */ /*GILLT_v8s16*//*Label 1485*/ GIMT_Encode4(83409),
     /*  60542 */ /*GILLT_v8s32*//*Label 1486*/ GIMT_Encode4(83983),
     /*  60546 */ /*GILLT_v8s64*//*Label 1487*/ GIMT_Encode4(84317),
     /*  60550 */ /*GILLT_v16s1*//*Label 1488*/ GIMT_Encode4(84491),
     /*  60554 */ /*GILLT_v16s8*//*Label 1489*/ GIMT_Encode4(84573),
     /*  60558 */ /*GILLT_v16s16*//*Label 1490*/ GIMT_Encode4(84827),
     /*  60562 */ /*GILLT_v16s32*//*Label 1491*/ GIMT_Encode4(85161),
     /*  60566 */ /*GILLT_v32s1*//*Label 1492*/ GIMT_Encode4(85335),
     /*  60570 */ /*GILLT_v32s8*//*Label 1493*/ GIMT_Encode4(85417),
     /*  60574 */ /*GILLT_v32s16*//*Label 1494*/ GIMT_Encode4(85591),
     /*  60578 */ /*GILLT_v64s1*//*Label 1495*/ GIMT_Encode4(85765),
     /*  60582 */ /*GILLT_v64s8*//*Label 1496*/ GIMT_Encode4(85847),
     /*  60586 */ // Label 1475: @60586
     /*  60586 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(60682), // Rule ID 22491 //
     /*  60591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60594 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60597 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60612 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60620 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60624 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60628 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60631 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60635 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60642 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60646 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60650 */   // MIs[0] dst
     /*  60650 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60655 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60657 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60664 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60667 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60671 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60680 */   GIR_RootConstrainSelectedInstOperands,
     /*  60681 */   // GIR_Coverage, 22491,
     /*  60681 */   GIR_EraseRootFromParent_Done,
     /*  60682 */ // Label 1498: @60682
     /*  60682 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(60778), // Rule ID 22495 //
     /*  60687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60708 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60716 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60720 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60724 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60731 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60738 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60742 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60746 */   // MIs[0] dst
     /*  60746 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60751 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60753 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60760 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60763 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60767 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60776 */   GIR_RootConstrainSelectedInstOperands,
     /*  60777 */   // GIR_Coverage, 22495,
     /*  60777 */   GIR_EraseRootFromParent_Done,
     /*  60778 */ // Label 1499: @60778
     /*  60778 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(60871), // Rule ID 22499 //
     /*  60783 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  60801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60809 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  60813 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60817 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60821 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60824 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60828 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60835 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60839 */   // MIs[0] dst
     /*  60839 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60844 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60846 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60853 */   // (atomic_store (sub:{ *:[i8] } 0:{ *:[i8] }, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  60856 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60860 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60863 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60869 */   GIR_RootConstrainSelectedInstOperands,
     /*  60870 */   // GIR_Coverage, 22499,
     /*  60870 */   GIR_EraseRootFromParent_Done,
     /*  60871 */ // Label 1500: @60871
     /*  60871 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(60961), // Rule ID 22503 //
     /*  60876 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60886 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60894 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60898 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60902 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60906 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60910 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60917 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60924 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60928 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60932 */   // MIs[0] dst
     /*  60932 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60937 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60939 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60946 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NOT8m addr:{ *:[iPTR] }:$dst)
     /*  60946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  60949 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60959 */   GIR_RootConstrainSelectedInstOperands,
     /*  60960 */   // GIR_Coverage, 22503,
     /*  60960 */   GIR_EraseRootFromParent_Done,
     /*  60961 */ // Label 1501: @60961
     /*  60961 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(61047), // Rule ID 225 //
     /*  60966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60984 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60992 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60996 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61000 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61003 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61007 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61011 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  61015 */   // MIs[0] src1
     /*  61015 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61020 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61022 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61029 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  61032 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61036 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61045 */   GIR_RootConstrainSelectedInstOperands,
     /*  61046 */   // GIR_Coverage, 225,
     /*  61046 */   GIR_EraseRootFromParent_Done,
     /*  61047 */ // Label 1502: @61047
     /*  61047 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(61133), // Rule ID 228 //
     /*  61052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  61055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61070 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61074 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61078 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61082 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61086 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61089 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61093 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61097 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61101 */   // MIs[0] src1
     /*  61101 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61106 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61108 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61115 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  61118 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61122 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61131 */   GIR_RootConstrainSelectedInstOperands,
     /*  61132 */   // GIR_Coverage, 228,
     /*  61132 */   GIR_EraseRootFromParent_Done,
     /*  61133 */ // Label 1503: @61133
     /*  61133 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(61216), // Rule ID 17612 //
     /*  61138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61141 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  61153 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61157 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61161 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61165 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61169 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61172 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61176 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61180 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61184 */   // MIs[0] dst
     /*  61184 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61189 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61191 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61198 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1),
     /*  61201 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61205 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61214 */   GIR_RootConstrainSelectedInstOperands,
     /*  61215 */   // GIR_Coverage, 17612,
     /*  61215 */   GIR_EraseRootFromParent_Done,
     /*  61216 */ // Label 1504: @61216
     /*  61216 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(61299), // Rule ID 17616 //
     /*  61221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61224 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  61236 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61240 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61252 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61255 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61259 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61263 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61267 */   // MIs[0] dst
     /*  61267 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61272 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61274 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61281 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1),
     /*  61284 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61288 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61297 */   GIR_RootConstrainSelectedInstOperands,
     /*  61298 */   // GIR_Coverage, 17616,
     /*  61298 */   GIR_EraseRootFromParent_Done,
     /*  61299 */ // Label 1505: @61299
     /*  61299 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(61382), // Rule ID 261 //
     /*  61304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61307 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61319 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61327 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  61331 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61335 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61339 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61342 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61346 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61350 */   // MIs[0] src1
     /*  61350 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61355 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61357 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61364 */   // (st (sub:{ *:[i8] } 0:{ *:[i8] }, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  61367 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61371 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61380 */   GIR_RootConstrainSelectedInstOperands,
     /*  61381 */   // GIR_Coverage, 261,
     /*  61381 */   GIR_EraseRootFromParent_Done,
     /*  61382 */ // Label 1506: @61382
     /*  61382 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(61462), // Rule ID 269 //
     /*  61387 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61394 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61402 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61406 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61410 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61414 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61418 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61421 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61425 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61429 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61433 */   // MIs[0] src1
     /*  61433 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61438 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61440 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61447 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT8m addr:{ *:[iPTR] }:$src1)
     /*  61447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  61450 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61460 */   GIR_RootConstrainSelectedInstOperands,
     /*  61461 */   // GIR_Coverage, 269,
     /*  61461 */   GIR_EraseRootFromParent_Done,
     /*  61462 */ // Label 1507: @61462
     /*  61462 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(61557), // Rule ID 413 //
     /*  61467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61482 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61490 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61494 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61498 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61501 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61505 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61509 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61513 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61517 */   // MIs[3] Operand 1
     /*  61517 */   // No operand predicates
     /*  61517 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61521 */   // MIs[0] src1
     /*  61521 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61526 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61528 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61535 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61538 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61542 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61545 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61555 */   GIR_RootConstrainSelectedInstOperands,
     /*  61556 */   // GIR_Coverage, 413,
     /*  61556 */   GIR_EraseRootFromParent_Done,
     /*  61557 */ // Label 1508: @61557
     /*  61557 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(61652), // Rule ID 305 //
     /*  61562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61577 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61581 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61585 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61589 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61593 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61600 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61604 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61608 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61612 */   // MIs[3] Operand 1
     /*  61612 */   // No operand predicates
     /*  61612 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61616 */   // MIs[0] src1
     /*  61616 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61621 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61623 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61630 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61633 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61637 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61640 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61650 */   GIR_RootConstrainSelectedInstOperands,
     /*  61651 */   // GIR_Coverage, 305,
     /*  61651 */   GIR_EraseRootFromParent_Done,
     /*  61652 */ // Label 1509: @61652
     /*  61652 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(61747), // Rule ID 341 //
     /*  61657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61672 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61676 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61680 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61684 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61688 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61691 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61695 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61699 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61703 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61707 */   // MIs[3] Operand 1
     /*  61707 */   // No operand predicates
     /*  61707 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61711 */   // MIs[0] src1
     /*  61711 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61716 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61718 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61725 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61728 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61732 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61735 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61745 */   GIR_RootConstrainSelectedInstOperands,
     /*  61746 */   // GIR_Coverage, 341,
     /*  61746 */   GIR_EraseRootFromParent_Done,
     /*  61747 */ // Label 1510: @61747
     /*  61747 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(61842), // Rule ID 453 //
     /*  61752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61783 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61790 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61794 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61798 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61802 */   // MIs[3] Operand 1
     /*  61802 */   // No operand predicates
     /*  61802 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61806 */   // MIs[0] src1
     /*  61806 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61811 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61813 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61820 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  61823 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61827 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61830 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61840 */   GIR_RootConstrainSelectedInstOperands,
     /*  61841 */   // GIR_Coverage, 453,
     /*  61841 */   GIR_EraseRootFromParent_Done,
     /*  61842 */ // Label 1511: @61842
     /*  61842 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(61937), // Rule ID 377 //
     /*  61847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61862 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61870 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61874 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61878 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61881 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61885 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61889 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61893 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61897 */   // MIs[3] Operand 1
     /*  61897 */   // No operand predicates
     /*  61897 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61901 */   // MIs[0] src1
     /*  61901 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61906 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61908 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61915 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  61918 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61922 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61925 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61928 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61935 */   GIR_RootConstrainSelectedInstOperands,
     /*  61936 */   // GIR_Coverage, 377,
     /*  61936 */   GIR_EraseRootFromParent_Done,
     /*  61937 */ // Label 1512: @61937
     /*  61937 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(62038), // Rule ID 22427 //
     /*  61942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61945 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61968 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61979 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61983 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61990 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61994 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61998 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62002 */   // MIs[3] Operand 1
     /*  62002 */   // No operand predicates
     /*  62002 */   // MIs[0] dst
     /*  62002 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62007 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62009 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62016 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  62019 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62023 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62026 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62029 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62036 */   GIR_RootConstrainSelectedInstOperands,
     /*  62037 */   // GIR_Coverage, 22427,
     /*  62037 */   GIR_EraseRootFromParent_Done,
     /*  62038 */ // Label 1513: @62038
     /*  62038 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(62139), // Rule ID 22435 //
     /*  62043 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62046 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62065 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62077 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62080 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62084 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62091 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62095 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62099 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62103 */   // MIs[3] Operand 1
     /*  62103 */   // No operand predicates
     /*  62103 */   // MIs[0] dst
     /*  62103 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62108 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62110 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62117 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  62120 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62124 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62127 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62137 */   GIR_RootConstrainSelectedInstOperands,
     /*  62138 */   // GIR_Coverage, 22435,
     /*  62138 */   GIR_EraseRootFromParent_Done,
     /*  62139 */ // Label 1514: @62139
     /*  62139 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(62240), // Rule ID 22443 //
     /*  62144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  62162 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62166 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62170 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62174 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62178 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62181 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62185 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62192 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62196 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62200 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62204 */   // MIs[3] Operand 1
     /*  62204 */   // No operand predicates
     /*  62204 */   // MIs[0] dst
     /*  62204 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62209 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62211 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62218 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  62221 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62225 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62228 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62238 */   GIR_RootConstrainSelectedInstOperands,
     /*  62239 */   // GIR_Coverage, 22443,
     /*  62239 */   GIR_EraseRootFromParent_Done,
     /*  62240 */ // Label 1515: @62240
     /*  62240 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(62341), // Rule ID 22459 //
     /*  62245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  62263 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62271 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62275 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62286 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62293 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62297 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62301 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62305 */   // MIs[3] Operand 1
     /*  62305 */   // No operand predicates
     /*  62305 */   // MIs[0] dst
     /*  62305 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62310 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62312 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62319 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  62322 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62326 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62329 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62339 */   GIR_RootConstrainSelectedInstOperands,
     /*  62340 */   // GIR_Coverage, 22459,
     /*  62340 */   GIR_EraseRootFromParent_Done,
     /*  62341 */ // Label 1516: @62341
     /*  62341 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(62442), // Rule ID 22451 //
     /*  62346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62364 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62368 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62372 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62376 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62380 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62387 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62394 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62398 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62402 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62406 */   // MIs[3] Operand 1
     /*  62406 */   // No operand predicates
     /*  62406 */   // MIs[0] dst
     /*  62406 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62411 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62413 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62420 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  62423 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62427 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62430 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62440 */   GIR_RootConstrainSelectedInstOperands,
     /*  62441 */   // GIR_Coverage, 22451,
     /*  62441 */   GIR_EraseRootFromParent_Done,
     /*  62442 */ // Label 1517: @62442
     /*  62442 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(62533), // Rule ID 733 //
     /*  62447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  62462 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62466 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62470 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62474 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62478 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62481 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62485 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62489 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62493 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62497 */   // MIs[3] Operand 1
     /*  62497 */   // No operand predicates
     /*  62497 */   // MIs[0] src1
     /*  62497 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62502 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62504 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62511 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi),
     /*  62514 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62518 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62521 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62531 */   GIR_RootConstrainSelectedInstOperands,
     /*  62532 */   // GIR_Coverage, 733,
     /*  62532 */   GIR_EraseRootFromParent_Done,
     /*  62533 */ // Label 1518: @62533
     /*  62533 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(62624), // Rule ID 701 //
     /*  62538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62541 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62557 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62561 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62565 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62569 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62572 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62576 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62580 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62584 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62588 */   // MIs[3] Operand 1
     /*  62588 */   // No operand predicates
     /*  62588 */   // MIs[0] src1
     /*  62588 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62593 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62595 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62602 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi),
     /*  62605 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62609 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62612 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62615 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62622 */   GIR_RootConstrainSelectedInstOperands,
     /*  62623 */   // GIR_Coverage, 701,
     /*  62623 */   GIR_EraseRootFromParent_Done,
     /*  62624 */ // Label 1519: @62624
     /*  62624 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(62715), // Rule ID 765 //
     /*  62629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  62644 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62648 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62652 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62656 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62660 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62663 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62667 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62671 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62675 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62679 */   // MIs[3] Operand 1
     /*  62679 */   // No operand predicates
     /*  62679 */   // MIs[0] src1
     /*  62679 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62684 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62686 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62693 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi),
     /*  62696 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62700 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62703 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62713 */   GIR_RootConstrainSelectedInstOperands,
     /*  62714 */   // GIR_Coverage, 765,
     /*  62714 */   GIR_EraseRootFromParent_Done,
     /*  62715 */ // Label 1520: @62715
     /*  62715 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(62806), // Rule ID 797 //
     /*  62720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  62735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62743 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62751 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62754 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62758 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62762 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62766 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62770 */   // MIs[3] Operand 1
     /*  62770 */   // No operand predicates
     /*  62770 */   // MIs[0] src1
     /*  62770 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62775 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62777 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62784 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi),
     /*  62787 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62791 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62794 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62804 */   GIR_RootConstrainSelectedInstOperands,
     /*  62805 */   // GIR_Coverage, 797,
     /*  62805 */   GIR_EraseRootFromParent_Done,
     /*  62806 */ // Label 1521: @62806
     /*  62806 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(62897), // Rule ID 669 //
     /*  62811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62814 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  62826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62834 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62838 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62842 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62845 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62849 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62853 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62857 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62861 */   // MIs[3] Operand 1
     /*  62861 */   // No operand predicates
     /*  62861 */   // MIs[0] src1
     /*  62861 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62866 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62868 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62875 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi),
     /*  62878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62882 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62885 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62895 */   GIR_RootConstrainSelectedInstOperands,
     /*  62896 */   // GIR_Coverage, 669,
     /*  62896 */   GIR_EraseRootFromParent_Done,
     /*  62897 */ // Label 1522: @62897
     /*  62897 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(62995), // Rule ID 22431 //
     /*  62902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62920 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62924 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62928 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62932 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62943 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62950 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62954 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62959 */   // MIs[0] dst
     /*  62959 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62964 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62966 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62973 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62976 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62980 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62984 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62993 */   GIR_RootConstrainSelectedInstOperands,
     /*  62994 */   // GIR_Coverage, 22431,
     /*  62994 */   GIR_EraseRootFromParent_Done,
     /*  62995 */ // Label 1523: @62995
     /*  62995 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63093), // Rule ID 26002 //
     /*  63000 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63003 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63031 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63035 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63039 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63046 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63053 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63057 */   // MIs[0] dst
     /*  63057 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63062 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63064 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63071 */   // (atomic_store (add:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63074 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63078 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63082 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63091 */   GIR_RootConstrainSelectedInstOperands,
     /*  63092 */   // GIR_Coverage, 26002,
     /*  63092 */   GIR_EraseRootFromParent_Done,
     /*  63093 */ // Label 1524: @63093
     /*  63093 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63191), // Rule ID 22439 //
     /*  63098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63116 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63120 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63124 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63128 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63132 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63139 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63146 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63150 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63155 */   // MIs[0] dst
     /*  63155 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63160 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63162 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63169 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63172 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63176 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63180 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63189 */   GIR_RootConstrainSelectedInstOperands,
     /*  63190 */   // GIR_Coverage, 22439,
     /*  63190 */   GIR_EraseRootFromParent_Done,
     /*  63191 */ // Label 1525: @63191
     /*  63191 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63289), // Rule ID 26006 //
     /*  63196 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63199 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63206 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63214 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63218 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63227 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63231 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63235 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63242 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63249 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63253 */   // MIs[0] dst
     /*  63253 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63258 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63260 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63267 */   // (atomic_store (and:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63270 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63274 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63278 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63287 */   GIR_RootConstrainSelectedInstOperands,
     /*  63288 */   // GIR_Coverage, 26006,
     /*  63288 */   GIR_EraseRootFromParent_Done,
     /*  63289 */ // Label 1526: @63289
     /*  63289 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63387), // Rule ID 22447 //
     /*  63294 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63312 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63316 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63320 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63324 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63328 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63335 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63342 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63346 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63351 */   // MIs[0] dst
     /*  63351 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63356 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63358 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63365 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63368 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63372 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63376 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63385 */   GIR_RootConstrainSelectedInstOperands,
     /*  63386 */   // GIR_Coverage, 22447,
     /*  63386 */   GIR_EraseRootFromParent_Done,
     /*  63387 */ // Label 1527: @63387
     /*  63387 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63485), // Rule ID 26010 //
     /*  63392 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63410 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63414 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63423 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63427 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63431 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63438 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63445 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63449 */   // MIs[0] dst
     /*  63449 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63454 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63456 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63463 */   // (atomic_store (or:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63466 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63470 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63474 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63483 */   GIR_RootConstrainSelectedInstOperands,
     /*  63484 */   // GIR_Coverage, 26010,
     /*  63484 */   GIR_EraseRootFromParent_Done,
     /*  63485 */ // Label 1528: @63485
     /*  63485 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63583), // Rule ID 22463 //
     /*  63490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  63508 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63516 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63520 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63527 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63531 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63538 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63542 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63547 */   // MIs[0] dst
     /*  63547 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63552 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63554 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63561 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  63564 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63568 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63572 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63581 */   GIR_RootConstrainSelectedInstOperands,
     /*  63582 */   // GIR_Coverage, 22463,
     /*  63582 */   GIR_EraseRootFromParent_Done,
     /*  63583 */ // Label 1529: @63583
     /*  63583 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63681), // Rule ID 22455 //
     /*  63588 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63591 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63606 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63610 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63614 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63618 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63622 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63629 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63636 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63640 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63645 */   // MIs[0] dst
     /*  63645 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63650 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63652 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63659 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63662 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63666 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63670 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63679 */   GIR_RootConstrainSelectedInstOperands,
     /*  63680 */   // GIR_Coverage, 22455,
     /*  63680 */   GIR_EraseRootFromParent_Done,
     /*  63681 */ // Label 1530: @63681
     /*  63681 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63779), // Rule ID 26014 //
     /*  63686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63712 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63717 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63721 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63732 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63739 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63743 */   // MIs[0] dst
     /*  63743 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63748 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63750 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63757 */   // (atomic_store (xor:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63760 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63764 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63768 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63777 */   GIR_RootConstrainSelectedInstOperands,
     /*  63778 */   // GIR_Coverage, 26014,
     /*  63778 */   GIR_EraseRootFromParent_Done,
     /*  63779 */ // Label 1531: @63779
     /*  63779 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63867), // Rule ID 409 //
     /*  63784 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63787 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63799 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63803 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63807 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63811 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63815 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63822 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63831 */   // MIs[0] src1
     /*  63831 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63836 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63838 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63845 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63848 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63852 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63856 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63865 */   GIR_RootConstrainSelectedInstOperands,
     /*  63866 */   // GIR_Coverage, 409,
     /*  63866 */   GIR_EraseRootFromParent_Done,
     /*  63867 */ // Label 1532: @63867
     /*  63867 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(63955), // Rule ID 23222 //
     /*  63872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63887 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63891 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63895 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63900 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63904 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63908 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63911 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63915 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63919 */   // MIs[0] src1
     /*  63919 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63924 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63926 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63933 */   // (st (add:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63936 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63940 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63944 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63953 */   GIR_RootConstrainSelectedInstOperands,
     /*  63954 */   // GIR_Coverage, 23222,
     /*  63954 */   GIR_EraseRootFromParent_Done,
     /*  63955 */ // Label 1533: @63955
     /*  63955 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(64043), // Rule ID 301 //
     /*  63960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63975 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63979 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63983 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63987 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63991 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63998 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64002 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64007 */   // MIs[0] src1
     /*  64007 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64012 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64014 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64021 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  64024 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64032 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64041 */   GIR_RootConstrainSelectedInstOperands,
     /*  64042 */   // GIR_Coverage, 301,
     /*  64042 */   GIR_EraseRootFromParent_Done,
     /*  64043 */ // Label 1534: @64043
     /*  64043 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(64131), // Rule ID 23186 //
     /*  64048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64051 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64063 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64067 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64071 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64076 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64080 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64084 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64091 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64095 */   // MIs[0] src1
     /*  64095 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64100 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64102 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64109 */   // (st (and:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  64112 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64116 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64120 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64123 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64129 */   GIR_RootConstrainSelectedInstOperands,
     /*  64130 */   // GIR_Coverage, 23186,
     /*  64130 */   GIR_EraseRootFromParent_Done,
     /*  64131 */ // Label 1535: @64131
     /*  64131 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(64229), // Rule ID 749 //
     /*  64136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64139 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  64151 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64159 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64163 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64167 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64170 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64174 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64178 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64183 */   // MIs[0] src1
     /*  64183 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64188 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64190 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64197 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64201 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL),
     /*  64214 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64218 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64221 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64227 */   GIR_RootConstrainSelectedInstOperands,
     /*  64228 */   // GIR_Coverage, 749,
     /*  64228 */   GIR_EraseRootFromParent_Done,
     /*  64229 */ // Label 1536: @64229
     /*  64229 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(64327), // Rule ID 717 //
     /*  64234 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64237 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64249 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64257 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64261 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64265 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64268 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64272 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64276 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64281 */   // MIs[0] src1
     /*  64281 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64286 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64288 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64295 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64299 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL),
     /*  64312 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64316 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64325 */   GIR_RootConstrainSelectedInstOperands,
     /*  64326 */   // GIR_Coverage, 717,
     /*  64326 */   GIR_EraseRootFromParent_Done,
     /*  64327 */ // Label 1537: @64327
     /*  64327 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(64415), // Rule ID 337 //
     /*  64332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64351 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64355 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64359 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64363 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64370 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64374 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64379 */   // MIs[0] src1
     /*  64379 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64384 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64386 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64393 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64396 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64400 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64404 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64413 */   GIR_RootConstrainSelectedInstOperands,
     /*  64414 */   // GIR_Coverage, 337,
     /*  64414 */   GIR_EraseRootFromParent_Done,
     /*  64415 */ // Label 1538: @64415
     /*  64415 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(64503), // Rule ID 23198 //
     /*  64420 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64423 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64435 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64448 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64452 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64456 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64463 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64467 */   // MIs[0] src1
     /*  64467 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64472 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64474 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64481 */   // (st (or:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64484 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64492 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64501 */   GIR_RootConstrainSelectedInstOperands,
     /*  64502 */   // GIR_Coverage, 23198,
     /*  64502 */   GIR_EraseRootFromParent_Done,
     /*  64503 */ // Label 1539: @64503
     /*  64503 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(64601), // Rule ID 781 //
     /*  64508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  64523 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64527 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64539 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64542 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64546 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64550 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64555 */   // MIs[0] src1
     /*  64555 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64560 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64562 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64569 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64573 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64579 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL),
     /*  64586 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64590 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64599 */   GIR_RootConstrainSelectedInstOperands,
     /*  64600 */   // GIR_Coverage, 781,
     /*  64600 */   GIR_EraseRootFromParent_Done,
     /*  64601 */ // Label 1540: @64601
     /*  64601 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(64699), // Rule ID 813 //
     /*  64606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64609 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  64621 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64625 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64629 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64633 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64637 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64640 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64644 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64653 */   // MIs[0] src1
     /*  64653 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64658 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64660 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64667 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64671 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64677 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL),
     /*  64684 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64688 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64697 */   GIR_RootConstrainSelectedInstOperands,
     /*  64698 */   // GIR_Coverage, 813,
     /*  64698 */   GIR_EraseRootFromParent_Done,
     /*  64699 */ // Label 1541: @64699
     /*  64699 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(64797), // Rule ID 685 //
     /*  64704 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64707 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  64719 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64723 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64727 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64731 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64735 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64738 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64742 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64746 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64751 */   // MIs[0] src1
     /*  64751 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64756 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64758 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64765 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64769 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64775 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL),
     /*  64782 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64786 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64795 */   GIR_RootConstrainSelectedInstOperands,
     /*  64796 */   // GIR_Coverage, 685,
     /*  64796 */   GIR_EraseRootFromParent_Done,
     /*  64797 */ // Label 1542: @64797
     /*  64797 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(64885), // Rule ID 445 //
     /*  64802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  64817 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64821 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64825 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64829 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64833 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64840 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64844 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64849 */   // MIs[0] src1
     /*  64849 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64854 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64856 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64863 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  64866 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64870 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64874 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64883 */   GIR_RootConstrainSelectedInstOperands,
     /*  64884 */   // GIR_Coverage, 445,
     /*  64884 */   GIR_EraseRootFromParent_Done,
     /*  64885 */ // Label 1543: @64885
     /*  64885 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(64973), // Rule ID 373 //
     /*  64890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64905 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64909 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64913 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64917 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64921 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64928 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64932 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64937 */   // MIs[0] src1
     /*  64937 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64942 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64944 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64951 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64954 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64958 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64962 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64971 */   GIR_RootConstrainSelectedInstOperands,
     /*  64972 */   // GIR_Coverage, 373,
     /*  64972 */   GIR_EraseRootFromParent_Done,
     /*  64973 */ // Label 1544: @64973
     /*  64973 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(65061), // Rule ID 23210 //
     /*  64978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64993 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64997 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65001 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65006 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65010 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65014 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65021 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65025 */   // MIs[0] src1
     /*  65025 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65030 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65032 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65039 */   // (st (xor:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  65039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  65042 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65046 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  65050 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65053 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65059 */   GIR_RootConstrainSelectedInstOperands,
     /*  65060 */   // GIR_Coverage, 23210,
     /*  65060 */   GIR_EraseRootFromParent_Done,
     /*  65061 */ // Label 1545: @65061
     /*  65061 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(65115), // Rule ID 24 //
     /*  65066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65069 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65081 */   // MIs[1] Operand 1
     /*  65081 */   // No operand predicates
     /*  65081 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  65085 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65098 */   // (st (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  65098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  65101 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65105 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  65108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  65113 */   GIR_RootConstrainSelectedInstOperands,
     /*  65114 */   // GIR_Coverage, 24,
     /*  65114 */   GIR_EraseRootFromParent_Done,
     /*  65115 */ // Label 1546: @65115
     /*  65115 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(65168), // Rule ID 22507 //
     /*  65120 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65123 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  65130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65138 */   // MIs[1] Operand 1
     /*  65138 */   // No operand predicates
     /*  65138 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65144 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65151 */   // (atomic_store (imm:{ *:[i8] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  65151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  65154 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65158 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  65161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  65166 */   GIR_RootConstrainSelectedInstOperands,
     /*  65167 */   // GIR_Coverage, 22507,
     /*  65167 */   GIR_EraseRootFromParent_Done,
     /*  65168 */ // Label 1547: @65168
     /*  65168 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(65213), // Rule ID 22511 //
     /*  65173 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65176 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  65183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65191 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65198 */   // (atomic_store GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65201 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65205 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65211 */   GIR_RootConstrainSelectedInstOperands,
     /*  65212 */   // GIR_Coverage, 22511,
     /*  65212 */   GIR_EraseRootFromParent_Done,
     /*  65213 */ // Label 1548: @65213
     /*  65213 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(65255), // Rule ID 32 //
     /*  65218 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65221 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65229 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65233 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65240 */   // (st GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65243 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65247 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65253 */   GIR_RootConstrainSelectedInstOperands,
     /*  65254 */   // GIR_Coverage, 32,
     /*  65254 */   GIR_EraseRootFromParent_Done,
     /*  65255 */ // Label 1549: @65255
     /*  65255 */ GIM_Reject,
     /*  65256 */ // Label 1476: @65256
     /*  65256 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(65352), // Rule ID 22492 //
     /*  65261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65264 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65267 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65290 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65294 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65301 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65305 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65312 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65316 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65320 */   // MIs[0] dst
     /*  65320 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65325 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65327 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65334 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65337 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65341 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65350 */   GIR_RootConstrainSelectedInstOperands,
     /*  65351 */   // GIR_Coverage, 22492,
     /*  65351 */   GIR_EraseRootFromParent_Done,
     /*  65352 */ // Label 1550: @65352
     /*  65352 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(65448), // Rule ID 22496 //
     /*  65357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65360 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65382 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65386 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65390 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65394 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65401 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65408 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65412 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65416 */   // MIs[0] dst
     /*  65416 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65421 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65423 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65430 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65433 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65437 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65446 */   GIR_RootConstrainSelectedInstOperands,
     /*  65447 */   // GIR_Coverage, 22496,
     /*  65447 */   GIR_EraseRootFromParent_Done,
     /*  65448 */ // Label 1551: @65448
     /*  65448 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(65541), // Rule ID 22500 //
     /*  65453 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65456 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65479 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65483 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65487 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65491 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65498 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65505 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65509 */   // MIs[0] dst
     /*  65509 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65514 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65516 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65523 */   // (atomic_store (sub:{ *:[i16] } 0:{ *:[i16] }, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65526 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65530 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65533 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65539 */   GIR_RootConstrainSelectedInstOperands,
     /*  65540 */   // GIR_Coverage, 22500,
     /*  65540 */   GIR_EraseRootFromParent_Done,
     /*  65541 */ // Label 1552: @65541
     /*  65541 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(65631), // Rule ID 22504 //
     /*  65546 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65549 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65568 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65572 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65576 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65580 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65587 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65594 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65598 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65602 */   // MIs[0] dst
     /*  65602 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65607 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65609 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65616 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NOT16m addr:{ *:[iPTR] }:$dst)
     /*  65616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65619 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65629 */   GIR_RootConstrainSelectedInstOperands,
     /*  65630 */   // GIR_Coverage, 22504,
     /*  65630 */   GIR_EraseRootFromParent_Done,
     /*  65631 */ // Label 1553: @65631
     /*  65631 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(65717), // Rule ID 226 //
     /*  65636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65646 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65654 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65658 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65662 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65666 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65670 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65673 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65677 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65681 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65685 */   // MIs[0] src1
     /*  65685 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65690 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65692 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65699 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65702 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65706 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65715 */   GIR_RootConstrainSelectedInstOperands,
     /*  65716 */   // GIR_Coverage, 226,
     /*  65716 */   GIR_EraseRootFromParent_Done,
     /*  65717 */ // Label 1554: @65717
     /*  65717 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(65803), // Rule ID 229 //
     /*  65722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65744 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65748 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65752 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65756 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65759 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65763 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65767 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65771 */   // MIs[0] src1
     /*  65771 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65776 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65778 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65785 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65788 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65792 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65801 */   GIR_RootConstrainSelectedInstOperands,
     /*  65802 */   // GIR_Coverage, 229,
     /*  65802 */   GIR_EraseRootFromParent_Done,
     /*  65803 */ // Label 1555: @65803
     /*  65803 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(65896), // Rule ID 22614 //
     /*  65808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65811 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65823 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65827 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65831 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65835 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65839 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65842 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65846 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65850 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  65861 */   // MIs[0] dst
     /*  65861 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65866 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65868 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65875 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i16] })
     /*  65875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  65878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  65885 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65894 */   GIR_RootConstrainSelectedInstOperands,
     /*  65895 */   // GIR_Coverage, 22614,
     /*  65895 */   GIR_EraseRootFromParent_Done,
     /*  65896 */ // Label 1556: @65896
     /*  65896 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(65979), // Rule ID 17613 //
     /*  65901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  65916 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65920 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65924 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65928 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65932 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65935 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65939 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65947 */   // MIs[0] dst
     /*  65947 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65952 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65954 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65961 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1),
     /*  65964 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65968 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65977 */   GIR_RootConstrainSelectedInstOperands,
     /*  65978 */   // GIR_Coverage, 17613,
     /*  65978 */   GIR_EraseRootFromParent_Done,
     /*  65979 */ // Label 1557: @65979
     /*  65979 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(66062), // Rule ID 17617 //
     /*  65984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  65999 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  66007 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66011 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66015 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66018 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66022 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66026 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  66030 */   // MIs[0] dst
     /*  66030 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66035 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66037 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66044 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  66044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1),
     /*  66047 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66051 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66060 */   GIR_RootConstrainSelectedInstOperands,
     /*  66061 */   // GIR_Coverage, 17617,
     /*  66061 */   GIR_EraseRootFromParent_Done,
     /*  66062 */ // Label 1558: @66062
     /*  66062 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(66145), // Rule ID 262 //
     /*  66067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66082 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66086 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66090 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  66094 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66098 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66102 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66105 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66109 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66113 */   // MIs[0] src1
     /*  66113 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66118 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66120 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66127 */   // (st (sub:{ *:[i16] } 0:{ *:[i16] }, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  66127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  66130 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66134 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66143 */   GIR_RootConstrainSelectedInstOperands,
     /*  66144 */   // GIR_Coverage, 262,
     /*  66144 */   GIR_EraseRootFromParent_Done,
     /*  66145 */ // Label 1559: @66145
     /*  66145 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(66225), // Rule ID 270 //
     /*  66150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66165 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66169 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66173 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66177 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66181 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66184 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66188 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66192 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  66196 */   // MIs[0] src1
     /*  66196 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66201 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66203 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66210 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT16m addr:{ *:[iPTR] }:$src1)
     /*  66210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  66213 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66223 */   GIR_RootConstrainSelectedInstOperands,
     /*  66224 */   // GIR_Coverage, 270,
     /*  66224 */   GIR_EraseRootFromParent_Done,
     /*  66225 */ // Label 1560: @66225
     /*  66225 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(66320), // Rule ID 414 //
     /*  66230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66245 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66253 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66257 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66261 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66268 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66272 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66276 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66280 */   // MIs[3] Operand 1
     /*  66280 */   // No operand predicates
     /*  66280 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66284 */   // MIs[0] src1
     /*  66284 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66289 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66291 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66298 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66301 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66305 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66308 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66318 */   GIR_RootConstrainSelectedInstOperands,
     /*  66319 */   // GIR_Coverage, 414,
     /*  66319 */   GIR_EraseRootFromParent_Done,
     /*  66320 */ // Label 1561: @66320
     /*  66320 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(66415), // Rule ID 306 //
     /*  66325 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66328 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66340 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66344 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66348 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66352 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66356 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66359 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66363 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66367 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66371 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66375 */   // MIs[3] Operand 1
     /*  66375 */   // No operand predicates
     /*  66375 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66379 */   // MIs[0] src1
     /*  66379 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66384 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66386 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66393 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66396 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66400 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66403 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66413 */   GIR_RootConstrainSelectedInstOperands,
     /*  66414 */   // GIR_Coverage, 306,
     /*  66414 */   GIR_EraseRootFromParent_Done,
     /*  66415 */ // Label 1562: @66415
     /*  66415 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(66510), // Rule ID 342 //
     /*  66420 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66423 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66435 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66443 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66447 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66451 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66458 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66462 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66466 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66470 */   // MIs[3] Operand 1
     /*  66470 */   // No operand predicates
     /*  66470 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66474 */   // MIs[0] src1
     /*  66474 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66479 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66481 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66488 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66491 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66495 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66498 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66508 */   GIR_RootConstrainSelectedInstOperands,
     /*  66509 */   // GIR_Coverage, 342,
     /*  66509 */   GIR_EraseRootFromParent_Done,
     /*  66510 */ // Label 1563: @66510
     /*  66510 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(66605), // Rule ID 454 //
     /*  66515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66518 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66534 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66538 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66542 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66546 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66549 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66553 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66557 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66561 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66565 */   // MIs[3] Operand 1
     /*  66565 */   // No operand predicates
     /*  66565 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66569 */   // MIs[0] src1
     /*  66569 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66574 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66576 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66583 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66586 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66590 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66593 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66603 */   GIR_RootConstrainSelectedInstOperands,
     /*  66604 */   // GIR_Coverage, 454,
     /*  66604 */   GIR_EraseRootFromParent_Done,
     /*  66605 */ // Label 1564: @66605
     /*  66605 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(66700), // Rule ID 378 //
     /*  66610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66613 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66625 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66633 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66637 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66641 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66644 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66648 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66652 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66656 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66660 */   // MIs[3] Operand 1
     /*  66660 */   // No operand predicates
     /*  66660 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66664 */   // MIs[0] src1
     /*  66664 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66669 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66671 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66678 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66681 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66685 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66688 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66698 */   GIR_RootConstrainSelectedInstOperands,
     /*  66699 */   // GIR_Coverage, 378,
     /*  66699 */   GIR_EraseRootFromParent_Done,
     /*  66700 */ // Label 1565: @66700
     /*  66700 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(66801), // Rule ID 22428 //
     /*  66705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66723 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66727 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66731 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66735 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66746 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66753 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66757 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66761 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66765 */   // MIs[3] Operand 1
     /*  66765 */   // No operand predicates
     /*  66765 */   // MIs[0] dst
     /*  66765 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66770 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66772 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66779 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66782 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66786 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66789 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66799 */   GIR_RootConstrainSelectedInstOperands,
     /*  66800 */   // GIR_Coverage, 22428,
     /*  66800 */   GIR_EraseRootFromParent_Done,
     /*  66801 */ // Label 1566: @66801
     /*  66801 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(66902), // Rule ID 22436 //
     /*  66806 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66809 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66824 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66832 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66836 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66840 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66843 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66847 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66854 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66858 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66862 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66866 */   // MIs[3] Operand 1
     /*  66866 */   // No operand predicates
     /*  66866 */   // MIs[0] dst
     /*  66866 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66871 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66873 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66880 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66883 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66890 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66900 */   GIR_RootConstrainSelectedInstOperands,
     /*  66901 */   // GIR_Coverage, 22436,
     /*  66901 */   GIR_EraseRootFromParent_Done,
     /*  66902 */ // Label 1567: @66902
     /*  66902 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(67003), // Rule ID 22444 //
     /*  66907 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66925 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66933 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66937 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66941 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66948 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66955 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66959 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66963 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66967 */   // MIs[3] Operand 1
     /*  66967 */   // No operand predicates
     /*  66967 */   // MIs[0] dst
     /*  66967 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66972 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66974 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66981 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66984 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66988 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66991 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67001 */   GIR_RootConstrainSelectedInstOperands,
     /*  67002 */   // GIR_Coverage, 22444,
     /*  67002 */   GIR_EraseRootFromParent_Done,
     /*  67003 */ // Label 1568: @67003
     /*  67003 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(67104), // Rule ID 22460 //
     /*  67008 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67011 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  67026 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67030 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67034 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67038 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67042 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67045 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67049 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67056 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67060 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67064 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67068 */   // MIs[3] Operand 1
     /*  67068 */   // No operand predicates
     /*  67068 */   // MIs[0] dst
     /*  67068 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67073 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67075 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67082 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  67085 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67089 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67092 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67102 */   GIR_RootConstrainSelectedInstOperands,
     /*  67103 */   // GIR_Coverage, 22460,
     /*  67103 */   GIR_EraseRootFromParent_Done,
     /*  67104 */ // Label 1569: @67104
     /*  67104 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(67205), // Rule ID 22452 //
     /*  67109 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67119 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67127 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67131 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67135 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67139 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67143 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67150 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67157 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67161 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67165 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67169 */   // MIs[3] Operand 1
     /*  67169 */   // No operand predicates
     /*  67169 */   // MIs[0] dst
     /*  67169 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67174 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67176 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67183 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  67186 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67190 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67193 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67203 */   GIR_RootConstrainSelectedInstOperands,
     /*  67204 */   // GIR_Coverage, 22452,
     /*  67204 */   GIR_EraseRootFromParent_Done,
     /*  67205 */ // Label 1570: @67205
     /*  67205 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(67296), // Rule ID 734 //
     /*  67210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67213 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  67225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67233 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67237 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67241 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67244 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67248 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67252 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67256 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67260 */   // MIs[3] Operand 1
     /*  67260 */   // No operand predicates
     /*  67260 */   // MIs[0] src1
     /*  67260 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67265 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67267 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67274 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi),
     /*  67277 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67281 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67284 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67294 */   GIR_RootConstrainSelectedInstOperands,
     /*  67295 */   // GIR_Coverage, 734,
     /*  67295 */   GIR_EraseRootFromParent_Done,
     /*  67296 */ // Label 1571: @67296
     /*  67296 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(67387), // Rule ID 702 //
     /*  67301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  67316 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67324 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67328 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67332 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67335 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67339 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67343 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67347 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67351 */   // MIs[3] Operand 1
     /*  67351 */   // No operand predicates
     /*  67351 */   // MIs[0] src1
     /*  67351 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67356 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67358 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67365 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi),
     /*  67368 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67372 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67375 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67385 */   GIR_RootConstrainSelectedInstOperands,
     /*  67386 */   // GIR_Coverage, 702,
     /*  67386 */   GIR_EraseRootFromParent_Done,
     /*  67387 */ // Label 1572: @67387
     /*  67387 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(67478), // Rule ID 766 //
     /*  67392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  67407 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67415 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67419 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67423 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67426 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67430 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67434 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67438 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67442 */   // MIs[3] Operand 1
     /*  67442 */   // No operand predicates
     /*  67442 */   // MIs[0] src1
     /*  67442 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67447 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67449 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67456 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi),
     /*  67459 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67463 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67466 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67476 */   GIR_RootConstrainSelectedInstOperands,
     /*  67477 */   // GIR_Coverage, 766,
     /*  67477 */   GIR_EraseRootFromParent_Done,
     /*  67478 */ // Label 1573: @67478
     /*  67478 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(67569), // Rule ID 798 //
     /*  67483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  67498 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67502 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67506 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67510 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67514 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67517 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67521 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67525 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67529 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67533 */   // MIs[3] Operand 1
     /*  67533 */   // No operand predicates
     /*  67533 */   // MIs[0] src1
     /*  67533 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67538 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67540 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67547 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi),
     /*  67550 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67554 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67557 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67567 */   GIR_RootConstrainSelectedInstOperands,
     /*  67568 */   // GIR_Coverage, 798,
     /*  67568 */   GIR_EraseRootFromParent_Done,
     /*  67569 */ // Label 1574: @67569
     /*  67569 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(67660), // Rule ID 670 //
     /*  67574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  67589 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67593 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67597 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67601 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67605 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67608 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67612 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67616 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67620 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67624 */   // MIs[3] Operand 1
     /*  67624 */   // No operand predicates
     /*  67624 */   // MIs[0] src1
     /*  67624 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67629 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67631 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67638 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi),
     /*  67641 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67645 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67648 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67658 */   GIR_RootConstrainSelectedInstOperands,
     /*  67659 */   // GIR_Coverage, 670,
     /*  67659 */   GIR_EraseRootFromParent_Done,
     /*  67660 */ // Label 1575: @67660
     /*  67660 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(67758), // Rule ID 22432 //
     /*  67665 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67683 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67687 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67691 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67695 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67699 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67706 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67713 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67717 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67722 */   // MIs[0] dst
     /*  67722 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67727 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67729 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67736 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67739 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67747 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67756 */   GIR_RootConstrainSelectedInstOperands,
     /*  67757 */   // GIR_Coverage, 22432,
     /*  67757 */   GIR_EraseRootFromParent_Done,
     /*  67758 */ // Label 1576: @67758
     /*  67758 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(67856), // Rule ID 26003 //
     /*  67763 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67766 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67781 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67785 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67789 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67794 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67798 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67802 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67809 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67816 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67820 */   // MIs[0] dst
     /*  67820 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67825 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67827 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67834 */   // (atomic_store (add:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67837 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67841 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67845 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67854 */   GIR_RootConstrainSelectedInstOperands,
     /*  67855 */   // GIR_Coverage, 26003,
     /*  67855 */   GIR_EraseRootFromParent_Done,
     /*  67856 */ // Label 1577: @67856
     /*  67856 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(67954), // Rule ID 22440 //
     /*  67861 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67879 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67883 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67887 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67891 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67895 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67902 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67909 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67913 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67918 */   // MIs[0] dst
     /*  67918 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67923 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67925 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67932 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67935 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67943 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67952 */   GIR_RootConstrainSelectedInstOperands,
     /*  67953 */   // GIR_Coverage, 22440,
     /*  67953 */   GIR_EraseRootFromParent_Done,
     /*  67954 */ // Label 1578: @67954
     /*  67954 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(68052), // Rule ID 26007 //
     /*  67959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67962 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67977 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67981 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67985 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67990 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67994 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67998 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68005 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68012 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68016 */   // MIs[0] dst
     /*  68016 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68021 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68023 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68030 */   // (atomic_store (and:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68033 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68037 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68041 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68050 */   GIR_RootConstrainSelectedInstOperands,
     /*  68051 */   // GIR_Coverage, 26007,
     /*  68051 */   GIR_EraseRootFromParent_Done,
     /*  68052 */ // Label 1579: @68052
     /*  68052 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(68150), // Rule ID 22448 //
     /*  68057 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68060 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68075 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68079 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68083 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68087 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68091 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68098 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68105 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68109 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68114 */   // MIs[0] dst
     /*  68114 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68119 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68121 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68128 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68131 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68135 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68139 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68148 */   GIR_RootConstrainSelectedInstOperands,
     /*  68149 */   // GIR_Coverage, 22448,
     /*  68149 */   GIR_EraseRootFromParent_Done,
     /*  68150 */ // Label 1580: @68150
     /*  68150 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(68248), // Rule ID 26011 //
     /*  68155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68158 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68173 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68177 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68186 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68190 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68201 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68208 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68212 */   // MIs[0] dst
     /*  68212 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68217 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68219 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68226 */   // (atomic_store (or:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68229 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68237 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68246 */   GIR_RootConstrainSelectedInstOperands,
     /*  68247 */   // GIR_Coverage, 26011,
     /*  68247 */   GIR_EraseRootFromParent_Done,
     /*  68248 */ // Label 1581: @68248
     /*  68248 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(68346), // Rule ID 22464 //
     /*  68253 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68263 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  68271 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68275 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68279 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68283 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68287 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68290 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68294 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68301 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68305 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68310 */   // MIs[0] dst
     /*  68310 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68315 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68317 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68324 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  68327 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68331 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68335 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68344 */   GIR_RootConstrainSelectedInstOperands,
     /*  68345 */   // GIR_Coverage, 22464,
     /*  68345 */   GIR_EraseRootFromParent_Done,
     /*  68346 */ // Label 1582: @68346
     /*  68346 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(68444), // Rule ID 22456 //
     /*  68351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68361 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68365 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68369 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68377 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68381 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68385 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68392 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68399 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68403 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68408 */   // MIs[0] dst
     /*  68408 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68413 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68415 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68422 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68425 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68429 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68433 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68442 */   GIR_RootConstrainSelectedInstOperands,
     /*  68443 */   // GIR_Coverage, 22456,
     /*  68443 */   GIR_EraseRootFromParent_Done,
     /*  68444 */ // Label 1583: @68444
     /*  68444 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(68542), // Rule ID 26015 //
     /*  68449 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68480 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68484 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68488 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68495 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68502 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68506 */   // MIs[0] dst
     /*  68506 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68511 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68513 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68520 */   // (atomic_store (xor:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68523 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68527 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68531 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68534 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68540 */   GIR_RootConstrainSelectedInstOperands,
     /*  68541 */   // GIR_Coverage, 26015,
     /*  68541 */   GIR_EraseRootFromParent_Done,
     /*  68542 */ // Label 1584: @68542
     /*  68542 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(68630), // Rule ID 410 //
     /*  68547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68550 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68562 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68566 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68570 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68574 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68578 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68585 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68589 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68594 */   // MIs[0] src1
     /*  68594 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68599 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68601 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68608 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68611 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68615 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68619 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68628 */   GIR_RootConstrainSelectedInstOperands,
     /*  68629 */   // GIR_Coverage, 410,
     /*  68629 */   GIR_EraseRootFromParent_Done,
     /*  68630 */ // Label 1585: @68630
     /*  68630 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(68718), // Rule ID 23223 //
     /*  68635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68638 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68650 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68654 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68658 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68663 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68667 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68671 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68678 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68682 */   // MIs[0] src1
     /*  68682 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68687 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68689 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68696 */   // (st (add:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68699 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68703 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68707 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68716 */   GIR_RootConstrainSelectedInstOperands,
     /*  68717 */   // GIR_Coverage, 23223,
     /*  68717 */   GIR_EraseRootFromParent_Done,
     /*  68718 */ // Label 1586: @68718
     /*  68718 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(68806), // Rule ID 302 //
     /*  68723 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68726 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68742 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68746 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68750 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68754 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68757 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68761 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68765 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68770 */   // MIs[0] src1
     /*  68770 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68775 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68777 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68784 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68787 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68791 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68795 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68804 */   GIR_RootConstrainSelectedInstOperands,
     /*  68805 */   // GIR_Coverage, 302,
     /*  68805 */   GIR_EraseRootFromParent_Done,
     /*  68806 */ // Label 1587: @68806
     /*  68806 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(68894), // Rule ID 23187 //
     /*  68811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68814 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68834 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68839 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68843 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68847 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68854 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68858 */   // MIs[0] src1
     /*  68858 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68863 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68865 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68872 */   // (st (and:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68879 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68883 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68886 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68892 */   GIR_RootConstrainSelectedInstOperands,
     /*  68893 */   // GIR_Coverage, 23187,
     /*  68893 */   GIR_EraseRootFromParent_Done,
     /*  68894 */ // Label 1588: @68894
     /*  68894 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(68992), // Rule ID 750 //
     /*  68899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  68914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68918 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68922 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68926 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68930 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68933 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68937 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68941 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68946 */   // MIs[0] src1
     /*  68946 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68951 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68953 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68960 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68964 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68970 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL),
     /*  68977 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68981 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68990 */   GIR_RootConstrainSelectedInstOperands,
     /*  68991 */   // GIR_Coverage, 750,
     /*  68991 */   GIR_EraseRootFromParent_Done,
     /*  68992 */ // Label 1589: @68992
     /*  68992 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(69090), // Rule ID 718 //
     /*  68997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69004 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  69012 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69016 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69020 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69024 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69028 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69031 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69035 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69044 */   // MIs[0] src1
     /*  69044 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69049 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69051 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69058 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69062 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69068 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL),
     /*  69075 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69079 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69082 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69088 */   GIR_RootConstrainSelectedInstOperands,
     /*  69089 */   // GIR_Coverage, 718,
     /*  69089 */   GIR_EraseRootFromParent_Done,
     /*  69090 */ // Label 1590: @69090
     /*  69090 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(69178), // Rule ID 338 //
     /*  69095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  69110 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69114 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69118 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69122 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69126 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69133 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69137 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69142 */   // MIs[0] src1
     /*  69142 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69147 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69149 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69156 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69159 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69163 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69167 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69176 */   GIR_RootConstrainSelectedInstOperands,
     /*  69177 */   // GIR_Coverage, 338,
     /*  69177 */   GIR_EraseRootFromParent_Done,
     /*  69178 */ // Label 1591: @69178
     /*  69178 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(69266), // Rule ID 23199 //
     /*  69183 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69186 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69190 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69194 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  69198 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69202 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69206 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69211 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69215 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69219 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69226 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69230 */   // MIs[0] src1
     /*  69230 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69235 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69237 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69244 */   // (st (or:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69247 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69251 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69255 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69264 */   GIR_RootConstrainSelectedInstOperands,
     /*  69265 */   // GIR_Coverage, 23199,
     /*  69265 */   GIR_EraseRootFromParent_Done,
     /*  69266 */ // Label 1592: @69266
     /*  69266 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(69364), // Rule ID 782 //
     /*  69271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69274 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  69286 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69290 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69294 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69298 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69302 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69305 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69309 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69313 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69318 */   // MIs[0] src1
     /*  69318 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69323 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69325 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69332 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69336 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69342 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL),
     /*  69349 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69353 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69362 */   GIR_RootConstrainSelectedInstOperands,
     /*  69363 */   // GIR_Coverage, 782,
     /*  69363 */   GIR_EraseRootFromParent_Done,
     /*  69364 */ // Label 1593: @69364
     /*  69364 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(69462), // Rule ID 814 //
     /*  69369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69372 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  69384 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69388 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69392 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69396 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69400 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69403 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69407 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69416 */   // MIs[0] src1
     /*  69416 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69421 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69423 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69430 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69434 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69440 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL),
     /*  69447 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69451 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69460 */   GIR_RootConstrainSelectedInstOperands,
     /*  69461 */   // GIR_Coverage, 814,
     /*  69461 */   GIR_EraseRootFromParent_Done,
     /*  69462 */ // Label 1594: @69462
     /*  69462 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(69560), // Rule ID 686 //
     /*  69467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  69482 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69490 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69494 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69498 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69501 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69505 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69509 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69514 */   // MIs[0] src1
     /*  69514 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69519 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69521 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69528 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69532 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69538 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL),
     /*  69545 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69549 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69558 */   GIR_RootConstrainSelectedInstOperands,
     /*  69559 */   // GIR_Coverage, 686,
     /*  69559 */   GIR_EraseRootFromParent_Done,
     /*  69560 */ // Label 1595: @69560
     /*  69560 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(69648), // Rule ID 446 //
     /*  69565 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69568 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  69580 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69584 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69588 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69592 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69596 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69603 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69612 */   // MIs[0] src1
     /*  69612 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69617 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69619 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69626 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  69629 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69633 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69637 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69646 */   GIR_RootConstrainSelectedInstOperands,
     /*  69647 */   // GIR_Coverage, 446,
     /*  69647 */   GIR_EraseRootFromParent_Done,
     /*  69648 */ // Label 1596: @69648
     /*  69648 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(69736), // Rule ID 374 //
     /*  69653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69668 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69672 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69676 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69680 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69684 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69691 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69695 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69700 */   // MIs[0] src1
     /*  69700 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69705 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69707 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69714 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69717 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69721 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69725 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69734 */   GIR_RootConstrainSelectedInstOperands,
     /*  69735 */   // GIR_Coverage, 374,
     /*  69735 */   GIR_EraseRootFromParent_Done,
     /*  69736 */ // Label 1597: @69736
     /*  69736 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(69824), // Rule ID 23211 //
     /*  69741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69756 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69760 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69764 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69769 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69773 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69777 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69780 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69784 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69788 */   // MIs[0] src1
     /*  69788 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69793 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69795 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69802 */   // (st (xor:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69805 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69809 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69813 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69822 */   GIR_RootConstrainSelectedInstOperands,
     /*  69823 */   // GIR_Coverage, 23211,
     /*  69823 */   GIR_EraseRootFromParent_Done,
     /*  69824 */ // Label 1598: @69824
     /*  69824 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(69878), // Rule ID 25 //
     /*  69829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69832 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69844 */   // MIs[1] Operand 1
     /*  69844 */   // No operand predicates
     /*  69844 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  69848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69854 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69861 */   // (st (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69864 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69868 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69876 */   GIR_RootConstrainSelectedInstOperands,
     /*  69877 */   // GIR_Coverage, 25,
     /*  69877 */   GIR_EraseRootFromParent_Done,
     /*  69878 */ // Label 1599: @69878
     /*  69878 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(69931), // Rule ID 22508 //
     /*  69883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69901 */   // MIs[1] Operand 1
     /*  69901 */   // No operand predicates
     /*  69901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69914 */   // (atomic_store (imm:{ *:[i16] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69917 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69921 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69929 */   GIR_RootConstrainSelectedInstOperands,
     /*  69930 */   // GIR_Coverage, 22508,
     /*  69930 */   GIR_EraseRootFromParent_Done,
     /*  69931 */ // Label 1600: @69931
     /*  69931 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(69994), // Rule ID 50 //
     /*  69936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  69939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69954 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69958 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69976 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr),
     /*  69979 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69983 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69992 */   GIR_RootConstrainSelectedInstOperands,
     /*  69993 */   // GIR_Coverage, 50,
     /*  69993 */   GIR_EraseRootFromParent_Done,
     /*  69994 */ // Label 1601: @69994
     /*  69994 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(70057), // Rule ID 56 //
     /*  69999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  70002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70005 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  70017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  70021 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70039 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr_EVEX addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  70039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr_EVEX),
     /*  70042 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70046 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  70050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  70055 */   GIR_RootConstrainSelectedInstOperands,
     /*  70056 */   // GIR_Coverage, 56,
     /*  70056 */   GIR_EraseRootFromParent_Done,
     /*  70057 */ // Label 1602: @70057
     /*  70057 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(70102), // Rule ID 22512 //
     /*  70062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  70072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70087 */   // (atomic_store GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  70087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70090 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70094 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70100 */   GIR_RootConstrainSelectedInstOperands,
     /*  70101 */   // GIR_Coverage, 22512,
     /*  70101 */   GIR_EraseRootFromParent_Done,
     /*  70102 */ // Label 1603: @70102
     /*  70102 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(70144), // Rule ID 33 //
     /*  70107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70122 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70129 */   // (st GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  70129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70132 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70136 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70142 */   GIR_RootConstrainSelectedInstOperands,
     /*  70143 */   // GIR_Coverage, 33,
     /*  70143 */   GIR_EraseRootFromParent_Done,
     /*  70144 */ // Label 1604: @70144
     /*  70144 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(70189), // Rule ID 4622 //
     /*  70149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  70152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70155 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  70163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70174 */   // (st FR16X:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSHZmr addr:{ *:[iPTR] }:$dst, FR16X:{ *:[f16] }:$src)
     /*  70174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZmr),
     /*  70177 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70181 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70187 */   GIR_RootConstrainSelectedInstOperands,
     /*  70188 */   // GIR_Coverage, 4622,
     /*  70188 */   GIR_EraseRootFromParent_Done,
     /*  70189 */ // Label 1605: @70189
     /*  70189 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(70255), // Rule ID 18547 //
     /*  70194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  70197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70200 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70215 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PEXTRWmri),
     /*  70239 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70253 */   GIR_RootConstrainSelectedInstOperands,
     /*  70254 */   // GIR_Coverage, 18547,
     /*  70254 */   GIR_EraseRootFromParent_Done,
     /*  70255 */ // Label 1606: @70255
     /*  70255 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(70321), // Rule ID 18548 //
     /*  70260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  70263 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70266 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70281 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70293 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWmri),
     /*  70305 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70319 */   GIR_RootConstrainSelectedInstOperands,
     /*  70320 */   // GIR_Coverage, 18548,
     /*  70320 */   GIR_EraseRootFromParent_Done,
     /*  70321 */ // Label 1607: @70321
     /*  70321 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(70433), // Rule ID 18336 //
     /*  70326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  70329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70336 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70347 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] }))
     /*  70347 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  70350 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70354 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70359 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70363 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70368 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  70371 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  70375 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70380 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  70383 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  70386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  70388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  70391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70400 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  70407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  70412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  70417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70420 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70431 */   GIR_RootConstrainSelectedInstOperands,
     /*  70432 */   // GIR_Coverage, 18336,
     /*  70432 */   GIR_EraseRootFromParent_Done,
     /*  70433 */ // Label 1608: @70433
     /*  70433 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(70499), // Rule ID 21840 //
     /*  70438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  70441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70452 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70459 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWZmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70471 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZmri),
     /*  70483 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70497 */   GIR_RootConstrainSelectedInstOperands,
     /*  70498 */   // GIR_Coverage, 21840,
     /*  70498 */   GIR_EraseRootFromParent_Done,
     /*  70499 */ // Label 1609: @70499
     /*  70499 */ GIM_Reject,
     /*  70500 */ // Label 1477: @70500
     /*  70500 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(70596), // Rule ID 22493 //
     /*  70505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70508 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70530 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70534 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70538 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70542 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70545 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70549 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70556 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70560 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70564 */   // MIs[0] dst
     /*  70564 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70569 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70571 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70578 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70585 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70594 */   GIR_RootConstrainSelectedInstOperands,
     /*  70595 */   // GIR_Coverage, 22493,
     /*  70595 */   GIR_EraseRootFromParent_Done,
     /*  70596 */ // Label 1610: @70596
     /*  70596 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(70692), // Rule ID 22497 //
     /*  70601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70604 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70607 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70622 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70630 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70634 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70638 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70645 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70652 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70656 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70660 */   // MIs[0] dst
     /*  70660 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70665 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70667 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70674 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70677 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70681 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70690 */   GIR_RootConstrainSelectedInstOperands,
     /*  70691 */   // GIR_Coverage, 22497,
     /*  70691 */   GIR_EraseRootFromParent_Done,
     /*  70692 */ // Label 1611: @70692
     /*  70692 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(70785), // Rule ID 22501 //
     /*  70697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70715 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70723 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70727 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70731 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70735 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70742 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70749 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70753 */   // MIs[0] dst
     /*  70753 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70758 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70760 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70767 */   // (atomic_store (sub:{ *:[i32] } 0:{ *:[i32] }, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70770 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70774 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70777 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70783 */   GIR_RootConstrainSelectedInstOperands,
     /*  70784 */   // GIR_Coverage, 22501,
     /*  70784 */   GIR_EraseRootFromParent_Done,
     /*  70785 */ // Label 1612: @70785
     /*  70785 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(70875), // Rule ID 22505 //
     /*  70790 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70808 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70812 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70816 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70820 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70824 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70831 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70838 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70842 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70846 */   // MIs[0] dst
     /*  70846 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70851 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70853 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70860 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NOT32m addr:{ *:[iPTR] }:$dst)
     /*  70860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  70863 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70873 */   GIR_RootConstrainSelectedInstOperands,
     /*  70874 */   // GIR_Coverage, 22505,
     /*  70874 */   GIR_EraseRootFromParent_Done,
     /*  70875 */ // Label 1613: @70875
     /*  70875 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(70961), // Rule ID 227 //
     /*  70880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70902 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70906 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70910 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70914 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70917 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70921 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70925 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70929 */   // MIs[0] src1
     /*  70929 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70934 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70936 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70943 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70946 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70950 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70959 */   GIR_RootConstrainSelectedInstOperands,
     /*  70960 */   // GIR_Coverage, 227,
     /*  70960 */   GIR_EraseRootFromParent_Done,
     /*  70961 */ // Label 1614: @70961
     /*  70961 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(71047), // Rule ID 230 //
     /*  70966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70984 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70992 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70996 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71000 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71003 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71007 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71011 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71015 */   // MIs[0] src1
     /*  71015 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71020 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71022 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71029 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  71032 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71036 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71045 */   GIR_RootConstrainSelectedInstOperands,
     /*  71046 */   // GIR_Coverage, 230,
     /*  71046 */   GIR_EraseRootFromParent_Done,
     /*  71047 */ // Label 1615: @71047
     /*  71047 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(71140), // Rule ID 22615 //
     /*  71052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71055 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71067 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71071 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71075 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71079 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71083 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71086 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71090 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71094 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  71105 */   // MIs[0] dst
     /*  71105 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71110 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71112 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71119 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i32] })
     /*  71119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71122 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  71129 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71138 */   GIR_RootConstrainSelectedInstOperands,
     /*  71139 */   // GIR_Coverage, 22615,
     /*  71139 */   GIR_EraseRootFromParent_Done,
     /*  71140 */ // Label 1616: @71140
     /*  71140 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(71223), // Rule ID 17614 //
     /*  71145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71152 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71156 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  71160 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71164 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71168 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71172 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71176 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71179 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71183 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71187 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71191 */   // MIs[0] dst
     /*  71191 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71196 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71198 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71205 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1),
     /*  71208 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71212 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71221 */   GIR_RootConstrainSelectedInstOperands,
     /*  71222 */   // GIR_Coverage, 17614,
     /*  71222 */   GIR_EraseRootFromParent_Done,
     /*  71223 */ // Label 1617: @71223
     /*  71223 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(71306), // Rule ID 17618 //
     /*  71228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  71243 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71247 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71251 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71255 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71259 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71262 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71266 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71270 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71274 */   // MIs[0] dst
     /*  71274 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71279 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71281 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71288 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1),
     /*  71291 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71295 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71304 */   GIR_RootConstrainSelectedInstOperands,
     /*  71305 */   // GIR_Coverage, 17618,
     /*  71305 */   GIR_EraseRootFromParent_Done,
     /*  71306 */ // Label 1618: @71306
     /*  71306 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(71389), // Rule ID 263 //
     /*  71311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71314 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71326 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71330 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71334 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  71338 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71342 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71346 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71349 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71353 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71357 */   // MIs[0] src1
     /*  71357 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71362 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71364 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71371 */   // (st (sub:{ *:[i32] } 0:{ *:[i32] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  71374 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71378 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71387 */   GIR_RootConstrainSelectedInstOperands,
     /*  71388 */   // GIR_Coverage, 263,
     /*  71388 */   GIR_EraseRootFromParent_Done,
     /*  71389 */ // Label 1619: @71389
     /*  71389 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(71469), // Rule ID 271 //
     /*  71394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71409 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71413 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71417 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71421 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71425 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71428 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71432 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71436 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71440 */   // MIs[0] src1
     /*  71440 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71445 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71447 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71454 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT32m addr:{ *:[iPTR] }:$src1)
     /*  71454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  71457 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71467 */   GIR_RootConstrainSelectedInstOperands,
     /*  71468 */   // GIR_Coverage, 271,
     /*  71468 */   GIR_EraseRootFromParent_Done,
     /*  71469 */ // Label 1620: @71469
     /*  71469 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(71564), // Rule ID 415 //
     /*  71474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71477 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71489 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71493 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71497 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71501 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71505 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71512 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71516 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71520 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71524 */   // MIs[3] Operand 1
     /*  71524 */   // No operand predicates
     /*  71524 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71528 */   // MIs[0] src1
     /*  71528 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71533 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71535 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71542 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71545 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71549 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71552 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71562 */   GIR_RootConstrainSelectedInstOperands,
     /*  71563 */   // GIR_Coverage, 415,
     /*  71563 */   GIR_EraseRootFromParent_Done,
     /*  71564 */ // Label 1621: @71564
     /*  71564 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(71659), // Rule ID 307 //
     /*  71569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71572 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71584 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71588 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71592 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71596 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71600 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71607 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71611 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71615 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71619 */   // MIs[3] Operand 1
     /*  71619 */   // No operand predicates
     /*  71619 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71623 */   // MIs[0] src1
     /*  71623 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71628 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71630 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71637 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71640 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71647 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71657 */   GIR_RootConstrainSelectedInstOperands,
     /*  71658 */   // GIR_Coverage, 307,
     /*  71658 */   GIR_EraseRootFromParent_Done,
     /*  71659 */ // Label 1622: @71659
     /*  71659 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(71754), // Rule ID 343 //
     /*  71664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71687 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71691 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71695 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71702 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71706 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71710 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71714 */   // MIs[3] Operand 1
     /*  71714 */   // No operand predicates
     /*  71714 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71718 */   // MIs[0] src1
     /*  71718 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71723 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71725 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71732 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71735 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71739 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71742 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71752 */   GIR_RootConstrainSelectedInstOperands,
     /*  71753 */   // GIR_Coverage, 343,
     /*  71753 */   GIR_EraseRootFromParent_Done,
     /*  71754 */ // Label 1623: @71754
     /*  71754 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(71849), // Rule ID 455 //
     /*  71759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71766 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71774 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71782 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71786 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71790 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71797 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71801 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71805 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71809 */   // MIs[3] Operand 1
     /*  71809 */   // No operand predicates
     /*  71809 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71813 */   // MIs[0] src1
     /*  71813 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71818 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71820 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71827 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71830 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71834 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71837 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71840 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71847 */   GIR_RootConstrainSelectedInstOperands,
     /*  71848 */   // GIR_Coverage, 455,
     /*  71848 */   GIR_EraseRootFromParent_Done,
     /*  71849 */ // Label 1624: @71849
     /*  71849 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(71944), // Rule ID 379 //
     /*  71854 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71857 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71861 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71865 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71869 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71873 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71877 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71881 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71885 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71888 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71892 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71896 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71900 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71904 */   // MIs[3] Operand 1
     /*  71904 */   // No operand predicates
     /*  71904 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71908 */   // MIs[0] src1
     /*  71908 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71913 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71915 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71922 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71925 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71929 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71932 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71942 */   GIR_RootConstrainSelectedInstOperands,
     /*  71943 */   // GIR_Coverage, 379,
     /*  71943 */   GIR_EraseRootFromParent_Done,
     /*  71944 */ // Label 1625: @71944
     /*  71944 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(72045), // Rule ID 22429 //
     /*  71949 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71967 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71971 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71975 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71979 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71983 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71990 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71997 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72001 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72005 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72009 */   // MIs[3] Operand 1
     /*  72009 */   // No operand predicates
     /*  72009 */   // MIs[0] dst
     /*  72009 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72014 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72016 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72023 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  72026 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72030 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72033 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72043 */   GIR_RootConstrainSelectedInstOperands,
     /*  72044 */   // GIR_Coverage, 22429,
     /*  72044 */   GIR_EraseRootFromParent_Done,
     /*  72045 */ // Label 1626: @72045
     /*  72045 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(72146), // Rule ID 22437 //
     /*  72050 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72060 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72068 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72072 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72076 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72080 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72084 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72087 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72091 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72098 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72102 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72106 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72110 */   // MIs[3] Operand 1
     /*  72110 */   // No operand predicates
     /*  72110 */   // MIs[0] dst
     /*  72110 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72115 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72117 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72124 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  72127 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72131 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72134 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72144 */   GIR_RootConstrainSelectedInstOperands,
     /*  72145 */   // GIR_Coverage, 22437,
     /*  72145 */   GIR_EraseRootFromParent_Done,
     /*  72146 */ // Label 1627: @72146
     /*  72146 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(72247), // Rule ID 22445 //
     /*  72151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72161 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  72169 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72177 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72181 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72185 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72192 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72199 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72203 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72207 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72211 */   // MIs[3] Operand 1
     /*  72211 */   // No operand predicates
     /*  72211 */   // MIs[0] dst
     /*  72211 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72216 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72218 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72225 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  72228 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72232 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72235 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72245 */   GIR_RootConstrainSelectedInstOperands,
     /*  72246 */   // GIR_Coverage, 22445,
     /*  72246 */   GIR_EraseRootFromParent_Done,
     /*  72247 */ // Label 1628: @72247
     /*  72247 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(72348), // Rule ID 22461 //
     /*  72252 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  72270 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72274 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72278 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72282 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72286 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72293 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72300 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72304 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72308 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72312 */   // MIs[3] Operand 1
     /*  72312 */   // No operand predicates
     /*  72312 */   // MIs[0] dst
     /*  72312 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72317 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72319 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72326 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  72329 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72333 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72336 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72346 */   GIR_RootConstrainSelectedInstOperands,
     /*  72347 */   // GIR_Coverage, 22461,
     /*  72347 */   GIR_EraseRootFromParent_Done,
     /*  72348 */ // Label 1629: @72348
     /*  72348 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(72449), // Rule ID 22453 //
     /*  72353 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72356 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72371 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72379 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72383 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72387 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72394 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72401 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72405 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72409 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72413 */   // MIs[3] Operand 1
     /*  72413 */   // No operand predicates
     /*  72413 */   // MIs[0] dst
     /*  72413 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72418 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72420 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72427 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  72430 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72434 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72437 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72447 */   GIR_RootConstrainSelectedInstOperands,
     /*  72448 */   // GIR_Coverage, 22453,
     /*  72448 */   GIR_EraseRootFromParent_Done,
     /*  72449 */ // Label 1630: @72449
     /*  72449 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(72553), // Rule ID 834 //
     /*  72454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  72469 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72473 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72477 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72481 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72485 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72489 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72492 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72496 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72500 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72505 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72509 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72513 */   // MIs[3] Operand 1
     /*  72513 */   // No operand predicates
     /*  72513 */   // MIs[0] src1
     /*  72513 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72518 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72520 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72527 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8),
     /*  72530 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72534 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  72538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72541 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72551 */   GIR_RootConstrainSelectedInstOperands,
     /*  72552 */   // GIR_Coverage, 834,
     /*  72552 */   GIR_EraseRootFromParent_Done,
     /*  72553 */ // Label 1631: @72553
     /*  72553 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(72657), // Rule ID 858 //
     /*  72558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  72573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72581 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72585 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72590 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72594 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72598 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72601 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72605 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72609 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72613 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72617 */   // MIs[3] Operand 1
     /*  72617 */   // No operand predicates
     /*  72617 */   // MIs[0] src1
     /*  72617 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72622 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72624 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72631 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8),
     /*  72634 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  72642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72645 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72655 */   GIR_RootConstrainSelectedInstOperands,
     /*  72656 */   // GIR_Coverage, 858,
     /*  72656 */   GIR_EraseRootFromParent_Done,
     /*  72657 */ // Label 1632: @72657
     /*  72657 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(72748), // Rule ID 735 //
     /*  72662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  72677 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72681 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72685 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72689 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72693 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72696 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72700 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72704 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72708 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72712 */   // MIs[3] Operand 1
     /*  72712 */   // No operand predicates
     /*  72712 */   // MIs[0] src1
     /*  72712 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72717 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72719 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72726 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi),
     /*  72729 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72733 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72736 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72746 */   GIR_RootConstrainSelectedInstOperands,
     /*  72747 */   // GIR_Coverage, 735,
     /*  72747 */   GIR_EraseRootFromParent_Done,
     /*  72748 */ // Label 1633: @72748
     /*  72748 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(72839), // Rule ID 703 //
     /*  72753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  72768 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72772 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72776 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72780 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72784 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72787 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72791 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72795 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72799 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72803 */   // MIs[3] Operand 1
     /*  72803 */   // No operand predicates
     /*  72803 */   // MIs[0] src1
     /*  72803 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72808 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72810 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72817 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi),
     /*  72820 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72824 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72827 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72837 */   GIR_RootConstrainSelectedInstOperands,
     /*  72838 */   // GIR_Coverage, 703,
     /*  72838 */   GIR_EraseRootFromParent_Done,
     /*  72839 */ // Label 1634: @72839
     /*  72839 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(72930), // Rule ID 767 //
     /*  72844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72851 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72855 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  72859 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72863 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72867 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72871 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72875 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72878 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72882 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72886 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72890 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72894 */   // MIs[3] Operand 1
     /*  72894 */   // No operand predicates
     /*  72894 */   // MIs[0] src1
     /*  72894 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72899 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72901 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72908 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi),
     /*  72911 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72915 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72918 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72928 */   GIR_RootConstrainSelectedInstOperands,
     /*  72929 */   // GIR_Coverage, 767,
     /*  72929 */   GIR_EraseRootFromParent_Done,
     /*  72930 */ // Label 1635: @72930
     /*  72930 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(73021), // Rule ID 799 //
     /*  72935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  72950 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72958 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72962 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72966 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72969 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72973 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72977 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72981 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72985 */   // MIs[3] Operand 1
     /*  72985 */   // No operand predicates
     /*  72985 */   // MIs[0] src1
     /*  72985 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72990 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72992 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72999 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi),
     /*  73002 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73006 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  73009 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  73019 */   GIR_RootConstrainSelectedInstOperands,
     /*  73020 */   // GIR_Coverage, 799,
     /*  73020 */   GIR_EraseRootFromParent_Done,
     /*  73021 */ // Label 1636: @73021
     /*  73021 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(73112), // Rule ID 671 //
     /*  73026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73029 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  73041 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73045 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  73049 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73053 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73057 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73060 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73064 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73068 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  73072 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73076 */   // MIs[3] Operand 1
     /*  73076 */   // No operand predicates
     /*  73076 */   // MIs[0] src1
     /*  73076 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73081 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73083 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73090 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  73090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi),
     /*  73093 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73097 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  73100 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  73110 */   GIR_RootConstrainSelectedInstOperands,
     /*  73111 */   // GIR_Coverage, 671,
     /*  73111 */   GIR_EraseRootFromParent_Done,
     /*  73112 */ // Label 1637: @73112
     /*  73112 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(73210), // Rule ID 22433 //
     /*  73117 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73143 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73147 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73154 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73158 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73165 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73174 */   // MIs[0] dst
     /*  73174 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73179 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73181 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73188 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73191 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73195 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73199 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73208 */   GIR_RootConstrainSelectedInstOperands,
     /*  73209 */   // GIR_Coverage, 22433,
     /*  73209 */   GIR_EraseRootFromParent_Done,
     /*  73210 */ // Label 1638: @73210
     /*  73210 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(73308), // Rule ID 26004 //
     /*  73215 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73218 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73233 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73237 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73241 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73246 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73250 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73254 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73261 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73268 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73272 */   // MIs[0] dst
     /*  73272 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73277 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73279 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73286 */   // (atomic_store (add:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73293 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73297 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73306 */   GIR_RootConstrainSelectedInstOperands,
     /*  73307 */   // GIR_Coverage, 26004,
     /*  73307 */   GIR_EraseRootFromParent_Done,
     /*  73308 */ // Label 1639: @73308
     /*  73308 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(73406), // Rule ID 22441 //
     /*  73313 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73316 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73339 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73343 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73347 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73354 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73361 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73365 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73370 */   // MIs[0] dst
     /*  73370 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73375 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73377 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73384 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73387 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73391 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73395 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73404 */   GIR_RootConstrainSelectedInstOperands,
     /*  73405 */   // GIR_Coverage, 22441,
     /*  73405 */   GIR_EraseRootFromParent_Done,
     /*  73406 */ // Label 1640: @73406
     /*  73406 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(73504), // Rule ID 26008 //
     /*  73411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73429 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73442 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73446 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73450 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73453 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73457 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73464 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73468 */   // MIs[0] dst
     /*  73468 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73473 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73475 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73482 */   // (atomic_store (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73485 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73489 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73493 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73502 */   GIR_RootConstrainSelectedInstOperands,
     /*  73503 */   // GIR_Coverage, 26008,
     /*  73503 */   GIR_EraseRootFromParent_Done,
     /*  73504 */ // Label 1641: @73504
     /*  73504 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(73602), // Rule ID 22449 //
     /*  73509 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73527 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73535 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73539 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73550 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73557 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73566 */   // MIs[0] dst
     /*  73566 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73571 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73573 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73580 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73583 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73587 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73591 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73600 */   GIR_RootConstrainSelectedInstOperands,
     /*  73601 */   // GIR_Coverage, 22449,
     /*  73601 */   GIR_EraseRootFromParent_Done,
     /*  73602 */ // Label 1642: @73602
     /*  73602 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(73700), // Rule ID 26012 //
     /*  73607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73625 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73633 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73638 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73642 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73646 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73653 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73660 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73664 */   // MIs[0] dst
     /*  73664 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73669 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73671 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73678 */   // (atomic_store (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73681 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73689 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73698 */   GIR_RootConstrainSelectedInstOperands,
     /*  73699 */   // GIR_Coverage, 26012,
     /*  73699 */   GIR_EraseRootFromParent_Done,
     /*  73700 */ // Label 1643: @73700
     /*  73700 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(73798), // Rule ID 22465 //
     /*  73705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  73723 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73727 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73731 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73735 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73746 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73753 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73762 */   // MIs[0] dst
     /*  73762 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73767 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73769 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73776 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  73779 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73787 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73796 */   GIR_RootConstrainSelectedInstOperands,
     /*  73797 */   // GIR_Coverage, 22465,
     /*  73797 */   GIR_EraseRootFromParent_Done,
     /*  73798 */ // Label 1644: @73798
     /*  73798 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(73896), // Rule ID 22457 //
     /*  73803 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73829 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73833 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73840 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73844 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73851 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73860 */   // MIs[0] dst
     /*  73860 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73865 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73867 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73874 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73877 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73881 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73885 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73894 */   GIR_RootConstrainSelectedInstOperands,
     /*  73895 */   // GIR_Coverage, 22457,
     /*  73895 */   GIR_EraseRootFromParent_Done,
     /*  73896 */ // Label 1645: @73896
     /*  73896 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(73994), // Rule ID 26016 //
     /*  73901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73919 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73927 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73932 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73936 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73943 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73947 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73954 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73958 */   // MIs[0] dst
     /*  73958 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73965 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73972 */   // (atomic_store (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73975 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73979 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73983 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73992 */   GIR_RootConstrainSelectedInstOperands,
     /*  73993 */   // GIR_Coverage, 26016,
     /*  73993 */   GIR_EraseRootFromParent_Done,
     /*  73994 */ // Label 1646: @73994
     /*  73994 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(74105), // Rule ID 837 //
     /*  73999 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  74014 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74018 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74022 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  74026 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74030 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74034 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74037 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74041 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74045 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74050 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74055 */   // MIs[0] src1
     /*  74055 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74060 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74062 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74069 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74073 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74079 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  74083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL),
     /*  74086 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74090 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74094 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74103 */   GIR_RootConstrainSelectedInstOperands,
     /*  74104 */   // GIR_Coverage, 837,
     /*  74104 */   GIR_EraseRootFromParent_Done,
     /*  74105 */ // Label 1647: @74105
     /*  74105 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(74216), // Rule ID 861 //
     /*  74110 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  74125 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74129 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74133 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  74137 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74142 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74146 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74150 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74153 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74157 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74161 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74166 */   // MIs[0] src1
     /*  74166 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74171 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74173 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74180 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74184 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74190 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  74194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL),
     /*  74197 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74201 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74205 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74214 */   GIR_RootConstrainSelectedInstOperands,
     /*  74215 */   // GIR_Coverage, 861,
     /*  74215 */   GIR_EraseRootFromParent_Done,
     /*  74216 */ // Label 1648: @74216
     /*  74216 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(74304), // Rule ID 411 //
     /*  74221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74224 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74236 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74240 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74252 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74255 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74259 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74263 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74268 */   // MIs[0] src1
     /*  74268 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74273 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74275 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74282 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74285 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74289 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74293 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74302 */   GIR_RootConstrainSelectedInstOperands,
     /*  74303 */   // GIR_Coverage, 411,
     /*  74303 */   GIR_EraseRootFromParent_Done,
     /*  74304 */ // Label 1649: @74304
     /*  74304 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(74392), // Rule ID 23224 //
     /*  74309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74312 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74324 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74328 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74332 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74337 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74341 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74345 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74348 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74352 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74356 */   // MIs[0] src1
     /*  74356 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74361 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74363 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74370 */   // (st (add:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74373 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74377 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74381 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74390 */   GIR_RootConstrainSelectedInstOperands,
     /*  74391 */   // GIR_Coverage, 23224,
     /*  74391 */   GIR_EraseRootFromParent_Done,
     /*  74392 */ // Label 1650: @74392
     /*  74392 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(74480), // Rule ID 303 //
     /*  74397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74400 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74404 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74408 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74412 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74416 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74420 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74424 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74428 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74435 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74439 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74444 */   // MIs[0] src1
     /*  74444 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74449 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74451 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74458 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74469 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74478 */   GIR_RootConstrainSelectedInstOperands,
     /*  74479 */   // GIR_Coverage, 303,
     /*  74479 */   GIR_EraseRootFromParent_Done,
     /*  74480 */ // Label 1651: @74480
     /*  74480 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(74568), // Rule ID 23188 //
     /*  74485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74488 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74500 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74504 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74508 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74513 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74517 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74521 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74528 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74532 */   // MIs[0] src1
     /*  74532 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74537 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74539 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74546 */   // (st (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74549 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74557 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74566 */   GIR_RootConstrainSelectedInstOperands,
     /*  74567 */   // GIR_Coverage, 23188,
     /*  74567 */   GIR_EraseRootFromParent_Done,
     /*  74568 */ // Label 1652: @74568
     /*  74568 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(74666), // Rule ID 751 //
     /*  74573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74580 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  74588 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74592 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74596 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74600 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74604 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74607 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74611 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74615 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74620 */   // MIs[0] src1
     /*  74620 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74625 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74627 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74634 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74638 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74644 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL),
     /*  74651 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74655 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74664 */   GIR_RootConstrainSelectedInstOperands,
     /*  74665 */   // GIR_Coverage, 751,
     /*  74665 */   GIR_EraseRootFromParent_Done,
     /*  74666 */ // Label 1653: @74666
     /*  74666 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(74764), // Rule ID 719 //
     /*  74671 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  74686 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74694 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74698 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74702 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74705 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74709 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74713 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74718 */   // MIs[0] src1
     /*  74718 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74723 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74725 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74732 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74736 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL),
     /*  74749 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74753 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74762 */   GIR_RootConstrainSelectedInstOperands,
     /*  74763 */   // GIR_Coverage, 719,
     /*  74763 */   GIR_EraseRootFromParent_Done,
     /*  74764 */ // Label 1654: @74764
     /*  74764 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(74852), // Rule ID 339 //
     /*  74769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74784 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74788 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74792 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74796 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74800 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74807 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74816 */   // MIs[0] src1
     /*  74816 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74821 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74823 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74830 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74833 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74841 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74850 */   GIR_RootConstrainSelectedInstOperands,
     /*  74851 */   // GIR_Coverage, 339,
     /*  74851 */   GIR_EraseRootFromParent_Done,
     /*  74852 */ // Label 1655: @74852
     /*  74852 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(74940), // Rule ID 23200 //
     /*  74857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74872 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74885 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74889 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74893 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74896 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74900 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74904 */   // MIs[0] src1
     /*  74904 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74909 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74911 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74918 */   // (st (or:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74921 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74925 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74929 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74938 */   GIR_RootConstrainSelectedInstOperands,
     /*  74939 */   // GIR_Coverage, 23200,
     /*  74939 */   GIR_EraseRootFromParent_Done,
     /*  74940 */ // Label 1656: @74940
     /*  74940 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(75038), // Rule ID 783 //
     /*  74945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  74960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74968 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74976 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74979 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74983 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74992 */   // MIs[0] src1
     /*  74992 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74997 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74999 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75006 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75010 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75016 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL),
     /*  75023 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75027 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75036 */   GIR_RootConstrainSelectedInstOperands,
     /*  75037 */   // GIR_Coverage, 783,
     /*  75037 */   GIR_EraseRootFromParent_Done,
     /*  75038 */ // Label 1657: @75038
     /*  75038 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(75136), // Rule ID 815 //
     /*  75043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75046 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75050 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  75058 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75062 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  75066 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75070 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75074 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75077 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75081 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75085 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75090 */   // MIs[0] src1
     /*  75090 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75095 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75097 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75104 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75108 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75114 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL),
     /*  75121 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75125 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75134 */   GIR_RootConstrainSelectedInstOperands,
     /*  75135 */   // GIR_Coverage, 815,
     /*  75135 */   GIR_EraseRootFromParent_Done,
     /*  75136 */ // Label 1658: @75136
     /*  75136 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(75234), // Rule ID 687 //
     /*  75141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  75156 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75160 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  75164 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75168 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75172 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75175 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75179 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75188 */   // MIs[0] src1
     /*  75188 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75193 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75195 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75202 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75212 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL),
     /*  75219 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75223 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75232 */   GIR_RootConstrainSelectedInstOperands,
     /*  75233 */   // GIR_Coverage, 687,
     /*  75233 */   GIR_EraseRootFromParent_Done,
     /*  75234 */ // Label 1659: @75234
     /*  75234 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(75322), // Rule ID 447 //
     /*  75239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  75254 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75258 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75262 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75266 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75270 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75277 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75286 */   // MIs[0] src1
     /*  75286 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75291 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75293 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75300 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  75303 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75307 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75311 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75314 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75320 */   GIR_RootConstrainSelectedInstOperands,
     /*  75321 */   // GIR_Coverage, 447,
     /*  75321 */   GIR_EraseRootFromParent_Done,
     /*  75322 */ // Label 1660: @75322
     /*  75322 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(75410), // Rule ID 375 //
     /*  75327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75342 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75350 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75354 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75358 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75361 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75365 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75369 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75374 */   // MIs[0] src1
     /*  75374 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75379 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75381 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75388 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75391 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75399 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75408 */   GIR_RootConstrainSelectedInstOperands,
     /*  75409 */   // GIR_Coverage, 375,
     /*  75409 */   GIR_EraseRootFromParent_Done,
     /*  75410 */ // Label 1661: @75410
     /*  75410 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(75498), // Rule ID 23212 //
     /*  75415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75418 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75430 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75434 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75438 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75443 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75447 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75451 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75458 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75462 */   // MIs[0] src1
     /*  75462 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75467 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75469 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75476 */   // (st (xor:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75479 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75483 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  75487 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75496 */   GIR_RootConstrainSelectedInstOperands,
     /*  75497 */   // GIR_Coverage, 23212,
     /*  75497 */   GIR_EraseRootFromParent_Done,
     /*  75498 */ // Label 1662: @75498
     /*  75498 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(75552), // Rule ID 26 //
     /*  75503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75518 */   // MIs[1] Operand 1
     /*  75518 */   // No operand predicates
     /*  75518 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  75522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75535 */   // (st (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75538 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75542 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75550 */   GIR_RootConstrainSelectedInstOperands,
     /*  75551 */   // GIR_Coverage, 26,
     /*  75551 */   GIR_EraseRootFromParent_Done,
     /*  75552 */ // Label 1663: @75552
     /*  75552 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(75618), // Rule ID 22519 //
     /*  75557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75560 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75578 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75582 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75600 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75603 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75607 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75616 */   GIR_RootConstrainSelectedInstOperands,
     /*  75617 */   // GIR_Coverage, 22519,
     /*  75617 */   GIR_EraseRootFromParent_Done,
     /*  75618 */ // Label 1664: @75618
     /*  75618 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(75684), // Rule ID 22520 //
     /*  75623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75626 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75629 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75644 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75666 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75669 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75673 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75682 */   GIR_RootConstrainSelectedInstOperands,
     /*  75683 */   // GIR_Coverage, 22520,
     /*  75683 */   GIR_EraseRootFromParent_Done,
     /*  75684 */ // Label 1665: @75684
     /*  75684 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(75750), // Rule ID 22521 //
     /*  75689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75692 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75714 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75719 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75723 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75732 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75735 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75748 */   GIR_RootConstrainSelectedInstOperands,
     /*  75749 */   // GIR_Coverage, 22521,
     /*  75749 */   GIR_EraseRootFromParent_Done,
     /*  75750 */ // Label 1666: @75750
     /*  75750 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(75803), // Rule ID 22509 //
     /*  75755 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75773 */   // MIs[1] Operand 1
     /*  75773 */   // No operand predicates
     /*  75773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75786 */   // (atomic_store (imm:{ *:[i32] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75789 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75793 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75796 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75801 */   GIR_RootConstrainSelectedInstOperands,
     /*  75802 */   // GIR_Coverage, 22509,
     /*  75802 */   GIR_EraseRootFromParent_Done,
     /*  75803 */ // Label 1667: @75803
     /*  75803 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(75866), // Rule ID 52 //
     /*  75808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  75811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75814 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75830 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75848 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr),
     /*  75851 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75864 */   GIR_RootConstrainSelectedInstOperands,
     /*  75865 */   // GIR_Coverage, 52,
     /*  75865 */   GIR_EraseRootFromParent_Done,
     /*  75866 */ // Label 1668: @75866
     /*  75866 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(75929), // Rule ID 58 //
     /*  75871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  75874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75877 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75889 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75893 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75904 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75911 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr_EVEX),
     /*  75914 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75918 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75927 */   GIR_RootConstrainSelectedInstOperands,
     /*  75928 */   // GIR_Coverage, 58,
     /*  75928 */   GIR_EraseRootFromParent_Done,
     /*  75929 */ // Label 1669: @75929
     /*  75929 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(75974), // Rule ID 22513 //
     /*  75934 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75959 */   // (atomic_store GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75962 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75966 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75972 */   GIR_RootConstrainSelectedInstOperands,
     /*  75973 */   // GIR_Coverage, 22513,
     /*  75973 */   GIR_EraseRootFromParent_Done,
     /*  75974 */ // Label 1670: @75974
     /*  75974 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(76016), // Rule ID 34 //
     /*  75979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75994 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76001 */   // (st GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  76001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  76004 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76008 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76014 */   GIR_RootConstrainSelectedInstOperands,
     /*  76015 */   // GIR_Coverage, 34,
     /*  76015 */   GIR_EraseRootFromParent_Done,
     /*  76016 */ // Label 1671: @76016
     /*  76016 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(76064), // Rule ID 1095 //
     /*  76021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  76024 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76027 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  76035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76046 */   // (st RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp32m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /*  76046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp32m),
     /*  76049 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  76053 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76055 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  76058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76062 */   GIR_RootConstrainSelectedInstOperands,
     /*  76063 */   // GIR_Coverage, 1095,
     /*  76063 */   GIR_EraseRootFromParent_Done,
     /*  76064 */ // Label 1672: @76064
     /*  76064 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(76109), // Rule ID 1688 //
     /*  76069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  76072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  76083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76094 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  76094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  76097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76101 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76107 */   GIR_RootConstrainSelectedInstOperands,
     /*  76108 */   // GIR_Coverage, 1688,
     /*  76108 */   GIR_EraseRootFromParent_Done,
     /*  76109 */ // Label 1673: @76109
     /*  76109 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(76154), // Rule ID 1690 //
     /*  76114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  76117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76120 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  76128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76139 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  76139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  76142 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76146 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76152 */   GIR_RootConstrainSelectedInstOperands,
     /*  76153 */   // GIR_Coverage, 1690,
     /*  76153 */   GIR_EraseRootFromParent_Done,
     /*  76154 */ // Label 1674: @76154
     /*  76154 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(76199), // Rule ID 4610 //
     /*  76159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  76162 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76165 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  76173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76184 */   // (st FR32X:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32X:{ *:[f32] }:$src)
     /*  76184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  76187 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76191 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76197 */   GIR_RootConstrainSelectedInstOperands,
     /*  76198 */   // GIR_Coverage, 4610,
     /*  76198 */   GIR_EraseRootFromParent_Done,
     /*  76199 */ // Label 1675: @76199
     /*  76199 */ GIM_Reject,
     /*  76200 */ // Label 1478: @76200
     /*  76200 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(76296), // Rule ID 22494 //
     /*  76205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76208 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76211 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76218 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76226 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76230 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76234 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76238 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76242 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76249 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76256 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76260 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76264 */   // MIs[0] dst
     /*  76264 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76269 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76271 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76278 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76281 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76285 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76288 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76294 */   GIR_RootConstrainSelectedInstOperands,
     /*  76295 */   // GIR_Coverage, 22494,
     /*  76295 */   GIR_EraseRootFromParent_Done,
     /*  76296 */ // Label 1676: @76296
     /*  76296 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(76392), // Rule ID 22498 //
     /*  76301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76304 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76307 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76314 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76322 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76326 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76330 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76334 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76338 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76345 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76352 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76356 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76360 */   // MIs[0] dst
     /*  76360 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76365 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76367 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76374 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76377 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76381 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76390 */   GIR_RootConstrainSelectedInstOperands,
     /*  76391 */   // GIR_Coverage, 22498,
     /*  76391 */   GIR_EraseRootFromParent_Done,
     /*  76392 */ // Label 1677: @76392
     /*  76392 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(76485), // Rule ID 22502 //
     /*  76397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76415 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76419 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76423 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76442 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76449 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76453 */   // MIs[0] dst
     /*  76453 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76458 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76460 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76467 */   // (atomic_store (sub:{ *:[i64] } 0:{ *:[i64] }, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76470 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76474 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76483 */   GIR_RootConstrainSelectedInstOperands,
     /*  76484 */   // GIR_Coverage, 22502,
     /*  76484 */   GIR_EraseRootFromParent_Done,
     /*  76485 */ // Label 1678: @76485
     /*  76485 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(76575), // Rule ID 22506 //
     /*  76490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76508 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76516 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76520 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76527 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76531 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76538 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76542 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76546 */   // MIs[0] dst
     /*  76546 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76553 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76560 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NOT64m addr:{ *:[iPTR] }:$dst)
     /*  76560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76563 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76573 */   GIR_RootConstrainSelectedInstOperands,
     /*  76574 */   // GIR_Coverage, 22506,
     /*  76574 */   GIR_EraseRootFromParent_Done,
     /*  76575 */ // Label 1679: @76575
     /*  76575 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(76661), // Rule ID 231 //
     /*  76580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76586 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76598 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76602 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76606 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76610 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76614 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76617 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76621 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76625 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76629 */   // MIs[0] src1
     /*  76629 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76634 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76636 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76643 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76646 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76650 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76659 */   GIR_RootConstrainSelectedInstOperands,
     /*  76660 */   // GIR_Coverage, 231,
     /*  76660 */   GIR_EraseRootFromParent_Done,
     /*  76661 */ // Label 1680: @76661
     /*  76661 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(76747), // Rule ID 232 //
     /*  76666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76688 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76692 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76696 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76700 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76707 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76711 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76715 */   // MIs[0] src1
     /*  76715 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76720 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76722 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76729 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76732 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76736 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76745 */   GIR_RootConstrainSelectedInstOperands,
     /*  76746 */   // GIR_Coverage, 232,
     /*  76746 */   GIR_EraseRootFromParent_Done,
     /*  76747 */ // Label 1681: @76747
     /*  76747 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(76840), // Rule ID 22616 //
     /*  76752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76783 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76790 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76794 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  76805 */   // MIs[0] dst
     /*  76805 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76810 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76812 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76819 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i64] })
     /*  76819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76822 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  76829 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76838 */   GIR_RootConstrainSelectedInstOperands,
     /*  76839 */   // GIR_Coverage, 22616,
     /*  76839 */   GIR_EraseRootFromParent_Done,
     /*  76840 */ // Label 1682: @76840
     /*  76840 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(76940), // Rule ID 22624 //
     /*  76845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76868 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76872 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76876 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76883 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76887 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2147483648),
     /*  76898 */   // MIs[0] dst
     /*  76898 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76903 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76905 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76912 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -2147483648:{ *:[i64] })
     /*  76912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76915 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76919 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  76929 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76938 */   GIR_RootConstrainSelectedInstOperands,
     /*  76939 */   // GIR_Coverage, 22624,
     /*  76939 */   GIR_EraseRootFromParent_Done,
     /*  76940 */ // Label 1683: @76940
     /*  76940 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(77026), // Rule ID 17615 //
     /*  76945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76951 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  76963 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76967 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76971 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76975 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76979 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76986 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76990 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76994 */   // MIs[0] dst
     /*  76994 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76999 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77001 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77008 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  77008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1),
     /*  77011 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77015 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77024 */   GIR_RootConstrainSelectedInstOperands,
     /*  77025 */   // GIR_Coverage, 17615,
     /*  77025 */   GIR_EraseRootFromParent_Done,
     /*  77026 */ // Label 1684: @77026
     /*  77026 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(77112), // Rule ID 17619 //
     /*  77031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77034 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77037 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77041 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77045 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  77049 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77053 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77057 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77061 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77065 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77072 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77076 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  77080 */   // MIs[0] dst
     /*  77080 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77085 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77087 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77094 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  77094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1),
     /*  77097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77101 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77110 */   GIR_RootConstrainSelectedInstOperands,
     /*  77111 */   // GIR_Coverage, 17619,
     /*  77111 */   GIR_EraseRootFromParent_Done,
     /*  77112 */ // Label 1685: @77112
     /*  77112 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(77198), // Rule ID 264 //
     /*  77117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77143 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  77147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77155 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77162 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77166 */   // MIs[0] src1
     /*  77166 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77171 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77173 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77180 */   // (st (sub:{ *:[i64] } 0:{ *:[i64] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  77180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  77183 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77187 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77196 */   GIR_RootConstrainSelectedInstOperands,
     /*  77197 */   // GIR_Coverage, 264,
     /*  77197 */   GIR_EraseRootFromParent_Done,
     /*  77198 */ // Label 1686: @77198
     /*  77198 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(77281), // Rule ID 272 //
     /*  77203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77225 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77229 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77233 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77237 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77240 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77244 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77248 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  77252 */   // MIs[0] src1
     /*  77252 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77257 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77259 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77266 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT64m addr:{ *:[iPTR] }:$src1)
     /*  77266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  77269 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77279 */   GIR_RootConstrainSelectedInstOperands,
     /*  77280 */   // GIR_Coverage, 272,
     /*  77280 */   GIR_EraseRootFromParent_Done,
     /*  77281 */ // Label 1687: @77281
     /*  77281 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(77386), // Rule ID 22430 //
     /*  77286 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77289 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  77304 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77308 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77312 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77316 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77323 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77327 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77334 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77338 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77342 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77346 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77350 */   // MIs[3] Operand 1
     /*  77350 */   // No operand predicates
     /*  77350 */   // MIs[0] dst
     /*  77350 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77355 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77357 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77364 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mi32),
     /*  77367 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77371 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77374 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77384 */   GIR_RootConstrainSelectedInstOperands,
     /*  77385 */   // GIR_Coverage, 22430,
     /*  77385 */   GIR_EraseRootFromParent_Done,
     /*  77386 */ // Label 1688: @77386
     /*  77386 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(77491), // Rule ID 22438 //
     /*  77391 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77394 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77409 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77413 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77417 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77421 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77428 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77432 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77439 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77443 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77447 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77451 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77455 */   // MIs[3] Operand 1
     /*  77455 */   // No operand predicates
     /*  77455 */   // MIs[0] dst
     /*  77455 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77460 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77462 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77469 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mi32),
     /*  77472 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77476 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77479 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77489 */   GIR_RootConstrainSelectedInstOperands,
     /*  77490 */   // GIR_Coverage, 22438,
     /*  77490 */   GIR_EraseRootFromParent_Done,
     /*  77491 */ // Label 1689: @77491
     /*  77491 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(77596), // Rule ID 22446 //
     /*  77496 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77499 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77514 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77518 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77522 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77526 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77530 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77533 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77537 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77544 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77548 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77552 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77556 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77560 */   // MIs[3] Operand 1
     /*  77560 */   // No operand predicates
     /*  77560 */   // MIs[0] dst
     /*  77560 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77565 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77567 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77574 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mi32),
     /*  77577 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77581 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77584 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77594 */   GIR_RootConstrainSelectedInstOperands,
     /*  77595 */   // GIR_Coverage, 22446,
     /*  77595 */   GIR_EraseRootFromParent_Done,
     /*  77596 */ // Label 1690: @77596
     /*  77596 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(77701), // Rule ID 22462 //
     /*  77601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77623 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77627 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77631 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77635 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77638 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77642 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77649 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77653 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77657 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77661 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77665 */   // MIs[3] Operand 1
     /*  77665 */   // No operand predicates
     /*  77665 */   // MIs[0] dst
     /*  77665 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77670 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77672 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77679 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  77682 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77686 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77689 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77699 */   GIR_RootConstrainSelectedInstOperands,
     /*  77700 */   // GIR_Coverage, 22462,
     /*  77700 */   GIR_EraseRootFromParent_Done,
     /*  77701 */ // Label 1691: @77701
     /*  77701 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(77806), // Rule ID 22454 //
     /*  77706 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77728 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77732 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77736 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77747 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77754 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77758 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77762 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77766 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77770 */   // MIs[3] Operand 1
     /*  77770 */   // No operand predicates
     /*  77770 */   // MIs[0] dst
     /*  77770 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77775 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77777 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77784 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mi32),
     /*  77787 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77791 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77794 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77804 */   GIR_RootConstrainSelectedInstOperands,
     /*  77805 */   // GIR_Coverage, 22454,
     /*  77805 */   GIR_EraseRootFromParent_Done,
     /*  77806 */ // Label 1692: @77806
     /*  77806 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(77910), // Rule ID 835 //
     /*  77811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77814 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  77826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77834 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77838 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77842 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77846 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77853 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77857 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77862 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77866 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77870 */   // MIs[3] Operand 1
     /*  77870 */   // No operand predicates
     /*  77870 */   // MIs[0] src1
     /*  77870 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77875 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77877 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77884 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8),
     /*  77887 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77891 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  77895 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77898 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77908 */   GIR_RootConstrainSelectedInstOperands,
     /*  77909 */   // GIR_Coverage, 835,
     /*  77909 */   GIR_EraseRootFromParent_Done,
     /*  77910 */ // Label 1693: @77910
     /*  77910 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(78014), // Rule ID 859 //
     /*  77915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  77930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77938 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77942 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77947 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77955 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77962 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77966 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77970 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77974 */   // MIs[3] Operand 1
     /*  77974 */   // No operand predicates
     /*  77974 */   // MIs[0] src1
     /*  77974 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77979 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77981 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77988 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8),
     /*  77991 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77995 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  77999 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  78002 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78012 */   GIR_RootConstrainSelectedInstOperands,
     /*  78013 */   // GIR_Coverage, 859,
     /*  78013 */   GIR_EraseRootFromParent_Done,
     /*  78014 */ // Label 1694: @78014
     /*  78014 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(78108), // Rule ID 736 //
     /*  78019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  78037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78045 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78049 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78053 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78056 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78060 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78064 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78068 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78072 */   // MIs[3] Operand 1
     /*  78072 */   // No operand predicates
     /*  78072 */   // MIs[0] src1
     /*  78072 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78077 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78079 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78086 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi),
     /*  78089 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78093 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78096 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78106 */   GIR_RootConstrainSelectedInstOperands,
     /*  78107 */   // GIR_Coverage, 736,
     /*  78107 */   GIR_EraseRootFromParent_Done,
     /*  78108 */ // Label 1695: @78108
     /*  78108 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(78202), // Rule ID 704 //
     /*  78113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  78131 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78135 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78139 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78143 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78147 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78154 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78158 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78162 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78166 */   // MIs[3] Operand 1
     /*  78166 */   // No operand predicates
     /*  78166 */   // MIs[0] src1
     /*  78166 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78171 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78173 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78180 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi),
     /*  78183 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78187 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78190 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78200 */   GIR_RootConstrainSelectedInstOperands,
     /*  78201 */   // GIR_Coverage, 704,
     /*  78201 */   GIR_EraseRootFromParent_Done,
     /*  78202 */ // Label 1696: @78202
     /*  78202 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(78296), // Rule ID 768 //
     /*  78207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78213 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  78225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78233 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78237 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78241 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78248 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78252 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78256 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78260 */   // MIs[3] Operand 1
     /*  78260 */   // No operand predicates
     /*  78260 */   // MIs[0] src1
     /*  78260 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78265 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78267 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78274 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi),
     /*  78277 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78281 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78284 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78294 */   GIR_RootConstrainSelectedInstOperands,
     /*  78295 */   // GIR_Coverage, 768,
     /*  78295 */   GIR_EraseRootFromParent_Done,
     /*  78296 */ // Label 1697: @78296
     /*  78296 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(78390), // Rule ID 800 //
     /*  78301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78307 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  78319 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78327 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78331 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78335 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78338 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78342 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78346 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78350 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78354 */   // MIs[3] Operand 1
     /*  78354 */   // No operand predicates
     /*  78354 */   // MIs[0] src1
     /*  78354 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78359 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78361 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78368 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi),
     /*  78371 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78375 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78378 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78388 */   GIR_RootConstrainSelectedInstOperands,
     /*  78389 */   // GIR_Coverage, 800,
     /*  78389 */   GIR_EraseRootFromParent_Done,
     /*  78390 */ // Label 1698: @78390
     /*  78390 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(78484), // Rule ID 672 //
     /*  78395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78398 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78401 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  78413 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78421 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78425 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78429 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78436 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78440 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78444 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78448 */   // MIs[3] Operand 1
     /*  78448 */   // No operand predicates
     /*  78448 */   // MIs[0] src1
     /*  78448 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78453 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78455 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78462 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi),
     /*  78465 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78469 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78472 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78482 */   GIR_RootConstrainSelectedInstOperands,
     /*  78483 */   // GIR_Coverage, 672,
     /*  78483 */   GIR_EraseRootFromParent_Done,
     /*  78484 */ // Label 1699: @78484
     /*  78484 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(78582), // Rule ID 22434 //
     /*  78489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78515 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78519 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78523 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78530 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78537 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78546 */   // MIs[0] dst
     /*  78546 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78553 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78560 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78563 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78567 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78571 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78574 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78580 */   GIR_RootConstrainSelectedInstOperands,
     /*  78581 */   // GIR_Coverage, 22434,
     /*  78581 */   GIR_EraseRootFromParent_Done,
     /*  78582 */ // Label 1700: @78582
     /*  78582 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(78680), // Rule ID 26005 //
     /*  78587 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78597 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78601 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78605 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78613 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78618 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78622 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78626 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78633 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78640 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78644 */   // MIs[0] dst
     /*  78644 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78649 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78651 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78658 */   // (atomic_store (add:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78661 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78665 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78669 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78672 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78678 */   GIR_RootConstrainSelectedInstOperands,
     /*  78679 */   // GIR_Coverage, 26005,
     /*  78679 */   GIR_EraseRootFromParent_Done,
     /*  78680 */ // Label 1701: @78680
     /*  78680 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(78778), // Rule ID 22442 //
     /*  78685 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78688 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78695 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78703 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78707 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78711 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78715 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78726 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78733 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78742 */   // MIs[0] dst
     /*  78742 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78747 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78749 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78756 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78759 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78767 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78776 */   GIR_RootConstrainSelectedInstOperands,
     /*  78777 */   // GIR_Coverage, 22442,
     /*  78777 */   GIR_EraseRootFromParent_Done,
     /*  78778 */ // Label 1702: @78778
     /*  78778 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(78876), // Rule ID 26009 //
     /*  78783 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78809 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78814 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78818 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78822 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78829 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78836 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78840 */   // MIs[0] dst
     /*  78840 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78845 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78847 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78854 */   // (atomic_store (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78857 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78861 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78865 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78874 */   GIR_RootConstrainSelectedInstOperands,
     /*  78875 */   // GIR_Coverage, 26009,
     /*  78875 */   GIR_EraseRootFromParent_Done,
     /*  78876 */ // Label 1703: @78876
     /*  78876 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(78974), // Rule ID 22450 //
     /*  78881 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78899 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78907 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78911 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78922 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78929 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78938 */   // MIs[0] dst
     /*  78938 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78943 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78945 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78952 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78955 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78959 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78963 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78972 */   GIR_RootConstrainSelectedInstOperands,
     /*  78973 */   // GIR_Coverage, 22450,
     /*  78973 */   GIR_EraseRootFromParent_Done,
     /*  78974 */ // Label 1704: @78974
     /*  78974 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(79072), // Rule ID 26013 //
     /*  78979 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78982 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79010 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79014 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79018 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79025 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79032 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79036 */   // MIs[0] dst
     /*  79036 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79041 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79043 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79050 */   // (atomic_store (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  79053 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79057 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79061 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79070 */   GIR_RootConstrainSelectedInstOperands,
     /*  79071 */   // GIR_Coverage, 26013,
     /*  79071 */   GIR_EraseRootFromParent_Done,
     /*  79072 */ // Label 1705: @79072
     /*  79072 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(79170), // Rule ID 22466 //
     /*  79077 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79095 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79099 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79103 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79107 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79118 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79125 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79134 */   // MIs[0] dst
     /*  79134 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79139 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79141 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79148 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  79151 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79155 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79159 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79168 */   GIR_RootConstrainSelectedInstOperands,
     /*  79169 */   // GIR_Coverage, 22466,
     /*  79169 */   GIR_EraseRootFromParent_Done,
     /*  79170 */ // Label 1706: @79170
     /*  79170 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(79268), // Rule ID 22458 //
     /*  79175 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79178 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79193 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79197 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79201 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79205 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79209 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79212 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79216 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79223 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79227 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79232 */   // MIs[0] dst
     /*  79232 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79237 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79239 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79246 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79249 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79257 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79266 */   GIR_RootConstrainSelectedInstOperands,
     /*  79267 */   // GIR_Coverage, 22458,
     /*  79267 */   GIR_EraseRootFromParent_Done,
     /*  79268 */ // Label 1707: @79268
     /*  79268 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(79366), // Rule ID 26017 //
     /*  79273 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79291 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79299 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79304 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79308 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79312 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79315 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79319 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79326 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79330 */   // MIs[0] dst
     /*  79330 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79335 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79337 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79344 */   // (atomic_store (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79347 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79351 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79355 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79358 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79364 */   GIR_RootConstrainSelectedInstOperands,
     /*  79365 */   // GIR_Coverage, 26017,
     /*  79365 */   GIR_EraseRootFromParent_Done,
     /*  79366 */ // Label 1708: @79366
     /*  79366 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(79477), // Rule ID 838 //
     /*  79371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  79386 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79390 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79394 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79398 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79402 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79406 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79413 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79417 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79427 */   // MIs[0] src1
     /*  79427 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79432 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79434 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79441 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79445 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79451 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL),
     /*  79458 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79462 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79466 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79475 */   GIR_RootConstrainSelectedInstOperands,
     /*  79476 */   // GIR_Coverage, 838,
     /*  79476 */   GIR_EraseRootFromParent_Done,
     /*  79477 */ // Label 1709: @79477
     /*  79477 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(79588), // Rule ID 862 //
     /*  79482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79485 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79489 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79493 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  79497 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79501 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79505 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79509 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79514 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79518 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79522 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79525 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79529 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79533 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79538 */   // MIs[0] src1
     /*  79538 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79543 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79545 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79552 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79556 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79562 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL),
     /*  79569 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79573 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79577 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79586 */   GIR_RootConstrainSelectedInstOperands,
     /*  79587 */   // GIR_Coverage, 862,
     /*  79587 */   GIR_EraseRootFromParent_Done,
     /*  79588 */ // Label 1710: @79588
     /*  79588 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(79676), // Rule ID 412 //
     /*  79593 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79608 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79612 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79616 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79620 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79624 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79631 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79640 */   // MIs[0] src1
     /*  79640 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79645 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79647 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79654 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79657 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79661 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79665 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79674 */   GIR_RootConstrainSelectedInstOperands,
     /*  79675 */   // GIR_Coverage, 412,
     /*  79675 */   GIR_EraseRootFromParent_Done,
     /*  79676 */ // Label 1711: @79676
     /*  79676 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(79764), // Rule ID 23225 //
     /*  79681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79709 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79713 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79717 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79720 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79724 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79728 */   // MIs[0] src1
     /*  79728 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79733 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79735 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79742 */   // (st (add:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79745 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79753 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79756 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79762 */   GIR_RootConstrainSelectedInstOperands,
     /*  79763 */   // GIR_Coverage, 23225,
     /*  79763 */   GIR_EraseRootFromParent_Done,
     /*  79764 */ // Label 1712: @79764
     /*  79764 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(79852), // Rule ID 304 //
     /*  79769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79784 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79788 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79792 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79796 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79800 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79803 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79807 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79816 */   // MIs[0] src1
     /*  79816 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79821 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79823 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79830 */   // (st (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79833 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79841 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79850 */   GIR_RootConstrainSelectedInstOperands,
     /*  79851 */   // GIR_Coverage, 304,
     /*  79851 */   GIR_EraseRootFromParent_Done,
     /*  79852 */ // Label 1713: @79852
     /*  79852 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(79940), // Rule ID 23189 //
     /*  79857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79872 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79885 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79889 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79893 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79896 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79900 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79904 */   // MIs[0] src1
     /*  79904 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79909 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79911 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79918 */   // (st (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79921 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79925 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79929 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79938 */   GIR_RootConstrainSelectedInstOperands,
     /*  79939 */   // GIR_Coverage, 23189,
     /*  79939 */   GIR_EraseRootFromParent_Done,
     /*  79940 */ // Label 1714: @79940
     /*  79940 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(80041), // Rule ID 752 //
     /*  79945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79951 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  79963 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79967 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79971 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79975 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79979 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79986 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79990 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79995 */   // MIs[0] src1
     /*  79995 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80000 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80002 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80009 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80013 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL),
     /*  80026 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80030 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80039 */   GIR_RootConstrainSelectedInstOperands,
     /*  80040 */   // GIR_Coverage, 752,
     /*  80040 */   GIR_EraseRootFromParent_Done,
     /*  80041 */ // Label 1715: @80041
     /*  80041 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(80142), // Rule ID 720 //
     /*  80046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80052 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  80064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80072 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80076 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80080 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80083 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80087 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80091 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80096 */   // MIs[0] src1
     /*  80096 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80101 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80103 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80110 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80114 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80120 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL),
     /*  80127 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80131 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80140 */   GIR_RootConstrainSelectedInstOperands,
     /*  80141 */   // GIR_Coverage, 720,
     /*  80141 */   GIR_EraseRootFromParent_Done,
     /*  80142 */ // Label 1716: @80142
     /*  80142 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(80230), // Rule ID 340 //
     /*  80147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80162 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80166 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80170 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80174 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80178 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80181 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80185 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80194 */   // MIs[0] src1
     /*  80194 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80199 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80201 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80208 */   // (st (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80211 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80215 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80219 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80228 */   GIR_RootConstrainSelectedInstOperands,
     /*  80229 */   // GIR_Coverage, 340,
     /*  80229 */   GIR_EraseRootFromParent_Done,
     /*  80230 */ // Label 1717: @80230
     /*  80230 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(80318), // Rule ID 23201 //
     /*  80235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80263 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80267 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80271 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80274 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80278 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80282 */   // MIs[0] src1
     /*  80282 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80287 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80289 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80296 */   // (st (or:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80299 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80303 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80307 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80316 */   GIR_RootConstrainSelectedInstOperands,
     /*  80317 */   // GIR_Coverage, 23201,
     /*  80317 */   GIR_EraseRootFromParent_Done,
     /*  80318 */ // Label 1718: @80318
     /*  80318 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(80419), // Rule ID 784 //
     /*  80323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80329 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  80341 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80345 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80349 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80353 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80357 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80364 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80373 */   // MIs[0] src1
     /*  80373 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80378 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80380 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80387 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80391 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL),
     /*  80404 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80408 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80417 */   GIR_RootConstrainSelectedInstOperands,
     /*  80418 */   // GIR_Coverage, 784,
     /*  80418 */   GIR_EraseRootFromParent_Done,
     /*  80419 */ // Label 1719: @80419
     /*  80419 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(80520), // Rule ID 816 //
     /*  80424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80427 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  80442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80446 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80450 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80454 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80458 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80461 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80465 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80474 */   // MIs[0] src1
     /*  80474 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80479 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80481 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80488 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80492 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80498 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL),
     /*  80505 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80509 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80518 */   GIR_RootConstrainSelectedInstOperands,
     /*  80519 */   // GIR_Coverage, 816,
     /*  80519 */   GIR_EraseRootFromParent_Done,
     /*  80520 */ // Label 1720: @80520
     /*  80520 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(80621), // Rule ID 688 //
     /*  80525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80531 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  80543 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80547 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80551 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80555 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80559 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80566 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80575 */   // MIs[0] src1
     /*  80575 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80580 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80582 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80589 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80593 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL),
     /*  80606 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80610 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80619 */   GIR_RootConstrainSelectedInstOperands,
     /*  80620 */   // GIR_Coverage, 688,
     /*  80620 */   GIR_EraseRootFromParent_Done,
     /*  80621 */ // Label 1721: @80621
     /*  80621 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(80709), // Rule ID 448 //
     /*  80626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80649 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80653 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80657 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80664 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80673 */   // MIs[0] src1
     /*  80673 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80678 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80680 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80687 */   // (st (sub:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  80690 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80694 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80698 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80707 */   GIR_RootConstrainSelectedInstOperands,
     /*  80708 */   // GIR_Coverage, 448,
     /*  80708 */   GIR_EraseRootFromParent_Done,
     /*  80709 */ // Label 1722: @80709
     /*  80709 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(80797), // Rule ID 376 //
     /*  80714 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80717 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80729 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80733 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80737 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80741 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80745 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80752 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80756 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80761 */   // MIs[0] src1
     /*  80761 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80766 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80768 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80775 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80778 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80782 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80786 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80795 */   GIR_RootConstrainSelectedInstOperands,
     /*  80796 */   // GIR_Coverage, 376,
     /*  80796 */   GIR_EraseRootFromParent_Done,
     /*  80797 */ // Label 1723: @80797
     /*  80797 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(80885), // Rule ID 23213 //
     /*  80802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80817 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80821 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80825 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80830 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80834 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80838 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80841 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80845 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80849 */   // MIs[0] src1
     /*  80849 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80854 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80856 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80863 */   // (st (xor:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80866 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80870 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80874 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80883 */   GIR_RootConstrainSelectedInstOperands,
     /*  80884 */   // GIR_Coverage, 23213,
     /*  80884 */   GIR_EraseRootFromParent_Done,
     /*  80885 */ // Label 1724: @80885
     /*  80885 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(80942), // Rule ID 22510 //
     /*  80890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80908 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  80912 */   // MIs[1] Operand 1
     /*  80912 */   // No operand predicates
     /*  80912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80925 */   // (atomic_store (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mi32 addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  80925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mi32),
     /*  80928 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80932 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  80935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80940 */   GIR_RootConstrainSelectedInstOperands,
     /*  80941 */   // GIR_Coverage, 22510,
     /*  80941 */   GIR_EraseRootFromParent_Done,
     /*  80942 */ // Label 1725: @80942
     /*  80942 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(81008), // Rule ID 22522 //
     /*  80947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80950 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80953 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80960 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80968 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80972 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80981 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80990 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  80993 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81006 */   GIR_RootConstrainSelectedInstOperands,
     /*  81007 */   // GIR_Coverage, 22522,
     /*  81007 */   GIR_EraseRootFromParent_Done,
     /*  81008 */ // Label 1726: @81008
     /*  81008 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(81074), // Rule ID 22523 //
     /*  81013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  81034 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81043 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81056 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81059 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81063 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81072 */   GIR_RootConstrainSelectedInstOperands,
     /*  81073 */   // GIR_Coverage, 22523,
     /*  81073 */   GIR_EraseRootFromParent_Done,
     /*  81074 */ // Label 1727: @81074
     /*  81074 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(81140), // Rule ID 22524 //
     /*  81079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81082 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81092 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81096 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  81100 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81104 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81109 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81122 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81125 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81129 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81138 */   GIR_RootConstrainSelectedInstOperands,
     /*  81139 */   // GIR_Coverage, 22524,
     /*  81139 */   GIR_EraseRootFromParent_Done,
     /*  81140 */ // Label 1728: @81140
     /*  81140 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(81203), // Rule ID 54 //
     /*  81145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  81148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81163 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81185 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr),
     /*  81188 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81192 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81201 */   GIR_RootConstrainSelectedInstOperands,
     /*  81202 */   // GIR_Coverage, 54,
     /*  81202 */   GIR_EraseRootFromParent_Done,
     /*  81203 */ // Label 1729: @81203
     /*  81203 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(81266), // Rule ID 60 //
     /*  81208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  81211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81218 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81226 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81230 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81248 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr_EVEX),
     /*  81251 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81255 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81264 */   GIR_RootConstrainSelectedInstOperands,
     /*  81265 */   // GIR_Coverage, 60,
     /*  81265 */   GIR_EraseRootFromParent_Done,
     /*  81266 */ // Label 1730: @81266
     /*  81266 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(81311), // Rule ID 22514 //
     /*  81271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81296 */   // (atomic_store GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81299 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81303 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81309 */   GIR_RootConstrainSelectedInstOperands,
     /*  81310 */   // GIR_Coverage, 22514,
     /*  81310 */   GIR_EraseRootFromParent_Done,
     /*  81311 */ // Label 1731: @81311
     /*  81311 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(81353), // Rule ID 35 //
     /*  81316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81327 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81338 */   // (st GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81341 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81345 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81351 */   GIR_RootConstrainSelectedInstOperands,
     /*  81352 */   // GIR_Coverage, 35,
     /*  81352 */   GIR_EraseRootFromParent_Done,
     /*  81353 */ // Label 1732: @81353
     /*  81353 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(81408), // Rule ID 1096 //
     /*  81358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81364 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81390 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m32),
     /*  81393 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81397 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81399 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81406 */   GIR_RootConstrainSelectedInstOperands,
     /*  81407 */   // GIR_Coverage, 1096,
     /*  81407 */   GIR_EraseRootFromParent_Done,
     /*  81408 */ // Label 1733: @81408
     /*  81408 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(81456), // Rule ID 1097 //
     /*  81413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81431 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81438 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp64m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m),
     /*  81441 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81445 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81447 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81454 */   GIR_RootConstrainSelectedInstOperands,
     /*  81455 */   // GIR_Coverage, 1097,
     /*  81455 */   GIR_EraseRootFromParent_Done,
     /*  81456 */ // Label 1734: @81456
     /*  81456 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(81501), // Rule ID 1692 //
     /*  81461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81467 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81479 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81486 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81489 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81493 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81499 */   GIR_RootConstrainSelectedInstOperands,
     /*  81500 */   // GIR_Coverage, 1692,
     /*  81500 */   GIR_EraseRootFromParent_Done,
     /*  81501 */ // Label 1735: @81501
     /*  81501 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(81546), // Rule ID 1694 //
     /*  81506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81509 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81512 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81520 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81524 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81531 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81534 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81538 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81544 */   GIR_RootConstrainSelectedInstOperands,
     /*  81545 */   // GIR_Coverage, 1694,
     /*  81545 */   GIR_EraseRootFromParent_Done,
     /*  81546 */ // Label 1736: @81546
     /*  81546 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(81591), // Rule ID 4616 //
     /*  81551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81554 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81557 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  81565 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81569 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81576 */   // (st FR64X:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDZmr addr:{ *:[iPTR] }:$dst, FR64X:{ *:[f64] }:$src)
     /*  81576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZmr),
     /*  81579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81583 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81589 */   GIR_RootConstrainSelectedInstOperands,
     /*  81590 */   // GIR_Coverage, 4616,
     /*  81590 */   GIR_EraseRootFromParent_Done,
     /*  81591 */ // Label 1737: @81591
     /*  81591 */ GIM_Reject,
     /*  81592 */ // Label 1479: @81592
     /*  81592 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(81750),
     /*  81597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81600 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(81652), // Rule ID 1098 //
     /*  81605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81608 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81634 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp80m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m32),
     /*  81637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81641 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81650 */     GIR_RootConstrainSelectedInstOperands,
     /*  81651 */     // GIR_Coverage, 1098,
     /*  81651 */     GIR_EraseRootFromParent_Done,
     /*  81652 */   // Label 1739: @81652
     /*  81652 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(81704), // Rule ID 1099 //
     /*  81657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81660 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81686 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref64>>  =>  (ST_Fp80m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m64),
     /*  81689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81693 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81702 */     GIR_RootConstrainSelectedInstOperands,
     /*  81703 */     // GIR_Coverage, 1099,
     /*  81703 */     GIR_EraseRootFromParent_Done,
     /*  81704 */   // Label 1740: @81704
     /*  81704 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(81749), // Rule ID 1100 //
     /*  81709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81731 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_FpP80m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_FpP80m),
     /*  81734 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81738 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81747 */     GIR_RootConstrainSelectedInstOperands,
     /*  81748 */     // GIR_Coverage, 1100,
     /*  81748 */     GIR_EraseRootFromParent_Done,
     /*  81749 */   // Label 1741: @81749
     /*  81749 */   GIM_Reject,
     /*  81750 */ // Label 1738: @81750
     /*  81750 */ GIM_Reject,
     /*  81751 */ // Label 1480: @81751
     /*  81751 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(82004),
     /*  81756 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81763 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(81805), // Rule ID 23142 //
     /*  81768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81790 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81797 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81803 */     GIR_RootConstrainSelectedInstOperands,
     /*  81804 */     // GIR_Coverage, 23142,
     /*  81804 */     GIR_EraseRootFromParent_Done,
     /*  81805 */   // Label 1743: @81805
     /*  81805 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(81843), // Rule ID 23143 //
     /*  81810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81828 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81835 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81841 */     GIR_RootConstrainSelectedInstOperands,
     /*  81842 */     // GIR_Coverage, 23143,
     /*  81842 */     GIR_EraseRootFromParent_Done,
     /*  81843 */   // Label 1744: @81843
     /*  81843 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(81885), // Rule ID 23146 //
     /*  81848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81870 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81877 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81883 */     GIR_RootConstrainSelectedInstOperands,
     /*  81884 */     // GIR_Coverage, 23146,
     /*  81884 */     GIR_EraseRootFromParent_Done,
     /*  81885 */   // Label 1745: @81885
     /*  81885 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(81923), // Rule ID 23147 //
     /*  81890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81908 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81915 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81921 */     GIR_RootConstrainSelectedInstOperands,
     /*  81922 */     // GIR_Coverage, 23147,
     /*  81922 */     GIR_EraseRootFromParent_Done,
     /*  81923 */   // Label 1746: @81923
     /*  81923 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(81965), // Rule ID 23150 //
     /*  81928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81950 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81957 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81963 */     GIR_RootConstrainSelectedInstOperands,
     /*  81964 */     // GIR_Coverage, 23150,
     /*  81964 */     GIR_EraseRootFromParent_Done,
     /*  81965 */   // Label 1747: @81965
     /*  81965 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(82003), // Rule ID 23151 //
     /*  81970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81988 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  81991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81995 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82001 */     GIR_RootConstrainSelectedInstOperands,
     /*  82002 */     // GIR_Coverage, 23151,
     /*  82002 */     GIR_EraseRootFromParent_Done,
     /*  82003 */   // Label 1748: @82003
     /*  82003 */   GIM_Reject,
     /*  82004 */ // Label 1742: @82004
     /*  82004 */ GIM_Reject,
     /*  82005 */ // Label 1481: @82005
     /*  82005 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(82498),
     /*  82010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82013 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82017 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(82059), // Rule ID 1716 //
     /*  82022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82044 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDmr),
     /*  82047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82051 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82057 */     GIR_RootConstrainSelectedInstOperands,
     /*  82058 */     // GIR_Coverage, 1716,
     /*  82058 */     GIR_EraseRootFromParent_Done,
     /*  82059 */   // Label 1750: @82059
     /*  82059 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(82097), // Rule ID 1718 //
     /*  82064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82082 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDmr),
     /*  82085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82089 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82095 */     GIR_RootConstrainSelectedInstOperands,
     /*  82096 */     // GIR_Coverage, 1718,
     /*  82096 */     GIR_EraseRootFromParent_Done,
     /*  82097 */   // Label 1751: @82097
     /*  82097 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(82139), // Rule ID 1724 //
     /*  82102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82124 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDmr),
     /*  82127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82131 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82137 */     GIR_RootConstrainSelectedInstOperands,
     /*  82138 */     // GIR_Coverage, 1724,
     /*  82138 */     GIR_EraseRootFromParent_Done,
     /*  82139 */   // Label 1752: @82139
     /*  82139 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(82177), // Rule ID 1726 //
     /*  82144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82162 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDmr),
     /*  82165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82169 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82175 */     GIR_RootConstrainSelectedInstOperands,
     /*  82176 */     // GIR_Coverage, 1726,
     /*  82176 */     GIR_EraseRootFromParent_Done,
     /*  82177 */   // Label 1753: @82177
     /*  82177 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(82219), // Rule ID 2520 //
     /*  82182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82204 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82211 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82217 */     GIR_RootConstrainSelectedInstOperands,
     /*  82218 */     // GIR_Coverage, 2520,
     /*  82218 */     GIR_EraseRootFromParent_Done,
     /*  82219 */   // Label 1754: @82219
     /*  82219 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(82257), // Rule ID 2521 //
     /*  82224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82242 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82249 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82255 */     GIR_RootConstrainSelectedInstOperands,
     /*  82256 */     // GIR_Coverage, 2521,
     /*  82256 */     GIR_EraseRootFromParent_Done,
     /*  82257 */   // Label 1755: @82257
     /*  82257 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(82299), // Rule ID 4496 //
     /*  82262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82284 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128mr),
     /*  82287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82291 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82297 */     GIR_RootConstrainSelectedInstOperands,
     /*  82298 */     // GIR_Coverage, 4496,
     /*  82298 */     GIR_EraseRootFromParent_Done,
     /*  82299 */   // Label 1756: @82299
     /*  82299 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(82337), // Rule ID 4520 //
     /*  82304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82322 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128mr),
     /*  82325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82329 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82335 */     GIR_RootConstrainSelectedInstOperands,
     /*  82336 */     // GIR_Coverage, 4520,
     /*  82336 */     GIR_EraseRootFromParent_Done,
     /*  82337 */   // Label 1757: @82337
     /*  82337 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(82379), // Rule ID 4550 //
     /*  82342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82364 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82371 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82377 */     GIR_RootConstrainSelectedInstOperands,
     /*  82378 */     // GIR_Coverage, 4550,
     /*  82378 */     GIR_EraseRootFromParent_Done,
     /*  82379 */   // Label 1758: @82379
     /*  82379 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(82417), // Rule ID 4592 //
     /*  82384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82402 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82409 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82415 */     GIR_RootConstrainSelectedInstOperands,
     /*  82416 */     // GIR_Coverage, 4592,
     /*  82416 */     GIR_EraseRootFromParent_Done,
     /*  82417 */   // Label 1759: @82417
     /*  82417 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(82459), // Rule ID 17947 //
     /*  82422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82444 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82451 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82457 */     GIR_RootConstrainSelectedInstOperands,
     /*  82458 */     // GIR_Coverage, 17947,
     /*  82458 */     GIR_EraseRootFromParent_Done,
     /*  82459 */   // Label 1760: @82459
     /*  82459 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(82497), // Rule ID 17951 //
     /*  82464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82482 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82489 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82495 */     GIR_RootConstrainSelectedInstOperands,
     /*  82496 */     // GIR_Coverage, 17951,
     /*  82496 */     GIR_EraseRootFromParent_Done,
     /*  82497 */   // Label 1761: @82497
     /*  82497 */   GIM_Reject,
     /*  82498 */ // Label 1749: @82498
     /*  82498 */ GIM_Reject,
     /*  82499 */ // Label 1482: @82499
     /*  82499 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(82992),
     /*  82504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82507 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82511 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(82553), // Rule ID 1715 //
     /*  82516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82538 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  82541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82545 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82551 */     GIR_RootConstrainSelectedInstOperands,
     /*  82552 */     // GIR_Coverage, 1715,
     /*  82552 */     GIR_EraseRootFromParent_Done,
     /*  82553 */   // Label 1763: @82553
     /*  82553 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(82591), // Rule ID 1717 //
     /*  82558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82576 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  82579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82583 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82589 */     GIR_RootConstrainSelectedInstOperands,
     /*  82590 */     // GIR_Coverage, 1717,
     /*  82590 */     GIR_EraseRootFromParent_Done,
     /*  82591 */   // Label 1764: @82591
     /*  82591 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(82633), // Rule ID 1723 //
     /*  82596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82618 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82625 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82631 */     GIR_RootConstrainSelectedInstOperands,
     /*  82632 */     // GIR_Coverage, 1723,
     /*  82632 */     GIR_EraseRootFromParent_Done,
     /*  82633 */   // Label 1765: @82633
     /*  82633 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(82671), // Rule ID 1725 //
     /*  82638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82656 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82663 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82669 */     GIR_RootConstrainSelectedInstOperands,
     /*  82670 */     // GIR_Coverage, 1725,
     /*  82670 */     GIR_EraseRootFromParent_Done,
     /*  82671 */   // Label 1766: @82671
     /*  82671 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(82713), // Rule ID 4478 //
     /*  82676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82698 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  82701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82705 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82711 */     GIR_RootConstrainSelectedInstOperands,
     /*  82712 */     // GIR_Coverage, 4478,
     /*  82712 */     GIR_EraseRootFromParent_Done,
     /*  82713 */   // Label 1767: @82713
     /*  82713 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(82751), // Rule ID 4508 //
     /*  82718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82736 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82743 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82749 */     GIR_RootConstrainSelectedInstOperands,
     /*  82750 */     // GIR_Coverage, 4508,
     /*  82750 */     GIR_EraseRootFromParent_Done,
     /*  82751 */   // Label 1768: @82751
     /*  82751 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(82793), // Rule ID 17948 //
     /*  82756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82778 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82785 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82791 */     GIR_RootConstrainSelectedInstOperands,
     /*  82792 */     // GIR_Coverage, 17948,
     /*  82792 */     GIR_EraseRootFromParent_Done,
     /*  82793 */   // Label 1769: @82793
     /*  82793 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(82831), // Rule ID 17952 //
     /*  82798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82816 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82823 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82829 */     GIR_RootConstrainSelectedInstOperands,
     /*  82830 */     // GIR_Coverage, 17952,
     /*  82830 */     GIR_EraseRootFromParent_Done,
     /*  82831 */   // Label 1770: @82831
     /*  82831 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(82873), // Rule ID 18327 //
     /*  82836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82858 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82865 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82871 */     GIR_RootConstrainSelectedInstOperands,
     /*  82872 */     // GIR_Coverage, 18327,
     /*  82872 */     GIR_EraseRootFromParent_Done,
     /*  82873 */   // Label 1771: @82873
     /*  82873 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(82911), // Rule ID 18331 //
     /*  82878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82896 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82903 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82909 */     GIR_RootConstrainSelectedInstOperands,
     /*  82910 */     // GIR_Coverage, 18331,
     /*  82910 */     GIR_EraseRootFromParent_Done,
     /*  82911 */   // Label 1772: @82911
     /*  82911 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(82953), // Rule ID 19820 //
     /*  82916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82938 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82945 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82951 */     GIR_RootConstrainSelectedInstOperands,
     /*  82952 */     // GIR_Coverage, 19820,
     /*  82952 */     GIR_EraseRootFromParent_Done,
     /*  82953 */   // Label 1773: @82953
     /*  82953 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(82991), // Rule ID 19824 //
     /*  82958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82976 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82983 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82989 */     GIR_RootConstrainSelectedInstOperands,
     /*  82990 */     // GIR_Coverage, 19824,
     /*  82990 */     GIR_EraseRootFromParent_Done,
     /*  82991 */   // Label 1774: @82991
     /*  82991 */   GIM_Reject,
     /*  82992 */ // Label 1762: @82992
     /*  82992 */ GIM_Reject,
     /*  82993 */ // Label 1483: @82993
     /*  82993 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(83326),
     /*  82998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83005 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(83047), // Rule ID 1720 //
     /*  83010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83032 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  83032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYmr),
     /*  83035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83039 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83045 */     GIR_RootConstrainSelectedInstOperands,
     /*  83046 */     // GIR_Coverage, 1720,
     /*  83046 */     GIR_EraseRootFromParent_Done,
     /*  83047 */   // Label 1776: @83047
     /*  83047 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(83085), // Rule ID 1722 //
     /*  83052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83070 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  83070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYmr),
     /*  83073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83077 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83083 */     GIR_RootConstrainSelectedInstOperands,
     /*  83084 */     // GIR_Coverage, 1722,
     /*  83084 */     GIR_EraseRootFromParent_Done,
     /*  83085 */   // Label 1777: @83085
     /*  83085 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(83127), // Rule ID 4495 //
     /*  83090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83112 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  83112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256mr),
     /*  83115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83119 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83125 */     GIR_RootConstrainSelectedInstOperands,
     /*  83126 */     // GIR_Coverage, 4495,
     /*  83126 */     GIR_EraseRootFromParent_Done,
     /*  83127 */   // Label 1778: @83127
     /*  83127 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(83165), // Rule ID 4519 //
     /*  83132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83150 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  83150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256mr),
     /*  83153 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83157 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83163 */     GIR_RootConstrainSelectedInstOperands,
     /*  83164 */     // GIR_Coverage, 4519,
     /*  83164 */     GIR_EraseRootFromParent_Done,
     /*  83165 */   // Label 1779: @83165
     /*  83165 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(83207), // Rule ID 4549 //
     /*  83170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83192 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  83195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83199 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83205 */     GIR_RootConstrainSelectedInstOperands,
     /*  83206 */     // GIR_Coverage, 4549,
     /*  83206 */     GIR_EraseRootFromParent_Done,
     /*  83207 */   // Label 1780: @83207
     /*  83207 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(83245), // Rule ID 4591 //
     /*  83212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83230 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  83233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83237 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83243 */     GIR_RootConstrainSelectedInstOperands,
     /*  83244 */     // GIR_Coverage, 4591,
     /*  83244 */     GIR_EraseRootFromParent_Done,
     /*  83245 */   // Label 1781: @83245
     /*  83245 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(83287), // Rule ID 17923 //
     /*  83250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83272 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83279 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83285 */     GIR_RootConstrainSelectedInstOperands,
     /*  83286 */     // GIR_Coverage, 17923,
     /*  83286 */     GIR_EraseRootFromParent_Done,
     /*  83287 */   // Label 1782: @83287
     /*  83287 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(83325), // Rule ID 17927 //
     /*  83292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83310 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83317 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83323 */     GIR_RootConstrainSelectedInstOperands,
     /*  83324 */     // GIR_Coverage, 17927,
     /*  83324 */     GIR_EraseRootFromParent_Done,
     /*  83325 */   // Label 1783: @83325
     /*  83325 */   GIM_Reject,
     /*  83326 */ // Label 1775: @83326
     /*  83326 */ GIM_Reject,
     /*  83327 */ // Label 1484: @83327
     /*  83327 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(83408),
     /*  83332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  83343 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83347 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(83377), // Rule ID 4396 //
     /*  83352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  83355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83362 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk),
     /*  83365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83369 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83375 */     GIR_RootConstrainSelectedInstOperands,
     /*  83376 */     // GIR_Coverage, 4396,
     /*  83376 */     GIR_EraseRootFromParent_Done,
     /*  83377 */   // Label 1785: @83377
     /*  83377 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(83407), // Rule ID 4398 //
     /*  83382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  83385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83392 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk_EVEX addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk_EVEX),
     /*  83395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83399 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83405 */     GIR_RootConstrainSelectedInstOperands,
     /*  83406 */     // GIR_Coverage, 4398,
     /*  83406 */     GIR_EraseRootFromParent_Done,
     /*  83407 */   // Label 1786: @83407
     /*  83407 */   GIM_Reject,
     /*  83408 */ // Label 1784: @83408
     /*  83408 */ GIM_Reject,
     /*  83409 */ // Label 1485: @83409
     /*  83409 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(83982),
     /*  83414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83417 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83421 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(83463), // Rule ID 17933 //
     /*  83426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83448 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  83451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83455 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83461 */     GIR_RootConstrainSelectedInstOperands,
     /*  83462 */     // GIR_Coverage, 17933,
     /*  83462 */     GIR_EraseRootFromParent_Done,
     /*  83463 */   // Label 1788: @83463
     /*  83463 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(83501), // Rule ID 17934 //
     /*  83468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83486 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  83489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83493 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83499 */     GIR_RootConstrainSelectedInstOperands,
     /*  83500 */     // GIR_Coverage, 17934,
     /*  83500 */     GIR_EraseRootFromParent_Done,
     /*  83501 */   // Label 1789: @83501
     /*  83501 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(83543), // Rule ID 17949 //
     /*  83506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83528 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83535 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83541 */     GIR_RootConstrainSelectedInstOperands,
     /*  83542 */     // GIR_Coverage, 17949,
     /*  83542 */     GIR_EraseRootFromParent_Done,
     /*  83543 */   // Label 1790: @83543
     /*  83543 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(83581), // Rule ID 17953 //
     /*  83548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83566 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83573 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83579 */     GIR_RootConstrainSelectedInstOperands,
     /*  83580 */     // GIR_Coverage, 17953,
     /*  83580 */     GIR_EraseRootFromParent_Done,
     /*  83581 */   // Label 1791: @83581
     /*  83581 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(83623), // Rule ID 17957 //
     /*  83586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83608 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83615 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83621 */     GIR_RootConstrainSelectedInstOperands,
     /*  83622 */     // GIR_Coverage, 17957,
     /*  83622 */     GIR_EraseRootFromParent_Done,
     /*  83623 */   // Label 1792: @83623
     /*  83623 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(83661), // Rule ID 17958 //
     /*  83628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83646 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83653 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83659 */     GIR_RootConstrainSelectedInstOperands,
     /*  83660 */     // GIR_Coverage, 17958,
     /*  83660 */     GIR_EraseRootFromParent_Done,
     /*  83661 */   // Label 1793: @83661
     /*  83661 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(83703), // Rule ID 18328 //
     /*  83666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83688 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83691 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83695 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83701 */     GIR_RootConstrainSelectedInstOperands,
     /*  83702 */     // GIR_Coverage, 18328,
     /*  83702 */     GIR_EraseRootFromParent_Done,
     /*  83703 */   // Label 1794: @83703
     /*  83703 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(83745), // Rule ID 18329 //
     /*  83708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83730 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83737 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83743 */     GIR_RootConstrainSelectedInstOperands,
     /*  83744 */     // GIR_Coverage, 18329,
     /*  83744 */     GIR_EraseRootFromParent_Done,
     /*  83745 */   // Label 1795: @83745
     /*  83745 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(83783), // Rule ID 18332 //
     /*  83750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83768 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83775 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83781 */     GIR_RootConstrainSelectedInstOperands,
     /*  83782 */     // GIR_Coverage, 18332,
     /*  83782 */     GIR_EraseRootFromParent_Done,
     /*  83783 */   // Label 1796: @83783
     /*  83783 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(83821), // Rule ID 18333 //
     /*  83788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83806 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83813 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83819 */     GIR_RootConstrainSelectedInstOperands,
     /*  83820 */     // GIR_Coverage, 18333,
     /*  83820 */     GIR_EraseRootFromParent_Done,
     /*  83821 */   // Label 1797: @83821
     /*  83821 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(83863), // Rule ID 19821 //
     /*  83826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83848 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  83851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83855 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83861 */     GIR_RootConstrainSelectedInstOperands,
     /*  83862 */     // GIR_Coverage, 19821,
     /*  83862 */     GIR_EraseRootFromParent_Done,
     /*  83863 */   // Label 1798: @83863
     /*  83863 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(83905), // Rule ID 19822 //
     /*  83868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83890 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  83893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83897 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83903 */     GIR_RootConstrainSelectedInstOperands,
     /*  83904 */     // GIR_Coverage, 19822,
     /*  83904 */     GIR_EraseRootFromParent_Done,
     /*  83905 */   // Label 1799: @83905
     /*  83905 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(83943), // Rule ID 19825 //
     /*  83910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83928 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  83931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83935 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83941 */     GIR_RootConstrainSelectedInstOperands,
     /*  83942 */     // GIR_Coverage, 19825,
     /*  83942 */     GIR_EraseRootFromParent_Done,
     /*  83943 */   // Label 1800: @83943
     /*  83943 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(83981), // Rule ID 19826 //
     /*  83948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83966 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  83969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83973 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83979 */     GIR_RootConstrainSelectedInstOperands,
     /*  83980 */     // GIR_Coverage, 19826,
     /*  83980 */     GIR_EraseRootFromParent_Done,
     /*  83981 */   // Label 1801: @83981
     /*  83981 */   GIM_Reject,
     /*  83982 */ // Label 1787: @83982
     /*  83982 */ GIM_Reject,
     /*  83983 */ // Label 1486: @83983
     /*  83983 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(84316),
     /*  83988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83995 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(84037), // Rule ID 1719 //
     /*  84000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84022 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  84022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84029 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84035 */     GIR_RootConstrainSelectedInstOperands,
     /*  84036 */     // GIR_Coverage, 1719,
     /*  84036 */     GIR_EraseRootFromParent_Done,
     /*  84037 */   // Label 1803: @84037
     /*  84037 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(84075), // Rule ID 1721 //
     /*  84042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84060 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  84060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84067 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84073 */     GIR_RootConstrainSelectedInstOperands,
     /*  84074 */     // GIR_Coverage, 1721,
     /*  84074 */     GIR_EraseRootFromParent_Done,
     /*  84075 */   // Label 1804: @84075
     /*  84075 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(84117), // Rule ID 4477 //
     /*  84080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  84083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84102 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  84102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  84105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84109 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84115 */     GIR_RootConstrainSelectedInstOperands,
     /*  84116 */     // GIR_Coverage, 4477,
     /*  84116 */     GIR_EraseRootFromParent_Done,
     /*  84117 */   // Label 1805: @84117
     /*  84117 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(84155), // Rule ID 4507 //
     /*  84122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  84125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84140 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  84140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  84143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84147 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84153 */     GIR_RootConstrainSelectedInstOperands,
     /*  84154 */     // GIR_Coverage, 4507,
     /*  84154 */     GIR_EraseRootFromParent_Done,
     /*  84155 */   // Label 1806: @84155
     /*  84155 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(84197), // Rule ID 17924 //
     /*  84160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84182 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84189 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84195 */     GIR_RootConstrainSelectedInstOperands,
     /*  84196 */     // GIR_Coverage, 17924,
     /*  84196 */     GIR_EraseRootFromParent_Done,
     /*  84197 */   // Label 1807: @84197
     /*  84197 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(84235), // Rule ID 17928 //
     /*  84202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84220 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84227 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84233 */     GIR_RootConstrainSelectedInstOperands,
     /*  84234 */     // GIR_Coverage, 17928,
     /*  84234 */     GIR_EraseRootFromParent_Done,
     /*  84235 */   // Label 1808: @84235
     /*  84235 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(84277), // Rule ID 19836 //
     /*  84240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84262 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84269 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84275 */     GIR_RootConstrainSelectedInstOperands,
     /*  84276 */     // GIR_Coverage, 19836,
     /*  84276 */     GIR_EraseRootFromParent_Done,
     /*  84277 */   // Label 1809: @84277
     /*  84277 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(84315), // Rule ID 19840 //
     /*  84282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84300 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84307 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84313 */     GIR_RootConstrainSelectedInstOperands,
     /*  84314 */     // GIR_Coverage, 19840,
     /*  84314 */     GIR_EraseRootFromParent_Done,
     /*  84315 */   // Label 1810: @84315
     /*  84315 */   GIM_Reject,
     /*  84316 */ // Label 1802: @84316
     /*  84316 */ GIM_Reject,
     /*  84317 */ // Label 1487: @84317
     /*  84317 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(84490),
     /*  84322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84329 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(84371), // Rule ID 4494 //
     /*  84334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84356 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZmr),
     /*  84359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84363 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84369 */     GIR_RootConstrainSelectedInstOperands,
     /*  84370 */     // GIR_Coverage, 4494,
     /*  84370 */     GIR_EraseRootFromParent_Done,
     /*  84371 */   // Label 1812: @84371
     /*  84371 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(84409), // Rule ID 4518 //
     /*  84376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84394 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZmr),
     /*  84397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84401 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84407 */     GIR_RootConstrainSelectedInstOperands,
     /*  84408 */     // GIR_Coverage, 4518,
     /*  84408 */     GIR_EraseRootFromParent_Done,
     /*  84409 */   // Label 1813: @84409
     /*  84409 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(84451), // Rule ID 4548 //
     /*  84414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84436 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84443 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84449 */     GIR_RootConstrainSelectedInstOperands,
     /*  84450 */     // GIR_Coverage, 4548,
     /*  84450 */     GIR_EraseRootFromParent_Done,
     /*  84451 */   // Label 1814: @84451
     /*  84451 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(84489), // Rule ID 4590 //
     /*  84456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84474 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  84477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84481 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84487 */     GIR_RootConstrainSelectedInstOperands,
     /*  84488 */     // GIR_Coverage, 4590,
     /*  84488 */     GIR_EraseRootFromParent_Done,
     /*  84489 */   // Label 1815: @84489
     /*  84489 */   GIM_Reject,
     /*  84490 */ // Label 1811: @84490
     /*  84490 */ GIM_Reject,
     /*  84491 */ // Label 1488: @84491
     /*  84491 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(84572),
     /*  84496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  84507 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84511 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(84541), // Rule ID 4400 //
     /*  84516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  84519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84526 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk),
     /*  84529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84533 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84539 */     GIR_RootConstrainSelectedInstOperands,
     /*  84540 */     // GIR_Coverage, 4400,
     /*  84540 */     GIR_EraseRootFromParent_Done,
     /*  84541 */   // Label 1817: @84541
     /*  84541 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(84571), // Rule ID 4402 //
     /*  84546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  84549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84556 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk_EVEX addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk_EVEX),
     /*  84559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84563 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84569 */     GIR_RootConstrainSelectedInstOperands,
     /*  84570 */     // GIR_Coverage, 4402,
     /*  84570 */     GIR_EraseRootFromParent_Done,
     /*  84571 */   // Label 1818: @84571
     /*  84571 */   GIM_Reject,
     /*  84572 */ // Label 1816: @84572
     /*  84572 */ GIM_Reject,
     /*  84573 */ // Label 1489: @84573
     /*  84573 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(84826),
     /*  84578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84585 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(84627), // Rule ID 17950 //
     /*  84590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84612 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  84615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84619 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84625 */     GIR_RootConstrainSelectedInstOperands,
     /*  84626 */     // GIR_Coverage, 17950,
     /*  84626 */     GIR_EraseRootFromParent_Done,
     /*  84627 */   // Label 1820: @84627
     /*  84627 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(84665), // Rule ID 17954 //
     /*  84632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84650 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  84653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84657 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84663 */     GIR_RootConstrainSelectedInstOperands,
     /*  84664 */     // GIR_Coverage, 17954,
     /*  84664 */     GIR_EraseRootFromParent_Done,
     /*  84665 */   // Label 1821: @84665
     /*  84665 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(84707), // Rule ID 18330 //
     /*  84670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84692 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  84695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84699 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84705 */     GIR_RootConstrainSelectedInstOperands,
     /*  84706 */     // GIR_Coverage, 18330,
     /*  84706 */     GIR_EraseRootFromParent_Done,
     /*  84707 */   // Label 1822: @84707
     /*  84707 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(84745), // Rule ID 18334 //
     /*  84712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84730 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  84733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84737 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84743 */     GIR_RootConstrainSelectedInstOperands,
     /*  84744 */     // GIR_Coverage, 18334,
     /*  84744 */     GIR_EraseRootFromParent_Done,
     /*  84745 */   // Label 1823: @84745
     /*  84745 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(84787), // Rule ID 19823 //
     /*  84750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84772 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  84775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84779 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84785 */     GIR_RootConstrainSelectedInstOperands,
     /*  84786 */     // GIR_Coverage, 19823,
     /*  84786 */     GIR_EraseRootFromParent_Done,
     /*  84787 */   // Label 1824: @84787
     /*  84787 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(84825), // Rule ID 19827 //
     /*  84792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84810 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  84813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84817 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84823 */     GIR_RootConstrainSelectedInstOperands,
     /*  84824 */     // GIR_Coverage, 19827,
     /*  84824 */     GIR_EraseRootFromParent_Done,
     /*  84825 */   // Label 1825: @84825
     /*  84825 */   GIM_Reject,
     /*  84826 */ // Label 1819: @84826
     /*  84826 */ GIM_Reject,
     /*  84827 */ // Label 1490: @84827
     /*  84827 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(85160),
     /*  84832 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84835 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84839 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(84881), // Rule ID 17925 //
     /*  84844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84866 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84873 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84879 */     GIR_RootConstrainSelectedInstOperands,
     /*  84880 */     // GIR_Coverage, 17925,
     /*  84880 */     GIR_EraseRootFromParent_Done,
     /*  84881 */   // Label 1827: @84881
     /*  84881 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(84919), // Rule ID 17929 //
     /*  84886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84904 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84911 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84917 */     GIR_RootConstrainSelectedInstOperands,
     /*  84918 */     // GIR_Coverage, 17929,
     /*  84918 */     GIR_EraseRootFromParent_Done,
     /*  84919 */   // Label 1828: @84919
     /*  84919 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(84961), // Rule ID 17937 //
     /*  84924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84946 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84953 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84959 */     GIR_RootConstrainSelectedInstOperands,
     /*  84960 */     // GIR_Coverage, 17937,
     /*  84960 */     GIR_EraseRootFromParent_Done,
     /*  84961 */   // Label 1829: @84961
     /*  84961 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(84999), // Rule ID 17938 //
     /*  84966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84984 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84991 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84997 */     GIR_RootConstrainSelectedInstOperands,
     /*  84998 */     // GIR_Coverage, 17938,
     /*  84998 */     GIR_EraseRootFromParent_Done,
     /*  84999 */   // Label 1830: @84999
     /*  84999 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(85041), // Rule ID 19837 //
     /*  85004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85026 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  85026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85033 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85039 */     GIR_RootConstrainSelectedInstOperands,
     /*  85040 */     // GIR_Coverage, 19837,
     /*  85040 */     GIR_EraseRootFromParent_Done,
     /*  85041 */   // Label 1831: @85041
     /*  85041 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(85083), // Rule ID 19838 //
     /*  85046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85068 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  85068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  85071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85075 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85081 */     GIR_RootConstrainSelectedInstOperands,
     /*  85082 */     // GIR_Coverage, 19838,
     /*  85082 */     GIR_EraseRootFromParent_Done,
     /*  85083 */   // Label 1832: @85083
     /*  85083 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(85121), // Rule ID 19841 //
     /*  85088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85106 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  85106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85113 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85119 */     GIR_RootConstrainSelectedInstOperands,
     /*  85120 */     // GIR_Coverage, 19841,
     /*  85120 */     GIR_EraseRootFromParent_Done,
     /*  85121 */   // Label 1833: @85121
     /*  85121 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(85159), // Rule ID 19842 //
     /*  85126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85144 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  85144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  85147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85151 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85157 */     GIR_RootConstrainSelectedInstOperands,
     /*  85158 */     // GIR_Coverage, 19842,
     /*  85158 */     GIR_EraseRootFromParent_Done,
     /*  85159 */   // Label 1834: @85159
     /*  85159 */   GIM_Reject,
     /*  85160 */ // Label 1826: @85160
     /*  85160 */ GIM_Reject,
     /*  85161 */ // Label 1491: @85161
     /*  85161 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(85334),
     /*  85166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85169 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85173 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(85215), // Rule ID 4476 //
     /*  85178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85200 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85207 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85213 */     GIR_RootConstrainSelectedInstOperands,
     /*  85214 */     // GIR_Coverage, 4476,
     /*  85214 */     GIR_EraseRootFromParent_Done,
     /*  85215 */   // Label 1836: @85215
     /*  85215 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(85253), // Rule ID 4506 //
     /*  85220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85238 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85245 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85251 */     GIR_RootConstrainSelectedInstOperands,
     /*  85252 */     // GIR_Coverage, 4506,
     /*  85252 */     GIR_EraseRootFromParent_Done,
     /*  85253 */   // Label 1837: @85253
     /*  85253 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(85295), // Rule ID 19804 //
     /*  85258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85280 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85287 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85293 */     GIR_RootConstrainSelectedInstOperands,
     /*  85294 */     // GIR_Coverage, 19804,
     /*  85294 */     GIR_EraseRootFromParent_Done,
     /*  85295 */   // Label 1838: @85295
     /*  85295 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(85333), // Rule ID 19808 //
     /*  85300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85318 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85325 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85331 */     GIR_RootConstrainSelectedInstOperands,
     /*  85332 */     // GIR_Coverage, 19808,
     /*  85332 */     GIR_EraseRootFromParent_Done,
     /*  85333 */   // Label 1839: @85333
     /*  85333 */   GIM_Reject,
     /*  85334 */ // Label 1835: @85334
     /*  85334 */ GIM_Reject,
     /*  85335 */ // Label 1492: @85335
     /*  85335 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(85416),
     /*  85340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85343 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  85351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85355 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(85385), // Rule ID 4404 //
     /*  85360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85370 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk),
     /*  85373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85377 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85383 */     GIR_RootConstrainSelectedInstOperands,
     /*  85384 */     // GIR_Coverage, 4404,
     /*  85384 */     GIR_EraseRootFromParent_Done,
     /*  85385 */   // Label 1841: @85385
     /*  85385 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(85415), // Rule ID 4408 //
     /*  85390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85400 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk_EVEX addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk_EVEX),
     /*  85403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85407 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85413 */     GIR_RootConstrainSelectedInstOperands,
     /*  85414 */     // GIR_Coverage, 4408,
     /*  85414 */     GIR_EraseRootFromParent_Done,
     /*  85415 */   // Label 1842: @85415
     /*  85415 */   GIM_Reject,
     /*  85416 */ // Label 1840: @85416
     /*  85416 */ GIM_Reject,
     /*  85417 */ // Label 1493: @85417
     /*  85417 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(85590),
     /*  85422 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85425 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85429 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(85471), // Rule ID 17926 //
     /*  85434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85456 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  85459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85463 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85469 */     GIR_RootConstrainSelectedInstOperands,
     /*  85470 */     // GIR_Coverage, 17926,
     /*  85470 */     GIR_EraseRootFromParent_Done,
     /*  85471 */   // Label 1844: @85471
     /*  85471 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(85509), // Rule ID 17930 //
     /*  85476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85494 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  85497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85501 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85507 */     GIR_RootConstrainSelectedInstOperands,
     /*  85508 */     // GIR_Coverage, 17930,
     /*  85508 */     GIR_EraseRootFromParent_Done,
     /*  85509 */   // Label 1845: @85509
     /*  85509 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(85551), // Rule ID 19839 //
     /*  85514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85536 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85543 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85549 */     GIR_RootConstrainSelectedInstOperands,
     /*  85550 */     // GIR_Coverage, 19839,
     /*  85550 */     GIR_EraseRootFromParent_Done,
     /*  85551 */   // Label 1846: @85551
     /*  85551 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(85589), // Rule ID 19843 //
     /*  85556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85574 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85581 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85587 */     GIR_RootConstrainSelectedInstOperands,
     /*  85588 */     // GIR_Coverage, 19843,
     /*  85588 */     GIR_EraseRootFromParent_Done,
     /*  85589 */   // Label 1847: @85589
     /*  85589 */   GIM_Reject,
     /*  85590 */ // Label 1843: @85590
     /*  85590 */ GIM_Reject,
     /*  85591 */ // Label 1494: @85591
     /*  85591 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(85764),
     /*  85596 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85603 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(85645), // Rule ID 19805 //
     /*  85608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85630 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85637 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85643 */     GIR_RootConstrainSelectedInstOperands,
     /*  85644 */     // GIR_Coverage, 19805,
     /*  85644 */     GIR_EraseRootFromParent_Done,
     /*  85645 */   // Label 1849: @85645
     /*  85645 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(85687), // Rule ID 19806 //
     /*  85650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85672 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85679 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85685 */     GIR_RootConstrainSelectedInstOperands,
     /*  85686 */     // GIR_Coverage, 19806,
     /*  85686 */     GIR_EraseRootFromParent_Done,
     /*  85687 */   // Label 1850: @85687
     /*  85687 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(85725), // Rule ID 19809 //
     /*  85692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85710 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85717 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85723 */     GIR_RootConstrainSelectedInstOperands,
     /*  85724 */     // GIR_Coverage, 19809,
     /*  85724 */     GIR_EraseRootFromParent_Done,
     /*  85725 */   // Label 1851: @85725
     /*  85725 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(85763), // Rule ID 19810 //
     /*  85730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85748 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85755 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85761 */     GIR_RootConstrainSelectedInstOperands,
     /*  85762 */     // GIR_Coverage, 19810,
     /*  85762 */     GIR_EraseRootFromParent_Done,
     /*  85763 */   // Label 1852: @85763
     /*  85763 */   GIM_Reject,
     /*  85764 */ // Label 1848: @85764
     /*  85764 */ GIM_Reject,
     /*  85765 */ // Label 1495: @85765
     /*  85765 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(85846),
     /*  85770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  85781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85785 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(85815), // Rule ID 4406 //
     /*  85790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85800 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk),
     /*  85803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85807 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85813 */     GIR_RootConstrainSelectedInstOperands,
     /*  85814 */     // GIR_Coverage, 4406,
     /*  85814 */     GIR_EraseRootFromParent_Done,
     /*  85815 */   // Label 1854: @85815
     /*  85815 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(85845), // Rule ID 4410 //
     /*  85820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85830 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk_EVEX addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk_EVEX),
     /*  85833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85837 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85843 */     GIR_RootConstrainSelectedInstOperands,
     /*  85844 */     // GIR_Coverage, 4410,
     /*  85844 */     GIR_EraseRootFromParent_Done,
     /*  85845 */   // Label 1855: @85845
     /*  85845 */   GIM_Reject,
     /*  85846 */ // Label 1853: @85846
     /*  85846 */ GIM_Reject,
     /*  85847 */ // Label 1496: @85847
     /*  85847 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(85940),
     /*  85852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85859 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(85901), // Rule ID 19807 //
     /*  85864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85886 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85893 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85899 */     GIR_RootConstrainSelectedInstOperands,
     /*  85900 */     // GIR_Coverage, 19807,
     /*  85900 */     GIR_EraseRootFromParent_Done,
     /*  85901 */   // Label 1857: @85901
     /*  85901 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(85939), // Rule ID 19811 //
     /*  85906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85924 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85931 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85937 */     GIR_RootConstrainSelectedInstOperands,
     /*  85938 */     // GIR_Coverage, 19811,
     /*  85938 */     GIR_EraseRootFromParent_Done,
     /*  85939 */   // Label 1858: @85939
     /*  85939 */   GIM_Reject,
     /*  85940 */ // Label 1856: @85940
     /*  85940 */ GIM_Reject,
     /*  85941 */ // Label 1497: @85941
     /*  85941 */ GIM_Reject,
     /*  85942 */ // Label 14: @85942
     /*  85942 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1863*/ GIMT_Encode4(86177),
     /*  85953 */ /*GILLT_s8*//*Label 1859*/ GIMT_Encode4(85969),
     /*  85957 */ /*GILLT_s16*//*Label 1860*/ GIMT_Encode4(86021),
     /*  85961 */ /*GILLT_s32*//*Label 1861*/ GIMT_Encode4(86073),
     /*  85965 */ /*GILLT_s64*//*Label 1862*/ GIMT_Encode4(86125),
     /*  85969 */ // Label 1859: @85969
     /*  85969 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(86020), // Rule ID 45 //
     /*  85974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86003 */   // (atomic_swap:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_swap_i8>>  =>  (XCHG8rm:{ *:[i8] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG8rm),
     /*  86006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86008 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86010 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86018 */   GIR_RootConstrainSelectedInstOperands,
     /*  86019 */   // GIR_Coverage, 45,
     /*  86019 */   GIR_EraseRootFromParent_Done,
     /*  86020 */ // Label 1864: @86020
     /*  86020 */ GIM_Reject,
     /*  86021 */ // Label 1860: @86021
     /*  86021 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(86072), // Rule ID 46 //
     /*  86026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86029 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86040 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86048 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86055 */   // (atomic_swap:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_swap_i16>>  =>  (XCHG16rm:{ *:[i16] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG16rm),
     /*  86058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86060 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86062 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86070 */   GIR_RootConstrainSelectedInstOperands,
     /*  86071 */   // GIR_Coverage, 46,
     /*  86071 */   GIR_EraseRootFromParent_Done,
     /*  86072 */ // Label 1865: @86072
     /*  86072 */ GIM_Reject,
     /*  86073 */ // Label 1861: @86073
     /*  86073 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(86124), // Rule ID 47 //
     /*  86078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86092 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86107 */   // (atomic_swap:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>>  =>  (XCHG32rm:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG32rm),
     /*  86110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86112 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86114 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86122 */   GIR_RootConstrainSelectedInstOperands,
     /*  86123 */   // GIR_Coverage, 47,
     /*  86123 */   GIR_EraseRootFromParent_Done,
     /*  86124 */ // Label 1866: @86124
     /*  86124 */ GIM_Reject,
     /*  86125 */ // Label 1862: @86125
     /*  86125 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(86176), // Rule ID 48 //
     /*  86130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86159 */   // (atomic_swap:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>>  =>  (XCHG64rm:{ *:[i64] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG64rm),
     /*  86162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86164 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86166 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86174 */   GIR_RootConstrainSelectedInstOperands,
     /*  86175 */   // GIR_Coverage, 48,
     /*  86175 */   GIR_EraseRootFromParent_Done,
     /*  86176 */ // Label 1867: @86176
     /*  86176 */ GIM_Reject,
     /*  86177 */ // Label 1863: @86177
     /*  86177 */ GIM_Reject,
     /*  86178 */ // Label 15: @86178
     /*  86178 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(86425),
     /*  86189 */ /*GILLT_s8*//*Label 1868*/ GIMT_Encode4(86205),
     /*  86193 */ /*GILLT_s16*//*Label 1869*/ GIMT_Encode4(86260),
     /*  86197 */ /*GILLT_s32*//*Label 1870*/ GIMT_Encode4(86315),
     /*  86201 */ /*GILLT_s64*//*Label 1871*/ GIMT_Encode4(86370),
     /*  86205 */ // Label 1868: @86205
     /*  86205 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(86259), // Rule ID 17298 //
     /*  86210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  86213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86232 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86239 */   // (atomic_load_add:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_load_add_i8>>  =>  (LXADD8:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD8),
     /*  86242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86244 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86246 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86250 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86257 */   GIR_RootConstrainSelectedInstOperands,
     /*  86258 */   // GIR_Coverage, 17298,
     /*  86258 */   GIR_EraseRootFromParent_Done,
     /*  86259 */ // Label 1873: @86259
     /*  86259 */ GIM_Reject,
     /*  86260 */ // Label 1869: @86260
     /*  86260 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(86314), // Rule ID 17299 //
     /*  86265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86287 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86294 */   // (atomic_load_add:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_load_add_i16>>  =>  (LXADD16:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD16),
     /*  86297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86299 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86301 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86305 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86308 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86312 */   GIR_RootConstrainSelectedInstOperands,
     /*  86313 */   // GIR_Coverage, 17299,
     /*  86313 */   GIR_EraseRootFromParent_Done,
     /*  86314 */ // Label 1874: @86314
     /*  86314 */ GIM_Reject,
     /*  86315 */ // Label 1870: @86315
     /*  86315 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(86369), // Rule ID 17300 //
     /*  86320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86349 */   // (atomic_load_add:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>>  =>  (LXADD32:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD32),
     /*  86352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86354 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86356 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86360 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86367 */   GIR_RootConstrainSelectedInstOperands,
     /*  86368 */   // GIR_Coverage, 17300,
     /*  86368 */   GIR_EraseRootFromParent_Done,
     /*  86369 */ // Label 1875: @86369
     /*  86369 */ GIM_Reject,
     /*  86370 */ // Label 1871: @86370
     /*  86370 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(86424), // Rule ID 17301 //
     /*  86375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86378 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86404 */   // (atomic_load_add:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>>  =>  (LXADD64:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD64),
     /*  86407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86409 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86411 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86415 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86422 */   GIR_RootConstrainSelectedInstOperands,
     /*  86423 */   // GIR_Coverage, 17301,
     /*  86423 */   GIR_EraseRootFromParent_Done,
     /*  86424 */ // Label 1876: @86424
     /*  86424 */ GIM_Reject,
     /*  86425 */ // Label 1872: @86425
     /*  86425 */ GIM_Reject,
     /*  86426 */ // Label 16: @86426
     /*  86426 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(86581),
     /*  86431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86434 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(86484), // Rule ID 156 //
     /*  86439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86471 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT0 addr:{ *:[iPTR] }:$src)
     /*  86471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT0),
     /*  86474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86482 */     GIR_RootConstrainSelectedInstOperands,
     /*  86483 */     // GIR_Coverage, 156,
     /*  86483 */     GIR_EraseRootFromParent_Done,
     /*  86484 */   // Label 1878: @86484
     /*  86484 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(86534), // Rule ID 157 //
     /*  86489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86521 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT1 addr:{ *:[iPTR] }:$src)
     /*  86521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT1),
     /*  86524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86532 */     GIR_RootConstrainSelectedInstOperands,
     /*  86533 */     // GIR_Coverage, 157,
     /*  86533 */     GIR_EraseRootFromParent_Done,
     /*  86534 */   // Label 1879: @86534
     /*  86534 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(86580), // Rule ID 16983 //
     /*  86539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrefetchW),
     /*  86542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /*  86553 */     // MIs[0] Operand 2
     /*  86553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  86556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86567 */     // (prefetch addr:{ *:[iPTR] }:$addr, 1:{ *:[i32] }, (timm:{ *:[i32] })<<P:Predicate_PrefetchWLevel>>, 1:{ *:[i32] })  =>  (PREFETCHW addr:{ *:[iPTR] }:$addr)
     /*  86567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHW),
     /*  86570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // addr
     /*  86574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86578 */     GIR_RootConstrainSelectedInstOperands,
     /*  86579 */     // GIR_Coverage, 16983,
     /*  86579 */     GIR_EraseRootFromParent_Done,
     /*  86580 */   // Label 1880: @86580
     /*  86580 */   GIM_Reject,
     /*  86581 */ // Label 1877: @86581
     /*  86581 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(86744),
     /*  86586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86596 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  86599 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(86635), // Rule ID 2505 //
     /*  86604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86622 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT0 addr:{ *:[iPTR] }:$src)
     /*  86622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT0),
     /*  86625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86633 */     GIR_RootConstrainSelectedInstOperands,
     /*  86634 */     // GIR_Coverage, 2505,
     /*  86634 */     GIR_EraseRootFromParent_Done,
     /*  86635 */   // Label 1882: @86635
     /*  86635 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(86671), // Rule ID 2506 //
     /*  86640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86658 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT1 addr:{ *:[iPTR] }:$src)
     /*  86658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT1),
     /*  86661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86669 */     GIR_RootConstrainSelectedInstOperands,
     /*  86670 */     // GIR_Coverage, 2506,
     /*  86670 */     GIR_EraseRootFromParent_Done,
     /*  86671 */   // Label 1883: @86671
     /*  86671 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(86707), // Rule ID 2507 //
     /*  86676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  86683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86694 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT2 addr:{ *:[iPTR] }:$src)
     /*  86694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT2),
     /*  86697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86705 */     GIR_RootConstrainSelectedInstOperands,
     /*  86706 */     // GIR_Coverage, 2507,
     /*  86706 */     GIR_EraseRootFromParent_Done,
     /*  86707 */   // Label 1884: @86707
     /*  86707 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(86743), // Rule ID 2508 //
     /*  86712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  86719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86730 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHNTA addr:{ *:[iPTR] }:$src)
     /*  86730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHNTA),
     /*  86733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86741 */     GIR_RootConstrainSelectedInstOperands,
     /*  86742 */     // GIR_Coverage, 2508,
     /*  86742 */     GIR_EraseRootFromParent_Done,
     /*  86743 */   // Label 1885: @86743
     /*  86743 */   GIM_Reject,
     /*  86744 */ // Label 1881: @86744
     /*  86744 */ GIM_Reject,
     /*  86745 */ // Label 17: @86745
     /*  86745 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(89074),
     /*  86750 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  86753 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(86820), // Rule ID 1530 //
     /*  86758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  86766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86804 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15034:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrm),
     /*  86807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86818 */     GIR_RootConstrainSelectedInstOperands,
     /*  86819 */     // GIR_Coverage, 1530,
     /*  86819 */     GIR_EraseRootFromParent_Done,
     /*  86820 */   // Label 1887: @86820
     /*  86820 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(86887), // Rule ID 1532 //
     /*  86825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  86833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86871 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15033:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrm),
     /*  86874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86885 */     GIR_RootConstrainSelectedInstOperands,
     /*  86886 */     // GIR_Coverage, 1532,
     /*  86886 */     GIR_EraseRootFromParent_Done,
     /*  86887 */   // Label 1888: @86887
     /*  86887 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(86954), // Rule ID 1534 //
     /*  86892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  86900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86938 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15032:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrm),
     /*  86941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86952 */     GIR_RootConstrainSelectedInstOperands,
     /*  86953 */     // GIR_Coverage, 1534,
     /*  86953 */     GIR_EraseRootFromParent_Done,
     /*  86954 */   // Label 1889: @86954
     /*  86954 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(87021), // Rule ID 1536 //
     /*  86959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  86967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87005 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15031:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrm),
     /*  87008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87019 */     GIR_RootConstrainSelectedInstOperands,
     /*  87020 */     // GIR_Coverage, 1536,
     /*  87020 */     GIR_EraseRootFromParent_Done,
     /*  87021 */   // Label 1890: @87021
     /*  87021 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(87088), // Rule ID 1538 //
     /*  87026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  87034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87072 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15030:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrm),
     /*  87075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87086 */     GIR_RootConstrainSelectedInstOperands,
     /*  87087 */     // GIR_Coverage, 1538,
     /*  87087 */     GIR_EraseRootFromParent_Done,
     /*  87088 */   // Label 1891: @87088
     /*  87088 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(87155), // Rule ID 1540 //
     /*  87093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  87101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15029:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrm),
     /*  87142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87153 */     GIR_RootConstrainSelectedInstOperands,
     /*  87154 */     // GIR_Coverage, 1540,
     /*  87154 */     GIR_EraseRootFromParent_Done,
     /*  87155 */   // Label 1892: @87155
     /*  87155 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(87222), // Rule ID 1542 //
     /*  87160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  87168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87206 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15028:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrm),
     /*  87209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87220 */     GIR_RootConstrainSelectedInstOperands,
     /*  87221 */     // GIR_Coverage, 1542,
     /*  87221 */     GIR_EraseRootFromParent_Done,
     /*  87222 */   // Label 1893: @87222
     /*  87222 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(87289), // Rule ID 1544 //
     /*  87227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  87235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87273 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15027:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrm),
     /*  87276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87287 */     GIR_RootConstrainSelectedInstOperands,
     /*  87288 */     // GIR_Coverage, 1544,
     /*  87288 */     GIR_EraseRootFromParent_Done,
     /*  87289 */   // Label 1894: @87289
     /*  87289 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(87356), // Rule ID 1546 //
     /*  87294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  87302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87340 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15026:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrm),
     /*  87343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87354 */     GIR_RootConstrainSelectedInstOperands,
     /*  87355 */     // GIR_Coverage, 1546,
     /*  87355 */     GIR_EraseRootFromParent_Done,
     /*  87356 */   // Label 1895: @87356
     /*  87356 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(87423), // Rule ID 1548 //
     /*  87361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  87369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87407 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15025:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrm),
     /*  87410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87421 */     GIR_RootConstrainSelectedInstOperands,
     /*  87422 */     // GIR_Coverage, 1548,
     /*  87422 */     GIR_EraseRootFromParent_Done,
     /*  87423 */   // Label 1896: @87423
     /*  87423 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(87490), // Rule ID 1550 //
     /*  87428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  87436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87474 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15024:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrm),
     /*  87477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87488 */     GIR_RootConstrainSelectedInstOperands,
     /*  87489 */     // GIR_Coverage, 1550,
     /*  87489 */     GIR_EraseRootFromParent_Done,
     /*  87490 */   // Label 1897: @87490
     /*  87490 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(87557), // Rule ID 1552 //
     /*  87495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  87503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87521 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87541 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15023:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrm),
     /*  87544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87555 */     GIR_RootConstrainSelectedInstOperands,
     /*  87556 */     // GIR_Coverage, 1552,
     /*  87556 */     GIR_EraseRootFromParent_Done,
     /*  87557 */   // Label 1898: @87557
     /*  87557 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(87624), // Rule ID 1554 //
     /*  87562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  87570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15022:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrm),
     /*  87611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87622 */     GIR_RootConstrainSelectedInstOperands,
     /*  87623 */     // GIR_Coverage, 1554,
     /*  87623 */     GIR_EraseRootFromParent_Done,
     /*  87624 */   // Label 1899: @87624
     /*  87624 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(87691), // Rule ID 1556 //
     /*  87629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  87637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87675 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15021:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrm),
     /*  87678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87689 */     GIR_RootConstrainSelectedInstOperands,
     /*  87690 */     // GIR_Coverage, 1556,
     /*  87690 */     GIR_EraseRootFromParent_Done,
     /*  87691 */   // Label 1900: @87691
     /*  87691 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(87758), // Rule ID 1558 //
     /*  87696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  87704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15020:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrm),
     /*  87745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87756 */     GIR_RootConstrainSelectedInstOperands,
     /*  87757 */     // GIR_Coverage, 1558,
     /*  87757 */     GIR_EraseRootFromParent_Done,
     /*  87758 */   // Label 1901: @87758
     /*  87758 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(87825), // Rule ID 1564 //
     /*  87763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87796 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87809 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15012:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  87809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrm),
     /*  87812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87814 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87823 */     GIR_RootConstrainSelectedInstOperands,
     /*  87824 */     // GIR_Coverage, 1564,
     /*  87824 */     GIR_EraseRootFromParent_Done,
     /*  87825 */   // Label 1902: @87825
     /*  87825 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(87892), // Rule ID 1566 //
     /*  87830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  87838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  87841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  87844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87876 */     // (intrinsic_wo_chain:{ *:[v8f32] } 15013:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  87876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrm),
     /*  87879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87890 */     GIR_RootConstrainSelectedInstOperands,
     /*  87891 */     // GIR_Coverage, 1566,
     /*  87891 */     GIR_EraseRootFromParent_Done,
     /*  87892 */   // Label 1903: @87892
     /*  87892 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(87959), // Rule ID 1572 //
     /*  87897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  87905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87943 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15010:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  87943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrm),
     /*  87946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87957 */     GIR_RootConstrainSelectedInstOperands,
     /*  87958 */     // GIR_Coverage, 1572,
     /*  87958 */     GIR_EraseRootFromParent_Done,
     /*  87959 */   // Label 1904: @87959
     /*  87959 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(88026), // Rule ID 1574 //
     /*  87964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  87972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  87975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  87978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88010 */     // (intrinsic_wo_chain:{ *:[v4f64] } 15011:{ *:[iPTR] }, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  88010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrm),
     /*  88013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88015 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  88019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88024 */     GIR_RootConstrainSelectedInstOperands,
     /*  88025 */     // GIR_Coverage, 1574,
     /*  88025 */     GIR_EraseRootFromParent_Done,
     /*  88026 */   // Label 1905: @88026
     /*  88026 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(88093), // Rule ID 3364 //
     /*  88031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88077 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13385:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESIMCrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /*  88077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrm),
     /*  88080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  88086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88091 */     GIR_RootConstrainSelectedInstOperands,
     /*  88092 */     // GIR_Coverage, 3364,
     /*  88092 */     GIR_EraseRootFromParent_Done,
     /*  88093 */   // Label 1906: @88093
     /*  88093 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(88129), // Rule ID 1529 //
     /*  88098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  88106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88120 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15034:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /*  88123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88127 */     GIR_RootConstrainSelectedInstOperands,
     /*  88128 */     // GIR_Coverage, 1529,
     /*  88128 */     GIR_EraseRootFromParent_Done,
     /*  88129 */   // Label 1907: @88129
     /*  88129 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(88165), // Rule ID 1531 //
     /*  88134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  88142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88156 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15033:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /*  88159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88163 */     GIR_RootConstrainSelectedInstOperands,
     /*  88164 */     // GIR_Coverage, 1531,
     /*  88164 */     GIR_EraseRootFromParent_Done,
     /*  88165 */   // Label 1908: @88165
     /*  88165 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(88201), // Rule ID 1533 //
     /*  88170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  88178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15032:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /*  88195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88199 */     GIR_RootConstrainSelectedInstOperands,
     /*  88200 */     // GIR_Coverage, 1533,
     /*  88200 */     GIR_EraseRootFromParent_Done,
     /*  88201 */   // Label 1909: @88201
     /*  88201 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(88237), // Rule ID 1535 //
     /*  88206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  88214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88228 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15031:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /*  88231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88235 */     GIR_RootConstrainSelectedInstOperands,
     /*  88236 */     // GIR_Coverage, 1535,
     /*  88236 */     GIR_EraseRootFromParent_Done,
     /*  88237 */   // Label 1910: @88237
     /*  88237 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(88273), // Rule ID 1537 //
     /*  88242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  88250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15030:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /*  88267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88271 */     GIR_RootConstrainSelectedInstOperands,
     /*  88272 */     // GIR_Coverage, 1537,
     /*  88272 */     GIR_EraseRootFromParent_Done,
     /*  88273 */   // Label 1911: @88273
     /*  88273 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(88309), // Rule ID 1539 //
     /*  88278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  88286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88300 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15029:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /*  88303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88307 */     GIR_RootConstrainSelectedInstOperands,
     /*  88308 */     // GIR_Coverage, 1539,
     /*  88308 */     GIR_EraseRootFromParent_Done,
     /*  88309 */   // Label 1912: @88309
     /*  88309 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(88345), // Rule ID 1541 //
     /*  88314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  88322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88336 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15028:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /*  88339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88343 */     GIR_RootConstrainSelectedInstOperands,
     /*  88344 */     // GIR_Coverage, 1541,
     /*  88344 */     GIR_EraseRootFromParent_Done,
     /*  88345 */   // Label 1913: @88345
     /*  88345 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(88381), // Rule ID 1543 //
     /*  88350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  88358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88372 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15027:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /*  88375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88379 */     GIR_RootConstrainSelectedInstOperands,
     /*  88380 */     // GIR_Coverage, 1543,
     /*  88380 */     GIR_EraseRootFromParent_Done,
     /*  88381 */   // Label 1914: @88381
     /*  88381 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(88417), // Rule ID 1545 //
     /*  88386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  88394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88408 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15026:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /*  88411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88413 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88415 */     GIR_RootConstrainSelectedInstOperands,
     /*  88416 */     // GIR_Coverage, 1545,
     /*  88416 */     GIR_EraseRootFromParent_Done,
     /*  88417 */   // Label 1915: @88417
     /*  88417 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(88453), // Rule ID 1547 //
     /*  88422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  88430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15025:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /*  88447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88451 */     GIR_RootConstrainSelectedInstOperands,
     /*  88452 */     // GIR_Coverage, 1547,
     /*  88452 */     GIR_EraseRootFromParent_Done,
     /*  88453 */   // Label 1916: @88453
     /*  88453 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(88489), // Rule ID 1549 //
     /*  88458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  88466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88480 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15024:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /*  88483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88487 */     GIR_RootConstrainSelectedInstOperands,
     /*  88488 */     // GIR_Coverage, 1549,
     /*  88488 */     GIR_EraseRootFromParent_Done,
     /*  88489 */   // Label 1917: @88489
     /*  88489 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(88525), // Rule ID 1551 //
     /*  88494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  88502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88516 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15023:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /*  88519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88523 */     GIR_RootConstrainSelectedInstOperands,
     /*  88524 */     // GIR_Coverage, 1551,
     /*  88524 */     GIR_EraseRootFromParent_Done,
     /*  88525 */   // Label 1918: @88525
     /*  88525 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(88561), // Rule ID 1553 //
     /*  88530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  88538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88552 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15022:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /*  88555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88557 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88559 */     GIR_RootConstrainSelectedInstOperands,
     /*  88560 */     // GIR_Coverage, 1553,
     /*  88560 */     GIR_EraseRootFromParent_Done,
     /*  88561 */   // Label 1919: @88561
     /*  88561 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(88597), // Rule ID 1555 //
     /*  88566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  88574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88588 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15021:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /*  88591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88595 */     GIR_RootConstrainSelectedInstOperands,
     /*  88596 */     // GIR_Coverage, 1555,
     /*  88596 */     GIR_EraseRootFromParent_Done,
     /*  88597 */   // Label 1920: @88597
     /*  88597 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(88633), // Rule ID 1557 //
     /*  88602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  88610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15020:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /*  88627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88631 */     GIR_RootConstrainSelectedInstOperands,
     /*  88632 */     // GIR_Coverage, 1557,
     /*  88632 */     GIR_EraseRootFromParent_Done,
     /*  88633 */   // Label 1921: @88633
     /*  88633 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(88669), // Rule ID 1559 //
     /*  88638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /*  88646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88660 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15015:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /*  88663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88667 */     GIR_RootConstrainSelectedInstOperands,
     /*  88668 */     // GIR_Coverage, 1559,
     /*  88668 */     GIR_EraseRootFromParent_Done,
     /*  88669 */   // Label 1922: @88669
     /*  88669 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(88705), // Rule ID 1563 //
     /*  88674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  88682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88696 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15012:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /*  88699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88703 */     GIR_RootConstrainSelectedInstOperands,
     /*  88704 */     // GIR_Coverage, 1563,
     /*  88704 */     GIR_EraseRootFromParent_Done,
     /*  88705 */   // Label 1923: @88705
     /*  88705 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(88741), // Rule ID 1565 //
     /*  88710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  88718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88732 */     // (intrinsic_wo_chain:{ *:[v8f32] } 15013:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /*  88732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /*  88735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88739 */     GIR_RootConstrainSelectedInstOperands,
     /*  88740 */     // GIR_Coverage, 1565,
     /*  88740 */     GIR_EraseRootFromParent_Done,
     /*  88741 */   // Label 1924: @88741
     /*  88741 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(88777), // Rule ID 1567 //
     /*  88746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /*  88754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88768 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15014:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /*  88771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88773 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88775 */     GIR_RootConstrainSelectedInstOperands,
     /*  88776 */     // GIR_Coverage, 1567,
     /*  88776 */     GIR_EraseRootFromParent_Done,
     /*  88777 */   // Label 1925: @88777
     /*  88777 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(88813), // Rule ID 1571 //
     /*  88782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  88790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88804 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15010:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /*  88807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88811 */     GIR_RootConstrainSelectedInstOperands,
     /*  88812 */     // GIR_Coverage, 1571,
     /*  88812 */     GIR_EraseRootFromParent_Done,
     /*  88813 */   // Label 1926: @88813
     /*  88813 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(88849), // Rule ID 1573 //
     /*  88818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  88826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  88829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  88832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88840 */     // (intrinsic_wo_chain:{ *:[v4f64] } 15011:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /*  88840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /*  88843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88847 */     GIR_RootConstrainSelectedInstOperands,
     /*  88848 */     // GIR_Coverage, 1573,
     /*  88848 */     GIR_EraseRootFromParent_Done,
     /*  88849 */   // Label 1927: @88849
     /*  88849 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(88885), // Rule ID 3363 //
     /*  88854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88876 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13385:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /*  88879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88883 */     GIR_RootConstrainSelectedInstOperands,
     /*  88884 */     // GIR_Coverage, 3363,
     /*  88884 */     GIR_EraseRootFromParent_Done,
     /*  88885 */   // Label 1928: @88885
     /*  88885 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(88921), // Rule ID 3365 //
     /*  88890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  88893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88912 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13385:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /*  88915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88919 */     GIR_RootConstrainSelectedInstOperands,
     /*  88920 */     // GIR_Coverage, 3365,
     /*  88920 */     GIR_EraseRootFromParent_Done,
     /*  88921 */   // Label 1929: @88921
     /*  88921 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(88959), // Rule ID 18266 //
     /*  88926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88948 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14720:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /*  88951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88955 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88957 */     GIR_RootConstrainSelectedInstOperands,
     /*  88958 */     // GIR_Coverage, 18266,
     /*  88958 */     GIR_EraseRootFromParent_Done,
     /*  88959 */   // Label 1930: @88959
     /*  88959 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(88997), // Rule ID 18270 //
     /*  88964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88986 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14720:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /*  88989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88995 */     GIR_RootConstrainSelectedInstOperands,
     /*  88996 */     // GIR_Coverage, 18270,
     /*  88996 */     GIR_EraseRootFromParent_Done,
     /*  88997 */   // Label 1931: @88997
     /*  88997 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(89035), // Rule ID 18286 //
     /*  89002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  89005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  89010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89024 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14718:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /*  89027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89029 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89033 */     GIR_RootConstrainSelectedInstOperands,
     /*  89034 */     // GIR_Coverage, 18286,
     /*  89034 */     GIR_EraseRootFromParent_Done,
     /*  89035 */   // Label 1932: @89035
     /*  89035 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(89073), // Rule ID 18290 //
     /*  89040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  89048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89062 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14718:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /*  89065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89067 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89071 */     GIR_RootConstrainSelectedInstOperands,
     /*  89072 */     // GIR_Coverage, 18290,
     /*  89072 */     GIR_EraseRootFromParent_Done,
     /*  89073 */   // Label 1933: @89073
     /*  89073 */   GIM_Reject,
     /*  89074 */ // Label 1886: @89074
     /*  89074 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(95855),
     /*  89079 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  89082 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(89154), // Rule ID 3368 //
     /*  89087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  89090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  89095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  89098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89124 */     // MIs[0] src2
     /*  89124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  89127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89136 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13386:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  89136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rm),
     /*  89139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  89145 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  89147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89152 */     GIR_RootConstrainSelectedInstOperands,
     /*  89153 */     // GIR_Coverage, 3368,
     /*  89153 */     GIR_EraseRootFromParent_Done,
     /*  89154 */   // Label 1935: @89154
     /*  89154 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(89230), // Rule ID 16790 //
     /*  89159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  89167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89212 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rm),
     /*  89215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89228 */     GIR_RootConstrainSelectedInstOperands,
     /*  89229 */     // GIR_Coverage, 16790,
     /*  89229 */     GIR_EraseRootFromParent_Done,
     /*  89230 */   // Label 1936: @89230
     /*  89230 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(89306), // Rule ID 16792 //
     /*  89235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  89243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89288 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14990:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rm),
     /*  89291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89304 */     GIR_RootConstrainSelectedInstOperands,
     /*  89305 */     // GIR_Coverage, 16792,
     /*  89305 */     GIR_EraseRootFromParent_Done,
     /*  89306 */   // Label 1937: @89306
     /*  89306 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(89382), // Rule ID 16796 //
     /*  89311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  89319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89364 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rm),
     /*  89367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89371 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89380 */     GIR_RootConstrainSelectedInstOperands,
     /*  89381 */     // GIR_Coverage, 16796,
     /*  89381 */     GIR_EraseRootFromParent_Done,
     /*  89382 */   // Label 1938: @89382
     /*  89382 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(89458), // Rule ID 16798 //
     /*  89387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  89395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89440 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14993:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rm),
     /*  89443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89456 */     GIR_RootConstrainSelectedInstOperands,
     /*  89457 */     // GIR_Coverage, 16798,
     /*  89457 */     GIR_EraseRootFromParent_Done,
     /*  89458 */   // Label 1939: @89458
     /*  89458 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(89534), // Rule ID 3023 //
     /*  89463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  89471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89516 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14858:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrm),
     /*  89519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89532 */     GIR_RootConstrainSelectedInstOperands,
     /*  89533 */     // GIR_Coverage, 3023,
     /*  89533 */     GIR_EraseRootFromParent_Done,
     /*  89534 */   // Label 1940: @89534
     /*  89534 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(89610), // Rule ID 3025 //
     /*  89539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  89547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14862:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrm),
     /*  89595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89608 */     GIR_RootConstrainSelectedInstOperands,
     /*  89609 */     // GIR_Coverage, 3025,
     /*  89609 */     GIR_EraseRootFromParent_Done,
     /*  89610 */   // Label 1941: @89610
     /*  89610 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(89686), // Rule ID 3027 //
     /*  89615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  89623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89668 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14860:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrm),
     /*  89671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89684 */     GIR_RootConstrainSelectedInstOperands,
     /*  89685 */     // GIR_Coverage, 3027,
     /*  89685 */     GIR_EraseRootFromParent_Done,
     /*  89686 */   // Label 1942: @89686
     /*  89686 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(89762), // Rule ID 3029 //
     /*  89691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  89699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14842:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrm),
     /*  89747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89760 */     GIR_RootConstrainSelectedInstOperands,
     /*  89761 */     // GIR_Coverage, 3029,
     /*  89761 */     GIR_EraseRootFromParent_Done,
     /*  89762 */   // Label 1943: @89762
     /*  89762 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(89838), // Rule ID 3031 //
     /*  89767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  89775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14848:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrm),
     /*  89823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89836 */     GIR_RootConstrainSelectedInstOperands,
     /*  89837 */     // GIR_Coverage, 3031,
     /*  89837 */     GIR_EraseRootFromParent_Done,
     /*  89838 */   // Label 1944: @89838
     /*  89838 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(89914), // Rule ID 3047 //
     /*  89843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  89851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  89854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  89857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  89860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89896 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13749:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrm),
     /*  89899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89912 */     GIR_RootConstrainSelectedInstOperands,
     /*  89913 */     // GIR_Coverage, 3047,
     /*  89913 */     GIR_EraseRootFromParent_Done,
     /*  89914 */   // Label 1945: @89914
     /*  89914 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(89990), // Rule ID 3049 //
     /*  89919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  89927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89972 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13751:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrm),
     /*  89975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89988 */     GIR_RootConstrainSelectedInstOperands,
     /*  89989 */     // GIR_Coverage, 3049,
     /*  89989 */     GIR_EraseRootFromParent_Done,
     /*  89990 */   // Label 1946: @89990
     /*  89990 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(90066), // Rule ID 3051 //
     /*  89995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  90003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  90006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  90009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  90012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90048 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13750:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrm),
     /*  90051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90064 */     GIR_RootConstrainSelectedInstOperands,
     /*  90065 */     // GIR_Coverage, 3051,
     /*  90065 */     GIR_EraseRootFromParent_Done,
     /*  90066 */   // Label 1947: @90066
     /*  90066 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(90142), // Rule ID 3053 //
     /*  90071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  90079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  90082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  90085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  90088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90124 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13736:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrm),
     /*  90127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90140 */     GIR_RootConstrainSelectedInstOperands,
     /*  90141 */     // GIR_Coverage, 3053,
     /*  90141 */     GIR_EraseRootFromParent_Done,
     /*  90142 */   // Label 1948: @90142
     /*  90142 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(90218), // Rule ID 3055 //
     /*  90147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  90155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  90158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  90161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  90164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90200 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13739:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrm),
     /*  90203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90216 */     GIR_RootConstrainSelectedInstOperands,
     /*  90217 */     // GIR_Coverage, 3055,
     /*  90217 */     GIR_EraseRootFromParent_Done,
     /*  90218 */   // Label 1949: @90218
     /*  90218 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(90294), // Rule ID 3310 //
     /*  90223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90276 */     // (intrinsic_wo_chain:{ *:[i32] } 14816:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8),
     /*  90279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90292 */     GIR_RootConstrainSelectedInstOperands,
     /*  90293 */     // GIR_Coverage, 3310,
     /*  90293 */     GIR_EraseRootFromParent_Done,
     /*  90294 */   // Label 1950: @90294
     /*  90294 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(90370), // Rule ID 3312 //
     /*  90299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90352 */     // (intrinsic_wo_chain:{ *:[i32] } 14814:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16),
     /*  90355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90368 */     GIR_RootConstrainSelectedInstOperands,
     /*  90369 */     // GIR_Coverage, 3312,
     /*  90369 */     GIR_EraseRootFromParent_Done,
     /*  90370 */   // Label 1951: @90370
     /*  90370 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(90446), // Rule ID 3314 //
     /*  90375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90408 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90415 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90428 */     // (intrinsic_wo_chain:{ *:[i32] } 14815:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32),
     /*  90431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90444 */     GIR_RootConstrainSelectedInstOperands,
     /*  90445 */     // GIR_Coverage, 3314,
     /*  90445 */     GIR_EraseRootFromParent_Done,
     /*  90446 */   // Label 1952: @90446
     /*  90446 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(90522), // Rule ID 3316 //
     /*  90451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90504 */     // (intrinsic_wo_chain:{ *:[i64] } 14817:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64),
     /*  90507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90520 */     GIR_RootConstrainSelectedInstOperands,
     /*  90521 */     // GIR_Coverage, 3316,
     /*  90521 */     GIR_EraseRootFromParent_Done,
     /*  90522 */   // Label 1953: @90522
     /*  90522 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(90598), // Rule ID 3318 //
     /*  90527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90580 */     // (intrinsic_wo_chain:{ *:[i32] } 14816:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8_EVEX),
     /*  90583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90596 */     GIR_RootConstrainSelectedInstOperands,
     /*  90597 */     // GIR_Coverage, 3318,
     /*  90597 */     GIR_EraseRootFromParent_Done,
     /*  90598 */   // Label 1954: @90598
     /*  90598 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(90674), // Rule ID 3320 //
     /*  90603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90656 */     // (intrinsic_wo_chain:{ *:[i32] } 14814:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16_EVEX),
     /*  90659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90672 */     GIR_RootConstrainSelectedInstOperands,
     /*  90673 */     // GIR_Coverage, 3320,
     /*  90673 */     GIR_EraseRootFromParent_Done,
     /*  90674 */   // Label 1955: @90674
     /*  90674 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(90750), // Rule ID 3322 //
     /*  90679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90732 */     // (intrinsic_wo_chain:{ *:[i32] } 14815:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32_EVEX),
     /*  90735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90748 */     GIR_RootConstrainSelectedInstOperands,
     /*  90749 */     // GIR_Coverage, 3322,
     /*  90749 */     GIR_EraseRootFromParent_Done,
     /*  90750 */   // Label 1956: @90750
     /*  90750 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(90826), // Rule ID 3324 //
     /*  90755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90808 */     // (intrinsic_wo_chain:{ *:[i64] } 14817:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64_EVEX),
     /*  90811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90824 */     GIR_RootConstrainSelectedInstOperands,
     /*  90825 */     // GIR_Coverage, 3324,
     /*  90825 */     GIR_EraseRootFromParent_Done,
     /*  90826 */   // Label 1957: @90826
     /*  90826 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(90902), // Rule ID 3340 //
     /*  90831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  90839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90884 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13379:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrm),
     /*  90887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90900 */     GIR_RootConstrainSelectedInstOperands,
     /*  90901 */     // GIR_Coverage, 3340,
     /*  90901 */     GIR_EraseRootFromParent_Done,
     /*  90902 */   // Label 1958: @90902
     /*  90902 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(90978), // Rule ID 3342 //
     /*  90907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  90915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13382:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrm),
     /*  90963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90976 */     GIR_RootConstrainSelectedInstOperands,
     /*  90977 */     // GIR_Coverage, 3342,
     /*  90977 */     GIR_EraseRootFromParent_Done,
     /*  90978 */   // Label 1959: @90978
     /*  90978 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(91054), // Rule ID 3344 //
     /*  90983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  90991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91036 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13373:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrm),
     /*  91039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91052 */     GIR_RootConstrainSelectedInstOperands,
     /*  91053 */     // GIR_Coverage, 3344,
     /*  91053 */     GIR_EraseRootFromParent_Done,
     /*  91054 */   // Label 1960: @91054
     /*  91054 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(91130), // Rule ID 3346 //
     /*  91059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  91062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  91067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91112 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13376:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrm),
     /*  91115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91128 */     GIR_RootConstrainSelectedInstOperands,
     /*  91129 */     // GIR_Coverage, 3346,
     /*  91129 */     GIR_EraseRootFromParent_Done,
     /*  91130 */   // Label 1961: @91130
     /*  91130 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(91206), // Rule ID 3348 //
     /*  91135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91188 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13380:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrm),
     /*  91191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91204 */     GIR_RootConstrainSelectedInstOperands,
     /*  91205 */     // GIR_Coverage, 3348,
     /*  91205 */     GIR_EraseRootFromParent_Done,
     /*  91206 */   // Label 1962: @91206
     /*  91206 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(91282), // Rule ID 3350 //
     /*  91211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91264 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13383:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrm),
     /*  91267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91280 */     GIR_RootConstrainSelectedInstOperands,
     /*  91281 */     // GIR_Coverage, 3350,
     /*  91281 */     GIR_EraseRootFromParent_Done,
     /*  91282 */   // Label 1963: @91282
     /*  91282 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(91358), // Rule ID 3352 //
     /*  91287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  91295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91340 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13374:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrm),
     /*  91343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91356 */     GIR_RootConstrainSelectedInstOperands,
     /*  91357 */     // GIR_Coverage, 3352,
     /*  91357 */     GIR_EraseRootFromParent_Done,
     /*  91358 */   // Label 1964: @91358
     /*  91358 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(91434), // Rule ID 3354 //
     /*  91363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  91371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91416 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13377:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrm),
     /*  91419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91432 */     GIR_RootConstrainSelectedInstOperands,
     /*  91433 */     // GIR_Coverage, 3354,
     /*  91433 */     GIR_EraseRootFromParent_Done,
     /*  91434 */   // Label 1965: @91434
     /*  91434 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(91510), // Rule ID 3565 //
     /*  91439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  91447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rm),
     /*  91495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91508 */     GIR_RootConstrainSelectedInstOperands,
     /*  91509 */     // GIR_Coverage, 3565,
     /*  91509 */     GIR_EraseRootFromParent_Done,
     /*  91510 */   // Label 1966: @91510
     /*  91510 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(91586), // Rule ID 3567 //
     /*  91515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  91523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91568 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14990:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrm),
     /*  91571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91584 */     GIR_RootConstrainSelectedInstOperands,
     /*  91585 */     // GIR_Coverage, 3567,
     /*  91585 */     GIR_EraseRootFromParent_Done,
     /*  91586 */   // Label 1967: @91586
     /*  91586 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(91662), // Rule ID 3569 //
     /*  91591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  91599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91644 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rm),
     /*  91647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91660 */     GIR_RootConstrainSelectedInstOperands,
     /*  91661 */     // GIR_Coverage, 3569,
     /*  91661 */     GIR_EraseRootFromParent_Done,
     /*  91662 */   // Label 1968: @91662
     /*  91662 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(91738), // Rule ID 3571 //
     /*  91667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  91675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91720 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14993:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrm),
     /*  91723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91725 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91736 */     GIR_RootConstrainSelectedInstOperands,
     /*  91737 */     // GIR_Coverage, 3571,
     /*  91737 */     GIR_EraseRootFromParent_Done,
     /*  91738 */   // Label 1969: @91738
     /*  91738 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(91814), // Rule ID 14061 //
     /*  91743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  91751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13379:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rm),
     /*  91799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91812 */     GIR_RootConstrainSelectedInstOperands,
     /*  91813 */     // GIR_Coverage, 14061,
     /*  91813 */     GIR_EraseRootFromParent_Done,
     /*  91814 */   // Label 1970: @91814
     /*  91814 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(91890), // Rule ID 14063 //
     /*  91819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91872 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13380:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rm),
     /*  91875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91888 */     GIR_RootConstrainSelectedInstOperands,
     /*  91889 */     // GIR_Coverage, 14063,
     /*  91889 */     GIR_EraseRootFromParent_Done,
     /*  91890 */   // Label 1971: @91890
     /*  91890 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(91966), // Rule ID 14065 //
     /*  91895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  91903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91948 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13381:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrm),
     /*  91951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91964 */     GIR_RootConstrainSelectedInstOperands,
     /*  91965 */     // GIR_Coverage, 14065,
     /*  91965 */     GIR_EraseRootFromParent_Done,
     /*  91966 */   // Label 1972: @91966
     /*  91966 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(92042), // Rule ID 14067 //
     /*  91971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  91979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92024 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13382:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rm),
     /*  92027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92029 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92031 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92040 */     GIR_RootConstrainSelectedInstOperands,
     /*  92041 */     // GIR_Coverage, 14067,
     /*  92041 */     GIR_EraseRootFromParent_Done,
     /*  92042 */   // Label 1973: @92042
     /*  92042 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(92118), // Rule ID 14069 //
     /*  92047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  92055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92100 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13383:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rm),
     /*  92103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92116 */     GIR_RootConstrainSelectedInstOperands,
     /*  92117 */     // GIR_Coverage, 14069,
     /*  92117 */     GIR_EraseRootFromParent_Done,
     /*  92118 */   // Label 1974: @92118
     /*  92118 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(92194), // Rule ID 14071 //
     /*  92123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  92131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92176 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13384:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrm),
     /*  92179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92192 */     GIR_RootConstrainSelectedInstOperands,
     /*  92193 */     // GIR_Coverage, 14071,
     /*  92193 */     GIR_EraseRootFromParent_Done,
     /*  92194 */   // Label 1975: @92194
     /*  92194 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(92270), // Rule ID 14073 //
     /*  92199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  92207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92252 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13373:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rm),
     /*  92255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92268 */     GIR_RootConstrainSelectedInstOperands,
     /*  92269 */     // GIR_Coverage, 14073,
     /*  92269 */     GIR_EraseRootFromParent_Done,
     /*  92270 */   // Label 1976: @92270
     /*  92270 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(92346), // Rule ID 14075 //
     /*  92275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  92283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92328 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13374:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rm),
     /*  92331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92344 */     GIR_RootConstrainSelectedInstOperands,
     /*  92345 */     // GIR_Coverage, 14075,
     /*  92345 */     GIR_EraseRootFromParent_Done,
     /*  92346 */   // Label 1977: @92346
     /*  92346 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(92422), // Rule ID 14077 //
     /*  92351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  92359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92384 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92391 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92404 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13375:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrm),
     /*  92407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92420 */     GIR_RootConstrainSelectedInstOperands,
     /*  92421 */     // GIR_Coverage, 14077,
     /*  92421 */     GIR_EraseRootFromParent_Done,
     /*  92422 */   // Label 1978: @92422
     /*  92422 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(92498), // Rule ID 14079 //
     /*  92427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  92435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92480 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13376:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rm),
     /*  92483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92496 */     GIR_RootConstrainSelectedInstOperands,
     /*  92497 */     // GIR_Coverage, 14079,
     /*  92497 */     GIR_EraseRootFromParent_Done,
     /*  92498 */   // Label 1979: @92498
     /*  92498 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(92574), // Rule ID 14081 //
     /*  92503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  92511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92556 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13377:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rm),
     /*  92559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92572 */     GIR_RootConstrainSelectedInstOperands,
     /*  92573 */     // GIR_Coverage, 14081,
     /*  92573 */     GIR_EraseRootFromParent_Done,
     /*  92574 */   // Label 1980: @92574
     /*  92574 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(92650), // Rule ID 14083 //
     /*  92579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  92587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92619 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92632 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13378:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrm),
     /*  92635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92648 */     GIR_RootConstrainSelectedInstOperands,
     /*  92649 */     // GIR_Coverage, 14083,
     /*  92649 */     GIR_EraseRootFromParent_Done,
     /*  92650 */   // Label 1981: @92650
     /*  92650 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(92726), // Rule ID 16794 //
     /*  92655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  92663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92708 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14991:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrm),
     /*  92711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92713 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92724 */     GIR_RootConstrainSelectedInstOperands,
     /*  92725 */     // GIR_Coverage, 16794,
     /*  92725 */     GIR_EraseRootFromParent_Done,
     /*  92726 */   // Label 1982: @92726
     /*  92726 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(92802), // Rule ID 16800 //
     /*  92731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  92739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92771 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92784 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14994:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrm),
     /*  92787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92800 */     GIR_RootConstrainSelectedInstOperands,
     /*  92801 */     // GIR_Coverage, 16800,
     /*  92801 */     GIR_EraseRootFromParent_Done,
     /*  92802 */   // Label 1983: @92802
     /*  92802 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(92843), // Rule ID 3367 //
     /*  92807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  92810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92829 */     // MIs[0] src2
     /*  92829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13386:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /*  92835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92839 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92841 */     GIR_RootConstrainSelectedInstOperands,
     /*  92842 */     // GIR_Coverage, 3367,
     /*  92842 */     GIR_EraseRootFromParent_Done,
     /*  92843 */   // Label 1984: @92843
     /*  92843 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(92884), // Rule ID 3369 //
     /*  92848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  92851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92870 */     // MIs[0] src2
     /*  92870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92873 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13386:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /*  92876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92878 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92880 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92882 */     GIR_RootConstrainSelectedInstOperands,
     /*  92883 */     // GIR_Coverage, 3369,
     /*  92883 */     GIR_EraseRootFromParent_Done,
     /*  92884 */   // Label 1985: @92884
     /*  92884 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(92929), // Rule ID 16789 //
     /*  92889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  92897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92918 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /*  92921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92925 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92927 */     GIR_RootConstrainSelectedInstOperands,
     /*  92928 */     // GIR_Coverage, 16789,
     /*  92928 */     GIR_EraseRootFromParent_Done,
     /*  92929 */   // Label 1986: @92929
     /*  92929 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(92974), // Rule ID 16791 //
     /*  92934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  92942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92963 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14990:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /*  92966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92970 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92972 */     GIR_RootConstrainSelectedInstOperands,
     /*  92973 */     // GIR_Coverage, 16791,
     /*  92973 */     GIR_EraseRootFromParent_Done,
     /*  92974 */   // Label 1987: @92974
     /*  92974 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(93019), // Rule ID 16795 //
     /*  92979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  92987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93008 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  93008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /*  93011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93013 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93015 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93017 */     GIR_RootConstrainSelectedInstOperands,
     /*  93018 */     // GIR_Coverage, 16795,
     /*  93018 */     GIR_EraseRootFromParent_Done,
     /*  93019 */   // Label 1988: @93019
     /*  93019 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(93064), // Rule ID 16797 //
     /*  93024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  93027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  93032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93053 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14993:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  93053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /*  93056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93060 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93062 */     GIR_RootConstrainSelectedInstOperands,
     /*  93063 */     // GIR_Coverage, 16797,
     /*  93063 */     GIR_EraseRootFromParent_Done,
     /*  93064 */   // Label 1989: @93064
     /*  93064 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(93109), // Rule ID 3022 //
     /*  93069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93098 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14858:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /*  93101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93105 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93107 */     GIR_RootConstrainSelectedInstOperands,
     /*  93108 */     // GIR_Coverage, 3022,
     /*  93108 */     GIR_EraseRootFromParent_Done,
     /*  93109 */   // Label 1990: @93109
     /*  93109 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(93154), // Rule ID 3024 //
     /*  93114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93143 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14862:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /*  93146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93150 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93152 */     GIR_RootConstrainSelectedInstOperands,
     /*  93153 */     // GIR_Coverage, 3024,
     /*  93153 */     GIR_EraseRootFromParent_Done,
     /*  93154 */   // Label 1991: @93154
     /*  93154 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(93199), // Rule ID 3026 //
     /*  93159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93188 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14860:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /*  93191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93195 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93197 */     GIR_RootConstrainSelectedInstOperands,
     /*  93198 */     // GIR_Coverage, 3026,
     /*  93198 */     GIR_EraseRootFromParent_Done,
     /*  93199 */   // Label 1992: @93199
     /*  93199 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(93244), // Rule ID 3028 //
     /*  93204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93233 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14842:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /*  93236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93240 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93242 */     GIR_RootConstrainSelectedInstOperands,
     /*  93243 */     // GIR_Coverage, 3028,
     /*  93243 */     GIR_EraseRootFromParent_Done,
     /*  93244 */   // Label 1993: @93244
     /*  93244 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(93289), // Rule ID 3030 //
     /*  93249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93278 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14848:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /*  93281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93283 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93285 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93287 */     GIR_RootConstrainSelectedInstOperands,
     /*  93288 */     // GIR_Coverage, 3030,
     /*  93288 */     GIR_EraseRootFromParent_Done,
     /*  93289 */   // Label 1994: @93289
     /*  93289 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(93334), // Rule ID 3046 //
     /*  93294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  93302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  93305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  93308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  93311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93323 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13749:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  93323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /*  93326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93328 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93330 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93332 */     GIR_RootConstrainSelectedInstOperands,
     /*  93333 */     // GIR_Coverage, 3046,
     /*  93333 */     GIR_EraseRootFromParent_Done,
     /*  93334 */   // Label 1995: @93334
     /*  93334 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(93379), // Rule ID 3048 //
     /*  93339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  93347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93368 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13751:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /*  93371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93373 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93375 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93377 */     GIR_RootConstrainSelectedInstOperands,
     /*  93378 */     // GIR_Coverage, 3048,
     /*  93378 */     GIR_EraseRootFromParent_Done,
     /*  93379 */   // Label 1996: @93379
     /*  93379 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(93424), // Rule ID 3050 //
     /*  93384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  93392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93413 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13750:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  93413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /*  93416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93422 */     GIR_RootConstrainSelectedInstOperands,
     /*  93423 */     // GIR_Coverage, 3050,
     /*  93423 */     GIR_EraseRootFromParent_Done,
     /*  93424 */   // Label 1997: @93424
     /*  93424 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(93469), // Rule ID 3052 //
     /*  93429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  93437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93458 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13736:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /*  93461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93465 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93467 */     GIR_RootConstrainSelectedInstOperands,
     /*  93468 */     // GIR_Coverage, 3052,
     /*  93468 */     GIR_EraseRootFromParent_Done,
     /*  93469 */   // Label 1998: @93469
     /*  93469 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(93514), // Rule ID 3054 //
     /*  93474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  93482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93503 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13739:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /*  93506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93510 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93512 */     GIR_RootConstrainSelectedInstOperands,
     /*  93513 */     // GIR_Coverage, 3054,
     /*  93513 */     GIR_EraseRootFromParent_Done,
     /*  93514 */   // Label 1999: @93514
     /*  93514 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(93559), // Rule ID 3064 //
     /*  93519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93548 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14858:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /*  93551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93555 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93557 */     GIR_RootConstrainSelectedInstOperands,
     /*  93558 */     // GIR_Coverage, 3064,
     /*  93558 */     GIR_EraseRootFromParent_Done,
     /*  93559 */   // Label 2000: @93559
     /*  93559 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(93604), // Rule ID 3066 //
     /*  93564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93593 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14862:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /*  93596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93600 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93602 */     GIR_RootConstrainSelectedInstOperands,
     /*  93603 */     // GIR_Coverage, 3066,
     /*  93603 */     GIR_EraseRootFromParent_Done,
     /*  93604 */   // Label 2001: @93604
     /*  93604 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(93649), // Rule ID 3068 //
     /*  93609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93638 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14860:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /*  93641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93645 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93647 */     GIR_RootConstrainSelectedInstOperands,
     /*  93648 */     // GIR_Coverage, 3068,
     /*  93648 */     GIR_EraseRootFromParent_Done,
     /*  93649 */   // Label 2002: @93649
     /*  93649 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(93694), // Rule ID 3072 //
     /*  93654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93683 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14842:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /*  93686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93690 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93692 */     GIR_RootConstrainSelectedInstOperands,
     /*  93693 */     // GIR_Coverage, 3072,
     /*  93693 */     GIR_EraseRootFromParent_Done,
     /*  93694 */   // Label 2003: @93694
     /*  93694 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(93739), // Rule ID 3074 //
     /*  93699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93728 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14848:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /*  93731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93735 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93737 */     GIR_RootConstrainSelectedInstOperands,
     /*  93738 */     // GIR_Coverage, 3074,
     /*  93738 */     GIR_EraseRootFromParent_Done,
     /*  93739 */   // Label 2004: @93739
     /*  93739 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(93784), // Rule ID 3309 //
     /*  93744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93773 */     // (intrinsic_wo_chain:{ *:[i32] } 14816:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /*  93776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93778 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93782 */     GIR_RootConstrainSelectedInstOperands,
     /*  93783 */     // GIR_Coverage, 3309,
     /*  93783 */     GIR_EraseRootFromParent_Done,
     /*  93784 */   // Label 2005: @93784
     /*  93784 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(93829), // Rule ID 3311 //
     /*  93789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93818 */     // (intrinsic_wo_chain:{ *:[i32] } 14814:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /*  93821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93825 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93827 */     GIR_RootConstrainSelectedInstOperands,
     /*  93828 */     // GIR_Coverage, 3311,
     /*  93828 */     GIR_EraseRootFromParent_Done,
     /*  93829 */   // Label 2006: @93829
     /*  93829 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(93874), // Rule ID 3313 //
     /*  93834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93863 */     // (intrinsic_wo_chain:{ *:[i32] } 14815:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /*  93866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93870 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93872 */     GIR_RootConstrainSelectedInstOperands,
     /*  93873 */     // GIR_Coverage, 3313,
     /*  93873 */     GIR_EraseRootFromParent_Done,
     /*  93874 */   // Label 2007: @93874
     /*  93874 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(93919), // Rule ID 3315 //
     /*  93879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93908 */     // (intrinsic_wo_chain:{ *:[i64] } 14817:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /*  93911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93915 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93917 */     GIR_RootConstrainSelectedInstOperands,
     /*  93918 */     // GIR_Coverage, 3315,
     /*  93918 */     GIR_EraseRootFromParent_Done,
     /*  93919 */   // Label 2008: @93919
     /*  93919 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(93964), // Rule ID 3317 //
     /*  93924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93953 */     // (intrinsic_wo_chain:{ *:[i32] } 14816:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /*  93956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93960 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93962 */     GIR_RootConstrainSelectedInstOperands,
     /*  93963 */     // GIR_Coverage, 3317,
     /*  93963 */     GIR_EraseRootFromParent_Done,
     /*  93964 */   // Label 2009: @93964
     /*  93964 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(94009), // Rule ID 3319 //
     /*  93969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93998 */     // (intrinsic_wo_chain:{ *:[i32] } 14814:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /*  94001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94005 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94007 */     GIR_RootConstrainSelectedInstOperands,
     /*  94008 */     // GIR_Coverage, 3319,
     /*  94008 */     GIR_EraseRootFromParent_Done,
     /*  94009 */   // Label 2010: @94009
     /*  94009 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(94054), // Rule ID 3321 //
     /*  94014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  94017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  94022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94043 */     // (intrinsic_wo_chain:{ *:[i32] } 14815:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  94043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /*  94046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94050 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94052 */     GIR_RootConstrainSelectedInstOperands,
     /*  94053 */     // GIR_Coverage, 3321,
     /*  94053 */     GIR_EraseRootFromParent_Done,
     /*  94054 */   // Label 2011: @94054
     /*  94054 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(94099), // Rule ID 3323 //
     /*  94059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  94062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  94067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  94073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  94076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94088 */     // (intrinsic_wo_chain:{ *:[i64] } 14817:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  94088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /*  94091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94095 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94097 */     GIR_RootConstrainSelectedInstOperands,
     /*  94098 */     // GIR_Coverage, 3323,
     /*  94098 */     GIR_EraseRootFromParent_Done,
     /*  94099 */   // Label 2012: @94099
     /*  94099 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(94144), // Rule ID 3327 //
     /*  94104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /*  94112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94133 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14686:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /*  94136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94140 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94142 */     GIR_RootConstrainSelectedInstOperands,
     /*  94143 */     // GIR_Coverage, 3327,
     /*  94143 */     GIR_EraseRootFromParent_Done,
     /*  94144 */   // Label 2013: @94144
     /*  94144 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(94189), // Rule ID 3329 //
     /*  94149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /*  94157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14684:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94183 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94185 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94187 */     GIR_RootConstrainSelectedInstOperands,
     /*  94188 */     // GIR_Coverage, 3329,
     /*  94188 */     GIR_EraseRootFromParent_Done,
     /*  94189 */   // Label 2014: @94189
     /*  94189 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(94234), // Rule ID 3331 //
     /*  94194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /*  94202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94223 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14685:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /*  94226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94228 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94230 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94232 */     GIR_RootConstrainSelectedInstOperands,
     /*  94233 */     // GIR_Coverage, 3331,
     /*  94233 */     GIR_EraseRootFromParent_Done,
     /*  94234 */   // Label 2015: @94234
     /*  94234 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(94279), // Rule ID 3335 //
     /*  94239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /*  94247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94268 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14688:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /*  94271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94273 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94275 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94277 */     GIR_RootConstrainSelectedInstOperands,
     /*  94278 */     // GIR_Coverage, 3335,
     /*  94278 */     GIR_EraseRootFromParent_Done,
     /*  94279 */   // Label 2016: @94279
     /*  94279 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(94324), // Rule ID 3337 //
     /*  94284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /*  94292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14689:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /*  94316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94320 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94322 */     GIR_RootConstrainSelectedInstOperands,
     /*  94323 */     // GIR_Coverage, 3337,
     /*  94323 */     GIR_EraseRootFromParent_Done,
     /*  94324 */   // Label 2017: @94324
     /*  94324 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(94369), // Rule ID 3339 //
     /*  94329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94358 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13379:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /*  94361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94367 */     GIR_RootConstrainSelectedInstOperands,
     /*  94368 */     // GIR_Coverage, 3339,
     /*  94368 */     GIR_EraseRootFromParent_Done,
     /*  94369 */   // Label 2018: @94369
     /*  94369 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(94414), // Rule ID 3341 //
     /*  94374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94403 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13382:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /*  94406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94410 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94412 */     GIR_RootConstrainSelectedInstOperands,
     /*  94413 */     // GIR_Coverage, 3341,
     /*  94413 */     GIR_EraseRootFromParent_Done,
     /*  94414 */   // Label 2019: @94414
     /*  94414 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(94459), // Rule ID 3343 //
     /*  94419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94448 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13373:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /*  94451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94455 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94457 */     GIR_RootConstrainSelectedInstOperands,
     /*  94458 */     // GIR_Coverage, 3343,
     /*  94458 */     GIR_EraseRootFromParent_Done,
     /*  94459 */   // Label 2020: @94459
     /*  94459 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(94504), // Rule ID 3345 //
     /*  94464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94493 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13376:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /*  94496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94500 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94502 */     GIR_RootConstrainSelectedInstOperands,
     /*  94503 */     // GIR_Coverage, 3345,
     /*  94503 */     GIR_EraseRootFromParent_Done,
     /*  94504 */   // Label 2021: @94504
     /*  94504 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(94549), // Rule ID 3347 //
     /*  94509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  94517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94538 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13380:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /*  94541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94545 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94547 */     GIR_RootConstrainSelectedInstOperands,
     /*  94548 */     // GIR_Coverage, 3347,
     /*  94548 */     GIR_EraseRootFromParent_Done,
     /*  94549 */   // Label 2022: @94549
     /*  94549 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(94594), // Rule ID 3349 //
     /*  94554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  94562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94583 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13383:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /*  94586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94588 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94590 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94592 */     GIR_RootConstrainSelectedInstOperands,
     /*  94593 */     // GIR_Coverage, 3349,
     /*  94593 */     GIR_EraseRootFromParent_Done,
     /*  94594 */   // Label 2023: @94594
     /*  94594 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(94639), // Rule ID 3351 //
     /*  94599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  94607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94628 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13374:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /*  94631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94635 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94637 */     GIR_RootConstrainSelectedInstOperands,
     /*  94638 */     // GIR_Coverage, 3351,
     /*  94638 */     GIR_EraseRootFromParent_Done,
     /*  94639 */   // Label 2024: @94639
     /*  94639 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(94684), // Rule ID 3353 //
     /*  94644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  94652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94673 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13377:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /*  94676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94680 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94682 */     GIR_RootConstrainSelectedInstOperands,
     /*  94683 */     // GIR_Coverage, 3353,
     /*  94683 */     GIR_EraseRootFromParent_Done,
     /*  94684 */   // Label 2025: @94684
     /*  94684 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(94729), // Rule ID 3355 //
     /*  94689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94718 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13379:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /*  94721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94727 */     GIR_RootConstrainSelectedInstOperands,
     /*  94728 */     // GIR_Coverage, 3355,
     /*  94728 */     GIR_EraseRootFromParent_Done,
     /*  94729 */   // Label 2026: @94729
     /*  94729 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(94774), // Rule ID 3357 //
     /*  94734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94763 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13382:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /*  94766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94768 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94770 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94772 */     GIR_RootConstrainSelectedInstOperands,
     /*  94773 */     // GIR_Coverage, 3357,
     /*  94773 */     GIR_EraseRootFromParent_Done,
     /*  94774 */   // Label 2027: @94774
     /*  94774 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(94819), // Rule ID 3359 //
     /*  94779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94808 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13373:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /*  94811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94817 */     GIR_RootConstrainSelectedInstOperands,
     /*  94818 */     // GIR_Coverage, 3359,
     /*  94818 */     GIR_EraseRootFromParent_Done,
     /*  94819 */   // Label 2028: @94819
     /*  94819 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(94864), // Rule ID 3361 //
     /*  94824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94853 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13376:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /*  94856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94860 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94862 */     GIR_RootConstrainSelectedInstOperands,
     /*  94863 */     // GIR_Coverage, 3361,
     /*  94863 */     GIR_EraseRootFromParent_Done,
     /*  94864 */   // Label 2029: @94864
     /*  94864 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(94909), // Rule ID 3378 //
     /*  94869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /*  94877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94898 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14832:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /*  94898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /*  94901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94905 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94907 */     GIR_RootConstrainSelectedInstOperands,
     /*  94908 */     // GIR_Coverage, 3378,
     /*  94908 */     GIR_EraseRootFromParent_Done,
     /*  94909 */   // Label 2030: @94909
     /*  94909 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(94954), // Rule ID 3380 //
     /*  94914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /*  94922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94943 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14834:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /*  94943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /*  94946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94950 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94952 */     GIR_RootConstrainSelectedInstOperands,
     /*  94953 */     // GIR_Coverage, 3380,
     /*  94953 */     GIR_EraseRootFromParent_Done,
     /*  94954 */   // Label 2031: @94954
     /*  94954 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(94999), // Rule ID 3555 //
     /*  94959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /*  94967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94988 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14983:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /*  94991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94995 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94997 */     GIR_RootConstrainSelectedInstOperands,
     /*  94998 */     // GIR_Coverage, 3555,
     /*  94998 */     GIR_EraseRootFromParent_Done,
     /*  94999 */   // Label 2032: @94999
     /*  94999 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(95044), // Rule ID 3556 //
     /*  95004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  95007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /*  95012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95033 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14984:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  95033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /*  95036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95040 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95042 */     GIR_RootConstrainSelectedInstOperands,
     /*  95043 */     // GIR_Coverage, 3556,
     /*  95043 */     GIR_EraseRootFromParent_Done,
     /*  95044 */   // Label 2033: @95044
     /*  95044 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(95089), // Rule ID 3564 //
     /*  95049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  95057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95078 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14989:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  95078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /*  95081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95083 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95085 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95087 */     GIR_RootConstrainSelectedInstOperands,
     /*  95088 */     // GIR_Coverage, 3564,
     /*  95088 */     GIR_EraseRootFromParent_Done,
     /*  95089 */   // Label 2034: @95089
     /*  95089 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(95134), // Rule ID 3566 //
     /*  95094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  95102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95123 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14990:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /*  95126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95132 */     GIR_RootConstrainSelectedInstOperands,
     /*  95133 */     // GIR_Coverage, 3566,
     /*  95133 */     GIR_EraseRootFromParent_Done,
     /*  95134 */   // Label 2035: @95134
     /*  95134 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(95179), // Rule ID 3568 //
     /*  95139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  95147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95168 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14992:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  95168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /*  95171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95175 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95177 */     GIR_RootConstrainSelectedInstOperands,
     /*  95178 */     // GIR_Coverage, 3568,
     /*  95178 */     GIR_EraseRootFromParent_Done,
     /*  95179 */   // Label 2036: @95179
     /*  95179 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(95224), // Rule ID 3570 //
     /*  95184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  95192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95213 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14993:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /*  95216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95222 */     GIR_RootConstrainSelectedInstOperands,
     /*  95223 */     // GIR_Coverage, 3570,
     /*  95223 */     GIR_EraseRootFromParent_Done,
     /*  95224 */   // Label 2037: @95224
     /*  95224 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(95269), // Rule ID 14060 //
     /*  95229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  95237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95258 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13379:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /*  95261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95265 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95267 */     GIR_RootConstrainSelectedInstOperands,
     /*  95268 */     // GIR_Coverage, 14060,
     /*  95268 */     GIR_EraseRootFromParent_Done,
     /*  95269 */   // Label 2038: @95269
     /*  95269 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(95314), // Rule ID 14062 //
     /*  95274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  95282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95303 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13380:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /*  95306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95308 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95310 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95312 */     GIR_RootConstrainSelectedInstOperands,
     /*  95313 */     // GIR_Coverage, 14062,
     /*  95313 */     GIR_EraseRootFromParent_Done,
     /*  95314 */   // Label 2039: @95314
     /*  95314 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(95359), // Rule ID 14064 //
     /*  95319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  95327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95348 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13381:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /*  95351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95355 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95357 */     GIR_RootConstrainSelectedInstOperands,
     /*  95358 */     // GIR_Coverage, 14064,
     /*  95358 */     GIR_EraseRootFromParent_Done,
     /*  95359 */   // Label 2040: @95359
     /*  95359 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(95404), // Rule ID 14066 //
     /*  95364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  95372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95393 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13382:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /*  95396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95402 */     GIR_RootConstrainSelectedInstOperands,
     /*  95403 */     // GIR_Coverage, 14066,
     /*  95403 */     GIR_EraseRootFromParent_Done,
     /*  95404 */   // Label 2041: @95404
     /*  95404 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(95449), // Rule ID 14068 //
     /*  95409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  95417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95438 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13383:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /*  95441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95443 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95445 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95447 */     GIR_RootConstrainSelectedInstOperands,
     /*  95448 */     // GIR_Coverage, 14068,
     /*  95448 */     GIR_EraseRootFromParent_Done,
     /*  95449 */   // Label 2042: @95449
     /*  95449 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(95494), // Rule ID 14070 //
     /*  95454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  95462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95483 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13384:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /*  95486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95490 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95492 */     GIR_RootConstrainSelectedInstOperands,
     /*  95493 */     // GIR_Coverage, 14070,
     /*  95493 */     GIR_EraseRootFromParent_Done,
     /*  95494 */   // Label 2043: @95494
     /*  95494 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(95539), // Rule ID 14072 //
     /*  95499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  95507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95528 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13373:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /*  95531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95535 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95537 */     GIR_RootConstrainSelectedInstOperands,
     /*  95538 */     // GIR_Coverage, 14072,
     /*  95538 */     GIR_EraseRootFromParent_Done,
     /*  95539 */   // Label 2044: @95539
     /*  95539 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(95584), // Rule ID 14074 //
     /*  95544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  95552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95573 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13374:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /*  95576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95578 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95580 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95582 */     GIR_RootConstrainSelectedInstOperands,
     /*  95583 */     // GIR_Coverage, 14074,
     /*  95583 */     GIR_EraseRootFromParent_Done,
     /*  95584 */   // Label 2045: @95584
     /*  95584 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(95629), // Rule ID 14076 //
     /*  95589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  95597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95618 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13375:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /*  95621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95625 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95627 */     GIR_RootConstrainSelectedInstOperands,
     /*  95628 */     // GIR_Coverage, 14076,
     /*  95628 */     GIR_EraseRootFromParent_Done,
     /*  95629 */   // Label 2046: @95629
     /*  95629 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(95674), // Rule ID 14078 //
     /*  95634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  95642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95663 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13376:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /*  95666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95668 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95672 */     GIR_RootConstrainSelectedInstOperands,
     /*  95673 */     // GIR_Coverage, 14078,
     /*  95673 */     GIR_EraseRootFromParent_Done,
     /*  95674 */   // Label 2047: @95674
     /*  95674 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(95719), // Rule ID 14080 //
     /*  95679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  95687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95708 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13377:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /*  95711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95713 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95715 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95717 */     GIR_RootConstrainSelectedInstOperands,
     /*  95718 */     // GIR_Coverage, 14080,
     /*  95718 */     GIR_EraseRootFromParent_Done,
     /*  95719 */   // Label 2048: @95719
     /*  95719 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(95764), // Rule ID 14082 //
     /*  95724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  95732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95753 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13378:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /*  95756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95760 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95762 */     GIR_RootConstrainSelectedInstOperands,
     /*  95763 */     // GIR_Coverage, 14082,
     /*  95763 */     GIR_EraseRootFromParent_Done,
     /*  95764 */   // Label 2049: @95764
     /*  95764 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(95809), // Rule ID 16793 //
     /*  95769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  95777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95798 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14991:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /*  95801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95807 */     GIR_RootConstrainSelectedInstOperands,
     /*  95808 */     // GIR_Coverage, 16793,
     /*  95808 */     GIR_EraseRootFromParent_Done,
     /*  95809 */   // Label 2050: @95809
     /*  95809 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(95854), // Rule ID 16799 //
     /*  95814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  95822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95843 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14994:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /*  95846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95852 */     GIR_RootConstrainSelectedInstOperands,
     /*  95853 */     // GIR_Coverage, 16799,
     /*  95853 */     GIR_EraseRootFromParent_Done,
     /*  95854 */   // Label 2051: @95854
     /*  95854 */   GIM_Reject,
     /*  95855 */ // Label 1934: @95855
     /*  95855 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(100441),
     /*  95860 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  95863 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(95944), // Rule ID 23534 //
     /*  95868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95912 */     // MIs[0] src3
     /*  95912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95924 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14801:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95929 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95935 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95942 */     GIR_RootConstrainSelectedInstOperands,
     /*  95943 */     // GIR_Coverage, 23534,
     /*  95943 */     GIR_EraseRootFromParent_Done,
     /*  95944 */   // Label 2053: @95944
     /*  95944 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(96025), // Rule ID 23535 //
     /*  95949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95993 */     // MIs[0] src3
     /*  95993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96005 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14800:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96016 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96023 */     GIR_RootConstrainSelectedInstOperands,
     /*  96024 */     // GIR_Coverage, 23535,
     /*  96024 */     GIR_EraseRootFromParent_Done,
     /*  96025 */   // Label 2054: @96025
     /*  96025 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(96106), // Rule ID 23536 //
     /*  96030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96074 */     // MIs[0] src3
     /*  96074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96086 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13411:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96091 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96097 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96104 */     GIR_RootConstrainSelectedInstOperands,
     /*  96105 */     // GIR_Coverage, 23536,
     /*  96105 */     GIR_EraseRootFromParent_Done,
     /*  96106 */   // Label 2055: @96106
     /*  96106 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(96187), // Rule ID 3254 //
     /*  96111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  96119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96155 */     // MIs[0] src3
     /*  96155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96167 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14801:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  96170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96172 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96178 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96185 */     GIR_RootConstrainSelectedInstOperands,
     /*  96186 */     // GIR_Coverage, 3254,
     /*  96186 */     GIR_EraseRootFromParent_Done,
     /*  96187 */   // Label 2056: @96187
     /*  96187 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(96268), // Rule ID 3256 //
     /*  96192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  96200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96225 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96236 */     // MIs[0] src3
     /*  96236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96248 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14800:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96259 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96266 */     GIR_RootConstrainSelectedInstOperands,
     /*  96267 */     // GIR_Coverage, 3256,
     /*  96267 */     GIR_EraseRootFromParent_Done,
     /*  96268 */   // Label 2057: @96268
     /*  96268 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(96349), // Rule ID 3258 //
     /*  96273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96317 */     // MIs[0] src3
     /*  96317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96329 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13411:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96340 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96347 */     GIR_RootConstrainSelectedInstOperands,
     /*  96348 */     // GIR_Coverage, 3258,
     /*  96348 */     GIR_EraseRootFromParent_Done,
     /*  96349 */   // Label 2058: @96349
     /*  96349 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(96430), // Rule ID 3374 //
     /*  96354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  96357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96398 */     // MIs[0] src3
     /*  96398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96410 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14652:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrmi:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrmi),
     /*  96413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96421 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96428 */     GIR_RootConstrainSelectedInstOperands,
     /*  96429 */     // GIR_Coverage, 3374,
     /*  96429 */     GIR_EraseRootFromParent_Done,
     /*  96430 */   // Label 2059: @96430
     /*  96430 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(96511), // Rule ID 3376 //
     /*  96435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  96438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96468 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96479 */     // MIs[0] src3
     /*  96479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96491 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14653:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrmi:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrmi),
     /*  96494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96502 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96509 */     GIR_RootConstrainSelectedInstOperands,
     /*  96510 */     // GIR_Coverage, 3376,
     /*  96510 */     GIR_EraseRootFromParent_Done,
     /*  96511 */   // Label 2060: @96511
     /*  96511 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(96592), // Rule ID 14085 //
     /*  96516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  96519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  96524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  96527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  96530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  96533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96556 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96560 */     // MIs[0] src3
     /*  96560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96572 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14654:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrmi:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrmi),
     /*  96575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96583 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96590 */     GIR_RootConstrainSelectedInstOperands,
     /*  96591 */     // GIR_Coverage, 14085,
     /*  96591 */     GIR_EraseRootFromParent_Done,
     /*  96592 */   // Label 2061: @96592
     /*  96592 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(96673), // Rule ID 14087 //
     /*  96597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96641 */     // MIs[0] src3
     /*  96641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96653 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14652:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rmi:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rmi),
     /*  96656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96664 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96671 */     GIR_RootConstrainSelectedInstOperands,
     /*  96672 */     // GIR_Coverage, 14087,
     /*  96672 */     GIR_EraseRootFromParent_Done,
     /*  96673 */   // Label 2062: @96673
     /*  96673 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(96754), // Rule ID 14089 //
     /*  96678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96722 */     // MIs[0] src3
     /*  96722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96734 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14653:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rmi:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rmi),
     /*  96737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96745 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96752 */     GIR_RootConstrainSelectedInstOperands,
     /*  96753 */     // GIR_Coverage, 14089,
     /*  96753 */     GIR_EraseRootFromParent_Done,
     /*  96754 */   // Label 2063: @96754
     /*  96754 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(96839), // Rule ID 23336 //
     /*  96759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  96767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96791 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96794 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96798 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96819 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15046:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  96822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96824 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96830 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96837 */     GIR_RootConstrainSelectedInstOperands,
     /*  96838 */     // GIR_Coverage, 23336,
     /*  96838 */     GIR_EraseRootFromParent_Done,
     /*  96839 */   // Label 2064: @96839
     /*  96839 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(96924), // Rule ID 23337 //
     /*  96844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  96852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15045:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  96907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96909 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96915 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96922 */     GIR_RootConstrainSelectedInstOperands,
     /*  96923 */     // GIR_Coverage, 23337,
     /*  96923 */     GIR_EraseRootFromParent_Done,
     /*  96924 */   // Label 2065: @96924
     /*  96924 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(97009), // Rule ID 23338 //
     /*  96929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  96937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96961 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96964 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96968 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96989 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15044:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  96992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96994 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97000 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97007 */     GIR_RootConstrainSelectedInstOperands,
     /*  97008 */     // GIR_Coverage, 23338,
     /*  97008 */     GIR_EraseRootFromParent_Done,
     /*  97009 */   // Label 2066: @97009
     /*  97009 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(97094), // Rule ID 23339 //
     /*  97014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  97022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97046 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97074 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15043:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  97077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97079 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97085 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97092 */     GIR_RootConstrainSelectedInstOperands,
     /*  97093 */     // GIR_Coverage, 23339,
     /*  97093 */     GIR_EraseRootFromParent_Done,
     /*  97094 */   // Label 2067: @97094
     /*  97094 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(97179), // Rule ID 23340 //
     /*  97099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  97107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97159 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15042:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  97162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97164 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97170 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97177 */     GIR_RootConstrainSelectedInstOperands,
     /*  97178 */     // GIR_Coverage, 23340,
     /*  97178 */     GIR_EraseRootFromParent_Done,
     /*  97179 */   // Label 2068: @97179
     /*  97179 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(97264), // Rule ID 23341 //
     /*  97184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  97192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15041:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  97247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97249 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97255 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97262 */     GIR_RootConstrainSelectedInstOperands,
     /*  97263 */     // GIR_Coverage, 23341,
     /*  97263 */     GIR_EraseRootFromParent_Done,
     /*  97264 */   // Label 2069: @97264
     /*  97264 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(97349), // Rule ID 23342 //
     /*  97269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  97277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97329 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15040:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  97332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97334 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97340 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97347 */     GIR_RootConstrainSelectedInstOperands,
     /*  97348 */     // GIR_Coverage, 23342,
     /*  97348 */     GIR_EraseRootFromParent_Done,
     /*  97349 */   // Label 2070: @97349
     /*  97349 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(97434), // Rule ID 23343 //
     /*  97354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  97362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97414 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15039:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  97417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97419 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97425 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97432 */     GIR_RootConstrainSelectedInstOperands,
     /*  97433 */     // GIR_Coverage, 23343,
     /*  97433 */     GIR_EraseRootFromParent_Done,
     /*  97434 */   // Label 2071: @97434
     /*  97434 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(97519), // Rule ID 23344 //
     /*  97439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  97447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97499 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15038:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  97502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97504 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97506 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97510 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97517 */     GIR_RootConstrainSelectedInstOperands,
     /*  97518 */     // GIR_Coverage, 23344,
     /*  97518 */     GIR_EraseRootFromParent_Done,
     /*  97519 */   // Label 2072: @97519
     /*  97519 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(97604), // Rule ID 23345 //
     /*  97524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  97532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97584 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15037:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  97587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97589 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97595 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97602 */     GIR_RootConstrainSelectedInstOperands,
     /*  97603 */     // GIR_Coverage, 23345,
     /*  97603 */     GIR_EraseRootFromParent_Done,
     /*  97604 */   // Label 2073: @97604
     /*  97604 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(97689), // Rule ID 23346 //
     /*  97609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  97617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97669 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15036:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  97672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97674 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97680 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97687 */     GIR_RootConstrainSelectedInstOperands,
     /*  97688 */     // GIR_Coverage, 23346,
     /*  97688 */     GIR_EraseRootFromParent_Done,
     /*  97689 */   // Label 2074: @97689
     /*  97689 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(97774), // Rule ID 23347 //
     /*  97694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  97702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97726 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97733 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15035:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  97757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97759 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97765 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97772 */     GIR_RootConstrainSelectedInstOperands,
     /*  97773 */     // GIR_Coverage, 23347,
     /*  97773 */     GIR_EraseRootFromParent_Done,
     /*  97774 */   // Label 2075: @97774
     /*  97774 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(97859), // Rule ID 1620 //
     /*  97779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  97787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15046:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  97842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97850 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97857 */     GIR_RootConstrainSelectedInstOperands,
     /*  97858 */     // GIR_Coverage, 1620,
     /*  97858 */     GIR_EraseRootFromParent_Done,
     /*  97859 */   // Label 2076: @97859
     /*  97859 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(97944), // Rule ID 1622 //
     /*  97864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  97872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15045:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  97927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97935 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97942 */     GIR_RootConstrainSelectedInstOperands,
     /*  97943 */     // GIR_Coverage, 1622,
     /*  97943 */     GIR_EraseRootFromParent_Done,
     /*  97944 */   // Label 2077: @97944
     /*  97944 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(98029), // Rule ID 1624 //
     /*  97949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  97957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98009 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15044:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  98009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  98012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98020 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98027 */     GIR_RootConstrainSelectedInstOperands,
     /*  98028 */     // GIR_Coverage, 1624,
     /*  98028 */     GIR_EraseRootFromParent_Done,
     /*  98029 */   // Label 2078: @98029
     /*  98029 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(98114), // Rule ID 1626 //
     /*  98034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  98042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15043:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  98097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98105 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98112 */     GIR_RootConstrainSelectedInstOperands,
     /*  98113 */     // GIR_Coverage, 1626,
     /*  98113 */     GIR_EraseRootFromParent_Done,
     /*  98114 */   // Label 2079: @98114
     /*  98114 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(98199), // Rule ID 1628 //
     /*  98119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  98127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  98130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  98139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98179 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15042:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  98179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  98182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98184 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98190 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98197 */     GIR_RootConstrainSelectedInstOperands,
     /*  98198 */     // GIR_Coverage, 1628,
     /*  98198 */     GIR_EraseRootFromParent_Done,
     /*  98199 */   // Label 2080: @98199
     /*  98199 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(98284), // Rule ID 1630 //
     /*  98204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  98212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15041:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  98267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98275 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98282 */     GIR_RootConstrainSelectedInstOperands,
     /*  98283 */     // GIR_Coverage, 1630,
     /*  98283 */     GIR_EraseRootFromParent_Done,
     /*  98284 */   // Label 2081: @98284
     /*  98284 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(98369), // Rule ID 1632 //
     /*  98289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  98297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98349 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15040:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  98352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98360 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98367 */     GIR_RootConstrainSelectedInstOperands,
     /*  98368 */     // GIR_Coverage, 1632,
     /*  98368 */     GIR_EraseRootFromParent_Done,
     /*  98369 */   // Label 2082: @98369
     /*  98369 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(98454), // Rule ID 1634 //
     /*  98374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  98382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98434 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15039:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  98437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98445 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98452 */     GIR_RootConstrainSelectedInstOperands,
     /*  98453 */     // GIR_Coverage, 1634,
     /*  98453 */     GIR_EraseRootFromParent_Done,
     /*  98454 */   // Label 2083: @98454
     /*  98454 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(98539), // Rule ID 1636 //
     /*  98459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  98467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98519 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15038:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  98522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98530 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98537 */     GIR_RootConstrainSelectedInstOperands,
     /*  98538 */     // GIR_Coverage, 1636,
     /*  98538 */     GIR_EraseRootFromParent_Done,
     /*  98539 */   // Label 2084: @98539
     /*  98539 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(98624), // Rule ID 1638 //
     /*  98544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  98552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98604 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15037:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  98607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98615 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98622 */     GIR_RootConstrainSelectedInstOperands,
     /*  98623 */     // GIR_Coverage, 1638,
     /*  98623 */     GIR_EraseRootFromParent_Done,
     /*  98624 */   // Label 2085: @98624
     /*  98624 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(98709), // Rule ID 1640 //
     /*  98629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  98637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98689 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15036:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  98692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98700 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98707 */     GIR_RootConstrainSelectedInstOperands,
     /*  98708 */     // GIR_Coverage, 1640,
     /*  98708 */     GIR_EraseRootFromParent_Done,
     /*  98709 */   // Label 2086: @98709
     /*  98709 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(98794), // Rule ID 1642 //
     /*  98714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  98722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98774 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15035:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  98777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98785 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98792 */     GIR_RootConstrainSelectedInstOperands,
     /*  98793 */     // GIR_Coverage, 1642,
     /*  98793 */     GIR_EraseRootFromParent_Done,
     /*  98794 */   // Label 2087: @98794
     /*  98794 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(98879), // Rule ID 3559 //
     /*  98799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  98807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98859 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14986:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG1rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rm),
     /*  98862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98866 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98877 */     GIR_RootConstrainSelectedInstOperands,
     /*  98878 */     // GIR_Coverage, 3559,
     /*  98878 */     GIR_EraseRootFromParent_Done,
     /*  98879 */   // Label 2088: @98879
     /*  98879 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(98964), // Rule ID 3561 //
     /*  98884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  98892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98944 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14987:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG2rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rm),
     /*  98947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98951 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98962 */     GIR_RootConstrainSelectedInstOperands,
     /*  98963 */     // GIR_Coverage, 3561,
     /*  98963 */     GIR_EraseRootFromParent_Done,
     /*  98964 */   // Label 2089: @98964
     /*  98964 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(99014), // Rule ID 3253 //
     /*  98969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98998 */     // MIs[0] src3
     /*  98998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99001 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14801:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /*  99004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99010 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99012 */     GIR_RootConstrainSelectedInstOperands,
     /*  99013 */     // GIR_Coverage, 3253,
     /*  99013 */     GIR_EraseRootFromParent_Done,
     /*  99014 */   // Label 2090: @99014
     /*  99014 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(99064), // Rule ID 3255 //
     /*  99019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  99022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  99027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99048 */     // MIs[0] src3
     /*  99048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99051 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14800:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /*  99054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99058 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99060 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99062 */     GIR_RootConstrainSelectedInstOperands,
     /*  99063 */     // GIR_Coverage, 3255,
     /*  99063 */     GIR_EraseRootFromParent_Done,
     /*  99064 */   // Label 2091: @99064
     /*  99064 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(99114), // Rule ID 3257 //
     /*  99069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  99072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  99077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  99080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  99083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  99086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99098 */     // MIs[0] src3
     /*  99098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99101 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13411:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /*  99104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99108 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99110 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99112 */     GIR_RootConstrainSelectedInstOperands,
     /*  99113 */     // GIR_Coverage, 3257,
     /*  99113 */     GIR_EraseRootFromParent_Done,
     /*  99114 */   // Label 2092: @99114
     /*  99114 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(99164), // Rule ID 3263 //
     /*  99119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  99122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  99127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99148 */     // MIs[0] src3
     /*  99148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99151 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14801:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /*  99154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99158 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99160 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99162 */     GIR_RootConstrainSelectedInstOperands,
     /*  99163 */     // GIR_Coverage, 3263,
     /*  99163 */     GIR_EraseRootFromParent_Done,
     /*  99164 */   // Label 2093: @99164
     /*  99164 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(99214), // Rule ID 3265 //
     /*  99169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  99172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  99177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99198 */     // MIs[0] src3
     /*  99198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99201 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14800:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /*  99204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99206 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99208 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99210 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99212 */     GIR_RootConstrainSelectedInstOperands,
     /*  99213 */     // GIR_Coverage, 3265,
     /*  99213 */     GIR_EraseRootFromParent_Done,
     /*  99214 */   // Label 2094: @99214
     /*  99214 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(99264), // Rule ID 3325 //
     /*  99219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  99222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /*  99227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99248 */     // MIs[0] src3
     /*  99248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99251 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14687:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /*  99254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99258 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99260 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99262 */     GIR_RootConstrainSelectedInstOperands,
     /*  99263 */     // GIR_Coverage, 3325,
     /*  99263 */     GIR_EraseRootFromParent_Done,
     /*  99264 */   // Label 2095: @99264
     /*  99264 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(99314), // Rule ID 3371 //
     /*  99269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /*  99272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99298 */     // MIs[0] src3
     /*  99298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14652:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /*  99304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99306 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99308 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99310 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99312 */     GIR_RootConstrainSelectedInstOperands,
     /*  99313 */     // GIR_Coverage, 3371,
     /*  99313 */     GIR_EraseRootFromParent_Done,
     /*  99314 */   // Label 2096: @99314
     /*  99314 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(99364), // Rule ID 3373 //
     /*  99319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  99322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99348 */     // MIs[0] src3
     /*  99348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99351 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14652:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /*  99354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99358 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99360 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99362 */     GIR_RootConstrainSelectedInstOperands,
     /*  99363 */     // GIR_Coverage, 3373,
     /*  99363 */     GIR_EraseRootFromParent_Done,
     /*  99364 */   // Label 2097: @99364
     /*  99364 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(99414), // Rule ID 3375 //
     /*  99369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  99372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99398 */     // MIs[0] src3
     /*  99398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99401 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14653:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /*  99404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99408 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99410 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99412 */     GIR_RootConstrainSelectedInstOperands,
     /*  99413 */     // GIR_Coverage, 3375,
     /*  99413 */     GIR_EraseRootFromParent_Done,
     /*  99414 */   // Label 2098: @99414
     /*  99414 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(99464), // Rule ID 14084 //
     /*  99419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  99422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  99427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  99430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  99433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  99436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99448 */     // MIs[0] src3
     /*  99448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99451 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14654:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /*  99454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99456 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99458 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99460 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99462 */     GIR_RootConstrainSelectedInstOperands,
     /*  99463 */     // GIR_Coverage, 14084,
     /*  99463 */     GIR_EraseRootFromParent_Done,
     /*  99464 */   // Label 2099: @99464
     /*  99464 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(99514), // Rule ID 14086 //
     /*  99469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99498 */     // MIs[0] src3
     /*  99498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99501 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14652:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /*  99504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99510 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99512 */     GIR_RootConstrainSelectedInstOperands,
     /*  99513 */     // GIR_Coverage, 14086,
     /*  99513 */     GIR_EraseRootFromParent_Done,
     /*  99514 */   // Label 2100: @99514
     /*  99514 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(99564), // Rule ID 14088 //
     /*  99519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99548 */     // MIs[0] src3
     /*  99548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99551 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14653:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /*  99554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99558 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99560 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99562 */     GIR_RootConstrainSelectedInstOperands,
     /*  99563 */     // GIR_Coverage, 14088,
     /*  99563 */     GIR_EraseRootFromParent_Done,
     /*  99564 */   // Label 2101: @99564
     /*  99564 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(99618), // Rule ID 1619 //
     /*  99569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  99577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99605 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15046:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /*  99608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99612 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99614 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99616 */     GIR_RootConstrainSelectedInstOperands,
     /*  99617 */     // GIR_Coverage, 1619,
     /*  99617 */     GIR_EraseRootFromParent_Done,
     /*  99618 */   // Label 2102: @99618
     /*  99618 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(99672), // Rule ID 1621 //
     /*  99623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  99631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99659 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15045:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /*  99662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99666 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99668 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99670 */     GIR_RootConstrainSelectedInstOperands,
     /*  99671 */     // GIR_Coverage, 1621,
     /*  99671 */     GIR_EraseRootFromParent_Done,
     /*  99672 */   // Label 2103: @99672
     /*  99672 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(99726), // Rule ID 1623 //
     /*  99677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  99685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99713 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15044:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  99716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99720 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99722 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99724 */     GIR_RootConstrainSelectedInstOperands,
     /*  99725 */     // GIR_Coverage, 1623,
     /*  99725 */     GIR_EraseRootFromParent_Done,
     /*  99726 */   // Label 2104: @99726
     /*  99726 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(99780), // Rule ID 1625 //
     /*  99731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  99739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99767 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15043:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /*  99770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99774 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99776 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99778 */     GIR_RootConstrainSelectedInstOperands,
     /*  99779 */     // GIR_Coverage, 1625,
     /*  99779 */     GIR_EraseRootFromParent_Done,
     /*  99780 */   // Label 2105: @99780
     /*  99780 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(99834), // Rule ID 1627 //
     /*  99785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  99793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99821 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15042:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /*  99824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99830 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99832 */     GIR_RootConstrainSelectedInstOperands,
     /*  99833 */     // GIR_Coverage, 1627,
     /*  99833 */     GIR_EraseRootFromParent_Done,
     /*  99834 */   // Label 2106: @99834
     /*  99834 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(99888), // Rule ID 1629 //
     /*  99839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  99847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99875 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15041:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /*  99878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99882 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99884 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99886 */     GIR_RootConstrainSelectedInstOperands,
     /*  99887 */     // GIR_Coverage, 1629,
     /*  99887 */     GIR_EraseRootFromParent_Done,
     /*  99888 */   // Label 2107: @99888
     /*  99888 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(99942), // Rule ID 1631 //
     /*  99893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  99901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99929 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15040:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /*  99932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99938 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99940 */     GIR_RootConstrainSelectedInstOperands,
     /*  99941 */     // GIR_Coverage, 1631,
     /*  99941 */     GIR_EraseRootFromParent_Done,
     /*  99942 */   // Label 2108: @99942
     /*  99942 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(99996), // Rule ID 1633 //
     /*  99947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  99955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99983 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15039:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /*  99986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99990 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99992 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99994 */     GIR_RootConstrainSelectedInstOperands,
     /*  99995 */     // GIR_Coverage, 1633,
     /*  99995 */     GIR_EraseRootFromParent_Done,
     /*  99996 */   // Label 2109: @99996
     /*  99996 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(100050), // Rule ID 1635 //
     /* 100001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /* 100009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100037 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15038:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /* 100040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100044 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100046 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100048 */     GIR_RootConstrainSelectedInstOperands,
     /* 100049 */     // GIR_Coverage, 1635,
     /* 100049 */     GIR_EraseRootFromParent_Done,
     /* 100050 */   // Label 2110: @100050
     /* 100050 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(100104), // Rule ID 1637 //
     /* 100055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /* 100063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 100066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100091 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15037:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /* 100094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100098 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100100 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100102 */     GIR_RootConstrainSelectedInstOperands,
     /* 100103 */     // GIR_Coverage, 1637,
     /* 100103 */     GIR_EraseRootFromParent_Done,
     /* 100104 */   // Label 2111: @100104
     /* 100104 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(100158), // Rule ID 1639 //
     /* 100109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /* 100117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 100120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100145 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15036:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /* 100148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100152 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100154 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100156 */     GIR_RootConstrainSelectedInstOperands,
     /* 100157 */     // GIR_Coverage, 1639,
     /* 100157 */     GIR_EraseRootFromParent_Done,
     /* 100158 */   // Label 2112: @100158
     /* 100158 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(100212), // Rule ID 1641 //
     /* 100163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /* 100171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100199 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15035:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /* 100202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100206 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100208 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100210 */     GIR_RootConstrainSelectedInstOperands,
     /* 100211 */     // GIR_Coverage, 1641,
     /* 100211 */     GIR_EraseRootFromParent_Done,
     /* 100212 */   // Label 2113: @100212
     /* 100212 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(100278), // Rule ID 3333 //
     /* 100217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 100220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 100225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100253 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14690:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 100253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100257 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 100267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 100270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100274 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100276 */     GIR_RootConstrainSelectedInstOperands,
     /* 100277 */     // GIR_Coverage, 3333,
     /* 100277 */     GIR_EraseRootFromParent_Done,
     /* 100278 */   // Label 2114: @100278
     /* 100278 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(100332), // Rule ID 3557 //
     /* 100283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 100286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 100291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 100294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 100297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 100300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100319 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14985:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 100322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100326 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100328 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100330 */     GIR_RootConstrainSelectedInstOperands,
     /* 100331 */     // GIR_Coverage, 3557,
     /* 100331 */     GIR_EraseRootFromParent_Done,
     /* 100332 */   // Label 2115: @100332
     /* 100332 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(100386), // Rule ID 3558 //
     /* 100337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 100345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100373 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14986:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 100376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100380 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100382 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100384 */     GIR_RootConstrainSelectedInstOperands,
     /* 100385 */     // GIR_Coverage, 3558,
     /* 100385 */     GIR_EraseRootFromParent_Done,
     /* 100386 */   // Label 2116: @100386
     /* 100386 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(100440), // Rule ID 3560 //
     /* 100391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 100399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14987:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 100430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100434 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100436 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100438 */     GIR_RootConstrainSelectedInstOperands,
     /* 100439 */     // GIR_Coverage, 3560,
     /* 100439 */     GIR_EraseRootFromParent_Done,
     /* 100440 */   // Label 2117: @100440
     /* 100440 */   GIM_Reject,
     /* 100441 */ // Label 2052: @100441
     /* 100441 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(100570),
     /* 100446 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 100449 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 100454 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100463 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100478 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(100539), // Rule ID 3563 //
     /* 100483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 100490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100505 */     // MIs[0] src4
     /* 100505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100517 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14988:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rmi:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rmi),
     /* 100520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100524 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 100530 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100537 */     GIR_RootConstrainSelectedInstOperands,
     /* 100538 */     // GIR_Coverage, 3563,
     /* 100538 */     GIR_EraseRootFromParent_Done,
     /* 100539 */   // Label 2119: @100539
     /* 100539 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(100569), // Rule ID 3562 //
     /* 100544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100551 */     // MIs[0] src4
     /* 100551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100554 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14988:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rri),
     /* 100557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100561 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100563 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100565 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100567 */     GIR_RootConstrainSelectedInstOperands,
     /* 100568 */     // GIR_Coverage, 3562,
     /* 100568 */     GIR_EraseRootFromParent_Done,
     /* 100569 */   // Label 2120: @100569
     /* 100569 */   GIM_Reject,
     /* 100570 */ // Label 2118: @100570
     /* 100570 */ GIM_Reject,
     /* 100571 */ // Label 18: @100571
     /* 100571 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(101130),
     /* 100576 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 100579 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(100601), // Rule ID 149 //
     /* 100584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 100587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 100592 */     // (intrinsic_void 14682:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 100592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 100595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100599 */     GIR_RootConstrainSelectedInstOperands,
     /* 100600 */     // GIR_Coverage, 149,
     /* 100600 */     GIR_EraseRootFromParent_Done,
     /* 100601 */   // Label 2122: @100601
     /* 100601 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(100623), // Rule ID 150 //
     /* 100606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 100614 */     // (intrinsic_void 15070:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 100614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 100617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100621 */     GIR_RootConstrainSelectedInstOperands,
     /* 100622 */     // GIR_Coverage, 150,
     /* 100622 */     GIR_EraseRootFromParent_Done,
     /* 100623 */   // Label 2123: @100623
     /* 100623 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(100645), // Rule ID 151 //
     /* 100628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 100636 */     // (intrinsic_void 15056:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 100636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 100639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100643 */     GIR_RootConstrainSelectedInstOperands,
     /* 100644 */     // GIR_Coverage, 151,
     /* 100644 */     GIR_EraseRootFromParent_Done,
     /* 100645 */   // Label 2124: @100645
     /* 100645 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(100667), // Rule ID 152 //
     /* 100650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 100658 */     // (intrinsic_void 14540:{ *:[iPTR] })  =>  (CLUI)
     /* 100658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 100661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100665 */     GIR_RootConstrainSelectedInstOperands,
     /* 100666 */     // GIR_Coverage, 152,
     /* 100666 */     GIR_EraseRootFromParent_Done,
     /* 100667 */   // Label 2125: @100667
     /* 100667 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(100689), // Rule ID 153 //
     /* 100672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 100680 */     // (intrinsic_void 14864:{ *:[iPTR] })  =>  (STUI)
     /* 100680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 100683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100687 */     GIR_RootConstrainSelectedInstOperands,
     /* 100688 */     // GIR_Coverage, 153,
     /* 100688 */     GIR_EraseRootFromParent_Done,
     /* 100689 */   // Label 2126: @100689
     /* 100689 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(100708), // Rule ID 2510 //
     /* 100694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 100699 */     // (intrinsic_void 14759:{ *:[iPTR] })  =>  (PAUSE)
     /* 100699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 100702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100706 */     GIR_RootConstrainSelectedInstOperands,
     /* 100707 */     // GIR_Coverage, 2510,
     /* 100707 */     GIR_EraseRootFromParent_Done,
     /* 100708 */   // Label 2127: @100708
     /* 100708 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(100730), // Rule ID 2511 //
     /* 100713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 100716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 100721 */     // (intrinsic_void 14721:{ *:[iPTR] })  =>  (SFENCE)
     /* 100721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 100724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100728 */     GIR_RootConstrainSelectedInstOperands,
     /* 100729 */     // GIR_Coverage, 2511,
     /* 100729 */     GIR_EraseRootFromParent_Done,
     /* 100730 */   // Label 2128: @100730
     /* 100730 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(100752), // Rule ID 2512 //
     /* 100735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 100738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 100743 */     // (intrinsic_void 14748:{ *:[iPTR] })  =>  (LFENCE)
     /* 100743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 100746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100750 */     GIR_RootConstrainSelectedInstOperands,
     /* 100751 */     // GIR_Coverage, 2512,
     /* 100751 */     GIR_EraseRootFromParent_Done,
     /* 100752 */   // Label 2129: @100752
     /* 100752 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(100774), // Rule ID 2513 //
     /* 100757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 100760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 100765 */     // (intrinsic_void 14752:{ *:[iPTR] })  =>  (MFENCE)
     /* 100765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 100768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100772 */     GIR_RootConstrainSelectedInstOperands,
     /* 100773 */     // GIR_Coverage, 2513,
     /* 100773 */     GIR_EraseRootFromParent_Done,
     /* 100774 */   // Label 2130: @100774
     /* 100774 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(100840), // Rule ID 3427 //
     /* 100779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 100787 */     // (intrinsic_void 13454:{ *:[iPTR] })  =>  (VZEROALL)
     /* 100787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 100790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100838 */     GIR_RootConstrainSelectedInstOperands,
     /* 100839 */     // GIR_Coverage, 3427,
     /* 100839 */     GIR_EraseRootFromParent_Done,
     /* 100840 */   // Label 2131: @100840
     /* 100840 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(100906), // Rule ID 3428 //
     /* 100845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 100853 */     // (intrinsic_void 13455:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 100853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 100856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100904 */     GIR_RootConstrainSelectedInstOperands,
     /* 100905 */     // GIR_Coverage, 3428,
     /* 100905 */     GIR_EraseRootFromParent_Done,
     /* 100906 */   // Label 2132: @100906
     /* 100906 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(100976), // Rule ID 16802 //
     /* 100911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 100914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 100919 */     // (intrinsic_void 14575:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 100919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 100922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 100925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 100928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 100931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 100934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 100937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 100940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 100943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 100946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 100949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 100952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 100955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 100958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 100961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 100964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 100967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 100970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100974 */     GIR_RootConstrainSelectedInstOperands,
     /* 100975 */     // GIR_Coverage, 16802,
     /* 100975 */     GIR_EraseRootFromParent_Done,
     /* 100976 */   // Label 2133: @100976
     /* 100976 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(100998), // Rule ID 16985 //
     /* 100981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 100984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 100989 */     // (intrinsic_void 15008:{ *:[iPTR] })  =>  (XEND)
     /* 100989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 100992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100996 */     GIR_RootConstrainSelectedInstOperands,
     /* 100997 */     // GIR_Coverage, 16985,
     /* 100997 */     GIR_EraseRootFromParent_Done,
     /* 100998 */   // Label 2134: @100998
     /* 100998 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(101044), // Rule ID 16997 //
     /* 101003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 101006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 101011 */     // (intrinsic_void 14934:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 101011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 101014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101042 */     GIR_RootConstrainSelectedInstOperands,
     /* 101043 */     // GIR_Coverage, 16997,
     /* 101043 */     GIR_EraseRootFromParent_Done,
     /* 101044 */   // Label 2135: @101044
     /* 101044 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(101063), // Rule ID 17086 //
     /* 101049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 101054 */     // (intrinsic_void 14995:{ *:[iPTR] })  =>  (WBINVD)
     /* 101054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 101057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101061 */     GIR_RootConstrainSelectedInstOperands,
     /* 101062 */     // GIR_Coverage, 17086,
     /* 101062 */     GIR_EraseRootFromParent_Done,
     /* 101063 */   // Label 2136: @101063
     /* 101063 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(101085), // Rule ID 17087 //
     /* 101068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 101071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 101076 */     // (intrinsic_void 14996:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 101076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 101079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101083 */     GIR_RootConstrainSelectedInstOperands,
     /* 101084 */     // GIR_Coverage, 17087,
     /* 101084 */     GIR_EraseRootFromParent_Done,
     /* 101085 */   // Label 2137: @101085
     /* 101085 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(101107), // Rule ID 17092 //
     /* 101090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 101095 */     // (intrinsic_void 14677:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 101095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 101098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101105 */     GIR_RootConstrainSelectedInstOperands,
     /* 101106 */     // GIR_Coverage, 17092,
     /* 101106 */     GIR_EraseRootFromParent_Done,
     /* 101107 */   // Label 2138: @101107
     /* 101107 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(101129), // Rule ID 17102 //
     /* 101112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 101117 */     // (intrinsic_void 14683:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 101117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 101120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101127 */     GIR_RootConstrainSelectedInstOperands,
     /* 101128 */     // GIR_Coverage, 17102,
     /* 101128 */     GIR_EraseRootFromParent_Done,
     /* 101129 */   // Label 2139: @101129
     /* 101129 */   GIM_Reject,
     /* 101130 */ // Label 2121: @101130
     /* 101130 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(103018),
     /* 101135 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 101138 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(101196), // Rule ID 17130 //
     /* 101143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 101146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 101151 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 101169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101182 */     // (intrinsic_void 14657:{ *:[iPTR] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (PTWRITE64m addr:{ *:[iPTR] }:$dst)
     /* 101182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64m),
     /* 101185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101194 */     GIR_RootConstrainSelectedInstOperands,
     /* 101195 */     // GIR_Coverage, 17130,
     /* 101195 */     GIR_EraseRootFromParent_Done,
     /* 101196 */   // Label 2141: @101196
     /* 101196 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(101254), // Rule ID 17129 //
     /* 101201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 101204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 101209 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101220 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101227 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 101231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101240 */     // (intrinsic_void 14656:{ *:[iPTR] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (PTWRITEm addr:{ *:[iPTR] }:$dst)
     /* 101240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEm),
     /* 101243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101252 */     GIR_RootConstrainSelectedInstOperands,
     /* 101253 */     // GIR_Coverage, 17129,
     /* 101253 */     GIR_EraseRootFromParent_Done,
     /* 101254 */   // Label 2142: @101254
     /* 101254 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(101291), // Rule ID 162 //
     /* 101259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSHOPT),
     /* 101262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clflushopt),
     /* 101267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101278 */     // (intrinsic_void 14538:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSHOPT addr:{ *:[iPTR] }:$src)
     /* 101278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSHOPT),
     /* 101281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101289 */     GIR_RootConstrainSelectedInstOperands,
     /* 101290 */     // GIR_Coverage, 162,
     /* 101290 */     GIR_EraseRootFromParent_Done,
     /* 101291 */   // Label 2143: @101291
     /* 101291 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(101328), // Rule ID 163 //
     /* 101296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLWB),
     /* 101299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clwb),
     /* 101304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101315 */     // (intrinsic_void 14541:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLWB addr:{ *:[iPTR] }:$src)
     /* 101315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLWB),
     /* 101318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101326 */     GIR_RootConstrainSelectedInstOperands,
     /* 101327 */     // GIR_Coverage, 163,
     /* 101327 */     GIR_EraseRootFromParent_Done,
     /* 101328 */   // Label 2144: @101328
     /* 101328 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(101365), // Rule ID 164 //
     /* 101333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLDEMOTE),
     /* 101336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_cldemote),
     /* 101341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101352 */     // (intrinsic_void 14537:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLDEMOTE addr:{ *:[iPTR] }:$src)
     /* 101352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLDEMOTE),
     /* 101355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101363 */     GIR_RootConstrainSelectedInstOperands,
     /* 101364 */     // GIR_Coverage, 164,
     /* 101364 */     GIR_EraseRootFromParent_Done,
     /* 101365 */   // Label 2145: @101365
     /* 101365 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(101402), // Rule ID 169 //
     /* 101370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS),
     /* 101373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_prefetchrs),
     /* 101378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101389 */     // (intrinsic_void 14655:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (PREFETCHRST2 addr:{ *:[iPTR] }:$src)
     /* 101389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHRST2),
     /* 101392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101400 */     GIR_RootConstrainSelectedInstOperands,
     /* 101401 */     // GIR_Coverage, 169,
     /* 101401 */     GIR_EraseRootFromParent_Done,
     /* 101402 */   // Label 2146: @101402
     /* 101402 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(101439), // Rule ID 1133 //
     /* 101407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave),
     /* 101415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101426 */     // (intrinsic_void 14561:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE addr:{ *:[iPTR] }:$dst)
     /* 101426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE),
     /* 101429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101437 */     GIR_RootConstrainSelectedInstOperands,
     /* 101438 */     // GIR_Coverage, 1133,
     /* 101438 */     GIR_EraseRootFromParent_Done,
     /* 101439 */   // Label 2147: @101439
     /* 101439 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(101476), // Rule ID 1134 //
     /* 101444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave64),
     /* 101452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101463 */     // (intrinsic_void 14562:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 101463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE64),
     /* 101466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101474 */     GIR_RootConstrainSelectedInstOperands,
     /* 101475 */     // GIR_Coverage, 1134,
     /* 101475 */     GIR_EraseRootFromParent_Done,
     /* 101476 */   // Label 2148: @101476
     /* 101476 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(101519), // Rule ID 1135 //
     /* 101481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor),
     /* 101489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101500 */     // (intrinsic_void 14559:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR),
     /* 101503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101517 */     GIR_RootConstrainSelectedInstOperands,
     /* 101518 */     // GIR_Coverage, 1135,
     /* 101518 */     GIR_EraseRootFromParent_Done,
     /* 101519 */   // Label 2149: @101519
     /* 101519 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(101562), // Rule ID 1136 //
     /* 101524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor64),
     /* 101532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101543 */     // (intrinsic_void 14560:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR64:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR64),
     /* 101546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101560 */     GIR_RootConstrainSelectedInstOperands,
     /* 101561 */     // GIR_Coverage, 1136,
     /* 101561 */     GIR_EraseRootFromParent_Done,
     /* 101562 */   // Label 2150: @101562
     /* 101562 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(101599), // Rule ID 2509 //
     /* 101567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSH),
     /* 101570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_clflush),
     /* 101575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101586 */     // (intrinsic_void 14729:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSH addr:{ *:[iPTR] }:$src)
     /* 101586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSH),
     /* 101589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101597 */     GIR_RootConstrainSelectedInstOperands,
     /* 101598 */     // GIR_Coverage, 2509,
     /* 101598 */     GIR_EraseRootFromParent_Done,
     /* 101599 */   // Label 2151: @101599
     /* 101599 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(101639), // Rule ID 2514 //
     /* 101604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101623 */     // (intrinsic_void 14710:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDMXCSR),
     /* 101626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101637 */     GIR_RootConstrainSelectedInstOperands,
     /* 101638 */     // GIR_Coverage, 2514,
     /* 101638 */     GIR_EraseRootFromParent_Done,
     /* 101639 */   // Label 2152: @101639
     /* 101639 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(101676), // Rule ID 2515 //
     /* 101644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101663 */     // (intrinsic_void 14722:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (VSTMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSTMXCSR),
     /* 101666 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101674 */     GIR_RootConstrainSelectedInstOperands,
     /* 101675 */     // GIR_Coverage, 2515,
     /* 101675 */     GIR_EraseRootFromParent_Done,
     /* 101676 */   // Label 2153: @101676
     /* 101676 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(101713), // Rule ID 2516 //
     /* 101681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101697 */     // (intrinsic_void 14710:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDMXCSR),
     /* 101700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101711 */     GIR_RootConstrainSelectedInstOperands,
     /* 101712 */     // GIR_Coverage, 2516,
     /* 101712 */     GIR_EraseRootFromParent_Done,
     /* 101713 */   // Label 2154: @101713
     /* 101713 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(101747), // Rule ID 2517 //
     /* 101718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101734 */     // (intrinsic_void 14722:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (STMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STMXCSR),
     /* 101737 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101745 */     GIR_RootConstrainSelectedInstOperands,
     /* 101746 */     // GIR_Coverage, 2517,
     /* 101746 */     GIR_EraseRootFromParent_Done,
     /* 101747 */   // Label 2155: @101747
     /* 101747 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(101808), // Rule ID 16993 //
     /* 101752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101771 */     // (intrinsic_void 14567:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG),
     /* 101774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101806 */     GIR_RootConstrainSelectedInstOperands,
     /* 101807 */     // GIR_Coverage, 16993,
     /* 101807 */     GIR_EraseRootFromParent_Done,
     /* 101808 */   // Label 2156: @101808
     /* 101808 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(101845), // Rule ID 16994 //
     /* 101813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101832 */     // (intrinsic_void 14863:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG addr:{ *:[iPTR] }:$src)
     /* 101832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG),
     /* 101835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101843 */     GIR_RootConstrainSelectedInstOperands,
     /* 101844 */     // GIR_Coverage, 16994,
     /* 101844 */     GIR_EraseRootFromParent_Done,
     /* 101845 */   // Label 2157: @101845
     /* 101845 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(101906), // Rule ID 16995 //
     /* 101850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101869 */     // (intrinsic_void 14567:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG_EVEX:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG_EVEX),
     /* 101872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101904 */     GIR_RootConstrainSelectedInstOperands,
     /* 101905 */     // GIR_Coverage, 16995,
     /* 101905 */     GIR_EraseRootFromParent_Done,
     /* 101906 */   // Label 2158: @101906
     /* 101906 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(101943), // Rule ID 16996 //
     /* 101911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101930 */     // (intrinsic_void 14863:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG_EVEX addr:{ *:[iPTR] }:$src)
     /* 101930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG_EVEX),
     /* 101933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101941 */     GIR_RootConstrainSelectedInstOperands,
     /* 101942 */     // GIR_Coverage, 16996,
     /* 101942 */     GIR_EraseRootFromParent_Done,
     /* 101943 */   // Label 2159: @101943
     /* 101943 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(101980), // Rule ID 17093 //
     /* 101948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_rstorssp),
     /* 101953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101964 */     // (intrinsic_void 14676:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (RSTORSSP addr:{ *:[iPTR] }:$src)
     /* 101964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSTORSSP),
     /* 101967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101978 */     GIR_RootConstrainSelectedInstOperands,
     /* 101979 */     // GIR_Coverage, 17093,
     /* 101979 */     GIR_EraseRootFromParent_Done,
     /* 101980 */   // Label 2160: @101980
     /* 101980 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(102017), // Rule ID 17103 //
     /* 101985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clrssbsy),
     /* 101990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102001 */     // (intrinsic_void 14539:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLRSSBSY addr:{ *:[iPTR] }:$src)
     /* 102001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLRSSBSY),
     /* 102004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102015 */     GIR_RootConstrainSelectedInstOperands,
     /* 102016 */     // GIR_Coverage, 17103,
     /* 102016 */     GIR_EraseRootFromParent_Done,
     /* 102017 */   // Label 2161: @102017
     /* 102017 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(102047), // Rule ID 17075 //
     /* 102022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 102027 */     // MIs[0] Operand 1
     /* 102027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 102038 */     // (intrinsic_void 14565:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 102038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 102041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102045 */     GIR_RootConstrainSelectedInstOperands,
     /* 102046 */     // GIR_Coverage, 17075,
     /* 102046 */     GIR_EraseRootFromParent_Done,
     /* 102047 */   // Label 2162: @102047
     /* 102047 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(102074), // Rule ID 16987 //
     /* 102052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 102060 */     // MIs[0] imm
     /* 102060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102063 */     // (intrinsic_void 15006:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 102063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 102066 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 102068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102072 */     GIR_RootConstrainSelectedInstOperands,
     /* 102073 */     // GIR_Coverage, 16987,
     /* 102073 */     GIR_EraseRootFromParent_Done,
     /* 102074 */   // Label 2163: @102074
     /* 102074 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(102101), // Rule ID 16999 //
     /* 102079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 102082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 102087 */     // MIs[0] src
     /* 102087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102090 */     // (intrinsic_void 14937:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 102090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 102093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102099 */     GIR_RootConstrainSelectedInstOperands,
     /* 102100 */     // GIR_Coverage, 16999,
     /* 102100 */     GIR_EraseRootFromParent_Done,
     /* 102101 */   // Label 2164: @102101
     /* 102101 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(102125), // Rule ID 17077 //
     /* 102106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 102111 */     // MIs[0] trap
     /* 102111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102114 */     // (intrinsic_void 14565:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 102114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 102117 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 102119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102123 */     GIR_RootConstrainSelectedInstOperands,
     /* 102124 */     // GIR_Coverage, 17077,
     /* 102124 */     GIR_EraseRootFromParent_Done,
     /* 102125 */   // Label 2165: @102125
     /* 102125 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(102159), // Rule ID 1 //
     /* 102130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 102138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102145 */     // (intrinsic_w_chain:{ *:[i32] } 14551:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 102145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 102148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102157 */     GIR_RootConstrainSelectedInstOperands,
     /* 102158 */     // GIR_Coverage, 1,
     /* 102158 */     GIR_EraseRootFromParent_Done,
     /* 102159 */   // Label 2166: @102159
     /* 102159 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(102193), // Rule ID 2 //
     /* 102164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 102172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102179 */     // (intrinsic_w_chain:{ *:[i64] } 14552:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 102179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 102182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102191 */     GIR_RootConstrainSelectedInstOperands,
     /* 102192 */     // GIR_Coverage, 2,
     /* 102192 */     GIR_EraseRootFromParent_Done,
     /* 102193 */   // Label 2167: @102193
     /* 102193 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(102224), // Rule ID 115 //
     /* 102198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102213 */     // (intrinsic_w_chain:{ *:[i32] } 14691:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 102213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 102216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102222 */     GIR_RootConstrainSelectedInstOperands,
     /* 102223 */     // GIR_Coverage, 115,
     /* 102223 */     GIR_EraseRootFromParent_Done,
     /* 102224 */   // Label 2168: @102224
     /* 102224 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(102255), // Rule ID 117 //
     /* 102229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102244 */     // (intrinsic_w_chain:{ *:[i64] } 14691:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 102244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 102247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102253 */     GIR_RootConstrainSelectedInstOperands,
     /* 102254 */     // GIR_Coverage, 117,
     /* 102254 */     GIR_EraseRootFromParent_Done,
     /* 102255 */   // Label 2169: @102255
     /* 102255 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(102286), // Rule ID 16984 //
     /* 102260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 102268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102275 */     // (intrinsic_w_chain:{ *:[i32] } 15007:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 102275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 102278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102284 */     GIR_RootConstrainSelectedInstOperands,
     /* 102285 */     // GIR_Coverage, 16984,
     /* 102285 */     GIR_EraseRootFromParent_Done,
     /* 102286 */   // Label 2170: @102286
     /* 102286 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(102317), // Rule ID 17119 //
     /* 102291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 102299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102306 */     // (intrinsic_w_chain:{ *:[i32] } 14658:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 102306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 102309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102315 */     GIR_RootConstrainSelectedInstOperands,
     /* 102316 */     // GIR_Coverage, 17119,
     /* 102316 */     GIR_EraseRootFromParent_Done,
     /* 102317 */   // Label 2171: @102317
     /* 102317 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(102348), // Rule ID 17120 //
     /* 102322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 102330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102337 */     // (intrinsic_w_chain:{ *:[i64] } 14659:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 102337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 102340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102346 */     GIR_RootConstrainSelectedInstOperands,
     /* 102347 */     // GIR_Coverage, 17120,
     /* 102347 */     GIR_EraseRootFromParent_Done,
     /* 102348 */   // Label 2172: @102348
     /* 102348 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(102379), // Rule ID 17121 //
     /* 102353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 102361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102368 */     // (intrinsic_w_chain:{ *:[i32] } 14660:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 102368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 102371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102377 */     GIR_RootConstrainSelectedInstOperands,
     /* 102378 */     // GIR_Coverage, 17121,
     /* 102378 */     GIR_EraseRootFromParent_Done,
     /* 102379 */   // Label 2173: @102379
     /* 102379 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(102410), // Rule ID 17122 //
     /* 102384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 102392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102399 */     // (intrinsic_w_chain:{ *:[i64] } 14661:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 102399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 102402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102408 */     GIR_RootConstrainSelectedInstOperands,
     /* 102409 */     // GIR_Coverage, 17122,
     /* 102409 */     GIR_EraseRootFromParent_Done,
     /* 102410 */   // Label 2174: @102410
     /* 102410 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(102441), // Rule ID 17128 //
     /* 102415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 102418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102430 */     // (intrinsic_w_chain:{ *:[i32] } 14662:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 102430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 102433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102439 */     GIR_RootConstrainSelectedInstOperands,
     /* 102440 */     // GIR_Coverage, 17128,
     /* 102440 */     GIR_EraseRootFromParent_Done,
     /* 102441 */   // Label 2175: @102441
     /* 102441 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(102498), // Rule ID 22381 //
     /* 102446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 102449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102461 */     // (intrinsic_w_chain:{ *:[i32] } 14662:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 102461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 102468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 102487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 102492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 102497 */     // GIR_Coverage, 22381,
     /* 102497 */     GIR_EraseRootFromParent_Done,
     /* 102498 */   // Label 2176: @102498
     /* 102498 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(102538), // Rule ID 3 //
     /* 102503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 102511 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102518 */     // (intrinsic_void 14553:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 102518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 102521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102536 */     GIR_RootConstrainSelectedInstOperands,
     /* 102537 */     // GIR_Coverage, 3,
     /* 102537 */     GIR_EraseRootFromParent_Done,
     /* 102538 */   // Label 2177: @102538
     /* 102538 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(102578), // Rule ID 4 //
     /* 102543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 102551 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102558 */     // (intrinsic_void 14554:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 102558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 102561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 102566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102576 */     GIR_RootConstrainSelectedInstOperands,
     /* 102577 */     // GIR_Coverage, 4,
     /* 102577 */     GIR_EraseRootFromParent_Done,
     /* 102578 */   // Label 2178: @102578
     /* 102578 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(102609), // Rule ID 154 //
     /* 102583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 102586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 102591 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102598 */     // (intrinsic_void 14681:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 102598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 102601 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 102603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102607 */     GIR_RootConstrainSelectedInstOperands,
     /* 102608 */     // GIR_Coverage, 154,
     /* 102608 */     GIR_EraseRootFromParent_Done,
     /* 102609 */   // Label 2179: @102609
     /* 102609 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(102640), // Rule ID 17088 //
     /* 102614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 102619 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102626 */     // (intrinsic_void 14563:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 102626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 102629 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102638 */     GIR_RootConstrainSelectedInstOperands,
     /* 102639 */     // GIR_Coverage, 17088,
     /* 102639 */     GIR_EraseRootFromParent_Done,
     /* 102640 */   // Label 2180: @102640
     /* 102640 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(102671), // Rule ID 17089 //
     /* 102645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 102650 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102657 */     // (intrinsic_void 14564:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 102657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 102660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102669 */     GIR_RootConstrainSelectedInstOperands,
     /* 102670 */     // GIR_Coverage, 17089,
     /* 102670 */     GIR_EraseRootFromParent_Done,
     /* 102671 */   // Label 2181: @102671
     /* 102671 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(102702), // Rule ID 17123 //
     /* 102676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 102684 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102691 */     // (intrinsic_void 14997:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 102691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 102694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102700 */     GIR_RootConstrainSelectedInstOperands,
     /* 102701 */     // GIR_Coverage, 17123,
     /* 102701 */     GIR_EraseRootFromParent_Done,
     /* 102702 */   // Label 2182: @102702
     /* 102702 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(102733), // Rule ID 17124 //
     /* 102707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 102715 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102722 */     // (intrinsic_void 14998:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 102722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 102725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102731 */     GIR_RootConstrainSelectedInstOperands,
     /* 102732 */     // GIR_Coverage, 17124,
     /* 102732 */     GIR_EraseRootFromParent_Done,
     /* 102733 */   // Label 2183: @102733
     /* 102733 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(102764), // Rule ID 17125 //
     /* 102738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 102746 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102753 */     // (intrinsic_void 14999:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 102753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 102756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102762 */     GIR_RootConstrainSelectedInstOperands,
     /* 102763 */     // GIR_Coverage, 17125,
     /* 102763 */     GIR_EraseRootFromParent_Done,
     /* 102764 */   // Label 2184: @102764
     /* 102764 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(102795), // Rule ID 17126 //
     /* 102769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 102777 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102784 */     // (intrinsic_void 15000:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 102784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 102787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102793 */     GIR_RootConstrainSelectedInstOperands,
     /* 102794 */     // GIR_Coverage, 17126,
     /* 102794 */     GIR_EraseRootFromParent_Done,
     /* 102795 */   // Label 2185: @102795
     /* 102795 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(102826), // Rule ID 17131 //
     /* 102800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 102803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 102808 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102815 */     // (intrinsic_void 14656:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 102815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 102818 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102824 */     GIR_RootConstrainSelectedInstOperands,
     /* 102825 */     // GIR_Coverage, 17131,
     /* 102825 */     GIR_EraseRootFromParent_Done,
     /* 102826 */   // Label 2186: @102826
     /* 102826 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(102857), // Rule ID 17132 //
     /* 102831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 102834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 102839 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102846 */     // (intrinsic_void 14657:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 102846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 102849 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102855 */     GIR_RootConstrainSelectedInstOperands,
     /* 102856 */     // GIR_Coverage, 17132,
     /* 102856 */     GIR_EraseRootFromParent_Done,
     /* 102857 */   // Label 2187: @102857
     /* 102857 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(102889), // Rule ID 114 //
     /* 102862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102870 */     // MIs[0] src
     /* 102870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102878 */     // (intrinsic_void 14569:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 102878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 102881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102887 */     GIR_RootConstrainSelectedInstOperands,
     /* 102888 */     // GIR_Coverage, 114,
     /* 102888 */     GIR_EraseRootFromParent_Done,
     /* 102889 */   // Label 2188: @102889
     /* 102889 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(102921), // Rule ID 116 //
     /* 102894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102902 */     // MIs[0] src
     /* 102902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102910 */     // (intrinsic_void 14569:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 102910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 102913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102919 */     GIR_RootConstrainSelectedInstOperands,
     /* 102920 */     // GIR_Coverage, 116,
     /* 102920 */     GIR_EraseRootFromParent_Done,
     /* 102921 */   // Label 2189: @102921
     /* 102921 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(102953), // Rule ID 126 //
     /* 102926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 102929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102934 */     // MIs[0] src
     /* 102934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 102938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102942 */     // (intrinsic_void 14954:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 102942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 102945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102951 */     GIR_RootConstrainSelectedInstOperands,
     /* 102952 */     // GIR_Coverage, 126,
     /* 102952 */     GIR_EraseRootFromParent_Done,
     /* 102953 */   // Label 2190: @102953
     /* 102953 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(102985), // Rule ID 127 //
     /* 102958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 102961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102966 */     // MIs[0] src
     /* 102966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102974 */     // (intrinsic_void 14954:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 102974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 102977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102983 */     GIR_RootConstrainSelectedInstOperands,
     /* 102984 */     // GIR_Coverage, 127,
     /* 102984 */     GIR_EraseRootFromParent_Done,
     /* 102985 */   // Label 2191: @102985
     /* 102985 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(103017), // Rule ID 128 //
     /* 102990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 102993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102998 */     // MIs[0] src
     /* 102998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103006 */     // (intrinsic_void 14954:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 103006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 103009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 103011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103015 */     GIR_RootConstrainSelectedInstOperands,
     /* 103016 */     // GIR_Coverage, 128,
     /* 103016 */     GIR_EraseRootFromParent_Done,
     /* 103017 */   // Label 2192: @103017
     /* 103017 */   GIM_Reject,
     /* 103018 */ // Label 2140: @103018
     /* 103018 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(106012),
     /* 103023 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 103026 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(103072), // Rule ID 165 //
     /* 103031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103057 */     // (intrinsic_w_chain:{ *:[i8] } 14649:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm),
     /* 103060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103070 */     GIR_RootConstrainSelectedInstOperands,
     /* 103071 */     // GIR_Coverage, 165,
     /* 103071 */     GIR_EraseRootFromParent_Done,
     /* 103072 */   // Label 2194: @103072
     /* 103072 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(103118), // Rule ID 166 //
     /* 103077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103103 */     // (intrinsic_w_chain:{ *:[i16] } 14648:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm),
     /* 103106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103116 */     GIR_RootConstrainSelectedInstOperands,
     /* 103117 */     // GIR_Coverage, 166,
     /* 103117 */     GIR_EraseRootFromParent_Done,
     /* 103118 */   // Label 2195: @103118
     /* 103118 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(103164), // Rule ID 167 //
     /* 103123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103149 */     // (intrinsic_w_chain:{ *:[i32] } 14650:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm),
     /* 103152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103162 */     GIR_RootConstrainSelectedInstOperands,
     /* 103163 */     // GIR_Coverage, 167,
     /* 103163 */     GIR_EraseRootFromParent_Done,
     /* 103164 */   // Label 2196: @103164
     /* 103164 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(103210), // Rule ID 168 //
     /* 103169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103195 */     // (intrinsic_w_chain:{ *:[i64] } 14647:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm),
     /* 103198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103208 */     GIR_RootConstrainSelectedInstOperands,
     /* 103209 */     // GIR_Coverage, 168,
     /* 103209 */     GIR_EraseRootFromParent_Done,
     /* 103210 */   // Label 2197: @103210
     /* 103210 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(103256), // Rule ID 170 //
     /* 103215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103241 */     // (intrinsic_w_chain:{ *:[i8] } 14649:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm_EVEX:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm_EVEX),
     /* 103244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103246 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103254 */     GIR_RootConstrainSelectedInstOperands,
     /* 103255 */     // GIR_Coverage, 170,
     /* 103255 */     GIR_EraseRootFromParent_Done,
     /* 103256 */   // Label 2198: @103256
     /* 103256 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(103302), // Rule ID 171 //
     /* 103261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103287 */     // (intrinsic_w_chain:{ *:[i16] } 14648:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm_EVEX),
     /* 103290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103300 */     GIR_RootConstrainSelectedInstOperands,
     /* 103301 */     // GIR_Coverage, 171,
     /* 103301 */     GIR_EraseRootFromParent_Done,
     /* 103302 */   // Label 2199: @103302
     /* 103302 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(103348), // Rule ID 172 //
     /* 103307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103333 */     // (intrinsic_w_chain:{ *:[i32] } 14650:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm_EVEX),
     /* 103336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103346 */     GIR_RootConstrainSelectedInstOperands,
     /* 103347 */     // GIR_Coverage, 172,
     /* 103347 */     GIR_EraseRootFromParent_Done,
     /* 103348 */   // Label 2200: @103348
     /* 103348 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(103394), // Rule ID 173 //
     /* 103353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103379 */     // (intrinsic_w_chain:{ *:[i64] } 14647:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm_EVEX),
     /* 103382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103392 */     GIR_RootConstrainSelectedInstOperands,
     /* 103393 */     // GIR_Coverage, 173,
     /* 103393 */     GIR_EraseRootFromParent_Done,
     /* 103394 */   // Label 2201: @103394
     /* 103394 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(103440), // Rule ID 2951 //
     /* 103399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103425 */     // (intrinsic_w_chain:{ *:[v16i8] } 14795:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUrm),
     /* 103428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103438 */     GIR_RootConstrainSelectedInstOperands,
     /* 103439 */     // GIR_Coverage, 2951,
     /* 103439 */     GIR_EraseRootFromParent_Done,
     /* 103440 */   // Label 2202: @103440
     /* 103440 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(103486), // Rule ID 2952 //
     /* 103445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_ldu_dq_256),
     /* 103453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103471 */     // (intrinsic_w_chain:{ *:[v32i8] } 13416:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUYrm),
     /* 103474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103484 */     GIR_RootConstrainSelectedInstOperands,
     /* 103485 */     // GIR_Coverage, 2952,
     /* 103485 */     GIR_EraseRootFromParent_Done,
     /* 103486 */   // Label 2203: @103486
     /* 103486 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(103532), // Rule ID 2953 //
     /* 103491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE3),
     /* 103494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103517 */     // (intrinsic_w_chain:{ *:[v16i8] } 14795:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDDQUrm),
     /* 103520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103530 */     GIR_RootConstrainSelectedInstOperands,
     /* 103531 */     // GIR_Coverage, 2953,
     /* 103531 */     GIR_EraseRootFromParent_Done,
     /* 103532 */   // Label 2204: @103532
     /* 103532 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(103578), // Rule ID 3543 //
     /* 103537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps128),
     /* 103545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103563 */     // (intrinsic_w_chain:{ *:[v4f32] } 14958:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSrm),
     /* 103566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103568 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103576 */     GIR_RootConstrainSelectedInstOperands,
     /* 103577 */     // GIR_Coverage, 3543,
     /* 103577 */     GIR_EraseRootFromParent_Done,
     /* 103578 */   // Label 2205: @103578
     /* 103578 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(103624), // Rule ID 3544 //
     /* 103583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps256),
     /* 103591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103609 */     // (intrinsic_w_chain:{ *:[v8f32] } 14959:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSYrm),
     /* 103612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103622 */     GIR_RootConstrainSelectedInstOperands,
     /* 103623 */     // GIR_Coverage, 3544,
     /* 103623 */     GIR_EraseRootFromParent_Done,
     /* 103624 */   // Label 2206: @103624
     /* 103624 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(103670), // Rule ID 3545 //
     /* 103629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps128),
     /* 103637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103655 */     // (intrinsic_w_chain:{ *:[v4f32] } 14960:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSrm),
     /* 103658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103668 */     GIR_RootConstrainSelectedInstOperands,
     /* 103669 */     // GIR_Coverage, 3545,
     /* 103669 */     GIR_EraseRootFromParent_Done,
     /* 103670 */   // Label 2207: @103670
     /* 103670 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(103716), // Rule ID 3546 //
     /* 103675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps256),
     /* 103683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103701 */     // (intrinsic_w_chain:{ *:[v8f32] } 14961:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSYrm),
     /* 103704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103706 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103714 */     GIR_RootConstrainSelectedInstOperands,
     /* 103715 */     // GIR_Coverage, 3546,
     /* 103715 */     GIR_EraseRootFromParent_Done,
     /* 103716 */   // Label 2208: @103716
     /* 103716 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(103762), // Rule ID 3547 //
     /* 103721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps128),
     /* 103729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103747 */     // (intrinsic_w_chain:{ *:[v4f32] } 14962:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSrm),
     /* 103750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103760 */     GIR_RootConstrainSelectedInstOperands,
     /* 103761 */     // GIR_Coverage, 3547,
     /* 103761 */     GIR_EraseRootFromParent_Done,
     /* 103762 */   // Label 2209: @103762
     /* 103762 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(103808), // Rule ID 3548 //
     /* 103767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps256),
     /* 103775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103793 */     // (intrinsic_w_chain:{ *:[v8f32] } 14963:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSYrm),
     /* 103796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103806 */     GIR_RootConstrainSelectedInstOperands,
     /* 103807 */     // GIR_Coverage, 3548,
     /* 103807 */     GIR_EraseRootFromParent_Done,
     /* 103808 */   // Label 2210: @103808
     /* 103808 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(103854), // Rule ID 3549 //
     /* 103813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps128),
     /* 103821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103839 */     // (intrinsic_w_chain:{ *:[v4f32] } 14964:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSrm),
     /* 103842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103844 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103852 */     GIR_RootConstrainSelectedInstOperands,
     /* 103853 */     // GIR_Coverage, 3549,
     /* 103853 */     GIR_EraseRootFromParent_Done,
     /* 103854 */   // Label 2211: @103854
     /* 103854 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(103900), // Rule ID 3550 //
     /* 103859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps256),
     /* 103867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103885 */     // (intrinsic_w_chain:{ *:[v8f32] } 14965:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSYrm),
     /* 103888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103898 */     GIR_RootConstrainSelectedInstOperands,
     /* 103899 */     // GIR_Coverage, 3550,
     /* 103899 */     GIR_EraseRootFromParent_Done,
     /* 103900 */   // Label 2212: @103900
     /* 103900 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(103946), // Rule ID 3551 //
     /* 103905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps128),
     /* 103913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103931 */     // (intrinsic_w_chain:{ *:[v4f32] } 14966:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSrm),
     /* 103934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103944 */     GIR_RootConstrainSelectedInstOperands,
     /* 103945 */     // GIR_Coverage, 3551,
     /* 103945 */     GIR_EraseRootFromParent_Done,
     /* 103946 */   // Label 2213: @103946
     /* 103946 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(103992), // Rule ID 3552 //
     /* 103951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps256),
     /* 103959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103977 */     // (intrinsic_w_chain:{ *:[v8f32] } 14967:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSYrm),
     /* 103980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103990 */     GIR_RootConstrainSelectedInstOperands,
     /* 103991 */     // GIR_Coverage, 3552,
     /* 103991 */     GIR_EraseRootFromParent_Done,
     /* 103992 */   // Label 2214: @103992
     /* 103992 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(104038), // Rule ID 3553 //
     /* 103997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 104000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps128),
     /* 104005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 104012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104023 */     // (intrinsic_w_chain:{ *:[v4f32] } 14968:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 104023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSrm),
     /* 104026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104036 */     GIR_RootConstrainSelectedInstOperands,
     /* 104037 */     // GIR_Coverage, 3553,
     /* 104037 */     GIR_EraseRootFromParent_Done,
     /* 104038 */   // Label 2215: @104038
     /* 104038 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(104084), // Rule ID 3554 //
     /* 104043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 104046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps256),
     /* 104051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 104058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104069 */     // (intrinsic_w_chain:{ *:[v8f32] } 14969:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 104069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSYrm),
     /* 104072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104082 */     GIR_RootConstrainSelectedInstOperands,
     /* 104083 */     // GIR_Coverage, 3554,
     /* 104083 */     GIR_EraseRootFromParent_Done,
     /* 104084 */   // Label 2216: @104084
     /* 104084 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(104130), // Rule ID 16753 //
     /* 104089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb512),
     /* 104097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v64s8,
     /* 104100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104115 */     // (intrinsic_w_chain:{ *:[v64i8] } 13672:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /* 104115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZm),
     /* 104118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104128 */     GIR_RootConstrainSelectedInstOperands,
     /* 104129 */     // GIR_Coverage, 16753,
     /* 104129 */     GIR_EraseRootFromParent_Done,
     /* 104130 */   // Label 2217: @104130
     /* 104130 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(104176), // Rule ID 16756 //
     /* 104135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb128),
     /* 104143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 104146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104161 */     // (intrinsic_w_chain:{ *:[v16i8] } 13670:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ128m:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 104161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ128m),
     /* 104164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104174 */     GIR_RootConstrainSelectedInstOperands,
     /* 104175 */     // GIR_Coverage, 16756,
     /* 104175 */     GIR_EraseRootFromParent_Done,
     /* 104176 */   // Label 2218: @104176
     /* 104176 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(104222), // Rule ID 16759 //
     /* 104181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb256),
     /* 104189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 104192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104207 */     // (intrinsic_w_chain:{ *:[v32i8] } 13671:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ256m:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 104207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ256m),
     /* 104210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104220 */     GIR_RootConstrainSelectedInstOperands,
     /* 104221 */     // GIR_Coverage, 16759,
     /* 104221 */     GIR_EraseRootFromParent_Done,
     /* 104222 */   // Label 2219: @104222
     /* 104222 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(104268), // Rule ID 16762 //
     /* 104227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw512),
     /* 104235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 104238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104253 */     // (intrinsic_w_chain:{ *:[v32i16] } 13681:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 104253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZm),
     /* 104256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104266 */     GIR_RootConstrainSelectedInstOperands,
     /* 104267 */     // GIR_Coverage, 16762,
     /* 104267 */     GIR_EraseRootFromParent_Done,
     /* 104268 */   // Label 2220: @104268
     /* 104268 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(104314), // Rule ID 16765 //
     /* 104273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw128),
     /* 104281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 104284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104299 */     // (intrinsic_w_chain:{ *:[v8i16] } 13679:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ128m:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 104299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ128m),
     /* 104302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104312 */     GIR_RootConstrainSelectedInstOperands,
     /* 104313 */     // GIR_Coverage, 16765,
     /* 104313 */     GIR_EraseRootFromParent_Done,
     /* 104314 */   // Label 2221: @104314
     /* 104314 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(104360), // Rule ID 16768 //
     /* 104319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw256),
     /* 104327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 104330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104345 */     // (intrinsic_w_chain:{ *:[v16i16] } 13680:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ256m:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 104345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ256m),
     /* 104348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104358 */     GIR_RootConstrainSelectedInstOperands,
     /* 104359 */     // GIR_Coverage, 16768,
     /* 104359 */     GIR_EraseRootFromParent_Done,
     /* 104360 */   // Label 2222: @104360
     /* 104360 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(104406), // Rule ID 16771 //
     /* 104365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd512),
     /* 104373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 104376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104391 */     // (intrinsic_w_chain:{ *:[v16i32] } 13675:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 104391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZm),
     /* 104394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104404 */     GIR_RootConstrainSelectedInstOperands,
     /* 104405 */     // GIR_Coverage, 16771,
     /* 104405 */     GIR_EraseRootFromParent_Done,
     /* 104406 */   // Label 2223: @104406
     /* 104406 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(104452), // Rule ID 16774 //
     /* 104411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd128),
     /* 104419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104437 */     // (intrinsic_w_chain:{ *:[v4i32] } 13673:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ128m:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 104437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ128m),
     /* 104440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104450 */     GIR_RootConstrainSelectedInstOperands,
     /* 104451 */     // GIR_Coverage, 16774,
     /* 104451 */     GIR_EraseRootFromParent_Done,
     /* 104452 */   // Label 2224: @104452
     /* 104452 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(104498), // Rule ID 16777 //
     /* 104457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd256),
     /* 104465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104483 */     // (intrinsic_w_chain:{ *:[v8i32] } 13674:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ256m:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 104483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ256m),
     /* 104486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104496 */     GIR_RootConstrainSelectedInstOperands,
     /* 104497 */     // GIR_Coverage, 16777,
     /* 104497 */     GIR_EraseRootFromParent_Done,
     /* 104498 */   // Label 2225: @104498
     /* 104498 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(104544), // Rule ID 16780 //
     /* 104503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq512),
     /* 104511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 104514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104529 */     // (intrinsic_w_chain:{ *:[v8i64] } 13678:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 104529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZm),
     /* 104532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104542 */     GIR_RootConstrainSelectedInstOperands,
     /* 104543 */     // GIR_Coverage, 16780,
     /* 104543 */     GIR_EraseRootFromParent_Done,
     /* 104544 */   // Label 2226: @104544
     /* 104544 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(104590), // Rule ID 16783 //
     /* 104549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq128),
     /* 104557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 104560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104575 */     // (intrinsic_w_chain:{ *:[v2i64] } 13676:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ128m:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /* 104575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ128m),
     /* 104578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104588 */     GIR_RootConstrainSelectedInstOperands,
     /* 104589 */     // GIR_Coverage, 16783,
     /* 104589 */     GIR_EraseRootFromParent_Done,
     /* 104590 */   // Label 2227: @104590
     /* 104590 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(104636), // Rule ID 16786 //
     /* 104595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq256),
     /* 104603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 104606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104621 */     // (intrinsic_w_chain:{ *:[v4i64] } 13677:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ256m:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 104621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ256m),
     /* 104624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104634 */     GIR_RootConstrainSelectedInstOperands,
     /* 104635 */     // GIR_Coverage, 16786,
     /* 104635 */     GIR_EraseRootFromParent_Done,
     /* 104636 */   // Label 2228: @104636
     /* 104636 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(104682), // Rule ID 17094 //
     /* 104641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104649 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104667 */     // (intrinsic_void 15002:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD),
     /* 104670 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104680 */     GIR_RootConstrainSelectedInstOperands,
     /* 104681 */     // GIR_Coverage, 17094,
     /* 104681 */     GIR_EraseRootFromParent_Done,
     /* 104682 */   // Label 2229: @104682
     /* 104682 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(104728), // Rule ID 17095 //
     /* 104687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104695 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104713 */     // (intrinsic_void 15003:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ),
     /* 104716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104726 */     GIR_RootConstrainSelectedInstOperands,
     /* 104727 */     // GIR_Coverage, 17095,
     /* 104727 */     GIR_EraseRootFromParent_Done,
     /* 104728 */   // Label 2230: @104728
     /* 104728 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(104774), // Rule ID 17096 //
     /* 104733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104741 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104759 */     // (intrinsic_void 15004:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD),
     /* 104762 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104772 */     GIR_RootConstrainSelectedInstOperands,
     /* 104773 */     // GIR_Coverage, 17096,
     /* 104773 */     GIR_EraseRootFromParent_Done,
     /* 104774 */   // Label 2231: @104774
     /* 104774 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(104820), // Rule ID 17097 //
     /* 104779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104787 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104805 */     // (intrinsic_void 15005:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ),
     /* 104808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104812 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104818 */     GIR_RootConstrainSelectedInstOperands,
     /* 104819 */     // GIR_Coverage, 17097,
     /* 104819 */     GIR_EraseRootFromParent_Done,
     /* 104820 */   // Label 2232: @104820
     /* 104820 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(104866), // Rule ID 17098 //
     /* 104825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104833 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104851 */     // (intrinsic_void 15002:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD_EVEX),
     /* 104854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104864 */     GIR_RootConstrainSelectedInstOperands,
     /* 104865 */     // GIR_Coverage, 17098,
     /* 104865 */     GIR_EraseRootFromParent_Done,
     /* 104866 */   // Label 2233: @104866
     /* 104866 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(104912), // Rule ID 17099 //
     /* 104871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104879 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104897 */     // (intrinsic_void 15003:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ_EVEX),
     /* 104900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104910 */     GIR_RootConstrainSelectedInstOperands,
     /* 104911 */     // GIR_Coverage, 17099,
     /* 104911 */     GIR_EraseRootFromParent_Done,
     /* 104912 */   // Label 2234: @104912
     /* 104912 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(104958), // Rule ID 17100 //
     /* 104917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104925 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104943 */     // (intrinsic_void 15004:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD_EVEX),
     /* 104946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104956 */     GIR_RootConstrainSelectedInstOperands,
     /* 104957 */     // GIR_Coverage, 17100,
     /* 104957 */     GIR_EraseRootFromParent_Done,
     /* 104958 */   // Label 2235: @104958
     /* 104958 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(105004), // Rule ID 17101 //
     /* 104963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104971 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104989 */     // (intrinsic_void 15005:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ_EVEX),
     /* 104992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104996 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105002 */     GIR_RootConstrainSelectedInstOperands,
     /* 105003 */     // GIR_Coverage, 17101,
     /* 105003 */     GIR_EraseRootFromParent_Done,
     /* 105004 */   // Label 2236: @105004
     /* 105004 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(105050), // Rule ID 17127 //
     /* 105009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_Not64BitMode),
     /* 105012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105017 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105035 */     // (intrinsic_void 14566:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID32 GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID32),
     /* 105038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105048 */     GIR_RootConstrainSelectedInstOperands,
     /* 105049 */     // GIR_Coverage, 17127,
     /* 105049 */     GIR_EraseRootFromParent_Done,
     /* 105050 */   // Label 2237: @105050
     /* 105050 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(105142), // Rule ID 22379 //
     /* 105055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_NoEGPR),
     /* 105058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105063 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105081 */     // (intrinsic_void 14566:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64 (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 105081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 105088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 105097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64),
     /* 105133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105140 */     GIR_RootConstrainSelectedInstOperands,
     /* 105141 */     // GIR_Coverage, 22379,
     /* 105141 */     GIR_EraseRootFromParent_Done,
     /* 105142 */   // Label 2238: @105142
     /* 105142 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(105234), // Rule ID 22380 //
     /* 105147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasINVPCID),
     /* 105150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105155 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105173 */     // (intrinsic_void 14566:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64_EVEX (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 105173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 105180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105185 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 105189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64_EVEX),
     /* 105225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105232 */     GIR_RootConstrainSelectedInstOperands,
     /* 105233 */     // GIR_Coverage, 22380,
     /* 105233 */     GIR_EraseRootFromParent_Done,
     /* 105234 */   // Label 2239: @105234
     /* 105234 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(105280), // Rule ID 131 //
     /* 105239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_NoEGPR),
     /* 105242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105265 */     // (intrinsic_void 14545:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32 addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32),
     /* 105268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105278 */     GIR_RootConstrainSelectedInstOperands,
     /* 105279 */     // GIR_Coverage, 131,
     /* 105279 */     GIR_EraseRootFromParent_Done,
     /* 105280 */   // Label 2240: @105280
     /* 105280 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(105326), // Rule ID 132 //
     /* 105285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_In64BitMode_NoEGPR),
     /* 105288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105311 */     // (intrinsic_void 14546:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64 addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64),
     /* 105314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105324 */     GIR_RootConstrainSelectedInstOperands,
     /* 105325 */     // GIR_Coverage, 132,
     /* 105325 */     GIR_EraseRootFromParent_Done,
     /* 105326 */   // Label 2241: @105326
     /* 105326 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(105372), // Rule ID 133 //
     /* 105331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105357 */     // (intrinsic_void 14545:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32_EVEX),
     /* 105360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105370 */     GIR_RootConstrainSelectedInstOperands,
     /* 105371 */     // GIR_Coverage, 133,
     /* 105371 */     GIR_EraseRootFromParent_Done,
     /* 105372 */   // Label 2242: @105372
     /* 105372 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(105418), // Rule ID 134 //
     /* 105377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105403 */     // (intrinsic_void 14546:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64_EVEX),
     /* 105406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105416 */     GIR_RootConstrainSelectedInstOperands,
     /* 105417 */     // GIR_Coverage, 134,
     /* 105417 */     GIR_EraseRootFromParent_Done,
     /* 105418 */   // Label 2243: @105418
     /* 105418 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(105465), // Rule ID 135 //
     /* 105423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_NoEGPR),
     /* 105426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105431 */     // MIs[0] dst
     /* 105431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105450 */     // (intrinsic_void 14646:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32 GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32),
     /* 105453 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105463 */     GIR_RootConstrainSelectedInstOperands,
     /* 105464 */     // GIR_Coverage, 135,
     /* 105464 */     GIR_EraseRootFromParent_Done,
     /* 105465 */   // Label 2244: @105465
     /* 105465 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(105512), // Rule ID 136 //
     /* 105470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR),
     /* 105473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105478 */     // MIs[0] dst
     /* 105478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105497 */     // (intrinsic_void 14646:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64 GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64),
     /* 105500 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105510 */     GIR_RootConstrainSelectedInstOperands,
     /* 105511 */     // GIR_Coverage, 136,
     /* 105511 */     GIR_EraseRootFromParent_Done,
     /* 105512 */   // Label 2245: @105512
     /* 105512 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(105559), // Rule ID 137 //
     /* 105517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105525 */     // MIs[0] dst
     /* 105525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105544 */     // (intrinsic_void 14646:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32_EVEX GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32_EVEX),
     /* 105547 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105557 */     GIR_RootConstrainSelectedInstOperands,
     /* 105558 */     // GIR_Coverage, 137,
     /* 105558 */     GIR_EraseRootFromParent_Done,
     /* 105559 */   // Label 2246: @105559
     /* 105559 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(105606), // Rule ID 138 //
     /* 105564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105572 */     // MIs[0] dst
     /* 105572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105591 */     // (intrinsic_void 14646:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64_EVEX GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64_EVEX),
     /* 105594 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105596 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105604 */     GIR_RootConstrainSelectedInstOperands,
     /* 105605 */     // GIR_Coverage, 138,
     /* 105605 */     GIR_EraseRootFromParent_Done,
     /* 105606 */   // Label 2247: @105606
     /* 105606 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(105638), // Rule ID 17025 //
     /* 105611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 105614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 105619 */     // MIs[0] dst
     /* 105619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105622 */     // MIs[0] src
     /* 105622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105625 */     // (intrinsic_void 14952:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 105628 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105636 */     GIR_RootConstrainSelectedInstOperands,
     /* 105637 */     // GIR_Coverage, 17025,
     /* 105637 */     GIR_EraseRootFromParent_Done,
     /* 105638 */   // Label 2248: @105638
     /* 105638 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(105670), // Rule ID 17037 //
     /* 105643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 105646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 105651 */     // MIs[0] dst
     /* 105651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105654 */     // MIs[0] src
     /* 105654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105657 */     // (intrinsic_void 14891:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 105660 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105662 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105668 */     GIR_RootConstrainSelectedInstOperands,
     /* 105669 */     // GIR_Coverage, 17037,
     /* 105669 */     GIR_EraseRootFromParent_Done,
     /* 105670 */   // Label 2249: @105670
     /* 105670 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(105713), // Rule ID 17152 //
     /* 105675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 105680 */     // MIs[0] addr
     /* 105680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 105688 */     // MIs[0] accessinfo
     /* 105688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105691 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 105691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 105694 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 105696 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 105698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 105701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 105704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 105707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105711 */     GIR_RootConstrainSelectedInstOperands,
     /* 105712 */     // GIR_Coverage, 17152,
     /* 105712 */     GIR_EraseRootFromParent_Done,
     /* 105713 */   // Label 2250: @105713
     /* 105713 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(105753), // Rule ID 17078 //
     /* 105718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105740 */     // (intrinsic_w_chain:{ *:[i64] } 14956:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 105743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105751 */     GIR_RootConstrainSelectedInstOperands,
     /* 105752 */     // GIR_Coverage, 17078,
     /* 105752 */     GIR_EraseRootFromParent_Done,
     /* 105753 */   // Label 2251: @105753
     /* 105753 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(105793), // Rule ID 17082 //
     /* 105758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105780 */     // (intrinsic_w_chain:{ *:[i64] } 14956:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 105783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105791 */     GIR_RootConstrainSelectedInstOperands,
     /* 105792 */     // GIR_Coverage, 17082,
     /* 105792 */     GIR_EraseRootFromParent_Done,
     /* 105793 */   // Label 2252: @105793
     /* 105793 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(105830), // Rule ID 17090 //
     /* 105798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 105803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 105806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105817 */     // (intrinsic_w_chain:{ *:[i32] } 14672:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 105817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 105820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105828 */     GIR_RootConstrainSelectedInstOperands,
     /* 105829 */     // GIR_Coverage, 17090,
     /* 105829 */     GIR_EraseRootFromParent_Done,
     /* 105830 */   // Label 2253: @105830
     /* 105830 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(105867), // Rule ID 17091 //
     /* 105835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 105840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105854 */     // (intrinsic_w_chain:{ *:[i64] } 14673:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 105857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105859 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105865 */     GIR_RootConstrainSelectedInstOperands,
     /* 105866 */     // GIR_Coverage, 17091,
     /* 105866 */     GIR_EraseRootFromParent_Done,
     /* 105867 */   // Label 2254: @105867
     /* 105867 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(105931), // Rule ID 3086 //
     /* 105872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 105875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 105880 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 105890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 105894 */     // (intrinsic_void 14797:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 105894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105898 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105904 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 105908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105912 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 105922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 105925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105929 */     GIR_RootConstrainSelectedInstOperands,
     /* 105930 */     // GIR_Coverage, 3086,
     /* 105930 */     GIR_EraseRootFromParent_Done,
     /* 105931 */   // Label 2255: @105931
     /* 105931 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(105971), // Rule ID 17080 //
     /* 105936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105944 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105958 */     // (intrinsic_void 14957:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 105961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105969 */     GIR_RootConstrainSelectedInstOperands,
     /* 105970 */     // GIR_Coverage, 17080,
     /* 105970 */     GIR_EraseRootFromParent_Done,
     /* 105971 */   // Label 2256: @105971
     /* 105971 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(106011), // Rule ID 17084 //
     /* 105976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105984 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105998 */     // (intrinsic_void 14957:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 106001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 106003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 106005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106009 */     GIR_RootConstrainSelectedInstOperands,
     /* 106010 */     // GIR_Coverage, 17084,
     /* 106010 */     GIR_EraseRootFromParent_Done,
     /* 106011 */   // Label 2257: @106011
     /* 106011 */   GIM_Reject,
     /* 106012 */ // Label 2193: @106012
     /* 106012 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(109557),
     /* 106017 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 106020 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(106092), // Rule ID 123 //
     /* 106025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 106028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 106033 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 106043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106051 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106058 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 106062 */     // MIs[0] cntl
     /* 106062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 106065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106074 */     // (intrinsic_void 14573:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rmi GR32:{ *:[i32] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 106074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rmi),
     /* 106077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 106079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 106083 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 106085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106090 */     GIR_RootConstrainSelectedInstOperands,
     /* 106091 */     // GIR_Coverage, 123,
     /* 106091 */     GIR_EraseRootFromParent_Done,
     /* 106092 */   // Label 2259: @106092
     /* 106092 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(106164), // Rule ID 125 //
     /* 106097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 106100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 106105 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106123 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106130 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 106134 */     // MIs[0] cntl
     /* 106134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 106137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106146 */     // (intrinsic_void 14574:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rmi GR64:{ *:[i64] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 106146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rmi),
     /* 106149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 106151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 106155 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 106157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106162 */     GIR_RootConstrainSelectedInstOperands,
     /* 106163 */     // GIR_Coverage, 125,
     /* 106163 */     GIR_EraseRootFromParent_Done,
     /* 106164 */   // Label 2260: @106164
     /* 106164 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(106219), // Rule ID 3387 //
     /* 106169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps),
     /* 106177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106202 */     // (intrinsic_w_chain:{ *:[v4f32] } 13419:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VMASKMOVPSrm:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSrm),
     /* 106205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106207 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106217 */     GIR_RootConstrainSelectedInstOperands,
     /* 106218 */     // GIR_Coverage, 3387,
     /* 106218 */     GIR_EraseRootFromParent_Done,
     /* 106219 */   // Label 2261: @106219
     /* 106219 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(106274), // Rule ID 3388 //
     /* 106224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps_256),
     /* 106232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106257 */     // (intrinsic_w_chain:{ *:[v8f32] } 13420:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VMASKMOVPSYrm:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYrm),
     /* 106260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106262 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106272 */     GIR_RootConstrainSelectedInstOperands,
     /* 106273 */     // GIR_Coverage, 3388,
     /* 106273 */     GIR_EraseRootFromParent_Done,
     /* 106274 */   // Label 2262: @106274
     /* 106274 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(106329), // Rule ID 3391 //
     /* 106279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd),
     /* 106287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106312 */     // (intrinsic_w_chain:{ *:[v2f64] } 13417:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VMASKMOVPDrm:{ *:[v2f64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDrm),
     /* 106315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106317 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106327 */     GIR_RootConstrainSelectedInstOperands,
     /* 106328 */     // GIR_Coverage, 3391,
     /* 106328 */     GIR_EraseRootFromParent_Done,
     /* 106329 */   // Label 2263: @106329
     /* 106329 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(106384), // Rule ID 3392 //
     /* 106334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd_256),
     /* 106342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106367 */     // (intrinsic_w_chain:{ *:[v4f64] } 13418:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VMASKMOVPDYrm:{ *:[v4f64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYrm),
     /* 106370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106372 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106382 */     GIR_RootConstrainSelectedInstOperands,
     /* 106383 */     // GIR_Coverage, 3392,
     /* 106383 */     GIR_EraseRootFromParent_Done,
     /* 106384 */   // Label 2264: @106384
     /* 106384 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(106439), // Rule ID 3465 //
     /* 106389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d),
     /* 106397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106422 */     // (intrinsic_w_chain:{ *:[v4i32] } 13717:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VPMASKMOVDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDrm),
     /* 106425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106437 */     GIR_RootConstrainSelectedInstOperands,
     /* 106438 */     // GIR_Coverage, 3465,
     /* 106438 */     GIR_EraseRootFromParent_Done,
     /* 106439 */   // Label 2265: @106439
     /* 106439 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(106494), // Rule ID 3466 //
     /* 106444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d_256),
     /* 106452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106477 */     // (intrinsic_w_chain:{ *:[v8i32] } 13718:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VPMASKMOVDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYrm),
     /* 106480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106482 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106492 */     GIR_RootConstrainSelectedInstOperands,
     /* 106493 */     // GIR_Coverage, 3466,
     /* 106493 */     GIR_EraseRootFromParent_Done,
     /* 106494 */   // Label 2266: @106494
     /* 106494 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(106549), // Rule ID 3469 //
     /* 106499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q),
     /* 106507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106532 */     // (intrinsic_w_chain:{ *:[v2i64] } 13719:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VPMASKMOVQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQrm),
     /* 106535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106537 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106547 */     GIR_RootConstrainSelectedInstOperands,
     /* 106548 */     // GIR_Coverage, 3469,
     /* 106548 */     GIR_EraseRootFromParent_Done,
     /* 106549 */   // Label 2267: @106549
     /* 106549 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(106604), // Rule ID 3470 //
     /* 106554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q_256),
     /* 106562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106587 */     // (intrinsic_w_chain:{ *:[v4i64] } 13720:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VPMASKMOVQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYrm),
     /* 106590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106592 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106594 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106602 */     GIR_RootConstrainSelectedInstOperands,
     /* 106603 */     // GIR_Coverage, 3470,
     /* 106603 */     GIR_EraseRootFromParent_Done,
     /* 106604 */   // Label 2268: @106604
     /* 106604 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(106659), // Rule ID 3389 //
     /* 106609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps),
     /* 106617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106642 */     // (intrinsic_void 13423:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMASKMOVPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 106642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSmr),
     /* 106645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106651 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106657 */     GIR_RootConstrainSelectedInstOperands,
     /* 106658 */     // GIR_Coverage, 3389,
     /* 106658 */     GIR_EraseRootFromParent_Done,
     /* 106659 */   // Label 2269: @106659
     /* 106659 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(106714), // Rule ID 3390 //
     /* 106664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps_256),
     /* 106672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106697 */     // (intrinsic_void 13424:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMASKMOVPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 106697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYmr),
     /* 106700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106706 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106712 */     GIR_RootConstrainSelectedInstOperands,
     /* 106713 */     // GIR_Coverage, 3390,
     /* 106713 */     GIR_EraseRootFromParent_Done,
     /* 106714 */   // Label 2270: @106714
     /* 106714 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(106769), // Rule ID 3393 //
     /* 106719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd),
     /* 106727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106752 */     // (intrinsic_void 13421:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMASKMOVPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 106752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDmr),
     /* 106755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106759 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106761 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106767 */     GIR_RootConstrainSelectedInstOperands,
     /* 106768 */     // GIR_Coverage, 3393,
     /* 106768 */     GIR_EraseRootFromParent_Done,
     /* 106769 */   // Label 2271: @106769
     /* 106769 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(106824), // Rule ID 3394 //
     /* 106774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd_256),
     /* 106782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106807 */     // (intrinsic_void 13422:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMASKMOVPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 106807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYmr),
     /* 106810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106816 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106822 */     GIR_RootConstrainSelectedInstOperands,
     /* 106823 */     // GIR_Coverage, 3394,
     /* 106823 */     GIR_EraseRootFromParent_Done,
     /* 106824 */   // Label 2272: @106824
     /* 106824 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(106879), // Rule ID 3467 //
     /* 106829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d),
     /* 106837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106862 */     // (intrinsic_void 13721:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMASKMOVDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 106862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDmr),
     /* 106865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106877 */     GIR_RootConstrainSelectedInstOperands,
     /* 106878 */     // GIR_Coverage, 3467,
     /* 106878 */     GIR_EraseRootFromParent_Done,
     /* 106879 */   // Label 2273: @106879
     /* 106879 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(106934), // Rule ID 3468 //
     /* 106884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d_256),
     /* 106892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106917 */     // (intrinsic_void 13722:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMASKMOVDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 106917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYmr),
     /* 106920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106926 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106932 */     GIR_RootConstrainSelectedInstOperands,
     /* 106933 */     // GIR_Coverage, 3468,
     /* 106933 */     GIR_EraseRootFromParent_Done,
     /* 106934 */   // Label 2274: @106934
     /* 106934 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(106989), // Rule ID 3471 //
     /* 106939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q),
     /* 106947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106972 */     // (intrinsic_void 13723:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPMASKMOVQmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 106972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQmr),
     /* 106975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106981 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106987 */     GIR_RootConstrainSelectedInstOperands,
     /* 106988 */     // GIR_Coverage, 3471,
     /* 106988 */     GIR_EraseRootFromParent_Done,
     /* 106989 */   // Label 2275: @106989
     /* 106989 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(107044), // Rule ID 3472 //
     /* 106994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q_256),
     /* 107002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 107005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 107008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 107016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 107020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107027 */     // (intrinsic_void 13724:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPMASKMOVQYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 107027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYmr),
     /* 107030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 107038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107042 */     GIR_RootConstrainSelectedInstOperands,
     /* 107043 */     // GIR_Coverage, 3472,
     /* 107043 */     GIR_EraseRootFromParent_Done,
     /* 107044 */   // Label 2276: @107044
     /* 107044 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(107123), // Rule ID 17105 //
     /* 107049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave),
     /* 107057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107082 */     // (intrinsic_void 15061:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE addr:{ *:[iPTR] }:$dst)
     /* 107082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107086 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107100 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE),
     /* 107113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107121 */     GIR_RootConstrainSelectedInstOperands,
     /* 107122 */     // GIR_Coverage, 17105,
     /* 107122 */     GIR_EraseRootFromParent_Done,
     /* 107123 */   // Label 2277: @107123
     /* 107123 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(107202), // Rule ID 17106 //
     /* 107128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave64),
     /* 107136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107161 */     // (intrinsic_void 15062:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 107161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107165 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107179 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE64),
     /* 107192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107200 */     GIR_RootConstrainSelectedInstOperands,
     /* 107201 */     // GIR_Coverage, 17106,
     /* 107201 */     GIR_EraseRootFromParent_Done,
     /* 107202 */   // Label 2278: @107202
     /* 107202 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(107281), // Rule ID 17107 //
     /* 107207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor),
     /* 107215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107240 */     // (intrinsic_void 15057:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR addr:{ *:[iPTR] }:$dst)
     /* 107240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107244 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107250 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107258 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR),
     /* 107271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107279 */     GIR_RootConstrainSelectedInstOperands,
     /* 107280 */     // GIR_Coverage, 17107,
     /* 107280 */     GIR_EraseRootFromParent_Done,
     /* 107281 */   // Label 2279: @107281
     /* 107281 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(107360), // Rule ID 17108 //
     /* 107286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor64),
     /* 107294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107319 */     // (intrinsic_void 15058:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR64 addr:{ *:[iPTR] }:$dst)
     /* 107319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107323 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR64),
     /* 107350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107358 */     GIR_RootConstrainSelectedInstOperands,
     /* 107359 */     // GIR_Coverage, 17108,
     /* 107359 */     GIR_EraseRootFromParent_Done,
     /* 107360 */   // Label 2280: @107360
     /* 107360 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(107439), // Rule ID 17109 //
     /* 107365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT),
     /* 107368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt),
     /* 107373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107398 */     // (intrinsic_void 15065:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT addr:{ *:[iPTR] }:$dst)
     /* 107398 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107402 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107408 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107416 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT),
     /* 107429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107437 */     GIR_RootConstrainSelectedInstOperands,
     /* 107438 */     // GIR_Coverage, 17109,
     /* 107438 */     GIR_EraseRootFromParent_Done,
     /* 107439 */   // Label 2281: @107439
     /* 107439 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(107518), // Rule ID 17110 //
     /* 107444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT_In64BitMode),
     /* 107447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt64),
     /* 107452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107477 */     // (intrinsic_void 15066:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT64 addr:{ *:[iPTR] }:$dst)
     /* 107477 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107481 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107495 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT64),
     /* 107508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107516 */     GIR_RootConstrainSelectedInstOperands,
     /* 107517 */     // GIR_Coverage, 17110,
     /* 107517 */     GIR_EraseRootFromParent_Done,
     /* 107518 */   // Label 2282: @107518
     /* 107518 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(107597), // Rule ID 17111 //
     /* 107523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC),
     /* 107526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec),
     /* 107531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107556 */     // (intrinsic_void 15063:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC addr:{ *:[iPTR] }:$dst)
     /* 107556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107560 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107574 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC),
     /* 107587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107595 */     GIR_RootConstrainSelectedInstOperands,
     /* 107596 */     // GIR_Coverage, 17111,
     /* 107596 */     GIR_EraseRootFromParent_Done,
     /* 107597 */   // Label 2283: @107597
     /* 107597 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(107676), // Rule ID 17112 //
     /* 107602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC_In64BitMode),
     /* 107605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec64),
     /* 107610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107635 */     // (intrinsic_void 15064:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC64 addr:{ *:[iPTR] }:$dst)
     /* 107635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107639 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107653 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC64),
     /* 107666 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107674 */     GIR_RootConstrainSelectedInstOperands,
     /* 107675 */     // GIR_Coverage, 17112,
     /* 107675 */     GIR_EraseRootFromParent_Done,
     /* 107676 */   // Label 2284: @107676
     /* 107676 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(107755), // Rule ID 17113 //
     /* 107681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves),
     /* 107689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107714 */     // (intrinsic_void 15067:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES addr:{ *:[iPTR] }:$dst)
     /* 107714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107718 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107724 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107732 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES),
     /* 107745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107753 */     GIR_RootConstrainSelectedInstOperands,
     /* 107754 */     // GIR_Coverage, 17113,
     /* 107754 */     GIR_EraseRootFromParent_Done,
     /* 107755 */   // Label 2285: @107755
     /* 107755 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(107834), // Rule ID 17114 //
     /* 107760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves64),
     /* 107768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107793 */     // (intrinsic_void 15068:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES64 addr:{ *:[iPTR] }:$dst)
     /* 107793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107797 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107811 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES64),
     /* 107824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107832 */     GIR_RootConstrainSelectedInstOperands,
     /* 107833 */     // GIR_Coverage, 17114,
     /* 107833 */     GIR_EraseRootFromParent_Done,
     /* 107834 */   // Label 2286: @107834
     /* 107834 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(107913), // Rule ID 17115 //
     /* 107839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors),
     /* 107847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107872 */     // (intrinsic_void 15059:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS addr:{ *:[iPTR] }:$dst)
     /* 107872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107876 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107890 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS),
     /* 107903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107911 */     GIR_RootConstrainSelectedInstOperands,
     /* 107912 */     // GIR_Coverage, 17115,
     /* 107912 */     GIR_EraseRootFromParent_Done,
     /* 107913 */   // Label 2287: @107913
     /* 107913 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(107992), // Rule ID 17116 //
     /* 107918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES_In64BitMode),
     /* 107921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors64),
     /* 107926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107951 */     // (intrinsic_void 15060:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS64 addr:{ *:[iPTR] }:$dst)
     /* 107951 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107955 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107961 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107969 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS64),
     /* 107982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107990 */     GIR_RootConstrainSelectedInstOperands,
     /* 107991 */     // GIR_Coverage, 17116,
     /* 107991 */     GIR_EraseRootFromParent_Done,
     /* 107992 */   // Label 2288: @107992
     /* 107992 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(108029), // Rule ID 17004 //
     /* 107997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 108005 */     // MIs[0] src1
     /* 108005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108008 */     // MIs[0] src2
     /* 108008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108011 */     // MIs[0] src3
     /* 108011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108014 */     // (intrinsic_void 14909:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 108017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108021 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108027 */     GIR_RootConstrainSelectedInstOperands,
     /* 108028 */     // GIR_Coverage, 17004,
     /* 108028 */     GIR_EraseRootFromParent_Done,
     /* 108029 */   // Label 2289: @108029
     /* 108029 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(108066), // Rule ID 17005 //
     /* 108034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 108042 */     // MIs[0] src1
     /* 108042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108045 */     // MIs[0] src2
     /* 108045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108048 */     // MIs[0] src3
     /* 108048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108051 */     // (intrinsic_void 14911:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 108054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108058 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108064 */     GIR_RootConstrainSelectedInstOperands,
     /* 108065 */     // GIR_Coverage, 17005,
     /* 108065 */     GIR_EraseRootFromParent_Done,
     /* 108066 */   // Label 2290: @108066
     /* 108066 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(108103), // Rule ID 17006 //
     /* 108071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 108079 */     // MIs[0] src1
     /* 108079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108082 */     // MIs[0] src2
     /* 108082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108085 */     // MIs[0] src3
     /* 108085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108088 */     // (intrinsic_void 14913:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 108091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108095 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108101 */     GIR_RootConstrainSelectedInstOperands,
     /* 108102 */     // GIR_Coverage, 17006,
     /* 108102 */     GIR_EraseRootFromParent_Done,
     /* 108103 */   // Label 2291: @108103
     /* 108103 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(108140), // Rule ID 17007 //
     /* 108108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 108116 */     // MIs[0] src1
     /* 108116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108119 */     // MIs[0] src2
     /* 108119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108122 */     // MIs[0] src3
     /* 108122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108125 */     // (intrinsic_void 14915:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 108128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108132 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108138 */     GIR_RootConstrainSelectedInstOperands,
     /* 108139 */     // GIR_Coverage, 17007,
     /* 108139 */     GIR_EraseRootFromParent_Done,
     /* 108140 */   // Label 2292: @108140
     /* 108140 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(108177), // Rule ID 17009 //
     /* 108145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 108148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 108153 */     // MIs[0] src1
     /* 108153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108156 */     // MIs[0] src2
     /* 108156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108159 */     // MIs[0] src3
     /* 108159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108162 */     // (intrinsic_void 14903:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 108165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108167 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108169 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108175 */     GIR_RootConstrainSelectedInstOperands,
     /* 108176 */     // GIR_Coverage, 17009,
     /* 108176 */     GIR_EraseRootFromParent_Done,
     /* 108177 */   // Label 2293: @108177
     /* 108177 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(108214), // Rule ID 17011 //
     /* 108182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 108185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 108190 */     // MIs[0] src1
     /* 108190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108193 */     // MIs[0] src2
     /* 108193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108196 */     // MIs[0] src3
     /* 108196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108199 */     // (intrinsic_void 14917:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 108202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108206 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108212 */     GIR_RootConstrainSelectedInstOperands,
     /* 108213 */     // GIR_Coverage, 17011,
     /* 108213 */     GIR_EraseRootFromParent_Done,
     /* 108214 */   // Label 2294: @108214
     /* 108214 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(108251), // Rule ID 17014 //
     /* 108219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 108227 */     // MIs[0] src1
     /* 108227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108230 */     // MIs[0] src2
     /* 108230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108233 */     // MIs[0] src3
     /* 108233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108236 */     // (intrinsic_void 14885:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 108239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108243 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108249 */     GIR_RootConstrainSelectedInstOperands,
     /* 108250 */     // GIR_Coverage, 17014,
     /* 108250 */     GIR_EraseRootFromParent_Done,
     /* 108251 */   // Label 2295: @108251
     /* 108251 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(108288), // Rule ID 17015 //
     /* 108256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 108264 */     // MIs[0] src1
     /* 108264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108267 */     // MIs[0] src2
     /* 108267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108270 */     // MIs[0] src3
     /* 108270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108273 */     // (intrinsic_void 14887:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 108276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108280 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108286 */     GIR_RootConstrainSelectedInstOperands,
     /* 108287 */     // GIR_Coverage, 17015,
     /* 108287 */     GIR_EraseRootFromParent_Done,
     /* 108288 */   // Label 2296: @108288
     /* 108288 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(108325), // Rule ID 17016 //
     /* 108293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 108301 */     // MIs[0] src1
     /* 108301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108304 */     // MIs[0] src2
     /* 108304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108307 */     // MIs[0] src3
     /* 108307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108310 */     // (intrinsic_void 14905:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 108313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108317 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108323 */     GIR_RootConstrainSelectedInstOperands,
     /* 108324 */     // GIR_Coverage, 17016,
     /* 108324 */     GIR_EraseRootFromParent_Done,
     /* 108325 */   // Label 2297: @108325
     /* 108325 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(108362), // Rule ID 17017 //
     /* 108330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 108338 */     // MIs[0] src1
     /* 108338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108341 */     // MIs[0] src2
     /* 108341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108344 */     // MIs[0] src3
     /* 108344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108347 */     // (intrinsic_void 14907:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 108350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108360 */     GIR_RootConstrainSelectedInstOperands,
     /* 108361 */     // GIR_Coverage, 17017,
     /* 108361 */     GIR_EraseRootFromParent_Done,
     /* 108362 */   // Label 2298: @108362
     /* 108362 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(108399), // Rule ID 17018 //
     /* 108367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 108375 */     // MIs[0] src1
     /* 108375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108378 */     // MIs[0] src2
     /* 108378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108381 */     // MIs[0] src3
     /* 108381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108384 */     // (intrinsic_void 14919:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 108387 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108391 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108397 */     GIR_RootConstrainSelectedInstOperands,
     /* 108398 */     // GIR_Coverage, 17018,
     /* 108398 */     GIR_EraseRootFromParent_Done,
     /* 108399 */   // Label 2299: @108399
     /* 108399 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(108436), // Rule ID 17019 //
     /* 108404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 108412 */     // MIs[0] src1
     /* 108412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108415 */     // MIs[0] src2
     /* 108415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108418 */     // MIs[0] src3
     /* 108418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108421 */     // (intrinsic_void 14921:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 108424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108428 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108434 */     GIR_RootConstrainSelectedInstOperands,
     /* 108435 */     // GIR_Coverage, 17019,
     /* 108435 */     GIR_EraseRootFromParent_Done,
     /* 108436 */   // Label 2300: @108436
     /* 108436 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(108473), // Rule ID 17027 //
     /* 108441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 108444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 108449 */     // MIs[0] src1
     /* 108449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108452 */     // MIs[0] src2
     /* 108452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108455 */     // MIs[0] src3
     /* 108455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108458 */     // (intrinsic_void 14946:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 108461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108465 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108471 */     GIR_RootConstrainSelectedInstOperands,
     /* 108472 */     // GIR_Coverage, 17027,
     /* 108472 */     GIR_EraseRootFromParent_Done,
     /* 108473 */   // Label 2301: @108473
     /* 108473 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(108510), // Rule ID 17029 //
     /* 108478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 108481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 108486 */     // MIs[0] src1
     /* 108486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108489 */     // MIs[0] src2
     /* 108489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108492 */     // MIs[0] src3
     /* 108492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108495 */     // (intrinsic_void 14948:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 108498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108502 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108508 */     GIR_RootConstrainSelectedInstOperands,
     /* 108509 */     // GIR_Coverage, 17029,
     /* 108509 */     GIR_EraseRootFromParent_Done,
     /* 108510 */   // Label 2302: @108510
     /* 108510 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(108547), // Rule ID 17034 //
     /* 108515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 108523 */     // MIs[0] src1
     /* 108523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108526 */     // MIs[0] src2
     /* 108526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108529 */     // MIs[0] src3
     /* 108529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108532 */     // (intrinsic_void 14942:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 108535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108539 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108545 */     GIR_RootConstrainSelectedInstOperands,
     /* 108546 */     // GIR_Coverage, 17034,
     /* 108546 */     GIR_EraseRootFromParent_Done,
     /* 108547 */   // Label 2303: @108547
     /* 108547 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(108584), // Rule ID 17035 //
     /* 108552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 108560 */     // MIs[0] src1
     /* 108560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108563 */     // MIs[0] src2
     /* 108563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108566 */     // MIs[0] src3
     /* 108566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108569 */     // (intrinsic_void 14944:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 108572 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108582 */     GIR_RootConstrainSelectedInstOperands,
     /* 108583 */     // GIR_Coverage, 17035,
     /* 108583 */     GIR_EraseRootFromParent_Done,
     /* 108584 */   // Label 2304: @108584
     /* 108584 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(108621), // Rule ID 17036 //
     /* 108589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 108597 */     // MIs[0] src1
     /* 108597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108600 */     // MIs[0] src2
     /* 108600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108603 */     // MIs[0] src3
     /* 108603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108606 */     // (intrinsic_void 14889:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 108609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108613 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108619 */     GIR_RootConstrainSelectedInstOperands,
     /* 108620 */     // GIR_Coverage, 17036,
     /* 108620 */     GIR_EraseRootFromParent_Done,
     /* 108621 */   // Label 2305: @108621
     /* 108621 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(108658), // Rule ID 17055 //
     /* 108626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 108629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 108634 */     // MIs[0] src1
     /* 108634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108637 */     // MIs[0] src2
     /* 108637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108640 */     // MIs[0] src3
     /* 108640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108643 */     // (intrinsic_void 14939:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 108646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108650 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108656 */     GIR_RootConstrainSelectedInstOperands,
     /* 108657 */     // GIR_Coverage, 17055,
     /* 108657 */     GIR_EraseRootFromParent_Done,
     /* 108658 */   // Label 2306: @108658
     /* 108658 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(108695), // Rule ID 17057 //
     /* 108663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 108666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 108671 */     // MIs[0] src1
     /* 108671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108674 */     // MIs[0] src2
     /* 108674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108677 */     // MIs[0] src3
     /* 108677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108680 */     // (intrinsic_void 14950:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 108683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108687 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108693 */     GIR_RootConstrainSelectedInstOperands,
     /* 108694 */     // GIR_Coverage, 17057,
     /* 108694 */     GIR_EraseRootFromParent_Done,
     /* 108695 */   // Label 2307: @108695
     /* 108695 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(108748), // Rule ID 17038 //
     /* 108700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108718 */     // MIs[0] src1
     /* 108718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108729 */     // MIs[1] Operand 1
     /* 108729 */     // No operand predicates
     /* 108729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108731 */     // (intrinsic_w_chain:{ *:[v16f32] } 14893:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 108734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108746 */     GIR_RootConstrainSelectedInstOperands,
     /* 108747 */     // GIR_Coverage, 17038,
     /* 108747 */     GIR_EraseRootFromParent_Done,
     /* 108748 */   // Label 2308: @108748
     /* 108748 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(108801), // Rule ID 17047 //
     /* 108753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108771 */     // MIs[0] src1
     /* 108771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108782 */     // MIs[1] Operand 1
     /* 108782 */     // No operand predicates
     /* 108782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108784 */     // (intrinsic_w_chain:{ *:[v32f16] } 14899:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 108787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108799 */     GIR_RootConstrainSelectedInstOperands,
     /* 108800 */     // GIR_Coverage, 17047,
     /* 108800 */     GIR_EraseRootFromParent_Done,
     /* 108801 */   // Label 2309: @108801
     /* 108801 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(108854), // Rule ID 17049 //
     /* 108806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108824 */     // MIs[0] src1
     /* 108824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108835 */     // MIs[1] Operand 1
     /* 108835 */     // No operand predicates
     /* 108835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108837 */     // (intrinsic_w_chain:{ *:[v32f16] } 14901:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 108840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108842 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108852 */     GIR_RootConstrainSelectedInstOperands,
     /* 108853 */     // GIR_Coverage, 17049,
     /* 108853 */     GIR_EraseRootFromParent_Done,
     /* 108854 */   // Label 2310: @108854
     /* 108854 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(108907), // Rule ID 17050 //
     /* 108859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108877 */     // MIs[0] src1
     /* 108877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108888 */     // MIs[1] Operand 1
     /* 108888 */     // No operand predicates
     /* 108888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108890 */     // (intrinsic_w_chain:{ *:[v16i32] } 14932:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 108893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108895 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108905 */     GIR_RootConstrainSelectedInstOperands,
     /* 108906 */     // GIR_Coverage, 17050,
     /* 108906 */     GIR_EraseRootFromParent_Done,
     /* 108907 */   // Label 2311: @108907
     /* 108907 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(108952), // Rule ID 17039 //
     /* 108912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108930 */     // MIs[0] src1
     /* 108930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108937 */     // (intrinsic_w_chain:{ *:[v16f32] } 14893:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 108940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108950 */     GIR_RootConstrainSelectedInstOperands,
     /* 108951 */     // GIR_Coverage, 17039,
     /* 108951 */     GIR_EraseRootFromParent_Done,
     /* 108952 */   // Label 2312: @108952
     /* 108952 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(108997), // Rule ID 17046 //
     /* 108957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108975 */     // MIs[0] src1
     /* 108975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108982 */     // (intrinsic_w_chain:{ *:[v32f16] } 14899:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 108985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108987 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108989 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108995 */     GIR_RootConstrainSelectedInstOperands,
     /* 108996 */     // GIR_Coverage, 17046,
     /* 108996 */     GIR_EraseRootFromParent_Done,
     /* 108997 */   // Label 2313: @108997
     /* 108997 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(109042), // Rule ID 17048 //
     /* 109002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 109005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 109010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 109013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109020 */     // MIs[0] src1
     /* 109020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 109023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109027 */     // (intrinsic_w_chain:{ *:[v32f16] } 14901:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 109030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109034 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109040 */     GIR_RootConstrainSelectedInstOperands,
     /* 109041 */     // GIR_Coverage, 17048,
     /* 109041 */     GIR_EraseRootFromParent_Done,
     /* 109042 */   // Label 2314: @109042
     /* 109042 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(109087), // Rule ID 17051 //
     /* 109047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 109050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 109055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 109058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109065 */     // MIs[0] src1
     /* 109065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 109068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109072 */     // (intrinsic_w_chain:{ *:[v16i32] } 14932:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 109075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109077 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109079 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109085 */     GIR_RootConstrainSelectedInstOperands,
     /* 109086 */     // GIR_Coverage, 17051,
     /* 109086 */     GIR_EraseRootFromParent_Done,
     /* 109087 */   // Label 2315: @109087
     /* 109087 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(109132), // Rule ID 122 //
     /* 109092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 109095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 109100 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109114 */     // MIs[0] cntl
     /* 109114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 109117 */     // (intrinsic_void 14573:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 109117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 109120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 109122 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109124 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 109126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109130 */     GIR_RootConstrainSelectedInstOperands,
     /* 109131 */     // GIR_Coverage, 122,
     /* 109131 */     GIR_EraseRootFromParent_Done,
     /* 109132 */   // Label 2316: @109132
     /* 109132 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(109177), // Rule ID 124 //
     /* 109137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 109140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 109145 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109159 */     // MIs[0] cntl
     /* 109159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 109162 */     // (intrinsic_void 14574:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 109162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 109165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 109167 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109169 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 109171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109175 */     GIR_RootConstrainSelectedInstOperands,
     /* 109176 */     // GIR_Coverage, 124,
     /* 109176 */     GIR_EraseRootFromParent_Done,
     /* 109177 */   // Label 2317: @109177
     /* 109177 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(109259), // Rule ID 17104 //
     /* 109182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 109187 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 109200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 109204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109208 */     // (intrinsic_void 15069:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 109208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109212 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109218 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 109222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109226 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109232 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 109236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109240 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 109250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 109253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109257 */     GIR_RootConstrainSelectedInstOperands,
     /* 109258 */     // GIR_Coverage, 17104,
     /* 109258 */     GIR_EraseRootFromParent_Done,
     /* 109259 */   // Label 2318: @109259
     /* 109259 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(109308), // Rule ID 17293 //
     /* 109264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 109267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 109272 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109293 */     // (intrinsic_void 14651:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 109293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 109296 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 109298 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 109300 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 109302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109306 */     GIR_RootConstrainSelectedInstOperands,
     /* 109307 */     // GIR_Coverage, 17293,
     /* 109307 */     GIR_EraseRootFromParent_Done,
     /* 109308 */   // Label 2319: @109308
     /* 109308 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(109370), // Rule ID 2903 //
     /* 109313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 109316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109321 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109335 */     // MIs[0] Operand 3
     /* 109335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109343 */     // (intrinsic_void 14749:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109347 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 109360 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109362 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109368 */     GIR_RootConstrainSelectedInstOperands,
     /* 109369 */     // GIR_Coverage, 2903,
     /* 109369 */     GIR_EraseRootFromParent_Done,
     /* 109370 */   // Label 2320: @109370
     /* 109370 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(109432), // Rule ID 2904 //
     /* 109375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 109378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109383 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109397 */     // MIs[0] Operand 3
     /* 109397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109405 */     // (intrinsic_void 14749:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109409 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 109422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109424 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109430 */     GIR_RootConstrainSelectedInstOperands,
     /* 109431 */     // GIR_Coverage, 2904,
     /* 109431 */     GIR_EraseRootFromParent_Done,
     /* 109432 */   // Label 2321: @109432
     /* 109432 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(109494), // Rule ID 2905 //
     /* 109437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 109440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109445 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109459 */     // MIs[0] Operand 3
     /* 109459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109467 */     // (intrinsic_void 14749:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109471 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 109484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109486 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109492 */     GIR_RootConstrainSelectedInstOperands,
     /* 109493 */     // GIR_Coverage, 2905,
     /* 109493 */     GIR_EraseRootFromParent_Done,
     /* 109494 */   // Label 2322: @109494
     /* 109494 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(109556), // Rule ID 2906 //
     /* 109499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 109502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109507 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109521 */     // MIs[0] Operand 3
     /* 109521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109529 */     // (intrinsic_void 14749:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109533 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 109546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109548 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109554 */     GIR_RootConstrainSelectedInstOperands,
     /* 109555 */     // GIR_Coverage, 2906,
     /* 109555 */     GIR_EraseRootFromParent_Done,
     /* 109556 */   // Label 2323: @109556
     /* 109556 */   GIM_Reject,
     /* 109557 */ // Label 2258: @109557
     /* 109557 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(109645), // Rule ID 16988 //
     /* 109562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 109565 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 109568 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 109573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 109579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 109582 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 109585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109597 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109601 */   // (intrinsic_void 14570:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 109601 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109605 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109611 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 109615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109619 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109625 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 109629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 109632 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109634 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109636 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 109639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109643 */   GIR_RootConstrainSelectedInstOperands,
     /* 109644 */   // GIR_Coverage, 16988,
     /* 109644 */   GIR_EraseRootFromParent_Done,
     /* 109645 */ // Label 2324: @109645
     /* 109645 */ GIM_Reject,
     /* 109646 */ // Label 19: @109646
     /* 109646 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2328*/ GIMT_Encode4(110080),
     /* 109657 */ /*GILLT_s16*//*Label 2325*/ GIMT_Encode4(109669),
     /* 109661 */ /*GILLT_s32*//*Label 2326*/ GIMT_Encode4(109727),
     /* 109665 */ /*GILLT_s64*//*Label 2327*/ GIMT_Encode4(109902),
     /* 109669 */ // Label 2325: @109669
     /* 109669 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(109726), // Rule ID 22590 //
     /* 109674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109685 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 109685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109697 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109708 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 109715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109725 */   // GIR_Coverage, 22590,
     /* 109725 */   GIR_EraseRootFromParent_Done,
     /* 109726 */ // Label 2329: @109726
     /* 109726 */ GIM_Reject,
     /* 109727 */ // Label 2326: @109727
     /* 109727 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(109773), // Rule ID 19437 //
     /* 109732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109747 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109751 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109758 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 109758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109767 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109772 */   // GIR_Coverage, 19437,
     /* 109772 */   GIR_EraseRootFromParent_Done,
     /* 109773 */ // Label 2330: @109773
     /* 109773 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(109819), // Rule ID 19440 //
     /* 109778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109793 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 109797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 109802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109804 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 109804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109809 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109818 */   // GIR_Coverage, 19440,
     /* 109818 */   GIR_EraseRootFromParent_Done,
     /* 109819 */ // Label 2331: @109819
     /* 109819 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(109842), // Rule ID 22591 //
     /* 109824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109835 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 109835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109840 */   GIR_RootConstrainSelectedInstOperands,
     /* 109841 */   // GIR_Coverage, 22591,
     /* 109841 */   GIR_Done,
     /* 109842 */ // Label 2332: @109842
     /* 109842 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(109901), // Rule ID 22592 //
     /* 109847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109858 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 109858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 109885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109890 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109895 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 109900 */   // GIR_Coverage, 22592,
     /* 109900 */   GIR_EraseRootFromParent_Done,
     /* 109901 */ // Label 2333: @109901
     /* 109901 */ GIM_Reject,
     /* 109902 */ // Label 2327: @109902
     /* 109902 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(109961), // Rule ID 22593 //
     /* 109907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109918 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 109918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109930 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109960 */   // GIR_Coverage, 22593,
     /* 109960 */   GIR_EraseRootFromParent_Done,
     /* 109961 */ // Label 2334: @109961
     /* 109961 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(110020), // Rule ID 22594 //
     /* 109966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109977 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 109977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 109984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109989 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110019 */   // GIR_Coverage, 22594,
     /* 110019 */   GIR_EraseRootFromParent_Done,
     /* 110020 */ // Label 2335: @110020
     /* 110020 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(110079), // Rule ID 22595 //
     /* 110025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 110032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110036 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 110036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 110039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110058 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 110073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110078 */   // GIR_Coverage, 22595,
     /* 110078 */   GIR_EraseRootFromParent_Done,
     /* 110079 */ // Label 2336: @110079
     /* 110079 */ GIM_Reject,
     /* 110080 */ // Label 2328: @110080
     /* 110080 */ GIM_Reject,
     /* 110081 */ // Label 20: @110081
     /* 110081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 2345*/ GIMT_Encode4(111169),
     /* 110092 */ /*GILLT_s8*//*Label 2337*/ GIMT_Encode4(110176),
     /* 110096 */ /*GILLT_s16*//*Label 2338*/ GIMT_Encode4(110460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110128 */ /*GILLT_v4s32*//*Label 2339*/ GIMT_Encode4(110499), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110140 */ /*GILLT_v8s16*//*Label 2340*/ GIMT_Encode4(110639),
     /* 110144 */ /*GILLT_v8s32*//*Label 2341*/ GIMT_Encode4(110802), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110156 */ /*GILLT_v16s8*//*Label 2342*/ GIMT_Encode4(110829),
     /* 110160 */ /*GILLT_v16s16*//*Label 2343*/ GIMT_Encode4(111115), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110172 */ /*GILLT_v32s8*//*Label 2344*/ GIMT_Encode4(111142),
     /* 110176 */ // Label 2337: @110176
     /* 110176 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(110251), // Rule ID 19432 //
     /* 110181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 110196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 110200 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 110205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110207 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 110223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 110228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110233 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110250 */   // GIR_Coverage, 19432,
     /* 110250 */   GIR_EraseRootFromParent_Done,
     /* 110251 */ // Label 2346: @110251
     /* 110251 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(110314), // Rule ID 22652 //
     /* 110256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110270 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110282 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110286 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110296 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110313 */   // GIR_Coverage, 22652,
     /* 110313 */   GIR_EraseRootFromParent_Done,
     /* 110314 */ // Label 2347: @110314
     /* 110314 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(110377), // Rule ID 22653 //
     /* 110319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110333 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110345 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110359 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110376 */   // GIR_Coverage, 22653,
     /* 110376 */   GIR_EraseRootFromParent_Done,
     /* 110377 */ // Label 2348: @110377
     /* 110377 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(110418), // Rule ID 22657 //
     /* 110382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110396 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 110396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110401 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110407 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110417 */   // GIR_Coverage, 22657,
     /* 110417 */   GIR_EraseRootFromParent_Done,
     /* 110418 */ // Label 2349: @110418
     /* 110418 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(110459), // Rule ID 22658 //
     /* 110423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110437 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 110437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110442 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 110458 */   // GIR_Coverage, 22658,
     /* 110458 */   GIR_EraseRootFromParent_Done,
     /* 110459 */ // Label 2350: @110459
     /* 110459 */ GIM_Reject,
     /* 110460 */ // Label 2338: @110460
     /* 110460 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(110498), // Rule ID 22651 //
     /* 110465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110476 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 110476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110481 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 110487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110497 */   // GIR_Coverage, 22651,
     /* 110497 */   GIR_EraseRootFromParent_Done,
     /* 110498 */ // Label 2351: @110498
     /* 110498 */ GIM_Reject,
     /* 110499 */ // Label 2339: @110499
     /* 110499 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(110638),
     /* 110504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 110507 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(110530), // Rule ID 12262 //
     /* 110512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110523 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 110523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 110528 */     GIR_RootConstrainSelectedInstOperands,
     /* 110529 */     // GIR_Coverage, 12262,
     /* 110529 */     GIR_Done,
     /* 110530 */   // Label 2353: @110530
     /* 110530 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(110637), // Rule ID 21557 //
     /* 110535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110546 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110546 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 110549 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110553 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110560 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 110563 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110567 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110572 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110579 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 110600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110619 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110636 */     // GIR_Coverage, 21557,
     /* 110636 */     GIR_EraseRootFromParent_Done,
     /* 110637 */   // Label 2354: @110637
     /* 110637 */   GIM_Reject,
     /* 110638 */ // Label 2352: @110638
     /* 110638 */ GIM_Reject,
     /* 110639 */ // Label 2340: @110639
     /* 110639 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(110665), // Rule ID 12238 //
     /* 110644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110658 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 110658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 110663 */   GIR_RootConstrainSelectedInstOperands,
     /* 110664 */   // GIR_Coverage, 12238,
     /* 110664 */   GIR_Done,
     /* 110665 */ // Label 2355: @110665
     /* 110665 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(110691), // Rule ID 12316 //
     /* 110670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110684 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 110684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 110689 */   GIR_RootConstrainSelectedInstOperands,
     /* 110690 */   // GIR_Coverage, 12316,
     /* 110690 */   GIR_Done,
     /* 110691 */ // Label 2356: @110691
     /* 110691 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(110801), // Rule ID 21556 //
     /* 110696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110710 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110710 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 110713 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110717 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110724 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 110727 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110731 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110736 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110739 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110743 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110746 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110751 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110756 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 110764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110773 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110783 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110800 */   // GIR_Coverage, 21556,
     /* 110800 */   GIR_EraseRootFromParent_Done,
     /* 110801 */ // Label 2357: @110801
     /* 110801 */ GIM_Reject,
     /* 110802 */ // Label 2341: @110802
     /* 110802 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(110828), // Rule ID 12265 //
     /* 110807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110821 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 110821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110826 */   GIR_RootConstrainSelectedInstOperands,
     /* 110827 */   // GIR_Coverage, 12265,
     /* 110827 */   GIR_Done,
     /* 110828 */ // Label 2358: @110828
     /* 110828 */ GIM_Reject,
     /* 110829 */ // Label 2342: @110829
     /* 110829 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(110905), // Rule ID 21650 //
     /* 110834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110844 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110848 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 110852 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 110859 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 110863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110865 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 110872 */   // (trunc:{ *:[v16i8] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src))
     /* 110872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 110879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110884 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /* 110888 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110903 */   GIR_RootConstrainSelectedInstOperands,
     /* 110904 */   // GIR_Coverage, 21650,
     /* 110904 */   GIR_EraseRootFromParent_Done,
     /* 110905 */ // Label 2359: @110905
     /* 110905 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(110931), // Rule ID 12292 //
     /* 110910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110924 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 110924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110929 */   GIR_RootConstrainSelectedInstOperands,
     /* 110930 */   // GIR_Coverage, 12292,
     /* 110930 */   GIR_Done,
     /* 110931 */ // Label 2360: @110931
     /* 110931 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(110957), // Rule ID 12343 //
     /* 110936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 110939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110950 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 110950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 110955 */   GIR_RootConstrainSelectedInstOperands,
     /* 110956 */   // GIR_Coverage, 12343,
     /* 110956 */   GIR_Done,
     /* 110957 */ // Label 2361: @110957
     /* 110957 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(111067), // Rule ID 21558 //
     /* 110962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 110965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110976 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110976 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 110979 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110983 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110990 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 110993 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110997 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111002 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 111005 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111009 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 111012 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 111017 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 111022 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 111027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 111030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 111034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111039 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 111042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111049 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 111056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 111061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 111066 */   // GIR_Coverage, 21558,
     /* 111066 */   GIR_EraseRootFromParent_Done,
     /* 111067 */ // Label 2362: @111067
     /* 111067 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(111114), // Rule ID 21649 //
     /* 111072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 111075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 111078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 111082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111086 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 111086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 111089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 111093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111098 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 111107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111112 */   GIR_RootConstrainSelectedInstOperands,
     /* 111113 */   // GIR_Coverage, 21649,
     /* 111113 */   GIR_EraseRootFromParent_Done,
     /* 111114 */ // Label 2363: @111114
     /* 111114 */ GIM_Reject,
     /* 111115 */ // Label 2343: @111115
     /* 111115 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(111141), // Rule ID 12319 //
     /* 111120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 111123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 111126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 111134 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 111134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 111139 */   GIR_RootConstrainSelectedInstOperands,
     /* 111140 */   // GIR_Coverage, 12319,
     /* 111140 */   GIR_Done,
     /* 111141 */ // Label 2364: @111141
     /* 111141 */ GIM_Reject,
     /* 111142 */ // Label 2344: @111142
     /* 111142 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(111168), // Rule ID 12346 //
     /* 111147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 111150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 111153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 111161 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 111161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 111166 */   GIR_RootConstrainSelectedInstOperands,
     /* 111167 */   // GIR_Coverage, 12346,
     /* 111167 */   GIR_Done,
     /* 111168 */ // Label 2365: @111168
     /* 111168 */ GIM_Reject,
     /* 111169 */ // Label 2345: @111169
     /* 111169 */ GIM_Reject,
     /* 111170 */ // Label 21: @111170
     /* 111170 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2370*/ GIMT_Encode4(111775),
     /* 111181 */ /*GILLT_s8*//*Label 2366*/ GIMT_Encode4(111197),
     /* 111185 */ /*GILLT_s16*//*Label 2367*/ GIMT_Encode4(111279),
     /* 111189 */ /*GILLT_s32*//*Label 2368*/ GIMT_Encode4(111479),
     /* 111193 */ /*GILLT_s64*//*Label 2369*/ GIMT_Encode4(111621),
     /* 111197 */ // Label 2366: @111197
     /* 111197 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(111278),
     /* 111202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111206 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(111262), // Rule ID 22384 //
     /* 111211 */     // MIs[0] Operand 1
     /* 111211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111222 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 111222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111234 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 111251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 111256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111261 */     // GIR_Coverage, 22384,
     /* 111261 */     GIR_EraseRootFromParent_Done,
     /* 111262 */   // Label 2372: @111262
     /* 111262 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(111277), // Rule ID 19 //
     /* 111267 */     // MIs[0] Operand 1
     /* 111267 */     // No operand predicates
     /* 111267 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 111267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 111270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111275 */     GIR_RootConstrainSelectedInstOperands,
     /* 111276 */     // GIR_Coverage, 19,
     /* 111276 */     GIR_EraseRootFromParent_Done,
     /* 111277 */   // Label 2373: @111277
     /* 111277 */   GIM_Reject,
     /* 111278 */ // Label 2371: @111278
     /* 111278 */ GIM_Reject,
     /* 111279 */ // Label 2367: @111279
     /* 111279 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(111478),
     /* 111284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111288 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(111344), // Rule ID 22385 //
     /* 111293 */     // MIs[0] Operand 1
     /* 111293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111304 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111316 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111326 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111343 */     // GIR_Coverage, 22385,
     /* 111343 */     GIR_EraseRootFromParent_Done,
     /* 111344 */   // Label 2375: @111344
     /* 111344 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(111403), // Rule ID 22387 //
     /* 111349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111352 */     // MIs[0] Operand 1
     /* 111352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111363 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111375 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111385 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111402 */     // GIR_Coverage, 22387,
     /* 111402 */     GIR_EraseRootFromParent_Done,
     /* 111403 */   // Label 2376: @111403
     /* 111403 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(111462), // Rule ID 22388 //
     /* 111408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111411 */     // MIs[0] Operand 1
     /* 111411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111422 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111434 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111444 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111461 */     // GIR_Coverage, 22388,
     /* 111461 */     GIR_EraseRootFromParent_Done,
     /* 111462 */   // Label 2377: @111462
     /* 111462 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(111477), // Rule ID 20 //
     /* 111467 */     // MIs[0] Operand 1
     /* 111467 */     // No operand predicates
     /* 111467 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 111467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 111470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111475 */     GIR_RootConstrainSelectedInstOperands,
     /* 111476 */     // GIR_Coverage, 20,
     /* 111476 */     GIR_EraseRootFromParent_Done,
     /* 111477 */   // Label 2378: @111477
     /* 111477 */   GIM_Reject,
     /* 111478 */ // Label 2374: @111478
     /* 111478 */ GIM_Reject,
     /* 111479 */ // Label 2368: @111479
     /* 111479 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(111509), // Rule ID 17153 //
     /* 111484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111488 */   // MIs[0] Operand 1
     /* 111488 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111499 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 111499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111504 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111507 */   GIR_RootConstrainSelectedInstOperands,
     /* 111508 */   // GIR_Coverage, 17153,
     /* 111508 */   GIR_EraseRootFromParent_Done,
     /* 111509 */ // Label 2379: @111509
     /* 111509 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(111542), // Rule ID 17154 //
     /* 111514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111521 */   // MIs[0] Operand 1
     /* 111521 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111532 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 111532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111537 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111540 */   GIR_RootConstrainSelectedInstOperands,
     /* 111541 */   // GIR_Coverage, 17154,
     /* 111541 */   GIR_EraseRootFromParent_Done,
     /* 111542 */ // Label 2380: @111542
     /* 111542 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(111575), // Rule ID 17155 //
     /* 111547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111554 */   // MIs[0] Operand 1
     /* 111554 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111565 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 111565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111570 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111573 */   GIR_RootConstrainSelectedInstOperands,
     /* 111574 */   // GIR_Coverage, 17155,
     /* 111574 */   GIR_EraseRootFromParent_Done,
     /* 111575 */ // Label 2381: @111575
     /* 111575 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(111601), // Rule ID 17156 //
     /* 111580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111583 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 111587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111591 */   // MIs[0] Operand 1
     /* 111591 */   // No operand predicates
     /* 111591 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 111594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111596 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111599 */   GIR_RootConstrainSelectedInstOperands,
     /* 111600 */   // GIR_Coverage, 17156,
     /* 111600 */   GIR_EraseRootFromParent_Done,
     /* 111601 */ // Label 2382: @111601
     /* 111601 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(111620), // Rule ID 21 //
     /* 111606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111610 */   // MIs[0] Operand 1
     /* 111610 */   // No operand predicates
     /* 111610 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 111613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111615 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111618 */   GIR_RootConstrainSelectedInstOperands,
     /* 111619 */   // GIR_Coverage, 21,
     /* 111619 */   GIR_EraseRootFromParent_Done,
     /* 111620 */ // Label 2383: @111620
     /* 111620 */ GIM_Reject,
     /* 111621 */ // Label 2369: @111621
     /* 111621 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(111683), // Rule ID 22386 //
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111630 */   // MIs[0] Operand 1
     /* 111630 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111641 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 111641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111653 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 111672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 111677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 111682 */   // GIR_Coverage, 22386,
     /* 111682 */   GIR_EraseRootFromParent_Done,
     /* 111683 */ // Label 2384: @111683
     /* 111683 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(111709), // Rule ID 17157 //
     /* 111688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111691 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 111695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111699 */   // MIs[0] Operand 1
     /* 111699 */   // No operand predicates
     /* 111699 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 111702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111704 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111707 */   GIR_RootConstrainSelectedInstOperands,
     /* 111708 */   // GIR_Coverage, 17157,
     /* 111708 */   GIR_EraseRootFromParent_Done,
     /* 111709 */ // Label 2385: @111709
     /* 111709 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(111732), // Rule ID 17158 //
     /* 111714 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 111718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111722 */   // MIs[0] Operand 1
     /* 111722 */   // No operand predicates
     /* 111722 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 111725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111727 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111730 */   GIR_RootConstrainSelectedInstOperands,
     /* 111731 */   // GIR_Coverage, 17158,
     /* 111731 */   GIR_EraseRootFromParent_Done,
     /* 111732 */ // Label 2386: @111732
     /* 111732 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(111755), // Rule ID 22 //
     /* 111737 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 111741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111745 */   // MIs[0] Operand 1
     /* 111745 */   // No operand predicates
     /* 111745 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 111748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111750 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111753 */   GIR_RootConstrainSelectedInstOperands,
     /* 111754 */   // GIR_Coverage, 22,
     /* 111754 */   GIR_EraseRootFromParent_Done,
     /* 111755 */ // Label 2387: @111755
     /* 111755 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(111774), // Rule ID 23 //
     /* 111760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111764 */   // MIs[0] Operand 1
     /* 111764 */   // No operand predicates
     /* 111764 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 111767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111769 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111772 */   GIR_RootConstrainSelectedInstOperands,
     /* 111773 */   // GIR_Coverage, 23,
     /* 111773 */   GIR_EraseRootFromParent_Done,
     /* 111774 */ // Label 2388: @111774
     /* 111774 */ GIM_Reject,
     /* 111775 */ // Label 2370: @111775
     /* 111775 */ GIM_Reject,
     /* 111776 */ // Label 22: @111776
     /* 111776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2392*/ GIMT_Encode4(112228),
     /* 111787 */ /*GILLT_s32*//*Label 2389*/ GIMT_Encode4(111799),
     /* 111791 */ /*GILLT_s64*//*Label 2390*/ GIMT_Encode4(111944),
     /* 111795 */ /*GILLT_s80*//*Label 2391*/ GIMT_Encode4(112089),
     /* 111799 */ // Label 2389: @111799
     /* 111799 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(111825), // Rule ID 1116 //
     /* 111804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111807 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111815 */   // MIs[0] Operand 1
     /* 111815 */   // No operand predicates
     /* 111815 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 111815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111820 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111823 */   GIR_RootConstrainSelectedInstOperands,
     /* 111824 */   // GIR_Coverage, 1116,
     /* 111824 */   GIR_EraseRootFromParent_Done,
     /* 111825 */ // Label 2393: @111825
     /* 111825 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(111851), // Rule ID 1117 //
     /* 111830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111833 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111841 */   // MIs[0] Operand 1
     /* 111841 */   // No operand predicates
     /* 111841 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 111841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111846 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111849 */   GIR_RootConstrainSelectedInstOperands,
     /* 111850 */   // GIR_Coverage, 1117,
     /* 111850 */   GIR_EraseRootFromParent_Done,
     /* 111851 */ // Label 2394: @111851
     /* 111851 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(111897), // Rule ID 17720 //
     /* 111856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111859 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111867 */   // MIs[0] Operand 1
     /* 111867 */   // No operand predicates
     /* 111867 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 111867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111879 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111892 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111895 */   GIR_RootConstrainSelectedInstOperands,
     /* 111896 */   // GIR_Coverage, 17720,
     /* 111896 */   GIR_EraseRootFromParent_Done,
     /* 111897 */ // Label 2395: @111897
     /* 111897 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(111943), // Rule ID 17721 //
     /* 111902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111905 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111913 */   // MIs[0] Operand 1
     /* 111913 */   // No operand predicates
     /* 111913 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 111913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111925 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111938 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111941 */   GIR_RootConstrainSelectedInstOperands,
     /* 111942 */   // GIR_Coverage, 17721,
     /* 111942 */   GIR_EraseRootFromParent_Done,
     /* 111943 */ // Label 2396: @111943
     /* 111943 */ GIM_Reject,
     /* 111944 */ // Label 2390: @111944
     /* 111944 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(111970), // Rule ID 1118 //
     /* 111949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111952 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111960 */   // MIs[0] Operand 1
     /* 111960 */   // No operand predicates
     /* 111960 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 111960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111965 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111968 */   GIR_RootConstrainSelectedInstOperands,
     /* 111969 */   // GIR_Coverage, 1118,
     /* 111969 */   GIR_EraseRootFromParent_Done,
     /* 111970 */ // Label 2397: @111970
     /* 111970 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(111996), // Rule ID 1119 //
     /* 111975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111978 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111986 */   // MIs[0] Operand 1
     /* 111986 */   // No operand predicates
     /* 111986 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 111986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111991 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111994 */   GIR_RootConstrainSelectedInstOperands,
     /* 111995 */   // GIR_Coverage, 1119,
     /* 111995 */   GIR_EraseRootFromParent_Done,
     /* 111996 */ // Label 2398: @111996
     /* 111996 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(112042), // Rule ID 17722 //
     /* 112001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 112004 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 112008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112012 */   // MIs[0] Operand 1
     /* 112012 */   // No operand predicates
     /* 112012 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 112012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 112019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112024 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 112032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112037 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112040 */   GIR_RootConstrainSelectedInstOperands,
     /* 112041 */   // GIR_Coverage, 17722,
     /* 112041 */   GIR_EraseRootFromParent_Done,
     /* 112042 */ // Label 2399: @112042
     /* 112042 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(112088), // Rule ID 17723 //
     /* 112047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 112050 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 112054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112058 */   // MIs[0] Operand 1
     /* 112058 */   // No operand predicates
     /* 112058 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 112058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 112065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112070 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 112078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112083 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112086 */   GIR_RootConstrainSelectedInstOperands,
     /* 112087 */   // GIR_Coverage, 17723,
     /* 112087 */   GIR_EraseRootFromParent_Done,
     /* 112088 */ // Label 2400: @112088
     /* 112088 */ GIM_Reject,
     /* 112089 */ // Label 2391: @112089
     /* 112089 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(112115), // Rule ID 1120 //
     /* 112094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 112097 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 112101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112105 */   // MIs[0] Operand 1
     /* 112105 */   // No operand predicates
     /* 112105 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 112105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 112108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112110 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112113 */   GIR_RootConstrainSelectedInstOperands,
     /* 112114 */   // GIR_Coverage, 1120,
     /* 112114 */   GIR_EraseRootFromParent_Done,
     /* 112115 */ // Label 2401: @112115
     /* 112115 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(112141), // Rule ID 1121 //
     /* 112120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 112123 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 112127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112131 */   // MIs[0] Operand 1
     /* 112131 */   // No operand predicates
     /* 112131 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 112131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112136 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112139 */   GIR_RootConstrainSelectedInstOperands,
     /* 112140 */   // GIR_Coverage, 1121,
     /* 112140 */   GIR_EraseRootFromParent_Done,
     /* 112141 */ // Label 2402: @112141
     /* 112141 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(112184), // Rule ID 17724 //
     /* 112146 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 112150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112154 */   // MIs[0] Operand 1
     /* 112154 */   // No operand predicates
     /* 112154 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 112154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 112161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112166 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112179 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112182 */   GIR_RootConstrainSelectedInstOperands,
     /* 112183 */   // GIR_Coverage, 17724,
     /* 112183 */   GIR_EraseRootFromParent_Done,
     /* 112184 */ // Label 2403: @112184
     /* 112184 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(112227), // Rule ID 17725 //
     /* 112189 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 112193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112197 */   // MIs[0] Operand 1
     /* 112197 */   // No operand predicates
     /* 112197 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 112197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112209 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112222 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112225 */   GIR_RootConstrainSelectedInstOperands,
     /* 112226 */   // GIR_Coverage, 17725,
     /* 112226 */   GIR_EraseRootFromParent_Done,
     /* 112227 */ // Label 2404: @112227
     /* 112227 */ GIM_Reject,
     /* 112228 */ // Label 2392: @112228
     /* 112228 */ GIM_Reject,
     /* 112229 */ // Label 23: @112229
     /* 112229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2420*/ GIMT_Encode4(113900),
     /* 112240 */ /*GILLT_s16*//*Label 2405*/ GIMT_Encode4(112332),
     /* 112244 */ /*GILLT_s32*//*Label 2406*/ GIMT_Encode4(112390),
     /* 112248 */ /*GILLT_s64*//*Label 2407*/ GIMT_Encode4(112437), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112264 */ /*GILLT_v2s64*//*Label 2408*/ GIMT_Encode4(112510), GIMT_Encode4(0),
     /* 112272 */ /*GILLT_v4s32*//*Label 2409*/ GIMT_Encode4(112537),
     /* 112276 */ /*GILLT_v4s64*//*Label 2410*/ GIMT_Encode4(112564), GIMT_Encode4(0),
     /* 112284 */ /*GILLT_v8s16*//*Label 2411*/ GIMT_Encode4(112761),
     /* 112288 */ /*GILLT_v8s32*//*Label 2412*/ GIMT_Encode4(112830),
     /* 112292 */ /*GILLT_v8s64*//*Label 2413*/ GIMT_Encode4(113027), GIMT_Encode4(0),
     /* 112300 */ /*GILLT_v16s8*//*Label 2414*/ GIMT_Encode4(113224),
     /* 112304 */ /*GILLT_v16s16*//*Label 2415*/ GIMT_Encode4(113293),
     /* 112308 */ /*GILLT_v16s32*//*Label 2416*/ GIMT_Encode4(113537), GIMT_Encode4(0),
     /* 112316 */ /*GILLT_v32s8*//*Label 2417*/ GIMT_Encode4(113734),
     /* 112320 */ /*GILLT_v32s16*//*Label 2418*/ GIMT_Encode4(113761), GIMT_Encode4(0),
     /* 112328 */ /*GILLT_v64s8*//*Label 2419*/ GIMT_Encode4(113873),
     /* 112332 */ // Label 2405: @112332
     /* 112332 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(112389), // Rule ID 22647 //
     /* 112337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112348 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 112348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112371 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 112378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 112383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 112388 */   // GIR_Coverage, 22647,
     /* 112388 */   GIR_EraseRootFromParent_Done,
     /* 112389 */ // Label 2421: @112389
     /* 112389 */ GIM_Reject,
     /* 112390 */ // Label 2406: @112390
     /* 112390 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(112413), // Rule ID 614 //
     /* 112395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112406 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 112406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112411 */   GIR_RootConstrainSelectedInstOperands,
     /* 112412 */   // GIR_Coverage, 614,
     /* 112412 */   GIR_Done,
     /* 112413 */ // Label 2422: @112413
     /* 112413 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(112436), // Rule ID 616 //
     /* 112418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112429 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 112429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 112434 */   GIR_RootConstrainSelectedInstOperands,
     /* 112435 */   // GIR_Coverage, 616,
     /* 112435 */   GIR_Done,
     /* 112436 */ // Label 2423: @112436
     /* 112436 */ GIM_Reject,
     /* 112437 */ // Label 2407: @112437
     /* 112437 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(112460), // Rule ID 622 //
     /* 112442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112453 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 112453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 112458 */   GIR_RootConstrainSelectedInstOperands,
     /* 112459 */   // GIR_Coverage, 622,
     /* 112459 */   GIR_Done,
     /* 112460 */ // Label 2424: @112460
     /* 112460 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(112483), // Rule ID 624 //
     /* 112465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112476 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 112476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 112481 */   GIR_RootConstrainSelectedInstOperands,
     /* 112482 */   // GIR_Coverage, 624,
     /* 112482 */   GIR_Done,
     /* 112483 */ // Label 2425: @112483
     /* 112483 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(112509), // Rule ID 626 //
     /* 112488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 112491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112502 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 112502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 112507 */   GIR_RootConstrainSelectedInstOperands,
     /* 112508 */   // GIR_Coverage, 626,
     /* 112508 */   GIR_Done,
     /* 112509 */ // Label 2426: @112509
     /* 112509 */ GIM_Reject,
     /* 112510 */ // Label 2408: @112510
     /* 112510 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(112536), // Rule ID 12594 //
     /* 112515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 112521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 112529 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 112529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 112534 */   GIR_RootConstrainSelectedInstOperands,
     /* 112535 */   // GIR_Coverage, 12594,
     /* 112535 */   GIR_Done,
     /* 112536 */ // Label 2427: @112536
     /* 112536 */ GIM_Reject,
     /* 112537 */ // Label 2409: @112537
     /* 112537 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(112563), // Rule ID 12591 //
     /* 112542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112556 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 112556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 112561 */   GIR_RootConstrainSelectedInstOperands,
     /* 112562 */   // GIR_Coverage, 12591,
     /* 112562 */   GIR_Done,
     /* 112563 */ // Label 2428: @112563
     /* 112563 */ GIM_Reject,
     /* 112564 */ // Label 2410: @112564
     /* 112564 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(112623), // Rule ID 18390 //
     /* 112569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112587 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112594 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112600 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112607 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrm),
     /* 112610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112612 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112621 */   GIR_RootConstrainSelectedInstOperands,
     /* 112622 */   // GIR_Coverage, 18390,
     /* 112622 */   GIR_EraseRootFromParent_Done,
     /* 112623 */ // Label 2429: @112623
     /* 112623 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(112682), // Rule ID 21585 //
     /* 112628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112646 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112653 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112659 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112666 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rm),
     /* 112669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112671 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112680 */   GIR_RootConstrainSelectedInstOperands,
     /* 112681 */   // GIR_Coverage, 21585,
     /* 112681 */   GIR_EraseRootFromParent_Done,
     /* 112682 */ // Label 2430: @112682
     /* 112682 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(112708), // Rule ID 12571 //
     /* 112687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112701 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 112701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 112706 */   GIR_RootConstrainSelectedInstOperands,
     /* 112707 */   // GIR_Coverage, 12571,
     /* 112707 */   GIR_Done,
     /* 112708 */ // Label 2431: @112708
     /* 112708 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(112734), // Rule ID 12593 //
     /* 112713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112727 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 112727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 112732 */   GIR_RootConstrainSelectedInstOperands,
     /* 112733 */   // GIR_Coverage, 12593,
     /* 112733 */   GIR_Done,
     /* 112734 */ // Label 2432: @112734
     /* 112734 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(112760), // Rule ID 18378 //
     /* 112739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112753 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 112753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 112758 */   GIR_RootConstrainSelectedInstOperands,
     /* 112759 */   // GIR_Coverage, 18378,
     /* 112759 */   GIR_Done,
     /* 112760 */ // Label 2433: @112760
     /* 112760 */ GIM_Reject,
     /* 112761 */ // Label 2411: @112761
     /* 112761 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(112829),
     /* 112766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112777 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(112792), // Rule ID 12588 //
     /* 112782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112785 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 112785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 112790 */     GIR_RootConstrainSelectedInstOperands,
     /* 112791 */     // GIR_Coverage, 12588,
     /* 112791 */     GIR_Done,
     /* 112792 */   // Label 2435: @112792
     /* 112792 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(112828), // Rule ID 21661 //
     /* 112797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 112800 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 112800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 112803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 112821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112826 */     GIR_RootConstrainSelectedInstOperands,
     /* 112827 */     // GIR_Coverage, 21661,
     /* 112827 */     GIR_EraseRootFromParent_Done,
     /* 112828 */   // Label 2436: @112828
     /* 112828 */   GIM_Reject,
     /* 112829 */ // Label 2434: @112829
     /* 112829 */ GIM_Reject,
     /* 112830 */ // Label 2412: @112830
     /* 112830 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(112889), // Rule ID 18386 //
     /* 112835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112845 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112853 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112856 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112860 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112866 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112873 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrm),
     /* 112876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112878 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112887 */   GIR_RootConstrainSelectedInstOperands,
     /* 112888 */   // GIR_Coverage, 18386,
     /* 112888 */   GIR_EraseRootFromParent_Done,
     /* 112889 */ // Label 2437: @112889
     /* 112889 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(112948), // Rule ID 21584 //
     /* 112894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112912 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112915 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112919 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112925 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112932 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rm),
     /* 112935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112937 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112946 */   GIR_RootConstrainSelectedInstOperands,
     /* 112947 */   // GIR_Coverage, 21584,
     /* 112947 */   GIR_EraseRootFromParent_Done,
     /* 112948 */ // Label 2438: @112948
     /* 112948 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(112974), // Rule ID 12535 //
     /* 112953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112967 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 112967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 112972 */   GIR_RootConstrainSelectedInstOperands,
     /* 112973 */   // GIR_Coverage, 12535,
     /* 112973 */   GIR_Done,
     /* 112974 */ // Label 2439: @112974
     /* 112974 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(113000), // Rule ID 12590 //
     /* 112979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112993 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 112993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112998 */   GIR_RootConstrainSelectedInstOperands,
     /* 112999 */   // GIR_Coverage, 12590,
     /* 112999 */   GIR_Done,
     /* 113000 */ // Label 2440: @113000
     /* 113000 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(113026), // Rule ID 18376 //
     /* 113005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 113008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113019 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 113019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 113024 */   GIR_RootConstrainSelectedInstOperands,
     /* 113025 */   // GIR_Coverage, 18376,
     /* 113025 */   GIR_Done,
     /* 113026 */ // Label 2441: @113026
     /* 113026 */ GIM_Reject,
     /* 113027 */ // Label 2413: @113027
     /* 113027 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(113086), // Rule ID 21589 //
     /* 113032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113050 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113053 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113057 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113063 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113070 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 113070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrm),
     /* 113073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113075 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113084 */   GIR_RootConstrainSelectedInstOperands,
     /* 113085 */   // GIR_Coverage, 21589,
     /* 113085 */   GIR_EraseRootFromParent_Done,
     /* 113086 */ // Label 2442: @113086
     /* 113086 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(113145), // Rule ID 21590 //
     /* 113091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 113097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113101 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113105 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113109 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113116 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113122 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113129 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 113129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrm),
     /* 113132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113134 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113143 */   GIR_RootConstrainSelectedInstOperands,
     /* 113144 */   // GIR_Coverage, 21590,
     /* 113144 */   GIR_EraseRootFromParent_Done,
     /* 113145 */ // Label 2443: @113145
     /* 113145 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(113171), // Rule ID 12559 //
     /* 113150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113164 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 113164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 113169 */   GIR_RootConstrainSelectedInstOperands,
     /* 113170 */   // GIR_Coverage, 12559,
     /* 113170 */   GIR_Done,
     /* 113171 */ // Label 2444: @113171
     /* 113171 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(113197), // Rule ID 12577 //
     /* 113176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 113182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113190 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 113190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 113195 */   GIR_RootConstrainSelectedInstOperands,
     /* 113196 */   // GIR_Coverage, 12577,
     /* 113196 */   GIR_Done,
     /* 113197 */ // Label 2445: @113197
     /* 113197 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(113223), // Rule ID 12592 //
     /* 113202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113216 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 113216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 113221 */   GIR_RootConstrainSelectedInstOperands,
     /* 113222 */   // GIR_Coverage, 12592,
     /* 113222 */   GIR_Done,
     /* 113223 */ // Label 2446: @113223
     /* 113223 */ GIM_Reject,
     /* 113224 */ // Label 2414: @113224
     /* 113224 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(113292),
     /* 113229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113240 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(113255), // Rule ID 12585 //
     /* 113245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113248 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 113248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 113253 */     GIR_RootConstrainSelectedInstOperands,
     /* 113254 */     // GIR_Coverage, 12585,
     /* 113254 */     GIR_Done,
     /* 113255 */   // Label 2448: @113255
     /* 113255 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(113291), // Rule ID 21659 //
     /* 113260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113263 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 113284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113289 */     GIR_RootConstrainSelectedInstOperands,
     /* 113290 */     // GIR_Coverage, 21659,
     /* 113290 */     GIR_EraseRootFromParent_Done,
     /* 113291 */   // Label 2449: @113291
     /* 113291 */   GIM_Reject,
     /* 113292 */ // Label 2447: @113292
     /* 113292 */ GIM_Reject,
     /* 113293 */ // Label 2415: @113293
     /* 113293 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(113352), // Rule ID 18380 //
     /* 113298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113316 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113323 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113329 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113336 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrm),
     /* 113339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113341 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113350 */   GIR_RootConstrainSelectedInstOperands,
     /* 113351 */   // GIR_Coverage, 18380,
     /* 113351 */   GIR_EraseRootFromParent_Done,
     /* 113352 */ // Label 2450: @113352
     /* 113352 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(113411), // Rule ID 21583 //
     /* 113357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113375 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113382 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113386 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113388 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113395 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rm),
     /* 113398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113400 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113409 */   GIR_RootConstrainSelectedInstOperands,
     /* 113410 */   // GIR_Coverage, 21583,
     /* 113410 */   GIR_EraseRootFromParent_Done,
     /* 113411 */ // Label 2451: @113411
     /* 113411 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(113437), // Rule ID 12481 //
     /* 113416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113430 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 113430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 113435 */   GIR_RootConstrainSelectedInstOperands,
     /* 113436 */   // GIR_Coverage, 12481,
     /* 113436 */   GIR_Done,
     /* 113437 */ // Label 2452: @113437
     /* 113437 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(113463), // Rule ID 12587 //
     /* 113442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113456 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 113456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 113461 */   GIR_RootConstrainSelectedInstOperands,
     /* 113462 */   // GIR_Coverage, 12587,
     /* 113462 */   GIR_Done,
     /* 113463 */ // Label 2453: @113463
     /* 113463 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(113489), // Rule ID 18373 //
     /* 113468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113482 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 113482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 113487 */   GIR_RootConstrainSelectedInstOperands,
     /* 113488 */   // GIR_Coverage, 18373,
     /* 113488 */   GIR_Done,
     /* 113489 */ // Label 2454: @113489
     /* 113489 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(113536), // Rule ID 21660 //
     /* 113494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113508 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113520 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 113529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113534 */   GIR_RootConstrainSelectedInstOperands,
     /* 113535 */   // GIR_Coverage, 21660,
     /* 113535 */   GIR_EraseRootFromParent_Done,
     /* 113536 */ // Label 2455: @113536
     /* 113536 */ GIM_Reject,
     /* 113537 */ // Label 2416: @113537
     /* 113537 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(113596), // Rule ID 21587 //
     /* 113542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113560 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113563 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113567 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113573 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113580 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrm),
     /* 113583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113585 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113594 */   GIR_RootConstrainSelectedInstOperands,
     /* 113595 */   // GIR_Coverage, 21587,
     /* 113595 */   GIR_EraseRootFromParent_Done,
     /* 113596 */ // Label 2456: @113596
     /* 113596 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(113655), // Rule ID 21588 //
     /* 113601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113619 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113626 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113632 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113639 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrm),
     /* 113642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113644 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113653 */   GIR_RootConstrainSelectedInstOperands,
     /* 113654 */   // GIR_Coverage, 21588,
     /* 113654 */   GIR_EraseRootFromParent_Done,
     /* 113655 */ // Label 2457: @113655
     /* 113655 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(113681), // Rule ID 12505 //
     /* 113660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113674 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 113674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 113679 */   GIR_RootConstrainSelectedInstOperands,
     /* 113680 */   // GIR_Coverage, 12505,
     /* 113680 */   GIR_Done,
     /* 113681 */ // Label 2458: @113681
     /* 113681 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(113707), // Rule ID 12541 //
     /* 113686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113700 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 113700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 113705 */   GIR_RootConstrainSelectedInstOperands,
     /* 113706 */   // GIR_Coverage, 12541,
     /* 113706 */   GIR_Done,
     /* 113707 */ // Label 2459: @113707
     /* 113707 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(113733), // Rule ID 12589 //
     /* 113712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113726 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 113726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113731 */   GIR_RootConstrainSelectedInstOperands,
     /* 113732 */   // GIR_Coverage, 12589,
     /* 113732 */   GIR_Done,
     /* 113733 */ // Label 2460: @113733
     /* 113733 */ GIM_Reject,
     /* 113734 */ // Label 2417: @113734
     /* 113734 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(113760), // Rule ID 12584 //
     /* 113739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113753 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 113753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 113758 */   GIR_RootConstrainSelectedInstOperands,
     /* 113759 */   // GIR_Coverage, 12584,
     /* 113759 */   GIR_Done,
     /* 113760 */ // Label 2461: @113760
     /* 113760 */ GIM_Reject,
     /* 113761 */ // Label 2418: @113761
     /* 113761 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(113820), // Rule ID 21586 //
     /* 113766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113784 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113787 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113791 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113795 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113797 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113804 */   // (sext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 113804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrm),
     /* 113807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113809 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113818 */   GIR_RootConstrainSelectedInstOperands,
     /* 113819 */   // GIR_Coverage, 21586,
     /* 113819 */   GIR_EraseRootFromParent_Done,
     /* 113820 */ // Label 2462: @113820
     /* 113820 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(113846), // Rule ID 12487 //
     /* 113825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113839 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 113839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 113844 */   GIR_RootConstrainSelectedInstOperands,
     /* 113845 */   // GIR_Coverage, 12487,
     /* 113845 */   GIR_Done,
     /* 113846 */ // Label 2463: @113846
     /* 113846 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(113872), // Rule ID 12586 //
     /* 113851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113865 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 113865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 113870 */   GIR_RootConstrainSelectedInstOperands,
     /* 113871 */   // GIR_Coverage, 12586,
     /* 113871 */   GIR_Done,
     /* 113872 */ // Label 2464: @113872
     /* 113872 */ GIM_Reject,
     /* 113873 */ // Label 2419: @113873
     /* 113873 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(113899), // Rule ID 12583 //
     /* 113878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 113884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 113892 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 113892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 113897 */   GIR_RootConstrainSelectedInstOperands,
     /* 113898 */   // GIR_Coverage, 12583,
     /* 113898 */   GIR_Done,
     /* 113899 */ // Label 2465: @113899
     /* 113899 */ GIM_Reject,
     /* 113900 */ // Label 2420: @113900
     /* 113900 */ GIM_Reject,
     /* 113901 */ // Label 24: @113901
     /* 113901 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2468*/ GIMT_Encode4(114142),
     /* 113912 */ /*GILLT_s16*//*Label 2466*/ GIMT_Encode4(113920),
     /* 113916 */ /*GILLT_s32*//*Label 2467*/ GIMT_Encode4(114016),
     /* 113920 */ // Label 2466: @113920
     /* 113920 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(114015), // Rule ID 22643 //
     /* 113925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113936 */   // MIs[0] Operand 2
     /* 113936 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113947 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 113947 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 113950 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113954 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113959 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113965 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113970 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 113975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113987 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113997 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114014 */   // GIR_Coverage, 22643,
     /* 114014 */   GIR_EraseRootFromParent_Done,
     /* 114015 */ // Label 2469: @114015
     /* 114015 */ GIM_Reject,
     /* 114016 */ // Label 2467: @114016
     /* 114016 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(114141),
     /* 114021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114032 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(114086), // Rule ID 22641 //
     /* 114037 */     // MIs[0] Operand 2
     /* 114037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 114048 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 114048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 114066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 114079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114084 */     GIR_RootConstrainSelectedInstOperands,
     /* 114085 */     // GIR_Coverage, 22641,
     /* 114085 */     GIR_EraseRootFromParent_Done,
     /* 114086 */   // Label 2471: @114086
     /* 114086 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(114140), // Rule ID 22642 //
     /* 114091 */     // MIs[0] Operand 2
     /* 114091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 114102 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 114102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 114105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114114 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 114120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 114125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 114133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114138 */     GIR_RootConstrainSelectedInstOperands,
     /* 114139 */     // GIR_Coverage, 22642,
     /* 114139 */     GIR_EraseRootFromParent_Done,
     /* 114140 */   // Label 2472: @114140
     /* 114140 */   GIM_Reject,
     /* 114141 */ // Label 2470: @114141
     /* 114141 */ GIM_Reject,
     /* 114142 */ // Label 2468: @114142
     /* 114142 */ GIM_Reject,
     /* 114143 */ // Label 25: @114143
     /* 114143 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2482*/ GIMT_Encode4(116126),
     /* 114154 */ /*GILLT_s16*//*Label 2473*/ GIMT_Encode4(114238),
     /* 114158 */ /*GILLT_s32*//*Label 2474*/ GIMT_Encode4(114296),
     /* 114162 */ /*GILLT_s64*//*Label 2475*/ GIMT_Encode4(114648), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114190 */ /*GILLT_v4s64*//*Label 2476*/ GIMT_Encode4(115195), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114202 */ /*GILLT_v8s32*//*Label 2477*/ GIMT_Encode4(115363),
     /* 114206 */ /*GILLT_v8s64*//*Label 2478*/ GIMT_Encode4(115531), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114218 */ /*GILLT_v16s16*//*Label 2479*/ GIMT_Encode4(115702),
     /* 114222 */ /*GILLT_v16s32*//*Label 2480*/ GIMT_Encode4(115870), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114234 */ /*GILLT_v32s16*//*Label 2481*/ GIMT_Encode4(116041),
     /* 114238 */ // Label 2473: @114238
     /* 114238 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(114295), // Rule ID 22649 //
     /* 114243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114254 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 114254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114277 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114294 */   // GIR_Coverage, 22649,
     /* 114294 */   GIR_EraseRootFromParent_Done,
     /* 114295 */ // Label 2483: @114295
     /* 114295 */ GIM_Reject,
     /* 114296 */ // Label 2474: @114296
     /* 114296 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(114419), // Rule ID 22973 //
     /* 114301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114319 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114327 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114331 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114335 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114338 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114342 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114346 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114350 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114354 */   // MIs[3] Operand 1
     /* 114354 */   // No operand predicates
     /* 114354 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114356 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114363 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114375 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114379 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114382 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114385 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114418 */   // GIR_Coverage, 22973,
     /* 114418 */   GIR_EraseRootFromParent_Done,
     /* 114419 */ // Label 2484: @114419
     /* 114419 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(114514), // Rule ID 22972 //
     /* 114424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114446 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114450 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114455 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114459 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114463 */   // MIs[2] Operand 1
     /* 114463 */   // No operand predicates
     /* 114463 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114465 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114477 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114481 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114484 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114513 */   // GIR_Coverage, 22972,
     /* 114513 */   GIR_EraseRootFromParent_Done,
     /* 114514 */ // Label 2485: @114514
     /* 114514 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(114556), // Rule ID 19435 //
     /* 114519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114534 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114538 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114545 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 114545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114550 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114554 */   GIR_RootConstrainSelectedInstOperands,
     /* 114555 */   // GIR_Coverage, 19435,
     /* 114555 */   GIR_EraseRootFromParent_Done,
     /* 114556 */ // Label 2486: @114556
     /* 114556 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(114601), // Rule ID 19438 //
     /* 114561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114579 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114583 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114588 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114590 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 114590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114595 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114599 */   GIR_RootConstrainSelectedInstOperands,
     /* 114600 */   // GIR_Coverage, 19438,
     /* 114600 */   GIR_EraseRootFromParent_Done,
     /* 114601 */ // Label 2487: @114601
     /* 114601 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(114624), // Rule ID 618 //
     /* 114606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114617 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 114617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114622 */   GIR_RootConstrainSelectedInstOperands,
     /* 114623 */   // GIR_Coverage, 618,
     /* 114623 */   GIR_Done,
     /* 114624 */ // Label 2488: @114624
     /* 114624 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(114647), // Rule ID 620 //
     /* 114629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114640 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 114640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114645 */   GIR_RootConstrainSelectedInstOperands,
     /* 114646 */   // GIR_Coverage, 620,
     /* 114646 */   GIR_Done,
     /* 114647 */ // Label 2489: @114647
     /* 114647 */ GIM_Reject,
     /* 114648 */ // Label 2475: @114648
     /* 114648 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(114771), // Rule ID 22975 //
     /* 114653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114671 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114675 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114679 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114683 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114687 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114690 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114694 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114698 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114702 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114706 */   // MIs[3] Operand 1
     /* 114706 */   // No operand predicates
     /* 114706 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114708 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114715 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114727 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114731 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114734 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114737 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114770 */   // GIR_Coverage, 22975,
     /* 114770 */   GIR_EraseRootFromParent_Done,
     /* 114771 */ // Label 2490: @114771
     /* 114771 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(114866), // Rule ID 22974 //
     /* 114776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114794 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114807 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114811 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114815 */   // MIs[2] Operand 1
     /* 114815 */   // No operand predicates
     /* 114815 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114817 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114829 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114833 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114836 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114865 */   // GIR_Coverage, 22974,
     /* 114865 */   GIR_EraseRootFromParent_Done,
     /* 114866 */ // Label 2491: @114866
     /* 114866 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(114940), // Rule ID 19436 //
     /* 114871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114897 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114939 */   // GIR_Coverage, 19436,
     /* 114939 */   GIR_EraseRootFromParent_Done,
     /* 114940 */ // Label 2492: @114940
     /* 114940 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(115017), // Rule ID 19439 //
     /* 114945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114963 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114967 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114974 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114986 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115016 */   // GIR_Coverage, 19439,
     /* 115016 */   GIR_EraseRootFromParent_Done,
     /* 115017 */ // Label 2493: @115017
     /* 115017 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(115076), // Rule ID 17590 //
     /* 115022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 115025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115033 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 115033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 115040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115045 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115075 */   // GIR_Coverage, 17590,
     /* 115075 */   GIR_EraseRootFromParent_Done,
     /* 115076 */ // Label 2494: @115076
     /* 115076 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(115135), // Rule ID 17592 //
     /* 115081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 115092 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 115092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 115099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115104 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115134 */   // GIR_Coverage, 17592,
     /* 115134 */   GIR_EraseRootFromParent_Done,
     /* 115135 */ // Label 2495: @115135
     /* 115135 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(115194), // Rule ID 17594 //
     /* 115140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 115151 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 115151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 115158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115163 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115193 */   // GIR_Coverage, 17594,
     /* 115193 */   GIR_EraseRootFromParent_Done,
     /* 115194 */ // Label 2496: @115194
     /* 115194 */ GIM_Reject,
     /* 115195 */ // Label 2476: @115195
     /* 115195 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(115362),
     /* 115200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115203 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(115259), // Rule ID 18413 //
     /* 115208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115243 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrm),
     /* 115246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115257 */     GIR_RootConstrainSelectedInstOperands,
     /* 115258 */     // GIR_Coverage, 18413,
     /* 115258 */     GIR_EraseRootFromParent_Done,
     /* 115259 */   // Label 2498: @115259
     /* 115259 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(115315), // Rule ID 21618 //
     /* 115264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115279 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115286 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115299 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rm),
     /* 115302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115313 */     GIR_RootConstrainSelectedInstOperands,
     /* 115314 */     // GIR_Coverage, 21618,
     /* 115314 */     GIR_EraseRootFromParent_Done,
     /* 115315 */   // Label 2499: @115315
     /* 115315 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(115338), // Rule ID 12463 //
     /* 115320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115331 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 115331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 115336 */     GIR_RootConstrainSelectedInstOperands,
     /* 115337 */     // GIR_Coverage, 12463,
     /* 115337 */     GIR_Done,
     /* 115338 */   // Label 2500: @115338
     /* 115338 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(115361), // Rule ID 18401 //
     /* 115343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115354 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 115354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 115359 */     GIR_RootConstrainSelectedInstOperands,
     /* 115360 */     // GIR_Coverage, 18401,
     /* 115360 */     GIR_Done,
     /* 115361 */   // Label 2501: @115361
     /* 115361 */   GIM_Reject,
     /* 115362 */ // Label 2497: @115362
     /* 115362 */ GIM_Reject,
     /* 115363 */ // Label 2477: @115363
     /* 115363 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(115530),
     /* 115368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115371 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(115427), // Rule ID 18409 //
     /* 115376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115411 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrm),
     /* 115414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115425 */     GIR_RootConstrainSelectedInstOperands,
     /* 115426 */     // GIR_Coverage, 18409,
     /* 115426 */     GIR_EraseRootFromParent_Done,
     /* 115427 */   // Label 2503: @115427
     /* 115427 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(115483), // Rule ID 21617 //
     /* 115432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115447 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115467 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rm),
     /* 115470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115481 */     GIR_RootConstrainSelectedInstOperands,
     /* 115482 */     // GIR_Coverage, 21617,
     /* 115482 */     GIR_EraseRootFromParent_Done,
     /* 115483 */   // Label 2504: @115483
     /* 115483 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(115506), // Rule ID 12427 //
     /* 115488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115499 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 115499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 115504 */     GIR_RootConstrainSelectedInstOperands,
     /* 115505 */     // GIR_Coverage, 12427,
     /* 115505 */     GIR_Done,
     /* 115506 */   // Label 2505: @115506
     /* 115506 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(115529), // Rule ID 18399 //
     /* 115511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115522 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 115522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 115527 */     GIR_RootConstrainSelectedInstOperands,
     /* 115528 */     // GIR_Coverage, 18399,
     /* 115528 */     GIR_Done,
     /* 115529 */   // Label 2506: @115529
     /* 115529 */   GIM_Reject,
     /* 115530 */ // Label 2502: @115530
     /* 115530 */ GIM_Reject,
     /* 115531 */ // Label 2478: @115531
     /* 115531 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(115590), // Rule ID 21622 //
     /* 115536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115554 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115557 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115561 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115567 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115574 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrm),
     /* 115577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115588 */   GIR_RootConstrainSelectedInstOperands,
     /* 115589 */   // GIR_Coverage, 21622,
     /* 115589 */   GIR_EraseRootFromParent_Done,
     /* 115590 */ // Label 2507: @115590
     /* 115590 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(115649), // Rule ID 21623 //
     /* 115595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115613 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115620 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115626 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115633 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrm),
     /* 115636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115638 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115647 */   GIR_RootConstrainSelectedInstOperands,
     /* 115648 */   // GIR_Coverage, 21623,
     /* 115648 */   GIR_EraseRootFromParent_Done,
     /* 115649 */ // Label 2508: @115649
     /* 115649 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(115675), // Rule ID 12451 //
     /* 115654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115668 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 115668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 115673 */   GIR_RootConstrainSelectedInstOperands,
     /* 115674 */   // GIR_Coverage, 12451,
     /* 115674 */   GIR_Done,
     /* 115675 */ // Label 2509: @115675
     /* 115675 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(115701), // Rule ID 12469 //
     /* 115680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115694 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 115694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 115699 */   GIR_RootConstrainSelectedInstOperands,
     /* 115700 */   // GIR_Coverage, 12469,
     /* 115700 */   GIR_Done,
     /* 115701 */ // Label 2510: @115701
     /* 115701 */ GIM_Reject,
     /* 115702 */ // Label 2479: @115702
     /* 115702 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(115869),
     /* 115707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115710 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(115766), // Rule ID 18403 //
     /* 115715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115750 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrm),
     /* 115753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115764 */     GIR_RootConstrainSelectedInstOperands,
     /* 115765 */     // GIR_Coverage, 18403,
     /* 115765 */     GIR_EraseRootFromParent_Done,
     /* 115766 */   // Label 2512: @115766
     /* 115766 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(115822), // Rule ID 21616 //
     /* 115771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115806 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rm),
     /* 115809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115820 */     GIR_RootConstrainSelectedInstOperands,
     /* 115821 */     // GIR_Coverage, 21616,
     /* 115821 */     GIR_EraseRootFromParent_Done,
     /* 115822 */   // Label 2513: @115822
     /* 115822 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(115845), // Rule ID 12373 //
     /* 115827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115838 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 115838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 115843 */     GIR_RootConstrainSelectedInstOperands,
     /* 115844 */     // GIR_Coverage, 12373,
     /* 115844 */     GIR_Done,
     /* 115845 */   // Label 2514: @115845
     /* 115845 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(115868), // Rule ID 18396 //
     /* 115850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115861 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 115861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 115866 */     GIR_RootConstrainSelectedInstOperands,
     /* 115867 */     // GIR_Coverage, 18396,
     /* 115867 */     GIR_Done,
     /* 115868 */   // Label 2515: @115868
     /* 115868 */   GIM_Reject,
     /* 115869 */ // Label 2511: @115869
     /* 115869 */ GIM_Reject,
     /* 115870 */ // Label 2480: @115870
     /* 115870 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(115929), // Rule ID 21620 //
     /* 115875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115885 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115889 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115893 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115896 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115900 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115906 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115913 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrm),
     /* 115916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115918 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115927 */   GIR_RootConstrainSelectedInstOperands,
     /* 115928 */   // GIR_Coverage, 21620,
     /* 115928 */   GIR_EraseRootFromParent_Done,
     /* 115929 */ // Label 2516: @115929
     /* 115929 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(115988), // Rule ID 21621 //
     /* 115934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115952 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115959 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115965 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115972 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 115975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115977 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115986 */   GIR_RootConstrainSelectedInstOperands,
     /* 115987 */   // GIR_Coverage, 21621,
     /* 115987 */   GIR_EraseRootFromParent_Done,
     /* 115988 */ // Label 2517: @115988
     /* 115988 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(116014), // Rule ID 12397 //
     /* 115993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 116007 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 116007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 116012 */   GIR_RootConstrainSelectedInstOperands,
     /* 116013 */   // GIR_Coverage, 12397,
     /* 116013 */   GIR_Done,
     /* 116014 */ // Label 2518: @116014
     /* 116014 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(116040), // Rule ID 12433 //
     /* 116019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 116022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 116025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 116033 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 116033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 116038 */   GIR_RootConstrainSelectedInstOperands,
     /* 116039 */   // GIR_Coverage, 12433,
     /* 116039 */   GIR_Done,
     /* 116040 */ // Label 2519: @116040
     /* 116040 */ GIM_Reject,
     /* 116041 */ // Label 2481: @116041
     /* 116041 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(116125),
     /* 116046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 116049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116053 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(116105), // Rule ID 21619 //
     /* 116058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 116061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 116076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116089 */     // (zext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 116089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrm),
     /* 116092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 116098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116103 */     GIR_RootConstrainSelectedInstOperands,
     /* 116104 */     // GIR_Coverage, 21619,
     /* 116104 */     GIR_EraseRootFromParent_Done,
     /* 116105 */   // Label 2521: @116105
     /* 116105 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(116124), // Rule ID 12379 //
     /* 116110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 116113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 116117 */     // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 116117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 116122 */     GIR_RootConstrainSelectedInstOperands,
     /* 116123 */     // GIR_Coverage, 12379,
     /* 116123 */     GIR_Done,
     /* 116124 */   // Label 2522: @116124
     /* 116124 */   GIM_Reject,
     /* 116125 */ // Label 2520: @116125
     /* 116125 */ GIM_Reject,
     /* 116126 */ // Label 2482: @116126
     /* 116126 */ GIM_Reject,
     /* 116127 */ // Label 26: @116127
     /* 116127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(118410),
     /* 116138 */ /*GILLT_s8*//*Label 2523*/ GIMT_Encode4(116154),
     /* 116142 */ /*GILLT_s16*//*Label 2524*/ GIMT_Encode4(116529),
     /* 116146 */ /*GILLT_s32*//*Label 2525*/ GIMT_Encode4(116904),
     /* 116150 */ /*GILLT_s64*//*Label 2526*/ GIMT_Encode4(117657),
     /* 116154 */ // Label 2523: @116154
     /* 116154 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(116528),
     /* 116159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 116162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116169 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(116236), // Rule ID 673 //
     /* 116174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116185 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116192 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116204 */     // MIs[2] Operand 1
     /* 116204 */     // No operand predicates
     /* 116204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116213 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi_ND),
     /* 116216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116234 */     GIR_RootConstrainSelectedInstOperands,
     /* 116235 */     // GIR_Coverage, 673,
     /* 116235 */     GIR_EraseRootFromParent_Done,
     /* 116236 */   // Label 2529: @116236
     /* 116236 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(116309), // Rule ID 689 //
     /* 116241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116259 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116276 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116280 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL_ND),
     /* 116293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116307 */     GIR_RootConstrainSelectedInstOperands,
     /* 116308 */     // GIR_Coverage, 689,
     /* 116308 */     GIR_EraseRootFromParent_Done,
     /* 116309 */   // Label 2530: @116309
     /* 116309 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(116339), // Rule ID 22674 //
     /* 116314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116325 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 116328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116337 */     GIR_RootConstrainSelectedInstOperands,
     /* 116338 */     // GIR_Coverage, 22674,
     /* 116338 */     GIR_EraseRootFromParent_Done,
     /* 116339 */   // Label 2531: @116339
     /* 116339 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(116369), // Rule ID 22678 //
     /* 116344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116355 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 116358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116360 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116367 */     GIR_RootConstrainSelectedInstOperands,
     /* 116368 */     // GIR_Coverage, 22678,
     /* 116368 */     GIR_EraseRootFromParent_Done,
     /* 116369 */   // Label 2532: @116369
     /* 116369 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(116406), // Rule ID 661 //
     /* 116374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116389 */     // MIs[1] Operand 1
     /* 116389 */     // No operand predicates
     /* 116389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116391 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 116394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116404 */     GIR_RootConstrainSelectedInstOperands,
     /* 116405 */     // GIR_Coverage, 661,
     /* 116405 */     GIR_EraseRootFromParent_Done,
     /* 116406 */   // Label 2533: @116406
     /* 116406 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(116443), // Rule ID 665 //
     /* 116411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116426 */     // MIs[1] Operand 1
     /* 116426 */     // No operand predicates
     /* 116426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116428 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 116431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116433 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116441 */     GIR_RootConstrainSelectedInstOperands,
     /* 116442 */     // GIR_Coverage, 665,
     /* 116442 */     GIR_EraseRootFromParent_Done,
     /* 116443 */   // Label 2534: @116443
     /* 116443 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(116485), // Rule ID 677 //
     /* 116448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116459 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116463 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 116476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116483 */     GIR_RootConstrainSelectedInstOperands,
     /* 116484 */     // GIR_Coverage, 677,
     /* 116484 */     GIR_EraseRootFromParent_Done,
     /* 116485 */   // Label 2535: @116485
     /* 116485 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(116527), // Rule ID 681 //
     /* 116490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116501 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116505 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 116518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116525 */     GIR_RootConstrainSelectedInstOperands,
     /* 116526 */     // GIR_Coverage, 681,
     /* 116526 */     GIR_EraseRootFromParent_Done,
     /* 116527 */   // Label 2536: @116527
     /* 116527 */   GIM_Reject,
     /* 116528 */ // Label 2528: @116528
     /* 116528 */ GIM_Reject,
     /* 116529 */ // Label 2524: @116529
     /* 116529 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(116903),
     /* 116534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116544 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(116611), // Rule ID 674 //
     /* 116549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116567 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116579 */     // MIs[2] Operand 1
     /* 116579 */     // No operand predicates
     /* 116579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116588 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi_ND),
     /* 116591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116609 */     GIR_RootConstrainSelectedInstOperands,
     /* 116610 */     // GIR_Coverage, 674,
     /* 116610 */     GIR_EraseRootFromParent_Done,
     /* 116611 */   // Label 2538: @116611
     /* 116611 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(116684), // Rule ID 690 //
     /* 116616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116634 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116651 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116655 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL_ND),
     /* 116668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116670 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116682 */     GIR_RootConstrainSelectedInstOperands,
     /* 116683 */     // GIR_Coverage, 690,
     /* 116683 */     GIR_EraseRootFromParent_Done,
     /* 116684 */   // Label 2539: @116684
     /* 116684 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(116714), // Rule ID 22675 //
     /* 116689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116700 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 116703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116712 */     GIR_RootConstrainSelectedInstOperands,
     /* 116713 */     // GIR_Coverage, 22675,
     /* 116713 */     GIR_EraseRootFromParent_Done,
     /* 116714 */   // Label 2540: @116714
     /* 116714 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(116744), // Rule ID 22679 //
     /* 116719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116730 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 116733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116742 */     GIR_RootConstrainSelectedInstOperands,
     /* 116743 */     // GIR_Coverage, 22679,
     /* 116743 */     GIR_EraseRootFromParent_Done,
     /* 116744 */   // Label 2541: @116744
     /* 116744 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(116781), // Rule ID 662 //
     /* 116749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116764 */     // MIs[1] Operand 1
     /* 116764 */     // No operand predicates
     /* 116764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116766 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 116769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116771 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116779 */     GIR_RootConstrainSelectedInstOperands,
     /* 116780 */     // GIR_Coverage, 662,
     /* 116780 */     GIR_EraseRootFromParent_Done,
     /* 116781 */   // Label 2542: @116781
     /* 116781 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(116818), // Rule ID 666 //
     /* 116786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116801 */     // MIs[1] Operand 1
     /* 116801 */     // No operand predicates
     /* 116801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116803 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 116806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116816 */     GIR_RootConstrainSelectedInstOperands,
     /* 116817 */     // GIR_Coverage, 666,
     /* 116817 */     GIR_EraseRootFromParent_Done,
     /* 116818 */   // Label 2543: @116818
     /* 116818 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(116860), // Rule ID 678 //
     /* 116823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116834 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116838 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 116851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116858 */     GIR_RootConstrainSelectedInstOperands,
     /* 116859 */     // GIR_Coverage, 678,
     /* 116859 */     GIR_EraseRootFromParent_Done,
     /* 116860 */   // Label 2544: @116860
     /* 116860 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(116902), // Rule ID 682 //
     /* 116865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116876 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 116893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116900 */     GIR_RootConstrainSelectedInstOperands,
     /* 116901 */     // GIR_Coverage, 682,
     /* 116901 */     GIR_EraseRootFromParent_Done,
     /* 116902 */   // Label 2545: @116902
     /* 116902 */   GIM_Reject,
     /* 116903 */ // Label 2537: @116903
     /* 116903 */ GIM_Reject,
     /* 116904 */ // Label 2525: @116904
     /* 116904 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(117656),
     /* 116909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116919 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(116986), // Rule ID 675 //
     /* 116924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116942 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116954 */     // MIs[2] Operand 1
     /* 116954 */     // No operand predicates
     /* 116954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116963 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi_ND),
     /* 116966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116984 */     GIR_RootConstrainSelectedInstOperands,
     /* 116985 */     // GIR_Coverage, 675,
     /* 116985 */     GIR_EraseRootFromParent_Done,
     /* 116986 */   // Label 2547: @116986
     /* 116986 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(117059), // Rule ID 691 //
     /* 116991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117009 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117026 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117030 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL_ND),
     /* 117043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117057 */     GIR_RootConstrainSelectedInstOperands,
     /* 117058 */     // GIR_Coverage, 691,
     /* 117058 */     GIR_EraseRootFromParent_Done,
     /* 117059 */   // Label 2548: @117059
     /* 117059 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(117169), // Rule ID 17672 //
     /* 117064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117082 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117099 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm),
     /* 117153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117167 */     GIR_RootConstrainSelectedInstOperands,
     /* 117168 */     // GIR_Coverage, 17672,
     /* 117168 */     GIR_EraseRootFromParent_Done,
     /* 117169 */   // Label 2549: @117169
     /* 117169 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(117279), // Rule ID 17704 //
     /* 117174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117185 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117192 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117209 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm_EVEX),
     /* 117263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117277 */     GIR_RootConstrainSelectedInstOperands,
     /* 117278 */     // GIR_Coverage, 17704,
     /* 117278 */     GIR_EraseRootFromParent_Done,
     /* 117279 */   // Label 2550: @117279
     /* 117279 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(117309), // Rule ID 22676 //
     /* 117284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117295 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 117298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117307 */     GIR_RootConstrainSelectedInstOperands,
     /* 117308 */     // GIR_Coverage, 22676,
     /* 117308 */     GIR_EraseRootFromParent_Done,
     /* 117309 */   // Label 2551: @117309
     /* 117309 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(117339), // Rule ID 22680 //
     /* 117314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117325 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 117328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117337 */     GIR_RootConstrainSelectedInstOperands,
     /* 117338 */     // GIR_Coverage, 22680,
     /* 117338 */     GIR_EraseRootFromParent_Done,
     /* 117339 */   // Label 2552: @117339
     /* 117339 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(117376), // Rule ID 663 //
     /* 117344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117359 */     // MIs[1] Operand 1
     /* 117359 */     // No operand predicates
     /* 117359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117361 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 117364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117374 */     GIR_RootConstrainSelectedInstOperands,
     /* 117375 */     // GIR_Coverage, 663,
     /* 117375 */     GIR_EraseRootFromParent_Done,
     /* 117376 */   // Label 2553: @117376
     /* 117376 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(117413), // Rule ID 667 //
     /* 117381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117396 */     // MIs[1] Operand 1
     /* 117396 */     // No operand predicates
     /* 117396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117398 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 117401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117411 */     GIR_RootConstrainSelectedInstOperands,
     /* 117412 */     // GIR_Coverage, 667,
     /* 117412 */     GIR_EraseRootFromParent_Done,
     /* 117413 */   // Label 2554: @117413
     /* 117413 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(117492), // Rule ID 17668 //
     /* 117418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117429 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 117483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117490 */     GIR_RootConstrainSelectedInstOperands,
     /* 117491 */     // GIR_Coverage, 17668,
     /* 117491 */     GIR_EraseRootFromParent_Done,
     /* 117492 */   // Label 2555: @117492
     /* 117492 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(117571), // Rule ID 17700 //
     /* 117497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117508 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117508 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117511 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117515 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117534 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 117562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117569 */     GIR_RootConstrainSelectedInstOperands,
     /* 117570 */     // GIR_Coverage, 17700,
     /* 117570 */     GIR_EraseRootFromParent_Done,
     /* 117571 */   // Label 2556: @117571
     /* 117571 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(117613), // Rule ID 679 //
     /* 117576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117587 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117591 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 117604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117611 */     GIR_RootConstrainSelectedInstOperands,
     /* 117612 */     // GIR_Coverage, 679,
     /* 117612 */     GIR_EraseRootFromParent_Done,
     /* 117613 */   // Label 2557: @117613
     /* 117613 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(117655), // Rule ID 683 //
     /* 117618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117629 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117633 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 117646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117653 */     GIR_RootConstrainSelectedInstOperands,
     /* 117654 */     // GIR_Coverage, 683,
     /* 117654 */     GIR_EraseRootFromParent_Done,
     /* 117655 */   // Label 2558: @117655
     /* 117655 */   GIM_Reject,
     /* 117656 */ // Label 2546: @117656
     /* 117656 */ GIM_Reject,
     /* 117657 */ // Label 2526: @117657
     /* 117657 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(118409),
     /* 117662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 117668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117672 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(117739), // Rule ID 676 //
     /* 117677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 117703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117707 */     // MIs[2] Operand 1
     /* 117707 */     // No operand predicates
     /* 117707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117716 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi_ND),
     /* 117719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117737 */     GIR_RootConstrainSelectedInstOperands,
     /* 117738 */     // GIR_Coverage, 676,
     /* 117738 */     GIR_EraseRootFromParent_Done,
     /* 117739 */   // Label 2560: @117739
     /* 117739 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(117812), // Rule ID 692 //
     /* 117744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117755 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117762 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117779 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117783 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL_ND),
     /* 117796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117810 */     GIR_RootConstrainSelectedInstOperands,
     /* 117811 */     // GIR_Coverage, 692,
     /* 117811 */     GIR_EraseRootFromParent_Done,
     /* 117812 */   // Label 2561: @117812
     /* 117812 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(117922), // Rule ID 17673 //
     /* 117817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117852 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm),
     /* 117906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117920 */     GIR_RootConstrainSelectedInstOperands,
     /* 117921 */     // GIR_Coverage, 17673,
     /* 117921 */     GIR_EraseRootFromParent_Done,
     /* 117922 */   // Label 2562: @117922
     /* 117922 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(118032), // Rule ID 17705 //
     /* 117927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117962 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117988 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117995 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm_EVEX),
     /* 118016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118030 */     GIR_RootConstrainSelectedInstOperands,
     /* 118031 */     // GIR_Coverage, 17705,
     /* 118031 */     GIR_EraseRootFromParent_Done,
     /* 118032 */   // Label 2563: @118032
     /* 118032 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(118062), // Rule ID 22677 //
     /* 118037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 118048 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 118048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 118051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118060 */     GIR_RootConstrainSelectedInstOperands,
     /* 118061 */     // GIR_Coverage, 22677,
     /* 118061 */     GIR_EraseRootFromParent_Done,
     /* 118062 */   // Label 2564: @118062
     /* 118062 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(118092), // Rule ID 22681 //
     /* 118067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 118070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 118078 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 118078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 118081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118090 */     GIR_RootConstrainSelectedInstOperands,
     /* 118091 */     // GIR_Coverage, 22681,
     /* 118091 */     GIR_EraseRootFromParent_Done,
     /* 118092 */   // Label 2565: @118092
     /* 118092 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(118129), // Rule ID 664 //
     /* 118097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118112 */     // MIs[1] Operand 1
     /* 118112 */     // No operand predicates
     /* 118112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118114 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 118117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118127 */     GIR_RootConstrainSelectedInstOperands,
     /* 118128 */     // GIR_Coverage, 664,
     /* 118128 */     GIR_EraseRootFromParent_Done,
     /* 118129 */   // Label 2566: @118129
     /* 118129 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(118166), // Rule ID 668 //
     /* 118134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118149 */     // MIs[1] Operand 1
     /* 118149 */     // No operand predicates
     /* 118149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118151 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 118154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118164 */     GIR_RootConstrainSelectedInstOperands,
     /* 118165 */     // GIR_Coverage, 668,
     /* 118165 */     GIR_EraseRootFromParent_Done,
     /* 118166 */   // Label 2567: @118166
     /* 118166 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(118245), // Rule ID 17669 //
     /* 118171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 118174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118182 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118208 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 118236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118243 */     GIR_RootConstrainSelectedInstOperands,
     /* 118244 */     // GIR_Coverage, 17669,
     /* 118244 */     GIR_EraseRootFromParent_Done,
     /* 118245 */   // Label 2568: @118245
     /* 118245 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(118324), // Rule ID 17701 //
     /* 118250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118261 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 118315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118322 */     GIR_RootConstrainSelectedInstOperands,
     /* 118323 */     // GIR_Coverage, 17701,
     /* 118323 */     GIR_EraseRootFromParent_Done,
     /* 118324 */   // Label 2569: @118324
     /* 118324 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(118366), // Rule ID 680 //
     /* 118329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118340 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118344 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 118357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118364 */     GIR_RootConstrainSelectedInstOperands,
     /* 118365 */     // GIR_Coverage, 680,
     /* 118365 */     GIR_EraseRootFromParent_Done,
     /* 118366 */   // Label 2570: @118366
     /* 118366 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(118408), // Rule ID 684 //
     /* 118371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118382 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118386 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 118399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118406 */     GIR_RootConstrainSelectedInstOperands,
     /* 118407 */     // GIR_Coverage, 684,
     /* 118407 */     GIR_EraseRootFromParent_Done,
     /* 118408 */   // Label 2571: @118408
     /* 118408 */   GIM_Reject,
     /* 118409 */ // Label 2559: @118409
     /* 118409 */ GIM_Reject,
     /* 118410 */ // Label 2527: @118410
     /* 118410 */ GIM_Reject,
     /* 118411 */ // Label 27: @118411
     /* 118411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(120454),
     /* 118422 */ /*GILLT_s8*//*Label 2572*/ GIMT_Encode4(118438),
     /* 118426 */ /*GILLT_s16*//*Label 2573*/ GIMT_Encode4(118753),
     /* 118430 */ /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(119068),
     /* 118434 */ /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(119761),
     /* 118438 */ // Label 2572: @118438
     /* 118438 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(118752),
     /* 118443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 118446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118453 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(118520), // Rule ID 705 //
     /* 118458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118469 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118476 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118488 */     // MIs[2] Operand 1
     /* 118488 */     // No operand predicates
     /* 118488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118497 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi_ND),
     /* 118500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118518 */     GIR_RootConstrainSelectedInstOperands,
     /* 118519 */     // GIR_Coverage, 705,
     /* 118519 */     GIR_EraseRootFromParent_Done,
     /* 118520 */   // Label 2578: @118520
     /* 118520 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(118593), // Rule ID 721 //
     /* 118525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118543 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118560 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118564 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL_ND),
     /* 118577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118591 */     GIR_RootConstrainSelectedInstOperands,
     /* 118592 */     // GIR_Coverage, 721,
     /* 118592 */     GIR_EraseRootFromParent_Done,
     /* 118593 */   // Label 2579: @118593
     /* 118593 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(118630), // Rule ID 693 //
     /* 118598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118613 */     // MIs[1] Operand 1
     /* 118613 */     // No operand predicates
     /* 118613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118615 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 118618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118628 */     GIR_RootConstrainSelectedInstOperands,
     /* 118629 */     // GIR_Coverage, 693,
     /* 118629 */     GIR_EraseRootFromParent_Done,
     /* 118630 */   // Label 2580: @118630
     /* 118630 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(118667), // Rule ID 697 //
     /* 118635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118650 */     // MIs[1] Operand 1
     /* 118650 */     // No operand predicates
     /* 118650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118652 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 118655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118665 */     GIR_RootConstrainSelectedInstOperands,
     /* 118666 */     // GIR_Coverage, 697,
     /* 118666 */     GIR_EraseRootFromParent_Done,
     /* 118667 */   // Label 2581: @118667
     /* 118667 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(118709), // Rule ID 709 //
     /* 118672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118683 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118687 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 118700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118707 */     GIR_RootConstrainSelectedInstOperands,
     /* 118708 */     // GIR_Coverage, 709,
     /* 118708 */     GIR_EraseRootFromParent_Done,
     /* 118709 */   // Label 2582: @118709
     /* 118709 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(118751), // Rule ID 713 //
     /* 118714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118725 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118729 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 118742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118744 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118749 */     GIR_RootConstrainSelectedInstOperands,
     /* 118750 */     // GIR_Coverage, 713,
     /* 118750 */     GIR_EraseRootFromParent_Done,
     /* 118751 */   // Label 2583: @118751
     /* 118751 */   GIM_Reject,
     /* 118752 */ // Label 2577: @118752
     /* 118752 */ GIM_Reject,
     /* 118753 */ // Label 2573: @118753
     /* 118753 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(119067),
     /* 118758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118768 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(118835), // Rule ID 706 //
     /* 118773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118803 */     // MIs[2] Operand 1
     /* 118803 */     // No operand predicates
     /* 118803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118812 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi_ND),
     /* 118815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118833 */     GIR_RootConstrainSelectedInstOperands,
     /* 118834 */     // GIR_Coverage, 706,
     /* 118834 */     GIR_EraseRootFromParent_Done,
     /* 118835 */   // Label 2585: @118835
     /* 118835 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(118908), // Rule ID 722 //
     /* 118840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118858 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118875 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118879 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL_ND),
     /* 118892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118906 */     GIR_RootConstrainSelectedInstOperands,
     /* 118907 */     // GIR_Coverage, 722,
     /* 118907 */     GIR_EraseRootFromParent_Done,
     /* 118908 */   // Label 2586: @118908
     /* 118908 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(118945), // Rule ID 694 //
     /* 118913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118928 */     // MIs[1] Operand 1
     /* 118928 */     // No operand predicates
     /* 118928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118930 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 118933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118935 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118943 */     GIR_RootConstrainSelectedInstOperands,
     /* 118944 */     // GIR_Coverage, 694,
     /* 118944 */     GIR_EraseRootFromParent_Done,
     /* 118945 */   // Label 2587: @118945
     /* 118945 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(118982), // Rule ID 698 //
     /* 118950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118965 */     // MIs[1] Operand 1
     /* 118965 */     // No operand predicates
     /* 118965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118967 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 118970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118972 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118980 */     GIR_RootConstrainSelectedInstOperands,
     /* 118981 */     // GIR_Coverage, 698,
     /* 118981 */     GIR_EraseRootFromParent_Done,
     /* 118982 */   // Label 2588: @118982
     /* 118982 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(119024), // Rule ID 710 //
     /* 118987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118998 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119002 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 119015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119022 */     GIR_RootConstrainSelectedInstOperands,
     /* 119023 */     // GIR_Coverage, 710,
     /* 119023 */     GIR_EraseRootFromParent_Done,
     /* 119024 */   // Label 2589: @119024
     /* 119024 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(119066), // Rule ID 714 //
     /* 119029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 119036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119040 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 119040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119044 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 119057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119064 */     GIR_RootConstrainSelectedInstOperands,
     /* 119065 */     // GIR_Coverage, 714,
     /* 119065 */     GIR_EraseRootFromParent_Done,
     /* 119066 */   // Label 2590: @119066
     /* 119066 */   GIM_Reject,
     /* 119067 */ // Label 2584: @119067
     /* 119067 */ GIM_Reject,
     /* 119068 */ // Label 2574: @119068
     /* 119068 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(119760),
     /* 119073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119083 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(119150), // Rule ID 707 //
     /* 119088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119106 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119118 */     // MIs[2] Operand 1
     /* 119118 */     // No operand predicates
     /* 119118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119127 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi_ND),
     /* 119130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119148 */     GIR_RootConstrainSelectedInstOperands,
     /* 119149 */     // GIR_Coverage, 707,
     /* 119149 */     GIR_EraseRootFromParent_Done,
     /* 119150 */   // Label 2592: @119150
     /* 119150 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(119223), // Rule ID 723 //
     /* 119155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119173 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119190 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119194 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL_ND),
     /* 119207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119221 */     GIR_RootConstrainSelectedInstOperands,
     /* 119222 */     // GIR_Coverage, 723,
     /* 119222 */     GIR_EraseRootFromParent_Done,
     /* 119223 */   // Label 2593: @119223
     /* 119223 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(119333), // Rule ID 17664 //
     /* 119228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119246 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119263 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm),
     /* 119317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119331 */     GIR_RootConstrainSelectedInstOperands,
     /* 119332 */     // GIR_Coverage, 17664,
     /* 119332 */     GIR_EraseRootFromParent_Done,
     /* 119333 */   // Label 2594: @119333
     /* 119333 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(119443), // Rule ID 17696 //
     /* 119338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119349 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119356 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119373 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119399 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm_EVEX),
     /* 119427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119441 */     GIR_RootConstrainSelectedInstOperands,
     /* 119442 */     // GIR_Coverage, 17696,
     /* 119442 */     GIR_EraseRootFromParent_Done,
     /* 119443 */   // Label 2595: @119443
     /* 119443 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(119480), // Rule ID 695 //
     /* 119448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119463 */     // MIs[1] Operand 1
     /* 119463 */     // No operand predicates
     /* 119463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119465 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 119468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119478 */     GIR_RootConstrainSelectedInstOperands,
     /* 119479 */     // GIR_Coverage, 695,
     /* 119479 */     GIR_EraseRootFromParent_Done,
     /* 119480 */   // Label 2596: @119480
     /* 119480 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(119517), // Rule ID 699 //
     /* 119485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119500 */     // MIs[1] Operand 1
     /* 119500 */     // No operand predicates
     /* 119500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119502 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 119505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119515 */     GIR_RootConstrainSelectedInstOperands,
     /* 119516 */     // GIR_Coverage, 699,
     /* 119516 */     GIR_EraseRootFromParent_Done,
     /* 119517 */   // Label 2597: @119517
     /* 119517 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(119596), // Rule ID 17660 //
     /* 119522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119533 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 119587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119594 */     GIR_RootConstrainSelectedInstOperands,
     /* 119595 */     // GIR_Coverage, 17660,
     /* 119595 */     GIR_EraseRootFromParent_Done,
     /* 119596 */   // Label 2598: @119596
     /* 119596 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(119675), // Rule ID 17692 //
     /* 119601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119612 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119638 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 119666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119673 */     GIR_RootConstrainSelectedInstOperands,
     /* 119674 */     // GIR_Coverage, 17692,
     /* 119674 */     GIR_EraseRootFromParent_Done,
     /* 119675 */   // Label 2599: @119675
     /* 119675 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(119717), // Rule ID 711 //
     /* 119680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119691 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119695 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 119708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119715 */     GIR_RootConstrainSelectedInstOperands,
     /* 119716 */     // GIR_Coverage, 711,
     /* 119716 */     GIR_EraseRootFromParent_Done,
     /* 119717 */   // Label 2600: @119717
     /* 119717 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(119759), // Rule ID 715 //
     /* 119722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119733 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119737 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 119750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119757 */     GIR_RootConstrainSelectedInstOperands,
     /* 119758 */     // GIR_Coverage, 715,
     /* 119758 */     GIR_EraseRootFromParent_Done,
     /* 119759 */   // Label 2601: @119759
     /* 119759 */   GIM_Reject,
     /* 119760 */ // Label 2591: @119760
     /* 119760 */ GIM_Reject,
     /* 119761 */ // Label 2575: @119761
     /* 119761 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(120453),
     /* 119766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119776 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(119843), // Rule ID 708 //
     /* 119781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119811 */     // MIs[2] Operand 1
     /* 119811 */     // No operand predicates
     /* 119811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119820 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi_ND),
     /* 119823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119841 */     GIR_RootConstrainSelectedInstOperands,
     /* 119842 */     // GIR_Coverage, 708,
     /* 119842 */     GIR_EraseRootFromParent_Done,
     /* 119843 */   // Label 2603: @119843
     /* 119843 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(119916), // Rule ID 724 //
     /* 119848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119883 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119887 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL_ND),
     /* 119900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119914 */     GIR_RootConstrainSelectedInstOperands,
     /* 119915 */     // GIR_Coverage, 724,
     /* 119915 */     GIR_EraseRootFromParent_Done,
     /* 119916 */   // Label 2604: @119916
     /* 119916 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(120026), // Rule ID 17665 //
     /* 119921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119956 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm),
     /* 120010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120024 */     GIR_RootConstrainSelectedInstOperands,
     /* 120025 */     // GIR_Coverage, 17665,
     /* 120025 */     GIR_EraseRootFromParent_Done,
     /* 120026 */   // Label 2605: @120026
     /* 120026 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(120136), // Rule ID 17697 //
     /* 120031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 120049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120066 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm_EVEX),
     /* 120120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120134 */     GIR_RootConstrainSelectedInstOperands,
     /* 120135 */     // GIR_Coverage, 17697,
     /* 120135 */     GIR_EraseRootFromParent_Done,
     /* 120136 */   // Label 2606: @120136
     /* 120136 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(120173), // Rule ID 696 //
     /* 120141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120156 */     // MIs[1] Operand 1
     /* 120156 */     // No operand predicates
     /* 120156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120158 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 120161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120171 */     GIR_RootConstrainSelectedInstOperands,
     /* 120172 */     // GIR_Coverage, 696,
     /* 120172 */     GIR_EraseRootFromParent_Done,
     /* 120173 */   // Label 2607: @120173
     /* 120173 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(120210), // Rule ID 700 //
     /* 120178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120193 */     // MIs[1] Operand 1
     /* 120193 */     // No operand predicates
     /* 120193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120195 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 120198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120208 */     GIR_RootConstrainSelectedInstOperands,
     /* 120209 */     // GIR_Coverage, 700,
     /* 120209 */     GIR_EraseRootFromParent_Done,
     /* 120210 */   // Label 2608: @120210
     /* 120210 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(120289), // Rule ID 17661 //
     /* 120215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120226 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 120280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120287 */     GIR_RootConstrainSelectedInstOperands,
     /* 120288 */     // GIR_Coverage, 17661,
     /* 120288 */     GIR_EraseRootFromParent_Done,
     /* 120289 */   // Label 2609: @120289
     /* 120289 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(120368), // Rule ID 17693 //
     /* 120294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120305 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120305 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120308 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120312 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120331 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120338 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 120359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120366 */     GIR_RootConstrainSelectedInstOperands,
     /* 120367 */     // GIR_Coverage, 17693,
     /* 120367 */     GIR_EraseRootFromParent_Done,
     /* 120368 */   // Label 2610: @120368
     /* 120368 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(120410), // Rule ID 712 //
     /* 120373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120384 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120388 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 120401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120408 */     GIR_RootConstrainSelectedInstOperands,
     /* 120409 */     // GIR_Coverage, 712,
     /* 120409 */     GIR_EraseRootFromParent_Done,
     /* 120410 */   // Label 2611: @120410
     /* 120410 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(120452), // Rule ID 716 //
     /* 120415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120426 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120430 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 120443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120450 */     GIR_RootConstrainSelectedInstOperands,
     /* 120451 */     // GIR_Coverage, 716,
     /* 120451 */     GIR_EraseRootFromParent_Done,
     /* 120452 */   // Label 2612: @120452
     /* 120452 */   GIM_Reject,
     /* 120453 */ // Label 2602: @120453
     /* 120453 */ GIM_Reject,
     /* 120454 */ // Label 2576: @120454
     /* 120454 */ GIM_Reject,
     /* 120455 */ // Label 28: @120455
     /* 120455 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(122498),
     /* 120466 */ /*GILLT_s8*//*Label 2613*/ GIMT_Encode4(120482),
     /* 120470 */ /*GILLT_s16*//*Label 2614*/ GIMT_Encode4(120797),
     /* 120474 */ /*GILLT_s32*//*Label 2615*/ GIMT_Encode4(121112),
     /* 120478 */ /*GILLT_s64*//*Label 2616*/ GIMT_Encode4(121805),
     /* 120482 */ // Label 2613: @120482
     /* 120482 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(120796),
     /* 120487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 120490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120497 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(120564), // Rule ID 737 //
     /* 120502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120513 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120516 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120520 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120532 */     // MIs[2] Operand 1
     /* 120532 */     // No operand predicates
     /* 120532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120541 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SAR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi_ND),
     /* 120544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120562 */     GIR_RootConstrainSelectedInstOperands,
     /* 120563 */     // GIR_Coverage, 737,
     /* 120563 */     GIR_EraseRootFromParent_Done,
     /* 120564 */   // Label 2619: @120564
     /* 120564 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(120637), // Rule ID 753 //
     /* 120569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120587 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120604 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SAR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120608 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL_ND),
     /* 120621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120635 */     GIR_RootConstrainSelectedInstOperands,
     /* 120636 */     // GIR_Coverage, 753,
     /* 120636 */     GIR_EraseRootFromParent_Done,
     /* 120637 */   // Label 2620: @120637
     /* 120637 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(120674), // Rule ID 725 //
     /* 120642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120657 */     // MIs[1] Operand 1
     /* 120657 */     // No operand predicates
     /* 120657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120659 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 120662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120672 */     GIR_RootConstrainSelectedInstOperands,
     /* 120673 */     // GIR_Coverage, 725,
     /* 120673 */     GIR_EraseRootFromParent_Done,
     /* 120674 */   // Label 2621: @120674
     /* 120674 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(120711), // Rule ID 729 //
     /* 120679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120694 */     // MIs[1] Operand 1
     /* 120694 */     // No operand predicates
     /* 120694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120696 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 120699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120709 */     GIR_RootConstrainSelectedInstOperands,
     /* 120710 */     // GIR_Coverage, 729,
     /* 120710 */     GIR_EraseRootFromParent_Done,
     /* 120711 */   // Label 2622: @120711
     /* 120711 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(120753), // Rule ID 741 //
     /* 120716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120727 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120731 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 120744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120751 */     GIR_RootConstrainSelectedInstOperands,
     /* 120752 */     // GIR_Coverage, 741,
     /* 120752 */     GIR_EraseRootFromParent_Done,
     /* 120753 */   // Label 2623: @120753
     /* 120753 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(120795), // Rule ID 745 //
     /* 120758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120769 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120773 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 120786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120793 */     GIR_RootConstrainSelectedInstOperands,
     /* 120794 */     // GIR_Coverage, 745,
     /* 120794 */     GIR_EraseRootFromParent_Done,
     /* 120795 */   // Label 2624: @120795
     /* 120795 */   GIM_Reject,
     /* 120796 */ // Label 2618: @120796
     /* 120796 */ GIM_Reject,
     /* 120797 */ // Label 2614: @120797
     /* 120797 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(121111),
     /* 120802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120812 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(120879), // Rule ID 738 //
     /* 120817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120831 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120835 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120847 */     // MIs[2] Operand 1
     /* 120847 */     // No operand predicates
     /* 120847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120856 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SAR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi_ND),
     /* 120859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120877 */     GIR_RootConstrainSelectedInstOperands,
     /* 120878 */     // GIR_Coverage, 738,
     /* 120878 */     GIR_EraseRootFromParent_Done,
     /* 120879 */   // Label 2626: @120879
     /* 120879 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(120952), // Rule ID 754 //
     /* 120884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120902 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120919 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SAR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120923 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL_ND),
     /* 120936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120950 */     GIR_RootConstrainSelectedInstOperands,
     /* 120951 */     // GIR_Coverage, 754,
     /* 120951 */     GIR_EraseRootFromParent_Done,
     /* 120952 */   // Label 2627: @120952
     /* 120952 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(120989), // Rule ID 726 //
     /* 120957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120972 */     // MIs[1] Operand 1
     /* 120972 */     // No operand predicates
     /* 120972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120974 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 120977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120987 */     GIR_RootConstrainSelectedInstOperands,
     /* 120988 */     // GIR_Coverage, 726,
     /* 120988 */     GIR_EraseRootFromParent_Done,
     /* 120989 */   // Label 2628: @120989
     /* 120989 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(121026), // Rule ID 730 //
     /* 120994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121009 */     // MIs[1] Operand 1
     /* 121009 */     // No operand predicates
     /* 121009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121011 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 121014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121024 */     GIR_RootConstrainSelectedInstOperands,
     /* 121025 */     // GIR_Coverage, 730,
     /* 121025 */     GIR_EraseRootFromParent_Done,
     /* 121026 */   // Label 2629: @121026
     /* 121026 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(121068), // Rule ID 742 //
     /* 121031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121042 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 121042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121046 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 121059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121066 */     GIR_RootConstrainSelectedInstOperands,
     /* 121067 */     // GIR_Coverage, 742,
     /* 121067 */     GIR_EraseRootFromParent_Done,
     /* 121068 */   // Label 2630: @121068
     /* 121068 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(121110), // Rule ID 746 //
     /* 121073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121084 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 121084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121088 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 121101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121108 */     GIR_RootConstrainSelectedInstOperands,
     /* 121109 */     // GIR_Coverage, 746,
     /* 121109 */     GIR_EraseRootFromParent_Done,
     /* 121110 */   // Label 2631: @121110
     /* 121110 */   GIM_Reject,
     /* 121111 */ // Label 2625: @121111
     /* 121111 */ GIM_Reject,
     /* 121112 */ // Label 2615: @121112
     /* 121112 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(121804),
     /* 121117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121127 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(121194), // Rule ID 739 //
     /* 121132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121150 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121162 */     // MIs[2] Operand 1
     /* 121162 */     // No operand predicates
     /* 121162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121171 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SAR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi_ND),
     /* 121174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121192 */     GIR_RootConstrainSelectedInstOperands,
     /* 121193 */     // GIR_Coverage, 739,
     /* 121193 */     GIR_EraseRootFromParent_Done,
     /* 121194 */   // Label 2633: @121194
     /* 121194 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(121267), // Rule ID 755 //
     /* 121199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121217 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121234 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SAR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121238 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL_ND),
     /* 121251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121265 */     GIR_RootConstrainSelectedInstOperands,
     /* 121266 */     // GIR_Coverage, 755,
     /* 121266 */     GIR_EraseRootFromParent_Done,
     /* 121267 */   // Label 2634: @121267
     /* 121267 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(121377), // Rule ID 17656 //
     /* 121272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121283 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121286 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121290 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121307 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm),
     /* 121361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121375 */     GIR_RootConstrainSelectedInstOperands,
     /* 121376 */     // GIR_Coverage, 17656,
     /* 121376 */     GIR_EraseRootFromParent_Done,
     /* 121377 */   // Label 2635: @121377
     /* 121377 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(121487), // Rule ID 17688 //
     /* 121382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121400 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121417 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm_EVEX),
     /* 121471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121485 */     GIR_RootConstrainSelectedInstOperands,
     /* 121486 */     // GIR_Coverage, 17688,
     /* 121486 */     GIR_EraseRootFromParent_Done,
     /* 121487 */   // Label 2636: @121487
     /* 121487 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(121524), // Rule ID 727 //
     /* 121492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121507 */     // MIs[1] Operand 1
     /* 121507 */     // No operand predicates
     /* 121507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121509 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 121512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121522 */     GIR_RootConstrainSelectedInstOperands,
     /* 121523 */     // GIR_Coverage, 727,
     /* 121523 */     GIR_EraseRootFromParent_Done,
     /* 121524 */   // Label 2637: @121524
     /* 121524 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(121561), // Rule ID 731 //
     /* 121529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121544 */     // MIs[1] Operand 1
     /* 121544 */     // No operand predicates
     /* 121544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121546 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 121549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121559 */     GIR_RootConstrainSelectedInstOperands,
     /* 121560 */     // GIR_Coverage, 731,
     /* 121560 */     GIR_EraseRootFromParent_Done,
     /* 121561 */   // Label 2638: @121561
     /* 121561 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(121640), // Rule ID 17652 //
     /* 121566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121577 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121610 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 121631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121638 */     GIR_RootConstrainSelectedInstOperands,
     /* 121639 */     // GIR_Coverage, 17652,
     /* 121639 */     GIR_EraseRootFromParent_Done,
     /* 121640 */   // Label 2639: @121640
     /* 121640 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(121719), // Rule ID 17684 //
     /* 121645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121656 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121656 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121659 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121663 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121689 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 121710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121717 */     GIR_RootConstrainSelectedInstOperands,
     /* 121718 */     // GIR_Coverage, 17684,
     /* 121718 */     GIR_EraseRootFromParent_Done,
     /* 121719 */   // Label 2640: @121719
     /* 121719 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(121761), // Rule ID 743 //
     /* 121724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121735 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121739 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 121752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121759 */     GIR_RootConstrainSelectedInstOperands,
     /* 121760 */     // GIR_Coverage, 743,
     /* 121760 */     GIR_EraseRootFromParent_Done,
     /* 121761 */   // Label 2641: @121761
     /* 121761 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(121803), // Rule ID 747 //
     /* 121766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121777 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121781 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 121794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121801 */     GIR_RootConstrainSelectedInstOperands,
     /* 121802 */     // GIR_Coverage, 747,
     /* 121802 */     GIR_EraseRootFromParent_Done,
     /* 121803 */   // Label 2642: @121803
     /* 121803 */   GIM_Reject,
     /* 121804 */ // Label 2632: @121804
     /* 121804 */ GIM_Reject,
     /* 121805 */ // Label 2616: @121805
     /* 121805 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(122497),
     /* 121810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 121813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121820 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(121887), // Rule ID 740 //
     /* 121825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121855 */     // MIs[2] Operand 1
     /* 121855 */     // No operand predicates
     /* 121855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121864 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SAR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi_ND),
     /* 121867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121885 */     GIR_RootConstrainSelectedInstOperands,
     /* 121886 */     // GIR_Coverage, 740,
     /* 121886 */     GIR_EraseRootFromParent_Done,
     /* 121887 */   // Label 2644: @121887
     /* 121887 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(121960), // Rule ID 756 //
     /* 121892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121927 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SAR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121931 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL_ND),
     /* 121944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121958 */     GIR_RootConstrainSelectedInstOperands,
     /* 121959 */     // GIR_Coverage, 756,
     /* 121959 */     GIR_EraseRootFromParent_Done,
     /* 121960 */   // Label 2645: @121960
     /* 121960 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(122070), // Rule ID 17657 //
     /* 121965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121976 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122000 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm),
     /* 122054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122068 */     GIR_RootConstrainSelectedInstOperands,
     /* 122069 */     // GIR_Coverage, 17657,
     /* 122069 */     GIR_EraseRootFromParent_Done,
     /* 122070 */   // Label 2646: @122070
     /* 122070 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(122180), // Rule ID 17689 //
     /* 122075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122086 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122093 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122110 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122136 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122143 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm_EVEX),
     /* 122164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122178 */     GIR_RootConstrainSelectedInstOperands,
     /* 122179 */     // GIR_Coverage, 17689,
     /* 122179 */     GIR_EraseRootFromParent_Done,
     /* 122180 */   // Label 2647: @122180
     /* 122180 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(122217), // Rule ID 728 //
     /* 122185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122200 */     // MIs[1] Operand 1
     /* 122200 */     // No operand predicates
     /* 122200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122202 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 122205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122215 */     GIR_RootConstrainSelectedInstOperands,
     /* 122216 */     // GIR_Coverage, 728,
     /* 122216 */     GIR_EraseRootFromParent_Done,
     /* 122217 */   // Label 2648: @122217
     /* 122217 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(122254), // Rule ID 732 //
     /* 122222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122237 */     // MIs[1] Operand 1
     /* 122237 */     // No operand predicates
     /* 122237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122239 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 122242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122244 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122252 */     GIR_RootConstrainSelectedInstOperands,
     /* 122253 */     // GIR_Coverage, 732,
     /* 122253 */     GIR_EraseRootFromParent_Done,
     /* 122254 */   // Label 2649: @122254
     /* 122254 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(122333), // Rule ID 17653 //
     /* 122259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 122262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122270 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 122324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122331 */     GIR_RootConstrainSelectedInstOperands,
     /* 122332 */     // GIR_Coverage, 17653,
     /* 122332 */     GIR_EraseRootFromParent_Done,
     /* 122333 */   // Label 2650: @122333
     /* 122333 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(122412), // Rule ID 17685 //
     /* 122338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122349 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122382 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 122403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122410 */     GIR_RootConstrainSelectedInstOperands,
     /* 122411 */     // GIR_Coverage, 17685,
     /* 122411 */     GIR_EraseRootFromParent_Done,
     /* 122412 */   // Label 2651: @122412
     /* 122412 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(122454), // Rule ID 744 //
     /* 122417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122428 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122432 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 122445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122452 */     GIR_RootConstrainSelectedInstOperands,
     /* 122453 */     // GIR_Coverage, 744,
     /* 122453 */     GIR_EraseRootFromParent_Done,
     /* 122454 */   // Label 2652: @122454
     /* 122454 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(122496), // Rule ID 748 //
     /* 122459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122470 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122474 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 122487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122494 */     GIR_RootConstrainSelectedInstOperands,
     /* 122495 */     // GIR_Coverage, 748,
     /* 122495 */     GIR_EraseRootFromParent_Done,
     /* 122496 */   // Label 2653: @122496
     /* 122496 */   GIM_Reject,
     /* 122497 */ // Label 2643: @122497
     /* 122497 */ GIM_Reject,
     /* 122498 */ // Label 2617: @122498
     /* 122498 */ GIM_Reject,
     /* 122499 */ // Label 29: @122499
     /* 122499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(123226),
     /* 122510 */ /*GILLT_s32*//*Label 2654*/ GIMT_Encode4(122518),
     /* 122514 */ /*GILLT_s64*//*Label 2655*/ GIMT_Encode4(122872),
     /* 122518 */ // Label 2654: @122518
     /* 122518 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(122871),
     /* 122523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122536 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(122609), // Rule ID 840 //
     /* 122541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122552 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122559 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122575 */     // MIs[2] Operand 1
     /* 122575 */     // No operand predicates
     /* 122575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122584 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8_ND),
     /* 122587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122607 */     GIR_RootConstrainSelectedInstOperands,
     /* 122608 */     // GIR_Coverage, 840,
     /* 122608 */     GIR_EraseRootFromParent_Done,
     /* 122609 */   // Label 2658: @122609
     /* 122609 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(122688), // Rule ID 843 //
     /* 122614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122628 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122632 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122653 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122657 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL_ND),
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122686 */     GIR_RootConstrainSelectedInstOperands,
     /* 122687 */     // GIR_Coverage, 843,
     /* 122687 */     GIR_EraseRootFromParent_Done,
     /* 122688 */   // Label 2659: @122688
     /* 122688 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(122731), // Rule ID 822 //
     /* 122693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122712 */     // MIs[1] Operand 1
     /* 122712 */     // No operand predicates
     /* 122712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122714 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 122717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122729 */     GIR_RootConstrainSelectedInstOperands,
     /* 122730 */     // GIR_Coverage, 822,
     /* 122730 */     GIR_EraseRootFromParent_Done,
     /* 122731 */   // Label 2660: @122731
     /* 122731 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(122774), // Rule ID 828 //
     /* 122736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122755 */     // MIs[1] Operand 1
     /* 122755 */     // No operand predicates
     /* 122755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122757 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 122760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122772 */     GIR_RootConstrainSelectedInstOperands,
     /* 122773 */     // GIR_Coverage, 828,
     /* 122773 */     GIR_EraseRootFromParent_Done,
     /* 122774 */   // Label 2661: @122774
     /* 122774 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(122822), // Rule ID 825 //
     /* 122779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122794 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122798 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 122811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122820 */     GIR_RootConstrainSelectedInstOperands,
     /* 122821 */     // GIR_Coverage, 825,
     /* 122821 */     GIR_EraseRootFromParent_Done,
     /* 122822 */   // Label 2662: @122822
     /* 122822 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(122870), // Rule ID 831 //
     /* 122827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122842 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122846 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 122859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122868 */     GIR_RootConstrainSelectedInstOperands,
     /* 122869 */     // GIR_Coverage, 831,
     /* 122869 */     GIR_EraseRootFromParent_Done,
     /* 122870 */   // Label 2663: @122870
     /* 122870 */   GIM_Reject,
     /* 122871 */ // Label 2657: @122871
     /* 122871 */ GIM_Reject,
     /* 122872 */ // Label 2655: @122872
     /* 122872 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(123225),
     /* 122877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122890 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(122963), // Rule ID 841 //
     /* 122895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122929 */     // MIs[2] Operand 1
     /* 122929 */     // No operand predicates
     /* 122929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122938 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8_ND),
     /* 122941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122961 */     GIR_RootConstrainSelectedInstOperands,
     /* 122962 */     // GIR_Coverage, 841,
     /* 122962 */     GIR_EraseRootFromParent_Done,
     /* 122963 */   // Label 2665: @122963
     /* 122963 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(123042), // Rule ID 844 //
     /* 122968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123007 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123011 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL_ND),
     /* 123024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123040 */     GIR_RootConstrainSelectedInstOperands,
     /* 123041 */     // GIR_Coverage, 844,
     /* 123041 */     GIR_EraseRootFromParent_Done,
     /* 123042 */   // Label 2666: @123042
     /* 123042 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(123085), // Rule ID 823 //
     /* 123047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123066 */     // MIs[1] Operand 1
     /* 123066 */     // No operand predicates
     /* 123066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123068 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 123071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123083 */     GIR_RootConstrainSelectedInstOperands,
     /* 123084 */     // GIR_Coverage, 823,
     /* 123084 */     GIR_EraseRootFromParent_Done,
     /* 123085 */   // Label 2667: @123085
     /* 123085 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(123128), // Rule ID 829 //
     /* 123090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123109 */     // MIs[1] Operand 1
     /* 123109 */     // No operand predicates
     /* 123109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123111 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 123114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123126 */     GIR_RootConstrainSelectedInstOperands,
     /* 123127 */     // GIR_Coverage, 829,
     /* 123127 */     GIR_EraseRootFromParent_Done,
     /* 123128 */   // Label 2668: @123128
     /* 123128 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(123176), // Rule ID 826 //
     /* 123133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123148 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123152 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 123165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123174 */     GIR_RootConstrainSelectedInstOperands,
     /* 123175 */     // GIR_Coverage, 826,
     /* 123175 */     GIR_EraseRootFromParent_Done,
     /* 123176 */   // Label 2669: @123176
     /* 123176 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(123224), // Rule ID 832 //
     /* 123181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123196 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123200 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 123213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123222 */     GIR_RootConstrainSelectedInstOperands,
     /* 123223 */     // GIR_Coverage, 832,
     /* 123223 */     GIR_EraseRootFromParent_Done,
     /* 123224 */   // Label 2670: @123224
     /* 123224 */   GIM_Reject,
     /* 123225 */ // Label 2664: @123225
     /* 123225 */ GIM_Reject,
     /* 123226 */ // Label 2656: @123226
     /* 123226 */ GIM_Reject,
     /* 123227 */ // Label 30: @123227
     /* 123227 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2673*/ GIMT_Encode4(123914),
     /* 123238 */ /*GILLT_s32*//*Label 2671*/ GIMT_Encode4(123246),
     /* 123242 */ /*GILLT_s64*//*Label 2672*/ GIMT_Encode4(123580),
     /* 123246 */ // Label 2671: @123246
     /* 123246 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(123579),
     /* 123251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 123254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123268 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(123337), // Rule ID 864 //
     /* 123273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123291 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123303 */     // MIs[2] Operand 1
     /* 123303 */     // No operand predicates
     /* 123303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123312 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8_ND),
     /* 123315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123335 */     GIR_RootConstrainSelectedInstOperands,
     /* 123336 */     // GIR_Coverage, 864,
     /* 123336 */     GIR_EraseRootFromParent_Done,
     /* 123337 */   // Label 2675: @123337
     /* 123337 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(123412), // Rule ID 867 //
     /* 123342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123356 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123360 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123377 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHRD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123381 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123387 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL_ND),
     /* 123394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123410 */     GIR_RootConstrainSelectedInstOperands,
     /* 123411 */     // GIR_Coverage, 867,
     /* 123411 */     GIR_EraseRootFromParent_Done,
     /* 123412 */   // Label 2676: @123412
     /* 123412 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(123451), // Rule ID 846 //
     /* 123417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123432 */     // MIs[1] Operand 1
     /* 123432 */     // No operand predicates
     /* 123432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123434 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 123437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123449 */     GIR_RootConstrainSelectedInstOperands,
     /* 123450 */     // GIR_Coverage, 846,
     /* 123450 */     GIR_EraseRootFromParent_Done,
     /* 123451 */   // Label 2677: @123451
     /* 123451 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(123490), // Rule ID 852 //
     /* 123456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123471 */     // MIs[1] Operand 1
     /* 123471 */     // No operand predicates
     /* 123471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123473 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 123476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123488 */     GIR_RootConstrainSelectedInstOperands,
     /* 123489 */     // GIR_Coverage, 852,
     /* 123489 */     GIR_EraseRootFromParent_Done,
     /* 123490 */   // Label 2678: @123490
     /* 123490 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(123534), // Rule ID 849 //
     /* 123495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123506 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123510 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 123523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123525 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123532 */     GIR_RootConstrainSelectedInstOperands,
     /* 123533 */     // GIR_Coverage, 849,
     /* 123533 */     GIR_EraseRootFromParent_Done,
     /* 123534 */   // Label 2679: @123534
     /* 123534 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(123578), // Rule ID 855 //
     /* 123539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123550 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123554 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 123567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123576 */     GIR_RootConstrainSelectedInstOperands,
     /* 123577 */     // GIR_Coverage, 855,
     /* 123577 */     GIR_EraseRootFromParent_Done,
     /* 123578 */   // Label 2680: @123578
     /* 123578 */   GIM_Reject,
     /* 123579 */ // Label 2674: @123579
     /* 123579 */ GIM_Reject,
     /* 123580 */ // Label 2672: @123580
     /* 123580 */ GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(123913),
     /* 123585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 123588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123602 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(123671), // Rule ID 865 //
     /* 123607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123625 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123637 */     // MIs[2] Operand 1
     /* 123637 */     // No operand predicates
     /* 123637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123646 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8_ND),
     /* 123649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123669 */     GIR_RootConstrainSelectedInstOperands,
     /* 123670 */     // GIR_Coverage, 865,
     /* 123670 */     GIR_EraseRootFromParent_Done,
     /* 123671 */   // Label 2682: @123671
     /* 123671 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(123746), // Rule ID 868 //
     /* 123676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123687 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123694 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123711 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHRD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123715 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL_ND),
     /* 123728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123744 */     GIR_RootConstrainSelectedInstOperands,
     /* 123745 */     // GIR_Coverage, 868,
     /* 123745 */     GIR_EraseRootFromParent_Done,
     /* 123746 */   // Label 2683: @123746
     /* 123746 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(123785), // Rule ID 847 //
     /* 123751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123766 */     // MIs[1] Operand 1
     /* 123766 */     // No operand predicates
     /* 123766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123768 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 123771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123773 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123783 */     GIR_RootConstrainSelectedInstOperands,
     /* 123784 */     // GIR_Coverage, 847,
     /* 123784 */     GIR_EraseRootFromParent_Done,
     /* 123785 */   // Label 2684: @123785
     /* 123785 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(123824), // Rule ID 853 //
     /* 123790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123805 */     // MIs[1] Operand 1
     /* 123805 */     // No operand predicates
     /* 123805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123807 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 123810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123822 */     GIR_RootConstrainSelectedInstOperands,
     /* 123823 */     // GIR_Coverage, 853,
     /* 123823 */     GIR_EraseRootFromParent_Done,
     /* 123824 */   // Label 2685: @123824
     /* 123824 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(123868), // Rule ID 850 //
     /* 123829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123840 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123844 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 123857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123859 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123866 */     GIR_RootConstrainSelectedInstOperands,
     /* 123867 */     // GIR_Coverage, 850,
     /* 123867 */     GIR_EraseRootFromParent_Done,
     /* 123868 */   // Label 2686: @123868
     /* 123868 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(123912), // Rule ID 856 //
     /* 123873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123884 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123888 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 123901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123910 */     GIR_RootConstrainSelectedInstOperands,
     /* 123911 */     // GIR_Coverage, 856,
     /* 123911 */     GIR_EraseRootFromParent_Done,
     /* 123912 */   // Label 2687: @123912
     /* 123912 */   GIM_Reject,
     /* 123913 */ // Label 2681: @123913
     /* 123913 */ GIM_Reject,
     /* 123914 */ // Label 2673: @123914
     /* 123914 */ GIM_Reject,
     /* 123915 */ // Label 31: @123915
     /* 123915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2698*/ GIMT_Encode4(127412),
     /* 123926 */ /*GILLT_s8*//*Label 2688*/ GIMT_Encode4(124002),
     /* 123930 */ /*GILLT_s16*//*Label 2689*/ GIMT_Encode4(124432),
     /* 123934 */ /*GILLT_s32*//*Label 2690*/ GIMT_Encode4(124862),
     /* 123938 */ /*GILLT_s64*//*Label 2691*/ GIMT_Encode4(125525), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123954 */ /*GILLT_v2s64*//*Label 2692*/ GIMT_Encode4(126188), GIMT_Encode4(0),
     /* 123962 */ /*GILLT_v4s32*//*Label 2693*/ GIMT_Encode4(126455),
     /* 123966 */ /*GILLT_v4s64*//*Label 2694*/ GIMT_Encode4(126722), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123978 */ /*GILLT_v8s32*//*Label 2695*/ GIMT_Encode4(126973),
     /* 123982 */ /*GILLT_v8s64*//*Label 2696*/ GIMT_Encode4(127224), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123998 */ /*GILLT_v16s32*//*Label 2697*/ GIMT_Encode4(127318),
     /* 124002 */ // Label 2688: @124002
     /* 124002 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(124431),
     /* 124007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 124010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124017 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(124076), // Rule ID 17624 //
     /* 124022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124040 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124057 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROL8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1_ND),
     /* 124060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124074 */     GIR_RootConstrainSelectedInstOperands,
     /* 124075 */     // GIR_Coverage, 17624,
     /* 124075 */     GIR_EraseRootFromParent_Done,
     /* 124076 */   // Label 2700: @124076
     /* 124076 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(124143), // Rule ID 801 //
     /* 124081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124099 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124111 */     // MIs[2] Operand 1
     /* 124111 */     // No operand predicates
     /* 124111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124120 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi_ND),
     /* 124123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124141 */     GIR_RootConstrainSelectedInstOperands,
     /* 124142 */     // GIR_Coverage, 801,
     /* 124142 */     GIR_EraseRootFromParent_Done,
     /* 124143 */   // Label 2701: @124143
     /* 124143 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(124216), // Rule ID 817 //
     /* 124148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124166 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124183 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124187 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL_ND),
     /* 124200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124214 */     GIR_RootConstrainSelectedInstOperands,
     /* 124215 */     // GIR_Coverage, 817,
     /* 124215 */     GIR_EraseRootFromParent_Done,
     /* 124216 */   // Label 2702: @124216
     /* 124216 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(124244), // Rule ID 17600 //
     /* 124221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124232 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 124235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124242 */     GIR_RootConstrainSelectedInstOperands,
     /* 124243 */     // GIR_Coverage, 17600,
     /* 124243 */     GIR_EraseRootFromParent_Done,
     /* 124244 */   // Label 2703: @124244
     /* 124244 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(124272), // Rule ID 17608 //
     /* 124249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124260 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 124263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124270 */     GIR_RootConstrainSelectedInstOperands,
     /* 124271 */     // GIR_Coverage, 17608,
     /* 124271 */     GIR_EraseRootFromParent_Done,
     /* 124272 */   // Label 2704: @124272
     /* 124272 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(124309), // Rule ID 789 //
     /* 124277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124292 */     // MIs[1] Operand 1
     /* 124292 */     // No operand predicates
     /* 124292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124294 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 124297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124307 */     GIR_RootConstrainSelectedInstOperands,
     /* 124308 */     // GIR_Coverage, 789,
     /* 124308 */     GIR_EraseRootFromParent_Done,
     /* 124309 */   // Label 2705: @124309
     /* 124309 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(124346), // Rule ID 793 //
     /* 124314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124329 */     // MIs[1] Operand 1
     /* 124329 */     // No operand predicates
     /* 124329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124331 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 124334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124336 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124344 */     GIR_RootConstrainSelectedInstOperands,
     /* 124345 */     // GIR_Coverage, 793,
     /* 124345 */     GIR_EraseRootFromParent_Done,
     /* 124346 */   // Label 2706: @124346
     /* 124346 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(124388), // Rule ID 805 //
     /* 124351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124362 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 124379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124386 */     GIR_RootConstrainSelectedInstOperands,
     /* 124387 */     // GIR_Coverage, 805,
     /* 124387 */     GIR_EraseRootFromParent_Done,
     /* 124388 */   // Label 2707: @124388
     /* 124388 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(124430), // Rule ID 809 //
     /* 124393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124404 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124408 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 124421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124428 */     GIR_RootConstrainSelectedInstOperands,
     /* 124429 */     // GIR_Coverage, 809,
     /* 124429 */     GIR_EraseRootFromParent_Done,
     /* 124430 */   // Label 2708: @124430
     /* 124430 */   GIM_Reject,
     /* 124431 */ // Label 2699: @124431
     /* 124431 */ GIM_Reject,
     /* 124432 */ // Label 2689: @124432
     /* 124432 */ GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(124861),
     /* 124437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 124440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124447 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(124506), // Rule ID 17625 //
     /* 124452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124463 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124466 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124470 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124487 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROL16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1_ND),
     /* 124490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124504 */     GIR_RootConstrainSelectedInstOperands,
     /* 124505 */     // GIR_Coverage, 17625,
     /* 124505 */     GIR_EraseRootFromParent_Done,
     /* 124506 */   // Label 2710: @124506
     /* 124506 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(124573), // Rule ID 802 //
     /* 124511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124529 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124541 */     // MIs[2] Operand 1
     /* 124541 */     // No operand predicates
     /* 124541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124550 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi_ND),
     /* 124553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124571 */     GIR_RootConstrainSelectedInstOperands,
     /* 124572 */     // GIR_Coverage, 802,
     /* 124572 */     GIR_EraseRootFromParent_Done,
     /* 124573 */   // Label 2711: @124573
     /* 124573 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(124646), // Rule ID 818 //
     /* 124578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124596 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124613 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124617 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL_ND),
     /* 124630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124644 */     GIR_RootConstrainSelectedInstOperands,
     /* 124645 */     // GIR_Coverage, 818,
     /* 124645 */     GIR_EraseRootFromParent_Done,
     /* 124646 */   // Label 2712: @124646
     /* 124646 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(124674), // Rule ID 17601 //
     /* 124651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124662 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 124665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124672 */     GIR_RootConstrainSelectedInstOperands,
     /* 124673 */     // GIR_Coverage, 17601,
     /* 124673 */     GIR_EraseRootFromParent_Done,
     /* 124674 */   // Label 2713: @124674
     /* 124674 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(124702), // Rule ID 17609 //
     /* 124679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124690 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 124693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124700 */     GIR_RootConstrainSelectedInstOperands,
     /* 124701 */     // GIR_Coverage, 17609,
     /* 124701 */     GIR_EraseRootFromParent_Done,
     /* 124702 */   // Label 2714: @124702
     /* 124702 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(124739), // Rule ID 790 //
     /* 124707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124722 */     // MIs[1] Operand 1
     /* 124722 */     // No operand predicates
     /* 124722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124724 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 124727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124737 */     GIR_RootConstrainSelectedInstOperands,
     /* 124738 */     // GIR_Coverage, 790,
     /* 124738 */     GIR_EraseRootFromParent_Done,
     /* 124739 */   // Label 2715: @124739
     /* 124739 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(124776), // Rule ID 794 //
     /* 124744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124759 */     // MIs[1] Operand 1
     /* 124759 */     // No operand predicates
     /* 124759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124761 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 124764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124774 */     GIR_RootConstrainSelectedInstOperands,
     /* 124775 */     // GIR_Coverage, 794,
     /* 124775 */     GIR_EraseRootFromParent_Done,
     /* 124776 */   // Label 2716: @124776
     /* 124776 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(124818), // Rule ID 806 //
     /* 124781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124792 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124796 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 124809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124816 */     GIR_RootConstrainSelectedInstOperands,
     /* 124817 */     // GIR_Coverage, 806,
     /* 124817 */     GIR_EraseRootFromParent_Done,
     /* 124818 */   // Label 2717: @124818
     /* 124818 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(124860), // Rule ID 810 //
     /* 124823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124834 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124838 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 124851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124858 */     GIR_RootConstrainSelectedInstOperands,
     /* 124859 */     // GIR_Coverage, 810,
     /* 124859 */     GIR_EraseRootFromParent_Done,
     /* 124860 */   // Label 2718: @124860
     /* 124860 */   GIM_Reject,
     /* 124861 */ // Label 2709: @124861
     /* 124861 */ GIM_Reject,
     /* 124862 */ // Label 2690: @124862
     /* 124862 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(125524),
     /* 124867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 124870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124877 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(124936), // Rule ID 17626 //
     /* 124882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124900 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124917 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROL32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1_ND),
     /* 124920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124934 */     GIR_RootConstrainSelectedInstOperands,
     /* 124935 */     // GIR_Coverage, 17626,
     /* 124935 */     GIR_EraseRootFromParent_Done,
     /* 124936 */   // Label 2720: @124936
     /* 124936 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(125003), // Rule ID 803 //
     /* 124941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124959 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124971 */     // MIs[2] Operand 1
     /* 124971 */     // No operand predicates
     /* 124971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124980 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi_ND),
     /* 124983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125001 */     GIR_RootConstrainSelectedInstOperands,
     /* 125002 */     // GIR_Coverage, 803,
     /* 125002 */     GIR_EraseRootFromParent_Done,
     /* 125003 */   // Label 2721: @125003
     /* 125003 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(125067), // Rule ID 17648 //
     /* 125008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125019 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125026 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125038 */     // MIs[2] Operand 1
     /* 125038 */     // No operand predicates
     /* 125038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125047 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi),
     /* 125050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125065 */     GIR_RootConstrainSelectedInstOperands,
     /* 125066 */     // GIR_Coverage, 17648,
     /* 125066 */     GIR_EraseRootFromParent_Done,
     /* 125067 */   // Label 2722: @125067
     /* 125067 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(125131), // Rule ID 17680 //
     /* 125072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125083 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125090 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125102 */     // MIs[2] Operand 1
     /* 125102 */     // No operand predicates
     /* 125102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125111 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi_EVEX),
     /* 125114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125129 */     GIR_RootConstrainSelectedInstOperands,
     /* 125130 */     // GIR_Coverage, 17680,
     /* 125130 */     GIR_EraseRootFromParent_Done,
     /* 125131 */   // Label 2723: @125131
     /* 125131 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(125204), // Rule ID 819 //
     /* 125136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125154 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125171 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125175 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL_ND),
     /* 125188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125202 */     GIR_RootConstrainSelectedInstOperands,
     /* 125203 */     // GIR_Coverage, 819,
     /* 125203 */     GIR_EraseRootFromParent_Done,
     /* 125204 */   // Label 2724: @125204
     /* 125204 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(125238), // Rule ID 17644 //
     /* 125209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125224 */     // MIs[1] Operand 1
     /* 125224 */     // No operand predicates
     /* 125224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125226 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 125229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125236 */     GIR_RootConstrainSelectedInstOperands,
     /* 125237 */     // GIR_Coverage, 17644,
     /* 125237 */     GIR_EraseRootFromParent_Done,
     /* 125238 */   // Label 2725: @125238
     /* 125238 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(125272), // Rule ID 17676 //
     /* 125243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125258 */     // MIs[1] Operand 1
     /* 125258 */     // No operand predicates
     /* 125258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125260 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 125263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125270 */     GIR_RootConstrainSelectedInstOperands,
     /* 125271 */     // GIR_Coverage, 17676,
     /* 125271 */     GIR_EraseRootFromParent_Done,
     /* 125272 */   // Label 2726: @125272
     /* 125272 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(125309), // Rule ID 871 //
     /* 125277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125292 */     // MIs[1] Operand 1
     /* 125292 */     // No operand predicates
     /* 125292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125294 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 125297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125307 */     GIR_RootConstrainSelectedInstOperands,
     /* 125308 */     // GIR_Coverage, 871,
     /* 125308 */     GIR_EraseRootFromParent_Done,
     /* 125309 */   // Label 2727: @125309
     /* 125309 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(125337), // Rule ID 17602 //
     /* 125314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125325 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 125328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125335 */     GIR_RootConstrainSelectedInstOperands,
     /* 125336 */     // GIR_Coverage, 17602,
     /* 125336 */     GIR_EraseRootFromParent_Done,
     /* 125337 */   // Label 2728: @125337
     /* 125337 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(125365), // Rule ID 17610 //
     /* 125342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125353 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 125356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125363 */     GIR_RootConstrainSelectedInstOperands,
     /* 125364 */     // GIR_Coverage, 17610,
     /* 125364 */     GIR_EraseRootFromParent_Done,
     /* 125365 */   // Label 2729: @125365
     /* 125365 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(125402), // Rule ID 791 //
     /* 125370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125385 */     // MIs[1] Operand 1
     /* 125385 */     // No operand predicates
     /* 125385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125387 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 125390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125400 */     GIR_RootConstrainSelectedInstOperands,
     /* 125401 */     // GIR_Coverage, 791,
     /* 125401 */     GIR_EraseRootFromParent_Done,
     /* 125402 */   // Label 2730: @125402
     /* 125402 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(125439), // Rule ID 795 //
     /* 125407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125422 */     // MIs[1] Operand 1
     /* 125422 */     // No operand predicates
     /* 125422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125424 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 125427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125437 */     GIR_RootConstrainSelectedInstOperands,
     /* 125438 */     // GIR_Coverage, 795,
     /* 125438 */     GIR_EraseRootFromParent_Done,
     /* 125439 */   // Label 2731: @125439
     /* 125439 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(125481), // Rule ID 807 //
     /* 125444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125455 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125459 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 125472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125474 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125479 */     GIR_RootConstrainSelectedInstOperands,
     /* 125480 */     // GIR_Coverage, 807,
     /* 125480 */     GIR_EraseRootFromParent_Done,
     /* 125481 */   // Label 2732: @125481
     /* 125481 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(125523), // Rule ID 811 //
     /* 125486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125497 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125501 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 125514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125516 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125521 */     GIR_RootConstrainSelectedInstOperands,
     /* 125522 */     // GIR_Coverage, 811,
     /* 125522 */     GIR_EraseRootFromParent_Done,
     /* 125523 */   // Label 2733: @125523
     /* 125523 */   GIM_Reject,
     /* 125524 */ // Label 2719: @125524
     /* 125524 */ GIM_Reject,
     /* 125525 */ // Label 2691: @125525
     /* 125525 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(126187),
     /* 125530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 125533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 125536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125540 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(125599), // Rule ID 17627 //
     /* 125545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125580 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROL64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 125580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1_ND),
     /* 125583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125597 */     GIR_RootConstrainSelectedInstOperands,
     /* 125598 */     // GIR_Coverage, 17627,
     /* 125598 */     GIR_EraseRootFromParent_Done,
     /* 125599 */   // Label 2735: @125599
     /* 125599 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(125666), // Rule ID 804 //
     /* 125604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125634 */     // MIs[2] Operand 1
     /* 125634 */     // No operand predicates
     /* 125634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125643 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi_ND),
     /* 125646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125648 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125664 */     GIR_RootConstrainSelectedInstOperands,
     /* 125665 */     // GIR_Coverage, 804,
     /* 125665 */     GIR_EraseRootFromParent_Done,
     /* 125666 */   // Label 2736: @125666
     /* 125666 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(125730), // Rule ID 17649 //
     /* 125671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125701 */     // MIs[2] Operand 1
     /* 125701 */     // No operand predicates
     /* 125701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125710 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi),
     /* 125713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125728 */     GIR_RootConstrainSelectedInstOperands,
     /* 125729 */     // GIR_Coverage, 17649,
     /* 125729 */     GIR_EraseRootFromParent_Done,
     /* 125730 */   // Label 2737: @125730
     /* 125730 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(125794), // Rule ID 17681 //
     /* 125735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125765 */     // MIs[2] Operand 1
     /* 125765 */     // No operand predicates
     /* 125765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125774 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi_EVEX),
     /* 125777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125779 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125792 */     GIR_RootConstrainSelectedInstOperands,
     /* 125793 */     // GIR_Coverage, 17681,
     /* 125793 */     GIR_EraseRootFromParent_Done,
     /* 125794 */   // Label 2738: @125794
     /* 125794 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(125867), // Rule ID 820 //
     /* 125799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125810 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125817 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125834 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125838 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL_ND),
     /* 125851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125865 */     GIR_RootConstrainSelectedInstOperands,
     /* 125866 */     // GIR_Coverage, 820,
     /* 125866 */     GIR_EraseRootFromParent_Done,
     /* 125867 */   // Label 2739: @125867
     /* 125867 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(125901), // Rule ID 17645 //
     /* 125872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125887 */     // MIs[1] Operand 1
     /* 125887 */     // No operand predicates
     /* 125887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125889 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 125892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125899 */     GIR_RootConstrainSelectedInstOperands,
     /* 125900 */     // GIR_Coverage, 17645,
     /* 125900 */     GIR_EraseRootFromParent_Done,
     /* 125901 */   // Label 2740: @125901
     /* 125901 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(125935), // Rule ID 17677 //
     /* 125906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125921 */     // MIs[1] Operand 1
     /* 125921 */     // No operand predicates
     /* 125921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125923 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 125926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125933 */     GIR_RootConstrainSelectedInstOperands,
     /* 125934 */     // GIR_Coverage, 17677,
     /* 125934 */     GIR_EraseRootFromParent_Done,
     /* 125935 */   // Label 2741: @125935
     /* 125935 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(125972), // Rule ID 872 //
     /* 125940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125955 */     // MIs[1] Operand 1
     /* 125955 */     // No operand predicates
     /* 125955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125957 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 125960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125970 */     GIR_RootConstrainSelectedInstOperands,
     /* 125971 */     // GIR_Coverage, 872,
     /* 125971 */     GIR_EraseRootFromParent_Done,
     /* 125972 */   // Label 2742: @125972
     /* 125972 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(126000), // Rule ID 17603 //
     /* 125977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125988 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 125991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125998 */     GIR_RootConstrainSelectedInstOperands,
     /* 125999 */     // GIR_Coverage, 17603,
     /* 125999 */     GIR_EraseRootFromParent_Done,
     /* 126000 */   // Label 2743: @126000
     /* 126000 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(126028), // Rule ID 17611 //
     /* 126005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 126008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 126016 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 126019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126026 */     GIR_RootConstrainSelectedInstOperands,
     /* 126027 */     // GIR_Coverage, 17611,
     /* 126027 */     GIR_EraseRootFromParent_Done,
     /* 126028 */   // Label 2744: @126028
     /* 126028 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(126065), // Rule ID 792 //
     /* 126033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126048 */     // MIs[1] Operand 1
     /* 126048 */     // No operand predicates
     /* 126048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126050 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 126053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 126060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126063 */     GIR_RootConstrainSelectedInstOperands,
     /* 126064 */     // GIR_Coverage, 792,
     /* 126064 */     GIR_EraseRootFromParent_Done,
     /* 126065 */   // Label 2745: @126065
     /* 126065 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(126102), // Rule ID 796 //
     /* 126070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126085 */     // MIs[1] Operand 1
     /* 126085 */     // No operand predicates
     /* 126085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126087 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 126090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 126097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126100 */     GIR_RootConstrainSelectedInstOperands,
     /* 126101 */     // GIR_Coverage, 796,
     /* 126101 */     GIR_EraseRootFromParent_Done,
     /* 126102 */   // Label 2746: @126102
     /* 126102 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(126144), // Rule ID 808 //
     /* 126107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126118 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126122 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 126135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126142 */     GIR_RootConstrainSelectedInstOperands,
     /* 126143 */     // GIR_Coverage, 808,
     /* 126143 */     GIR_EraseRootFromParent_Done,
     /* 126144 */   // Label 2747: @126144
     /* 126144 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(126186), // Rule ID 812 //
     /* 126149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126160 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126164 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 126177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126184 */     GIR_RootConstrainSelectedInstOperands,
     /* 126185 */     // GIR_Coverage, 812,
     /* 126185 */     GIR_EraseRootFromParent_Done,
     /* 126186 */   // Label 2748: @126186
     /* 126186 */   GIM_Reject,
     /* 126187 */ // Label 2734: @126187
     /* 126187 */ GIM_Reject,
     /* 126188 */ // Label 2692: @126188
     /* 126188 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(126454),
     /* 126193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 126196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 126199 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(126261), // Rule ID 8005 //
     /* 126204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126243 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rm),
     /* 126246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126259 */     GIR_RootConstrainSelectedInstOperands,
     /* 126260 */     // GIR_Coverage, 8005,
     /* 126260 */     GIR_EraseRootFromParent_Done,
     /* 126261 */   // Label 2750: @126261
     /* 126261 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(126288), // Rule ID 8002 //
     /* 126266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126281 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 126281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 126286 */     GIR_RootConstrainSelectedInstOperands,
     /* 126287 */     // GIR_Coverage, 8002,
     /* 126287 */     GIR_Done,
     /* 126288 */   // Label 2751: @126288
     /* 126288 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(126453), // Rule ID 20804 //
     /* 126293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126308 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126308 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126311 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126315 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126322 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126325 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126329 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126334 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126337 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126341 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126344 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126349 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126354 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126435 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126452 */     // GIR_Coverage, 20804,
     /* 126452 */     GIR_EraseRootFromParent_Done,
     /* 126453 */   // Label 2752: @126453
     /* 126453 */   GIM_Reject,
     /* 126454 */ // Label 2749: @126454
     /* 126454 */ GIM_Reject,
     /* 126455 */ // Label 2693: @126455
     /* 126455 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(126721),
     /* 126460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 126466 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(126528), // Rule ID 7978 //
     /* 126471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126490 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126497 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126510 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rm),
     /* 126513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126515 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126526 */     GIR_RootConstrainSelectedInstOperands,
     /* 126527 */     // GIR_Coverage, 7978,
     /* 126527 */     GIR_EraseRootFromParent_Done,
     /* 126528 */   // Label 2754: @126528
     /* 126528 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(126555), // Rule ID 7975 //
     /* 126533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126548 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 126548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 126553 */     GIR_RootConstrainSelectedInstOperands,
     /* 126554 */     // GIR_Coverage, 7975,
     /* 126554 */     GIR_Done,
     /* 126555 */   // Label 2755: @126555
     /* 126555 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(126720), // Rule ID 20806 //
     /* 126560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126575 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126575 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126578 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126582 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126589 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126592 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126596 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126601 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126604 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126608 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126611 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126616 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126621 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126626 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126629 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126633 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126652 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126659 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126702 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126719 */     // GIR_Coverage, 20806,
     /* 126719 */     GIR_EraseRootFromParent_Done,
     /* 126720 */   // Label 2756: @126720
     /* 126720 */   GIM_Reject,
     /* 126721 */ // Label 2753: @126721
     /* 126721 */ GIM_Reject,
     /* 126722 */ // Label 2694: @126722
     /* 126722 */ GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(126972),
     /* 126727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 126730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 126733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126741 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(126795), // Rule ID 7996 //
     /* 126746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126777 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rm),
     /* 126780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126793 */     GIR_RootConstrainSelectedInstOperands,
     /* 126794 */     // GIR_Coverage, 7996,
     /* 126794 */     GIR_EraseRootFromParent_Done,
     /* 126795 */   // Label 2758: @126795
     /* 126795 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(126814), // Rule ID 7993 //
     /* 126800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126807 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 126807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 126812 */     GIR_RootConstrainSelectedInstOperands,
     /* 126813 */     // GIR_Coverage, 7993,
     /* 126813 */     GIR_Done,
     /* 126814 */   // Label 2759: @126814
     /* 126814 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(126971), // Rule ID 20805 //
     /* 126819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126826 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126826 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126829 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126833 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126840 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126843 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126847 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126852 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126855 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126859 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126862 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126867 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126872 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126877 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126880 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126884 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126903 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126910 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126918 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126923 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126940 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126943 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126970 */     // GIR_Coverage, 20805,
     /* 126970 */     GIR_EraseRootFromParent_Done,
     /* 126971 */   // Label 2760: @126971
     /* 126971 */   GIM_Reject,
     /* 126972 */ // Label 2757: @126972
     /* 126972 */ GIM_Reject,
     /* 126973 */ // Label 2695: @126973
     /* 126973 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(127223),
     /* 126978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 126981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 126984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126992 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(127046), // Rule ID 7969 //
     /* 126997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 127000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127028 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rm),
     /* 127031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127044 */     GIR_RootConstrainSelectedInstOperands,
     /* 127045 */     // GIR_Coverage, 7969,
     /* 127045 */     GIR_EraseRootFromParent_Done,
     /* 127046 */   // Label 2762: @127046
     /* 127046 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(127065), // Rule ID 7966 //
     /* 127051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 127054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127058 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 127058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 127063 */     GIR_RootConstrainSelectedInstOperands,
     /* 127064 */     // GIR_Coverage, 7966,
     /* 127064 */     GIR_Done,
     /* 127065 */   // Label 2763: @127065
     /* 127065 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(127222), // Rule ID 20807 //
     /* 127070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 127073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127077 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 127077 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 127080 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127084 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 127091 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 127094 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 127098 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127103 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 127106 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 127110 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 127113 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 127118 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127123 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127128 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 127131 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127135 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 127145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 127149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127154 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 127157 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 127161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 127164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 127169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 127182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 127194 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 127197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 127211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127221 */     // GIR_Coverage, 20807,
     /* 127221 */     GIR_EraseRootFromParent_Done,
     /* 127222 */   // Label 2764: @127222
     /* 127222 */   GIM_Reject,
     /* 127223 */ // Label 2761: @127223
     /* 127223 */ GIM_Reject,
     /* 127224 */ // Label 2696: @127224
     /* 127224 */ GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(127317),
     /* 127229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 127232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 127235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127243 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(127297), // Rule ID 7987 //
     /* 127248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127259 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127279 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrm),
     /* 127282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127295 */     GIR_RootConstrainSelectedInstOperands,
     /* 127296 */     // GIR_Coverage, 7987,
     /* 127296 */     GIR_EraseRootFromParent_Done,
     /* 127297 */   // Label 2766: @127297
     /* 127297 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(127316), // Rule ID 7984 //
     /* 127302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127309 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 127309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 127314 */     GIR_RootConstrainSelectedInstOperands,
     /* 127315 */     // GIR_Coverage, 7984,
     /* 127315 */     GIR_Done,
     /* 127316 */   // Label 2767: @127316
     /* 127316 */   GIM_Reject,
     /* 127317 */ // Label 2765: @127317
     /* 127317 */ GIM_Reject,
     /* 127318 */ // Label 2697: @127318
     /* 127318 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(127411),
     /* 127323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 127326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 127329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127337 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(127391), // Rule ID 7960 //
     /* 127342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127373 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrm),
     /* 127376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127389 */     GIR_RootConstrainSelectedInstOperands,
     /* 127390 */     // GIR_Coverage, 7960,
     /* 127390 */     GIR_EraseRootFromParent_Done,
     /* 127391 */   // Label 2769: @127391
     /* 127391 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(127410), // Rule ID 7957 //
     /* 127396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127403 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 127403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127408 */     GIR_RootConstrainSelectedInstOperands,
     /* 127409 */     // GIR_Coverage, 7957,
     /* 127409 */     GIR_Done,
     /* 127410 */   // Label 2770: @127410
     /* 127410 */   GIM_Reject,
     /* 127411 */ // Label 2768: @127411
     /* 127411 */ GIM_Reject,
     /* 127412 */ // Label 2698: @127412
     /* 127412 */ GIM_Reject,
     /* 127413 */ // Label 32: @127413
     /* 127413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2783*/ GIMT_Encode4(131132),
     /* 127424 */ /*GILLT_s8*//*Label 2771*/ GIMT_Encode4(127500),
     /* 127428 */ /*GILLT_s16*//*Label 2772*/ GIMT_Encode4(127930),
     /* 127432 */ /*GILLT_s32*//*Label 2773*/ GIMT_Encode4(128360),
     /* 127436 */ /*GILLT_s64*//*Label 2774*/ GIMT_Encode4(128827), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127452 */ /*GILLT_v2s64*//*Label 2775*/ GIMT_Encode4(129294), GIMT_Encode4(0),
     /* 127460 */ /*GILLT_v4s32*//*Label 2776*/ GIMT_Encode4(129712),
     /* 127464 */ /*GILLT_v4s64*//*Label 2777*/ GIMT_Encode4(130130), GIMT_Encode4(0),
     /* 127472 */ /*GILLT_v8s16*//*Label 2778*/ GIMT_Encode4(130381),
     /* 127476 */ /*GILLT_v8s32*//*Label 2779*/ GIMT_Encode4(130537),
     /* 127480 */ /*GILLT_v8s64*//*Label 2780*/ GIMT_Encode4(130788), GIMT_Encode4(0),
     /* 127488 */ /*GILLT_v16s8*//*Label 2781*/ GIMT_Encode4(130882), GIMT_Encode4(0),
     /* 127496 */ /*GILLT_v16s32*//*Label 2782*/ GIMT_Encode4(131038),
     /* 127500 */ // Label 2771: @127500
     /* 127500 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(127929),
     /* 127505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 127508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127515 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(127574), // Rule ID 17620 //
     /* 127520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127538 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127555 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROR8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1_ND),
     /* 127558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127572 */     GIR_RootConstrainSelectedInstOperands,
     /* 127573 */     // GIR_Coverage, 17620,
     /* 127573 */     GIR_EraseRootFromParent_Done,
     /* 127574 */   // Label 2785: @127574
     /* 127574 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(127641), // Rule ID 769 //
     /* 127579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127597 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127609 */     // MIs[2] Operand 1
     /* 127609 */     // No operand predicates
     /* 127609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127618 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi_ND),
     /* 127621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127639 */     GIR_RootConstrainSelectedInstOperands,
     /* 127640 */     // GIR_Coverage, 769,
     /* 127640 */     GIR_EraseRootFromParent_Done,
     /* 127641 */   // Label 2786: @127641
     /* 127641 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(127714), // Rule ID 785 //
     /* 127646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127657 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127664 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127681 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127685 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL_ND),
     /* 127698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127712 */     GIR_RootConstrainSelectedInstOperands,
     /* 127713 */     // GIR_Coverage, 785,
     /* 127713 */     GIR_EraseRootFromParent_Done,
     /* 127714 */   // Label 2787: @127714
     /* 127714 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(127742), // Rule ID 17596 //
     /* 127719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127730 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 127733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127740 */     GIR_RootConstrainSelectedInstOperands,
     /* 127741 */     // GIR_Coverage, 17596,
     /* 127741 */     GIR_EraseRootFromParent_Done,
     /* 127742 */   // Label 2788: @127742
     /* 127742 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(127770), // Rule ID 17604 //
     /* 127747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127758 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 127761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127768 */     GIR_RootConstrainSelectedInstOperands,
     /* 127769 */     // GIR_Coverage, 17604,
     /* 127769 */     GIR_EraseRootFromParent_Done,
     /* 127770 */   // Label 2789: @127770
     /* 127770 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(127807), // Rule ID 757 //
     /* 127775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127790 */     // MIs[1] Operand 1
     /* 127790 */     // No operand predicates
     /* 127790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127792 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 127795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127805 */     GIR_RootConstrainSelectedInstOperands,
     /* 127806 */     // GIR_Coverage, 757,
     /* 127806 */     GIR_EraseRootFromParent_Done,
     /* 127807 */   // Label 2790: @127807
     /* 127807 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(127844), // Rule ID 761 //
     /* 127812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127827 */     // MIs[1] Operand 1
     /* 127827 */     // No operand predicates
     /* 127827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127829 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 127832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127834 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127842 */     GIR_RootConstrainSelectedInstOperands,
     /* 127843 */     // GIR_Coverage, 761,
     /* 127843 */     GIR_EraseRootFromParent_Done,
     /* 127844 */   // Label 2791: @127844
     /* 127844 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(127886), // Rule ID 773 //
     /* 127849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127860 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127864 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 127877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127879 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127884 */     GIR_RootConstrainSelectedInstOperands,
     /* 127885 */     // GIR_Coverage, 773,
     /* 127885 */     GIR_EraseRootFromParent_Done,
     /* 127886 */   // Label 2792: @127886
     /* 127886 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(127928), // Rule ID 777 //
     /* 127891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127902 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127906 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 127919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127921 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127926 */     GIR_RootConstrainSelectedInstOperands,
     /* 127927 */     // GIR_Coverage, 777,
     /* 127927 */     GIR_EraseRootFromParent_Done,
     /* 127928 */   // Label 2793: @127928
     /* 127928 */   GIM_Reject,
     /* 127929 */ // Label 2784: @127929
     /* 127929 */ GIM_Reject,
     /* 127930 */ // Label 2772: @127930
     /* 127930 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(128359),
     /* 127935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127945 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(128004), // Rule ID 17621 //
     /* 127950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127961 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127968 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127985 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROR16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1_ND),
     /* 127988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128002 */     GIR_RootConstrainSelectedInstOperands,
     /* 128003 */     // GIR_Coverage, 17621,
     /* 128003 */     GIR_EraseRootFromParent_Done,
     /* 128004 */   // Label 2795: @128004
     /* 128004 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(128071), // Rule ID 770 //
     /* 128009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128027 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 128031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128039 */     // MIs[2] Operand 1
     /* 128039 */     // No operand predicates
     /* 128039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128048 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi_ND),
     /* 128051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128069 */     GIR_RootConstrainSelectedInstOperands,
     /* 128070 */     // GIR_Coverage, 770,
     /* 128070 */     GIR_EraseRootFromParent_Done,
     /* 128071 */   // Label 2796: @128071
     /* 128071 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(128144), // Rule ID 786 //
     /* 128076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128094 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 128098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128111 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128115 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL_ND),
     /* 128128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128142 */     GIR_RootConstrainSelectedInstOperands,
     /* 128143 */     // GIR_Coverage, 786,
     /* 128143 */     GIR_EraseRootFromParent_Done,
     /* 128144 */   // Label 2797: @128144
     /* 128144 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(128172), // Rule ID 17597 //
     /* 128149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 128160 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 128163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128170 */     GIR_RootConstrainSelectedInstOperands,
     /* 128171 */     // GIR_Coverage, 17597,
     /* 128171 */     GIR_EraseRootFromParent_Done,
     /* 128172 */   // Label 2798: @128172
     /* 128172 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(128200), // Rule ID 17605 //
     /* 128177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 128188 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 128191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128198 */     GIR_RootConstrainSelectedInstOperands,
     /* 128199 */     // GIR_Coverage, 17605,
     /* 128199 */     GIR_EraseRootFromParent_Done,
     /* 128200 */   // Label 2799: @128200
     /* 128200 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(128237), // Rule ID 758 //
     /* 128205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128220 */     // MIs[1] Operand 1
     /* 128220 */     // No operand predicates
     /* 128220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128222 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 128225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128235 */     GIR_RootConstrainSelectedInstOperands,
     /* 128236 */     // GIR_Coverage, 758,
     /* 128236 */     GIR_EraseRootFromParent_Done,
     /* 128237 */   // Label 2800: @128237
     /* 128237 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(128274), // Rule ID 762 //
     /* 128242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128257 */     // MIs[1] Operand 1
     /* 128257 */     // No operand predicates
     /* 128257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128259 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 128262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128272 */     GIR_RootConstrainSelectedInstOperands,
     /* 128273 */     // GIR_Coverage, 762,
     /* 128273 */     GIR_EraseRootFromParent_Done,
     /* 128274 */   // Label 2801: @128274
     /* 128274 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(128316), // Rule ID 774 //
     /* 128279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128290 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128294 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 128307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128314 */     GIR_RootConstrainSelectedInstOperands,
     /* 128315 */     // GIR_Coverage, 774,
     /* 128315 */     GIR_EraseRootFromParent_Done,
     /* 128316 */   // Label 2802: @128316
     /* 128316 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(128358), // Rule ID 778 //
     /* 128321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128332 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128336 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 128349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128356 */     GIR_RootConstrainSelectedInstOperands,
     /* 128357 */     // GIR_Coverage, 778,
     /* 128357 */     GIR_EraseRootFromParent_Done,
     /* 128358 */   // Label 2803: @128358
     /* 128358 */   GIM_Reject,
     /* 128359 */ // Label 2794: @128359
     /* 128359 */ GIM_Reject,
     /* 128360 */ // Label 2773: @128360
     /* 128360 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(128826),
     /* 128365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128375 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(128434), // Rule ID 17622 //
     /* 128380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128398 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128415 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROR32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1_ND),
     /* 128418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128432 */     GIR_RootConstrainSelectedInstOperands,
     /* 128433 */     // GIR_Coverage, 17622,
     /* 128433 */     GIR_EraseRootFromParent_Done,
     /* 128434 */   // Label 2805: @128434
     /* 128434 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(128501), // Rule ID 771 //
     /* 128439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128457 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128469 */     // MIs[2] Operand 1
     /* 128469 */     // No operand predicates
     /* 128469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128478 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi_ND),
     /* 128481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128499 */     GIR_RootConstrainSelectedInstOperands,
     /* 128500 */     // GIR_Coverage, 771,
     /* 128500 */     GIR_EraseRootFromParent_Done,
     /* 128501 */   // Label 2806: @128501
     /* 128501 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(128574), // Rule ID 787 //
     /* 128506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128520 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128524 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128541 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128545 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL_ND),
     /* 128558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128572 */     GIR_RootConstrainSelectedInstOperands,
     /* 128573 */     // GIR_Coverage, 787,
     /* 128573 */     GIR_EraseRootFromParent_Done,
     /* 128574 */   // Label 2807: @128574
     /* 128574 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(128611), // Rule ID 869 //
     /* 128579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128594 */     // MIs[1] Operand 1
     /* 128594 */     // No operand predicates
     /* 128594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128596 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 128599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128609 */     GIR_RootConstrainSelectedInstOperands,
     /* 128610 */     // GIR_Coverage, 869,
     /* 128610 */     GIR_EraseRootFromParent_Done,
     /* 128611 */   // Label 2808: @128611
     /* 128611 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(128639), // Rule ID 17598 //
     /* 128616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128627 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 128630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128637 */     GIR_RootConstrainSelectedInstOperands,
     /* 128638 */     // GIR_Coverage, 17598,
     /* 128638 */     GIR_EraseRootFromParent_Done,
     /* 128639 */   // Label 2809: @128639
     /* 128639 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(128667), // Rule ID 17606 //
     /* 128644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128655 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 128658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128665 */     GIR_RootConstrainSelectedInstOperands,
     /* 128666 */     // GIR_Coverage, 17606,
     /* 128666 */     GIR_EraseRootFromParent_Done,
     /* 128667 */   // Label 2810: @128667
     /* 128667 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(128704), // Rule ID 759 //
     /* 128672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128687 */     // MIs[1] Operand 1
     /* 128687 */     // No operand predicates
     /* 128687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128689 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 128692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128702 */     GIR_RootConstrainSelectedInstOperands,
     /* 128703 */     // GIR_Coverage, 759,
     /* 128703 */     GIR_EraseRootFromParent_Done,
     /* 128704 */   // Label 2811: @128704
     /* 128704 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(128741), // Rule ID 763 //
     /* 128709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128724 */     // MIs[1] Operand 1
     /* 128724 */     // No operand predicates
     /* 128724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128726 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 128729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128739 */     GIR_RootConstrainSelectedInstOperands,
     /* 128740 */     // GIR_Coverage, 763,
     /* 128740 */     GIR_EraseRootFromParent_Done,
     /* 128741 */   // Label 2812: @128741
     /* 128741 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(128783), // Rule ID 775 //
     /* 128746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128757 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128761 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 128774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128776 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128781 */     GIR_RootConstrainSelectedInstOperands,
     /* 128782 */     // GIR_Coverage, 775,
     /* 128782 */     GIR_EraseRootFromParent_Done,
     /* 128783 */   // Label 2813: @128783
     /* 128783 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(128825), // Rule ID 779 //
     /* 128788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128799 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128803 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 128816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128818 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128823 */     GIR_RootConstrainSelectedInstOperands,
     /* 128824 */     // GIR_Coverage, 779,
     /* 128824 */     GIR_EraseRootFromParent_Done,
     /* 128825 */   // Label 2814: @128825
     /* 128825 */   GIM_Reject,
     /* 128826 */ // Label 2804: @128826
     /* 128826 */ GIM_Reject,
     /* 128827 */ // Label 2774: @128827
     /* 128827 */ GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(129293),
     /* 128832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128842 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(128901), // Rule ID 17623 //
     /* 128847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128882 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROR64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1_ND),
     /* 128885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128899 */     GIR_RootConstrainSelectedInstOperands,
     /* 128900 */     // GIR_Coverage, 17623,
     /* 128900 */     GIR_EraseRootFromParent_Done,
     /* 128901 */   // Label 2816: @128901
     /* 128901 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(128968), // Rule ID 772 //
     /* 128906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128936 */     // MIs[2] Operand 1
     /* 128936 */     // No operand predicates
     /* 128936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128945 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi_ND),
     /* 128948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128966 */     GIR_RootConstrainSelectedInstOperands,
     /* 128967 */     // GIR_Coverage, 772,
     /* 128967 */     GIR_EraseRootFromParent_Done,
     /* 128968 */   // Label 2817: @128968
     /* 128968 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(129041), // Rule ID 788 //
     /* 128973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129008 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 129008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129012 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL_ND),
     /* 129025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129039 */     GIR_RootConstrainSelectedInstOperands,
     /* 129040 */     // GIR_Coverage, 788,
     /* 129040 */     GIR_EraseRootFromParent_Done,
     /* 129041 */   // Label 2818: @129041
     /* 129041 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(129078), // Rule ID 870 //
     /* 129046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 129049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129061 */     // MIs[1] Operand 1
     /* 129061 */     // No operand predicates
     /* 129061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129063 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 129063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 129066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 129073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129076 */     GIR_RootConstrainSelectedInstOperands,
     /* 129077 */     // GIR_Coverage, 870,
     /* 129077 */     GIR_EraseRootFromParent_Done,
     /* 129078 */   // Label 2819: @129078
     /* 129078 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(129106), // Rule ID 17599 //
     /* 129083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 129094 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 129097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129104 */     GIR_RootConstrainSelectedInstOperands,
     /* 129105 */     // GIR_Coverage, 17599,
     /* 129105 */     GIR_EraseRootFromParent_Done,
     /* 129106 */   // Label 2820: @129106
     /* 129106 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(129134), // Rule ID 17607 //
     /* 129111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 129114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 129122 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 129125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129127 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129132 */     GIR_RootConstrainSelectedInstOperands,
     /* 129133 */     // GIR_Coverage, 17607,
     /* 129133 */     GIR_EraseRootFromParent_Done,
     /* 129134 */   // Label 2821: @129134
     /* 129134 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(129171), // Rule ID 760 //
     /* 129139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129154 */     // MIs[1] Operand 1
     /* 129154 */     // No operand predicates
     /* 129154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129156 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 129156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 129159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129169 */     GIR_RootConstrainSelectedInstOperands,
     /* 129170 */     // GIR_Coverage, 760,
     /* 129170 */     GIR_EraseRootFromParent_Done,
     /* 129171 */   // Label 2822: @129171
     /* 129171 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(129208), // Rule ID 764 //
     /* 129176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129191 */     // MIs[1] Operand 1
     /* 129191 */     // No operand predicates
     /* 129191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129193 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 129193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 129196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129206 */     GIR_RootConstrainSelectedInstOperands,
     /* 129207 */     // GIR_Coverage, 764,
     /* 129207 */     GIR_EraseRootFromParent_Done,
     /* 129208 */   // Label 2823: @129208
     /* 129208 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(129250), // Rule ID 776 //
     /* 129213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129224 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129228 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 129241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129248 */     GIR_RootConstrainSelectedInstOperands,
     /* 129249 */     // GIR_Coverage, 776,
     /* 129249 */     GIR_EraseRootFromParent_Done,
     /* 129250 */   // Label 2824: @129250
     /* 129250 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(129292), // Rule ID 780 //
     /* 129255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129266 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129270 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 129283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129290 */     GIR_RootConstrainSelectedInstOperands,
     /* 129291 */     // GIR_Coverage, 780,
     /* 129291 */     GIR_EraseRootFromParent_Done,
     /* 129292 */   // Label 2825: @129292
     /* 129292 */   GIM_Reject,
     /* 129293 */ // Label 2815: @129293
     /* 129293 */ GIM_Reject,
     /* 129294 */ // Label 2775: @129294
     /* 129294 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(129711),
     /* 129299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 129302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 129305 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(129367), // Rule ID 1583 //
     /* 129310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129349 */     // (rotl:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQmr:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQmr),
     /* 129352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129365 */     GIR_RootConstrainSelectedInstOperands,
     /* 129366 */     // GIR_Coverage, 1583,
     /* 129366 */     GIR_EraseRootFromParent_Done,
     /* 129367 */   // Label 2827: @129367
     /* 129367 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(129429), // Rule ID 1582 //
     /* 129372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129411 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQrm),
     /* 129414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129427 */     GIR_RootConstrainSelectedInstOperands,
     /* 129428 */     // GIR_Coverage, 1582,
     /* 129428 */     GIR_EraseRootFromParent_Done,
     /* 129429 */   // Label 2828: @129429
     /* 129429 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(129491), // Rule ID 8059 //
     /* 129434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129473 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rm),
     /* 129476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129489 */     GIR_RootConstrainSelectedInstOperands,
     /* 129490 */     // GIR_Coverage, 8059,
     /* 129490 */     GIR_EraseRootFromParent_Done,
     /* 129491 */   // Label 2829: @129491
     /* 129491 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(129518), // Rule ID 1581 //
     /* 129496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129511 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 129516 */     GIR_RootConstrainSelectedInstOperands,
     /* 129517 */     // GIR_Coverage, 1581,
     /* 129517 */     GIR_Done,
     /* 129518 */   // Label 2830: @129518
     /* 129518 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(129545), // Rule ID 8056 //
     /* 129523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129538 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 129538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 129543 */     GIR_RootConstrainSelectedInstOperands,
     /* 129544 */     // GIR_Coverage, 8056,
     /* 129544 */     GIR_Done,
     /* 129545 */   // Label 2831: @129545
     /* 129545 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(129710), // Rule ID 20796 //
     /* 129550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129565 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129565 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 129568 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129572 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129579 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 129582 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129586 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129591 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129594 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129598 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129601 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129606 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129611 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 129619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 129633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 129670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 129674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129692 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129709 */     // GIR_Coverage, 20796,
     /* 129709 */     GIR_EraseRootFromParent_Done,
     /* 129710 */   // Label 2832: @129710
     /* 129710 */   GIM_Reject,
     /* 129711 */ // Label 2826: @129711
     /* 129711 */ GIM_Reject,
     /* 129712 */ // Label 2776: @129712
     /* 129712 */ GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(130129),
     /* 129717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129723 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(129785), // Rule ID 1580 //
     /* 129728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129743 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129767 */     // (rotl:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDmr:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDmr),
     /* 129770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129783 */     GIR_RootConstrainSelectedInstOperands,
     /* 129784 */     // GIR_Coverage, 1580,
     /* 129784 */     GIR_EraseRootFromParent_Done,
     /* 129785 */   // Label 2834: @129785
     /* 129785 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(129847), // Rule ID 1579 //
     /* 129790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129829 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDrm),
     /* 129832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129834 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129845 */     GIR_RootConstrainSelectedInstOperands,
     /* 129846 */     // GIR_Coverage, 1579,
     /* 129846 */     GIR_EraseRootFromParent_Done,
     /* 129847 */   // Label 2835: @129847
     /* 129847 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(129909), // Rule ID 8032 //
     /* 129852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129891 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rm),
     /* 129894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129896 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129907 */     GIR_RootConstrainSelectedInstOperands,
     /* 129908 */     // GIR_Coverage, 8032,
     /* 129908 */     GIR_EraseRootFromParent_Done,
     /* 129909 */   // Label 2836: @129909
     /* 129909 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(129936), // Rule ID 1578 //
     /* 129914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129929 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 129934 */     GIR_RootConstrainSelectedInstOperands,
     /* 129935 */     // GIR_Coverage, 1578,
     /* 129935 */     GIR_Done,
     /* 129936 */   // Label 2837: @129936
     /* 129936 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(129963), // Rule ID 8029 //
     /* 129941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129956 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 129956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 129961 */     GIR_RootConstrainSelectedInstOperands,
     /* 129962 */     // GIR_Coverage, 8029,
     /* 129962 */     GIR_Done,
     /* 129963 */   // Label 2838: @129963
     /* 129963 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(130128), // Rule ID 20798 //
     /* 129968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129983 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129983 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 129986 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129990 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129997 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130000 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130004 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130009 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130012 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130016 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 130019 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130024 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130029 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130060 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130067 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 130070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130080 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130097 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 130117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 130122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130127 */     // GIR_Coverage, 20798,
     /* 130127 */     GIR_EraseRootFromParent_Done,
     /* 130128 */   // Label 2839: @130128
     /* 130128 */   GIM_Reject,
     /* 130129 */ // Label 2833: @130129
     /* 130129 */ GIM_Reject,
     /* 130130 */ // Label 2777: @130130
     /* 130130 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(130380),
     /* 130135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 130138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 130141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130149 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(130203), // Rule ID 8050 //
     /* 130154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130165 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130168 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130172 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130185 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rm),
     /* 130188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130201 */     GIR_RootConstrainSelectedInstOperands,
     /* 130202 */     // GIR_Coverage, 8050,
     /* 130202 */     GIR_EraseRootFromParent_Done,
     /* 130203 */   // Label 2841: @130203
     /* 130203 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(130222), // Rule ID 8047 //
     /* 130208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130215 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 130215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 130220 */     GIR_RootConstrainSelectedInstOperands,
     /* 130221 */     // GIR_Coverage, 8047,
     /* 130221 */     GIR_Done,
     /* 130222 */   // Label 2842: @130222
     /* 130222 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(130379), // Rule ID 20797 //
     /* 130227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130234 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130234 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 130237 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130241 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130248 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 130251 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130255 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130260 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130263 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130267 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130270 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130275 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130280 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130311 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 130339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130378 */     // GIR_Coverage, 20797,
     /* 130378 */     GIR_EraseRootFromParent_Done,
     /* 130379 */   // Label 2843: @130379
     /* 130379 */   GIM_Reject,
     /* 130380 */ // Label 2840: @130380
     /* 130380 */ GIM_Reject,
     /* 130381 */ // Label 2778: @130381
     /* 130381 */ GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(130536),
     /* 130386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 130392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130396 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(130454), // Rule ID 1586 //
     /* 130401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130436 */     // (rotl:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWmr:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWmr),
     /* 130439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130452 */     GIR_RootConstrainSelectedInstOperands,
     /* 130453 */     // GIR_Coverage, 1586,
     /* 130453 */     GIR_EraseRootFromParent_Done,
     /* 130454 */   // Label 2845: @130454
     /* 130454 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(130512), // Rule ID 1585 //
     /* 130459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130494 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWrm),
     /* 130497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130510 */     GIR_RootConstrainSelectedInstOperands,
     /* 130511 */     // GIR_Coverage, 1585,
     /* 130511 */     GIR_EraseRootFromParent_Done,
     /* 130512 */   // Label 2846: @130512
     /* 130512 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(130535), // Rule ID 1584 //
     /* 130517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130528 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 130533 */     GIR_RootConstrainSelectedInstOperands,
     /* 130534 */     // GIR_Coverage, 1584,
     /* 130534 */     GIR_Done,
     /* 130535 */   // Label 2847: @130535
     /* 130535 */   GIM_Reject,
     /* 130536 */ // Label 2844: @130536
     /* 130536 */ GIM_Reject,
     /* 130537 */ // Label 2779: @130537
     /* 130537 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(130787),
     /* 130542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 130545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 130548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130556 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(130610), // Rule ID 8023 //
     /* 130561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130592 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rm),
     /* 130595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130608 */     GIR_RootConstrainSelectedInstOperands,
     /* 130609 */     // GIR_Coverage, 8023,
     /* 130609 */     GIR_EraseRootFromParent_Done,
     /* 130610 */   // Label 2849: @130610
     /* 130610 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(130629), // Rule ID 8020 //
     /* 130615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130622 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 130622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 130627 */     GIR_RootConstrainSelectedInstOperands,
     /* 130628 */     // GIR_Coverage, 8020,
     /* 130628 */     GIR_Done,
     /* 130629 */   // Label 2850: @130629
     /* 130629 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(130786), // Rule ID 20799 //
     /* 130634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130641 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130641 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 130644 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130648 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130655 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130658 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130662 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130667 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130670 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130674 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130677 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130682 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130687 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130758 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130785 */     // GIR_Coverage, 20799,
     /* 130785 */     GIR_EraseRootFromParent_Done,
     /* 130786 */   // Label 2851: @130786
     /* 130786 */   GIM_Reject,
     /* 130787 */ // Label 2848: @130787
     /* 130787 */ GIM_Reject,
     /* 130788 */ // Label 2780: @130788
     /* 130788 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(130881),
     /* 130793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 130796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 130799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130807 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(130861), // Rule ID 8041 //
     /* 130812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130823 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130843 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrm),
     /* 130846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130859 */     GIR_RootConstrainSelectedInstOperands,
     /* 130860 */     // GIR_Coverage, 8041,
     /* 130860 */     GIR_EraseRootFromParent_Done,
     /* 130861 */   // Label 2853: @130861
     /* 130861 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(130880), // Rule ID 8038 //
     /* 130866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130873 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 130873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130878 */     GIR_RootConstrainSelectedInstOperands,
     /* 130879 */     // GIR_Coverage, 8038,
     /* 130879 */     GIR_Done,
     /* 130880 */   // Label 2854: @130880
     /* 130880 */   GIM_Reject,
     /* 130881 */ // Label 2852: @130881
     /* 130881 */ GIM_Reject,
     /* 130882 */ // Label 2781: @130882
     /* 130882 */ GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(131037),
     /* 130887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 130890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 130893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130897 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(130955), // Rule ID 1577 //
     /* 130902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130937 */     // (rotl:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBmr:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBmr),
     /* 130940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130942 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130953 */     GIR_RootConstrainSelectedInstOperands,
     /* 130954 */     // GIR_Coverage, 1577,
     /* 130954 */     GIR_EraseRootFromParent_Done,
     /* 130955 */   // Label 2856: @130955
     /* 130955 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(131013), // Rule ID 1576 //
     /* 130960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130995 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBrm),
     /* 130998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 131002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 131006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131011 */     GIR_RootConstrainSelectedInstOperands,
     /* 131012 */     // GIR_Coverage, 1576,
     /* 131012 */     GIR_EraseRootFromParent_Done,
     /* 131013 */   // Label 2857: @131013
     /* 131013 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(131036), // Rule ID 1575 //
     /* 131018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 131021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 131025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 131029 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 131029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 131034 */     GIR_RootConstrainSelectedInstOperands,
     /* 131035 */     // GIR_Coverage, 1575,
     /* 131035 */     GIR_Done,
     /* 131036 */   // Label 2858: @131036
     /* 131036 */   GIM_Reject,
     /* 131037 */ // Label 2855: @131037
     /* 131037 */ GIM_Reject,
     /* 131038 */ // Label 2782: @131038
     /* 131038 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(131131),
     /* 131043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 131046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 131049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131057 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(131111), // Rule ID 8014 //
     /* 131062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 131065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 131073 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131076 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 131080 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 131084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 131093 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 131093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrm),
     /* 131096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 131100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 131104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131109 */     GIR_RootConstrainSelectedInstOperands,
     /* 131110 */     // GIR_Coverage, 8014,
     /* 131110 */     GIR_EraseRootFromParent_Done,
     /* 131111 */   // Label 2860: @131111
     /* 131111 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(131130), // Rule ID 8011 //
     /* 131116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 131119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131123 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 131123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 131128 */     GIR_RootConstrainSelectedInstOperands,
     /* 131129 */     // GIR_Coverage, 8011,
     /* 131129 */     GIR_Done,
     /* 131130 */   // Label 2861: @131130
     /* 131130 */   GIM_Reject,
     /* 131131 */ // Label 2859: @131131
     /* 131131 */ GIM_Reject,
     /* 131132 */ // Label 2783: @131132
     /* 131132 */ GIM_Reject,
     /* 131133 */ // Label 33: @131133
     /* 131133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 2868*/ GIMT_Encode4(132789),
     /* 131144 */ /*GILLT_v2s1*//*Label 2862*/ GIMT_Encode4(131212), GIMT_Encode4(0),
     /* 131152 */ /*GILLT_v4s1*//*Label 2863*/ GIMT_Encode4(131373), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131164 */ /*GILLT_v8s1*//*Label 2864*/ GIMT_Encode4(131720), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131180 */ /*GILLT_v16s1*//*Label 2865*/ GIMT_Encode4(132117), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131196 */ /*GILLT_v32s1*//*Label 2866*/ GIMT_Encode4(132514), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131208 */ /*GILLT_v64s1*//*Label 2867*/ GIMT_Encode4(132738),
     /* 131212 */ // Label 2862: @131212
     /* 131212 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(131372),
     /* 131217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 131220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 131223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 131227 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131236 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(131267), // Rule ID 12606 //
     /* 131241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131258 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 131258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 131261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131265 */     GIR_RootConstrainSelectedInstOperands,
     /* 131266 */     // GIR_Coverage, 12606,
     /* 131266 */     GIR_EraseRootFromParent_Done,
     /* 131267 */   // Label 2870: @131267
     /* 131267 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(131371), // Rule ID 21658 //
     /* 131272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131279 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131289 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 131289 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131292 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131296 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131315 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131322 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 131370 */     // GIR_Coverage, 21658,
     /* 131370 */     GIR_EraseRootFromParent_Done,
     /* 131371 */   // Label 2871: @131371
     /* 131371 */   GIM_Reject,
     /* 131372 */ // Label 2869: @131372
     /* 131372 */ GIM_Reject,
     /* 131373 */ // Label 2863: @131373
     /* 131373 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(131423), // Rule ID 12603 //
     /* 131378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131391 */   // MIs[0] Operand 1
     /* 131391 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131400 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131406 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131412 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131414 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 131414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 131417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131419 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131421 */   GIR_RootConstrainSelectedInstOperands,
     /* 131422 */   // GIR_Coverage, 12603,
     /* 131422 */   GIR_EraseRootFromParent_Done,
     /* 131423 */ // Label 2872: @131423
     /* 131423 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(131473), // Rule ID 12605 //
     /* 131428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131441 */   // MIs[0] Operand 1
     /* 131441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131450 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131456 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131464 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 131464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 131467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131469 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131471 */   GIR_RootConstrainSelectedInstOperands,
     /* 131472 */   // GIR_Coverage, 12605,
     /* 131472 */   GIR_EraseRootFromParent_Done,
     /* 131473 */ // Label 2873: @131473
     /* 131473 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(131596), // Rule ID 21656 //
     /* 131478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131491 */   // MIs[0] Operand 1
     /* 131491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131500 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131506 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131508 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131514 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131514 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131517 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131521 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131540 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131543 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131547 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131550 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131555 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131560 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131577 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131595 */   // GIR_Coverage, 21656,
     /* 131595 */   GIR_EraseRootFromParent_Done,
     /* 131596 */ // Label 2874: @131596
     /* 131596 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(131719), // Rule ID 21657 //
     /* 131601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131607 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131614 */   // MIs[0] Operand 1
     /* 131614 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131623 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131629 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131631 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131637 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131637 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131640 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131644 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131651 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131654 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131658 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131663 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131670 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131673 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131678 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131683 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131700 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131718 */   // GIR_Coverage, 21657,
     /* 131718 */   GIR_EraseRootFromParent_Done,
     /* 131719 */ // Label 2875: @131719
     /* 131719 */ GIM_Reject,
     /* 131720 */ // Label 2864: @131720
     /* 131720 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(131770), // Rule ID 12600 //
     /* 131725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131738 */   // MIs[0] Operand 1
     /* 131738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131747 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131753 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131755 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131761 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 131761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 131764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131766 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131768 */   GIR_RootConstrainSelectedInstOperands,
     /* 131769 */   // GIR_Coverage, 12600,
     /* 131769 */   GIR_EraseRootFromParent_Done,
     /* 131770 */ // Label 2876: @131770
     /* 131770 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(131820), // Rule ID 12602 //
     /* 131775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131788 */   // MIs[0] Operand 1
     /* 131788 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131797 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131803 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131811 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 131811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 131814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131816 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131818 */   GIR_RootConstrainSelectedInstOperands,
     /* 131819 */   // GIR_Coverage, 12602,
     /* 131819 */   GIR_EraseRootFromParent_Done,
     /* 131820 */ // Label 2877: @131820
     /* 131820 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(131870), // Rule ID 12604 //
     /* 131825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 131831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 131834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131838 */   // MIs[0] Operand 1
     /* 131838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131847 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131853 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131855 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131861 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 131861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131866 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131868 */   GIR_RootConstrainSelectedInstOperands,
     /* 131869 */   // GIR_Coverage, 12604,
     /* 131869 */   GIR_EraseRootFromParent_Done,
     /* 131870 */ // Label 2878: @131870
     /* 131870 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(131993), // Rule ID 21654 //
     /* 131875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131888 */   // MIs[0] Operand 1
     /* 131888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131897 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131903 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131911 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131911 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131914 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131918 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131937 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131940 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131944 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131947 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131952 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131957 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131974 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131992 */   // GIR_Coverage, 21654,
     /* 131992 */   GIR_EraseRootFromParent_Done,
     /* 131993 */ // Label 2879: @131993
     /* 131993 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(132116), // Rule ID 21655 //
     /* 131998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 132001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 132004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 132007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 132011 */   // MIs[0] Operand 1
     /* 132011 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132020 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132026 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132034 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 132034 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 132037 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132041 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132048 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 132051 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132055 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132060 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132063 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132067 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132070 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132075 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132080 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 132088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 132115 */   // GIR_Coverage, 21655,
     /* 132115 */   GIR_EraseRootFromParent_Done,
     /* 132116 */ // Label 2880: @132116
     /* 132116 */ GIM_Reject,
     /* 132117 */ // Label 2865: @132117
     /* 132117 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(132167), // Rule ID 12597 //
     /* 132122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132135 */   // MIs[0] Operand 1
     /* 132135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132144 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132150 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132152 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132156 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132158 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 132158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 132161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132163 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132165 */   GIR_RootConstrainSelectedInstOperands,
     /* 132166 */   // GIR_Coverage, 12597,
     /* 132166 */   GIR_EraseRootFromParent_Done,
     /* 132167 */ // Label 2881: @132167
     /* 132167 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(132217), // Rule ID 12599 //
     /* 132172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132185 */   // MIs[0] Operand 1
     /* 132185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132190 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132194 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132200 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132206 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132208 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 132208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 132211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132213 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132215 */   GIR_RootConstrainSelectedInstOperands,
     /* 132216 */   // GIR_Coverage, 12599,
     /* 132216 */   GIR_EraseRootFromParent_Done,
     /* 132217 */ // Label 2882: @132217
     /* 132217 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(132267), // Rule ID 12601 //
     /* 132222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 132225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 132228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 132231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132235 */   // MIs[0] Operand 1
     /* 132235 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132244 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132250 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132258 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 132258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132263 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132265 */   GIR_RootConstrainSelectedInstOperands,
     /* 132266 */   // GIR_Coverage, 12601,
     /* 132266 */   GIR_EraseRootFromParent_Done,
     /* 132267 */ // Label 2883: @132267
     /* 132267 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(132390), // Rule ID 21652 //
     /* 132272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132285 */   // MIs[0] Operand 1
     /* 132285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132290 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132294 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132300 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132302 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132308 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132308 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132311 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132315 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132322 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132325 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132329 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132334 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132337 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132341 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132344 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132349 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132354 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132371 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132389 */   // GIR_Coverage, 21652,
     /* 132389 */   GIR_EraseRootFromParent_Done,
     /* 132390 */ // Label 2884: @132390
     /* 132390 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(132513), // Rule ID 21653 //
     /* 132395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132408 */   // MIs[0] Operand 1
     /* 132408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132417 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132423 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132429 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132431 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132431 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 132434 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132438 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132445 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 132448 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132452 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132457 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132460 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132464 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132467 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132472 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132477 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 132485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132512 */   // GIR_Coverage, 21653,
     /* 132512 */   GIR_EraseRootFromParent_Done,
     /* 132513 */ // Label 2885: @132513
     /* 132513 */ GIM_Reject,
     /* 132514 */ // Label 2866: @132514
     /* 132514 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(132564), // Rule ID 12596 //
     /* 132519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132532 */   // MIs[0] Operand 1
     /* 132532 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132541 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132547 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132549 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132555 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 132555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 132558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132560 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132562 */   GIR_RootConstrainSelectedInstOperands,
     /* 132563 */   // GIR_Coverage, 12596,
     /* 132563 */   GIR_EraseRootFromParent_Done,
     /* 132564 */ // Label 2886: @132564
     /* 132564 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(132614), // Rule ID 12598 //
     /* 132569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 132575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 132578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132582 */   // MIs[0] Operand 1
     /* 132582 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132591 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132597 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132599 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132605 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 132605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132610 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132612 */   GIR_RootConstrainSelectedInstOperands,
     /* 132613 */   // GIR_Coverage, 12598,
     /* 132613 */   GIR_EraseRootFromParent_Done,
     /* 132614 */ // Label 2887: @132614
     /* 132614 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(132737), // Rule ID 21651 //
     /* 132619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132632 */   // MIs[0] Operand 1
     /* 132632 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132641 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132647 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132649 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132653 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132655 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 132655 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132658 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132662 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132669 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132672 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132676 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132681 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132684 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132688 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132691 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132696 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132701 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132718 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 132736 */   // GIR_Coverage, 21651,
     /* 132736 */   GIR_EraseRootFromParent_Done,
     /* 132737 */ // Label 2888: @132737
     /* 132737 */ GIM_Reject,
     /* 132738 */ // Label 2867: @132738
     /* 132738 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(132788), // Rule ID 12595 //
     /* 132743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 132749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 132752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 132756 */   // MIs[0] Operand 1
     /* 132756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132765 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132771 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132773 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132779 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 132779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132784 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132786 */   GIR_RootConstrainSelectedInstOperands,
     /* 132787 */   // GIR_Coverage, 12595,
     /* 132787 */   GIR_EraseRootFromParent_Done,
     /* 132788 */ // Label 2889: @132788
     /* 132788 */ GIM_Reject,
     /* 132789 */ // Label 2868: @132789
     /* 132789 */ GIM_Reject,
     /* 132790 */ // Label 34: @132790
     /* 132790 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2902*/ GIMT_Encode4(140455),
     /* 132801 */ /*GILLT_v2s64*//*Label 2890*/ GIMT_Encode4(132869), GIMT_Encode4(0),
     /* 132809 */ /*GILLT_v4s32*//*Label 2891*/ GIMT_Encode4(133733),
     /* 132813 */ /*GILLT_v4s64*//*Label 2892*/ GIMT_Encode4(134597), GIMT_Encode4(0),
     /* 132821 */ /*GILLT_v8s16*//*Label 2893*/ GIMT_Encode4(135377),
     /* 132825 */ /*GILLT_v8s32*//*Label 2894*/ GIMT_Encode4(136535),
     /* 132829 */ /*GILLT_v8s64*//*Label 2895*/ GIMT_Encode4(137315), GIMT_Encode4(0),
     /* 132837 */ /*GILLT_v16s8*//*Label 2896*/ GIMT_Encode4(137696),
     /* 132841 */ /*GILLT_v16s16*//*Label 2897*/ GIMT_Encode4(138136),
     /* 132845 */ /*GILLT_v16s32*//*Label 2898*/ GIMT_Encode4(139206), GIMT_Encode4(0),
     /* 132853 */ /*GILLT_v32s8*//*Label 2899*/ GIMT_Encode4(139547),
     /* 132857 */ /*GILLT_v32s16*//*Label 2900*/ GIMT_Encode4(139951), GIMT_Encode4(0),
     /* 132865 */ /*GILLT_v64s8*//*Label 2901*/ GIMT_Encode4(140369),
     /* 132869 */ // Label 2890: @132869
     /* 132869 */ GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(133732),
     /* 132874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 132877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 132880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 132883 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(132928), // Rule ID 4489 //
     /* 132888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132907 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132913 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132917 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 132917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 132920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132922 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132926 */     GIR_RootConstrainSelectedInstOperands,
     /* 132927 */     // GIR_Coverage, 4489,
     /* 132927 */     GIR_EraseRootFromParent_Done,
     /* 132928 */   // Label 2904: @132928
     /* 132928 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(132973), // Rule ID 4543 //
     /* 132933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132958 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132962 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 132962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 132965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132967 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132971 */     GIR_RootConstrainSelectedInstOperands,
     /* 132972 */     // GIR_Coverage, 4543,
     /* 132972 */     GIR_EraseRootFromParent_Done,
     /* 132973 */   // Label 2905: @132973
     /* 132973 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(133122), // Rule ID 19777 //
     /* 132978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132997 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133003 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133007 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133007 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 133010 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133014 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133033 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133036 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133040 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133043 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133048 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133053 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133074 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 133086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133091 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133094 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133104 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133121 */     // GIR_Coverage, 19777,
     /* 133121 */     GIR_EraseRootFromParent_Done,
     /* 133122 */   // Label 2906: @133122
     /* 133122 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(133271), // Rule ID 19779 //
     /* 133127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133146 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133152 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133156 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133156 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 133159 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133163 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133182 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133185 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133189 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133192 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133197 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133202 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 133235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133240 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133253 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133270 */     // GIR_Coverage, 19779,
     /* 133270 */     GIR_EraseRootFromParent_Done,
     /* 133271 */   // Label 2907: @133271
     /* 133271 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(133308), // Rule ID 4491 //
     /* 133276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133295 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 133295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 133298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133300 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133302 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133306 */     GIR_RootConstrainSelectedInstOperands,
     /* 133307 */     // GIR_Coverage, 4491,
     /* 133307 */     GIR_EraseRootFromParent_Done,
     /* 133308 */   // Label 2908: @133308
     /* 133308 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(133345), // Rule ID 4545 //
     /* 133313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133332 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 133332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 133335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133339 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133343 */     GIR_RootConstrainSelectedInstOperands,
     /* 133344 */     // GIR_Coverage, 4545,
     /* 133344 */     GIR_EraseRootFromParent_Done,
     /* 133345 */   // Label 2909: @133345
     /* 133345 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(133538), // Rule ID 19776 //
     /* 133350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133369 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133369 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133372 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133376 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133383 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133386 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133390 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133395 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133398 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133402 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133405 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133410 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133415 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133420 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133423 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133427 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133432 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133436 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133441 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133444 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133448 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133467 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133470 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133474 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 133499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133510 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133520 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133537 */     // GIR_Coverage, 19776,
     /* 133537 */     GIR_EraseRootFromParent_Done,
     /* 133538 */   // Label 2910: @133538
     /* 133538 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(133731), // Rule ID 19778 //
     /* 133543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133562 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133562 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133565 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133569 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133576 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133579 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133583 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133588 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133591 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133595 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133598 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133603 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133608 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133613 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133616 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133620 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133625 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133629 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133634 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133637 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133641 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133648 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133651 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133655 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133660 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133667 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133675 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 133692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133703 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133713 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133730 */     // GIR_Coverage, 19778,
     /* 133730 */     GIR_EraseRootFromParent_Done,
     /* 133731 */   // Label 2911: @133731
     /* 133731 */   GIM_Reject,
     /* 133732 */ // Label 2903: @133732
     /* 133732 */ GIM_Reject,
     /* 133733 */ // Label 2891: @133733
     /* 133733 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(134596),
     /* 133738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 133744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 133747 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(133792), // Rule ID 4471 //
     /* 133752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133781 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 133781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 133784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133786 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133790 */     GIR_RootConstrainSelectedInstOperands,
     /* 133791 */     // GIR_Coverage, 4471,
     /* 133791 */     GIR_EraseRootFromParent_Done,
     /* 133792 */   // Label 2913: @133792
     /* 133792 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(133837), // Rule ID 4529 //
     /* 133797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133816 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133822 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133826 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 133826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 133829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133831 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133835 */     GIR_RootConstrainSelectedInstOperands,
     /* 133836 */     // GIR_Coverage, 4529,
     /* 133836 */     GIR_EraseRootFromParent_Done,
     /* 133837 */   // Label 2914: @133837
     /* 133837 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(133986), // Rule ID 19769 //
     /* 133842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133861 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133867 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133871 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133871 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133874 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133878 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133897 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133900 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133904 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133907 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133912 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133917 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133922 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133925 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133929 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133934 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 133950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133968 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133985 */     // GIR_Coverage, 19769,
     /* 133985 */     GIR_EraseRootFromParent_Done,
     /* 133986 */   // Label 2915: @133986
     /* 133986 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(134135), // Rule ID 19771 //
     /* 133991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134010 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134016 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134020 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134020 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 134023 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134027 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134046 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134049 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134053 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 134056 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134061 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134066 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 134074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 134099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134117 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134134 */     // GIR_Coverage, 19771,
     /* 134134 */     GIR_EraseRootFromParent_Done,
     /* 134135 */   // Label 2916: @134135
     /* 134135 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(134172), // Rule ID 4473 //
     /* 134140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134159 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 134159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 134162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134164 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134166 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134170 */     GIR_RootConstrainSelectedInstOperands,
     /* 134171 */     // GIR_Coverage, 4473,
     /* 134171 */     GIR_EraseRootFromParent_Done,
     /* 134172 */   // Label 2917: @134172
     /* 134172 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(134209), // Rule ID 4530 //
     /* 134177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134196 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 134196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 134199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134201 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134203 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134207 */     GIR_RootConstrainSelectedInstOperands,
     /* 134208 */     // GIR_Coverage, 4530,
     /* 134208 */     GIR_EraseRootFromParent_Done,
     /* 134209 */   // Label 2918: @134209
     /* 134209 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(134402), // Rule ID 19768 //
     /* 134214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134233 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134233 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134236 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134240 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134247 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134250 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134254 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134259 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134262 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134266 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134269 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134274 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134279 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134284 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134287 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134291 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134296 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134300 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134305 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134308 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134312 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134331 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134338 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 134363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134401 */     // GIR_Coverage, 19768,
     /* 134401 */     GIR_EraseRootFromParent_Done,
     /* 134402 */   // Label 2919: @134402
     /* 134402 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(134595), // Rule ID 19770 //
     /* 134407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134426 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134426 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134429 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134433 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134440 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134443 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134447 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134452 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134455 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134459 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134462 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134467 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134472 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134477 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134480 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134484 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134489 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134493 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134498 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134501 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134505 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134512 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134515 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134519 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134524 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134527 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134531 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134534 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 134556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134564 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134567 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134577 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134594 */     // GIR_Coverage, 19770,
     /* 134594 */     GIR_EraseRootFromParent_Done,
     /* 134595 */   // Label 2920: @134595
     /* 134595 */   GIM_Reject,
     /* 134596 */ // Label 2912: @134596
     /* 134596 */ GIM_Reject,
     /* 134597 */ // Label 2892: @134597
     /* 134597 */ GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(135376),
     /* 134602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 134605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 134608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 134611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134623 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(134656), // Rule ID 4484 //
     /* 134628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134635 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134641 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134645 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 134645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 134648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134650 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134652 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134654 */     GIR_RootConstrainSelectedInstOperands,
     /* 134655 */     // GIR_Coverage, 4484,
     /* 134655 */     GIR_EraseRootFromParent_Done,
     /* 134656 */   // Label 2922: @134656
     /* 134656 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(134689), // Rule ID 4538 //
     /* 134661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134668 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134674 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134678 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 134678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 134681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134683 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134687 */     GIR_RootConstrainSelectedInstOperands,
     /* 134688 */     // GIR_Coverage, 4538,
     /* 134688 */     GIR_EraseRootFromParent_Done,
     /* 134689 */   // Label 2923: @134689
     /* 134689 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(134826), // Rule ID 19781 //
     /* 134694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134701 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134707 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134711 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134711 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134714 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134718 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134725 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134728 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134732 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134737 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134740 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134744 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134747 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134752 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134757 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134774 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134778 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 134790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134795 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134808 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134825 */     // GIR_Coverage, 19781,
     /* 134825 */     GIR_EraseRootFromParent_Done,
     /* 134826 */   // Label 2924: @134826
     /* 134826 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(134963), // Rule ID 19783 //
     /* 134831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134838 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134844 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134848 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134848 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134851 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134855 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134862 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134865 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134869 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134874 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134877 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134881 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134884 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134889 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134894 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134915 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 134927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134932 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134935 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134962 */     // GIR_Coverage, 19783,
     /* 134962 */     GIR_EraseRootFromParent_Done,
     /* 134963 */   // Label 2925: @134963
     /* 134963 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(134988), // Rule ID 4486 //
     /* 134968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134975 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 134975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 134978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134980 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134982 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134986 */     GIR_RootConstrainSelectedInstOperands,
     /* 134987 */     // GIR_Coverage, 4486,
     /* 134987 */     GIR_EraseRootFromParent_Done,
     /* 134988 */   // Label 2926: @134988
     /* 134988 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(135013), // Rule ID 4540 //
     /* 134993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135000 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 135000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 135003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135005 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135007 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135011 */     GIR_RootConstrainSelectedInstOperands,
     /* 135012 */     // GIR_Coverage, 4540,
     /* 135012 */     GIR_EraseRootFromParent_Done,
     /* 135013 */   // Label 2927: @135013
     /* 135013 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(135194), // Rule ID 19780 //
     /* 135018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135025 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135025 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135028 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135032 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135039 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135042 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135046 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135051 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135054 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135058 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135061 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135066 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135071 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135076 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135079 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135083 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135088 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135092 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135097 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135100 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135104 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135123 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135130 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 135155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135166 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135176 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135193 */     // GIR_Coverage, 19780,
     /* 135193 */     GIR_EraseRootFromParent_Done,
     /* 135194 */   // Label 2928: @135194
     /* 135194 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(135375), // Rule ID 19782 //
     /* 135199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135206 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135206 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135209 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135213 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135220 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135223 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135227 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135232 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135235 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135239 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135242 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135247 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135252 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135257 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135260 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135264 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135269 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135273 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135304 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135311 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135314 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 135336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135357 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135374 */     // GIR_Coverage, 19782,
     /* 135374 */     GIR_EraseRootFromParent_Done,
     /* 135375 */   // Label 2929: @135375
     /* 135375 */   GIM_Reject,
     /* 135376 */ // Label 2921: @135376
     /* 135376 */ GIM_Reject,
     /* 135377 */ // Label 2893: @135377
     /* 135377 */ GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(136534),
     /* 135382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 135385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 135391 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(135470), // Rule ID 19867 //
     /* 135396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135426 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135434 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135440 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135451 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135456 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135468 */     GIR_RootConstrainSelectedInstOperands,
     /* 135469 */     // GIR_Coverage, 19867,
     /* 135469 */     GIR_EraseRootFromParent_Done,
     /* 135470 */   // Label 2931: @135470
     /* 135470 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(135545), // Rule ID 19869 //
     /* 135475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135509 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135526 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135531 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135543 */     GIR_RootConstrainSelectedInstOperands,
     /* 135544 */     // GIR_Coverage, 19869,
     /* 135544 */     GIR_EraseRootFromParent_Done,
     /* 135545 */   // Label 2932: @135545
     /* 135545 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(135617), // Rule ID 19866 //
     /* 135550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135580 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135597 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135602 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135604 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135615 */     GIR_RootConstrainSelectedInstOperands,
     /* 135616 */     // GIR_Coverage, 19866,
     /* 135616 */     GIR_EraseRootFromParent_Done,
     /* 135617 */   // Label 2933: @135617
     /* 135617 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(135685), // Rule ID 19868 //
     /* 135622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135665 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135672 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135683 */     GIR_RootConstrainSelectedInstOperands,
     /* 135684 */     // GIR_Coverage, 19868,
     /* 135684 */     GIR_EraseRootFromParent_Done,
     /* 135685 */   // Label 2934: @135685
     /* 135685 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(135730), // Rule ID 4571 //
     /* 135690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135709 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135715 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135719 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 135719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135724 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135726 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135728 */     GIR_RootConstrainSelectedInstOperands,
     /* 135729 */     // GIR_Coverage, 4571,
     /* 135729 */     GIR_EraseRootFromParent_Done,
     /* 135730 */   // Label 2935: @135730
     /* 135730 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(135879), // Rule ID 19789 //
     /* 135735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135754 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135760 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135764 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135764 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135767 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135771 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135778 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135781 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135785 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135790 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135793 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135797 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135800 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135805 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135878 */     // GIR_Coverage, 19789,
     /* 135878 */     GIR_EraseRootFromParent_Done,
     /* 135879 */   // Label 2936: @135879
     /* 135879 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(136028), // Rule ID 19793 //
     /* 135884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135913 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135913 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135916 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135920 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135939 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135942 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135949 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135954 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135959 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135964 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135967 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135971 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135976 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135997 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136010 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136027 */     // GIR_Coverage, 19793,
     /* 136027 */     GIR_EraseRootFromParent_Done,
     /* 136028 */   // Label 2937: @136028
     /* 136028 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(136073), // Rule ID 19865 //
     /* 136033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136062 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 136065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136067 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136071 */     GIR_RootConstrainSelectedInstOperands,
     /* 136072 */     // GIR_Coverage, 19865,
     /* 136072 */     GIR_EraseRootFromParent_Done,
     /* 136073 */   // Label 2938: @136073
     /* 136073 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(136110), // Rule ID 4572 //
     /* 136078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136097 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 136097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136104 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136108 */     GIR_RootConstrainSelectedInstOperands,
     /* 136109 */     // GIR_Coverage, 4572,
     /* 136109 */     GIR_EraseRootFromParent_Done,
     /* 136110 */   // Label 2939: @136110
     /* 136110 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(136303), // Rule ID 19788 //
     /* 136115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136134 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136134 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136137 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136141 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136148 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136151 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136155 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136160 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136163 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136167 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136170 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136175 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136180 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136185 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136188 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136192 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136197 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136201 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136206 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136209 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136213 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136232 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136239 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136272 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136275 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136285 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136302 */     // GIR_Coverage, 19788,
     /* 136302 */     GIR_EraseRootFromParent_Done,
     /* 136303 */   // Label 2940: @136303
     /* 136303 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(136496), // Rule ID 19792 //
     /* 136308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136327 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136327 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136330 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136334 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136341 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136344 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136348 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136353 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136356 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136360 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136363 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136368 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136373 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136378 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136381 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136385 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136390 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136394 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136413 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136416 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136420 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136425 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136428 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136432 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136435 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136465 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136478 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136495 */     // GIR_Coverage, 19792,
     /* 136495 */     GIR_EraseRootFromParent_Done,
     /* 136496 */   // Label 2941: @136496
     /* 136496 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(136533), // Rule ID 19864 //
     /* 136501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136520 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136525 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136527 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136531 */     GIR_RootConstrainSelectedInstOperands,
     /* 136532 */     // GIR_Coverage, 19864,
     /* 136532 */     GIR_EraseRootFromParent_Done,
     /* 136533 */   // Label 2942: @136533
     /* 136533 */   GIM_Reject,
     /* 136534 */ // Label 2930: @136534
     /* 136534 */ GIM_Reject,
     /* 136535 */ // Label 2894: @136535
     /* 136535 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(137314),
     /* 136540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 136546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 136549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136561 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(136594), // Rule ID 4466 //
     /* 136566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136573 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136579 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136583 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 136583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 136586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136588 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136590 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136592 */     GIR_RootConstrainSelectedInstOperands,
     /* 136593 */     // GIR_Coverage, 4466,
     /* 136593 */     GIR_EraseRootFromParent_Done,
     /* 136594 */   // Label 2944: @136594
     /* 136594 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(136627), // Rule ID 4525 //
     /* 136599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136606 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136616 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 136616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 136619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136621 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136625 */     GIR_RootConstrainSelectedInstOperands,
     /* 136626 */     // GIR_Coverage, 4525,
     /* 136626 */     GIR_EraseRootFromParent_Done,
     /* 136627 */   // Label 2945: @136627
     /* 136627 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(136764), // Rule ID 19773 //
     /* 136632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136639 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136645 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136649 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136649 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136652 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136656 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136663 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136666 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136670 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136675 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136678 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136685 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136690 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136695 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 136728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136746 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136763 */     // GIR_Coverage, 19773,
     /* 136763 */     GIR_EraseRootFromParent_Done,
     /* 136764 */   // Label 2946: @136764
     /* 136764 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(136901), // Rule ID 19775 //
     /* 136769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136786 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136786 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136789 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136793 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136800 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136803 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136807 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136812 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136815 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136819 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136822 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136827 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136832 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136837 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136840 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136844 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136849 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 136865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136900 */     // GIR_Coverage, 19775,
     /* 136900 */     GIR_EraseRootFromParent_Done,
     /* 136901 */   // Label 2947: @136901
     /* 136901 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(136926), // Rule ID 4468 //
     /* 136906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136913 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 136913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 136916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136918 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136920 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136924 */     GIR_RootConstrainSelectedInstOperands,
     /* 136925 */     // GIR_Coverage, 4468,
     /* 136925 */     GIR_EraseRootFromParent_Done,
     /* 136926 */   // Label 2948: @136926
     /* 136926 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(136951), // Rule ID 4526 //
     /* 136931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136938 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 136938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 136941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136943 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136945 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136949 */     GIR_RootConstrainSelectedInstOperands,
     /* 136950 */     // GIR_Coverage, 4526,
     /* 136950 */     GIR_EraseRootFromParent_Done,
     /* 136951 */   // Label 2949: @136951
     /* 136951 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(137132), // Rule ID 19772 //
     /* 136956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136963 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136963 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136966 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136970 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136977 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136980 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136984 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136989 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136992 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136996 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136999 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137004 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137009 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137014 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 137017 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137021 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137026 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137030 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137035 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137038 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137042 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137061 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137064 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137068 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137076 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137081 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 137093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137098 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137101 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137104 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137114 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137131 */     // GIR_Coverage, 19772,
     /* 137131 */     GIR_EraseRootFromParent_Done,
     /* 137132 */   // Label 2950: @137132
     /* 137132 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(137313), // Rule ID 19774 //
     /* 137137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 137140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137144 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 137144 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 137147 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137151 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137158 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 137161 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137165 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137170 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137173 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137177 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 137180 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137185 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137190 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137195 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 137198 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137202 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137207 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137211 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137216 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137219 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137223 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137242 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137245 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137249 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137257 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 137274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137282 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137295 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137312 */     // GIR_Coverage, 19774,
     /* 137312 */     GIR_EraseRootFromParent_Done,
     /* 137313 */   // Label 2951: @137313
     /* 137313 */   GIM_Reject,
     /* 137314 */ // Label 2943: @137314
     /* 137314 */ GIM_Reject,
     /* 137315 */ // Label 2895: @137315
     /* 137315 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(137695),
     /* 137320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 137326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 137329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137333 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(137402), // Rule ID 19766 //
     /* 137338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 137346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 137354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 137359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 137363 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137369 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 137371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 137375 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137381 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 137383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 137389 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 137398 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137400 */     GIR_RootConstrainSelectedInstOperands,
     /* 137401 */     // GIR_Coverage, 19766,
     /* 137401 */     GIR_EraseRootFromParent_Done,
     /* 137402 */   // Label 2953: @137402
     /* 137402 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(137449), // Rule ID 3599 //
     /* 137407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 137426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137430 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137436 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137440 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 137440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 137443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137445 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137447 */     GIR_RootConstrainSelectedInstOperands,
     /* 137448 */     // GIR_Coverage, 3599,
     /* 137448 */     GIR_EraseRootFromParent_Done,
     /* 137449 */   // Label 2954: @137449
     /* 137449 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(137546), // Rule ID 19764 //
     /* 137454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137462 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137468 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137476 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 137476 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 137479 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137483 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137488 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137492 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 137497 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 137500 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 137504 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137509 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 137517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 137534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137542 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137544 */     GIR_RootConstrainSelectedInstOperands,
     /* 137545 */     // GIR_Coverage, 19764,
     /* 137545 */     GIR_EraseRootFromParent_Done,
     /* 137546 */   // Label 2955: @137546
     /* 137546 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(137587), // Rule ID 4479 //
     /* 137551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137576 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 137576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 137579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137581 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137585 */     GIR_RootConstrainSelectedInstOperands,
     /* 137586 */     // GIR_Coverage, 4479,
     /* 137586 */     GIR_EraseRootFromParent_Done,
     /* 137587 */   // Label 2956: @137587
     /* 137587 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(137628), // Rule ID 4533 //
     /* 137592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137607 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137613 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137617 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137622 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137624 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137626 */     GIR_RootConstrainSelectedInstOperands,
     /* 137627 */     // GIR_Coverage, 4533,
     /* 137627 */     GIR_EraseRootFromParent_Done,
     /* 137628 */   // Label 2957: @137628
     /* 137628 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(137661), // Rule ID 4481 //
     /* 137633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137648 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 137648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 137651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137653 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137655 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137659 */     GIR_RootConstrainSelectedInstOperands,
     /* 137660 */     // GIR_Coverage, 4481,
     /* 137660 */     GIR_EraseRootFromParent_Done,
     /* 137661 */   // Label 2958: @137661
     /* 137661 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(137694), // Rule ID 4535 //
     /* 137666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137681 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 137681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 137684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137686 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137688 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137690 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137692 */     GIR_RootConstrainSelectedInstOperands,
     /* 137693 */     // GIR_Coverage, 4535,
     /* 137693 */     GIR_EraseRootFromParent_Done,
     /* 137694 */   // Label 2959: @137694
     /* 137694 */   GIM_Reject,
     /* 137695 */ // Label 2952: @137695
     /* 137695 */ GIM_Reject,
     /* 137696 */ // Label 2896: @137696
     /* 137696 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(138135),
     /* 137701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 137707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 137710 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(137755), // Rule ID 4559 //
     /* 137715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137734 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137740 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137744 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 137744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 137747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137749 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137753 */     GIR_RootConstrainSelectedInstOperands,
     /* 137754 */     // GIR_Coverage, 4559,
     /* 137754 */     GIR_EraseRootFromParent_Done,
     /* 137755 */   // Label 2961: @137755
     /* 137755 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(137904), // Rule ID 19785 //
     /* 137760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137785 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137789 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137789 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 137792 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137796 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137803 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137806 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137810 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137815 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137818 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137822 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 137825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137830 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137835 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 137843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137852 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 137868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137876 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137886 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137903 */     // GIR_Coverage, 19785,
     /* 137903 */     GIR_EraseRootFromParent_Done,
     /* 137904 */   // Label 2962: @137904
     /* 137904 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(137941), // Rule ID 4560 //
     /* 137909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137928 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 137928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 137931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137933 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137935 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137939 */     GIR_RootConstrainSelectedInstOperands,
     /* 137940 */     // GIR_Coverage, 4560,
     /* 137940 */     GIR_EraseRootFromParent_Done,
     /* 137941 */   // Label 2963: @137941
     /* 137941 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(138134), // Rule ID 19784 //
     /* 137946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137965 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137965 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 137968 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137972 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137979 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 137982 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137986 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137991 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137994 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137998 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 138001 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138006 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138011 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 138016 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 138019 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138023 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138028 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138032 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 138037 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 138040 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138044 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 138054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138063 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138070 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 138073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 138088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 138091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 138095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 138123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 138128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138133 */     // GIR_Coverage, 19784,
     /* 138133 */     GIR_EraseRootFromParent_Done,
     /* 138134 */   // Label 2964: @138134
     /* 138134 */   GIM_Reject,
     /* 138135 */ // Label 2960: @138135
     /* 138135 */ GIM_Reject,
     /* 138136 */ // Label 2897: @138136
     /* 138136 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(139205),
     /* 138141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 138144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 138147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 138150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138158 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(138229), // Rule ID 19857 //
     /* 138163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138185 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138193 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138210 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138215 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138227 */     GIR_RootConstrainSelectedInstOperands,
     /* 138228 */     // GIR_Coverage, 19857,
     /* 138228 */     GIR_EraseRootFromParent_Done,
     /* 138229 */   // Label 2966: @138229
     /* 138229 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(138296), // Rule ID 19859 //
     /* 138234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138260 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138277 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138282 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138294 */     GIR_RootConstrainSelectedInstOperands,
     /* 138295 */     // GIR_Coverage, 19859,
     /* 138295 */     GIR_EraseRootFromParent_Done,
     /* 138296 */   // Label 2967: @138296
     /* 138296 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(138360), // Rule ID 19856 //
     /* 138301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138323 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138340 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138345 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138347 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138358 */     GIR_RootConstrainSelectedInstOperands,
     /* 138359 */     // GIR_Coverage, 19856,
     /* 138359 */     GIR_EraseRootFromParent_Done,
     /* 138360 */   // Label 2968: @138360
     /* 138360 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(138420), // Rule ID 19858 //
     /* 138365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138400 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138405 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138407 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138418 */     GIR_RootConstrainSelectedInstOperands,
     /* 138419 */     // GIR_Coverage, 19858,
     /* 138419 */     GIR_EraseRootFromParent_Done,
     /* 138420 */   // Label 2969: @138420
     /* 138420 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(138457), // Rule ID 4567 //
     /* 138425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138436 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138442 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138446 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 138446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138451 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138455 */     GIR_RootConstrainSelectedInstOperands,
     /* 138456 */     // GIR_Coverage, 4567,
     /* 138456 */     GIR_EraseRootFromParent_Done,
     /* 138457 */   // Label 2970: @138457
     /* 138457 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(138598), // Rule ID 19791 //
     /* 138462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138483 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138483 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138486 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138490 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138497 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138500 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138504 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138509 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138512 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138516 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138519 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138524 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138529 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138550 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138567 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138580 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138597 */     // GIR_Coverage, 19791,
     /* 138597 */     GIR_EraseRootFromParent_Done,
     /* 138598 */   // Label 2971: @138598
     /* 138598 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(138739), // Rule ID 19795 //
     /* 138603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138614 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138620 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138624 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138624 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138627 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138631 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138650 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138653 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138657 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138660 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138665 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138670 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138721 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138738 */     // GIR_Coverage, 19795,
     /* 138738 */     GIR_EraseRootFromParent_Done,
     /* 138739 */   // Label 2972: @138739
     /* 138739 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(138776), // Rule ID 19855 //
     /* 138744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138765 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138770 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138774 */     GIR_RootConstrainSelectedInstOperands,
     /* 138775 */     // GIR_Coverage, 19855,
     /* 138775 */     GIR_EraseRootFromParent_Done,
     /* 138776 */   // Label 2973: @138776
     /* 138776 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(138805), // Rule ID 4568 //
     /* 138781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138792 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 138792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138797 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138799 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138803 */     GIR_RootConstrainSelectedInstOperands,
     /* 138804 */     // GIR_Coverage, 4568,
     /* 138804 */     GIR_EraseRootFromParent_Done,
     /* 138805 */   // Label 2974: @138805
     /* 138805 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(138990), // Rule ID 19790 //
     /* 138810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138821 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138821 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138824 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138828 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138835 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138838 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138842 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138847 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138850 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138854 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138857 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138862 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138867 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138872 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138875 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138879 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138884 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138888 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138893 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138896 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138900 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138919 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138926 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138956 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138959 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138972 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138989 */     // GIR_Coverage, 19790,
     /* 138989 */     GIR_EraseRootFromParent_Done,
     /* 138990 */   // Label 2975: @138990
     /* 138990 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(139175), // Rule ID 19794 //
     /* 138995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139006 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139006 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 139009 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139013 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139020 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 139023 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139027 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139032 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139035 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139039 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139042 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139047 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139052 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139057 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 139060 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139064 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139069 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139073 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 139081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 139095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139104 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139111 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 139132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 139136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139157 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139174 */     // GIR_Coverage, 19794,
     /* 139174 */     GIR_EraseRootFromParent_Done,
     /* 139175 */   // Label 2976: @139175
     /* 139175 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(139204), // Rule ID 19854 //
     /* 139180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139191 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 139191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 139194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139196 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139198 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139202 */     GIR_RootConstrainSelectedInstOperands,
     /* 139203 */     // GIR_Coverage, 19854,
     /* 139203 */     GIR_EraseRootFromParent_Done,
     /* 139204 */   // Label 2977: @139204
     /* 139204 */   GIM_Reject,
     /* 139205 */ // Label 2965: @139205
     /* 139205 */ GIM_Reject,
     /* 139206 */ // Label 2898: @139206
     /* 139206 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(139546),
     /* 139211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 139217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 139220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139224 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(139293), // Rule ID 19767 //
     /* 139229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 139237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 139245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 139250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139254 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 139262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 139266 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139272 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 139274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139280 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 139289 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139291 */     GIR_RootConstrainSelectedInstOperands,
     /* 139292 */     // GIR_Coverage, 19767,
     /* 139292 */     GIR_EraseRootFromParent_Done,
     /* 139293 */   // Label 2979: @139293
     /* 139293 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(139340), // Rule ID 3598 //
     /* 139298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139309 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 139317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139321 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139331 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 139331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 139334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139336 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139338 */     GIR_RootConstrainSelectedInstOperands,
     /* 139339 */     // GIR_Coverage, 3598,
     /* 139339 */     GIR_EraseRootFromParent_Done,
     /* 139340 */   // Label 2980: @139340
     /* 139340 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(139397), // Rule ID 19765 //
     /* 139345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139367 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 139367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 139370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 139374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139393 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139395 */     GIR_RootConstrainSelectedInstOperands,
     /* 139396 */     // GIR_Coverage, 19765,
     /* 139396 */     GIR_EraseRootFromParent_Done,
     /* 139397 */   // Label 2981: @139397
     /* 139397 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(139438), // Rule ID 4461 //
     /* 139402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139417 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139423 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139427 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 139427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 139430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139432 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139434 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139436 */     GIR_RootConstrainSelectedInstOperands,
     /* 139437 */     // GIR_Coverage, 4461,
     /* 139437 */     GIR_EraseRootFromParent_Done,
     /* 139438 */   // Label 2982: @139438
     /* 139438 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(139479), // Rule ID 4521 //
     /* 139443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139458 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139464 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139468 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139473 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139477 */     GIR_RootConstrainSelectedInstOperands,
     /* 139478 */     // GIR_Coverage, 4521,
     /* 139478 */     GIR_EraseRootFromParent_Done,
     /* 139479 */   // Label 2983: @139479
     /* 139479 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(139512), // Rule ID 4463 //
     /* 139484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139499 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 139499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 139502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139504 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139506 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139510 */     GIR_RootConstrainSelectedInstOperands,
     /* 139511 */     // GIR_Coverage, 4463,
     /* 139511 */     GIR_EraseRootFromParent_Done,
     /* 139512 */   // Label 2984: @139512
     /* 139512 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(139545), // Rule ID 4522 //
     /* 139517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139532 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 139532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 139535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139537 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139539 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139543 */     GIR_RootConstrainSelectedInstOperands,
     /* 139544 */     // GIR_Coverage, 4522,
     /* 139544 */     GIR_EraseRootFromParent_Done,
     /* 139545 */   // Label 2985: @139545
     /* 139545 */   GIM_Reject,
     /* 139546 */ // Label 2978: @139546
     /* 139546 */ GIM_Reject,
     /* 139547 */ // Label 2899: @139547
     /* 139547 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(139950),
     /* 139552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 139558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 139561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139573 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(139606), // Rule ID 4555 //
     /* 139578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139585 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139591 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139595 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 139595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 139598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139600 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139602 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139604 */     GIR_RootConstrainSelectedInstOperands,
     /* 139605 */     // GIR_Coverage, 4555,
     /* 139605 */     GIR_EraseRootFromParent_Done,
     /* 139606 */   // Label 2987: @139606
     /* 139606 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(139743), // Rule ID 19787 //
     /* 139611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139628 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139628 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 139631 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139635 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139654 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 139657 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139661 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 139664 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139669 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139674 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 139682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 139707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139725 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139742 */     // GIR_Coverage, 19787,
     /* 139742 */     GIR_EraseRootFromParent_Done,
     /* 139743 */   // Label 2988: @139743
     /* 139743 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(139768), // Rule ID 4556 //
     /* 139748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139755 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 139755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 139758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139760 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139762 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139766 */     GIR_RootConstrainSelectedInstOperands,
     /* 139767 */     // GIR_Coverage, 4556,
     /* 139767 */     GIR_EraseRootFromParent_Done,
     /* 139768 */   // Label 2989: @139768
     /* 139768 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(139949), // Rule ID 19786 //
     /* 139773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139780 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139780 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 139783 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139787 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139794 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 139797 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139801 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139806 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139809 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139813 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139816 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139821 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139826 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139831 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 139834 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139838 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139843 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139847 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139852 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139855 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139859 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 139869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139878 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139885 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139931 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139948 */     // GIR_Coverage, 19786,
     /* 139948 */     GIR_EraseRootFromParent_Done,
     /* 139949 */   // Label 2990: @139949
     /* 139949 */   GIM_Reject,
     /* 139950 */ // Label 2986: @139950
     /* 139950 */ GIM_Reject,
     /* 139951 */ // Label 2900: @139951
     /* 139951 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(140368),
     /* 139956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 139962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 139965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139973 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(140044), // Rule ID 19847 //
     /* 139978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139989 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139996 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140000 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 140004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 140008 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 140016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140025 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 140028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140030 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 140042 */     GIR_RootConstrainSelectedInstOperands,
     /* 140043 */     // GIR_Coverage, 19847,
     /* 140043 */     GIR_EraseRootFromParent_Done,
     /* 140044 */   // Label 2992: @140044
     /* 140044 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(140111), // Rule ID 19849 //
     /* 140049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 140075 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 140083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140092 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 140095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140097 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 140109 */     GIR_RootConstrainSelectedInstOperands,
     /* 140110 */     // GIR_Coverage, 19849,
     /* 140110 */     GIR_EraseRootFromParent_Done,
     /* 140111 */   // Label 2993: @140111
     /* 140111 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(140175), // Rule ID 19846 //
     /* 140116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140138 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 140142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140155 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140160 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140162 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140173 */     GIR_RootConstrainSelectedInstOperands,
     /* 140174 */     // GIR_Coverage, 19846,
     /* 140174 */     GIR_EraseRootFromParent_Done,
     /* 140175 */   // Label 2994: @140175
     /* 140175 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(140235), // Rule ID 19848 //
     /* 140180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140215 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140222 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140233 */     GIR_RootConstrainSelectedInstOperands,
     /* 140234 */     // GIR_Coverage, 19848,
     /* 140234 */     GIR_EraseRootFromParent_Done,
     /* 140235 */   // Label 2995: @140235
     /* 140235 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(140272), // Rule ID 4563 //
     /* 140240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140251 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140257 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140261 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 140261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140266 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140270 */     GIR_RootConstrainSelectedInstOperands,
     /* 140271 */     // GIR_Coverage, 4563,
     /* 140271 */     GIR_EraseRootFromParent_Done,
     /* 140272 */   // Label 2996: @140272
     /* 140272 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(140309), // Rule ID 19845 //
     /* 140277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140288 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140294 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140298 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140303 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140307 */     GIR_RootConstrainSelectedInstOperands,
     /* 140308 */     // GIR_Coverage, 19845,
     /* 140308 */     GIR_EraseRootFromParent_Done,
     /* 140309 */   // Label 2997: @140309
     /* 140309 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(140338), // Rule ID 4564 //
     /* 140314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140325 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 140325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140330 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140332 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140336 */     GIR_RootConstrainSelectedInstOperands,
     /* 140337 */     // GIR_Coverage, 4564,
     /* 140337 */     GIR_EraseRootFromParent_Done,
     /* 140338 */   // Label 2998: @140338
     /* 140338 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(140367), // Rule ID 19844 //
     /* 140343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140354 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140361 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140365 */     GIR_RootConstrainSelectedInstOperands,
     /* 140366 */     // GIR_Coverage, 19844,
     /* 140366 */     GIR_EraseRootFromParent_Done,
     /* 140367 */   // Label 2999: @140367
     /* 140367 */   GIM_Reject,
     /* 140368 */ // Label 2991: @140368
     /* 140368 */ GIM_Reject,
     /* 140369 */ // Label 2901: @140369
     /* 140369 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(140454),
     /* 140374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 140377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 140380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 140383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 140391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140395 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(140428), // Rule ID 4551 //
     /* 140400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140417 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 140417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 140420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140422 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140426 */     GIR_RootConstrainSelectedInstOperands,
     /* 140427 */     // GIR_Coverage, 4551,
     /* 140427 */     GIR_EraseRootFromParent_Done,
     /* 140428 */   // Label 3001: @140428
     /* 140428 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(140453), // Rule ID 4552 //
     /* 140433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140440 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 140440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 140443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140445 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140447 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140451 */     GIR_RootConstrainSelectedInstOperands,
     /* 140452 */     // GIR_Coverage, 4552,
     /* 140452 */     GIR_EraseRootFromParent_Done,
     /* 140453 */   // Label 3002: @140453
     /* 140453 */   GIM_Reject,
     /* 140454 */ // Label 3000: @140454
     /* 140454 */ GIM_Reject,
     /* 140455 */ // Label 2902: @140455
     /* 140455 */ GIM_Reject,
     /* 140456 */ // Label 35: @140456
     /* 140456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3006*/ GIMT_Encode4(141320),
     /* 140467 */ /*GILLT_v8s16*//*Label 3003*/ GIMT_Encode4(140507), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140487 */ /*GILLT_v16s16*//*Label 3004*/ GIMT_Encode4(140849), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140503 */ /*GILLT_v32s16*//*Label 3005*/ GIMT_Encode4(141164),
     /* 140507 */ // Label 3003: @140507
     /* 140507 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(140848),
     /* 140512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140518 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(140580), // Rule ID 23456 //
     /* 140523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140562 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140578 */     GIR_RootConstrainSelectedInstOperands,
     /* 140579 */     // GIR_Coverage, 23456,
     /* 140579 */     GIR_EraseRootFromParent_Done,
     /* 140580 */   // Label 3008: @140580
     /* 140580 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(140642), // Rule ID 23846 //
     /* 140585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140624 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140640 */     GIR_RootConstrainSelectedInstOperands,
     /* 140641 */     // GIR_Coverage, 23846,
     /* 140641 */     GIR_EraseRootFromParent_Done,
     /* 140642 */   // Label 3009: @140642
     /* 140642 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(140704), // Rule ID 2577 //
     /* 140647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140686 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140702 */     GIR_RootConstrainSelectedInstOperands,
     /* 140703 */     // GIR_Coverage, 2577,
     /* 140703 */     GIR_EraseRootFromParent_Done,
     /* 140704 */   // Label 3010: @140704
     /* 140704 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(140766), // Rule ID 5062 //
     /* 140709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140748 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140764 */     GIR_RootConstrainSelectedInstOperands,
     /* 140765 */     // GIR_Coverage, 5062,
     /* 140765 */     GIR_EraseRootFromParent_Done,
     /* 140766 */   // Label 3011: @140766
     /* 140766 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(140793), // Rule ID 2576 //
     /* 140771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140786 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 140791 */     GIR_RootConstrainSelectedInstOperands,
     /* 140792 */     // GIR_Coverage, 2576,
     /* 140792 */     GIR_Done,
     /* 140793 */   // Label 3012: @140793
     /* 140793 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(140820), // Rule ID 2578 //
     /* 140798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140813 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 140818 */     GIR_RootConstrainSelectedInstOperands,
     /* 140819 */     // GIR_Coverage, 2578,
     /* 140819 */     GIR_Done,
     /* 140820 */   // Label 3013: @140820
     /* 140820 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(140847), // Rule ID 5059 //
     /* 140825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140840 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 140845 */     GIR_RootConstrainSelectedInstOperands,
     /* 140846 */     // GIR_Coverage, 5059,
     /* 140846 */     GIR_Done,
     /* 140847 */   // Label 3014: @140847
     /* 140847 */   GIM_Reject,
     /* 140848 */ // Label 3007: @140848
     /* 140848 */ GIM_Reject,
     /* 140849 */ // Label 3004: @140849
     /* 140849 */ GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(141163),
     /* 140854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 140857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 140860 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(140922), // Rule ID 23458 //
     /* 140865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140904 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140920 */     GIR_RootConstrainSelectedInstOperands,
     /* 140921 */     // GIR_Coverage, 23458,
     /* 140921 */     GIR_EraseRootFromParent_Done,
     /* 140922 */   // Label 3016: @140922
     /* 140922 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(140984), // Rule ID 23843 //
     /* 140927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140966 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140982 */     GIR_RootConstrainSelectedInstOperands,
     /* 140983 */     // GIR_Coverage, 23843,
     /* 140983 */     GIR_EraseRootFromParent_Done,
     /* 140984 */   // Label 3017: @140984
     /* 140984 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(141046), // Rule ID 2581 //
     /* 140989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141028 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 141031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141044 */     GIR_RootConstrainSelectedInstOperands,
     /* 141045 */     // GIR_Coverage, 2581,
     /* 141045 */     GIR_EraseRootFromParent_Done,
     /* 141046 */   // Label 3018: @141046
     /* 141046 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(141108), // Rule ID 5056 //
     /* 141051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141090 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 141093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141106 */     GIR_RootConstrainSelectedInstOperands,
     /* 141107 */     // GIR_Coverage, 5056,
     /* 141107 */     GIR_EraseRootFromParent_Done,
     /* 141108 */   // Label 3019: @141108
     /* 141108 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(141135), // Rule ID 2580 //
     /* 141113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141128 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 141133 */     GIR_RootConstrainSelectedInstOperands,
     /* 141134 */     // GIR_Coverage, 2580,
     /* 141134 */     GIR_Done,
     /* 141135 */   // Label 3020: @141135
     /* 141135 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(141162), // Rule ID 5053 //
     /* 141140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141155 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 141155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 141160 */     GIR_RootConstrainSelectedInstOperands,
     /* 141161 */     // GIR_Coverage, 5053,
     /* 141161 */     GIR_Done,
     /* 141162 */   // Label 3021: @141162
     /* 141162 */   GIM_Reject,
     /* 141163 */ // Label 3015: @141163
     /* 141163 */ GIM_Reject,
     /* 141164 */ // Label 3005: @141164
     /* 141164 */ GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(141319),
     /* 141169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 141172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 141175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141179 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(141237), // Rule ID 23840 //
     /* 141184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141219 */     // (mulhu:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141235 */     GIR_RootConstrainSelectedInstOperands,
     /* 141236 */     // GIR_Coverage, 23840,
     /* 141236 */     GIR_EraseRootFromParent_Done,
     /* 141237 */   // Label 3023: @141237
     /* 141237 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(141295), // Rule ID 5050 //
     /* 141242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141257 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141277 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141293 */     GIR_RootConstrainSelectedInstOperands,
     /* 141294 */     // GIR_Coverage, 5050,
     /* 141294 */     GIR_EraseRootFromParent_Done,
     /* 141295 */   // Label 3024: @141295
     /* 141295 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(141318), // Rule ID 5047 //
     /* 141300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141311 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 141316 */     GIR_RootConstrainSelectedInstOperands,
     /* 141317 */     // GIR_Coverage, 5047,
     /* 141317 */     GIR_Done,
     /* 141318 */   // Label 3025: @141318
     /* 141318 */   GIM_Reject,
     /* 141319 */ // Label 3022: @141319
     /* 141319 */ GIM_Reject,
     /* 141320 */ // Label 3006: @141320
     /* 141320 */ GIM_Reject,
     /* 141321 */ // Label 36: @141321
     /* 141321 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3029*/ GIMT_Encode4(142185),
     /* 141332 */ /*GILLT_v8s16*//*Label 3026*/ GIMT_Encode4(141372), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141352 */ /*GILLT_v16s16*//*Label 3027*/ GIMT_Encode4(141714), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141368 */ /*GILLT_v32s16*//*Label 3028*/ GIMT_Encode4(142029),
     /* 141372 */ // Label 3026: @141372
     /* 141372 */ GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(141713),
     /* 141377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 141380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141383 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(141445), // Rule ID 23459 //
     /* 141388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141427 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141443 */     GIR_RootConstrainSelectedInstOperands,
     /* 141444 */     // GIR_Coverage, 23459,
     /* 141444 */     GIR_EraseRootFromParent_Done,
     /* 141445 */   // Label 3031: @141445
     /* 141445 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(141507), // Rule ID 23837 //
     /* 141450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141489 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141505 */     GIR_RootConstrainSelectedInstOperands,
     /* 141506 */     // GIR_Coverage, 23837,
     /* 141506 */     GIR_EraseRootFromParent_Done,
     /* 141507 */   // Label 3032: @141507
     /* 141507 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(141569), // Rule ID 2583 //
     /* 141512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141538 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141551 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141567 */     GIR_RootConstrainSelectedInstOperands,
     /* 141568 */     // GIR_Coverage, 2583,
     /* 141568 */     GIR_EraseRootFromParent_Done,
     /* 141569 */   // Label 3033: @141569
     /* 141569 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(141631), // Rule ID 5044 //
     /* 141574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141613 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141629 */     GIR_RootConstrainSelectedInstOperands,
     /* 141630 */     // GIR_Coverage, 5044,
     /* 141630 */     GIR_EraseRootFromParent_Done,
     /* 141631 */   // Label 3034: @141631
     /* 141631 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(141658), // Rule ID 2582 //
     /* 141636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141651 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 141656 */     GIR_RootConstrainSelectedInstOperands,
     /* 141657 */     // GIR_Coverage, 2582,
     /* 141657 */     GIR_Done,
     /* 141658 */   // Label 3035: @141658
     /* 141658 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(141685), // Rule ID 2584 //
     /* 141663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 141666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141678 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 141683 */     GIR_RootConstrainSelectedInstOperands,
     /* 141684 */     // GIR_Coverage, 2584,
     /* 141684 */     GIR_Done,
     /* 141685 */   // Label 3036: @141685
     /* 141685 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(141712), // Rule ID 5041 //
     /* 141690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141705 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 141705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 141710 */     GIR_RootConstrainSelectedInstOperands,
     /* 141711 */     // GIR_Coverage, 5041,
     /* 141711 */     GIR_Done,
     /* 141712 */   // Label 3037: @141712
     /* 141712 */   GIM_Reject,
     /* 141713 */ // Label 3030: @141713
     /* 141713 */ GIM_Reject,
     /* 141714 */ // Label 3027: @141714
     /* 141714 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(142028),
     /* 141719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 141722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 141725 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(141787), // Rule ID 23461 //
     /* 141730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141752 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141769 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141785 */     GIR_RootConstrainSelectedInstOperands,
     /* 141786 */     // GIR_Coverage, 23461,
     /* 141786 */     GIR_EraseRootFromParent_Done,
     /* 141787 */   // Label 3039: @141787
     /* 141787 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(141849), // Rule ID 23834 //
     /* 141792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141831 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141847 */     GIR_RootConstrainSelectedInstOperands,
     /* 141848 */     // GIR_Coverage, 23834,
     /* 141848 */     GIR_EraseRootFromParent_Done,
     /* 141849 */   // Label 3040: @141849
     /* 141849 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(141911), // Rule ID 2587 //
     /* 141854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141893 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141909 */     GIR_RootConstrainSelectedInstOperands,
     /* 141910 */     // GIR_Coverage, 2587,
     /* 141910 */     GIR_EraseRootFromParent_Done,
     /* 141911 */   // Label 3041: @141911
     /* 141911 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(141973), // Rule ID 5038 //
     /* 141916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141935 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141942 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141955 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141960 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141971 */     GIR_RootConstrainSelectedInstOperands,
     /* 141972 */     // GIR_Coverage, 5038,
     /* 141972 */     GIR_EraseRootFromParent_Done,
     /* 141973 */   // Label 3042: @141973
     /* 141973 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(142000), // Rule ID 2586 //
     /* 141978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141993 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 141998 */     GIR_RootConstrainSelectedInstOperands,
     /* 141999 */     // GIR_Coverage, 2586,
     /* 141999 */     GIR_Done,
     /* 142000 */   // Label 3043: @142000
     /* 142000 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(142027), // Rule ID 5035 //
     /* 142005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142020 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 142020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 142025 */     GIR_RootConstrainSelectedInstOperands,
     /* 142026 */     // GIR_Coverage, 5035,
     /* 142026 */     GIR_Done,
     /* 142027 */   // Label 3044: @142027
     /* 142027 */   GIM_Reject,
     /* 142028 */ // Label 3038: @142028
     /* 142028 */ GIM_Reject,
     /* 142029 */ // Label 3028: @142029
     /* 142029 */ GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(142184),
     /* 142034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 142037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 142040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142044 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(142102), // Rule ID 23831 //
     /* 142049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142084 */     // (mulhs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 142087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142100 */     GIR_RootConstrainSelectedInstOperands,
     /* 142101 */     // GIR_Coverage, 23831,
     /* 142101 */     GIR_EraseRootFromParent_Done,
     /* 142102 */   // Label 3046: @142102
     /* 142102 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(142160), // Rule ID 5032 //
     /* 142107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142142 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 142145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142158 */     GIR_RootConstrainSelectedInstOperands,
     /* 142159 */     // GIR_Coverage, 5032,
     /* 142159 */     GIR_EraseRootFromParent_Done,
     /* 142160 */   // Label 3047: @142160
     /* 142160 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(142183), // Rule ID 5029 //
     /* 142165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142176 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 142176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 142181 */     GIR_RootConstrainSelectedInstOperands,
     /* 142182 */     // GIR_Coverage, 5029,
     /* 142182 */     GIR_Done,
     /* 142183 */   // Label 3048: @142183
     /* 142183 */   GIM_Reject,
     /* 142184 */ // Label 3045: @142184
     /* 142184 */ GIM_Reject,
     /* 142185 */ // Label 3029: @142185
     /* 142185 */ GIM_Reject,
     /* 142186 */ // Label 37: @142186
     /* 142186 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3055*/ GIMT_Encode4(143871),
     /* 142197 */ /*GILLT_v8s16*//*Label 3049*/ GIMT_Encode4(142245), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142213 */ /*GILLT_v16s8*//*Label 3050*/ GIMT_Encode4(142587),
     /* 142217 */ /*GILLT_v16s16*//*Label 3051*/ GIMT_Encode4(142929), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142229 */ /*GILLT_v32s8*//*Label 3052*/ GIMT_Encode4(143244),
     /* 142233 */ /*GILLT_v32s16*//*Label 3053*/ GIMT_Encode4(143559), GIMT_Encode4(0),
     /* 142241 */ /*GILLT_v64s8*//*Label 3054*/ GIMT_Encode4(143715),
     /* 142245 */ // Label 3049: @142245
     /* 142245 */ GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(142586),
     /* 142250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142256 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(142318), // Rule ID 23450 //
     /* 142261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142300 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142316 */     GIR_RootConstrainSelectedInstOperands,
     /* 142317 */     // GIR_Coverage, 23450,
     /* 142317 */     GIR_EraseRootFromParent_Done,
     /* 142318 */   // Label 3057: @142318
     /* 142318 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(142380), // Rule ID 23774 //
     /* 142323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142362 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142378 */     GIR_RootConstrainSelectedInstOperands,
     /* 142379 */     // GIR_Coverage, 23774,
     /* 142379 */     GIR_EraseRootFromParent_Done,
     /* 142380 */   // Label 3058: @142380
     /* 142380 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(142442), // Rule ID 2565 //
     /* 142385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142424 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142440 */     GIR_RootConstrainSelectedInstOperands,
     /* 142441 */     // GIR_Coverage, 2565,
     /* 142441 */     GIR_EraseRootFromParent_Done,
     /* 142442 */   // Label 3059: @142442
     /* 142442 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(142504), // Rule ID 4900 //
     /* 142447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142486 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142502 */     GIR_RootConstrainSelectedInstOperands,
     /* 142503 */     // GIR_Coverage, 4900,
     /* 142503 */     GIR_EraseRootFromParent_Done,
     /* 142504 */   // Label 3060: @142504
     /* 142504 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(142531), // Rule ID 2564 //
     /* 142509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142524 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 142529 */     GIR_RootConstrainSelectedInstOperands,
     /* 142530 */     // GIR_Coverage, 2564,
     /* 142530 */     GIR_Done,
     /* 142531 */   // Label 3061: @142531
     /* 142531 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(142558), // Rule ID 2566 //
     /* 142536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142551 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 142556 */     GIR_RootConstrainSelectedInstOperands,
     /* 142557 */     // GIR_Coverage, 2566,
     /* 142557 */     GIR_Done,
     /* 142558 */   // Label 3062: @142558
     /* 142558 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(142585), // Rule ID 4897 //
     /* 142563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142578 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 142578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 142583 */     GIR_RootConstrainSelectedInstOperands,
     /* 142584 */     // GIR_Coverage, 4897,
     /* 142584 */     GIR_Done,
     /* 142585 */   // Label 3063: @142585
     /* 142585 */   GIM_Reject,
     /* 142586 */ // Label 3056: @142586
     /* 142586 */ GIM_Reject,
     /* 142587 */ // Label 3050: @142587
     /* 142587 */ GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(142928),
     /* 142592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 142595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142598 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(142660), // Rule ID 23447 //
     /* 142603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142625 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142642 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142658 */     GIR_RootConstrainSelectedInstOperands,
     /* 142659 */     // GIR_Coverage, 23447,
     /* 142659 */     GIR_EraseRootFromParent_Done,
     /* 142660 */   // Label 3065: @142660
     /* 142660 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(142722), // Rule ID 23783 //
     /* 142665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142680 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142704 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142720 */     GIR_RootConstrainSelectedInstOperands,
     /* 142721 */     // GIR_Coverage, 23783,
     /* 142721 */     GIR_EraseRootFromParent_Done,
     /* 142722 */   // Label 3066: @142722
     /* 142722 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(142784), // Rule ID 2559 //
     /* 142727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142766 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142771 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142782 */     GIR_RootConstrainSelectedInstOperands,
     /* 142783 */     // GIR_Coverage, 2559,
     /* 142783 */     GIR_EraseRootFromParent_Done,
     /* 142784 */   // Label 3067: @142784
     /* 142784 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(142846), // Rule ID 4918 //
     /* 142789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142828 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142844 */     GIR_RootConstrainSelectedInstOperands,
     /* 142845 */     // GIR_Coverage, 4918,
     /* 142845 */     GIR_EraseRootFromParent_Done,
     /* 142846 */   // Label 3068: @142846
     /* 142846 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(142873), // Rule ID 2558 //
     /* 142851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142866 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 142871 */     GIR_RootConstrainSelectedInstOperands,
     /* 142872 */     // GIR_Coverage, 2558,
     /* 142872 */     GIR_Done,
     /* 142873 */   // Label 3069: @142873
     /* 142873 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(142900), // Rule ID 2560 //
     /* 142878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142893 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 142898 */     GIR_RootConstrainSelectedInstOperands,
     /* 142899 */     // GIR_Coverage, 2560,
     /* 142899 */     GIR_Done,
     /* 142900 */   // Label 3070: @142900
     /* 142900 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(142927), // Rule ID 4915 //
     /* 142905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142920 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 142920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 142925 */     GIR_RootConstrainSelectedInstOperands,
     /* 142926 */     // GIR_Coverage, 4915,
     /* 142926 */     GIR_Done,
     /* 142927 */   // Label 3071: @142927
     /* 142927 */   GIM_Reject,
     /* 142928 */ // Label 3064: @142928
     /* 142928 */ GIM_Reject,
     /* 142929 */ // Label 3051: @142929
     /* 142929 */ GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(143243),
     /* 142934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 142937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 142940 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(143002), // Rule ID 23452 //
     /* 142945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142984 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142989 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143000 */     GIR_RootConstrainSelectedInstOperands,
     /* 143001 */     // GIR_Coverage, 23452,
     /* 143001 */     GIR_EraseRootFromParent_Done,
     /* 143002 */   // Label 3073: @143002
     /* 143002 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(143064), // Rule ID 23771 //
     /* 143007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143046 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 143049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143062 */     GIR_RootConstrainSelectedInstOperands,
     /* 143063 */     // GIR_Coverage, 23771,
     /* 143063 */     GIR_EraseRootFromParent_Done,
     /* 143064 */   // Label 3074: @143064
     /* 143064 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(143126), // Rule ID 2569 //
     /* 143069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143108 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 143111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143124 */     GIR_RootConstrainSelectedInstOperands,
     /* 143125 */     // GIR_Coverage, 2569,
     /* 143125 */     GIR_EraseRootFromParent_Done,
     /* 143126 */   // Label 3075: @143126
     /* 143126 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(143188), // Rule ID 4894 //
     /* 143131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143170 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 143173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143186 */     GIR_RootConstrainSelectedInstOperands,
     /* 143187 */     // GIR_Coverage, 4894,
     /* 143187 */     GIR_EraseRootFromParent_Done,
     /* 143188 */   // Label 3076: @143188
     /* 143188 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(143215), // Rule ID 2568 //
     /* 143193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143208 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 143208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 143213 */     GIR_RootConstrainSelectedInstOperands,
     /* 143214 */     // GIR_Coverage, 2568,
     /* 143214 */     GIR_Done,
     /* 143215 */   // Label 3077: @143215
     /* 143215 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(143242), // Rule ID 4891 //
     /* 143220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143235 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 143235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 143240 */     GIR_RootConstrainSelectedInstOperands,
     /* 143241 */     // GIR_Coverage, 4891,
     /* 143241 */     GIR_Done,
     /* 143242 */   // Label 3078: @143242
     /* 143242 */   GIM_Reject,
     /* 143243 */ // Label 3072: @143243
     /* 143243 */ GIM_Reject,
     /* 143244 */ // Label 3052: @143244
     /* 143244 */ GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(143558),
     /* 143249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 143252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 143255 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(143317), // Rule ID 23449 //
     /* 143260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143299 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143315 */     GIR_RootConstrainSelectedInstOperands,
     /* 143316 */     // GIR_Coverage, 23449,
     /* 143316 */     GIR_EraseRootFromParent_Done,
     /* 143317 */   // Label 3080: @143317
     /* 143317 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(143379), // Rule ID 23780 //
     /* 143322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143361 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143377 */     GIR_RootConstrainSelectedInstOperands,
     /* 143378 */     // GIR_Coverage, 23780,
     /* 143378 */     GIR_EraseRootFromParent_Done,
     /* 143379 */   // Label 3081: @143379
     /* 143379 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(143441), // Rule ID 2563 //
     /* 143384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143423 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143439 */     GIR_RootConstrainSelectedInstOperands,
     /* 143440 */     // GIR_Coverage, 2563,
     /* 143440 */     GIR_EraseRootFromParent_Done,
     /* 143441 */   // Label 3082: @143441
     /* 143441 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(143503), // Rule ID 4912 //
     /* 143446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143485 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143501 */     GIR_RootConstrainSelectedInstOperands,
     /* 143502 */     // GIR_Coverage, 4912,
     /* 143502 */     GIR_EraseRootFromParent_Done,
     /* 143503 */   // Label 3083: @143503
     /* 143503 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(143530), // Rule ID 2562 //
     /* 143508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143523 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 143523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 143528 */     GIR_RootConstrainSelectedInstOperands,
     /* 143529 */     // GIR_Coverage, 2562,
     /* 143529 */     GIR_Done,
     /* 143530 */   // Label 3084: @143530
     /* 143530 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(143557), // Rule ID 4909 //
     /* 143535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143550 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 143550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 143555 */     GIR_RootConstrainSelectedInstOperands,
     /* 143556 */     // GIR_Coverage, 4909,
     /* 143556 */     GIR_Done,
     /* 143557 */   // Label 3085: @143557
     /* 143557 */   GIM_Reject,
     /* 143558 */ // Label 3079: @143558
     /* 143558 */ GIM_Reject,
     /* 143559 */ // Label 3053: @143559
     /* 143559 */ GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(143714),
     /* 143564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 143567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 143570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143574 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(143632), // Rule ID 23768 //
     /* 143579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143614 */     // (uaddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143630 */     GIR_RootConstrainSelectedInstOperands,
     /* 143631 */     // GIR_Coverage, 23768,
     /* 143631 */     GIR_EraseRootFromParent_Done,
     /* 143632 */   // Label 3087: @143632
     /* 143632 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(143690), // Rule ID 4888 //
     /* 143637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143672 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143688 */     GIR_RootConstrainSelectedInstOperands,
     /* 143689 */     // GIR_Coverage, 4888,
     /* 143689 */     GIR_EraseRootFromParent_Done,
     /* 143690 */   // Label 3088: @143690
     /* 143690 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(143713), // Rule ID 4885 //
     /* 143695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143706 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 143706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 143711 */     GIR_RootConstrainSelectedInstOperands,
     /* 143712 */     // GIR_Coverage, 4885,
     /* 143712 */     GIR_Done,
     /* 143713 */   // Label 3089: @143713
     /* 143713 */   GIM_Reject,
     /* 143714 */ // Label 3086: @143714
     /* 143714 */ GIM_Reject,
     /* 143715 */ // Label 3054: @143715
     /* 143715 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(143870),
     /* 143720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 143723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 143726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143730 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(143788), // Rule ID 23777 //
     /* 143735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143770 */     // (uaddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143786 */     GIR_RootConstrainSelectedInstOperands,
     /* 143787 */     // GIR_Coverage, 23777,
     /* 143787 */     GIR_EraseRootFromParent_Done,
     /* 143788 */   // Label 3091: @143788
     /* 143788 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(143846), // Rule ID 4906 //
     /* 143793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143828 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143844 */     GIR_RootConstrainSelectedInstOperands,
     /* 143845 */     // GIR_Coverage, 4906,
     /* 143845 */     GIR_EraseRootFromParent_Done,
     /* 143846 */   // Label 3092: @143846
     /* 143846 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(143869), // Rule ID 4903 //
     /* 143851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143862 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 143862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 143867 */     GIR_RootConstrainSelectedInstOperands,
     /* 143868 */     // GIR_Coverage, 4903,
     /* 143868 */     GIR_Done,
     /* 143869 */   // Label 3093: @143869
     /* 143869 */   GIM_Reject,
     /* 143870 */ // Label 3090: @143870
     /* 143870 */ GIM_Reject,
     /* 143871 */ // Label 3055: @143871
     /* 143871 */ GIM_Reject,
     /* 143872 */ // Label 38: @143872
     /* 143872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3100*/ GIMT_Encode4(145557),
     /* 143883 */ /*GILLT_v8s16*//*Label 3094*/ GIMT_Encode4(143931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143899 */ /*GILLT_v16s8*//*Label 3095*/ GIMT_Encode4(144273),
     /* 143903 */ /*GILLT_v16s16*//*Label 3096*/ GIMT_Encode4(144615), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143915 */ /*GILLT_v32s8*//*Label 3097*/ GIMT_Encode4(144930),
     /* 143919 */ /*GILLT_v32s16*//*Label 3098*/ GIMT_Encode4(145245), GIMT_Encode4(0),
     /* 143927 */ /*GILLT_v64s8*//*Label 3099*/ GIMT_Encode4(145401),
     /* 143931 */ // Label 3094: @143931
     /* 143931 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(144272),
     /* 143936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 143939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143942 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(144004), // Rule ID 23444 //
     /* 143947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143986 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143993 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144002 */     GIR_RootConstrainSelectedInstOperands,
     /* 144003 */     // GIR_Coverage, 23444,
     /* 144003 */     GIR_EraseRootFromParent_Done,
     /* 144004 */   // Label 3102: @144004
     /* 144004 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(144066), // Rule ID 23756 //
     /* 144009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144048 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 144051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144064 */     GIR_RootConstrainSelectedInstOperands,
     /* 144065 */     // GIR_Coverage, 23756,
     /* 144065 */     GIR_EraseRootFromParent_Done,
     /* 144066 */   // Label 3103: @144066
     /* 144066 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(144128), // Rule ID 2553 //
     /* 144071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144110 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 144113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144126 */     GIR_RootConstrainSelectedInstOperands,
     /* 144127 */     // GIR_Coverage, 2553,
     /* 144127 */     GIR_EraseRootFromParent_Done,
     /* 144128 */   // Label 3104: @144128
     /* 144128 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(144190), // Rule ID 4828 //
     /* 144133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144172 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 144175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144188 */     GIR_RootConstrainSelectedInstOperands,
     /* 144189 */     // GIR_Coverage, 4828,
     /* 144189 */     GIR_EraseRootFromParent_Done,
     /* 144190 */   // Label 3105: @144190
     /* 144190 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(144217), // Rule ID 2552 //
     /* 144195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144210 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 144215 */     GIR_RootConstrainSelectedInstOperands,
     /* 144216 */     // GIR_Coverage, 2552,
     /* 144216 */     GIR_Done,
     /* 144217 */   // Label 3106: @144217
     /* 144217 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(144244), // Rule ID 2554 //
     /* 144222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144237 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 144242 */     GIR_RootConstrainSelectedInstOperands,
     /* 144243 */     // GIR_Coverage, 2554,
     /* 144243 */     GIR_Done,
     /* 144244 */   // Label 3107: @144244
     /* 144244 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(144271), // Rule ID 4825 //
     /* 144249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144264 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 144264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 144269 */     GIR_RootConstrainSelectedInstOperands,
     /* 144270 */     // GIR_Coverage, 4825,
     /* 144270 */     GIR_Done,
     /* 144271 */   // Label 3108: @144271
     /* 144271 */   GIM_Reject,
     /* 144272 */ // Label 3101: @144272
     /* 144272 */ GIM_Reject,
     /* 144273 */ // Label 3095: @144273
     /* 144273 */ GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(144614),
     /* 144278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 144281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144284 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(144346), // Rule ID 23441 //
     /* 144289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144328 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144344 */     GIR_RootConstrainSelectedInstOperands,
     /* 144345 */     // GIR_Coverage, 23441,
     /* 144345 */     GIR_EraseRootFromParent_Done,
     /* 144346 */   // Label 3110: @144346
     /* 144346 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(144408), // Rule ID 23765 //
     /* 144351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144390 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144406 */     GIR_RootConstrainSelectedInstOperands,
     /* 144407 */     // GIR_Coverage, 23765,
     /* 144407 */     GIR_EraseRootFromParent_Done,
     /* 144408 */   // Label 3111: @144408
     /* 144408 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(144470), // Rule ID 2547 //
     /* 144413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144452 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144468 */     GIR_RootConstrainSelectedInstOperands,
     /* 144469 */     // GIR_Coverage, 2547,
     /* 144469 */     GIR_EraseRootFromParent_Done,
     /* 144470 */   // Label 3112: @144470
     /* 144470 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(144532), // Rule ID 4846 //
     /* 144475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144514 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144530 */     GIR_RootConstrainSelectedInstOperands,
     /* 144531 */     // GIR_Coverage, 4846,
     /* 144531 */     GIR_EraseRootFromParent_Done,
     /* 144532 */   // Label 3113: @144532
     /* 144532 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(144559), // Rule ID 2546 //
     /* 144537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144552 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 144557 */     GIR_RootConstrainSelectedInstOperands,
     /* 144558 */     // GIR_Coverage, 2546,
     /* 144558 */     GIR_Done,
     /* 144559 */   // Label 3114: @144559
     /* 144559 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(144586), // Rule ID 2548 //
     /* 144564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144579 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 144584 */     GIR_RootConstrainSelectedInstOperands,
     /* 144585 */     // GIR_Coverage, 2548,
     /* 144585 */     GIR_Done,
     /* 144586 */   // Label 3115: @144586
     /* 144586 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(144613), // Rule ID 4843 //
     /* 144591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144606 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 144606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 144611 */     GIR_RootConstrainSelectedInstOperands,
     /* 144612 */     // GIR_Coverage, 4843,
     /* 144612 */     GIR_Done,
     /* 144613 */   // Label 3116: @144613
     /* 144613 */   GIM_Reject,
     /* 144614 */ // Label 3109: @144614
     /* 144614 */ GIM_Reject,
     /* 144615 */ // Label 3096: @144615
     /* 144615 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(144929),
     /* 144620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 144623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 144626 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(144688), // Rule ID 23446 //
     /* 144631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144670 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144686 */     GIR_RootConstrainSelectedInstOperands,
     /* 144687 */     // GIR_Coverage, 23446,
     /* 144687 */     GIR_EraseRootFromParent_Done,
     /* 144688 */   // Label 3118: @144688
     /* 144688 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(144750), // Rule ID 23753 //
     /* 144693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144732 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144748 */     GIR_RootConstrainSelectedInstOperands,
     /* 144749 */     // GIR_Coverage, 23753,
     /* 144749 */     GIR_EraseRootFromParent_Done,
     /* 144750 */   // Label 3119: @144750
     /* 144750 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(144812), // Rule ID 2557 //
     /* 144755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144794 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144810 */     GIR_RootConstrainSelectedInstOperands,
     /* 144811 */     // GIR_Coverage, 2557,
     /* 144811 */     GIR_EraseRootFromParent_Done,
     /* 144812 */   // Label 3120: @144812
     /* 144812 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(144874), // Rule ID 4822 //
     /* 144817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144856 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144872 */     GIR_RootConstrainSelectedInstOperands,
     /* 144873 */     // GIR_Coverage, 4822,
     /* 144873 */     GIR_EraseRootFromParent_Done,
     /* 144874 */   // Label 3121: @144874
     /* 144874 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(144901), // Rule ID 2556 //
     /* 144879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144894 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 144894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 144899 */     GIR_RootConstrainSelectedInstOperands,
     /* 144900 */     // GIR_Coverage, 2556,
     /* 144900 */     GIR_Done,
     /* 144901 */   // Label 3122: @144901
     /* 144901 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(144928), // Rule ID 4819 //
     /* 144906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144921 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 144921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 144926 */     GIR_RootConstrainSelectedInstOperands,
     /* 144927 */     // GIR_Coverage, 4819,
     /* 144927 */     GIR_Done,
     /* 144928 */   // Label 3123: @144928
     /* 144928 */   GIM_Reject,
     /* 144929 */ // Label 3117: @144929
     /* 144929 */ GIM_Reject,
     /* 144930 */ // Label 3097: @144930
     /* 144930 */ GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(145244),
     /* 144935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 144938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 144941 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(145003), // Rule ID 23443 //
     /* 144946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144961 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144964 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144968 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144985 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145001 */     GIR_RootConstrainSelectedInstOperands,
     /* 145002 */     // GIR_Coverage, 23443,
     /* 145002 */     GIR_EraseRootFromParent_Done,
     /* 145003 */   // Label 3125: @145003
     /* 145003 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(145065), // Rule ID 23762 //
     /* 145008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145047 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 145050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145063 */     GIR_RootConstrainSelectedInstOperands,
     /* 145064 */     // GIR_Coverage, 23762,
     /* 145064 */     GIR_EraseRootFromParent_Done,
     /* 145065 */   // Label 3126: @145065
     /* 145065 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(145127), // Rule ID 2551 //
     /* 145070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145109 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 145112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145114 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145125 */     GIR_RootConstrainSelectedInstOperands,
     /* 145126 */     // GIR_Coverage, 2551,
     /* 145126 */     GIR_EraseRootFromParent_Done,
     /* 145127 */   // Label 3127: @145127
     /* 145127 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(145189), // Rule ID 4840 //
     /* 145132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145171 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 145174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145187 */     GIR_RootConstrainSelectedInstOperands,
     /* 145188 */     // GIR_Coverage, 4840,
     /* 145188 */     GIR_EraseRootFromParent_Done,
     /* 145189 */   // Label 3128: @145189
     /* 145189 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(145216), // Rule ID 2550 //
     /* 145194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145209 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 145209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 145214 */     GIR_RootConstrainSelectedInstOperands,
     /* 145215 */     // GIR_Coverage, 2550,
     /* 145215 */     GIR_Done,
     /* 145216 */   // Label 3129: @145216
     /* 145216 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(145243), // Rule ID 4837 //
     /* 145221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145236 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 145236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 145241 */     GIR_RootConstrainSelectedInstOperands,
     /* 145242 */     // GIR_Coverage, 4837,
     /* 145242 */     GIR_Done,
     /* 145243 */   // Label 3130: @145243
     /* 145243 */   GIM_Reject,
     /* 145244 */ // Label 3124: @145244
     /* 145244 */ GIM_Reject,
     /* 145245 */ // Label 3098: @145245
     /* 145245 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(145400),
     /* 145250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 145253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 145256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145260 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(145318), // Rule ID 23750 //
     /* 145265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145300 */     // (saddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145316 */     GIR_RootConstrainSelectedInstOperands,
     /* 145317 */     // GIR_Coverage, 23750,
     /* 145317 */     GIR_EraseRootFromParent_Done,
     /* 145318 */   // Label 3132: @145318
     /* 145318 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(145376), // Rule ID 4816 //
     /* 145323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145358 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145374 */     GIR_RootConstrainSelectedInstOperands,
     /* 145375 */     // GIR_Coverage, 4816,
     /* 145375 */     GIR_EraseRootFromParent_Done,
     /* 145376 */   // Label 3133: @145376
     /* 145376 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(145399), // Rule ID 4813 //
     /* 145381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145392 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 145392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 145397 */     GIR_RootConstrainSelectedInstOperands,
     /* 145398 */     // GIR_Coverage, 4813,
     /* 145398 */     GIR_Done,
     /* 145399 */   // Label 3134: @145399
     /* 145399 */   GIM_Reject,
     /* 145400 */ // Label 3131: @145400
     /* 145400 */ GIM_Reject,
     /* 145401 */ // Label 3099: @145401
     /* 145401 */ GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(145556),
     /* 145406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 145409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 145412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145416 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(145474), // Rule ID 23759 //
     /* 145421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145456 */     // (saddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145472 */     GIR_RootConstrainSelectedInstOperands,
     /* 145473 */     // GIR_Coverage, 23759,
     /* 145473 */     GIR_EraseRootFromParent_Done,
     /* 145474 */   // Label 3136: @145474
     /* 145474 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(145532), // Rule ID 4834 //
     /* 145479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145514 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145530 */     GIR_RootConstrainSelectedInstOperands,
     /* 145531 */     // GIR_Coverage, 4834,
     /* 145531 */     GIR_EraseRootFromParent_Done,
     /* 145532 */   // Label 3137: @145532
     /* 145532 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(145555), // Rule ID 4831 //
     /* 145537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145548 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 145548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 145553 */     GIR_RootConstrainSelectedInstOperands,
     /* 145554 */     // GIR_Coverage, 4831,
     /* 145554 */     GIR_Done,
     /* 145555 */   // Label 3138: @145555
     /* 145555 */   GIM_Reject,
     /* 145556 */ // Label 3135: @145556
     /* 145556 */ GIM_Reject,
     /* 145557 */ // Label 3100: @145557
     /* 145557 */ GIM_Reject,
     /* 145558 */ // Label 39: @145558
     /* 145558 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3145*/ GIMT_Encode4(146623),
     /* 145569 */ /*GILLT_v8s16*//*Label 3139*/ GIMT_Encode4(145617), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145585 */ /*GILLT_v16s8*//*Label 3140*/ GIMT_Encode4(145835),
     /* 145589 */ /*GILLT_v16s16*//*Label 3141*/ GIMT_Encode4(146053), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145601 */ /*GILLT_v32s8*//*Label 3142*/ GIMT_Encode4(146244),
     /* 145605 */ /*GILLT_v32s16*//*Label 3143*/ GIMT_Encode4(146435), GIMT_Encode4(0),
     /* 145613 */ /*GILLT_v64s8*//*Label 3144*/ GIMT_Encode4(146529),
     /* 145617 */ // Label 3139: @145617
     /* 145617 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(145834),
     /* 145622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145628 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(145690), // Rule ID 2631 //
     /* 145633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145672 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrm),
     /* 145675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145688 */     GIR_RootConstrainSelectedInstOperands,
     /* 145689 */     // GIR_Coverage, 2631,
     /* 145689 */     GIR_EraseRootFromParent_Done,
     /* 145690 */   // Label 3147: @145690
     /* 145690 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(145752), // Rule ID 4936 //
     /* 145695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145734 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rm),
     /* 145737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145750 */     GIR_RootConstrainSelectedInstOperands,
     /* 145751 */     // GIR_Coverage, 4936,
     /* 145751 */     GIR_EraseRootFromParent_Done,
     /* 145752 */   // Label 3148: @145752
     /* 145752 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(145779), // Rule ID 2630 //
     /* 145757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145772 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 145777 */     GIR_RootConstrainSelectedInstOperands,
     /* 145778 */     // GIR_Coverage, 2630,
     /* 145778 */     GIR_Done,
     /* 145779 */   // Label 3149: @145779
     /* 145779 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(145806), // Rule ID 2632 //
     /* 145784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145799 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 145804 */     GIR_RootConstrainSelectedInstOperands,
     /* 145805 */     // GIR_Coverage, 2632,
     /* 145805 */     GIR_Done,
     /* 145806 */   // Label 3150: @145806
     /* 145806 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(145833), // Rule ID 4933 //
     /* 145811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145826 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 145826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 145831 */     GIR_RootConstrainSelectedInstOperands,
     /* 145832 */     // GIR_Coverage, 4933,
     /* 145832 */     GIR_Done,
     /* 145833 */   // Label 3151: @145833
     /* 145833 */   GIM_Reject,
     /* 145834 */ // Label 3146: @145834
     /* 145834 */ GIM_Reject,
     /* 145835 */ // Label 3140: @145835
     /* 145835 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(146052),
     /* 145840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 145843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145846 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(145908), // Rule ID 2625 //
     /* 145851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145890 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrm),
     /* 145893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145906 */     GIR_RootConstrainSelectedInstOperands,
     /* 145907 */     // GIR_Coverage, 2625,
     /* 145907 */     GIR_EraseRootFromParent_Done,
     /* 145908 */   // Label 3153: @145908
     /* 145908 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(145970), // Rule ID 4954 //
     /* 145913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145952 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rm),
     /* 145955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145968 */     GIR_RootConstrainSelectedInstOperands,
     /* 145969 */     // GIR_Coverage, 4954,
     /* 145969 */     GIR_EraseRootFromParent_Done,
     /* 145970 */   // Label 3154: @145970
     /* 145970 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(145997), // Rule ID 2624 //
     /* 145975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145990 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 145995 */     GIR_RootConstrainSelectedInstOperands,
     /* 145996 */     // GIR_Coverage, 2624,
     /* 145996 */     GIR_Done,
     /* 145997 */   // Label 3155: @145997
     /* 145997 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(146024), // Rule ID 2626 //
     /* 146002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146017 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 146022 */     GIR_RootConstrainSelectedInstOperands,
     /* 146023 */     // GIR_Coverage, 2626,
     /* 146023 */     GIR_Done,
     /* 146024 */   // Label 3156: @146024
     /* 146024 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(146051), // Rule ID 4951 //
     /* 146029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146044 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 146044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 146049 */     GIR_RootConstrainSelectedInstOperands,
     /* 146050 */     // GIR_Coverage, 4951,
     /* 146050 */     GIR_Done,
     /* 146051 */   // Label 3157: @146051
     /* 146051 */   GIM_Reject,
     /* 146052 */ // Label 3152: @146052
     /* 146052 */ GIM_Reject,
     /* 146053 */ // Label 3141: @146053
     /* 146053 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(146243),
     /* 146058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 146061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 146064 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(146126), // Rule ID 2635 //
     /* 146069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146108 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrm),
     /* 146111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146124 */     GIR_RootConstrainSelectedInstOperands,
     /* 146125 */     // GIR_Coverage, 2635,
     /* 146125 */     GIR_EraseRootFromParent_Done,
     /* 146126 */   // Label 3159: @146126
     /* 146126 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(146188), // Rule ID 4930 //
     /* 146131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146170 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rm),
     /* 146173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146186 */     GIR_RootConstrainSelectedInstOperands,
     /* 146187 */     // GIR_Coverage, 4930,
     /* 146187 */     GIR_EraseRootFromParent_Done,
     /* 146188 */   // Label 3160: @146188
     /* 146188 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(146215), // Rule ID 2634 //
     /* 146193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146208 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 146208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 146213 */     GIR_RootConstrainSelectedInstOperands,
     /* 146214 */     // GIR_Coverage, 2634,
     /* 146214 */     GIR_Done,
     /* 146215 */   // Label 3161: @146215
     /* 146215 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(146242), // Rule ID 4927 //
     /* 146220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146235 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 146235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 146240 */     GIR_RootConstrainSelectedInstOperands,
     /* 146241 */     // GIR_Coverage, 4927,
     /* 146241 */     GIR_Done,
     /* 146242 */   // Label 3162: @146242
     /* 146242 */   GIM_Reject,
     /* 146243 */ // Label 3158: @146243
     /* 146243 */ GIM_Reject,
     /* 146244 */ // Label 3142: @146244
     /* 146244 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(146434),
     /* 146249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 146252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 146255 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(146317), // Rule ID 2629 //
     /* 146260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146279 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146286 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146299 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrm),
     /* 146302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146304 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146315 */     GIR_RootConstrainSelectedInstOperands,
     /* 146316 */     // GIR_Coverage, 2629,
     /* 146316 */     GIR_EraseRootFromParent_Done,
     /* 146317 */   // Label 3164: @146317
     /* 146317 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(146379), // Rule ID 4948 //
     /* 146322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146341 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146348 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146361 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rm),
     /* 146364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146377 */     GIR_RootConstrainSelectedInstOperands,
     /* 146378 */     // GIR_Coverage, 4948,
     /* 146378 */     GIR_EraseRootFromParent_Done,
     /* 146379 */   // Label 3165: @146379
     /* 146379 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(146406), // Rule ID 2628 //
     /* 146384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146399 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 146399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 146404 */     GIR_RootConstrainSelectedInstOperands,
     /* 146405 */     // GIR_Coverage, 2628,
     /* 146405 */     GIR_Done,
     /* 146406 */   // Label 3166: @146406
     /* 146406 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(146433), // Rule ID 4945 //
     /* 146411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146426 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 146426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 146431 */     GIR_RootConstrainSelectedInstOperands,
     /* 146432 */     // GIR_Coverage, 4945,
     /* 146432 */     GIR_Done,
     /* 146433 */   // Label 3167: @146433
     /* 146433 */   GIM_Reject,
     /* 146434 */ // Label 3163: @146434
     /* 146434 */ GIM_Reject,
     /* 146435 */ // Label 3143: @146435
     /* 146435 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(146528),
     /* 146440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 146443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 146446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146454 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(146508), // Rule ID 4924 //
     /* 146459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146490 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrm),
     /* 146493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146506 */     GIR_RootConstrainSelectedInstOperands,
     /* 146507 */     // GIR_Coverage, 4924,
     /* 146507 */     GIR_EraseRootFromParent_Done,
     /* 146508 */   // Label 3169: @146508
     /* 146508 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(146527), // Rule ID 4921 //
     /* 146513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146520 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 146520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 146525 */     GIR_RootConstrainSelectedInstOperands,
     /* 146526 */     // GIR_Coverage, 4921,
     /* 146526 */     GIR_Done,
     /* 146527 */   // Label 3170: @146527
     /* 146527 */   GIM_Reject,
     /* 146528 */ // Label 3168: @146528
     /* 146528 */ GIM_Reject,
     /* 146529 */ // Label 3144: @146529
     /* 146529 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(146622),
     /* 146534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 146537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 146540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146548 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(146602), // Rule ID 4942 //
     /* 146553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146584 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrm),
     /* 146587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146600 */     GIR_RootConstrainSelectedInstOperands,
     /* 146601 */     // GIR_Coverage, 4942,
     /* 146601 */     GIR_EraseRootFromParent_Done,
     /* 146602 */   // Label 3172: @146602
     /* 146602 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(146621), // Rule ID 4939 //
     /* 146607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146614 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 146614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 146619 */     GIR_RootConstrainSelectedInstOperands,
     /* 146620 */     // GIR_Coverage, 4939,
     /* 146620 */     GIR_Done,
     /* 146621 */   // Label 3173: @146621
     /* 146621 */   GIM_Reject,
     /* 146622 */ // Label 3171: @146622
     /* 146622 */ GIM_Reject,
     /* 146623 */ // Label 3145: @146623
     /* 146623 */ GIM_Reject,
     /* 146624 */ // Label 40: @146624
     /* 146624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3180*/ GIMT_Encode4(147689),
     /* 146635 */ /*GILLT_v8s16*//*Label 3174*/ GIMT_Encode4(146683), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146651 */ /*GILLT_v16s8*//*Label 3175*/ GIMT_Encode4(146901),
     /* 146655 */ /*GILLT_v16s16*//*Label 3176*/ GIMT_Encode4(147119), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146667 */ /*GILLT_v32s8*//*Label 3177*/ GIMT_Encode4(147310),
     /* 146671 */ /*GILLT_v32s16*//*Label 3178*/ GIMT_Encode4(147501), GIMT_Encode4(0),
     /* 146679 */ /*GILLT_v64s8*//*Label 3179*/ GIMT_Encode4(147595),
     /* 146683 */ // Label 3174: @146683
     /* 146683 */ GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(146900),
     /* 146688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146694 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(146756), // Rule ID 2619 //
     /* 146699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146738 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrm),
     /* 146741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146754 */     GIR_RootConstrainSelectedInstOperands,
     /* 146755 */     // GIR_Coverage, 2619,
     /* 146755 */     GIR_EraseRootFromParent_Done,
     /* 146756 */   // Label 3182: @146756
     /* 146756 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(146818), // Rule ID 4864 //
     /* 146761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146800 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rm),
     /* 146803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146805 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146816 */     GIR_RootConstrainSelectedInstOperands,
     /* 146817 */     // GIR_Coverage, 4864,
     /* 146817 */     GIR_EraseRootFromParent_Done,
     /* 146818 */   // Label 3183: @146818
     /* 146818 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(146845), // Rule ID 2618 //
     /* 146823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146838 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 146843 */     GIR_RootConstrainSelectedInstOperands,
     /* 146844 */     // GIR_Coverage, 2618,
     /* 146844 */     GIR_Done,
     /* 146845 */   // Label 3184: @146845
     /* 146845 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(146872), // Rule ID 2620 //
     /* 146850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146865 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 146870 */     GIR_RootConstrainSelectedInstOperands,
     /* 146871 */     // GIR_Coverage, 2620,
     /* 146871 */     GIR_Done,
     /* 146872 */   // Label 3185: @146872
     /* 146872 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(146899), // Rule ID 4861 //
     /* 146877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146892 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 146892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 146897 */     GIR_RootConstrainSelectedInstOperands,
     /* 146898 */     // GIR_Coverage, 4861,
     /* 146898 */     GIR_Done,
     /* 146899 */   // Label 3186: @146899
     /* 146899 */   GIM_Reject,
     /* 146900 */ // Label 3181: @146900
     /* 146900 */ GIM_Reject,
     /* 146901 */ // Label 3175: @146901
     /* 146901 */ GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(147118),
     /* 146906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 146909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146912 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(146974), // Rule ID 2613 //
     /* 146917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146956 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrm),
     /* 146959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146972 */     GIR_RootConstrainSelectedInstOperands,
     /* 146973 */     // GIR_Coverage, 2613,
     /* 146973 */     GIR_EraseRootFromParent_Done,
     /* 146974 */   // Label 3188: @146974
     /* 146974 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(147036), // Rule ID 4882 //
     /* 146979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146998 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147018 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rm),
     /* 147021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147034 */     GIR_RootConstrainSelectedInstOperands,
     /* 147035 */     // GIR_Coverage, 4882,
     /* 147035 */     GIR_EraseRootFromParent_Done,
     /* 147036 */   // Label 3189: @147036
     /* 147036 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(147063), // Rule ID 2612 //
     /* 147041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 147044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147056 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 147056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 147061 */     GIR_RootConstrainSelectedInstOperands,
     /* 147062 */     // GIR_Coverage, 2612,
     /* 147062 */     GIR_Done,
     /* 147063 */   // Label 3190: @147063
     /* 147063 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(147090), // Rule ID 2614 //
     /* 147068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 147071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147083 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 147083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 147088 */     GIR_RootConstrainSelectedInstOperands,
     /* 147089 */     // GIR_Coverage, 2614,
     /* 147089 */     GIR_Done,
     /* 147090 */   // Label 3191: @147090
     /* 147090 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(147117), // Rule ID 4879 //
     /* 147095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147110 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 147110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 147115 */     GIR_RootConstrainSelectedInstOperands,
     /* 147116 */     // GIR_Coverage, 4879,
     /* 147116 */     GIR_Done,
     /* 147117 */   // Label 3192: @147117
     /* 147117 */   GIM_Reject,
     /* 147118 */ // Label 3187: @147118
     /* 147118 */ GIM_Reject,
     /* 147119 */ // Label 3176: @147119
     /* 147119 */ GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(147309),
     /* 147124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 147127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 147130 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(147192), // Rule ID 2623 //
     /* 147135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147174 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrm),
     /* 147177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147190 */     GIR_RootConstrainSelectedInstOperands,
     /* 147191 */     // GIR_Coverage, 2623,
     /* 147191 */     GIR_EraseRootFromParent_Done,
     /* 147192 */   // Label 3194: @147192
     /* 147192 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(147254), // Rule ID 4858 //
     /* 147197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147236 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rm),
     /* 147239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147252 */     GIR_RootConstrainSelectedInstOperands,
     /* 147253 */     // GIR_Coverage, 4858,
     /* 147253 */     GIR_EraseRootFromParent_Done,
     /* 147254 */   // Label 3195: @147254
     /* 147254 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(147281), // Rule ID 2622 //
     /* 147259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147274 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 147274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 147279 */     GIR_RootConstrainSelectedInstOperands,
     /* 147280 */     // GIR_Coverage, 2622,
     /* 147280 */     GIR_Done,
     /* 147281 */   // Label 3196: @147281
     /* 147281 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(147308), // Rule ID 4855 //
     /* 147286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147301 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 147301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 147306 */     GIR_RootConstrainSelectedInstOperands,
     /* 147307 */     // GIR_Coverage, 4855,
     /* 147307 */     GIR_Done,
     /* 147308 */   // Label 3197: @147308
     /* 147308 */   GIM_Reject,
     /* 147309 */ // Label 3193: @147309
     /* 147309 */ GIM_Reject,
     /* 147310 */ // Label 3177: @147310
     /* 147310 */ GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(147500),
     /* 147315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 147318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 147321 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(147383), // Rule ID 2617 //
     /* 147326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147365 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrm),
     /* 147368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147381 */     GIR_RootConstrainSelectedInstOperands,
     /* 147382 */     // GIR_Coverage, 2617,
     /* 147382 */     GIR_EraseRootFromParent_Done,
     /* 147383 */   // Label 3199: @147383
     /* 147383 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(147445), // Rule ID 4876 //
     /* 147388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147407 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147427 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rm),
     /* 147430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147443 */     GIR_RootConstrainSelectedInstOperands,
     /* 147444 */     // GIR_Coverage, 4876,
     /* 147444 */     GIR_EraseRootFromParent_Done,
     /* 147445 */   // Label 3200: @147445
     /* 147445 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(147472), // Rule ID 2616 //
     /* 147450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147465 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 147465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 147470 */     GIR_RootConstrainSelectedInstOperands,
     /* 147471 */     // GIR_Coverage, 2616,
     /* 147471 */     GIR_Done,
     /* 147472 */   // Label 3201: @147472
     /* 147472 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(147499), // Rule ID 4873 //
     /* 147477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147492 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 147492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 147497 */     GIR_RootConstrainSelectedInstOperands,
     /* 147498 */     // GIR_Coverage, 4873,
     /* 147498 */     GIR_Done,
     /* 147499 */   // Label 3202: @147499
     /* 147499 */   GIM_Reject,
     /* 147500 */ // Label 3198: @147500
     /* 147500 */ GIM_Reject,
     /* 147501 */ // Label 3178: @147501
     /* 147501 */ GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(147594),
     /* 147506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 147509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 147512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147520 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(147574), // Rule ID 4852 //
     /* 147525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147556 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrm),
     /* 147559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147572 */     GIR_RootConstrainSelectedInstOperands,
     /* 147573 */     // GIR_Coverage, 4852,
     /* 147573 */     GIR_EraseRootFromParent_Done,
     /* 147574 */   // Label 3204: @147574
     /* 147574 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(147593), // Rule ID 4849 //
     /* 147579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147586 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 147586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 147591 */     GIR_RootConstrainSelectedInstOperands,
     /* 147592 */     // GIR_Coverage, 4849,
     /* 147592 */     GIR_Done,
     /* 147593 */   // Label 3205: @147593
     /* 147593 */   GIM_Reject,
     /* 147594 */ // Label 3203: @147594
     /* 147594 */ GIM_Reject,
     /* 147595 */ // Label 3179: @147595
     /* 147595 */ GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(147688),
     /* 147600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 147603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 147606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147614 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(147668), // Rule ID 4870 //
     /* 147619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147650 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrm),
     /* 147653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147666 */     GIR_RootConstrainSelectedInstOperands,
     /* 147667 */     // GIR_Coverage, 4870,
     /* 147667 */     GIR_EraseRootFromParent_Done,
     /* 147668 */   // Label 3207: @147668
     /* 147668 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(147687), // Rule ID 4867 //
     /* 147673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147680 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 147680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 147685 */     GIR_RootConstrainSelectedInstOperands,
     /* 147686 */     // GIR_Coverage, 4867,
     /* 147686 */     GIR_Done,
     /* 147687 */   // Label 3208: @147687
     /* 147687 */   GIM_Reject,
     /* 147688 */ // Label 3206: @147688
     /* 147688 */ GIM_Reject,
     /* 147689 */ // Label 3180: @147689
     /* 147689 */ GIM_Reject,
     /* 147690 */ // Label 41: @147690
     /* 147690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3222*/ GIMT_Encode4(153603),
     /* 147701 */ /*GILLT_s16*//*Label 3209*/ GIMT_Encode4(147785),
     /* 147705 */ /*GILLT_s32*//*Label 3210*/ GIMT_Encode4(147945),
     /* 147709 */ /*GILLT_s64*//*Label 3211*/ GIMT_Encode4(149342),
     /* 147713 */ /*GILLT_s80*//*Label 3212*/ GIMT_Encode4(150883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147725 */ /*GILLT_v2s64*//*Label 3213*/ GIMT_Encode4(151449), GIMT_Encode4(0),
     /* 147733 */ /*GILLT_v4s32*//*Label 3214*/ GIMT_Encode4(151803),
     /* 147737 */ /*GILLT_v4s64*//*Label 3215*/ GIMT_Encode4(152157), GIMT_Encode4(0),
     /* 147745 */ /*GILLT_v8s16*//*Label 3216*/ GIMT_Encode4(152480),
     /* 147749 */ /*GILLT_v8s32*//*Label 3217*/ GIMT_Encode4(152640),
     /* 147753 */ /*GILLT_v8s64*//*Label 3218*/ GIMT_Encode4(152963), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147765 */ /*GILLT_v16s16*//*Label 3219*/ GIMT_Encode4(153123),
     /* 147769 */ /*GILLT_v16s32*//*Label 3220*/ GIMT_Encode4(153283), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147781 */ /*GILLT_v32s16*//*Label 3221*/ GIMT_Encode4(153443),
     /* 147785 */ // Label 3209: @147785
     /* 147785 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(147944),
     /* 147790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 147793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147800 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(147858), // Rule ID 24250 //
     /* 147805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147840 */     // (fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147856 */     GIR_RootConstrainSelectedInstOperands,
     /* 147857 */     // GIR_Coverage, 24250,
     /* 147857 */     GIR_EraseRootFromParent_Done,
     /* 147858 */   // Label 3224: @147858
     /* 147858 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(147916), // Rule ID 5955 //
     /* 147863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147878 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147881 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147898 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147914 */     GIR_RootConstrainSelectedInstOperands,
     /* 147915 */     // GIR_Coverage, 5955,
     /* 147915 */     GIR_EraseRootFromParent_Done,
     /* 147916 */   // Label 3225: @147916
     /* 147916 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(147943), // Rule ID 5953 //
     /* 147921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147932 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 147932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 147937 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 147941 */     GIR_RootConstrainSelectedInstOperands,
     /* 147942 */     // GIR_Coverage, 5953,
     /* 147942 */     GIR_Done,
     /* 147943 */   // Label 3226: @147943
     /* 147943 */   GIM_Reject,
     /* 147944 */ // Label 3223: @147944
     /* 147944 */ GIM_Reject,
     /* 147945 */ // Label 3210: @147945
     /* 147945 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(149341),
     /* 147950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 147953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147956 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(148038), // Rule ID 26018 //
     /* 147961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147988 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 147995 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148019 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148036 */     GIR_RootConstrainSelectedInstOperands,
     /* 148037 */     // GIR_Coverage, 26018,
     /* 148037 */     GIR_EraseRootFromParent_Done,
     /* 148038 */   // Label 3228: @148038
     /* 148038 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(148120), // Rule ID 26019 //
     /* 148043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148070 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148077 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148084 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148101 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148118 */     GIR_RootConstrainSelectedInstOperands,
     /* 148119 */     // GIR_Coverage, 26019,
     /* 148119 */     GIR_EraseRootFromParent_Done,
     /* 148120 */   // Label 3229: @148120
     /* 148120 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(148202), // Rule ID 26020 //
     /* 148125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148152 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148159 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148166 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148183 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148200 */     GIR_RootConstrainSelectedInstOperands,
     /* 148201 */     // GIR_Coverage, 26020,
     /* 148201 */     GIR_EraseRootFromParent_Done,
     /* 148202 */   // Label 3230: @148202
     /* 148202 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(148284), // Rule ID 22467 //
     /* 148207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148238 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148245 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148252 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148265 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148282 */     GIR_RootConstrainSelectedInstOperands,
     /* 148283 */     // GIR_Coverage, 22467,
     /* 148283 */     GIR_EraseRootFromParent_Done,
     /* 148284 */   // Label 3231: @148284
     /* 148284 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(148366), // Rule ID 22468 //
     /* 148289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148320 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148327 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148334 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148347 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148364 */     GIR_RootConstrainSelectedInstOperands,
     /* 148365 */     // GIR_Coverage, 22468,
     /* 148365 */     GIR_EraseRootFromParent_Done,
     /* 148366 */   // Label 3232: @148366
     /* 148366 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(148448), // Rule ID 22469 //
     /* 148371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148402 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148409 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148416 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148429 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148446 */     GIR_RootConstrainSelectedInstOperands,
     /* 148447 */     // GIR_Coverage, 22469,
     /* 148447 */     GIR_EraseRootFromParent_Done,
     /* 148448 */   // Label 3233: @148448
     /* 148448 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(148513), // Rule ID 23247 //
     /* 148453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148468 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148492 */     // (fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 148495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148511 */     GIR_RootConstrainSelectedInstOperands,
     /* 148512 */     // GIR_Coverage, 23247,
     /* 148512 */     GIR_EraseRootFromParent_Done,
     /* 148513 */   // Label 3234: @148513
     /* 148513 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(148578), // Rule ID 23249 //
     /* 148518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148533 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148557 */     // (fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 148560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148562 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148576 */     GIR_RootConstrainSelectedInstOperands,
     /* 148577 */     // GIR_Coverage, 23249,
     /* 148577 */     GIR_EraseRootFromParent_Done,
     /* 148578 */   // Label 3235: @148578
     /* 148578 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(148643), // Rule ID 23237 //
     /* 148583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148598 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148605 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148622 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148627 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148641 */     GIR_RootConstrainSelectedInstOperands,
     /* 148642 */     // GIR_Coverage, 23237,
     /* 148642 */     GIR_EraseRootFromParent_Done,
     /* 148643 */   // Label 3236: @148643
     /* 148643 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(148705), // Rule ID 23382 //
     /* 148648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148687 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148692 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148703 */     GIR_RootConstrainSelectedInstOperands,
     /* 148704 */     // GIR_Coverage, 23382,
     /* 148704 */     GIR_EraseRootFromParent_Done,
     /* 148705 */   // Label 3237: @148705
     /* 148705 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(148767), // Rule ID 23386 //
     /* 148710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148725 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148728 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148732 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148749 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148756 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148765 */     GIR_RootConstrainSelectedInstOperands,
     /* 148766 */     // GIR_Coverage, 23386,
     /* 148766 */     GIR_EraseRootFromParent_Done,
     /* 148767 */   // Label 3238: @148767
     /* 148767 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(148829), // Rule ID 24246 //
     /* 148772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148811 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148827 */     GIR_RootConstrainSelectedInstOperands,
     /* 148828 */     // GIR_Coverage, 24246,
     /* 148828 */     GIR_EraseRootFromParent_Done,
     /* 148829 */   // Label 3239: @148829
     /* 148829 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(148894), // Rule ID 921 //
     /* 148834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148853 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148873 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 148876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148892 */     GIR_RootConstrainSelectedInstOperands,
     /* 148893 */     // GIR_Coverage, 921,
     /* 148893 */     GIR_EraseRootFromParent_Done,
     /* 148894 */   // Label 3240: @148894
     /* 148894 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(148959), // Rule ID 923 //
     /* 148899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148918 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148938 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 148941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148957 */     GIR_RootConstrainSelectedInstOperands,
     /* 148958 */     // GIR_Coverage, 923,
     /* 148958 */     GIR_EraseRootFromParent_Done,
     /* 148959 */   // Label 3241: @148959
     /* 148959 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(149024), // Rule ID 911 //
     /* 148964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149003 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 149006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149008 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149022 */     GIR_RootConstrainSelectedInstOperands,
     /* 149023 */     // GIR_Coverage, 911,
     /* 149023 */     GIR_EraseRootFromParent_Done,
     /* 149024 */   // Label 3242: @149024
     /* 149024 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(149086), // Rule ID 2161 //
     /* 149029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149068 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 149071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149084 */     GIR_RootConstrainSelectedInstOperands,
     /* 149085 */     // GIR_Coverage, 2161,
     /* 149085 */     GIR_EraseRootFromParent_Done,
     /* 149086 */   // Label 3243: @149086
     /* 149086 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(149148), // Rule ID 2169 //
     /* 149091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149130 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 149133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149135 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149137 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149146 */     GIR_RootConstrainSelectedInstOperands,
     /* 149147 */     // GIR_Coverage, 2169,
     /* 149147 */     GIR_EraseRootFromParent_Done,
     /* 149148 */   // Label 3244: @149148
     /* 149148 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(149210), // Rule ID 5917 //
     /* 149153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149192 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 149195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149208 */     GIR_RootConstrainSelectedInstOperands,
     /* 149209 */     // GIR_Coverage, 5917,
     /* 149209 */     GIR_EraseRootFromParent_Done,
     /* 149210 */   // Label 3245: @149210
     /* 149210 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(149247), // Rule ID 887 //
     /* 149215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 149218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149230 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 149230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 149235 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 149241 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 149245 */     GIR_RootConstrainSelectedInstOperands,
     /* 149246 */     // GIR_Coverage, 887,
     /* 149246 */     GIR_Done,
     /* 149247 */   // Label 3246: @149247
     /* 149247 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(149278), // Rule ID 2159 //
     /* 149252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149267 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 149267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 149272 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149276 */     GIR_RootConstrainSelectedInstOperands,
     /* 149277 */     // GIR_Coverage, 2159,
     /* 149277 */     GIR_Done,
     /* 149278 */   // Label 3247: @149278
     /* 149278 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(149309), // Rule ID 2167 //
     /* 149283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149298 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 149298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 149303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149307 */     GIR_RootConstrainSelectedInstOperands,
     /* 149308 */     // GIR_Coverage, 2167,
     /* 149308 */     GIR_Done,
     /* 149309 */   // Label 3248: @149309
     /* 149309 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(149340), // Rule ID 5915 //
     /* 149314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149329 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 149329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 149334 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149338 */     GIR_RootConstrainSelectedInstOperands,
     /* 149339 */     // GIR_Coverage, 5915,
     /* 149339 */     GIR_Done,
     /* 149340 */   // Label 3249: @149340
     /* 149340 */   GIM_Reject,
     /* 149341 */ // Label 3227: @149341
     /* 149341 */ GIM_Reject,
     /* 149342 */ // Label 3211: @149342
     /* 149342 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(150882),
     /* 149347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 149350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149353 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(149435), // Rule ID 26021 //
     /* 149358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149385 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149392 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149399 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149416 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149433 */     GIR_RootConstrainSelectedInstOperands,
     /* 149434 */     // GIR_Coverage, 26021,
     /* 149434 */     GIR_EraseRootFromParent_Done,
     /* 149435 */   // Label 3251: @149435
     /* 149435 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(149517), // Rule ID 26022 //
     /* 149440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149467 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149470 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149474 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149481 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149498 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149515 */     GIR_RootConstrainSelectedInstOperands,
     /* 149516 */     // GIR_Coverage, 26022,
     /* 149516 */     GIR_EraseRootFromParent_Done,
     /* 149517 */   // Label 3252: @149517
     /* 149517 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(149599), // Rule ID 26023 //
     /* 149522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149549 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149556 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149580 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149597 */     GIR_RootConstrainSelectedInstOperands,
     /* 149598 */     // GIR_Coverage, 26023,
     /* 149598 */     GIR_EraseRootFromParent_Done,
     /* 149599 */   // Label 3253: @149599
     /* 149599 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(149681), // Rule ID 22470 //
     /* 149604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149635 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149642 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149649 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149662 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149679 */     GIR_RootConstrainSelectedInstOperands,
     /* 149680 */     // GIR_Coverage, 22470,
     /* 149680 */     GIR_EraseRootFromParent_Done,
     /* 149681 */   // Label 3254: @149681
     /* 149681 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(149763), // Rule ID 22471 //
     /* 149686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149717 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149724 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149731 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149744 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149761 */     GIR_RootConstrainSelectedInstOperands,
     /* 149762 */     // GIR_Coverage, 22471,
     /* 149762 */     GIR_EraseRootFromParent_Done,
     /* 149763 */   // Label 3255: @149763
     /* 149763 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(149845), // Rule ID 22472 //
     /* 149768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149799 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149806 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149813 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149826 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149843 */     GIR_RootConstrainSelectedInstOperands,
     /* 149844 */     // GIR_Coverage, 22472,
     /* 149844 */     GIR_EraseRootFromParent_Done,
     /* 149845 */   // Label 3256: @149845
     /* 149845 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(149910), // Rule ID 23251 //
     /* 149850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 149865 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149889 */     // (fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 149892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149894 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149908 */     GIR_RootConstrainSelectedInstOperands,
     /* 149909 */     // GIR_Coverage, 23251,
     /* 149909 */     GIR_EraseRootFromParent_Done,
     /* 149910 */   // Label 3257: @149910
     /* 149910 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(149975), // Rule ID 23253 //
     /* 149915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 149930 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149954 */     // (fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 149957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149973 */     GIR_RootConstrainSelectedInstOperands,
     /* 149974 */     // GIR_Coverage, 23253,
     /* 149974 */     GIR_EraseRootFromParent_Done,
     /* 149975 */   // Label 3258: @149975
     /* 149975 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(150040), // Rule ID 23239 //
     /* 149980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150019 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 150022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150038 */     GIR_RootConstrainSelectedInstOperands,
     /* 150039 */     // GIR_Coverage, 23239,
     /* 150039 */     GIR_EraseRootFromParent_Done,
     /* 150040 */   // Label 3259: @150040
     /* 150040 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(150112), // Rule ID 23241 //
     /* 150045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150063 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150067 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150091 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 150094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150110 */     GIR_RootConstrainSelectedInstOperands,
     /* 150111 */     // GIR_Coverage, 23241,
     /* 150111 */     GIR_EraseRootFromParent_Done,
     /* 150112 */   // Label 3260: @150112
     /* 150112 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(150174), // Rule ID 23384 //
     /* 150117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150156 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 150159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150172 */     GIR_RootConstrainSelectedInstOperands,
     /* 150173 */     // GIR_Coverage, 23384,
     /* 150173 */     GIR_EraseRootFromParent_Done,
     /* 150174 */   // Label 3261: @150174
     /* 150174 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(150236), // Rule ID 23388 //
     /* 150179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150218 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 150221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150234 */     GIR_RootConstrainSelectedInstOperands,
     /* 150235 */     // GIR_Coverage, 23388,
     /* 150235 */     GIR_EraseRootFromParent_Done,
     /* 150236 */   // Label 3262: @150236
     /* 150236 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(150298), // Rule ID 24248 //
     /* 150241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150280 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150296 */     GIR_RootConstrainSelectedInstOperands,
     /* 150297 */     // GIR_Coverage, 24248,
     /* 150297 */     GIR_EraseRootFromParent_Done,
     /* 150298 */   // Label 3263: @150298
     /* 150298 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(150363), // Rule ID 925 //
     /* 150303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150322 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150342 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 150345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150361 */     GIR_RootConstrainSelectedInstOperands,
     /* 150362 */     // GIR_Coverage, 925,
     /* 150362 */     GIR_EraseRootFromParent_Done,
     /* 150363 */   // Label 3264: @150363
     /* 150363 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(150428), // Rule ID 927 //
     /* 150368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150387 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150407 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 150410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150426 */     GIR_RootConstrainSelectedInstOperands,
     /* 150427 */     // GIR_Coverage, 927,
     /* 150427 */     GIR_EraseRootFromParent_Done,
     /* 150428 */   // Label 3265: @150428
     /* 150428 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(150493), // Rule ID 913 //
     /* 150433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150472 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 150475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150491 */     GIR_RootConstrainSelectedInstOperands,
     /* 150492 */     // GIR_Coverage, 913,
     /* 150492 */     GIR_EraseRootFromParent_Done,
     /* 150493 */   // Label 3266: @150493
     /* 150493 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(150565), // Rule ID 915 //
     /* 150498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150520 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150524 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150544 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 150547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150563 */     GIR_RootConstrainSelectedInstOperands,
     /* 150564 */     // GIR_Coverage, 915,
     /* 150564 */     GIR_EraseRootFromParent_Done,
     /* 150565 */   // Label 3267: @150565
     /* 150565 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(150627), // Rule ID 2165 //
     /* 150570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150609 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 150612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150614 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150625 */     GIR_RootConstrainSelectedInstOperands,
     /* 150626 */     // GIR_Coverage, 2165,
     /* 150626 */     GIR_EraseRootFromParent_Done,
     /* 150627 */   // Label 3268: @150627
     /* 150627 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(150689), // Rule ID 2173 //
     /* 150632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150671 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 150674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150676 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150687 */     GIR_RootConstrainSelectedInstOperands,
     /* 150688 */     // GIR_Coverage, 2173,
     /* 150688 */     GIR_EraseRootFromParent_Done,
     /* 150689 */   // Label 3269: @150689
     /* 150689 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(150751), // Rule ID 5936 //
     /* 150694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150733 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150749 */     GIR_RootConstrainSelectedInstOperands,
     /* 150750 */     // GIR_Coverage, 5936,
     /* 150750 */     GIR_EraseRootFromParent_Done,
     /* 150751 */   // Label 3270: @150751
     /* 150751 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(150788), // Rule ID 889 //
     /* 150756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150771 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 150771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 150776 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150782 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150786 */     GIR_RootConstrainSelectedInstOperands,
     /* 150787 */     // GIR_Coverage, 889,
     /* 150787 */     GIR_Done,
     /* 150788 */   // Label 3271: @150788
     /* 150788 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(150819), // Rule ID 2163 //
     /* 150793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150808 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 150813 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150817 */     GIR_RootConstrainSelectedInstOperands,
     /* 150818 */     // GIR_Coverage, 2163,
     /* 150818 */     GIR_Done,
     /* 150819 */   // Label 3272: @150819
     /* 150819 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(150850), // Rule ID 2171 //
     /* 150824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150839 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 150844 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150848 */     GIR_RootConstrainSelectedInstOperands,
     /* 150849 */     // GIR_Coverage, 2171,
     /* 150849 */     GIR_Done,
     /* 150850 */   // Label 3273: @150850
     /* 150850 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(150881), // Rule ID 5934 //
     /* 150855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150870 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 150870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 150875 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150879 */     GIR_RootConstrainSelectedInstOperands,
     /* 150880 */     // GIR_Coverage, 5934,
     /* 150880 */     GIR_Done,
     /* 150881 */   // Label 3274: @150881
     /* 150881 */   GIM_Reject,
     /* 150882 */ // Label 3250: @150882
     /* 150882 */ GIM_Reject,
     /* 150883 */ // Label 3212: @150883
     /* 150883 */ GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(151448),
     /* 150888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 150891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 150894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150898 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(150959), // Rule ID 23255 //
     /* 150903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150914 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150938 */     // (fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 150941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150957 */     GIR_RootConstrainSelectedInstOperands,
     /* 150958 */     // GIR_Coverage, 23255,
     /* 150958 */     GIR_EraseRootFromParent_Done,
     /* 150959 */   // Label 3276: @150959
     /* 150959 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(151020), // Rule ID 23257 //
     /* 150964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150975 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150999 */     // (fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 151002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151018 */     GIR_RootConstrainSelectedInstOperands,
     /* 151019 */     // GIR_Coverage, 23257,
     /* 151019 */     GIR_EraseRootFromParent_Done,
     /* 151020 */   // Label 3277: @151020
     /* 151020 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(151088), // Rule ID 23243 //
     /* 151025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151039 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151043 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151067 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 151070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151086 */     GIR_RootConstrainSelectedInstOperands,
     /* 151087 */     // GIR_Coverage, 23243,
     /* 151087 */     GIR_EraseRootFromParent_Done,
     /* 151088 */   // Label 3278: @151088
     /* 151088 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(151156), // Rule ID 23245 //
     /* 151093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151107 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151111 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151135 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 151138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151154 */     GIR_RootConstrainSelectedInstOperands,
     /* 151155 */     // GIR_Coverage, 23245,
     /* 151155 */     GIR_EraseRootFromParent_Done,
     /* 151156 */   // Label 3279: @151156
     /* 151156 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(151217), // Rule ID 929 //
     /* 151161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 151176 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151196 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 151199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151215 */     GIR_RootConstrainSelectedInstOperands,
     /* 151216 */     // GIR_Coverage, 929,
     /* 151216 */     GIR_EraseRootFromParent_Done,
     /* 151217 */   // Label 3280: @151217
     /* 151217 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(151278), // Rule ID 931 //
     /* 151222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 151237 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151244 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151257 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 151260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151276 */     GIR_RootConstrainSelectedInstOperands,
     /* 151277 */     // GIR_Coverage, 931,
     /* 151277 */     GIR_EraseRootFromParent_Done,
     /* 151278 */   // Label 3281: @151278
     /* 151278 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(151346), // Rule ID 917 //
     /* 151283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151301 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151305 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151325 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 151328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151344 */     GIR_RootConstrainSelectedInstOperands,
     /* 151345 */     // GIR_Coverage, 917,
     /* 151345 */     GIR_EraseRootFromParent_Done,
     /* 151346 */   // Label 3282: @151346
     /* 151346 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(151414), // Rule ID 919 //
     /* 151351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151369 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151373 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151393 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 151396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151412 */     GIR_RootConstrainSelectedInstOperands,
     /* 151413 */     // GIR_Coverage, 919,
     /* 151413 */     GIR_EraseRootFromParent_Done,
     /* 151414 */   // Label 3283: @151414
     /* 151414 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(151447), // Rule ID 891 //
     /* 151419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151430 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 151430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 151435 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 151441 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 151445 */     GIR_RootConstrainSelectedInstOperands,
     /* 151446 */     // GIR_Coverage, 891,
     /* 151446 */     GIR_Done,
     /* 151447 */   // Label 3284: @151447
     /* 151447 */   GIM_Reject,
     /* 151448 */ // Label 3275: @151448
     /* 151448 */ GIM_Reject,
     /* 151449 */ // Label 3213: @151449
     /* 151449 */ GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(151802),
     /* 151454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 151457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151460 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(151522), // Rule ID 23372 //
     /* 151465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151504 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 151507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151520 */     GIR_RootConstrainSelectedInstOperands,
     /* 151521 */     // GIR_Coverage, 23372,
     /* 151521 */     GIR_EraseRootFromParent_Done,
     /* 151522 */   // Label 3286: @151522
     /* 151522 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(151584), // Rule ID 24296 //
     /* 151527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151566 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 151569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151582 */     GIR_RootConstrainSelectedInstOperands,
     /* 151583 */     // GIR_Coverage, 24296,
     /* 151583 */     GIR_EraseRootFromParent_Done,
     /* 151584 */   // Label 3287: @151584
     /* 151584 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(151646), // Rule ID 2141 //
     /* 151589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151628 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 151631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151644 */     GIR_RootConstrainSelectedInstOperands,
     /* 151645 */     // GIR_Coverage, 2141,
     /* 151645 */     GIR_EraseRootFromParent_Done,
     /* 151646 */   // Label 3288: @151646
     /* 151646 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(151708), // Rule ID 6309 //
     /* 151651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151670 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151690 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 151693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151706 */     GIR_RootConstrainSelectedInstOperands,
     /* 151707 */     // GIR_Coverage, 6309,
     /* 151707 */     GIR_EraseRootFromParent_Done,
     /* 151708 */   // Label 3289: @151708
     /* 151708 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(151739), // Rule ID 2139 //
     /* 151713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151728 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 151728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 151733 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151737 */     GIR_RootConstrainSelectedInstOperands,
     /* 151738 */     // GIR_Coverage, 2139,
     /* 151738 */     GIR_Done,
     /* 151739 */   // Label 3290: @151739
     /* 151739 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(151770), // Rule ID 2155 //
     /* 151744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 151747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151759 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 151759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 151764 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151768 */     GIR_RootConstrainSelectedInstOperands,
     /* 151769 */     // GIR_Coverage, 2155,
     /* 151769 */     GIR_Done,
     /* 151770 */   // Label 3291: @151770
     /* 151770 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(151801), // Rule ID 6305 //
     /* 151775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151790 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 151790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 151795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151799 */     GIR_RootConstrainSelectedInstOperands,
     /* 151800 */     // GIR_Coverage, 6305,
     /* 151800 */     GIR_Done,
     /* 151801 */   // Label 3292: @151801
     /* 151801 */   GIM_Reject,
     /* 151802 */ // Label 3285: @151802
     /* 151802 */ GIM_Reject,
     /* 151803 */ // Label 3214: @151803
     /* 151803 */ GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(152156),
     /* 151808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151814 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(151876), // Rule ID 23370 //
     /* 151819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151858 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151874 */     GIR_RootConstrainSelectedInstOperands,
     /* 151875 */     // GIR_Coverage, 23370,
     /* 151875 */     GIR_EraseRootFromParent_Done,
     /* 151876 */   // Label 3294: @151876
     /* 151876 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(151938), // Rule ID 24280 //
     /* 151881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151920 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 151923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151936 */     GIR_RootConstrainSelectedInstOperands,
     /* 151937 */     // GIR_Coverage, 24280,
     /* 151937 */     GIR_EraseRootFromParent_Done,
     /* 151938 */   // Label 3295: @151938
     /* 151938 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(152000), // Rule ID 2137 //
     /* 151943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151982 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151998 */     GIR_RootConstrainSelectedInstOperands,
     /* 151999 */     // GIR_Coverage, 2137,
     /* 151999 */     GIR_EraseRootFromParent_Done,
     /* 152000 */   // Label 3296: @152000
     /* 152000 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(152062), // Rule ID 6285 //
     /* 152005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152044 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 152047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152060 */     GIR_RootConstrainSelectedInstOperands,
     /* 152061 */     // GIR_Coverage, 6285,
     /* 152061 */     GIR_EraseRootFromParent_Done,
     /* 152062 */   // Label 3297: @152062
     /* 152062 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(152093), // Rule ID 2135 //
     /* 152067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152082 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 152082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 152087 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152091 */     GIR_RootConstrainSelectedInstOperands,
     /* 152092 */     // GIR_Coverage, 2135,
     /* 152092 */     GIR_Done,
     /* 152093 */   // Label 3298: @152093
     /* 152093 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(152124), // Rule ID 2151 //
     /* 152098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152113 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 152113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 152118 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152122 */     GIR_RootConstrainSelectedInstOperands,
     /* 152123 */     // GIR_Coverage, 2151,
     /* 152123 */     GIR_Done,
     /* 152124 */   // Label 3299: @152124
     /* 152124 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(152155), // Rule ID 6281 //
     /* 152129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152144 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 152144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 152149 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152153 */     GIR_RootConstrainSelectedInstOperands,
     /* 152154 */     // GIR_Coverage, 6281,
     /* 152154 */     GIR_Done,
     /* 152155 */   // Label 3300: @152155
     /* 152155 */   GIM_Reject,
     /* 152156 */ // Label 3293: @152156
     /* 152156 */ GIM_Reject,
     /* 152157 */ // Label 3215: @152157
     /* 152157 */ GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(152479),
     /* 152162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 152165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 152168 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(152230), // Rule ID 23376 //
     /* 152173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152212 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 152215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152228 */     GIR_RootConstrainSelectedInstOperands,
     /* 152229 */     // GIR_Coverage, 23376,
     /* 152229 */     GIR_EraseRootFromParent_Done,
     /* 152230 */   // Label 3302: @152230
     /* 152230 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(152292), // Rule ID 24304 //
     /* 152235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152257 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152274 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 152277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152290 */     GIR_RootConstrainSelectedInstOperands,
     /* 152291 */     // GIR_Coverage, 24304,
     /* 152291 */     GIR_EraseRootFromParent_Done,
     /* 152292 */   // Label 3303: @152292
     /* 152292 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(152354), // Rule ID 2149 //
     /* 152297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152336 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 152339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152352 */     GIR_RootConstrainSelectedInstOperands,
     /* 152353 */     // GIR_Coverage, 2149,
     /* 152353 */     GIR_EraseRootFromParent_Done,
     /* 152354 */   // Label 3304: @152354
     /* 152354 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(152416), // Rule ID 6321 //
     /* 152359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152398 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 152401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152414 */     GIR_RootConstrainSelectedInstOperands,
     /* 152415 */     // GIR_Coverage, 6321,
     /* 152415 */     GIR_EraseRootFromParent_Done,
     /* 152416 */   // Label 3305: @152416
     /* 152416 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(152447), // Rule ID 2147 //
     /* 152421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152436 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 152436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 152441 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152445 */     GIR_RootConstrainSelectedInstOperands,
     /* 152446 */     // GIR_Coverage, 2147,
     /* 152446 */     GIR_Done,
     /* 152447 */   // Label 3306: @152447
     /* 152447 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(152478), // Rule ID 6317 //
     /* 152452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152467 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 152467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 152472 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152476 */     GIR_RootConstrainSelectedInstOperands,
     /* 152477 */     // GIR_Coverage, 6317,
     /* 152477 */     GIR_Done,
     /* 152478 */   // Label 3307: @152478
     /* 152478 */   GIM_Reject,
     /* 152479 */ // Label 3301: @152479
     /* 152479 */ GIM_Reject,
     /* 152480 */ // Label 3216: @152480
     /* 152480 */ GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(152639),
     /* 152485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152495 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(152553), // Rule ID 24320 //
     /* 152500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152535 */     // (fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 152538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152551 */     GIR_RootConstrainSelectedInstOperands,
     /* 152552 */     // GIR_Coverage, 24320,
     /* 152552 */     GIR_EraseRootFromParent_Done,
     /* 152553 */   // Label 3309: @152553
     /* 152553 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(152611), // Rule ID 6345 //
     /* 152558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152580 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152593 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 152596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152609 */     GIR_RootConstrainSelectedInstOperands,
     /* 152610 */     // GIR_Coverage, 6345,
     /* 152610 */     GIR_EraseRootFromParent_Done,
     /* 152611 */   // Label 3310: @152611
     /* 152611 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(152638), // Rule ID 6341 //
     /* 152616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152627 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 152627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 152632 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152636 */     GIR_RootConstrainSelectedInstOperands,
     /* 152637 */     // GIR_Coverage, 6341,
     /* 152637 */     GIR_Done,
     /* 152638 */   // Label 3311: @152638
     /* 152638 */   GIM_Reject,
     /* 152639 */ // Label 3308: @152639
     /* 152639 */ GIM_Reject,
     /* 152640 */ // Label 3217: @152640
     /* 152640 */ GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(152962),
     /* 152645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 152648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 152651 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(152713), // Rule ID 23374 //
     /* 152656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152695 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 152698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152711 */     GIR_RootConstrainSelectedInstOperands,
     /* 152712 */     // GIR_Coverage, 23374,
     /* 152712 */     GIR_EraseRootFromParent_Done,
     /* 152713 */   // Label 3313: @152713
     /* 152713 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(152775), // Rule ID 24288 //
     /* 152718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152733 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152740 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152757 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 152760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152762 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152773 */     GIR_RootConstrainSelectedInstOperands,
     /* 152774 */     // GIR_Coverage, 24288,
     /* 152774 */     GIR_EraseRootFromParent_Done,
     /* 152775 */   // Label 3314: @152775
     /* 152775 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(152837), // Rule ID 2145 //
     /* 152780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152819 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 152822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152835 */     GIR_RootConstrainSelectedInstOperands,
     /* 152836 */     // GIR_Coverage, 2145,
     /* 152836 */     GIR_EraseRootFromParent_Done,
     /* 152837 */   // Label 3315: @152837
     /* 152837 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(152899), // Rule ID 6297 //
     /* 152842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152861 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152868 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152881 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 152884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152897 */     GIR_RootConstrainSelectedInstOperands,
     /* 152898 */     // GIR_Coverage, 6297,
     /* 152898 */     GIR_EraseRootFromParent_Done,
     /* 152899 */   // Label 3316: @152899
     /* 152899 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(152930), // Rule ID 2143 //
     /* 152904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152919 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 152919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 152924 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152928 */     GIR_RootConstrainSelectedInstOperands,
     /* 152929 */     // GIR_Coverage, 2143,
     /* 152929 */     GIR_Done,
     /* 152930 */   // Label 3317: @152930
     /* 152930 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(152961), // Rule ID 6293 //
     /* 152935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152950 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 152950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 152955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152959 */     GIR_RootConstrainSelectedInstOperands,
     /* 152960 */     // GIR_Coverage, 6293,
     /* 152960 */     GIR_Done,
     /* 152961 */   // Label 3318: @152961
     /* 152961 */   GIM_Reject,
     /* 152962 */ // Label 3312: @152962
     /* 152962 */ GIM_Reject,
     /* 152963 */ // Label 3218: @152963
     /* 152963 */ GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(153122),
     /* 152968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 152971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 152974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152978 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(153036), // Rule ID 24272 //
     /* 152983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153018 */     // (fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 153021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153034 */     GIR_RootConstrainSelectedInstOperands,
     /* 153035 */     // GIR_Coverage, 24272,
     /* 153035 */     GIR_EraseRootFromParent_Done,
     /* 153036 */   // Label 3320: @153036
     /* 153036 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(153094), // Rule ID 6273 //
     /* 153041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153063 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153076 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 153079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153081 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153092 */     GIR_RootConstrainSelectedInstOperands,
     /* 153093 */     // GIR_Coverage, 6273,
     /* 153093 */     GIR_EraseRootFromParent_Done,
     /* 153094 */   // Label 3321: @153094
     /* 153094 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(153121), // Rule ID 6269 //
     /* 153099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153110 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 153110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 153115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153119 */     GIR_RootConstrainSelectedInstOperands,
     /* 153120 */     // GIR_Coverage, 6269,
     /* 153120 */     GIR_Done,
     /* 153121 */   // Label 3322: @153121
     /* 153121 */   GIM_Reject,
     /* 153122 */ // Label 3319: @153122
     /* 153122 */ GIM_Reject,
     /* 153123 */ // Label 3219: @153123
     /* 153123 */ GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(153282),
     /* 153128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 153131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 153134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153138 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(153196), // Rule ID 24328 //
     /* 153143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153178 */     // (fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 153181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153183 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153194 */     GIR_RootConstrainSelectedInstOperands,
     /* 153195 */     // GIR_Coverage, 24328,
     /* 153195 */     GIR_EraseRootFromParent_Done,
     /* 153196 */   // Label 3324: @153196
     /* 153196 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(153254), // Rule ID 6357 //
     /* 153201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153236 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 153239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153252 */     GIR_RootConstrainSelectedInstOperands,
     /* 153253 */     // GIR_Coverage, 6357,
     /* 153253 */     GIR_EraseRootFromParent_Done,
     /* 153254 */   // Label 3325: @153254
     /* 153254 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(153281), // Rule ID 6353 //
     /* 153259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153270 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 153270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 153275 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153279 */     GIR_RootConstrainSelectedInstOperands,
     /* 153280 */     // GIR_Coverage, 6353,
     /* 153280 */     GIR_Done,
     /* 153281 */   // Label 3326: @153281
     /* 153281 */   GIM_Reject,
     /* 153282 */ // Label 3323: @153282
     /* 153282 */ GIM_Reject,
     /* 153283 */ // Label 3220: @153283
     /* 153283 */ GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(153442),
     /* 153288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 153291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 153294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153298 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(153356), // Rule ID 24264 //
     /* 153303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153338 */     // (fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 153341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153354 */     GIR_RootConstrainSelectedInstOperands,
     /* 153355 */     // GIR_Coverage, 24264,
     /* 153355 */     GIR_EraseRootFromParent_Done,
     /* 153356 */   // Label 3328: @153356
     /* 153356 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(153414), // Rule ID 6261 //
     /* 153361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153396 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 153399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153412 */     GIR_RootConstrainSelectedInstOperands,
     /* 153413 */     // GIR_Coverage, 6261,
     /* 153413 */     GIR_EraseRootFromParent_Done,
     /* 153414 */   // Label 3329: @153414
     /* 153414 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(153441), // Rule ID 6257 //
     /* 153419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153430 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 153430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 153435 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153439 */     GIR_RootConstrainSelectedInstOperands,
     /* 153440 */     // GIR_Coverage, 6257,
     /* 153440 */     GIR_Done,
     /* 153441 */   // Label 3330: @153441
     /* 153441 */   GIM_Reject,
     /* 153442 */ // Label 3327: @153442
     /* 153442 */ GIM_Reject,
     /* 153443 */ // Label 3221: @153443
     /* 153443 */ GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(153602),
     /* 153448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 153451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 153454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153458 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(153516), // Rule ID 24312 //
     /* 153463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153498 */     // (fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 153501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153514 */     GIR_RootConstrainSelectedInstOperands,
     /* 153515 */     // GIR_Coverage, 24312,
     /* 153515 */     GIR_EraseRootFromParent_Done,
     /* 153516 */   // Label 3332: @153516
     /* 153516 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(153574), // Rule ID 6333 //
     /* 153521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153556 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 153559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153572 */     GIR_RootConstrainSelectedInstOperands,
     /* 153573 */     // GIR_Coverage, 6333,
     /* 153573 */     GIR_EraseRootFromParent_Done,
     /* 153574 */   // Label 3333: @153574
     /* 153574 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(153601), // Rule ID 6329 //
     /* 153579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153590 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 153590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 153595 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153599 */     GIR_RootConstrainSelectedInstOperands,
     /* 153600 */     // GIR_Coverage, 6329,
     /* 153600 */     GIR_Done,
     /* 153601 */   // Label 3334: @153601
     /* 153601 */   GIM_Reject,
     /* 153602 */ // Label 3331: @153602
     /* 153602 */ GIM_Reject,
     /* 153603 */ // Label 3222: @153603
     /* 153603 */ GIM_Reject,
     /* 153604 */ // Label 42: @153604
     /* 153604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3348*/ GIMT_Encode4(157785),
     /* 153615 */ /*GILLT_s16*//*Label 3335*/ GIMT_Encode4(153699),
     /* 153619 */ /*GILLT_s32*//*Label 3336*/ GIMT_Encode4(153797),
     /* 153623 */ /*GILLT_s64*//*Label 3337*/ GIMT_Encode4(154762),
     /* 153627 */ /*GILLT_s80*//*Label 3338*/ GIMT_Encode4(155871), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153639 */ /*GILLT_v2s64*//*Label 3339*/ GIMT_Encode4(156437), GIMT_Encode4(0),
     /* 153647 */ /*GILLT_v4s32*//*Label 3340*/ GIMT_Encode4(156667),
     /* 153651 */ /*GILLT_v4s64*//*Label 3341*/ GIMT_Encode4(156897), GIMT_Encode4(0),
     /* 153659 */ /*GILLT_v8s16*//*Label 3342*/ GIMT_Encode4(157096),
     /* 153663 */ /*GILLT_v8s32*//*Label 3343*/ GIMT_Encode4(157194),
     /* 153667 */ /*GILLT_v8s64*//*Label 3344*/ GIMT_Encode4(157393), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153679 */ /*GILLT_v16s16*//*Label 3345*/ GIMT_Encode4(157491),
     /* 153683 */ /*GILLT_v16s32*//*Label 3346*/ GIMT_Encode4(157589), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153695 */ /*GILLT_v32s16*//*Label 3347*/ GIMT_Encode4(157687),
     /* 153699 */ // Label 3335: @153699
     /* 153699 */ GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(153796),
     /* 153704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 153707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153718 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(153772), // Rule ID 6069 //
     /* 153723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153754 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 153757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153770 */     GIR_RootConstrainSelectedInstOperands,
     /* 153771 */     // GIR_Coverage, 6069,
     /* 153771 */     GIR_EraseRootFromParent_Done,
     /* 153772 */   // Label 3350: @153772
     /* 153772 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(153795), // Rule ID 6067 //
     /* 153777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153784 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 153784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 153789 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153793 */     GIR_RootConstrainSelectedInstOperands,
     /* 153794 */     // GIR_Coverage, 6067,
     /* 153794 */     GIR_Done,
     /* 153795 */   // Label 3351: @153795
     /* 153795 */   GIM_Reject,
     /* 153796 */ // Label 3349: @153796
     /* 153796 */ GIM_Reject,
     /* 153797 */ // Label 3336: @153797
     /* 153797 */ GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(154761),
     /* 153802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 153805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153808 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(153890), // Rule ID 22473 //
     /* 153813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153844 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153851 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153871 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 153874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153876 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153888 */     GIR_RootConstrainSelectedInstOperands,
     /* 153889 */     // GIR_Coverage, 22473,
     /* 153889 */     GIR_EraseRootFromParent_Done,
     /* 153890 */   // Label 3353: @153890
     /* 153890 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(153972), // Rule ID 22474 //
     /* 153895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153926 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153933 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153953 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 153956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153970 */     GIR_RootConstrainSelectedInstOperands,
     /* 153971 */     // GIR_Coverage, 22474,
     /* 153971 */     GIR_EraseRootFromParent_Done,
     /* 153972 */   // Label 3354: @153972
     /* 153972 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(154054), // Rule ID 22475 //
     /* 153977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 153988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 154000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154008 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154015 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154022 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154035 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 154038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154052 */     GIR_RootConstrainSelectedInstOperands,
     /* 154053 */     // GIR_Coverage, 22475,
     /* 154053 */     GIR_EraseRootFromParent_Done,
     /* 154054 */   // Label 3355: @154054
     /* 154054 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(154119), // Rule ID 965 //
     /* 154059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154074 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154098 */     // (fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m32),
     /* 154101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154117 */     GIR_RootConstrainSelectedInstOperands,
     /* 154118 */     // GIR_Coverage, 965,
     /* 154118 */     GIR_EraseRootFromParent_Done,
     /* 154119 */   // Label 3356: @154119
     /* 154119 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(154184), // Rule ID 967 //
     /* 154124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154139 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154163 */     // (fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m32),
     /* 154166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154182 */     GIR_RootConstrainSelectedInstOperands,
     /* 154183 */     // GIR_Coverage, 967,
     /* 154183 */     GIR_EraseRootFromParent_Done,
     /* 154184 */   // Label 3357: @154184
     /* 154184 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(154249), // Rule ID 955 //
     /* 154189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154228 */     // (fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 154231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154235 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154247 */     GIR_RootConstrainSelectedInstOperands,
     /* 154248 */     // GIR_Coverage, 955,
     /* 154248 */     GIR_EraseRootFromParent_Done,
     /* 154249 */   // Label 3358: @154249
     /* 154249 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(154314), // Rule ID 943 //
     /* 154254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154273 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154280 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154293 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m32),
     /* 154296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154298 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154312 */     GIR_RootConstrainSelectedInstOperands,
     /* 154313 */     // GIR_Coverage, 943,
     /* 154313 */     GIR_EraseRootFromParent_Done,
     /* 154314 */   // Label 3359: @154314
     /* 154314 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(154379), // Rule ID 945 //
     /* 154319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154338 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154358 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m32),
     /* 154361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154377 */     GIR_RootConstrainSelectedInstOperands,
     /* 154378 */     // GIR_Coverage, 945,
     /* 154378 */     GIR_EraseRootFromParent_Done,
     /* 154379 */   // Label 3360: @154379
     /* 154379 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(154444), // Rule ID 933 //
     /* 154384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154423 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 154426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154442 */     GIR_RootConstrainSelectedInstOperands,
     /* 154443 */     // GIR_Coverage, 933,
     /* 154443 */     GIR_EraseRootFromParent_Done,
     /* 154444 */   // Label 3361: @154444
     /* 154444 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(154506), // Rule ID 2241 //
     /* 154449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154468 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154488 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 154491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154504 */     GIR_RootConstrainSelectedInstOperands,
     /* 154505 */     // GIR_Coverage, 2241,
     /* 154505 */     GIR_EraseRootFromParent_Done,
     /* 154506 */   // Label 3362: @154506
     /* 154506 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(154568), // Rule ID 2249 //
     /* 154511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154550 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 154553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154566 */     GIR_RootConstrainSelectedInstOperands,
     /* 154567 */     // GIR_Coverage, 2249,
     /* 154567 */     GIR_EraseRootFromParent_Done,
     /* 154568 */   // Label 3363: @154568
     /* 154568 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(154630), // Rule ID 6031 //
     /* 154573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154612 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 154615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154628 */     GIR_RootConstrainSelectedInstOperands,
     /* 154629 */     // GIR_Coverage, 6031,
     /* 154629 */     GIR_EraseRootFromParent_Done,
     /* 154630 */   // Label 3364: @154630
     /* 154630 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(154667), // Rule ID 893 //
     /* 154635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154650 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 154650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 154655 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154661 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154665 */     GIR_RootConstrainSelectedInstOperands,
     /* 154666 */     // GIR_Coverage, 893,
     /* 154666 */     GIR_Done,
     /* 154667 */   // Label 3365: @154667
     /* 154667 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(154698), // Rule ID 2239 //
     /* 154672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154687 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 154687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 154692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154696 */     GIR_RootConstrainSelectedInstOperands,
     /* 154697 */     // GIR_Coverage, 2239,
     /* 154697 */     GIR_Done,
     /* 154698 */   // Label 3366: @154698
     /* 154698 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(154729), // Rule ID 2247 //
     /* 154703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154718 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 154718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 154723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154727 */     GIR_RootConstrainSelectedInstOperands,
     /* 154728 */     // GIR_Coverage, 2247,
     /* 154728 */     GIR_Done,
     /* 154729 */   // Label 3367: @154729
     /* 154729 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(154760), // Rule ID 6029 //
     /* 154734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154749 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 154749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 154754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154758 */     GIR_RootConstrainSelectedInstOperands,
     /* 154759 */     // GIR_Coverage, 6029,
     /* 154759 */     GIR_Done,
     /* 154760 */   // Label 3368: @154760
     /* 154760 */   GIM_Reject,
     /* 154761 */ // Label 3352: @154761
     /* 154761 */ GIM_Reject,
     /* 154762 */ // Label 3337: @154762
     /* 154762 */ GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(155870),
     /* 154767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 154770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154773 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(154855), // Rule ID 22476 //
     /* 154778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154809 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154816 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154823 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154836 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 154839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154841 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154853 */     GIR_RootConstrainSelectedInstOperands,
     /* 154854 */     // GIR_Coverage, 22476,
     /* 154854 */     GIR_EraseRootFromParent_Done,
     /* 154855 */   // Label 3370: @154855
     /* 154855 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(154937), // Rule ID 22477 //
     /* 154860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154891 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154898 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154905 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154918 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 154921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154923 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154935 */     GIR_RootConstrainSelectedInstOperands,
     /* 154936 */     // GIR_Coverage, 22477,
     /* 154936 */     GIR_EraseRootFromParent_Done,
     /* 154937 */   // Label 3371: @154937
     /* 154937 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(155019), // Rule ID 22478 //
     /* 154942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154973 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154980 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154987 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155000 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 155003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 155017 */     GIR_RootConstrainSelectedInstOperands,
     /* 155018 */     // GIR_Coverage, 22478,
     /* 155018 */     GIR_EraseRootFromParent_Done,
     /* 155019 */   // Label 3372: @155019
     /* 155019 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(155084), // Rule ID 969 //
     /* 155024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155039 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155063 */     // (fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m64),
     /* 155066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155082 */     GIR_RootConstrainSelectedInstOperands,
     /* 155083 */     // GIR_Coverage, 969,
     /* 155083 */     GIR_EraseRootFromParent_Done,
     /* 155084 */   // Label 3373: @155084
     /* 155084 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(155149), // Rule ID 971 //
     /* 155089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155104 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155128 */     // (fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m64),
     /* 155131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155147 */     GIR_RootConstrainSelectedInstOperands,
     /* 155148 */     // GIR_Coverage, 971,
     /* 155148 */     GIR_EraseRootFromParent_Done,
     /* 155149 */   // Label 3374: @155149
     /* 155149 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(155214), // Rule ID 957 //
     /* 155154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155193 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 155196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155198 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155212 */     GIR_RootConstrainSelectedInstOperands,
     /* 155213 */     // GIR_Coverage, 957,
     /* 155213 */     GIR_EraseRootFromParent_Done,
     /* 155214 */   // Label 3375: @155214
     /* 155214 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(155286), // Rule ID 959 //
     /* 155219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155234 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155237 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155241 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155248 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155265 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 155268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155284 */     GIR_RootConstrainSelectedInstOperands,
     /* 155285 */     // GIR_Coverage, 959,
     /* 155285 */     GIR_EraseRootFromParent_Done,
     /* 155286 */   // Label 3376: @155286
     /* 155286 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(155351), // Rule ID 947 //
     /* 155291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155310 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155330 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m64),
     /* 155333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155335 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155349 */     GIR_RootConstrainSelectedInstOperands,
     /* 155350 */     // GIR_Coverage, 947,
     /* 155350 */     GIR_EraseRootFromParent_Done,
     /* 155351 */   // Label 3377: @155351
     /* 155351 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(155416), // Rule ID 949 //
     /* 155356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155375 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155395 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m64),
     /* 155398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155414 */     GIR_RootConstrainSelectedInstOperands,
     /* 155415 */     // GIR_Coverage, 949,
     /* 155415 */     GIR_EraseRootFromParent_Done,
     /* 155416 */   // Label 3378: @155416
     /* 155416 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(155481), // Rule ID 935 //
     /* 155421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155460 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 155463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155479 */     GIR_RootConstrainSelectedInstOperands,
     /* 155480 */     // GIR_Coverage, 935,
     /* 155480 */     GIR_EraseRootFromParent_Done,
     /* 155481 */   // Label 3379: @155481
     /* 155481 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(155553), // Rule ID 937 //
     /* 155486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155505 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155508 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155512 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155532 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 155535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155551 */     GIR_RootConstrainSelectedInstOperands,
     /* 155552 */     // GIR_Coverage, 937,
     /* 155552 */     GIR_EraseRootFromParent_Done,
     /* 155553 */   // Label 3380: @155553
     /* 155553 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(155615), // Rule ID 2245 //
     /* 155558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155597 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 155600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155613 */     GIR_RootConstrainSelectedInstOperands,
     /* 155614 */     // GIR_Coverage, 2245,
     /* 155614 */     GIR_EraseRootFromParent_Done,
     /* 155615 */   // Label 3381: @155615
     /* 155615 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(155677), // Rule ID 2253 //
     /* 155620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 155623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155639 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155642 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155646 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155659 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 155662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155666 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155675 */     GIR_RootConstrainSelectedInstOperands,
     /* 155676 */     // GIR_Coverage, 2253,
     /* 155676 */     GIR_EraseRootFromParent_Done,
     /* 155677 */   // Label 3382: @155677
     /* 155677 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(155739), // Rule ID 6050 //
     /* 155682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155701 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155708 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155721 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 155724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155726 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155737 */     GIR_RootConstrainSelectedInstOperands,
     /* 155738 */     // GIR_Coverage, 6050,
     /* 155738 */     GIR_EraseRootFromParent_Done,
     /* 155739 */   // Label 3383: @155739
     /* 155739 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(155776), // Rule ID 895 //
     /* 155744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155759 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 155759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 155764 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 155770 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 155774 */     GIR_RootConstrainSelectedInstOperands,
     /* 155775 */     // GIR_Coverage, 895,
     /* 155775 */     GIR_Done,
     /* 155776 */   // Label 3384: @155776
     /* 155776 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(155807), // Rule ID 2243 //
     /* 155781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155796 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 155796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 155801 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155805 */     GIR_RootConstrainSelectedInstOperands,
     /* 155806 */     // GIR_Coverage, 2243,
     /* 155806 */     GIR_Done,
     /* 155807 */   // Label 3385: @155807
     /* 155807 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(155838), // Rule ID 2251 //
     /* 155812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 155815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155827 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 155827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 155832 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155836 */     GIR_RootConstrainSelectedInstOperands,
     /* 155837 */     // GIR_Coverage, 2251,
     /* 155837 */     GIR_Done,
     /* 155838 */   // Label 3386: @155838
     /* 155838 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(155869), // Rule ID 6048 //
     /* 155843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155858 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 155858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 155863 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155867 */     GIR_RootConstrainSelectedInstOperands,
     /* 155868 */     // GIR_Coverage, 6048,
     /* 155868 */     GIR_Done,
     /* 155869 */   // Label 3387: @155869
     /* 155869 */   GIM_Reject,
     /* 155870 */ // Label 3369: @155870
     /* 155870 */ GIM_Reject,
     /* 155871 */ // Label 3338: @155871
     /* 155871 */ GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(156436),
     /* 155876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 155879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 155882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155886 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(155947), // Rule ID 973 //
     /* 155891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 155894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155902 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155926 */     // (fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m80),
     /* 155929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155945 */     GIR_RootConstrainSelectedInstOperands,
     /* 155946 */     // GIR_Coverage, 973,
     /* 155946 */     GIR_EraseRootFromParent_Done,
     /* 155947 */   // Label 3389: @155947
     /* 155947 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(156008), // Rule ID 975 //
     /* 155952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 155955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155963 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155987 */     // (fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m80),
     /* 155990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156006 */     GIR_RootConstrainSelectedInstOperands,
     /* 156007 */     // GIR_Coverage, 975,
     /* 156007 */     GIR_EraseRootFromParent_Done,
     /* 156008 */   // Label 3390: @156008
     /* 156008 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(156076), // Rule ID 961 //
     /* 156013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156027 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156031 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156055 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 156058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156074 */     GIR_RootConstrainSelectedInstOperands,
     /* 156075 */     // GIR_Coverage, 961,
     /* 156075 */     GIR_EraseRootFromParent_Done,
     /* 156076 */   // Label 3391: @156076
     /* 156076 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(156144), // Rule ID 963 //
     /* 156081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156095 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156099 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156123 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 156126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156142 */     GIR_RootConstrainSelectedInstOperands,
     /* 156143 */     // GIR_Coverage, 963,
     /* 156143 */     GIR_EraseRootFromParent_Done,
     /* 156144 */   // Label 3392: @156144
     /* 156144 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(156205), // Rule ID 951 //
     /* 156149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 156164 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156184 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m80),
     /* 156187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156203 */     GIR_RootConstrainSelectedInstOperands,
     /* 156204 */     // GIR_Coverage, 951,
     /* 156204 */     GIR_EraseRootFromParent_Done,
     /* 156205 */   // Label 3393: @156205
     /* 156205 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(156266), // Rule ID 953 //
     /* 156210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 156225 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156245 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m80),
     /* 156248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156264 */     GIR_RootConstrainSelectedInstOperands,
     /* 156265 */     // GIR_Coverage, 953,
     /* 156265 */     GIR_EraseRootFromParent_Done,
     /* 156266 */   // Label 3394: @156266
     /* 156266 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(156334), // Rule ID 939 //
     /* 156271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156289 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156293 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156300 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156313 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 156316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156318 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156332 */     GIR_RootConstrainSelectedInstOperands,
     /* 156333 */     // GIR_Coverage, 939,
     /* 156333 */     GIR_EraseRootFromParent_Done,
     /* 156334 */   // Label 3395: @156334
     /* 156334 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(156402), // Rule ID 941 //
     /* 156339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156357 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156361 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156381 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 156384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156400 */     GIR_RootConstrainSelectedInstOperands,
     /* 156401 */     // GIR_Coverage, 941,
     /* 156401 */     GIR_EraseRootFromParent_Done,
     /* 156402 */   // Label 3396: @156402
     /* 156402 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(156435), // Rule ID 897 //
     /* 156407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156418 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 156418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 156423 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 156429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 156433 */     GIR_RootConstrainSelectedInstOperands,
     /* 156434 */     // GIR_Coverage, 897,
     /* 156434 */     GIR_Done,
     /* 156435 */   // Label 3397: @156435
     /* 156435 */   GIM_Reject,
     /* 156436 */ // Label 3388: @156436
     /* 156436 */ GIM_Reject,
     /* 156437 */ // Label 3339: @156437
     /* 156437 */ GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(156666),
     /* 156442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156448 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(156510), // Rule ID 2221 //
     /* 156453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156492 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 156495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156508 */     GIR_RootConstrainSelectedInstOperands,
     /* 156509 */     // GIR_Coverage, 2221,
     /* 156509 */     GIR_EraseRootFromParent_Done,
     /* 156510 */   // Label 3399: @156510
     /* 156510 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(156572), // Rule ID 6543 //
     /* 156515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156534 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156554 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156559 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156570 */     GIR_RootConstrainSelectedInstOperands,
     /* 156571 */     // GIR_Coverage, 6543,
     /* 156571 */     GIR_EraseRootFromParent_Done,
     /* 156572 */   // Label 3400: @156572
     /* 156572 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(156603), // Rule ID 2219 //
     /* 156577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156592 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 156592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 156597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156601 */     GIR_RootConstrainSelectedInstOperands,
     /* 156602 */     // GIR_Coverage, 2219,
     /* 156602 */     GIR_Done,
     /* 156603 */   // Label 3401: @156603
     /* 156603 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(156634), // Rule ID 2235 //
     /* 156608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 156611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156623 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 156623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 156628 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156632 */     GIR_RootConstrainSelectedInstOperands,
     /* 156633 */     // GIR_Coverage, 2235,
     /* 156633 */     GIR_Done,
     /* 156634 */   // Label 3402: @156634
     /* 156634 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(156665), // Rule ID 6539 //
     /* 156639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156654 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 156654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 156659 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156663 */     GIR_RootConstrainSelectedInstOperands,
     /* 156664 */     // GIR_Coverage, 6539,
     /* 156664 */     GIR_Done,
     /* 156665 */   // Label 3403: @156665
     /* 156665 */   GIM_Reject,
     /* 156666 */ // Label 3398: @156666
     /* 156666 */ GIM_Reject,
     /* 156667 */ // Label 3340: @156667
     /* 156667 */ GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(156896),
     /* 156672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156678 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(156740), // Rule ID 2217 //
     /* 156683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156705 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156722 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 156725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156738 */     GIR_RootConstrainSelectedInstOperands,
     /* 156739 */     // GIR_Coverage, 2217,
     /* 156739 */     GIR_EraseRootFromParent_Done,
     /* 156740 */   // Label 3405: @156740
     /* 156740 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(156802), // Rule ID 6519 //
     /* 156745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156771 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156784 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 156787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156800 */     GIR_RootConstrainSelectedInstOperands,
     /* 156801 */     // GIR_Coverage, 6519,
     /* 156801 */     GIR_EraseRootFromParent_Done,
     /* 156802 */   // Label 3406: @156802
     /* 156802 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(156833), // Rule ID 2215 //
     /* 156807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156822 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 156822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 156827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156831 */     GIR_RootConstrainSelectedInstOperands,
     /* 156832 */     // GIR_Coverage, 2215,
     /* 156832 */     GIR_Done,
     /* 156833 */   // Label 3407: @156833
     /* 156833 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(156864), // Rule ID 2231 //
     /* 156838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156853 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 156853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 156858 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156862 */     GIR_RootConstrainSelectedInstOperands,
     /* 156863 */     // GIR_Coverage, 2231,
     /* 156863 */     GIR_Done,
     /* 156864 */   // Label 3408: @156864
     /* 156864 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(156895), // Rule ID 6515 //
     /* 156869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156884 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 156884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 156889 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156893 */     GIR_RootConstrainSelectedInstOperands,
     /* 156894 */     // GIR_Coverage, 6515,
     /* 156894 */     GIR_Done,
     /* 156895 */   // Label 3409: @156895
     /* 156895 */   GIM_Reject,
     /* 156896 */ // Label 3404: @156896
     /* 156896 */ GIM_Reject,
     /* 156897 */ // Label 3341: @156897
     /* 156897 */ GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(157095),
     /* 156902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 156905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 156908 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(156970), // Rule ID 2229 //
     /* 156913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 156920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 156924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156952 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 156955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156968 */     GIR_RootConstrainSelectedInstOperands,
     /* 156969 */     // GIR_Coverage, 2229,
     /* 156969 */     GIR_EraseRootFromParent_Done,
     /* 156970 */   // Label 3411: @156970
     /* 156970 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(157032), // Rule ID 6555 //
     /* 156975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 156982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 156986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157014 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 157017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157030 */     GIR_RootConstrainSelectedInstOperands,
     /* 157031 */     // GIR_Coverage, 6555,
     /* 157031 */     GIR_EraseRootFromParent_Done,
     /* 157032 */   // Label 3412: @157032
     /* 157032 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(157063), // Rule ID 2227 //
     /* 157037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157052 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 157052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 157057 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157061 */     GIR_RootConstrainSelectedInstOperands,
     /* 157062 */     // GIR_Coverage, 2227,
     /* 157062 */     GIR_Done,
     /* 157063 */   // Label 3413: @157063
     /* 157063 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(157094), // Rule ID 6551 //
     /* 157068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157083 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 157083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 157088 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157092 */     GIR_RootConstrainSelectedInstOperands,
     /* 157093 */     // GIR_Coverage, 6551,
     /* 157093 */     GIR_Done,
     /* 157094 */   // Label 3414: @157094
     /* 157094 */   GIM_Reject,
     /* 157095 */ // Label 3410: @157095
     /* 157095 */ GIM_Reject,
     /* 157096 */ // Label 3342: @157096
     /* 157096 */ GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(157193),
     /* 157101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 157107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157115 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(157169), // Rule ID 6579 //
     /* 157120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157131 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157151 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 157154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157158 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157167 */     GIR_RootConstrainSelectedInstOperands,
     /* 157168 */     // GIR_Coverage, 6579,
     /* 157168 */     GIR_EraseRootFromParent_Done,
     /* 157169 */   // Label 3416: @157169
     /* 157169 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(157192), // Rule ID 6575 //
     /* 157174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157181 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 157181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 157186 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157190 */     GIR_RootConstrainSelectedInstOperands,
     /* 157191 */     // GIR_Coverage, 6575,
     /* 157191 */     GIR_Done,
     /* 157192 */   // Label 3417: @157192
     /* 157192 */   GIM_Reject,
     /* 157193 */ // Label 3415: @157193
     /* 157193 */ GIM_Reject,
     /* 157194 */ // Label 3343: @157194
     /* 157194 */ GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(157392),
     /* 157199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 157202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 157205 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(157267), // Rule ID 2225 //
     /* 157210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157249 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 157252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157265 */     GIR_RootConstrainSelectedInstOperands,
     /* 157266 */     // GIR_Coverage, 2225,
     /* 157266 */     GIR_EraseRootFromParent_Done,
     /* 157267 */   // Label 3419: @157267
     /* 157267 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(157329), // Rule ID 6531 //
     /* 157272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157311 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 157314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157316 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157327 */     GIR_RootConstrainSelectedInstOperands,
     /* 157328 */     // GIR_Coverage, 6531,
     /* 157328 */     GIR_EraseRootFromParent_Done,
     /* 157329 */   // Label 3420: @157329
     /* 157329 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(157360), // Rule ID 2223 //
     /* 157334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157349 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 157349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 157354 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157358 */     GIR_RootConstrainSelectedInstOperands,
     /* 157359 */     // GIR_Coverage, 2223,
     /* 157359 */     GIR_Done,
     /* 157360 */   // Label 3421: @157360
     /* 157360 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(157391), // Rule ID 6527 //
     /* 157365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157380 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 157380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 157385 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157389 */     GIR_RootConstrainSelectedInstOperands,
     /* 157390 */     // GIR_Coverage, 6527,
     /* 157390 */     GIR_Done,
     /* 157391 */   // Label 3422: @157391
     /* 157391 */   GIM_Reject,
     /* 157392 */ // Label 3418: @157392
     /* 157392 */ GIM_Reject,
     /* 157393 */ // Label 3344: @157393
     /* 157393 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(157490),
     /* 157398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 157401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 157404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157412 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(157466), // Rule ID 6507 //
     /* 157417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157448 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 157451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157464 */     GIR_RootConstrainSelectedInstOperands,
     /* 157465 */     // GIR_Coverage, 6507,
     /* 157465 */     GIR_EraseRootFromParent_Done,
     /* 157466 */   // Label 3424: @157466
     /* 157466 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(157489), // Rule ID 6503 //
     /* 157471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157478 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 157478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 157483 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157487 */     GIR_RootConstrainSelectedInstOperands,
     /* 157488 */     // GIR_Coverage, 6503,
     /* 157488 */     GIR_Done,
     /* 157489 */   // Label 3425: @157489
     /* 157489 */   GIM_Reject,
     /* 157490 */ // Label 3423: @157490
     /* 157490 */ GIM_Reject,
     /* 157491 */ // Label 3345: @157491
     /* 157491 */ GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(157588),
     /* 157496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 157499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 157502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157510 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(157564), // Rule ID 6591 //
     /* 157515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157526 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157546 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 157549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157562 */     GIR_RootConstrainSelectedInstOperands,
     /* 157563 */     // GIR_Coverage, 6591,
     /* 157563 */     GIR_EraseRootFromParent_Done,
     /* 157564 */   // Label 3427: @157564
     /* 157564 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(157587), // Rule ID 6587 //
     /* 157569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157576 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 157576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 157581 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157585 */     GIR_RootConstrainSelectedInstOperands,
     /* 157586 */     // GIR_Coverage, 6587,
     /* 157586 */     GIR_Done,
     /* 157587 */   // Label 3428: @157587
     /* 157587 */   GIM_Reject,
     /* 157588 */ // Label 3426: @157588
     /* 157588 */ GIM_Reject,
     /* 157589 */ // Label 3346: @157589
     /* 157589 */ GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(157686),
     /* 157594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 157597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 157600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157608 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(157662), // Rule ID 6495 //
     /* 157613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157644 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 157647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157660 */     GIR_RootConstrainSelectedInstOperands,
     /* 157661 */     // GIR_Coverage, 6495,
     /* 157661 */     GIR_EraseRootFromParent_Done,
     /* 157662 */   // Label 3430: @157662
     /* 157662 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(157685), // Rule ID 6491 //
     /* 157667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157674 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 157674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 157679 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157683 */     GIR_RootConstrainSelectedInstOperands,
     /* 157684 */     // GIR_Coverage, 6491,
     /* 157684 */     GIR_Done,
     /* 157685 */   // Label 3431: @157685
     /* 157685 */   GIM_Reject,
     /* 157686 */ // Label 3429: @157686
     /* 157686 */ GIM_Reject,
     /* 157687 */ // Label 3347: @157687
     /* 157687 */ GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(157784),
     /* 157692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 157695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 157698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157706 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(157760), // Rule ID 6567 //
     /* 157711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157742 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 157745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157758 */     GIR_RootConstrainSelectedInstOperands,
     /* 157759 */     // GIR_Coverage, 6567,
     /* 157759 */     GIR_EraseRootFromParent_Done,
     /* 157760 */   // Label 3433: @157760
     /* 157760 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(157783), // Rule ID 6563 //
     /* 157765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157772 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 157772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 157777 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157781 */     GIR_RootConstrainSelectedInstOperands,
     /* 157782 */     // GIR_Coverage, 6563,
     /* 157782 */     GIR_Done,
     /* 157783 */   // Label 3434: @157783
     /* 157783 */   GIM_Reject,
     /* 157784 */ // Label 3432: @157784
     /* 157784 */ GIM_Reject,
     /* 157785 */ // Label 3348: @157785
     /* 157785 */ GIM_Reject,
     /* 157786 */ // Label 43: @157786
     /* 157786 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3448*/ GIMT_Encode4(163699),
     /* 157797 */ /*GILLT_s16*//*Label 3435*/ GIMT_Encode4(157881),
     /* 157801 */ /*GILLT_s32*//*Label 3436*/ GIMT_Encode4(158041),
     /* 157805 */ /*GILLT_s64*//*Label 3437*/ GIMT_Encode4(159438),
     /* 157809 */ /*GILLT_s80*//*Label 3438*/ GIMT_Encode4(160979), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157821 */ /*GILLT_v2s64*//*Label 3439*/ GIMT_Encode4(161545), GIMT_Encode4(0),
     /* 157829 */ /*GILLT_v4s32*//*Label 3440*/ GIMT_Encode4(161899),
     /* 157833 */ /*GILLT_v4s64*//*Label 3441*/ GIMT_Encode4(162253), GIMT_Encode4(0),
     /* 157841 */ /*GILLT_v8s16*//*Label 3442*/ GIMT_Encode4(162576),
     /* 157845 */ /*GILLT_v8s32*//*Label 3443*/ GIMT_Encode4(162736),
     /* 157849 */ /*GILLT_v8s64*//*Label 3444*/ GIMT_Encode4(163059), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157861 */ /*GILLT_v16s16*//*Label 3445*/ GIMT_Encode4(163219),
     /* 157865 */ /*GILLT_v16s32*//*Label 3446*/ GIMT_Encode4(163379), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157877 */ /*GILLT_v32s16*//*Label 3447*/ GIMT_Encode4(163539),
     /* 157881 */ // Label 3435: @157881
     /* 157881 */ GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(158040),
     /* 157886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 157889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157896 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(157954), // Rule ID 24256 //
     /* 157901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157936 */     // (fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 157939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157952 */     GIR_RootConstrainSelectedInstOperands,
     /* 157953 */     // GIR_Coverage, 24256,
     /* 157953 */     GIR_EraseRootFromParent_Done,
     /* 157954 */   // Label 3450: @157954
     /* 157954 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(158012), // Rule ID 6012 //
     /* 157959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157994 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 157997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158010 */     GIR_RootConstrainSelectedInstOperands,
     /* 158011 */     // GIR_Coverage, 6012,
     /* 158011 */     GIR_EraseRootFromParent_Done,
     /* 158012 */   // Label 3451: @158012
     /* 158012 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(158039), // Rule ID 6010 //
     /* 158017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 158020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 158024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 158028 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 158028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 158033 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158037 */     GIR_RootConstrainSelectedInstOperands,
     /* 158038 */     // GIR_Coverage, 6010,
     /* 158038 */     GIR_Done,
     /* 158039 */   // Label 3452: @158039
     /* 158039 */   GIM_Reject,
     /* 158040 */ // Label 3449: @158040
     /* 158040 */ GIM_Reject,
     /* 158041 */ // Label 3436: @158041
     /* 158041 */ GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(159437),
     /* 158046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 158049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158052 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(158134), // Rule ID 26024 //
     /* 158057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158084 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158091 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158098 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158115 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158132 */     GIR_RootConstrainSelectedInstOperands,
     /* 158133 */     // GIR_Coverage, 26024,
     /* 158133 */     GIR_EraseRootFromParent_Done,
     /* 158134 */   // Label 3454: @158134
     /* 158134 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(158216), // Rule ID 26025 //
     /* 158139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158166 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158173 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158180 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158197 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158214 */     GIR_RootConstrainSelectedInstOperands,
     /* 158215 */     // GIR_Coverage, 26025,
     /* 158215 */     GIR_EraseRootFromParent_Done,
     /* 158216 */   // Label 3455: @158216
     /* 158216 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(158298), // Rule ID 26026 //
     /* 158221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158248 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158255 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158262 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158279 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158296 */     GIR_RootConstrainSelectedInstOperands,
     /* 158297 */     // GIR_Coverage, 26026,
     /* 158297 */     GIR_EraseRootFromParent_Done,
     /* 158298 */   // Label 3456: @158298
     /* 158298 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(158380), // Rule ID 22479 //
     /* 158303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158334 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158341 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158348 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158361 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158378 */     GIR_RootConstrainSelectedInstOperands,
     /* 158379 */     // GIR_Coverage, 22479,
     /* 158379 */     GIR_EraseRootFromParent_Done,
     /* 158380 */   // Label 3457: @158380
     /* 158380 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(158462), // Rule ID 22480 //
     /* 158385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158416 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158423 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158430 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158443 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158460 */     GIR_RootConstrainSelectedInstOperands,
     /* 158461 */     // GIR_Coverage, 22480,
     /* 158461 */     GIR_EraseRootFromParent_Done,
     /* 158462 */   // Label 3458: @158462
     /* 158462 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(158544), // Rule ID 22481 //
     /* 158467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158498 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158501 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158505 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158512 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158525 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158530 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158542 */     GIR_RootConstrainSelectedInstOperands,
     /* 158543 */     // GIR_Coverage, 22481,
     /* 158543 */     GIR_EraseRootFromParent_Done,
     /* 158544 */   // Label 3459: @158544
     /* 158544 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(158609), // Rule ID 23269 //
     /* 158549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158564 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158588 */     // (fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 158591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158607 */     GIR_RootConstrainSelectedInstOperands,
     /* 158608 */     // GIR_Coverage, 23269,
     /* 158608 */     GIR_EraseRootFromParent_Done,
     /* 158609 */   // Label 3460: @158609
     /* 158609 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(158674), // Rule ID 23271 //
     /* 158614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158629 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158653 */     // (fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 158656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158672 */     GIR_RootConstrainSelectedInstOperands,
     /* 158673 */     // GIR_Coverage, 23271,
     /* 158673 */     GIR_EraseRootFromParent_Done,
     /* 158674 */   // Label 3461: @158674
     /* 158674 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(158739), // Rule ID 23259 //
     /* 158679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158718 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 158721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158737 */     GIR_RootConstrainSelectedInstOperands,
     /* 158738 */     // GIR_Coverage, 23259,
     /* 158738 */     GIR_EraseRootFromParent_Done,
     /* 158739 */   // Label 3462: @158739
     /* 158739 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(158801), // Rule ID 23402 //
     /* 158744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158783 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158799 */     GIR_RootConstrainSelectedInstOperands,
     /* 158800 */     // GIR_Coverage, 23402,
     /* 158800 */     GIR_EraseRootFromParent_Done,
     /* 158801 */   // Label 3463: @158801
     /* 158801 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(158863), // Rule ID 23406 //
     /* 158806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158845 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158850 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158852 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158861 */     GIR_RootConstrainSelectedInstOperands,
     /* 158862 */     // GIR_Coverage, 23406,
     /* 158862 */     GIR_EraseRootFromParent_Done,
     /* 158863 */   // Label 3464: @158863
     /* 158863 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(158925), // Rule ID 24252 //
     /* 158868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158907 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158912 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158923 */     GIR_RootConstrainSelectedInstOperands,
     /* 158924 */     // GIR_Coverage, 24252,
     /* 158924 */     GIR_EraseRootFromParent_Done,
     /* 158925 */   // Label 3465: @158925
     /* 158925 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(158990), // Rule ID 987 //
     /* 158930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158949 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158969 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 158972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158976 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158988 */     GIR_RootConstrainSelectedInstOperands,
     /* 158989 */     // GIR_Coverage, 987,
     /* 158989 */     GIR_EraseRootFromParent_Done,
     /* 158990 */   // Label 3466: @158990
     /* 158990 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(159055), // Rule ID 989 //
     /* 158995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 159014 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159034 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 159037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159053 */     GIR_RootConstrainSelectedInstOperands,
     /* 159054 */     // GIR_Coverage, 989,
     /* 159054 */     GIR_EraseRootFromParent_Done,
     /* 159055 */   // Label 3467: @159055
     /* 159055 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(159120), // Rule ID 977 //
     /* 159060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159099 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 159102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159118 */     GIR_RootConstrainSelectedInstOperands,
     /* 159119 */     // GIR_Coverage, 977,
     /* 159119 */     GIR_EraseRootFromParent_Done,
     /* 159120 */   // Label 3468: @159120
     /* 159120 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(159182), // Rule ID 2201 //
     /* 159125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159144 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159164 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 159167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159180 */     GIR_RootConstrainSelectedInstOperands,
     /* 159181 */     // GIR_Coverage, 2201,
     /* 159181 */     GIR_EraseRootFromParent_Done,
     /* 159182 */   // Label 3469: @159182
     /* 159182 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(159244), // Rule ID 2209 //
     /* 159187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159206 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159226 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 159229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159242 */     GIR_RootConstrainSelectedInstOperands,
     /* 159243 */     // GIR_Coverage, 2209,
     /* 159243 */     GIR_EraseRootFromParent_Done,
     /* 159244 */   // Label 3470: @159244
     /* 159244 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(159306), // Rule ID 5974 //
     /* 159249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159288 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 159291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159293 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159304 */     GIR_RootConstrainSelectedInstOperands,
     /* 159305 */     // GIR_Coverage, 5974,
     /* 159305 */     GIR_EraseRootFromParent_Done,
     /* 159306 */   // Label 3471: @159306
     /* 159306 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(159343), // Rule ID 899 //
     /* 159311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159326 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 159326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 159331 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 159337 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 159341 */     GIR_RootConstrainSelectedInstOperands,
     /* 159342 */     // GIR_Coverage, 899,
     /* 159342 */     GIR_Done,
     /* 159343 */   // Label 3472: @159343
     /* 159343 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(159374), // Rule ID 2199 //
     /* 159348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159363 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 159363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 159368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159372 */     GIR_RootConstrainSelectedInstOperands,
     /* 159373 */     // GIR_Coverage, 2199,
     /* 159373 */     GIR_Done,
     /* 159374 */   // Label 3473: @159374
     /* 159374 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(159405), // Rule ID 2207 //
     /* 159379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159394 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 159394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 159399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159403 */     GIR_RootConstrainSelectedInstOperands,
     /* 159404 */     // GIR_Coverage, 2207,
     /* 159404 */     GIR_Done,
     /* 159405 */   // Label 3474: @159405
     /* 159405 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(159436), // Rule ID 5972 //
     /* 159410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159425 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 159425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 159430 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159434 */     GIR_RootConstrainSelectedInstOperands,
     /* 159435 */     // GIR_Coverage, 5972,
     /* 159435 */     GIR_Done,
     /* 159436 */   // Label 3475: @159436
     /* 159436 */   GIM_Reject,
     /* 159437 */ // Label 3453: @159437
     /* 159437 */ GIM_Reject,
     /* 159438 */ // Label 3437: @159438
     /* 159438 */ GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(160978),
     /* 159443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 159446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159449 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(159531), // Rule ID 26027 //
     /* 159454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159481 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159488 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159495 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159512 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 159515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159529 */     GIR_RootConstrainSelectedInstOperands,
     /* 159530 */     // GIR_Coverage, 26027,
     /* 159530 */     GIR_EraseRootFromParent_Done,
     /* 159531 */   // Label 3477: @159531
     /* 159531 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(159613), // Rule ID 26028 //
     /* 159536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159563 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159570 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159577 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159594 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 159597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159611 */     GIR_RootConstrainSelectedInstOperands,
     /* 159612 */     // GIR_Coverage, 26028,
     /* 159612 */     GIR_EraseRootFromParent_Done,
     /* 159613 */   // Label 3478: @159613
     /* 159613 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(159695), // Rule ID 26029 //
     /* 159618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159645 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159652 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159659 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159676 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 159679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159693 */     GIR_RootConstrainSelectedInstOperands,
     /* 159694 */     // GIR_Coverage, 26029,
     /* 159694 */     GIR_EraseRootFromParent_Done,
     /* 159695 */   // Label 3479: @159695
     /* 159695 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(159777), // Rule ID 22482 //
     /* 159700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159731 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159738 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159745 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159758 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 159761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159775 */     GIR_RootConstrainSelectedInstOperands,
     /* 159776 */     // GIR_Coverage, 22482,
     /* 159776 */     GIR_EraseRootFromParent_Done,
     /* 159777 */   // Label 3480: @159777
     /* 159777 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(159859), // Rule ID 22483 //
     /* 159782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159813 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159816 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159820 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159827 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159840 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 159843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159857 */     GIR_RootConstrainSelectedInstOperands,
     /* 159858 */     // GIR_Coverage, 22483,
     /* 159858 */     GIR_EraseRootFromParent_Done,
     /* 159859 */   // Label 3481: @159859
     /* 159859 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(159941), // Rule ID 22484 //
     /* 159864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159895 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159902 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159909 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159922 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 159925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159939 */     GIR_RootConstrainSelectedInstOperands,
     /* 159940 */     // GIR_Coverage, 22484,
     /* 159940 */     GIR_EraseRootFromParent_Done,
     /* 159941 */   // Label 3482: @159941
     /* 159941 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(160006), // Rule ID 23273 //
     /* 159946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 159949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 159953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 159961 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159968 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 159976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159985 */     // (fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 159988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160004 */     GIR_RootConstrainSelectedInstOperands,
     /* 160005 */     // GIR_Coverage, 23273,
     /* 160005 */     GIR_EraseRootFromParent_Done,
     /* 160006 */   // Label 3483: @160006
     /* 160006 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(160071), // Rule ID 23275 //
     /* 160011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160026 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160050 */     // (fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 160053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160055 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160069 */     GIR_RootConstrainSelectedInstOperands,
     /* 160070 */     // GIR_Coverage, 23275,
     /* 160070 */     GIR_EraseRootFromParent_Done,
     /* 160071 */   // Label 3484: @160071
     /* 160071 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(160136), // Rule ID 23261 //
     /* 160076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160115 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 160118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160134 */     GIR_RootConstrainSelectedInstOperands,
     /* 160135 */     // GIR_Coverage, 23261,
     /* 160135 */     GIR_EraseRootFromParent_Done,
     /* 160136 */   // Label 3485: @160136
     /* 160136 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(160208), // Rule ID 23263 //
     /* 160141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160159 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160163 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160187 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 160190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160206 */     GIR_RootConstrainSelectedInstOperands,
     /* 160207 */     // GIR_Coverage, 23263,
     /* 160207 */     GIR_EraseRootFromParent_Done,
     /* 160208 */   // Label 3486: @160208
     /* 160208 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(160270), // Rule ID 23404 //
     /* 160213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160252 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 160255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160268 */     GIR_RootConstrainSelectedInstOperands,
     /* 160269 */     // GIR_Coverage, 23404,
     /* 160269 */     GIR_EraseRootFromParent_Done,
     /* 160270 */   // Label 3487: @160270
     /* 160270 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(160332), // Rule ID 23408 //
     /* 160275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160290 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160314 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 160317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160319 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160330 */     GIR_RootConstrainSelectedInstOperands,
     /* 160331 */     // GIR_Coverage, 23408,
     /* 160331 */     GIR_EraseRootFromParent_Done,
     /* 160332 */   // Label 3488: @160332
     /* 160332 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(160394), // Rule ID 24254 //
     /* 160337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160376 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 160379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160392 */     GIR_RootConstrainSelectedInstOperands,
     /* 160393 */     // GIR_Coverage, 24254,
     /* 160393 */     GIR_EraseRootFromParent_Done,
     /* 160394 */   // Label 3489: @160394
     /* 160394 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(160459), // Rule ID 991 //
     /* 160399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160418 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 160425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160438 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 160441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160457 */     GIR_RootConstrainSelectedInstOperands,
     /* 160458 */     // GIR_Coverage, 991,
     /* 160458 */     GIR_EraseRootFromParent_Done,
     /* 160459 */   // Label 3490: @160459
     /* 160459 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(160524), // Rule ID 993 //
     /* 160464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160483 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160503 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 160506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160522 */     GIR_RootConstrainSelectedInstOperands,
     /* 160523 */     // GIR_Coverage, 993,
     /* 160523 */     GIR_EraseRootFromParent_Done,
     /* 160524 */   // Label 3491: @160524
     /* 160524 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(160589), // Rule ID 979 //
     /* 160529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160568 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 160571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160587 */     GIR_RootConstrainSelectedInstOperands,
     /* 160588 */     // GIR_Coverage, 979,
     /* 160588 */     GIR_EraseRootFromParent_Done,
     /* 160589 */   // Label 3492: @160589
     /* 160589 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(160661), // Rule ID 981 //
     /* 160594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160616 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160620 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160640 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 160643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160659 */     GIR_RootConstrainSelectedInstOperands,
     /* 160660 */     // GIR_Coverage, 981,
     /* 160660 */     GIR_EraseRootFromParent_Done,
     /* 160661 */   // Label 3493: @160661
     /* 160661 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(160723), // Rule ID 2205 //
     /* 160666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160705 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 160708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160721 */     GIR_RootConstrainSelectedInstOperands,
     /* 160722 */     // GIR_Coverage, 2205,
     /* 160722 */     GIR_EraseRootFromParent_Done,
     /* 160723 */   // Label 3494: @160723
     /* 160723 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(160785), // Rule ID 2213 //
     /* 160728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160747 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160754 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160767 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 160770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160783 */     GIR_RootConstrainSelectedInstOperands,
     /* 160784 */     // GIR_Coverage, 2213,
     /* 160784 */     GIR_EraseRootFromParent_Done,
     /* 160785 */   // Label 3495: @160785
     /* 160785 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(160847), // Rule ID 5993 //
     /* 160790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160829 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 160832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160834 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160845 */     GIR_RootConstrainSelectedInstOperands,
     /* 160846 */     // GIR_Coverage, 5993,
     /* 160846 */     GIR_EraseRootFromParent_Done,
     /* 160847 */   // Label 3496: @160847
     /* 160847 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(160884), // Rule ID 901 //
     /* 160852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160867 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 160867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 160872 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 160878 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 160882 */     GIR_RootConstrainSelectedInstOperands,
     /* 160883 */     // GIR_Coverage, 901,
     /* 160883 */     GIR_Done,
     /* 160884 */   // Label 3497: @160884
     /* 160884 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(160915), // Rule ID 2203 //
     /* 160889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160904 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 160904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 160909 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160913 */     GIR_RootConstrainSelectedInstOperands,
     /* 160914 */     // GIR_Coverage, 2203,
     /* 160914 */     GIR_Done,
     /* 160915 */   // Label 3498: @160915
     /* 160915 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(160946), // Rule ID 2211 //
     /* 160920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160935 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 160935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 160940 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160944 */     GIR_RootConstrainSelectedInstOperands,
     /* 160945 */     // GIR_Coverage, 2211,
     /* 160945 */     GIR_Done,
     /* 160946 */   // Label 3499: @160946
     /* 160946 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(160977), // Rule ID 5991 //
     /* 160951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160966 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 160966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 160971 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160975 */     GIR_RootConstrainSelectedInstOperands,
     /* 160976 */     // GIR_Coverage, 5991,
     /* 160976 */     GIR_Done,
     /* 160977 */   // Label 3500: @160977
     /* 160977 */   GIM_Reject,
     /* 160978 */ // Label 3476: @160978
     /* 160978 */ GIM_Reject,
     /* 160979 */ // Label 3438: @160979
     /* 160979 */ GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(161544),
     /* 160984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 160987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 160990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 160994 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(161055), // Rule ID 23277 //
     /* 160999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161010 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161034 */     // (fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 161037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161053 */     GIR_RootConstrainSelectedInstOperands,
     /* 161054 */     // GIR_Coverage, 23277,
     /* 161054 */     GIR_EraseRootFromParent_Done,
     /* 161055 */   // Label 3502: @161055
     /* 161055 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(161116), // Rule ID 23279 //
     /* 161060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161071 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161095 */     // (fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 161098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161114 */     GIR_RootConstrainSelectedInstOperands,
     /* 161115 */     // GIR_Coverage, 23279,
     /* 161115 */     GIR_EraseRootFromParent_Done,
     /* 161116 */   // Label 3503: @161116
     /* 161116 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(161184), // Rule ID 23265 //
     /* 161121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161135 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161139 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161163 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 161166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161182 */     GIR_RootConstrainSelectedInstOperands,
     /* 161183 */     // GIR_Coverage, 23265,
     /* 161183 */     GIR_EraseRootFromParent_Done,
     /* 161184 */   // Label 3504: @161184
     /* 161184 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(161252), // Rule ID 23267 //
     /* 161189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161203 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161207 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 161214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161231 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 161234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161236 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161238 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161250 */     GIR_RootConstrainSelectedInstOperands,
     /* 161251 */     // GIR_Coverage, 23267,
     /* 161251 */     GIR_EraseRootFromParent_Done,
     /* 161252 */   // Label 3505: @161252
     /* 161252 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(161313), // Rule ID 995 //
     /* 161257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161272 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161292 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 161295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161311 */     GIR_RootConstrainSelectedInstOperands,
     /* 161312 */     // GIR_Coverage, 995,
     /* 161312 */     GIR_EraseRootFromParent_Done,
     /* 161313 */   // Label 3506: @161313
     /* 161313 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(161374), // Rule ID 997 //
     /* 161318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161333 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161353 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 161356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161372 */     GIR_RootConstrainSelectedInstOperands,
     /* 161373 */     // GIR_Coverage, 997,
     /* 161373 */     GIR_EraseRootFromParent_Done,
     /* 161374 */   // Label 3507: @161374
     /* 161374 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(161442), // Rule ID 983 //
     /* 161379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161397 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161401 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161421 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 161424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161440 */     GIR_RootConstrainSelectedInstOperands,
     /* 161441 */     // GIR_Coverage, 983,
     /* 161441 */     GIR_EraseRootFromParent_Done,
     /* 161442 */   // Label 3508: @161442
     /* 161442 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(161510), // Rule ID 985 //
     /* 161447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161465 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161469 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 161476 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161489 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 161492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161508 */     GIR_RootConstrainSelectedInstOperands,
     /* 161509 */     // GIR_Coverage, 985,
     /* 161509 */     GIR_EraseRootFromParent_Done,
     /* 161510 */   // Label 3509: @161510
     /* 161510 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(161543), // Rule ID 903 //
     /* 161515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161526 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 161526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 161531 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 161537 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 161541 */     GIR_RootConstrainSelectedInstOperands,
     /* 161542 */     // GIR_Coverage, 903,
     /* 161542 */     GIR_Done,
     /* 161543 */   // Label 3510: @161543
     /* 161543 */   GIM_Reject,
     /* 161544 */ // Label 3501: @161544
     /* 161544 */ GIM_Reject,
     /* 161545 */ // Label 3439: @161545
     /* 161545 */ GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(161898),
     /* 161550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161556 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(161618), // Rule ID 23392 //
     /* 161561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161600 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 161603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161616 */     GIR_RootConstrainSelectedInstOperands,
     /* 161617 */     // GIR_Coverage, 23392,
     /* 161617 */     GIR_EraseRootFromParent_Done,
     /* 161618 */   // Label 3512: @161618
     /* 161618 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(161680), // Rule ID 24368 //
     /* 161623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161662 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 161665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161667 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161678 */     GIR_RootConstrainSelectedInstOperands,
     /* 161679 */     // GIR_Coverage, 24368,
     /* 161679 */     GIR_EraseRootFromParent_Done,
     /* 161680 */   // Label 3513: @161680
     /* 161680 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(161742), // Rule ID 2181 //
     /* 161685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161724 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 161727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161740 */     GIR_RootConstrainSelectedInstOperands,
     /* 161741 */     // GIR_Coverage, 2181,
     /* 161741 */     GIR_EraseRootFromParent_Done,
     /* 161742 */   // Label 3514: @161742
     /* 161742 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(161804), // Rule ID 6426 //
     /* 161747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161786 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 161789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161802 */     GIR_RootConstrainSelectedInstOperands,
     /* 161803 */     // GIR_Coverage, 6426,
     /* 161803 */     GIR_EraseRootFromParent_Done,
     /* 161804 */   // Label 3515: @161804
     /* 161804 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(161835), // Rule ID 2179 //
     /* 161809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161824 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 161824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 161829 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161833 */     GIR_RootConstrainSelectedInstOperands,
     /* 161834 */     // GIR_Coverage, 2179,
     /* 161834 */     GIR_Done,
     /* 161835 */   // Label 3516: @161835
     /* 161835 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(161866), // Rule ID 2195 //
     /* 161840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 161843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161855 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 161855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 161860 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161864 */     GIR_RootConstrainSelectedInstOperands,
     /* 161865 */     // GIR_Coverage, 2195,
     /* 161865 */     GIR_Done,
     /* 161866 */   // Label 3517: @161866
     /* 161866 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(161897), // Rule ID 6422 //
     /* 161871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161886 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 161886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 161891 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161895 */     GIR_RootConstrainSelectedInstOperands,
     /* 161896 */     // GIR_Coverage, 6422,
     /* 161896 */     GIR_Done,
     /* 161897 */   // Label 3518: @161897
     /* 161897 */   GIM_Reject,
     /* 161898 */ // Label 3511: @161898
     /* 161898 */ GIM_Reject,
     /* 161899 */ // Label 3440: @161899
     /* 161899 */ GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(162252),
     /* 161904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161910 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(161972), // Rule ID 23390 //
     /* 161915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161954 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 161957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161970 */     GIR_RootConstrainSelectedInstOperands,
     /* 161971 */     // GIR_Coverage, 23390,
     /* 161971 */     GIR_EraseRootFromParent_Done,
     /* 161972 */   // Label 3520: @161972
     /* 161972 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(162034), // Rule ID 24352 //
     /* 161977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162016 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 162019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162032 */     GIR_RootConstrainSelectedInstOperands,
     /* 162033 */     // GIR_Coverage, 24352,
     /* 162033 */     GIR_EraseRootFromParent_Done,
     /* 162034 */   // Label 3521: @162034
     /* 162034 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(162096), // Rule ID 2177 //
     /* 162039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162078 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 162081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162094 */     GIR_RootConstrainSelectedInstOperands,
     /* 162095 */     // GIR_Coverage, 2177,
     /* 162095 */     GIR_EraseRootFromParent_Done,
     /* 162096 */   // Label 3522: @162096
     /* 162096 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(162158), // Rule ID 6402 //
     /* 162101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162140 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 162143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162156 */     GIR_RootConstrainSelectedInstOperands,
     /* 162157 */     // GIR_Coverage, 6402,
     /* 162157 */     GIR_EraseRootFromParent_Done,
     /* 162158 */   // Label 3523: @162158
     /* 162158 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(162189), // Rule ID 2175 //
     /* 162163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162178 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 162178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 162183 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162187 */     GIR_RootConstrainSelectedInstOperands,
     /* 162188 */     // GIR_Coverage, 2175,
     /* 162188 */     GIR_Done,
     /* 162189 */   // Label 3524: @162189
     /* 162189 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(162220), // Rule ID 2191 //
     /* 162194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 162197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162209 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 162209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 162214 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162218 */     GIR_RootConstrainSelectedInstOperands,
     /* 162219 */     // GIR_Coverage, 2191,
     /* 162219 */     GIR_Done,
     /* 162220 */   // Label 3525: @162220
     /* 162220 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(162251), // Rule ID 6398 //
     /* 162225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162240 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 162240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 162245 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162249 */     GIR_RootConstrainSelectedInstOperands,
     /* 162250 */     // GIR_Coverage, 6398,
     /* 162250 */     GIR_Done,
     /* 162251 */   // Label 3526: @162251
     /* 162251 */   GIM_Reject,
     /* 162252 */ // Label 3519: @162252
     /* 162252 */ GIM_Reject,
     /* 162253 */ // Label 3441: @162253
     /* 162253 */ GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(162575),
     /* 162258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 162261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 162264 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(162326), // Rule ID 23396 //
     /* 162269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162308 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 162311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162324 */     GIR_RootConstrainSelectedInstOperands,
     /* 162325 */     // GIR_Coverage, 23396,
     /* 162325 */     GIR_EraseRootFromParent_Done,
     /* 162326 */   // Label 3528: @162326
     /* 162326 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(162388), // Rule ID 24376 //
     /* 162331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162370 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 162373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162377 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162386 */     GIR_RootConstrainSelectedInstOperands,
     /* 162387 */     // GIR_Coverage, 24376,
     /* 162387 */     GIR_EraseRootFromParent_Done,
     /* 162388 */   // Label 3529: @162388
     /* 162388 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(162450), // Rule ID 2189 //
     /* 162393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162432 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 162435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162448 */     GIR_RootConstrainSelectedInstOperands,
     /* 162449 */     // GIR_Coverage, 2189,
     /* 162449 */     GIR_EraseRootFromParent_Done,
     /* 162450 */   // Label 3530: @162450
     /* 162450 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(162512), // Rule ID 6438 //
     /* 162455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162494 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 162497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162510 */     GIR_RootConstrainSelectedInstOperands,
     /* 162511 */     // GIR_Coverage, 6438,
     /* 162511 */     GIR_EraseRootFromParent_Done,
     /* 162512 */   // Label 3531: @162512
     /* 162512 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(162543), // Rule ID 2187 //
     /* 162517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162532 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 162532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 162537 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162541 */     GIR_RootConstrainSelectedInstOperands,
     /* 162542 */     // GIR_Coverage, 2187,
     /* 162542 */     GIR_Done,
     /* 162543 */   // Label 3532: @162543
     /* 162543 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(162574), // Rule ID 6434 //
     /* 162548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162563 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 162563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 162568 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162572 */     GIR_RootConstrainSelectedInstOperands,
     /* 162573 */     // GIR_Coverage, 6434,
     /* 162573 */     GIR_Done,
     /* 162574 */   // Label 3533: @162574
     /* 162574 */   GIM_Reject,
     /* 162575 */ // Label 3527: @162575
     /* 162575 */ GIM_Reject,
     /* 162576 */ // Label 3442: @162576
     /* 162576 */ GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(162735),
     /* 162581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162591 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(162649), // Rule ID 24392 //
     /* 162596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162631 */     // (fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 162634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162647 */     GIR_RootConstrainSelectedInstOperands,
     /* 162648 */     // GIR_Coverage, 24392,
     /* 162648 */     GIR_EraseRootFromParent_Done,
     /* 162649 */   // Label 3535: @162649
     /* 162649 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(162707), // Rule ID 6462 //
     /* 162654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162669 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162672 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162689 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 162692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162705 */     GIR_RootConstrainSelectedInstOperands,
     /* 162706 */     // GIR_Coverage, 6462,
     /* 162706 */     GIR_EraseRootFromParent_Done,
     /* 162707 */   // Label 3536: @162707
     /* 162707 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(162734), // Rule ID 6458 //
     /* 162712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162723 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 162723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 162728 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162732 */     GIR_RootConstrainSelectedInstOperands,
     /* 162733 */     // GIR_Coverage, 6458,
     /* 162733 */     GIR_Done,
     /* 162734 */   // Label 3537: @162734
     /* 162734 */   GIM_Reject,
     /* 162735 */ // Label 3534: @162735
     /* 162735 */ GIM_Reject,
     /* 162736 */ // Label 3443: @162736
     /* 162736 */ GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(163058),
     /* 162741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 162744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 162747 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(162809), // Rule ID 23394 //
     /* 162752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162791 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 162794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162807 */     GIR_RootConstrainSelectedInstOperands,
     /* 162808 */     // GIR_Coverage, 23394,
     /* 162808 */     GIR_EraseRootFromParent_Done,
     /* 162809 */   // Label 3539: @162809
     /* 162809 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(162871), // Rule ID 24360 //
     /* 162814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162853 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 162856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162869 */     GIR_RootConstrainSelectedInstOperands,
     /* 162870 */     // GIR_Coverage, 24360,
     /* 162870 */     GIR_EraseRootFromParent_Done,
     /* 162871 */   // Label 3540: @162871
     /* 162871 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(162933), // Rule ID 2185 //
     /* 162876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162915 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 162918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162931 */     GIR_RootConstrainSelectedInstOperands,
     /* 162932 */     // GIR_Coverage, 2185,
     /* 162932 */     GIR_EraseRootFromParent_Done,
     /* 162933 */   // Label 3541: @162933
     /* 162933 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(162995), // Rule ID 6414 //
     /* 162938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162977 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 162980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162993 */     GIR_RootConstrainSelectedInstOperands,
     /* 162994 */     // GIR_Coverage, 6414,
     /* 162994 */     GIR_EraseRootFromParent_Done,
     /* 162995 */   // Label 3542: @162995
     /* 162995 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(163026), // Rule ID 2183 //
     /* 163000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 163003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163015 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 163015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 163020 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163024 */     GIR_RootConstrainSelectedInstOperands,
     /* 163025 */     // GIR_Coverage, 2183,
     /* 163025 */     GIR_Done,
     /* 163026 */   // Label 3543: @163026
     /* 163026 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(163057), // Rule ID 6410 //
     /* 163031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163046 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 163046 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 163051 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163055 */     GIR_RootConstrainSelectedInstOperands,
     /* 163056 */     // GIR_Coverage, 6410,
     /* 163056 */     GIR_Done,
     /* 163057 */   // Label 3544: @163057
     /* 163057 */   GIM_Reject,
     /* 163058 */ // Label 3538: @163058
     /* 163058 */ GIM_Reject,
     /* 163059 */ // Label 3444: @163059
     /* 163059 */ GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(163218),
     /* 163064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 163067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 163070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163074 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(163132), // Rule ID 24344 //
     /* 163079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163114 */     // (fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 163117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163130 */     GIR_RootConstrainSelectedInstOperands,
     /* 163131 */     // GIR_Coverage, 24344,
     /* 163131 */     GIR_EraseRootFromParent_Done,
     /* 163132 */   // Label 3546: @163132
     /* 163132 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(163190), // Rule ID 6390 //
     /* 163137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163172 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 163175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163188 */     GIR_RootConstrainSelectedInstOperands,
     /* 163189 */     // GIR_Coverage, 6390,
     /* 163189 */     GIR_EraseRootFromParent_Done,
     /* 163190 */   // Label 3547: @163190
     /* 163190 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(163217), // Rule ID 6386 //
     /* 163195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163206 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 163206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 163211 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163215 */     GIR_RootConstrainSelectedInstOperands,
     /* 163216 */     // GIR_Coverage, 6386,
     /* 163216 */     GIR_Done,
     /* 163217 */   // Label 3548: @163217
     /* 163217 */   GIM_Reject,
     /* 163218 */ // Label 3545: @163218
     /* 163218 */ GIM_Reject,
     /* 163219 */ // Label 3445: @163219
     /* 163219 */ GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(163378),
     /* 163224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 163227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 163230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163234 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(163292), // Rule ID 24400 //
     /* 163239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163257 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163274 */     // (fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163290 */     GIR_RootConstrainSelectedInstOperands,
     /* 163291 */     // GIR_Coverage, 24400,
     /* 163291 */     GIR_EraseRootFromParent_Done,
     /* 163292 */   // Label 3550: @163292
     /* 163292 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(163350), // Rule ID 6474 //
     /* 163297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163332 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 163335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163348 */     GIR_RootConstrainSelectedInstOperands,
     /* 163349 */     // GIR_Coverage, 6474,
     /* 163349 */     GIR_EraseRootFromParent_Done,
     /* 163350 */   // Label 3551: @163350
     /* 163350 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(163377), // Rule ID 6470 //
     /* 163355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163366 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 163366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 163371 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163375 */     GIR_RootConstrainSelectedInstOperands,
     /* 163376 */     // GIR_Coverage, 6470,
     /* 163376 */     GIR_Done,
     /* 163377 */   // Label 3552: @163377
     /* 163377 */   GIM_Reject,
     /* 163378 */ // Label 3549: @163378
     /* 163378 */ GIM_Reject,
     /* 163379 */ // Label 3446: @163379
     /* 163379 */ GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(163538),
     /* 163384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 163387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 163390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163394 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(163452), // Rule ID 24336 //
     /* 163399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163434 */     // (fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 163437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163450 */     GIR_RootConstrainSelectedInstOperands,
     /* 163451 */     // GIR_Coverage, 24336,
     /* 163451 */     GIR_EraseRootFromParent_Done,
     /* 163452 */   // Label 3554: @163452
     /* 163452 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(163510), // Rule ID 6378 //
     /* 163457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163492 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 163495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163508 */     GIR_RootConstrainSelectedInstOperands,
     /* 163509 */     // GIR_Coverage, 6378,
     /* 163509 */     GIR_EraseRootFromParent_Done,
     /* 163510 */   // Label 3555: @163510
     /* 163510 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(163537), // Rule ID 6374 //
     /* 163515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163526 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 163526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 163531 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163535 */     GIR_RootConstrainSelectedInstOperands,
     /* 163536 */     // GIR_Coverage, 6374,
     /* 163536 */     GIR_Done,
     /* 163537 */   // Label 3556: @163537
     /* 163537 */   GIM_Reject,
     /* 163538 */ // Label 3553: @163538
     /* 163538 */ GIM_Reject,
     /* 163539 */ // Label 3447: @163539
     /* 163539 */ GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(163698),
     /* 163544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 163547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 163550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163554 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(163612), // Rule ID 24384 //
     /* 163559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163594 */     // (fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 163597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163610 */     GIR_RootConstrainSelectedInstOperands,
     /* 163611 */     // GIR_Coverage, 24384,
     /* 163611 */     GIR_EraseRootFromParent_Done,
     /* 163612 */   // Label 3558: @163612
     /* 163612 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(163670), // Rule ID 6450 //
     /* 163617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163652 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 163655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163668 */     GIR_RootConstrainSelectedInstOperands,
     /* 163669 */     // GIR_Coverage, 6450,
     /* 163669 */     GIR_EraseRootFromParent_Done,
     /* 163670 */   // Label 3559: @163670
     /* 163670 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(163697), // Rule ID 6446 //
     /* 163675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163686 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 163686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 163691 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163695 */     GIR_RootConstrainSelectedInstOperands,
     /* 163696 */     // GIR_Coverage, 6446,
     /* 163696 */     GIR_Done,
     /* 163697 */   // Label 3560: @163697
     /* 163697 */   GIM_Reject,
     /* 163698 */ // Label 3557: @163698
     /* 163698 */ GIM_Reject,
     /* 163699 */ // Label 3448: @163699
     /* 163699 */ GIM_Reject,
     /* 163700 */ // Label 44: @163700
     /* 163700 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3573*/ GIMT_Encode4(169687),
     /* 163711 */ /*GILLT_s16*//*Label 3561*/ GIMT_Encode4(163795),
     /* 163715 */ /*GILLT_s32*//*Label 3562*/ GIMT_Encode4(164040),
     /* 163719 */ /*GILLT_s64*//*Label 3563*/ GIMT_Encode4(164777), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163735 */ /*GILLT_v2s64*//*Label 3564*/ GIMT_Encode4(165514), GIMT_Encode4(0),
     /* 163743 */ /*GILLT_v4s32*//*Label 3565*/ GIMT_Encode4(166251),
     /* 163747 */ /*GILLT_v4s64*//*Label 3566*/ GIMT_Encode4(166988), GIMT_Encode4(0),
     /* 163755 */ /*GILLT_v8s16*//*Label 3567*/ GIMT_Encode4(167725),
     /* 163759 */ /*GILLT_v8s32*//*Label 3568*/ GIMT_Encode4(167970),
     /* 163763 */ /*GILLT_v8s64*//*Label 3569*/ GIMT_Encode4(168707), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163775 */ /*GILLT_v16s16*//*Label 3570*/ GIMT_Encode4(168952),
     /* 163779 */ /*GILLT_v16s32*//*Label 3571*/ GIMT_Encode4(169197), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163791 */ /*GILLT_v32s16*//*Label 3572*/ GIMT_Encode4(169442),
     /* 163795 */ // Label 3561: @163795
     /* 163795 */ GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(164039),
     /* 163800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 163803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 163809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163813 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(163877), // Rule ID 10158 //
     /* 163818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163857 */     // (fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 163860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163864 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163875 */     GIR_RootConstrainSelectedInstOperands,
     /* 163876 */     // GIR_Coverage, 10158,
     /* 163876 */     GIR_EraseRootFromParent_Done,
     /* 163877 */   // Label 3575: @163877
     /* 163877 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(163941), // Rule ID 10156 //
     /* 163882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163921 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 163924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163926 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163939 */     GIR_RootConstrainSelectedInstOperands,
     /* 163940 */     // GIR_Coverage, 10156,
     /* 163940 */     GIR_EraseRootFromParent_Done,
     /* 163941 */   // Label 3576: @163941
     /* 163941 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(164005), // Rule ID 10153 //
     /* 163946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163985 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 163988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164003 */     GIR_RootConstrainSelectedInstOperands,
     /* 164004 */     // GIR_Coverage, 10153,
     /* 164004 */     GIR_EraseRootFromParent_Done,
     /* 164005 */   // Label 3577: @164005
     /* 164005 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(164038), // Rule ID 10151 //
     /* 164010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 164013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164025 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 164025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 164028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164034 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164036 */     GIR_RootConstrainSelectedInstOperands,
     /* 164037 */     // GIR_Coverage, 10151,
     /* 164037 */     GIR_EraseRootFromParent_Done,
     /* 164038 */   // Label 3578: @164038
     /* 164038 */   GIM_Reject,
     /* 164039 */ // Label 3574: @164039
     /* 164039 */ GIM_Reject,
     /* 164040 */ // Label 3562: @164040
     /* 164040 */ GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(164776),
     /* 164045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164054 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(164122), // Rule ID 1304 //
     /* 164059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164102 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 164105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164109 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164120 */     GIR_RootConstrainSelectedInstOperands,
     /* 164121 */     // GIR_Coverage, 1304,
     /* 164121 */     GIR_EraseRootFromParent_Done,
     /* 164122 */   // Label 3580: @164122
     /* 164122 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(164190), // Rule ID 10140 //
     /* 164127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164170 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 164173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164188 */     GIR_RootConstrainSelectedInstOperands,
     /* 164189 */     // GIR_Coverage, 10140,
     /* 164189 */     GIR_EraseRootFromParent_Done,
     /* 164190 */   // Label 3581: @164190
     /* 164190 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(164258), // Rule ID 23281 //
     /* 164195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164238 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 164241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164249 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164256 */     GIR_RootConstrainSelectedInstOperands,
     /* 164257 */     // GIR_Coverage, 23281,
     /* 164257 */     GIR_EraseRootFromParent_Done,
     /* 164258 */   // Label 3582: @164258
     /* 164258 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(164326), // Rule ID 1302 //
     /* 164263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164306 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 164309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164311 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164324 */     GIR_RootConstrainSelectedInstOperands,
     /* 164325 */     // GIR_Coverage, 1302,
     /* 164325 */     GIR_EraseRootFromParent_Done,
     /* 164326 */   // Label 3583: @164326
     /* 164326 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(164394), // Rule ID 1366 //
     /* 164331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164374 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 164377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164385 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164392 */     GIR_RootConstrainSelectedInstOperands,
     /* 164393 */     // GIR_Coverage, 1366,
     /* 164393 */     GIR_EraseRootFromParent_Done,
     /* 164394 */   // Label 3584: @164394
     /* 164394 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(164462), // Rule ID 10138 //
     /* 164399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164442 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 164445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164447 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164460 */     GIR_RootConstrainSelectedInstOperands,
     /* 164461 */     // GIR_Coverage, 10138,
     /* 164461 */     GIR_EraseRootFromParent_Done,
     /* 164462 */   // Label 3585: @164462
     /* 164462 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(164530), // Rule ID 1300 //
     /* 164467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164490 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164497 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164510 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 164513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164528 */     GIR_RootConstrainSelectedInstOperands,
     /* 164529 */     // GIR_Coverage, 1300,
     /* 164529 */     GIR_EraseRootFromParent_Done,
     /* 164530 */   // Label 3586: @164530
     /* 164530 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(164598), // Rule ID 1364 //
     /* 164535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164578 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 164581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 164587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164596 */     GIR_RootConstrainSelectedInstOperands,
     /* 164597 */     // GIR_Coverage, 1364,
     /* 164597 */     GIR_EraseRootFromParent_Done,
     /* 164598 */   // Label 3587: @164598
     /* 164598 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(164666), // Rule ID 10135 //
     /* 164603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164633 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164646 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 164649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164651 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164664 */     GIR_RootConstrainSelectedInstOperands,
     /* 164665 */     // GIR_Coverage, 10135,
     /* 164665 */     GIR_EraseRootFromParent_Done,
     /* 164666 */   // Label 3588: @164666
     /* 164666 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(164703), // Rule ID 1298 //
     /* 164671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164690 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 164693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164701 */     GIR_RootConstrainSelectedInstOperands,
     /* 164702 */     // GIR_Coverage, 1298,
     /* 164702 */     GIR_EraseRootFromParent_Done,
     /* 164703 */   // Label 3589: @164703
     /* 164703 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(164738), // Rule ID 1362 //
     /* 164708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164727 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 164732 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 164736 */     GIR_RootConstrainSelectedInstOperands,
     /* 164737 */     // GIR_Coverage, 1362,
     /* 164737 */     GIR_Done,
     /* 164738 */   // Label 3590: @164738
     /* 164738 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(164775), // Rule ID 10133 //
     /* 164743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164762 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 164762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 164765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164771 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164773 */     GIR_RootConstrainSelectedInstOperands,
     /* 164774 */     // GIR_Coverage, 10133,
     /* 164774 */     GIR_EraseRootFromParent_Done,
     /* 164775 */   // Label 3591: @164775
     /* 164775 */   GIM_Reject,
     /* 164776 */ // Label 3579: @164776
     /* 164776 */ GIM_Reject,
     /* 164777 */ // Label 3563: @164777
     /* 164777 */ GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(165513),
     /* 164782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164791 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(164859), // Rule ID 1312 //
     /* 164796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164839 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 164842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164846 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164857 */     GIR_RootConstrainSelectedInstOperands,
     /* 164858 */     // GIR_Coverage, 1312,
     /* 164858 */     GIR_EraseRootFromParent_Done,
     /* 164859 */   // Label 3593: @164859
     /* 164859 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(164927), // Rule ID 10149 //
     /* 164864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164879 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164882 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164907 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 164910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164912 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164914 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164925 */     GIR_RootConstrainSelectedInstOperands,
     /* 164926 */     // GIR_Coverage, 10149,
     /* 164926 */     GIR_EraseRootFromParent_Done,
     /* 164927 */   // Label 3594: @164927
     /* 164927 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(164995), // Rule ID 23309 //
     /* 164932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164975 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 164975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 164978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164986 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164993 */     GIR_RootConstrainSelectedInstOperands,
     /* 164994 */     // GIR_Coverage, 23309,
     /* 164994 */     GIR_EraseRootFromParent_Done,
     /* 164995 */   // Label 3595: @164995
     /* 164995 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(165063), // Rule ID 1310 //
     /* 165000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165019 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165022 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165026 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165043 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 165046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165048 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165061 */     GIR_RootConstrainSelectedInstOperands,
     /* 165062 */     // GIR_Coverage, 1310,
     /* 165062 */     GIR_EraseRootFromParent_Done,
     /* 165063 */   // Label 3596: @165063
     /* 165063 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(165131), // Rule ID 1450 //
     /* 165068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165111 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 165114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165122 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165129 */     GIR_RootConstrainSelectedInstOperands,
     /* 165130 */     // GIR_Coverage, 1450,
     /* 165130 */     GIR_EraseRootFromParent_Done,
     /* 165131 */   // Label 3597: @165131
     /* 165131 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(165199), // Rule ID 10147 //
     /* 165136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165179 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 165182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165184 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165197 */     GIR_RootConstrainSelectedInstOperands,
     /* 165198 */     // GIR_Coverage, 10147,
     /* 165198 */     GIR_EraseRootFromParent_Done,
     /* 165199 */   // Label 3598: @165199
     /* 165199 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(165267), // Rule ID 1308 //
     /* 165204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165247 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 165250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165252 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165265 */     GIR_RootConstrainSelectedInstOperands,
     /* 165266 */     // GIR_Coverage, 1308,
     /* 165266 */     GIR_EraseRootFromParent_Done,
     /* 165267 */   // Label 3599: @165267
     /* 165267 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(165335), // Rule ID 1448 //
     /* 165272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165315 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 165318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165322 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 165324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165333 */     GIR_RootConstrainSelectedInstOperands,
     /* 165334 */     // GIR_Coverage, 1448,
     /* 165334 */     GIR_EraseRootFromParent_Done,
     /* 165335 */   // Label 3600: @165335
     /* 165335 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(165403), // Rule ID 10144 //
     /* 165340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165383 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 165386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165388 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165401 */     GIR_RootConstrainSelectedInstOperands,
     /* 165402 */     // GIR_Coverage, 10144,
     /* 165402 */     GIR_EraseRootFromParent_Done,
     /* 165403 */   // Label 3601: @165403
     /* 165403 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(165440), // Rule ID 1306 //
     /* 165408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165427 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 165430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165436 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165438 */     GIR_RootConstrainSelectedInstOperands,
     /* 165439 */     // GIR_Coverage, 1306,
     /* 165439 */     GIR_EraseRootFromParent_Done,
     /* 165440 */   // Label 3602: @165440
     /* 165440 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(165475), // Rule ID 1446 //
     /* 165445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165464 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 165469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 165473 */     GIR_RootConstrainSelectedInstOperands,
     /* 165474 */     // GIR_Coverage, 1446,
     /* 165474 */     GIR_Done,
     /* 165475 */   // Label 3603: @165475
     /* 165475 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(165512), // Rule ID 10142 //
     /* 165480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165499 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 165499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 165502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165504 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165510 */     GIR_RootConstrainSelectedInstOperands,
     /* 165511 */     // GIR_Coverage, 10142,
     /* 165511 */     GIR_EraseRootFromParent_Done,
     /* 165512 */   // Label 3604: @165512
     /* 165512 */   GIM_Reject,
     /* 165513 */ // Label 3592: @165513
     /* 165513 */ GIM_Reject,
     /* 165514 */ // Label 3564: @165514
     /* 165514 */ GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(166250),
     /* 165519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165528 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(165596), // Rule ID 1192 //
     /* 165533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165576 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 165579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165583 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165594 */     GIR_RootConstrainSelectedInstOperands,
     /* 165595 */     // GIR_Coverage, 1192,
     /* 165595 */     GIR_EraseRootFromParent_Done,
     /* 165596 */   // Label 3606: @165596
     /* 165596 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(165664), // Rule ID 9681 //
     /* 165601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165644 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 165647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165651 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165662 */     GIR_RootConstrainSelectedInstOperands,
     /* 165663 */     // GIR_Coverage, 9681,
     /* 165663 */     GIR_EraseRootFromParent_Done,
     /* 165664 */   // Label 3607: @165664
     /* 165664 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(165732), // Rule ID 23317 //
     /* 165669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165684 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165691 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165712 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 165712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 165715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165717 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165723 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165730 */     GIR_RootConstrainSelectedInstOperands,
     /* 165731 */     // GIR_Coverage, 23317,
     /* 165731 */     GIR_EraseRootFromParent_Done,
     /* 165732 */   // Label 3608: @165732
     /* 165732 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(165800), // Rule ID 1190 //
     /* 165737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165780 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 165783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165785 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165798 */     GIR_RootConstrainSelectedInstOperands,
     /* 165799 */     // GIR_Coverage, 1190,
     /* 165799 */     GIR_EraseRootFromParent_Done,
     /* 165800 */   // Label 3609: @165800
     /* 165800 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(165868), // Rule ID 1474 //
     /* 165805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165824 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165827 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165831 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165848 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 165848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 165851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165859 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165866 */     GIR_RootConstrainSelectedInstOperands,
     /* 165867 */     // GIR_Coverage, 1474,
     /* 165867 */     GIR_EraseRootFromParent_Done,
     /* 165868 */   // Label 3610: @165868
     /* 165868 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(165936), // Rule ID 9141 //
     /* 165873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165916 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 165919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165921 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165923 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165934 */     GIR_RootConstrainSelectedInstOperands,
     /* 165935 */     // GIR_Coverage, 9141,
     /* 165935 */     GIR_EraseRootFromParent_Done,
     /* 165936 */   // Label 3611: @165936
     /* 165936 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(166004), // Rule ID 1188 //
     /* 165941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165984 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 165987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165989 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165993 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166002 */     GIR_RootConstrainSelectedInstOperands,
     /* 166003 */     // GIR_Coverage, 1188,
     /* 166003 */     GIR_EraseRootFromParent_Done,
     /* 166004 */   // Label 3612: @166004
     /* 166004 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(166072), // Rule ID 1472 //
     /* 166009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166052 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 166055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166070 */     GIR_RootConstrainSelectedInstOperands,
     /* 166071 */     // GIR_Coverage, 1472,
     /* 166071 */     GIR_EraseRootFromParent_Done,
     /* 166072 */   // Label 3613: @166072
     /* 166072 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(166140), // Rule ID 8514 //
     /* 166077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166120 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 166123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166127 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166138 */     GIR_RootConstrainSelectedInstOperands,
     /* 166139 */     // GIR_Coverage, 8514,
     /* 166139 */     GIR_EraseRootFromParent_Done,
     /* 166140 */   // Label 3614: @166140
     /* 166140 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(166177), // Rule ID 1186 //
     /* 166145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166164 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 166164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 166167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166171 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166173 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166175 */     GIR_RootConstrainSelectedInstOperands,
     /* 166176 */     // GIR_Coverage, 1186,
     /* 166176 */     GIR_EraseRootFromParent_Done,
     /* 166177 */   // Label 3615: @166177
     /* 166177 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(166212), // Rule ID 1470 //
     /* 166182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166201 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 166201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 166206 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166210 */     GIR_RootConstrainSelectedInstOperands,
     /* 166211 */     // GIR_Coverage, 1470,
     /* 166211 */     GIR_Done,
     /* 166212 */   // Label 3616: @166212
     /* 166212 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(166249), // Rule ID 8510 //
     /* 166217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166236 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 166236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 166239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166245 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166247 */     GIR_RootConstrainSelectedInstOperands,
     /* 166248 */     // GIR_Coverage, 8510,
     /* 166248 */     GIR_EraseRootFromParent_Done,
     /* 166249 */   // Label 3617: @166249
     /* 166249 */   GIM_Reject,
     /* 166250 */ // Label 3605: @166250
     /* 166250 */ GIM_Reject,
     /* 166251 */ // Label 3565: @166251
     /* 166251 */ GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(166987),
     /* 166256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166265 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(166333), // Rule ID 1144 //
     /* 166270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166285 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166313 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 166316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166320 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166331 */     GIR_RootConstrainSelectedInstOperands,
     /* 166332 */     // GIR_Coverage, 1144,
     /* 166332 */     GIR_EraseRootFromParent_Done,
     /* 166333 */   // Label 3619: @166333
     /* 166333 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(166401), // Rule ID 9649 //
     /* 166338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166381 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 166384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166386 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166388 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166399 */     GIR_RootConstrainSelectedInstOperands,
     /* 166400 */     // GIR_Coverage, 9649,
     /* 166400 */     GIR_EraseRootFromParent_Done,
     /* 166401 */   // Label 3620: @166401
     /* 166401 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(166469), // Rule ID 23289 //
     /* 166406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166421 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166424 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166428 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166449 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 166452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166460 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166467 */     GIR_RootConstrainSelectedInstOperands,
     /* 166468 */     // GIR_Coverage, 23289,
     /* 166468 */     GIR_EraseRootFromParent_Done,
     /* 166469 */   // Label 3621: @166469
     /* 166469 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(166537), // Rule ID 1142 //
     /* 166474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166517 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 166520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166522 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166535 */     GIR_RootConstrainSelectedInstOperands,
     /* 166536 */     // GIR_Coverage, 1142,
     /* 166536 */     GIR_EraseRootFromParent_Done,
     /* 166537 */   // Label 3622: @166537
     /* 166537 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(166605), // Rule ID 1390 //
     /* 166542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166585 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 166588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166596 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166603 */     GIR_RootConstrainSelectedInstOperands,
     /* 166604 */     // GIR_Coverage, 1390,
     /* 166604 */     GIR_EraseRootFromParent_Done,
     /* 166605 */   // Label 3623: @166605
     /* 166605 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(166673), // Rule ID 9109 //
     /* 166610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166653 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 166656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166658 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166671 */     GIR_RootConstrainSelectedInstOperands,
     /* 166672 */     // GIR_Coverage, 9109,
     /* 166672 */     GIR_EraseRootFromParent_Done,
     /* 166673 */   // Label 3624: @166673
     /* 166673 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(166741), // Rule ID 1140 //
     /* 166678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166701 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166708 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166721 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 166724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166726 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166728 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166739 */     GIR_RootConstrainSelectedInstOperands,
     /* 166740 */     // GIR_Coverage, 1140,
     /* 166740 */     GIR_EraseRootFromParent_Done,
     /* 166741 */   // Label 3625: @166741
     /* 166741 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(166809), // Rule ID 1388 //
     /* 166746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166789 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 166792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166807 */     GIR_RootConstrainSelectedInstOperands,
     /* 166808 */     // GIR_Coverage, 1388,
     /* 166808 */     GIR_EraseRootFromParent_Done,
     /* 166809 */   // Label 3626: @166809
     /* 166809 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(166877), // Rule ID 8475 //
     /* 166814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166857 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 166860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166875 */     GIR_RootConstrainSelectedInstOperands,
     /* 166876 */     // GIR_Coverage, 8475,
     /* 166876 */     GIR_EraseRootFromParent_Done,
     /* 166877 */   // Label 3627: @166877
     /* 166877 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(166914), // Rule ID 1138 //
     /* 166882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166901 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 166904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166910 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166912 */     GIR_RootConstrainSelectedInstOperands,
     /* 166913 */     // GIR_Coverage, 1138,
     /* 166913 */     GIR_EraseRootFromParent_Done,
     /* 166914 */   // Label 3628: @166914
     /* 166914 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(166949), // Rule ID 1386 //
     /* 166919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166938 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 166943 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166947 */     GIR_RootConstrainSelectedInstOperands,
     /* 166948 */     // GIR_Coverage, 1386,
     /* 166948 */     GIR_Done,
     /* 166949 */   // Label 3629: @166949
     /* 166949 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(166986), // Rule ID 8471 //
     /* 166954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166973 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 166973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 166976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166980 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166982 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166984 */     GIR_RootConstrainSelectedInstOperands,
     /* 166985 */     // GIR_Coverage, 8471,
     /* 166985 */     GIR_EraseRootFromParent_Done,
     /* 166986 */   // Label 3630: @166986
     /* 166986 */   GIM_Reject,
     /* 166987 */ // Label 3618: @166987
     /* 166987 */ GIM_Reject,
     /* 166988 */ // Label 3566: @166988
     /* 166988 */ GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(167724),
     /* 166993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 166996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 166999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 167002 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(167070), // Rule ID 1200 //
     /* 167007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167050 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 167053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167055 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167057 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167068 */     GIR_RootConstrainSelectedInstOperands,
     /* 167069 */     // GIR_Coverage, 1200,
     /* 167069 */     GIR_EraseRootFromParent_Done,
     /* 167070 */   // Label 3632: @167070
     /* 167070 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(167138), // Rule ID 9671 //
     /* 167075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167118 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 167121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167123 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167125 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167136 */     GIR_RootConstrainSelectedInstOperands,
     /* 167137 */     // GIR_Coverage, 9671,
     /* 167137 */     GIR_EraseRootFromParent_Done,
     /* 167138 */   // Label 3633: @167138
     /* 167138 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(167206), // Rule ID 23319 //
     /* 167143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167186 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 167189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167204 */     GIR_RootConstrainSelectedInstOperands,
     /* 167205 */     // GIR_Coverage, 23319,
     /* 167205 */     GIR_EraseRootFromParent_Done,
     /* 167206 */   // Label 3634: @167206
     /* 167206 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(167274), // Rule ID 1198 //
     /* 167211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167254 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 167257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167259 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167272 */     GIR_RootConstrainSelectedInstOperands,
     /* 167273 */     // GIR_Coverage, 1198,
     /* 167273 */     GIR_EraseRootFromParent_Done,
     /* 167274 */   // Label 3635: @167274
     /* 167274 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(167342), // Rule ID 1480 //
     /* 167279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167322 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 167325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167333 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167340 */     GIR_RootConstrainSelectedInstOperands,
     /* 167341 */     // GIR_Coverage, 1480,
     /* 167341 */     GIR_EraseRootFromParent_Done,
     /* 167342 */   // Label 3636: @167342
     /* 167342 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(167410), // Rule ID 9131 //
     /* 167347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167390 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 167393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167395 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167408 */     GIR_RootConstrainSelectedInstOperands,
     /* 167409 */     // GIR_Coverage, 9131,
     /* 167409 */     GIR_EraseRootFromParent_Done,
     /* 167410 */   // Label 3637: @167410
     /* 167410 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(167478), // Rule ID 1196 //
     /* 167415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167458 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 167461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167476 */     GIR_RootConstrainSelectedInstOperands,
     /* 167477 */     // GIR_Coverage, 1196,
     /* 167477 */     GIR_EraseRootFromParent_Done,
     /* 167478 */   // Label 3638: @167478
     /* 167478 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(167546), // Rule ID 1478 //
     /* 167483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167526 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 167529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 167535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167544 */     GIR_RootConstrainSelectedInstOperands,
     /* 167545 */     // GIR_Coverage, 1478,
     /* 167545 */     GIR_EraseRootFromParent_Done,
     /* 167546 */   // Label 3639: @167546
     /* 167546 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(167614), // Rule ID 8502 //
     /* 167551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167594 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 167597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167612 */     GIR_RootConstrainSelectedInstOperands,
     /* 167613 */     // GIR_Coverage, 8502,
     /* 167613 */     GIR_EraseRootFromParent_Done,
     /* 167614 */   // Label 3640: @167614
     /* 167614 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(167651), // Rule ID 1194 //
     /* 167619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167638 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 167641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167647 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167649 */     GIR_RootConstrainSelectedInstOperands,
     /* 167650 */     // GIR_Coverage, 1194,
     /* 167650 */     GIR_EraseRootFromParent_Done,
     /* 167651 */   // Label 3641: @167651
     /* 167651 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(167686), // Rule ID 1476 //
     /* 167656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167675 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 167680 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167684 */     GIR_RootConstrainSelectedInstOperands,
     /* 167685 */     // GIR_Coverage, 1476,
     /* 167685 */     GIR_Done,
     /* 167686 */   // Label 3642: @167686
     /* 167686 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(167723), // Rule ID 8498 //
     /* 167691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167710 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 167710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 167713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167719 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167721 */     GIR_RootConstrainSelectedInstOperands,
     /* 167722 */     // GIR_Coverage, 8498,
     /* 167722 */     GIR_EraseRootFromParent_Done,
     /* 167723 */   // Label 3643: @167723
     /* 167723 */   GIM_Reject,
     /* 167724 */ // Label 3631: @167724
     /* 167724 */ GIM_Reject,
     /* 167725 */ // Label 3567: @167725
     /* 167725 */ GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(167969),
     /* 167730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 167733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167743 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(167807), // Rule ID 9617 //
     /* 167748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167787 */     // (fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 167790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167794 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167805 */     GIR_RootConstrainSelectedInstOperands,
     /* 167806 */     // GIR_Coverage, 9617,
     /* 167806 */     GIR_EraseRootFromParent_Done,
     /* 167807 */   // Label 3645: @167807
     /* 167807 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(167871), // Rule ID 9077 //
     /* 167812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167851 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 167854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167856 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167869 */     GIR_RootConstrainSelectedInstOperands,
     /* 167870 */     // GIR_Coverage, 9077,
     /* 167870 */     GIR_EraseRootFromParent_Done,
     /* 167871 */   // Label 3646: @167871
     /* 167871 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(167935), // Rule ID 8436 //
     /* 167876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167895 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167902 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167915 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 167918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167933 */     GIR_RootConstrainSelectedInstOperands,
     /* 167934 */     // GIR_Coverage, 8436,
     /* 167934 */     GIR_EraseRootFromParent_Done,
     /* 167935 */   // Label 3647: @167935
     /* 167935 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(167968), // Rule ID 8432 //
     /* 167940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167955 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 167955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 167958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167964 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167966 */     GIR_RootConstrainSelectedInstOperands,
     /* 167967 */     // GIR_Coverage, 8432,
     /* 167967 */     GIR_EraseRootFromParent_Done,
     /* 167968 */   // Label 3648: @167968
     /* 167968 */   GIM_Reject,
     /* 167969 */ // Label 3644: @167969
     /* 167969 */ GIM_Reject,
     /* 167970 */ // Label 3568: @167970
     /* 167970 */ GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(168706),
     /* 167975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 167978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 167981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 167984 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(168052), // Rule ID 1152 //
     /* 167989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168032 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 168035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168037 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168039 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168050 */     GIR_RootConstrainSelectedInstOperands,
     /* 168051 */     // GIR_Coverage, 1152,
     /* 168051 */     GIR_EraseRootFromParent_Done,
     /* 168052 */   // Label 3650: @168052
     /* 168052 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(168120), // Rule ID 9639 //
     /* 168057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168100 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 168103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168107 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168118 */     GIR_RootConstrainSelectedInstOperands,
     /* 168119 */     // GIR_Coverage, 9639,
     /* 168119 */     GIR_EraseRootFromParent_Done,
     /* 168120 */   // Label 3651: @168120
     /* 168120 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(168188), // Rule ID 23291 //
     /* 168125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168168 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 168171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168179 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168186 */     GIR_RootConstrainSelectedInstOperands,
     /* 168187 */     // GIR_Coverage, 23291,
     /* 168187 */     GIR_EraseRootFromParent_Done,
     /* 168188 */   // Label 3652: @168188
     /* 168188 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(168256), // Rule ID 1150 //
     /* 168193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168236 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 168239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168241 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168254 */     GIR_RootConstrainSelectedInstOperands,
     /* 168255 */     // GIR_Coverage, 1150,
     /* 168255 */     GIR_EraseRootFromParent_Done,
     /* 168256 */   // Label 3653: @168256
     /* 168256 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(168324), // Rule ID 1396 //
     /* 168261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168304 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 168307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168315 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168322 */     GIR_RootConstrainSelectedInstOperands,
     /* 168323 */     // GIR_Coverage, 1396,
     /* 168323 */     GIR_EraseRootFromParent_Done,
     /* 168324 */   // Label 3654: @168324
     /* 168324 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(168392), // Rule ID 9099 //
     /* 168329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168372 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 168375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168377 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168390 */     GIR_RootConstrainSelectedInstOperands,
     /* 168391 */     // GIR_Coverage, 9099,
     /* 168391 */     GIR_EraseRootFromParent_Done,
     /* 168392 */   // Label 3655: @168392
     /* 168392 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(168460), // Rule ID 1148 //
     /* 168397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168440 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 168443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168458 */     GIR_RootConstrainSelectedInstOperands,
     /* 168459 */     // GIR_Coverage, 1148,
     /* 168459 */     GIR_EraseRootFromParent_Done,
     /* 168460 */   // Label 3656: @168460
     /* 168460 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(168528), // Rule ID 1394 //
     /* 168465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168508 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 168511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 168517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168526 */     GIR_RootConstrainSelectedInstOperands,
     /* 168527 */     // GIR_Coverage, 1394,
     /* 168527 */     GIR_EraseRootFromParent_Done,
     /* 168528 */   // Label 3657: @168528
     /* 168528 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(168596), // Rule ID 8463 //
     /* 168533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168576 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 168579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168594 */     GIR_RootConstrainSelectedInstOperands,
     /* 168595 */     // GIR_Coverage, 8463,
     /* 168595 */     GIR_EraseRootFromParent_Done,
     /* 168596 */   // Label 3658: @168596
     /* 168596 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(168633), // Rule ID 1146 //
     /* 168601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168620 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 168623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168629 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168631 */     GIR_RootConstrainSelectedInstOperands,
     /* 168632 */     // GIR_Coverage, 1146,
     /* 168632 */     GIR_EraseRootFromParent_Done,
     /* 168633 */   // Label 3659: @168633
     /* 168633 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(168668), // Rule ID 1392 //
     /* 168638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168657 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 168662 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168666 */     GIR_RootConstrainSelectedInstOperands,
     /* 168667 */     // GIR_Coverage, 1392,
     /* 168667 */     GIR_Done,
     /* 168668 */   // Label 3660: @168668
     /* 168668 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(168705), // Rule ID 8459 //
     /* 168673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168692 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 168692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 168695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168701 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168703 */     GIR_RootConstrainSelectedInstOperands,
     /* 168704 */     // GIR_Coverage, 8459,
     /* 168704 */     GIR_EraseRootFromParent_Done,
     /* 168705 */   // Label 3661: @168705
     /* 168705 */   GIM_Reject,
     /* 168706 */ // Label 3649: @168706
     /* 168706 */ GIM_Reject,
     /* 168707 */ // Label 3569: @168707
     /* 168707 */ GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(168951),
     /* 168712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 168715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 168718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 168721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168725 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(168789), // Rule ID 9659 //
     /* 168730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168741 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168744 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168748 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168769 */     // (fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 168772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168776 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168778 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168787 */     GIR_RootConstrainSelectedInstOperands,
     /* 168788 */     // GIR_Coverage, 9659,
     /* 168788 */     GIR_EraseRootFromParent_Done,
     /* 168789 */   // Label 3663: @168789
     /* 168789 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(168853), // Rule ID 9119 //
     /* 168794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168833 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 168836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168838 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168851 */     GIR_RootConstrainSelectedInstOperands,
     /* 168852 */     // GIR_Coverage, 9119,
     /* 168852 */     GIR_EraseRootFromParent_Done,
     /* 168853 */   // Label 3664: @168853
     /* 168853 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(168917), // Rule ID 8487 //
     /* 168858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168897 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 168900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168915 */     GIR_RootConstrainSelectedInstOperands,
     /* 168916 */     // GIR_Coverage, 8487,
     /* 168916 */     GIR_EraseRootFromParent_Done,
     /* 168917 */   // Label 3665: @168917
     /* 168917 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(168950), // Rule ID 8483 //
     /* 168922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168937 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 168937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 168940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168946 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168948 */     GIR_RootConstrainSelectedInstOperands,
     /* 168949 */     // GIR_Coverage, 8483,
     /* 168949 */     GIR_EraseRootFromParent_Done,
     /* 168950 */   // Label 3666: @168950
     /* 168950 */   GIM_Reject,
     /* 168951 */ // Label 3662: @168951
     /* 168951 */ GIM_Reject,
     /* 168952 */ // Label 3570: @168952
     /* 168952 */ GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(169196),
     /* 168957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 168960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 168963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 168966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168970 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(169034), // Rule ID 9607 //
     /* 168975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 168978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169014 */     // (fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 169017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169021 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169032 */     GIR_RootConstrainSelectedInstOperands,
     /* 169033 */     // GIR_Coverage, 9607,
     /* 169033 */     GIR_EraseRootFromParent_Done,
     /* 169034 */   // Label 3668: @169034
     /* 169034 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(169098), // Rule ID 9067 //
     /* 169039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169061 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169078 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 169081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169083 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169096 */     GIR_RootConstrainSelectedInstOperands,
     /* 169097 */     // GIR_Coverage, 9067,
     /* 169097 */     GIR_EraseRootFromParent_Done,
     /* 169098 */   // Label 3669: @169098
     /* 169098 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(169162), // Rule ID 8424 //
     /* 169103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169142 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169160 */     GIR_RootConstrainSelectedInstOperands,
     /* 169161 */     // GIR_Coverage, 8424,
     /* 169161 */     GIR_EraseRootFromParent_Done,
     /* 169162 */   // Label 3670: @169162
     /* 169162 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(169195), // Rule ID 8420 //
     /* 169167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169182 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 169182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 169185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169191 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169193 */     GIR_RootConstrainSelectedInstOperands,
     /* 169194 */     // GIR_Coverage, 8420,
     /* 169194 */     GIR_EraseRootFromParent_Done,
     /* 169195 */   // Label 3671: @169195
     /* 169195 */   GIM_Reject,
     /* 169196 */ // Label 3667: @169196
     /* 169196 */ GIM_Reject,
     /* 169197 */ // Label 3571: @169197
     /* 169197 */ GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(169441),
     /* 169202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 169205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 169208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 169211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169215 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(169279), // Rule ID 9627 //
     /* 169220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169238 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169259 */     // (fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 169262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169266 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169277 */     GIR_RootConstrainSelectedInstOperands,
     /* 169278 */     // GIR_Coverage, 9627,
     /* 169278 */     GIR_EraseRootFromParent_Done,
     /* 169279 */   // Label 3673: @169279
     /* 169279 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(169343), // Rule ID 9087 //
     /* 169284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169323 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 169326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169328 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169341 */     GIR_RootConstrainSelectedInstOperands,
     /* 169342 */     // GIR_Coverage, 9087,
     /* 169342 */     GIR_EraseRootFromParent_Done,
     /* 169343 */   // Label 3674: @169343
     /* 169343 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(169407), // Rule ID 8448 //
     /* 169348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169367 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169387 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 169390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169405 */     GIR_RootConstrainSelectedInstOperands,
     /* 169406 */     // GIR_Coverage, 8448,
     /* 169406 */     GIR_EraseRootFromParent_Done,
     /* 169407 */   // Label 3675: @169407
     /* 169407 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(169440), // Rule ID 8444 //
     /* 169412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169427 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 169427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 169430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169436 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169438 */     GIR_RootConstrainSelectedInstOperands,
     /* 169439 */     // GIR_Coverage, 8444,
     /* 169439 */     GIR_EraseRootFromParent_Done,
     /* 169440 */   // Label 3676: @169440
     /* 169440 */   GIM_Reject,
     /* 169441 */ // Label 3672: @169441
     /* 169441 */ GIM_Reject,
     /* 169442 */ // Label 3572: @169442
     /* 169442 */ GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(169686),
     /* 169447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 169450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 169453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 169456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169460 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(169524), // Rule ID 9595 //
     /* 169465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169504 */     // (fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 169507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169511 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169522 */     GIR_RootConstrainSelectedInstOperands,
     /* 169523 */     // GIR_Coverage, 9595,
     /* 169523 */     GIR_EraseRootFromParent_Done,
     /* 169524 */   // Label 3678: @169524
     /* 169524 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(169588), // Rule ID 9055 //
     /* 169529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169568 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 169571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169573 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169586 */     GIR_RootConstrainSelectedInstOperands,
     /* 169587 */     // GIR_Coverage, 9055,
     /* 169587 */     GIR_EraseRootFromParent_Done,
     /* 169588 */   // Label 3679: @169588
     /* 169588 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(169652), // Rule ID 8409 //
     /* 169593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169619 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169632 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 169635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169650 */     GIR_RootConstrainSelectedInstOperands,
     /* 169651 */     // GIR_Coverage, 8409,
     /* 169651 */     GIR_EraseRootFromParent_Done,
     /* 169652 */   // Label 3680: @169652
     /* 169652 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(169685), // Rule ID 8405 //
     /* 169657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169672 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 169672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 169675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169681 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169683 */     GIR_RootConstrainSelectedInstOperands,
     /* 169684 */     // GIR_Coverage, 8405,
     /* 169684 */     GIR_EraseRootFromParent_Done,
     /* 169685 */   // Label 3681: @169685
     /* 169685 */   GIM_Reject,
     /* 169686 */ // Label 3677: @169686
     /* 169686 */ GIM_Reject,
     /* 169687 */ // Label 3573: @169687
     /* 169687 */ GIM_Reject,
     /* 169688 */ // Label 45: @169688
     /* 169688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3695*/ GIMT_Encode4(173869),
     /* 169699 */ /*GILLT_s16*//*Label 3682*/ GIMT_Encode4(169783),
     /* 169703 */ /*GILLT_s32*//*Label 3683*/ GIMT_Encode4(169881),
     /* 169707 */ /*GILLT_s64*//*Label 3684*/ GIMT_Encode4(170846),
     /* 169711 */ /*GILLT_s80*//*Label 3685*/ GIMT_Encode4(171955), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169723 */ /*GILLT_v2s64*//*Label 3686*/ GIMT_Encode4(172521), GIMT_Encode4(0),
     /* 169731 */ /*GILLT_v4s32*//*Label 3687*/ GIMT_Encode4(172751),
     /* 169735 */ /*GILLT_v4s64*//*Label 3688*/ GIMT_Encode4(172981), GIMT_Encode4(0),
     /* 169743 */ /*GILLT_v8s16*//*Label 3689*/ GIMT_Encode4(173180),
     /* 169747 */ /*GILLT_v8s32*//*Label 3690*/ GIMT_Encode4(173278),
     /* 169751 */ /*GILLT_v8s64*//*Label 3691*/ GIMT_Encode4(173477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169763 */ /*GILLT_v16s16*//*Label 3692*/ GIMT_Encode4(173575),
     /* 169767 */ /*GILLT_v16s32*//*Label 3693*/ GIMT_Encode4(173673), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169779 */ /*GILLT_v32s16*//*Label 3694*/ GIMT_Encode4(173771),
     /* 169783 */ // Label 3682: @169783
     /* 169783 */ GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(169880),
     /* 169788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 169791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 169794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169802 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(169856), // Rule ID 6126 //
     /* 169807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169838 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 169841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169854 */     GIR_RootConstrainSelectedInstOperands,
     /* 169855 */     // GIR_Coverage, 6126,
     /* 169855 */     GIR_EraseRootFromParent_Done,
     /* 169856 */   // Label 3697: @169856
     /* 169856 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(169879), // Rule ID 6124 //
     /* 169861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169868 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 169868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 169873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169877 */     GIR_RootConstrainSelectedInstOperands,
     /* 169878 */     // GIR_Coverage, 6124,
     /* 169878 */     GIR_Done,
     /* 169879 */   // Label 3698: @169879
     /* 169879 */   GIM_Reject,
     /* 169880 */ // Label 3696: @169880
     /* 169880 */ GIM_Reject,
     /* 169881 */ // Label 3683: @169881
     /* 169881 */ GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(170845),
     /* 169886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169892 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(169974), // Rule ID 22485 //
     /* 169897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 169900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 169916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 169924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169928 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 169935 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169942 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 169946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169955 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 169958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169960 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 169972 */     GIR_RootConstrainSelectedInstOperands,
     /* 169973 */     // GIR_Coverage, 22485,
     /* 169973 */     GIR_EraseRootFromParent_Done,
     /* 169974 */   // Label 3700: @169974
     /* 169974 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(170056), // Rule ID 22486 //
     /* 169979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 169982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 169998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 170002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170010 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170017 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170024 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170037 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 170040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170054 */     GIR_RootConstrainSelectedInstOperands,
     /* 170055 */     // GIR_Coverage, 22486,
     /* 170055 */     GIR_EraseRootFromParent_Done,
     /* 170056 */   // Label 3701: @170056
     /* 170056 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(170138), // Rule ID 22487 //
     /* 170061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 170084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170092 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170099 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170106 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170119 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 170122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170136 */     GIR_RootConstrainSelectedInstOperands,
     /* 170137 */     // GIR_Coverage, 22487,
     /* 170137 */     GIR_EraseRootFromParent_Done,
     /* 170138 */   // Label 3702: @170138
     /* 170138 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(170203), // Rule ID 1031 //
     /* 170143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170158 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170182 */     // (fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m32),
     /* 170185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170201 */     GIR_RootConstrainSelectedInstOperands,
     /* 170202 */     // GIR_Coverage, 1031,
     /* 170202 */     GIR_EraseRootFromParent_Done,
     /* 170203 */   // Label 3703: @170203
     /* 170203 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(170268), // Rule ID 1033 //
     /* 170208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170223 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170247 */     // (fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m32),
     /* 170250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170252 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170266 */     GIR_RootConstrainSelectedInstOperands,
     /* 170267 */     // GIR_Coverage, 1033,
     /* 170267 */     GIR_EraseRootFromParent_Done,
     /* 170268 */   // Label 3704: @170268
     /* 170268 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(170333), // Rule ID 1021 //
     /* 170273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170312 */     // (fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 170315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170331 */     GIR_RootConstrainSelectedInstOperands,
     /* 170332 */     // GIR_Coverage, 1021,
     /* 170332 */     GIR_EraseRootFromParent_Done,
     /* 170333 */   // Label 3705: @170333
     /* 170333 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(170398), // Rule ID 1009 //
     /* 170338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170357 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170377 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m32),
     /* 170380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170396 */     GIR_RootConstrainSelectedInstOperands,
     /* 170397 */     // GIR_Coverage, 1009,
     /* 170397 */     GIR_EraseRootFromParent_Done,
     /* 170398 */   // Label 3706: @170398
     /* 170398 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(170463), // Rule ID 1011 //
     /* 170403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170422 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170442 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m32),
     /* 170445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170461 */     GIR_RootConstrainSelectedInstOperands,
     /* 170462 */     // GIR_Coverage, 1011,
     /* 170462 */     GIR_EraseRootFromParent_Done,
     /* 170463 */   // Label 3707: @170463
     /* 170463 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(170528), // Rule ID 999 //
     /* 170468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170507 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 170510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170526 */     GIR_RootConstrainSelectedInstOperands,
     /* 170527 */     // GIR_Coverage, 999,
     /* 170527 */     GIR_EraseRootFromParent_Done,
     /* 170528 */   // Label 3708: @170528
     /* 170528 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(170590), // Rule ID 2281 //
     /* 170533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170552 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170572 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 170575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170577 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170588 */     GIR_RootConstrainSelectedInstOperands,
     /* 170589 */     // GIR_Coverage, 2281,
     /* 170589 */     GIR_EraseRootFromParent_Done,
     /* 170590 */   // Label 3709: @170590
     /* 170590 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(170652), // Rule ID 2289 //
     /* 170595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170614 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170621 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170634 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 170637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170650 */     GIR_RootConstrainSelectedInstOperands,
     /* 170651 */     // GIR_Coverage, 2289,
     /* 170651 */     GIR_EraseRootFromParent_Done,
     /* 170652 */   // Label 3710: @170652
     /* 170652 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(170714), // Rule ID 6088 //
     /* 170657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170696 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 170699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170712 */     GIR_RootConstrainSelectedInstOperands,
     /* 170713 */     // GIR_Coverage, 6088,
     /* 170713 */     GIR_EraseRootFromParent_Done,
     /* 170714 */   // Label 3711: @170714
     /* 170714 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(170751), // Rule ID 905 //
     /* 170719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170734 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 170734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 170739 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 170749 */     GIR_RootConstrainSelectedInstOperands,
     /* 170750 */     // GIR_Coverage, 905,
     /* 170750 */     GIR_Done,
     /* 170751 */   // Label 3712: @170751
     /* 170751 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(170782), // Rule ID 2279 //
     /* 170756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170771 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 170771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 170776 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170780 */     GIR_RootConstrainSelectedInstOperands,
     /* 170781 */     // GIR_Coverage, 2279,
     /* 170781 */     GIR_Done,
     /* 170782 */   // Label 3713: @170782
     /* 170782 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(170813), // Rule ID 2287 //
     /* 170787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170802 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 170802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 170807 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170811 */     GIR_RootConstrainSelectedInstOperands,
     /* 170812 */     // GIR_Coverage, 2287,
     /* 170812 */     GIR_Done,
     /* 170813 */   // Label 3714: @170813
     /* 170813 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(170844), // Rule ID 6086 //
     /* 170818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170833 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 170833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 170838 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170842 */     GIR_RootConstrainSelectedInstOperands,
     /* 170843 */     // GIR_Coverage, 6086,
     /* 170843 */     GIR_Done,
     /* 170844 */   // Label 3715: @170844
     /* 170844 */   GIM_Reject,
     /* 170845 */ // Label 3699: @170845
     /* 170845 */ GIM_Reject,
     /* 170846 */ // Label 3684: @170846
     /* 170846 */ GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(171954),
     /* 170851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170857 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(170939), // Rule ID 22488 //
     /* 170862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170893 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170900 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 170907 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170920 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 170923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170937 */     GIR_RootConstrainSelectedInstOperands,
     /* 170938 */     // GIR_Coverage, 22488,
     /* 170938 */     GIR_EraseRootFromParent_Done,
     /* 170939 */   // Label 3717: @170939
     /* 170939 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(171021), // Rule ID 22489 //
     /* 170944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170975 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170982 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 170989 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171002 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 171005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 171019 */     GIR_RootConstrainSelectedInstOperands,
     /* 171020 */     // GIR_Coverage, 22489,
     /* 171020 */     GIR_EraseRootFromParent_Done,
     /* 171021 */   // Label 3718: @171021
     /* 171021 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(171103), // Rule ID 22490 //
     /* 171026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 171045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 171049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171057 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 171064 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 171071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 171075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 171077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171084 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 171087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 171101 */     GIR_RootConstrainSelectedInstOperands,
     /* 171102 */     // GIR_Coverage, 22490,
     /* 171102 */     GIR_EraseRootFromParent_Done,
     /* 171103 */   // Label 3719: @171103
     /* 171103 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(171168), // Rule ID 1035 //
     /* 171108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171123 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171130 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171147 */     // (fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m64),
     /* 171150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171152 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171166 */     GIR_RootConstrainSelectedInstOperands,
     /* 171167 */     // GIR_Coverage, 1035,
     /* 171167 */     GIR_EraseRootFromParent_Done,
     /* 171168 */   // Label 3720: @171168
     /* 171168 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(171233), // Rule ID 1037 //
     /* 171173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171188 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171212 */     // (fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m64),
     /* 171215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171231 */     GIR_RootConstrainSelectedInstOperands,
     /* 171232 */     // GIR_Coverage, 1037,
     /* 171232 */     GIR_EraseRootFromParent_Done,
     /* 171233 */   // Label 3721: @171233
     /* 171233 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(171298), // Rule ID 1023 //
     /* 171238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171277 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 171280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171296 */     GIR_RootConstrainSelectedInstOperands,
     /* 171297 */     // GIR_Coverage, 1023,
     /* 171297 */     GIR_EraseRootFromParent_Done,
     /* 171298 */   // Label 3722: @171298
     /* 171298 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(171370), // Rule ID 1025 //
     /* 171303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171321 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171325 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171349 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 171352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171368 */     GIR_RootConstrainSelectedInstOperands,
     /* 171369 */     // GIR_Coverage, 1025,
     /* 171369 */     GIR_EraseRootFromParent_Done,
     /* 171370 */   // Label 3723: @171370
     /* 171370 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(171435), // Rule ID 1013 //
     /* 171375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171394 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171414 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m64),
     /* 171417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171433 */     GIR_RootConstrainSelectedInstOperands,
     /* 171434 */     // GIR_Coverage, 1013,
     /* 171434 */     GIR_EraseRootFromParent_Done,
     /* 171435 */   // Label 3724: @171435
     /* 171435 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(171500), // Rule ID 1015 //
     /* 171440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171459 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171466 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171479 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m64),
     /* 171482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171498 */     GIR_RootConstrainSelectedInstOperands,
     /* 171499 */     // GIR_Coverage, 1015,
     /* 171499 */     GIR_EraseRootFromParent_Done,
     /* 171500 */   // Label 3725: @171500
     /* 171500 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(171565), // Rule ID 1001 //
     /* 171505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171544 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 171547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171563 */     GIR_RootConstrainSelectedInstOperands,
     /* 171564 */     // GIR_Coverage, 1001,
     /* 171564 */     GIR_EraseRootFromParent_Done,
     /* 171565 */   // Label 3726: @171565
     /* 171565 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(171637), // Rule ID 1003 //
     /* 171570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171592 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171596 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171616 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 171619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171635 */     GIR_RootConstrainSelectedInstOperands,
     /* 171636 */     // GIR_Coverage, 1003,
     /* 171636 */     GIR_EraseRootFromParent_Done,
     /* 171637 */   // Label 3727: @171637
     /* 171637 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(171699), // Rule ID 2285 //
     /* 171642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171681 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 171684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171697 */     GIR_RootConstrainSelectedInstOperands,
     /* 171698 */     // GIR_Coverage, 2285,
     /* 171698 */     GIR_EraseRootFromParent_Done,
     /* 171699 */   // Label 3728: @171699
     /* 171699 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(171761), // Rule ID 2293 //
     /* 171704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171743 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 171746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171759 */     GIR_RootConstrainSelectedInstOperands,
     /* 171760 */     // GIR_Coverage, 2293,
     /* 171760 */     GIR_EraseRootFromParent_Done,
     /* 171761 */   // Label 3729: @171761
     /* 171761 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(171823), // Rule ID 6107 //
     /* 171766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171805 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 171808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171821 */     GIR_RootConstrainSelectedInstOperands,
     /* 171822 */     // GIR_Coverage, 6107,
     /* 171822 */     GIR_EraseRootFromParent_Done,
     /* 171823 */   // Label 3730: @171823
     /* 171823 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(171860), // Rule ID 907 //
     /* 171828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171843 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 171843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 171848 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 171854 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 171858 */     GIR_RootConstrainSelectedInstOperands,
     /* 171859 */     // GIR_Coverage, 907,
     /* 171859 */     GIR_Done,
     /* 171860 */   // Label 3731: @171860
     /* 171860 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(171891), // Rule ID 2283 //
     /* 171865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171880 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 171880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 171885 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171889 */     GIR_RootConstrainSelectedInstOperands,
     /* 171890 */     // GIR_Coverage, 2283,
     /* 171890 */     GIR_Done,
     /* 171891 */   // Label 3732: @171891
     /* 171891 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(171922), // Rule ID 2291 //
     /* 171896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171911 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 171911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 171916 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171920 */     GIR_RootConstrainSelectedInstOperands,
     /* 171921 */     // GIR_Coverage, 2291,
     /* 171921 */     GIR_Done,
     /* 171922 */   // Label 3733: @171922
     /* 171922 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(171953), // Rule ID 6105 //
     /* 171927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171942 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 171942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 171947 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171951 */     GIR_RootConstrainSelectedInstOperands,
     /* 171952 */     // GIR_Coverage, 6105,
     /* 171952 */     GIR_Done,
     /* 171953 */   // Label 3734: @171953
     /* 171953 */   GIM_Reject,
     /* 171954 */ // Label 3716: @171954
     /* 171954 */ GIM_Reject,
     /* 171955 */ // Label 3685: @171955
     /* 171955 */ GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(172520),
     /* 171960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 171966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171970 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(172031), // Rule ID 1039 //
     /* 171975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 171978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171986 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172010 */     // (fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m80),
     /* 172013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172029 */     GIR_RootConstrainSelectedInstOperands,
     /* 172030 */     // GIR_Coverage, 1039,
     /* 172030 */     GIR_EraseRootFromParent_Done,
     /* 172031 */   // Label 3736: @172031
     /* 172031 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(172092), // Rule ID 1041 //
     /* 172036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172047 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172071 */     // (fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m80),
     /* 172074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172090 */     GIR_RootConstrainSelectedInstOperands,
     /* 172091 */     // GIR_Coverage, 1041,
     /* 172091 */     GIR_EraseRootFromParent_Done,
     /* 172092 */   // Label 3737: @172092
     /* 172092 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(172160), // Rule ID 1027 //
     /* 172097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172111 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172115 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172139 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 172142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172158 */     GIR_RootConstrainSelectedInstOperands,
     /* 172159 */     // GIR_Coverage, 1027,
     /* 172159 */     GIR_EraseRootFromParent_Done,
     /* 172160 */   // Label 3738: @172160
     /* 172160 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(172228), // Rule ID 1029 //
     /* 172165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172179 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172183 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172207 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 172210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172226 */     GIR_RootConstrainSelectedInstOperands,
     /* 172227 */     // GIR_Coverage, 1029,
     /* 172227 */     GIR_EraseRootFromParent_Done,
     /* 172228 */   // Label 3739: @172228
     /* 172228 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(172289), // Rule ID 1017 //
     /* 172233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172248 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172268 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m80),
     /* 172271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172287 */     GIR_RootConstrainSelectedInstOperands,
     /* 172288 */     // GIR_Coverage, 1017,
     /* 172288 */     GIR_EraseRootFromParent_Done,
     /* 172289 */   // Label 3740: @172289
     /* 172289 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(172350), // Rule ID 1019 //
     /* 172294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172309 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172329 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m80),
     /* 172332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172334 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172348 */     GIR_RootConstrainSelectedInstOperands,
     /* 172349 */     // GIR_Coverage, 1019,
     /* 172349 */     GIR_EraseRootFromParent_Done,
     /* 172350 */   // Label 3741: @172350
     /* 172350 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(172418), // Rule ID 1005 //
     /* 172355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172370 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172373 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172377 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172397 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 172400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172416 */     GIR_RootConstrainSelectedInstOperands,
     /* 172417 */     // GIR_Coverage, 1005,
     /* 172417 */     GIR_EraseRootFromParent_Done,
     /* 172418 */   // Label 3742: @172418
     /* 172418 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(172486), // Rule ID 1007 //
     /* 172423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172441 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172445 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172465 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 172468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172484 */     GIR_RootConstrainSelectedInstOperands,
     /* 172485 */     // GIR_Coverage, 1007,
     /* 172485 */     GIR_EraseRootFromParent_Done,
     /* 172486 */   // Label 3743: @172486
     /* 172486 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(172519), // Rule ID 909 //
     /* 172491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172502 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 172502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 172507 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 172513 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 172517 */     GIR_RootConstrainSelectedInstOperands,
     /* 172518 */     // GIR_Coverage, 909,
     /* 172518 */     GIR_Done,
     /* 172519 */   // Label 3744: @172519
     /* 172519 */   GIM_Reject,
     /* 172520 */ // Label 3735: @172520
     /* 172520 */ GIM_Reject,
     /* 172521 */ // Label 3686: @172521
     /* 172521 */ GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(172750),
     /* 172526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172532 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(172594), // Rule ID 2261 //
     /* 172537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172576 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 172579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172592 */     GIR_RootConstrainSelectedInstOperands,
     /* 172593 */     // GIR_Coverage, 2261,
     /* 172593 */     GIR_EraseRootFromParent_Done,
     /* 172594 */   // Label 3746: @172594
     /* 172594 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(172656), // Rule ID 6660 //
     /* 172599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172625 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172638 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 172641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172643 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172654 */     GIR_RootConstrainSelectedInstOperands,
     /* 172655 */     // GIR_Coverage, 6660,
     /* 172655 */     GIR_EraseRootFromParent_Done,
     /* 172656 */   // Label 3747: @172656
     /* 172656 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(172687), // Rule ID 2259 //
     /* 172661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172676 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 172676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 172681 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172685 */     GIR_RootConstrainSelectedInstOperands,
     /* 172686 */     // GIR_Coverage, 2259,
     /* 172686 */     GIR_Done,
     /* 172687 */   // Label 3748: @172687
     /* 172687 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(172718), // Rule ID 2275 //
     /* 172692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172707 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 172707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 172712 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172716 */     GIR_RootConstrainSelectedInstOperands,
     /* 172717 */     // GIR_Coverage, 2275,
     /* 172717 */     GIR_Done,
     /* 172718 */   // Label 3749: @172718
     /* 172718 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(172749), // Rule ID 6656 //
     /* 172723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172738 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 172738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 172743 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172747 */     GIR_RootConstrainSelectedInstOperands,
     /* 172748 */     // GIR_Coverage, 6656,
     /* 172748 */     GIR_Done,
     /* 172749 */   // Label 3750: @172749
     /* 172749 */   GIM_Reject,
     /* 172750 */ // Label 3745: @172750
     /* 172750 */ GIM_Reject,
     /* 172751 */ // Label 3687: @172751
     /* 172751 */ GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(172980),
     /* 172756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172762 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(172824), // Rule ID 2257 //
     /* 172767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172806 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 172809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172822 */     GIR_RootConstrainSelectedInstOperands,
     /* 172823 */     // GIR_Coverage, 2257,
     /* 172823 */     GIR_EraseRootFromParent_Done,
     /* 172824 */   // Label 3752: @172824
     /* 172824 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(172886), // Rule ID 6636 //
     /* 172829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172868 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 172871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172884 */     GIR_RootConstrainSelectedInstOperands,
     /* 172885 */     // GIR_Coverage, 6636,
     /* 172885 */     GIR_EraseRootFromParent_Done,
     /* 172886 */   // Label 3753: @172886
     /* 172886 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(172917), // Rule ID 2255 //
     /* 172891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172906 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 172906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 172911 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172915 */     GIR_RootConstrainSelectedInstOperands,
     /* 172916 */     // GIR_Coverage, 2255,
     /* 172916 */     GIR_Done,
     /* 172917 */   // Label 3754: @172917
     /* 172917 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(172948), // Rule ID 2271 //
     /* 172922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172937 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 172937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 172942 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172946 */     GIR_RootConstrainSelectedInstOperands,
     /* 172947 */     // GIR_Coverage, 2271,
     /* 172947 */     GIR_Done,
     /* 172948 */   // Label 3755: @172948
     /* 172948 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(172979), // Rule ID 6632 //
     /* 172953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172968 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 172968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 172973 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172977 */     GIR_RootConstrainSelectedInstOperands,
     /* 172978 */     // GIR_Coverage, 6632,
     /* 172978 */     GIR_Done,
     /* 172979 */   // Label 3756: @172979
     /* 172979 */   GIM_Reject,
     /* 172980 */ // Label 3751: @172980
     /* 172980 */ GIM_Reject,
     /* 172981 */ // Label 3688: @172981
     /* 172981 */ GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(173179),
     /* 172986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 172989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 172992 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(173054), // Rule ID 2269 //
     /* 172997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173036 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 173039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173052 */     GIR_RootConstrainSelectedInstOperands,
     /* 173053 */     // GIR_Coverage, 2269,
     /* 173053 */     GIR_EraseRootFromParent_Done,
     /* 173054 */   // Label 3758: @173054
     /* 173054 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(173116), // Rule ID 6672 //
     /* 173059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173098 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 173101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173114 */     GIR_RootConstrainSelectedInstOperands,
     /* 173115 */     // GIR_Coverage, 6672,
     /* 173115 */     GIR_EraseRootFromParent_Done,
     /* 173116 */   // Label 3759: @173116
     /* 173116 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(173147), // Rule ID 2267 //
     /* 173121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173136 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 173136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 173141 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173145 */     GIR_RootConstrainSelectedInstOperands,
     /* 173146 */     // GIR_Coverage, 2267,
     /* 173146 */     GIR_Done,
     /* 173147 */   // Label 3760: @173147
     /* 173147 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(173178), // Rule ID 6668 //
     /* 173152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173167 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 173167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 173172 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173176 */     GIR_RootConstrainSelectedInstOperands,
     /* 173177 */     // GIR_Coverage, 6668,
     /* 173177 */     GIR_Done,
     /* 173178 */   // Label 3761: @173178
     /* 173178 */   GIM_Reject,
     /* 173179 */ // Label 3757: @173179
     /* 173179 */ GIM_Reject,
     /* 173180 */ // Label 3689: @173180
     /* 173180 */ GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(173277),
     /* 173185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173199 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(173253), // Rule ID 6696 //
     /* 173204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173235 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 173238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173251 */     GIR_RootConstrainSelectedInstOperands,
     /* 173252 */     // GIR_Coverage, 6696,
     /* 173252 */     GIR_EraseRootFromParent_Done,
     /* 173253 */   // Label 3763: @173253
     /* 173253 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(173276), // Rule ID 6692 //
     /* 173258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173265 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 173265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 173270 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173274 */     GIR_RootConstrainSelectedInstOperands,
     /* 173275 */     // GIR_Coverage, 6692,
     /* 173275 */     GIR_Done,
     /* 173276 */   // Label 3764: @173276
     /* 173276 */   GIM_Reject,
     /* 173277 */ // Label 3762: @173277
     /* 173277 */ GIM_Reject,
     /* 173278 */ // Label 3690: @173278
     /* 173278 */ GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(173476),
     /* 173283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 173286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 173289 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(173351), // Rule ID 2265 //
     /* 173294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173333 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 173336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173349 */     GIR_RootConstrainSelectedInstOperands,
     /* 173350 */     // GIR_Coverage, 2265,
     /* 173350 */     GIR_EraseRootFromParent_Done,
     /* 173351 */   // Label 3766: @173351
     /* 173351 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(173413), // Rule ID 6648 //
     /* 173356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173395 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 173398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173411 */     GIR_RootConstrainSelectedInstOperands,
     /* 173412 */     // GIR_Coverage, 6648,
     /* 173412 */     GIR_EraseRootFromParent_Done,
     /* 173413 */   // Label 3767: @173413
     /* 173413 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(173444), // Rule ID 2263 //
     /* 173418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173433 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 173433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 173438 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173442 */     GIR_RootConstrainSelectedInstOperands,
     /* 173443 */     // GIR_Coverage, 2263,
     /* 173443 */     GIR_Done,
     /* 173444 */   // Label 3768: @173444
     /* 173444 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(173475), // Rule ID 6644 //
     /* 173449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173464 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 173464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 173469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173473 */     GIR_RootConstrainSelectedInstOperands,
     /* 173474 */     // GIR_Coverage, 6644,
     /* 173474 */     GIR_Done,
     /* 173475 */   // Label 3769: @173475
     /* 173475 */   GIM_Reject,
     /* 173476 */ // Label 3765: @173476
     /* 173476 */ GIM_Reject,
     /* 173477 */ // Label 3691: @173477
     /* 173477 */ GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(173574),
     /* 173482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 173485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 173488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173496 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(173550), // Rule ID 6624 //
     /* 173501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173532 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 173535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173548 */     GIR_RootConstrainSelectedInstOperands,
     /* 173549 */     // GIR_Coverage, 6624,
     /* 173549 */     GIR_EraseRootFromParent_Done,
     /* 173550 */   // Label 3771: @173550
     /* 173550 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(173573), // Rule ID 6620 //
     /* 173555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173562 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 173562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 173567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173571 */     GIR_RootConstrainSelectedInstOperands,
     /* 173572 */     // GIR_Coverage, 6620,
     /* 173572 */     GIR_Done,
     /* 173573 */   // Label 3772: @173573
     /* 173573 */   GIM_Reject,
     /* 173574 */ // Label 3770: @173574
     /* 173574 */ GIM_Reject,
     /* 173575 */ // Label 3692: @173575
     /* 173575 */ GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(173672),
     /* 173580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 173583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 173586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173594 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(173648), // Rule ID 6708 //
     /* 173599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173630 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 173633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173635 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173646 */     GIR_RootConstrainSelectedInstOperands,
     /* 173647 */     // GIR_Coverage, 6708,
     /* 173647 */     GIR_EraseRootFromParent_Done,
     /* 173648 */   // Label 3774: @173648
     /* 173648 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(173671), // Rule ID 6704 //
     /* 173653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173660 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 173660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 173665 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173669 */     GIR_RootConstrainSelectedInstOperands,
     /* 173670 */     // GIR_Coverage, 6704,
     /* 173670 */     GIR_Done,
     /* 173671 */   // Label 3775: @173671
     /* 173671 */   GIM_Reject,
     /* 173672 */ // Label 3773: @173672
     /* 173672 */ GIM_Reject,
     /* 173673 */ // Label 3693: @173673
     /* 173673 */ GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(173770),
     /* 173678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 173681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 173684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173692 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(173746), // Rule ID 6612 //
     /* 173697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173728 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 173731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173735 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173744 */     GIR_RootConstrainSelectedInstOperands,
     /* 173745 */     // GIR_Coverage, 6612,
     /* 173745 */     GIR_EraseRootFromParent_Done,
     /* 173746 */   // Label 3777: @173746
     /* 173746 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(173769), // Rule ID 6608 //
     /* 173751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173758 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 173758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 173763 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173767 */     GIR_RootConstrainSelectedInstOperands,
     /* 173768 */     // GIR_Coverage, 6608,
     /* 173768 */     GIR_Done,
     /* 173769 */   // Label 3778: @173769
     /* 173769 */   GIM_Reject,
     /* 173770 */ // Label 3776: @173770
     /* 173770 */ GIM_Reject,
     /* 173771 */ // Label 3694: @173771
     /* 173771 */ GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(173868),
     /* 173776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 173779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 173782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173790 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(173844), // Rule ID 6684 //
     /* 173795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173826 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 173829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173842 */     GIR_RootConstrainSelectedInstOperands,
     /* 173843 */     // GIR_Coverage, 6684,
     /* 173843 */     GIR_EraseRootFromParent_Done,
     /* 173844 */   // Label 3780: @173844
     /* 173844 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(173867), // Rule ID 6680 //
     /* 173849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173856 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 173856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 173861 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173865 */     GIR_RootConstrainSelectedInstOperands,
     /* 173866 */     // GIR_Coverage, 6680,
     /* 173866 */     GIR_Done,
     /* 173867 */   // Label 3781: @173867
     /* 173867 */   GIM_Reject,
     /* 173868 */ // Label 3779: @173868
     /* 173868 */ GIM_Reject,
     /* 173869 */ // Label 3695: @173869
     /* 173869 */ GIM_Reject,
     /* 173870 */ // Label 46: @173870
     /* 173870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3785*/ GIMT_Encode4(173992),
     /* 173881 */ /*GILLT_s32*//*Label 3782*/ GIMT_Encode4(173893),
     /* 173885 */ /*GILLT_s64*//*Label 3783*/ GIMT_Encode4(173926),
     /* 173889 */ /*GILLT_s80*//*Label 3784*/ GIMT_Encode4(173959),
     /* 173893 */ // Label 3782: @173893
     /* 173893 */ GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(173925), // Rule ID 1042 //
     /* 173898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 173901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 173908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 173912 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 173912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 173917 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173923 */   GIR_RootConstrainSelectedInstOperands,
     /* 173924 */   // GIR_Coverage, 1042,
     /* 173924 */   GIR_Done,
     /* 173925 */ // Label 3786: @173925
     /* 173925 */ GIM_Reject,
     /* 173926 */ // Label 3783: @173926
     /* 173926 */ GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(173958), // Rule ID 1043 //
     /* 173931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 173934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 173941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 173945 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 173945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 173950 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173956 */   GIR_RootConstrainSelectedInstOperands,
     /* 173957 */   // GIR_Coverage, 1043,
     /* 173957 */   GIR_Done,
     /* 173958 */ // Label 3787: @173958
     /* 173958 */ GIM_Reject,
     /* 173959 */ // Label 3784: @173959
     /* 173959 */ GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(173991), // Rule ID 1044 //
     /* 173964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 173967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 173970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 173974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 173978 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 173978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 173983 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173989 */   GIR_RootConstrainSelectedInstOperands,
     /* 173990 */   // GIR_Coverage, 1044,
     /* 173990 */   GIR_Done,
     /* 173991 */ // Label 3788: @173991
     /* 173991 */ GIM_Reject,
     /* 173992 */ // Label 3785: @173992
     /* 173992 */ GIM_Reject,
     /* 173993 */ // Label 47: @173993
     /* 173993 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 3796*/ GIMT_Encode4(174924),
     /* 174004 */ /*GILLT_s32*//*Label 3789*/ GIMT_Encode4(174072),
     /* 174008 */ /*GILLT_s64*//*Label 3790*/ GIMT_Encode4(174193),
     /* 174012 */ /*GILLT_s80*//*Label 3791*/ GIMT_Encode4(174676), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174036 */ /*GILLT_v4s64*//*Label 3792*/ GIMT_Encode4(174737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174048 */ /*GILLT_v8s32*//*Label 3793*/ GIMT_Encode4(174801),
     /* 174052 */ /*GILLT_v8s64*//*Label 3794*/ GIMT_Encode4(174832), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174068 */ /*GILLT_v16s32*//*Label 3795*/ GIMT_Encode4(174893),
     /* 174072 */ // Label 3789: @174072
     /* 174072 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(174192),
     /* 174077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174084 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(174153), // Rule ID 21204 //
     /* 174089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 174092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174120 */     // (fpextend:{ *:[f32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrm),
     /* 174137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174151 */     GIR_RootConstrainSelectedInstOperands,
     /* 174152 */     // GIR_Coverage, 21204,
     /* 174152 */     GIR_EraseRootFromParent_Done,
     /* 174153 */   // Label 3798: @174153
     /* 174153 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(174191), // Rule ID 21202 //
     /* 174158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174165 */     // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 174165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 174182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174189 */     GIR_RootConstrainSelectedInstOperands,
     /* 174190 */     // GIR_Coverage, 21202,
     /* 174190 */     GIR_EraseRootFromParent_Done,
     /* 174191 */   // Label 3799: @174191
     /* 174191 */   GIM_Reject,
     /* 174192 */ // Label 3797: @174192
     /* 174192 */ GIM_Reject,
     /* 174193 */ // Label 3790: @174193
     /* 174193 */ GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(174252), // Rule ID 1894 //
     /* 174198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 174201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174216 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174223 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174227 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174229 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174236 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 174236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrm),
     /* 174239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174241 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174250 */   GIR_RootConstrainSelectedInstOperands,
     /* 174251 */   // GIR_Coverage, 1894,
     /* 174251 */   GIR_EraseRootFromParent_Done,
     /* 174252 */ // Label 3800: @174252
     /* 174252 */ GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(174328), // Rule ID 18002 //
     /* 174257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 174260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174275 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174282 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174288 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174295 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrm),
     /* 174312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174317 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174326 */   GIR_RootConstrainSelectedInstOperands,
     /* 174327 */   // GIR_Coverage, 18002,
     /* 174327 */   GIR_EraseRootFromParent_Done,
     /* 174328 */ // Label 3801: @174328
     /* 174328 */ GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(174404), // Rule ID 21198 //
     /* 174333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 174336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174351 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174358 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174362 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174364 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174371 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrm),
     /* 174388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174393 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174402 */   GIR_RootConstrainSelectedInstOperands,
     /* 174403 */   // GIR_Coverage, 21198,
     /* 174403 */   GIR_EraseRootFromParent_Done,
     /* 174404 */ // Label 3802: @174404
     /* 174404 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(174480), // Rule ID 21208 //
     /* 174409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 174412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174427 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174434 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174438 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174440 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174447 */   // (fpextend:{ *:[f64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrm),
     /* 174464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174478 */   GIR_RootConstrainSelectedInstOperands,
     /* 174479 */   // GIR_Coverage, 21208,
     /* 174479 */   GIR_EraseRootFromParent_Done,
     /* 174480 */ // Label 3803: @174480
     /* 174480 */ GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(174510), // Rule ID 1892 //
     /* 174485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174499 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 174499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 174504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174508 */   GIR_RootConstrainSelectedInstOperands,
     /* 174509 */   // GIR_Coverage, 1892,
     /* 174509 */   GIR_Done,
     /* 174510 */ // Label 3804: @174510
     /* 174510 */ GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(174540), // Rule ID 17727 //
     /* 174515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 174518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 174525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 174529 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 174529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 174539 */   // GIR_Coverage, 17727,
     /* 174539 */   GIR_Done,
     /* 174540 */ // Label 3805: @174540
     /* 174540 */ GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(174585), // Rule ID 18000 //
     /* 174545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174559 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 174559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 174576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174583 */   GIR_RootConstrainSelectedInstOperands,
     /* 174584 */   // GIR_Coverage, 18000,
     /* 174584 */   GIR_EraseRootFromParent_Done,
     /* 174585 */ // Label 3806: @174585
     /* 174585 */ GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(174630), // Rule ID 21196 //
     /* 174590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174604 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 174604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 174621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174626 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174628 */   GIR_RootConstrainSelectedInstOperands,
     /* 174629 */   // GIR_Coverage, 21196,
     /* 174629 */   GIR_EraseRootFromParent_Done,
     /* 174630 */ // Label 3807: @174630
     /* 174630 */ GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(174675), // Rule ID 21206 //
     /* 174635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174649 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 174649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 174666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174671 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174673 */   GIR_RootConstrainSelectedInstOperands,
     /* 174674 */   // GIR_Coverage, 21206,
     /* 174674 */   GIR_EraseRootFromParent_Done,
     /* 174675 */ // Label 3808: @174675
     /* 174675 */ GIM_Reject,
     /* 174676 */ // Label 3791: @174676
     /* 174676 */ GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(174706), // Rule ID 17729 //
     /* 174681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 174684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 174691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 174695 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 174695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174700 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 174705 */   // GIR_Coverage, 17729,
     /* 174705 */   GIR_Done,
     /* 174706 */ // Label 3809: @174706
     /* 174706 */ GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(174736), // Rule ID 17731 //
     /* 174711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 174714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 174721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 174725 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 174725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 174735 */   // GIR_Coverage, 17731,
     /* 174735 */   GIR_Done,
     /* 174736 */ // Label 3810: @174736
     /* 174736 */ GIM_Reject,
     /* 174737 */ // Label 3792: @174737
     /* 174737 */ GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(174800),
     /* 174742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174745 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(174772), // Rule ID 1935 //
     /* 174750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 174753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 174757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 174761 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 174761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 174766 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174770 */     GIR_RootConstrainSelectedInstOperands,
     /* 174771 */     // GIR_Coverage, 1935,
     /* 174771 */     GIR_Done,
     /* 174772 */   // Label 3812: @174772
     /* 174772 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(174799), // Rule ID 10575 //
     /* 174777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 174780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174788 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 174788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 174793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174797 */     GIR_RootConstrainSelectedInstOperands,
     /* 174798 */     // GIR_Coverage, 10575,
     /* 174798 */     GIR_Done,
     /* 174799 */   // Label 3813: @174799
     /* 174799 */   GIM_Reject,
     /* 174800 */ // Label 3811: @174800
     /* 174800 */ GIM_Reject,
     /* 174801 */ // Label 3793: @174801
     /* 174801 */ GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(174831), // Rule ID 10638 //
     /* 174806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 174809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174820 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 174820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 174825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174829 */   GIR_RootConstrainSelectedInstOperands,
     /* 174830 */   // GIR_Coverage, 10638,
     /* 174830 */   GIR_Done,
     /* 174831 */ // Label 3814: @174831
     /* 174831 */ GIM_Reject,
     /* 174832 */ // Label 3794: @174832
     /* 174832 */ GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(174862), // Rule ID 10550 //
     /* 174837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 174843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174851 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 174851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 174856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174860 */   GIR_RootConstrainSelectedInstOperands,
     /* 174861 */   // GIR_Coverage, 10550,
     /* 174861 */   GIR_Done,
     /* 174862 */ // Label 3815: @174862
     /* 174862 */ GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(174892), // Rule ID 10664 //
     /* 174867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174881 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 174881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 174886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174890 */   GIR_RootConstrainSelectedInstOperands,
     /* 174891 */   // GIR_Coverage, 10664,
     /* 174891 */   GIR_Done,
     /* 174892 */ // Label 3816: @174892
     /* 174892 */ GIM_Reject,
     /* 174893 */ // Label 3795: @174893
     /* 174893 */ GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(174923), // Rule ID 10613 //
     /* 174898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 174904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174912 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 174912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 174917 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174921 */   GIR_RootConstrainSelectedInstOperands,
     /* 174922 */   // GIR_Coverage, 10613,
     /* 174922 */   GIR_Done,
     /* 174923 */ // Label 3817: @174923
     /* 174923 */ GIM_Reject,
     /* 174924 */ // Label 3796: @174924
     /* 174924 */ GIM_Reject,
     /* 174925 */ // Label 48: @174925
     /* 174925 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 3821*/ GIMT_Encode4(175310),
     /* 174936 */ /*GILLT_s16*//*Label 3818*/ GIMT_Encode4(174948),
     /* 174940 */ /*GILLT_s32*//*Label 3819*/ GIMT_Encode4(175039),
     /* 174944 */ /*GILLT_s64*//*Label 3820*/ GIMT_Encode4(175279),
     /* 174948 */ // Label 3818: @174948
     /* 174948 */ GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(174993), // Rule ID 21210 //
     /* 174953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174967 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 174967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 174984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174989 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174991 */   GIR_RootConstrainSelectedInstOperands,
     /* 174992 */   // GIR_Coverage, 21210,
     /* 174992 */   GIR_EraseRootFromParent_Done,
     /* 174993 */ // Label 3822: @174993
     /* 174993 */ GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(175038), // Rule ID 21212 //
     /* 174998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 175008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175012 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 175012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 175029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175034 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175036 */   GIR_RootConstrainSelectedInstOperands,
     /* 175037 */   // GIR_Coverage, 21212,
     /* 175037 */   GIR_EraseRootFromParent_Done,
     /* 175038 */ // Label 3823: @175038
     /* 175038 */ GIM_Reject,
     /* 175039 */ // Label 3819: @175039
     /* 175039 */ GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(175098), // Rule ID 1882 //
     /* 175044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 175047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175062 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175065 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175069 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175075 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175082 */   // (fpround:{ *:[f32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 175082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrm),
     /* 175085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175087 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175096 */   GIR_RootConstrainSelectedInstOperands,
     /* 175097 */   // GIR_Coverage, 1882,
     /* 175097 */   GIR_EraseRootFromParent_Done,
     /* 175098 */ // Label 3824: @175098
     /* 175098 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(175128), // Rule ID 1880 //
     /* 175103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175117 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 175117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 175122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175126 */   GIR_RootConstrainSelectedInstOperands,
     /* 175127 */   // GIR_Coverage, 1880,
     /* 175127 */   GIR_Done,
     /* 175128 */ // Label 3825: @175128
     /* 175128 */ GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(175158), // Rule ID 17733 //
     /* 175133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 175136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 175143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 175147 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 175147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 175157 */   // GIR_Coverage, 17733,
     /* 175157 */   GIR_Done,
     /* 175158 */ // Label 3826: @175158
     /* 175158 */ GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(175188), // Rule ID 17735 //
     /* 175163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 175166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 175169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 175173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 175177 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 175177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 175187 */   // GIR_Coverage, 17735,
     /* 175187 */   GIR_Done,
     /* 175188 */ // Label 3827: @175188
     /* 175188 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(175233), // Rule ID 17998 //
     /* 175193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175207 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 175207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 175224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175231 */   GIR_RootConstrainSelectedInstOperands,
     /* 175232 */   // GIR_Coverage, 17998,
     /* 175232 */   GIR_EraseRootFromParent_Done,
     /* 175233 */ // Label 3828: @175233
     /* 175233 */ GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(175278), // Rule ID 21200 //
     /* 175238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 175248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175252 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 175252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 175269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175274 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175276 */   GIR_RootConstrainSelectedInstOperands,
     /* 175277 */   // GIR_Coverage, 21200,
     /* 175277 */   GIR_EraseRootFromParent_Done,
     /* 175278 */ // Label 3829: @175278
     /* 175278 */ GIM_Reject,
     /* 175279 */ // Label 3820: @175279
     /* 175279 */ GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(175309), // Rule ID 17737 //
     /* 175284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 175287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 175290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 175294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 175298 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 175298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 175308 */   // GIR_Coverage, 17737,
     /* 175308 */   GIR_Done,
     /* 175309 */ // Label 3830: @175309
     /* 175309 */ GIM_Reject,
     /* 175310 */ // Label 3821: @175310
     /* 175310 */ GIM_Reject,
     /* 175311 */ // Label 49: @175311
     /* 175311 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 3834*/ GIMT_Encode4(176691),
     /* 175322 */ /*GILLT_s32*//*Label 3831*/ GIMT_Encode4(175354),
     /* 175326 */ /*GILLT_s64*//*Label 3832*/ GIMT_Encode4(175978), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 175350 */ /*GILLT_v4s32*//*Label 3833*/ GIMT_Encode4(176602),
     /* 175354 */ // Label 3831: @175354
     /* 175354 */ GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(175413), // Rule ID 1742 //
     /* 175359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175377 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175384 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175390 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175397 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrm),
     /* 175400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175402 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175411 */   GIR_RootConstrainSelectedInstOperands,
     /* 175412 */   // GIR_Coverage, 1742,
     /* 175412 */   GIR_EraseRootFromParent_Done,
     /* 175413 */ // Label 3835: @175413
     /* 175413 */ GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(175472), // Rule ID 1750 //
     /* 175418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175436 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175443 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175449 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175456 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrm),
     /* 175459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175470 */   GIR_RootConstrainSelectedInstOperands,
     /* 175471 */   // GIR_Coverage, 1750,
     /* 175471 */   GIR_EraseRootFromParent_Done,
     /* 175472 */ // Label 3836: @175472
     /* 175472 */ GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(175531), // Rule ID 1766 //
     /* 175477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 175480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175495 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175502 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175506 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175508 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175515 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrm),
     /* 175518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175520 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175529 */   GIR_RootConstrainSelectedInstOperands,
     /* 175530 */   // GIR_Coverage, 1766,
     /* 175530 */   GIR_EraseRootFromParent_Done,
     /* 175531 */ // Label 3837: @175531
     /* 175531 */ GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(175590), // Rule ID 1774 //
     /* 175536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175554 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175557 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175561 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175567 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175574 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrm),
     /* 175577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175588 */   GIR_RootConstrainSelectedInstOperands,
     /* 175589 */   // GIR_Coverage, 1774,
     /* 175589 */   GIR_EraseRootFromParent_Done,
     /* 175590 */ // Label 3838: @175590
     /* 175590 */ GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(175649), // Rule ID 10363 //
     /* 175595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175613 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175620 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175626 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175633 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrm),
     /* 175636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175638 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175647 */   GIR_RootConstrainSelectedInstOperands,
     /* 175648 */   // GIR_Coverage, 10363,
     /* 175648 */   GIR_EraseRootFromParent_Done,
     /* 175649 */ // Label 3839: @175649
     /* 175649 */ GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(175708), // Rule ID 10381 //
     /* 175654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175672 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175675 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175679 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175685 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175692 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrm),
     /* 175695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175697 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175706 */   GIR_RootConstrainSelectedInstOperands,
     /* 175707 */   // GIR_Coverage, 10381,
     /* 175707 */   GIR_EraseRootFromParent_Done,
     /* 175708 */ // Label 3840: @175708
     /* 175708 */ GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(175767), // Rule ID 15171 //
     /* 175713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 175719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175731 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175738 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175744 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175751 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /* 175754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175756 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175765 */   GIR_RootConstrainSelectedInstOperands,
     /* 175766 */   // GIR_Coverage, 15171,
     /* 175766 */   GIR_EraseRootFromParent_Done,
     /* 175767 */ // Label 3841: @175767
     /* 175767 */ GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(175797), // Rule ID 1740 //
     /* 175772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175786 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 175786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 175791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175795 */   GIR_RootConstrainSelectedInstOperands,
     /* 175796 */   // GIR_Coverage, 1740,
     /* 175796 */   GIR_Done,
     /* 175797 */ // Label 3842: @175797
     /* 175797 */ GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(175827), // Rule ID 1748 //
     /* 175802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175816 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 175816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 175821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175825 */   GIR_RootConstrainSelectedInstOperands,
     /* 175826 */   // GIR_Coverage, 1748,
     /* 175826 */   GIR_Done,
     /* 175827 */ // Label 3843: @175827
     /* 175827 */ GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(175857), // Rule ID 1764 //
     /* 175832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 175835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175846 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 175846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 175851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175855 */   GIR_RootConstrainSelectedInstOperands,
     /* 175856 */   // GIR_Coverage, 1764,
     /* 175856 */   GIR_Done,
     /* 175857 */ // Label 3844: @175857
     /* 175857 */ GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(175887), // Rule ID 1772 //
     /* 175862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175876 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 175876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 175881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175885 */   GIR_RootConstrainSelectedInstOperands,
     /* 175886 */   // GIR_Coverage, 1772,
     /* 175886 */   GIR_Done,
     /* 175887 */ // Label 3845: @175887
     /* 175887 */ GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(175917), // Rule ID 10361 //
     /* 175892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 175906 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 175906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 175911 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175915 */   GIR_RootConstrainSelectedInstOperands,
     /* 175916 */   // GIR_Coverage, 10361,
     /* 175916 */   GIR_Done,
     /* 175917 */ // Label 3846: @175917
     /* 175917 */ GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(175947), // Rule ID 10379 //
     /* 175922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175936 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 175936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 175941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175945 */   GIR_RootConstrainSelectedInstOperands,
     /* 175946 */   // GIR_Coverage, 10379,
     /* 175946 */   GIR_Done,
     /* 175947 */ // Label 3847: @175947
     /* 175947 */ GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(175977), // Rule ID 15169 //
     /* 175952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 175958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 175966 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 175966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 175971 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175975 */   GIR_RootConstrainSelectedInstOperands,
     /* 175976 */   // GIR_Coverage, 15169,
     /* 175976 */   GIR_Done,
     /* 175977 */ // Label 3848: @175977
     /* 175977 */ GIM_Reject,
     /* 175978 */ // Label 3832: @175978
     /* 175978 */ GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(176037), // Rule ID 1746 //
     /* 175983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 175993 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176001 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176008 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176014 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176021 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rm),
     /* 176024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176026 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176035 */   GIR_RootConstrainSelectedInstOperands,
     /* 176036 */   // GIR_Coverage, 1746,
     /* 176036 */   GIR_EraseRootFromParent_Done,
     /* 176037 */ // Label 3849: @176037
     /* 176037 */ GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(176096), // Rule ID 1754 //
     /* 176042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176060 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176067 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176073 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176080 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rm),
     /* 176083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176085 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176094 */   GIR_RootConstrainSelectedInstOperands,
     /* 176095 */   // GIR_Coverage, 1754,
     /* 176095 */   GIR_EraseRootFromParent_Done,
     /* 176096 */ // Label 3850: @176096
     /* 176096 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(176155), // Rule ID 1770 //
     /* 176101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 176104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176119 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176126 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176130 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176132 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176139 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rm),
     /* 176142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176144 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176153 */   GIR_RootConstrainSelectedInstOperands,
     /* 176154 */   // GIR_Coverage, 1770,
     /* 176154 */   GIR_EraseRootFromParent_Done,
     /* 176155 */ // Label 3851: @176155
     /* 176155 */ GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(176214), // Rule ID 1778 //
     /* 176160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 176163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176178 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176181 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176185 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176191 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176198 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rm),
     /* 176201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176203 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176212 */   GIR_RootConstrainSelectedInstOperands,
     /* 176213 */   // GIR_Coverage, 1778,
     /* 176213 */   GIR_EraseRootFromParent_Done,
     /* 176214 */ // Label 3852: @176214
     /* 176214 */ GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(176273), // Rule ID 10372 //
     /* 176219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176229 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176233 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176237 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176240 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176244 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176250 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176257 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrm),
     /* 176260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176262 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176271 */   GIR_RootConstrainSelectedInstOperands,
     /* 176272 */   // GIR_Coverage, 10372,
     /* 176272 */   GIR_EraseRootFromParent_Done,
     /* 176273 */ // Label 3853: @176273
     /* 176273 */ GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(176332), // Rule ID 10390 //
     /* 176278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176288 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176296 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176303 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176309 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176316 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrm),
     /* 176319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176321 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176330 */   GIR_RootConstrainSelectedInstOperands,
     /* 176331 */   // GIR_Coverage, 10390,
     /* 176331 */   GIR_EraseRootFromParent_Done,
     /* 176332 */ // Label 3854: @176332
     /* 176332 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(176391), // Rule ID 15180 //
     /* 176337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176355 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176358 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176362 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176368 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176375 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /* 176378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176380 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176389 */   GIR_RootConstrainSelectedInstOperands,
     /* 176390 */   // GIR_Coverage, 15180,
     /* 176390 */   GIR_EraseRootFromParent_Done,
     /* 176391 */ // Label 3855: @176391
     /* 176391 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(176421), // Rule ID 1744 //
     /* 176396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 176410 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 176410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 176415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176419 */   GIR_RootConstrainSelectedInstOperands,
     /* 176420 */   // GIR_Coverage, 1744,
     /* 176420 */   GIR_Done,
     /* 176421 */ // Label 3856: @176421
     /* 176421 */ GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(176451), // Rule ID 1752 //
     /* 176426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 176440 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 176440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 176445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176449 */   GIR_RootConstrainSelectedInstOperands,
     /* 176450 */   // GIR_Coverage, 1752,
     /* 176450 */   GIR_Done,
     /* 176451 */ // Label 3857: @176451
     /* 176451 */ GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(176481), // Rule ID 1768 //
     /* 176456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 176459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 176470 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 176470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 176475 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176479 */   GIR_RootConstrainSelectedInstOperands,
     /* 176480 */   // GIR_Coverage, 1768,
     /* 176480 */   GIR_Done,
     /* 176481 */ // Label 3858: @176481
     /* 176481 */ GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(176511), // Rule ID 1776 //
     /* 176486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 176489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 176500 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 176500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 176505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176509 */   GIR_RootConstrainSelectedInstOperands,
     /* 176510 */   // GIR_Coverage, 1776,
     /* 176510 */   GIR_Done,
     /* 176511 */ // Label 3859: @176511
     /* 176511 */ GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(176541), // Rule ID 10370 //
     /* 176516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 176530 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 176530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 176535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176539 */   GIR_RootConstrainSelectedInstOperands,
     /* 176540 */   // GIR_Coverage, 10370,
     /* 176540 */   GIR_Done,
     /* 176541 */ // Label 3860: @176541
     /* 176541 */ GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(176571), // Rule ID 10388 //
     /* 176546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 176560 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 176560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 176565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176569 */   GIR_RootConstrainSelectedInstOperands,
     /* 176570 */   // GIR_Coverage, 10388,
     /* 176570 */   GIR_Done,
     /* 176571 */ // Label 3861: @176571
     /* 176571 */ GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(176601), // Rule ID 15178 //
     /* 176576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176590 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 176590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 176595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176599 */   GIR_RootConstrainSelectedInstOperands,
     /* 176600 */   // GIR_Coverage, 15178,
     /* 176600 */   GIR_Done,
     /* 176601 */ // Label 3862: @176601
     /* 176601 */ GIM_Reject,
     /* 176602 */ // Label 3833: @176602
     /* 176602 */ GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(176690),
     /* 176607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 176614 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(176666), // Rule ID 18054 //
     /* 176619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176650 */     // (fp_to_sint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 176650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrm),
     /* 176653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176664 */     GIR_RootConstrainSelectedInstOperands,
     /* 176665 */     // GIR_Coverage, 18054,
     /* 176665 */     GIR_EraseRootFromParent_Done,
     /* 176666 */   // Label 3864: @176666
     /* 176666 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(176689), // Rule ID 18052 //
     /* 176671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176678 */     // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 176678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 176683 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176687 */     GIR_RootConstrainSelectedInstOperands,
     /* 176688 */     // GIR_Coverage, 18052,
     /* 176688 */     GIR_Done,
     /* 176689 */   // Label 3865: @176689
     /* 176689 */   GIM_Reject,
     /* 176690 */ // Label 3863: @176690
     /* 176690 */ GIM_Reject,
     /* 176691 */ // Label 3834: @176691
     /* 176691 */ GIM_Reject,
     /* 176692 */ // Label 50: @176692
     /* 176692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3868*/ GIMT_Encode4(177247),
     /* 176703 */ /*GILLT_s32*//*Label 3866*/ GIMT_Encode4(176711),
     /* 176707 */ /*GILLT_s64*//*Label 3867*/ GIMT_Encode4(176979),
     /* 176711 */ // Label 3866: @176711
     /* 176711 */ GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(176770), // Rule ID 10399 //
     /* 176716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176734 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176737 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176741 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176747 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176754 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrm),
     /* 176757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176759 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176763 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176768 */   GIR_RootConstrainSelectedInstOperands,
     /* 176769 */   // GIR_Coverage, 10399,
     /* 176769 */   GIR_EraseRootFromParent_Done,
     /* 176770 */ // Label 3869: @176770
     /* 176770 */ GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(176829), // Rule ID 10417 //
     /* 176775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176793 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176796 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176800 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176804 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176806 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176813 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrm),
     /* 176816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176818 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176827 */   GIR_RootConstrainSelectedInstOperands,
     /* 176828 */   // GIR_Coverage, 10417,
     /* 176828 */   GIR_EraseRootFromParent_Done,
     /* 176829 */ // Label 3870: @176829
     /* 176829 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(176888), // Rule ID 15189 //
     /* 176834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176844 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176848 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176852 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176859 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176865 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176872 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrm),
     /* 176875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176877 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176886 */   GIR_RootConstrainSelectedInstOperands,
     /* 176887 */   // GIR_Coverage, 15189,
     /* 176887 */   GIR_EraseRootFromParent_Done,
     /* 176888 */ // Label 3871: @176888
     /* 176888 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(176918), // Rule ID 10397 //
     /* 176893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 176907 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 176907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 176912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176916 */   GIR_RootConstrainSelectedInstOperands,
     /* 176917 */   // GIR_Coverage, 10397,
     /* 176917 */   GIR_Done,
     /* 176918 */ // Label 3872: @176918
     /* 176918 */ GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(176948), // Rule ID 10415 //
     /* 176923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 176937 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 176937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 176942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176946 */   GIR_RootConstrainSelectedInstOperands,
     /* 176947 */   // GIR_Coverage, 10415,
     /* 176947 */   GIR_Done,
     /* 176948 */ // Label 3873: @176948
     /* 176948 */ GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(176978), // Rule ID 15187 //
     /* 176953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176967 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 176967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 176972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176976 */   GIR_RootConstrainSelectedInstOperands,
     /* 176977 */   // GIR_Coverage, 15187,
     /* 176977 */   GIR_Done,
     /* 176978 */ // Label 3874: @176978
     /* 176978 */ GIM_Reject,
     /* 176979 */ // Label 3867: @176979
     /* 176979 */ GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(177038), // Rule ID 10408 //
     /* 176984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176994 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176998 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177002 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177005 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177009 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177015 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177022 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrm),
     /* 177025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177027 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177036 */   GIR_RootConstrainSelectedInstOperands,
     /* 177037 */   // GIR_Coverage, 10408,
     /* 177037 */   GIR_EraseRootFromParent_Done,
     /* 177038 */ // Label 3875: @177038
     /* 177038 */ GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(177097), // Rule ID 10426 //
     /* 177043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177061 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177068 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177072 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177074 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177081 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrm),
     /* 177084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177086 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177095 */   GIR_RootConstrainSelectedInstOperands,
     /* 177096 */   // GIR_Coverage, 10426,
     /* 177096 */   GIR_EraseRootFromParent_Done,
     /* 177097 */ // Label 3876: @177097
     /* 177097 */ GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(177156), // Rule ID 15198 //
     /* 177102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 177108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177120 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177127 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177133 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177140 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrm),
     /* 177143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177145 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177154 */   GIR_RootConstrainSelectedInstOperands,
     /* 177155 */   // GIR_Coverage, 15198,
     /* 177155 */   GIR_EraseRootFromParent_Done,
     /* 177156 */ // Label 3877: @177156
     /* 177156 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(177186), // Rule ID 10406 //
     /* 177161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177175 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 177175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 177180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177184 */   GIR_RootConstrainSelectedInstOperands,
     /* 177185 */   // GIR_Coverage, 10406,
     /* 177185 */   GIR_Done,
     /* 177186 */ // Label 3878: @177186
     /* 177186 */ GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(177216), // Rule ID 10424 //
     /* 177191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177205 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 177205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 177210 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177214 */   GIR_RootConstrainSelectedInstOperands,
     /* 177215 */   // GIR_Coverage, 10424,
     /* 177215 */   GIR_Done,
     /* 177216 */ // Label 3879: @177216
     /* 177216 */ GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(177246), // Rule ID 15196 //
     /* 177221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 177227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177235 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 177235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 177240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177244 */   GIR_RootConstrainSelectedInstOperands,
     /* 177245 */   // GIR_Coverage, 15196,
     /* 177245 */   GIR_Done,
     /* 177246 */ // Label 3880: @177246
     /* 177246 */ GIM_Reject,
     /* 177247 */ // Label 3868: @177247
     /* 177247 */ GIM_Reject,
     /* 177248 */ // Label 51: @177248
     /* 177248 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3893*/ GIMT_Encode4(180623),
     /* 177259 */ /*GILLT_s16*//*Label 3881*/ GIMT_Encode4(177343),
     /* 177263 */ /*GILLT_s32*//*Label 3882*/ GIMT_Encode4(177586),
     /* 177267 */ /*GILLT_s64*//*Label 3883*/ GIMT_Encode4(178249), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177283 */ /*GILLT_v2s64*//*Label 3884*/ GIMT_Encode4(178908), GIMT_Encode4(0),
     /* 177291 */ /*GILLT_v4s32*//*Label 3885*/ GIMT_Encode4(178997),
     /* 177295 */ /*GILLT_v4s64*//*Label 3886*/ GIMT_Encode4(179295), GIMT_Encode4(0),
     /* 177303 */ /*GILLT_v8s16*//*Label 3887*/ GIMT_Encode4(179555),
     /* 177307 */ /*GILLT_v8s32*//*Label 3888*/ GIMT_Encode4(179823),
     /* 177311 */ /*GILLT_v8s64*//*Label 3889*/ GIMT_Encode4(180091), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177323 */ /*GILLT_v16s16*//*Label 3890*/ GIMT_Encode4(180266),
     /* 177327 */ /*GILLT_v16s32*//*Label 3891*/ GIMT_Encode4(180445), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177339 */ /*GILLT_v32s16*//*Label 3892*/ GIMT_Encode4(180534),
     /* 177343 */ // Label 3881: @177343
     /* 177343 */ GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(177419), // Rule ID 22179 //
     /* 177348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177366 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177369 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177373 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177379 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177386 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrm),
     /* 177403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177408 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177417 */   GIR_RootConstrainSelectedInstOperands,
     /* 177418 */   // GIR_Coverage, 22179,
     /* 177418 */   GIR_EraseRootFromParent_Done,
     /* 177419 */ // Label 3894: @177419
     /* 177419 */ GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(177495), // Rule ID 22177 //
     /* 177424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177442 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177445 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177449 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177455 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177462 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrm),
     /* 177479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177484 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177488 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177493 */   GIR_RootConstrainSelectedInstOperands,
     /* 177494 */   // GIR_Coverage, 22177,
     /* 177494 */   GIR_EraseRootFromParent_Done,
     /* 177495 */ // Label 3895: @177495
     /* 177495 */ GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(177540), // Rule ID 22181 //
     /* 177500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177514 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 177514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 177531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177538 */   GIR_RootConstrainSelectedInstOperands,
     /* 177539 */   // GIR_Coverage, 22181,
     /* 177539 */   GIR_EraseRootFromParent_Done,
     /* 177540 */ // Label 3896: @177540
     /* 177540 */ GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(177585), // Rule ID 22183 //
     /* 177545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177559 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 177559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 177576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177583 */   GIR_RootConstrainSelectedInstOperands,
     /* 177584 */   // GIR_Coverage, 22183,
     /* 177584 */   GIR_EraseRootFromParent_Done,
     /* 177585 */ // Label 3897: @177585
     /* 177585 */ GIM_Reject,
     /* 177586 */ // Label 3882: @177586
     /* 177586 */ GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(177645), // Rule ID 1794 //
     /* 177591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 177594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177609 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177616 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177622 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177629 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 177629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrm),
     /* 177632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177634 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177643 */   GIR_RootConstrainSelectedInstOperands,
     /* 177644 */   // GIR_Coverage, 1794,
     /* 177644 */   GIR_EraseRootFromParent_Done,
     /* 177645 */ // Label 3898: @177645
     /* 177645 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(177721), // Rule ID 17976 //
     /* 177650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 177653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177668 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177671 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177675 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177681 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177688 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrm),
     /* 177705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177710 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177719 */   GIR_RootConstrainSelectedInstOperands,
     /* 177720 */   // GIR_Coverage, 17976,
     /* 177720 */   GIR_EraseRootFromParent_Done,
     /* 177721 */ // Label 3899: @177721
     /* 177721 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(177797), // Rule ID 21130 //
     /* 177726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177736 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177744 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177747 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177751 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177757 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177764 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrm),
     /* 177781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177786 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177795 */   GIR_RootConstrainSelectedInstOperands,
     /* 177796 */   // GIR_Coverage, 21130,
     /* 177796 */   GIR_EraseRootFromParent_Done,
     /* 177797 */ // Label 3900: @177797
     /* 177797 */ GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(177856), // Rule ID 1790 //
     /* 177802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 177805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177820 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177823 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177827 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177833 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177840 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 177840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrm),
     /* 177843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177854 */   GIR_RootConstrainSelectedInstOperands,
     /* 177855 */   // GIR_Coverage, 1790,
     /* 177855 */   GIR_EraseRootFromParent_Done,
     /* 177856 */ // Label 3901: @177856
     /* 177856 */ GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(177932), // Rule ID 17974 //
     /* 177861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 177864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177879 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177882 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177886 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177892 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177899 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrm),
     /* 177916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177921 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177930 */   GIR_RootConstrainSelectedInstOperands,
     /* 177931 */   // GIR_Coverage, 17974,
     /* 177931 */   GIR_EraseRootFromParent_Done,
     /* 177932 */ // Label 3902: @177932
     /* 177932 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(178008), // Rule ID 21128 //
     /* 177937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177955 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177958 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177962 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177968 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177975 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrm),
     /* 177992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177997 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178006 */   GIR_RootConstrainSelectedInstOperands,
     /* 178007 */   // GIR_Coverage, 21128,
     /* 178007 */   GIR_EraseRootFromParent_Done,
     /* 178008 */ // Label 3903: @178008
     /* 178008 */ GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(178038), // Rule ID 1788 //
     /* 178013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 178016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178027 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 178027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 178032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178036 */   GIR_RootConstrainSelectedInstOperands,
     /* 178037 */   // GIR_Coverage, 1788,
     /* 178037 */   GIR_Done,
     /* 178038 */ // Label 3904: @178038
     /* 178038 */ GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(178068), // Rule ID 1792 //
     /* 178043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 178046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178057 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 178057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 178062 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178066 */   GIR_RootConstrainSelectedInstOperands,
     /* 178067 */   // GIR_Coverage, 1792,
     /* 178067 */   GIR_Done,
     /* 178068 */ // Label 3905: @178068
     /* 178068 */ GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(178113), // Rule ID 17982 //
     /* 178073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178087 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 178087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 178104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178111 */   GIR_RootConstrainSelectedInstOperands,
     /* 178112 */   // GIR_Coverage, 17982,
     /* 178112 */   GIR_EraseRootFromParent_Done,
     /* 178113 */ // Label 3906: @178113
     /* 178113 */ GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(178158), // Rule ID 17984 //
     /* 178118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178132 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 178132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 178149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178154 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178156 */   GIR_RootConstrainSelectedInstOperands,
     /* 178157 */   // GIR_Coverage, 17984,
     /* 178157 */   GIR_EraseRootFromParent_Done,
     /* 178158 */ // Label 3907: @178158
     /* 178158 */ GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(178203), // Rule ID 21136 //
     /* 178163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 178173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178177 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 178177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 178194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178201 */   GIR_RootConstrainSelectedInstOperands,
     /* 178202 */   // GIR_Coverage, 21136,
     /* 178202 */   GIR_EraseRootFromParent_Done,
     /* 178203 */ // Label 3908: @178203
     /* 178203 */ GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(178248), // Rule ID 21138 //
     /* 178208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 178218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178222 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 178222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 178239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178244 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178246 */   GIR_RootConstrainSelectedInstOperands,
     /* 178247 */   // GIR_Coverage, 21138,
     /* 178247 */   GIR_EraseRootFromParent_Done,
     /* 178248 */ // Label 3909: @178248
     /* 178248 */ GIM_Reject,
     /* 178249 */ // Label 3883: @178249
     /* 178249 */ GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(178308), // Rule ID 1802 //
     /* 178254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178272 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178279 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178285 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178292 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 178292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrm),
     /* 178295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178306 */   GIR_RootConstrainSelectedInstOperands,
     /* 178307 */   // GIR_Coverage, 1802,
     /* 178307 */   GIR_EraseRootFromParent_Done,
     /* 178308 */ // Label 3910: @178308
     /* 178308 */ GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(178384), // Rule ID 17980 //
     /* 178313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178331 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178334 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178338 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178344 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178351 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrm),
     /* 178368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178373 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178382 */   GIR_RootConstrainSelectedInstOperands,
     /* 178383 */   // GIR_Coverage, 17980,
     /* 178383 */   GIR_EraseRootFromParent_Done,
     /* 178384 */ // Label 3911: @178384
     /* 178384 */ GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(178460), // Rule ID 21134 //
     /* 178389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178407 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178414 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178420 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178427 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrm),
     /* 178444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178449 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178458 */   GIR_RootConstrainSelectedInstOperands,
     /* 178459 */   // GIR_Coverage, 21134,
     /* 178459 */   GIR_EraseRootFromParent_Done,
     /* 178460 */ // Label 3912: @178460
     /* 178460 */ GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(178519), // Rule ID 1798 //
     /* 178465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178483 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178486 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178490 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178496 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178503 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 178503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrm),
     /* 178506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178508 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178517 */   GIR_RootConstrainSelectedInstOperands,
     /* 178518 */   // GIR_Coverage, 1798,
     /* 178518 */   GIR_EraseRootFromParent_Done,
     /* 178519 */ // Label 3913: @178519
     /* 178519 */ GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(178595), // Rule ID 17978 //
     /* 178524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178542 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178545 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178549 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178555 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178562 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrm),
     /* 178579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178584 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178593 */   GIR_RootConstrainSelectedInstOperands,
     /* 178594 */   // GIR_Coverage, 17978,
     /* 178594 */   GIR_EraseRootFromParent_Done,
     /* 178595 */ // Label 3914: @178595
     /* 178595 */ GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(178671), // Rule ID 21132 //
     /* 178600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178618 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178621 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178625 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178629 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178631 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178638 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrm),
     /* 178655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178657 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178660 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178669 */   GIR_RootConstrainSelectedInstOperands,
     /* 178670 */   // GIR_Coverage, 21132,
     /* 178670 */   GIR_EraseRootFromParent_Done,
     /* 178671 */ // Label 3915: @178671
     /* 178671 */ GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(178697), // Rule ID 1796 //
     /* 178676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178690 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 178690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 178695 */   GIR_RootConstrainSelectedInstOperands,
     /* 178696 */   // GIR_Coverage, 1796,
     /* 178696 */   GIR_Done,
     /* 178697 */ // Label 3916: @178697
     /* 178697 */ GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(178727), // Rule ID 1800 //
     /* 178702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178716 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 178716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 178721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178725 */   GIR_RootConstrainSelectedInstOperands,
     /* 178726 */   // GIR_Coverage, 1800,
     /* 178726 */   GIR_Done,
     /* 178727 */ // Label 3917: @178727
     /* 178727 */ GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(178772), // Rule ID 17986 //
     /* 178732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178746 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 178763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178770 */   GIR_RootConstrainSelectedInstOperands,
     /* 178771 */   // GIR_Coverage, 17986,
     /* 178771 */   GIR_EraseRootFromParent_Done,
     /* 178772 */ // Label 3918: @178772
     /* 178772 */ GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(178817), // Rule ID 17988 //
     /* 178777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178791 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 178808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178813 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178815 */   GIR_RootConstrainSelectedInstOperands,
     /* 178816 */   // GIR_Coverage, 17988,
     /* 178816 */   GIR_EraseRootFromParent_Done,
     /* 178817 */ // Label 3919: @178817
     /* 178817 */ GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(178862), // Rule ID 21140 //
     /* 178822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178836 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 178853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178858 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178860 */   GIR_RootConstrainSelectedInstOperands,
     /* 178861 */   // GIR_Coverage, 21140,
     /* 178861 */   GIR_EraseRootFromParent_Done,
     /* 178862 */ // Label 3920: @178862
     /* 178862 */ GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(178907), // Rule ID 21142 //
     /* 178867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178881 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 178898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178903 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178905 */   GIR_RootConstrainSelectedInstOperands,
     /* 178906 */   // GIR_Coverage, 21142,
     /* 178906 */   GIR_EraseRootFromParent_Done,
     /* 178907 */ // Label 3921: @178907
     /* 178907 */ GIM_Reject,
     /* 178908 */ // Label 3884: @178908
     /* 178908 */ GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(178996),
     /* 178913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178920 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(178972), // Rule ID 11379 //
     /* 178925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178956 */     // (sint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 178956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rm),
     /* 178959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178970 */     GIR_RootConstrainSelectedInstOperands,
     /* 178971 */     // GIR_Coverage, 11379,
     /* 178971 */     GIR_EraseRootFromParent_Done,
     /* 178972 */   // Label 3923: @178972
     /* 178972 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(178995), // Rule ID 11375 //
     /* 178977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178984 */     // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 178984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 178989 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178993 */     GIR_RootConstrainSelectedInstOperands,
     /* 178994 */     // GIR_Coverage, 11375,
     /* 178994 */     GIR_Done,
     /* 178995 */   // Label 3924: @178995
     /* 178995 */   GIM_Reject,
     /* 178996 */ // Label 3922: @178996
     /* 178996 */ GIM_Reject,
     /* 178997 */ // Label 3885: @178997
     /* 178997 */ GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(179056), // Rule ID 1870 //
     /* 179002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179012 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179016 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179020 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179027 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179033 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179040 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrm),
     /* 179043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179045 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179054 */   GIR_RootConstrainSelectedInstOperands,
     /* 179055 */   // GIR_Coverage, 1870,
     /* 179055 */   GIR_EraseRootFromParent_Done,
     /* 179056 */ // Label 3925: @179056
     /* 179056 */ GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(179115), // Rule ID 10755 //
     /* 179061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179079 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179086 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179090 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179092 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179099 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rm),
     /* 179102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179104 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179113 */   GIR_RootConstrainSelectedInstOperands,
     /* 179114 */   // GIR_Coverage, 10755,
     /* 179114 */   GIR_EraseRootFromParent_Done,
     /* 179115 */ // Label 3926: @179115
     /* 179115 */ GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(179174), // Rule ID 11511 //
     /* 179120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179138 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179141 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179145 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179151 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179158 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rm),
     /* 179161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179163 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179172 */   GIR_RootConstrainSelectedInstOperands,
     /* 179173 */   // GIR_Coverage, 11511,
     /* 179173 */   GIR_EraseRootFromParent_Done,
     /* 179174 */ // Label 3927: @179174
     /* 179174 */ GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(179204), // Rule ID 1868 //
     /* 179179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179193 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 179193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 179198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179202 */   GIR_RootConstrainSelectedInstOperands,
     /* 179203 */   // GIR_Coverage, 1868,
     /* 179203 */   GIR_Done,
     /* 179204 */ // Label 3928: @179204
     /* 179204 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(179234), // Rule ID 1876 //
     /* 179209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 179212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179223 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 179223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 179228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179232 */   GIR_RootConstrainSelectedInstOperands,
     /* 179233 */   // GIR_Coverage, 1876,
     /* 179233 */   GIR_Done,
     /* 179234 */ // Label 3929: @179234
     /* 179234 */ GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(179264), // Rule ID 10751 //
     /* 179239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179253 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 179253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 179258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179262 */   GIR_RootConstrainSelectedInstOperands,
     /* 179263 */   // GIR_Coverage, 10751,
     /* 179263 */   GIR_Done,
     /* 179264 */ // Label 3930: @179264
     /* 179264 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(179294), // Rule ID 11507 //
     /* 179269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179283 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 179283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 179288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179292 */   GIR_RootConstrainSelectedInstOperands,
     /* 179293 */   // GIR_Coverage, 11507,
     /* 179293 */   GIR_Done,
     /* 179294 */ // Label 3931: @179294
     /* 179294 */ GIM_Reject,
     /* 179295 */ // Label 3886: @179295
     /* 179295 */ GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(179354), // Rule ID 1945 //
     /* 179300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179318 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179321 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179325 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179331 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179338 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrm),
     /* 179341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179343 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179352 */   GIR_RootConstrainSelectedInstOperands,
     /* 179353 */   // GIR_Coverage, 1945,
     /* 179353 */   GIR_EraseRootFromParent_Done,
     /* 179354 */ // Label 3932: @179354
     /* 179354 */ GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(179413), // Rule ID 10728 //
     /* 179359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179377 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179384 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179390 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179397 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rm),
     /* 179400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179402 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179411 */   GIR_RootConstrainSelectedInstOperands,
     /* 179412 */   // GIR_Coverage, 10728,
     /* 179412 */   GIR_EraseRootFromParent_Done,
     /* 179413 */ // Label 3933: @179413
     /* 179413 */ GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(179472), // Rule ID 11391 //
     /* 179418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179436 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179443 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179449 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179456 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rm),
     /* 179459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179470 */   GIR_RootConstrainSelectedInstOperands,
     /* 179471 */   // GIR_Coverage, 11391,
     /* 179471 */   GIR_EraseRootFromParent_Done,
     /* 179472 */ // Label 3934: @179472
     /* 179472 */ GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(179498), // Rule ID 1947 //
     /* 179477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179491 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 179491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 179496 */   GIR_RootConstrainSelectedInstOperands,
     /* 179497 */   // GIR_Coverage, 1947,
     /* 179497 */   GIR_Done,
     /* 179498 */ // Label 3935: @179498
     /* 179498 */ GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(179524), // Rule ID 10724 //
     /* 179503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179517 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 179517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 179522 */   GIR_RootConstrainSelectedInstOperands,
     /* 179523 */   // GIR_Coverage, 10724,
     /* 179523 */   GIR_Done,
     /* 179524 */ // Label 3936: @179524
     /* 179524 */ GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(179554), // Rule ID 11387 //
     /* 179529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179543 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 179543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 179548 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179552 */   GIR_RootConstrainSelectedInstOperands,
     /* 179553 */   // GIR_Coverage, 11387,
     /* 179553 */   GIR_Done,
     /* 179554 */ // Label 3937: @179554
     /* 179554 */ GIM_Reject,
     /* 179555 */ // Label 3887: @179555
     /* 179555 */ GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(179614), // Rule ID 11457 //
     /* 179560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179578 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179585 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179591 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179598 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rm),
     /* 179601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179603 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179612 */   GIR_RootConstrainSelectedInstOperands,
     /* 179613 */   // GIR_Coverage, 11457,
     /* 179613 */   GIR_EraseRootFromParent_Done,
     /* 179614 */ // Label 3938: @179614
     /* 179614 */ GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(179673), // Rule ID 14823 //
     /* 179619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179637 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179644 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179648 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179650 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179657 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rm),
     /* 179660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179662 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179671 */   GIR_RootConstrainSelectedInstOperands,
     /* 179672 */   // GIR_Coverage, 14823,
     /* 179672 */   GIR_EraseRootFromParent_Done,
     /* 179673 */ // Label 3939: @179673
     /* 179673 */ GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(179732), // Rule ID 15123 //
     /* 179678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179696 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179699 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179703 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179707 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179709 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179716 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrm),
     /* 179719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179721 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179730 */   GIR_RootConstrainSelectedInstOperands,
     /* 179731 */   // GIR_Coverage, 15123,
     /* 179731 */   GIR_EraseRootFromParent_Done,
     /* 179732 */ // Label 3940: @179732
     /* 179732 */ GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(179762), // Rule ID 11453 //
     /* 179737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179751 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 179751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 179756 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179760 */   GIR_RootConstrainSelectedInstOperands,
     /* 179761 */   // GIR_Coverage, 11453,
     /* 179761 */   GIR_Done,
     /* 179762 */ // Label 3941: @179762
     /* 179762 */ GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(179792), // Rule ID 14819 //
     /* 179767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179781 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 179781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 179786 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179790 */   GIR_RootConstrainSelectedInstOperands,
     /* 179791 */   // GIR_Coverage, 14819,
     /* 179791 */   GIR_Done,
     /* 179792 */ // Label 3942: @179792
     /* 179792 */ GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(179822), // Rule ID 15119 //
     /* 179797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179811 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 179811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 179816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179820 */   GIR_RootConstrainSelectedInstOperands,
     /* 179821 */   // GIR_Coverage, 15119,
     /* 179821 */   GIR_Done,
     /* 179822 */ // Label 3943: @179822
     /* 179822 */ GIM_Reject,
     /* 179823 */ // Label 3888: @179823
     /* 179823 */ GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(179882), // Rule ID 1874 //
     /* 179828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179846 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179853 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179859 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179866 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrm),
     /* 179869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179871 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179880 */   GIR_RootConstrainSelectedInstOperands,
     /* 179881 */   // GIR_Coverage, 1874,
     /* 179881 */   GIR_EraseRootFromParent_Done,
     /* 179882 */ // Label 3944: @179882
     /* 179882 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(179941), // Rule ID 10767 //
     /* 179887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179905 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179912 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179918 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179925 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rm),
     /* 179928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179930 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179939 */   GIR_RootConstrainSelectedInstOperands,
     /* 179940 */   // GIR_Coverage, 10767,
     /* 179940 */   GIR_EraseRootFromParent_Done,
     /* 179941 */ // Label 3945: @179941
     /* 179941 */ GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(180000), // Rule ID 11496 //
     /* 179946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179964 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179967 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179971 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179975 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179977 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179984 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrm),
     /* 179987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179989 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179998 */   GIR_RootConstrainSelectedInstOperands,
     /* 179999 */   // GIR_Coverage, 11496,
     /* 179999 */   GIR_EraseRootFromParent_Done,
     /* 180000 */ // Label 3946: @180000
     /* 180000 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(180030), // Rule ID 1872 //
     /* 180005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180019 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 180019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 180024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180028 */   GIR_RootConstrainSelectedInstOperands,
     /* 180029 */   // GIR_Coverage, 1872,
     /* 180029 */   GIR_Done,
     /* 180030 */ // Label 3947: @180030
     /* 180030 */ GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(180060), // Rule ID 10763 //
     /* 180035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 180038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180049 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 180049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 180054 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180058 */   GIR_RootConstrainSelectedInstOperands,
     /* 180059 */   // GIR_Coverage, 10763,
     /* 180059 */   GIR_Done,
     /* 180060 */ // Label 3948: @180060
     /* 180060 */ GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(180090), // Rule ID 11492 //
     /* 180065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180079 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 180079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 180084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180088 */   GIR_RootConstrainSelectedInstOperands,
     /* 180089 */   // GIR_Coverage, 11492,
     /* 180089 */   GIR_Done,
     /* 180090 */ // Label 3949: @180090
     /* 180090 */ GIM_Reject,
     /* 180091 */ // Label 3889: @180091
     /* 180091 */ GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(180150), // Rule ID 10704 //
     /* 180096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180114 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180117 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180121 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180127 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180134 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 180134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrm),
     /* 180137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180139 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180148 */   GIR_RootConstrainSelectedInstOperands,
     /* 180149 */   // GIR_Coverage, 10704,
     /* 180149 */   GIR_EraseRootFromParent_Done,
     /* 180150 */ // Label 3950: @180150
     /* 180150 */ GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(180209), // Rule ID 11364 //
     /* 180155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180173 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180180 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180184 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180186 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180193 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 180193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrm),
     /* 180196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180198 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180207 */   GIR_RootConstrainSelectedInstOperands,
     /* 180208 */   // GIR_Coverage, 11364,
     /* 180208 */   GIR_EraseRootFromParent_Done,
     /* 180209 */ // Label 3951: @180209
     /* 180209 */ GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(180235), // Rule ID 10700 //
     /* 180214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180228 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 180228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 180233 */   GIR_RootConstrainSelectedInstOperands,
     /* 180234 */   // GIR_Coverage, 10700,
     /* 180234 */   GIR_Done,
     /* 180235 */ // Label 3952: @180235
     /* 180235 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(180265), // Rule ID 11360 //
     /* 180240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180254 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 180254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 180259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180263 */   GIR_RootConstrainSelectedInstOperands,
     /* 180264 */   // GIR_Coverage, 11360,
     /* 180264 */   GIR_Done,
     /* 180265 */ // Label 3953: @180265
     /* 180265 */ GIM_Reject,
     /* 180266 */ // Label 3890: @180266
     /* 180266 */ GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(180325), // Rule ID 11442 //
     /* 180271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180281 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180285 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180289 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180292 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180296 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180300 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180302 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180309 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 180309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrm),
     /* 180312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180314 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180323 */   GIR_RootConstrainSelectedInstOperands,
     /* 180324 */   // GIR_Coverage, 11442,
     /* 180324 */   GIR_EraseRootFromParent_Done,
     /* 180325 */ // Label 3954: @180325
     /* 180325 */ GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(180384), // Rule ID 14835 //
     /* 180330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 180333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 180336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180348 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180351 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180355 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180361 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180368 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 180368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rm),
     /* 180371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180373 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180382 */   GIR_RootConstrainSelectedInstOperands,
     /* 180383 */   // GIR_Coverage, 14835,
     /* 180383 */   GIR_EraseRootFromParent_Done,
     /* 180384 */ // Label 3955: @180384
     /* 180384 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(180414), // Rule ID 11438 //
     /* 180389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180403 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 180403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 180408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180412 */   GIR_RootConstrainSelectedInstOperands,
     /* 180413 */   // GIR_Coverage, 11438,
     /* 180413 */   GIR_Done,
     /* 180414 */ // Label 3956: @180414
     /* 180414 */ GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(180444), // Rule ID 14831 //
     /* 180419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 180422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 180425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180433 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 180433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 180438 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180442 */   GIR_RootConstrainSelectedInstOperands,
     /* 180443 */   // GIR_Coverage, 14831,
     /* 180443 */   GIR_Done,
     /* 180444 */ // Label 3957: @180444
     /* 180444 */ GIM_Reject,
     /* 180445 */ // Label 3891: @180445
     /* 180445 */ GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(180533),
     /* 180450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180457 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(180509), // Rule ID 10740 //
     /* 180462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180493 */     // (sint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 180493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrm),
     /* 180496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180507 */     GIR_RootConstrainSelectedInstOperands,
     /* 180508 */     // GIR_Coverage, 10740,
     /* 180508 */     GIR_EraseRootFromParent_Done,
     /* 180509 */   // Label 3959: @180509
     /* 180509 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(180532), // Rule ID 10736 //
     /* 180514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180521 */     // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 180521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 180526 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180530 */     GIR_RootConstrainSelectedInstOperands,
     /* 180531 */     // GIR_Coverage, 10736,
     /* 180531 */     GIR_Done,
     /* 180532 */   // Label 3960: @180532
     /* 180532 */   GIM_Reject,
     /* 180533 */ // Label 3958: @180533
     /* 180533 */ GIM_Reject,
     /* 180534 */ // Label 3892: @180534
     /* 180534 */ GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(180622),
     /* 180539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 180542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180546 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(180598), // Rule ID 14808 //
     /* 180551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180582 */     // (sint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 180582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrm),
     /* 180585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180587 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180596 */     GIR_RootConstrainSelectedInstOperands,
     /* 180597 */     // GIR_Coverage, 14808,
     /* 180597 */     GIR_EraseRootFromParent_Done,
     /* 180598 */   // Label 3962: @180598
     /* 180598 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(180621), // Rule ID 14804 //
     /* 180603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180610 */     // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 180610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 180615 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180619 */     GIR_RootConstrainSelectedInstOperands,
     /* 180620 */     // GIR_Coverage, 14804,
     /* 180620 */     GIR_Done,
     /* 180621 */   // Label 3963: @180621
     /* 180621 */   GIM_Reject,
     /* 180622 */ // Label 3961: @180622
     /* 180622 */ GIM_Reject,
     /* 180623 */ // Label 3893: @180623
     /* 180623 */ GIM_Reject,
     /* 180624 */ // Label 52: @180624
     /* 180624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3976*/ GIMT_Encode4(182870),
     /* 180635 */ /*GILLT_s16*//*Label 3964*/ GIMT_Encode4(180719),
     /* 180639 */ /*GILLT_s32*//*Label 3965*/ GIMT_Encode4(180962),
     /* 180643 */ /*GILLT_s64*//*Label 3966*/ GIMT_Encode4(181205), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180659 */ /*GILLT_v2s64*//*Label 3967*/ GIMT_Encode4(181448), GIMT_Encode4(0),
     /* 180667 */ /*GILLT_v4s32*//*Label 3968*/ GIMT_Encode4(181537),
     /* 180671 */ /*GILLT_v4s64*//*Label 3969*/ GIMT_Encode4(181716), GIMT_Encode4(0),
     /* 180679 */ /*GILLT_v8s16*//*Label 3970*/ GIMT_Encode4(181891),
     /* 180683 */ /*GILLT_v8s32*//*Label 3971*/ GIMT_Encode4(182159),
     /* 180687 */ /*GILLT_v8s64*//*Label 3972*/ GIMT_Encode4(182338), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180699 */ /*GILLT_v16s16*//*Label 3973*/ GIMT_Encode4(182513),
     /* 180703 */ /*GILLT_v16s32*//*Label 3974*/ GIMT_Encode4(182692), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180715 */ /*GILLT_v32s16*//*Label 3975*/ GIMT_Encode4(182781),
     /* 180719 */ // Label 3964: @180719
     /* 180719 */ GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(180795), // Rule ID 22187 //
     /* 180724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180742 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180745 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180749 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180755 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180762 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 180762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrm),
     /* 180779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180784 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180793 */   GIR_RootConstrainSelectedInstOperands,
     /* 180794 */   // GIR_Coverage, 22187,
     /* 180794 */   GIR_EraseRootFromParent_Done,
     /* 180795 */ // Label 3977: @180795
     /* 180795 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(180871), // Rule ID 22185 //
     /* 180800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 180806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180818 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180821 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180825 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 180829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180831 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180838 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 180838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrm),
     /* 180855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180860 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180869 */   GIR_RootConstrainSelectedInstOperands,
     /* 180870 */   // GIR_Coverage, 22185,
     /* 180870 */   GIR_EraseRootFromParent_Done,
     /* 180871 */ // Label 3978: @180871
     /* 180871 */ GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(180916), // Rule ID 22189 //
     /* 180876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 180882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 180890 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 180890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 180907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180912 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 180914 */   GIR_RootConstrainSelectedInstOperands,
     /* 180915 */   // GIR_Coverage, 22189,
     /* 180915 */   GIR_EraseRootFromParent_Done,
     /* 180916 */ // Label 3979: @180916
     /* 180916 */ GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(180961), // Rule ID 22191 //
     /* 180921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 180935 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 180935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 180952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180957 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 180959 */   GIR_RootConstrainSelectedInstOperands,
     /* 180960 */   // GIR_Coverage, 22191,
     /* 180960 */   GIR_EraseRootFromParent_Done,
     /* 180961 */ // Label 3980: @180961
     /* 180961 */ GIM_Reject,
     /* 180962 */ // Label 3965: @180962
     /* 180962 */ GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(181038), // Rule ID 21146 //
     /* 180967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 180977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180985 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180992 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180998 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181005 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 181005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrm),
     /* 181022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181027 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181036 */   GIR_RootConstrainSelectedInstOperands,
     /* 181037 */   // GIR_Coverage, 21146,
     /* 181037 */   GIR_EraseRootFromParent_Done,
     /* 181038 */ // Label 3981: @181038
     /* 181038 */ GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(181114), // Rule ID 21144 //
     /* 181043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181061 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181064 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181068 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 181072 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181074 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181081 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 181081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrm),
     /* 181098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181103 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181112 */   GIR_RootConstrainSelectedInstOperands,
     /* 181113 */   // GIR_Coverage, 21144,
     /* 181113 */   GIR_EraseRootFromParent_Done,
     /* 181114 */ // Label 3982: @181114
     /* 181114 */ GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(181159), // Rule ID 21152 //
     /* 181119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 181133 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 181133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 181150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181157 */   GIR_RootConstrainSelectedInstOperands,
     /* 181158 */   // GIR_Coverage, 21152,
     /* 181158 */   GIR_EraseRootFromParent_Done,
     /* 181159 */ // Label 3983: @181159
     /* 181159 */ GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(181204), // Rule ID 21154 //
     /* 181164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 181178 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 181178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 181195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181202 */   GIR_RootConstrainSelectedInstOperands,
     /* 181203 */   // GIR_Coverage, 21154,
     /* 181203 */   GIR_EraseRootFromParent_Done,
     /* 181204 */ // Label 3984: @181204
     /* 181204 */ GIM_Reject,
     /* 181205 */ // Label 3966: @181205
     /* 181205 */ GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(181281), // Rule ID 21150 //
     /* 181210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181228 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181235 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181239 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181241 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181248 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 181248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrm),
     /* 181265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181270 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181279 */   GIR_RootConstrainSelectedInstOperands,
     /* 181280 */   // GIR_Coverage, 21150,
     /* 181280 */   GIR_EraseRootFromParent_Done,
     /* 181281 */ // Label 3985: @181281
     /* 181281 */ GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(181357), // Rule ID 21148 //
     /* 181286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181304 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181307 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181311 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 181315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181317 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181324 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 181324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrm),
     /* 181341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181346 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181355 */   GIR_RootConstrainSelectedInstOperands,
     /* 181356 */   // GIR_Coverage, 21148,
     /* 181356 */   GIR_EraseRootFromParent_Done,
     /* 181357 */ // Label 3986: @181357
     /* 181357 */ GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(181402), // Rule ID 21156 //
     /* 181362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 181376 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 181376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 181393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181400 */   GIR_RootConstrainSelectedInstOperands,
     /* 181401 */   // GIR_Coverage, 21156,
     /* 181401 */   GIR_EraseRootFromParent_Done,
     /* 181402 */ // Label 3987: @181402
     /* 181402 */ GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(181447), // Rule ID 21158 //
     /* 181407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 181421 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 181421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 181438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181443 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181445 */   GIR_RootConstrainSelectedInstOperands,
     /* 181446 */   // GIR_Coverage, 21158,
     /* 181446 */   GIR_EraseRootFromParent_Done,
     /* 181447 */ // Label 3988: @181447
     /* 181447 */ GIM_Reject,
     /* 181448 */ // Label 3967: @181448
     /* 181448 */ GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(181536),
     /* 181453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 181456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181460 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(181512), // Rule ID 11418 //
     /* 181465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181496 */     // (uint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 181496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rm),
     /* 181499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181510 */     GIR_RootConstrainSelectedInstOperands,
     /* 181511 */     // GIR_Coverage, 11418,
     /* 181511 */     GIR_EraseRootFromParent_Done,
     /* 181512 */   // Label 3990: @181512
     /* 181512 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(181535), // Rule ID 11414 //
     /* 181517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181524 */     // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 181524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 181529 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181533 */     GIR_RootConstrainSelectedInstOperands,
     /* 181534 */     // GIR_Coverage, 11414,
     /* 181534 */     GIR_Done,
     /* 181535 */   // Label 3991: @181535
     /* 181535 */   GIM_Reject,
     /* 181536 */ // Label 3989: @181536
     /* 181536 */ GIM_Reject,
     /* 181537 */ // Label 3968: @181537
     /* 181537 */ GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(181596), // Rule ID 10962 //
     /* 181542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181560 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181563 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181567 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181573 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181580 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 181580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rm),
     /* 181583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181585 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181594 */   GIR_RootConstrainSelectedInstOperands,
     /* 181595 */   // GIR_Coverage, 10962,
     /* 181595 */   GIR_EraseRootFromParent_Done,
     /* 181596 */ // Label 3992: @181596
     /* 181596 */ GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(181655), // Rule ID 11538 //
     /* 181601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181619 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181626 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181632 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181639 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 181639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rm),
     /* 181642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181644 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181653 */   GIR_RootConstrainSelectedInstOperands,
     /* 181654 */   // GIR_Coverage, 11538,
     /* 181654 */   GIR_EraseRootFromParent_Done,
     /* 181655 */ // Label 3993: @181655
     /* 181655 */ GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(181685), // Rule ID 10958 //
     /* 181660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181674 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 181674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 181679 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181683 */   GIR_RootConstrainSelectedInstOperands,
     /* 181684 */   // GIR_Coverage, 10958,
     /* 181684 */   GIR_Done,
     /* 181685 */ // Label 3994: @181685
     /* 181685 */ GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(181715), // Rule ID 11534 //
     /* 181690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181704 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 181704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 181709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181713 */   GIR_RootConstrainSelectedInstOperands,
     /* 181714 */   // GIR_Coverage, 11534,
     /* 181714 */   GIR_Done,
     /* 181715 */ // Label 3995: @181715
     /* 181715 */ GIM_Reject,
     /* 181716 */ // Label 3969: @181716
     /* 181716 */ GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(181775), // Rule ID 10935 //
     /* 181721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181739 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181746 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181752 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181759 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 181759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rm),
     /* 181762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181764 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181773 */   GIR_RootConstrainSelectedInstOperands,
     /* 181774 */   // GIR_Coverage, 10935,
     /* 181774 */   GIR_EraseRootFromParent_Done,
     /* 181775 */ // Label 3996: @181775
     /* 181775 */ GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(181834), // Rule ID 11430 //
     /* 181780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181798 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181805 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181811 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181818 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 181818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rm),
     /* 181821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181823 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181832 */   GIR_RootConstrainSelectedInstOperands,
     /* 181833 */   // GIR_Coverage, 11430,
     /* 181833 */   GIR_EraseRootFromParent_Done,
     /* 181834 */ // Label 3997: @181834
     /* 181834 */ GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(181860), // Rule ID 10931 //
     /* 181839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181853 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 181853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 181858 */   GIR_RootConstrainSelectedInstOperands,
     /* 181859 */   // GIR_Coverage, 10931,
     /* 181859 */   GIR_Done,
     /* 181860 */ // Label 3998: @181860
     /* 181860 */ GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(181890), // Rule ID 11426 //
     /* 181865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181879 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 181879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 181884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181888 */   GIR_RootConstrainSelectedInstOperands,
     /* 181889 */   // GIR_Coverage, 11426,
     /* 181889 */   GIR_Done,
     /* 181890 */ // Label 3999: @181890
     /* 181890 */ GIM_Reject,
     /* 181891 */ // Label 3970: @181891
     /* 181891 */ GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(181950), // Rule ID 11484 //
     /* 181896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 181899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 181902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181914 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181917 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181921 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181927 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181934 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 181934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rm),
     /* 181937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181939 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181948 */   GIR_RootConstrainSelectedInstOperands,
     /* 181949 */   // GIR_Coverage, 11484,
     /* 181949 */   GIR_EraseRootFromParent_Done,
     /* 181950 */ // Label 4000: @181950
     /* 181950 */ GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(182009), // Rule ID 14676 //
     /* 181955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 181958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 181961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181973 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181980 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181986 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181993 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 181993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rm),
     /* 181996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181998 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182007 */   GIR_RootConstrainSelectedInstOperands,
     /* 182008 */   // GIR_Coverage, 14676,
     /* 182008 */   GIR_EraseRootFromParent_Done,
     /* 182009 */ // Label 4001: @182009
     /* 182009 */ GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(182068), // Rule ID 15138 //
     /* 182014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182032 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182039 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182045 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182052 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 182052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrm),
     /* 182055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182057 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182066 */   GIR_RootConstrainSelectedInstOperands,
     /* 182067 */   // GIR_Coverage, 15138,
     /* 182067 */   GIR_EraseRootFromParent_Done,
     /* 182068 */ // Label 4002: @182068
     /* 182068 */ GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(182098), // Rule ID 11480 //
     /* 182073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182087 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 182087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 182092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182096 */   GIR_RootConstrainSelectedInstOperands,
     /* 182097 */   // GIR_Coverage, 11480,
     /* 182097 */   GIR_Done,
     /* 182098 */ // Label 4003: @182098
     /* 182098 */ GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(182128), // Rule ID 14672 //
     /* 182103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 182109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182117 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 182117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 182122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182126 */   GIR_RootConstrainSelectedInstOperands,
     /* 182127 */   // GIR_Coverage, 14672,
     /* 182127 */   GIR_Done,
     /* 182128 */ // Label 4004: @182128
     /* 182128 */ GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(182158), // Rule ID 15134 //
     /* 182133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182147 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 182147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 182152 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182156 */   GIR_RootConstrainSelectedInstOperands,
     /* 182157 */   // GIR_Coverage, 15134,
     /* 182157 */   GIR_Done,
     /* 182158 */ // Label 4005: @182158
     /* 182158 */ GIM_Reject,
     /* 182159 */ // Label 3971: @182159
     /* 182159 */ GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(182218), // Rule ID 10974 //
     /* 182164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 182167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182182 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182185 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182189 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182195 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182202 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 182202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rm),
     /* 182205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182207 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182216 */   GIR_RootConstrainSelectedInstOperands,
     /* 182217 */   // GIR_Coverage, 10974,
     /* 182217 */   GIR_EraseRootFromParent_Done,
     /* 182218 */ // Label 4006: @182218
     /* 182218 */ GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(182277), // Rule ID 11523 //
     /* 182223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182241 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182248 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182254 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182261 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 182261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrm),
     /* 182264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182266 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182275 */   GIR_RootConstrainSelectedInstOperands,
     /* 182276 */   // GIR_Coverage, 11523,
     /* 182276 */   GIR_EraseRootFromParent_Done,
     /* 182277 */ // Label 4007: @182277
     /* 182277 */ GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(182307), // Rule ID 10970 //
     /* 182282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 182285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182296 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 182296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 182301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182305 */   GIR_RootConstrainSelectedInstOperands,
     /* 182306 */   // GIR_Coverage, 10970,
     /* 182306 */   GIR_Done,
     /* 182307 */ // Label 4008: @182307
     /* 182307 */ GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(182337), // Rule ID 11519 //
     /* 182312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182326 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 182326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 182331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182335 */   GIR_RootConstrainSelectedInstOperands,
     /* 182336 */   // GIR_Coverage, 11519,
     /* 182336 */   GIR_Done,
     /* 182337 */ // Label 4009: @182337
     /* 182337 */ GIM_Reject,
     /* 182338 */ // Label 3972: @182338
     /* 182338 */ GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(182397), // Rule ID 10911 //
     /* 182343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182361 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182364 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182368 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182374 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182381 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 182381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrm),
     /* 182384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182386 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182395 */   GIR_RootConstrainSelectedInstOperands,
     /* 182396 */   // GIR_Coverage, 10911,
     /* 182396 */   GIR_EraseRootFromParent_Done,
     /* 182397 */ // Label 4010: @182397
     /* 182397 */ GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(182456), // Rule ID 11403 //
     /* 182402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182420 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182423 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182427 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182433 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182440 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 182440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrm),
     /* 182443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182445 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182454 */   GIR_RootConstrainSelectedInstOperands,
     /* 182455 */   // GIR_Coverage, 11403,
     /* 182455 */   GIR_EraseRootFromParent_Done,
     /* 182456 */ // Label 4011: @182456
     /* 182456 */ GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(182482), // Rule ID 10907 //
     /* 182461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182475 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 182475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 182480 */   GIR_RootConstrainSelectedInstOperands,
     /* 182481 */   // GIR_Coverage, 10907,
     /* 182481 */   GIR_Done,
     /* 182482 */ // Label 4012: @182482
     /* 182482 */ GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(182512), // Rule ID 11399 //
     /* 182487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182501 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 182501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 182506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182510 */   GIR_RootConstrainSelectedInstOperands,
     /* 182511 */   // GIR_Coverage, 11399,
     /* 182511 */   GIR_Done,
     /* 182512 */ // Label 4013: @182512
     /* 182512 */ GIM_Reject,
     /* 182513 */ // Label 3973: @182513
     /* 182513 */ GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(182572), // Rule ID 11469 //
     /* 182518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182536 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182543 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182549 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182556 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 182556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrm),
     /* 182559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182561 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182570 */   GIR_RootConstrainSelectedInstOperands,
     /* 182571 */   // GIR_Coverage, 11469,
     /* 182571 */   GIR_EraseRootFromParent_Done,
     /* 182572 */ // Label 4014: @182572
     /* 182572 */ GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(182631), // Rule ID 14688 //
     /* 182577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 182583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182595 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182602 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182608 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182615 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 182615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rm),
     /* 182618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182620 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182629 */   GIR_RootConstrainSelectedInstOperands,
     /* 182630 */   // GIR_Coverage, 14688,
     /* 182630 */   GIR_EraseRootFromParent_Done,
     /* 182631 */ // Label 4015: @182631
     /* 182631 */ GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(182661), // Rule ID 11465 //
     /* 182636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182650 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 182650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 182655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182659 */   GIR_RootConstrainSelectedInstOperands,
     /* 182660 */   // GIR_Coverage, 11465,
     /* 182660 */   GIR_Done,
     /* 182661 */ // Label 4016: @182661
     /* 182661 */ GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(182691), // Rule ID 14684 //
     /* 182666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 182672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182680 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 182680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 182685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182689 */   GIR_RootConstrainSelectedInstOperands,
     /* 182690 */   // GIR_Coverage, 14684,
     /* 182690 */   GIR_Done,
     /* 182691 */ // Label 4017: @182691
     /* 182691 */ GIM_Reject,
     /* 182692 */ // Label 3974: @182692
     /* 182692 */ GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(182780),
     /* 182697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182704 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(182756), // Rule ID 10947 //
     /* 182709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182740 */     // (uint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 182740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrm),
     /* 182743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182754 */     GIR_RootConstrainSelectedInstOperands,
     /* 182755 */     // GIR_Coverage, 10947,
     /* 182755 */     GIR_EraseRootFromParent_Done,
     /* 182756 */   // Label 4019: @182756
     /* 182756 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(182779), // Rule ID 10943 //
     /* 182761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182768 */     // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 182768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 182773 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182777 */     GIR_RootConstrainSelectedInstOperands,
     /* 182778 */     // GIR_Coverage, 10943,
     /* 182778 */     GIR_Done,
     /* 182779 */   // Label 4020: @182779
     /* 182779 */   GIM_Reject,
     /* 182780 */ // Label 4018: @182780
     /* 182780 */ GIM_Reject,
     /* 182781 */ // Label 3975: @182781
     /* 182781 */ GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(182869),
     /* 182786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 182789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182793 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(182845), // Rule ID 14661 //
     /* 182798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182829 */     // (uint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 182829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrm),
     /* 182832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182843 */     GIR_RootConstrainSelectedInstOperands,
     /* 182844 */     // GIR_Coverage, 14661,
     /* 182844 */     GIR_EraseRootFromParent_Done,
     /* 182845 */   // Label 4022: @182845
     /* 182845 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(182868), // Rule ID 14657 //
     /* 182850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182857 */     // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 182857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 182862 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182866 */     GIR_RootConstrainSelectedInstOperands,
     /* 182867 */     // GIR_Coverage, 14657,
     /* 182867 */     GIR_Done,
     /* 182868 */   // Label 4023: @182868
     /* 182868 */   GIM_Reject,
     /* 182869 */ // Label 4021: @182869
     /* 182869 */ GIM_Reject,
     /* 182870 */ // Label 3976: @182870
     /* 182870 */ GIM_Reject,
     /* 182871 */ // Label 53: @182871
     /* 182871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 4027*/ GIMT_Encode4(182993),
     /* 182882 */ /*GILLT_s32*//*Label 4024*/ GIMT_Encode4(182894),
     /* 182886 */ /*GILLT_s64*//*Label 4025*/ GIMT_Encode4(182927),
     /* 182890 */ /*GILLT_s80*//*Label 4026*/ GIMT_Encode4(182960),
     /* 182894 */ // Label 4024: @182894
     /* 182894 */ GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(182926), // Rule ID 1045 //
     /* 182899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 182902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 182905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 182909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 182913 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 182913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 182918 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182924 */   GIR_RootConstrainSelectedInstOperands,
     /* 182925 */   // GIR_Coverage, 1045,
     /* 182925 */   GIR_Done,
     /* 182926 */ // Label 4028: @182926
     /* 182926 */ GIM_Reject,
     /* 182927 */ // Label 4025: @182927
     /* 182927 */ GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(182959), // Rule ID 1046 //
     /* 182932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 182935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 182942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 182946 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 182946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 182951 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182957 */   GIR_RootConstrainSelectedInstOperands,
     /* 182958 */   // GIR_Coverage, 1046,
     /* 182958 */   GIR_Done,
     /* 182959 */ // Label 4029: @182959
     /* 182959 */ GIM_Reject,
     /* 182960 */ // Label 4026: @182960
     /* 182960 */ GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(182992), // Rule ID 1047 //
     /* 182965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 182968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 182971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 182975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 182979 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 182979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 182984 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182990 */   GIR_RootConstrainSelectedInstOperands,
     /* 182991 */   // GIR_Coverage, 1047,
     /* 182991 */   GIR_Done,
     /* 182992 */ // Label 4030: @182992
     /* 182992 */ GIM_Reject,
     /* 182993 */ // Label 4027: @182993
     /* 182993 */ GIM_Reject,
     /* 182994 */ // Label 54: @182994
     /* 182994 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4043*/ GIMT_Encode4(186314),
     /* 183005 */ /*GILLT_v2s64*//*Label 4031*/ GIMT_Encode4(183073), GIMT_Encode4(0),
     /* 183013 */ /*GILLT_v4s32*//*Label 4032*/ GIMT_Encode4(183402),
     /* 183017 */ /*GILLT_v4s64*//*Label 4033*/ GIMT_Encode4(183744), GIMT_Encode4(0),
     /* 183025 */ /*GILLT_v8s16*//*Label 4034*/ GIMT_Encode4(184061),
     /* 183029 */ /*GILLT_v8s32*//*Label 4035*/ GIMT_Encode4(184403),
     /* 183033 */ /*GILLT_v8s64*//*Label 4036*/ GIMT_Encode4(184718), GIMT_Encode4(0),
     /* 183041 */ /*GILLT_v16s8*//*Label 4037*/ GIMT_Encode4(184874),
     /* 183045 */ /*GILLT_v16s16*//*Label 4038*/ GIMT_Encode4(185216),
     /* 183049 */ /*GILLT_v16s32*//*Label 4039*/ GIMT_Encode4(185531), GIMT_Encode4(0),
     /* 183057 */ /*GILLT_v32s8*//*Label 4040*/ GIMT_Encode4(185687),
     /* 183061 */ /*GILLT_v32s16*//*Label 4041*/ GIMT_Encode4(186002), GIMT_Encode4(0),
     /* 183069 */ /*GILLT_v64s8*//*Label 4042*/ GIMT_Encode4(186158),
     /* 183073 */ // Label 4031: @183073
     /* 183073 */ GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(183401),
     /* 183078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 183081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183084 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(183146), // Rule ID 24077 //
     /* 183089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183104 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183111 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183128 */     // (smin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 183131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183144 */     GIR_RootConstrainSelectedInstOperands,
     /* 183145 */     // GIR_Coverage, 24077,
     /* 183145 */     GIR_EraseRootFromParent_Done,
     /* 183146 */   // Label 4045: @183146
     /* 183146 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(183208), // Rule ID 5590 //
     /* 183151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183190 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 183193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183206 */     GIR_RootConstrainSelectedInstOperands,
     /* 183207 */     // GIR_Coverage, 5590,
     /* 183207 */     GIR_EraseRootFromParent_Done,
     /* 183208 */   // Label 4046: @183208
     /* 183208 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(183235), // Rule ID 5587 //
     /* 183213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183228 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 183228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 183233 */     GIR_RootConstrainSelectedInstOperands,
     /* 183234 */     // GIR_Coverage, 5587,
     /* 183234 */     GIR_Done,
     /* 183235 */   // Label 4047: @183235
     /* 183235 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(183400), // Rule ID 20014 //
     /* 183240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 183247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183255 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 183255 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183258 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183262 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183281 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183284 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183288 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 183291 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183296 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183301 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183306 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183309 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183313 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183320 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183323 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183327 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183332 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183339 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 183342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 183360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 183364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183369 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 183372 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 183375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183382 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 183389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 183394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183399 */     // GIR_Coverage, 20014,
     /* 183399 */     GIR_EraseRootFromParent_Done,
     /* 183400 */   // Label 4048: @183400
     /* 183400 */   GIM_Reject,
     /* 183401 */ // Label 4044: @183401
     /* 183401 */ GIM_Reject,
     /* 183402 */ // Label 4032: @183402
     /* 183402 */ GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(183743),
     /* 183407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 183410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183413 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(183475), // Rule ID 23501 //
     /* 183418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183457 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 183460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183473 */     GIR_RootConstrainSelectedInstOperands,
     /* 183474 */     // GIR_Coverage, 23501,
     /* 183474 */     GIR_EraseRootFromParent_Done,
     /* 183475 */   // Label 4050: @183475
     /* 183475 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(183537), // Rule ID 24059 //
     /* 183480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183519 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 183522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183535 */     GIR_RootConstrainSelectedInstOperands,
     /* 183536 */     // GIR_Coverage, 24059,
     /* 183536 */     GIR_EraseRootFromParent_Done,
     /* 183537 */   // Label 4051: @183537
     /* 183537 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(183599), // Rule ID 3186 //
     /* 183542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183581 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 183584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183597 */     GIR_RootConstrainSelectedInstOperands,
     /* 183598 */     // GIR_Coverage, 3186,
     /* 183598 */     GIR_EraseRootFromParent_Done,
     /* 183599 */   // Label 4052: @183599
     /* 183599 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(183661), // Rule ID 5563 //
     /* 183604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183643 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 183646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183659 */     GIR_RootConstrainSelectedInstOperands,
     /* 183660 */     // GIR_Coverage, 5563,
     /* 183660 */     GIR_EraseRootFromParent_Done,
     /* 183661 */   // Label 4053: @183661
     /* 183661 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(183688), // Rule ID 3185 //
     /* 183666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183681 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 183686 */     GIR_RootConstrainSelectedInstOperands,
     /* 183687 */     // GIR_Coverage, 3185,
     /* 183687 */     GIR_Done,
     /* 183688 */   // Label 4054: @183688
     /* 183688 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(183715), // Rule ID 3223 //
     /* 183693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 183696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183708 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 183713 */     GIR_RootConstrainSelectedInstOperands,
     /* 183714 */     // GIR_Coverage, 3223,
     /* 183714 */     GIR_Done,
     /* 183715 */   // Label 4055: @183715
     /* 183715 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(183742), // Rule ID 5560 //
     /* 183720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183735 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 183735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 183740 */     GIR_RootConstrainSelectedInstOperands,
     /* 183741 */     // GIR_Coverage, 5560,
     /* 183741 */     GIR_Done,
     /* 183742 */   // Label 4056: @183742
     /* 183742 */   GIM_Reject,
     /* 183743 */ // Label 4049: @183743
     /* 183743 */ GIM_Reject,
     /* 183744 */ // Label 4033: @183744
     /* 183744 */ GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(184060),
     /* 183749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 183752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 183755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183759 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(183817), // Rule ID 24071 //
     /* 183764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183799 */     // (smin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 183802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183806 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183815 */     GIR_RootConstrainSelectedInstOperands,
     /* 183816 */     // GIR_Coverage, 24071,
     /* 183816 */     GIR_EraseRootFromParent_Done,
     /* 183817 */   // Label 4058: @183817
     /* 183817 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(183875), // Rule ID 5581 //
     /* 183822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183857 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 183860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183862 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183873 */     GIR_RootConstrainSelectedInstOperands,
     /* 183874 */     // GIR_Coverage, 5581,
     /* 183874 */     GIR_EraseRootFromParent_Done,
     /* 183875 */   // Label 4059: @183875
     /* 183875 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(183898), // Rule ID 5578 //
     /* 183880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183891 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 183891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 183896 */     GIR_RootConstrainSelectedInstOperands,
     /* 183897 */     // GIR_Coverage, 5578,
     /* 183897 */     GIR_Done,
     /* 183898 */   // Label 4060: @183898
     /* 183898 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(184059), // Rule ID 20012 //
     /* 183903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183914 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 183914 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183917 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183921 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183928 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183931 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183935 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183940 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183943 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183947 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 183950 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183955 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183960 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 183965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183991 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183998 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 184001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 184019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 184023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184028 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 184031 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 184034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 184036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 184048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184058 */     // GIR_Coverage, 20012,
     /* 184058 */     GIR_EraseRootFromParent_Done,
     /* 184059 */   // Label 4061: @184059
     /* 184059 */   GIM_Reject,
     /* 184060 */ // Label 4057: @184060
     /* 184060 */ GIM_Reject,
     /* 184061 */ // Label 4034: @184061
     /* 184061 */ GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(184402),
     /* 184066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 184069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184072 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(184134), // Rule ID 23465 //
     /* 184077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184116 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 184119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184123 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184132 */     GIR_RootConstrainSelectedInstOperands,
     /* 184133 */     // GIR_Coverage, 23465,
     /* 184133 */     GIR_EraseRootFromParent_Done,
     /* 184134 */   // Label 4063: @184134
     /* 184134 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(184196), // Rule ID 24044 //
     /* 184139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184178 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 184181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184183 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184194 */     GIR_RootConstrainSelectedInstOperands,
     /* 184195 */     // GIR_Coverage, 24044,
     /* 184195 */     GIR_EraseRootFromParent_Done,
     /* 184196 */   // Label 4064: @184196
     /* 184196 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(184258), // Rule ID 2643 //
     /* 184201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184220 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184223 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184227 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184240 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 184243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184256 */     GIR_RootConstrainSelectedInstOperands,
     /* 184257 */     // GIR_Coverage, 2643,
     /* 184257 */     GIR_EraseRootFromParent_Done,
     /* 184258 */   // Label 4065: @184258
     /* 184258 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(184320), // Rule ID 5539 //
     /* 184263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184302 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 184305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184318 */     GIR_RootConstrainSelectedInstOperands,
     /* 184319 */     // GIR_Coverage, 5539,
     /* 184319 */     GIR_EraseRootFromParent_Done,
     /* 184320 */   // Label 4066: @184320
     /* 184320 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(184347), // Rule ID 2642 //
     /* 184325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184340 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 184345 */     GIR_RootConstrainSelectedInstOperands,
     /* 184346 */     // GIR_Coverage, 2642,
     /* 184346 */     GIR_Done,
     /* 184347 */   // Label 4067: @184347
     /* 184347 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(184374), // Rule ID 2644 //
     /* 184352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 184355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184367 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 184372 */     GIR_RootConstrainSelectedInstOperands,
     /* 184373 */     // GIR_Coverage, 2644,
     /* 184373 */     GIR_Done,
     /* 184374 */   // Label 4068: @184374
     /* 184374 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(184401), // Rule ID 5536 //
     /* 184379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184394 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 184394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 184399 */     GIR_RootConstrainSelectedInstOperands,
     /* 184400 */     // GIR_Coverage, 5536,
     /* 184400 */     GIR_Done,
     /* 184401 */   // Label 4069: @184401
     /* 184401 */   GIM_Reject,
     /* 184402 */ // Label 4062: @184402
     /* 184402 */ GIM_Reject,
     /* 184403 */ // Label 4035: @184403
     /* 184403 */ GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(184717),
     /* 184408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 184411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 184414 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(184476), // Rule ID 23510 //
     /* 184419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184458 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 184461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184474 */     GIR_RootConstrainSelectedInstOperands,
     /* 184475 */     // GIR_Coverage, 23510,
     /* 184475 */     GIR_EraseRootFromParent_Done,
     /* 184476 */   // Label 4071: @184476
     /* 184476 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(184538), // Rule ID 24053 //
     /* 184481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184520 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 184523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184525 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184527 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184536 */     GIR_RootConstrainSelectedInstOperands,
     /* 184537 */     // GIR_Coverage, 24053,
     /* 184537 */     GIR_EraseRootFromParent_Done,
     /* 184538 */   // Label 4072: @184538
     /* 184538 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(184600), // Rule ID 3204 //
     /* 184543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184582 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 184585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184598 */     GIR_RootConstrainSelectedInstOperands,
     /* 184599 */     // GIR_Coverage, 3204,
     /* 184599 */     GIR_EraseRootFromParent_Done,
     /* 184600 */   // Label 4073: @184600
     /* 184600 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(184662), // Rule ID 5554 //
     /* 184605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184644 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 184647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184660 */     GIR_RootConstrainSelectedInstOperands,
     /* 184661 */     // GIR_Coverage, 5554,
     /* 184661 */     GIR_EraseRootFromParent_Done,
     /* 184662 */   // Label 4074: @184662
     /* 184662 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(184689), // Rule ID 3203 //
     /* 184667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184682 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 184682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 184687 */     GIR_RootConstrainSelectedInstOperands,
     /* 184688 */     // GIR_Coverage, 3203,
     /* 184688 */     GIR_Done,
     /* 184689 */   // Label 4075: @184689
     /* 184689 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(184716), // Rule ID 5551 //
     /* 184694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184709 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 184709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 184714 */     GIR_RootConstrainSelectedInstOperands,
     /* 184715 */     // GIR_Coverage, 5551,
     /* 184715 */     GIR_Done,
     /* 184716 */   // Label 4076: @184716
     /* 184716 */   GIM_Reject,
     /* 184717 */ // Label 4070: @184717
     /* 184717 */ GIM_Reject,
     /* 184718 */ // Label 4036: @184718
     /* 184718 */ GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(184873),
     /* 184723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 184726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 184729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184733 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(184791), // Rule ID 24065 //
     /* 184738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184749 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184752 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184756 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184773 */     // (smin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 184776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184778 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184789 */     GIR_RootConstrainSelectedInstOperands,
     /* 184790 */     // GIR_Coverage, 24065,
     /* 184790 */     GIR_EraseRootFromParent_Done,
     /* 184791 */   // Label 4078: @184791
     /* 184791 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(184849), // Rule ID 5572 //
     /* 184796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184831 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 184834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184847 */     GIR_RootConstrainSelectedInstOperands,
     /* 184848 */     // GIR_Coverage, 5572,
     /* 184848 */     GIR_EraseRootFromParent_Done,
     /* 184849 */   // Label 4079: @184849
     /* 184849 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(184872), // Rule ID 5569 //
     /* 184854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184865 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 184865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 184870 */     GIR_RootConstrainSelectedInstOperands,
     /* 184871 */     // GIR_Coverage, 5569,
     /* 184871 */     GIR_Done,
     /* 184872 */   // Label 4080: @184872
     /* 184872 */   GIM_Reject,
     /* 184873 */ // Label 4077: @184873
     /* 184873 */ GIM_Reject,
     /* 184874 */ // Label 4037: @184874
     /* 184874 */ GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(185215),
     /* 184879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 184882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184885 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(184947), // Rule ID 23506 //
     /* 184890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184908 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184929 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 184932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184945 */     GIR_RootConstrainSelectedInstOperands,
     /* 184946 */     // GIR_Coverage, 23506,
     /* 184946 */     GIR_EraseRootFromParent_Done,
     /* 184947 */   // Label 4082: @184947
     /* 184947 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(185009), // Rule ID 24035 //
     /* 184952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184991 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 184994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184998 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185007 */     GIR_RootConstrainSelectedInstOperands,
     /* 185008 */     // GIR_Coverage, 24035,
     /* 185008 */     GIR_EraseRootFromParent_Done,
     /* 185009 */   // Label 4083: @185009
     /* 185009 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(185071), // Rule ID 3196 //
     /* 185014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185040 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185053 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 185056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185069 */     GIR_RootConstrainSelectedInstOperands,
     /* 185070 */     // GIR_Coverage, 3196,
     /* 185070 */     GIR_EraseRootFromParent_Done,
     /* 185071 */   // Label 4084: @185071
     /* 185071 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(185133), // Rule ID 5521 //
     /* 185076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185115 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 185118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185131 */     GIR_RootConstrainSelectedInstOperands,
     /* 185132 */     // GIR_Coverage, 5521,
     /* 185132 */     GIR_EraseRootFromParent_Done,
     /* 185133 */   // Label 4085: @185133
     /* 185133 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(185160), // Rule ID 3195 //
     /* 185138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185153 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 185158 */     GIR_RootConstrainSelectedInstOperands,
     /* 185159 */     // GIR_Coverage, 3195,
     /* 185159 */     GIR_Done,
     /* 185160 */   // Label 4086: @185160
     /* 185160 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(185187), // Rule ID 3221 //
     /* 185165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 185168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185180 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 185185 */     GIR_RootConstrainSelectedInstOperands,
     /* 185186 */     // GIR_Coverage, 3221,
     /* 185186 */     GIR_Done,
     /* 185187 */   // Label 4087: @185187
     /* 185187 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(185214), // Rule ID 5518 //
     /* 185192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185207 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 185207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 185212 */     GIR_RootConstrainSelectedInstOperands,
     /* 185213 */     // GIR_Coverage, 5518,
     /* 185213 */     GIR_Done,
     /* 185214 */   // Label 4088: @185214
     /* 185214 */   GIM_Reject,
     /* 185215 */ // Label 4081: @185215
     /* 185215 */ GIM_Reject,
     /* 185216 */ // Label 4038: @185216
     /* 185216 */ GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(185530),
     /* 185221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 185224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 185227 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(185289), // Rule ID 23467 //
     /* 185232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185271 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 185274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185287 */     GIR_RootConstrainSelectedInstOperands,
     /* 185288 */     // GIR_Coverage, 23467,
     /* 185288 */     GIR_EraseRootFromParent_Done,
     /* 185289 */   // Label 4090: @185289
     /* 185289 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(185351), // Rule ID 24041 //
     /* 185294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185333 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 185336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185338 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185349 */     GIR_RootConstrainSelectedInstOperands,
     /* 185350 */     // GIR_Coverage, 24041,
     /* 185350 */     GIR_EraseRootFromParent_Done,
     /* 185351 */   // Label 4091: @185351
     /* 185351 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(185413), // Rule ID 2647 //
     /* 185356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185395 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 185398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185411 */     GIR_RootConstrainSelectedInstOperands,
     /* 185412 */     // GIR_Coverage, 2647,
     /* 185412 */     GIR_EraseRootFromParent_Done,
     /* 185413 */   // Label 4092: @185413
     /* 185413 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(185475), // Rule ID 5533 //
     /* 185418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185457 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 185460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185473 */     GIR_RootConstrainSelectedInstOperands,
     /* 185474 */     // GIR_Coverage, 5533,
     /* 185474 */     GIR_EraseRootFromParent_Done,
     /* 185475 */   // Label 4093: @185475
     /* 185475 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(185502), // Rule ID 2646 //
     /* 185480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185495 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 185495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 185500 */     GIR_RootConstrainSelectedInstOperands,
     /* 185501 */     // GIR_Coverage, 2646,
     /* 185501 */     GIR_Done,
     /* 185502 */   // Label 4094: @185502
     /* 185502 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(185529), // Rule ID 5530 //
     /* 185507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185522 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 185522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 185527 */     GIR_RootConstrainSelectedInstOperands,
     /* 185528 */     // GIR_Coverage, 5530,
     /* 185528 */     GIR_Done,
     /* 185529 */   // Label 4095: @185529
     /* 185529 */   GIM_Reject,
     /* 185530 */ // Label 4089: @185530
     /* 185530 */ GIM_Reject,
     /* 185531 */ // Label 4039: @185531
     /* 185531 */ GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(185686),
     /* 185536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 185539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 185542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185546 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(185604), // Rule ID 24047 //
     /* 185551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185586 */     // (smin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 185589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185591 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185602 */     GIR_RootConstrainSelectedInstOperands,
     /* 185603 */     // GIR_Coverage, 24047,
     /* 185603 */     GIR_EraseRootFromParent_Done,
     /* 185604 */   // Label 4097: @185604
     /* 185604 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(185662), // Rule ID 5545 //
     /* 185609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185644 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 185647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185660 */     GIR_RootConstrainSelectedInstOperands,
     /* 185661 */     // GIR_Coverage, 5545,
     /* 185661 */     GIR_EraseRootFromParent_Done,
     /* 185662 */   // Label 4098: @185662
     /* 185662 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(185685), // Rule ID 5542 //
     /* 185667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185678 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 185678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 185683 */     GIR_RootConstrainSelectedInstOperands,
     /* 185684 */     // GIR_Coverage, 5542,
     /* 185684 */     GIR_Done,
     /* 185685 */   // Label 4099: @185685
     /* 185685 */   GIM_Reject,
     /* 185686 */ // Label 4096: @185686
     /* 185686 */ GIM_Reject,
     /* 185687 */ // Label 4040: @185687
     /* 185687 */ GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(186001),
     /* 185692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 185695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 185698 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(185760), // Rule ID 23515 //
     /* 185703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185742 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 185745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185758 */     GIR_RootConstrainSelectedInstOperands,
     /* 185759 */     // GIR_Coverage, 23515,
     /* 185759 */     GIR_EraseRootFromParent_Done,
     /* 185760 */   // Label 4101: @185760
     /* 185760 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(185822), // Rule ID 24032 //
     /* 185765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185804 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 185807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185820 */     GIR_RootConstrainSelectedInstOperands,
     /* 185821 */     // GIR_Coverage, 24032,
     /* 185821 */     GIR_EraseRootFromParent_Done,
     /* 185822 */   // Label 4102: @185822
     /* 185822 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(185884), // Rule ID 3214 //
     /* 185827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185866 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 185869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185882 */     GIR_RootConstrainSelectedInstOperands,
     /* 185883 */     // GIR_Coverage, 3214,
     /* 185883 */     GIR_EraseRootFromParent_Done,
     /* 185884 */   // Label 4103: @185884
     /* 185884 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(185946), // Rule ID 5515 //
     /* 185889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185928 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 185931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185944 */     GIR_RootConstrainSelectedInstOperands,
     /* 185945 */     // GIR_Coverage, 5515,
     /* 185945 */     GIR_EraseRootFromParent_Done,
     /* 185946 */   // Label 4104: @185946
     /* 185946 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(185973), // Rule ID 3213 //
     /* 185951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185966 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 185966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 185971 */     GIR_RootConstrainSelectedInstOperands,
     /* 185972 */     // GIR_Coverage, 3213,
     /* 185972 */     GIR_Done,
     /* 185973 */   // Label 4105: @185973
     /* 185973 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(186000), // Rule ID 5512 //
     /* 185978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185993 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 185993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 185998 */     GIR_RootConstrainSelectedInstOperands,
     /* 185999 */     // GIR_Coverage, 5512,
     /* 185999 */     GIR_Done,
     /* 186000 */   // Label 4106: @186000
     /* 186000 */   GIM_Reject,
     /* 186001 */ // Label 4100: @186001
     /* 186001 */ GIM_Reject,
     /* 186002 */ // Label 4041: @186002
     /* 186002 */ GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(186157),
     /* 186007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 186010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 186013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186017 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(186075), // Rule ID 24038 //
     /* 186022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186040 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186057 */     // (smin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 186060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186062 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186073 */     GIR_RootConstrainSelectedInstOperands,
     /* 186074 */     // GIR_Coverage, 24038,
     /* 186074 */     GIR_EraseRootFromParent_Done,
     /* 186075 */   // Label 4108: @186075
     /* 186075 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(186133), // Rule ID 5527 //
     /* 186080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186115 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 186118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186131 */     GIR_RootConstrainSelectedInstOperands,
     /* 186132 */     // GIR_Coverage, 5527,
     /* 186132 */     GIR_EraseRootFromParent_Done,
     /* 186133 */   // Label 4109: @186133
     /* 186133 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(186156), // Rule ID 5524 //
     /* 186138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186149 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 186149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 186154 */     GIR_RootConstrainSelectedInstOperands,
     /* 186155 */     // GIR_Coverage, 5524,
     /* 186155 */     GIR_Done,
     /* 186156 */   // Label 4110: @186156
     /* 186156 */   GIM_Reject,
     /* 186157 */ // Label 4107: @186157
     /* 186157 */ GIM_Reject,
     /* 186158 */ // Label 4042: @186158
     /* 186158 */ GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(186313),
     /* 186163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 186166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 186169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186173 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(186231), // Rule ID 24029 //
     /* 186178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186213 */     // (smin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 186216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186229 */     GIR_RootConstrainSelectedInstOperands,
     /* 186230 */     // GIR_Coverage, 24029,
     /* 186230 */     GIR_EraseRootFromParent_Done,
     /* 186231 */   // Label 4112: @186231
     /* 186231 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(186289), // Rule ID 5509 //
     /* 186236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186271 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 186274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186287 */     GIR_RootConstrainSelectedInstOperands,
     /* 186288 */     // GIR_Coverage, 5509,
     /* 186288 */     GIR_EraseRootFromParent_Done,
     /* 186289 */   // Label 4113: @186289
     /* 186289 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(186312), // Rule ID 5506 //
     /* 186294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186305 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 186305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 186310 */     GIR_RootConstrainSelectedInstOperands,
     /* 186311 */     // GIR_Coverage, 5506,
     /* 186311 */     GIR_Done,
     /* 186312 */   // Label 4114: @186312
     /* 186312 */   GIM_Reject,
     /* 186313 */ // Label 4111: @186313
     /* 186313 */ GIM_Reject,
     /* 186314 */ // Label 4043: @186314
     /* 186314 */ GIM_Reject,
     /* 186315 */ // Label 55: @186315
     /* 186315 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4127*/ GIMT_Encode4(189635),
     /* 186326 */ /*GILLT_v2s64*//*Label 4115*/ GIMT_Encode4(186394), GIMT_Encode4(0),
     /* 186334 */ /*GILLT_v4s32*//*Label 4116*/ GIMT_Encode4(186723),
     /* 186338 */ /*GILLT_v4s64*//*Label 4117*/ GIMT_Encode4(187065), GIMT_Encode4(0),
     /* 186346 */ /*GILLT_v8s16*//*Label 4118*/ GIMT_Encode4(187382),
     /* 186350 */ /*GILLT_v8s32*//*Label 4119*/ GIMT_Encode4(187724),
     /* 186354 */ /*GILLT_v8s64*//*Label 4120*/ GIMT_Encode4(188039), GIMT_Encode4(0),
     /* 186362 */ /*GILLT_v16s8*//*Label 4121*/ GIMT_Encode4(188195),
     /* 186366 */ /*GILLT_v16s16*//*Label 4122*/ GIMT_Encode4(188537),
     /* 186370 */ /*GILLT_v16s32*//*Label 4123*/ GIMT_Encode4(188852), GIMT_Encode4(0),
     /* 186378 */ /*GILLT_v32s8*//*Label 4124*/ GIMT_Encode4(189008),
     /* 186382 */ /*GILLT_v32s16*//*Label 4125*/ GIMT_Encode4(189323), GIMT_Encode4(0),
     /* 186390 */ /*GILLT_v64s8*//*Label 4126*/ GIMT_Encode4(189479),
     /* 186394 */ // Label 4115: @186394
     /* 186394 */ GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(186722),
     /* 186399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 186402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186405 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(186467), // Rule ID 23969 //
     /* 186410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186449 */     // (smax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 186452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186465 */     GIR_RootConstrainSelectedInstOperands,
     /* 186466 */     // GIR_Coverage, 23969,
     /* 186466 */     GIR_EraseRootFromParent_Done,
     /* 186467 */   // Label 4129: @186467
     /* 186467 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(186529), // Rule ID 5410 //
     /* 186472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186511 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 186514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186516 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186527 */     GIR_RootConstrainSelectedInstOperands,
     /* 186528 */     // GIR_Coverage, 5410,
     /* 186528 */     GIR_EraseRootFromParent_Done,
     /* 186529 */   // Label 4130: @186529
     /* 186529 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(186556), // Rule ID 5407 //
     /* 186534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186549 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 186549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 186554 */     GIR_RootConstrainSelectedInstOperands,
     /* 186555 */     // GIR_Coverage, 5407,
     /* 186555 */     GIR_Done,
     /* 186556 */   // Label 4131: @186556
     /* 186556 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(186721), // Rule ID 20010 //
     /* 186561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 186564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 186568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186576 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 186576 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 186579 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186583 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186602 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186605 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186609 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 186612 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186617 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186622 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 186663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 186685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 186710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 186715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186720 */     // GIR_Coverage, 20010,
     /* 186720 */     GIR_EraseRootFromParent_Done,
     /* 186721 */   // Label 4132: @186721
     /* 186721 */   GIM_Reject,
     /* 186722 */ // Label 4128: @186722
     /* 186722 */ GIM_Reject,
     /* 186723 */ // Label 4116: @186723
     /* 186723 */ GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(187064),
     /* 186728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 186731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186734 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(186796), // Rule ID 23503 //
     /* 186739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186761 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186778 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 186781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186783 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186794 */     GIR_RootConstrainSelectedInstOperands,
     /* 186795 */     // GIR_Coverage, 23503,
     /* 186795 */     GIR_EraseRootFromParent_Done,
     /* 186796 */   // Label 4134: @186796
     /* 186796 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(186858), // Rule ID 23951 //
     /* 186801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186840 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 186843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186856 */     GIR_RootConstrainSelectedInstOperands,
     /* 186857 */     // GIR_Coverage, 23951,
     /* 186857 */     GIR_EraseRootFromParent_Done,
     /* 186858 */   // Label 4135: @186858
     /* 186858 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(186920), // Rule ID 3190 //
     /* 186863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186902 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 186905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186918 */     GIR_RootConstrainSelectedInstOperands,
     /* 186919 */     // GIR_Coverage, 3190,
     /* 186919 */     GIR_EraseRootFromParent_Done,
     /* 186920 */   // Label 4136: @186920
     /* 186920 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(186982), // Rule ID 5383 //
     /* 186925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186964 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 186967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186980 */     GIR_RootConstrainSelectedInstOperands,
     /* 186981 */     // GIR_Coverage, 5383,
     /* 186981 */     GIR_EraseRootFromParent_Done,
     /* 186982 */   // Label 4137: @186982
     /* 186982 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(187009), // Rule ID 3189 //
     /* 186987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187002 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 187007 */     GIR_RootConstrainSelectedInstOperands,
     /* 187008 */     // GIR_Coverage, 3189,
     /* 187008 */     GIR_Done,
     /* 187009 */   // Label 4138: @187009
     /* 187009 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(187036), // Rule ID 3231 //
     /* 187014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187029 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 187034 */     GIR_RootConstrainSelectedInstOperands,
     /* 187035 */     // GIR_Coverage, 3231,
     /* 187035 */     GIR_Done,
     /* 187036 */   // Label 4139: @187036
     /* 187036 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(187063), // Rule ID 5380 //
     /* 187041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187056 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 187056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 187061 */     GIR_RootConstrainSelectedInstOperands,
     /* 187062 */     // GIR_Coverage, 5380,
     /* 187062 */     GIR_Done,
     /* 187063 */   // Label 4140: @187063
     /* 187063 */   GIM_Reject,
     /* 187064 */ // Label 4133: @187064
     /* 187064 */ GIM_Reject,
     /* 187065 */ // Label 4117: @187065
     /* 187065 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(187381),
     /* 187070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 187073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 187076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187080 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(187138), // Rule ID 23963 //
     /* 187085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187096 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187120 */     // (smax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 187123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187136 */     GIR_RootConstrainSelectedInstOperands,
     /* 187137 */     // GIR_Coverage, 23963,
     /* 187137 */     GIR_EraseRootFromParent_Done,
     /* 187138 */   // Label 4142: @187138
     /* 187138 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(187196), // Rule ID 5401 //
     /* 187143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187178 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 187181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187194 */     GIR_RootConstrainSelectedInstOperands,
     /* 187195 */     // GIR_Coverage, 5401,
     /* 187195 */     GIR_EraseRootFromParent_Done,
     /* 187196 */   // Label 4143: @187196
     /* 187196 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(187219), // Rule ID 5398 //
     /* 187201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187212 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 187212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 187217 */     GIR_RootConstrainSelectedInstOperands,
     /* 187218 */     // GIR_Coverage, 5398,
     /* 187218 */     GIR_Done,
     /* 187219 */   // Label 4144: @187219
     /* 187219 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(187380), // Rule ID 20008 //
     /* 187224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 187227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187235 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 187235 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 187238 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187242 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 187249 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 187252 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187256 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187261 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 187264 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 187268 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 187271 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187276 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187281 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187286 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 187289 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187293 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 187300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 187303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187312 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 187315 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 187319 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 187322 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187327 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 187340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 187344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 187352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 187355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 187357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187362 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 187369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187379 */     // GIR_Coverage, 20008,
     /* 187379 */     GIR_EraseRootFromParent_Done,
     /* 187380 */   // Label 4145: @187380
     /* 187380 */   GIM_Reject,
     /* 187381 */ // Label 4141: @187381
     /* 187381 */ GIM_Reject,
     /* 187382 */ // Label 4118: @187382
     /* 187382 */ GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(187723),
     /* 187387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 187390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187393 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(187455), // Rule ID 23471 //
     /* 187398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187437 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 187440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187442 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187444 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187453 */     GIR_RootConstrainSelectedInstOperands,
     /* 187454 */     // GIR_Coverage, 23471,
     /* 187454 */     GIR_EraseRootFromParent_Done,
     /* 187455 */   // Label 4147: @187455
     /* 187455 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(187517), // Rule ID 23936 //
     /* 187460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187475 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187478 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187482 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187499 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 187502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187504 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187506 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187515 */     GIR_RootConstrainSelectedInstOperands,
     /* 187516 */     // GIR_Coverage, 23936,
     /* 187516 */     GIR_EraseRootFromParent_Done,
     /* 187517 */   // Label 4148: @187517
     /* 187517 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(187579), // Rule ID 2655 //
     /* 187522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187541 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187548 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187561 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 187564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187568 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187577 */     GIR_RootConstrainSelectedInstOperands,
     /* 187578 */     // GIR_Coverage, 2655,
     /* 187578 */     GIR_EraseRootFromParent_Done,
     /* 187579 */   // Label 4149: @187579
     /* 187579 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(187641), // Rule ID 5359 //
     /* 187584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187603 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187623 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 187626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187639 */     GIR_RootConstrainSelectedInstOperands,
     /* 187640 */     // GIR_Coverage, 5359,
     /* 187640 */     GIR_EraseRootFromParent_Done,
     /* 187641 */   // Label 4150: @187641
     /* 187641 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(187668), // Rule ID 2654 //
     /* 187646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187661 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 187666 */     GIR_RootConstrainSelectedInstOperands,
     /* 187667 */     // GIR_Coverage, 2654,
     /* 187667 */     GIR_Done,
     /* 187668 */   // Label 4151: @187668
     /* 187668 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(187695), // Rule ID 2656 //
     /* 187673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 187676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187688 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 187693 */     GIR_RootConstrainSelectedInstOperands,
     /* 187694 */     // GIR_Coverage, 2656,
     /* 187694 */     GIR_Done,
     /* 187695 */   // Label 4152: @187695
     /* 187695 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(187722), // Rule ID 5356 //
     /* 187700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187715 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 187715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 187720 */     GIR_RootConstrainSelectedInstOperands,
     /* 187721 */     // GIR_Coverage, 5356,
     /* 187721 */     GIR_Done,
     /* 187722 */   // Label 4153: @187722
     /* 187722 */   GIM_Reject,
     /* 187723 */ // Label 4146: @187723
     /* 187723 */ GIM_Reject,
     /* 187724 */ // Label 4119: @187724
     /* 187724 */ GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(188038),
     /* 187729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 187732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 187735 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(187797), // Rule ID 23512 //
     /* 187740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187755 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187762 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187779 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 187782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187795 */     GIR_RootConstrainSelectedInstOperands,
     /* 187796 */     // GIR_Coverage, 23512,
     /* 187796 */     GIR_EraseRootFromParent_Done,
     /* 187797 */   // Label 4155: @187797
     /* 187797 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(187859), // Rule ID 23945 //
     /* 187802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187817 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187841 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 187844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187857 */     GIR_RootConstrainSelectedInstOperands,
     /* 187858 */     // GIR_Coverage, 23945,
     /* 187858 */     GIR_EraseRootFromParent_Done,
     /* 187859 */   // Label 4156: @187859
     /* 187859 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(187921), // Rule ID 3208 //
     /* 187864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187903 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 187906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187919 */     GIR_RootConstrainSelectedInstOperands,
     /* 187920 */     // GIR_Coverage, 3208,
     /* 187920 */     GIR_EraseRootFromParent_Done,
     /* 187921 */   // Label 4157: @187921
     /* 187921 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(187983), // Rule ID 5374 //
     /* 187926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187945 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187965 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 187968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187981 */     GIR_RootConstrainSelectedInstOperands,
     /* 187982 */     // GIR_Coverage, 5374,
     /* 187982 */     GIR_EraseRootFromParent_Done,
     /* 187983 */   // Label 4158: @187983
     /* 187983 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(188010), // Rule ID 3207 //
     /* 187988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188003 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 188003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 188008 */     GIR_RootConstrainSelectedInstOperands,
     /* 188009 */     // GIR_Coverage, 3207,
     /* 188009 */     GIR_Done,
     /* 188010 */   // Label 4159: @188010
     /* 188010 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(188037), // Rule ID 5371 //
     /* 188015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 188018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188030 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 188030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 188035 */     GIR_RootConstrainSelectedInstOperands,
     /* 188036 */     // GIR_Coverage, 5371,
     /* 188036 */     GIR_Done,
     /* 188037 */   // Label 4160: @188037
     /* 188037 */   GIM_Reject,
     /* 188038 */ // Label 4154: @188038
     /* 188038 */ GIM_Reject,
     /* 188039 */ // Label 4120: @188039
     /* 188039 */ GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(188194),
     /* 188044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 188047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 188050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188054 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(188112), // Rule ID 23957 //
     /* 188059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188094 */     // (smax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 188097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188110 */     GIR_RootConstrainSelectedInstOperands,
     /* 188111 */     // GIR_Coverage, 23957,
     /* 188111 */     GIR_EraseRootFromParent_Done,
     /* 188112 */   // Label 4162: @188112
     /* 188112 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(188170), // Rule ID 5392 //
     /* 188117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188152 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 188155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188168 */     GIR_RootConstrainSelectedInstOperands,
     /* 188169 */     // GIR_Coverage, 5392,
     /* 188169 */     GIR_EraseRootFromParent_Done,
     /* 188170 */   // Label 4163: @188170
     /* 188170 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(188193), // Rule ID 5389 //
     /* 188175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188186 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 188186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 188192 */     // GIR_Coverage, 5389,
     /* 188192 */     GIR_Done,
     /* 188193 */   // Label 4164: @188193
     /* 188193 */   GIM_Reject,
     /* 188194 */ // Label 4161: @188194
     /* 188194 */ GIM_Reject,
     /* 188195 */ // Label 4121: @188195
     /* 188195 */ GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(188536),
     /* 188200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 188203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188206 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(188268), // Rule ID 23508 //
     /* 188211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188250 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 188253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188266 */     GIR_RootConstrainSelectedInstOperands,
     /* 188267 */     // GIR_Coverage, 23508,
     /* 188267 */     GIR_EraseRootFromParent_Done,
     /* 188268 */   // Label 4166: @188268
     /* 188268 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(188330), // Rule ID 23927 //
     /* 188273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188312 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 188315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188317 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188328 */     GIR_RootConstrainSelectedInstOperands,
     /* 188329 */     // GIR_Coverage, 23927,
     /* 188329 */     GIR_EraseRootFromParent_Done,
     /* 188330 */   // Label 4167: @188330
     /* 188330 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(188392), // Rule ID 3200 //
     /* 188335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188374 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 188377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188390 */     GIR_RootConstrainSelectedInstOperands,
     /* 188391 */     // GIR_Coverage, 3200,
     /* 188391 */     GIR_EraseRootFromParent_Done,
     /* 188392 */   // Label 4168: @188392
     /* 188392 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(188454), // Rule ID 5341 //
     /* 188397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188436 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 188439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188452 */     GIR_RootConstrainSelectedInstOperands,
     /* 188453 */     // GIR_Coverage, 5341,
     /* 188453 */     GIR_EraseRootFromParent_Done,
     /* 188454 */   // Label 4169: @188454
     /* 188454 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(188481), // Rule ID 3199 //
     /* 188459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188474 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 188479 */     GIR_RootConstrainSelectedInstOperands,
     /* 188480 */     // GIR_Coverage, 3199,
     /* 188480 */     GIR_Done,
     /* 188481 */   // Label 4170: @188481
     /* 188481 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(188508), // Rule ID 3229 //
     /* 188486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 188489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188501 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 188506 */     GIR_RootConstrainSelectedInstOperands,
     /* 188507 */     // GIR_Coverage, 3229,
     /* 188507 */     GIR_Done,
     /* 188508 */   // Label 4171: @188508
     /* 188508 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(188535), // Rule ID 5338 //
     /* 188513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188528 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 188528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 188533 */     GIR_RootConstrainSelectedInstOperands,
     /* 188534 */     // GIR_Coverage, 5338,
     /* 188534 */     GIR_Done,
     /* 188535 */   // Label 4172: @188535
     /* 188535 */   GIM_Reject,
     /* 188536 */ // Label 4165: @188536
     /* 188536 */ GIM_Reject,
     /* 188537 */ // Label 4122: @188537
     /* 188537 */ GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(188851),
     /* 188542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 188545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 188548 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(188610), // Rule ID 23473 //
     /* 188553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188592 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 188595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188608 */     GIR_RootConstrainSelectedInstOperands,
     /* 188609 */     // GIR_Coverage, 23473,
     /* 188609 */     GIR_EraseRootFromParent_Done,
     /* 188610 */   // Label 4174: @188610
     /* 188610 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(188672), // Rule ID 23933 //
     /* 188615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188654 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 188657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188659 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188670 */     GIR_RootConstrainSelectedInstOperands,
     /* 188671 */     // GIR_Coverage, 23933,
     /* 188671 */     GIR_EraseRootFromParent_Done,
     /* 188672 */   // Label 4175: @188672
     /* 188672 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(188734), // Rule ID 2659 //
     /* 188677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188716 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 188719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188732 */     GIR_RootConstrainSelectedInstOperands,
     /* 188733 */     // GIR_Coverage, 2659,
     /* 188733 */     GIR_EraseRootFromParent_Done,
     /* 188734 */   // Label 4176: @188734
     /* 188734 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(188796), // Rule ID 5353 //
     /* 188739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188778 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 188781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188794 */     GIR_RootConstrainSelectedInstOperands,
     /* 188795 */     // GIR_Coverage, 5353,
     /* 188795 */     GIR_EraseRootFromParent_Done,
     /* 188796 */   // Label 4177: @188796
     /* 188796 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(188823), // Rule ID 2658 //
     /* 188801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188816 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 188816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 188821 */     GIR_RootConstrainSelectedInstOperands,
     /* 188822 */     // GIR_Coverage, 2658,
     /* 188822 */     GIR_Done,
     /* 188823 */   // Label 4178: @188823
     /* 188823 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(188850), // Rule ID 5350 //
     /* 188828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188843 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 188843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 188848 */     GIR_RootConstrainSelectedInstOperands,
     /* 188849 */     // GIR_Coverage, 5350,
     /* 188849 */     GIR_Done,
     /* 188850 */   // Label 4179: @188850
     /* 188850 */   GIM_Reject,
     /* 188851 */ // Label 4173: @188851
     /* 188851 */ GIM_Reject,
     /* 188852 */ // Label 4123: @188852
     /* 188852 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(189007),
     /* 188857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 188860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 188863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188867 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(188925), // Rule ID 23939 //
     /* 188872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188907 */     // (smax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 188910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188912 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188923 */     GIR_RootConstrainSelectedInstOperands,
     /* 188924 */     // GIR_Coverage, 23939,
     /* 188924 */     GIR_EraseRootFromParent_Done,
     /* 188925 */   // Label 4181: @188925
     /* 188925 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(188983), // Rule ID 5365 //
     /* 188930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188945 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188965 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 188968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188981 */     GIR_RootConstrainSelectedInstOperands,
     /* 188982 */     // GIR_Coverage, 5365,
     /* 188982 */     GIR_EraseRootFromParent_Done,
     /* 188983 */   // Label 4182: @188983
     /* 188983 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(189006), // Rule ID 5362 //
     /* 188988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188999 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 188999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 189004 */     GIR_RootConstrainSelectedInstOperands,
     /* 189005 */     // GIR_Coverage, 5362,
     /* 189005 */     GIR_Done,
     /* 189006 */   // Label 4183: @189006
     /* 189006 */   GIM_Reject,
     /* 189007 */ // Label 4180: @189007
     /* 189007 */ GIM_Reject,
     /* 189008 */ // Label 4124: @189008
     /* 189008 */ GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(189322),
     /* 189013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 189016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 189019 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(189081), // Rule ID 23517 //
     /* 189024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189063 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 189066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189079 */     GIR_RootConstrainSelectedInstOperands,
     /* 189080 */     // GIR_Coverage, 23517,
     /* 189080 */     GIR_EraseRootFromParent_Done,
     /* 189081 */   // Label 4185: @189081
     /* 189081 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(189143), // Rule ID 23924 //
     /* 189086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189125 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 189128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189141 */     GIR_RootConstrainSelectedInstOperands,
     /* 189142 */     // GIR_Coverage, 23924,
     /* 189142 */     GIR_EraseRootFromParent_Done,
     /* 189143 */   // Label 4186: @189143
     /* 189143 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(189205), // Rule ID 3218 //
     /* 189148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189187 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 189190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189203 */     GIR_RootConstrainSelectedInstOperands,
     /* 189204 */     // GIR_Coverage, 3218,
     /* 189204 */     GIR_EraseRootFromParent_Done,
     /* 189205 */   // Label 4187: @189205
     /* 189205 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(189267), // Rule ID 5335 //
     /* 189210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189249 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 189252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189265 */     GIR_RootConstrainSelectedInstOperands,
     /* 189266 */     // GIR_Coverage, 5335,
     /* 189266 */     GIR_EraseRootFromParent_Done,
     /* 189267 */   // Label 4188: @189267
     /* 189267 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(189294), // Rule ID 3217 //
     /* 189272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189287 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 189287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 189292 */     GIR_RootConstrainSelectedInstOperands,
     /* 189293 */     // GIR_Coverage, 3217,
     /* 189293 */     GIR_Done,
     /* 189294 */   // Label 4189: @189294
     /* 189294 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(189321), // Rule ID 5332 //
     /* 189299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189314 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 189314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 189319 */     GIR_RootConstrainSelectedInstOperands,
     /* 189320 */     // GIR_Coverage, 5332,
     /* 189320 */     GIR_Done,
     /* 189321 */   // Label 4190: @189321
     /* 189321 */   GIM_Reject,
     /* 189322 */ // Label 4184: @189322
     /* 189322 */ GIM_Reject,
     /* 189323 */ // Label 4125: @189323
     /* 189323 */ GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(189478),
     /* 189328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 189331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 189334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189338 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(189396), // Rule ID 23930 //
     /* 189343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189378 */     // (smax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 189381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189394 */     GIR_RootConstrainSelectedInstOperands,
     /* 189395 */     // GIR_Coverage, 23930,
     /* 189395 */     GIR_EraseRootFromParent_Done,
     /* 189396 */   // Label 4192: @189396
     /* 189396 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(189454), // Rule ID 5347 //
     /* 189401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189436 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 189439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189452 */     GIR_RootConstrainSelectedInstOperands,
     /* 189453 */     // GIR_Coverage, 5347,
     /* 189453 */     GIR_EraseRootFromParent_Done,
     /* 189454 */   // Label 4193: @189454
     /* 189454 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(189477), // Rule ID 5344 //
     /* 189459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189470 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 189470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 189475 */     GIR_RootConstrainSelectedInstOperands,
     /* 189476 */     // GIR_Coverage, 5344,
     /* 189476 */     GIR_Done,
     /* 189477 */   // Label 4194: @189477
     /* 189477 */   GIM_Reject,
     /* 189478 */ // Label 4191: @189478
     /* 189478 */ GIM_Reject,
     /* 189479 */ // Label 4126: @189479
     /* 189479 */ GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(189634),
     /* 189484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 189487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 189490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189494 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(189552), // Rule ID 23921 //
     /* 189499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189534 */     // (smax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 189537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189539 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189550 */     GIR_RootConstrainSelectedInstOperands,
     /* 189551 */     // GIR_Coverage, 23921,
     /* 189551 */     GIR_EraseRootFromParent_Done,
     /* 189552 */   // Label 4196: @189552
     /* 189552 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(189610), // Rule ID 5329 //
     /* 189557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189592 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 189595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189608 */     GIR_RootConstrainSelectedInstOperands,
     /* 189609 */     // GIR_Coverage, 5329,
     /* 189609 */     GIR_EraseRootFromParent_Done,
     /* 189610 */   // Label 4197: @189610
     /* 189610 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(189633), // Rule ID 5326 //
     /* 189615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189626 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 189626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 189631 */     GIR_RootConstrainSelectedInstOperands,
     /* 189632 */     // GIR_Coverage, 5326,
     /* 189632 */     GIR_Done,
     /* 189633 */   // Label 4198: @189633
     /* 189633 */   GIM_Reject,
     /* 189634 */ // Label 4195: @189634
     /* 189634 */ GIM_Reject,
     /* 189635 */ // Label 4127: @189635
     /* 189635 */ GIM_Reject,
     /* 189636 */ // Label 56: @189636
     /* 189636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4211*/ GIMT_Encode4(192956),
     /* 189647 */ /*GILLT_v2s64*//*Label 4199*/ GIMT_Encode4(189715), GIMT_Encode4(0),
     /* 189655 */ /*GILLT_v4s32*//*Label 4200*/ GIMT_Encode4(190044),
     /* 189659 */ /*GILLT_v4s64*//*Label 4201*/ GIMT_Encode4(190386), GIMT_Encode4(0),
     /* 189667 */ /*GILLT_v8s16*//*Label 4202*/ GIMT_Encode4(190703),
     /* 189671 */ /*GILLT_v8s32*//*Label 4203*/ GIMT_Encode4(191045),
     /* 189675 */ /*GILLT_v8s64*//*Label 4204*/ GIMT_Encode4(191360), GIMT_Encode4(0),
     /* 189683 */ /*GILLT_v16s8*//*Label 4205*/ GIMT_Encode4(191516),
     /* 189687 */ /*GILLT_v16s16*//*Label 4206*/ GIMT_Encode4(191858),
     /* 189691 */ /*GILLT_v16s32*//*Label 4207*/ GIMT_Encode4(192173), GIMT_Encode4(0),
     /* 189699 */ /*GILLT_v32s8*//*Label 4208*/ GIMT_Encode4(192329),
     /* 189703 */ /*GILLT_v32s16*//*Label 4209*/ GIMT_Encode4(192644), GIMT_Encode4(0),
     /* 189711 */ /*GILLT_v64s8*//*Label 4210*/ GIMT_Encode4(192800),
     /* 189715 */ // Label 4199: @189715
     /* 189715 */ GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(190043),
     /* 189720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 189723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189726 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(189788), // Rule ID 24131 //
     /* 189731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189770 */     // (umin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 189773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189786 */     GIR_RootConstrainSelectedInstOperands,
     /* 189787 */     // GIR_Coverage, 24131,
     /* 189787 */     GIR_EraseRootFromParent_Done,
     /* 189788 */   // Label 4213: @189788
     /* 189788 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(189850), // Rule ID 5680 //
     /* 189793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189832 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 189835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189848 */     GIR_RootConstrainSelectedInstOperands,
     /* 189849 */     // GIR_Coverage, 5680,
     /* 189849 */     GIR_EraseRootFromParent_Done,
     /* 189850 */   // Label 4214: @189850
     /* 189850 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(189877), // Rule ID 5677 //
     /* 189855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189870 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 189870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 189875 */     GIR_RootConstrainSelectedInstOperands,
     /* 189876 */     // GIR_Coverage, 5677,
     /* 189876 */     GIR_Done,
     /* 189877 */   // Label 4215: @189877
     /* 189877 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(190042), // Rule ID 20006 //
     /* 189882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 189889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189897 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 189897 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189900 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189904 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189911 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189914 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189918 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189923 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189926 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 189930 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 189933 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189938 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189943 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 189948 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 189951 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189955 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 189962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 189965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189974 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 189977 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 189981 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 189984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189989 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189994 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 189999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 190006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190011 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190024 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 190031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 190036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190041 */     // GIR_Coverage, 20006,
     /* 190041 */     GIR_EraseRootFromParent_Done,
     /* 190042 */   // Label 4216: @190042
     /* 190042 */   GIM_Reject,
     /* 190043 */ // Label 4212: @190043
     /* 190043 */ GIM_Reject,
     /* 190044 */ // Label 4200: @190044
     /* 190044 */ GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(190385),
     /* 190049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 190052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190055 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(190117), // Rule ID 23502 //
     /* 190060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190099 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 190102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190115 */     GIR_RootConstrainSelectedInstOperands,
     /* 190116 */     // GIR_Coverage, 23502,
     /* 190116 */     GIR_EraseRootFromParent_Done,
     /* 190117 */   // Label 4218: @190117
     /* 190117 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(190179), // Rule ID 24113 //
     /* 190122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190161 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 190164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190177 */     GIR_RootConstrainSelectedInstOperands,
     /* 190178 */     // GIR_Coverage, 24113,
     /* 190178 */     GIR_EraseRootFromParent_Done,
     /* 190179 */   // Label 4219: @190179
     /* 190179 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(190241), // Rule ID 3188 //
     /* 190184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190223 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 190226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190239 */     GIR_RootConstrainSelectedInstOperands,
     /* 190240 */     // GIR_Coverage, 3188,
     /* 190240 */     GIR_EraseRootFromParent_Done,
     /* 190241 */   // Label 4220: @190241
     /* 190241 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(190303), // Rule ID 5653 //
     /* 190246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190285 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 190288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190301 */     GIR_RootConstrainSelectedInstOperands,
     /* 190302 */     // GIR_Coverage, 5653,
     /* 190302 */     GIR_EraseRootFromParent_Done,
     /* 190303 */   // Label 4221: @190303
     /* 190303 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(190330), // Rule ID 3187 //
     /* 190308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190323 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 190328 */     GIR_RootConstrainSelectedInstOperands,
     /* 190329 */     // GIR_Coverage, 3187,
     /* 190329 */     GIR_Done,
     /* 190330 */   // Label 4222: @190330
     /* 190330 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(190357), // Rule ID 3225 //
     /* 190335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190350 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 190355 */     GIR_RootConstrainSelectedInstOperands,
     /* 190356 */     // GIR_Coverage, 3225,
     /* 190356 */     GIR_Done,
     /* 190357 */   // Label 4223: @190357
     /* 190357 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(190384), // Rule ID 5650 //
     /* 190362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190377 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 190377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 190382 */     GIR_RootConstrainSelectedInstOperands,
     /* 190383 */     // GIR_Coverage, 5650,
     /* 190383 */     GIR_Done,
     /* 190384 */   // Label 4224: @190384
     /* 190384 */   GIM_Reject,
     /* 190385 */ // Label 4217: @190385
     /* 190385 */ GIM_Reject,
     /* 190386 */ // Label 4201: @190386
     /* 190386 */ GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(190702),
     /* 190391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 190394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 190397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190401 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(190459), // Rule ID 24125 //
     /* 190406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190417 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190424 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190441 */     // (umin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 190444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190457 */     GIR_RootConstrainSelectedInstOperands,
     /* 190458 */     // GIR_Coverage, 24125,
     /* 190458 */     GIR_EraseRootFromParent_Done,
     /* 190459 */   // Label 4226: @190459
     /* 190459 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(190517), // Rule ID 5671 //
     /* 190464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190479 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190499 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 190502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190506 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190515 */     GIR_RootConstrainSelectedInstOperands,
     /* 190516 */     // GIR_Coverage, 5671,
     /* 190516 */     GIR_EraseRootFromParent_Done,
     /* 190517 */   // Label 4227: @190517
     /* 190517 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(190540), // Rule ID 5668 //
     /* 190522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190533 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 190533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 190538 */     GIR_RootConstrainSelectedInstOperands,
     /* 190539 */     // GIR_Coverage, 5668,
     /* 190539 */     GIR_Done,
     /* 190540 */   // Label 4228: @190540
     /* 190540 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(190701), // Rule ID 20004 //
     /* 190545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 190548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190556 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 190556 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 190559 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190563 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 190570 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 190573 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190577 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190582 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 190585 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 190589 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 190592 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190597 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190602 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 190643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 190665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190673 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190683 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 190690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190700 */     // GIR_Coverage, 20004,
     /* 190700 */     GIR_EraseRootFromParent_Done,
     /* 190701 */   // Label 4229: @190701
     /* 190701 */   GIM_Reject,
     /* 190702 */ // Label 4225: @190702
     /* 190702 */ GIM_Reject,
     /* 190703 */ // Label 4202: @190703
     /* 190703 */ GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(191044),
     /* 190708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 190711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190714 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(190776), // Rule ID 23507 //
     /* 190719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190758 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 190761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190774 */     GIR_RootConstrainSelectedInstOperands,
     /* 190775 */     // GIR_Coverage, 23507,
     /* 190775 */     GIR_EraseRootFromParent_Done,
     /* 190776 */   // Label 4231: @190776
     /* 190776 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(190838), // Rule ID 24098 //
     /* 190781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190796 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190820 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 190823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190825 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190836 */     GIR_RootConstrainSelectedInstOperands,
     /* 190837 */     // GIR_Coverage, 24098,
     /* 190837 */     GIR_EraseRootFromParent_Done,
     /* 190838 */   // Label 4232: @190838
     /* 190838 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(190900), // Rule ID 3198 //
     /* 190843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190882 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 190885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190898 */     GIR_RootConstrainSelectedInstOperands,
     /* 190899 */     // GIR_Coverage, 3198,
     /* 190899 */     GIR_EraseRootFromParent_Done,
     /* 190900 */   // Label 4233: @190900
     /* 190900 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(190962), // Rule ID 5629 //
     /* 190905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190944 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 190947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190949 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190960 */     GIR_RootConstrainSelectedInstOperands,
     /* 190961 */     // GIR_Coverage, 5629,
     /* 190961 */     GIR_EraseRootFromParent_Done,
     /* 190962 */   // Label 4234: @190962
     /* 190962 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(190989), // Rule ID 3197 //
     /* 190967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190982 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 190982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 190987 */     GIR_RootConstrainSelectedInstOperands,
     /* 190988 */     // GIR_Coverage, 3197,
     /* 190988 */     GIR_Done,
     /* 190989 */   // Label 4235: @190989
     /* 190989 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(191016), // Rule ID 3227 //
     /* 190994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191009 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 191014 */     GIR_RootConstrainSelectedInstOperands,
     /* 191015 */     // GIR_Coverage, 3227,
     /* 191015 */     GIR_Done,
     /* 191016 */   // Label 4236: @191016
     /* 191016 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(191043), // Rule ID 5626 //
     /* 191021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191036 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 191036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 191041 */     GIR_RootConstrainSelectedInstOperands,
     /* 191042 */     // GIR_Coverage, 5626,
     /* 191042 */     GIR_Done,
     /* 191043 */   // Label 4237: @191043
     /* 191043 */   GIM_Reject,
     /* 191044 */ // Label 4230: @191044
     /* 191044 */ GIM_Reject,
     /* 191045 */ // Label 4203: @191045
     /* 191045 */ GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(191359),
     /* 191050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 191053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 191056 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(191118), // Rule ID 23511 //
     /* 191061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191100 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 191103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191116 */     GIR_RootConstrainSelectedInstOperands,
     /* 191117 */     // GIR_Coverage, 23511,
     /* 191117 */     GIR_EraseRootFromParent_Done,
     /* 191118 */   // Label 4239: @191118
     /* 191118 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(191180), // Rule ID 24107 //
     /* 191123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191162 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 191165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191167 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191178 */     GIR_RootConstrainSelectedInstOperands,
     /* 191179 */     // GIR_Coverage, 24107,
     /* 191179 */     GIR_EraseRootFromParent_Done,
     /* 191180 */   // Label 4240: @191180
     /* 191180 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(191242), // Rule ID 3206 //
     /* 191185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191224 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 191227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191240 */     GIR_RootConstrainSelectedInstOperands,
     /* 191241 */     // GIR_Coverage, 3206,
     /* 191241 */     GIR_EraseRootFromParent_Done,
     /* 191242 */   // Label 4241: @191242
     /* 191242 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(191304), // Rule ID 5644 //
     /* 191247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191286 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 191289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191302 */     GIR_RootConstrainSelectedInstOperands,
     /* 191303 */     // GIR_Coverage, 5644,
     /* 191303 */     GIR_EraseRootFromParent_Done,
     /* 191304 */   // Label 4242: @191304
     /* 191304 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(191331), // Rule ID 3205 //
     /* 191309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191324 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 191324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 191329 */     GIR_RootConstrainSelectedInstOperands,
     /* 191330 */     // GIR_Coverage, 3205,
     /* 191330 */     GIR_Done,
     /* 191331 */   // Label 4243: @191331
     /* 191331 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(191358), // Rule ID 5641 //
     /* 191336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191351 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 191351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 191356 */     GIR_RootConstrainSelectedInstOperands,
     /* 191357 */     // GIR_Coverage, 5641,
     /* 191357 */     GIR_Done,
     /* 191358 */   // Label 4244: @191358
     /* 191358 */   GIM_Reject,
     /* 191359 */ // Label 4238: @191359
     /* 191359 */ GIM_Reject,
     /* 191360 */ // Label 4204: @191360
     /* 191360 */ GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(191515),
     /* 191365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 191368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 191371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191375 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(191433), // Rule ID 24119 //
     /* 191380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191415 */     // (umin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 191418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191431 */     GIR_RootConstrainSelectedInstOperands,
     /* 191432 */     // GIR_Coverage, 24119,
     /* 191432 */     GIR_EraseRootFromParent_Done,
     /* 191433 */   // Label 4246: @191433
     /* 191433 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(191491), // Rule ID 5662 //
     /* 191438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191473 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 191476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191489 */     GIR_RootConstrainSelectedInstOperands,
     /* 191490 */     // GIR_Coverage, 5662,
     /* 191490 */     GIR_EraseRootFromParent_Done,
     /* 191491 */   // Label 4247: @191491
     /* 191491 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(191514), // Rule ID 5659 //
     /* 191496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191507 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 191507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 191512 */     GIR_RootConstrainSelectedInstOperands,
     /* 191513 */     // GIR_Coverage, 5659,
     /* 191513 */     GIR_Done,
     /* 191514 */   // Label 4248: @191514
     /* 191514 */   GIM_Reject,
     /* 191515 */ // Label 4245: @191515
     /* 191515 */ GIM_Reject,
     /* 191516 */ // Label 4205: @191516
     /* 191516 */ GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(191857),
     /* 191521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 191524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191527 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(191589), // Rule ID 23462 //
     /* 191532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191547 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191571 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 191574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191587 */     GIR_RootConstrainSelectedInstOperands,
     /* 191588 */     // GIR_Coverage, 23462,
     /* 191588 */     GIR_EraseRootFromParent_Done,
     /* 191589 */   // Label 4250: @191589
     /* 191589 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(191651), // Rule ID 24089 //
     /* 191594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191633 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 191636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191638 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191649 */     GIR_RootConstrainSelectedInstOperands,
     /* 191650 */     // GIR_Coverage, 24089,
     /* 191650 */     GIR_EraseRootFromParent_Done,
     /* 191651 */   // Label 4251: @191651
     /* 191651 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(191713), // Rule ID 2637 //
     /* 191656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191695 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 191698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191711 */     GIR_RootConstrainSelectedInstOperands,
     /* 191712 */     // GIR_Coverage, 2637,
     /* 191712 */     GIR_EraseRootFromParent_Done,
     /* 191713 */   // Label 4252: @191713
     /* 191713 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(191775), // Rule ID 5611 //
     /* 191718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191757 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 191760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191773 */     GIR_RootConstrainSelectedInstOperands,
     /* 191774 */     // GIR_Coverage, 5611,
     /* 191774 */     GIR_EraseRootFromParent_Done,
     /* 191775 */   // Label 4253: @191775
     /* 191775 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(191802), // Rule ID 2636 //
     /* 191780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191795 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 191800 */     GIR_RootConstrainSelectedInstOperands,
     /* 191801 */     // GIR_Coverage, 2636,
     /* 191801 */     GIR_Done,
     /* 191802 */   // Label 4254: @191802
     /* 191802 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(191829), // Rule ID 2638 //
     /* 191807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 191810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191822 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 191827 */     GIR_RootConstrainSelectedInstOperands,
     /* 191828 */     // GIR_Coverage, 2638,
     /* 191828 */     GIR_Done,
     /* 191829 */   // Label 4255: @191829
     /* 191829 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(191856), // Rule ID 5608 //
     /* 191834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191849 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 191849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 191854 */     GIR_RootConstrainSelectedInstOperands,
     /* 191855 */     // GIR_Coverage, 5608,
     /* 191855 */     GIR_Done,
     /* 191856 */   // Label 4256: @191856
     /* 191856 */   GIM_Reject,
     /* 191857 */ // Label 4249: @191857
     /* 191857 */ GIM_Reject,
     /* 191858 */ // Label 4206: @191858
     /* 191858 */ GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(192172),
     /* 191863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 191866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 191869 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(191931), // Rule ID 23516 //
     /* 191874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191913 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 191916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191929 */     GIR_RootConstrainSelectedInstOperands,
     /* 191930 */     // GIR_Coverage, 23516,
     /* 191930 */     GIR_EraseRootFromParent_Done,
     /* 191931 */   // Label 4258: @191931
     /* 191931 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(191993), // Rule ID 24095 //
     /* 191936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191975 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 191978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191991 */     GIR_RootConstrainSelectedInstOperands,
     /* 191992 */     // GIR_Coverage, 24095,
     /* 191992 */     GIR_EraseRootFromParent_Done,
     /* 191993 */   // Label 4259: @191993
     /* 191993 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(192055), // Rule ID 3216 //
     /* 191998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192037 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 192040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192053 */     GIR_RootConstrainSelectedInstOperands,
     /* 192054 */     // GIR_Coverage, 3216,
     /* 192054 */     GIR_EraseRootFromParent_Done,
     /* 192055 */   // Label 4260: @192055
     /* 192055 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(192117), // Rule ID 5623 //
     /* 192060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192099 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 192102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192115 */     GIR_RootConstrainSelectedInstOperands,
     /* 192116 */     // GIR_Coverage, 5623,
     /* 192116 */     GIR_EraseRootFromParent_Done,
     /* 192117 */   // Label 4261: @192117
     /* 192117 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(192144), // Rule ID 3215 //
     /* 192122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192137 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 192137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 192142 */     GIR_RootConstrainSelectedInstOperands,
     /* 192143 */     // GIR_Coverage, 3215,
     /* 192143 */     GIR_Done,
     /* 192144 */   // Label 4262: @192144
     /* 192144 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(192171), // Rule ID 5620 //
     /* 192149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192164 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 192164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 192169 */     GIR_RootConstrainSelectedInstOperands,
     /* 192170 */     // GIR_Coverage, 5620,
     /* 192170 */     GIR_Done,
     /* 192171 */   // Label 4263: @192171
     /* 192171 */   GIM_Reject,
     /* 192172 */ // Label 4257: @192172
     /* 192172 */ GIM_Reject,
     /* 192173 */ // Label 4207: @192173
     /* 192173 */ GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(192328),
     /* 192178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 192181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 192184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192188 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(192246), // Rule ID 24101 //
     /* 192193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192228 */     // (umin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 192231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192235 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192244 */     GIR_RootConstrainSelectedInstOperands,
     /* 192245 */     // GIR_Coverage, 24101,
     /* 192245 */     GIR_EraseRootFromParent_Done,
     /* 192246 */   // Label 4265: @192246
     /* 192246 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(192304), // Rule ID 5635 //
     /* 192251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192286 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 192289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192302 */     GIR_RootConstrainSelectedInstOperands,
     /* 192303 */     // GIR_Coverage, 5635,
     /* 192303 */     GIR_EraseRootFromParent_Done,
     /* 192304 */   // Label 4266: @192304
     /* 192304 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(192327), // Rule ID 5632 //
     /* 192309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192320 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 192320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 192325 */     GIR_RootConstrainSelectedInstOperands,
     /* 192326 */     // GIR_Coverage, 5632,
     /* 192326 */     GIR_Done,
     /* 192327 */   // Label 4267: @192327
     /* 192327 */   GIM_Reject,
     /* 192328 */ // Label 4264: @192328
     /* 192328 */ GIM_Reject,
     /* 192329 */ // Label 4208: @192329
     /* 192329 */ GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(192643),
     /* 192334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 192337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 192340 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(192402), // Rule ID 23464 //
     /* 192345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192384 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 192387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192400 */     GIR_RootConstrainSelectedInstOperands,
     /* 192401 */     // GIR_Coverage, 23464,
     /* 192401 */     GIR_EraseRootFromParent_Done,
     /* 192402 */   // Label 4269: @192402
     /* 192402 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(192464), // Rule ID 24086 //
     /* 192407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192446 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 192449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192462 */     GIR_RootConstrainSelectedInstOperands,
     /* 192463 */     // GIR_Coverage, 24086,
     /* 192463 */     GIR_EraseRootFromParent_Done,
     /* 192464 */   // Label 4270: @192464
     /* 192464 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(192526), // Rule ID 2641 //
     /* 192469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192508 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 192511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192524 */     GIR_RootConstrainSelectedInstOperands,
     /* 192525 */     // GIR_Coverage, 2641,
     /* 192525 */     GIR_EraseRootFromParent_Done,
     /* 192526 */   // Label 4271: @192526
     /* 192526 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(192588), // Rule ID 5605 //
     /* 192531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192570 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 192573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192586 */     GIR_RootConstrainSelectedInstOperands,
     /* 192587 */     // GIR_Coverage, 5605,
     /* 192587 */     GIR_EraseRootFromParent_Done,
     /* 192588 */   // Label 4272: @192588
     /* 192588 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(192615), // Rule ID 2640 //
     /* 192593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192608 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 192608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 192613 */     GIR_RootConstrainSelectedInstOperands,
     /* 192614 */     // GIR_Coverage, 2640,
     /* 192614 */     GIR_Done,
     /* 192615 */   // Label 4273: @192615
     /* 192615 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(192642), // Rule ID 5602 //
     /* 192620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192635 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 192635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 192640 */     GIR_RootConstrainSelectedInstOperands,
     /* 192641 */     // GIR_Coverage, 5602,
     /* 192641 */     GIR_Done,
     /* 192642 */   // Label 4274: @192642
     /* 192642 */   GIM_Reject,
     /* 192643 */ // Label 4268: @192643
     /* 192643 */ GIM_Reject,
     /* 192644 */ // Label 4209: @192644
     /* 192644 */ GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(192799),
     /* 192649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 192652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 192655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192659 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(192717), // Rule ID 24092 //
     /* 192664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192699 */     // (umin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 192702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192706 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192715 */     GIR_RootConstrainSelectedInstOperands,
     /* 192716 */     // GIR_Coverage, 24092,
     /* 192716 */     GIR_EraseRootFromParent_Done,
     /* 192717 */   // Label 4276: @192717
     /* 192717 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(192775), // Rule ID 5617 //
     /* 192722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192757 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 192760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192773 */     GIR_RootConstrainSelectedInstOperands,
     /* 192774 */     // GIR_Coverage, 5617,
     /* 192774 */     GIR_EraseRootFromParent_Done,
     /* 192775 */   // Label 4277: @192775
     /* 192775 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(192798), // Rule ID 5614 //
     /* 192780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192791 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 192791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 192796 */     GIR_RootConstrainSelectedInstOperands,
     /* 192797 */     // GIR_Coverage, 5614,
     /* 192797 */     GIR_Done,
     /* 192798 */   // Label 4278: @192798
     /* 192798 */   GIM_Reject,
     /* 192799 */ // Label 4275: @192799
     /* 192799 */ GIM_Reject,
     /* 192800 */ // Label 4210: @192800
     /* 192800 */ GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(192955),
     /* 192805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 192808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 192811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192815 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(192873), // Rule ID 24083 //
     /* 192820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192855 */     // (umin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 192858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192871 */     GIR_RootConstrainSelectedInstOperands,
     /* 192872 */     // GIR_Coverage, 24083,
     /* 192872 */     GIR_EraseRootFromParent_Done,
     /* 192873 */   // Label 4280: @192873
     /* 192873 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(192931), // Rule ID 5599 //
     /* 192878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192900 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192913 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 192916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192929 */     GIR_RootConstrainSelectedInstOperands,
     /* 192930 */     // GIR_Coverage, 5599,
     /* 192930 */     GIR_EraseRootFromParent_Done,
     /* 192931 */   // Label 4281: @192931
     /* 192931 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(192954), // Rule ID 5596 //
     /* 192936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192947 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 192947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 192952 */     GIR_RootConstrainSelectedInstOperands,
     /* 192953 */     // GIR_Coverage, 5596,
     /* 192953 */     GIR_Done,
     /* 192954 */   // Label 4282: @192954
     /* 192954 */   GIM_Reject,
     /* 192955 */ // Label 4279: @192955
     /* 192955 */ GIM_Reject,
     /* 192956 */ // Label 4211: @192956
     /* 192956 */ GIM_Reject,
     /* 192957 */ // Label 57: @192957
     /* 192957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4295*/ GIMT_Encode4(196277),
     /* 192968 */ /*GILLT_v2s64*//*Label 4283*/ GIMT_Encode4(193036), GIMT_Encode4(0),
     /* 192976 */ /*GILLT_v4s32*//*Label 4284*/ GIMT_Encode4(193365),
     /* 192980 */ /*GILLT_v4s64*//*Label 4285*/ GIMT_Encode4(193707), GIMT_Encode4(0),
     /* 192988 */ /*GILLT_v8s16*//*Label 4286*/ GIMT_Encode4(194024),
     /* 192992 */ /*GILLT_v8s32*//*Label 4287*/ GIMT_Encode4(194366),
     /* 192996 */ /*GILLT_v8s64*//*Label 4288*/ GIMT_Encode4(194681), GIMT_Encode4(0),
     /* 193004 */ /*GILLT_v16s8*//*Label 4289*/ GIMT_Encode4(194837),
     /* 193008 */ /*GILLT_v16s16*//*Label 4290*/ GIMT_Encode4(195179),
     /* 193012 */ /*GILLT_v16s32*//*Label 4291*/ GIMT_Encode4(195494), GIMT_Encode4(0),
     /* 193020 */ /*GILLT_v32s8*//*Label 4292*/ GIMT_Encode4(195650),
     /* 193024 */ /*GILLT_v32s16*//*Label 4293*/ GIMT_Encode4(195965), GIMT_Encode4(0),
     /* 193032 */ /*GILLT_v64s8*//*Label 4294*/ GIMT_Encode4(196121),
     /* 193036 */ // Label 4283: @193036
     /* 193036 */ GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(193364),
     /* 193041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193047 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(193109), // Rule ID 24023 //
     /* 193052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193091 */     // (umax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 193094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193107 */     GIR_RootConstrainSelectedInstOperands,
     /* 193108 */     // GIR_Coverage, 24023,
     /* 193108 */     GIR_EraseRootFromParent_Done,
     /* 193109 */   // Label 4297: @193109
     /* 193109 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(193171), // Rule ID 5500 //
     /* 193114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193153 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 193156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193169 */     GIR_RootConstrainSelectedInstOperands,
     /* 193170 */     // GIR_Coverage, 5500,
     /* 193170 */     GIR_EraseRootFromParent_Done,
     /* 193171 */   // Label 4298: @193171
     /* 193171 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(193198), // Rule ID 5497 //
     /* 193176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193191 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 193191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 193196 */     GIR_RootConstrainSelectedInstOperands,
     /* 193197 */     // GIR_Coverage, 5497,
     /* 193197 */     GIR_Done,
     /* 193198 */   // Label 4299: @193198
     /* 193198 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(193363), // Rule ID 20002 //
     /* 193203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 193210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193218 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 193218 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 193221 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193225 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 193232 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 193235 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193239 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193244 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 193247 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 193251 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 193254 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193259 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193264 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193269 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193272 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193276 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193295 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 193302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 193305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193310 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 193327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 193338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193345 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 193352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 193357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193362 */     // GIR_Coverage, 20002,
     /* 193362 */     GIR_EraseRootFromParent_Done,
     /* 193363 */   // Label 4300: @193363
     /* 193363 */   GIM_Reject,
     /* 193364 */ // Label 4296: @193364
     /* 193364 */ GIM_Reject,
     /* 193365 */ // Label 4284: @193365
     /* 193365 */ GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(193706),
     /* 193370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193376 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(193438), // Rule ID 23504 //
     /* 193381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193420 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 193423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193436 */     GIR_RootConstrainSelectedInstOperands,
     /* 193437 */     // GIR_Coverage, 23504,
     /* 193437 */     GIR_EraseRootFromParent_Done,
     /* 193438 */   // Label 4302: @193438
     /* 193438 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(193500), // Rule ID 24005 //
     /* 193443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193482 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 193485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193487 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193498 */     GIR_RootConstrainSelectedInstOperands,
     /* 193499 */     // GIR_Coverage, 24005,
     /* 193499 */     GIR_EraseRootFromParent_Done,
     /* 193500 */   // Label 4303: @193500
     /* 193500 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(193562), // Rule ID 3192 //
     /* 193505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193544 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 193547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193560 */     GIR_RootConstrainSelectedInstOperands,
     /* 193561 */     // GIR_Coverage, 3192,
     /* 193561 */     GIR_EraseRootFromParent_Done,
     /* 193562 */   // Label 4304: @193562
     /* 193562 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(193624), // Rule ID 5473 //
     /* 193567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193606 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 193609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193622 */     GIR_RootConstrainSelectedInstOperands,
     /* 193623 */     // GIR_Coverage, 5473,
     /* 193623 */     GIR_EraseRootFromParent_Done,
     /* 193624 */   // Label 4305: @193624
     /* 193624 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(193651), // Rule ID 3191 //
     /* 193629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193644 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 193644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 193649 */     GIR_RootConstrainSelectedInstOperands,
     /* 193650 */     // GIR_Coverage, 3191,
     /* 193650 */     GIR_Done,
     /* 193651 */   // Label 4306: @193651
     /* 193651 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(193678), // Rule ID 3233 //
     /* 193656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 193659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193671 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 193671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 193676 */     GIR_RootConstrainSelectedInstOperands,
     /* 193677 */     // GIR_Coverage, 3233,
     /* 193677 */     GIR_Done,
     /* 193678 */   // Label 4307: @193678
     /* 193678 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(193705), // Rule ID 5470 //
     /* 193683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193698 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 193698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 193703 */     GIR_RootConstrainSelectedInstOperands,
     /* 193704 */     // GIR_Coverage, 5470,
     /* 193704 */     GIR_Done,
     /* 193705 */   // Label 4308: @193705
     /* 193705 */   GIM_Reject,
     /* 193706 */ // Label 4301: @193706
     /* 193706 */ GIM_Reject,
     /* 193707 */ // Label 4285: @193707
     /* 193707 */ GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(194023),
     /* 193712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 193715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 193718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193722 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(193780), // Rule ID 24017 //
     /* 193727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193762 */     // (umax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 193765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193778 */     GIR_RootConstrainSelectedInstOperands,
     /* 193779 */     // GIR_Coverage, 24017,
     /* 193779 */     GIR_EraseRootFromParent_Done,
     /* 193780 */   // Label 4310: @193780
     /* 193780 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(193838), // Rule ID 5491 //
     /* 193785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193820 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 193823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193836 */     GIR_RootConstrainSelectedInstOperands,
     /* 193837 */     // GIR_Coverage, 5491,
     /* 193837 */     GIR_EraseRootFromParent_Done,
     /* 193838 */   // Label 4311: @193838
     /* 193838 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(193861), // Rule ID 5488 //
     /* 193843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193854 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 193854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 193859 */     GIR_RootConstrainSelectedInstOperands,
     /* 193860 */     // GIR_Coverage, 5488,
     /* 193860 */     GIR_Done,
     /* 193861 */   // Label 4312: @193861
     /* 193861 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(194022), // Rule ID 20000 //
     /* 193866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193877 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 193877 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 193880 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193884 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 193891 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 193894 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193898 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193903 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 193906 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 193910 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 193913 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193918 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193923 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193928 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193931 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193935 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193954 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193957 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 193961 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 193964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 193986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 193997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 194011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 194016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 194021 */     // GIR_Coverage, 20000,
     /* 194021 */     GIR_EraseRootFromParent_Done,
     /* 194022 */   // Label 4313: @194022
     /* 194022 */   GIM_Reject,
     /* 194023 */ // Label 4309: @194023
     /* 194023 */ GIM_Reject,
     /* 194024 */ // Label 4286: @194024
     /* 194024 */ GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(194365),
     /* 194029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194035 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(194097), // Rule ID 23509 //
     /* 194040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194079 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 194082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194095 */     GIR_RootConstrainSelectedInstOperands,
     /* 194096 */     // GIR_Coverage, 23509,
     /* 194096 */     GIR_EraseRootFromParent_Done,
     /* 194097 */   // Label 4315: @194097
     /* 194097 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(194159), // Rule ID 23990 //
     /* 194102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194141 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 194144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194157 */     GIR_RootConstrainSelectedInstOperands,
     /* 194158 */     // GIR_Coverage, 23990,
     /* 194158 */     GIR_EraseRootFromParent_Done,
     /* 194159 */   // Label 4316: @194159
     /* 194159 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(194221), // Rule ID 3202 //
     /* 194164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194203 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 194206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194208 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194219 */     GIR_RootConstrainSelectedInstOperands,
     /* 194220 */     // GIR_Coverage, 3202,
     /* 194220 */     GIR_EraseRootFromParent_Done,
     /* 194221 */   // Label 4317: @194221
     /* 194221 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(194283), // Rule ID 5449 //
     /* 194226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194265 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 194268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194281 */     GIR_RootConstrainSelectedInstOperands,
     /* 194282 */     // GIR_Coverage, 5449,
     /* 194282 */     GIR_EraseRootFromParent_Done,
     /* 194283 */   // Label 4318: @194283
     /* 194283 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(194310), // Rule ID 3201 //
     /* 194288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194303 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 194303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 194308 */     GIR_RootConstrainSelectedInstOperands,
     /* 194309 */     // GIR_Coverage, 3201,
     /* 194309 */     GIR_Done,
     /* 194310 */   // Label 4319: @194310
     /* 194310 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(194337), // Rule ID 3235 //
     /* 194315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 194318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194330 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 194330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 194335 */     GIR_RootConstrainSelectedInstOperands,
     /* 194336 */     // GIR_Coverage, 3235,
     /* 194336 */     GIR_Done,
     /* 194337 */   // Label 4320: @194337
     /* 194337 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(194364), // Rule ID 5446 //
     /* 194342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194357 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 194357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 194362 */     GIR_RootConstrainSelectedInstOperands,
     /* 194363 */     // GIR_Coverage, 5446,
     /* 194363 */     GIR_Done,
     /* 194364 */   // Label 4321: @194364
     /* 194364 */   GIM_Reject,
     /* 194365 */ // Label 4314: @194365
     /* 194365 */ GIM_Reject,
     /* 194366 */ // Label 4287: @194366
     /* 194366 */ GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(194680),
     /* 194371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 194374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 194377 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(194439), // Rule ID 23513 //
     /* 194382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194397 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194421 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 194424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194437 */     GIR_RootConstrainSelectedInstOperands,
     /* 194438 */     // GIR_Coverage, 23513,
     /* 194438 */     GIR_EraseRootFromParent_Done,
     /* 194439 */   // Label 4323: @194439
     /* 194439 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(194501), // Rule ID 23999 //
     /* 194444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194459 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194466 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194483 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 194486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194499 */     GIR_RootConstrainSelectedInstOperands,
     /* 194500 */     // GIR_Coverage, 23999,
     /* 194500 */     GIR_EraseRootFromParent_Done,
     /* 194501 */   // Label 4324: @194501
     /* 194501 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(194563), // Rule ID 3210 //
     /* 194506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194525 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194532 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194545 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 194548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194550 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194552 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194561 */     GIR_RootConstrainSelectedInstOperands,
     /* 194562 */     // GIR_Coverage, 3210,
     /* 194562 */     GIR_EraseRootFromParent_Done,
     /* 194563 */   // Label 4325: @194563
     /* 194563 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(194625), // Rule ID 5464 //
     /* 194568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194607 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 194610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194623 */     GIR_RootConstrainSelectedInstOperands,
     /* 194624 */     // GIR_Coverage, 5464,
     /* 194624 */     GIR_EraseRootFromParent_Done,
     /* 194625 */   // Label 4326: @194625
     /* 194625 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(194652), // Rule ID 3209 //
     /* 194630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194645 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 194645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 194650 */     GIR_RootConstrainSelectedInstOperands,
     /* 194651 */     // GIR_Coverage, 3209,
     /* 194651 */     GIR_Done,
     /* 194652 */   // Label 4327: @194652
     /* 194652 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(194679), // Rule ID 5461 //
     /* 194657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194672 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 194672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 194677 */     GIR_RootConstrainSelectedInstOperands,
     /* 194678 */     // GIR_Coverage, 5461,
     /* 194678 */     GIR_Done,
     /* 194679 */   // Label 4328: @194679
     /* 194679 */   GIM_Reject,
     /* 194680 */ // Label 4322: @194680
     /* 194680 */ GIM_Reject,
     /* 194681 */ // Label 4288: @194681
     /* 194681 */ GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(194836),
     /* 194686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 194692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194696 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(194754), // Rule ID 24011 //
     /* 194701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194736 */     // (umax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 194739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194752 */     GIR_RootConstrainSelectedInstOperands,
     /* 194753 */     // GIR_Coverage, 24011,
     /* 194753 */     GIR_EraseRootFromParent_Done,
     /* 194754 */   // Label 4330: @194754
     /* 194754 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(194812), // Rule ID 5482 //
     /* 194759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194794 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 194797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194810 */     GIR_RootConstrainSelectedInstOperands,
     /* 194811 */     // GIR_Coverage, 5482,
     /* 194811 */     GIR_EraseRootFromParent_Done,
     /* 194812 */   // Label 4331: @194812
     /* 194812 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(194835), // Rule ID 5479 //
     /* 194817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194828 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 194828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 194833 */     GIR_RootConstrainSelectedInstOperands,
     /* 194834 */     // GIR_Coverage, 5479,
     /* 194834 */     GIR_Done,
     /* 194835 */   // Label 4332: @194835
     /* 194835 */   GIM_Reject,
     /* 194836 */ // Label 4329: @194836
     /* 194836 */ GIM_Reject,
     /* 194837 */ // Label 4289: @194837
     /* 194837 */ GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(195178),
     /* 194842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 194845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194848 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(194910), // Rule ID 23468 //
     /* 194853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194892 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 194895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194908 */     GIR_RootConstrainSelectedInstOperands,
     /* 194909 */     // GIR_Coverage, 23468,
     /* 194909 */     GIR_EraseRootFromParent_Done,
     /* 194910 */   // Label 4334: @194910
     /* 194910 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(194972), // Rule ID 23981 //
     /* 194915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194954 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 194957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194970 */     GIR_RootConstrainSelectedInstOperands,
     /* 194971 */     // GIR_Coverage, 23981,
     /* 194971 */     GIR_EraseRootFromParent_Done,
     /* 194972 */   // Label 4335: @194972
     /* 194972 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(195034), // Rule ID 2649 //
     /* 194977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195016 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 195019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195032 */     GIR_RootConstrainSelectedInstOperands,
     /* 195033 */     // GIR_Coverage, 2649,
     /* 195033 */     GIR_EraseRootFromParent_Done,
     /* 195034 */   // Label 4336: @195034
     /* 195034 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(195096), // Rule ID 5431 //
     /* 195039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195078 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 195081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195094 */     GIR_RootConstrainSelectedInstOperands,
     /* 195095 */     // GIR_Coverage, 5431,
     /* 195095 */     GIR_EraseRootFromParent_Done,
     /* 195096 */   // Label 4337: @195096
     /* 195096 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(195123), // Rule ID 2648 //
     /* 195101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 195104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195116 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 195116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 195121 */     GIR_RootConstrainSelectedInstOperands,
     /* 195122 */     // GIR_Coverage, 2648,
     /* 195122 */     GIR_Done,
     /* 195123 */   // Label 4338: @195123
     /* 195123 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(195150), // Rule ID 2650 //
     /* 195128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 195131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195143 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 195143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 195148 */     GIR_RootConstrainSelectedInstOperands,
     /* 195149 */     // GIR_Coverage, 2650,
     /* 195149 */     GIR_Done,
     /* 195150 */   // Label 4339: @195150
     /* 195150 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(195177), // Rule ID 5428 //
     /* 195155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195170 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 195170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 195175 */     GIR_RootConstrainSelectedInstOperands,
     /* 195176 */     // GIR_Coverage, 5428,
     /* 195176 */     GIR_Done,
     /* 195177 */   // Label 4340: @195177
     /* 195177 */   GIM_Reject,
     /* 195178 */ // Label 4333: @195178
     /* 195178 */ GIM_Reject,
     /* 195179 */ // Label 4290: @195179
     /* 195179 */ GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(195493),
     /* 195184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 195187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 195190 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(195252), // Rule ID 23518 //
     /* 195195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195234 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 195237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195239 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195250 */     GIR_RootConstrainSelectedInstOperands,
     /* 195251 */     // GIR_Coverage, 23518,
     /* 195251 */     GIR_EraseRootFromParent_Done,
     /* 195252 */   // Label 4342: @195252
     /* 195252 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(195314), // Rule ID 23987 //
     /* 195257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195296 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 195299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195301 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195312 */     GIR_RootConstrainSelectedInstOperands,
     /* 195313 */     // GIR_Coverage, 23987,
     /* 195313 */     GIR_EraseRootFromParent_Done,
     /* 195314 */   // Label 4343: @195314
     /* 195314 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(195376), // Rule ID 3220 //
     /* 195319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195358 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 195361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195374 */     GIR_RootConstrainSelectedInstOperands,
     /* 195375 */     // GIR_Coverage, 3220,
     /* 195375 */     GIR_EraseRootFromParent_Done,
     /* 195376 */   // Label 4344: @195376
     /* 195376 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(195438), // Rule ID 5443 //
     /* 195381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195420 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 195423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195425 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195436 */     GIR_RootConstrainSelectedInstOperands,
     /* 195437 */     // GIR_Coverage, 5443,
     /* 195437 */     GIR_EraseRootFromParent_Done,
     /* 195438 */   // Label 4345: @195438
     /* 195438 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(195465), // Rule ID 3219 //
     /* 195443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195458 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 195458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 195463 */     GIR_RootConstrainSelectedInstOperands,
     /* 195464 */     // GIR_Coverage, 3219,
     /* 195464 */     GIR_Done,
     /* 195465 */   // Label 4346: @195465
     /* 195465 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(195492), // Rule ID 5440 //
     /* 195470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195485 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 195485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 195490 */     GIR_RootConstrainSelectedInstOperands,
     /* 195491 */     // GIR_Coverage, 5440,
     /* 195491 */     GIR_Done,
     /* 195492 */   // Label 4347: @195492
     /* 195492 */   GIM_Reject,
     /* 195493 */ // Label 4341: @195493
     /* 195493 */ GIM_Reject,
     /* 195494 */ // Label 4291: @195494
     /* 195494 */ GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(195649),
     /* 195499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 195505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195509 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(195567), // Rule ID 23993 //
     /* 195514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195525 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195532 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195549 */     // (umax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 195552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195554 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195565 */     GIR_RootConstrainSelectedInstOperands,
     /* 195566 */     // GIR_Coverage, 23993,
     /* 195566 */     GIR_EraseRootFromParent_Done,
     /* 195567 */   // Label 4349: @195567
     /* 195567 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(195625), // Rule ID 5455 //
     /* 195572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195607 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 195610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195623 */     GIR_RootConstrainSelectedInstOperands,
     /* 195624 */     // GIR_Coverage, 5455,
     /* 195624 */     GIR_EraseRootFromParent_Done,
     /* 195625 */   // Label 4350: @195625
     /* 195625 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(195648), // Rule ID 5452 //
     /* 195630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195641 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 195641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 195646 */     GIR_RootConstrainSelectedInstOperands,
     /* 195647 */     // GIR_Coverage, 5452,
     /* 195647 */     GIR_Done,
     /* 195648 */   // Label 4351: @195648
     /* 195648 */   GIM_Reject,
     /* 195649 */ // Label 4348: @195649
     /* 195649 */ GIM_Reject,
     /* 195650 */ // Label 4292: @195650
     /* 195650 */ GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(195964),
     /* 195655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 195658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 195661 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(195723), // Rule ID 23470 //
     /* 195666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195705 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 195708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195721 */     GIR_RootConstrainSelectedInstOperands,
     /* 195722 */     // GIR_Coverage, 23470,
     /* 195722 */     GIR_EraseRootFromParent_Done,
     /* 195723 */   // Label 4353: @195723
     /* 195723 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(195785), // Rule ID 23978 //
     /* 195728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195743 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195767 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 195770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195783 */     GIR_RootConstrainSelectedInstOperands,
     /* 195784 */     // GIR_Coverage, 23978,
     /* 195784 */     GIR_EraseRootFromParent_Done,
     /* 195785 */   // Label 4354: @195785
     /* 195785 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(195847), // Rule ID 2653 //
     /* 195790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195829 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 195832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195834 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195845 */     GIR_RootConstrainSelectedInstOperands,
     /* 195846 */     // GIR_Coverage, 2653,
     /* 195846 */     GIR_EraseRootFromParent_Done,
     /* 195847 */   // Label 4355: @195847
     /* 195847 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(195909), // Rule ID 5425 //
     /* 195852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195891 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 195894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195896 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195907 */     GIR_RootConstrainSelectedInstOperands,
     /* 195908 */     // GIR_Coverage, 5425,
     /* 195908 */     GIR_EraseRootFromParent_Done,
     /* 195909 */   // Label 4356: @195909
     /* 195909 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(195936), // Rule ID 2652 //
     /* 195914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195929 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 195929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 195934 */     GIR_RootConstrainSelectedInstOperands,
     /* 195935 */     // GIR_Coverage, 2652,
     /* 195935 */     GIR_Done,
     /* 195936 */   // Label 4357: @195936
     /* 195936 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(195963), // Rule ID 5422 //
     /* 195941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195956 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 195956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 195961 */     GIR_RootConstrainSelectedInstOperands,
     /* 195962 */     // GIR_Coverage, 5422,
     /* 195962 */     GIR_Done,
     /* 195963 */   // Label 4358: @195963
     /* 195963 */   GIM_Reject,
     /* 195964 */ // Label 4352: @195964
     /* 195964 */ GIM_Reject,
     /* 195965 */ // Label 4293: @195965
     /* 195965 */ GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(196120),
     /* 195970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 195973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 195976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195980 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(196038), // Rule ID 23984 //
     /* 195985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 195988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196020 */     // (umax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 196023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 196027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196036 */     GIR_RootConstrainSelectedInstOperands,
     /* 196037 */     // GIR_Coverage, 23984,
     /* 196037 */     GIR_EraseRootFromParent_Done,
     /* 196038 */   // Label 4360: @196038
     /* 196038 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(196096), // Rule ID 5437 //
     /* 196043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 196054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196078 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 196081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 196085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196094 */     GIR_RootConstrainSelectedInstOperands,
     /* 196095 */     // GIR_Coverage, 5437,
     /* 196095 */     GIR_EraseRootFromParent_Done,
     /* 196096 */   // Label 4361: @196096
     /* 196096 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(196119), // Rule ID 5434 //
     /* 196101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196112 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 196112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 196117 */     GIR_RootConstrainSelectedInstOperands,
     /* 196118 */     // GIR_Coverage, 5434,
     /* 196118 */     GIR_Done,
     /* 196119 */   // Label 4362: @196119
     /* 196119 */   GIM_Reject,
     /* 196120 */ // Label 4359: @196120
     /* 196120 */ GIM_Reject,
     /* 196121 */ // Label 4294: @196121
     /* 196121 */ GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(196276),
     /* 196126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 196129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 196132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196136 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(196194), // Rule ID 23975 //
     /* 196141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196176 */     // (umax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 196179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 196183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196192 */     GIR_RootConstrainSelectedInstOperands,
     /* 196193 */     // GIR_Coverage, 23975,
     /* 196193 */     GIR_EraseRootFromParent_Done,
     /* 196194 */   // Label 4364: @196194
     /* 196194 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(196252), // Rule ID 5419 //
     /* 196199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 196210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196234 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 196237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 196241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196250 */     GIR_RootConstrainSelectedInstOperands,
     /* 196251 */     // GIR_Coverage, 5419,
     /* 196251 */     GIR_EraseRootFromParent_Done,
     /* 196252 */   // Label 4365: @196252
     /* 196252 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(196275), // Rule ID 5416 //
     /* 196257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196268 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 196268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 196273 */     GIR_RootConstrainSelectedInstOperands,
     /* 196274 */     // GIR_Coverage, 5416,
     /* 196274 */     GIR_Done,
     /* 196275 */   // Label 4366: @196275
     /* 196275 */   GIM_Reject,
     /* 196276 */ // Label 4363: @196276
     /* 196276 */ GIM_Reject,
     /* 196277 */ // Label 4295: @196277
     /* 196277 */ GIM_Reject,
     /* 196278 */ // Label 58: @196278
     /* 196278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4379*/ GIMT_Encode4(198158),
     /* 196289 */ /*GILLT_v2s64*//*Label 4367*/ GIMT_Encode4(196357), GIMT_Encode4(0),
     /* 196297 */ /*GILLT_v4s32*//*Label 4368*/ GIMT_Encode4(196553),
     /* 196301 */ /*GILLT_v4s64*//*Label 4369*/ GIMT_Encode4(196744), GIMT_Encode4(0),
     /* 196309 */ /*GILLT_v8s16*//*Label 4370*/ GIMT_Encode4(196932),
     /* 196313 */ /*GILLT_v8s32*//*Label 4371*/ GIMT_Encode4(197123),
     /* 196317 */ /*GILLT_v8s64*//*Label 4372*/ GIMT_Encode4(197291), GIMT_Encode4(0),
     /* 196325 */ /*GILLT_v16s8*//*Label 4373*/ GIMT_Encode4(197376),
     /* 196329 */ /*GILLT_v16s16*//*Label 4374*/ GIMT_Encode4(197567),
     /* 196333 */ /*GILLT_v16s32*//*Label 4375*/ GIMT_Encode4(197735), GIMT_Encode4(0),
     /* 196341 */ /*GILLT_v32s8*//*Label 4376*/ GIMT_Encode4(197820),
     /* 196345 */ /*GILLT_v32s16*//*Label 4377*/ GIMT_Encode4(197988), GIMT_Encode4(0),
     /* 196353 */ /*GILLT_v64s8*//*Label 4378*/ GIMT_Encode4(198073),
     /* 196357 */ // Label 4367: @196357
     /* 196357 */ GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(196552),
     /* 196362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196365 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(196421), // Rule ID 13267 //
     /* 196370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196405 */     // (abs:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 196405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rm),
     /* 196408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196419 */     GIR_RootConstrainSelectedInstOperands,
     /* 196420 */     // GIR_Coverage, 13267,
     /* 196420 */     GIR_EraseRootFromParent_Done,
     /* 196421 */   // Label 4381: @196421
     /* 196421 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(196444), // Rule ID 13264 //
     /* 196426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196437 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 196437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 196442 */     GIR_RootConstrainSelectedInstOperands,
     /* 196443 */     // GIR_Coverage, 13264,
     /* 196443 */     GIR_Done,
     /* 196444 */   // Label 4382: @196444
     /* 196444 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(196551), // Rule ID 21824 //
     /* 196449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 196452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196460 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 196460 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 196463 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196467 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 196474 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 196477 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196481 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196486 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 196489 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 196493 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 196496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 196501 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 196511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 196514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 196518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196523 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 196526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 196528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 196540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196550 */     // GIR_Coverage, 21824,
     /* 196550 */     GIR_EraseRootFromParent_Done,
     /* 196551 */   // Label 4383: @196551
     /* 196551 */   GIM_Reject,
     /* 196552 */ // Label 4380: @196552
     /* 196552 */ GIM_Reject,
     /* 196553 */ // Label 4368: @196553
     /* 196553 */ GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(196743),
     /* 196558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 196561 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(196617), // Rule ID 2995 //
     /* 196566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 196569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196601 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 196601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDrm),
     /* 196604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 196610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196615 */     GIR_RootConstrainSelectedInstOperands,
     /* 196616 */     // GIR_Coverage, 2995,
     /* 196616 */     GIR_EraseRootFromParent_Done,
     /* 196617 */   // Label 4385: @196617
     /* 196617 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(196673), // Rule ID 13294 //
     /* 196622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196637 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196640 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196644 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196657 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 196657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rm),
     /* 196660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196671 */     GIR_RootConstrainSelectedInstOperands,
     /* 196672 */     // GIR_Coverage, 13294,
     /* 196672 */     GIR_EraseRootFromParent_Done,
     /* 196673 */   // Label 4386: @196673
     /* 196673 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(196696), // Rule ID 2994 //
     /* 196678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 196681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196689 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 196689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 196694 */     GIR_RootConstrainSelectedInstOperands,
     /* 196695 */     // GIR_Coverage, 2994,
     /* 196695 */     GIR_Done,
     /* 196696 */   // Label 4387: @196696
     /* 196696 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(196719), // Rule ID 3006 //
     /* 196701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 196704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196712 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 196712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 196717 */     GIR_RootConstrainSelectedInstOperands,
     /* 196718 */     // GIR_Coverage, 3006,
     /* 196718 */     GIR_Done,
     /* 196719 */   // Label 4388: @196719
     /* 196719 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(196742), // Rule ID 13291 //
     /* 196724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196735 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 196735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 196740 */     GIR_RootConstrainSelectedInstOperands,
     /* 196741 */     // GIR_Coverage, 13291,
     /* 196741 */     GIR_Done,
     /* 196742 */   // Label 4389: @196742
     /* 196742 */   GIM_Reject,
     /* 196743 */ // Label 4384: @196743
     /* 196743 */ GIM_Reject,
     /* 196744 */ // Label 4369: @196744
     /* 196744 */ GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(196931),
     /* 196749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 196752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196756 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(196808), // Rule ID 13258 //
     /* 196761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196792 */     // (abs:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 196792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rm),
     /* 196795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196806 */     GIR_RootConstrainSelectedInstOperands,
     /* 196807 */     // GIR_Coverage, 13258,
     /* 196807 */     GIR_EraseRootFromParent_Done,
     /* 196808 */   // Label 4391: @196808
     /* 196808 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(196827), // Rule ID 13255 //
     /* 196813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196820 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 196820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 196825 */     GIR_RootConstrainSelectedInstOperands,
     /* 196826 */     // GIR_Coverage, 13255,
     /* 196826 */     GIR_Done,
     /* 196827 */   // Label 4392: @196827
     /* 196827 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(196930), // Rule ID 21823 //
     /* 196832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 196835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196839 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 196839 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 196842 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196846 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 196853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 196856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196865 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 196868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 196872 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 196875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 196880 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196885 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 196893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 196897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 196905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 196907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 196919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196929 */     // GIR_Coverage, 21823,
     /* 196929 */     GIR_EraseRootFromParent_Done,
     /* 196930 */   // Label 4393: @196930
     /* 196930 */   GIM_Reject,
     /* 196931 */ // Label 4390: @196931
     /* 196931 */ GIM_Reject,
     /* 196932 */ // Label 4370: @196932
     /* 196932 */ GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(197122),
     /* 196937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196940 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(196996), // Rule ID 2993 //
     /* 196945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 196948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196980 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 196980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWrm),
     /* 196983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 196989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196994 */     GIR_RootConstrainSelectedInstOperands,
     /* 196995 */     // GIR_Coverage, 2993,
     /* 196995 */     GIR_EraseRootFromParent_Done,
     /* 196996 */   // Label 4395: @196996
     /* 196996 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(197052), // Rule ID 13315 //
     /* 197001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197036 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 197036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rm),
     /* 197039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197050 */     GIR_RootConstrainSelectedInstOperands,
     /* 197051 */     // GIR_Coverage, 13315,
     /* 197051 */     GIR_EraseRootFromParent_Done,
     /* 197052 */   // Label 4396: @197052
     /* 197052 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(197075), // Rule ID 2992 //
     /* 197057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197068 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 197068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 197073 */     GIR_RootConstrainSelectedInstOperands,
     /* 197074 */     // GIR_Coverage, 2992,
     /* 197074 */     GIR_Done,
     /* 197075 */   // Label 4397: @197075
     /* 197075 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(197098), // Rule ID 3004 //
     /* 197080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 197083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197091 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 197091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 197096 */     GIR_RootConstrainSelectedInstOperands,
     /* 197097 */     // GIR_Coverage, 3004,
     /* 197097 */     GIR_Done,
     /* 197098 */   // Label 4398: @197098
     /* 197098 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(197121), // Rule ID 13312 //
     /* 197103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197114 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 197114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 197119 */     GIR_RootConstrainSelectedInstOperands,
     /* 197120 */     // GIR_Coverage, 13312,
     /* 197120 */     GIR_Done,
     /* 197121 */   // Label 4399: @197121
     /* 197121 */   GIM_Reject,
     /* 197122 */ // Label 4394: @197122
     /* 197122 */ GIM_Reject,
     /* 197123 */ // Label 4371: @197123
     /* 197123 */ GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(197290),
     /* 197128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 197131 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(197187), // Rule ID 3001 //
     /* 197136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 197139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197171 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 197171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDYrm),
     /* 197174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197185 */     GIR_RootConstrainSelectedInstOperands,
     /* 197186 */     // GIR_Coverage, 3001,
     /* 197186 */     GIR_EraseRootFromParent_Done,
     /* 197187 */   // Label 4401: @197187
     /* 197187 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(197243), // Rule ID 13285 //
     /* 197192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197207 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197214 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197227 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 197227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rm),
     /* 197230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197241 */     GIR_RootConstrainSelectedInstOperands,
     /* 197242 */     // GIR_Coverage, 13285,
     /* 197242 */     GIR_EraseRootFromParent_Done,
     /* 197243 */   // Label 4402: @197243
     /* 197243 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(197266), // Rule ID 3000 //
     /* 197248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 197251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197259 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 197259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 197264 */     GIR_RootConstrainSelectedInstOperands,
     /* 197265 */     // GIR_Coverage, 3000,
     /* 197265 */     GIR_Done,
     /* 197266 */   // Label 4403: @197266
     /* 197266 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(197289), // Rule ID 13282 //
     /* 197271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197282 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 197282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 197287 */     GIR_RootConstrainSelectedInstOperands,
     /* 197288 */     // GIR_Coverage, 13282,
     /* 197288 */     GIR_Done,
     /* 197289 */   // Label 4404: @197289
     /* 197289 */   GIM_Reject,
     /* 197290 */ // Label 4400: @197290
     /* 197290 */ GIM_Reject,
     /* 197291 */ // Label 4372: @197291
     /* 197291 */ GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(197375),
     /* 197296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 197299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197303 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(197355), // Rule ID 13249 //
     /* 197308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197319 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197326 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197339 */     // (abs:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 197339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZrm),
     /* 197342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197353 */     GIR_RootConstrainSelectedInstOperands,
     /* 197354 */     // GIR_Coverage, 13249,
     /* 197354 */     GIR_EraseRootFromParent_Done,
     /* 197355 */   // Label 4406: @197355
     /* 197355 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(197374), // Rule ID 13246 //
     /* 197360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197367 */     // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 197367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 197372 */     GIR_RootConstrainSelectedInstOperands,
     /* 197373 */     // GIR_Coverage, 13246,
     /* 197373 */     GIR_Done,
     /* 197374 */   // Label 4407: @197374
     /* 197374 */   GIM_Reject,
     /* 197375 */ // Label 4405: @197375
     /* 197375 */ GIM_Reject,
     /* 197376 */ // Label 4373: @197376
     /* 197376 */ GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(197566),
     /* 197381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 197384 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(197440), // Rule ID 2991 //
     /* 197389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197424 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 197424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBrm),
     /* 197427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197438 */     GIR_RootConstrainSelectedInstOperands,
     /* 197439 */     // GIR_Coverage, 2991,
     /* 197439 */     GIR_EraseRootFromParent_Done,
     /* 197440 */   // Label 4409: @197440
     /* 197440 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(197496), // Rule ID 13333 //
     /* 197445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197480 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 197480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rm),
     /* 197483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197494 */     GIR_RootConstrainSelectedInstOperands,
     /* 197495 */     // GIR_Coverage, 13333,
     /* 197495 */     GIR_EraseRootFromParent_Done,
     /* 197496 */   // Label 4410: @197496
     /* 197496 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(197519), // Rule ID 2990 //
     /* 197501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197512 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 197512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 197517 */     GIR_RootConstrainSelectedInstOperands,
     /* 197518 */     // GIR_Coverage, 2990,
     /* 197518 */     GIR_Done,
     /* 197519 */   // Label 4411: @197519
     /* 197519 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(197542), // Rule ID 3002 //
     /* 197524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 197527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197535 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 197535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 197540 */     GIR_RootConstrainSelectedInstOperands,
     /* 197541 */     // GIR_Coverage, 3002,
     /* 197541 */     GIR_Done,
     /* 197542 */   // Label 4412: @197542
     /* 197542 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(197565), // Rule ID 13330 //
     /* 197547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197558 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 197558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 197563 */     GIR_RootConstrainSelectedInstOperands,
     /* 197564 */     // GIR_Coverage, 13330,
     /* 197564 */     GIR_Done,
     /* 197565 */   // Label 4413: @197565
     /* 197565 */   GIM_Reject,
     /* 197566 */ // Label 4408: @197566
     /* 197566 */ GIM_Reject,
     /* 197567 */ // Label 4374: @197567
     /* 197567 */ GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(197734),
     /* 197572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197575 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(197631), // Rule ID 2999 //
     /* 197580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197595 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197602 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197615 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 197615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWYrm),
     /* 197618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197629 */     GIR_RootConstrainSelectedInstOperands,
     /* 197630 */     // GIR_Coverage, 2999,
     /* 197630 */     GIR_EraseRootFromParent_Done,
     /* 197631 */   // Label 4415: @197631
     /* 197631 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(197687), // Rule ID 13309 //
     /* 197636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197671 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 197671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rm),
     /* 197674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197685 */     GIR_RootConstrainSelectedInstOperands,
     /* 197686 */     // GIR_Coverage, 13309,
     /* 197686 */     GIR_EraseRootFromParent_Done,
     /* 197687 */   // Label 4416: @197687
     /* 197687 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(197710), // Rule ID 2998 //
     /* 197692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197703 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 197703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 197708 */     GIR_RootConstrainSelectedInstOperands,
     /* 197709 */     // GIR_Coverage, 2998,
     /* 197709 */     GIR_Done,
     /* 197710 */   // Label 4417: @197710
     /* 197710 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(197733), // Rule ID 13306 //
     /* 197715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197726 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 197726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 197731 */     GIR_RootConstrainSelectedInstOperands,
     /* 197732 */     // GIR_Coverage, 13306,
     /* 197732 */     GIR_Done,
     /* 197733 */   // Label 4418: @197733
     /* 197733 */   GIM_Reject,
     /* 197734 */ // Label 4414: @197734
     /* 197734 */ GIM_Reject,
     /* 197735 */ // Label 4375: @197735
     /* 197735 */ GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(197819),
     /* 197740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 197743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197747 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(197799), // Rule ID 13276 //
     /* 197752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197763 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197770 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197783 */     // (abs:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 197783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZrm),
     /* 197786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197797 */     GIR_RootConstrainSelectedInstOperands,
     /* 197798 */     // GIR_Coverage, 13276,
     /* 197798 */     GIR_EraseRootFromParent_Done,
     /* 197799 */   // Label 4420: @197799
     /* 197799 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(197818), // Rule ID 13273 //
     /* 197804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197811 */     // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 197811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 197816 */     GIR_RootConstrainSelectedInstOperands,
     /* 197817 */     // GIR_Coverage, 13273,
     /* 197817 */     GIR_Done,
     /* 197818 */   // Label 4421: @197818
     /* 197818 */   GIM_Reject,
     /* 197819 */ // Label 4419: @197819
     /* 197819 */ GIM_Reject,
     /* 197820 */ // Label 4376: @197820
     /* 197820 */ GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(197987),
     /* 197825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 197828 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(197884), // Rule ID 2997 //
     /* 197833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197868 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 197868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBYrm),
     /* 197871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197882 */     GIR_RootConstrainSelectedInstOperands,
     /* 197883 */     // GIR_Coverage, 2997,
     /* 197883 */     GIR_EraseRootFromParent_Done,
     /* 197884 */   // Label 4423: @197884
     /* 197884 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(197940), // Rule ID 13327 //
     /* 197889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197924 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 197924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rm),
     /* 197927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197938 */     GIR_RootConstrainSelectedInstOperands,
     /* 197939 */     // GIR_Coverage, 13327,
     /* 197939 */     GIR_EraseRootFromParent_Done,
     /* 197940 */   // Label 4424: @197940
     /* 197940 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(197963), // Rule ID 2996 //
     /* 197945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197956 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 197956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 197961 */     GIR_RootConstrainSelectedInstOperands,
     /* 197962 */     // GIR_Coverage, 2996,
     /* 197962 */     GIR_Done,
     /* 197963 */   // Label 4425: @197963
     /* 197963 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(197986), // Rule ID 13324 //
     /* 197968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197979 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 197979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 197984 */     GIR_RootConstrainSelectedInstOperands,
     /* 197985 */     // GIR_Coverage, 13324,
     /* 197985 */     GIR_Done,
     /* 197986 */   // Label 4426: @197986
     /* 197986 */   GIM_Reject,
     /* 197987 */ // Label 4422: @197987
     /* 197987 */ GIM_Reject,
     /* 197988 */ // Label 4377: @197988
     /* 197988 */ GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(198072),
     /* 197993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198000 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(198052), // Rule ID 13303 //
     /* 198005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 198012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 198016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 198019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 198023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 198027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 198036 */     // (abs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 198036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZrm),
     /* 198039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 198045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 198050 */     GIR_RootConstrainSelectedInstOperands,
     /* 198051 */     // GIR_Coverage, 13303,
     /* 198051 */     GIR_EraseRootFromParent_Done,
     /* 198052 */   // Label 4428: @198052
     /* 198052 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(198071), // Rule ID 13300 //
     /* 198057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198064 */     // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 198064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 198069 */     GIR_RootConstrainSelectedInstOperands,
     /* 198070 */     // GIR_Coverage, 13300,
     /* 198070 */     GIR_Done,
     /* 198071 */   // Label 4429: @198071
     /* 198071 */   GIM_Reject,
     /* 198072 */ // Label 4427: @198072
     /* 198072 */ GIM_Reject,
     /* 198073 */ // Label 4378: @198073
     /* 198073 */ GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(198157),
     /* 198078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 198081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198085 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(198137), // Rule ID 13321 //
     /* 198090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 198097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 198101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 198104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 198108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 198112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 198121 */     // (abs:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 198121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZrm),
     /* 198124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 198130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 198135 */     GIR_RootConstrainSelectedInstOperands,
     /* 198136 */     // GIR_Coverage, 13321,
     /* 198136 */     GIR_EraseRootFromParent_Done,
     /* 198137 */   // Label 4431: @198137
     /* 198137 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(198156), // Rule ID 13318 //
     /* 198142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198149 */     // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 198149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 198154 */     GIR_RootConstrainSelectedInstOperands,
     /* 198155 */     // GIR_Coverage, 13318,
     /* 198155 */     GIR_Done,
     /* 198156 */   // Label 4432: @198156
     /* 198156 */   GIM_Reject,
     /* 198157 */ // Label 4430: @198157
     /* 198157 */ GIM_Reject,
     /* 198158 */ // Label 4379: @198158
     /* 198158 */ GIM_Reject,
     /* 198159 */ // Label 59: @198159
     /* 198159 */ GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(198174), // Rule ID 630 //
     /* 198164 */   // MIs[0] dst
     /* 198164 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 198167 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 198167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 198172 */   GIR_RootConstrainSelectedInstOperands,
     /* 198173 */   // GIR_Coverage, 630,
     /* 198173 */   GIR_Done,
     /* 198174 */ // Label 4433: @198174
     /* 198174 */ GIM_Reject,
     /* 198175 */ // Label 60: @198175
     /* 198175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 4448*/ GIMT_Encode4(201103),
     /* 198186 */ /*GILLT_s1*//*Label 4434*/ GIMT_Encode4(198274), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 198214 */ /*GILLT_v2s1*//*Label 4435*/ GIMT_Encode4(198515),
     /* 198218 */ /*GILLT_v2s64*//*Label 4436*/ GIMT_Encode4(198716),
     /* 198222 */ /*GILLT_v4s1*//*Label 4437*/ GIMT_Encode4(199197),
     /* 198226 */ /*GILLT_v4s32*//*Label 4438*/ GIMT_Encode4(199358),
     /* 198230 */ /*GILLT_v4s64*//*Label 4439*/ GIMT_Encode4(199839),
     /* 198234 */ /*GILLT_v8s1*//*Label 4440*/ GIMT_Encode4(199922),
     /* 198238 */ /*GILLT_v8s16*//*Label 4441*/ GIMT_Encode4(200043),
     /* 198242 */ /*GILLT_v8s32*//*Label 4442*/ GIMT_Encode4(200524), GIMT_Encode4(0),
     /* 198250 */ /*GILLT_v16s1*//*Label 4443*/ GIMT_Encode4(200607),
     /* 198254 */ /*GILLT_v16s8*//*Label 4444*/ GIMT_Encode4(200688),
     /* 198258 */ /*GILLT_v16s16*//*Label 4445*/ GIMT_Encode4(200929), GIMT_Encode4(0),
     /* 198266 */ /*GILLT_v32s1*//*Label 4446*/ GIMT_Encode4(201012),
     /* 198270 */ /*GILLT_v32s8*//*Label 4447*/ GIMT_Encode4(201053),
     /* 198274 */ // Label 4434: @198274
     /* 198274 */ GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(198314), // Rule ID 19602 //
     /* 198279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 198282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198290 */   // MIs[0] Operand 2
     /* 198290 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198301 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 198301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198313 */   // GIR_Coverage, 19602,
     /* 198313 */   GIR_EraseRootFromParent_Done,
     /* 198314 */ // Label 4449: @198314
     /* 198314 */ GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(198354), // Rule ID 19604 //
     /* 198319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 198322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 198330 */   // MIs[0] Operand 2
     /* 198330 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198341 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 198341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198346 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198353 */   // GIR_Coverage, 19604,
     /* 198353 */   GIR_EraseRootFromParent_Done,
     /* 198354 */ // Label 4450: @198354
     /* 198354 */ GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(198394), // Rule ID 19606 //
     /* 198359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 198362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 198370 */   // MIs[0] Operand 2
     /* 198370 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198381 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 198381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198393 */   // GIR_Coverage, 19606,
     /* 198393 */   GIR_EraseRootFromParent_Done,
     /* 198394 */ // Label 4451: @198394
     /* 198394 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(198434), // Rule ID 19608 //
     /* 198399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 198402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 198410 */   // MIs[0] Operand 2
     /* 198410 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198421 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 198421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198433 */   // GIR_Coverage, 19608,
     /* 198433 */   GIR_EraseRootFromParent_Done,
     /* 198434 */ // Label 4452: @198434
     /* 198434 */ GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(198474), // Rule ID 19610 //
     /* 198439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 198442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 198450 */   // MIs[0] Operand 2
     /* 198450 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198461 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 198461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198466 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198473 */   // GIR_Coverage, 19610,
     /* 198473 */   GIR_EraseRootFromParent_Done,
     /* 198474 */ // Label 4453: @198474
     /* 198474 */ GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(198514), // Rule ID 19612 //
     /* 198479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 198482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 198490 */   // MIs[0] Operand 2
     /* 198490 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198501 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 198501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198506 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198513 */   // GIR_Coverage, 19612,
     /* 198513 */   GIR_EraseRootFromParent_Done,
     /* 198514 */ // Label 4454: @198514
     /* 198514 */ GIM_Reject,
     /* 198515 */ // Label 4435: @198515
     /* 198515 */ GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(198555), // Rule ID 19614 //
     /* 198520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 198523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 198531 */   // MIs[0] Operand 2
     /* 198531 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198542 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 198542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198554 */   // GIR_Coverage, 19614,
     /* 198554 */   GIR_EraseRootFromParent_Done,
     /* 198555 */ // Label 4455: @198555
     /* 198555 */ GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(198595), // Rule ID 19616 //
     /* 198560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 198563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 198571 */   // MIs[0] Operand 2
     /* 198571 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198582 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 198582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198594 */   // GIR_Coverage, 19616,
     /* 198594 */   GIR_EraseRootFromParent_Done,
     /* 198595 */ // Label 4456: @198595
     /* 198595 */ GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(198635), // Rule ID 19618 //
     /* 198600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 198603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 198611 */   // MIs[0] Operand 2
     /* 198611 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198622 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 198622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198627 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198634 */   // GIR_Coverage, 19618,
     /* 198634 */   GIR_EraseRootFromParent_Done,
     /* 198635 */ // Label 4457: @198635
     /* 198635 */ GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(198675), // Rule ID 19620 //
     /* 198640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 198643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 198651 */   // MIs[0] Operand 2
     /* 198651 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198662 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 198662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198674 */   // GIR_Coverage, 19620,
     /* 198674 */   GIR_EraseRootFromParent_Done,
     /* 198675 */ // Label 4458: @198675
     /* 198675 */ GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(198715), // Rule ID 19622 //
     /* 198680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 198683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 198691 */   // MIs[0] Operand 2
     /* 198691 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198702 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 198702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198714 */   // GIR_Coverage, 19622,
     /* 198714 */   GIR_EraseRootFromParent_Done,
     /* 198715 */ // Label 4459: @198715
     /* 198715 */ GIM_Reject,
     /* 198716 */ // Label 4436: @198716
     /* 198716 */ GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(198787), // Rule ID 19053 //
     /* 198721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 198724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 198731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198735 */   // MIs[0] Operand 2
     /* 198735 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198746 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198758 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198769 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 198777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198785 */   GIR_RootConstrainSelectedInstOperands,
     /* 198786 */   // GIR_Coverage, 19053,
     /* 198786 */   GIR_EraseRootFromParent_Done,
     /* 198787 */ // Label 4460: @198787
     /* 198787 */ GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(198858), // Rule ID 19054 //
     /* 198792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 198795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 198802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198806 */   // MIs[0] Operand 2
     /* 198806 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198817 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198829 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 198848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198856 */   GIR_RootConstrainSelectedInstOperands,
     /* 198857 */   // GIR_Coverage, 19054,
     /* 198857 */   GIR_EraseRootFromParent_Done,
     /* 198858 */ // Label 4461: @198858
     /* 198858 */ GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(198929), // Rule ID 19060 //
     /* 198863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 198866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198877 */   // MIs[0] Operand 2
     /* 198877 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198888 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198900 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198911 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 198919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198927 */   GIR_RootConstrainSelectedInstOperands,
     /* 198928 */   // GIR_Coverage, 19060,
     /* 198928 */   GIR_EraseRootFromParent_Done,
     /* 198929 */ // Label 4462: @198929
     /* 198929 */ GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(199000), // Rule ID 19061 //
     /* 198934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 198937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198948 */   // MIs[0] Operand 2
     /* 198948 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198959 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198971 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 198990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198998 */   GIR_RootConstrainSelectedInstOperands,
     /* 198999 */   // GIR_Coverage, 19061,
     /* 198999 */   GIR_EraseRootFromParent_Done,
     /* 199000 */ // Label 4463: @199000
     /* 199000 */ GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(199049), // Rule ID 23007 //
     /* 199005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 199008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199016 */   // MIs[0] Operand 2
     /* 199016 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199027 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 199027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199032 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199048 */   // GIR_Coverage, 23007,
     /* 199048 */   GIR_EraseRootFromParent_Done,
     /* 199049 */ // Label 4464: @199049
     /* 199049 */ GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(199098), // Rule ID 23010 //
     /* 199054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 199057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199065 */   // MIs[0] Operand 2
     /* 199065 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199076 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 199076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199081 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199097 */   // GIR_Coverage, 23010,
     /* 199097 */   GIR_EraseRootFromParent_Done,
     /* 199098 */ // Label 4465: @199098
     /* 199098 */ GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(199147), // Rule ID 23028 //
     /* 199103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199114 */   // MIs[0] Operand 2
     /* 199114 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199125 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 199125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199130 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199146 */   // GIR_Coverage, 23028,
     /* 199146 */   GIR_EraseRootFromParent_Done,
     /* 199147 */ // Label 4466: @199147
     /* 199147 */ GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(199196), // Rule ID 23031 //
     /* 199152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199163 */   // MIs[0] Operand 2
     /* 199163 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199174 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 199174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199179 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199185 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199195 */   // GIR_Coverage, 23031,
     /* 199195 */   GIR_EraseRootFromParent_Done,
     /* 199196 */ // Label 4467: @199196
     /* 199196 */ GIM_Reject,
     /* 199197 */ // Label 4437: @199197
     /* 199197 */ GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(199237), // Rule ID 19624 //
     /* 199202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 199205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199213 */   // MIs[0] Operand 2
     /* 199213 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199224 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 199224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199236 */   // GIR_Coverage, 19624,
     /* 199236 */   GIR_EraseRootFromParent_Done,
     /* 199237 */ // Label 4468: @199237
     /* 199237 */ GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(199277), // Rule ID 19626 //
     /* 199242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 199245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 199253 */   // MIs[0] Operand 2
     /* 199253 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199264 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 199264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199276 */   // GIR_Coverage, 19626,
     /* 199276 */   GIR_EraseRootFromParent_Done,
     /* 199277 */ // Label 4469: @199277
     /* 199277 */ GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(199317), // Rule ID 19628 //
     /* 199282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 199285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 199293 */   // MIs[0] Operand 2
     /* 199293 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199304 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 199304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199309 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199311 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199316 */   // GIR_Coverage, 19628,
     /* 199316 */   GIR_EraseRootFromParent_Done,
     /* 199317 */ // Label 4470: @199317
     /* 199317 */ GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(199357), // Rule ID 19630 //
     /* 199322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 199325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 199333 */   // MIs[0] Operand 2
     /* 199333 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199344 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 199344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199349 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199356 */   // GIR_Coverage, 19630,
     /* 199356 */   GIR_EraseRootFromParent_Done,
     /* 199357 */ // Label 4471: @199357
     /* 199357 */ GIM_Reject,
     /* 199358 */ // Label 4438: @199358
     /* 199358 */ GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(199429), // Rule ID 19055 //
     /* 199363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 199366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 199373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199377 */   // MIs[0] Operand 2
     /* 199377 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199388 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199400 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199411 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 199419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199427 */   GIR_RootConstrainSelectedInstOperands,
     /* 199428 */   // GIR_Coverage, 19055,
     /* 199428 */   GIR_EraseRootFromParent_Done,
     /* 199429 */ // Label 4472: @199429
     /* 199429 */ GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(199500), // Rule ID 19056 //
     /* 199434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 199437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 199444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199448 */   // MIs[0] Operand 2
     /* 199448 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199459 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199471 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199482 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 199490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199498 */   GIR_RootConstrainSelectedInstOperands,
     /* 199499 */   // GIR_Coverage, 19056,
     /* 199499 */   GIR_EraseRootFromParent_Done,
     /* 199500 */ // Label 4473: @199500
     /* 199500 */ GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(199571), // Rule ID 19062 //
     /* 199505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 199508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199519 */   // MIs[0] Operand 2
     /* 199519 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199530 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199542 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 199561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199569 */   GIR_RootConstrainSelectedInstOperands,
     /* 199570 */   // GIR_Coverage, 19062,
     /* 199570 */   GIR_EraseRootFromParent_Done,
     /* 199571 */ // Label 4474: @199571
     /* 199571 */ GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(199642), // Rule ID 19063 //
     /* 199576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 199579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199590 */   // MIs[0] Operand 2
     /* 199590 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199601 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199613 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199619 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199624 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 199632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199640 */   GIR_RootConstrainSelectedInstOperands,
     /* 199641 */   // GIR_Coverage, 19063,
     /* 199641 */   GIR_EraseRootFromParent_Done,
     /* 199642 */ // Label 4475: @199642
     /* 199642 */ GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(199691), // Rule ID 23001 //
     /* 199647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 199650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199658 */   // MIs[0] Operand 2
     /* 199658 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199669 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 199669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199674 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199690 */   // GIR_Coverage, 23001,
     /* 199690 */   GIR_EraseRootFromParent_Done,
     /* 199691 */ // Label 4476: @199691
     /* 199691 */ GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(199740), // Rule ID 23004 //
     /* 199696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 199699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199707 */   // MIs[0] Operand 2
     /* 199707 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199718 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 199718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199723 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199739 */   // GIR_Coverage, 23004,
     /* 199739 */   GIR_EraseRootFromParent_Done,
     /* 199740 */ // Label 4477: @199740
     /* 199740 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(199789), // Rule ID 23022 //
     /* 199745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199756 */   // MIs[0] Operand 2
     /* 199756 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199767 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 199767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199772 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199788 */   // GIR_Coverage, 23022,
     /* 199788 */   GIR_EraseRootFromParent_Done,
     /* 199789 */ // Label 4478: @199789
     /* 199789 */ GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(199838), // Rule ID 23025 //
     /* 199794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199805 */   // MIs[0] Operand 2
     /* 199805 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199816 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 199816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199821 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199837 */   // GIR_Coverage, 23025,
     /* 199837 */   GIR_EraseRootFromParent_Done,
     /* 199838 */ // Label 4479: @199838
     /* 199838 */ GIM_Reject,
     /* 199839 */ // Label 4439: @199839
     /* 199839 */ GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(199921),
     /* 199844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199855 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199866 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(199893), // Rule ID 23049 //
     /* 199871 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 199871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199876 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199892 */     // GIR_Coverage, 23049,
     /* 199892 */     GIR_EraseRootFromParent_Done,
     /* 199893 */   // Label 4481: @199893
     /* 199893 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(199920), // Rule ID 23052 //
     /* 199898 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 199898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199903 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199919 */     // GIR_Coverage, 23052,
     /* 199919 */     GIR_EraseRootFromParent_Done,
     /* 199920 */   // Label 4482: @199920
     /* 199920 */   GIM_Reject,
     /* 199921 */ // Label 4480: @199921
     /* 199921 */ GIM_Reject,
     /* 199922 */ // Label 4440: @199922
     /* 199922 */ GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(199962), // Rule ID 19632 //
     /* 199927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 199930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 199938 */   // MIs[0] Operand 2
     /* 199938 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199949 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 199949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199954 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199956 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 199961 */   // GIR_Coverage, 19632,
     /* 199961 */   GIR_EraseRootFromParent_Done,
     /* 199962 */ // Label 4483: @199962
     /* 199962 */ GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(200002), // Rule ID 19634 //
     /* 199967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 199970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 199978 */   // MIs[0] Operand 2
     /* 199978 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199989 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 199989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199994 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199996 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 200001 */   // GIR_Coverage, 19634,
     /* 200001 */   GIR_EraseRootFromParent_Done,
     /* 200002 */ // Label 4484: @200002
     /* 200002 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(200042), // Rule ID 19636 //
     /* 200007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 200010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 200014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 200018 */   // MIs[0] Operand 2
     /* 200018 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200029 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 200029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200034 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 200041 */   // GIR_Coverage, 19636,
     /* 200041 */   GIR_EraseRootFromParent_Done,
     /* 200042 */ // Label 4485: @200042
     /* 200042 */ GIM_Reject,
     /* 200043 */ // Label 4441: @200043
     /* 200043 */ GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(200114), // Rule ID 19057 //
     /* 200048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200062 */   // MIs[0] Operand 2
     /* 200062 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200073 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200085 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200091 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 200104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200112 */   GIR_RootConstrainSelectedInstOperands,
     /* 200113 */   // GIR_Coverage, 19057,
     /* 200113 */   GIR_EraseRootFromParent_Done,
     /* 200114 */ // Label 4486: @200114
     /* 200114 */ GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(200185), // Rule ID 19058 //
     /* 200119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200133 */   // MIs[0] Operand 2
     /* 200133 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200144 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200156 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200167 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 200175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200183 */   GIR_RootConstrainSelectedInstOperands,
     /* 200184 */   // GIR_Coverage, 19058,
     /* 200184 */   GIR_EraseRootFromParent_Done,
     /* 200185 */ // Label 4487: @200185
     /* 200185 */ GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(200256), // Rule ID 19064 //
     /* 200190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200204 */   // MIs[0] Operand 2
     /* 200204 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200215 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200227 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 200246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200254 */   GIR_RootConstrainSelectedInstOperands,
     /* 200255 */   // GIR_Coverage, 19064,
     /* 200255 */   GIR_EraseRootFromParent_Done,
     /* 200256 */ // Label 4488: @200256
     /* 200256 */ GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(200327), // Rule ID 19065 //
     /* 200261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200275 */   // MIs[0] Operand 2
     /* 200275 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200286 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200298 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200304 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 200317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200325 */   GIR_RootConstrainSelectedInstOperands,
     /* 200326 */   // GIR_Coverage, 19065,
     /* 200326 */   GIR_EraseRootFromParent_Done,
     /* 200327 */ // Label 4489: @200327
     /* 200327 */ GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(200376), // Rule ID 23013 //
     /* 200332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 200335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200343 */   // MIs[0] Operand 2
     /* 200343 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200354 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 200354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200359 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200375 */   // GIR_Coverage, 23013,
     /* 200375 */   GIR_EraseRootFromParent_Done,
     /* 200376 */ // Label 4490: @200376
     /* 200376 */ GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(200425), // Rule ID 23019 //
     /* 200381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 200384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200392 */   // MIs[0] Operand 2
     /* 200392 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200403 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 200403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200408 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200424 */   // GIR_Coverage, 23019,
     /* 200424 */   GIR_EraseRootFromParent_Done,
     /* 200425 */ // Label 4491: @200425
     /* 200425 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(200474), // Rule ID 23034 //
     /* 200430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200441 */   // MIs[0] Operand 2
     /* 200441 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200452 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 200452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200457 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200473 */   // GIR_Coverage, 23034,
     /* 200473 */   GIR_EraseRootFromParent_Done,
     /* 200474 */ // Label 4492: @200474
     /* 200474 */ GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(200523), // Rule ID 23040 //
     /* 200479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200490 */   // MIs[0] Operand 2
     /* 200490 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200501 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 200501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200506 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200522 */   // GIR_Coverage, 23040,
     /* 200522 */   GIR_EraseRootFromParent_Done,
     /* 200523 */ // Label 4493: @200523
     /* 200523 */ GIM_Reject,
     /* 200524 */ // Label 4442: @200524
     /* 200524 */ GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(200606),
     /* 200529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 200532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200540 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200551 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(200578), // Rule ID 23043 //
     /* 200556 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 200556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200561 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200577 */     // GIR_Coverage, 23043,
     /* 200577 */     GIR_EraseRootFromParent_Done,
     /* 200578 */   // Label 4495: @200578
     /* 200578 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(200605), // Rule ID 23046 //
     /* 200583 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 200583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200588 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200604 */     // GIR_Coverage, 23046,
     /* 200604 */     GIR_EraseRootFromParent_Done,
     /* 200605 */   // Label 4496: @200605
     /* 200605 */   GIM_Reject,
     /* 200606 */ // Label 4494: @200606
     /* 200606 */ GIM_Reject,
     /* 200607 */ // Label 4443: @200607
     /* 200607 */ GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(200647), // Rule ID 19638 //
     /* 200612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 200615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 200619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 200623 */   // MIs[0] Operand 2
     /* 200623 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200634 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 200634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200639 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 200646 */   // GIR_Coverage, 19638,
     /* 200646 */   GIR_EraseRootFromParent_Done,
     /* 200647 */ // Label 4497: @200647
     /* 200647 */ GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(200687), // Rule ID 19640 //
     /* 200652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 200655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 200659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 200663 */   // MIs[0] Operand 2
     /* 200663 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200674 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 200674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 200686 */   // GIR_Coverage, 19640,
     /* 200686 */   GIR_EraseRootFromParent_Done,
     /* 200687 */ // Label 4498: @200687
     /* 200687 */ GIM_Reject,
     /* 200688 */ // Label 4444: @200688
     /* 200688 */ GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(200759), // Rule ID 19059 //
     /* 200693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200707 */   // MIs[0] Operand 2
     /* 200707 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 200718 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 200721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200730 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200736 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 200749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200757 */   GIR_RootConstrainSelectedInstOperands,
     /* 200758 */   // GIR_Coverage, 19059,
     /* 200758 */   GIR_EraseRootFromParent_Done,
     /* 200759 */ // Label 4499: @200759
     /* 200759 */ GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(200830), // Rule ID 19066 //
     /* 200764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200778 */   // MIs[0] Operand 2
     /* 200778 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 200789 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 200792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200801 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 200820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200828 */   GIR_RootConstrainSelectedInstOperands,
     /* 200829 */   // GIR_Coverage, 19066,
     /* 200829 */   GIR_EraseRootFromParent_Done,
     /* 200830 */ // Label 4500: @200830
     /* 200830 */ GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(200879), // Rule ID 23016 //
     /* 200835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 200838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200846 */   // MIs[0] Operand 2
     /* 200846 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200857 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 200857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200862 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200878 */   // GIR_Coverage, 23016,
     /* 200878 */   GIR_EraseRootFromParent_Done,
     /* 200879 */ // Label 4501: @200879
     /* 200879 */ GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(200928), // Rule ID 23037 //
     /* 200884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200895 */   // MIs[0] Operand 2
     /* 200895 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200906 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 200906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200911 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200922 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200927 */   // GIR_Coverage, 23037,
     /* 200927 */   GIR_EraseRootFromParent_Done,
     /* 200928 */ // Label 4502: @200928
     /* 200928 */ GIM_Reject,
     /* 200929 */ // Label 4445: @200929
     /* 200929 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(201011),
     /* 200934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200945 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200956 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(200983), // Rule ID 23055 //
     /* 200961 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 200961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200966 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200982 */     // GIR_Coverage, 23055,
     /* 200982 */     GIR_EraseRootFromParent_Done,
     /* 200983 */   // Label 4504: @200983
     /* 200983 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(201010), // Rule ID 23061 //
     /* 200988 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 200988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200993 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201009 */     // GIR_Coverage, 23061,
     /* 201009 */     GIR_EraseRootFromParent_Done,
     /* 201010 */   // Label 4505: @201010
     /* 201010 */   GIM_Reject,
     /* 201011 */ // Label 4503: @201011
     /* 201011 */ GIM_Reject,
     /* 201012 */ // Label 4446: @201012
     /* 201012 */ GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(201052), // Rule ID 19642 //
     /* 201017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 201020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 201024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 201028 */   // MIs[0] Operand 2
     /* 201028 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 201039 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 201039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 201051 */   // GIR_Coverage, 19642,
     /* 201051 */   GIR_EraseRootFromParent_Done,
     /* 201052 */ // Label 4506: @201052
     /* 201052 */ GIM_Reject,
     /* 201053 */ // Label 4447: @201053
     /* 201053 */ GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(201102), // Rule ID 23058 //
     /* 201058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 201061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201069 */   // MIs[0] Operand 2
     /* 201069 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 201080 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 201080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201085 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 201091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201101 */   // GIR_Coverage, 23058,
     /* 201101 */   GIR_EraseRootFromParent_Done,
     /* 201102 */ // Label 4507: @201102
     /* 201102 */ GIM_Reject,
     /* 201103 */ // Label 4448: @201103
     /* 201103 */ GIM_Reject,
     /* 201104 */ // Label 61: @201104
     /* 201104 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4520*/ GIMT_Encode4(203085),
     /* 201115 */ /*GILLT_v2s64*//*Label 4508*/ GIMT_Encode4(201183), GIMT_Encode4(0),
     /* 201123 */ /*GILLT_v4s32*//*Label 4509*/ GIMT_Encode4(201385),
     /* 201127 */ /*GILLT_v4s64*//*Label 4510*/ GIMT_Encode4(201587), GIMT_Encode4(0),
     /* 201135 */ /*GILLT_v8s16*//*Label 4511*/ GIMT_Encode4(201789),
     /* 201139 */ /*GILLT_v8s32*//*Label 4512*/ GIMT_Encode4(201904),
     /* 201143 */ /*GILLT_v8s64*//*Label 4513*/ GIMT_Encode4(202106), GIMT_Encode4(0),
     /* 201151 */ /*GILLT_v16s8*//*Label 4514*/ GIMT_Encode4(202308),
     /* 201155 */ /*GILLT_v16s16*//*Label 4515*/ GIMT_Encode4(202423),
     /* 201159 */ /*GILLT_v16s32*//*Label 4516*/ GIMT_Encode4(202538), GIMT_Encode4(0),
     /* 201167 */ /*GILLT_v32s8*//*Label 4517*/ GIMT_Encode4(202740),
     /* 201171 */ /*GILLT_v32s16*//*Label 4518*/ GIMT_Encode4(202855), GIMT_Encode4(0),
     /* 201179 */ /*GILLT_v64s8*//*Label 4519*/ GIMT_Encode4(202970),
     /* 201183 */ // Label 4508: @201183
     /* 201183 */ GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(201384),
     /* 201188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 201191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 201194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 201197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 201209 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(201242), // Rule ID 21696 //
     /* 201214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201221 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201227 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201231 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 201234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201236 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201240 */     GIR_RootConstrainSelectedInstOperands,
     /* 201241 */     // GIR_Coverage, 21696,
     /* 201241 */     GIR_EraseRootFromParent_Done,
     /* 201242 */   // Label 4522: @201242
     /* 201242 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(201275), // Rule ID 21732 //
     /* 201247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201254 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201260 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201264 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 201267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201269 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201273 */     GIR_RootConstrainSelectedInstOperands,
     /* 201274 */     // GIR_Coverage, 21732,
     /* 201274 */     GIR_EraseRootFromParent_Done,
     /* 201275 */   // Label 4523: @201275
     /* 201275 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(201304), // Rule ID 21695 //
     /* 201280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201293 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 201296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201298 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201302 */     GIR_RootConstrainSelectedInstOperands,
     /* 201303 */     // GIR_Coverage, 21695,
     /* 201303 */     GIR_EraseRootFromParent_Done,
     /* 201304 */   // Label 4524: @201304
     /* 201304 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(201333), // Rule ID 21731 //
     /* 201309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201322 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 201325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201327 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201331 */     GIR_RootConstrainSelectedInstOperands,
     /* 201332 */     // GIR_Coverage, 21731,
     /* 201332 */     GIR_EraseRootFromParent_Done,
     /* 201333 */   // Label 4525: @201333
     /* 201333 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(201358), // Rule ID 21697 //
     /* 201338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201345 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 201348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201350 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201352 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201354 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201356 */     GIR_RootConstrainSelectedInstOperands,
     /* 201357 */     // GIR_Coverage, 21697,
     /* 201357 */     GIR_EraseRootFromParent_Done,
     /* 201358 */   // Label 4526: @201358
     /* 201358 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(201383), // Rule ID 21733 //
     /* 201363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201370 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 201373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201375 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201377 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201381 */     GIR_RootConstrainSelectedInstOperands,
     /* 201382 */     // GIR_Coverage, 21733,
     /* 201382 */     GIR_EraseRootFromParent_Done,
     /* 201383 */   // Label 4527: @201383
     /* 201383 */   GIM_Reject,
     /* 201384 */ // Label 4521: @201384
     /* 201384 */ GIM_Reject,
     /* 201385 */ // Label 4509: @201385
     /* 201385 */ GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(201586),
     /* 201390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 201396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 201399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 201411 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(201444), // Rule ID 21678 //
     /* 201416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201433 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 201436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201438 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201442 */     GIR_RootConstrainSelectedInstOperands,
     /* 201443 */     // GIR_Coverage, 21678,
     /* 201443 */     GIR_EraseRootFromParent_Done,
     /* 201444 */   // Label 4529: @201444
     /* 201444 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(201477), // Rule ID 21714 //
     /* 201449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201456 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201462 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201466 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 201469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201471 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201475 */     GIR_RootConstrainSelectedInstOperands,
     /* 201476 */     // GIR_Coverage, 21714,
     /* 201476 */     GIR_EraseRootFromParent_Done,
     /* 201477 */   // Label 4530: @201477
     /* 201477 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(201506), // Rule ID 21677 //
     /* 201482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201495 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201500 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201504 */     GIR_RootConstrainSelectedInstOperands,
     /* 201505 */     // GIR_Coverage, 21677,
     /* 201505 */     GIR_EraseRootFromParent_Done,
     /* 201506 */   // Label 4531: @201506
     /* 201506 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(201535), // Rule ID 21713 //
     /* 201511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201524 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 201527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201529 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201533 */     GIR_RootConstrainSelectedInstOperands,
     /* 201534 */     // GIR_Coverage, 21713,
     /* 201534 */     GIR_EraseRootFromParent_Done,
     /* 201535 */   // Label 4532: @201535
     /* 201535 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(201560), // Rule ID 21679 //
     /* 201540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201547 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 201550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201552 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201554 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201558 */     GIR_RootConstrainSelectedInstOperands,
     /* 201559 */     // GIR_Coverage, 21679,
     /* 201559 */     GIR_EraseRootFromParent_Done,
     /* 201560 */   // Label 4533: @201560
     /* 201560 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(201585), // Rule ID 21715 //
     /* 201565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201572 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 201575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201577 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201579 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201583 */     GIR_RootConstrainSelectedInstOperands,
     /* 201584 */     // GIR_Coverage, 21715,
     /* 201584 */     GIR_EraseRootFromParent_Done,
     /* 201585 */   // Label 4534: @201585
     /* 201585 */   GIM_Reject,
     /* 201586 */ // Label 4528: @201586
     /* 201586 */ GIM_Reject,
     /* 201587 */ // Label 4510: @201587
     /* 201587 */ GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(201788),
     /* 201592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 201595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 201598 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 201601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 201613 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(201646), // Rule ID 21690 //
     /* 201618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201635 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 201638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201640 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201644 */     GIR_RootConstrainSelectedInstOperands,
     /* 201645 */     // GIR_Coverage, 21690,
     /* 201645 */     GIR_EraseRootFromParent_Done,
     /* 201646 */   // Label 4536: @201646
     /* 201646 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(201679), // Rule ID 21726 //
     /* 201651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201658 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201664 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201668 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 201671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201673 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201677 */     GIR_RootConstrainSelectedInstOperands,
     /* 201678 */     // GIR_Coverage, 21726,
     /* 201678 */     GIR_EraseRootFromParent_Done,
     /* 201679 */   // Label 4537: @201679
     /* 201679 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(201708), // Rule ID 21689 //
     /* 201684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201697 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 201700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201702 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201706 */     GIR_RootConstrainSelectedInstOperands,
     /* 201707 */     // GIR_Coverage, 21689,
     /* 201707 */     GIR_EraseRootFromParent_Done,
     /* 201708 */   // Label 4538: @201708
     /* 201708 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(201737), // Rule ID 21725 //
     /* 201713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201726 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 201729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201731 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201735 */     GIR_RootConstrainSelectedInstOperands,
     /* 201736 */     // GIR_Coverage, 21725,
     /* 201736 */     GIR_EraseRootFromParent_Done,
     /* 201737 */   // Label 4539: @201737
     /* 201737 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(201762), // Rule ID 21691 //
     /* 201742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201749 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 201752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201754 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201756 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201760 */     GIR_RootConstrainSelectedInstOperands,
     /* 201761 */     // GIR_Coverage, 21691,
     /* 201761 */     GIR_EraseRootFromParent_Done,
     /* 201762 */   // Label 4540: @201762
     /* 201762 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(201787), // Rule ID 21727 //
     /* 201767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201774 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 201777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201779 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201781 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201785 */     GIR_RootConstrainSelectedInstOperands,
     /* 201786 */     // GIR_Coverage, 21727,
     /* 201786 */     GIR_EraseRootFromParent_Done,
     /* 201787 */   // Label 4541: @201787
     /* 201787 */   GIM_Reject,
     /* 201788 */ // Label 4535: @201788
     /* 201788 */ GIM_Reject,
     /* 201789 */ // Label 4511: @201789
     /* 201789 */ GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(201903),
     /* 201794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 201800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 201815 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(201848), // Rule ID 22098 //
     /* 201820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201827 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201833 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201837 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 201840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201842 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201846 */     GIR_RootConstrainSelectedInstOperands,
     /* 201847 */     // GIR_Coverage, 22098,
     /* 201847 */     GIR_EraseRootFromParent_Done,
     /* 201848 */   // Label 4543: @201848
     /* 201848 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(201877), // Rule ID 22097 //
     /* 201853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201866 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 201869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201871 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201875 */     GIR_RootConstrainSelectedInstOperands,
     /* 201876 */     // GIR_Coverage, 22097,
     /* 201876 */     GIR_EraseRootFromParent_Done,
     /* 201877 */   // Label 4544: @201877
     /* 201877 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(201902), // Rule ID 22099 //
     /* 201882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201889 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 201892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201894 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201896 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201900 */     GIR_RootConstrainSelectedInstOperands,
     /* 201901 */     // GIR_Coverage, 22099,
     /* 201901 */     GIR_EraseRootFromParent_Done,
     /* 201902 */   // Label 4545: @201902
     /* 201902 */   GIM_Reject,
     /* 201903 */ // Label 4542: @201903
     /* 201903 */ GIM_Reject,
     /* 201904 */ // Label 4512: @201904
     /* 201904 */ GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(202105),
     /* 201909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 201912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 201915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 201918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 201930 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(201963), // Rule ID 21672 //
     /* 201935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201942 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201952 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 201952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 201955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201957 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201961 */     GIR_RootConstrainSelectedInstOperands,
     /* 201962 */     // GIR_Coverage, 21672,
     /* 201962 */     GIR_EraseRootFromParent_Done,
     /* 201963 */   // Label 4547: @201963
     /* 201963 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(201996), // Rule ID 21708 //
     /* 201968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201975 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201981 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201985 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 201985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 201988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201990 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201994 */     GIR_RootConstrainSelectedInstOperands,
     /* 201995 */     // GIR_Coverage, 21708,
     /* 201995 */     GIR_EraseRootFromParent_Done,
     /* 201996 */   // Label 4548: @201996
     /* 201996 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(202025), // Rule ID 21671 //
     /* 202001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202014 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 202014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 202017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202019 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202023 */     GIR_RootConstrainSelectedInstOperands,
     /* 202024 */     // GIR_Coverage, 21671,
     /* 202024 */     GIR_EraseRootFromParent_Done,
     /* 202025 */   // Label 4549: @202025
     /* 202025 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(202054), // Rule ID 21707 //
     /* 202030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202043 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 202046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202048 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202052 */     GIR_RootConstrainSelectedInstOperands,
     /* 202053 */     // GIR_Coverage, 21707,
     /* 202053 */     GIR_EraseRootFromParent_Done,
     /* 202054 */   // Label 4550: @202054
     /* 202054 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(202079), // Rule ID 21673 //
     /* 202059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202066 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 202066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 202069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202071 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202073 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202077 */     GIR_RootConstrainSelectedInstOperands,
     /* 202078 */     // GIR_Coverage, 21673,
     /* 202078 */     GIR_EraseRootFromParent_Done,
     /* 202079 */   // Label 4551: @202079
     /* 202079 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(202104), // Rule ID 21709 //
     /* 202084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202091 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 202094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202096 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202098 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202102 */     GIR_RootConstrainSelectedInstOperands,
     /* 202103 */     // GIR_Coverage, 21709,
     /* 202103 */     GIR_EraseRootFromParent_Done,
     /* 202104 */   // Label 4552: @202104
     /* 202104 */   GIM_Reject,
     /* 202105 */ // Label 4546: @202105
     /* 202105 */ GIM_Reject,
     /* 202106 */ // Label 4513: @202106
     /* 202106 */ GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(202307),
     /* 202111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 202114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 202117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 202120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 202132 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(202165), // Rule ID 21684 //
     /* 202137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202154 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 202157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202159 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202163 */     GIR_RootConstrainSelectedInstOperands,
     /* 202164 */     // GIR_Coverage, 21684,
     /* 202164 */     GIR_EraseRootFromParent_Done,
     /* 202165 */   // Label 4554: @202165
     /* 202165 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(202198), // Rule ID 21720 //
     /* 202170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202187 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 202190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202192 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202196 */     GIR_RootConstrainSelectedInstOperands,
     /* 202197 */     // GIR_Coverage, 21720,
     /* 202197 */     GIR_EraseRootFromParent_Done,
     /* 202198 */   // Label 4555: @202198
     /* 202198 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(202227), // Rule ID 21683 //
     /* 202203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202216 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 202219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202221 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202223 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202225 */     GIR_RootConstrainSelectedInstOperands,
     /* 202226 */     // GIR_Coverage, 21683,
     /* 202226 */     GIR_EraseRootFromParent_Done,
     /* 202227 */   // Label 4556: @202227
     /* 202227 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(202256), // Rule ID 21719 //
     /* 202232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202245 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 202248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202250 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202254 */     GIR_RootConstrainSelectedInstOperands,
     /* 202255 */     // GIR_Coverage, 21719,
     /* 202255 */     GIR_EraseRootFromParent_Done,
     /* 202256 */   // Label 4557: @202256
     /* 202256 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(202281), // Rule ID 21685 //
     /* 202261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202268 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 202271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202273 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202275 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202279 */     GIR_RootConstrainSelectedInstOperands,
     /* 202280 */     // GIR_Coverage, 21685,
     /* 202280 */     GIR_EraseRootFromParent_Done,
     /* 202281 */   // Label 4558: @202281
     /* 202281 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(202306), // Rule ID 21721 //
     /* 202286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202293 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 202296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202298 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202300 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202304 */     GIR_RootConstrainSelectedInstOperands,
     /* 202305 */     // GIR_Coverage, 21721,
     /* 202305 */     GIR_EraseRootFromParent_Done,
     /* 202306 */   // Label 4559: @202306
     /* 202306 */   GIM_Reject,
     /* 202307 */ // Label 4553: @202307
     /* 202307 */ GIM_Reject,
     /* 202308 */ // Label 4514: @202308
     /* 202308 */ GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(202422),
     /* 202313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 202316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202319 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 202322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202334 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(202367), // Rule ID 22080 //
     /* 202339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202346 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202356 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 202359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202361 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202365 */     GIR_RootConstrainSelectedInstOperands,
     /* 202366 */     // GIR_Coverage, 22080,
     /* 202366 */     GIR_EraseRootFromParent_Done,
     /* 202367 */   // Label 4561: @202367
     /* 202367 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(202396), // Rule ID 22079 //
     /* 202372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202385 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 202388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202390 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202394 */     GIR_RootConstrainSelectedInstOperands,
     /* 202395 */     // GIR_Coverage, 22079,
     /* 202395 */     GIR_EraseRootFromParent_Done,
     /* 202396 */   // Label 4562: @202396
     /* 202396 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(202421), // Rule ID 22081 //
     /* 202401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202408 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 202411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202413 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202415 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202419 */     GIR_RootConstrainSelectedInstOperands,
     /* 202420 */     // GIR_Coverage, 22081,
     /* 202420 */     GIR_EraseRootFromParent_Done,
     /* 202421 */   // Label 4563: @202421
     /* 202421 */   GIM_Reject,
     /* 202422 */ // Label 4560: @202422
     /* 202422 */ GIM_Reject,
     /* 202423 */ // Label 4515: @202423
     /* 202423 */ GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(202537),
     /* 202428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 202431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 202437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202449 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(202482), // Rule ID 22092 //
     /* 202454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202461 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202467 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202471 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 202474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202476 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202480 */     GIR_RootConstrainSelectedInstOperands,
     /* 202481 */     // GIR_Coverage, 22092,
     /* 202481 */     GIR_EraseRootFromParent_Done,
     /* 202482 */   // Label 4565: @202482
     /* 202482 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(202511), // Rule ID 22091 //
     /* 202487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202500 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 202503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202505 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202509 */     GIR_RootConstrainSelectedInstOperands,
     /* 202510 */     // GIR_Coverage, 22091,
     /* 202510 */     GIR_EraseRootFromParent_Done,
     /* 202511 */   // Label 4566: @202511
     /* 202511 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(202536), // Rule ID 22093 //
     /* 202516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202523 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 202526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202528 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202530 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202534 */     GIR_RootConstrainSelectedInstOperands,
     /* 202535 */     // GIR_Coverage, 22093,
     /* 202535 */     GIR_EraseRootFromParent_Done,
     /* 202536 */   // Label 4567: @202536
     /* 202536 */   GIM_Reject,
     /* 202537 */ // Label 4564: @202537
     /* 202537 */ GIM_Reject,
     /* 202538 */ // Label 4516: @202538
     /* 202538 */ GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(202739),
     /* 202543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 202546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 202552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202564 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(202597), // Rule ID 21666 //
     /* 202569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202576 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202582 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202586 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 202589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202591 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202595 */     GIR_RootConstrainSelectedInstOperands,
     /* 202596 */     // GIR_Coverage, 21666,
     /* 202596 */     GIR_EraseRootFromParent_Done,
     /* 202597 */   // Label 4569: @202597
     /* 202597 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(202630), // Rule ID 21702 //
     /* 202602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202609 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202615 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202619 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 202622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202624 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202628 */     GIR_RootConstrainSelectedInstOperands,
     /* 202629 */     // GIR_Coverage, 21702,
     /* 202629 */     GIR_EraseRootFromParent_Done,
     /* 202630 */   // Label 4570: @202630
     /* 202630 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(202659), // Rule ID 21665 //
     /* 202635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202648 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 202651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202653 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202657 */     GIR_RootConstrainSelectedInstOperands,
     /* 202658 */     // GIR_Coverage, 21665,
     /* 202658 */     GIR_EraseRootFromParent_Done,
     /* 202659 */   // Label 4571: @202659
     /* 202659 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(202688), // Rule ID 21701 //
     /* 202664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202677 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 202680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202682 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202686 */     GIR_RootConstrainSelectedInstOperands,
     /* 202687 */     // GIR_Coverage, 21701,
     /* 202687 */     GIR_EraseRootFromParent_Done,
     /* 202688 */   // Label 4572: @202688
     /* 202688 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(202713), // Rule ID 21667 //
     /* 202693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202700 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 202703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202705 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202707 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202709 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202711 */     GIR_RootConstrainSelectedInstOperands,
     /* 202712 */     // GIR_Coverage, 21667,
     /* 202712 */     GIR_EraseRootFromParent_Done,
     /* 202713 */   // Label 4573: @202713
     /* 202713 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(202738), // Rule ID 21703 //
     /* 202718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202725 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 202728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202730 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202732 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202736 */     GIR_RootConstrainSelectedInstOperands,
     /* 202737 */     // GIR_Coverage, 21703,
     /* 202737 */     GIR_EraseRootFromParent_Done,
     /* 202738 */   // Label 4574: @202738
     /* 202738 */   GIM_Reject,
     /* 202739 */ // Label 4568: @202739
     /* 202739 */ GIM_Reject,
     /* 202740 */ // Label 4517: @202740
     /* 202740 */ GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(202854),
     /* 202745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 202748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 202751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 202754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 202766 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(202799), // Rule ID 22074 //
     /* 202771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202784 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202788 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 202791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202793 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202797 */     GIR_RootConstrainSelectedInstOperands,
     /* 202798 */     // GIR_Coverage, 22074,
     /* 202798 */     GIR_EraseRootFromParent_Done,
     /* 202799 */   // Label 4576: @202799
     /* 202799 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(202828), // Rule ID 22073 //
     /* 202804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202817 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 202820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202822 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202826 */     GIR_RootConstrainSelectedInstOperands,
     /* 202827 */     // GIR_Coverage, 22073,
     /* 202827 */     GIR_EraseRootFromParent_Done,
     /* 202828 */   // Label 4577: @202828
     /* 202828 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(202853), // Rule ID 22075 //
     /* 202833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202840 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 202843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202845 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202847 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202851 */     GIR_RootConstrainSelectedInstOperands,
     /* 202852 */     // GIR_Coverage, 22075,
     /* 202852 */     GIR_EraseRootFromParent_Done,
     /* 202853 */   // Label 4578: @202853
     /* 202853 */   GIM_Reject,
     /* 202854 */ // Label 4575: @202854
     /* 202854 */ GIM_Reject,
     /* 202855 */ // Label 4518: @202855
     /* 202855 */ GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(202969),
     /* 202860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 202863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 202866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 202869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 202881 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(202914), // Rule ID 22086 //
     /* 202886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202893 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202899 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202903 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 202906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202908 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202912 */     GIR_RootConstrainSelectedInstOperands,
     /* 202913 */     // GIR_Coverage, 22086,
     /* 202913 */     GIR_EraseRootFromParent_Done,
     /* 202914 */   // Label 4580: @202914
     /* 202914 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(202943), // Rule ID 22085 //
     /* 202919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202932 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 202935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202937 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202941 */     GIR_RootConstrainSelectedInstOperands,
     /* 202942 */     // GIR_Coverage, 22085,
     /* 202942 */     GIR_EraseRootFromParent_Done,
     /* 202943 */   // Label 4581: @202943
     /* 202943 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(202968), // Rule ID 22087 //
     /* 202948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202955 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 202958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202960 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202962 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202966 */     GIR_RootConstrainSelectedInstOperands,
     /* 202967 */     // GIR_Coverage, 22087,
     /* 202967 */     GIR_EraseRootFromParent_Done,
     /* 202968 */   // Label 4582: @202968
     /* 202968 */   GIM_Reject,
     /* 202969 */ // Label 4579: @202969
     /* 202969 */ GIM_Reject,
     /* 202970 */ // Label 4519: @202970
     /* 202970 */ GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(203084),
     /* 202975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 202978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 202981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 202984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 202996 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(203029), // Rule ID 22068 //
     /* 203001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 203008 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 203014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 203016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203018 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 203021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203023 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203027 */     GIR_RootConstrainSelectedInstOperands,
     /* 203028 */     // GIR_Coverage, 22068,
     /* 203028 */     GIR_EraseRootFromParent_Done,
     /* 203029 */   // Label 4584: @203029
     /* 203029 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(203058), // Rule ID 22067 //
     /* 203034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 203041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 203045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203047 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 203050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203052 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203056 */     GIR_RootConstrainSelectedInstOperands,
     /* 203057 */     // GIR_Coverage, 22067,
     /* 203057 */     GIR_EraseRootFromParent_Done,
     /* 203058 */   // Label 4585: @203058
     /* 203058 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(203083), // Rule ID 22069 //
     /* 203063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203070 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 203073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203075 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 203077 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203081 */     GIR_RootConstrainSelectedInstOperands,
     /* 203082 */     // GIR_Coverage, 22069,
     /* 203082 */     GIR_EraseRootFromParent_Done,
     /* 203083 */   // Label 4586: @203083
     /* 203083 */   GIM_Reject,
     /* 203084 */ // Label 4583: @203084
     /* 203084 */ GIM_Reject,
     /* 203085 */ // Label 4520: @203085
     /* 203085 */ GIM_Reject,
     /* 203086 */ // Label 62: @203086
     /* 203086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4590*/ GIMT_Encode4(203391),
     /* 203097 */ /*GILLT_s16*//*Label 4587*/ GIMT_Encode4(203109),
     /* 203101 */ /*GILLT_s32*//*Label 4588*/ GIMT_Encode4(203203),
     /* 203105 */ /*GILLT_s64*//*Label 4589*/ GIMT_Encode4(203297),
     /* 203109 */ // Label 4587: @203109
     /* 203109 */ GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(203202),
     /* 203114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203121 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(203176), // Rule ID 77 //
     /* 203126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203144 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203157 */     // (cttz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (TZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT16rm),
     /* 203160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203174 */     GIR_RootConstrainSelectedInstOperands,
     /* 203175 */     // GIR_Coverage, 77,
     /* 203175 */     GIR_EraseRootFromParent_Done,
     /* 203176 */   // Label 4592: @203176
     /* 203176 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(203201), // Rule ID 76 //
     /* 203181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203188 */     // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 203188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 203193 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203199 */     GIR_RootConstrainSelectedInstOperands,
     /* 203200 */     // GIR_Coverage, 76,
     /* 203200 */     GIR_Done,
     /* 203201 */   // Label 4593: @203201
     /* 203201 */   GIM_Reject,
     /* 203202 */ // Label 4591: @203202
     /* 203202 */ GIM_Reject,
     /* 203203 */ // Label 4588: @203203
     /* 203203 */ GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(203296),
     /* 203208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203215 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(203270), // Rule ID 79 //
     /* 203220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203238 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203251 */     // (cttz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (TZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT32rm),
     /* 203254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203268 */     GIR_RootConstrainSelectedInstOperands,
     /* 203269 */     // GIR_Coverage, 79,
     /* 203269 */     GIR_EraseRootFromParent_Done,
     /* 203270 */   // Label 4595: @203270
     /* 203270 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(203295), // Rule ID 78 //
     /* 203275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203282 */     // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 203282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 203287 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203293 */     GIR_RootConstrainSelectedInstOperands,
     /* 203294 */     // GIR_Coverage, 78,
     /* 203294 */     GIR_Done,
     /* 203295 */   // Label 4596: @203295
     /* 203295 */   GIM_Reject,
     /* 203296 */ // Label 4594: @203296
     /* 203296 */ GIM_Reject,
     /* 203297 */ // Label 4589: @203297
     /* 203297 */ GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(203390),
     /* 203302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203309 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(203364), // Rule ID 81 //
     /* 203314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203345 */     // (cttz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (TZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT64rm),
     /* 203348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203362 */     GIR_RootConstrainSelectedInstOperands,
     /* 203363 */     // GIR_Coverage, 81,
     /* 203363 */     GIR_EraseRootFromParent_Done,
     /* 203364 */   // Label 4598: @203364
     /* 203364 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(203389), // Rule ID 80 //
     /* 203369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203376 */     // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 203376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 203381 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203387 */     GIR_RootConstrainSelectedInstOperands,
     /* 203388 */     // GIR_Coverage, 80,
     /* 203388 */     GIR_Done,
     /* 203389 */   // Label 4599: @203389
     /* 203389 */   GIM_Reject,
     /* 203390 */ // Label 4597: @203390
     /* 203390 */ GIM_Reject,
     /* 203391 */ // Label 4590: @203391
     /* 203391 */ GIM_Reject,
     /* 203392 */ // Label 63: @203392
     /* 203392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4603*/ GIMT_Encode4(203778),
     /* 203403 */ /*GILLT_s16*//*Label 4600*/ GIMT_Encode4(203415),
     /* 203407 */ /*GILLT_s32*//*Label 4601*/ GIMT_Encode4(203536),
     /* 203411 */ /*GILLT_s64*//*Label 4602*/ GIMT_Encode4(203657),
     /* 203415 */ // Label 4600: @203415
     /* 203415 */ GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(203535),
     /* 203420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203427 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(203496), // Rule ID 22985 //
     /* 203432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203447 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203460 */     // (cttz_zero_undef:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (BSF16rm:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), addr:{ *:[iPTR] }:$src)
     /* 203460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 203463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rm),
     /* 203477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203494 */     GIR_RootConstrainSelectedInstOperands,
     /* 203495 */     // GIR_Coverage, 22985,
     /* 203495 */     GIR_EraseRootFromParent_Done,
     /* 203496 */   // Label 4605: @203496
     /* 203496 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(203534), // Rule ID 22982 //
     /* 203501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203505 */     // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 203505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 203508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 203522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203532 */     GIR_RootConstrainSelectedInstOperands,
     /* 203533 */     // GIR_Coverage, 22982,
     /* 203533 */     GIR_EraseRootFromParent_Done,
     /* 203534 */   // Label 4606: @203534
     /* 203534 */   GIM_Reject,
     /* 203535 */ // Label 4604: @203535
     /* 203535 */ GIM_Reject,
     /* 203536 */ // Label 4601: @203536
     /* 203536 */ GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(203656),
     /* 203541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203548 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(203617), // Rule ID 22986 //
     /* 203553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203568 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203581 */     // (cttz_zero_undef:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (BSF32rm:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), addr:{ *:[iPTR] }:$src)
     /* 203581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 203584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rm),
     /* 203598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203615 */     GIR_RootConstrainSelectedInstOperands,
     /* 203616 */     // GIR_Coverage, 22986,
     /* 203616 */     GIR_EraseRootFromParent_Done,
     /* 203617 */   // Label 4608: @203617
     /* 203617 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(203655), // Rule ID 22983 //
     /* 203622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203626 */     // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 203626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 203629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 203643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203653 */     GIR_RootConstrainSelectedInstOperands,
     /* 203654 */     // GIR_Coverage, 22983,
     /* 203654 */     GIR_EraseRootFromParent_Done,
     /* 203655 */   // Label 4609: @203655
     /* 203655 */   GIM_Reject,
     /* 203656 */ // Label 4607: @203656
     /* 203656 */ GIM_Reject,
     /* 203657 */ // Label 4602: @203657
     /* 203657 */ GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(203777),
     /* 203662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203669 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(203738), // Rule ID 22987 //
     /* 203674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203702 */     // (cttz_zero_undef:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (BSF64rm:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), addr:{ *:[iPTR] }:$src)
     /* 203702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 203705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rm),
     /* 203719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203736 */     GIR_RootConstrainSelectedInstOperands,
     /* 203737 */     // GIR_Coverage, 22987,
     /* 203737 */     GIR_EraseRootFromParent_Done,
     /* 203738 */   // Label 4611: @203738
     /* 203738 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(203776), // Rule ID 22984 //
     /* 203743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203747 */     // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 203747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 203750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 203764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203774 */     GIR_RootConstrainSelectedInstOperands,
     /* 203775 */     // GIR_Coverage, 22984,
     /* 203775 */     GIR_EraseRootFromParent_Done,
     /* 203776 */   // Label 4612: @203776
     /* 203776 */   GIM_Reject,
     /* 203777 */ // Label 4610: @203777
     /* 203777 */ GIM_Reject,
     /* 203778 */ // Label 4603: @203778
     /* 203778 */ GIM_Reject,
     /* 203779 */ // Label 64: @203779
     /* 203779 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 4622*/ GIMT_Encode4(205082),
     /* 203790 */ /*GILLT_s16*//*Label 4613*/ GIMT_Encode4(203862),
     /* 203794 */ /*GILLT_s32*//*Label 4614*/ GIMT_Encode4(203956),
     /* 203798 */ /*GILLT_s64*//*Label 4615*/ GIMT_Encode4(204050), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203814 */ /*GILLT_v2s64*//*Label 4616*/ GIMT_Encode4(204144), GIMT_Encode4(0),
     /* 203822 */ /*GILLT_v4s32*//*Label 4617*/ GIMT_Encode4(204340),
     /* 203826 */ /*GILLT_v4s64*//*Label 4618*/ GIMT_Encode4(204536), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203838 */ /*GILLT_v8s32*//*Label 4619*/ GIMT_Encode4(204724),
     /* 203842 */ /*GILLT_v8s64*//*Label 4620*/ GIMT_Encode4(204912), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203858 */ /*GILLT_v16s32*//*Label 4621*/ GIMT_Encode4(204997),
     /* 203862 */ // Label 4613: @203862
     /* 203862 */ GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(203955),
     /* 203867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203874 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(203929), // Rule ID 71 //
     /* 203879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203890 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203893 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203897 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203910 */     // (ctlz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (LZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT16rm),
     /* 203913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203927 */     GIR_RootConstrainSelectedInstOperands,
     /* 203928 */     // GIR_Coverage, 71,
     /* 203928 */     GIR_EraseRootFromParent_Done,
     /* 203929 */   // Label 4624: @203929
     /* 203929 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(203954), // Rule ID 70 //
     /* 203934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203941 */     // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 203941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 203946 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203952 */     GIR_RootConstrainSelectedInstOperands,
     /* 203953 */     // GIR_Coverage, 70,
     /* 203953 */     GIR_Done,
     /* 203954 */   // Label 4625: @203954
     /* 203954 */   GIM_Reject,
     /* 203955 */ // Label 4623: @203955
     /* 203955 */ GIM_Reject,
     /* 203956 */ // Label 4614: @203956
     /* 203956 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(204049),
     /* 203961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203968 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(204023), // Rule ID 73 //
     /* 203973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203991 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204004 */     // (ctlz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (LZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT32rm),
     /* 204007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204021 */     GIR_RootConstrainSelectedInstOperands,
     /* 204022 */     // GIR_Coverage, 73,
     /* 204022 */     GIR_EraseRootFromParent_Done,
     /* 204023 */   // Label 4627: @204023
     /* 204023 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(204048), // Rule ID 72 //
     /* 204028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204035 */     // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 204035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 204040 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 204046 */     GIR_RootConstrainSelectedInstOperands,
     /* 204047 */     // GIR_Coverage, 72,
     /* 204047 */     GIR_Done,
     /* 204048 */   // Label 4628: @204048
     /* 204048 */   GIM_Reject,
     /* 204049 */ // Label 4626: @204049
     /* 204049 */ GIM_Reject,
     /* 204050 */ // Label 4615: @204050
     /* 204050 */ GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(204143),
     /* 204055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 204058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204062 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(204117), // Rule ID 75 //
     /* 204067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204098 */     // (ctlz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT64rm),
     /* 204101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204115 */     GIR_RootConstrainSelectedInstOperands,
     /* 204116 */     // GIR_Coverage, 75,
     /* 204116 */     GIR_EraseRootFromParent_Done,
     /* 204117 */   // Label 4630: @204117
     /* 204117 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(204142), // Rule ID 74 //
     /* 204122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204129 */     // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 204129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 204134 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 204140 */     GIR_RootConstrainSelectedInstOperands,
     /* 204141 */     // GIR_Coverage, 74,
     /* 204141 */     GIR_Done,
     /* 204142 */   // Label 4631: @204142
     /* 204142 */   GIM_Reject,
     /* 204143 */ // Label 4629: @204143
     /* 204143 */ GIM_Reject,
     /* 204144 */ // Label 4616: @204144
     /* 204144 */ GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(204339),
     /* 204149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 204152 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(204208), // Rule ID 13357 //
     /* 204157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204192 */     // (ctlz:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 204192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rm),
     /* 204195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204206 */     GIR_RootConstrainSelectedInstOperands,
     /* 204207 */     // GIR_Coverage, 13357,
     /* 204207 */     GIR_EraseRootFromParent_Done,
     /* 204208 */   // Label 4633: @204208
     /* 204208 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(204231), // Rule ID 13354 //
     /* 204213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204224 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 204224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 204229 */     GIR_RootConstrainSelectedInstOperands,
     /* 204230 */     // GIR_Coverage, 13354,
     /* 204230 */     GIR_Done,
     /* 204231 */   // Label 4634: @204231
     /* 204231 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(204338), // Rule ID 21826 //
     /* 204236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204247 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 204247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 204250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 204264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 204283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 204298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 204327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 204332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204337 */     // GIR_Coverage, 21826,
     /* 204337 */     GIR_EraseRootFromParent_Done,
     /* 204338 */   // Label 4635: @204338
     /* 204338 */   GIM_Reject,
     /* 204339 */ // Label 4632: @204339
     /* 204339 */ GIM_Reject,
     /* 204340 */ // Label 4617: @204340
     /* 204340 */ GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(204535),
     /* 204345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204348 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(204404), // Rule ID 13384 //
     /* 204353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204388 */     // (ctlz:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 204388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rm),
     /* 204391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204402 */     GIR_RootConstrainSelectedInstOperands,
     /* 204403 */     // GIR_Coverage, 13384,
     /* 204403 */     GIR_EraseRootFromParent_Done,
     /* 204404 */   // Label 4637: @204404
     /* 204404 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(204427), // Rule ID 13381 //
     /* 204409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204420 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 204420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 204425 */     GIR_RootConstrainSelectedInstOperands,
     /* 204426 */     // GIR_Coverage, 13381,
     /* 204426 */     GIR_Done,
     /* 204427 */   // Label 4638: @204427
     /* 204427 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(204534), // Rule ID 21828 //
     /* 204432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204443 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 204443 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 204446 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204450 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 204460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204469 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204476 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 204479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 204494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 204501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204516 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 204523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 204528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204533 */     // GIR_Coverage, 21828,
     /* 204533 */     GIR_EraseRootFromParent_Done,
     /* 204534 */   // Label 4639: @204534
     /* 204534 */   GIM_Reject,
     /* 204535 */ // Label 4636: @204535
     /* 204535 */ GIM_Reject,
     /* 204536 */ // Label 4618: @204536
     /* 204536 */ GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(204723),
     /* 204541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 204544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204548 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(204600), // Rule ID 13348 //
     /* 204553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204584 */     // (ctlz:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 204584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rm),
     /* 204587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204598 */     GIR_RootConstrainSelectedInstOperands,
     /* 204599 */     // GIR_Coverage, 13348,
     /* 204599 */     GIR_EraseRootFromParent_Done,
     /* 204600 */   // Label 4641: @204600
     /* 204600 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(204619), // Rule ID 13345 //
     /* 204605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204612 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 204612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 204617 */     GIR_RootConstrainSelectedInstOperands,
     /* 204618 */     // GIR_Coverage, 13345,
     /* 204618 */     GIR_Done,
     /* 204619 */   // Label 4642: @204619
     /* 204619 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(204722), // Rule ID 21825 //
     /* 204624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204631 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 204631 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 204634 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204638 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 204648 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204652 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204657 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204660 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204664 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 204667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204694 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204704 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 204711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204721 */     // GIR_Coverage, 21825,
     /* 204721 */     GIR_EraseRootFromParent_Done,
     /* 204722 */   // Label 4643: @204722
     /* 204722 */   GIM_Reject,
     /* 204723 */ // Label 4640: @204723
     /* 204723 */ GIM_Reject,
     /* 204724 */ // Label 4619: @204724
     /* 204724 */ GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(204911),
     /* 204729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 204732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204736 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(204788), // Rule ID 13375 //
     /* 204741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204759 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204772 */     // (ctlz:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 204772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rm),
     /* 204775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204786 */     GIR_RootConstrainSelectedInstOperands,
     /* 204787 */     // GIR_Coverage, 13375,
     /* 204787 */     GIR_EraseRootFromParent_Done,
     /* 204788 */   // Label 4645: @204788
     /* 204788 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(204807), // Rule ID 13372 //
     /* 204793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204800 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 204800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 204805 */     GIR_RootConstrainSelectedInstOperands,
     /* 204806 */     // GIR_Coverage, 13372,
     /* 204806 */     GIR_Done,
     /* 204807 */   // Label 4646: @204807
     /* 204807 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(204910), // Rule ID 21827 //
     /* 204812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204819 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 204819 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 204822 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204826 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 204836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204845 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204848 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204852 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 204855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 204877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204892 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 204899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204909 */     // GIR_Coverage, 21827,
     /* 204909 */     GIR_EraseRootFromParent_Done,
     /* 204910 */   // Label 4647: @204910
     /* 204910 */   GIM_Reject,
     /* 204911 */ // Label 4644: @204911
     /* 204911 */ GIM_Reject,
     /* 204912 */ // Label 4620: @204912
     /* 204912 */ GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(204996),
     /* 204917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 204920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204924 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(204976), // Rule ID 13339 //
     /* 204929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 204932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204960 */     // (ctlz:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 204960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrm),
     /* 204963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204974 */     GIR_RootConstrainSelectedInstOperands,
     /* 204975 */     // GIR_Coverage, 13339,
     /* 204975 */     GIR_EraseRootFromParent_Done,
     /* 204976 */   // Label 4649: @204976
     /* 204976 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(204995), // Rule ID 13336 //
     /* 204981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 204984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204988 */     // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 204988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204993 */     GIR_RootConstrainSelectedInstOperands,
     /* 204994 */     // GIR_Coverage, 13336,
     /* 204994 */     GIR_Done,
     /* 204995 */   // Label 4650: @204995
     /* 204995 */   GIM_Reject,
     /* 204996 */ // Label 4648: @204996
     /* 204996 */ GIM_Reject,
     /* 204997 */ // Label 4621: @204997
     /* 204997 */ GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(205081),
     /* 205002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 205005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205009 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(205061), // Rule ID 13366 //
     /* 205014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205045 */     // (ctlz:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 205045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrm),
     /* 205048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205059 */     GIR_RootConstrainSelectedInstOperands,
     /* 205060 */     // GIR_Coverage, 13366,
     /* 205060 */     GIR_EraseRootFromParent_Done,
     /* 205061 */   // Label 4652: @205061
     /* 205061 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(205080), // Rule ID 13363 //
     /* 205066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205073 */     // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 205073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 205078 */     GIR_RootConstrainSelectedInstOperands,
     /* 205079 */     // GIR_Coverage, 13363,
     /* 205079 */     GIR_Done,
     /* 205080 */   // Label 4653: @205080
     /* 205080 */   GIM_Reject,
     /* 205081 */ // Label 4651: @205081
     /* 205081 */ GIM_Reject,
     /* 205082 */ // Label 4622: @205082
     /* 205082 */ GIM_Reject,
     /* 205083 */ // Label 65: @205083
     /* 205083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 4669*/ GIMT_Encode4(207344),
     /* 205094 */ /*GILLT_s16*//*Label 4654*/ GIMT_Encode4(205186),
     /* 205098 */ /*GILLT_s32*//*Label 4655*/ GIMT_Encode4(205280),
     /* 205102 */ /*GILLT_s64*//*Label 4656*/ GIMT_Encode4(205374), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 205118 */ /*GILLT_v2s64*//*Label 4657*/ GIMT_Encode4(205468), GIMT_Encode4(0),
     /* 205126 */ /*GILLT_v4s32*//*Label 4658*/ GIMT_Encode4(205664),
     /* 205130 */ /*GILLT_v4s64*//*Label 4659*/ GIMT_Encode4(205860), GIMT_Encode4(0),
     /* 205138 */ /*GILLT_v8s16*//*Label 4660*/ GIMT_Encode4(206048),
     /* 205142 */ /*GILLT_v8s32*//*Label 4661*/ GIMT_Encode4(206244),
     /* 205146 */ /*GILLT_v8s64*//*Label 4662*/ GIMT_Encode4(206432), GIMT_Encode4(0),
     /* 205154 */ /*GILLT_v16s8*//*Label 4663*/ GIMT_Encode4(206517),
     /* 205158 */ /*GILLT_v16s16*//*Label 4664*/ GIMT_Encode4(206713),
     /* 205162 */ /*GILLT_v16s32*//*Label 4665*/ GIMT_Encode4(206901), GIMT_Encode4(0),
     /* 205170 */ /*GILLT_v32s8*//*Label 4666*/ GIMT_Encode4(206986),
     /* 205174 */ /*GILLT_v32s16*//*Label 4667*/ GIMT_Encode4(207174), GIMT_Encode4(0),
     /* 205182 */ /*GILLT_v64s8*//*Label 4668*/ GIMT_Encode4(207259),
     /* 205186 */ // Label 4654: @205186
     /* 205186 */ GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(205279),
     /* 205191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 205194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 205198 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(205253), // Rule ID 3176 //
     /* 205203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205221 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 205225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205234 */     // (ctpop:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (POPCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT16rm),
     /* 205237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205251 */     GIR_RootConstrainSelectedInstOperands,
     /* 205252 */     // GIR_Coverage, 3176,
     /* 205252 */     GIR_EraseRootFromParent_Done,
     /* 205253 */   // Label 4671: @205253
     /* 205253 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(205278), // Rule ID 3175 //
     /* 205258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 205265 */     // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 205265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 205270 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205276 */     GIR_RootConstrainSelectedInstOperands,
     /* 205277 */     // GIR_Coverage, 3175,
     /* 205277 */     GIR_Done,
     /* 205278 */   // Label 4672: @205278
     /* 205278 */   GIM_Reject,
     /* 205279 */ // Label 4670: @205279
     /* 205279 */ GIM_Reject,
     /* 205280 */ // Label 4655: @205280
     /* 205280 */ GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(205373),
     /* 205285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 205288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 205292 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(205347), // Rule ID 3178 //
     /* 205297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205315 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 205319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205328 */     // (ctpop:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (POPCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT32rm),
     /* 205331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205345 */     GIR_RootConstrainSelectedInstOperands,
     /* 205346 */     // GIR_Coverage, 3178,
     /* 205346 */     GIR_EraseRootFromParent_Done,
     /* 205347 */   // Label 4674: @205347
     /* 205347 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(205372), // Rule ID 3177 //
     /* 205352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 205359 */     // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 205359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 205364 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205370 */     GIR_RootConstrainSelectedInstOperands,
     /* 205371 */     // GIR_Coverage, 3177,
     /* 205371 */     GIR_Done,
     /* 205372 */   // Label 4675: @205372
     /* 205372 */   GIM_Reject,
     /* 205373 */ // Label 4673: @205373
     /* 205373 */ GIM_Reject,
     /* 205374 */ // Label 4656: @205374
     /* 205374 */ GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(205467),
     /* 205379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 205382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 205386 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(205441), // Rule ID 3180 //
     /* 205391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205422 */     // (ctpop:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (POPCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT64rm),
     /* 205425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205439 */     GIR_RootConstrainSelectedInstOperands,
     /* 205440 */     // GIR_Coverage, 3180,
     /* 205440 */     GIR_EraseRootFromParent_Done,
     /* 205441 */   // Label 4677: @205441
     /* 205441 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(205466), // Rule ID 3179 //
     /* 205446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 205453 */     // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 205453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 205458 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205464 */     GIR_RootConstrainSelectedInstOperands,
     /* 205465 */     // GIR_Coverage, 3179,
     /* 205465 */     GIR_Done,
     /* 205466 */   // Label 4678: @205466
     /* 205466 */   GIM_Reject,
     /* 205467 */ // Label 4676: @205467
     /* 205467 */ GIM_Reject,
     /* 205468 */ // Label 4657: @205468
     /* 205468 */ GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(205663),
     /* 205473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 205476 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(205532), // Rule ID 13465 //
     /* 205481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205516 */     // (ctpop:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 205516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rm),
     /* 205519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205530 */     GIR_RootConstrainSelectedInstOperands,
     /* 205531 */     // GIR_Coverage, 13465,
     /* 205531 */     GIR_EraseRootFromParent_Done,
     /* 205532 */   // Label 4680: @205532
     /* 205532 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(205555), // Rule ID 13462 //
     /* 205537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205548 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 205548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 205553 */     GIR_RootConstrainSelectedInstOperands,
     /* 205554 */     // GIR_Coverage, 13462,
     /* 205554 */     GIR_Done,
     /* 205555 */   // Label 4681: @205555
     /* 205555 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(205662), // Rule ID 21830 //
     /* 205560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 205567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205571 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 205571 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 205574 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205578 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205585 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 205588 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205592 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205597 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205604 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 205607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 205622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 205625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 205629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205644 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 205651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 205656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205661 */     // GIR_Coverage, 21830,
     /* 205661 */     GIR_EraseRootFromParent_Done,
     /* 205662 */   // Label 4682: @205662
     /* 205662 */   GIM_Reject,
     /* 205663 */ // Label 4679: @205663
     /* 205663 */ GIM_Reject,
     /* 205664 */ // Label 4658: @205664
     /* 205664 */ GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(205859),
     /* 205669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205672 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(205728), // Rule ID 13492 //
     /* 205677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205692 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205695 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205699 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205712 */     // (ctpop:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 205712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rm),
     /* 205715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205726 */     GIR_RootConstrainSelectedInstOperands,
     /* 205727 */     // GIR_Coverage, 13492,
     /* 205727 */     GIR_EraseRootFromParent_Done,
     /* 205728 */   // Label 4684: @205728
     /* 205728 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(205751), // Rule ID 13489 //
     /* 205733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205744 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 205744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 205749 */     GIR_RootConstrainSelectedInstOperands,
     /* 205750 */     // GIR_Coverage, 13489,
     /* 205750 */     GIR_Done,
     /* 205751 */   // Label 4685: @205751
     /* 205751 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(205858), // Rule ID 21832 //
     /* 205756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 205763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205767 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 205767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 205770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 205784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 205803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 205818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 205821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 205825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205840 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 205847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 205852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205857 */     // GIR_Coverage, 21832,
     /* 205857 */     GIR_EraseRootFromParent_Done,
     /* 205858 */   // Label 4686: @205858
     /* 205858 */   GIM_Reject,
     /* 205859 */ // Label 4683: @205859
     /* 205859 */ GIM_Reject,
     /* 205860 */ // Label 4659: @205860
     /* 205860 */ GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(206047),
     /* 205865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 205868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205872 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(205924), // Rule ID 13456 //
     /* 205877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205908 */     // (ctpop:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 205908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rm),
     /* 205911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205922 */     GIR_RootConstrainSelectedInstOperands,
     /* 205923 */     // GIR_Coverage, 13456,
     /* 205923 */     GIR_EraseRootFromParent_Done,
     /* 205924 */   // Label 4688: @205924
     /* 205924 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(205943), // Rule ID 13453 //
     /* 205929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205936 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 205936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 205941 */     GIR_RootConstrainSelectedInstOperands,
     /* 205942 */     // GIR_Coverage, 13453,
     /* 205942 */     GIR_Done,
     /* 205943 */   // Label 4689: @205943
     /* 205943 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(206046), // Rule ID 21829 //
     /* 205948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205955 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 205955 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 205958 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205962 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 205972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205981 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 205991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 206013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206028 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206045 */     // GIR_Coverage, 21829,
     /* 206045 */     GIR_EraseRootFromParent_Done,
     /* 206046 */   // Label 4690: @206046
     /* 206046 */   GIM_Reject,
     /* 206047 */ // Label 4687: @206047
     /* 206047 */ GIM_Reject,
     /* 206048 */ // Label 4660: @206048
     /* 206048 */ GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(206243),
     /* 206053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 206056 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(206112), // Rule ID 14519 //
     /* 206061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206096 */     // (ctpop:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 206096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rm),
     /* 206099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206110 */     GIR_RootConstrainSelectedInstOperands,
     /* 206111 */     // GIR_Coverage, 14519,
     /* 206111 */     GIR_EraseRootFromParent_Done,
     /* 206112 */   // Label 4692: @206112
     /* 206112 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(206135), // Rule ID 14516 //
     /* 206117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206128 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 206128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 206133 */     GIR_RootConstrainSelectedInstOperands,
     /* 206134 */     // GIR_Coverage, 14516,
     /* 206134 */     GIR_Done,
     /* 206135 */   // Label 4693: @206135
     /* 206135 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(206242), // Rule ID 22139 //
     /* 206140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206151 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 206151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 206154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 206168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206177 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206180 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 206187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 206202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 206209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206224 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 206231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 206236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206241 */     // GIR_Coverage, 22139,
     /* 206241 */     GIR_EraseRootFromParent_Done,
     /* 206242 */   // Label 4694: @206242
     /* 206242 */   GIM_Reject,
     /* 206243 */ // Label 4691: @206243
     /* 206243 */ GIM_Reject,
     /* 206244 */ // Label 4661: @206244
     /* 206244 */ GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(206431),
     /* 206249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 206252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206256 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(206308), // Rule ID 13483 //
     /* 206261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 206264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206275 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206279 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206292 */     // (ctpop:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 206292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rm),
     /* 206295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206306 */     GIR_RootConstrainSelectedInstOperands,
     /* 206307 */     // GIR_Coverage, 13483,
     /* 206307 */     GIR_EraseRootFromParent_Done,
     /* 206308 */   // Label 4696: @206308
     /* 206308 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(206327), // Rule ID 13480 //
     /* 206313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 206316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206320 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 206320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 206325 */     GIR_RootConstrainSelectedInstOperands,
     /* 206326 */     // GIR_Coverage, 13480,
     /* 206326 */     GIR_Done,
     /* 206327 */   // Label 4697: @206327
     /* 206327 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(206430), // Rule ID 21831 //
     /* 206332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 206335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206339 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 206339 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 206342 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206346 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 206356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206365 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206368 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206372 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 206397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206429 */     // GIR_Coverage, 21831,
     /* 206429 */     GIR_EraseRootFromParent_Done,
     /* 206430 */   // Label 4698: @206430
     /* 206430 */   GIM_Reject,
     /* 206431 */ // Label 4695: @206431
     /* 206431 */ GIM_Reject,
     /* 206432 */ // Label 4662: @206432
     /* 206432 */ GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(206516),
     /* 206437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 206440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206444 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(206496), // Rule ID 13447 //
     /* 206449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206480 */     // (ctpop:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 206480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrm),
     /* 206483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206494 */     GIR_RootConstrainSelectedInstOperands,
     /* 206495 */     // GIR_Coverage, 13447,
     /* 206495 */     GIR_EraseRootFromParent_Done,
     /* 206496 */   // Label 4700: @206496
     /* 206496 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(206515), // Rule ID 13444 //
     /* 206501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206508 */     // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 206508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 206513 */     GIR_RootConstrainSelectedInstOperands,
     /* 206514 */     // GIR_Coverage, 13444,
     /* 206514 */     GIR_Done,
     /* 206515 */   // Label 4701: @206515
     /* 206515 */   GIM_Reject,
     /* 206516 */ // Label 4699: @206516
     /* 206516 */ GIM_Reject,
     /* 206517 */ // Label 4663: @206517
     /* 206517 */ GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(206712),
     /* 206522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 206525 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(206581), // Rule ID 14501 //
     /* 206530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206565 */     // (ctpop:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 206565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rm),
     /* 206568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206579 */     GIR_RootConstrainSelectedInstOperands,
     /* 206580 */     // GIR_Coverage, 14501,
     /* 206580 */     GIR_EraseRootFromParent_Done,
     /* 206581 */   // Label 4703: @206581
     /* 206581 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(206604), // Rule ID 14498 //
     /* 206586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206597 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 206597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 206602 */     GIR_RootConstrainSelectedInstOperands,
     /* 206603 */     // GIR_Coverage, 14498,
     /* 206603 */     GIR_Done,
     /* 206604 */   // Label 4704: @206604
     /* 206604 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(206711), // Rule ID 22137 //
     /* 206609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206620 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 206620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 206623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 206637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206646 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206653 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 206656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 206671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 206678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 206700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 206705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206710 */     // GIR_Coverage, 22137,
     /* 206710 */     GIR_EraseRootFromParent_Done,
     /* 206711 */   // Label 4705: @206711
     /* 206711 */   GIM_Reject,
     /* 206712 */ // Label 4702: @206712
     /* 206712 */ GIM_Reject,
     /* 206713 */ // Label 4664: @206713
     /* 206713 */ GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(206900),
     /* 206718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 206721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206725 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(206777), // Rule ID 14513 //
     /* 206730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206741 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206744 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206748 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206761 */     // (ctpop:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 206761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rm),
     /* 206764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206775 */     GIR_RootConstrainSelectedInstOperands,
     /* 206776 */     // GIR_Coverage, 14513,
     /* 206776 */     GIR_EraseRootFromParent_Done,
     /* 206777 */   // Label 4707: @206777
     /* 206777 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(206796), // Rule ID 14510 //
     /* 206782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206789 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 206789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 206794 */     GIR_RootConstrainSelectedInstOperands,
     /* 206795 */     // GIR_Coverage, 14510,
     /* 206795 */     GIR_Done,
     /* 206796 */   // Label 4708: @206796
     /* 206796 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(206899), // Rule ID 22138 //
     /* 206801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206808 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 206808 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 206811 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206815 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 206825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206834 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 206866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206881 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206898 */     // GIR_Coverage, 22138,
     /* 206898 */     GIR_EraseRootFromParent_Done,
     /* 206899 */   // Label 4709: @206899
     /* 206899 */   GIM_Reject,
     /* 206900 */ // Label 4706: @206900
     /* 206900 */ GIM_Reject,
     /* 206901 */ // Label 4665: @206901
     /* 206901 */ GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(206985),
     /* 206906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 206909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206913 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(206965), // Rule ID 13474 //
     /* 206918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206949 */     // (ctpop:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 206949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrm),
     /* 206952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206963 */     GIR_RootConstrainSelectedInstOperands,
     /* 206964 */     // GIR_Coverage, 13474,
     /* 206964 */     GIR_EraseRootFromParent_Done,
     /* 206965 */   // Label 4711: @206965
     /* 206965 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(206984), // Rule ID 13471 //
     /* 206970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206977 */     // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 206977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 206982 */     GIR_RootConstrainSelectedInstOperands,
     /* 206983 */     // GIR_Coverage, 13471,
     /* 206983 */     GIR_Done,
     /* 206984 */   // Label 4712: @206984
     /* 206984 */   GIM_Reject,
     /* 206985 */ // Label 4710: @206985
     /* 206985 */ GIM_Reject,
     /* 206986 */ // Label 4666: @206986
     /* 206986 */ GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(207173),
     /* 206991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 206994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206998 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(207050), // Rule ID 14495 //
     /* 207003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 207006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207034 */     // (ctpop:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 207034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rm),
     /* 207037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207048 */     GIR_RootConstrainSelectedInstOperands,
     /* 207049 */     // GIR_Coverage, 14495,
     /* 207049 */     GIR_EraseRootFromParent_Done,
     /* 207050 */   // Label 4714: @207050
     /* 207050 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(207069), // Rule ID 14492 //
     /* 207055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 207058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207062 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 207062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 207067 */     GIR_RootConstrainSelectedInstOperands,
     /* 207068 */     // GIR_Coverage, 14492,
     /* 207068 */     GIR_Done,
     /* 207069 */   // Label 4715: @207069
     /* 207069 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(207172), // Rule ID 22136 //
     /* 207074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 207077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207081 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 207081 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 207084 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207088 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 207095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 207098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207107 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 207110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 207114 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 207117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 207122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 207127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 207132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 207135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 207139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 207147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207154 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 207161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 207166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 207171 */     // GIR_Coverage, 22136,
     /* 207171 */     GIR_EraseRootFromParent_Done,
     /* 207172 */   // Label 4716: @207172
     /* 207172 */   GIM_Reject,
     /* 207173 */ // Label 4713: @207173
     /* 207173 */ GIM_Reject,
     /* 207174 */ // Label 4667: @207174
     /* 207174 */ GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(207258),
     /* 207179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 207182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207186 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(207238), // Rule ID 14507 //
     /* 207191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207222 */     // (ctpop:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 207222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrm),
     /* 207225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207236 */     GIR_RootConstrainSelectedInstOperands,
     /* 207237 */     // GIR_Coverage, 14507,
     /* 207237 */     GIR_EraseRootFromParent_Done,
     /* 207238 */   // Label 4718: @207238
     /* 207238 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(207257), // Rule ID 14504 //
     /* 207243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207250 */     // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 207250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 207255 */     GIR_RootConstrainSelectedInstOperands,
     /* 207256 */     // GIR_Coverage, 14504,
     /* 207256 */     GIR_Done,
     /* 207257 */   // Label 4719: @207257
     /* 207257 */   GIM_Reject,
     /* 207258 */ // Label 4717: @207258
     /* 207258 */ GIM_Reject,
     /* 207259 */ // Label 4668: @207259
     /* 207259 */ GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(207343),
     /* 207264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 207267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207271 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(207323), // Rule ID 14489 //
     /* 207276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207287 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207294 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207307 */     // (ctpop:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 207307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrm),
     /* 207310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207321 */     GIR_RootConstrainSelectedInstOperands,
     /* 207322 */     // GIR_Coverage, 14489,
     /* 207322 */     GIR_EraseRootFromParent_Done,
     /* 207323 */   // Label 4721: @207323
     /* 207323 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(207342), // Rule ID 14486 //
     /* 207328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207335 */     // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 207335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 207340 */     GIR_RootConstrainSelectedInstOperands,
     /* 207341 */     // GIR_Coverage, 14486,
     /* 207341 */     GIR_Done,
     /* 207342 */   // Label 4722: @207342
     /* 207342 */   GIM_Reject,
     /* 207343 */ // Label 4720: @207343
     /* 207343 */ GIM_Reject,
     /* 207344 */ // Label 4669: @207344
     /* 207344 */ GIM_Reject,
     /* 207345 */ // Label 66: @207345
     /* 207345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4726*/ GIMT_Encode4(207844),
     /* 207356 */ /*GILLT_s16*//*Label 4723*/ GIMT_Encode4(207368),
     /* 207360 */ /*GILLT_s32*//*Label 4724*/ GIMT_Encode4(207532),
     /* 207364 */ /*GILLT_s64*//*Label 4725*/ GIMT_Encode4(207688),
     /* 207368 */ // Label 4723: @207368
     /* 207368 */ GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(207531),
     /* 207373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 207376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207380 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(207432), // Rule ID 49 //
     /* 207385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207403 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 207407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207416 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 207416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm),
     /* 207419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207430 */     GIR_RootConstrainSelectedInstOperands,
     /* 207431 */     // GIR_Coverage, 49,
     /* 207431 */     GIR_EraseRootFromParent_Done,
     /* 207432 */   // Label 4728: @207432
     /* 207432 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(207484), // Rule ID 55 //
     /* 207437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207455 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 207459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207468 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 207468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm_EVEX),
     /* 207471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207482 */     GIR_RootConstrainSelectedInstOperands,
     /* 207483 */     // GIR_Coverage, 55,
     /* 207483 */     GIR_EraseRootFromParent_Done,
     /* 207484 */   // Label 4729: @207484
     /* 207484 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(207503), // Rule ID 61 //
     /* 207489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207496 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 207496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 207501 */     GIR_RootConstrainSelectedInstOperands,
     /* 207502 */     // GIR_Coverage, 61,
     /* 207502 */     GIR_Done,
     /* 207503 */   // Label 4730: @207503
     /* 207503 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(207530), // Rule ID 22988 //
     /* 207508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 207511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207515 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 207515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 207518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 207522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 207525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 207528 */     GIR_RootConstrainSelectedInstOperands,
     /* 207529 */     // GIR_Coverage, 22988,
     /* 207529 */     GIR_EraseRootFromParent_Done,
     /* 207530 */   // Label 4731: @207530
     /* 207530 */   GIM_Reject,
     /* 207531 */ // Label 4727: @207531
     /* 207531 */ GIM_Reject,
     /* 207532 */ // Label 4724: @207532
     /* 207532 */ GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(207687),
     /* 207537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207544 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(207596), // Rule ID 51 //
     /* 207549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207567 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 207571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207580 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 207580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm),
     /* 207583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207594 */     GIR_RootConstrainSelectedInstOperands,
     /* 207595 */     // GIR_Coverage, 51,
     /* 207595 */     GIR_EraseRootFromParent_Done,
     /* 207596 */   // Label 4733: @207596
     /* 207596 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(207648), // Rule ID 57 //
     /* 207601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207619 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 207623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207632 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 207632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm_EVEX),
     /* 207635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207646 */     GIR_RootConstrainSelectedInstOperands,
     /* 207647 */     // GIR_Coverage, 57,
     /* 207647 */     GIR_EraseRootFromParent_Done,
     /* 207648 */   // Label 4734: @207648
     /* 207648 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(207667), // Rule ID 5 //
     /* 207653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 207656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207660 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 207660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 207665 */     GIR_RootConstrainSelectedInstOperands,
     /* 207666 */     // GIR_Coverage, 5,
     /* 207666 */     GIR_Done,
     /* 207667 */   // Label 4735: @207667
     /* 207667 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(207686), // Rule ID 62 //
     /* 207672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207679 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 207679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 207684 */     GIR_RootConstrainSelectedInstOperands,
     /* 207685 */     // GIR_Coverage, 62,
     /* 207685 */     GIR_Done,
     /* 207686 */   // Label 4736: @207686
     /* 207686 */   GIM_Reject,
     /* 207687 */ // Label 4732: @207687
     /* 207687 */ GIM_Reject,
     /* 207688 */ // Label 4725: @207688
     /* 207688 */ GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(207843),
     /* 207693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207700 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(207752), // Rule ID 53 //
     /* 207705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207736 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 207736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm),
     /* 207739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207750 */     GIR_RootConstrainSelectedInstOperands,
     /* 207751 */     // GIR_Coverage, 53,
     /* 207751 */     GIR_EraseRootFromParent_Done,
     /* 207752 */   // Label 4738: @207752
     /* 207752 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(207804), // Rule ID 59 //
     /* 207757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207768 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207775 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207788 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 207788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm_EVEX),
     /* 207791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207802 */     GIR_RootConstrainSelectedInstOperands,
     /* 207803 */     // GIR_Coverage, 59,
     /* 207803 */     GIR_EraseRootFromParent_Done,
     /* 207804 */   // Label 4739: @207804
     /* 207804 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(207823), // Rule ID 6 //
     /* 207809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 207812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207816 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 207816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 207821 */     GIR_RootConstrainSelectedInstOperands,
     /* 207822 */     // GIR_Coverage, 6,
     /* 207822 */     GIR_Done,
     /* 207823 */   // Label 4740: @207823
     /* 207823 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(207842), // Rule ID 63 //
     /* 207828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207835 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 207835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 207840 */     GIR_RootConstrainSelectedInstOperands,
     /* 207841 */     // GIR_Coverage, 63,
     /* 207841 */     GIR_Done,
     /* 207842 */   // Label 4741: @207842
     /* 207842 */   GIM_Reject,
     /* 207843 */ // Label 4737: @207843
     /* 207843 */ GIM_Reject,
     /* 207844 */ // Label 4726: @207844
     /* 207844 */ GIM_Reject,
     /* 207845 */ // Label 67: @207845
     /* 207845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4755*/ GIMT_Encode4(210013),
     /* 207856 */ /*GILLT_s16*//*Label 4742*/ GIMT_Encode4(207940),
     /* 207860 */ /*GILLT_s32*//*Label 4743*/ GIMT_Encode4(208061),
     /* 207864 */ /*GILLT_s64*//*Label 4744*/ GIMT_Encode4(208417),
     /* 207868 */ /*GILLT_s80*//*Label 4745*/ GIMT_Encode4(208773), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207880 */ /*GILLT_v2s64*//*Label 4746*/ GIMT_Encode4(208810), GIMT_Encode4(0),
     /* 207888 */ /*GILLT_v4s32*//*Label 4747*/ GIMT_Encode4(209013),
     /* 207892 */ /*GILLT_v4s64*//*Label 4748*/ GIMT_Encode4(209216), GIMT_Encode4(0),
     /* 207900 */ /*GILLT_v8s16*//*Label 4749*/ GIMT_Encode4(209392),
     /* 207904 */ /*GILLT_v8s32*//*Label 4750*/ GIMT_Encode4(209481),
     /* 207908 */ /*GILLT_v8s64*//*Label 4751*/ GIMT_Encode4(209657), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207920 */ /*GILLT_v16s16*//*Label 4752*/ GIMT_Encode4(209746),
     /* 207924 */ /*GILLT_v16s32*//*Label 4753*/ GIMT_Encode4(209835), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207936 */ /*GILLT_v32s16*//*Label 4754*/ GIMT_Encode4(209924),
     /* 207940 */ // Label 4742: @207940
     /* 207940 */ GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(208060),
     /* 207945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 207948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 207952 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(208021), // Rule ID 21421 //
     /* 207957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 207960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207968 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207988 */     // (fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 207988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 207991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 208005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208019 */     GIR_RootConstrainSelectedInstOperands,
     /* 208020 */     // GIR_Coverage, 21421,
     /* 208020 */     GIR_EraseRootFromParent_Done,
     /* 208021 */   // Label 4757: @208021
     /* 208021 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(208059), // Rule ID 21419 //
     /* 208026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 208029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 208033 */     // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 208033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 208036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 208050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208057 */     GIR_RootConstrainSelectedInstOperands,
     /* 208058 */     // GIR_Coverage, 21419,
     /* 208058 */     GIR_EraseRootFromParent_Done,
     /* 208059 */   // Label 4758: @208059
     /* 208059 */   GIM_Reject,
     /* 208060 */ // Label 4756: @208060
     /* 208060 */ GIM_Reject,
     /* 208061 */ // Label 4743: @208061
     /* 208061 */ GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(208416),
     /* 208066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208069 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(208125), // Rule ID 2449 //
     /* 208074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 208077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208109 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 208109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 208112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 208118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208123 */     GIR_RootConstrainSelectedInstOperands,
     /* 208124 */     // GIR_Coverage, 2449,
     /* 208124 */     GIR_EraseRootFromParent_Done,
     /* 208125 */   // Label 4760: @208125
     /* 208125 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(208198), // Rule ID 18277 //
     /* 208130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 208133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208165 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 208165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 208182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208196 */     GIR_RootConstrainSelectedInstOperands,
     /* 208197 */     // GIR_Coverage, 18277,
     /* 208197 */     GIR_EraseRootFromParent_Done,
     /* 208198 */   // Label 4761: @208198
     /* 208198 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(208271), // Rule ID 21425 //
     /* 208203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 208206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208238 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 208238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 208255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208269 */     GIR_RootConstrainSelectedInstOperands,
     /* 208270 */     // GIR_Coverage, 21425,
     /* 208270 */     GIR_EraseRootFromParent_Done,
     /* 208271 */   // Label 4762: @208271
     /* 208271 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(208304), // Rule ID 1049 //
     /* 208276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 208279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 208283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 208287 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 208287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 208292 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208298 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208302 */     GIR_RootConstrainSelectedInstOperands,
     /* 208303 */     // GIR_Coverage, 1049,
     /* 208303 */     GIR_Done,
     /* 208304 */   // Label 4763: @208304
     /* 208304 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(208331), // Rule ID 2447 //
     /* 208309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 208312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208320 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 208320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 208325 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208329 */     GIR_RootConstrainSelectedInstOperands,
     /* 208330 */     // GIR_Coverage, 2447,
     /* 208330 */     GIR_Done,
     /* 208331 */   // Label 4764: @208331
     /* 208331 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(208373), // Rule ID 18275 //
     /* 208336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208347 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 208347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 208364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208371 */     GIR_RootConstrainSelectedInstOperands,
     /* 208372 */     // GIR_Coverage, 18275,
     /* 208372 */     GIR_EraseRootFromParent_Done,
     /* 208373 */   // Label 4765: @208373
     /* 208373 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(208415), // Rule ID 21423 //
     /* 208378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208389 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 208389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 208406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208413 */     GIR_RootConstrainSelectedInstOperands,
     /* 208414 */     // GIR_Coverage, 21423,
     /* 208414 */     GIR_EraseRootFromParent_Done,
     /* 208415 */   // Label 4766: @208415
     /* 208415 */   GIM_Reject,
     /* 208416 */ // Label 4759: @208416
     /* 208416 */ GIM_Reject,
     /* 208417 */ // Label 4744: @208417
     /* 208417 */ GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(208772),
     /* 208422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208425 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(208481), // Rule ID 2465 //
     /* 208430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 208433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208465 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 208465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 208468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 208474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208479 */     GIR_RootConstrainSelectedInstOperands,
     /* 208480 */     // GIR_Coverage, 2465,
     /* 208480 */     GIR_EraseRootFromParent_Done,
     /* 208481 */   // Label 4768: @208481
     /* 208481 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(208554), // Rule ID 18281 //
     /* 208486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 208489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208501 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208508 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208521 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 208521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 208538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208552 */     GIR_RootConstrainSelectedInstOperands,
     /* 208553 */     // GIR_Coverage, 18281,
     /* 208553 */     GIR_EraseRootFromParent_Done,
     /* 208554 */   // Label 4769: @208554
     /* 208554 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(208627), // Rule ID 21429 //
     /* 208559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 208562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208594 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 208594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 208611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208625 */     GIR_RootConstrainSelectedInstOperands,
     /* 208626 */     // GIR_Coverage, 21429,
     /* 208626 */     GIR_EraseRootFromParent_Done,
     /* 208627 */   // Label 4770: @208627
     /* 208627 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(208660), // Rule ID 1051 //
     /* 208632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208643 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 208643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 208648 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208654 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208658 */     GIR_RootConstrainSelectedInstOperands,
     /* 208659 */     // GIR_Coverage, 1051,
     /* 208659 */     GIR_Done,
     /* 208660 */   // Label 4771: @208660
     /* 208660 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(208687), // Rule ID 2463 //
     /* 208665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208676 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 208676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 208681 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208685 */     GIR_RootConstrainSelectedInstOperands,
     /* 208686 */     // GIR_Coverage, 2463,
     /* 208686 */     GIR_Done,
     /* 208687 */   // Label 4772: @208687
     /* 208687 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(208729), // Rule ID 18279 //
     /* 208692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208703 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 208703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 208720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208727 */     GIR_RootConstrainSelectedInstOperands,
     /* 208728 */     // GIR_Coverage, 18279,
     /* 208728 */     GIR_EraseRootFromParent_Done,
     /* 208729 */   // Label 4773: @208729
     /* 208729 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(208771), // Rule ID 21427 //
     /* 208734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208745 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 208745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 208762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208769 */     GIR_RootConstrainSelectedInstOperands,
     /* 208770 */     // GIR_Coverage, 21427,
     /* 208770 */     GIR_EraseRootFromParent_Done,
     /* 208771 */   // Label 4774: @208771
     /* 208771 */   GIM_Reject,
     /* 208772 */ // Label 4767: @208772
     /* 208772 */ GIM_Reject,
     /* 208773 */ // Label 4745: @208773
     /* 208773 */ GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(208809), // Rule ID 1053 //
     /* 208778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 208784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208792 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 208792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 208797 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208807 */   GIR_RootConstrainSelectedInstOperands,
     /* 208808 */   // GIR_Coverage, 1053,
     /* 208808 */   GIR_Done,
     /* 208809 */ // Label 4775: @208809
     /* 208809 */ GIM_Reject,
     /* 208810 */ // Label 4746: @208810
     /* 208810 */ GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(209012),
     /* 208815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208818 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(208874), // Rule ID 2469 //
     /* 208823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208845 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208858 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 208858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 208861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208872 */     GIR_RootConstrainSelectedInstOperands,
     /* 208873 */     // GIR_Coverage, 2469,
     /* 208873 */     GIR_EraseRootFromParent_Done,
     /* 208874 */   // Label 4777: @208874
     /* 208874 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(208930), // Rule ID 12087 //
     /* 208879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 208882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208901 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208914 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 208914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 208917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208928 */     GIR_RootConstrainSelectedInstOperands,
     /* 208929 */     // GIR_Coverage, 12087,
     /* 208929 */     GIR_EraseRootFromParent_Done,
     /* 208930 */   // Label 4778: @208930
     /* 208930 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(208957), // Rule ID 2467 //
     /* 208935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208946 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 208946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 208951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208955 */     GIR_RootConstrainSelectedInstOperands,
     /* 208956 */     // GIR_Coverage, 2467,
     /* 208956 */     GIR_Done,
     /* 208957 */   // Label 4779: @208957
     /* 208957 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(208984), // Rule ID 2475 //
     /* 208962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208973 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 208973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 208978 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208982 */     GIR_RootConstrainSelectedInstOperands,
     /* 208983 */     // GIR_Coverage, 2475,
     /* 208983 */     GIR_Done,
     /* 208984 */   // Label 4780: @208984
     /* 208984 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(209011), // Rule ID 12083 //
     /* 208989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 208992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209000 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 209000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 209005 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209009 */     GIR_RootConstrainSelectedInstOperands,
     /* 209010 */     // GIR_Coverage, 12083,
     /* 209010 */     GIR_Done,
     /* 209011 */   // Label 4781: @209011
     /* 209011 */   GIM_Reject,
     /* 209012 */ // Label 4776: @209012
     /* 209012 */ GIM_Reject,
     /* 209013 */ // Label 4747: @209013
     /* 209013 */ GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(209215),
     /* 209018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209021 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(209077), // Rule ID 2453 //
     /* 209026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209041 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209061 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 209061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 209064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209075 */     GIR_RootConstrainSelectedInstOperands,
     /* 209076 */     // GIR_Coverage, 2453,
     /* 209076 */     GIR_EraseRootFromParent_Done,
     /* 209077 */   // Label 4783: @209077
     /* 209077 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(209133), // Rule ID 12063 //
     /* 209082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209097 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209117 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 209117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 209120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209131 */     GIR_RootConstrainSelectedInstOperands,
     /* 209132 */     // GIR_Coverage, 12063,
     /* 209132 */     GIR_EraseRootFromParent_Done,
     /* 209133 */   // Label 4784: @209133
     /* 209133 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(209160), // Rule ID 2451 //
     /* 209138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209149 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 209149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 209154 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209158 */     GIR_RootConstrainSelectedInstOperands,
     /* 209159 */     // GIR_Coverage, 2451,
     /* 209159 */     GIR_Done,
     /* 209160 */   // Label 4785: @209160
     /* 209160 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(209187), // Rule ID 2459 //
     /* 209165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 209168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209176 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 209176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 209181 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209185 */     GIR_RootConstrainSelectedInstOperands,
     /* 209186 */     // GIR_Coverage, 2459,
     /* 209186 */     GIR_Done,
     /* 209187 */   // Label 4786: @209187
     /* 209187 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(209214), // Rule ID 12059 //
     /* 209192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209203 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 209203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 209208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209212 */     GIR_RootConstrainSelectedInstOperands,
     /* 209213 */     // GIR_Coverage, 12059,
     /* 209213 */     GIR_Done,
     /* 209214 */   // Label 4787: @209214
     /* 209214 */   GIM_Reject,
     /* 209215 */ // Label 4782: @209215
     /* 209215 */ GIM_Reject,
     /* 209216 */ // Label 4748: @209216
     /* 209216 */ GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(209391),
     /* 209221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 209224 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(209280), // Rule ID 2473 //
     /* 209229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209264 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 209264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 209267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209278 */     GIR_RootConstrainSelectedInstOperands,
     /* 209279 */     // GIR_Coverage, 2473,
     /* 209279 */     GIR_EraseRootFromParent_Done,
     /* 209280 */   // Label 4789: @209280
     /* 209280 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(209336), // Rule ID 12099 //
     /* 209285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209320 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 209320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 209323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209334 */     GIR_RootConstrainSelectedInstOperands,
     /* 209335 */     // GIR_Coverage, 12099,
     /* 209335 */     GIR_EraseRootFromParent_Done,
     /* 209336 */   // Label 4790: @209336
     /* 209336 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(209363), // Rule ID 2471 //
     /* 209341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209352 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 209352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 209357 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209361 */     GIR_RootConstrainSelectedInstOperands,
     /* 209362 */     // GIR_Coverage, 2471,
     /* 209362 */     GIR_Done,
     /* 209363 */   // Label 4791: @209363
     /* 209363 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(209390), // Rule ID 12095 //
     /* 209368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209379 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 209379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 209384 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209388 */     GIR_RootConstrainSelectedInstOperands,
     /* 209389 */     // GIR_Coverage, 12095,
     /* 209389 */     GIR_Done,
     /* 209390 */   // Label 4792: @209390
     /* 209390 */   GIM_Reject,
     /* 209391 */ // Label 4788: @209391
     /* 209391 */ GIM_Reject,
     /* 209392 */ // Label 4749: @209392
     /* 209392 */ GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(209480),
     /* 209397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 209400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209404 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(209456), // Rule ID 12015 //
     /* 209409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209440 */     // (fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 209440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 209443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209454 */     GIR_RootConstrainSelectedInstOperands,
     /* 209455 */     // GIR_Coverage, 12015,
     /* 209455 */     GIR_EraseRootFromParent_Done,
     /* 209456 */   // Label 4794: @209456
     /* 209456 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(209479), // Rule ID 12011 //
     /* 209461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209468 */     // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 209468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 209473 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209477 */     GIR_RootConstrainSelectedInstOperands,
     /* 209478 */     // GIR_Coverage, 12011,
     /* 209478 */     GIR_Done,
     /* 209479 */   // Label 4795: @209479
     /* 209479 */   GIM_Reject,
     /* 209480 */ // Label 4793: @209480
     /* 209480 */ GIM_Reject,
     /* 209481 */ // Label 4750: @209481
     /* 209481 */ GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(209656),
     /* 209486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 209489 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(209545), // Rule ID 2457 //
     /* 209494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209509 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209516 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209529 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 209529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 209532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209543 */     GIR_RootConstrainSelectedInstOperands,
     /* 209544 */     // GIR_Coverage, 2457,
     /* 209544 */     GIR_EraseRootFromParent_Done,
     /* 209545 */   // Label 4797: @209545
     /* 209545 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(209601), // Rule ID 12075 //
     /* 209550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209565 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209572 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209585 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 209585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 209588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209599 */     GIR_RootConstrainSelectedInstOperands,
     /* 209600 */     // GIR_Coverage, 12075,
     /* 209600 */     GIR_EraseRootFromParent_Done,
     /* 209601 */   // Label 4798: @209601
     /* 209601 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(209628), // Rule ID 2455 //
     /* 209606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209617 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 209617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 209622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209626 */     GIR_RootConstrainSelectedInstOperands,
     /* 209627 */     // GIR_Coverage, 2455,
     /* 209627 */     GIR_Done,
     /* 209628 */   // Label 4799: @209628
     /* 209628 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(209655), // Rule ID 12071 //
     /* 209633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209644 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 209644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 209649 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209653 */     GIR_RootConstrainSelectedInstOperands,
     /* 209654 */     // GIR_Coverage, 12071,
     /* 209654 */     GIR_Done,
     /* 209655 */   // Label 4800: @209655
     /* 209655 */   GIM_Reject,
     /* 209656 */ // Label 4796: @209656
     /* 209656 */ GIM_Reject,
     /* 209657 */ // Label 4751: @209657
     /* 209657 */ GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(209745),
     /* 209662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 209665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209669 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(209721), // Rule ID 12051 //
     /* 209674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209705 */     // (fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 209705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 209708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209710 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209719 */     GIR_RootConstrainSelectedInstOperands,
     /* 209720 */     // GIR_Coverage, 12051,
     /* 209720 */     GIR_EraseRootFromParent_Done,
     /* 209721 */   // Label 4802: @209721
     /* 209721 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(209744), // Rule ID 12047 //
     /* 209726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209733 */     // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 209733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 209738 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209742 */     GIR_RootConstrainSelectedInstOperands,
     /* 209743 */     // GIR_Coverage, 12047,
     /* 209743 */     GIR_Done,
     /* 209744 */   // Label 4803: @209744
     /* 209744 */   GIM_Reject,
     /* 209745 */ // Label 4801: @209745
     /* 209745 */ GIM_Reject,
     /* 209746 */ // Label 4752: @209746
     /* 209746 */ GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(209834),
     /* 209751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 209754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209758 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(209810), // Rule ID 12027 //
     /* 209763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209794 */     // (fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 209794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 209797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209808 */     GIR_RootConstrainSelectedInstOperands,
     /* 209809 */     // GIR_Coverage, 12027,
     /* 209809 */     GIR_EraseRootFromParent_Done,
     /* 209810 */   // Label 4805: @209810
     /* 209810 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(209833), // Rule ID 12023 //
     /* 209815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209822 */     // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 209822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 209827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209831 */     GIR_RootConstrainSelectedInstOperands,
     /* 209832 */     // GIR_Coverage, 12023,
     /* 209832 */     GIR_Done,
     /* 209833 */   // Label 4806: @209833
     /* 209833 */   GIM_Reject,
     /* 209834 */ // Label 4804: @209834
     /* 209834 */ GIM_Reject,
     /* 209835 */ // Label 4753: @209835
     /* 209835 */ GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(209923),
     /* 209840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 209843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209847 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(209899), // Rule ID 12039 //
     /* 209852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209883 */     // (fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 209883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 209886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209897 */     GIR_RootConstrainSelectedInstOperands,
     /* 209898 */     // GIR_Coverage, 12039,
     /* 209898 */     GIR_EraseRootFromParent_Done,
     /* 209899 */   // Label 4808: @209899
     /* 209899 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(209922), // Rule ID 12035 //
     /* 209904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209911 */     // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 209911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 209916 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209920 */     GIR_RootConstrainSelectedInstOperands,
     /* 209921 */     // GIR_Coverage, 12035,
     /* 209921 */     GIR_Done,
     /* 209922 */   // Label 4809: @209922
     /* 209922 */   GIM_Reject,
     /* 209923 */ // Label 4807: @209923
     /* 209923 */ GIM_Reject,
     /* 209924 */ // Label 4754: @209924
     /* 209924 */ GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(210012),
     /* 209929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 209932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209936 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(209988), // Rule ID 12003 //
     /* 209941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 209944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209972 */     // (fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 209972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 209975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209986 */     GIR_RootConstrainSelectedInstOperands,
     /* 209987 */     // GIR_Coverage, 12003,
     /* 209987 */     GIR_EraseRootFromParent_Done,
     /* 209988 */   // Label 4811: @209988
     /* 209988 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(210011), // Rule ID 11999 //
     /* 209993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 209996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210000 */     // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 210000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 210005 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210009 */     GIR_RootConstrainSelectedInstOperands,
     /* 210010 */     // GIR_Coverage, 11999,
     /* 210010 */     GIR_Done,
     /* 210011 */   // Label 4812: @210011
     /* 210011 */   GIM_Reject,
     /* 210012 */ // Label 4810: @210012
     /* 210012 */ GIM_Reject,
     /* 210013 */ // Label 4755: @210013
     /* 210013 */ GIM_Reject,
     /* 210014 */ // Label 68: @210014
     /* 210014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4826*/ GIMT_Encode4(214943),
     /* 210025 */ /*GILLT_s16*//*Label 4813*/ GIMT_Encode4(210109),
     /* 210029 */ /*GILLT_s32*//*Label 4814*/ GIMT_Encode4(210269),
     /* 210033 */ /*GILLT_s64*//*Label 4815*/ GIMT_Encode4(211174),
     /* 210037 */ /*GILLT_s80*//*Label 4816*/ GIMT_Encode4(212223), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210049 */ /*GILLT_v2s64*//*Label 4817*/ GIMT_Encode4(212789), GIMT_Encode4(0),
     /* 210057 */ /*GILLT_v4s32*//*Label 4818*/ GIMT_Encode4(213143),
     /* 210061 */ /*GILLT_v4s64*//*Label 4819*/ GIMT_Encode4(213497), GIMT_Encode4(0),
     /* 210069 */ /*GILLT_v8s16*//*Label 4820*/ GIMT_Encode4(213820),
     /* 210073 */ /*GILLT_v8s32*//*Label 4821*/ GIMT_Encode4(213980),
     /* 210077 */ /*GILLT_v8s64*//*Label 4822*/ GIMT_Encode4(214303), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210089 */ /*GILLT_v16s16*//*Label 4823*/ GIMT_Encode4(214463),
     /* 210093 */ /*GILLT_v16s32*//*Label 4824*/ GIMT_Encode4(214623), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210105 */ /*GILLT_v32s16*//*Label 4825*/ GIMT_Encode4(214783),
     /* 210109 */ // Label 4813: @210109
     /* 210109 */ GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(210268),
     /* 210114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 210117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 210120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210124 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(210182), // Rule ID 24249 //
     /* 210129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210164 */     // (strict_fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 210167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210180 */     GIR_RootConstrainSelectedInstOperands,
     /* 210181 */     // GIR_Coverage, 24249,
     /* 210181 */     GIR_EraseRootFromParent_Done,
     /* 210182 */   // Label 4828: @210182
     /* 210182 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(210240), // Rule ID 5954 //
     /* 210187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210222 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 210225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210238 */     GIR_RootConstrainSelectedInstOperands,
     /* 210239 */     // GIR_Coverage, 5954,
     /* 210239 */     GIR_EraseRootFromParent_Done,
     /* 210240 */   // Label 4829: @210240
     /* 210240 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(210267), // Rule ID 5952 //
     /* 210245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210256 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 210256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 210261 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210265 */     GIR_RootConstrainSelectedInstOperands,
     /* 210266 */     // GIR_Coverage, 5952,
     /* 210266 */     GIR_Done,
     /* 210267 */   // Label 4830: @210267
     /* 210267 */   GIM_Reject,
     /* 210268 */ // Label 4827: @210268
     /* 210268 */ GIM_Reject,
     /* 210269 */ // Label 4814: @210269
     /* 210269 */ GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(211173),
     /* 210274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210280 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(210345), // Rule ID 23246 //
     /* 210285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210300 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 210307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210324 */     // (strict_fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 210327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210343 */     GIR_RootConstrainSelectedInstOperands,
     /* 210344 */     // GIR_Coverage, 23246,
     /* 210344 */     GIR_EraseRootFromParent_Done,
     /* 210345 */   // Label 4832: @210345
     /* 210345 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(210410), // Rule ID 23248 //
     /* 210350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210365 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 210372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210389 */     // (strict_fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 210392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210408 */     GIR_RootConstrainSelectedInstOperands,
     /* 210409 */     // GIR_Coverage, 23248,
     /* 210409 */     GIR_EraseRootFromParent_Done,
     /* 210410 */   // Label 4833: @210410
     /* 210410 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(210475), // Rule ID 23236 //
     /* 210415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210454 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 210457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210473 */     GIR_RootConstrainSelectedInstOperands,
     /* 210474 */     // GIR_Coverage, 23236,
     /* 210474 */     GIR_EraseRootFromParent_Done,
     /* 210475 */   // Label 4834: @210475
     /* 210475 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(210537), // Rule ID 23381 //
     /* 210480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210519 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 210522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210535 */     GIR_RootConstrainSelectedInstOperands,
     /* 210536 */     // GIR_Coverage, 23381,
     /* 210536 */     GIR_EraseRootFromParent_Done,
     /* 210537 */   // Label 4835: @210537
     /* 210537 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(210599), // Rule ID 23385 //
     /* 210542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210581 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 210584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210597 */     GIR_RootConstrainSelectedInstOperands,
     /* 210598 */     // GIR_Coverage, 23385,
     /* 210598 */     GIR_EraseRootFromParent_Done,
     /* 210599 */   // Label 4836: @210599
     /* 210599 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(210661), // Rule ID 24245 //
     /* 210604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210622 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210626 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210643 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 210646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210659 */     GIR_RootConstrainSelectedInstOperands,
     /* 210660 */     // GIR_Coverage, 24245,
     /* 210660 */     GIR_EraseRootFromParent_Done,
     /* 210661 */   // Label 4837: @210661
     /* 210661 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(210726), // Rule ID 920 //
     /* 210666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210685 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 210692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210705 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 210708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210724 */     GIR_RootConstrainSelectedInstOperands,
     /* 210725 */     // GIR_Coverage, 920,
     /* 210725 */     GIR_EraseRootFromParent_Done,
     /* 210726 */   // Label 4838: @210726
     /* 210726 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(210791), // Rule ID 922 //
     /* 210731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210750 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 210757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210770 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 210773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210789 */     GIR_RootConstrainSelectedInstOperands,
     /* 210790 */     // GIR_Coverage, 922,
     /* 210790 */     GIR_EraseRootFromParent_Done,
     /* 210791 */   // Label 4839: @210791
     /* 210791 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(210856), // Rule ID 910 //
     /* 210796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210835 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 210838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210854 */     GIR_RootConstrainSelectedInstOperands,
     /* 210855 */     // GIR_Coverage, 910,
     /* 210855 */     GIR_EraseRootFromParent_Done,
     /* 210856 */   // Label 4840: @210856
     /* 210856 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(210918), // Rule ID 2160 //
     /* 210861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210900 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 210903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210916 */     GIR_RootConstrainSelectedInstOperands,
     /* 210917 */     // GIR_Coverage, 2160,
     /* 210917 */     GIR_EraseRootFromParent_Done,
     /* 210918 */   // Label 4841: @210918
     /* 210918 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(210980), // Rule ID 2168 //
     /* 210923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210962 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 210965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210978 */     GIR_RootConstrainSelectedInstOperands,
     /* 210979 */     // GIR_Coverage, 2168,
     /* 210979 */     GIR_EraseRootFromParent_Done,
     /* 210980 */   // Label 4842: @210980
     /* 210980 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(211042), // Rule ID 5916 //
     /* 210985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211024 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 211027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211031 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211040 */     GIR_RootConstrainSelectedInstOperands,
     /* 211041 */     // GIR_Coverage, 5916,
     /* 211041 */     GIR_EraseRootFromParent_Done,
     /* 211042 */   // Label 4843: @211042
     /* 211042 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(211079), // Rule ID 886 //
     /* 211047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211062 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 211062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 211067 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211073 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211077 */     GIR_RootConstrainSelectedInstOperands,
     /* 211078 */     // GIR_Coverage, 886,
     /* 211078 */     GIR_Done,
     /* 211079 */   // Label 4844: @211079
     /* 211079 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(211110), // Rule ID 2158 //
     /* 211084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211099 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 211104 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211108 */     GIR_RootConstrainSelectedInstOperands,
     /* 211109 */     // GIR_Coverage, 2158,
     /* 211109 */     GIR_Done,
     /* 211110 */   // Label 4845: @211110
     /* 211110 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(211141), // Rule ID 2166 //
     /* 211115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211130 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 211135 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211139 */     GIR_RootConstrainSelectedInstOperands,
     /* 211140 */     // GIR_Coverage, 2166,
     /* 211140 */     GIR_Done,
     /* 211141 */   // Label 4846: @211141
     /* 211141 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(211172), // Rule ID 5914 //
     /* 211146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211161 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 211161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 211166 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211170 */     GIR_RootConstrainSelectedInstOperands,
     /* 211171 */     // GIR_Coverage, 5914,
     /* 211171 */     GIR_Done,
     /* 211172 */   // Label 4847: @211172
     /* 211172 */   GIM_Reject,
     /* 211173 */ // Label 4831: @211173
     /* 211173 */ GIM_Reject,
     /* 211174 */ // Label 4815: @211174
     /* 211174 */ GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(212222),
     /* 211179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211185 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(211250), // Rule ID 23250 //
     /* 211190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211205 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 211212 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211229 */     // (strict_fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 211232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211234 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211248 */     GIR_RootConstrainSelectedInstOperands,
     /* 211249 */     // GIR_Coverage, 23250,
     /* 211249 */     GIR_EraseRootFromParent_Done,
     /* 211250 */   // Label 4849: @211250
     /* 211250 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(211315), // Rule ID 23252 //
     /* 211255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211270 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211294 */     // (strict_fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 211297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211313 */     GIR_RootConstrainSelectedInstOperands,
     /* 211314 */     // GIR_Coverage, 23252,
     /* 211314 */     GIR_EraseRootFromParent_Done,
     /* 211315 */   // Label 4850: @211315
     /* 211315 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(211380), // Rule ID 23238 //
     /* 211320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211335 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211342 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211359 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211378 */     GIR_RootConstrainSelectedInstOperands,
     /* 211379 */     // GIR_Coverage, 23238,
     /* 211379 */     GIR_EraseRootFromParent_Done,
     /* 211380 */   // Label 4851: @211380
     /* 211380 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(211452), // Rule ID 23240 //
     /* 211385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211403 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211407 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211431 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 211434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211450 */     GIR_RootConstrainSelectedInstOperands,
     /* 211451 */     // GIR_Coverage, 23240,
     /* 211451 */     GIR_EraseRootFromParent_Done,
     /* 211452 */   // Label 4852: @211452
     /* 211452 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(211514), // Rule ID 23383 //
     /* 211457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211496 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 211499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211501 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211512 */     GIR_RootConstrainSelectedInstOperands,
     /* 211513 */     // GIR_Coverage, 23383,
     /* 211513 */     GIR_EraseRootFromParent_Done,
     /* 211514 */   // Label 4853: @211514
     /* 211514 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(211576), // Rule ID 23387 //
     /* 211519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211534 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211558 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 211561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211574 */     GIR_RootConstrainSelectedInstOperands,
     /* 211575 */     // GIR_Coverage, 23387,
     /* 211575 */     GIR_EraseRootFromParent_Done,
     /* 211576 */   // Label 4854: @211576
     /* 211576 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(211638), // Rule ID 24247 //
     /* 211581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211596 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211620 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 211623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211636 */     GIR_RootConstrainSelectedInstOperands,
     /* 211637 */     // GIR_Coverage, 24247,
     /* 211637 */     GIR_EraseRootFromParent_Done,
     /* 211638 */   // Label 4855: @211638
     /* 211638 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(211703), // Rule ID 924 //
     /* 211643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211662 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 211669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211682 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 211685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211701 */     GIR_RootConstrainSelectedInstOperands,
     /* 211702 */     // GIR_Coverage, 924,
     /* 211702 */     GIR_EraseRootFromParent_Done,
     /* 211703 */   // Label 4856: @211703
     /* 211703 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(211768), // Rule ID 926 //
     /* 211708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211727 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211747 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 211750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211766 */     GIR_RootConstrainSelectedInstOperands,
     /* 211767 */     // GIR_Coverage, 926,
     /* 211767 */     GIR_EraseRootFromParent_Done,
     /* 211768 */   // Label 4857: @211768
     /* 211768 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(211833), // Rule ID 912 //
     /* 211773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211812 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 211815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211831 */     GIR_RootConstrainSelectedInstOperands,
     /* 211832 */     // GIR_Coverage, 912,
     /* 211832 */     GIR_EraseRootFromParent_Done,
     /* 211833 */   // Label 4858: @211833
     /* 211833 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(211905), // Rule ID 914 //
     /* 211838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211860 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211864 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211884 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 211887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211903 */     GIR_RootConstrainSelectedInstOperands,
     /* 211904 */     // GIR_Coverage, 914,
     /* 211904 */     GIR_EraseRootFromParent_Done,
     /* 211905 */   // Label 4859: @211905
     /* 211905 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(211967), // Rule ID 2164 //
     /* 211910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211949 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 211952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211954 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211965 */     GIR_RootConstrainSelectedInstOperands,
     /* 211966 */     // GIR_Coverage, 2164,
     /* 211966 */     GIR_EraseRootFromParent_Done,
     /* 211967 */   // Label 4860: @211967
     /* 211967 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(212029), // Rule ID 2172 //
     /* 211972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212011 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 212014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212027 */     GIR_RootConstrainSelectedInstOperands,
     /* 212028 */     // GIR_Coverage, 2172,
     /* 212028 */     GIR_EraseRootFromParent_Done,
     /* 212029 */   // Label 4861: @212029
     /* 212029 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(212091), // Rule ID 5935 //
     /* 212034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212073 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 212076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212089 */     GIR_RootConstrainSelectedInstOperands,
     /* 212090 */     // GIR_Coverage, 5935,
     /* 212090 */     GIR_EraseRootFromParent_Done,
     /* 212091 */   // Label 4862: @212091
     /* 212091 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(212128), // Rule ID 888 //
     /* 212096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 212099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212111 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 212111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 212116 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212122 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212126 */     GIR_RootConstrainSelectedInstOperands,
     /* 212127 */     // GIR_Coverage, 888,
     /* 212127 */     GIR_Done,
     /* 212128 */   // Label 4863: @212128
     /* 212128 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(212159), // Rule ID 2162 //
     /* 212133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 212136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212148 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 212153 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212157 */     GIR_RootConstrainSelectedInstOperands,
     /* 212158 */     // GIR_Coverage, 2162,
     /* 212158 */     GIR_Done,
     /* 212159 */   // Label 4864: @212159
     /* 212159 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(212190), // Rule ID 2170 //
     /* 212164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212179 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 212184 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212188 */     GIR_RootConstrainSelectedInstOperands,
     /* 212189 */     // GIR_Coverage, 2170,
     /* 212189 */     GIR_Done,
     /* 212190 */   // Label 4865: @212190
     /* 212190 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(212221), // Rule ID 5933 //
     /* 212195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212210 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 212210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 212215 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212219 */     GIR_RootConstrainSelectedInstOperands,
     /* 212220 */     // GIR_Coverage, 5933,
     /* 212220 */     GIR_Done,
     /* 212221 */   // Label 4866: @212221
     /* 212221 */   GIM_Reject,
     /* 212222 */ // Label 4848: @212222
     /* 212222 */ GIM_Reject,
     /* 212223 */ // Label 4816: @212223
     /* 212223 */ GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(212788),
     /* 212228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 212231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 212234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212238 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(212299), // Rule ID 23254 //
     /* 212243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212254 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 212261 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212278 */     // (strict_fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 212281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212283 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212297 */     GIR_RootConstrainSelectedInstOperands,
     /* 212298 */     // GIR_Coverage, 23254,
     /* 212298 */     GIR_EraseRootFromParent_Done,
     /* 212299 */   // Label 4868: @212299
     /* 212299 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(212360), // Rule ID 23256 //
     /* 212304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212315 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212339 */     // (strict_fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 212342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212358 */     GIR_RootConstrainSelectedInstOperands,
     /* 212359 */     // GIR_Coverage, 23256,
     /* 212359 */     GIR_EraseRootFromParent_Done,
     /* 212360 */   // Label 4869: @212360
     /* 212360 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(212428), // Rule ID 23242 //
     /* 212365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212379 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212383 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212407 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 212410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212426 */     GIR_RootConstrainSelectedInstOperands,
     /* 212427 */     // GIR_Coverage, 23242,
     /* 212427 */     GIR_EraseRootFromParent_Done,
     /* 212428 */   // Label 4870: @212428
     /* 212428 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(212496), // Rule ID 23244 //
     /* 212433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212447 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212451 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212475 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 212478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212494 */     GIR_RootConstrainSelectedInstOperands,
     /* 212495 */     // GIR_Coverage, 23244,
     /* 212495 */     GIR_EraseRootFromParent_Done,
     /* 212496 */   // Label 4871: @212496
     /* 212496 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(212557), // Rule ID 928 //
     /* 212501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212516 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 212523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212536 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 212539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212541 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212555 */     GIR_RootConstrainSelectedInstOperands,
     /* 212556 */     // GIR_Coverage, 928,
     /* 212556 */     GIR_EraseRootFromParent_Done,
     /* 212557 */   // Label 4872: @212557
     /* 212557 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(212618), // Rule ID 930 //
     /* 212562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212577 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212597 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 212600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212616 */     GIR_RootConstrainSelectedInstOperands,
     /* 212617 */     // GIR_Coverage, 930,
     /* 212617 */     GIR_EraseRootFromParent_Done,
     /* 212618 */   // Label 4873: @212618
     /* 212618 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(212686), // Rule ID 916 //
     /* 212623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212641 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212645 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212652 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212665 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 212668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212670 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212684 */     GIR_RootConstrainSelectedInstOperands,
     /* 212685 */     // GIR_Coverage, 916,
     /* 212685 */     GIR_EraseRootFromParent_Done,
     /* 212686 */   // Label 4874: @212686
     /* 212686 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(212754), // Rule ID 918 //
     /* 212691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212709 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212713 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212733 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 212736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212752 */     GIR_RootConstrainSelectedInstOperands,
     /* 212753 */     // GIR_Coverage, 918,
     /* 212753 */     GIR_EraseRootFromParent_Done,
     /* 212754 */   // Label 4875: @212754
     /* 212754 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(212787), // Rule ID 890 //
     /* 212759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212770 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 212770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 212775 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212781 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212785 */     GIR_RootConstrainSelectedInstOperands,
     /* 212786 */     // GIR_Coverage, 890,
     /* 212786 */     GIR_Done,
     /* 212787 */   // Label 4876: @212787
     /* 212787 */   GIM_Reject,
     /* 212788 */ // Label 4867: @212788
     /* 212788 */ GIM_Reject,
     /* 212789 */ // Label 4817: @212789
     /* 212789 */ GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(213142),
     /* 212794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 212797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212800 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(212862), // Rule ID 23371 //
     /* 212805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212844 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 212847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212849 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212860 */     GIR_RootConstrainSelectedInstOperands,
     /* 212861 */     // GIR_Coverage, 23371,
     /* 212861 */     GIR_EraseRootFromParent_Done,
     /* 212862 */   // Label 4878: @212862
     /* 212862 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(212924), // Rule ID 24295 //
     /* 212867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212906 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 212909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212922 */     GIR_RootConstrainSelectedInstOperands,
     /* 212923 */     // GIR_Coverage, 24295,
     /* 212923 */     GIR_EraseRootFromParent_Done,
     /* 212924 */   // Label 4879: @212924
     /* 212924 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(212986), // Rule ID 2140 //
     /* 212929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212968 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 212971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212984 */     GIR_RootConstrainSelectedInstOperands,
     /* 212985 */     // GIR_Coverage, 2140,
     /* 212985 */     GIR_EraseRootFromParent_Done,
     /* 212986 */   // Label 4880: @212986
     /* 212986 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(213048), // Rule ID 6308 //
     /* 212991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213030 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 213033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213046 */     GIR_RootConstrainSelectedInstOperands,
     /* 213047 */     // GIR_Coverage, 6308,
     /* 213047 */     GIR_EraseRootFromParent_Done,
     /* 213048 */   // Label 4881: @213048
     /* 213048 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(213079), // Rule ID 2138 //
     /* 213053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213068 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 213068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 213073 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213077 */     GIR_RootConstrainSelectedInstOperands,
     /* 213078 */     // GIR_Coverage, 2138,
     /* 213078 */     GIR_Done,
     /* 213079 */   // Label 4882: @213079
     /* 213079 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(213110), // Rule ID 2154 //
     /* 213084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 213087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213099 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 213099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 213104 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213108 */     GIR_RootConstrainSelectedInstOperands,
     /* 213109 */     // GIR_Coverage, 2154,
     /* 213109 */     GIR_Done,
     /* 213110 */   // Label 4883: @213110
     /* 213110 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(213141), // Rule ID 6304 //
     /* 213115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213130 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 213130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 213135 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213139 */     GIR_RootConstrainSelectedInstOperands,
     /* 213140 */     // GIR_Coverage, 6304,
     /* 213140 */     GIR_Done,
     /* 213141 */   // Label 4884: @213141
     /* 213141 */   GIM_Reject,
     /* 213142 */ // Label 4877: @213142
     /* 213142 */ GIM_Reject,
     /* 213143 */ // Label 4818: @213143
     /* 213143 */ GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(213496),
     /* 213148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 213151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213154 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(213216), // Rule ID 23369 //
     /* 213159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213198 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 213201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213214 */     GIR_RootConstrainSelectedInstOperands,
     /* 213215 */     // GIR_Coverage, 23369,
     /* 213215 */     GIR_EraseRootFromParent_Done,
     /* 213216 */   // Label 4886: @213216
     /* 213216 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(213278), // Rule ID 24279 //
     /* 213221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213260 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 213263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213276 */     GIR_RootConstrainSelectedInstOperands,
     /* 213277 */     // GIR_Coverage, 24279,
     /* 213277 */     GIR_EraseRootFromParent_Done,
     /* 213278 */   // Label 4887: @213278
     /* 213278 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(213340), // Rule ID 2136 //
     /* 213283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213309 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213322 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 213325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213338 */     GIR_RootConstrainSelectedInstOperands,
     /* 213339 */     // GIR_Coverage, 2136,
     /* 213339 */     GIR_EraseRootFromParent_Done,
     /* 213340 */   // Label 4888: @213340
     /* 213340 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(213402), // Rule ID 6284 //
     /* 213345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213384 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 213387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213400 */     GIR_RootConstrainSelectedInstOperands,
     /* 213401 */     // GIR_Coverage, 6284,
     /* 213401 */     GIR_EraseRootFromParent_Done,
     /* 213402 */   // Label 4889: @213402
     /* 213402 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(213433), // Rule ID 2134 //
     /* 213407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213422 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 213422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 213427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213431 */     GIR_RootConstrainSelectedInstOperands,
     /* 213432 */     // GIR_Coverage, 2134,
     /* 213432 */     GIR_Done,
     /* 213433 */   // Label 4890: @213433
     /* 213433 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(213464), // Rule ID 2150 //
     /* 213438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 213441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213453 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 213453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 213458 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213462 */     GIR_RootConstrainSelectedInstOperands,
     /* 213463 */     // GIR_Coverage, 2150,
     /* 213463 */     GIR_Done,
     /* 213464 */   // Label 4891: @213464
     /* 213464 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(213495), // Rule ID 6280 //
     /* 213469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213484 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 213484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 213489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213493 */     GIR_RootConstrainSelectedInstOperands,
     /* 213494 */     // GIR_Coverage, 6280,
     /* 213494 */     GIR_Done,
     /* 213495 */   // Label 4892: @213495
     /* 213495 */   GIM_Reject,
     /* 213496 */ // Label 4885: @213496
     /* 213496 */ GIM_Reject,
     /* 213497 */ // Label 4819: @213497
     /* 213497 */ GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(213819),
     /* 213502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 213505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 213508 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(213570), // Rule ID 23375 //
     /* 213513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213552 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 213555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213557 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213568 */     GIR_RootConstrainSelectedInstOperands,
     /* 213569 */     // GIR_Coverage, 23375,
     /* 213569 */     GIR_EraseRootFromParent_Done,
     /* 213570 */   // Label 4894: @213570
     /* 213570 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(213632), // Rule ID 24303 //
     /* 213575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213614 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 213617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213630 */     GIR_RootConstrainSelectedInstOperands,
     /* 213631 */     // GIR_Coverage, 24303,
     /* 213631 */     GIR_EraseRootFromParent_Done,
     /* 213632 */   // Label 4895: @213632
     /* 213632 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(213694), // Rule ID 2148 //
     /* 213637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213676 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213692 */     GIR_RootConstrainSelectedInstOperands,
     /* 213693 */     // GIR_Coverage, 2148,
     /* 213693 */     GIR_EraseRootFromParent_Done,
     /* 213694 */   // Label 4896: @213694
     /* 213694 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(213756), // Rule ID 6320 //
     /* 213699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213738 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 213741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213754 */     GIR_RootConstrainSelectedInstOperands,
     /* 213755 */     // GIR_Coverage, 6320,
     /* 213755 */     GIR_EraseRootFromParent_Done,
     /* 213756 */   // Label 4897: @213756
     /* 213756 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(213787), // Rule ID 2146 //
     /* 213761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213776 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 213776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 213781 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213785 */     GIR_RootConstrainSelectedInstOperands,
     /* 213786 */     // GIR_Coverage, 2146,
     /* 213786 */     GIR_Done,
     /* 213787 */   // Label 4898: @213787
     /* 213787 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(213818), // Rule ID 6316 //
     /* 213792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213807 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 213807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 213812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213816 */     GIR_RootConstrainSelectedInstOperands,
     /* 213817 */     // GIR_Coverage, 6316,
     /* 213817 */     GIR_Done,
     /* 213818 */   // Label 4899: @213818
     /* 213818 */   GIM_Reject,
     /* 213819 */ // Label 4893: @213819
     /* 213819 */ GIM_Reject,
     /* 213820 */ // Label 4820: @213820
     /* 213820 */ GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(213979),
     /* 213825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213835 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(213893), // Rule ID 24319 //
     /* 213840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213875 */     // (strict_fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 213878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213891 */     GIR_RootConstrainSelectedInstOperands,
     /* 213892 */     // GIR_Coverage, 24319,
     /* 213892 */     GIR_EraseRootFromParent_Done,
     /* 213893 */   // Label 4901: @213893
     /* 213893 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(213951), // Rule ID 6344 //
     /* 213898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213933 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 213936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213949 */     GIR_RootConstrainSelectedInstOperands,
     /* 213950 */     // GIR_Coverage, 6344,
     /* 213950 */     GIR_EraseRootFromParent_Done,
     /* 213951 */   // Label 4902: @213951
     /* 213951 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(213978), // Rule ID 6340 //
     /* 213956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213967 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 213967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 213972 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213976 */     GIR_RootConstrainSelectedInstOperands,
     /* 213977 */     // GIR_Coverage, 6340,
     /* 213977 */     GIR_Done,
     /* 213978 */   // Label 4903: @213978
     /* 213978 */   GIM_Reject,
     /* 213979 */ // Label 4900: @213979
     /* 213979 */ GIM_Reject,
     /* 213980 */ // Label 4821: @213980
     /* 213980 */ GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(214302),
     /* 213985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 213988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 213991 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(214053), // Rule ID 23373 //
     /* 213996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214011 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214014 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214018 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214035 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 214038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214051 */     GIR_RootConstrainSelectedInstOperands,
     /* 214052 */     // GIR_Coverage, 23373,
     /* 214052 */     GIR_EraseRootFromParent_Done,
     /* 214053 */   // Label 4905: @214053
     /* 214053 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(214115), // Rule ID 24287 //
     /* 214058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214073 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214076 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214080 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214097 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 214100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214102 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214113 */     GIR_RootConstrainSelectedInstOperands,
     /* 214114 */     // GIR_Coverage, 24287,
     /* 214114 */     GIR_EraseRootFromParent_Done,
     /* 214115 */   // Label 4906: @214115
     /* 214115 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(214177), // Rule ID 2144 //
     /* 214120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214159 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 214162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214175 */     GIR_RootConstrainSelectedInstOperands,
     /* 214176 */     // GIR_Coverage, 2144,
     /* 214176 */     GIR_EraseRootFromParent_Done,
     /* 214177 */   // Label 4907: @214177
     /* 214177 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(214239), // Rule ID 6296 //
     /* 214182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214221 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 214224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214237 */     GIR_RootConstrainSelectedInstOperands,
     /* 214238 */     // GIR_Coverage, 6296,
     /* 214238 */     GIR_EraseRootFromParent_Done,
     /* 214239 */   // Label 4908: @214239
     /* 214239 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(214270), // Rule ID 2142 //
     /* 214244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214259 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 214259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 214264 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214268 */     GIR_RootConstrainSelectedInstOperands,
     /* 214269 */     // GIR_Coverage, 2142,
     /* 214269 */     GIR_Done,
     /* 214270 */   // Label 4909: @214270
     /* 214270 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(214301), // Rule ID 6292 //
     /* 214275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214290 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 214290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 214295 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214299 */     GIR_RootConstrainSelectedInstOperands,
     /* 214300 */     // GIR_Coverage, 6292,
     /* 214300 */     GIR_Done,
     /* 214301 */   // Label 4910: @214301
     /* 214301 */   GIM_Reject,
     /* 214302 */ // Label 4904: @214302
     /* 214302 */ GIM_Reject,
     /* 214303 */ // Label 4822: @214303
     /* 214303 */ GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(214462),
     /* 214308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 214311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 214314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214318 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(214376), // Rule ID 24271 //
     /* 214323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214358 */     // (strict_fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 214361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214374 */     GIR_RootConstrainSelectedInstOperands,
     /* 214375 */     // GIR_Coverage, 24271,
     /* 214375 */     GIR_EraseRootFromParent_Done,
     /* 214376 */   // Label 4912: @214376
     /* 214376 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(214434), // Rule ID 6272 //
     /* 214381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214416 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 214419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214432 */     GIR_RootConstrainSelectedInstOperands,
     /* 214433 */     // GIR_Coverage, 6272,
     /* 214433 */     GIR_EraseRootFromParent_Done,
     /* 214434 */   // Label 4913: @214434
     /* 214434 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(214461), // Rule ID 6268 //
     /* 214439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214450 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 214450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 214455 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214459 */     GIR_RootConstrainSelectedInstOperands,
     /* 214460 */     // GIR_Coverage, 6268,
     /* 214460 */     GIR_Done,
     /* 214461 */   // Label 4914: @214461
     /* 214461 */   GIM_Reject,
     /* 214462 */ // Label 4911: @214462
     /* 214462 */ GIM_Reject,
     /* 214463 */ // Label 4823: @214463
     /* 214463 */ GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(214622),
     /* 214468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 214471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 214474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214478 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(214536), // Rule ID 24327 //
     /* 214483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214518 */     // (strict_fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 214521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214523 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214534 */     GIR_RootConstrainSelectedInstOperands,
     /* 214535 */     // GIR_Coverage, 24327,
     /* 214535 */     GIR_EraseRootFromParent_Done,
     /* 214536 */   // Label 4916: @214536
     /* 214536 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(214594), // Rule ID 6356 //
     /* 214541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214576 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 214579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214592 */     GIR_RootConstrainSelectedInstOperands,
     /* 214593 */     // GIR_Coverage, 6356,
     /* 214593 */     GIR_EraseRootFromParent_Done,
     /* 214594 */   // Label 4917: @214594
     /* 214594 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(214621), // Rule ID 6352 //
     /* 214599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214610 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 214610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 214615 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214619 */     GIR_RootConstrainSelectedInstOperands,
     /* 214620 */     // GIR_Coverage, 6352,
     /* 214620 */     GIR_Done,
     /* 214621 */   // Label 4918: @214621
     /* 214621 */   GIM_Reject,
     /* 214622 */ // Label 4915: @214622
     /* 214622 */ GIM_Reject,
     /* 214623 */ // Label 4824: @214623
     /* 214623 */ GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(214782),
     /* 214628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 214631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 214634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214638 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(214696), // Rule ID 24263 //
     /* 214643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214678 */     // (strict_fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 214681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214683 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214694 */     GIR_RootConstrainSelectedInstOperands,
     /* 214695 */     // GIR_Coverage, 24263,
     /* 214695 */     GIR_EraseRootFromParent_Done,
     /* 214696 */   // Label 4920: @214696
     /* 214696 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(214754), // Rule ID 6260 //
     /* 214701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214736 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 214739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214752 */     GIR_RootConstrainSelectedInstOperands,
     /* 214753 */     // GIR_Coverage, 6260,
     /* 214753 */     GIR_EraseRootFromParent_Done,
     /* 214754 */   // Label 4921: @214754
     /* 214754 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(214781), // Rule ID 6256 //
     /* 214759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214770 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 214770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 214775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214779 */     GIR_RootConstrainSelectedInstOperands,
     /* 214780 */     // GIR_Coverage, 6256,
     /* 214780 */     GIR_Done,
     /* 214781 */   // Label 4922: @214781
     /* 214781 */   GIM_Reject,
     /* 214782 */ // Label 4919: @214782
     /* 214782 */ GIM_Reject,
     /* 214783 */ // Label 4825: @214783
     /* 214783 */ GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(214942),
     /* 214788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 214791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 214794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214798 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(214856), // Rule ID 24311 //
     /* 214803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214838 */     // (strict_fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 214841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214843 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214854 */     GIR_RootConstrainSelectedInstOperands,
     /* 214855 */     // GIR_Coverage, 24311,
     /* 214855 */     GIR_EraseRootFromParent_Done,
     /* 214856 */   // Label 4924: @214856
     /* 214856 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(214914), // Rule ID 6332 //
     /* 214861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214896 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 214899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214912 */     GIR_RootConstrainSelectedInstOperands,
     /* 214913 */     // GIR_Coverage, 6332,
     /* 214913 */     GIR_EraseRootFromParent_Done,
     /* 214914 */   // Label 4925: @214914
     /* 214914 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(214941), // Rule ID 6328 //
     /* 214919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214930 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 214930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 214935 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214939 */     GIR_RootConstrainSelectedInstOperands,
     /* 214940 */     // GIR_Coverage, 6328,
     /* 214940 */     GIR_Done,
     /* 214941 */   // Label 4926: @214941
     /* 214941 */   GIM_Reject,
     /* 214942 */ // Label 4923: @214942
     /* 214942 */ GIM_Reject,
     /* 214943 */ // Label 4826: @214943
     /* 214943 */ GIM_Reject,
     /* 214944 */ // Label 69: @214944
     /* 214944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4940*/ GIMT_Encode4(218633),
     /* 214955 */ /*GILLT_s16*//*Label 4927*/ GIMT_Encode4(215039),
     /* 214959 */ /*GILLT_s32*//*Label 4928*/ GIMT_Encode4(215137),
     /* 214963 */ /*GILLT_s64*//*Label 4929*/ GIMT_Encode4(215856),
     /* 214967 */ /*GILLT_s80*//*Label 4930*/ GIMT_Encode4(216719), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 214979 */ /*GILLT_v2s64*//*Label 4931*/ GIMT_Encode4(217285), GIMT_Encode4(0),
     /* 214987 */ /*GILLT_v4s32*//*Label 4932*/ GIMT_Encode4(217515),
     /* 214991 */ /*GILLT_v4s64*//*Label 4933*/ GIMT_Encode4(217745), GIMT_Encode4(0),
     /* 214999 */ /*GILLT_v8s16*//*Label 4934*/ GIMT_Encode4(217944),
     /* 215003 */ /*GILLT_v8s32*//*Label 4935*/ GIMT_Encode4(218042),
     /* 215007 */ /*GILLT_v8s64*//*Label 4936*/ GIMT_Encode4(218241), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 215019 */ /*GILLT_v16s16*//*Label 4937*/ GIMT_Encode4(218339),
     /* 215023 */ /*GILLT_v16s32*//*Label 4938*/ GIMT_Encode4(218437), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 215035 */ /*GILLT_v32s16*//*Label 4939*/ GIMT_Encode4(218535),
     /* 215039 */ // Label 4927: @215039
     /* 215039 */ GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(215136),
     /* 215044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 215047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 215050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215058 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(215112), // Rule ID 6068 //
     /* 215063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 215066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215094 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 215097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215110 */     GIR_RootConstrainSelectedInstOperands,
     /* 215111 */     // GIR_Coverage, 6068,
     /* 215111 */     GIR_EraseRootFromParent_Done,
     /* 215112 */   // Label 4942: @215112
     /* 215112 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(215135), // Rule ID 6066 //
     /* 215117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 215120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215124 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 215124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 215129 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215133 */     GIR_RootConstrainSelectedInstOperands,
     /* 215134 */     // GIR_Coverage, 6066,
     /* 215134 */     GIR_Done,
     /* 215135 */   // Label 4943: @215135
     /* 215135 */   GIM_Reject,
     /* 215136 */ // Label 4941: @215136
     /* 215136 */ GIM_Reject,
     /* 215137 */ // Label 4928: @215137
     /* 215137 */ GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(215855),
     /* 215142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 215145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 215148 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(215213), // Rule ID 964 //
     /* 215153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215168 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215192 */     // (strict_fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m32),
     /* 215195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215211 */     GIR_RootConstrainSelectedInstOperands,
     /* 215212 */     // GIR_Coverage, 964,
     /* 215212 */     GIR_EraseRootFromParent_Done,
     /* 215213 */   // Label 4945: @215213
     /* 215213 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(215278), // Rule ID 966 //
     /* 215218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215233 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215257 */     // (strict_fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m32),
     /* 215260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215262 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215276 */     GIR_RootConstrainSelectedInstOperands,
     /* 215277 */     // GIR_Coverage, 966,
     /* 215277 */     GIR_EraseRootFromParent_Done,
     /* 215278 */   // Label 4946: @215278
     /* 215278 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(215343), // Rule ID 954 //
     /* 215283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215322 */     // (strict_fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 215325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215341 */     GIR_RootConstrainSelectedInstOperands,
     /* 215342 */     // GIR_Coverage, 954,
     /* 215342 */     GIR_EraseRootFromParent_Done,
     /* 215343 */   // Label 4947: @215343
     /* 215343 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(215408), // Rule ID 942 //
     /* 215348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215367 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215387 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m32),
     /* 215390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215406 */     GIR_RootConstrainSelectedInstOperands,
     /* 215407 */     // GIR_Coverage, 942,
     /* 215407 */     GIR_EraseRootFromParent_Done,
     /* 215408 */   // Label 4948: @215408
     /* 215408 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(215473), // Rule ID 944 //
     /* 215413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215432 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215452 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m32),
     /* 215455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215471 */     GIR_RootConstrainSelectedInstOperands,
     /* 215472 */     // GIR_Coverage, 944,
     /* 215472 */     GIR_EraseRootFromParent_Done,
     /* 215473 */   // Label 4949: @215473
     /* 215473 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(215538), // Rule ID 932 //
     /* 215478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215497 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215504 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215517 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 215520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215536 */     GIR_RootConstrainSelectedInstOperands,
     /* 215537 */     // GIR_Coverage, 932,
     /* 215537 */     GIR_EraseRootFromParent_Done,
     /* 215538 */   // Label 4950: @215538
     /* 215538 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(215600), // Rule ID 2240 //
     /* 215543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215582 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 215585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215598 */     GIR_RootConstrainSelectedInstOperands,
     /* 215599 */     // GIR_Coverage, 2240,
     /* 215599 */     GIR_EraseRootFromParent_Done,
     /* 215600 */   // Label 4951: @215600
     /* 215600 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(215662), // Rule ID 2248 //
     /* 215605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215644 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 215647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215660 */     GIR_RootConstrainSelectedInstOperands,
     /* 215661 */     // GIR_Coverage, 2248,
     /* 215661 */     GIR_EraseRootFromParent_Done,
     /* 215662 */   // Label 4952: @215662
     /* 215662 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(215724), // Rule ID 6030 //
     /* 215667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215689 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215693 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215706 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 215709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215711 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215722 */     GIR_RootConstrainSelectedInstOperands,
     /* 215723 */     // GIR_Coverage, 6030,
     /* 215723 */     GIR_EraseRootFromParent_Done,
     /* 215724 */   // Label 4953: @215724
     /* 215724 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(215761), // Rule ID 892 //
     /* 215729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215744 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 215744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 215749 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215759 */     GIR_RootConstrainSelectedInstOperands,
     /* 215760 */     // GIR_Coverage, 892,
     /* 215760 */     GIR_Done,
     /* 215761 */   // Label 4954: @215761
     /* 215761 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(215792), // Rule ID 2238 //
     /* 215766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215781 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 215781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 215786 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215790 */     GIR_RootConstrainSelectedInstOperands,
     /* 215791 */     // GIR_Coverage, 2238,
     /* 215791 */     GIR_Done,
     /* 215792 */   // Label 4955: @215792
     /* 215792 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(215823), // Rule ID 2246 //
     /* 215797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215812 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 215812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 215817 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215821 */     GIR_RootConstrainSelectedInstOperands,
     /* 215822 */     // GIR_Coverage, 2246,
     /* 215822 */     GIR_Done,
     /* 215823 */   // Label 4956: @215823
     /* 215823 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(215854), // Rule ID 6028 //
     /* 215828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215843 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 215843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 215848 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215852 */     GIR_RootConstrainSelectedInstOperands,
     /* 215853 */     // GIR_Coverage, 6028,
     /* 215853 */     GIR_Done,
     /* 215854 */   // Label 4957: @215854
     /* 215854 */   GIM_Reject,
     /* 215855 */ // Label 4944: @215855
     /* 215855 */ GIM_Reject,
     /* 215856 */ // Label 4929: @215856
     /* 215856 */ GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(216718),
     /* 215861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 215864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215867 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(215932), // Rule ID 968 //
     /* 215872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215887 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215911 */     // (strict_fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m64),
     /* 215914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215930 */     GIR_RootConstrainSelectedInstOperands,
     /* 215931 */     // GIR_Coverage, 968,
     /* 215931 */     GIR_EraseRootFromParent_Done,
     /* 215932 */   // Label 4959: @215932
     /* 215932 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(215997), // Rule ID 970 //
     /* 215937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215952 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215976 */     // (strict_fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m64),
     /* 215979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215995 */     GIR_RootConstrainSelectedInstOperands,
     /* 215996 */     // GIR_Coverage, 970,
     /* 215996 */     GIR_EraseRootFromParent_Done,
     /* 215997 */   // Label 4960: @215997
     /* 215997 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(216062), // Rule ID 956 //
     /* 216002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216041 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 216044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216060 */     GIR_RootConstrainSelectedInstOperands,
     /* 216061 */     // GIR_Coverage, 956,
     /* 216061 */     GIR_EraseRootFromParent_Done,
     /* 216062 */   // Label 4961: @216062
     /* 216062 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(216134), // Rule ID 958 //
     /* 216067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216085 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216089 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216113 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 216116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216132 */     GIR_RootConstrainSelectedInstOperands,
     /* 216133 */     // GIR_Coverage, 958,
     /* 216133 */     GIR_EraseRootFromParent_Done,
     /* 216134 */   // Label 4962: @216134
     /* 216134 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(216199), // Rule ID 946 //
     /* 216139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216158 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 216165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216178 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m64),
     /* 216181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216197 */     GIR_RootConstrainSelectedInstOperands,
     /* 216198 */     // GIR_Coverage, 946,
     /* 216198 */     GIR_EraseRootFromParent_Done,
     /* 216199 */   // Label 4963: @216199
     /* 216199 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(216264), // Rule ID 948 //
     /* 216204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216223 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216243 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m64),
     /* 216246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216262 */     GIR_RootConstrainSelectedInstOperands,
     /* 216263 */     // GIR_Coverage, 948,
     /* 216263 */     GIR_EraseRootFromParent_Done,
     /* 216264 */   // Label 4964: @216264
     /* 216264 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(216329), // Rule ID 934 //
     /* 216269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216308 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 216311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216327 */     GIR_RootConstrainSelectedInstOperands,
     /* 216328 */     // GIR_Coverage, 934,
     /* 216328 */     GIR_EraseRootFromParent_Done,
     /* 216329 */   // Label 4965: @216329
     /* 216329 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(216401), // Rule ID 936 //
     /* 216334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216356 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216360 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216380 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 216383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216399 */     GIR_RootConstrainSelectedInstOperands,
     /* 216400 */     // GIR_Coverage, 936,
     /* 216400 */     GIR_EraseRootFromParent_Done,
     /* 216401 */   // Label 4966: @216401
     /* 216401 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(216463), // Rule ID 2244 //
     /* 216406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 216409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216425 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216432 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216445 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 216448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216461 */     GIR_RootConstrainSelectedInstOperands,
     /* 216462 */     // GIR_Coverage, 2244,
     /* 216462 */     GIR_EraseRootFromParent_Done,
     /* 216463 */   // Label 4967: @216463
     /* 216463 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(216525), // Rule ID 2252 //
     /* 216468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216507 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 216510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216523 */     GIR_RootConstrainSelectedInstOperands,
     /* 216524 */     // GIR_Coverage, 2252,
     /* 216524 */     GIR_EraseRootFromParent_Done,
     /* 216525 */   // Label 4968: @216525
     /* 216525 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(216587), // Rule ID 6049 //
     /* 216530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216556 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216569 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 216572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216585 */     GIR_RootConstrainSelectedInstOperands,
     /* 216586 */     // GIR_Coverage, 6049,
     /* 216586 */     GIR_EraseRootFromParent_Done,
     /* 216587 */   // Label 4969: @216587
     /* 216587 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(216624), // Rule ID 894 //
     /* 216592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216607 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 216607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 216612 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 216618 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 216622 */     GIR_RootConstrainSelectedInstOperands,
     /* 216623 */     // GIR_Coverage, 894,
     /* 216623 */     GIR_Done,
     /* 216624 */   // Label 4970: @216624
     /* 216624 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(216655), // Rule ID 2242 //
     /* 216629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 216632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216644 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 216644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 216649 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216653 */     GIR_RootConstrainSelectedInstOperands,
     /* 216654 */     // GIR_Coverage, 2242,
     /* 216654 */     GIR_Done,
     /* 216655 */   // Label 4971: @216655
     /* 216655 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(216686), // Rule ID 2250 //
     /* 216660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216675 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 216675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 216680 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216684 */     GIR_RootConstrainSelectedInstOperands,
     /* 216685 */     // GIR_Coverage, 2250,
     /* 216685 */     GIR_Done,
     /* 216686 */   // Label 4972: @216686
     /* 216686 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(216717), // Rule ID 6047 //
     /* 216691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216706 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 216706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 216711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216715 */     GIR_RootConstrainSelectedInstOperands,
     /* 216716 */     // GIR_Coverage, 6047,
     /* 216716 */     GIR_Done,
     /* 216717 */   // Label 4973: @216717
     /* 216717 */   GIM_Reject,
     /* 216718 */ // Label 4958: @216718
     /* 216718 */ GIM_Reject,
     /* 216719 */ // Label 4930: @216719
     /* 216719 */ GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(217284),
     /* 216724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 216727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 216730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216734 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(216795), // Rule ID 972 //
     /* 216739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216750 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 216757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216774 */     // (strict_fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m80),
     /* 216777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216793 */     GIR_RootConstrainSelectedInstOperands,
     /* 216794 */     // GIR_Coverage, 972,
     /* 216794 */     GIR_EraseRootFromParent_Done,
     /* 216795 */   // Label 4975: @216795
     /* 216795 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(216856), // Rule ID 974 //
     /* 216800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216811 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216835 */     // (strict_fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m80),
     /* 216838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216854 */     GIR_RootConstrainSelectedInstOperands,
     /* 216855 */     // GIR_Coverage, 974,
     /* 216855 */     GIR_EraseRootFromParent_Done,
     /* 216856 */   // Label 4976: @216856
     /* 216856 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(216924), // Rule ID 960 //
     /* 216861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216875 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216879 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216903 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 216906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216908 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216922 */     GIR_RootConstrainSelectedInstOperands,
     /* 216923 */     // GIR_Coverage, 960,
     /* 216923 */     GIR_EraseRootFromParent_Done,
     /* 216924 */   // Label 4977: @216924
     /* 216924 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(216992), // Rule ID 962 //
     /* 216929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216943 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216947 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 216954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216971 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 216974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216990 */     GIR_RootConstrainSelectedInstOperands,
     /* 216991 */     // GIR_Coverage, 962,
     /* 216991 */     GIR_EraseRootFromParent_Done,
     /* 216992 */   // Label 4978: @216992
     /* 216992 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(217053), // Rule ID 950 //
     /* 216997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 217012 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 217019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217032 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m80),
     /* 217035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217039 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217051 */     GIR_RootConstrainSelectedInstOperands,
     /* 217052 */     // GIR_Coverage, 950,
     /* 217052 */     GIR_EraseRootFromParent_Done,
     /* 217053 */   // Label 4979: @217053
     /* 217053 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(217114), // Rule ID 952 //
     /* 217058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 217073 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 217080 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217093 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m80),
     /* 217096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217112 */     GIR_RootConstrainSelectedInstOperands,
     /* 217113 */     // GIR_Coverage, 952,
     /* 217113 */     GIR_EraseRootFromParent_Done,
     /* 217114 */   // Label 4980: @217114
     /* 217114 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(217182), // Rule ID 938 //
     /* 217119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217137 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217141 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 217148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217161 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 217164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217180 */     GIR_RootConstrainSelectedInstOperands,
     /* 217181 */     // GIR_Coverage, 938,
     /* 217181 */     GIR_EraseRootFromParent_Done,
     /* 217182 */   // Label 4981: @217182
     /* 217182 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(217250), // Rule ID 940 //
     /* 217187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217205 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217209 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 217216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217229 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 217232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217248 */     GIR_RootConstrainSelectedInstOperands,
     /* 217249 */     // GIR_Coverage, 940,
     /* 217249 */     GIR_EraseRootFromParent_Done,
     /* 217250 */   // Label 4982: @217250
     /* 217250 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(217283), // Rule ID 896 //
     /* 217255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217266 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 217266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 217271 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 217277 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 217281 */     GIR_RootConstrainSelectedInstOperands,
     /* 217282 */     // GIR_Coverage, 896,
     /* 217282 */     GIR_Done,
     /* 217283 */   // Label 4983: @217283
     /* 217283 */   GIM_Reject,
     /* 217284 */ // Label 4974: @217284
     /* 217284 */ GIM_Reject,
     /* 217285 */ // Label 4931: @217285
     /* 217285 */ GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(217514),
     /* 217290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217296 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(217358), // Rule ID 2220 //
     /* 217301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217340 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 217343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217356 */     GIR_RootConstrainSelectedInstOperands,
     /* 217357 */     // GIR_Coverage, 2220,
     /* 217357 */     GIR_EraseRootFromParent_Done,
     /* 217358 */   // Label 4985: @217358
     /* 217358 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(217420), // Rule ID 6542 //
     /* 217363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217389 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217402 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 217405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217418 */     GIR_RootConstrainSelectedInstOperands,
     /* 217419 */     // GIR_Coverage, 6542,
     /* 217419 */     GIR_EraseRootFromParent_Done,
     /* 217420 */   // Label 4986: @217420
     /* 217420 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(217451), // Rule ID 2218 //
     /* 217425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217440 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 217440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 217445 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217449 */     GIR_RootConstrainSelectedInstOperands,
     /* 217450 */     // GIR_Coverage, 2218,
     /* 217450 */     GIR_Done,
     /* 217451 */   // Label 4987: @217451
     /* 217451 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(217482), // Rule ID 2234 //
     /* 217456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 217459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217471 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 217471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 217476 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217480 */     GIR_RootConstrainSelectedInstOperands,
     /* 217481 */     // GIR_Coverage, 2234,
     /* 217481 */     GIR_Done,
     /* 217482 */   // Label 4988: @217482
     /* 217482 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(217513), // Rule ID 6538 //
     /* 217487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217502 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 217502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 217507 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217511 */     GIR_RootConstrainSelectedInstOperands,
     /* 217512 */     // GIR_Coverage, 6538,
     /* 217512 */     GIR_Done,
     /* 217513 */   // Label 4989: @217513
     /* 217513 */   GIM_Reject,
     /* 217514 */ // Label 4984: @217514
     /* 217514 */ GIM_Reject,
     /* 217515 */ // Label 4932: @217515
     /* 217515 */ GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(217744),
     /* 217520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217526 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(217588), // Rule ID 2216 //
     /* 217531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217570 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 217573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217586 */     GIR_RootConstrainSelectedInstOperands,
     /* 217587 */     // GIR_Coverage, 2216,
     /* 217587 */     GIR_EraseRootFromParent_Done,
     /* 217588 */   // Label 4991: @217588
     /* 217588 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(217650), // Rule ID 6518 //
     /* 217593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217619 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217632 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 217635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217648 */     GIR_RootConstrainSelectedInstOperands,
     /* 217649 */     // GIR_Coverage, 6518,
     /* 217649 */     GIR_EraseRootFromParent_Done,
     /* 217650 */   // Label 4992: @217650
     /* 217650 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(217681), // Rule ID 2214 //
     /* 217655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217670 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 217670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 217675 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217679 */     GIR_RootConstrainSelectedInstOperands,
     /* 217680 */     // GIR_Coverage, 2214,
     /* 217680 */     GIR_Done,
     /* 217681 */   // Label 4993: @217681
     /* 217681 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(217712), // Rule ID 2230 //
     /* 217686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 217689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217701 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 217701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 217706 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217710 */     GIR_RootConstrainSelectedInstOperands,
     /* 217711 */     // GIR_Coverage, 2230,
     /* 217711 */     GIR_Done,
     /* 217712 */   // Label 4994: @217712
     /* 217712 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(217743), // Rule ID 6514 //
     /* 217717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217732 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 217732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 217737 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217741 */     GIR_RootConstrainSelectedInstOperands,
     /* 217742 */     // GIR_Coverage, 6514,
     /* 217742 */     GIR_Done,
     /* 217743 */   // Label 4995: @217743
     /* 217743 */   GIM_Reject,
     /* 217744 */ // Label 4990: @217744
     /* 217744 */ GIM_Reject,
     /* 217745 */ // Label 4933: @217745
     /* 217745 */ GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(217943),
     /* 217750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 217753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 217756 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(217818), // Rule ID 2228 //
     /* 217761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217800 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 217803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217805 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217816 */     GIR_RootConstrainSelectedInstOperands,
     /* 217817 */     // GIR_Coverage, 2228,
     /* 217817 */     GIR_EraseRootFromParent_Done,
     /* 217818 */   // Label 4997: @217818
     /* 217818 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(217880), // Rule ID 6554 //
     /* 217823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217862 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 217865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217867 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217878 */     GIR_RootConstrainSelectedInstOperands,
     /* 217879 */     // GIR_Coverage, 6554,
     /* 217879 */     GIR_EraseRootFromParent_Done,
     /* 217880 */   // Label 4998: @217880
     /* 217880 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(217911), // Rule ID 2226 //
     /* 217885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217900 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 217900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 217905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217909 */     GIR_RootConstrainSelectedInstOperands,
     /* 217910 */     // GIR_Coverage, 2226,
     /* 217910 */     GIR_Done,
     /* 217911 */   // Label 4999: @217911
     /* 217911 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(217942), // Rule ID 6550 //
     /* 217916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217931 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 217931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 217936 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217940 */     GIR_RootConstrainSelectedInstOperands,
     /* 217941 */     // GIR_Coverage, 6550,
     /* 217941 */     GIR_Done,
     /* 217942 */   // Label 5000: @217942
     /* 217942 */   GIM_Reject,
     /* 217943 */ // Label 4996: @217943
     /* 217943 */ GIM_Reject,
     /* 217944 */ // Label 4934: @217944
     /* 217944 */ GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(218041),
     /* 217949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217963 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(218017), // Rule ID 6578 //
     /* 217968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217999 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 218002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218015 */     GIR_RootConstrainSelectedInstOperands,
     /* 218016 */     // GIR_Coverage, 6578,
     /* 218016 */     GIR_EraseRootFromParent_Done,
     /* 218017 */   // Label 5002: @218017
     /* 218017 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(218040), // Rule ID 6574 //
     /* 218022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 218029 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 218029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 218034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218038 */     GIR_RootConstrainSelectedInstOperands,
     /* 218039 */     // GIR_Coverage, 6574,
     /* 218039 */     GIR_Done,
     /* 218040 */   // Label 5003: @218040
     /* 218040 */   GIM_Reject,
     /* 218041 */ // Label 5001: @218041
     /* 218041 */ GIM_Reject,
     /* 218042 */ // Label 4935: @218042
     /* 218042 */ GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(218240),
     /* 218047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 218050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 218053 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(218115), // Rule ID 2224 //
     /* 218058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218077 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218097 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 218100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218113 */     GIR_RootConstrainSelectedInstOperands,
     /* 218114 */     // GIR_Coverage, 2224,
     /* 218114 */     GIR_EraseRootFromParent_Done,
     /* 218115 */   // Label 5005: @218115
     /* 218115 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(218177), // Rule ID 6530 //
     /* 218120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 218123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218159 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 218162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218175 */     GIR_RootConstrainSelectedInstOperands,
     /* 218176 */     // GIR_Coverage, 6530,
     /* 218176 */     GIR_EraseRootFromParent_Done,
     /* 218177 */   // Label 5006: @218177
     /* 218177 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(218208), // Rule ID 2222 //
     /* 218182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218197 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 218197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 218202 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218206 */     GIR_RootConstrainSelectedInstOperands,
     /* 218207 */     // GIR_Coverage, 2222,
     /* 218207 */     GIR_Done,
     /* 218208 */   // Label 5007: @218208
     /* 218208 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(218239), // Rule ID 6526 //
     /* 218213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 218216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218228 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 218228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 218233 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218237 */     GIR_RootConstrainSelectedInstOperands,
     /* 218238 */     // GIR_Coverage, 6526,
     /* 218238 */     GIR_Done,
     /* 218239 */   // Label 5008: @218239
     /* 218239 */   GIM_Reject,
     /* 218240 */ // Label 5004: @218240
     /* 218240 */ GIM_Reject,
     /* 218241 */ // Label 4936: @218241
     /* 218241 */ GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(218338),
     /* 218246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 218249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 218252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218260 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(218314), // Rule ID 6506 //
     /* 218265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218296 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 218299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218301 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218312 */     GIR_RootConstrainSelectedInstOperands,
     /* 218313 */     // GIR_Coverage, 6506,
     /* 218313 */     GIR_EraseRootFromParent_Done,
     /* 218314 */   // Label 5010: @218314
     /* 218314 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(218337), // Rule ID 6502 //
     /* 218319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218326 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 218326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 218331 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218335 */     GIR_RootConstrainSelectedInstOperands,
     /* 218336 */     // GIR_Coverage, 6502,
     /* 218336 */     GIR_Done,
     /* 218337 */   // Label 5011: @218337
     /* 218337 */   GIM_Reject,
     /* 218338 */ // Label 5009: @218338
     /* 218338 */ GIM_Reject,
     /* 218339 */ // Label 4937: @218339
     /* 218339 */ GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(218436),
     /* 218344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 218347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 218350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218358 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(218412), // Rule ID 6590 //
     /* 218363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218394 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 218397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218410 */     GIR_RootConstrainSelectedInstOperands,
     /* 218411 */     // GIR_Coverage, 6590,
     /* 218411 */     GIR_EraseRootFromParent_Done,
     /* 218412 */   // Label 5013: @218412
     /* 218412 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(218435), // Rule ID 6586 //
     /* 218417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218424 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 218424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 218429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218433 */     GIR_RootConstrainSelectedInstOperands,
     /* 218434 */     // GIR_Coverage, 6586,
     /* 218434 */     GIR_Done,
     /* 218435 */   // Label 5014: @218435
     /* 218435 */   GIM_Reject,
     /* 218436 */ // Label 5012: @218436
     /* 218436 */ GIM_Reject,
     /* 218437 */ // Label 4938: @218437
     /* 218437 */ GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(218534),
     /* 218442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 218445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 218448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218456 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(218510), // Rule ID 6494 //
     /* 218461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218492 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 218495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218508 */     GIR_RootConstrainSelectedInstOperands,
     /* 218509 */     // GIR_Coverage, 6494,
     /* 218509 */     GIR_EraseRootFromParent_Done,
     /* 218510 */   // Label 5016: @218510
     /* 218510 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(218533), // Rule ID 6490 //
     /* 218515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218522 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 218522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 218527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218531 */     GIR_RootConstrainSelectedInstOperands,
     /* 218532 */     // GIR_Coverage, 6490,
     /* 218532 */     GIR_Done,
     /* 218533 */   // Label 5017: @218533
     /* 218533 */   GIM_Reject,
     /* 218534 */ // Label 5015: @218534
     /* 218534 */ GIM_Reject,
     /* 218535 */ // Label 4939: @218535
     /* 218535 */ GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(218632),
     /* 218540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 218543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 218546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218554 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(218608), // Rule ID 6566 //
     /* 218559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218590 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 218593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218606 */     GIR_RootConstrainSelectedInstOperands,
     /* 218607 */     // GIR_Coverage, 6566,
     /* 218607 */     GIR_EraseRootFromParent_Done,
     /* 218608 */   // Label 5019: @218608
     /* 218608 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(218631), // Rule ID 6562 //
     /* 218613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218620 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 218620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 218625 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218629 */     GIR_RootConstrainSelectedInstOperands,
     /* 218630 */     // GIR_Coverage, 6562,
     /* 218630 */     GIR_Done,
     /* 218631 */   // Label 5020: @218631
     /* 218631 */   GIM_Reject,
     /* 218632 */ // Label 5018: @218632
     /* 218632 */ GIM_Reject,
     /* 218633 */ // Label 4940: @218633
     /* 218633 */ GIM_Reject,
     /* 218634 */ // Label 70: @218634
     /* 218634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5034*/ GIMT_Encode4(223563),
     /* 218645 */ /*GILLT_s16*//*Label 5021*/ GIMT_Encode4(218729),
     /* 218649 */ /*GILLT_s32*//*Label 5022*/ GIMT_Encode4(218889),
     /* 218653 */ /*GILLT_s64*//*Label 5023*/ GIMT_Encode4(219794),
     /* 218657 */ /*GILLT_s80*//*Label 5024*/ GIMT_Encode4(220843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218669 */ /*GILLT_v2s64*//*Label 5025*/ GIMT_Encode4(221409), GIMT_Encode4(0),
     /* 218677 */ /*GILLT_v4s32*//*Label 5026*/ GIMT_Encode4(221763),
     /* 218681 */ /*GILLT_v4s64*//*Label 5027*/ GIMT_Encode4(222117), GIMT_Encode4(0),
     /* 218689 */ /*GILLT_v8s16*//*Label 5028*/ GIMT_Encode4(222440),
     /* 218693 */ /*GILLT_v8s32*//*Label 5029*/ GIMT_Encode4(222600),
     /* 218697 */ /*GILLT_v8s64*//*Label 5030*/ GIMT_Encode4(222923), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218709 */ /*GILLT_v16s16*//*Label 5031*/ GIMT_Encode4(223083),
     /* 218713 */ /*GILLT_v16s32*//*Label 5032*/ GIMT_Encode4(223243), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218725 */ /*GILLT_v32s16*//*Label 5033*/ GIMT_Encode4(223403),
     /* 218729 */ // Label 5021: @218729
     /* 218729 */ GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(218888),
     /* 218734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 218737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 218740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218744 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(218802), // Rule ID 24255 //
     /* 218749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218784 */     // (strict_fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 218787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218800 */     GIR_RootConstrainSelectedInstOperands,
     /* 218801 */     // GIR_Coverage, 24255,
     /* 218801 */     GIR_EraseRootFromParent_Done,
     /* 218802 */   // Label 5036: @218802
     /* 218802 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(218860), // Rule ID 6011 //
     /* 218807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218842 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 218845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218858 */     GIR_RootConstrainSelectedInstOperands,
     /* 218859 */     // GIR_Coverage, 6011,
     /* 218859 */     GIR_EraseRootFromParent_Done,
     /* 218860 */   // Label 5037: @218860
     /* 218860 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(218887), // Rule ID 6009 //
     /* 218865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218876 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 218876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 218881 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218885 */     GIR_RootConstrainSelectedInstOperands,
     /* 218886 */     // GIR_Coverage, 6009,
     /* 218886 */     GIR_Done,
     /* 218887 */   // Label 5038: @218887
     /* 218887 */   GIM_Reject,
     /* 218888 */ // Label 5035: @218888
     /* 218888 */ GIM_Reject,
     /* 218889 */ // Label 5022: @218889
     /* 218889 */ GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(219793),
     /* 218894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 218897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218900 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(218965), // Rule ID 23268 //
     /* 218905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 218920 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 218927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218944 */     // (strict_fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 218947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218963 */     GIR_RootConstrainSelectedInstOperands,
     /* 218964 */     // GIR_Coverage, 23268,
     /* 218964 */     GIR_EraseRootFromParent_Done,
     /* 218965 */   // Label 5040: @218965
     /* 218965 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(219030), // Rule ID 23270 //
     /* 218970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 218985 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219009 */     // (strict_fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 219012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219028 */     GIR_RootConstrainSelectedInstOperands,
     /* 219029 */     // GIR_Coverage, 23270,
     /* 219029 */     GIR_EraseRootFromParent_Done,
     /* 219030 */   // Label 5041: @219030
     /* 219030 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(219095), // Rule ID 23258 //
     /* 219035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219050 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219074 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 219077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219093 */     GIR_RootConstrainSelectedInstOperands,
     /* 219094 */     // GIR_Coverage, 23258,
     /* 219094 */     GIR_EraseRootFromParent_Done,
     /* 219095 */   // Label 5042: @219095
     /* 219095 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(219157), // Rule ID 23401 //
     /* 219100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219139 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 219142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219155 */     GIR_RootConstrainSelectedInstOperands,
     /* 219156 */     // GIR_Coverage, 23401,
     /* 219156 */     GIR_EraseRootFromParent_Done,
     /* 219157 */   // Label 5043: @219157
     /* 219157 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(219219), // Rule ID 23405 //
     /* 219162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219177 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219201 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 219204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219206 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219217 */     GIR_RootConstrainSelectedInstOperands,
     /* 219218 */     // GIR_Coverage, 23405,
     /* 219218 */     GIR_EraseRootFromParent_Done,
     /* 219219 */   // Label 5044: @219219
     /* 219219 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(219281), // Rule ID 24251 //
     /* 219224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219263 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 219266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219279 */     GIR_RootConstrainSelectedInstOperands,
     /* 219280 */     // GIR_Coverage, 24251,
     /* 219280 */     GIR_EraseRootFromParent_Done,
     /* 219281 */   // Label 5045: @219281
     /* 219281 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(219346), // Rule ID 986 //
     /* 219286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219305 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 219312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219325 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 219328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219344 */     GIR_RootConstrainSelectedInstOperands,
     /* 219345 */     // GIR_Coverage, 986,
     /* 219345 */     GIR_EraseRootFromParent_Done,
     /* 219346 */   // Label 5046: @219346
     /* 219346 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(219411), // Rule ID 988 //
     /* 219351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219370 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219377 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219390 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 219393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219395 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219409 */     GIR_RootConstrainSelectedInstOperands,
     /* 219410 */     // GIR_Coverage, 988,
     /* 219410 */     GIR_EraseRootFromParent_Done,
     /* 219411 */   // Label 5047: @219411
     /* 219411 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(219476), // Rule ID 976 //
     /* 219416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219435 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219455 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 219458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219474 */     GIR_RootConstrainSelectedInstOperands,
     /* 219475 */     // GIR_Coverage, 976,
     /* 219475 */     GIR_EraseRootFromParent_Done,
     /* 219476 */   // Label 5048: @219476
     /* 219476 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(219538), // Rule ID 2200 //
     /* 219481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219520 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 219523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219527 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219536 */     GIR_RootConstrainSelectedInstOperands,
     /* 219537 */     // GIR_Coverage, 2200,
     /* 219537 */     GIR_EraseRootFromParent_Done,
     /* 219538 */   // Label 5049: @219538
     /* 219538 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(219600), // Rule ID 2208 //
     /* 219543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219582 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 219585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219598 */     GIR_RootConstrainSelectedInstOperands,
     /* 219599 */     // GIR_Coverage, 2208,
     /* 219599 */     GIR_EraseRootFromParent_Done,
     /* 219600 */   // Label 5050: @219600
     /* 219600 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(219662), // Rule ID 5973 //
     /* 219605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219644 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 219647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219660 */     GIR_RootConstrainSelectedInstOperands,
     /* 219661 */     // GIR_Coverage, 5973,
     /* 219661 */     GIR_EraseRootFromParent_Done,
     /* 219662 */   // Label 5051: @219662
     /* 219662 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(219699), // Rule ID 898 //
     /* 219667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219682 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 219682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 219687 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219697 */     GIR_RootConstrainSelectedInstOperands,
     /* 219698 */     // GIR_Coverage, 898,
     /* 219698 */     GIR_Done,
     /* 219699 */   // Label 5052: @219699
     /* 219699 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(219730), // Rule ID 2198 //
     /* 219704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219719 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 219719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 219724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219728 */     GIR_RootConstrainSelectedInstOperands,
     /* 219729 */     // GIR_Coverage, 2198,
     /* 219729 */     GIR_Done,
     /* 219730 */   // Label 5053: @219730
     /* 219730 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(219761), // Rule ID 2206 //
     /* 219735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219750 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 219750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 219755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219759 */     GIR_RootConstrainSelectedInstOperands,
     /* 219760 */     // GIR_Coverage, 2206,
     /* 219760 */     GIR_Done,
     /* 219761 */   // Label 5054: @219761
     /* 219761 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(219792), // Rule ID 5971 //
     /* 219766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219781 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 219781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 219786 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219790 */     GIR_RootConstrainSelectedInstOperands,
     /* 219791 */     // GIR_Coverage, 5971,
     /* 219791 */     GIR_Done,
     /* 219792 */   // Label 5055: @219792
     /* 219792 */   GIM_Reject,
     /* 219793 */ // Label 5039: @219793
     /* 219793 */ GIM_Reject,
     /* 219794 */ // Label 5023: @219794
     /* 219794 */ GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(220842),
     /* 219799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 219802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219805 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(219870), // Rule ID 23272 //
     /* 219810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219825 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 219832 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219849 */     // (strict_fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 219852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219868 */     GIR_RootConstrainSelectedInstOperands,
     /* 219869 */     // GIR_Coverage, 23272,
     /* 219869 */     GIR_EraseRootFromParent_Done,
     /* 219870 */   // Label 5057: @219870
     /* 219870 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(219935), // Rule ID 23274 //
     /* 219875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219890 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219914 */     // (strict_fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 219917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219921 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219933 */     GIR_RootConstrainSelectedInstOperands,
     /* 219934 */     // GIR_Coverage, 23274,
     /* 219934 */     GIR_EraseRootFromParent_Done,
     /* 219935 */   // Label 5058: @219935
     /* 219935 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(220000), // Rule ID 23260 //
     /* 219940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219979 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 219982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219998 */     GIR_RootConstrainSelectedInstOperands,
     /* 219999 */     // GIR_Coverage, 23260,
     /* 219999 */     GIR_EraseRootFromParent_Done,
     /* 220000 */   // Label 5059: @220000
     /* 220000 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(220072), // Rule ID 23262 //
     /* 220005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220023 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220027 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220051 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 220054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220070 */     GIR_RootConstrainSelectedInstOperands,
     /* 220071 */     // GIR_Coverage, 23262,
     /* 220071 */     GIR_EraseRootFromParent_Done,
     /* 220072 */   // Label 5060: @220072
     /* 220072 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(220134), // Rule ID 23403 //
     /* 220077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220116 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 220119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220123 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220132 */     GIR_RootConstrainSelectedInstOperands,
     /* 220133 */     // GIR_Coverage, 23403,
     /* 220133 */     GIR_EraseRootFromParent_Done,
     /* 220134 */   // Label 5061: @220134
     /* 220134 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(220196), // Rule ID 23407 //
     /* 220139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220178 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 220181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220183 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220194 */     GIR_RootConstrainSelectedInstOperands,
     /* 220195 */     // GIR_Coverage, 23407,
     /* 220195 */     GIR_EraseRootFromParent_Done,
     /* 220196 */   // Label 5062: @220196
     /* 220196 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(220258), // Rule ID 24253 //
     /* 220201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220240 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 220243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220256 */     GIR_RootConstrainSelectedInstOperands,
     /* 220257 */     // GIR_Coverage, 24253,
     /* 220257 */     GIR_EraseRootFromParent_Done,
     /* 220258 */   // Label 5063: @220258
     /* 220258 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(220323), // Rule ID 990 //
     /* 220263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220282 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 220289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220302 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 220305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220321 */     GIR_RootConstrainSelectedInstOperands,
     /* 220322 */     // GIR_Coverage, 990,
     /* 220322 */     GIR_EraseRootFromParent_Done,
     /* 220323 */   // Label 5064: @220323
     /* 220323 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(220388), // Rule ID 992 //
     /* 220328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220347 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220354 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220367 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 220370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220386 */     GIR_RootConstrainSelectedInstOperands,
     /* 220387 */     // GIR_Coverage, 992,
     /* 220387 */     GIR_EraseRootFromParent_Done,
     /* 220388 */   // Label 5065: @220388
     /* 220388 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(220453), // Rule ID 978 //
     /* 220393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220412 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220432 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 220435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220439 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220451 */     GIR_RootConstrainSelectedInstOperands,
     /* 220452 */     // GIR_Coverage, 978,
     /* 220452 */     GIR_EraseRootFromParent_Done,
     /* 220453 */   // Label 5066: @220453
     /* 220453 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(220525), // Rule ID 980 //
     /* 220458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220480 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220484 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220504 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 220507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220523 */     GIR_RootConstrainSelectedInstOperands,
     /* 220524 */     // GIR_Coverage, 980,
     /* 220524 */     GIR_EraseRootFromParent_Done,
     /* 220525 */   // Label 5067: @220525
     /* 220525 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(220587), // Rule ID 2204 //
     /* 220530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220556 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220569 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 220572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220585 */     GIR_RootConstrainSelectedInstOperands,
     /* 220586 */     // GIR_Coverage, 2204,
     /* 220586 */     GIR_EraseRootFromParent_Done,
     /* 220587 */   // Label 5068: @220587
     /* 220587 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(220649), // Rule ID 2212 //
     /* 220592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220631 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 220634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220647 */     GIR_RootConstrainSelectedInstOperands,
     /* 220648 */     // GIR_Coverage, 2212,
     /* 220648 */     GIR_EraseRootFromParent_Done,
     /* 220649 */   // Label 5069: @220649
     /* 220649 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(220711), // Rule ID 5992 //
     /* 220654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220676 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220693 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 220696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220709 */     GIR_RootConstrainSelectedInstOperands,
     /* 220710 */     // GIR_Coverage, 5992,
     /* 220710 */     GIR_EraseRootFromParent_Done,
     /* 220711 */   // Label 5070: @220711
     /* 220711 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(220748), // Rule ID 900 //
     /* 220716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220731 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 220731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 220736 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 220742 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 220746 */     GIR_RootConstrainSelectedInstOperands,
     /* 220747 */     // GIR_Coverage, 900,
     /* 220747 */     GIR_Done,
     /* 220748 */   // Label 5071: @220748
     /* 220748 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(220779), // Rule ID 2202 //
     /* 220753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220768 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 220768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 220773 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220777 */     GIR_RootConstrainSelectedInstOperands,
     /* 220778 */     // GIR_Coverage, 2202,
     /* 220778 */     GIR_Done,
     /* 220779 */   // Label 5072: @220779
     /* 220779 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(220810), // Rule ID 2210 //
     /* 220784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220799 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 220799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 220804 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220808 */     GIR_RootConstrainSelectedInstOperands,
     /* 220809 */     // GIR_Coverage, 2210,
     /* 220809 */     GIR_Done,
     /* 220810 */   // Label 5073: @220810
     /* 220810 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(220841), // Rule ID 5990 //
     /* 220815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220830 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 220830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 220835 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220839 */     GIR_RootConstrainSelectedInstOperands,
     /* 220840 */     // GIR_Coverage, 5990,
     /* 220840 */     GIR_Done,
     /* 220841 */   // Label 5074: @220841
     /* 220841 */   GIM_Reject,
     /* 220842 */ // Label 5056: @220842
     /* 220842 */ GIM_Reject,
     /* 220843 */ // Label 5024: @220843
     /* 220843 */ GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(221408),
     /* 220848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 220851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 220854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220858 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(220919), // Rule ID 23276 //
     /* 220863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220874 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 220881 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220898 */     // (strict_fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 220901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220903 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220917 */     GIR_RootConstrainSelectedInstOperands,
     /* 220918 */     // GIR_Coverage, 23276,
     /* 220918 */     GIR_EraseRootFromParent_Done,
     /* 220919 */   // Label 5076: @220919
     /* 220919 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(220980), // Rule ID 23278 //
     /* 220924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220935 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220942 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220959 */     // (strict_fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 220962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220978 */     GIR_RootConstrainSelectedInstOperands,
     /* 220979 */     // GIR_Coverage, 23278,
     /* 220979 */     GIR_EraseRootFromParent_Done,
     /* 220980 */   // Label 5077: @220980
     /* 220980 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(221048), // Rule ID 23264 //
     /* 220985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220999 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221003 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221027 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 221030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221046 */     GIR_RootConstrainSelectedInstOperands,
     /* 221047 */     // GIR_Coverage, 23264,
     /* 221047 */     GIR_EraseRootFromParent_Done,
     /* 221048 */   // Label 5078: @221048
     /* 221048 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(221116), // Rule ID 23266 //
     /* 221053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221067 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221071 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 221078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221095 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 221098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221114 */     GIR_RootConstrainSelectedInstOperands,
     /* 221115 */     // GIR_Coverage, 23266,
     /* 221115 */     GIR_EraseRootFromParent_Done,
     /* 221116 */   // Label 5079: @221116
     /* 221116 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(221177), // Rule ID 994 //
     /* 221121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 221136 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 221143 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221156 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 221159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221175 */     GIR_RootConstrainSelectedInstOperands,
     /* 221176 */     // GIR_Coverage, 994,
     /* 221176 */     GIR_EraseRootFromParent_Done,
     /* 221177 */   // Label 5080: @221177
     /* 221177 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(221238), // Rule ID 996 //
     /* 221182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 221197 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221204 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221217 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 221220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221236 */     GIR_RootConstrainSelectedInstOperands,
     /* 221237 */     // GIR_Coverage, 996,
     /* 221237 */     GIR_EraseRootFromParent_Done,
     /* 221238 */   // Label 5081: @221238
     /* 221238 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(221306), // Rule ID 982 //
     /* 221243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221261 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221265 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221285 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 221288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221304 */     GIR_RootConstrainSelectedInstOperands,
     /* 221305 */     // GIR_Coverage, 982,
     /* 221305 */     GIR_EraseRootFromParent_Done,
     /* 221306 */   // Label 5082: @221306
     /* 221306 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(221374), // Rule ID 984 //
     /* 221311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221329 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221333 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 221340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221353 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 221356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221372 */     GIR_RootConstrainSelectedInstOperands,
     /* 221373 */     // GIR_Coverage, 984,
     /* 221373 */     GIR_EraseRootFromParent_Done,
     /* 221374 */   // Label 5083: @221374
     /* 221374 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(221407), // Rule ID 902 //
     /* 221379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221390 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 221390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 221395 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 221401 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 221405 */     GIR_RootConstrainSelectedInstOperands,
     /* 221406 */     // GIR_Coverage, 902,
     /* 221406 */     GIR_Done,
     /* 221407 */   // Label 5084: @221407
     /* 221407 */   GIM_Reject,
     /* 221408 */ // Label 5075: @221408
     /* 221408 */ GIM_Reject,
     /* 221409 */ // Label 5025: @221409
     /* 221409 */ GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(221762),
     /* 221414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 221417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 221420 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(221482), // Rule ID 23391 //
     /* 221425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221464 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 221467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221480 */     GIR_RootConstrainSelectedInstOperands,
     /* 221481 */     // GIR_Coverage, 23391,
     /* 221481 */     GIR_EraseRootFromParent_Done,
     /* 221482 */   // Label 5086: @221482
     /* 221482 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(221544), // Rule ID 24367 //
     /* 221487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221502 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221526 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 221529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221542 */     GIR_RootConstrainSelectedInstOperands,
     /* 221543 */     // GIR_Coverage, 24367,
     /* 221543 */     GIR_EraseRootFromParent_Done,
     /* 221544 */   // Label 5087: @221544
     /* 221544 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(221606), // Rule ID 2180 //
     /* 221549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221588 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 221591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221604 */     GIR_RootConstrainSelectedInstOperands,
     /* 221605 */     // GIR_Coverage, 2180,
     /* 221605 */     GIR_EraseRootFromParent_Done,
     /* 221606 */   // Label 5088: @221606
     /* 221606 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(221668), // Rule ID 6425 //
     /* 221611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221650 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 221653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221666 */     GIR_RootConstrainSelectedInstOperands,
     /* 221667 */     // GIR_Coverage, 6425,
     /* 221667 */     GIR_EraseRootFromParent_Done,
     /* 221668 */   // Label 5089: @221668
     /* 221668 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(221699), // Rule ID 2178 //
     /* 221673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221688 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 221688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 221693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221697 */     GIR_RootConstrainSelectedInstOperands,
     /* 221698 */     // GIR_Coverage, 2178,
     /* 221698 */     GIR_Done,
     /* 221699 */   // Label 5090: @221699
     /* 221699 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(221730), // Rule ID 2194 //
     /* 221704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 221707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221719 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 221719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 221724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221728 */     GIR_RootConstrainSelectedInstOperands,
     /* 221729 */     // GIR_Coverage, 2194,
     /* 221729 */     GIR_Done,
     /* 221730 */   // Label 5091: @221730
     /* 221730 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(221761), // Rule ID 6421 //
     /* 221735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221750 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 221750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 221755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221759 */     GIR_RootConstrainSelectedInstOperands,
     /* 221760 */     // GIR_Coverage, 6421,
     /* 221760 */     GIR_Done,
     /* 221761 */   // Label 5092: @221761
     /* 221761 */   GIM_Reject,
     /* 221762 */ // Label 5085: @221762
     /* 221762 */ GIM_Reject,
     /* 221763 */ // Label 5026: @221763
     /* 221763 */ GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(222116),
     /* 221768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221774 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(221836), // Rule ID 23389 //
     /* 221779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221818 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 221821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221834 */     GIR_RootConstrainSelectedInstOperands,
     /* 221835 */     // GIR_Coverage, 23389,
     /* 221835 */     GIR_EraseRootFromParent_Done,
     /* 221836 */   // Label 5094: @221836
     /* 221836 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(221898), // Rule ID 24351 //
     /* 221841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221880 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 221883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221896 */     GIR_RootConstrainSelectedInstOperands,
     /* 221897 */     // GIR_Coverage, 24351,
     /* 221897 */     GIR_EraseRootFromParent_Done,
     /* 221898 */   // Label 5095: @221898
     /* 221898 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(221960), // Rule ID 2176 //
     /* 221903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221922 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221929 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221942 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 221945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221958 */     GIR_RootConstrainSelectedInstOperands,
     /* 221959 */     // GIR_Coverage, 2176,
     /* 221959 */     GIR_EraseRootFromParent_Done,
     /* 221960 */   // Label 5096: @221960
     /* 221960 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(222022), // Rule ID 6401 //
     /* 221965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222004 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 222007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222020 */     GIR_RootConstrainSelectedInstOperands,
     /* 222021 */     // GIR_Coverage, 6401,
     /* 222021 */     GIR_EraseRootFromParent_Done,
     /* 222022 */   // Label 5097: @222022
     /* 222022 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(222053), // Rule ID 2174 //
     /* 222027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222042 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 222042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 222047 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222051 */     GIR_RootConstrainSelectedInstOperands,
     /* 222052 */     // GIR_Coverage, 2174,
     /* 222052 */     GIR_Done,
     /* 222053 */   // Label 5098: @222053
     /* 222053 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(222084), // Rule ID 2190 //
     /* 222058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 222061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222073 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 222073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 222078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222082 */     GIR_RootConstrainSelectedInstOperands,
     /* 222083 */     // GIR_Coverage, 2190,
     /* 222083 */     GIR_Done,
     /* 222084 */   // Label 5099: @222084
     /* 222084 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(222115), // Rule ID 6397 //
     /* 222089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222104 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 222104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 222109 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222113 */     GIR_RootConstrainSelectedInstOperands,
     /* 222114 */     // GIR_Coverage, 6397,
     /* 222114 */     GIR_Done,
     /* 222115 */   // Label 5100: @222115
     /* 222115 */   GIM_Reject,
     /* 222116 */ // Label 5093: @222116
     /* 222116 */ GIM_Reject,
     /* 222117 */ // Label 5027: @222117
     /* 222117 */ GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(222439),
     /* 222122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 222125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 222128 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(222190), // Rule ID 23395 //
     /* 222133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222172 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 222175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222177 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222188 */     GIR_RootConstrainSelectedInstOperands,
     /* 222189 */     // GIR_Coverage, 23395,
     /* 222189 */     GIR_EraseRootFromParent_Done,
     /* 222190 */   // Label 5102: @222190
     /* 222190 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(222252), // Rule ID 24375 //
     /* 222195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222234 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 222237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222239 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222250 */     GIR_RootConstrainSelectedInstOperands,
     /* 222251 */     // GIR_Coverage, 24375,
     /* 222251 */     GIR_EraseRootFromParent_Done,
     /* 222252 */   // Label 5103: @222252
     /* 222252 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(222314), // Rule ID 2188 //
     /* 222257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222296 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 222299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222301 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222312 */     GIR_RootConstrainSelectedInstOperands,
     /* 222313 */     // GIR_Coverage, 2188,
     /* 222313 */     GIR_EraseRootFromParent_Done,
     /* 222314 */   // Label 5104: @222314
     /* 222314 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(222376), // Rule ID 6437 //
     /* 222319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222358 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 222361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222374 */     GIR_RootConstrainSelectedInstOperands,
     /* 222375 */     // GIR_Coverage, 6437,
     /* 222375 */     GIR_EraseRootFromParent_Done,
     /* 222376 */   // Label 5105: @222376
     /* 222376 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(222407), // Rule ID 2186 //
     /* 222381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222396 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 222396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 222401 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222405 */     GIR_RootConstrainSelectedInstOperands,
     /* 222406 */     // GIR_Coverage, 2186,
     /* 222406 */     GIR_Done,
     /* 222407 */   // Label 5106: @222407
     /* 222407 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(222438), // Rule ID 6433 //
     /* 222412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222427 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 222427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 222432 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222436 */     GIR_RootConstrainSelectedInstOperands,
     /* 222437 */     // GIR_Coverage, 6433,
     /* 222437 */     GIR_Done,
     /* 222438 */   // Label 5107: @222438
     /* 222438 */   GIM_Reject,
     /* 222439 */ // Label 5101: @222439
     /* 222439 */ GIM_Reject,
     /* 222440 */ // Label 5028: @222440
     /* 222440 */ GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(222599),
     /* 222445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222455 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(222513), // Rule ID 24391 //
     /* 222460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222495 */     // (strict_fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 222498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222511 */     GIR_RootConstrainSelectedInstOperands,
     /* 222512 */     // GIR_Coverage, 24391,
     /* 222512 */     GIR_EraseRootFromParent_Done,
     /* 222513 */   // Label 5109: @222513
     /* 222513 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(222571), // Rule ID 6461 //
     /* 222518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222533 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222553 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 222556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222569 */     GIR_RootConstrainSelectedInstOperands,
     /* 222570 */     // GIR_Coverage, 6461,
     /* 222570 */     GIR_EraseRootFromParent_Done,
     /* 222571 */   // Label 5110: @222571
     /* 222571 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(222598), // Rule ID 6457 //
     /* 222576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222587 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 222587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 222592 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222596 */     GIR_RootConstrainSelectedInstOperands,
     /* 222597 */     // GIR_Coverage, 6457,
     /* 222597 */     GIR_Done,
     /* 222598 */   // Label 5111: @222598
     /* 222598 */   GIM_Reject,
     /* 222599 */ // Label 5108: @222599
     /* 222599 */ GIM_Reject,
     /* 222600 */ // Label 5029: @222600
     /* 222600 */ GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(222922),
     /* 222605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 222608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 222611 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(222673), // Rule ID 23393 //
     /* 222616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222631 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222638 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222655 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 222658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222671 */     GIR_RootConstrainSelectedInstOperands,
     /* 222672 */     // GIR_Coverage, 23393,
     /* 222672 */     GIR_EraseRootFromParent_Done,
     /* 222673 */   // Label 5113: @222673
     /* 222673 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(222735), // Rule ID 24359 //
     /* 222678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222717 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 222720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222733 */     GIR_RootConstrainSelectedInstOperands,
     /* 222734 */     // GIR_Coverage, 24359,
     /* 222734 */     GIR_EraseRootFromParent_Done,
     /* 222735 */   // Label 5114: @222735
     /* 222735 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(222797), // Rule ID 2184 //
     /* 222740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222779 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 222782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222784 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222795 */     GIR_RootConstrainSelectedInstOperands,
     /* 222796 */     // GIR_Coverage, 2184,
     /* 222796 */     GIR_EraseRootFromParent_Done,
     /* 222797 */   // Label 5115: @222797
     /* 222797 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(222859), // Rule ID 6413 //
     /* 222802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222841 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 222844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222857 */     GIR_RootConstrainSelectedInstOperands,
     /* 222858 */     // GIR_Coverage, 6413,
     /* 222858 */     GIR_EraseRootFromParent_Done,
     /* 222859 */   // Label 5116: @222859
     /* 222859 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(222890), // Rule ID 2182 //
     /* 222864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222879 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 222879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 222884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222888 */     GIR_RootConstrainSelectedInstOperands,
     /* 222889 */     // GIR_Coverage, 2182,
     /* 222889 */     GIR_Done,
     /* 222890 */   // Label 5117: @222890
     /* 222890 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(222921), // Rule ID 6409 //
     /* 222895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222910 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 222910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 222915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222919 */     GIR_RootConstrainSelectedInstOperands,
     /* 222920 */     // GIR_Coverage, 6409,
     /* 222920 */     GIR_Done,
     /* 222921 */   // Label 5118: @222921
     /* 222921 */   GIM_Reject,
     /* 222922 */ // Label 5112: @222922
     /* 222922 */ GIM_Reject,
     /* 222923 */ // Label 5030: @222923
     /* 222923 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(223082),
     /* 222928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 222931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 222934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 222938 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(222996), // Rule ID 24343 //
     /* 222943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 222969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222978 */     // (strict_fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 222981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222994 */     GIR_RootConstrainSelectedInstOperands,
     /* 222995 */     // GIR_Coverage, 24343,
     /* 222995 */     GIR_EraseRootFromParent_Done,
     /* 222996 */   // Label 5120: @222996
     /* 222996 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(223054), // Rule ID 6389 //
     /* 223001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223036 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 223039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223052 */     GIR_RootConstrainSelectedInstOperands,
     /* 223053 */     // GIR_Coverage, 6389,
     /* 223053 */     GIR_EraseRootFromParent_Done,
     /* 223054 */   // Label 5121: @223054
     /* 223054 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(223081), // Rule ID 6385 //
     /* 223059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223070 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 223070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 223075 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223079 */     GIR_RootConstrainSelectedInstOperands,
     /* 223080 */     // GIR_Coverage, 6385,
     /* 223080 */     GIR_Done,
     /* 223081 */   // Label 5122: @223081
     /* 223081 */   GIM_Reject,
     /* 223082 */ // Label 5119: @223082
     /* 223082 */ GIM_Reject,
     /* 223083 */ // Label 5031: @223083
     /* 223083 */ GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(223242),
     /* 223088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 223091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 223094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223098 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(223156), // Rule ID 24399 //
     /* 223103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223114 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223121 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223138 */     // (strict_fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 223141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223145 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223154 */     GIR_RootConstrainSelectedInstOperands,
     /* 223155 */     // GIR_Coverage, 24399,
     /* 223155 */     GIR_EraseRootFromParent_Done,
     /* 223156 */   // Label 5124: @223156
     /* 223156 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(223214), // Rule ID 6473 //
     /* 223161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223196 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 223199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223212 */     GIR_RootConstrainSelectedInstOperands,
     /* 223213 */     // GIR_Coverage, 6473,
     /* 223213 */     GIR_EraseRootFromParent_Done,
     /* 223214 */   // Label 5125: @223214
     /* 223214 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(223241), // Rule ID 6469 //
     /* 223219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223230 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 223230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 223235 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223239 */     GIR_RootConstrainSelectedInstOperands,
     /* 223240 */     // GIR_Coverage, 6469,
     /* 223240 */     GIR_Done,
     /* 223241 */   // Label 5126: @223241
     /* 223241 */   GIM_Reject,
     /* 223242 */ // Label 5123: @223242
     /* 223242 */ GIM_Reject,
     /* 223243 */ // Label 5032: @223243
     /* 223243 */ GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(223402),
     /* 223248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 223251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 223254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223258 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(223316), // Rule ID 24335 //
     /* 223263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223298 */     // (strict_fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 223301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223314 */     GIR_RootConstrainSelectedInstOperands,
     /* 223315 */     // GIR_Coverage, 24335,
     /* 223315 */     GIR_EraseRootFromParent_Done,
     /* 223316 */   // Label 5128: @223316
     /* 223316 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(223374), // Rule ID 6377 //
     /* 223321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223356 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 223359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223372 */     GIR_RootConstrainSelectedInstOperands,
     /* 223373 */     // GIR_Coverage, 6377,
     /* 223373 */     GIR_EraseRootFromParent_Done,
     /* 223374 */   // Label 5129: @223374
     /* 223374 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(223401), // Rule ID 6373 //
     /* 223379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223390 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 223390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 223395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223399 */     GIR_RootConstrainSelectedInstOperands,
     /* 223400 */     // GIR_Coverage, 6373,
     /* 223400 */     GIR_Done,
     /* 223401 */   // Label 5130: @223401
     /* 223401 */   GIM_Reject,
     /* 223402 */ // Label 5127: @223402
     /* 223402 */ GIM_Reject,
     /* 223403 */ // Label 5033: @223403
     /* 223403 */ GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(223562),
     /* 223408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 223411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 223414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223418 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(223476), // Rule ID 24383 //
     /* 223423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223458 */     // (strict_fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 223461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223474 */     GIR_RootConstrainSelectedInstOperands,
     /* 223475 */     // GIR_Coverage, 24383,
     /* 223475 */     GIR_EraseRootFromParent_Done,
     /* 223476 */   // Label 5132: @223476
     /* 223476 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(223534), // Rule ID 6449 //
     /* 223481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223516 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 223519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223532 */     GIR_RootConstrainSelectedInstOperands,
     /* 223533 */     // GIR_Coverage, 6449,
     /* 223533 */     GIR_EraseRootFromParent_Done,
     /* 223534 */   // Label 5133: @223534
     /* 223534 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(223561), // Rule ID 6445 //
     /* 223539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223550 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 223550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 223555 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223559 */     GIR_RootConstrainSelectedInstOperands,
     /* 223560 */     // GIR_Coverage, 6445,
     /* 223560 */     GIR_Done,
     /* 223561 */   // Label 5134: @223561
     /* 223561 */   GIM_Reject,
     /* 223562 */ // Label 5131: @223562
     /* 223562 */ GIM_Reject,
     /* 223563 */ // Label 5034: @223563
     /* 223563 */ GIM_Reject,
     /* 223564 */ // Label 71: @223564
     /* 223564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5148*/ GIMT_Encode4(227253),
     /* 223575 */ /*GILLT_s16*//*Label 5135*/ GIMT_Encode4(223659),
     /* 223579 */ /*GILLT_s32*//*Label 5136*/ GIMT_Encode4(223757),
     /* 223583 */ /*GILLT_s64*//*Label 5137*/ GIMT_Encode4(224476),
     /* 223587 */ /*GILLT_s80*//*Label 5138*/ GIMT_Encode4(225339), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223599 */ /*GILLT_v2s64*//*Label 5139*/ GIMT_Encode4(225905), GIMT_Encode4(0),
     /* 223607 */ /*GILLT_v4s32*//*Label 5140*/ GIMT_Encode4(226135),
     /* 223611 */ /*GILLT_v4s64*//*Label 5141*/ GIMT_Encode4(226365), GIMT_Encode4(0),
     /* 223619 */ /*GILLT_v8s16*//*Label 5142*/ GIMT_Encode4(226564),
     /* 223623 */ /*GILLT_v8s32*//*Label 5143*/ GIMT_Encode4(226662),
     /* 223627 */ /*GILLT_v8s64*//*Label 5144*/ GIMT_Encode4(226861), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223639 */ /*GILLT_v16s16*//*Label 5145*/ GIMT_Encode4(226959),
     /* 223643 */ /*GILLT_v16s32*//*Label 5146*/ GIMT_Encode4(227057), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223655 */ /*GILLT_v32s16*//*Label 5147*/ GIMT_Encode4(227155),
     /* 223659 */ // Label 5135: @223659
     /* 223659 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(223756),
     /* 223664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 223667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 223670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223678 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(223732), // Rule ID 6125 //
     /* 223683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223714 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 223717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223730 */     GIR_RootConstrainSelectedInstOperands,
     /* 223731 */     // GIR_Coverage, 6125,
     /* 223731 */     GIR_EraseRootFromParent_Done,
     /* 223732 */   // Label 5150: @223732
     /* 223732 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(223755), // Rule ID 6123 //
     /* 223737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223744 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 223744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 223749 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223753 */     GIR_RootConstrainSelectedInstOperands,
     /* 223754 */     // GIR_Coverage, 6123,
     /* 223754 */     GIR_Done,
     /* 223755 */   // Label 5151: @223755
     /* 223755 */   GIM_Reject,
     /* 223756 */ // Label 5149: @223756
     /* 223756 */ GIM_Reject,
     /* 223757 */ // Label 5136: @223757
     /* 223757 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(224475),
     /* 223762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 223765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223768 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(223833), // Rule ID 1030 //
     /* 223773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223788 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 223795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223812 */     // (strict_fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m32),
     /* 223815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223817 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223831 */     GIR_RootConstrainSelectedInstOperands,
     /* 223832 */     // GIR_Coverage, 1030,
     /* 223832 */     GIR_EraseRootFromParent_Done,
     /* 223833 */   // Label 5153: @223833
     /* 223833 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(223898), // Rule ID 1032 //
     /* 223838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223853 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 223860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223877 */     // (strict_fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m32),
     /* 223880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223896 */     GIR_RootConstrainSelectedInstOperands,
     /* 223897 */     // GIR_Coverage, 1032,
     /* 223897 */     GIR_EraseRootFromParent_Done,
     /* 223898 */   // Label 5154: @223898
     /* 223898 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(223963), // Rule ID 1020 //
     /* 223903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223942 */     // (strict_fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 223945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223961 */     GIR_RootConstrainSelectedInstOperands,
     /* 223962 */     // GIR_Coverage, 1020,
     /* 223962 */     GIR_EraseRootFromParent_Done,
     /* 223963 */   // Label 5155: @223963
     /* 223963 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(224028), // Rule ID 1008 //
     /* 223968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223987 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 223994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224007 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m32),
     /* 224010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224012 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224026 */     GIR_RootConstrainSelectedInstOperands,
     /* 224027 */     // GIR_Coverage, 1008,
     /* 224027 */     GIR_EraseRootFromParent_Done,
     /* 224028 */   // Label 5156: @224028
     /* 224028 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(224093), // Rule ID 1010 //
     /* 224033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224052 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224072 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m32),
     /* 224075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224091 */     GIR_RootConstrainSelectedInstOperands,
     /* 224092 */     // GIR_Coverage, 1010,
     /* 224092 */     GIR_EraseRootFromParent_Done,
     /* 224093 */   // Label 5157: @224093
     /* 224093 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(224158), // Rule ID 998 //
     /* 224098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224137 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 224140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224156 */     GIR_RootConstrainSelectedInstOperands,
     /* 224157 */     // GIR_Coverage, 998,
     /* 224157 */     GIR_EraseRootFromParent_Done,
     /* 224158 */   // Label 5158: @224158
     /* 224158 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(224220), // Rule ID 2280 //
     /* 224163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 224166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224202 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 224205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224218 */     GIR_RootConstrainSelectedInstOperands,
     /* 224219 */     // GIR_Coverage, 2280,
     /* 224219 */     GIR_EraseRootFromParent_Done,
     /* 224220 */   // Label 5159: @224220
     /* 224220 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(224282), // Rule ID 2288 //
     /* 224225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 224228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224264 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 224267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224280 */     GIR_RootConstrainSelectedInstOperands,
     /* 224281 */     // GIR_Coverage, 2288,
     /* 224281 */     GIR_EraseRootFromParent_Done,
     /* 224282 */   // Label 5160: @224282
     /* 224282 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(224344), // Rule ID 6087 //
     /* 224287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 224290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224326 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 224329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224342 */     GIR_RootConstrainSelectedInstOperands,
     /* 224343 */     // GIR_Coverage, 6087,
     /* 224343 */     GIR_EraseRootFromParent_Done,
     /* 224344 */   // Label 5161: @224344
     /* 224344 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(224381), // Rule ID 904 //
     /* 224349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224364 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 224364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 224369 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 224375 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 224379 */     GIR_RootConstrainSelectedInstOperands,
     /* 224380 */     // GIR_Coverage, 904,
     /* 224380 */     GIR_Done,
     /* 224381 */   // Label 5162: @224381
     /* 224381 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(224412), // Rule ID 2278 //
     /* 224386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 224389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224401 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 224401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 224406 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224410 */     GIR_RootConstrainSelectedInstOperands,
     /* 224411 */     // GIR_Coverage, 2278,
     /* 224411 */     GIR_Done,
     /* 224412 */   // Label 5163: @224412
     /* 224412 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(224443), // Rule ID 2286 //
     /* 224417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 224420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224432 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 224432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 224437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224441 */     GIR_RootConstrainSelectedInstOperands,
     /* 224442 */     // GIR_Coverage, 2286,
     /* 224442 */     GIR_Done,
     /* 224443 */   // Label 5164: @224443
     /* 224443 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(224474), // Rule ID 6085 //
     /* 224448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 224451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224463 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 224463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 224468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224472 */     GIR_RootConstrainSelectedInstOperands,
     /* 224473 */     // GIR_Coverage, 6085,
     /* 224473 */     GIR_Done,
     /* 224474 */   // Label 5165: @224474
     /* 224474 */   GIM_Reject,
     /* 224475 */ // Label 5152: @224475
     /* 224475 */ GIM_Reject,
     /* 224476 */ // Label 5137: @224476
     /* 224476 */ GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(225338),
     /* 224481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 224484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224487 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(224552), // Rule ID 1034 //
     /* 224492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224507 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224531 */     // (strict_fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m64),
     /* 224534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224550 */     GIR_RootConstrainSelectedInstOperands,
     /* 224551 */     // GIR_Coverage, 1034,
     /* 224551 */     GIR_EraseRootFromParent_Done,
     /* 224552 */   // Label 5167: @224552
     /* 224552 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(224617), // Rule ID 1036 //
     /* 224557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224572 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224596 */     // (strict_fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m64),
     /* 224599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224615 */     GIR_RootConstrainSelectedInstOperands,
     /* 224616 */     // GIR_Coverage, 1036,
     /* 224616 */     GIR_EraseRootFromParent_Done,
     /* 224617 */   // Label 5168: @224617
     /* 224617 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(224682), // Rule ID 1022 //
     /* 224622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224637 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224640 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224644 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224661 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 224664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224680 */     GIR_RootConstrainSelectedInstOperands,
     /* 224681 */     // GIR_Coverage, 1022,
     /* 224681 */     GIR_EraseRootFromParent_Done,
     /* 224682 */   // Label 5169: @224682
     /* 224682 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(224754), // Rule ID 1024 //
     /* 224687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224705 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224709 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224733 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 224736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224752 */     GIR_RootConstrainSelectedInstOperands,
     /* 224753 */     // GIR_Coverage, 1024,
     /* 224753 */     GIR_EraseRootFromParent_Done,
     /* 224754 */   // Label 5170: @224754
     /* 224754 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(224819), // Rule ID 1012 //
     /* 224759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224778 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224798 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m64),
     /* 224801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224817 */     GIR_RootConstrainSelectedInstOperands,
     /* 224818 */     // GIR_Coverage, 1012,
     /* 224818 */     GIR_EraseRootFromParent_Done,
     /* 224819 */   // Label 5171: @224819
     /* 224819 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(224884), // Rule ID 1014 //
     /* 224824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224843 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224863 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m64),
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224882 */     GIR_RootConstrainSelectedInstOperands,
     /* 224883 */     // GIR_Coverage, 1014,
     /* 224883 */     GIR_EraseRootFromParent_Done,
     /* 224884 */   // Label 5172: @224884
     /* 224884 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(224949), // Rule ID 1000 //
     /* 224889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224928 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 224931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224947 */     GIR_RootConstrainSelectedInstOperands,
     /* 224948 */     // GIR_Coverage, 1000,
     /* 224948 */     GIR_EraseRootFromParent_Done,
     /* 224949 */   // Label 5173: @224949
     /* 224949 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(225021), // Rule ID 1002 //
     /* 224954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224976 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224980 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225000 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 225003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225005 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225019 */     GIR_RootConstrainSelectedInstOperands,
     /* 225020 */     // GIR_Coverage, 1002,
     /* 225020 */     GIR_EraseRootFromParent_Done,
     /* 225021 */   // Label 5174: @225021
     /* 225021 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(225083), // Rule ID 2284 //
     /* 225026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 225029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225065 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 225068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225081 */     GIR_RootConstrainSelectedInstOperands,
     /* 225082 */     // GIR_Coverage, 2284,
     /* 225082 */     GIR_EraseRootFromParent_Done,
     /* 225083 */   // Label 5175: @225083
     /* 225083 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(225145), // Rule ID 2292 //
     /* 225088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 225091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225127 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 225130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225143 */     GIR_RootConstrainSelectedInstOperands,
     /* 225144 */     // GIR_Coverage, 2292,
     /* 225144 */     GIR_EraseRootFromParent_Done,
     /* 225145 */   // Label 5176: @225145
     /* 225145 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(225207), // Rule ID 6106 //
     /* 225150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225189 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 225192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225205 */     GIR_RootConstrainSelectedInstOperands,
     /* 225206 */     // GIR_Coverage, 6106,
     /* 225206 */     GIR_EraseRootFromParent_Done,
     /* 225207 */   // Label 5177: @225207
     /* 225207 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(225244), // Rule ID 906 //
     /* 225212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 225215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225227 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 225227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 225232 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 225238 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 225242 */     GIR_RootConstrainSelectedInstOperands,
     /* 225243 */     // GIR_Coverage, 906,
     /* 225243 */     GIR_Done,
     /* 225244 */   // Label 5178: @225244
     /* 225244 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(225275), // Rule ID 2282 //
     /* 225249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 225252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225264 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 225264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 225269 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225273 */     GIR_RootConstrainSelectedInstOperands,
     /* 225274 */     // GIR_Coverage, 2282,
     /* 225274 */     GIR_Done,
     /* 225275 */   // Label 5179: @225275
     /* 225275 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(225306), // Rule ID 2290 //
     /* 225280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 225283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225295 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 225295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 225300 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225304 */     GIR_RootConstrainSelectedInstOperands,
     /* 225305 */     // GIR_Coverage, 2290,
     /* 225305 */     GIR_Done,
     /* 225306 */   // Label 5180: @225306
     /* 225306 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(225337), // Rule ID 6104 //
     /* 225311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225326 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 225326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 225331 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225335 */     GIR_RootConstrainSelectedInstOperands,
     /* 225336 */     // GIR_Coverage, 6104,
     /* 225336 */     GIR_Done,
     /* 225337 */   // Label 5181: @225337
     /* 225337 */   GIM_Reject,
     /* 225338 */ // Label 5166: @225338
     /* 225338 */ GIM_Reject,
     /* 225339 */ // Label 5138: @225339
     /* 225339 */ GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(225904),
     /* 225344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 225347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 225350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225354 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(225415), // Rule ID 1038 //
     /* 225359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225370 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 225377 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225394 */     // (strict_fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m80),
     /* 225397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225399 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225413 */     GIR_RootConstrainSelectedInstOperands,
     /* 225414 */     // GIR_Coverage, 1038,
     /* 225414 */     GIR_EraseRootFromParent_Done,
     /* 225415 */   // Label 5183: @225415
     /* 225415 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(225476), // Rule ID 1040 //
     /* 225420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225431 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225438 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225455 */     // (strict_fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m80),
     /* 225458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225474 */     GIR_RootConstrainSelectedInstOperands,
     /* 225475 */     // GIR_Coverage, 1040,
     /* 225475 */     GIR_EraseRootFromParent_Done,
     /* 225476 */   // Label 5184: @225476
     /* 225476 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(225544), // Rule ID 1026 //
     /* 225481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225495 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225499 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225523 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 225526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225542 */     GIR_RootConstrainSelectedInstOperands,
     /* 225543 */     // GIR_Coverage, 1026,
     /* 225543 */     GIR_EraseRootFromParent_Done,
     /* 225544 */   // Label 5185: @225544
     /* 225544 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(225612), // Rule ID 1028 //
     /* 225549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225563 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225567 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 225574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225591 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 225594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225610 */     GIR_RootConstrainSelectedInstOperands,
     /* 225611 */     // GIR_Coverage, 1028,
     /* 225611 */     GIR_EraseRootFromParent_Done,
     /* 225612 */   // Label 5186: @225612
     /* 225612 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(225673), // Rule ID 1016 //
     /* 225617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225632 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 225639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225652 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m80),
     /* 225655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225671 */     GIR_RootConstrainSelectedInstOperands,
     /* 225672 */     // GIR_Coverage, 1016,
     /* 225672 */     GIR_EraseRootFromParent_Done,
     /* 225673 */   // Label 5187: @225673
     /* 225673 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(225734), // Rule ID 1018 //
     /* 225678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225693 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225713 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m80),
     /* 225716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225732 */     GIR_RootConstrainSelectedInstOperands,
     /* 225733 */     // GIR_Coverage, 1018,
     /* 225733 */     GIR_EraseRootFromParent_Done,
     /* 225734 */   // Label 5188: @225734
     /* 225734 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(225802), // Rule ID 1004 //
     /* 225739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225757 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225761 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225781 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 225784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225800 */     GIR_RootConstrainSelectedInstOperands,
     /* 225801 */     // GIR_Coverage, 1004,
     /* 225801 */     GIR_EraseRootFromParent_Done,
     /* 225802 */   // Label 5189: @225802
     /* 225802 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(225870), // Rule ID 1006 //
     /* 225807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225825 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225829 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 225836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225849 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 225852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225868 */     GIR_RootConstrainSelectedInstOperands,
     /* 225869 */     // GIR_Coverage, 1006,
     /* 225869 */     GIR_EraseRootFromParent_Done,
     /* 225870 */   // Label 5190: @225870
     /* 225870 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(225903), // Rule ID 908 //
     /* 225875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225886 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 225886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 225891 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 225897 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 225901 */     GIR_RootConstrainSelectedInstOperands,
     /* 225902 */     // GIR_Coverage, 908,
     /* 225902 */     GIR_Done,
     /* 225903 */   // Label 5191: @225903
     /* 225903 */   GIM_Reject,
     /* 225904 */ // Label 5182: @225904
     /* 225904 */ GIM_Reject,
     /* 225905 */ // Label 5139: @225905
     /* 225905 */ GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(226134),
     /* 225910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 225913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225916 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(225978), // Rule ID 2260 //
     /* 225921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 225924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 225928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 225932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225960 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 225963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225976 */     GIR_RootConstrainSelectedInstOperands,
     /* 225977 */     // GIR_Coverage, 2260,
     /* 225977 */     GIR_EraseRootFromParent_Done,
     /* 225978 */   // Label 5193: @225978
     /* 225978 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(226040), // Rule ID 6659 //
     /* 225983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 225994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226022 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 226025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226038 */     GIR_RootConstrainSelectedInstOperands,
     /* 226039 */     // GIR_Coverage, 6659,
     /* 226039 */     GIR_EraseRootFromParent_Done,
     /* 226040 */   // Label 5194: @226040
     /* 226040 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(226071), // Rule ID 2258 //
     /* 226045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226060 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 226060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 226065 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226069 */     GIR_RootConstrainSelectedInstOperands,
     /* 226070 */     // GIR_Coverage, 2258,
     /* 226070 */     GIR_Done,
     /* 226071 */   // Label 5195: @226071
     /* 226071 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(226102), // Rule ID 2274 //
     /* 226076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 226079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226091 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 226091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 226096 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226100 */     GIR_RootConstrainSelectedInstOperands,
     /* 226101 */     // GIR_Coverage, 2274,
     /* 226101 */     GIR_Done,
     /* 226102 */   // Label 5196: @226102
     /* 226102 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(226133), // Rule ID 6655 //
     /* 226107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226122 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 226122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 226127 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226131 */     GIR_RootConstrainSelectedInstOperands,
     /* 226132 */     // GIR_Coverage, 6655,
     /* 226132 */     GIR_Done,
     /* 226133 */   // Label 5197: @226133
     /* 226133 */   GIM_Reject,
     /* 226134 */ // Label 5192: @226134
     /* 226134 */ GIM_Reject,
     /* 226135 */ // Label 5140: @226135
     /* 226135 */ GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(226364),
     /* 226140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 226143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 226146 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(226208), // Rule ID 2256 //
     /* 226151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226190 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 226193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226206 */     GIR_RootConstrainSelectedInstOperands,
     /* 226207 */     // GIR_Coverage, 2256,
     /* 226207 */     GIR_EraseRootFromParent_Done,
     /* 226208 */   // Label 5199: @226208
     /* 226208 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(226270), // Rule ID 6635 //
     /* 226213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226252 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 226255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226268 */     GIR_RootConstrainSelectedInstOperands,
     /* 226269 */     // GIR_Coverage, 6635,
     /* 226269 */     GIR_EraseRootFromParent_Done,
     /* 226270 */   // Label 5200: @226270
     /* 226270 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(226301), // Rule ID 2254 //
     /* 226275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226290 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 226290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 226295 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226299 */     GIR_RootConstrainSelectedInstOperands,
     /* 226300 */     // GIR_Coverage, 2254,
     /* 226300 */     GIR_Done,
     /* 226301 */   // Label 5201: @226301
     /* 226301 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(226332), // Rule ID 2270 //
     /* 226306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 226309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226321 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 226321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 226326 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226330 */     GIR_RootConstrainSelectedInstOperands,
     /* 226331 */     // GIR_Coverage, 2270,
     /* 226331 */     GIR_Done,
     /* 226332 */   // Label 5202: @226332
     /* 226332 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(226363), // Rule ID 6631 //
     /* 226337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226352 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 226352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 226357 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226361 */     GIR_RootConstrainSelectedInstOperands,
     /* 226362 */     // GIR_Coverage, 6631,
     /* 226362 */     GIR_Done,
     /* 226363 */   // Label 5203: @226363
     /* 226363 */   GIM_Reject,
     /* 226364 */ // Label 5198: @226364
     /* 226364 */ GIM_Reject,
     /* 226365 */ // Label 5141: @226365
     /* 226365 */ GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(226563),
     /* 226370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 226373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 226376 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(226438), // Rule ID 2268 //
     /* 226381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226420 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 226423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226425 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226436 */     GIR_RootConstrainSelectedInstOperands,
     /* 226437 */     // GIR_Coverage, 2268,
     /* 226437 */     GIR_EraseRootFromParent_Done,
     /* 226438 */   // Label 5205: @226438
     /* 226438 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(226500), // Rule ID 6671 //
     /* 226443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226482 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 226485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226498 */     GIR_RootConstrainSelectedInstOperands,
     /* 226499 */     // GIR_Coverage, 6671,
     /* 226499 */     GIR_EraseRootFromParent_Done,
     /* 226500 */   // Label 5206: @226500
     /* 226500 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(226531), // Rule ID 2266 //
     /* 226505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226520 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 226520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 226525 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226529 */     GIR_RootConstrainSelectedInstOperands,
     /* 226530 */     // GIR_Coverage, 2266,
     /* 226530 */     GIR_Done,
     /* 226531 */   // Label 5207: @226531
     /* 226531 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(226562), // Rule ID 6667 //
     /* 226536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226551 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 226551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 226556 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226560 */     GIR_RootConstrainSelectedInstOperands,
     /* 226561 */     // GIR_Coverage, 6667,
     /* 226561 */     GIR_Done,
     /* 226562 */   // Label 5208: @226562
     /* 226562 */   GIM_Reject,
     /* 226563 */ // Label 5204: @226563
     /* 226563 */ GIM_Reject,
     /* 226564 */ // Label 5142: @226564
     /* 226564 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(226661),
     /* 226569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 226572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 226575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226583 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(226637), // Rule ID 6695 //
     /* 226588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226619 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 226622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226635 */     GIR_RootConstrainSelectedInstOperands,
     /* 226636 */     // GIR_Coverage, 6695,
     /* 226636 */     GIR_EraseRootFromParent_Done,
     /* 226637 */   // Label 5210: @226637
     /* 226637 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(226660), // Rule ID 6691 //
     /* 226642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226649 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 226649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 226654 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226658 */     GIR_RootConstrainSelectedInstOperands,
     /* 226659 */     // GIR_Coverage, 6691,
     /* 226659 */     GIR_Done,
     /* 226660 */   // Label 5211: @226660
     /* 226660 */   GIM_Reject,
     /* 226661 */ // Label 5209: @226661
     /* 226661 */ GIM_Reject,
     /* 226662 */ // Label 5143: @226662
     /* 226662 */ GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(226860),
     /* 226667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 226670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 226673 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(226735), // Rule ID 2264 //
     /* 226678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226717 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 226720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226733 */     GIR_RootConstrainSelectedInstOperands,
     /* 226734 */     // GIR_Coverage, 2264,
     /* 226734 */     GIR_EraseRootFromParent_Done,
     /* 226735 */   // Label 5213: @226735
     /* 226735 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(226797), // Rule ID 6647 //
     /* 226740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226779 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 226782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226784 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226795 */     GIR_RootConstrainSelectedInstOperands,
     /* 226796 */     // GIR_Coverage, 6647,
     /* 226796 */     GIR_EraseRootFromParent_Done,
     /* 226797 */   // Label 5214: @226797
     /* 226797 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(226828), // Rule ID 2262 //
     /* 226802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226817 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 226817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 226822 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226826 */     GIR_RootConstrainSelectedInstOperands,
     /* 226827 */     // GIR_Coverage, 2262,
     /* 226827 */     GIR_Done,
     /* 226828 */   // Label 5215: @226828
     /* 226828 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(226859), // Rule ID 6643 //
     /* 226833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226848 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 226848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 226853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226857 */     GIR_RootConstrainSelectedInstOperands,
     /* 226858 */     // GIR_Coverage, 6643,
     /* 226858 */     GIR_Done,
     /* 226859 */   // Label 5216: @226859
     /* 226859 */   GIM_Reject,
     /* 226860 */ // Label 5212: @226860
     /* 226860 */ GIM_Reject,
     /* 226861 */ // Label 5144: @226861
     /* 226861 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(226958),
     /* 226866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 226869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 226872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226880 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(226934), // Rule ID 6623 //
     /* 226885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226916 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 226919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226921 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226932 */     GIR_RootConstrainSelectedInstOperands,
     /* 226933 */     // GIR_Coverage, 6623,
     /* 226933 */     GIR_EraseRootFromParent_Done,
     /* 226934 */   // Label 5218: @226934
     /* 226934 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(226957), // Rule ID 6619 //
     /* 226939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226946 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 226946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 226951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226955 */     GIR_RootConstrainSelectedInstOperands,
     /* 226956 */     // GIR_Coverage, 6619,
     /* 226956 */     GIR_Done,
     /* 226957 */   // Label 5219: @226957
     /* 226957 */   GIM_Reject,
     /* 226958 */ // Label 5217: @226958
     /* 226958 */ GIM_Reject,
     /* 226959 */ // Label 5145: @226959
     /* 226959 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(227056),
     /* 226964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 226967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 226970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226978 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(227032), // Rule ID 6707 //
     /* 226983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227014 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 227017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227030 */     GIR_RootConstrainSelectedInstOperands,
     /* 227031 */     // GIR_Coverage, 6707,
     /* 227031 */     GIR_EraseRootFromParent_Done,
     /* 227032 */   // Label 5221: @227032
     /* 227032 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(227055), // Rule ID 6703 //
     /* 227037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 227040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227044 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 227044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 227049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227053 */     GIR_RootConstrainSelectedInstOperands,
     /* 227054 */     // GIR_Coverage, 6703,
     /* 227054 */     GIR_Done,
     /* 227055 */   // Label 5222: @227055
     /* 227055 */   GIM_Reject,
     /* 227056 */ // Label 5220: @227056
     /* 227056 */ GIM_Reject,
     /* 227057 */ // Label 5146: @227057
     /* 227057 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(227154),
     /* 227062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 227065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 227068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227076 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(227130), // Rule ID 6611 //
     /* 227081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227112 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 227115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227128 */     GIR_RootConstrainSelectedInstOperands,
     /* 227129 */     // GIR_Coverage, 6611,
     /* 227129 */     GIR_EraseRootFromParent_Done,
     /* 227130 */   // Label 5224: @227130
     /* 227130 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(227153), // Rule ID 6607 //
     /* 227135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227142 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 227142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 227147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227151 */     GIR_RootConstrainSelectedInstOperands,
     /* 227152 */     // GIR_Coverage, 6607,
     /* 227152 */     GIR_Done,
     /* 227153 */   // Label 5225: @227153
     /* 227153 */   GIM_Reject,
     /* 227154 */ // Label 5223: @227154
     /* 227154 */ GIM_Reject,
     /* 227155 */ // Label 5147: @227155
     /* 227155 */ GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(227252),
     /* 227160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 227163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 227166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227174 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(227228), // Rule ID 6683 //
     /* 227179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227210 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 227213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227226 */     GIR_RootConstrainSelectedInstOperands,
     /* 227227 */     // GIR_Coverage, 6683,
     /* 227227 */     GIR_EraseRootFromParent_Done,
     /* 227228 */   // Label 5227: @227228
     /* 227228 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(227251), // Rule ID 6679 //
     /* 227233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227240 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 227240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 227245 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227249 */     GIR_RootConstrainSelectedInstOperands,
     /* 227250 */     // GIR_Coverage, 6679,
     /* 227250 */     GIR_Done,
     /* 227251 */   // Label 5228: @227251
     /* 227251 */   GIM_Reject,
     /* 227252 */ // Label 5226: @227252
     /* 227252 */ GIM_Reject,
     /* 227253 */ // Label 5148: @227253
     /* 227253 */ GIM_Reject,
     /* 227254 */ // Label 72: @227254
     /* 227254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5241*/ GIMT_Encode4(233241),
     /* 227265 */ /*GILLT_s16*//*Label 5229*/ GIMT_Encode4(227349),
     /* 227269 */ /*GILLT_s32*//*Label 5230*/ GIMT_Encode4(227594),
     /* 227273 */ /*GILLT_s64*//*Label 5231*/ GIMT_Encode4(228331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227289 */ /*GILLT_v2s64*//*Label 5232*/ GIMT_Encode4(229068), GIMT_Encode4(0),
     /* 227297 */ /*GILLT_v4s32*//*Label 5233*/ GIMT_Encode4(229805),
     /* 227301 */ /*GILLT_v4s64*//*Label 5234*/ GIMT_Encode4(230542), GIMT_Encode4(0),
     /* 227309 */ /*GILLT_v8s16*//*Label 5235*/ GIMT_Encode4(231279),
     /* 227313 */ /*GILLT_v8s32*//*Label 5236*/ GIMT_Encode4(231524),
     /* 227317 */ /*GILLT_v8s64*//*Label 5237*/ GIMT_Encode4(232261), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227329 */ /*GILLT_v16s16*//*Label 5238*/ GIMT_Encode4(232506),
     /* 227333 */ /*GILLT_v16s32*//*Label 5239*/ GIMT_Encode4(232751), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227345 */ /*GILLT_v32s16*//*Label 5240*/ GIMT_Encode4(232996),
     /* 227349 */ // Label 5229: @227349
     /* 227349 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(227593),
     /* 227354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 227357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 227363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227367 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(227431), // Rule ID 10157 //
     /* 227372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227411 */     // (strict_fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 227414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227418 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227429 */     GIR_RootConstrainSelectedInstOperands,
     /* 227430 */     // GIR_Coverage, 10157,
     /* 227430 */     GIR_EraseRootFromParent_Done,
     /* 227431 */   // Label 5243: @227431
     /* 227431 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(227495), // Rule ID 10155 //
     /* 227436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227451 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227475 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 227478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227480 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 227482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227493 */     GIR_RootConstrainSelectedInstOperands,
     /* 227494 */     // GIR_Coverage, 10155,
     /* 227494 */     GIR_EraseRootFromParent_Done,
     /* 227495 */   // Label 5244: @227495
     /* 227495 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(227559), // Rule ID 10152 //
     /* 227500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 227515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227519 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227539 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 227542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227546 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227548 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227557 */     GIR_RootConstrainSelectedInstOperands,
     /* 227558 */     // GIR_Coverage, 10152,
     /* 227558 */     GIR_EraseRootFromParent_Done,
     /* 227559 */   // Label 5245: @227559
     /* 227559 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(227592), // Rule ID 10150 //
     /* 227564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227579 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 227579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 227582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227584 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227588 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227590 */     GIR_RootConstrainSelectedInstOperands,
     /* 227591 */     // GIR_Coverage, 10150,
     /* 227591 */     GIR_EraseRootFromParent_Done,
     /* 227592 */   // Label 5246: @227592
     /* 227592 */   GIM_Reject,
     /* 227593 */ // Label 5242: @227593
     /* 227593 */ GIM_Reject,
     /* 227594 */ // Label 5230: @227594
     /* 227594 */ GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(228330),
     /* 227599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 227602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 227608 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(227676), // Rule ID 1303 //
     /* 227613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 227616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227656 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 227659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227663 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227674 */     GIR_RootConstrainSelectedInstOperands,
     /* 227675 */     // GIR_Coverage, 1303,
     /* 227675 */     GIR_EraseRootFromParent_Done,
     /* 227676 */   // Label 5248: @227676
     /* 227676 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(227744), // Rule ID 10139 //
     /* 227681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227724 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 227727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227731 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227742 */     GIR_RootConstrainSelectedInstOperands,
     /* 227743 */     // GIR_Coverage, 10139,
     /* 227743 */     GIR_EraseRootFromParent_Done,
     /* 227744 */   // Label 5249: @227744
     /* 227744 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(227812), // Rule ID 23280 //
     /* 227749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 227752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227771 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227792 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 227792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227803 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227810 */     GIR_RootConstrainSelectedInstOperands,
     /* 227811 */     // GIR_Coverage, 23280,
     /* 227811 */     GIR_EraseRootFromParent_Done,
     /* 227812 */   // Label 5250: @227812
     /* 227812 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(227880), // Rule ID 1301 //
     /* 227817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 227820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227860 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 227863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227865 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 227867 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227878 */     GIR_RootConstrainSelectedInstOperands,
     /* 227879 */     // GIR_Coverage, 1301,
     /* 227879 */     GIR_EraseRootFromParent_Done,
     /* 227880 */   // Label 5251: @227880
     /* 227880 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(227948), // Rule ID 1365 //
     /* 227885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 227888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227928 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 227928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 227931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227939 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227946 */     GIR_RootConstrainSelectedInstOperands,
     /* 227947 */     // GIR_Coverage, 1365,
     /* 227947 */     GIR_EraseRootFromParent_Done,
     /* 227948 */   // Label 5252: @227948
     /* 227948 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(228016), // Rule ID 10137 //
     /* 227953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227996 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 227999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228014 */     GIR_RootConstrainSelectedInstOperands,
     /* 228015 */     // GIR_Coverage, 10137,
     /* 228015 */     GIR_EraseRootFromParent_Done,
     /* 228016 */   // Label 5253: @228016
     /* 228016 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(228084), // Rule ID 1299 //
     /* 228021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228064 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 228067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228071 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228082 */     GIR_RootConstrainSelectedInstOperands,
     /* 228083 */     // GIR_Coverage, 1299,
     /* 228083 */     GIR_EraseRootFromParent_Done,
     /* 228084 */   // Label 5254: @228084
     /* 228084 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(228152), // Rule ID 1363 //
     /* 228089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228132 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 228135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 228141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228150 */     GIR_RootConstrainSelectedInstOperands,
     /* 228151 */     // GIR_Coverage, 1363,
     /* 228151 */     GIR_EraseRootFromParent_Done,
     /* 228152 */   // Label 5255: @228152
     /* 228152 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(228220), // Rule ID 10134 //
     /* 228157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228200 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 228203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228218 */     GIR_RootConstrainSelectedInstOperands,
     /* 228219 */     // GIR_Coverage, 10134,
     /* 228219 */     GIR_EraseRootFromParent_Done,
     /* 228220 */   // Label 5256: @228220
     /* 228220 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(228257), // Rule ID 1297 //
     /* 228225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228244 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 228244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 228247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228249 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228253 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228255 */     GIR_RootConstrainSelectedInstOperands,
     /* 228256 */     // GIR_Coverage, 1297,
     /* 228256 */     GIR_EraseRootFromParent_Done,
     /* 228257 */   // Label 5257: @228257
     /* 228257 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(228292), // Rule ID 1361 //
     /* 228262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228281 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 228281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 228286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228290 */     GIR_RootConstrainSelectedInstOperands,
     /* 228291 */     // GIR_Coverage, 1361,
     /* 228291 */     GIR_Done,
     /* 228292 */   // Label 5258: @228292
     /* 228292 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(228329), // Rule ID 10132 //
     /* 228297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228316 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 228316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 228319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228325 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228327 */     GIR_RootConstrainSelectedInstOperands,
     /* 228328 */     // GIR_Coverage, 10132,
     /* 228328 */     GIR_EraseRootFromParent_Done,
     /* 228329 */   // Label 5259: @228329
     /* 228329 */   GIM_Reject,
     /* 228330 */ // Label 5247: @228330
     /* 228330 */ GIM_Reject,
     /* 228331 */ // Label 5231: @228331
     /* 228331 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(229067),
     /* 228336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 228339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 228345 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(228413), // Rule ID 1311 //
     /* 228350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228393 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 228396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 228402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228411 */     GIR_RootConstrainSelectedInstOperands,
     /* 228412 */     // GIR_Coverage, 1311,
     /* 228412 */     GIR_EraseRootFromParent_Done,
     /* 228413 */   // Label 5261: @228413
     /* 228413 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(228481), // Rule ID 10148 //
     /* 228418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228461 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 228464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228468 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 228470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228479 */     GIR_RootConstrainSelectedInstOperands,
     /* 228480 */     // GIR_Coverage, 10148,
     /* 228480 */     GIR_EraseRootFromParent_Done,
     /* 228481 */   // Label 5262: @228481
     /* 228481 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(228549), // Rule ID 23308 //
     /* 228486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228501 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228508 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228529 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 228532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228534 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 228540 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228547 */     GIR_RootConstrainSelectedInstOperands,
     /* 228548 */     // GIR_Coverage, 23308,
     /* 228548 */     GIR_EraseRootFromParent_Done,
     /* 228549 */   // Label 5263: @228549
     /* 228549 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(228617), // Rule ID 1309 //
     /* 228554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228573 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228580 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228597 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 228600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228602 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228615 */     GIR_RootConstrainSelectedInstOperands,
     /* 228616 */     // GIR_Coverage, 1309,
     /* 228616 */     GIR_EraseRootFromParent_Done,
     /* 228617 */   // Label 5264: @228617
     /* 228617 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(228685), // Rule ID 1449 //
     /* 228622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228665 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 228668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228670 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 228676 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228683 */     GIR_RootConstrainSelectedInstOperands,
     /* 228684 */     // GIR_Coverage, 1449,
     /* 228684 */     GIR_EraseRootFromParent_Done,
     /* 228685 */   // Label 5265: @228685
     /* 228685 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(228753), // Rule ID 10146 //
     /* 228690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228709 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228733 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 228736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228738 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228751 */     GIR_RootConstrainSelectedInstOperands,
     /* 228752 */     // GIR_Coverage, 10146,
     /* 228752 */     GIR_EraseRootFromParent_Done,
     /* 228753 */   // Label 5266: @228753
     /* 228753 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(228821), // Rule ID 1307 //
     /* 228758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228801 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 228804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228819 */     GIR_RootConstrainSelectedInstOperands,
     /* 228820 */     // GIR_Coverage, 1307,
     /* 228820 */     GIR_EraseRootFromParent_Done,
     /* 228821 */   // Label 5267: @228821
     /* 228821 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(228889), // Rule ID 1447 //
     /* 228826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228869 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 228872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 228878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228887 */     GIR_RootConstrainSelectedInstOperands,
     /* 228888 */     // GIR_Coverage, 1447,
     /* 228888 */     GIR_EraseRootFromParent_Done,
     /* 228889 */   // Label 5268: @228889
     /* 228889 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(228957), // Rule ID 10143 //
     /* 228894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228937 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 228940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228944 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228946 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228955 */     GIR_RootConstrainSelectedInstOperands,
     /* 228956 */     // GIR_Coverage, 10143,
     /* 228956 */     GIR_EraseRootFromParent_Done,
     /* 228957 */   // Label 5269: @228957
     /* 228957 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(228994), // Rule ID 1305 //
     /* 228962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228981 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 228984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228986 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228988 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228990 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228992 */     GIR_RootConstrainSelectedInstOperands,
     /* 228993 */     // GIR_Coverage, 1305,
     /* 228993 */     GIR_EraseRootFromParent_Done,
     /* 228994 */   // Label 5270: @228994
     /* 228994 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(229029), // Rule ID 1445 //
     /* 228999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 229002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229018 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 229018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 229023 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229027 */     GIR_RootConstrainSelectedInstOperands,
     /* 229028 */     // GIR_Coverage, 1445,
     /* 229028 */     GIR_Done,
     /* 229029 */   // Label 5271: @229029
     /* 229029 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(229066), // Rule ID 10141 //
     /* 229034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 229037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229053 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 229053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 229056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229062 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229064 */     GIR_RootConstrainSelectedInstOperands,
     /* 229065 */     // GIR_Coverage, 10141,
     /* 229065 */     GIR_EraseRootFromParent_Done,
     /* 229066 */   // Label 5272: @229066
     /* 229066 */   GIM_Reject,
     /* 229067 */ // Label 5260: @229067
     /* 229067 */ GIM_Reject,
     /* 229068 */ // Label 5232: @229068
     /* 229068 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(229804),
     /* 229073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 229076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 229079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 229082 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(229150), // Rule ID 1191 //
     /* 229087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229130 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 229133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229137 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229148 */     GIR_RootConstrainSelectedInstOperands,
     /* 229149 */     // GIR_Coverage, 1191,
     /* 229149 */     GIR_EraseRootFromParent_Done,
     /* 229150 */   // Label 5274: @229150
     /* 229150 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(229218), // Rule ID 9680 //
     /* 229155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229198 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 229201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229205 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229216 */     GIR_RootConstrainSelectedInstOperands,
     /* 229217 */     // GIR_Coverage, 9680,
     /* 229217 */     GIR_EraseRootFromParent_Done,
     /* 229218 */   // Label 5275: @229218
     /* 229218 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(229286), // Rule ID 23316 //
     /* 229223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229266 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 229269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 229277 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229284 */     GIR_RootConstrainSelectedInstOperands,
     /* 229285 */     // GIR_Coverage, 23316,
     /* 229285 */     GIR_EraseRootFromParent_Done,
     /* 229286 */   // Label 5276: @229286
     /* 229286 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(229354), // Rule ID 1189 //
     /* 229291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229334 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 229337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229339 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 229341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229352 */     GIR_RootConstrainSelectedInstOperands,
     /* 229353 */     // GIR_Coverage, 1189,
     /* 229353 */     GIR_EraseRootFromParent_Done,
     /* 229354 */   // Label 5277: @229354
     /* 229354 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(229422), // Rule ID 1473 //
     /* 229359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229402 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 229405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 229409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 229413 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229420 */     GIR_RootConstrainSelectedInstOperands,
     /* 229421 */     // GIR_Coverage, 1473,
     /* 229421 */     GIR_EraseRootFromParent_Done,
     /* 229422 */   // Label 5278: @229422
     /* 229422 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(229490), // Rule ID 9140 //
     /* 229427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229470 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 229473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 229477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229488 */     GIR_RootConstrainSelectedInstOperands,
     /* 229489 */     // GIR_Coverage, 9140,
     /* 229489 */     GIR_EraseRootFromParent_Done,
     /* 229490 */   // Label 5279: @229490
     /* 229490 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(229558), // Rule ID 1187 //
     /* 229495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229538 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 229541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229556 */     GIR_RootConstrainSelectedInstOperands,
     /* 229557 */     // GIR_Coverage, 1187,
     /* 229557 */     GIR_EraseRootFromParent_Done,
     /* 229558 */   // Label 5280: @229558
     /* 229558 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(229626), // Rule ID 1471 //
     /* 229563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229606 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 229609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 229613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 229615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229624 */     GIR_RootConstrainSelectedInstOperands,
     /* 229625 */     // GIR_Coverage, 1471,
     /* 229625 */     GIR_EraseRootFromParent_Done,
     /* 229626 */   // Label 5281: @229626
     /* 229626 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(229694), // Rule ID 8513 //
     /* 229631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229674 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 229677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229692 */     GIR_RootConstrainSelectedInstOperands,
     /* 229693 */     // GIR_Coverage, 8513,
     /* 229693 */     GIR_EraseRootFromParent_Done,
     /* 229694 */   // Label 5282: @229694
     /* 229694 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(229731), // Rule ID 1185 //
     /* 229699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229718 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 229721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229727 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229729 */     GIR_RootConstrainSelectedInstOperands,
     /* 229730 */     // GIR_Coverage, 1185,
     /* 229730 */     GIR_EraseRootFromParent_Done,
     /* 229731 */   // Label 5283: @229731
     /* 229731 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(229766), // Rule ID 1469 //
     /* 229736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229755 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 229760 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229764 */     GIR_RootConstrainSelectedInstOperands,
     /* 229765 */     // GIR_Coverage, 1469,
     /* 229765 */     GIR_Done,
     /* 229766 */   // Label 5284: @229766
     /* 229766 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(229803), // Rule ID 8509 //
     /* 229771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229790 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 229790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 229793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229799 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229801 */     GIR_RootConstrainSelectedInstOperands,
     /* 229802 */     // GIR_Coverage, 8509,
     /* 229802 */     GIR_EraseRootFromParent_Done,
     /* 229803 */   // Label 5285: @229803
     /* 229803 */   GIM_Reject,
     /* 229804 */ // Label 5273: @229804
     /* 229804 */ GIM_Reject,
     /* 229805 */ // Label 5233: @229805
     /* 229805 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(230541),
     /* 229810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 229813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 229819 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(229887), // Rule ID 1143 //
     /* 229824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229867 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 229870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229874 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229885 */     GIR_RootConstrainSelectedInstOperands,
     /* 229886 */     // GIR_Coverage, 1143,
     /* 229886 */     GIR_EraseRootFromParent_Done,
     /* 229887 */   // Label 5287: @229887
     /* 229887 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(229955), // Rule ID 9648 //
     /* 229892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229907 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229914 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229935 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 229938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229942 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229953 */     GIR_RootConstrainSelectedInstOperands,
     /* 229954 */     // GIR_Coverage, 9648,
     /* 229954 */     GIR_EraseRootFromParent_Done,
     /* 229955 */   // Label 5288: @229955
     /* 229955 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(230023), // Rule ID 23288 //
     /* 229960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230003 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 230006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230014 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230021 */     GIR_RootConstrainSelectedInstOperands,
     /* 230022 */     // GIR_Coverage, 23288,
     /* 230022 */     GIR_EraseRootFromParent_Done,
     /* 230023 */   // Label 5289: @230023
     /* 230023 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(230091), // Rule ID 1141 //
     /* 230028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230047 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230071 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 230074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230076 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230089 */     GIR_RootConstrainSelectedInstOperands,
     /* 230090 */     // GIR_Coverage, 1141,
     /* 230090 */     GIR_EraseRootFromParent_Done,
     /* 230091 */   // Label 5290: @230091
     /* 230091 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(230159), // Rule ID 1389 //
     /* 230096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230139 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 230142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230150 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230157 */     GIR_RootConstrainSelectedInstOperands,
     /* 230158 */     // GIR_Coverage, 1389,
     /* 230158 */     GIR_EraseRootFromParent_Done,
     /* 230159 */   // Label 5291: @230159
     /* 230159 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(230227), // Rule ID 9108 //
     /* 230164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230207 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 230210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230212 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230225 */     GIR_RootConstrainSelectedInstOperands,
     /* 230226 */     // GIR_Coverage, 9108,
     /* 230226 */     GIR_EraseRootFromParent_Done,
     /* 230227 */   // Label 5292: @230227
     /* 230227 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(230295), // Rule ID 1139 //
     /* 230232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230258 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230275 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 230278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230280 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230293 */     GIR_RootConstrainSelectedInstOperands,
     /* 230294 */     // GIR_Coverage, 1139,
     /* 230294 */     GIR_EraseRootFromParent_Done,
     /* 230295 */   // Label 5293: @230295
     /* 230295 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(230363), // Rule ID 1387 //
     /* 230300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230343 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 230346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 230352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230361 */     GIR_RootConstrainSelectedInstOperands,
     /* 230362 */     // GIR_Coverage, 1387,
     /* 230362 */     GIR_EraseRootFromParent_Done,
     /* 230363 */   // Label 5294: @230363
     /* 230363 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(230431), // Rule ID 8474 //
     /* 230368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230411 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 230414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230429 */     GIR_RootConstrainSelectedInstOperands,
     /* 230430 */     // GIR_Coverage, 8474,
     /* 230430 */     GIR_EraseRootFromParent_Done,
     /* 230431 */   // Label 5295: @230431
     /* 230431 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(230468), // Rule ID 1137 //
     /* 230436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230455 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 230458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230464 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230466 */     GIR_RootConstrainSelectedInstOperands,
     /* 230467 */     // GIR_Coverage, 1137,
     /* 230467 */     GIR_EraseRootFromParent_Done,
     /* 230468 */   // Label 5296: @230468
     /* 230468 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(230503), // Rule ID 1385 //
     /* 230473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230492 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 230497 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 230501 */     GIR_RootConstrainSelectedInstOperands,
     /* 230502 */     // GIR_Coverage, 1385,
     /* 230502 */     GIR_Done,
     /* 230503 */   // Label 5297: @230503
     /* 230503 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(230540), // Rule ID 8470 //
     /* 230508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230527 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 230527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 230530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230532 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230536 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230538 */     GIR_RootConstrainSelectedInstOperands,
     /* 230539 */     // GIR_Coverage, 8470,
     /* 230539 */     GIR_EraseRootFromParent_Done,
     /* 230540 */   // Label 5298: @230540
     /* 230540 */   GIM_Reject,
     /* 230541 */ // Label 5286: @230541
     /* 230541 */ GIM_Reject,
     /* 230542 */ // Label 5234: @230542
     /* 230542 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(231278),
     /* 230547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 230550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 230553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 230556 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(230624), // Rule ID 1199 //
     /* 230561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230604 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 230607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230611 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 230613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230622 */     GIR_RootConstrainSelectedInstOperands,
     /* 230623 */     // GIR_Coverage, 1199,
     /* 230623 */     GIR_EraseRootFromParent_Done,
     /* 230624 */   // Label 5300: @230624
     /* 230624 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(230692), // Rule ID 9670 //
     /* 230629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230672 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 230675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230679 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 230681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230690 */     GIR_RootConstrainSelectedInstOperands,
     /* 230691 */     // GIR_Coverage, 9670,
     /* 230691 */     GIR_EraseRootFromParent_Done,
     /* 230692 */   // Label 5301: @230692
     /* 230692 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(230760), // Rule ID 23318 //
     /* 230697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230740 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 230740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 230743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230751 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230758 */     GIR_RootConstrainSelectedInstOperands,
     /* 230759 */     // GIR_Coverage, 23318,
     /* 230759 */     GIR_EraseRootFromParent_Done,
     /* 230760 */   // Label 5302: @230760
     /* 230760 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(230828), // Rule ID 1197 //
     /* 230765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230808 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 230811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230813 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230826 */     GIR_RootConstrainSelectedInstOperands,
     /* 230827 */     // GIR_Coverage, 1197,
     /* 230827 */     GIR_EraseRootFromParent_Done,
     /* 230828 */   // Label 5303: @230828
     /* 230828 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(230896), // Rule ID 1479 //
     /* 230833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230876 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 230876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 230879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230887 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230894 */     GIR_RootConstrainSelectedInstOperands,
     /* 230895 */     // GIR_Coverage, 1479,
     /* 230895 */     GIR_EraseRootFromParent_Done,
     /* 230896 */   // Label 5304: @230896
     /* 230896 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(230964), // Rule ID 9130 //
     /* 230901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230944 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 230947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230949 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230962 */     GIR_RootConstrainSelectedInstOperands,
     /* 230963 */     // GIR_Coverage, 9130,
     /* 230963 */     GIR_EraseRootFromParent_Done,
     /* 230964 */   // Label 5305: @230964
     /* 230964 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(231032), // Rule ID 1195 //
     /* 230969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231012 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 231015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231030 */     GIR_RootConstrainSelectedInstOperands,
     /* 231031 */     // GIR_Coverage, 1195,
     /* 231031 */     GIR_EraseRootFromParent_Done,
     /* 231032 */   // Label 5306: @231032
     /* 231032 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(231100), // Rule ID 1477 //
     /* 231037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231080 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 231083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 231087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 231089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231098 */     GIR_RootConstrainSelectedInstOperands,
     /* 231099 */     // GIR_Coverage, 1477,
     /* 231099 */     GIR_EraseRootFromParent_Done,
     /* 231100 */   // Label 5307: @231100
     /* 231100 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(231168), // Rule ID 8501 //
     /* 231105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231148 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 231151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231166 */     GIR_RootConstrainSelectedInstOperands,
     /* 231167 */     // GIR_Coverage, 8501,
     /* 231167 */     GIR_EraseRootFromParent_Done,
     /* 231168 */   // Label 5308: @231168
     /* 231168 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(231205), // Rule ID 1193 //
     /* 231173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231192 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 231192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 231195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231201 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231203 */     GIR_RootConstrainSelectedInstOperands,
     /* 231204 */     // GIR_Coverage, 1193,
     /* 231204 */     GIR_EraseRootFromParent_Done,
     /* 231205 */   // Label 5309: @231205
     /* 231205 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(231240), // Rule ID 1475 //
     /* 231210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231229 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 231229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 231234 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 231238 */     GIR_RootConstrainSelectedInstOperands,
     /* 231239 */     // GIR_Coverage, 1475,
     /* 231239 */     GIR_Done,
     /* 231240 */   // Label 5310: @231240
     /* 231240 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(231277), // Rule ID 8497 //
     /* 231245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231264 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 231264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 231267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231273 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231275 */     GIR_RootConstrainSelectedInstOperands,
     /* 231276 */     // GIR_Coverage, 8497,
     /* 231276 */     GIR_EraseRootFromParent_Done,
     /* 231277 */   // Label 5311: @231277
     /* 231277 */   GIM_Reject,
     /* 231278 */ // Label 5299: @231278
     /* 231278 */ GIM_Reject,
     /* 231279 */ // Label 5235: @231279
     /* 231279 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(231523),
     /* 231284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 231287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231297 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(231361), // Rule ID 9616 //
     /* 231302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231341 */     // (strict_fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 231344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231348 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231350 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231359 */     GIR_RootConstrainSelectedInstOperands,
     /* 231360 */     // GIR_Coverage, 9616,
     /* 231360 */     GIR_EraseRootFromParent_Done,
     /* 231361 */   // Label 5313: @231361
     /* 231361 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(231425), // Rule ID 9076 //
     /* 231366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231405 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 231408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231410 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231423 */     GIR_RootConstrainSelectedInstOperands,
     /* 231424 */     // GIR_Coverage, 9076,
     /* 231424 */     GIR_EraseRootFromParent_Done,
     /* 231425 */   // Label 5314: @231425
     /* 231425 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(231489), // Rule ID 8435 //
     /* 231430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231469 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 231472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231487 */     GIR_RootConstrainSelectedInstOperands,
     /* 231488 */     // GIR_Coverage, 8435,
     /* 231488 */     GIR_EraseRootFromParent_Done,
     /* 231489 */   // Label 5315: @231489
     /* 231489 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(231522), // Rule ID 8431 //
     /* 231494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231509 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 231509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 231512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231516 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231518 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231520 */     GIR_RootConstrainSelectedInstOperands,
     /* 231521 */     // GIR_Coverage, 8431,
     /* 231521 */     GIR_EraseRootFromParent_Done,
     /* 231522 */   // Label 5316: @231522
     /* 231522 */   GIM_Reject,
     /* 231523 */ // Label 5312: @231523
     /* 231523 */ GIM_Reject,
     /* 231524 */ // Label 5236: @231524
     /* 231524 */ GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(232260),
     /* 231529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 231532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 231535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 231538 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(231606), // Rule ID 1151 //
     /* 231543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231586 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 231589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231591 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231593 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231604 */     GIR_RootConstrainSelectedInstOperands,
     /* 231605 */     // GIR_Coverage, 1151,
     /* 231605 */     GIR_EraseRootFromParent_Done,
     /* 231606 */   // Label 5318: @231606
     /* 231606 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(231674), // Rule ID 9638 //
     /* 231611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231629 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231633 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231654 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 231657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231659 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231661 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231672 */     GIR_RootConstrainSelectedInstOperands,
     /* 231673 */     // GIR_Coverage, 9638,
     /* 231673 */     GIR_EraseRootFromParent_Done,
     /* 231674 */   // Label 5319: @231674
     /* 231674 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(231742), // Rule ID 23290 //
     /* 231679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231722 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 231722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 231725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231727 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 231733 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231740 */     GIR_RootConstrainSelectedInstOperands,
     /* 231741 */     // GIR_Coverage, 23290,
     /* 231741 */     GIR_EraseRootFromParent_Done,
     /* 231742 */   // Label 5320: @231742
     /* 231742 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(231810), // Rule ID 1149 //
     /* 231747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231790 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 231793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231808 */     GIR_RootConstrainSelectedInstOperands,
     /* 231809 */     // GIR_Coverage, 1149,
     /* 231809 */     GIR_EraseRootFromParent_Done,
     /* 231810 */   // Label 5321: @231810
     /* 231810 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(231878), // Rule ID 1395 //
     /* 231815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231858 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 231858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 231861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231863 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 231865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 231869 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231876 */     GIR_RootConstrainSelectedInstOperands,
     /* 231877 */     // GIR_Coverage, 1395,
     /* 231877 */     GIR_EraseRootFromParent_Done,
     /* 231878 */   // Label 5322: @231878
     /* 231878 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(231946), // Rule ID 9098 //
     /* 231883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231926 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 231929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231931 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231944 */     GIR_RootConstrainSelectedInstOperands,
     /* 231945 */     // GIR_Coverage, 9098,
     /* 231945 */     GIR_EraseRootFromParent_Done,
     /* 231946 */   // Label 5323: @231946
     /* 231946 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(232014), // Rule ID 1147 //
     /* 231951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231994 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 231997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232012 */     GIR_RootConstrainSelectedInstOperands,
     /* 232013 */     // GIR_Coverage, 1147,
     /* 232013 */     GIR_EraseRootFromParent_Done,
     /* 232014 */   // Label 5324: @232014
     /* 232014 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(232082), // Rule ID 1393 //
     /* 232019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 232022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232062 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 232065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 232069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 232071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232080 */     GIR_RootConstrainSelectedInstOperands,
     /* 232081 */     // GIR_Coverage, 1393,
     /* 232081 */     GIR_EraseRootFromParent_Done,
     /* 232082 */   // Label 5325: @232082
     /* 232082 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(232150), // Rule ID 8462 //
     /* 232087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 232090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232130 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 232133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232148 */     GIR_RootConstrainSelectedInstOperands,
     /* 232149 */     // GIR_Coverage, 8462,
     /* 232149 */     GIR_EraseRootFromParent_Done,
     /* 232150 */   // Label 5326: @232150
     /* 232150 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(232187), // Rule ID 1145 //
     /* 232155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 232158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232174 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 232174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 232177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232185 */     GIR_RootConstrainSelectedInstOperands,
     /* 232186 */     // GIR_Coverage, 1145,
     /* 232186 */     GIR_EraseRootFromParent_Done,
     /* 232187 */   // Label 5327: @232187
     /* 232187 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(232222), // Rule ID 1391 //
     /* 232192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 232195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232211 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 232211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 232216 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 232220 */     GIR_RootConstrainSelectedInstOperands,
     /* 232221 */     // GIR_Coverage, 1391,
     /* 232221 */     GIR_Done,
     /* 232222 */   // Label 5328: @232222
     /* 232222 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(232259), // Rule ID 8458 //
     /* 232227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 232230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232246 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 232246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 232249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232255 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232257 */     GIR_RootConstrainSelectedInstOperands,
     /* 232258 */     // GIR_Coverage, 8458,
     /* 232258 */     GIR_EraseRootFromParent_Done,
     /* 232259 */   // Label 5329: @232259
     /* 232259 */   GIM_Reject,
     /* 232260 */ // Label 5317: @232260
     /* 232260 */ GIM_Reject,
     /* 232261 */ // Label 5237: @232261
     /* 232261 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(232505),
     /* 232266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 232269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 232272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 232275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232279 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(232343), // Rule ID 9658 //
     /* 232284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232323 */     // (strict_fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 232326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232328 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232330 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232341 */     GIR_RootConstrainSelectedInstOperands,
     /* 232342 */     // GIR_Coverage, 9658,
     /* 232342 */     GIR_EraseRootFromParent_Done,
     /* 232343 */   // Label 5331: @232343
     /* 232343 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(232407), // Rule ID 9118 //
     /* 232348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232387 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 232390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232392 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232405 */     GIR_RootConstrainSelectedInstOperands,
     /* 232406 */     // GIR_Coverage, 9118,
     /* 232406 */     GIR_EraseRootFromParent_Done,
     /* 232407 */   // Label 5332: @232407
     /* 232407 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(232471), // Rule ID 8486 //
     /* 232412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232431 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232434 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232438 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232451 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232456 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232458 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232469 */     GIR_RootConstrainSelectedInstOperands,
     /* 232470 */     // GIR_Coverage, 8486,
     /* 232470 */     GIR_EraseRootFromParent_Done,
     /* 232471 */   // Label 5333: @232471
     /* 232471 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(232504), // Rule ID 8482 //
     /* 232476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232491 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 232491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 232494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232500 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232502 */     GIR_RootConstrainSelectedInstOperands,
     /* 232503 */     // GIR_Coverage, 8482,
     /* 232503 */     GIR_EraseRootFromParent_Done,
     /* 232504 */   // Label 5334: @232504
     /* 232504 */   GIM_Reject,
     /* 232505 */ // Label 5330: @232505
     /* 232505 */ GIM_Reject,
     /* 232506 */ // Label 5238: @232506
     /* 232506 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(232750),
     /* 232511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 232514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 232517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 232520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232524 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(232588), // Rule ID 9606 //
     /* 232529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232568 */     // (strict_fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 232571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232575 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232586 */     GIR_RootConstrainSelectedInstOperands,
     /* 232587 */     // GIR_Coverage, 9606,
     /* 232587 */     GIR_EraseRootFromParent_Done,
     /* 232588 */   // Label 5336: @232588
     /* 232588 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(232652), // Rule ID 9066 //
     /* 232593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232632 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 232635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232637 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232650 */     GIR_RootConstrainSelectedInstOperands,
     /* 232651 */     // GIR_Coverage, 9066,
     /* 232651 */     GIR_EraseRootFromParent_Done,
     /* 232652 */   // Label 5337: @232652
     /* 232652 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(232716), // Rule ID 8423 //
     /* 232657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232696 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 232699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232714 */     GIR_RootConstrainSelectedInstOperands,
     /* 232715 */     // GIR_Coverage, 8423,
     /* 232715 */     GIR_EraseRootFromParent_Done,
     /* 232716 */   // Label 5338: @232716
     /* 232716 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(232749), // Rule ID 8419 //
     /* 232721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232736 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 232736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 232739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232747 */     GIR_RootConstrainSelectedInstOperands,
     /* 232748 */     // GIR_Coverage, 8419,
     /* 232748 */     GIR_EraseRootFromParent_Done,
     /* 232749 */   // Label 5339: @232749
     /* 232749 */   GIM_Reject,
     /* 232750 */ // Label 5335: @232750
     /* 232750 */ GIM_Reject,
     /* 232751 */ // Label 5239: @232751
     /* 232751 */ GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(232995),
     /* 232756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 232759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 232762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 232765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232769 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(232833), // Rule ID 9626 //
     /* 232774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232813 */     // (strict_fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 232816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232818 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232820 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232831 */     GIR_RootConstrainSelectedInstOperands,
     /* 232832 */     // GIR_Coverage, 9626,
     /* 232832 */     GIR_EraseRootFromParent_Done,
     /* 232833 */   // Label 5341: @232833
     /* 232833 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(232897), // Rule ID 9086 //
     /* 232838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232853 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232877 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 232880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232882 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232895 */     GIR_RootConstrainSelectedInstOperands,
     /* 232896 */     // GIR_Coverage, 9086,
     /* 232896 */     GIR_EraseRootFromParent_Done,
     /* 232897 */   // Label 5342: @232897
     /* 232897 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(232961), // Rule ID 8447 //
     /* 232902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232941 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 232944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232959 */     GIR_RootConstrainSelectedInstOperands,
     /* 232960 */     // GIR_Coverage, 8447,
     /* 232960 */     GIR_EraseRootFromParent_Done,
     /* 232961 */   // Label 5343: @232961
     /* 232961 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(232994), // Rule ID 8443 //
     /* 232966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232981 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 232981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 232984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232986 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232988 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232990 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232992 */     GIR_RootConstrainSelectedInstOperands,
     /* 232993 */     // GIR_Coverage, 8443,
     /* 232993 */     GIR_EraseRootFromParent_Done,
     /* 232994 */   // Label 5344: @232994
     /* 232994 */   GIM_Reject,
     /* 232995 */ // Label 5340: @232995
     /* 232995 */ GIM_Reject,
     /* 232996 */ // Label 5240: @232996
     /* 232996 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(233240),
     /* 233001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 233004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 233007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 233010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233014 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(233078), // Rule ID 9594 //
     /* 233019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233030 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233037 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233058 */     // (strict_fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 233061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233065 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 233067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233076 */     GIR_RootConstrainSelectedInstOperands,
     /* 233077 */     // GIR_Coverage, 9594,
     /* 233077 */     GIR_EraseRootFromParent_Done,
     /* 233078 */   // Label 5346: @233078
     /* 233078 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(233142), // Rule ID 9054 //
     /* 233083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233122 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 233125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233127 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233129 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233140 */     GIR_RootConstrainSelectedInstOperands,
     /* 233141 */     // GIR_Coverage, 9054,
     /* 233141 */     GIR_EraseRootFromParent_Done,
     /* 233142 */   // Label 5347: @233142
     /* 233142 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(233206), // Rule ID 8408 //
     /* 233147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 233162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233186 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 233189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233204 */     GIR_RootConstrainSelectedInstOperands,
     /* 233205 */     // GIR_Coverage, 8408,
     /* 233205 */     GIR_EraseRootFromParent_Done,
     /* 233206 */   // Label 5348: @233206
     /* 233206 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(233239), // Rule ID 8404 //
     /* 233211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233226 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 233226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 233229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233235 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 233237 */     GIR_RootConstrainSelectedInstOperands,
     /* 233238 */     // GIR_Coverage, 8404,
     /* 233238 */     GIR_EraseRootFromParent_Done,
     /* 233239 */   // Label 5349: @233239
     /* 233239 */   GIM_Reject,
     /* 233240 */ // Label 5345: @233240
     /* 233240 */ GIM_Reject,
     /* 233241 */ // Label 5241: @233241
     /* 233241 */ GIM_Reject,
     /* 233242 */ // Label 73: @233242
     /* 233242 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5363*/ GIMT_Encode4(235410),
     /* 233253 */ /*GILLT_s16*//*Label 5350*/ GIMT_Encode4(233337),
     /* 233257 */ /*GILLT_s32*//*Label 5351*/ GIMT_Encode4(233458),
     /* 233261 */ /*GILLT_s64*//*Label 5352*/ GIMT_Encode4(233814),
     /* 233265 */ /*GILLT_s80*//*Label 5353*/ GIMT_Encode4(234170), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233277 */ /*GILLT_v2s64*//*Label 5354*/ GIMT_Encode4(234207), GIMT_Encode4(0),
     /* 233285 */ /*GILLT_v4s32*//*Label 5355*/ GIMT_Encode4(234410),
     /* 233289 */ /*GILLT_v4s64*//*Label 5356*/ GIMT_Encode4(234613), GIMT_Encode4(0),
     /* 233297 */ /*GILLT_v8s16*//*Label 5357*/ GIMT_Encode4(234789),
     /* 233301 */ /*GILLT_v8s32*//*Label 5358*/ GIMT_Encode4(234878),
     /* 233305 */ /*GILLT_v8s64*//*Label 5359*/ GIMT_Encode4(235054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233317 */ /*GILLT_v16s16*//*Label 5360*/ GIMT_Encode4(235143),
     /* 233321 */ /*GILLT_v16s32*//*Label 5361*/ GIMT_Encode4(235232), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233333 */ /*GILLT_v32s16*//*Label 5362*/ GIMT_Encode4(235321),
     /* 233337 */ // Label 5350: @233337
     /* 233337 */ GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(233457),
     /* 233342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 233345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 233349 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(233418), // Rule ID 21420 //
     /* 233354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 233357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233385 */     // (strict_fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 233385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 233402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233416 */     GIR_RootConstrainSelectedInstOperands,
     /* 233417 */     // GIR_Coverage, 21420,
     /* 233417 */     GIR_EraseRootFromParent_Done,
     /* 233418 */   // Label 5365: @233418
     /* 233418 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(233456), // Rule ID 21418 //
     /* 233423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 233430 */     // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 233430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 233447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233454 */     GIR_RootConstrainSelectedInstOperands,
     /* 233455 */     // GIR_Coverage, 21418,
     /* 233455 */     GIR_EraseRootFromParent_Done,
     /* 233456 */   // Label 5366: @233456
     /* 233456 */   GIM_Reject,
     /* 233457 */ // Label 5364: @233457
     /* 233457 */ GIM_Reject,
     /* 233458 */ // Label 5351: @233458
     /* 233458 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(233813),
     /* 233463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 233466 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(233522), // Rule ID 2448 //
     /* 233471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 233474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233506 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 233506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 233509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 233515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233520 */     GIR_RootConstrainSelectedInstOperands,
     /* 233521 */     // GIR_Coverage, 2448,
     /* 233521 */     GIR_EraseRootFromParent_Done,
     /* 233522 */   // Label 5368: @233522
     /* 233522 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(233595), // Rule ID 18276 //
     /* 233527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 233530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233562 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 233562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 233579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233593 */     GIR_RootConstrainSelectedInstOperands,
     /* 233594 */     // GIR_Coverage, 18276,
     /* 233594 */     GIR_EraseRootFromParent_Done,
     /* 233595 */   // Label 5369: @233595
     /* 233595 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(233668), // Rule ID 21424 //
     /* 233600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 233603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233635 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 233635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 233652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233666 */     GIR_RootConstrainSelectedInstOperands,
     /* 233667 */     // GIR_Coverage, 21424,
     /* 233667 */     GIR_EraseRootFromParent_Done,
     /* 233668 */   // Label 5370: @233668
     /* 233668 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(233701), // Rule ID 1048 //
     /* 233673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 233676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 233680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 233684 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 233684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 233689 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 233695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 233699 */     GIR_RootConstrainSelectedInstOperands,
     /* 233700 */     // GIR_Coverage, 1048,
     /* 233700 */     GIR_Done,
     /* 233701 */   // Label 5371: @233701
     /* 233701 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(233728), // Rule ID 2446 //
     /* 233706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 233709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233717 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 233717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 233722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 233726 */     GIR_RootConstrainSelectedInstOperands,
     /* 233727 */     // GIR_Coverage, 2446,
     /* 233727 */     GIR_Done,
     /* 233728 */   // Label 5372: @233728
     /* 233728 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(233770), // Rule ID 18274 //
     /* 233733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 233736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233744 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 233744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 233761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233768 */     GIR_RootConstrainSelectedInstOperands,
     /* 233769 */     // GIR_Coverage, 18274,
     /* 233769 */     GIR_EraseRootFromParent_Done,
     /* 233770 */   // Label 5373: @233770
     /* 233770 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(233812), // Rule ID 21422 //
     /* 233775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 233778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233786 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 233786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 233803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233810 */     GIR_RootConstrainSelectedInstOperands,
     /* 233811 */     // GIR_Coverage, 21422,
     /* 233811 */     GIR_EraseRootFromParent_Done,
     /* 233812 */   // Label 5374: @233812
     /* 233812 */   GIM_Reject,
     /* 233813 */ // Label 5367: @233813
     /* 233813 */ GIM_Reject,
     /* 233814 */ // Label 5352: @233814
     /* 233814 */ GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(234169),
     /* 233819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 233822 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(233878), // Rule ID 2464 //
     /* 233827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 233830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 233834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233862 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 233862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 233865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 233871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233876 */     GIR_RootConstrainSelectedInstOperands,
     /* 233877 */     // GIR_Coverage, 2464,
     /* 233877 */     GIR_EraseRootFromParent_Done,
     /* 233878 */   // Label 5376: @233878
     /* 233878 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(233951), // Rule ID 18280 //
     /* 233883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 233886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 233890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233898 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233905 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233918 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 233918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 233921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 233935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233949 */     GIR_RootConstrainSelectedInstOperands,
     /* 233950 */     // GIR_Coverage, 18280,
     /* 233950 */     GIR_EraseRootFromParent_Done,
     /* 233951 */   // Label 5377: @233951
     /* 233951 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(234024), // Rule ID 21428 //
     /* 233956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 233959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 233963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233991 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 233991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 233994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234022 */     GIR_RootConstrainSelectedInstOperands,
     /* 234023 */     // GIR_Coverage, 21428,
     /* 234023 */     GIR_EraseRootFromParent_Done,
     /* 234024 */   // Label 5378: @234024
     /* 234024 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(234057), // Rule ID 1050 //
     /* 234029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 234032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 234036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 234040 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 234040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 234045 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 234051 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 234055 */     GIR_RootConstrainSelectedInstOperands,
     /* 234056 */     // GIR_Coverage, 1050,
     /* 234056 */     GIR_Done,
     /* 234057 */   // Label 5379: @234057
     /* 234057 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(234084), // Rule ID 2462 //
     /* 234062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 234065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234073 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 234073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 234078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234082 */     GIR_RootConstrainSelectedInstOperands,
     /* 234083 */     // GIR_Coverage, 2462,
     /* 234083 */     GIR_Done,
     /* 234084 */   // Label 5380: @234084
     /* 234084 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(234126), // Rule ID 18278 //
     /* 234089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 234092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234100 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 234100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 234117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 234124 */     GIR_RootConstrainSelectedInstOperands,
     /* 234125 */     // GIR_Coverage, 18278,
     /* 234125 */     GIR_EraseRootFromParent_Done,
     /* 234126 */   // Label 5381: @234126
     /* 234126 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(234168), // Rule ID 21426 //
     /* 234131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 234134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 234138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 234142 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 234142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 234159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 234166 */     GIR_RootConstrainSelectedInstOperands,
     /* 234167 */     // GIR_Coverage, 21426,
     /* 234167 */     GIR_EraseRootFromParent_Done,
     /* 234168 */   // Label 5382: @234168
     /* 234168 */   GIM_Reject,
     /* 234169 */ // Label 5375: @234169
     /* 234169 */ GIM_Reject,
     /* 234170 */ // Label 5353: @234170
     /* 234170 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(234206), // Rule ID 1052 //
     /* 234175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 234178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 234181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 234185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 234189 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 234189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 234194 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 234200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 234204 */   GIR_RootConstrainSelectedInstOperands,
     /* 234205 */   // GIR_Coverage, 1052,
     /* 234205 */   GIR_Done,
     /* 234206 */ // Label 5383: @234206
     /* 234206 */ GIM_Reject,
     /* 234207 */ // Label 5354: @234207
     /* 234207 */ GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(234409),
     /* 234212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 234215 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(234271), // Rule ID 2468 //
     /* 234220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234255 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 234255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 234258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234269 */     GIR_RootConstrainSelectedInstOperands,
     /* 234270 */     // GIR_Coverage, 2468,
     /* 234270 */     GIR_EraseRootFromParent_Done,
     /* 234271 */   // Label 5385: @234271
     /* 234271 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(234327), // Rule ID 12086 //
     /* 234276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234311 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 234311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 234314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234325 */     GIR_RootConstrainSelectedInstOperands,
     /* 234326 */     // GIR_Coverage, 12086,
     /* 234326 */     GIR_EraseRootFromParent_Done,
     /* 234327 */   // Label 5386: @234327
     /* 234327 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(234354), // Rule ID 2466 //
     /* 234332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234343 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 234343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 234348 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234352 */     GIR_RootConstrainSelectedInstOperands,
     /* 234353 */     // GIR_Coverage, 2466,
     /* 234353 */     GIR_Done,
     /* 234354 */   // Label 5387: @234354
     /* 234354 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(234381), // Rule ID 2474 //
     /* 234359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 234362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234370 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 234370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 234375 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234379 */     GIR_RootConstrainSelectedInstOperands,
     /* 234380 */     // GIR_Coverage, 2474,
     /* 234380 */     GIR_Done,
     /* 234381 */   // Label 5388: @234381
     /* 234381 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(234408), // Rule ID 12082 //
     /* 234386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234397 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 234397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 234402 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234406 */     GIR_RootConstrainSelectedInstOperands,
     /* 234407 */     // GIR_Coverage, 12082,
     /* 234407 */     GIR_Done,
     /* 234408 */   // Label 5389: @234408
     /* 234408 */   GIM_Reject,
     /* 234409 */ // Label 5384: @234409
     /* 234409 */ GIM_Reject,
     /* 234410 */ // Label 5355: @234410
     /* 234410 */ GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(234612),
     /* 234415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 234418 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(234474), // Rule ID 2452 //
     /* 234423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234458 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 234458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 234461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234472 */     GIR_RootConstrainSelectedInstOperands,
     /* 234473 */     // GIR_Coverage, 2452,
     /* 234473 */     GIR_EraseRootFromParent_Done,
     /* 234474 */   // Label 5391: @234474
     /* 234474 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(234530), // Rule ID 12062 //
     /* 234479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234514 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 234514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 234517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234528 */     GIR_RootConstrainSelectedInstOperands,
     /* 234529 */     // GIR_Coverage, 12062,
     /* 234529 */     GIR_EraseRootFromParent_Done,
     /* 234530 */   // Label 5392: @234530
     /* 234530 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(234557), // Rule ID 2450 //
     /* 234535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234546 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 234546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 234551 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234555 */     GIR_RootConstrainSelectedInstOperands,
     /* 234556 */     // GIR_Coverage, 2450,
     /* 234556 */     GIR_Done,
     /* 234557 */   // Label 5393: @234557
     /* 234557 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(234584), // Rule ID 2458 //
     /* 234562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 234565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234573 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 234573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 234578 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234582 */     GIR_RootConstrainSelectedInstOperands,
     /* 234583 */     // GIR_Coverage, 2458,
     /* 234583 */     GIR_Done,
     /* 234584 */   // Label 5394: @234584
     /* 234584 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(234611), // Rule ID 12058 //
     /* 234589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234600 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 234600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 234605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234609 */     GIR_RootConstrainSelectedInstOperands,
     /* 234610 */     // GIR_Coverage, 12058,
     /* 234610 */     GIR_Done,
     /* 234611 */   // Label 5395: @234611
     /* 234611 */   GIM_Reject,
     /* 234612 */ // Label 5390: @234612
     /* 234612 */ GIM_Reject,
     /* 234613 */ // Label 5356: @234613
     /* 234613 */ GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(234788),
     /* 234618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 234621 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(234677), // Rule ID 2472 //
     /* 234626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234661 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 234661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 234664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234666 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234675 */     GIR_RootConstrainSelectedInstOperands,
     /* 234676 */     // GIR_Coverage, 2472,
     /* 234676 */     GIR_EraseRootFromParent_Done,
     /* 234677 */   // Label 5397: @234677
     /* 234677 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(234733), // Rule ID 12098 //
     /* 234682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234717 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 234717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 234720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234731 */     GIR_RootConstrainSelectedInstOperands,
     /* 234732 */     // GIR_Coverage, 12098,
     /* 234732 */     GIR_EraseRootFromParent_Done,
     /* 234733 */   // Label 5398: @234733
     /* 234733 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(234760), // Rule ID 2470 //
     /* 234738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234749 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 234749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 234754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234758 */     GIR_RootConstrainSelectedInstOperands,
     /* 234759 */     // GIR_Coverage, 2470,
     /* 234759 */     GIR_Done,
     /* 234760 */   // Label 5399: @234760
     /* 234760 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(234787), // Rule ID 12094 //
     /* 234765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234776 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 234776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 234781 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234785 */     GIR_RootConstrainSelectedInstOperands,
     /* 234786 */     // GIR_Coverage, 12094,
     /* 234786 */     GIR_Done,
     /* 234787 */   // Label 5400: @234787
     /* 234787 */   GIM_Reject,
     /* 234788 */ // Label 5396: @234788
     /* 234788 */ GIM_Reject,
     /* 234789 */ // Label 5357: @234789
     /* 234789 */ GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(234877),
     /* 234794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 234797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234801 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(234853), // Rule ID 12014 //
     /* 234806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 234809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234817 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234837 */     // (strict_fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 234837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 234840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234851 */     GIR_RootConstrainSelectedInstOperands,
     /* 234852 */     // GIR_Coverage, 12014,
     /* 234852 */     GIR_EraseRootFromParent_Done,
     /* 234853 */   // Label 5402: @234853
     /* 234853 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(234876), // Rule ID 12010 //
     /* 234858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 234861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234865 */     // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 234865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 234870 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234874 */     GIR_RootConstrainSelectedInstOperands,
     /* 234875 */     // GIR_Coverage, 12010,
     /* 234875 */     GIR_Done,
     /* 234876 */   // Label 5403: @234876
     /* 234876 */   GIM_Reject,
     /* 234877 */ // Label 5401: @234877
     /* 234877 */ GIM_Reject,
     /* 234878 */ // Label 5358: @234878
     /* 234878 */ GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(235053),
     /* 234883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 234886 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(234942), // Rule ID 2456 //
     /* 234891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234926 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 234926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 234929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234940 */     GIR_RootConstrainSelectedInstOperands,
     /* 234941 */     // GIR_Coverage, 2456,
     /* 234941 */     GIR_EraseRootFromParent_Done,
     /* 234942 */   // Label 5405: @234942
     /* 234942 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(234998), // Rule ID 12074 //
     /* 234947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234982 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 234982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 234985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234996 */     GIR_RootConstrainSelectedInstOperands,
     /* 234997 */     // GIR_Coverage, 12074,
     /* 234997 */     GIR_EraseRootFromParent_Done,
     /* 234998 */   // Label 5406: @234998
     /* 234998 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(235025), // Rule ID 2454 //
     /* 235003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 235006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 235010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 235014 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 235014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 235019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235023 */     GIR_RootConstrainSelectedInstOperands,
     /* 235024 */     // GIR_Coverage, 2454,
     /* 235024 */     GIR_Done,
     /* 235025 */   // Label 5407: @235025
     /* 235025 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(235052), // Rule ID 12070 //
     /* 235030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 235033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235041 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 235041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 235046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235050 */     GIR_RootConstrainSelectedInstOperands,
     /* 235051 */     // GIR_Coverage, 12070,
     /* 235051 */     GIR_Done,
     /* 235052 */   // Label 5408: @235052
     /* 235052 */   GIM_Reject,
     /* 235053 */ // Label 5404: @235053
     /* 235053 */ GIM_Reject,
     /* 235054 */ // Label 5359: @235054
     /* 235054 */ GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(235142),
     /* 235059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 235062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235066 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(235118), // Rule ID 12050 //
     /* 235071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235102 */     // (strict_fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 235102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 235105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235116 */     GIR_RootConstrainSelectedInstOperands,
     /* 235117 */     // GIR_Coverage, 12050,
     /* 235117 */     GIR_EraseRootFromParent_Done,
     /* 235118 */   // Label 5410: @235118
     /* 235118 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(235141), // Rule ID 12046 //
     /* 235123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235130 */     // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 235130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 235135 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235139 */     GIR_RootConstrainSelectedInstOperands,
     /* 235140 */     // GIR_Coverage, 12046,
     /* 235140 */     GIR_Done,
     /* 235141 */   // Label 5411: @235141
     /* 235141 */   GIM_Reject,
     /* 235142 */ // Label 5409: @235142
     /* 235142 */ GIM_Reject,
     /* 235143 */ // Label 5360: @235143
     /* 235143 */ GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(235231),
     /* 235148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 235151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235155 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(235207), // Rule ID 12026 //
     /* 235160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 235163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235191 */     // (strict_fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 235191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 235194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235205 */     GIR_RootConstrainSelectedInstOperands,
     /* 235206 */     // GIR_Coverage, 12026,
     /* 235206 */     GIR_EraseRootFromParent_Done,
     /* 235207 */   // Label 5413: @235207
     /* 235207 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(235230), // Rule ID 12022 //
     /* 235212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 235215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235219 */     // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 235219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 235224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235228 */     GIR_RootConstrainSelectedInstOperands,
     /* 235229 */     // GIR_Coverage, 12022,
     /* 235229 */     GIR_Done,
     /* 235230 */   // Label 5414: @235230
     /* 235230 */   GIM_Reject,
     /* 235231 */ // Label 5412: @235231
     /* 235231 */ GIM_Reject,
     /* 235232 */ // Label 5361: @235232
     /* 235232 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(235320),
     /* 235237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 235240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235244 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(235296), // Rule ID 12038 //
     /* 235249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235280 */     // (strict_fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 235280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 235283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235294 */     GIR_RootConstrainSelectedInstOperands,
     /* 235295 */     // GIR_Coverage, 12038,
     /* 235295 */     GIR_EraseRootFromParent_Done,
     /* 235296 */   // Label 5416: @235296
     /* 235296 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(235319), // Rule ID 12034 //
     /* 235301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235308 */     // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 235308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 235313 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235317 */     GIR_RootConstrainSelectedInstOperands,
     /* 235318 */     // GIR_Coverage, 12034,
     /* 235318 */     GIR_Done,
     /* 235319 */   // Label 5417: @235319
     /* 235319 */   GIM_Reject,
     /* 235320 */ // Label 5415: @235320
     /* 235320 */ GIM_Reject,
     /* 235321 */ // Label 5362: @235321
     /* 235321 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(235409),
     /* 235326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 235329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235333 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(235385), // Rule ID 12002 //
     /* 235338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 235341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235349 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235356 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235369 */     // (strict_fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 235369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 235372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235383 */     GIR_RootConstrainSelectedInstOperands,
     /* 235384 */     // GIR_Coverage, 12002,
     /* 235384 */     GIR_EraseRootFromParent_Done,
     /* 235385 */   // Label 5419: @235385
     /* 235385 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(235408), // Rule ID 11998 //
     /* 235390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 235393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235397 */     // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 235397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 235402 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235406 */     GIR_RootConstrainSelectedInstOperands,
     /* 235407 */     // GIR_Coverage, 11998,
     /* 235407 */     GIR_Done,
     /* 235408 */   // Label 5420: @235408
     /* 235408 */   GIM_Reject,
     /* 235409 */ // Label 5418: @235409
     /* 235409 */ GIM_Reject,
     /* 235410 */ // Label 5363: @235410
     /* 235410 */ GIM_Reject,
     /* 235411 */ // Label 74: @235411
     /* 235411 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(235423), // Rule ID 17074 //
     /* 235416 */   // (trap)  =>  (TRAP)
     /* 235416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 235421 */   GIR_RootConstrainSelectedInstOperands,
     /* 235422 */   // GIR_Coverage, 17074,
     /* 235422 */   GIR_Done,
     /* 235423 */ // Label 5421: @235423
     /* 235423 */ GIM_Reject,
     /* 235424 */ // Label 75: @235424
     /* 235424 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(235439), // Rule ID 22377 //
     /* 235429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 235432 */   // (debugtrap)  =>  (INT3)
     /* 235432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 235437 */   GIR_RootConstrainSelectedInstOperands,
     /* 235438 */   // GIR_Coverage, 22377,
     /* 235438 */   GIR_Done,
     /* 235439 */ // Label 5422: @235439
     /* 235439 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(235459), // Rule ID 22378 //
     /* 235444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 235447 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 235447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 235450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 235453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235457 */   GIR_RootConstrainSelectedInstOperands,
     /* 235458 */   // GIR_Coverage, 22378,
     /* 235458 */   GIR_EraseRootFromParent_Done,
     /* 235459 */ // Label 5423: @235459
     /* 235459 */ GIM_Reject,
     /* 235460 */ // Label 76: @235460
     /* 235460 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(235475), // Rule ID 17076 //
     /* 235465 */   // MIs[0] kind
     /* 235465 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 235468 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 235468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 235473 */   GIR_RootConstrainSelectedInstOperands,
     /* 235474 */   // GIR_Coverage, 17076,
     /* 235474 */   GIR_Done,
     /* 235475 */ // Label 5424: @235475
     /* 235475 */ GIM_Reject,
     /* 235476 */ // Label 77: @235476
     /* 235476 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 5428*/ GIMT_Encode4(235934),
     /* 235487 */ /*GILLT_s32*//*Label 5425*/ GIMT_Encode4(235499),
     /* 235491 */ /*GILLT_s64*//*Label 5426*/ GIMT_Encode4(235644),
     /* 235495 */ /*GILLT_s80*//*Label 5427*/ GIMT_Encode4(235789),
     /* 235499 */ // Label 5425: @235499
     /* 235499 */ GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(235547), // Rule ID 1086 //
     /* 235504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235529 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m32),
     /* 235532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235534 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235538 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235545 */   GIR_RootConstrainSelectedInstOperands,
     /* 235546 */   // GIR_Coverage, 1086,
     /* 235546 */   GIR_EraseRootFromParent_Done,
     /* 235547 */ // Label 5429: @235547
     /* 235547 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(235595), // Rule ID 1087 //
     /* 235552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235570 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235577 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m32),
     /* 235580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235582 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235586 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235593 */   GIR_RootConstrainSelectedInstOperands,
     /* 235594 */   // GIR_Coverage, 1087,
     /* 235594 */   GIR_EraseRootFromParent_Done,
     /* 235595 */ // Label 5430: @235595
     /* 235595 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(235643), // Rule ID 1088 //
     /* 235600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235618 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235625 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m32),
     /* 235628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235630 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235634 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235641 */   GIR_RootConstrainSelectedInstOperands,
     /* 235642 */   // GIR_Coverage, 1088,
     /* 235642 */   GIR_EraseRootFromParent_Done,
     /* 235643 */ // Label 5431: @235643
     /* 235643 */ GIM_Reject,
     /* 235644 */ // Label 5426: @235644
     /* 235644 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(235692), // Rule ID 1089 //
     /* 235649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235663 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235667 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235674 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m64),
     /* 235677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235679 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235683 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235690 */   GIR_RootConstrainSelectedInstOperands,
     /* 235691 */   // GIR_Coverage, 1089,
     /* 235691 */   GIR_EraseRootFromParent_Done,
     /* 235692 */ // Label 5432: @235692
     /* 235692 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(235740), // Rule ID 1090 //
     /* 235697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235722 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m64),
     /* 235725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235727 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235731 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235738 */   GIR_RootConstrainSelectedInstOperands,
     /* 235739 */   // GIR_Coverage, 1090,
     /* 235739 */   GIR_EraseRootFromParent_Done,
     /* 235740 */ // Label 5433: @235740
     /* 235740 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(235788), // Rule ID 1091 //
     /* 235745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235770 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m64),
     /* 235773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235775 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235779 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235786 */   GIR_RootConstrainSelectedInstOperands,
     /* 235787 */   // GIR_Coverage, 1091,
     /* 235787 */   GIR_EraseRootFromParent_Done,
     /* 235788 */ // Label 5434: @235788
     /* 235788 */ GIM_Reject,
     /* 235789 */ // Label 5427: @235789
     /* 235789 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(235837), // Rule ID 1092 //
     /* 235794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235797 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235808 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235812 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235819 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m80),
     /* 235822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235824 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235828 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235835 */   GIR_RootConstrainSelectedInstOperands,
     /* 235836 */   // GIR_Coverage, 1092,
     /* 235836 */   GIR_EraseRootFromParent_Done,
     /* 235837 */ // Label 5435: @235837
     /* 235837 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(235885), // Rule ID 1093 //
     /* 235842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235867 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m80),
     /* 235870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235872 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235876 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235883 */   GIR_RootConstrainSelectedInstOperands,
     /* 235884 */   // GIR_Coverage, 1093,
     /* 235884 */   GIR_EraseRootFromParent_Done,
     /* 235885 */ // Label 5436: @235885
     /* 235885 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(235933), // Rule ID 1094 //
     /* 235890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235915 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m80),
     /* 235918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235920 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235924 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235931 */   GIR_RootConstrainSelectedInstOperands,
     /* 235932 */   // GIR_Coverage, 1094,
     /* 235932 */   GIR_EraseRootFromParent_Done,
     /* 235933 */ // Label 5437: @235933
     /* 235933 */ GIM_Reject,
     /* 235934 */ // Label 5428: @235934
     /* 235934 */ GIM_Reject,
     /* 235935 */ // Label 78: @235935
     /* 235935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 5441*/ GIMT_Encode4(236798),
     /* 235946 */ /*GILLT_s32*//*Label 5438*/ GIMT_Encode4(235958),
     /* 235950 */ /*GILLT_s64*//*Label 5439*/ GIMT_Encode4(236238),
     /* 235954 */ /*GILLT_s80*//*Label 5440*/ GIMT_Encode4(236518),
     /* 235958 */ // Label 5438: @235958
     /* 235958 */ GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(236003), // Rule ID 873 //
     /* 235963 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235978 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235985 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP32_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 235985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT16_IN_MEM),
     /* 235988 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 235992 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 235994 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 235997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236001 */   GIR_RootConstrainSelectedInstOperands,
     /* 236002 */   // GIR_Coverage, 873,
     /* 236002 */   GIR_EraseRootFromParent_Done,
     /* 236003 */ // Label 5442: @236003
     /* 236003 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(236048), // Rule ID 874 //
     /* 236008 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236030 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP32_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT32_IN_MEM),
     /* 236033 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236037 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236039 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236046 */   GIR_RootConstrainSelectedInstOperands,
     /* 236047 */   // GIR_Coverage, 874,
     /* 236047 */   GIR_EraseRootFromParent_Done,
     /* 236048 */ // Label 5443: @236048
     /* 236048 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(236093), // Rule ID 875 //
     /* 236053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236075 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP32_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT64_IN_MEM),
     /* 236078 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236082 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236084 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236091 */   GIR_RootConstrainSelectedInstOperands,
     /* 236092 */   // GIR_Coverage, 875,
     /* 236092 */   GIR_EraseRootFromParent_Done,
     /* 236093 */ // Label 5444: @236093
     /* 236093 */ GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(236141), // Rule ID 1107 //
     /* 236098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236123 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m32),
     /* 236126 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236130 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236132 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236139 */   GIR_RootConstrainSelectedInstOperands,
     /* 236140 */   // GIR_Coverage, 1107,
     /* 236140 */   GIR_EraseRootFromParent_Done,
     /* 236141 */ // Label 5445: @236141
     /* 236141 */ GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(236189), // Rule ID 1108 //
     /* 236146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236149 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236171 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m32),
     /* 236174 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236178 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236180 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236187 */   GIR_RootConstrainSelectedInstOperands,
     /* 236188 */   // GIR_Coverage, 1108,
     /* 236188 */   GIR_EraseRootFromParent_Done,
     /* 236189 */ // Label 5446: @236189
     /* 236189 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(236237), // Rule ID 1109 //
     /* 236194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236197 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236212 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236219 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m32),
     /* 236222 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236226 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236228 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236235 */   GIR_RootConstrainSelectedInstOperands,
     /* 236236 */   // GIR_Coverage, 1109,
     /* 236236 */   GIR_EraseRootFromParent_Done,
     /* 236237 */ // Label 5447: @236237
     /* 236237 */ GIM_Reject,
     /* 236238 */ // Label 5439: @236238
     /* 236238 */ GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(236283), // Rule ID 876 //
     /* 236243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236265 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP64_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT16_IN_MEM),
     /* 236268 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236272 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236274 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236281 */   GIR_RootConstrainSelectedInstOperands,
     /* 236282 */   // GIR_Coverage, 876,
     /* 236282 */   GIR_EraseRootFromParent_Done,
     /* 236283 */ // Label 5448: @236283
     /* 236283 */ GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(236328), // Rule ID 877 //
     /* 236288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236310 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP64_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT32_IN_MEM),
     /* 236313 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236317 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236319 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236326 */   GIR_RootConstrainSelectedInstOperands,
     /* 236327 */   // GIR_Coverage, 877,
     /* 236327 */   GIR_EraseRootFromParent_Done,
     /* 236328 */ // Label 5449: @236328
     /* 236328 */ GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(236373), // Rule ID 878 //
     /* 236333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236355 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP64_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT64_IN_MEM),
     /* 236358 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236362 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236364 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236371 */   GIR_RootConstrainSelectedInstOperands,
     /* 236372 */   // GIR_Coverage, 878,
     /* 236372 */   GIR_EraseRootFromParent_Done,
     /* 236373 */ // Label 5450: @236373
     /* 236373 */ GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(236421), // Rule ID 1110 //
     /* 236378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236381 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236403 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m64),
     /* 236406 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236410 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236412 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236419 */   GIR_RootConstrainSelectedInstOperands,
     /* 236420 */   // GIR_Coverage, 1110,
     /* 236420 */   GIR_EraseRootFromParent_Done,
     /* 236421 */ // Label 5451: @236421
     /* 236421 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(236469), // Rule ID 1111 //
     /* 236426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236429 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236451 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m64),
     /* 236454 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236458 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236460 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236467 */   GIR_RootConstrainSelectedInstOperands,
     /* 236468 */   // GIR_Coverage, 1111,
     /* 236468 */   GIR_EraseRootFromParent_Done,
     /* 236469 */ // Label 5452: @236469
     /* 236469 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(236517), // Rule ID 1112 //
     /* 236474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236499 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m64),
     /* 236502 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236506 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236508 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236511 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236515 */   GIR_RootConstrainSelectedInstOperands,
     /* 236516 */   // GIR_Coverage, 1112,
     /* 236516 */   GIR_EraseRootFromParent_Done,
     /* 236517 */ // Label 5453: @236517
     /* 236517 */ GIM_Reject,
     /* 236518 */ // Label 5440: @236518
     /* 236518 */ GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(236563), // Rule ID 879 //
     /* 236523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236545 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP80_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT16_IN_MEM),
     /* 236548 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236552 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236554 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236561 */   GIR_RootConstrainSelectedInstOperands,
     /* 236562 */   // GIR_Coverage, 879,
     /* 236562 */   GIR_EraseRootFromParent_Done,
     /* 236563 */ // Label 5454: @236563
     /* 236563 */ GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(236608), // Rule ID 880 //
     /* 236568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236583 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236590 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP80_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT32_IN_MEM),
     /* 236593 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236597 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236599 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236606 */   GIR_RootConstrainSelectedInstOperands,
     /* 236607 */   // GIR_Coverage, 880,
     /* 236607 */   GIR_EraseRootFromParent_Done,
     /* 236608 */ // Label 5455: @236608
     /* 236608 */ GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(236653), // Rule ID 881 //
     /* 236613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236635 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP80_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT64_IN_MEM),
     /* 236638 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236642 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236644 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236651 */   GIR_RootConstrainSelectedInstOperands,
     /* 236652 */   // GIR_Coverage, 881,
     /* 236652 */   GIR_EraseRootFromParent_Done,
     /* 236653 */ // Label 5456: @236653
     /* 236653 */ GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(236701), // Rule ID 1113 //
     /* 236658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236661 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236683 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m80),
     /* 236686 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236690 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236692 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236699 */   GIR_RootConstrainSelectedInstOperands,
     /* 236700 */   // GIR_Coverage, 1113,
     /* 236700 */   GIR_EraseRootFromParent_Done,
     /* 236701 */ // Label 5457: @236701
     /* 236701 */ GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(236749), // Rule ID 1114 //
     /* 236706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236720 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236724 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236731 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m80),
     /* 236734 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236738 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236740 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236747 */   GIR_RootConstrainSelectedInstOperands,
     /* 236748 */   // GIR_Coverage, 1114,
     /* 236748 */   GIR_EraseRootFromParent_Done,
     /* 236749 */ // Label 5458: @236749
     /* 236749 */ GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(236797), // Rule ID 1115 //
     /* 236754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236772 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236779 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m80),
     /* 236782 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236786 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236788 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236795 */   GIR_RootConstrainSelectedInstOperands,
     /* 236796 */   // GIR_Coverage, 1115,
     /* 236796 */   GIR_EraseRootFromParent_Done,
     /* 236797 */ // Label 5459: @236797
     /* 236797 */ GIM_Reject,
     /* 236798 */ // Label 5441: @236798
     /* 236798 */ GIM_Reject,
     /* 236799 */ // Label 79: @236799
     /* 236799 */ GIM_Reject,
     /* 236800 */ }; // Size: 236800 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
