/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Rewriters                                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: TestOps.td                                                           *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


static ::llvm::LogicalResult __mlir_ods_local_type_constraint_TestOps1(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Type type,
    ::llvm::StringRef failureStr) {
  if (!((type.isSignlessInteger(32)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": 32-bit signless integer";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_type_constraint_TestOps2(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Type type,
    ::llvm::StringRef failureStr) {
  if (!((type.isSignlessInteger(16)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": 16-bit signless integer";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps1(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == ::llvm::cast<::mlir::DenseFPElementsAttr>(::mlir::DenseElementsAttr::get(::mlir::RankedTensorType::get({2}, rewriter.getF32Type()), ::llvm::ArrayRef({3.0f, 4.0f})))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute {3.0f, 4.0f}";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps2(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == test::TestEnumAttr::get(rewriter.getContext(), test::TestEnum::First)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute test::TestEnum::First";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps3(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 0)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 0";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps4(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == test::TestBitEnumAttr::get(rewriter.getContext(), test::TestBitEnum::Write|test::TestBitEnum::Execute)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute test::TestBitEnum::Write|test::TestBitEnum::Execute";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps5(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(64))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": 64-bit signless integer attribute";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps6(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(64), 42)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 42";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps7(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getBoolAttr(true)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute true";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps8(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getBoolAttr(false)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute false";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps9(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!(((::llvm::cast<::mlir::IntegerAttr>(::llvm::cast<ArrayAttr>(attr)[0]).getInt() == 0)) && ((::llvm::cast<::mlir::IntegerAttr>(::llvm::cast<ArrayAttr>(attr)[1]).getInt() == 1)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": [0] == 0 and [1] == 1";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps10(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!(((::llvm::isa<::mlir::IntegerAttr>(attr))) && ((::llvm::cast<::mlir::IntegerAttr>(attr).getType().isSignlessInteger(32))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": 32-bit signless integer attribute";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps11(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((::llvm::cast<IntegerAttr>(attr).getInt() == 4))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": more constraint";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps12(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(32, 5))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case case5";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps13(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 5))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case case5";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps14(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 1))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case kind1";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps15(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 2))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case kind2";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps16(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 3))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case kind3";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps17(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 4))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case kind4";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps18(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 5))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case kind5";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps19(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((
    ::llvm::cast<::mlir::IntegerAttr>(attr).getValue().eq(::llvm::APInt(64, 6))))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": case kind6";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps20(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getStringAttr("MatchInverseVariadic")))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute \"MatchInverseVariadic\"";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps21(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 1)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 1";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps22(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 2)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 2";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps23(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 11)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 11";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps24(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 22)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 22";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps25(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 33)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 33";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps26(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 44)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 44";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps27(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 55)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 55";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_attr_constraint_TestOps28(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, ::mlir::Attribute attr,
    ::llvm::StringRef failureStr) {
  if (!((attr == rewriter.getIntegerAttr(rewriter.getIntegerType(32), 66)))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant attribute 66";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_prop_constraint_TestOps1(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, int64_t prop,
    ::llvm::StringRef failureStr) {
  if (!((prop >= 0))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": non-negative int64_t";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_prop_constraint_TestOps2(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, bool prop,
    ::llvm::StringRef failureStr) {
  if (!((prop == false))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant 'boolean': false";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult __mlir_ods_local_prop_constraint_TestOps3(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, bool prop,
    ::llvm::StringRef failureStr) {
  if (!((prop == true))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": constant 'boolean': true";
    });
  }
  return ::mlir::success();
}
template <typename T>
static ::llvm::LogicalResult __mlir_ods_local_prop_constraint_TestOps4(
    ::mlir::PatternRewriter &rewriter, ::mlir::Operation *op, T prop,
    ::llvm::StringRef failureStr) {
  if (!((!prop.empty()))) {
    return rewriter.notifyMatchFailure(op, [&](::mlir::Diagnostic &diag) {
      diag << failureStr << ": non-empty string";
    });
  }
  return ::mlir::success();
}
static ::llvm::LogicalResult static_dag_matcher_0(::mlir::PatternRewriter &rewriter, ::mlir::Operation *op0, ::llvm::SmallVector<::mlir::Operation *, 4> &tblgen_ops, ::mlir::IntegerAttr &attr, ::mlir::Operation::operand_range &input) {
  (void)tblgen_ops;
  auto castedOp1 = ::llvm::dyn_cast<::test::OpA>(op0); (void)castedOp1;
  if (!(castedOp1)){
    return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
      diag << "castedOp1 is not ::test::OpA type";
    });
  }
  input = castedOp1.getODSOperands(0);
  {
    [[maybe_unused]] auto tblgen_attr = castedOp1.getProperties().getAttr();
    if (!(tblgen_attr)){
      return rewriter.notifyMatchFailure(castedOp1, [&](::mlir::Diagnostic &diag) {
        diag << "expected op 'test.op_a' to have attribute 'attr' of type '::mlir::IntegerAttr'";
      });
    }
    attr = tblgen_attr;
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult static_dag_matcher_1(::mlir::PatternRewriter &rewriter, ::mlir::Operation *op0, ::llvm::SmallVector<::mlir::Operation *, 4> &tblgen_ops, ::mlir::Operation::operand_range &input) {
  (void)tblgen_ops;
  auto castedOp1 = ::llvm::dyn_cast<::test::OpD>(op0); (void)castedOp1;
  if (!(castedOp1)){
    return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
      diag << "castedOp1 is not ::test::OpD type";
    });
  }
  input = castedOp1.getODSOperands(0);
  return ::mlir::success();
}

static ::llvm::LogicalResult static_dag_matcher_2(::mlir::PatternRewriter &rewriter, ::mlir::Operation *op0, ::llvm::SmallVector<::mlir::Operation *, 4> &tblgen_ops, ::mlir::Operation::operand_range &input) {
  (void)tblgen_ops;
  auto castedOp1 = ::llvm::dyn_cast<::test::OpG>(op0); (void)castedOp1;
  if (!(castedOp1)){
    return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
      diag << "castedOp1 is not ::test::OpG type";
    });
  }
  input = castedOp1.getODSOperands(0);
  return ::mlir::success();
}

static ::llvm::LogicalResult static_dag_matcher_3(::mlir::PatternRewriter &rewriter, ::mlir::Operation *op0, ::llvm::SmallVector<::mlir::Operation *, 4> &tblgen_ops, ::mlir::Operation::operand_range &arg1) {
  (void)tblgen_ops;
  auto castedOp1 = ::llvm::dyn_cast<::test::TestEitherOpB>(op0); (void)castedOp1;
  if (!(castedOp1)){
    return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
      diag << "castedOp1 is not ::test::TestEitherOpB type";
    });
  }
  if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps1(rewriter, castedOp1, (*castedOp1.getODSOperands(0).begin()).getType(), "operand 0 of op 'test.either_op_b' failed to satisfy constraint: '32-bit signless integer'"))) {
    return ::mlir::failure();
  }
  arg1 = castedOp1.getODSOperands(0);
  return ::mlir::success();
}

static ::llvm::LogicalResult static_dag_matcher_4(::mlir::PatternRewriter &rewriter, ::mlir::Operation *op0, ::llvm::SmallVector<::mlir::Operation *, 4> &tblgen_ops) {
  (void)tblgen_ops;
  auto castedOp1 = ::llvm::dyn_cast<::test::ILLegalOpA>(op0); (void)castedOp1;
  if (!(castedOp1)){
    return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
      diag << "castedOp1 is not ::test::ILLegalOpA type";
    });
  }
  return ::mlir::success();
}

static ::llvm::LogicalResult static_dag_matcher_5(::mlir::PatternRewriter &rewriter, ::mlir::Operation *op0, ::llvm::SmallVector<::mlir::Operation *, 4> &tblgen_ops) {
  (void)tblgen_ops;
  auto castedOp1 = ::llvm::dyn_cast<::test::ILLegalOpC>(op0); (void)castedOp1;
  if (!(castedOp1)){
    return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
      diag << "castedOp1 is not ::test::ILLegalOpC type";
    });
  }
  return ::mlir::success();
}

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1157
*/
struct TestEqualArgsPattern : public ::mlir::RewritePattern {
  TestEqualArgsPattern(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_n", 1, context, {"test.op_o"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range a(op0->getOperands());
    ::mlir::Operation::operand_range a0(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpN>(op0); (void)castedOp0;
    a = castedOp0.getODSOperands(0);
    a0 = castedOp0.getODSOperands(1);
    if (!(*a.begin() == *a0.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'a' and 'a0' must be equal";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpO tblgen_OpO_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpO::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*a.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpO_0 = rewriter.create<::test::OpO>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpO_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1171
*/
struct TestMultipleEqualArgsPattern : public ::mlir::RewritePattern {
  TestMultipleEqualArgsPattern(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_p", 1, context, {"test.op_n"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range c(op0->getOperands());
    ::mlir::Operation::operand_range b(op0->getOperands());
    ::mlir::Operation::operand_range b0(op0->getOperands());
    ::mlir::Operation::operand_range a(op0->getOperands());
    ::mlir::Operation::operand_range a0(op0->getOperands());
    ::mlir::Operation::operand_range a1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpP>(op0); (void)castedOp0;
    a = castedOp0.getODSOperands(0);
    b = castedOp0.getODSOperands(1);
    a1 = castedOp0.getODSOperands(2);
    a0 = castedOp0.getODSOperands(3);
    b0 = castedOp0.getODSOperands(4);
    c = castedOp0.getODSOperands(5);
    if (!(*b.begin() == *b0.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'b' and 'b0' must be equal";
      });
    }
    if (!(*a.begin() == *a0.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'a' and 'a0' must be equal";
      });
    }
    if (!(*a.begin() == *a1.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'a' and 'a1' must be equal";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpN tblgen_OpN_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpN::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*c.begin()));
      tblgen_values.push_back((*b.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpN_0 = rewriter.create<::test::OpN>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpN_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1108
*/
struct TestNamedPatternRule : public ::mlir::RewritePattern {
  TestNamedPatternRule(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_a", 1, context, {"test.op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_0(rewriter, op0, tblgen_ops, attr, input))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::OpA>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpB tblgen_OpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(attr);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpB_0 = rewriter.create<::test::OpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1160
*/
struct TestNestedOpEqualArgsPattern : public ::mlir::RewritePattern {
  TestNestedOpEqualArgsPattern(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_n", 2, context, {}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range f(op0->getOperands());
    ::mlir::Operation::operand_range e(op0->getOperands());
    ::mlir::Operation::operand_range c(op0->getOperands());
    ::mlir::Operation::operand_range d(op0->getOperands());
    ::mlir::Operation::operand_range a(op0->getOperands());
    ::mlir::Operation::operand_range b(op0->getOperands());
    ::mlir::Operation::operand_range b0(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpN>(op0); (void)castedOp0;
    b = castedOp0.getODSOperands(0);
    {
      auto *op1 = (*castedOp0.getODSOperands(1).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 1 of castedOp0";
        });
      }
      auto castedOp1 = ::llvm::dyn_cast<::test::OpP>(op1); (void)castedOp1;
      if (!(castedOp1)){
        return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
          diag << "castedOp1 is not ::test::OpP type";
        });
      }
      a = castedOp1.getODSOperands(0);
      b0 = castedOp1.getODSOperands(1);
      c = castedOp1.getODSOperands(2);
      d = castedOp1.getODSOperands(3);
      e = castedOp1.getODSOperands(4);
      f = castedOp1.getODSOperands(5);
      tblgen_ops.push_back(op1);
    }
    if (!(*b.begin() == *b0.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'b' and 'b0' must be equal";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ b }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1167
*/
struct TestNestedSameOpAndSameArgEqualityPattern : public ::mlir::RewritePattern {
  TestNestedSameOpAndSameArgEqualityPattern(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_n", 2, context, {}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range x(op0->getOperands());
    ::mlir::Operation::operand_range x0(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpN>(op0); (void)castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
      auto castedOp1 = ::llvm::dyn_cast<::test::OpN>(op1); (void)castedOp1;
      if (!(castedOp1)){
        return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
          diag << "castedOp1 is not ::test::OpN type";
        });
      }
      x = castedOp1.getODSOperands(1);
      tblgen_ops.push_back(op1);
    }
    x0 = castedOp0.getODSOperands(1);
    if (!(*x.begin() == *x0.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'x' and 'x0' must be equal";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ x }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:909
*/
struct UpdateAttr : public ::mlir::RewritePattern {
  UpdateAttr(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.i32ElementsAttr", 1, context, {"test.i32ElementsAttr"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::DenseIntElementsAttr attr;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::I32ElementsAttrOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.i32ElementsAttr' to have attribute 'attr' of type '::mlir::DenseIntElementsAttr'";
        });
      }
      attr = tblgen_attr;
    }
    if (!((attr.getType().getRank() != 0))){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "entities 'attr' failed to satisfy constraint: ''";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::I32ElementsAttrOp tblgen_I32ElementsAttrOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::I32ElementsAttrOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(::llvm::cast<::mlir::DenseIntElementsAttr>(::mlir::DenseElementsAttr::get(::mlir::RankedTensorType::get({}, rewriter.getIntegerType(32)), ::llvm::ArrayRef(0))));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_I32ElementsAttrOp_0 = rewriter.create<::test::I32ElementsAttrOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:250
*/
struct UpdateFloatElementsAttr : public ::mlir::RewritePattern {
  UpdateFloatElementsAttr(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.float_elements_attr", 1, context, {"test.float_elements_attr"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::DenseFPElementsAttr f64attr;
    ::mlir::DenseFPElementsAttr f32attr;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::FloatElementsAttrOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getScalarF32Attr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.float_elements_attr' to have attribute 'scalar_f32_attr' of type '::mlir::DenseFPElementsAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps1(rewriter, castedOp0, tblgen_attr, "op 'test.float_elements_attr' attribute 'scalar_f32_attr' failed to satisfy constraint: 'constant attribute {3.0f, 4.0f}'"))) {
        return ::mlir::failure();
      }
      f32attr = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTensorF64Attr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.float_elements_attr' to have attribute 'tensor_f64_attr' of type '::mlir::DenseFPElementsAttr'";
        });
      }
      f64attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::FloatElementsAttrOp tblgen_FloatElementsAttrOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::FloatElementsAttrOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.scalar_f32_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.scalar_f32_attr)>(::llvm::cast<::mlir::DenseFPElementsAttr>(::mlir::DenseElementsAttr::get(::mlir::RankedTensorType::get({2}, rewriter.getF32Type()), ::llvm::ArrayRef({5.0f, 6.0f}))));
      tblgen_props.tensor_f64_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.tensor_f64_attr)>(f64attr);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_FloatElementsAttrOp_0 = rewriter.create<::test::FloatElementsAttrOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:417
*/
struct GeneratedConvert0 : public ::mlir::RewritePattern {
  GeneratedConvert0(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_with_enum", 1, context, {"test.op_with_enum"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Attribute tag;
    ::test::TestEnumAttr value;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpWithEnum>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getValue();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.op_with_enum' to have attribute 'value' of type '::test::TestEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps2(rewriter, castedOp0, tblgen_attr, "op 'test.op_with_enum' attribute 'value' failed to satisfy constraint: 'constant attribute test::TestEnum::First'"))) {
        return ::mlir::failure();
      }
      value = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!tblgen_attr) return ::mlir::failure();
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps3(rewriter, castedOp0, tblgen_attr, "op 'test.op_with_enum' attribute 'tag' failed to satisfy constraint: 'constant attribute 0'"))) {
        return ::mlir::failure();
      }
      tag = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::OpWithEnum tblgen_OpWithEnum_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpWithEnum::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.value = ::llvm::dyn_cast_if_present<decltype(tblgen_props.value)>(test::TestEnumAttr::get(rewriter.getContext(), test::TestEnum::Second));
      tblgen_props.tag = ::llvm::dyn_cast_if_present<decltype(tblgen_props.tag)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 1));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_OpWithEnum_0 = rewriter.create<::test::OpWithEnum>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:496
*/
struct GeneratedConvert1 : public ::mlir::RewritePattern {
  GeneratedConvert1(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_with_bit_enum", 1, context, {"test.op_with_bit_enum"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpWithBitEnum>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getValue();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.op_with_bit_enum' to have attribute 'value' of type '::test::TestBitEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps4(rewriter, castedOp0, tblgen_attr, "op 'test.op_with_bit_enum' attribute 'value' failed to satisfy constraint: 'constant attribute test::TestBitEnum::Write|test::TestBitEnum::Execute'"))) {
        return ::mlir::failure();
      }
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!tblgen_attr) return ::mlir::failure();
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps3(rewriter, castedOp0, tblgen_attr, "op 'test.op_with_bit_enum' attribute 'tag' failed to satisfy constraint: 'constant attribute 0'"))) {
        return ::mlir::failure();
      }
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::OpWithBitEnum tblgen_OpWithBitEnum_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpWithBitEnum::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.value = ::llvm::dyn_cast_if_present<decltype(tblgen_props.value)>(test::TestBitEnumAttr::get(rewriter.getContext(), test::TestBitEnum::Execute|test::TestBitEnum::Read));
      tblgen_props.tag = ::llvm::dyn_cast_if_present<decltype(tblgen_props.tag)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 1));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_OpWithBitEnum_0 = rewriter.create<::test::OpWithBitEnum>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1111
*/
struct GeneratedConvert2 : public ::mlir::RewritePattern {
  GeneratedConvert2(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_a", 2, context, {"test.op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr bttr;
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpA>(op0); (void)castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
      if(::mlir::failed(static_dag_matcher_0(rewriter, op1, tblgen_ops, attr, input))) {
        return ::mlir::failure();
      }
      tblgen_ops.push_back(op1);
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.op_a' to have attribute 'attr' of type '::mlir::IntegerAttr'";
        });
      }
      bttr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpB tblgen_OpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(bttr);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpB_0 = rewriter.create<::test::OpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1119
*/
struct GeneratedConvert3 : public ::mlir::RewritePattern {
  GeneratedConvert3(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_d", 1, context, {"test.op_e"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_1(rewriter, op0, tblgen_ops, input))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::OpD>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpE tblgen_OpE_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpE::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpE_0 = rewriter.create<::test::OpE>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpE_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1120
*/
struct GeneratedConvert4 : public ::mlir::RewritePattern {
  GeneratedConvert4(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_d", 11, context, {"test.op_f"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_1(rewriter, op0, tblgen_ops, input))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::OpD>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpF tblgen_OpF_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpF::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpF_0 = rewriter.create<::test::OpF>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpF_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1122
*/
struct GeneratedConvert5 : public ::mlir::RewritePattern {
  GeneratedConvert5(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_g", 1, context, {"test.op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_2(rewriter, op0, tblgen_ops, input))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::OpG>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpB tblgen_OpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 20));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpB_0 = rewriter.create<::test::OpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1123
*/
struct GeneratedConvert6 : public ::mlir::RewritePattern {
  GeneratedConvert6(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_g", 2, context, {"test.op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpG>(op0); (void)castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
      if(::mlir::failed(static_dag_matcher_2(rewriter, op1, tblgen_ops, input))) {
        return ::mlir::failure();
      }
      tblgen_ops.push_back(op1);
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpB tblgen_OpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 34));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpB_0 = rewriter.create<::test::OpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1128
*/
struct GeneratedConvert7 : public ::mlir::RewritePattern {
  GeneratedConvert7(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_h", 1, context, {"test.op_i"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpH>(op0); (void)castedOp0;
    input = castedOp0.getODSOperands(0);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::OpI tblgen_OpI_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpI::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_OpI_0 = rewriter.create<::test::OpI>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1133
*/
struct GeneratedConvert8 : public ::mlir::RewritePattern {
  GeneratedConvert8(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_j", 1, context, {"test.op_k"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpJ>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpK tblgen_OpK_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpK::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpK_0 = rewriter.create<::test::OpK>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpK_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1204
*/
struct GeneratedConvert9 : public ::mlir::RewritePattern {
  GeneratedConvert9(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_m", 1, context, {"test.op_m"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr optAttr;
    ::mlir::Operation::operand_range attr(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpM>(op0); (void)castedOp0;
    attr = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getOptionalAttr();
      optAttr = tblgen_attr;
    }
    if (!((! (optAttr)))){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "entities '' failed to satisfy constraint: 'Attribute is null'";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    auto nativeVar_0 = opMTest(rewriter, (*attr.begin())); (void)nativeVar_0;
    ::test::OpM tblgen_OpM_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpM::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*attr.begin()));
      tblgen_props.optional_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.optional_attr)>(nativeVar_0);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpM_1 = rewriter.create<::test::OpM>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpM_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1216
*/
struct GeneratedConvert10 : public ::mlir::RewritePattern {
  GeneratedConvert10(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.ignore_arg_match_src", 1, context, {"test.ignore_arg_match_dst"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Attribute f;
    ::mlir::Operation::operand_range b(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestIgnoreArgMatchSrcOp>(op0); (void)castedOp0;
    b = castedOp0.getODSOperands(1);
    if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps1(rewriter, castedOp0, (*castedOp0.getODSOperands(2).begin()).getType(), "operand 2 of op 'test.ignore_arg_match_src' failed to satisfy constraint: '32-bit signless integer'"))) {
      return ::mlir::failure();
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getD();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.ignore_arg_match_src' to have attribute 'd' of type '::mlir::Attribute'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps5(rewriter, castedOp0, tblgen_attr, "op 'test.ignore_arg_match_src' attribute 'd' failed to satisfy constraint: '64-bit signless integer attribute'"))) {
        return ::mlir::failure();
      }
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getE();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.ignore_arg_match_src' to have attribute 'e' of type '::mlir::Attribute'";
        });
      }
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getF();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.ignore_arg_match_src' to have attribute 'f' of type '::mlir::Attribute'";
        });
      }
      f = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::TestIgnoreArgMatchDstOp tblgen_TestIgnoreArgMatchDstOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestIgnoreArgMatchDstOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*b.begin()));
      tblgen_props.f = ::llvm::dyn_cast_if_present<decltype(tblgen_props.f)>(f);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_TestIgnoreArgMatchDstOp_0 = rewriter.create<::test::TestIgnoreArgMatchDstOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1248
*/
struct GeneratedConvert11 : public ::mlir::RewritePattern {
  GeneratedConvert11(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.many_arguments", 1, context, {"test.many_arguments"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr9;
    ::mlir::IntegerAttr attr7;
    ::mlir::IntegerAttr attr6;
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input3(op0->getOperands());
    ::mlir::Operation::operand_range input5(op0->getOperands());
    ::mlir::Operation::operand_range input7(op0->getOperands());
    ::mlir::IntegerAttr attr3;
    ::mlir::Operation::operand_range input6(op0->getOperands());
    ::mlir::IntegerAttr attr4;
    ::mlir::Operation::operand_range input8(op0->getOperands());
    ::mlir::Operation::operand_range input9(op0->getOperands());
    ::mlir::IntegerAttr attr2;
    ::mlir::IntegerAttr attr8;
    ::mlir::Operation::operand_range input4(op0->getOperands());
    ::mlir::IntegerAttr attr5;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ManyArgsOp>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    input2 = castedOp0.getODSOperands(1);
    input3 = castedOp0.getODSOperands(2);
    input4 = castedOp0.getODSOperands(3);
    input5 = castedOp0.getODSOperands(4);
    input6 = castedOp0.getODSOperands(5);
    input7 = castedOp0.getODSOperands(6);
    input8 = castedOp0.getODSOperands(7);
    input9 = castedOp0.getODSOperands(8);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps6(rewriter, castedOp0, tblgen_attr, "op 'test.many_arguments' attribute 'attr1' failed to satisfy constraint: 'constant attribute 42'"))) {
        return ::mlir::failure();
      }
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr2();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr2' of type '::mlir::IntegerAttr'";
        });
      }
      attr2 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr3();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr3' of type '::mlir::IntegerAttr'";
        });
      }
      attr3 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr4();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr4' of type '::mlir::IntegerAttr'";
        });
      }
      attr4 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr5();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr5' of type '::mlir::IntegerAttr'";
        });
      }
      attr5 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr6();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr6' of type '::mlir::IntegerAttr'";
        });
      }
      attr6 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr7();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr7' of type '::mlir::IntegerAttr'";
        });
      }
      attr7 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr8();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr8' of type '::mlir::IntegerAttr'";
        });
      }
      attr8 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr9();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.many_arguments' to have attribute 'attr9' of type '::mlir::IntegerAttr'";
        });
      }
      attr9 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::ManyArgsOp tblgen_ManyArgsOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::ManyArgsOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input1.begin()));
      tblgen_values.push_back((*input2.begin()));
      tblgen_values.push_back((*input3.begin()));
      tblgen_values.push_back((*input4.begin()));
      tblgen_values.push_back((*input5.begin()));
      tblgen_values.push_back((*input6.begin()));
      tblgen_values.push_back((*input7.begin()));
      tblgen_values.push_back((*input8.begin()));
      tblgen_values.push_back((*input9.begin()));
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(rewriter.getIntegerAttr(rewriter.getIntegerType(64), 24));
      tblgen_props.attr2 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr2)>(attr2);
      tblgen_props.attr3 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr3)>(attr3);
      tblgen_props.attr4 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr4)>(attr4);
      tblgen_props.attr5 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr5)>(attr5);
      tblgen_props.attr6 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr6)>(attr6);
      tblgen_props.attr7 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr7)>(attr7);
      tblgen_props.attr8 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr8)>(attr8);
      tblgen_props.attr9 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr9)>(attr9);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_ManyArgsOp_0 = rewriter.create<::test::ManyArgsOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1262
*/
struct GeneratedConvert12 : public ::mlir::RewritePattern {
  GeneratedConvert12(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.interleaved_operand_attr1", 1, context, {"test.interleaved_operand_attr2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr2;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpInterleavedOperandAttribute1>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.interleaved_operand_attr1' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      attr1 = tblgen_attr;
    }
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr2();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.interleaved_operand_attr1' to have attribute 'attr2' of type '::mlir::IntegerAttr'";
        });
      }
      attr2 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::OpInterleavedOperandAttribute2 tblgen_OpInterleavedOperandAttribute2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpInterleavedOperandAttribute2::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input1.begin()));
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(attr1);
      tblgen_values.push_back((*input2.begin()));
      tblgen_props.attr2 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr2)>(attr2);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_OpInterleavedOperandAttribute2_0 = rewriter.create<::test::OpInterleavedOperandAttribute2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1285
*/
struct GeneratedConvert13 : public ::mlir::RewritePattern {
  GeneratedConvert13(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.native_code_call1", 1, context, {"test.native_code_call2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr2;
    ::mlir::IntegerAttr attr1;
    ::mlir::BoolAttr choice;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpNativeCodeCall1>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getChoice();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.native_code_call1' to have attribute 'choice' of type '::mlir::BoolAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps7(rewriter, castedOp0, tblgen_attr, "op 'test.native_code_call1' attribute 'choice' failed to satisfy constraint: 'constant attribute true'"))) {
        return ::mlir::failure();
      }
      choice = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.native_code_call1' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      attr1 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr2();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.native_code_call1' to have attribute 'attr2' of type '::mlir::IntegerAttr'";
        });
      }
      attr2 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    auto nativeVar_0 = chooseOperand((*input1.begin()), (*input2.begin()), choice); (void)nativeVar_0;
    auto nativeVar_1 = rewriter.getArrayAttr({attr1, attr2}); (void)nativeVar_1;
    ::test::OpNativeCodeCall2 tblgen_OpNativeCodeCall2_2;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpNativeCodeCall2::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back(nativeVar_0);
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(nativeVar_1);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpNativeCodeCall2_2 = rewriter.create<::test::OpNativeCodeCall2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpNativeCodeCall2_2.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1293
*/
struct GeneratedConvert14 : public ::mlir::RewritePattern {
  GeneratedConvert14(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.native_code_call1", 1, context, {}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr2;
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpNativeCodeCall1>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getChoice();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.native_code_call1' to have attribute 'choice' of type '::mlir::BoolAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps8(rewriter, castedOp0, tblgen_attr, "op 'test.native_code_call1' attribute 'choice' failed to satisfy constraint: 'constant attribute false'"))) {
        return ::mlir::failure();
      }
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.native_code_call1' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      attr1 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr2();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.native_code_call1' to have attribute 'attr2' of type '::mlir::IntegerAttr'";
        });
      }
      attr2 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    auto nativeVar_0 = (*input2.begin()); (void)nativeVar_0;

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ {nativeVar_0} }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1303
*/
struct GeneratedConvert15 : public ::mlir::RewritePattern {
  GeneratedConvert15(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.native_code_call3", 1, context, {"test.op_k"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpNativeCodeCall3>(op0); (void)castedOp0;
    input = castedOp0.getODSOperands(0);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    createOpI(rewriter, odsLoc, (*input.begin()));
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpK tblgen_OpK_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpK::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpK_0 = rewriter.create<::test::OpK>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpK_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1318
*/
struct GeneratedConvert16 : public ::mlir::RewritePattern {
  GeneratedConvert16(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.native_code_call4", 1, context, {"test.native_code_call5"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Value ret;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpNativeCodeCall4>(op0); (void)castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
        ::mlir::Value arg1_0;
        if (!(!::mlir::failed(success(getFirstI32Result(op1, arg1_0))))){
          return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
            diag << "success(getFirstI32Result(op1, arg1_0)) return ::mlir::failure";
          });
        }
        ret = arg1_0;
      tblgen_ops.push_back(op1);
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    auto native = bindNativeCodeCallResult(ret); (void)native;
    ::test::OpNativeCodeCall5 tblgen_OpNativeCodeCall5_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpNativeCodeCall5::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back(native);
      tblgen_values.push_back(native);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpNativeCodeCall5_0 = rewriter.create<::test::OpNativeCodeCall5>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpNativeCodeCall5_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpNativeCodeCall5_0.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1330
*/
struct GeneratedConvert17 : public ::mlir::RewritePattern {
  GeneratedConvert17(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.native_code_call6", 1, context, {"test.native_code_call7"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range arg2(op0->getOperands());
    ::mlir::Operation::operand_range arg1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpNativeCodeCall6>(op0); (void)castedOp0;
    arg1 = castedOp0.getODSOperands(0);
    arg2 = castedOp0.getODSOperands(1);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    auto native = bindMultipleNativeCodeCallResult((*arg1.begin()), (*arg2.begin())); (void)native;
    ::test::OpNativeCodeCall7 tblgen_OpNativeCodeCall7_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpNativeCodeCall7::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back(native[0]);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpNativeCodeCall7_0 = rewriter.create<::test::OpNativeCodeCall7>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpNativeCodeCall7_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::OpNativeCodeCall7 tblgen_OpNativeCodeCall7_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpNativeCodeCall7::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back(native[1]);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpNativeCodeCall7_1 = rewriter.create<::test::OpNativeCodeCall7>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpNativeCodeCall7_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1349
*/
struct GeneratedConvert18 : public ::mlir::RewritePattern {
  GeneratedConvert18(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.all_attr_constraint_of1", 1, context, {"test.all_attr_constraint_of2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::ArrayAttr attr;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpAllAttrConstraint1>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.all_attr_constraint_of1' to have attribute 'attr' of type '::mlir::ArrayAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps9(rewriter, castedOp0, tblgen_attr, "op 'test.all_attr_constraint_of1' attribute 'attr' failed to satisfy constraint: '[0] == 0 and [1] == 1'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpAllAttrConstraint2 tblgen_OpAllAttrConstraint2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpAllAttrConstraint2::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(attr);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpAllAttrConstraint2_0 = rewriter.create<::test::OpAllAttrConstraint2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpAllAttrConstraint2_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1369
*/
struct GeneratedConvert19 : public ::mlir::RewritePattern {
  GeneratedConvert19(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_r", 1, context, {"test.op_s"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Attribute input2;
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpR>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    {
      auto *op1 = (*castedOp0.getODSOperands(1).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 1 of castedOp0";
        });
      }
        ::mlir::Attribute arg1_0;
        if (!(!::mlir::failed(::mlir::success(::mlir::matchPattern(op1->getResult(0), ::mlir::m_Constant(&arg1_0)))))){
          return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
            diag << "::mlir::success(::mlir::matchPattern(op1->getResult(0), ::mlir::m_Constant(&arg1_0))) return ::mlir::failure";
          });
        }
        input2 = arg1_0;
        if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps10(rewriter, op1, arg1_0, "operand 0 of native code call '::mlir::success(::mlir::matchPattern($_self->getResult(0), ::mlir::m_Constant(&$0)))' failed to satisfy constraint: '32-bit signless integer attribute'"))) {
          return ::mlir::failure();
        }
      tblgen_ops.push_back(op1);
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpS unused;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpS::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input1.begin()));
      tblgen_props.value = ::llvm::dyn_cast_if_present<decltype(tblgen_props.value)>(input2);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      unused = rewriter.create<::test::OpS>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ unused.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1528
*/
struct GeneratedConvert20 : public ::mlir::RewritePattern {
  GeneratedConvert20(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.symbol_binding_a", 1, context, {"test.symbol_binding_b", "test.symbol_binding_c", "test.symbol_binding_d"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range operand(op0->getOperands());
    ::test::OpSymbolBindingA res_a;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpSymbolBindingA>(op0); (void)castedOp0;
    res_a = castedOp0;
    operand = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.symbol_binding_a' to have attribute 'attr' of type '::mlir::IntegerAttr'";
        });
      }
      attr = tblgen_attr;
    }
    if (!(((*res_a.getODSResults(0).begin()).hasOneUse()))){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "entities 'res_a' failed to satisfy constraint: 'has one use'";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::OpSymbolBindingB res_b;
    {
      ::mlir::Value tblgen_value_0 = (*operand.begin());
      res_b = rewriter.create<::test::OpSymbolBindingB>(odsLoc,
        /*operand=*/tblgen_value_0
      );
    }
    ::test::OpSymbolBindingC res_c;
    {
      ::mlir::Value tblgen_value_0 = (*res_b.getODSResults(0).begin());
      res_c = rewriter.create<::test::OpSymbolBindingC>(odsLoc,
        /*operand=*/tblgen_value_0
      );
    }
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpSymbolBindingD tblgen_OpSymbolBindingD_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpSymbolBindingD::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*res_b.getODSResults(0).begin()));
      tblgen_values.push_back((*res_c.getODSResults(0).begin()));
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(attr);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpSymbolBindingD_0 = rewriter.create<::test::OpSymbolBindingD>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpSymbolBindingD_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1544
*/
struct GeneratedConvert21 : public ::mlir::RewritePattern {
  GeneratedConvert21(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.symbol_binding_no_result", 1, context, {}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range operand(op0->getOperands());
    ::test::OpSymbolBindingNoResult op;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpSymbolBindingNoResult>(op0); (void)castedOp0;
    op = castedOp0;
    operand = castedOp0.getODSOperands(0);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    handleNoResultOp(rewriter, op);
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1567
*/
struct GeneratedConvert22 : public ::mlir::RewritePattern {
  GeneratedConvert22(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.match_op_attribute1", 1, context, {"test.match_op_attribute2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr more;
    ::mlir::IntegerAttr default_valued;
    ::mlir::IntegerAttr optional;
    ::mlir::IntegerAttr required;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpAttrMatch1>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getRequiredAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.match_op_attribute1' to have attribute 'required_attr' of type '::mlir::IntegerAttr'";
        });
      }
      required = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getOptionalAttr();
      optional = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getDefaultValuedAttr();
      if (!tblgen_attr) tblgen_attr = rewriter.getIntegerAttr(rewriter.getIntegerType(32), 42);
      default_valued = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getMoreAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.match_op_attribute1' to have attribute 'more_attr' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps11(rewriter, castedOp0, tblgen_attr, "op 'test.match_op_attribute1' attribute 'more_attr' failed to satisfy constraint: 'more constraint'"))) {
        return ::mlir::failure();
      }
      more = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpAttrMatch2 tblgen_OpAttrMatch2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpAttrMatch2::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.required_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.required_attr)>(required);
      tblgen_props.optional_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.optional_attr)>(optional);
      tblgen_props.default_valued_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.default_valued_attr)>(default_valued);
      tblgen_props.more_attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.more_attr)>(more);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpAttrMatch2_0 = rewriter.create<::test::OpAttrMatch2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpAttrMatch2_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1580
*/
struct GeneratedConvert23 : public ::mlir::RewritePattern {
  GeneratedConvert23(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.match_op_attribute3", 1, context, {"test.match_op_attribute4"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::UnitAttr attr;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpAttrMatch3>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!tblgen_attr) tblgen_attr = ((false) ? rewriter.getUnitAttr() : nullptr);
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpAttrMatch4 tblgen_OpAttrMatch4_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpAttrMatch4::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(((true) ? rewriter.getUnitAttr() : nullptr));
      tblgen_props.attr2 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr2)>(attr);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpAttrMatch4_0 = rewriter.create<::test::OpAttrMatch4>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpAttrMatch4_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1584
*/
struct GeneratedConvert24 : public ::mlir::RewritePattern {
  GeneratedConvert24(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_c", 1, context, {"test.op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpC>(op0); (void)castedOp0;
    input = castedOp0.getODSOperands(0);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpB tblgen_OpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 17));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpB_0 = rewriter.create<::test::OpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1587
*/
struct GeneratedConvert25 : public ::mlir::RewritePattern {
  GeneratedConvert25(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.i32_enum_attr", 1, context, {"test.i32_enum_attr"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::I32EnumAttrOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.i32_enum_attr' to have attribute 'attr' of type '::SomeI32EnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps12(rewriter, castedOp0, tblgen_attr, "op 'test.i32_enum_attr' attribute 'attr' failed to satisfy constraint: 'case case5'"))) {
        return ::mlir::failure();
      }
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::I32EnumAttrOp tblgen_I32EnumAttrOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::I32EnumAttrOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 10));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_I32EnumAttrOp_0 = rewriter.create<::test::I32EnumAttrOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_I32EnumAttrOp_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1588
*/
struct GeneratedConvert26 : public ::mlir::RewritePattern {
  GeneratedConvert26(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.i64_enum_attr", 1, context, {"test.i64_enum_attr"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::I64EnumAttrOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.i64_enum_attr' to have attribute 'attr' of type '::SomeI64EnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps13(rewriter, castedOp0, tblgen_attr, "op 'test.i64_enum_attr' attribute 'attr' failed to satisfy constraint: 'case case5'"))) {
        return ::mlir::failure();
      }
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::I64EnumAttrOp tblgen_I64EnumAttrOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::I64EnumAttrOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.attr = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr)>(rewriter.getIntegerAttr(rewriter.getIntegerType(64), 10));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_I64EnumAttrOp_0 = rewriter.create<::test::I64EnumAttrOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_I64EnumAttrOp_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1628
*/
struct GeneratedConvert27 : public ::mlir::RewritePattern {
  GeneratedConvert27(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.three_result", 1, context, {"test.another_three_result"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::MultiResultOpEnumAttr kind;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ThreeResultOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getKind();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.three_result' to have attribute 'kind' of type '::MultiResultOpEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps14(rewriter, castedOp0, tblgen_attr, "op 'test.three_result' attribute 'kind' failed to satisfy constraint: 'case kind1'"))) {
        return ::mlir::failure();
      }
      kind = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::AnotherThreeResultOp tblgen_AnotherThreeResultOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::AnotherThreeResultOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(2)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_AnotherThreeResultOp_0 = rewriter.create<::test::AnotherThreeResultOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherThreeResultOp_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherThreeResultOp_0.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherThreeResultOp_0.getODSResults(2) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1632
*/
struct GeneratedConvert28 : public ::mlir::RewritePattern {
  GeneratedConvert28(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.three_result", 1, context, {"test.one_result1", "test.two_result"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::MultiResultOpEnumAttr kind;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ThreeResultOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getKind();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.three_result' to have attribute 'kind' of type '::MultiResultOpEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps15(rewriter, castedOp0, tblgen_attr, "op 'test.three_result' attribute 'kind' failed to satisfy constraint: 'case kind2'"))) {
        return ::mlir::failure();
      }
      kind = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TwoResultOp tblgen_TwoResultOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TwoResultOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TwoResultOp_0 = rewriter.create<::test::TwoResultOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TwoResultOp_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TwoResultOp_0.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::OneResultOp1 tblgen_OneResultOp1_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneResultOp1::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(2)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneResultOp1_1 = rewriter.create<::test::OneResultOp1>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneResultOp1_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1635
*/
struct GeneratedConvert29 : public ::mlir::RewritePattern {
  GeneratedConvert29(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.three_result", 1, context, {"test.another_two_result", "test.one_result2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::MultiResultOpEnumAttr kind;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ThreeResultOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getKind();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.three_result' to have attribute 'kind' of type '::MultiResultOpEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps16(rewriter, castedOp0, tblgen_attr, "op 'test.three_result' attribute 'kind' failed to satisfy constraint: 'case kind3'"))) {
        return ::mlir::failure();
      }
      kind = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OneResultOp2 tblgen_OneResultOp2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneResultOp2::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneResultOp2_0 = rewriter.create<::test::OneResultOp2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneResultOp2_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::AnotherTwoResultOp tblgen_AnotherTwoResultOp_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::AnotherTwoResultOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(2)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_AnotherTwoResultOp_1 = rewriter.create<::test::AnotherTwoResultOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherTwoResultOp_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherTwoResultOp_1.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1640
*/
struct GeneratedConvert30 : public ::mlir::RewritePattern {
  GeneratedConvert30(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.three_result", 1, context, {"test.one_result1", "test.two_result"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::MultiResultOpEnumAttr kind;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ThreeResultOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getKind();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.three_result' to have attribute 'kind' of type '::MultiResultOpEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps17(rewriter, castedOp0, tblgen_attr, "op 'test.three_result' attribute 'kind' failed to satisfy constraint: 'case kind4'"))) {
        return ::mlir::failure();
      }
      kind = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TwoResultOp res1;
    {
      res1 = rewriter.create<::test::TwoResultOp>(odsLoc,
        /*kind=*/kind
      );
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ res1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::OneResultOp1 tblgen_OneResultOp1_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneResultOp1::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneResultOp1_0 = rewriter.create<::test::OneResultOp1>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneResultOp1_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::TwoResultOp res2;
    {
      res2 = rewriter.create<::test::TwoResultOp>(odsLoc,
        /*kind=*/kind
      );
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ res2.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1647
*/
struct GeneratedConvert31 : public ::mlir::RewritePattern {
  GeneratedConvert31(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.two_result", 1, context, {"test.one_result1", "test.one_result2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::MultiResultOpEnumAttr kind;
    ::test::TwoResultOp res;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TwoResultOp>(op0); (void)castedOp0;
    res = castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getKind();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.two_result' to have attribute 'kind' of type '::MultiResultOpEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps18(rewriter, castedOp0, tblgen_attr, "op 'test.two_result' attribute 'kind' failed to satisfy constraint: 'case kind5'"))) {
        return ::mlir::failure();
      }
      kind = tblgen_attr;
    }
    if (!(((*res.getODSResults(1).begin()).use_empty()))){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "entities '' failed to satisfy constraint: 'has no use'";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OneResultOp2 tblgen_OneResultOp2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneResultOp2::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneResultOp2_0 = rewriter.create<::test::OneResultOp2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneResultOp2_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::OneResultOp1 tblgen_OneResultOp1_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneResultOp1::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneResultOp1_1 = rewriter.create<::test::OneResultOp1>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneResultOp1_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1653
*/
struct GeneratedConvert32 : public ::mlir::RewritePattern {
  GeneratedConvert32(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.three_result", 1, context, {"test.another_two_result", "test.one_result3", "test.two_result"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::MultiResultOpEnumAttr kind;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ThreeResultOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getKind();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.three_result' to have attribute 'kind' of type '::MultiResultOpEnumAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps19(rewriter, castedOp0, tblgen_attr, "op 'test.three_result' attribute 'kind' failed to satisfy constraint: 'case kind6'"))) {
        return ::mlir::failure();
      }
      kind = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::TwoResultOp interm;
    {
      interm = rewriter.create<::test::TwoResultOp>(odsLoc,
        /*kind=*/kind
      );
    }
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OneResultOp3 tblgen_OneResultOp3_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneResultOp3::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*interm.getODSResults(1).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneResultOp3_0 = rewriter.create<::test::OneResultOp3>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneResultOp3_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }
    ::test::AnotherTwoResultOp tblgen_AnotherTwoResultOp_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::AnotherTwoResultOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.kind = ::llvm::dyn_cast_if_present<decltype(tblgen_props.kind)>(kind);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(2)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_AnotherTwoResultOp_1 = rewriter.create<::test::AnotherTwoResultOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherTwoResultOp_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_AnotherTwoResultOp_1.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1678
*/
struct GeneratedConvert33 : public ::mlir::RewritePattern {
  GeneratedConvert33(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.one_variadic_out_one_variadic_in1", 1, context, {"test.one_variadic_out_one_variadic_in2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range inputs(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OneVResOneVOperandOp1>(op0); (void)castedOp0;
    inputs = castedOp0.getODSOperands(0);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OneVResOneVOperandOp2 tblgen_OneVResOneVOperandOp2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneVResOneVOperandOp2::Properties tblgen_props; (void)tblgen_props;
      for (auto v: inputs) {
        tblgen_values.push_back(v);
      }
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OneVResOneVOperandOp2_0 = rewriter.create<::test::OneVResOneVOperandOp2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OneVResOneVOperandOp2_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1699
*/
struct GeneratedConvert34 : public ::mlir::RewritePattern {
  GeneratedConvert34(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in1", 1, context, {"test.mixed_variadic_in2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input3(op0->getOperands());
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp1>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    input2 = castedOp0.getODSOperands(1);
    input3 = castedOp0.getODSOperands(2);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::MixedVOperandOp2 tblgen_MixedVOperandOp2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp2::Properties tblgen_props; (void)tblgen_props;
      for (auto v: input1) {
        tblgen_values.push_back(v);
      }
      tblgen_values.push_back((*input2.begin()));
      for (auto v: input3) {
        tblgen_values.push_back(v);
      }
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp2_0 = rewriter.create<::test::MixedVOperandOp2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1722
*/
struct GeneratedConvert35 : public ::mlir::RewritePattern {
  GeneratedConvert35(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_out1", 1, context, {"test.mixed_variadic_out2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVResultOp1>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::MixedVResultOp2 tblgen_MixedVResultOp2_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVResultOp2::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(1)) {
        tblgen_types.push_back(v.getType());
      }
      for (auto v: castedOp0.getODSResults(2)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_MixedVResultOp2_0 = rewriter.create<::test::MixedVResultOp2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_MixedVResultOp2_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_MixedVResultOp2_0.getODSResults(1) }) {
      tblgen_repl_values.push_back(v);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_MixedVResultOp2_0.getODSResults(2) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1766
*/
struct GeneratedConvert36 : public ::mlir::RewritePattern {
  GeneratedConvert36(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.one_i32_out", 1, context, {"test.mixed_variadic_in3", "test.mixed_variadic_out3"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OneI32ResultOp>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::MixedVResultOp3 results;
    {
      results = rewriter.create<::test::MixedVResultOp3>(odsLoc,
        rewriter.getIntegerAttr(rewriter.getIntegerType(32), 2)
      );
    }
    ::test::MixedVOperandOp3 tblgen_MixedVOperandOp3_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp3::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*results.getODSResults(0).begin()));
      for (auto v: results.getODSResults(1)) {
        tblgen_values.push_back(v);
      }
      for (auto v: results.getODSResults(2)) {
        tblgen_values.push_back(v);
      }
      tblgen_props.count = ::llvm::dyn_cast_if_present<decltype(tblgen_props.count)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), 2));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_MixedVOperandOp3_0 = rewriter.create<::test::MixedVOperandOp3>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_MixedVOperandOp3_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1802
*/
struct GeneratedConvert37 : public ::mlir::RewritePattern {
  GeneratedConvert37(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in4", 1, context, {"test.mixed_variadic_in5"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1b(op0->getOperands());
    ::mlir::Operation::operand_range input1a(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp4>(op0); (void)castedOp0;
    {
      auto variadic_operand_range = castedOp0.getODSOperands(0);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      input1a = variadic_operand_range.slice(0, 1);
      input1b = variadic_operand_range.slice(1, 1);
    }
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in4' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps3(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_in4' attribute 'attr1' failed to satisfy constraint: 'constant attribute 0'"))) {
        return ::mlir::failure();
      }
      attr1 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::MixedVOperandOp5 tblgen_MixedVOperandOp5_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp5::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input1a.begin()));
      tblgen_values.push_back((*input1b.begin()));
      tblgen_values.push_back((*input2.begin()));
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(attr1);
      tblgen_props.pattern_name = ::llvm::dyn_cast_if_present<decltype(tblgen_props.pattern_name)>(rewriter.getStringAttr("MatchVariadic"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp5_0 = rewriter.create<::test::MixedVOperandOp5>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1808
*/
struct GeneratedConvert38 : public ::mlir::RewritePattern {
  GeneratedConvert38(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in5", 1, context, {"test.mixed_variadic_in3"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1b(op0->getOperands());
    ::mlir::Operation::operand_range input1a(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp5>(op0); (void)castedOp0;
    input1a = castedOp0.getODSOperands(0);
    input1b = castedOp0.getODSOperands(1);
    input2 = castedOp0.getODSOperands(2);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in5' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      attr1 = tblgen_attr;
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getPatternName();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in5' to have attribute 'pattern_name' of type '::mlir::StringAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps20(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_in5' attribute 'pattern_name' failed to satisfy constraint: 'constant attribute \"MatchInverseVariadic\"'"))) {
        return ::mlir::failure();
      }
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_variadic_values_0;
    tblgen_variadic_values_0.push_back((*input1b.begin()));
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_variadic_values_1;
    tblgen_variadic_values_1.push_back((*input1a.begin()));
    ::test::MixedVOperandOp3 tblgen_MixedVOperandOp3_2;
    {
      ::mlir::Value tblgen_value_0 = (*input2.begin());
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values_1;
      for (auto v: tblgen_variadic_values_0) {
        tblgen_values_1.push_back(v);
      }
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values_2;
      for (auto v: tblgen_variadic_values_1) {
        tblgen_values_2.push_back(v);
      }
      tblgen_MixedVOperandOp3_2 = rewriter.create<::test::MixedVOperandOp3>(odsLoc,
        /*input1=*/tblgen_value_0,
        /*input2=*/tblgen_values_1,
        /*input3=*/tblgen_values_2,
        /*attr1=*/rewriter.getIntegerAttr(rewriter.getIntegerType(32), 1)
      );
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1814
*/
struct GeneratedConvert39 : public ::mlir::RewritePattern {
  GeneratedConvert39(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in4", 3, context, {"test.mixed_variadic_in5"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1b(op0->getOperands());
    ::mlir::Operation::operand_range input1a(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp4>(op0); (void)castedOp0;
    {
      auto variadic_operand_range = castedOp0.getODSOperands(0);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      {
        auto *local_op_0 = variadic_operand_range[0].getDefiningOp();
        if (!(local_op_0)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines variadic operand 0 (variadic sub-opearnd #0) of castedOp0";
          });
        }
        auto castedOp1 = ::llvm::dyn_cast<::test::MixedVOperandInOutI32Op>(local_op_0); (void)castedOp1;
        if (!(castedOp1)){
          return rewriter.notifyMatchFailure(local_op_0, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp1 is not ::test::MixedVOperandInOutI32Op type";
          });
        }
        input1a = castedOp1.getODSOperands(0);
        tblgen_ops.push_back(local_op_0);
      }
      {
        auto *local_op_1 = variadic_operand_range[1].getDefiningOp();
        if (!(local_op_1)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines variadic operand 0 (variadic sub-opearnd #1) of castedOp0";
          });
        }
        auto castedOp1 = ::llvm::dyn_cast<::test::MixedVOperandInOutI32Op>(local_op_1); (void)castedOp1;
        if (!(castedOp1)){
          return rewriter.notifyMatchFailure(local_op_1, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp1 is not ::test::MixedVOperandInOutI32Op type";
          });
        }
        input1b = castedOp1.getODSOperands(0);
        tblgen_ops.push_back(local_op_1);
      }
    }
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in4' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps21(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_in4' attribute 'attr1' failed to satisfy constraint: 'constant attribute 1'"))) {
        return ::mlir::failure();
      }
      attr1 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc(), tblgen_ops[2]->getLoc()}); (void)odsLoc;
    ::test::MixedVOperandOp5 tblgen_MixedVOperandOp5_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp5::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input1a.begin()));
      tblgen_values.push_back((*input1b.begin()));
      tblgen_values.push_back((*input2.begin()));
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(attr1);
      tblgen_props.pattern_name = ::llvm::dyn_cast_if_present<decltype(tblgen_props.pattern_name)>(rewriter.getStringAttr("MatchVariadicSubDag"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp5_0 = rewriter.create<::test::MixedVOperandOp5>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1821
*/
struct GeneratedConvert40 : public ::mlir::RewritePattern {
  GeneratedConvert40(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in4", 1, context, {"test.mixed_variadic_in5"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::mlir::Operation::operand_range input10(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp4>(op0); (void)castedOp0;
    {
      auto variadic_operand_range = castedOp0.getODSOperands(0);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      input1 = variadic_operand_range.slice(0, 1);
      input10 = variadic_operand_range.slice(1, 1);
    }
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in4' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps22(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_in4' attribute 'attr1' failed to satisfy constraint: 'constant attribute 2'"))) {
        return ::mlir::failure();
      }
      attr1 = tblgen_attr;
    }
    if (!(*input1.begin() == *input10.begin())){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "Operands 'input1' and 'input10' must be equal";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::MixedVOperandOp5 tblgen_MixedVOperandOp5_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp5::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input1.begin()));
      tblgen_values.push_back((*input1.begin()));
      tblgen_values.push_back((*input2.begin()));
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(attr1);
      tblgen_props.pattern_name = ::llvm::dyn_cast_if_present<decltype(tblgen_props.pattern_name)>(rewriter.getStringAttr("MatchVariadicSameSymbol"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp5_0 = rewriter.create<::test::MixedVOperandOp5>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1836
*/
struct GeneratedConvert41 : public ::mlir::RewritePattern {
  GeneratedConvert41(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in6", 1, context, {"test.mixed_variadic_in6"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2b(op0->getOperands());
    ::mlir::Operation::operand_range input2a(op0->getOperands());
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1b(op0->getOperands());
    ::mlir::Operation::operand_range input1a(op0->getOperands());
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp6>(op0); (void)castedOp0;
    {
      auto variadic_operand_range = castedOp0.getODSOperands(0);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      input1 = variadic_operand_range;
      input1a = variadic_operand_range.slice(0, 1);
      input1b = variadic_operand_range.slice(1, 1);
    }
    {
      auto variadic_operand_range = castedOp0.getODSOperands(1);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      input2 = variadic_operand_range;
      input2a = variadic_operand_range.slice(0, 1);
      input2b = variadic_operand_range.slice(1, 1);
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in6' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps21(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_in6' attribute 'attr1' failed to satisfy constraint: 'constant attribute 1'"))) {
        return ::mlir::failure();
      }
      attr1 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::MixedVOperandOp6 tblgen_MixedVOperandOp6_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp6::Properties tblgen_props; (void)tblgen_props;
      for (auto v: input2) {
        tblgen_values.push_back(v);
      }
      for (auto v: input1) {
        tblgen_values.push_back(v);
      }
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(rewriter.getIntegerAttr(rewriter.getIntegerType(32), -1));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp6_0 = rewriter.create<::test::MixedVOperandOp6>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1842
*/
struct GeneratedConvert42 : public ::mlir::RewritePattern {
  GeneratedConvert42(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_in6", 1, context, {"test.mixed_variadic_in5"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2b(op0->getOperands());
    ::mlir::Operation::operand_range input2a(op0->getOperands());
    ::mlir::Operation::operand_range input1b(op0->getOperands());
    ::mlir::Operation::operand_range input1a(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp6>(op0); (void)castedOp0;
    {
      auto variadic_operand_range = castedOp0.getODSOperands(0);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      input1a = variadic_operand_range.slice(0, 1);
      input1b = variadic_operand_range.slice(1, 1);
    }
    {
      auto variadic_operand_range = castedOp0.getODSOperands(1);
      if (variadic_operand_range.size() != 2) return ::mlir::failure();
      input2a = variadic_operand_range.slice(0, 1);
      input2b = variadic_operand_range.slice(1, 1);
    }
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_in6' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps22(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_in6' attribute 'attr1' failed to satisfy constraint: 'constant attribute 2'"))) {
        return ::mlir::failure();
      }
      attr1 = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::MixedVOperandOp5 tblgen_MixedVOperandOp5_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp5::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input2a.begin()));
      tblgen_values.push_back((*input2b.begin()));
      tblgen_values.push_back((*input1b.begin()));
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(attr1);
      tblgen_props.pattern_name = ::llvm::dyn_cast_if_present<decltype(tblgen_props.pattern_name)>(rewriter.getStringAttr("MatchMultiVariadicSubSymbol"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp5_0 = rewriter.create<::test::MixedVOperandOp5>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1858
*/
struct GeneratedConvert43 : public ::mlir::RewritePattern {
  GeneratedConvert43(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.mixed_variadic_optional_in7", 1, context, {"test.mixed_variadic_in6"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr1;
    ::mlir::Operation::operand_range input2(op0->getOperands());
    ::mlir::Operation::operand_range input1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::MixedVOperandOp7>(op0); (void)castedOp0;
    input1 = castedOp0.getODSOperands(0);
    input2 = castedOp0.getODSOperands(1);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr1();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.mixed_variadic_optional_in7' to have attribute 'attr1' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps22(rewriter, castedOp0, tblgen_attr, "op 'test.mixed_variadic_optional_in7' attribute 'attr1' failed to satisfy constraint: 'constant attribute 2'"))) {
        return ::mlir::failure();
      }
      attr1 = tblgen_attr;
    }
    if (!(((input2.empty() ? ::mlir::Value() : *input2.begin()) != Value()))){
      return rewriter.notifyMatchFailure(op0, [&](::mlir::Diagnostic &diag) {
        diag << "entities 'input2' failed to satisfy constraint: ''";
      });
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_variadic_values_0;
    tblgen_variadic_values_0.push_back((input2.empty() ? ::mlir::Value() : *input2.begin()));
    ::test::MixedVOperandOp6 tblgen_MixedVOperandOp6_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::MixedVOperandOp6::Properties tblgen_props; (void)tblgen_props;
      for (auto v: input1) {
        tblgen_values.push_back(v);
      }
      for (auto v: tblgen_variadic_values_0) {
        tblgen_values.push_back(v);
      }
      tblgen_props.attr1 = ::llvm::dyn_cast_if_present<decltype(tblgen_props.attr1)>(attr1);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_MixedVOperandOp6_1 = rewriter.create<::test::MixedVOperandOp6>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1882
*/
struct GeneratedConvert44 : public ::mlir::RewritePattern {
  GeneratedConvert44(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.either_op_a", 1, context, {"test.either_op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range x(op0->getOperands());
    ::mlir::Operation::operand_range arg2(op0->getOperands());
    ::mlir::Operation::operand_range arg1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestEitherOpA>(op0); (void)castedOp0;
    auto eitherLambda0 = [&](::mlir::OperandRange v0, ::mlir::OperandRange v1) {
      if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps1(rewriter, castedOp0, (*v0.begin()).getType(), "operand 0 of op 'test.either_op_a' failed to satisfy constraint: '32-bit signless integer'"))) {
        return ::mlir::failure();
      }
      arg1 = v0;
      if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps2(rewriter, castedOp0, (*v1.begin()).getType(), "operand 1 of op 'test.either_op_a' failed to satisfy constraint: '16-bit signless integer'"))) {
        return ::mlir::failure();
      }
      arg2 = v1;
      return ::mlir::success();
    };
    {
      auto eitherOperand0 = castedOp0.getODSOperands(0);
      auto eitherOperand1 = castedOp0.getODSOperands(1);
      if(::mlir::failed(eitherLambda0(eitherOperand0, eitherOperand1)) && ::mlir::failed(eitherLambda0(eitherOperand1, eitherOperand0)))
        return ::mlir::failure();
    }
    x = castedOp0.getODSOperands(2);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TestEitherOpB tblgen_TestEitherOpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestEitherOpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*arg2.begin()));
      tblgen_values.push_back((*x.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TestEitherOpB_0 = rewriter.create<::test::TestEitherOpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestEitherOpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1885
*/
struct GeneratedConvert45 : public ::mlir::RewritePattern {
  GeneratedConvert45(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.either_op_a", 2, context, {"test.either_op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range x(op0->getOperands());
    ::mlir::Operation::operand_range arg2(op0->getOperands());
    ::mlir::Operation::operand_range arg1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestEitherOpA>(op0); (void)castedOp0;
    auto eitherLambda0 = [&](::mlir::OperandRange v0, ::mlir::OperandRange v1) {
      auto local_op_0 = (*v0.begin()).getDefiningOp();
      {
        if (!(local_op_0)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 0 of castedOp0";
          });
        }
        if(::mlir::failed(static_dag_matcher_3(rewriter, local_op_0, tblgen_ops, arg1))) {
          return ::mlir::failure();
        }
      }
      if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps2(rewriter, castedOp0, (*v1.begin()).getType(), "operand 1 of op 'test.either_op_a' failed to satisfy constraint: '16-bit signless integer'"))) {
        return ::mlir::failure();
      }
      arg2 = v1;
      tblgen_ops.push_back(local_op_0);
      return ::mlir::success();
    };
    {
      auto eitherOperand0 = castedOp0.getODSOperands(0);
      auto eitherOperand1 = castedOp0.getODSOperands(1);
      if(::mlir::failed(eitherLambda0(eitherOperand0, eitherOperand1)) && ::mlir::failed(eitherLambda0(eitherOperand1, eitherOperand0)))
        return ::mlir::failure();
    }
    x = castedOp0.getODSOperands(2);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TestEitherOpB tblgen_TestEitherOpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestEitherOpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*arg2.begin()));
      tblgen_values.push_back((*x.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TestEitherOpB_0 = rewriter.create<::test::TestEitherOpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestEitherOpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1888
*/
struct GeneratedConvert46 : public ::mlir::RewritePattern {
  GeneratedConvert46(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.either_op_a", 3, context, {"test.either_op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range x(op0->getOperands());
    ::mlir::Operation::operand_range arg2(op0->getOperands());
    ::mlir::Operation::operand_range arg1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestEitherOpA>(op0); (void)castedOp0;
    auto eitherLambda0 = [&](::mlir::OperandRange v0, ::mlir::OperandRange v1) {
      auto local_op_0 = (*v0.begin()).getDefiningOp();
      {
        if (!(local_op_0)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 0 of castedOp0";
          });
        }
        if(::mlir::failed(static_dag_matcher_3(rewriter, local_op_0, tblgen_ops, arg1))) {
          return ::mlir::failure();
        }
      }
      auto local_op_1 = (*v1.begin()).getDefiningOp();
      {
        if (!(local_op_1)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 1 of castedOp0";
          });
        }
        auto castedOp1 = ::llvm::dyn_cast<::test::TestEitherOpB>(local_op_1); (void)castedOp1;
        if (!(castedOp1)){
          return rewriter.notifyMatchFailure(local_op_1, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp1 is not ::test::TestEitherOpB type";
          });
        }
        if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps2(rewriter, castedOp1, (*castedOp1.getODSOperands(0).begin()).getType(), "operand 0 of op 'test.either_op_b' failed to satisfy constraint: '16-bit signless integer'"))) {
          return ::mlir::failure();
        }
        arg2 = castedOp1.getODSOperands(0);
      }
      tblgen_ops.push_back(local_op_0);
      tblgen_ops.push_back(local_op_1);
      return ::mlir::success();
    };
    {
      auto eitherOperand0 = castedOp0.getODSOperands(0);
      auto eitherOperand1 = castedOp0.getODSOperands(1);
      if(::mlir::failed(eitherLambda0(eitherOperand0, eitherOperand1)) && ::mlir::failed(eitherLambda0(eitherOperand1, eitherOperand0)))
        return ::mlir::failure();
    }
    x = castedOp0.getODSOperands(2);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc(), tblgen_ops[2]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TestEitherOpB tblgen_TestEitherOpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestEitherOpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*arg2.begin()));
      tblgen_values.push_back((*x.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TestEitherOpB_0 = rewriter.create<::test::TestEitherOpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestEitherOpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1893
*/
struct GeneratedConvert47 : public ::mlir::RewritePattern {
  GeneratedConvert47(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.either_op_c", 1, context, {"test.either_op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range arg2(op0->getOperands());
    ::mlir::Operation::operand_range arg1(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestEitherOpC>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getAttr();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.either_op_c' to have attribute 'attr' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps3(rewriter, castedOp0, tblgen_attr, "op 'test.either_op_c' attribute 'attr' failed to satisfy constraint: 'constant attribute 0'"))) {
        return ::mlir::failure();
      }
    }
    auto eitherLambda0 = [&](::mlir::OperandRange v0, ::mlir::OperandRange v1) {
      arg1 = v0;
      if(::mlir::failed(__mlir_ods_local_type_constraint_TestOps1(rewriter, castedOp0, (*v1.begin()).getType(), "operand 1 of op 'test.either_op_c' failed to satisfy constraint: '32-bit signless integer'"))) {
        return ::mlir::failure();
      }
      arg2 = v1;
      return ::mlir::success();
    };
    {
      auto eitherOperand0 = castedOp0.getODSOperands(0);
      auto eitherOperand1 = castedOp0.getODSOperands(1);
      if(::mlir::failed(eitherLambda0(eitherOperand0, eitherOperand1)) && ::mlir::failed(eitherLambda0(eitherOperand1, eitherOperand0)))
        return ::mlir::failure();
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TestEitherOpB tblgen_TestEitherOpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestEitherOpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*arg1.begin()));
      tblgen_values.push_back((*arg2.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TestEitherOpB_0 = rewriter.create<::test::TestEitherOpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestEitherOpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1910
*/
struct GeneratedConvert48 : public ::mlir::RewritePattern {
  GeneratedConvert48(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.either_op_b", 3, context, {"test.either_op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range either_helper_1(op0->getOperands());
    ::mlir::Operation::operand_range either_helper_0(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestEitherOpB>(op0); (void)castedOp0;
    auto eitherLambda0 = [&](::mlir::OperandRange v0, ::mlir::OperandRange v1) {
      auto local_op_0 = (*v0.begin()).getDefiningOp();
      {
        if (!(local_op_0)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 0 of castedOp0";
          });
        }
        auto castedOp1 = ::llvm::dyn_cast<::test::TestEitherHelperOpA>(local_op_0); (void)castedOp1;
        if (!(castedOp1)){
          return rewriter.notifyMatchFailure(local_op_0, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp1 is not ::test::TestEitherHelperOpA type";
          });
        }
        either_helper_0 = castedOp1.getODSOperands(0);
      }
      auto local_op_1 = (*v1.begin()).getDefiningOp();
      {
        if (!(local_op_1)){
          return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 1 of castedOp0";
          });
        }
        auto castedOp1 = ::llvm::dyn_cast<::test::TestEitherHelperOpB>(local_op_1); (void)castedOp1;
        if (!(castedOp1)){
          return rewriter.notifyMatchFailure(local_op_1, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp1 is not ::test::TestEitherHelperOpB type";
          });
        }
        either_helper_1 = castedOp1.getODSOperands(0);
      }
      tblgen_ops.push_back(local_op_0);
      tblgen_ops.push_back(local_op_1);
      return ::mlir::success();
    };
    {
      auto eitherOperand0 = castedOp0.getODSOperands(0);
      auto eitherOperand1 = castedOp0.getODSOperands(1);
      if(::mlir::failed(eitherLambda0(eitherOperand0, eitherOperand1)) && ::mlir::failed(eitherLambda0(eitherOperand1, eitherOperand0)))
        return ::mlir::failure();
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc(), tblgen_ops[2]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TestEitherOpB tblgen_TestEitherOpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestEitherOpB::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*either_helper_0.begin()));
      tblgen_values.push_back((*either_helper_1.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TestEitherOpB_0 = rewriter.create<::test::TestEitherOpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestEitherOpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1919
*/
struct GeneratedConvert49 : public ::mlir::RewritePattern {
  GeneratedConvert49(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.loc_src", 3, context, {"test.loc_dst"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::test::TestLocationSrcOp res3;
    ::test::TestLocationSrcOp res2;
    ::test::TestLocationSrcOp res1;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestLocationSrcOp>(op0); (void)castedOp0;
    res1 = castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
      auto castedOp1 = ::llvm::dyn_cast<::test::TestLocationSrcOp>(op1); (void)castedOp1;
      if (!(castedOp1)){
        return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
          diag << "castedOp1 is not ::test::TestLocationSrcOp type";
        });
      }
      res2 = castedOp1;
      {
        auto *op2 = (*castedOp1.getODSOperands(0).begin()).getDefiningOp();
        if (!(op2)){
          return rewriter.notifyMatchFailure(castedOp1, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 0 of castedOp1";
          });
        }
        auto castedOp2 = ::llvm::dyn_cast<::test::TestLocationSrcOp>(op2); (void)castedOp2;
        if (!(castedOp2)){
          return rewriter.notifyMatchFailure(op2, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp2 is not ::test::TestLocationSrcOp type";
          });
        }
        res3 = castedOp2;
        input = castedOp2.getODSOperands(0);
        tblgen_ops.push_back(op2);
      }
      tblgen_ops.push_back(op1);
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc(), tblgen_ops[2]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::TestLocationDstOp tblgen_TestLocationDstOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestLocationDstOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      tblgen_TestLocationDstOp_0 = rewriter.create<::test::TestLocationDstOp>((*res1.getODSResults(0).begin()).getLoc(), tblgen_values, tblgen_props);
    }
    ::test::TestLocationDstOp tblgen_TestLocationDstOp_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestLocationDstOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_TestLocationDstOp_0.getODSResults(0).begin()));
      tblgen_TestLocationDstOp_1 = rewriter.create<::test::TestLocationDstOp>(::mlir::NameLoc::get(rewriter.getStringAttr("named")), tblgen_values, tblgen_props);
    }
    ::test::TestLocationDstOp tblgen_TestLocationDstOp_2;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestLocationDstOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_TestLocationDstOp_1.getODSResults(0).begin()));
      tblgen_TestLocationDstOp_2 = rewriter.create<::test::TestLocationDstOp>(rewriter.getFusedLoc({(*res2.getODSResults(0).begin()).getLoc(), (*res3.getODSResults(0).begin()).getLoc()}, rewriter.getStringAttr("fused")), tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestLocationDstOp_2.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1929
*/
struct GeneratedConvert50 : public ::mlir::RewritePattern {
  GeneratedConvert50(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.loc_src_no_res", 3, context, {"test.loc_dst_no_res"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::test::TestLocationSrcNoResOp loc;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestLocationSrcNoResOp>(op0); (void)castedOp0;
    loc = castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
      auto castedOp1 = ::llvm::dyn_cast<::test::TestLocationSrcOp>(op1); (void)castedOp1;
      if (!(castedOp1)){
        return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
          diag << "castedOp1 is not ::test::TestLocationSrcOp type";
        });
      }
      {
        auto *op2 = (*castedOp1.getODSOperands(0).begin()).getDefiningOp();
        if (!(op2)){
          return rewriter.notifyMatchFailure(castedOp1, [&](::mlir::Diagnostic &diag) {
            diag << "There's no operation that defines operand 0 of castedOp1";
          });
        }
        auto castedOp2 = ::llvm::dyn_cast<::test::TestLocationSrcOp>(op2); (void)castedOp2;
        if (!(castedOp2)){
          return rewriter.notifyMatchFailure(op2, [&](::mlir::Diagnostic &diag) {
            diag << "castedOp2 is not ::test::TestLocationSrcOp type";
          });
        }
        input = castedOp2.getODSOperands(0);
        tblgen_ops.push_back(op2);
      }
      tblgen_ops.push_back(op1);
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc(), tblgen_ops[2]->getLoc()}); (void)odsLoc;
    ::test::TestLocationDstNoResOp tblgen_TestLocationDstNoResOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestLocationDstNoResOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*input.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_TestLocationDstNoResOp_0 = rewriter.create<::test::TestLocationDstNoResOp>(loc.getLoc(), tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1950
*/
struct GeneratedConvert51 : public ::mlir::RewritePattern {
  GeneratedConvert51(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.source_op", 1, context, {"test.op_x"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range val(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::SourceOp>(op0); (void)castedOp0;
    val = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.source_op' to have attribute 'tag' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps23(rewriter, castedOp0, tblgen_attr, "op 'test.source_op' attribute 'tag' failed to satisfy constraint: 'constant attribute 11'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpX tblgen_OpX_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_types.push_back(rewriter.getI32Type());
      tblgen_OpX_0 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::OpX tblgen_OpX_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_OpX_0.getODSResults(0).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpX_1 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpX_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1955
*/
struct GeneratedConvert52 : public ::mlir::RewritePattern {
  GeneratedConvert52(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.source_op", 1, context, {"test.op_x"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range val(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::SourceOp>(op0); (void)castedOp0;
    val = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.source_op' to have attribute 'tag' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps24(rewriter, castedOp0, tblgen_attr, "op 'test.source_op' attribute 'tag' failed to satisfy constraint: 'constant attribute 22'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpX tblgen_OpX_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      auto nativeVar_1 = (*val.begin()).getType(); (void)nativeVar_1;
      tblgen_types.push_back(nativeVar_1);
      tblgen_OpX_0 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::OpX tblgen_OpX_2;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_OpX_0.getODSResults(0).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpX_2 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpX_2.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1972
*/
struct GeneratedConvert53 : public ::mlir::RewritePattern {
  GeneratedConvert53(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.source_op", 1, context, {"test.one_to_two", "test.op_x", "test.two_to_one"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range val(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::SourceOp>(op0); (void)castedOp0;
    val = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.source_op' to have attribute 'tag' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps25(rewriter, castedOp0, tblgen_attr, "op 'test.source_op' attribute 'tag' failed to satisfy constraint: 'constant attribute 33'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OneToTwo res;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneToTwo::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      auto nativeVar_0 = rewriter.getI64Type(); (void)nativeVar_0;
      tblgen_types.push_back(nativeVar_0);
      auto nativeVar_1 = rewriter.getI32Type(); (void)nativeVar_1;
      tblgen_types.push_back(nativeVar_1);
      res = rewriter.create<::test::OneToTwo>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::OpX tblgen_OpX_2;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*res.getODSResults(0).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      auto nativeVar_3 = rewriter.getI32Type(); (void)nativeVar_3;
      tblgen_types.push_back(nativeVar_3);
      tblgen_OpX_2 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::OpX tblgen_OpX_4;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*res.getODSResults(1).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      auto nativeVar_5 = rewriter.getI64Type(); (void)nativeVar_5;
      tblgen_types.push_back(nativeVar_5);
      tblgen_OpX_4 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::TwoToOne tblgen_TwoToOne_6;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TwoToOne::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_OpX_2.getODSResults(0).begin()));
      tblgen_values.push_back((*tblgen_OpX_4.getODSResults(0).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TwoToOne_6 = rewriter.create<::test::TwoToOne>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TwoToOne_6.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1977
*/
struct GeneratedConvert54 : public ::mlir::RewritePattern {
  GeneratedConvert54(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.source_op", 1, context, {"test.op_x"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range val(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::SourceOp>(op0); (void)castedOp0;
    val = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.source_op' to have attribute 'tag' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps26(rewriter, castedOp0, tblgen_attr, "op 'test.source_op' attribute 'tag' failed to satisfy constraint: 'constant attribute 44'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpX tblgen_OpX_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_types.push_back((*val.begin()).getType());
      tblgen_OpX_0 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::OpX tblgen_OpX_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_OpX_0.getODSResults(0).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpX_1 = rewriter.create<::test::OpX>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpX_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1981
*/
struct GeneratedConvert55 : public ::mlir::RewritePattern {
  GeneratedConvert55(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.source_op", 1, context, {"test.one_to_two", "test.two_to_one"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range val(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::SourceOp>(op0); (void)castedOp0;
    val = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.source_op' to have attribute 'tag' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps27(rewriter, castedOp0, tblgen_attr, "op 'test.source_op' attribute 'tag' failed to satisfy constraint: 'constant attribute 55'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OneToTwo res;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OneToTwo::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_types.push_back((*val.begin()).getType());
      tblgen_types.push_back(rewriter.getI64Type());
      res = rewriter.create<::test::OneToTwo>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::TwoToOne tblgen_TwoToOne_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TwoToOne::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*res.getODSResults(0).begin()));
      tblgen_values.push_back((*res.getODSResults(1).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TwoToOne_0 = rewriter.create<::test::TwoToOne>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TwoToOne_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:1989
*/
struct GeneratedConvert56 : public ::mlir::RewritePattern {
  GeneratedConvert56(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.source_op", 1, context, {"test.op_x", "test.two_to_one"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::IntegerAttr attr;
    ::mlir::Operation::operand_range val(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::SourceOp>(op0); (void)castedOp0;
    val = castedOp0.getODSOperands(0);
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getTag();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.source_op' to have attribute 'tag' of type '::mlir::IntegerAttr'";
        });
      }
      if(::mlir::failed(__mlir_ods_local_attr_constraint_TestOps28(rewriter, castedOp0, tblgen_attr, "op 'test.source_op' attribute 'tag' failed to satisfy constraint: 'constant attribute 66'"))) {
        return ::mlir::failure();
      }
      attr = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpX tblgen_OpX_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_types.push_back((*val.begin()).getType());
      tblgen_OpX_0 = rewriter.create<::test::OpX>(::mlir::NameLoc::get(rewriter.getStringAttr("loc1")), tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::OpX tblgen_OpX_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpX::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*val.begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_types.push_back((*val.begin()).getType());
      tblgen_OpX_1 = rewriter.create<::test::OpX>(::mlir::NameLoc::get(rewriter.getStringAttr("loc2")), tblgen_types, tblgen_values, tblgen_props);
    }
    ::test::TwoToOne tblgen_TwoToOne_2;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TwoToOne::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_OpX_0.getODSResults(0).begin()));
      tblgen_values.push_back((*tblgen_OpX_1.getODSResults(0).begin()));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TwoToOne_2 = rewriter.create<::test::TwoToOne>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TwoToOne_2.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2046
*/
struct GeneratedConvert57 : public ::mlir::RewritePattern {
  GeneratedConvert57(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_a", 1, context, {"test.legal_op_a"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_4(rewriter, op0, tblgen_ops))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::ILLegalOpA>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::LegalOpA tblgen_LegalOpA_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::LegalOpA::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.status = ::llvm::dyn_cast_if_present<decltype(tblgen_props.status)>(rewriter.getStringAttr("Success"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_LegalOpA_0 = rewriter.create<::test::LegalOpA>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_LegalOpA_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2048
*/
struct GeneratedConvert58 : public ::mlir::RewritePattern {
  GeneratedConvert58(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_a", 1, context, {"test.illegal_op_b"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_4(rewriter, op0, tblgen_ops))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::ILLegalOpA>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::ILLegalOpB tblgen_ILLegalOpB_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::ILLegalOpB::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_ILLegalOpB_0 = rewriter.create<::test::ILLegalOpB>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_ILLegalOpB_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2049
*/
struct GeneratedConvert59 : public ::mlir::RewritePattern {
  GeneratedConvert59(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_b", 1, context, {"test.legal_op_a"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ILLegalOpB>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::LegalOpA tblgen_LegalOpA_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::LegalOpA::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.status = ::llvm::dyn_cast_if_present<decltype(tblgen_props.status)>(rewriter.getStringAttr("Failure"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_LegalOpA_0 = rewriter.create<::test::LegalOpA>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_LegalOpA_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2053
*/
struct GeneratedConvert60 : public ::mlir::RewritePattern {
  GeneratedConvert60(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_c", 1, context, {"test.illegal_op_d"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_5(rewriter, op0, tblgen_ops))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::ILLegalOpC>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::ILLegalOpD tblgen_ILLegalOpD_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::ILLegalOpD::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_ILLegalOpD_0 = rewriter.create<::test::ILLegalOpD>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_ILLegalOpD_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2054
*/
struct GeneratedConvert61 : public ::mlir::RewritePattern {
  GeneratedConvert61(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_d", 1, context, {"test.legal_op_a"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ILLegalOpD>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::LegalOpA tblgen_LegalOpA_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::LegalOpA::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.status = ::llvm::dyn_cast_if_present<decltype(tblgen_props.status)>(rewriter.getStringAttr("Failure"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_LegalOpA_0 = rewriter.create<::test::LegalOpA>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_LegalOpA_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2056
*/
struct GeneratedConvert62 : public ::mlir::RewritePattern {
  GeneratedConvert62(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_c", 11, context, {"test.illegal_op_e"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    if(::mlir::failed(static_dag_matcher_5(rewriter, op0, tblgen_ops))) {
      return ::mlir::failure();
    }
    auto castedOp0 = ::llvm::dyn_cast_or_null<::test::ILLegalOpC>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::ILLegalOpE tblgen_ILLegalOpE_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::ILLegalOpE::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_ILLegalOpE_0 = rewriter.create<::test::ILLegalOpE>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_ILLegalOpE_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2057
*/
struct GeneratedConvert63 : public ::mlir::RewritePattern {
  GeneratedConvert63(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.illegal_op_e", 1, context, {"test.legal_op_a"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::ILLegalOpE>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::LegalOpA tblgen_LegalOpA_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::LegalOpA::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.status = ::llvm::dyn_cast_if_present<decltype(tblgen_props.status)>(rewriter.getStringAttr("Success"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_LegalOpA_0 = rewriter.create<::test::LegalOpA>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_LegalOpA_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2062
*/
struct GeneratedConvert64 : public ::mlir::RewritePattern {
  GeneratedConvert64(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.rewrite", 1, context, {}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range input(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestRewriteOp>(op0); (void)castedOp0;
    input = castedOp0.getODSOperands(0);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ input }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2680
*/
struct GeneratedConvert65 : public ::mlir::RewritePattern {
  GeneratedConvert65(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.op_crash_long", 1, context, {"test.op_crash_short"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::OpCrashLong>(op0); (void)castedOp0;

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    ::test::OpCrashShort tblgen_OpCrashShort_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::OpCrashShort::Properties tblgen_props; (void)tblgen_props;
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_OpCrashShort_0 = rewriter.create<::test::OpCrashShort>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_OpCrashShort_0.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2871
*/
struct GeneratedConvert66 : public ::mlir::RewritePattern {
  GeneratedConvert66(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.no_str_value", 1, context, {"test.has_str_value"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::StringAttr value;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestDefaultStrAttrNoValueOp>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_attr = castedOp0.getProperties().getValue();
      if (!(tblgen_attr)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "expected op 'test.no_str_value' to have attribute 'value' of type '::mlir::StringAttr'";
        });
      }
      value = tblgen_attr;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::TestDefaultStrAttrHasValueOp tblgen_TestDefaultStrAttrHasValueOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestDefaultStrAttrHasValueOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.value = ::llvm::dyn_cast_if_present<decltype(tblgen_props.value)>(rewriter.getStringAttr("foo"));
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_TestDefaultStrAttrHasValueOp_0 = rewriter.create<::test::TestDefaultStrAttrHasValueOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:2894
*/
struct GeneratedConvert67 : public ::mlir::RewritePattern {
  GeneratedConvert67(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.variadic_rewrite_src_op", 1, context, {"test.variadic_rewrite_dst_op"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::mlir::Operation::operand_range crg(op0->getOperands());
    ::mlir::Operation::operand_range brg(op0->getOperands());
    ::mlir::Operation::operand_range arg(op0->getOperands());
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestVariadicRewriteSrcOp>(op0); (void)castedOp0;
    arg = castedOp0.getODSOperands(0);
    brg = castedOp0.getODSOperands(1);
    crg = castedOp0.getODSOperands(2);

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::test::TestVariadicRewriteDstOp tblgen_TestVariadicRewriteDstOp_0;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestVariadicRewriteDstOp::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*brg.begin()));
      for (auto v: crg) {
        tblgen_values.push_back(v);
      }
      for (auto v: arg) {
        tblgen_values.push_back(v);
      }
      tblgen_props.operandSegmentSizes = { 1, static_cast<int32_t>(crg.size()), static_cast<int32_t>(arg.size()) };
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_TestVariadicRewriteDstOp_0 = rewriter.create<::test::TestVariadicRewriteDstOp>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:3503
*/
struct GeneratedConvert68 : public ::mlir::RewritePattern {
  GeneratedConvert68(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.prop_pattern_op_1", 1, context, {"test.prop_pattern_op_1"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    int64_t val;
    ::llvm::StringRef tag;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestPropPatternOp1>(op0); (void)castedOp0;
    {
      [[maybe_unused]] auto tblgen_prop = castedOp0.getProperties().getTag();
      tag = tblgen_prop;
    }
    {
      [[maybe_unused]] auto tblgen_prop = castedOp0.getProperties().getVal();
      if(::mlir::failed(__mlir_ods_local_prop_constraint_TestOps1(rewriter, castedOp0, tblgen_prop, "op 'test.prop_pattern_op_1' property 'val' failed to satisfy constraint: 'non-negative int64_t'"))) {
        return ::mlir::failure();
      }
      val = tblgen_prop;
    }
    {
      [[maybe_unused]] auto tblgen_prop = castedOp0.getProperties().getCond();
      if(::mlir::failed(__mlir_ods_local_prop_constraint_TestOps2(rewriter, castedOp0, tblgen_prop, "op 'test.prop_pattern_op_1' property 'cond' failed to satisfy constraint: 'constant 'boolean': false'"))) {
        return ::mlir::failure();
      }
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc()}); (void)odsLoc;
    ::llvm::SmallVector<::mlir::Value, 4> tblgen_repl_values;
    auto nativeVar_0 = val + 1; (void)nativeVar_0;
    ::test::TestPropPatternOp1 tblgen_TestPropPatternOp1_1;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestPropPatternOp1::Properties tblgen_props; (void)tblgen_props;
      tblgen_props.setTag(tag);
      tblgen_props.setVal(nativeVar_0);
      tblgen_props.setCond(true);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      for (auto v: castedOp0.getODSResults(0)) {
        tblgen_types.push_back(v.getType());
      }
      tblgen_TestPropPatternOp1_1 = rewriter.create<::test::TestPropPatternOp1>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }

    for (auto v: ::llvm::SmallVector<::mlir::Value, 4>{ tblgen_TestPropPatternOp1_1.getODSResults(0) }) {
      tblgen_repl_values.push_back(v);
    }

    rewriter.replaceOp(op0, tblgen_repl_values);
    return ::mlir::success();
  }
};

/* Generated from:
    /builddir/build/BUILD/llvm-21.0.0_pre20250629.g23be14b2220090-build/llvm-project-23be14b22200905b42bcea9add95f1f9233c728a/mlir/test/lib/Dialect/Test/TestOps.td:3507
*/
struct GeneratedConvert69 : public ::mlir::RewritePattern {
  GeneratedConvert69(::mlir::MLIRContext *context)
      : ::mlir::RewritePattern("test.prop_pattern_op_2", 2, context, {"test.prop_pattern_op_1", "test.prop_pattern_op_2"}) {}
  ::llvm::LogicalResult matchAndRewrite(::mlir::Operation *op0,
      ::mlir::PatternRewriter &rewriter) const override {
    // Variables for capturing values and attributes used while creating ops
    ::llvm::StringRef tag2;
    int64_t val;
    ::llvm::StringRef tag1;
    ::llvm::SmallVector<::mlir::Operation *, 4> tblgen_ops;

    // Match
    tblgen_ops.push_back(op0);
    auto castedOp0 = ::llvm::dyn_cast<::test::TestPropPatternOp2>(op0); (void)castedOp0;
    {
      auto *op1 = (*castedOp0.getODSOperands(0).begin()).getDefiningOp();
      if (!(op1)){
        return rewriter.notifyMatchFailure(castedOp0, [&](::mlir::Diagnostic &diag) {
          diag << "There's no operation that defines operand 0 of castedOp0";
        });
      }
      auto castedOp1 = ::llvm::dyn_cast<::test::TestPropPatternOp1>(op1); (void)castedOp1;
      if (!(castedOp1)){
        return rewriter.notifyMatchFailure(op1, [&](::mlir::Diagnostic &diag) {
          diag << "castedOp1 is not ::test::TestPropPatternOp1 type";
        });
      }
      {
        [[maybe_unused]] auto tblgen_prop = castedOp1.getProperties().getTag();
        tag1 = tblgen_prop;
      }
      {
        [[maybe_unused]] auto tblgen_prop = castedOp1.getProperties().getVal();
        val = tblgen_prop;
      }
      {
        [[maybe_unused]] auto tblgen_prop = castedOp1.getProperties().getCond();
        if(::mlir::failed(__mlir_ods_local_prop_constraint_TestOps3(rewriter, castedOp1, tblgen_prop, "op 'test.prop_pattern_op_1' property 'cond' failed to satisfy constraint: 'constant 'boolean': true'"))) {
          return ::mlir::failure();
        }
      }
      tblgen_ops.push_back(op1);
    }
    {
      [[maybe_unused]] auto tblgen_prop = castedOp0.getProperties().getTag();
      if(::mlir::failed(__mlir_ods_local_prop_constraint_TestOps4(rewriter, castedOp0, tblgen_prop, "op 'test.prop_pattern_op_2' property 'tag' failed to satisfy constraint: 'non-empty string'"))) {
        return ::mlir::failure();
      }
      tag2 = tblgen_prop;
    }

    // Rewrite
    auto odsLoc = rewriter.getFusedLoc({tblgen_ops[0]->getLoc(), tblgen_ops[1]->getLoc()}); (void)odsLoc;
    auto nativeVar_0 = -(val); (void)nativeVar_0;
    ::test::TestPropPatternOp1 tblgen_TestPropPatternOp1_1;
    {
      tblgen_TestPropPatternOp1_1 = rewriter.create<::test::TestPropPatternOp1>(odsLoc,
        /*tag=*/tag1,
        /*val=*/nativeVar_0,
        false
      );
    }
    auto nativeVar_2 = tag1.str() + "." + tag2.str(); (void)nativeVar_2;
    ::test::TestPropPatternOp2 tblgen_TestPropPatternOp2_3;
    {
      ::llvm::SmallVector<::mlir::Value, 4> tblgen_values; (void)tblgen_values;
      ::test::TestPropPatternOp2::Properties tblgen_props; (void)tblgen_props;
      tblgen_values.push_back((*tblgen_TestPropPatternOp1_1.getODSResults(0).begin()));
      tblgen_props.setTag(nativeVar_2);
      ::llvm::SmallVector<::mlir::Type, 4> tblgen_types; (void)tblgen_types;
      tblgen_TestPropPatternOp2_3 = rewriter.create<::test::TestPropPatternOp2>(odsLoc, tblgen_types, tblgen_values, tblgen_props);
    }
    rewriter.eraseOp(op0);
    return ::mlir::success();
  }
};

void LLVM_ATTRIBUTE_UNUSED populateWithGenerated(::mlir::RewritePatternSet &patterns) {
  patterns.add<TestEqualArgsPattern>(patterns.getContext());
  patterns.add<TestMultipleEqualArgsPattern>(patterns.getContext());
  patterns.add<TestNamedPatternRule>(patterns.getContext());
  patterns.add<TestNestedOpEqualArgsPattern>(patterns.getContext());
  patterns.add<TestNestedSameOpAndSameArgEqualityPattern>(patterns.getContext());
  patterns.add<UpdateAttr>(patterns.getContext());
  patterns.add<UpdateFloatElementsAttr>(patterns.getContext());
  patterns.add<GeneratedConvert0>(patterns.getContext());
  patterns.add<GeneratedConvert1>(patterns.getContext());
  patterns.add<GeneratedConvert2>(patterns.getContext());
  patterns.add<GeneratedConvert3>(patterns.getContext());
  patterns.add<GeneratedConvert4>(patterns.getContext());
  patterns.add<GeneratedConvert5>(patterns.getContext());
  patterns.add<GeneratedConvert6>(patterns.getContext());
  patterns.add<GeneratedConvert7>(patterns.getContext());
  patterns.add<GeneratedConvert8>(patterns.getContext());
  patterns.add<GeneratedConvert9>(patterns.getContext());
  patterns.add<GeneratedConvert10>(patterns.getContext());
  patterns.add<GeneratedConvert11>(patterns.getContext());
  patterns.add<GeneratedConvert12>(patterns.getContext());
  patterns.add<GeneratedConvert13>(patterns.getContext());
  patterns.add<GeneratedConvert14>(patterns.getContext());
  patterns.add<GeneratedConvert15>(patterns.getContext());
  patterns.add<GeneratedConvert16>(patterns.getContext());
  patterns.add<GeneratedConvert17>(patterns.getContext());
  patterns.add<GeneratedConvert18>(patterns.getContext());
  patterns.add<GeneratedConvert19>(patterns.getContext());
  patterns.add<GeneratedConvert20>(patterns.getContext());
  patterns.add<GeneratedConvert21>(patterns.getContext());
  patterns.add<GeneratedConvert22>(patterns.getContext());
  patterns.add<GeneratedConvert23>(patterns.getContext());
  patterns.add<GeneratedConvert24>(patterns.getContext());
  patterns.add<GeneratedConvert25>(patterns.getContext());
  patterns.add<GeneratedConvert26>(patterns.getContext());
  patterns.add<GeneratedConvert27>(patterns.getContext());
  patterns.add<GeneratedConvert28>(patterns.getContext());
  patterns.add<GeneratedConvert29>(patterns.getContext());
  patterns.add<GeneratedConvert30>(patterns.getContext());
  patterns.add<GeneratedConvert31>(patterns.getContext());
  patterns.add<GeneratedConvert32>(patterns.getContext());
  patterns.add<GeneratedConvert33>(patterns.getContext());
  patterns.add<GeneratedConvert34>(patterns.getContext());
  patterns.add<GeneratedConvert35>(patterns.getContext());
  patterns.add<GeneratedConvert36>(patterns.getContext());
  patterns.add<GeneratedConvert37>(patterns.getContext());
  patterns.add<GeneratedConvert38>(patterns.getContext());
  patterns.add<GeneratedConvert39>(patterns.getContext());
  patterns.add<GeneratedConvert40>(patterns.getContext());
  patterns.add<GeneratedConvert41>(patterns.getContext());
  patterns.add<GeneratedConvert42>(patterns.getContext());
  patterns.add<GeneratedConvert43>(patterns.getContext());
  patterns.add<GeneratedConvert44>(patterns.getContext());
  patterns.add<GeneratedConvert45>(patterns.getContext());
  patterns.add<GeneratedConvert46>(patterns.getContext());
  patterns.add<GeneratedConvert47>(patterns.getContext());
  patterns.add<GeneratedConvert48>(patterns.getContext());
  patterns.add<GeneratedConvert49>(patterns.getContext());
  patterns.add<GeneratedConvert50>(patterns.getContext());
  patterns.add<GeneratedConvert51>(patterns.getContext());
  patterns.add<GeneratedConvert52>(patterns.getContext());
  patterns.add<GeneratedConvert53>(patterns.getContext());
  patterns.add<GeneratedConvert54>(patterns.getContext());
  patterns.add<GeneratedConvert55>(patterns.getContext());
  patterns.add<GeneratedConvert56>(patterns.getContext());
  patterns.add<GeneratedConvert57>(patterns.getContext());
  patterns.add<GeneratedConvert58>(patterns.getContext());
  patterns.add<GeneratedConvert59>(patterns.getContext());
  patterns.add<GeneratedConvert60>(patterns.getContext());
  patterns.add<GeneratedConvert61>(patterns.getContext());
  patterns.add<GeneratedConvert62>(patterns.getContext());
  patterns.add<GeneratedConvert63>(patterns.getContext());
  patterns.add<GeneratedConvert64>(patterns.getContext());
  patterns.add<GeneratedConvert65>(patterns.getContext());
  patterns.add<GeneratedConvert66>(patterns.getContext());
  patterns.add<GeneratedConvert67>(patterns.getContext());
  patterns.add<GeneratedConvert68>(patterns.getContext());
  patterns.add<GeneratedConvert69>(patterns.getContext());
}
